pub const HIGHLIGHT_NAMES: &[&str] = &[
    "attribute",
    "type",
    "type.builtin",
    "type.enum",
    "type.enum.variant",
    "constructor",
    "constant",
    "constant.builtin",
    "constant.builtin.boolean",
    "constant.character",
    "constant.character.escape",
    "constant.numeric",
    "constant.numeric.integer",
    "constant.numeric.float",
    "string",
    "string.regexp",
    "string.special",
    "string.special.path",
    "string.special.url",
    "string.special.symbol",
    "escape",
    "comment",
    "comment.line",
    "comment.block",
    "comment.block.documentation",
    "variable",
    "variable.builtin",
    "variable.parameter",
    "variable.other",
    "variable.other.member",
    "label",
    "punctuation",
    "punctuation.delimiter",
    "punctuation.bracket",
    "punctuation.special",
    "keyword",
    "keyword.control",
    "keyword.control.conditional",
    "keyword.control.repeat",
    "keyword.control.import",
    "keyword.control.return",
    "keyword.control.exception",
    "keyword.operator",
    "keyword.directive",
    "keyword.function",
    "keyword.storage",
    "keyword.storage.type",
    "keyword.storage.modifier",
    "operator",
    "function",
    "function.builtin",
    "function.method",
    "function.macro",
    "function.special",
    "tag",
    "tag.builtin",
    "namespace",
    "special",
    "markup",
    "markup.heading",
    "markup.heading.marker",
    "markup.heading.1",
    "markup.heading.2",
    "markup.heading.3",
    "markup.heading.4",
    "markup.heading.5",
    "markup.heading.6",
    "markup.list",
    "markup.list.unnumbered",
    "markup.list.numbered",
    "markup.list.checked",
    "markup.list.unchecked",
    "markup.bold",
    "markup.italic",
    "markup.strikethrough",
    "markup.link",
    "markup.link.url",
    "markup.link.label",
    "markup.link.text",
    "markup.quote",
    "markup.raw",
    "markup.raw.inline",
    "markup.raw.block",
    "diff",
    "diff.plus",
    "diff.minus",
    "diff.delta",
    "diff.delta.moved",
];

crate::define_themes! {
    ACME => "../themes/acme.toml",
    ADWAITA_DARK => "../themes/adwaita-dark.toml",
    AMBERWOOD => "../themes/amberwood.toml",
    AO => "../themes/ao.toml",
    AYU_DARK => "../themes/ayu_dark.toml",
    AYU_LIGHT => "../themes/ayu_light.toml",
    AYU_MIRAGE => "../themes/ayu_mirage.toml",
    BASE16_DEFAULT_DARK => "../themes/base16_default_dark.toml",
    BASE16_DEFAULT_LIGHT => "../themes/base16_default_light.toml",
    BASE16_TERMINAL => "../themes/base16_terminal.toml",
    BASE16_TRANSPARENT => "../themes/base16_transparent.toml",
    BOGSTER => "../themes/bogster.toml",
    BOGSTER_LIGHT => "../themes/bogster_light.toml",
    BOO_BERRY => "../themes/boo_berry.toml",
    CATPPUCCIN_MOCHA => "../themes/catppuccin_mocha.toml",
    CURZON => "../themes/curzon.toml",
    CYAN_LIGHT => "../themes/cyan_light.toml",
    DARCULA => "../themes/darcula.toml",
    DARK_HIGH_CONTRAST => "../themes/dark_high_contrast.toml",
    DARK_PLUS => "../themes/dark_plus.toml",
    DOOM_ACARIO_DARK => "../themes/doom_acario_dark.toml",
    DRACULA => "../themes/dracula.toml",
    DRACULA_AT_NIGHT => "../themes/dracula_at_night.toml",
    EMACS => "../themes/emacs.toml",
    EVERBLUSH => "../themes/everblush.toml",
    EVERFOREST_DARK => "../themes/everforest_dark.toml",
    EVERFOREST_LIGHT => "../themes/everforest_light.toml",
    FERRA => "../themes/ferra.toml",
    FLATWHITE => "../themes/flatwhite.toml",
    FLEET_DARK => "../themes/fleet_dark.toml",
    FLEXOKI_LIGHT => "../themes/flexoki_light.toml",
    GITHUB_DARK => "../themes/github_dark.toml",
    GITHUB_LIGHT => "../themes/github_light.toml",
    GRUBER_DARKER => "../themes/gruber-darker.toml",
    GRUVBOX => "../themes/gruvbox.toml",
    HEISENBERG => "../themes/heisenberg.toml",
    HEX_STEEL => "../themes/hex_steel.toml",
    HORIZON_DARK => "../themes/horizon-dark.toml",
    ICEBERG_DARK => "../themes/iceberg-dark.toml",
    INGRID => "../themes/ingrid.toml",
    IROASETA => "../themes/iroaseta.toml",
    JELLYBEANS => "../themes/jellybeans.toml",
    JETBRAINS_DARK => "../themes/jetbrains_dark.toml",
    KANAGAWA => "../themes/kanagawa.toml",
    KAOLIN_DARK => "../themes/kaolin-dark.toml",
    MATERIAL_DEEP_OCEAN => "../themes/material_deep_ocean.toml",
    MELIORA => "../themes/meliora.toml",
    MELLOW => "../themes/mellow.toml",
    MERIONETTE => "../themes/merionette.toml",
    MODUS_OPERANDI => "../themes/modus_operandi.toml",
    MONOKAI => "../themes/monokai.toml",
    MONOKAI_PRO => "../themes/monokai_pro.toml",
    MONOKAI_PRO_MACHINE => "../themes/monokai_pro_machine.toml",
    MONOKAI_PRO_OCTAGON => "../themes/monokai_pro_octagon.toml",
    MONOKAI_PRO_RISTRETTO => "../themes/monokai_pro_ristretto.toml",
    MONOKAI_PRO_SPECTRUM => "../themes/monokai_pro_spectrum.toml",
    MONOKAI_SODA => "../themes/monokai_soda.toml",
    NAYSAYER => "../themes/naysayer.toml",
    NEW_MOON => "../themes/new_moon.toml",
    NIGHT_OWL => "../themes/night_owl.toml",
    NIGHTFOX => "../themes/nightfox.toml",
    NOCTIS => "../themes/noctis.toml",
    NOCTIS_BORDO => "../themes/noctis_bordo.toml",
    NORD => "../themes/nord.toml",
    NORD_LIGHT => "../themes/nord_light.toml",
    ONEDARK => "../themes/onedark.toml",
    ONEDARKER => "../themes/onedarker.toml",
    ONELIGHT => "../themes/onelight.toml",
    PAPERCOLOR_LIGHT => "../themes/papercolor-light.toml",
    PENUMBRA_PLUS => "../themes/penumbra-plus.toml",
    POIMANDRES => "../themes/poimandres.toml",
    POP_DARK => "../themes/pop-dark.toml",
    RASMUS => "../themes/rasmus.toml",
    ROSE_PINE => "../themes/rose_pine.toml",
    SERIKA_DARK => "../themes/serika-dark.toml",
    SERIKA_LIGHT => "../themes/serika-light.toml",
    SNAZZY => "../themes/snazzy.toml",
    SOLARIZED_DARK => "../themes/solarized_dark.toml",
    SOLARIZED_LIGHT => "../themes/solarized_light.toml",
    SONOKAI => "../themes/sonokai.toml",
    SPACEBONES_LIGHT => "../themes/spacebones_light.toml",
    STARLIGHT => "../themes/starlight.toml",
    TERM16_DARK => "../themes/term16_dark.toml",
    TOKYONIGHT => "../themes/tokyonight.toml",
    TTOX => "../themes/ttox.toml",
    VARUA => "../themes/varua.toml",
    VIM_DARK_HIGH_CONTRAST => "../themes/vim_dark_high_contrast.toml",
    VOXED => "../themes/voxed.toml",
    YELLOWED => "../themes/yellowed.toml",
    ZED_ONEDARK => "../themes/zed_onedark.toml",
    ZENBURN => "../themes/zenburn.toml",
}
