#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2288
#define LARGE_STATE_COUNT 224
#define SYMBOL_COUNT 177
#define ALIAS_COUNT 1
#define TOKEN_COUNT 105
#define EXTERNAL_TOKEN_COUNT 4
#define FIELD_COUNT 18
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 35

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_COMMA = 2,
  anon_sym_BEGIN = 3,
  anon_sym_END = 4,
  anon_sym_BEGINFILE = 5,
  anon_sym_ENDFILE = 6,
  anon_sym_ATinclude = 7,
  anon_sym_ATload = 8,
  anon_sym_ATnamespace = 9,
  anon_sym_SEMI = 10,
  anon_sym_LF = 11,
  anon_sym_CR_LF = 12,
  anon_sym_if = 13,
  anon_sym_LPAREN = 14,
  anon_sym_RPAREN = 15,
  anon_sym_else = 16,
  anon_sym_while = 17,
  anon_sym_do = 18,
  anon_sym_for = 19,
  anon_sym_in = 20,
  sym_break_statement = 21,
  sym_continue_statement = 22,
  anon_sym_delete = 23,
  anon_sym_exit = 24,
  anon_sym_return = 25,
  anon_sym_switch = 26,
  anon_sym_LBRACE = 27,
  anon_sym_RBRACE = 28,
  anon_sym_case = 29,
  anon_sym_COLON = 30,
  anon_sym_default = 31,
  anon_sym_getline = 32,
  anon_sym_LT = 33,
  sym_next_statement = 34,
  sym_nextfile_statement = 35,
  anon_sym_print = 36,
  anon_sym_LPAREN2 = 37,
  anon_sym_printf = 38,
  anon_sym_GT = 39,
  anon_sym_GT_GT = 40,
  anon_sym_PIPE = 41,
  anon_sym_PIPE_AMP = 42,
  anon_sym_QMARK = 43,
  anon_sym_CARET = 44,
  anon_sym_STAR_STAR = 45,
  anon_sym_STAR = 46,
  anon_sym_SLASH = 47,
  anon_sym_PERCENT = 48,
  anon_sym_PLUS = 49,
  anon_sym_DASH = 50,
  anon_sym_LT_EQ = 51,
  anon_sym_GT_EQ = 52,
  anon_sym_EQ_EQ = 53,
  anon_sym_BANG_EQ = 54,
  anon_sym_TILDE = 55,
  anon_sym_BANG_TILDE = 56,
  anon_sym_AMP_AMP = 57,
  anon_sym_PIPE_PIPE = 58,
  anon_sym_BANG = 59,
  anon_sym_PLUS_PLUS = 60,
  anon_sym_DASH_DASH = 61,
  anon_sym_EQ = 62,
  anon_sym_PLUS_EQ = 63,
  anon_sym_DASH_EQ = 64,
  anon_sym_STAR_EQ = 65,
  anon_sym_SLASH_EQ = 66,
  anon_sym_PERCENT_EQ = 67,
  anon_sym_CARET_EQ = 68,
  anon_sym_DOLLAR = 69,
  anon_sym_LBRACK = 70,
  anon_sym_RBRACK = 71,
  anon_sym_SLASH2 = 72,
  sym__regex_char = 73,
  sym__regex_char_escaped = 74,
  anon_sym_LBRACK2 = 75,
  anon_sym_COLON2 = 76,
  anon_sym_alnum = 77,
  anon_sym_alpha = 78,
  anon_sym_blank = 79,
  anon_sym_cntrl = 80,
  anon_sym_digit = 81,
  anon_sym_graph = 82,
  anon_sym_lower = 83,
  anon_sym_punct = 84,
  anon_sym_space = 85,
  anon_sym_upper = 86,
  anon_sym_xdigit = 87,
  anon_sym_RBRACK2 = 88,
  sym_regex_flags = 89,
  anon_sym_AT = 90,
  anon_sym_COLON_COLON = 91,
  aux_sym_number_token1 = 92,
  aux_sym_number_token2 = 93,
  anon_sym_DQUOTE = 94,
  aux_sym_string_token1 = 95,
  sym_escape_sequence = 96,
  anon_sym_function = 97,
  anon_sym_func = 98,
  anon_sym_POUND = 99,
  aux_sym_comment_token1 = 100,
  sym_concatenating_space = 101,
  sym__if_else_separator = 102,
  sym__no_space = 103,
  sym__func_call = 104,
  sym_program = 105,
  sym_rule = 106,
  sym_pattern = 107,
  sym_range_pattern = 108,
  sym__special_pattern = 109,
  sym_directive = 110,
  sym__statement = 111,
  sym__statement_separated = 112,
  sym__control_statement = 113,
  sym_if_statement = 114,
  sym_else_clause = 115,
  sym_while_statement = 116,
  sym_do_while_statement = 117,
  sym_for_statement = 118,
  sym_for_in_statement = 119,
  sym_delete_statement = 120,
  sym_exit_statement = 121,
  sym_return_statement = 122,
  sym_switch_statement = 123,
  sym_switch_body = 124,
  sym_switch_case = 125,
  sym_switch_default = 126,
  sym__io_statement = 127,
  sym__getline_exp = 128,
  sym_getline_input = 129,
  sym_getline_file = 130,
  sym__print_args = 131,
  sym_print_statement = 132,
  sym_printf_statement = 133,
  sym_redirected_io_statement = 134,
  sym_piped_io_statement = 135,
  sym_block = 136,
  sym__block_content = 137,
  sym__exp = 138,
  sym_ternary_exp = 139,
  sym_binary_exp = 140,
  sym__binary_in = 141,
  sym_unary_exp = 142,
  sym_update_exp = 143,
  sym_assignment_exp = 144,
  sym_piped_io_exp = 145,
  sym_string_concat = 146,
  sym_field_ref = 147,
  sym_array_ref = 148,
  sym_exp_list = 149,
  sym_regex = 150,
  sym__regex_char_class = 151,
  sym__regex_bracket_exp = 152,
  sym_regex_pattern = 153,
  sym_regex_constant = 154,
  sym_grouping = 155,
  sym__primitive = 156,
  sym_namespace = 157,
  sym_ns_qualified_name = 158,
  sym_number = 159,
  sym_string = 160,
  sym_func_def = 161,
  sym_param_list = 162,
  sym_func_call = 163,
  sym_indirect_func_call = 164,
  sym_args = 165,
  sym_comment = 166,
  aux_sym_program_repeat1 = 167,
  aux_sym_if_statement_repeat1 = 168,
  aux_sym_switch_body_repeat1 = 169,
  aux_sym_block_repeat1 = 170,
  aux_sym_exp_list_repeat1 = 171,
  aux_sym__regex_bracket_exp_repeat1 = 172,
  aux_sym_regex_pattern_repeat1 = 173,
  aux_sym_string_repeat1 = 174,
  aux_sym_param_list_repeat1 = 175,
  aux_sym_args_repeat1 = 176,
  anon_alias_sym_namespace = 177,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_COMMA] = ",",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_END] = "END",
  [anon_sym_BEGINFILE] = "BEGINFILE",
  [anon_sym_ENDFILE] = "ENDFILE",
  [anon_sym_ATinclude] = "@include",
  [anon_sym_ATload] = "@load",
  [anon_sym_ATnamespace] = "@namespace",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_CR_LF] = "\r\n",
  [anon_sym_if] = "if",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_else] = "else",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [anon_sym_delete] = "delete",
  [anon_sym_exit] = "exit",
  [anon_sym_return] = "return",
  [anon_sym_switch] = "switch",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_case] = "case",
  [anon_sym_COLON] = ":",
  [anon_sym_default] = "default",
  [anon_sym_getline] = "getline",
  [anon_sym_LT] = "<",
  [sym_next_statement] = "next_statement",
  [sym_nextfile_statement] = "nextfile_statement",
  [anon_sym_print] = "print",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_printf] = "printf",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PIPE] = "|",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_QMARK] = "\?",
  [anon_sym_CARET] = "^",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_SLASH2] = "/",
  [sym__regex_char] = "_regex_char",
  [sym__regex_char_escaped] = "_regex_char_escaped",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_COLON2] = ":",
  [anon_sym_alnum] = "alnum",
  [anon_sym_alpha] = "alpha",
  [anon_sym_blank] = "blank",
  [anon_sym_cntrl] = "cntrl",
  [anon_sym_digit] = "digit",
  [anon_sym_graph] = "graph",
  [anon_sym_lower] = "lower",
  [anon_sym_punct] = "punct",
  [anon_sym_space] = "space",
  [anon_sym_upper] = "upper",
  [anon_sym_xdigit] = "xdigit",
  [anon_sym_RBRACK2] = "]",
  [sym_regex_flags] = "regex_flags",
  [anon_sym_AT] = "@",
  [anon_sym_COLON_COLON] = "::",
  [aux_sym_number_token1] = "number_token1",
  [aux_sym_number_token2] = "number_token2",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_function] = "function",
  [anon_sym_func] = "func",
  [anon_sym_POUND] = "#",
  [aux_sym_comment_token1] = "comment_token1",
  [sym_concatenating_space] = "concatenating_space",
  [sym__if_else_separator] = "_if_else_separator",
  [sym__no_space] = "_no_space",
  [sym__func_call] = "_func_call",
  [sym_program] = "program",
  [sym_rule] = "rule",
  [sym_pattern] = "pattern",
  [sym_range_pattern] = "range_pattern",
  [sym__special_pattern] = "_special_pattern",
  [sym_directive] = "directive",
  [sym__statement] = "_statement",
  [sym__statement_separated] = "_statement_separated",
  [sym__control_statement] = "_control_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_while_statement] = "while_statement",
  [sym_do_while_statement] = "do_while_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_exit_statement] = "exit_statement",
  [sym_return_statement] = "return_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym__io_statement] = "_io_statement",
  [sym__getline_exp] = "_getline_exp",
  [sym_getline_input] = "getline_input",
  [sym_getline_file] = "getline_file",
  [sym__print_args] = "_print_args",
  [sym_print_statement] = "print_statement",
  [sym_printf_statement] = "printf_statement",
  [sym_redirected_io_statement] = "redirected_io_statement",
  [sym_piped_io_statement] = "piped_io_statement",
  [sym_block] = "block",
  [sym__block_content] = "_block_content",
  [sym__exp] = "_exp",
  [sym_ternary_exp] = "ternary_exp",
  [sym_binary_exp] = "binary_exp",
  [sym__binary_in] = "_binary_in",
  [sym_unary_exp] = "unary_exp",
  [sym_update_exp] = "update_exp",
  [sym_assignment_exp] = "assignment_exp",
  [sym_piped_io_exp] = "piped_io_exp",
  [sym_string_concat] = "string_concat",
  [sym_field_ref] = "field_ref",
  [sym_array_ref] = "array_ref",
  [sym_exp_list] = "exp_list",
  [sym_regex] = "regex",
  [sym__regex_char_class] = "_regex_char_class",
  [sym__regex_bracket_exp] = "_regex_bracket_exp",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_constant] = "regex_constant",
  [sym_grouping] = "grouping",
  [sym__primitive] = "_primitive",
  [sym_namespace] = "namespace",
  [sym_ns_qualified_name] = "ns_qualified_name",
  [sym_number] = "number",
  [sym_string] = "string",
  [sym_func_def] = "func_def",
  [sym_param_list] = "param_list",
  [sym_func_call] = "func_call",
  [sym_indirect_func_call] = "indirect_func_call",
  [sym_args] = "args",
  [sym_comment] = "comment",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_exp_list_repeat1] = "exp_list_repeat1",
  [aux_sym__regex_bracket_exp_repeat1] = "_regex_bracket_exp_repeat1",
  [aux_sym_regex_pattern_repeat1] = "regex_pattern_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_param_list_repeat1] = "param_list_repeat1",
  [aux_sym_args_repeat1] = "args_repeat1",
  [anon_alias_sym_namespace] = "namespace",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_BEGIN] = anon_sym_BEGIN,
  [anon_sym_END] = anon_sym_END,
  [anon_sym_BEGINFILE] = anon_sym_BEGINFILE,
  [anon_sym_ENDFILE] = anon_sym_ENDFILE,
  [anon_sym_ATinclude] = anon_sym_ATinclude,
  [anon_sym_ATload] = anon_sym_ATload,
  [anon_sym_ATnamespace] = anon_sym_ATnamespace,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_CR_LF] = anon_sym_CR_LF,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_exit] = anon_sym_exit,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_getline] = anon_sym_getline,
  [anon_sym_LT] = anon_sym_LT,
  [sym_next_statement] = sym_next_statement,
  [sym_nextfile_statement] = sym_nextfile_statement,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_printf] = anon_sym_printf,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PIPE_AMP] = anon_sym_PIPE_AMP,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG_TILDE] = anon_sym_BANG_TILDE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym__regex_char] = sym__regex_char,
  [sym__regex_char_escaped] = sym__regex_char_escaped,
  [anon_sym_LBRACK2] = anon_sym_LBRACK,
  [anon_sym_COLON2] = anon_sym_COLON,
  [anon_sym_alnum] = anon_sym_alnum,
  [anon_sym_alpha] = anon_sym_alpha,
  [anon_sym_blank] = anon_sym_blank,
  [anon_sym_cntrl] = anon_sym_cntrl,
  [anon_sym_digit] = anon_sym_digit,
  [anon_sym_graph] = anon_sym_graph,
  [anon_sym_lower] = anon_sym_lower,
  [anon_sym_punct] = anon_sym_punct,
  [anon_sym_space] = anon_sym_space,
  [anon_sym_upper] = anon_sym_upper,
  [anon_sym_xdigit] = anon_sym_xdigit,
  [anon_sym_RBRACK2] = anon_sym_RBRACK,
  [sym_regex_flags] = sym_regex_flags,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [aux_sym_number_token1] = aux_sym_number_token1,
  [aux_sym_number_token2] = aux_sym_number_token2,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_func] = anon_sym_func,
  [anon_sym_POUND] = anon_sym_POUND,
  [aux_sym_comment_token1] = aux_sym_comment_token1,
  [sym_concatenating_space] = sym_concatenating_space,
  [sym__if_else_separator] = sym__if_else_separator,
  [sym__no_space] = sym__no_space,
  [sym__func_call] = sym__func_call,
  [sym_program] = sym_program,
  [sym_rule] = sym_rule,
  [sym_pattern] = sym_pattern,
  [sym_range_pattern] = sym_range_pattern,
  [sym__special_pattern] = sym__special_pattern,
  [sym_directive] = sym_directive,
  [sym__statement] = sym__statement,
  [sym__statement_separated] = sym__statement_separated,
  [sym__control_statement] = sym__control_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_while_statement] = sym_while_statement,
  [sym_do_while_statement] = sym_do_while_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym_delete_statement] = sym_delete_statement,
  [sym_exit_statement] = sym_exit_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym__io_statement] = sym__io_statement,
  [sym__getline_exp] = sym__getline_exp,
  [sym_getline_input] = sym_getline_input,
  [sym_getline_file] = sym_getline_file,
  [sym__print_args] = sym__print_args,
  [sym_print_statement] = sym_print_statement,
  [sym_printf_statement] = sym_printf_statement,
  [sym_redirected_io_statement] = sym_redirected_io_statement,
  [sym_piped_io_statement] = sym_piped_io_statement,
  [sym_block] = sym_block,
  [sym__block_content] = sym__block_content,
  [sym__exp] = sym__exp,
  [sym_ternary_exp] = sym_ternary_exp,
  [sym_binary_exp] = sym_binary_exp,
  [sym__binary_in] = sym__binary_in,
  [sym_unary_exp] = sym_unary_exp,
  [sym_update_exp] = sym_update_exp,
  [sym_assignment_exp] = sym_assignment_exp,
  [sym_piped_io_exp] = sym_piped_io_exp,
  [sym_string_concat] = sym_string_concat,
  [sym_field_ref] = sym_field_ref,
  [sym_array_ref] = sym_array_ref,
  [sym_exp_list] = sym_exp_list,
  [sym_regex] = sym_regex,
  [sym__regex_char_class] = sym__regex_char_class,
  [sym__regex_bracket_exp] = sym__regex_bracket_exp,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_constant] = sym_regex_constant,
  [sym_grouping] = sym_grouping,
  [sym__primitive] = sym__primitive,
  [sym_namespace] = sym_namespace,
  [sym_ns_qualified_name] = sym_ns_qualified_name,
  [sym_number] = sym_number,
  [sym_string] = sym_string,
  [sym_func_def] = sym_func_def,
  [sym_param_list] = sym_param_list,
  [sym_func_call] = sym_func_call,
  [sym_indirect_func_call] = sym_indirect_func_call,
  [sym_args] = sym_args,
  [sym_comment] = sym_comment,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_exp_list_repeat1] = aux_sym_exp_list_repeat1,
  [aux_sym__regex_bracket_exp_repeat1] = aux_sym__regex_bracket_exp_repeat1,
  [aux_sym_regex_pattern_repeat1] = aux_sym_regex_pattern_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_param_list_repeat1] = aux_sym_param_list_repeat1,
  [aux_sym_args_repeat1] = aux_sym_args_repeat1,
  [anon_alias_sym_namespace] = anon_alias_sym_namespace,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BEGINFILE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ENDFILE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATinclude] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATnamespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_getline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [sym_next_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nextfile_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_printf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym__regex_char] = {
    .visible = false,
    .named = true,
  },
  [sym__regex_char_escaped] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alnum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alpha] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blank] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cntrl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_digit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_graph] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lower] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_punct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_space] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upper] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xdigit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_func] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_concatenating_space] = {
    .visible = true,
    .named = true,
  },
  [sym__if_else_separator] = {
    .visible = false,
    .named = true,
  },
  [sym__no_space] = {
    .visible = false,
    .named = true,
  },
  [sym__func_call] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_range_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__special_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_directive] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__statement_separated] = {
    .visible = false,
    .named = true,
  },
  [sym__control_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exit_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym__io_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__getline_exp] = {
    .visible = false,
    .named = true,
  },
  [sym_getline_input] = {
    .visible = true,
    .named = true,
  },
  [sym_getline_file] = {
    .visible = true,
    .named = true,
  },
  [sym__print_args] = {
    .visible = false,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_printf_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_redirected_io_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_piped_io_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__block_content] = {
    .visible = false,
    .named = true,
  },
  [sym__exp] = {
    .visible = false,
    .named = true,
  },
  [sym_ternary_exp] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_exp] = {
    .visible = true,
    .named = true,
  },
  [sym__binary_in] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_exp] = {
    .visible = true,
    .named = true,
  },
  [sym_update_exp] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_exp] = {
    .visible = true,
    .named = true,
  },
  [sym_piped_io_exp] = {
    .visible = true,
    .named = true,
  },
  [sym_string_concat] = {
    .visible = true,
    .named = true,
  },
  [sym_field_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_array_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_list] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym__regex_char_class] = {
    .visible = false,
    .named = true,
  },
  [sym__regex_bracket_exp] = {
    .visible = false,
    .named = true,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_grouping] = {
    .visible = true,
    .named = true,
  },
  [sym__primitive] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace] = {
    .visible = true,
    .named = true,
  },
  [sym_ns_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_func_def] = {
    .visible = true,
    .named = true,
  },
  [sym_param_list] = {
    .visible = true,
    .named = true,
  },
  [sym_func_call] = {
    .visible = true,
    .named = true,
  },
  [sym_indirect_func_call] = {
    .visible = true,
    .named = true,
  },
  [sym_args] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__regex_bracket_exp_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_regex_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_param_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_namespace] = {
    .visible = true,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_advancement = 1,
  field_alternative = 2,
  field_argument = 3,
  field_command = 4,
  field_condition = 5,
  field_consequence = 6,
  field_filename = 7,
  field_flags = 8,
  field_index = 9,
  field_initializer = 10,
  field_left = 11,
  field_name = 12,
  field_operator = 13,
  field_pattern = 14,
  field_right = 15,
  field_start = 16,
  field_stop = 17,
  field_value = 18,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_advancement] = "advancement",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_command] = "command",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_filename] = "filename",
  [field_flags] = "flags",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_pattern] = "pattern",
  [field_right] = "right",
  [field_start] = "start",
  [field_stop] = "stop",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 3},
  [3] = {.index = 3, .length = 2},
  [4] = {.index = 5, .length = 2},
  [5] = {.index = 7, .length = 1},
  [6] = {.index = 8, .length = 1},
  [7] = {.index = 9, .length = 1},
  [8] = {.index = 10, .length = 2},
  [9] = {.index = 12, .length = 2},
  [10] = {.index = 14, .length = 3},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 1},
  [13] = {.index = 19, .length = 1},
  [14] = {.index = 20, .length = 2},
  [15] = {.index = 22, .length = 1},
  [16] = {.index = 23, .length = 1},
  [17] = {.index = 24, .length = 5},
  [18] = {.index = 29, .length = 1},
  [19] = {.index = 30, .length = 3},
  [20] = {.index = 33, .length = 3},
  [21] = {.index = 36, .length = 3},
  [22] = {.index = 39, .length = 3},
  [23] = {.index = 42, .length = 3},
  [24] = {.index = 45, .length = 3},
  [25] = {.index = 48, .length = 3},
  [26] = {.index = 51, .length = 1},
  [27] = {.index = 52, .length = 1},
  [28] = {.index = 53, .length = 2},
  [29] = {.index = 55, .length = 1},
  [30] = {.index = 56, .length = 2},
  [31] = {.index = 58, .length = 2},
  [32] = {.index = 60, .length = 2},
  [33] = {.index = 62, .length = 1},
  [34] = {.index = 63, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_left, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right, 0, .inherited = true},
  [3] =
    {field_argument, 1},
    {field_operator, 0},
  [5] =
    {field_argument, 0},
    {field_operator, 1},
  [7] =
    {field_filename, 2},
  [8] =
    {field_flags, 2},
  [9] =
    {field_pattern, 1},
  [10] =
    {field_left, 0},
    {field_right, 2},
  [12] =
    {field_start, 0},
    {field_stop, 2},
  [14] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [17] =
    {field_command, 0},
  [18] =
    {field_command, 2},
  [19] =
    {field_filename, 3},
  [20] =
    {field_flags, 3},
    {field_pattern, 1},
  [22] =
    {field_name, 0},
  [23] =
    {field_index, 2},
  [24] =
    {field_left, 0},
    {field_left, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [29] =
    {field_name, 1},
  [30] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [33] =
    {field_condition, 1},
    {field_condition, 2},
    {field_condition, 3},
  [36] =
    {field_alternative, 5},
    {field_condition, 0},
    {field_consequence, 2},
  [39] =
    {field_alternative, 5},
    {field_condition, 0},
    {field_consequence, 3},
  [42] =
    {field_condition, 3},
    {field_condition, 4},
    {field_condition, 5},
  [45] =
    {field_alternative, 6},
    {field_condition, 0},
    {field_consequence, 3},
  [48] =
    {field_condition, 4},
    {field_condition, 5},
    {field_condition, 6},
  [51] =
    {field_advancement, 4},
  [52] =
    {field_condition, 3},
  [53] =
    {field_left, 2},
    {field_right, 4},
  [55] =
    {field_initializer, 2},
  [56] =
    {field_advancement, 5},
    {field_condition, 3},
  [58] =
    {field_advancement, 5},
    {field_initializer, 2},
  [60] =
    {field_condition, 4},
    {field_initializer, 2},
  [62] =
    {field_value, 1},
  [63] =
    {field_advancement, 6},
    {field_condition, 4},
    {field_initializer, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = anon_alias_sym_namespace,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 4,
  [7] = 4,
  [8] = 4,
  [9] = 5,
  [10] = 2,
  [11] = 5,
  [12] = 5,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 19,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 15,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 14,
  [31] = 29,
  [32] = 32,
  [33] = 13,
  [34] = 34,
  [35] = 16,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 40,
  [42] = 42,
  [43] = 36,
  [44] = 17,
  [45] = 24,
  [46] = 18,
  [47] = 22,
  [48] = 15,
  [49] = 23,
  [50] = 19,
  [51] = 34,
  [52] = 28,
  [53] = 16,
  [54] = 39,
  [55] = 14,
  [56] = 38,
  [57] = 57,
  [58] = 58,
  [59] = 24,
  [60] = 18,
  [61] = 37,
  [62] = 13,
  [63] = 15,
  [64] = 37,
  [65] = 17,
  [66] = 13,
  [67] = 14,
  [68] = 22,
  [69] = 27,
  [70] = 25,
  [71] = 16,
  [72] = 23,
  [73] = 22,
  [74] = 23,
  [75] = 14,
  [76] = 13,
  [77] = 37,
  [78] = 38,
  [79] = 32,
  [80] = 17,
  [81] = 38,
  [82] = 20,
  [83] = 16,
  [84] = 25,
  [85] = 15,
  [86] = 27,
  [87] = 18,
  [88] = 24,
  [89] = 39,
  [90] = 19,
  [91] = 40,
  [92] = 28,
  [93] = 20,
  [94] = 36,
  [95] = 34,
  [96] = 28,
  [97] = 34,
  [98] = 98,
  [99] = 20,
  [100] = 36,
  [101] = 40,
  [102] = 17,
  [103] = 22,
  [104] = 39,
  [105] = 23,
  [106] = 32,
  [107] = 29,
  [108] = 24,
  [109] = 19,
  [110] = 18,
  [111] = 37,
  [112] = 38,
  [113] = 38,
  [114] = 29,
  [115] = 25,
  [116] = 27,
  [117] = 39,
  [118] = 40,
  [119] = 37,
  [120] = 36,
  [121] = 34,
  [122] = 28,
  [123] = 13,
  [124] = 18,
  [125] = 28,
  [126] = 34,
  [127] = 27,
  [128] = 25,
  [129] = 32,
  [130] = 36,
  [131] = 14,
  [132] = 40,
  [133] = 19,
  [134] = 27,
  [135] = 24,
  [136] = 39,
  [137] = 15,
  [138] = 20,
  [139] = 29,
  [140] = 16,
  [141] = 23,
  [142] = 17,
  [143] = 32,
  [144] = 29,
  [145] = 20,
  [146] = 22,
  [147] = 32,
  [148] = 25,
  [149] = 149,
  [150] = 149,
  [151] = 151,
  [152] = 151,
  [153] = 2,
  [154] = 2,
  [155] = 155,
  [156] = 155,
  [157] = 155,
  [158] = 155,
  [159] = 155,
  [160] = 155,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 161,
  [165] = 165,
  [166] = 162,
  [167] = 163,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 161,
  [175] = 172,
  [176] = 161,
  [177] = 171,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 170,
  [183] = 183,
  [184] = 168,
  [185] = 171,
  [186] = 163,
  [187] = 165,
  [188] = 169,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 179,
  [193] = 161,
  [194] = 194,
  [195] = 195,
  [196] = 163,
  [197] = 197,
  [198] = 171,
  [199] = 170,
  [200] = 200,
  [201] = 168,
  [202] = 173,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 181,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 183,
  [218] = 178,
  [219] = 219,
  [220] = 180,
  [221] = 168,
  [222] = 161,
  [223] = 223,
  [224] = 210,
  [225] = 216,
  [226] = 168,
  [227] = 214,
  [228] = 195,
  [229] = 208,
  [230] = 223,
  [231] = 231,
  [232] = 200,
  [233] = 180,
  [234] = 204,
  [235] = 197,
  [236] = 191,
  [237] = 215,
  [238] = 212,
  [239] = 170,
  [240] = 205,
  [241] = 241,
  [242] = 203,
  [243] = 168,
  [244] = 209,
  [245] = 219,
  [246] = 246,
  [247] = 180,
  [248] = 194,
  [249] = 190,
  [250] = 206,
  [251] = 207,
  [252] = 189,
  [253] = 213,
  [254] = 181,
  [255] = 213,
  [256] = 256,
  [257] = 257,
  [258] = 189,
  [259] = 259,
  [260] = 246,
  [261] = 261,
  [262] = 262,
  [263] = 241,
  [264] = 264,
  [265] = 213,
  [266] = 266,
  [267] = 231,
  [268] = 268,
  [269] = 180,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 181,
  [275] = 275,
  [276] = 276,
  [277] = 180,
  [278] = 276,
  [279] = 262,
  [280] = 275,
  [281] = 273,
  [282] = 264,
  [283] = 272,
  [284] = 271,
  [285] = 213,
  [286] = 270,
  [287] = 268,
  [288] = 256,
  [289] = 189,
  [290] = 261,
  [291] = 266,
  [292] = 213,
  [293] = 257,
  [294] = 259,
  [295] = 163,
  [296] = 162,
  [297] = 161,
  [298] = 298,
  [299] = 171,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 162,
  [304] = 178,
  [305] = 169,
  [306] = 170,
  [307] = 172,
  [308] = 168,
  [309] = 169,
  [310] = 179,
  [311] = 171,
  [312] = 209,
  [313] = 180,
  [314] = 173,
  [315] = 162,
  [316] = 183,
  [317] = 181,
  [318] = 171,
  [319] = 178,
  [320] = 162,
  [321] = 178,
  [322] = 183,
  [323] = 172,
  [324] = 298,
  [325] = 300,
  [326] = 207,
  [327] = 219,
  [328] = 212,
  [329] = 214,
  [330] = 190,
  [331] = 189,
  [332] = 194,
  [333] = 171,
  [334] = 206,
  [335] = 215,
  [336] = 179,
  [337] = 162,
  [338] = 205,
  [339] = 241,
  [340] = 171,
  [341] = 183,
  [342] = 208,
  [343] = 197,
  [344] = 213,
  [345] = 210,
  [346] = 195,
  [347] = 231,
  [348] = 172,
  [349] = 209,
  [350] = 191,
  [351] = 223,
  [352] = 172,
  [353] = 183,
  [354] = 246,
  [355] = 173,
  [356] = 200,
  [357] = 204,
  [358] = 169,
  [359] = 216,
  [360] = 209,
  [361] = 203,
  [362] = 169,
  [363] = 178,
  [364] = 208,
  [365] = 259,
  [366] = 179,
  [367] = 173,
  [368] = 190,
  [369] = 275,
  [370] = 256,
  [371] = 171,
  [372] = 204,
  [373] = 161,
  [374] = 194,
  [375] = 214,
  [376] = 264,
  [377] = 205,
  [378] = 231,
  [379] = 173,
  [380] = 172,
  [381] = 262,
  [382] = 382,
  [383] = 212,
  [384] = 261,
  [385] = 210,
  [386] = 215,
  [387] = 216,
  [388] = 200,
  [389] = 276,
  [390] = 223,
  [391] = 209,
  [392] = 197,
  [393] = 191,
  [394] = 257,
  [395] = 179,
  [396] = 273,
  [397] = 203,
  [398] = 231,
  [399] = 207,
  [400] = 266,
  [401] = 206,
  [402] = 268,
  [403] = 270,
  [404] = 271,
  [405] = 246,
  [406] = 163,
  [407] = 219,
  [408] = 169,
  [409] = 195,
  [410] = 246,
  [411] = 241,
  [412] = 241,
  [413] = 178,
  [414] = 272,
  [415] = 183,
  [416] = 161,
  [417] = 219,
  [418] = 231,
  [419] = 223,
  [420] = 276,
  [421] = 204,
  [422] = 203,
  [423] = 212,
  [424] = 424,
  [425] = 425,
  [426] = 382,
  [427] = 190,
  [428] = 223,
  [429] = 208,
  [430] = 261,
  [431] = 207,
  [432] = 209,
  [433] = 270,
  [434] = 197,
  [435] = 191,
  [436] = 210,
  [437] = 264,
  [438] = 215,
  [439] = 219,
  [440] = 204,
  [441] = 272,
  [442] = 197,
  [443] = 259,
  [444] = 170,
  [445] = 190,
  [446] = 215,
  [447] = 276,
  [448] = 168,
  [449] = 179,
  [450] = 210,
  [451] = 200,
  [452] = 216,
  [453] = 266,
  [454] = 268,
  [455] = 257,
  [456] = 195,
  [457] = 191,
  [458] = 271,
  [459] = 273,
  [460] = 275,
  [461] = 205,
  [462] = 256,
  [463] = 262,
  [464] = 205,
  [465] = 168,
  [466] = 200,
  [467] = 216,
  [468] = 194,
  [469] = 212,
  [470] = 241,
  [471] = 246,
  [472] = 206,
  [473] = 214,
  [474] = 173,
  [475] = 191,
  [476] = 197,
  [477] = 276,
  [478] = 223,
  [479] = 205,
  [480] = 425,
  [481] = 210,
  [482] = 181,
  [483] = 180,
  [484] = 241,
  [485] = 200,
  [486] = 212,
  [487] = 216,
  [488] = 180,
  [489] = 215,
  [490] = 424,
  [491] = 165,
  [492] = 219,
  [493] = 246,
  [494] = 231,
  [495] = 190,
  [496] = 204,
  [497] = 270,
  [498] = 498,
  [499] = 266,
  [500] = 276,
  [501] = 259,
  [502] = 275,
  [503] = 256,
  [504] = 213,
  [505] = 505,
  [506] = 506,
  [507] = 257,
  [508] = 508,
  [509] = 509,
  [510] = 261,
  [511] = 165,
  [512] = 262,
  [513] = 273,
  [514] = 268,
  [515] = 264,
  [516] = 271,
  [517] = 272,
  [518] = 189,
  [519] = 213,
  [520] = 498,
  [521] = 509,
  [522] = 508,
  [523] = 506,
  [524] = 505,
  [525] = 165,
  [526] = 165,
  [527] = 162,
  [528] = 178,
  [529] = 172,
  [530] = 162,
  [531] = 178,
  [532] = 169,
  [533] = 209,
  [534] = 173,
  [535] = 183,
  [536] = 231,
  [537] = 246,
  [538] = 179,
  [539] = 171,
  [540] = 241,
  [541] = 169,
  [542] = 183,
  [543] = 171,
  [544] = 172,
  [545] = 209,
  [546] = 271,
  [547] = 219,
  [548] = 197,
  [549] = 204,
  [550] = 173,
  [551] = 231,
  [552] = 246,
  [553] = 273,
  [554] = 206,
  [555] = 179,
  [556] = 276,
  [557] = 200,
  [558] = 216,
  [559] = 203,
  [560] = 190,
  [561] = 191,
  [562] = 259,
  [563] = 264,
  [564] = 208,
  [565] = 266,
  [566] = 214,
  [567] = 382,
  [568] = 262,
  [569] = 261,
  [570] = 215,
  [571] = 210,
  [572] = 212,
  [573] = 268,
  [574] = 200,
  [575] = 241,
  [576] = 194,
  [577] = 298,
  [578] = 257,
  [579] = 205,
  [580] = 256,
  [581] = 300,
  [582] = 275,
  [583] = 191,
  [584] = 195,
  [585] = 272,
  [586] = 223,
  [587] = 270,
  [588] = 207,
  [589] = 219,
  [590] = 300,
  [591] = 163,
  [592] = 223,
  [593] = 205,
  [594] = 212,
  [595] = 210,
  [596] = 596,
  [597] = 276,
  [598] = 216,
  [599] = 215,
  [600] = 178,
  [601] = 190,
  [602] = 204,
  [603] = 298,
  [604] = 197,
  [605] = 161,
  [606] = 161,
  [607] = 178,
  [608] = 608,
  [609] = 163,
  [610] = 170,
  [611] = 181,
  [612] = 168,
  [613] = 168,
  [614] = 161,
  [615] = 300,
  [616] = 209,
  [617] = 298,
  [618] = 161,
  [619] = 170,
  [620] = 180,
  [621] = 241,
  [622] = 181,
  [623] = 231,
  [624] = 246,
  [625] = 168,
  [626] = 189,
  [627] = 298,
  [628] = 300,
  [629] = 168,
  [630] = 180,
  [631] = 178,
  [632] = 209,
  [633] = 264,
  [634] = 161,
  [635] = 241,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 178,
  [640] = 261,
  [641] = 262,
  [642] = 636,
  [643] = 636,
  [644] = 273,
  [645] = 270,
  [646] = 213,
  [647] = 636,
  [648] = 213,
  [649] = 161,
  [650] = 272,
  [651] = 180,
  [652] = 271,
  [653] = 257,
  [654] = 638,
  [655] = 276,
  [656] = 246,
  [657] = 231,
  [658] = 636,
  [659] = 637,
  [660] = 636,
  [661] = 661,
  [662] = 662,
  [663] = 259,
  [664] = 266,
  [665] = 180,
  [666] = 275,
  [667] = 268,
  [668] = 189,
  [669] = 256,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 673,
  [675] = 675,
  [676] = 676,
  [677] = 676,
  [678] = 673,
  [679] = 679,
  [680] = 676,
  [681] = 161,
  [682] = 682,
  [683] = 676,
  [684] = 161,
  [685] = 168,
  [686] = 676,
  [687] = 675,
  [688] = 675,
  [689] = 168,
  [690] = 675,
  [691] = 672,
  [692] = 679,
  [693] = 675,
  [694] = 213,
  [695] = 673,
  [696] = 679,
  [697] = 675,
  [698] = 672,
  [699] = 276,
  [700] = 679,
  [701] = 673,
  [702] = 682,
  [703] = 213,
  [704] = 672,
  [705] = 679,
  [706] = 671,
  [707] = 670,
  [708] = 675,
  [709] = 682,
  [710] = 672,
  [711] = 673,
  [712] = 273,
  [713] = 679,
  [714] = 676,
  [715] = 675,
  [716] = 676,
  [717] = 682,
  [718] = 672,
  [719] = 673,
  [720] = 675,
  [721] = 675,
  [722] = 672,
  [723] = 676,
  [724] = 679,
  [725] = 676,
  [726] = 682,
  [727] = 676,
  [728] = 679,
  [729] = 679,
  [730] = 672,
  [731] = 679,
  [732] = 682,
  [733] = 682,
  [734] = 679,
  [735] = 673,
  [736] = 672,
  [737] = 673,
  [738] = 672,
  [739] = 673,
  [740] = 672,
  [741] = 673,
  [742] = 672,
  [743] = 679,
  [744] = 673,
  [745] = 672,
  [746] = 676,
  [747] = 673,
  [748] = 672,
  [749] = 682,
  [750] = 676,
  [751] = 682,
  [752] = 673,
  [753] = 682,
  [754] = 682,
  [755] = 682,
  [756] = 264,
  [757] = 673,
  [758] = 682,
  [759] = 262,
  [760] = 261,
  [761] = 679,
  [762] = 257,
  [763] = 675,
  [764] = 675,
  [765] = 675,
  [766] = 259,
  [767] = 682,
  [768] = 676,
  [769] = 266,
  [770] = 675,
  [771] = 679,
  [772] = 675,
  [773] = 682,
  [774] = 675,
  [775] = 268,
  [776] = 672,
  [777] = 178,
  [778] = 662,
  [779] = 270,
  [780] = 679,
  [781] = 661,
  [782] = 271,
  [783] = 676,
  [784] = 272,
  [785] = 209,
  [786] = 676,
  [787] = 275,
  [788] = 673,
  [789] = 256,
  [790] = 676,
  [791] = 679,
  [792] = 792,
  [793] = 793,
  [794] = 792,
  [795] = 795,
  [796] = 209,
  [797] = 797,
  [798] = 241,
  [799] = 799,
  [800] = 800,
  [801] = 231,
  [802] = 246,
  [803] = 803,
  [804] = 792,
  [805] = 795,
  [806] = 795,
  [807] = 800,
  [808] = 800,
  [809] = 799,
  [810] = 803,
  [811] = 793,
  [812] = 812,
  [813] = 800,
  [814] = 800,
  [815] = 161,
  [816] = 795,
  [817] = 795,
  [818] = 793,
  [819] = 812,
  [820] = 803,
  [821] = 792,
  [822] = 792,
  [823] = 793,
  [824] = 812,
  [825] = 799,
  [826] = 792,
  [827] = 812,
  [828] = 803,
  [829] = 793,
  [830] = 830,
  [831] = 831,
  [832] = 830,
  [833] = 793,
  [834] = 803,
  [835] = 180,
  [836] = 830,
  [837] = 837,
  [838] = 161,
  [839] = 830,
  [840] = 180,
  [841] = 163,
  [842] = 830,
  [843] = 830,
  [844] = 812,
  [845] = 799,
  [846] = 803,
  [847] = 799,
  [848] = 812,
  [849] = 168,
  [850] = 799,
  [851] = 168,
  [852] = 830,
  [853] = 800,
  [854] = 795,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 855,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 860,
  [871] = 871,
  [872] = 857,
  [873] = 873,
  [874] = 869,
  [875] = 868,
  [876] = 867,
  [877] = 866,
  [878] = 865,
  [879] = 863,
  [880] = 862,
  [881] = 861,
  [882] = 859,
  [883] = 883,
  [884] = 856,
  [885] = 858,
  [886] = 861,
  [887] = 858,
  [888] = 862,
  [889] = 863,
  [890] = 865,
  [891] = 866,
  [892] = 867,
  [893] = 868,
  [894] = 883,
  [895] = 857,
  [896] = 860,
  [897] = 869,
  [898] = 873,
  [899] = 869,
  [900] = 868,
  [901] = 867,
  [902] = 866,
  [903] = 865,
  [904] = 863,
  [905] = 862,
  [906] = 861,
  [907] = 867,
  [908] = 883,
  [909] = 859,
  [910] = 857,
  [911] = 869,
  [912] = 858,
  [913] = 868,
  [914] = 865,
  [915] = 866,
  [916] = 858,
  [917] = 863,
  [918] = 862,
  [919] = 861,
  [920] = 859,
  [921] = 921,
  [922] = 861,
  [923] = 862,
  [924] = 863,
  [925] = 865,
  [926] = 866,
  [927] = 867,
  [928] = 868,
  [929] = 869,
  [930] = 858,
  [931] = 180,
  [932] = 873,
  [933] = 921,
  [934] = 934,
  [935] = 935,
  [936] = 831,
  [937] = 860,
  [938] = 921,
  [939] = 858,
  [940] = 871,
  [941] = 883,
  [942] = 873,
  [943] = 883,
  [944] = 860,
  [945] = 857,
  [946] = 871,
  [947] = 857,
  [948] = 231,
  [949] = 857,
  [950] = 883,
  [951] = 951,
  [952] = 860,
  [953] = 873,
  [954] = 860,
  [955] = 858,
  [956] = 859,
  [957] = 869,
  [958] = 868,
  [959] = 867,
  [960] = 866,
  [961] = 865,
  [962] = 863,
  [963] = 862,
  [964] = 861,
  [965] = 256,
  [966] = 871,
  [967] = 859,
  [968] = 275,
  [969] = 869,
  [970] = 868,
  [971] = 867,
  [972] = 866,
  [973] = 865,
  [974] = 863,
  [975] = 862,
  [976] = 861,
  [977] = 977,
  [978] = 272,
  [979] = 859,
  [980] = 271,
  [981] = 861,
  [982] = 862,
  [983] = 863,
  [984] = 984,
  [985] = 865,
  [986] = 866,
  [987] = 867,
  [988] = 868,
  [989] = 869,
  [990] = 871,
  [991] = 270,
  [992] = 860,
  [993] = 268,
  [994] = 935,
  [995] = 266,
  [996] = 857,
  [997] = 856,
  [998] = 883,
  [999] = 883,
  [1000] = 858,
  [1001] = 259,
  [1002] = 257,
  [1003] = 858,
  [1004] = 883,
  [1005] = 859,
  [1006] = 261,
  [1007] = 262,
  [1008] = 856,
  [1009] = 861,
  [1010] = 862,
  [1011] = 883,
  [1012] = 863,
  [1013] = 856,
  [1014] = 865,
  [1015] = 857,
  [1016] = 856,
  [1017] = 866,
  [1018] = 856,
  [1019] = 860,
  [1020] = 867,
  [1021] = 856,
  [1022] = 868,
  [1023] = 869,
  [1024] = 856,
  [1025] = 855,
  [1026] = 873,
  [1027] = 856,
  [1028] = 855,
  [1029] = 857,
  [1030] = 856,
  [1031] = 873,
  [1032] = 855,
  [1033] = 860,
  [1034] = 859,
  [1035] = 856,
  [1036] = 264,
  [1037] = 855,
  [1038] = 860,
  [1039] = 857,
  [1040] = 856,
  [1041] = 855,
  [1042] = 871,
  [1043] = 858,
  [1044] = 869,
  [1045] = 868,
  [1046] = 859,
  [1047] = 869,
  [1048] = 867,
  [1049] = 866,
  [1050] = 860,
  [1051] = 861,
  [1052] = 862,
  [1053] = 863,
  [1054] = 1054,
  [1055] = 865,
  [1056] = 866,
  [1057] = 867,
  [1058] = 868,
  [1059] = 869,
  [1060] = 865,
  [1061] = 873,
  [1062] = 873,
  [1063] = 170,
  [1064] = 859,
  [1065] = 860,
  [1066] = 1066,
  [1067] = 868,
  [1068] = 867,
  [1069] = 866,
  [1070] = 865,
  [1071] = 863,
  [1072] = 862,
  [1073] = 861,
  [1074] = 273,
  [1075] = 871,
  [1076] = 921,
  [1077] = 935,
  [1078] = 860,
  [1079] = 209,
  [1080] = 837,
  [1081] = 1081,
  [1082] = 246,
  [1083] = 1066,
  [1084] = 1054,
  [1085] = 859,
  [1086] = 1081,
  [1087] = 935,
  [1088] = 921,
  [1089] = 984,
  [1090] = 873,
  [1091] = 921,
  [1092] = 859,
  [1093] = 984,
  [1094] = 241,
  [1095] = 858,
  [1096] = 984,
  [1097] = 984,
  [1098] = 863,
  [1099] = 984,
  [1100] = 984,
  [1101] = 984,
  [1102] = 984,
  [1103] = 984,
  [1104] = 977,
  [1105] = 984,
  [1106] = 860,
  [1107] = 984,
  [1108] = 1108,
  [1109] = 984,
  [1110] = 883,
  [1111] = 168,
  [1112] = 984,
  [1113] = 934,
  [1114] = 1054,
  [1115] = 862,
  [1116] = 861,
  [1117] = 1066,
  [1118] = 859,
  [1119] = 859,
  [1120] = 935,
  [1121] = 180,
  [1122] = 856,
  [1123] = 855,
  [1124] = 855,
  [1125] = 856,
  [1126] = 859,
  [1127] = 857,
  [1128] = 860,
  [1129] = 858,
  [1130] = 859,
  [1131] = 213,
  [1132] = 168,
  [1133] = 856,
  [1134] = 860,
  [1135] = 855,
  [1136] = 883,
  [1137] = 883,
  [1138] = 857,
  [1139] = 860,
  [1140] = 873,
  [1141] = 859,
  [1142] = 860,
  [1143] = 859,
  [1144] = 858,
  [1145] = 276,
  [1146] = 873,
  [1147] = 860,
  [1148] = 859,
  [1149] = 873,
  [1150] = 859,
  [1151] = 860,
  [1152] = 873,
  [1153] = 859,
  [1154] = 856,
  [1155] = 868,
  [1156] = 860,
  [1157] = 1066,
  [1158] = 1054,
  [1159] = 859,
  [1160] = 857,
  [1161] = 857,
  [1162] = 860,
  [1163] = 1163,
  [1164] = 861,
  [1165] = 862,
  [1166] = 863,
  [1167] = 865,
  [1168] = 866,
  [1169] = 867,
  [1170] = 865,
  [1171] = 869,
  [1172] = 873,
  [1173] = 871,
  [1174] = 873,
  [1175] = 860,
  [1176] = 859,
  [1177] = 855,
  [1178] = 1066,
  [1179] = 1054,
  [1180] = 883,
  [1181] = 856,
  [1182] = 855,
  [1183] = 855,
  [1184] = 856,
  [1185] = 855,
  [1186] = 883,
  [1187] = 856,
  [1188] = 856,
  [1189] = 856,
  [1190] = 935,
  [1191] = 984,
  [1192] = 869,
  [1193] = 868,
  [1194] = 867,
  [1195] = 866,
  [1196] = 865,
  [1197] = 863,
  [1198] = 862,
  [1199] = 861,
  [1200] = 858,
  [1201] = 883,
  [1202] = 1054,
  [1203] = 1066,
  [1204] = 857,
  [1205] = 869,
  [1206] = 868,
  [1207] = 867,
  [1208] = 856,
  [1209] = 855,
  [1210] = 866,
  [1211] = 984,
  [1212] = 863,
  [1213] = 862,
  [1214] = 861,
  [1215] = 855,
  [1216] = 858,
  [1217] = 856,
  [1218] = 213,
  [1219] = 162,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 181,
  [1223] = 180,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 276,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 213,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 180,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1163,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 231,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1272,
  [1273] = 273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 264,
  [1284] = 262,
  [1285] = 261,
  [1286] = 257,
  [1287] = 259,
  [1288] = 266,
  [1289] = 268,
  [1290] = 270,
  [1291] = 271,
  [1292] = 272,
  [1293] = 213,
  [1294] = 275,
  [1295] = 256,
  [1296] = 241,
  [1297] = 246,
  [1298] = 259,
  [1299] = 1263,
  [1300] = 1229,
  [1301] = 272,
  [1302] = 271,
  [1303] = 270,
  [1304] = 1231,
  [1305] = 1279,
  [1306] = 189,
  [1307] = 268,
  [1308] = 266,
  [1309] = 257,
  [1310] = 261,
  [1311] = 262,
  [1312] = 1228,
  [1313] = 264,
  [1314] = 273,
  [1315] = 276,
  [1316] = 1230,
  [1317] = 1232,
  [1318] = 1233,
  [1319] = 256,
  [1320] = 1221,
  [1321] = 1235,
  [1322] = 1225,
  [1323] = 1237,
  [1324] = 1238,
  [1325] = 1239,
  [1326] = 1240,
  [1327] = 213,
  [1328] = 1242,
  [1329] = 1243,
  [1330] = 1244,
  [1331] = 1281,
  [1332] = 1282,
  [1333] = 1226,
  [1334] = 1245,
  [1335] = 162,
  [1336] = 1246,
  [1337] = 1247,
  [1338] = 213,
  [1339] = 1220,
  [1340] = 1248,
  [1341] = 1280,
  [1342] = 162,
  [1343] = 1249,
  [1344] = 1250,
  [1345] = 1236,
  [1346] = 1278,
  [1347] = 1277,
  [1348] = 178,
  [1349] = 1349,
  [1350] = 1251,
  [1351] = 1252,
  [1352] = 1253,
  [1353] = 1276,
  [1354] = 1254,
  [1355] = 1275,
  [1356] = 1255,
  [1357] = 1256,
  [1358] = 1257,
  [1359] = 1258,
  [1360] = 1224,
  [1361] = 1274,
  [1362] = 1272,
  [1363] = 1271,
  [1364] = 1259,
  [1365] = 1270,
  [1366] = 1260,
  [1367] = 1261,
  [1368] = 1268,
  [1369] = 1267,
  [1370] = 1262,
  [1371] = 1265,
  [1372] = 275,
  [1373] = 1264,
  [1374] = 1374,
  [1375] = 1374,
  [1376] = 1376,
  [1377] = 178,
  [1378] = 172,
  [1379] = 1379,
  [1380] = 1374,
  [1381] = 1376,
  [1382] = 1374,
  [1383] = 169,
  [1384] = 178,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1374,
  [1388] = 1374,
  [1389] = 1386,
  [1390] = 162,
  [1391] = 1385,
  [1392] = 1379,
  [1393] = 209,
  [1394] = 1394,
  [1395] = 1394,
  [1396] = 172,
  [1397] = 169,
  [1398] = 172,
  [1399] = 1394,
  [1400] = 183,
  [1401] = 1394,
  [1402] = 179,
  [1403] = 1394,
  [1404] = 178,
  [1405] = 1394,
  [1406] = 173,
  [1407] = 1407,
  [1408] = 171,
  [1409] = 169,
  [1410] = 1410,
  [1411] = 246,
  [1412] = 190,
  [1413] = 214,
  [1414] = 204,
  [1415] = 183,
  [1416] = 203,
  [1417] = 178,
  [1418] = 194,
  [1419] = 207,
  [1420] = 195,
  [1421] = 206,
  [1422] = 205,
  [1423] = 169,
  [1424] = 219,
  [1425] = 173,
  [1426] = 231,
  [1427] = 179,
  [1428] = 241,
  [1429] = 212,
  [1430] = 173,
  [1431] = 172,
  [1432] = 210,
  [1433] = 215,
  [1434] = 171,
  [1435] = 216,
  [1436] = 200,
  [1437] = 208,
  [1438] = 171,
  [1439] = 179,
  [1440] = 197,
  [1441] = 191,
  [1442] = 209,
  [1443] = 209,
  [1444] = 183,
  [1445] = 223,
  [1446] = 219,
  [1447] = 210,
  [1448] = 276,
  [1449] = 264,
  [1450] = 262,
  [1451] = 261,
  [1452] = 257,
  [1453] = 178,
  [1454] = 259,
  [1455] = 171,
  [1456] = 205,
  [1457] = 205,
  [1458] = 173,
  [1459] = 266,
  [1460] = 268,
  [1461] = 270,
  [1462] = 271,
  [1463] = 272,
  [1464] = 275,
  [1465] = 256,
  [1466] = 206,
  [1467] = 190,
  [1468] = 212,
  [1469] = 191,
  [1470] = 204,
  [1471] = 197,
  [1472] = 219,
  [1473] = 207,
  [1474] = 183,
  [1475] = 208,
  [1476] = 215,
  [1477] = 216,
  [1478] = 200,
  [1479] = 223,
  [1480] = 214,
  [1481] = 223,
  [1482] = 178,
  [1483] = 210,
  [1484] = 191,
  [1485] = 194,
  [1486] = 195,
  [1487] = 212,
  [1488] = 231,
  [1489] = 203,
  [1490] = 197,
  [1491] = 241,
  [1492] = 246,
  [1493] = 382,
  [1494] = 190,
  [1495] = 241,
  [1496] = 204,
  [1497] = 246,
  [1498] = 200,
  [1499] = 215,
  [1500] = 209,
  [1501] = 179,
  [1502] = 216,
  [1503] = 273,
  [1504] = 231,
  [1505] = 178,
  [1506] = 425,
  [1507] = 1282,
  [1508] = 259,
  [1509] = 261,
  [1510] = 246,
  [1511] = 262,
  [1512] = 264,
  [1513] = 162,
  [1514] = 212,
  [1515] = 257,
  [1516] = 200,
  [1517] = 241,
  [1518] = 382,
  [1519] = 266,
  [1520] = 276,
  [1521] = 268,
  [1522] = 270,
  [1523] = 271,
  [1524] = 210,
  [1525] = 272,
  [1526] = 275,
  [1527] = 178,
  [1528] = 276,
  [1529] = 424,
  [1530] = 231,
  [1531] = 209,
  [1532] = 273,
  [1533] = 256,
  [1534] = 219,
  [1535] = 190,
  [1536] = 191,
  [1537] = 197,
  [1538] = 1281,
  [1539] = 205,
  [1540] = 216,
  [1541] = 215,
  [1542] = 204,
  [1543] = 223,
  [1544] = 231,
  [1545] = 178,
  [1546] = 209,
  [1547] = 425,
  [1548] = 209,
  [1549] = 424,
  [1550] = 241,
  [1551] = 276,
  [1552] = 1407,
  [1553] = 162,
  [1554] = 246,
  [1555] = 241,
  [1556] = 257,
  [1557] = 498,
  [1558] = 505,
  [1559] = 382,
  [1560] = 506,
  [1561] = 231,
  [1562] = 509,
  [1563] = 246,
  [1564] = 508,
  [1565] = 209,
  [1566] = 276,
  [1567] = 273,
  [1568] = 246,
  [1569] = 241,
  [1570] = 169,
  [1571] = 256,
  [1572] = 275,
  [1573] = 272,
  [1574] = 271,
  [1575] = 266,
  [1576] = 270,
  [1577] = 209,
  [1578] = 268,
  [1579] = 172,
  [1580] = 231,
  [1581] = 259,
  [1582] = 262,
  [1583] = 261,
  [1584] = 264,
  [1585] = 273,
  [1586] = 276,
  [1587] = 172,
  [1588] = 382,
  [1589] = 241,
  [1590] = 241,
  [1591] = 179,
  [1592] = 276,
  [1593] = 246,
  [1594] = 231,
  [1595] = 173,
  [1596] = 264,
  [1597] = 262,
  [1598] = 261,
  [1599] = 257,
  [1600] = 259,
  [1601] = 209,
  [1602] = 266,
  [1603] = 268,
  [1604] = 270,
  [1605] = 169,
  [1606] = 271,
  [1607] = 272,
  [1608] = 275,
  [1609] = 256,
  [1610] = 508,
  [1611] = 425,
  [1612] = 424,
  [1613] = 498,
  [1614] = 231,
  [1615] = 505,
  [1616] = 246,
  [1617] = 183,
  [1618] = 171,
  [1619] = 506,
  [1620] = 509,
  [1621] = 271,
  [1622] = 223,
  [1623] = 1282,
  [1624] = 203,
  [1625] = 264,
  [1626] = 183,
  [1627] = 276,
  [1628] = 262,
  [1629] = 206,
  [1630] = 261,
  [1631] = 1281,
  [1632] = 1632,
  [1633] = 257,
  [1634] = 204,
  [1635] = 259,
  [1636] = 246,
  [1637] = 190,
  [1638] = 231,
  [1639] = 173,
  [1640] = 171,
  [1641] = 219,
  [1642] = 266,
  [1643] = 268,
  [1644] = 270,
  [1645] = 424,
  [1646] = 195,
  [1647] = 208,
  [1648] = 207,
  [1649] = 205,
  [1650] = 275,
  [1651] = 256,
  [1652] = 212,
  [1653] = 210,
  [1654] = 215,
  [1655] = 216,
  [1656] = 200,
  [1657] = 208,
  [1658] = 425,
  [1659] = 382,
  [1660] = 276,
  [1661] = 214,
  [1662] = 272,
  [1663] = 203,
  [1664] = 197,
  [1665] = 191,
  [1666] = 179,
  [1667] = 194,
  [1668] = 241,
  [1669] = 273,
  [1670] = 1670,
  [1671] = 200,
  [1672] = 190,
  [1673] = 1673,
  [1674] = 212,
  [1675] = 204,
  [1676] = 223,
  [1677] = 205,
  [1678] = 216,
  [1679] = 197,
  [1680] = 191,
  [1681] = 215,
  [1682] = 210,
  [1683] = 276,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 508,
  [1687] = 505,
  [1688] = 506,
  [1689] = 219,
  [1690] = 509,
  [1691] = 1691,
  [1692] = 498,
  [1693] = 1693,
  [1694] = 506,
  [1695] = 509,
  [1696] = 508,
  [1697] = 498,
  [1698] = 505,
  [1699] = 1699,
  [1700] = 424,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1701,
  [1704] = 1702,
  [1705] = 1701,
  [1706] = 1706,
  [1707] = 1701,
  [1708] = 1701,
  [1709] = 1702,
  [1710] = 1701,
  [1711] = 1701,
  [1712] = 1701,
  [1713] = 1701,
  [1714] = 1701,
  [1715] = 1702,
  [1716] = 1702,
  [1717] = 1702,
  [1718] = 1701,
  [1719] = 425,
  [1720] = 1701,
  [1721] = 1702,
  [1722] = 1701,
  [1723] = 1702,
  [1724] = 1702,
  [1725] = 1701,
  [1726] = 1701,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1729,
  [1733] = 1731,
  [1734] = 1728,
  [1735] = 1735,
  [1736] = 1730,
  [1737] = 1737,
  [1738] = 1730,
  [1739] = 1739,
  [1740] = 1730,
  [1741] = 1735,
  [1742] = 1742,
  [1743] = 1729,
  [1744] = 1729,
  [1745] = 1730,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1730,
  [1749] = 1749,
  [1750] = 1728,
  [1751] = 1747,
  [1752] = 1752,
  [1753] = 1746,
  [1754] = 1739,
  [1755] = 1755,
  [1756] = 1731,
  [1757] = 1731,
  [1758] = 1742,
  [1759] = 1752,
  [1760] = 1746,
  [1761] = 1747,
  [1762] = 1730,
  [1763] = 1763,
  [1764] = 1731,
  [1765] = 1729,
  [1766] = 1730,
  [1767] = 1742,
  [1768] = 1731,
  [1769] = 1731,
  [1770] = 1730,
  [1771] = 1731,
  [1772] = 1730,
  [1773] = 1746,
  [1774] = 1730,
  [1775] = 1735,
  [1776] = 1731,
  [1777] = 1747,
  [1778] = 1755,
  [1779] = 1763,
  [1780] = 1737,
  [1781] = 1739,
  [1782] = 1735,
  [1783] = 1752,
  [1784] = 1742,
  [1785] = 1737,
  [1786] = 1730,
  [1787] = 1728,
  [1788] = 1746,
  [1789] = 1752,
  [1790] = 1752,
  [1791] = 1791,
  [1792] = 1739,
  [1793] = 1731,
  [1794] = 1731,
  [1795] = 1731,
  [1796] = 1730,
  [1797] = 1737,
  [1798] = 1735,
  [1799] = 1728,
  [1800] = 1739,
  [1801] = 1739,
  [1802] = 1791,
  [1803] = 1735,
  [1804] = 1731,
  [1805] = 1747,
  [1806] = 1746,
  [1807] = 1731,
  [1808] = 1730,
  [1809] = 1731,
  [1810] = 1729,
  [1811] = 1737,
  [1812] = 1747,
  [1813] = 1742,
  [1814] = 1731,
  [1815] = 1752,
  [1816] = 1728,
  [1817] = 1730,
  [1818] = 1737,
  [1819] = 1730,
  [1820] = 1742,
  [1821] = 1821,
  [1822] = 1821,
  [1823] = 1821,
  [1824] = 1821,
  [1825] = 1821,
  [1826] = 1821,
  [1827] = 1821,
  [1828] = 1821,
  [1829] = 1821,
  [1830] = 1821,
  [1831] = 1821,
  [1832] = 1821,
  [1833] = 1821,
  [1834] = 1821,
  [1835] = 1821,
  [1836] = 1821,
  [1837] = 1837,
  [1838] = 831,
  [1839] = 1839,
  [1840] = 831,
  [1841] = 831,
  [1842] = 831,
  [1843] = 1843,
  [1844] = 1376,
  [1845] = 1376,
  [1846] = 1379,
  [1847] = 1847,
  [1848] = 1386,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1379,
  [1852] = 1385,
  [1853] = 1843,
  [1854] = 1850,
  [1855] = 1386,
  [1856] = 1385,
  [1857] = 1857,
  [1858] = 1857,
  [1859] = 1857,
  [1860] = 1857,
  [1861] = 1861,
  [1862] = 1857,
  [1863] = 1857,
  [1864] = 1857,
  [1865] = 1865,
  [1866] = 1857,
  [1867] = 1857,
  [1868] = 1857,
  [1869] = 1857,
  [1870] = 1857,
  [1871] = 1857,
  [1872] = 1857,
  [1873] = 1857,
  [1874] = 1857,
  [1875] = 1857,
  [1876] = 1857,
  [1877] = 1857,
  [1878] = 1857,
  [1879] = 1879,
  [1880] = 1857,
  [1881] = 1857,
  [1882] = 1857,
  [1883] = 1883,
  [1884] = 1857,
  [1885] = 1857,
  [1886] = 1886,
  [1887] = 1886,
  [1888] = 1888,
  [1889] = 1886,
  [1890] = 1888,
  [1891] = 1888,
  [1892] = 1886,
  [1893] = 1886,
  [1894] = 1888,
  [1895] = 1888,
  [1896] = 1888,
  [1897] = 1888,
  [1898] = 1888,
  [1899] = 1886,
  [1900] = 1888,
  [1901] = 1886,
  [1902] = 1886,
  [1903] = 1886,
  [1904] = 1888,
  [1905] = 1888,
  [1906] = 1886,
  [1907] = 1888,
  [1908] = 1888,
  [1909] = 1888,
  [1910] = 1888,
  [1911] = 1886,
  [1912] = 1888,
  [1913] = 1888,
  [1914] = 1888,
  [1915] = 1886,
  [1916] = 1888,
  [1917] = 1917,
  [1918] = 1886,
  [1919] = 1886,
  [1920] = 1888,
  [1921] = 1886,
  [1922] = 1886,
  [1923] = 1923,
  [1924] = 1888,
  [1925] = 1886,
  [1926] = 1886,
  [1927] = 1927,
  [1928] = 1886,
  [1929] = 1929,
  [1930] = 1888,
  [1931] = 1886,
  [1932] = 1886,
  [1933] = 1886,
  [1934] = 1886,
  [1935] = 1888,
  [1936] = 1888,
  [1937] = 1886,
  [1938] = 1376,
  [1939] = 1939,
  [1940] = 1376,
  [1941] = 1941,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1944,
  [1945] = 1941,
  [1946] = 1385,
  [1947] = 1349,
  [1948] = 1386,
  [1949] = 1941,
  [1950] = 1939,
  [1951] = 1939,
  [1952] = 1942,
  [1953] = 1939,
  [1954] = 1954,
  [1955] = 1385,
  [1956] = 1942,
  [1957] = 1941,
  [1958] = 1942,
  [1959] = 1939,
  [1960] = 1960,
  [1961] = 1941,
  [1962] = 1386,
  [1963] = 1944,
  [1964] = 1941,
  [1965] = 1379,
  [1966] = 1943,
  [1967] = 1944,
  [1968] = 1944,
  [1969] = 1944,
  [1970] = 1944,
  [1971] = 1939,
  [1972] = 1379,
  [1973] = 1954,
  [1974] = 1942,
  [1975] = 1942,
  [1976] = 1976,
  [1977] = 1977,
  [1978] = 1978,
  [1979] = 1976,
  [1980] = 1978,
  [1981] = 1981,
  [1982] = 1978,
  [1983] = 1977,
  [1984] = 1984,
  [1985] = 1976,
  [1986] = 1977,
  [1987] = 1978,
  [1988] = 1976,
  [1989] = 1989,
  [1990] = 1977,
  [1991] = 1978,
  [1992] = 1978,
  [1993] = 1976,
  [1994] = 1977,
  [1995] = 1978,
  [1996] = 1996,
  [1997] = 1977,
  [1998] = 1977,
  [1999] = 1999,
  [2000] = 1978,
  [2001] = 1978,
  [2002] = 1977,
  [2003] = 1977,
  [2004] = 2004,
  [2005] = 1989,
  [2006] = 1976,
  [2007] = 1977,
  [2008] = 1978,
  [2009] = 2004,
  [2010] = 1981,
  [2011] = 2011,
  [2012] = 2011,
  [2013] = 2011,
  [2014] = 2011,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2011,
  [2019] = 2019,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 2011,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2025,
  [2027] = 2025,
  [2028] = 241,
  [2029] = 2029,
  [2030] = 2025,
  [2031] = 246,
  [2032] = 2025,
  [2033] = 2033,
  [2034] = 2034,
  [2035] = 2025,
  [2036] = 2025,
  [2037] = 2029,
  [2038] = 2038,
  [2039] = 2039,
  [2040] = 2029,
  [2041] = 2041,
  [2042] = 2025,
  [2043] = 2025,
  [2044] = 2044,
  [2045] = 2045,
  [2046] = 2045,
  [2047] = 2025,
  [2048] = 2025,
  [2049] = 2025,
  [2050] = 2025,
  [2051] = 2025,
  [2052] = 2045,
  [2053] = 2029,
  [2054] = 2045,
  [2055] = 2045,
  [2056] = 2045,
  [2057] = 2045,
  [2058] = 2045,
  [2059] = 2025,
  [2060] = 2045,
  [2061] = 2045,
  [2062] = 2045,
  [2063] = 2045,
  [2064] = 2045,
  [2065] = 2045,
  [2066] = 2045,
  [2067] = 2029,
  [2068] = 2029,
  [2069] = 2069,
  [2070] = 2070,
  [2071] = 2071,
  [2072] = 2072,
  [2073] = 2071,
  [2074] = 2074,
  [2075] = 2069,
  [2076] = 2076,
  [2077] = 2071,
  [2078] = 2072,
  [2079] = 2079,
  [2080] = 2080,
  [2081] = 2069,
  [2082] = 2082,
  [2083] = 2071,
  [2084] = 2072,
  [2085] = 2072,
  [2086] = 2069,
  [2087] = 2070,
  [2088] = 2088,
  [2089] = 2071,
  [2090] = 2072,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2069,
  [2094] = 2071,
  [2095] = 2071,
  [2096] = 2072,
  [2097] = 2097,
  [2098] = 2072,
  [2099] = 2069,
  [2100] = 2074,
  [2101] = 2071,
  [2102] = 2072,
  [2103] = 2070,
  [2104] = 2074,
  [2105] = 2069,
  [2106] = 2074,
  [2107] = 2071,
  [2108] = 2069,
  [2109] = 2069,
  [2110] = 2069,
  [2111] = 2069,
  [2112] = 2069,
  [2113] = 2069,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2076,
  [2117] = 2117,
  [2118] = 2076,
  [2119] = 2082,
  [2120] = 2076,
  [2121] = 2121,
  [2122] = 2097,
  [2123] = 2071,
  [2124] = 2082,
  [2125] = 2072,
  [2126] = 2088,
  [2127] = 2127,
  [2128] = 2121,
  [2129] = 2088,
  [2130] = 2130,
  [2131] = 2069,
  [2132] = 2082,
  [2133] = 2071,
  [2134] = 2071,
  [2135] = 2072,
  [2136] = 2070,
  [2137] = 2070,
  [2138] = 2069,
  [2139] = 2070,
  [2140] = 2074,
  [2141] = 2076,
  [2142] = 2082,
  [2143] = 2076,
  [2144] = 2088,
  [2145] = 2088,
  [2146] = 2069,
  [2147] = 2072,
  [2148] = 2071,
  [2149] = 2082,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2074,
  [2153] = 2070,
  [2154] = 2082,
  [2155] = 2082,
  [2156] = 2156,
  [2157] = 2088,
  [2158] = 171,
  [2159] = 2082,
  [2160] = 2076,
  [2161] = 2070,
  [2162] = 2069,
  [2163] = 2088,
  [2164] = 2076,
  [2165] = 2165,
  [2166] = 2074,
  [2167] = 2070,
  [2168] = 2074,
  [2169] = 2076,
  [2170] = 2170,
  [2171] = 2070,
  [2172] = 2082,
  [2173] = 2088,
  [2174] = 206,
  [2175] = 2088,
  [2176] = 2076,
  [2177] = 2074,
  [2178] = 2072,
  [2179] = 2088,
  [2180] = 2076,
  [2181] = 2072,
  [2182] = 2117,
  [2183] = 2074,
  [2184] = 2184,
  [2185] = 2114,
  [2186] = 2115,
  [2187] = 2070,
  [2188] = 2117,
  [2189] = 2088,
  [2190] = 2088,
  [2191] = 2076,
  [2192] = 2074,
  [2193] = 2070,
  [2194] = 2194,
  [2195] = 2088,
  [2196] = 2088,
  [2197] = 2076,
  [2198] = 2198,
  [2199] = 2074,
  [2200] = 2070,
  [2201] = 2082,
  [2202] = 2088,
  [2203] = 2203,
  [2204] = 2115,
  [2205] = 2205,
  [2206] = 2071,
  [2207] = 2076,
  [2208] = 2074,
  [2209] = 2114,
  [2210] = 2076,
  [2211] = 2080,
  [2212] = 2114,
  [2213] = 2115,
  [2214] = 2074,
  [2215] = 2117,
  [2216] = 2079,
  [2217] = 2217,
  [2218] = 2070,
  [2219] = 2070,
  [2220] = 2088,
  [2221] = 2114,
  [2222] = 2074,
  [2223] = 2117,
  [2224] = 2194,
  [2225] = 2114,
  [2226] = 2088,
  [2227] = 2117,
  [2228] = 2114,
  [2229] = 2074,
  [2230] = 2117,
  [2231] = 2114,
  [2232] = 2088,
  [2233] = 2117,
  [2234] = 2114,
  [2235] = 2074,
  [2236] = 2117,
  [2237] = 2114,
  [2238] = 2088,
  [2239] = 2117,
  [2240] = 2114,
  [2241] = 2074,
  [2242] = 2117,
  [2243] = 2114,
  [2244] = 2088,
  [2245] = 2117,
  [2246] = 2114,
  [2247] = 2069,
  [2248] = 2117,
  [2249] = 2114,
  [2250] = 2088,
  [2251] = 2117,
  [2252] = 2114,
  [2253] = 2072,
  [2254] = 2117,
  [2255] = 2114,
  [2256] = 2114,
  [2257] = 2114,
  [2258] = 2114,
  [2259] = 2205,
  [2260] = 2115,
  [2261] = 2203,
  [2262] = 2198,
  [2263] = 2071,
  [2264] = 2150,
  [2265] = 2088,
  [2266] = 2088,
  [2267] = 2088,
  [2268] = 2092,
  [2269] = 2088,
  [2270] = 2082,
  [2271] = 2071,
  [2272] = 2205,
  [2273] = 2115,
  [2274] = 2203,
  [2275] = 2072,
  [2276] = 2069,
  [2277] = 2074,
  [2278] = 2082,
  [2279] = 2205,
  [2280] = 2203,
  [2281] = 2205,
  [2282] = 2082,
  [2283] = 2203,
  [2284] = 2082,
  [2285] = 2082,
  [2286] = 2203,
  [2287] = 2205,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(119);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead == ':') ADVANCE(170);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '[') ADVANCE(168);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == ']') ADVANCE(171);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(43)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(43)
      if (lookahead == '\r') SKIP(1)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(43)
      if (lookahead == '\r') SKIP(1)
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't' ||
          lookahead == 'v') ADVANCE(183);
      if (lookahead == 'x') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(185);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(105);
      if (lookahead == '\r') ADVANCE(5);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(54);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(7)
      if (lookahead == ']') ADVANCE(171);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(5)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(105);
      if (lookahead == '\r') ADVANCE(5);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(7)
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(5)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(5)
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(5)
      if (lookahead == '\r') SKIP(6)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(45)
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(45)
      if (lookahead == '\r') SKIP(8)
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(34)
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(34)
      if (lookahead == '\r') SKIP(10)
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(38)
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(38)
      if (lookahead == '\r') SKIP(12)
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(40)
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(40)
      if (lookahead == '\r') SKIP(14)
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(48)
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(48)
      if (lookahead == '\r') SKIP(16)
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(51)
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(51)
      if (lookahead == '\r') SKIP(18)
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(51)
      if (lookahead == '\r') SKIP(18)
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't' ||
          lookahead == 'v') ADVANCE(183);
      if (lookahead == 'x') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(185);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(55)
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(55)
      if (lookahead == '\r') SKIP(21)
      END_STATE();
    case 23:
      if (lookahead == '\n') ADVANCE(106);
      if (lookahead == '\r') ADVANCE(24);
      if (lookahead == '!') ADVANCE(151);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '(') ADVANCE(119);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '>') ADVANCE(122);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '\\') SKIP(28)
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(24)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 24:
      if (lookahead == '\n') ADVANCE(106);
      if (lookahead == '\r') ADVANCE(24);
      if (lookahead == '!') ADVANCE(151);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '>') ADVANCE(122);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '\\') SKIP(28)
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(24)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(42)
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(42)
      if (lookahead == '\r') SKIP(25)
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(24)
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(24)
      if (lookahead == '\r') SKIP(27)
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(36)
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(36)
      if (lookahead == '\r') SKIP(29)
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(46)
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(46)
      if (lookahead == '\r') SKIP(31)
      END_STATE();
    case 33:
      if (lookahead == '\n') ADVANCE(107);
      if (lookahead == '\r') ADVANCE(34);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(134);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '\\') SKIP(11)
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(34)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(172);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(176);
      END_STATE();
    case 34:
      if (lookahead == '\n') ADVANCE(107);
      if (lookahead == '\r') ADVANCE(34);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(134);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '\\') SKIP(11)
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(34)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 35:
      if (lookahead == '\n') ADVANCE(108);
      if (lookahead == '\r') ADVANCE(36);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '\\') SKIP(30)
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(36)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(172);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(176);
      END_STATE();
    case 36:
      if (lookahead == '\n') ADVANCE(108);
      if (lookahead == '\r') ADVANCE(36);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '\\') SKIP(30)
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(36)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 37:
      if (lookahead == '\n') ADVANCE(109);
      if (lookahead == '\r') ADVANCE(38);
      if (lookahead == '!') ADVANCE(57);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(54);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(13)
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(38)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 38:
      if (lookahead == '\n') ADVANCE(109);
      if (lookahead == '\r') ADVANCE(38);
      if (lookahead == '!') ADVANCE(57);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(13)
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(38)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 39:
      if (lookahead == '\n') ADVANCE(110);
      if (lookahead == '\r') ADVANCE(40);
      if (lookahead == '!') ADVANCE(57);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '\\') SKIP(15)
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(40)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(172);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(176);
      END_STATE();
    case 40:
      if (lookahead == '\n') ADVANCE(110);
      if (lookahead == '\r') ADVANCE(40);
      if (lookahead == '!') ADVANCE(57);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '\\') SKIP(15)
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(40)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 41:
      if (lookahead == '\n') ADVANCE(111);
      if (lookahead == '\r') ADVANCE(42);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(134);
      if (lookahead == ':') ADVANCE(54);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(26)
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(42)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 42:
      if (lookahead == '\n') ADVANCE(111);
      if (lookahead == '\r') ADVANCE(42);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(134);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(26)
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(42)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 43:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 44:
      if (lookahead == '!') ADVANCE(151);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(169);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '\\') SKIP(9)
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '}') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 45:
      if (lookahead == '!') ADVANCE(151);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '@') ADVANCE(174);
      if (lookahead == '\\') SKIP(9)
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '}') ADVANCE(115);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 46:
      if (lookahead == '!') ADVANCE(57);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(32)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 47:
      if (lookahead == '!') ADVANCE(57);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '\\') SKIP(17)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(172);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(176);
      END_STATE();
    case 48:
      if (lookahead == '!') ADVANCE(57);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '\\') SKIP(17)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 49:
      if (lookahead == '!') ADVANCE(57);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(117);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(32)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 50:
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '\\') ADVANCE(20);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(181);
      if (lookahead != 0) ADVANCE(182);
      END_STATE();
    case 51:
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '\\') SKIP(19)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(181);
      if (lookahead != 0) ADVANCE(182);
      END_STATE();
    case 52:
      if (lookahead == '&') ADVANCE(149);
      END_STATE();
    case 53:
      if (lookahead == '/') ADVANCE(165);
      if (lookahead == '[') ADVANCE(168);
      if (lookahead == '\\') ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(166);
      END_STATE();
    case 54:
      if (lookahead == ':') ADVANCE(177);
      END_STATE();
    case 55:
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == '\\') SKIP(22)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55)
      END_STATE();
    case 56:
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == '\\') SKIP(22)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(173);
      END_STATE();
    case 57:
      if (lookahead == '=') ADVANCE(146);
      if (lookahead == '~') ADVANCE(148);
      END_STATE();
    case 58:
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 59:
      if (lookahead == '[') ADVANCE(168);
      if (lookahead == '\\') ADVANCE(79);
      if (lookahead == ']') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '/') ADVANCE(166);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(71);
      END_STATE();
    case 61:
      if (lookahead == 'a') ADVANCE(65);
      END_STATE();
    case 62:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 63:
      if (lookahead == 'c') ADVANCE(70);
      END_STATE();
    case 64:
      if (lookahead == 'c') ADVANCE(69);
      END_STATE();
    case 65:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(68);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(101);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 70:
      if (lookahead == 'l') ADVANCE(76);
      END_STATE();
    case 71:
      if (lookahead == 'm') ADVANCE(67);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 73:
      if (lookahead == 'o') ADVANCE(61);
      END_STATE();
    case 74:
      if (lookahead == 'p') ADVANCE(62);
      END_STATE();
    case 75:
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 76:
      if (lookahead == 'u') ADVANCE(66);
      END_STATE();
    case 77:
      if (lookahead == '+' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(179);
      END_STATE();
    case 78:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(186);
      END_STATE();
    case 79:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 80:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(90)
      END_STATE();
    case 81:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(90)
      if (lookahead == '\r') SKIP(80)
      END_STATE();
    case 82:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(93)
      END_STATE();
    case 83:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(93)
      if (lookahead == '\r') SKIP(82)
      END_STATE();
    case 84:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(98)
      END_STATE();
    case 85:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(98)
      if (lookahead == '\r') SKIP(84)
      END_STATE();
    case 86:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(95)
      END_STATE();
    case 87:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(95)
      if (lookahead == '\r') SKIP(86)
      END_STATE();
    case 88:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(91)
      END_STATE();
    case 89:
      if (eof) ADVANCE(99);
      if (lookahead == '\n') SKIP(91)
      if (lookahead == '\r') SKIP(88)
      END_STATE();
    case 90:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(121);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(81)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 91:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(134);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(89)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 92:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(134);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '\\') SKIP(83)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(93)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(172);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(176);
      END_STATE();
    case 93:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(134);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '\\') SKIP(83)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(93)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 94:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(136);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '+') ADVANCE(139);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(134);
      if (lookahead == ':') ADVANCE(117);
      if (lookahead == ';') ADVANCE(104);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(89)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 95:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(116);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(87)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(95)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 96:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == ')') ADVANCE(113);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == ':') ADVANCE(117);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '[') ADVANCE(163);
      if (lookahead == '\\') SKIP(87)
      if (lookahead == ']') ADVANCE(164);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(115);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(95)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 97:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '\\') SKIP(85)
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(98)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(172);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(176);
      END_STATE();
    case 98:
      if (eof) ADVANCE(99);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(180);
      if (lookahead == '#') ADVANCE(187);
      if (lookahead == '$') ADVANCE(162);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(52);
      if (lookahead == '(') ADVANCE(112);
      if (lookahead == '*') ADVANCE(131);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(100);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(133);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(58);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(175);
      if (lookahead == '\\') SKIP(85)
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '{') ADVANCE(114);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(98)
      if (('.' <= lookahead && lookahead <= '9')) ADVANCE(178);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_ATinclude);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_ATload);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_ATnamespace);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(105);
      if (lookahead == '\r') ADVANCE(5);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(106);
      if (lookahead == '\r') ADVANCE(24);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(107);
      if (lookahead == '\r') ADVANCE(34);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(108);
      if (lookahead == '\r') ADVANCE(36);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(109);
      if (lookahead == '\r') ADVANCE(38);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(110);
      if (lookahead == '\r') ADVANCE(40);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(111);
      if (lookahead == '\r') ADVANCE(42);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(177);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(144);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(144);
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&') ADVANCE(126);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '|') ADVANCE(150);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(130);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '=') ADVANCE(158);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(159);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(160);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(153);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(153);
      if (lookahead == '=') ADVANCE(156);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(154);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(154);
      if (lookahead == '=') ADVANCE(157);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(146);
      if (lookahead == '~') ADVANCE(148);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym__regex_char);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym__regex_char_escaped);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(177);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_RBRACK2);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_regex_flags);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(176);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_regex_flags);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(173);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == 'i') ADVANCE(72);
      if (lookahead == 'l') ADVANCE(73);
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym_number_token1);
      if (lookahead == 'e') ADVANCE(77);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(aux_sym_number_token2);
      if (lookahead == '+' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(181);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(182);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(183);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(184);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(183);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '\r') ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(190);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(190);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(190);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'B') ADVANCE(1);
      if (lookahead == 'E') ADVANCE(2);
      if (lookahead == '\\') SKIP(3)
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'n') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 'u') ADVANCE(17);
      if (lookahead == 'w') ADVANCE(18);
      if (lookahead == 'x') ADVANCE(19);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'E') ADVANCE(20);
      END_STATE();
    case 2:
      if (lookahead == 'N') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(22)
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(23);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(24);
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'n') ADVANCE(27);
      if (lookahead == 'o') ADVANCE(28);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(33);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(36);
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(41);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(42);
      if (lookahead == 'u') ADVANCE(43);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(44);
      END_STATE();
    case 16:
      if (lookahead == 'p') ADVANCE(45);
      if (lookahead == 'w') ADVANCE(46);
      END_STATE();
    case 17:
      if (lookahead == 'p') ADVANCE(47);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(48);
      END_STATE();
    case 19:
      if (lookahead == 'd') ADVANCE(49);
      END_STATE();
    case 20:
      if (lookahead == 'G') ADVANCE(50);
      END_STATE();
    case 21:
      if (lookahead == 'D') ADVANCE(51);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(52);
      if (lookahead == 'p') ADVANCE(53);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(54);
      END_STATE();
    case 25:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(56);
      END_STATE();
    case 27:
      if (lookahead == 't') ADVANCE(57);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(58);
      END_STATE();
    case 29:
      if (lookahead == 'f') ADVANCE(59);
      if (lookahead == 'l') ADVANCE(60);
      END_STATE();
    case 30:
      if (lookahead == 'g') ADVANCE(61);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 32:
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 33:
      if (lookahead == 'i') ADVANCE(63);
      END_STATE();
    case 34:
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(65);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 37:
      if (lookahead == 'a') ADVANCE(67);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 40:
      if (lookahead == 'w') ADVANCE(68);
      END_STATE();
    case 41:
      if (lookahead == 'x') ADVANCE(69);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(71);
      END_STATE();
    case 44:
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 46:
      if (lookahead == 'i') ADVANCE(74);
      END_STATE();
    case 47:
      if (lookahead == 'p') ADVANCE(75);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(76);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(77);
      END_STATE();
    case 50:
      if (lookahead == 'I') ADVANCE(78);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == 'F') ADVANCE(79);
      END_STATE();
    case 52:
      if (lookahead == 'u') ADVANCE(80);
      END_STATE();
    case 53:
      if (lookahead == 'h') ADVANCE(81);
      END_STATE();
    case 54:
      if (lookahead == 'n') ADVANCE(82);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 57:
      if (lookahead == 'r') ADVANCE(85);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(87);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(88);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(89);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(91);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 65:
      if (lookahead == 'c') ADVANCE(92);
      END_STATE();
    case 66:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 67:
      if (lookahead == 'p') ADVANCE(94);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 69:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 71:
      if (lookahead == 'c') ADVANCE(98);
      END_STATE();
    case 72:
      if (lookahead == 'u') ADVANCE(99);
      END_STATE();
    case 73:
      if (lookahead == 'c') ADVANCE(100);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(103);
      END_STATE();
    case 77:
      if (lookahead == 'g') ADVANCE(104);
      END_STATE();
    case 78:
      if (lookahead == 'N') ADVANCE(105);
      END_STATE();
    case 79:
      if (lookahead == 'I') ADVANCE(106);
      END_STATE();
    case 80:
      if (lookahead == 'm') ADVANCE(107);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(108);
      END_STATE();
    case 82:
      if (lookahead == 'k') ADVANCE(109);
      END_STATE();
    case 83:
      if (lookahead == 'k') ADVANCE(110);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 85:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 86:
      if (lookahead == 'i') ADVANCE(112);
      END_STATE();
    case 87:
      if (lookahead == 'u') ADVANCE(113);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 89:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_exit);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_func);
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 94:
      if (lookahead == 'h') ADVANCE(118);
      END_STATE();
    case 95:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_next_statement);
      if (lookahead == 'f') ADVANCE(120);
      END_STATE();
    case 97:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 99:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 101:
      if (lookahead == 'c') ADVANCE(125);
      END_STATE();
    case 102:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 104:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == 'F') ADVANCE(129);
      END_STATE();
    case 106:
      if (lookahead == 'L') ADVANCE(130);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_alnum);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_alpha);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_blank);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_cntrl);
      END_STATE();
    case 112:
      if (lookahead == 'n') ADVANCE(131);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_digit);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(134);
      END_STATE();
    case 117:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_graph);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_lower);
      END_STATE();
    case 120:
      if (lookahead == 'i') ADVANCE(136);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_print);
      if (lookahead == 'f') ADVANCE(137);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_punct);
      END_STATE();
    case 123:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_space);
      END_STATE();
    case 125:
      if (lookahead == 'h') ADVANCE(139);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_upper);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 128:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 129:
      if (lookahead == 'I') ADVANCE(141);
      END_STATE();
    case 130:
      if (lookahead == 'E') ADVANCE(142);
      END_STATE();
    case 131:
      if (lookahead == 'u') ADVANCE(143);
      END_STATE();
    case 132:
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 134:
      if (lookahead == 'o') ADVANCE(145);
      END_STATE();
    case 135:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(147);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_printf);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_xdigit);
      END_STATE();
    case 141:
      if (lookahead == 'L') ADVANCE(148);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_ENDFILE);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 145:
      if (lookahead == 'n') ADVANCE(150);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_getline);
      END_STATE();
    case 147:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 148:
      if (lookahead == 'E') ADVANCE(152);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_continue_statement);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_nextfile_statement);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_BEGINFILE);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 96},
  [2] = {.lex_state = 4, .external_lex_state = 2},
  [3] = {.lex_state = 44},
  [4] = {.lex_state = 44},
  [5] = {.lex_state = 44},
  [6] = {.lex_state = 44},
  [7] = {.lex_state = 44},
  [8] = {.lex_state = 44},
  [9] = {.lex_state = 44},
  [10] = {.lex_state = 4},
  [11] = {.lex_state = 44},
  [12] = {.lex_state = 44},
  [13] = {.lex_state = 44},
  [14] = {.lex_state = 44},
  [15] = {.lex_state = 44},
  [16] = {.lex_state = 44},
  [17] = {.lex_state = 44},
  [18] = {.lex_state = 44},
  [19] = {.lex_state = 44},
  [20] = {.lex_state = 44},
  [21] = {.lex_state = 44},
  [22] = {.lex_state = 44},
  [23] = {.lex_state = 44},
  [24] = {.lex_state = 44},
  [25] = {.lex_state = 44},
  [26] = {.lex_state = 44},
  [27] = {.lex_state = 44},
  [28] = {.lex_state = 44},
  [29] = {.lex_state = 44},
  [30] = {.lex_state = 44},
  [31] = {.lex_state = 44},
  [32] = {.lex_state = 44},
  [33] = {.lex_state = 44},
  [34] = {.lex_state = 44},
  [35] = {.lex_state = 44},
  [36] = {.lex_state = 44},
  [37] = {.lex_state = 44},
  [38] = {.lex_state = 44},
  [39] = {.lex_state = 44},
  [40] = {.lex_state = 44},
  [41] = {.lex_state = 44},
  [42] = {.lex_state = 44},
  [43] = {.lex_state = 44},
  [44] = {.lex_state = 44},
  [45] = {.lex_state = 44},
  [46] = {.lex_state = 44},
  [47] = {.lex_state = 44},
  [48] = {.lex_state = 44},
  [49] = {.lex_state = 44},
  [50] = {.lex_state = 44},
  [51] = {.lex_state = 44},
  [52] = {.lex_state = 44},
  [53] = {.lex_state = 44},
  [54] = {.lex_state = 44},
  [55] = {.lex_state = 44},
  [56] = {.lex_state = 44},
  [57] = {.lex_state = 44},
  [58] = {.lex_state = 44},
  [59] = {.lex_state = 44},
  [60] = {.lex_state = 44},
  [61] = {.lex_state = 44},
  [62] = {.lex_state = 44},
  [63] = {.lex_state = 44},
  [64] = {.lex_state = 44},
  [65] = {.lex_state = 44},
  [66] = {.lex_state = 44},
  [67] = {.lex_state = 44},
  [68] = {.lex_state = 44},
  [69] = {.lex_state = 44},
  [70] = {.lex_state = 44},
  [71] = {.lex_state = 44},
  [72] = {.lex_state = 44},
  [73] = {.lex_state = 44},
  [74] = {.lex_state = 44},
  [75] = {.lex_state = 44},
  [76] = {.lex_state = 44},
  [77] = {.lex_state = 44},
  [78] = {.lex_state = 44},
  [79] = {.lex_state = 44},
  [80] = {.lex_state = 44},
  [81] = {.lex_state = 44},
  [82] = {.lex_state = 44},
  [83] = {.lex_state = 44},
  [84] = {.lex_state = 44},
  [85] = {.lex_state = 44},
  [86] = {.lex_state = 44},
  [87] = {.lex_state = 44},
  [88] = {.lex_state = 44},
  [89] = {.lex_state = 44},
  [90] = {.lex_state = 44},
  [91] = {.lex_state = 44},
  [92] = {.lex_state = 44},
  [93] = {.lex_state = 44},
  [94] = {.lex_state = 44},
  [95] = {.lex_state = 44},
  [96] = {.lex_state = 44},
  [97] = {.lex_state = 44},
  [98] = {.lex_state = 44},
  [99] = {.lex_state = 44},
  [100] = {.lex_state = 44},
  [101] = {.lex_state = 44},
  [102] = {.lex_state = 44},
  [103] = {.lex_state = 44},
  [104] = {.lex_state = 44},
  [105] = {.lex_state = 44},
  [106] = {.lex_state = 44},
  [107] = {.lex_state = 44},
  [108] = {.lex_state = 44},
  [109] = {.lex_state = 44},
  [110] = {.lex_state = 44},
  [111] = {.lex_state = 44},
  [112] = {.lex_state = 44},
  [113] = {.lex_state = 44},
  [114] = {.lex_state = 44},
  [115] = {.lex_state = 44},
  [116] = {.lex_state = 44},
  [117] = {.lex_state = 44},
  [118] = {.lex_state = 44},
  [119] = {.lex_state = 44},
  [120] = {.lex_state = 44},
  [121] = {.lex_state = 44},
  [122] = {.lex_state = 44},
  [123] = {.lex_state = 44},
  [124] = {.lex_state = 44},
  [125] = {.lex_state = 44},
  [126] = {.lex_state = 44},
  [127] = {.lex_state = 44},
  [128] = {.lex_state = 44},
  [129] = {.lex_state = 44},
  [130] = {.lex_state = 44},
  [131] = {.lex_state = 44},
  [132] = {.lex_state = 44},
  [133] = {.lex_state = 44},
  [134] = {.lex_state = 44},
  [135] = {.lex_state = 44},
  [136] = {.lex_state = 44},
  [137] = {.lex_state = 44},
  [138] = {.lex_state = 44},
  [139] = {.lex_state = 44},
  [140] = {.lex_state = 44},
  [141] = {.lex_state = 44},
  [142] = {.lex_state = 44},
  [143] = {.lex_state = 44},
  [144] = {.lex_state = 44},
  [145] = {.lex_state = 44},
  [146] = {.lex_state = 44},
  [147] = {.lex_state = 44},
  [148] = {.lex_state = 44},
  [149] = {.lex_state = 44},
  [150] = {.lex_state = 44},
  [151] = {.lex_state = 44},
  [152] = {.lex_state = 44},
  [153] = {.lex_state = 4, .external_lex_state = 2},
  [154] = {.lex_state = 4},
  [155] = {.lex_state = 44},
  [156] = {.lex_state = 44},
  [157] = {.lex_state = 44},
  [158] = {.lex_state = 44},
  [159] = {.lex_state = 44},
  [160] = {.lex_state = 44},
  [161] = {.lex_state = 41, .external_lex_state = 3},
  [162] = {.lex_state = 41, .external_lex_state = 4},
  [163] = {.lex_state = 41, .external_lex_state = 3},
  [164] = {.lex_state = 41, .external_lex_state = 5},
  [165] = {.lex_state = 23, .external_lex_state = 2},
  [166] = {.lex_state = 41, .external_lex_state = 6},
  [167] = {.lex_state = 41, .external_lex_state = 5},
  [168] = {.lex_state = 41, .external_lex_state = 3},
  [169] = {.lex_state = 41, .external_lex_state = 4},
  [170] = {.lex_state = 41, .external_lex_state = 3},
  [171] = {.lex_state = 41, .external_lex_state = 3},
  [172] = {.lex_state = 41, .external_lex_state = 4},
  [173] = {.lex_state = 41, .external_lex_state = 4},
  [174] = {.lex_state = 41, .external_lex_state = 3},
  [175] = {.lex_state = 41, .external_lex_state = 6},
  [176] = {.lex_state = 41, .external_lex_state = 3},
  [177] = {.lex_state = 41, .external_lex_state = 4},
  [178] = {.lex_state = 41, .external_lex_state = 4},
  [179] = {.lex_state = 41, .external_lex_state = 4},
  [180] = {.lex_state = 41, .external_lex_state = 4},
  [181] = {.lex_state = 41, .external_lex_state = 4},
  [182] = {.lex_state = 41, .external_lex_state = 5},
  [183] = {.lex_state = 41, .external_lex_state = 4},
  [184] = {.lex_state = 41, .external_lex_state = 5},
  [185] = {.lex_state = 41, .external_lex_state = 5},
  [186] = {.lex_state = 41, .external_lex_state = 3},
  [187] = {.lex_state = 23},
  [188] = {.lex_state = 41, .external_lex_state = 6},
  [189] = {.lex_state = 41, .external_lex_state = 4},
  [190] = {.lex_state = 41, .external_lex_state = 4},
  [191] = {.lex_state = 41, .external_lex_state = 4},
  [192] = {.lex_state = 41, .external_lex_state = 6},
  [193] = {.lex_state = 41, .external_lex_state = 5},
  [194] = {.lex_state = 41, .external_lex_state = 4},
  [195] = {.lex_state = 41, .external_lex_state = 4},
  [196] = {.lex_state = 41, .external_lex_state = 5},
  [197] = {.lex_state = 41, .external_lex_state = 4},
  [198] = {.lex_state = 41, .external_lex_state = 6},
  [199] = {.lex_state = 41, .external_lex_state = 3},
  [200] = {.lex_state = 41, .external_lex_state = 4},
  [201] = {.lex_state = 41, .external_lex_state = 3},
  [202] = {.lex_state = 41, .external_lex_state = 6},
  [203] = {.lex_state = 41, .external_lex_state = 4},
  [204] = {.lex_state = 41, .external_lex_state = 4},
  [205] = {.lex_state = 41, .external_lex_state = 4},
  [206] = {.lex_state = 41, .external_lex_state = 4},
  [207] = {.lex_state = 41, .external_lex_state = 4},
  [208] = {.lex_state = 41, .external_lex_state = 4},
  [209] = {.lex_state = 41, .external_lex_state = 4},
  [210] = {.lex_state = 41, .external_lex_state = 4},
  [211] = {.lex_state = 41, .external_lex_state = 6},
  [212] = {.lex_state = 41, .external_lex_state = 4},
  [213] = {.lex_state = 41, .external_lex_state = 4},
  [214] = {.lex_state = 41, .external_lex_state = 4},
  [215] = {.lex_state = 41, .external_lex_state = 4},
  [216] = {.lex_state = 41, .external_lex_state = 4},
  [217] = {.lex_state = 41, .external_lex_state = 6},
  [218] = {.lex_state = 41, .external_lex_state = 6},
  [219] = {.lex_state = 41, .external_lex_state = 4},
  [220] = {.lex_state = 41, .external_lex_state = 6},
  [221] = {.lex_state = 41, .external_lex_state = 3},
  [222] = {.lex_state = 41, .external_lex_state = 5},
  [223] = {.lex_state = 41, .external_lex_state = 4},
  [224] = {.lex_state = 41, .external_lex_state = 6},
  [225] = {.lex_state = 41, .external_lex_state = 6},
  [226] = {.lex_state = 41, .external_lex_state = 5},
  [227] = {.lex_state = 41, .external_lex_state = 6},
  [228] = {.lex_state = 41, .external_lex_state = 6},
  [229] = {.lex_state = 41, .external_lex_state = 6},
  [230] = {.lex_state = 41, .external_lex_state = 6},
  [231] = {.lex_state = 41, .external_lex_state = 4},
  [232] = {.lex_state = 41, .external_lex_state = 6},
  [233] = {.lex_state = 41, .external_lex_state = 4},
  [234] = {.lex_state = 41, .external_lex_state = 6},
  [235] = {.lex_state = 41, .external_lex_state = 6},
  [236] = {.lex_state = 41, .external_lex_state = 6},
  [237] = {.lex_state = 41, .external_lex_state = 6},
  [238] = {.lex_state = 41, .external_lex_state = 6},
  [239] = {.lex_state = 41, .external_lex_state = 5},
  [240] = {.lex_state = 41, .external_lex_state = 6},
  [241] = {.lex_state = 33, .external_lex_state = 4},
  [242] = {.lex_state = 41, .external_lex_state = 6},
  [243] = {.lex_state = 41, .external_lex_state = 5},
  [244] = {.lex_state = 41, .external_lex_state = 6},
  [245] = {.lex_state = 41, .external_lex_state = 6},
  [246] = {.lex_state = 33, .external_lex_state = 4},
  [247] = {.lex_state = 41, .external_lex_state = 4},
  [248] = {.lex_state = 41, .external_lex_state = 6},
  [249] = {.lex_state = 41, .external_lex_state = 6},
  [250] = {.lex_state = 41, .external_lex_state = 6},
  [251] = {.lex_state = 41, .external_lex_state = 6},
  [252] = {.lex_state = 41, .external_lex_state = 6},
  [253] = {.lex_state = 41, .external_lex_state = 6},
  [254] = {.lex_state = 41, .external_lex_state = 4},
  [255] = {.lex_state = 41, .external_lex_state = 4},
  [256] = {.lex_state = 41, .external_lex_state = 4},
  [257] = {.lex_state = 41, .external_lex_state = 4},
  [258] = {.lex_state = 41, .external_lex_state = 4},
  [259] = {.lex_state = 41, .external_lex_state = 4},
  [260] = {.lex_state = 33, .external_lex_state = 6},
  [261] = {.lex_state = 41, .external_lex_state = 4},
  [262] = {.lex_state = 41, .external_lex_state = 4},
  [263] = {.lex_state = 33, .external_lex_state = 6},
  [264] = {.lex_state = 41, .external_lex_state = 4},
  [265] = {.lex_state = 41, .external_lex_state = 4},
  [266] = {.lex_state = 41, .external_lex_state = 4},
  [267] = {.lex_state = 41, .external_lex_state = 6},
  [268] = {.lex_state = 41, .external_lex_state = 4},
  [269] = {.lex_state = 41, .external_lex_state = 6},
  [270] = {.lex_state = 41, .external_lex_state = 4},
  [271] = {.lex_state = 41, .external_lex_state = 4},
  [272] = {.lex_state = 41, .external_lex_state = 4},
  [273] = {.lex_state = 41, .external_lex_state = 4},
  [274] = {.lex_state = 41, .external_lex_state = 6},
  [275] = {.lex_state = 41, .external_lex_state = 4},
  [276] = {.lex_state = 41, .external_lex_state = 4},
  [277] = {.lex_state = 41, .external_lex_state = 6},
  [278] = {.lex_state = 41, .external_lex_state = 6},
  [279] = {.lex_state = 41, .external_lex_state = 6},
  [280] = {.lex_state = 41, .external_lex_state = 6},
  [281] = {.lex_state = 41, .external_lex_state = 6},
  [282] = {.lex_state = 41, .external_lex_state = 6},
  [283] = {.lex_state = 41, .external_lex_state = 6},
  [284] = {.lex_state = 41, .external_lex_state = 6},
  [285] = {.lex_state = 41, .external_lex_state = 6},
  [286] = {.lex_state = 41, .external_lex_state = 6},
  [287] = {.lex_state = 41, .external_lex_state = 6},
  [288] = {.lex_state = 41, .external_lex_state = 6},
  [289] = {.lex_state = 41, .external_lex_state = 6},
  [290] = {.lex_state = 41, .external_lex_state = 6},
  [291] = {.lex_state = 41, .external_lex_state = 6},
  [292] = {.lex_state = 41, .external_lex_state = 6},
  [293] = {.lex_state = 41, .external_lex_state = 6},
  [294] = {.lex_state = 41, .external_lex_state = 6},
  [295] = {.lex_state = 94, .external_lex_state = 5},
  [296] = {.lex_state = 94, .external_lex_state = 6},
  [297] = {.lex_state = 94, .external_lex_state = 5},
  [298] = {.lex_state = 4, .external_lex_state = 2},
  [299] = {.lex_state = 94, .external_lex_state = 5},
  [300] = {.lex_state = 4, .external_lex_state = 2},
  [301] = {.lex_state = 96},
  [302] = {.lex_state = 96},
  [303] = {.lex_state = 4, .external_lex_state = 4},
  [304] = {.lex_state = 4, .external_lex_state = 4},
  [305] = {.lex_state = 94, .external_lex_state = 6},
  [306] = {.lex_state = 94, .external_lex_state = 5},
  [307] = {.lex_state = 94, .external_lex_state = 6},
  [308] = {.lex_state = 94, .external_lex_state = 5},
  [309] = {.lex_state = 4, .external_lex_state = 4},
  [310] = {.lex_state = 94, .external_lex_state = 6},
  [311] = {.lex_state = 94, .external_lex_state = 6},
  [312] = {.lex_state = 4, .external_lex_state = 4},
  [313] = {.lex_state = 94, .external_lex_state = 6},
  [314] = {.lex_state = 94, .external_lex_state = 6},
  [315] = {.lex_state = 4, .external_lex_state = 6},
  [316] = {.lex_state = 94, .external_lex_state = 6},
  [317] = {.lex_state = 94, .external_lex_state = 6},
  [318] = {.lex_state = 4, .external_lex_state = 2},
  [319] = {.lex_state = 4, .external_lex_state = 2},
  [320] = {.lex_state = 4, .external_lex_state = 2},
  [321] = {.lex_state = 4, .external_lex_state = 6},
  [322] = {.lex_state = 4, .external_lex_state = 2},
  [323] = {.lex_state = 4, .external_lex_state = 4},
  [324] = {.lex_state = 4},
  [325] = {.lex_state = 4},
  [326] = {.lex_state = 94, .external_lex_state = 6},
  [327] = {.lex_state = 94, .external_lex_state = 6},
  [328] = {.lex_state = 94, .external_lex_state = 6},
  [329] = {.lex_state = 94, .external_lex_state = 6},
  [330] = {.lex_state = 94, .external_lex_state = 6},
  [331] = {.lex_state = 94, .external_lex_state = 6},
  [332] = {.lex_state = 94, .external_lex_state = 6},
  [333] = {.lex_state = 4, .external_lex_state = 4},
  [334] = {.lex_state = 94, .external_lex_state = 6},
  [335] = {.lex_state = 94, .external_lex_state = 6},
  [336] = {.lex_state = 4, .external_lex_state = 4},
  [337] = {.lex_state = 4},
  [338] = {.lex_state = 94, .external_lex_state = 6},
  [339] = {.lex_state = 35, .external_lex_state = 4},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 4, .external_lex_state = 4},
  [342] = {.lex_state = 94, .external_lex_state = 6},
  [343] = {.lex_state = 94, .external_lex_state = 6},
  [344] = {.lex_state = 94, .external_lex_state = 6},
  [345] = {.lex_state = 94, .external_lex_state = 6},
  [346] = {.lex_state = 94, .external_lex_state = 6},
  [347] = {.lex_state = 4, .external_lex_state = 4},
  [348] = {.lex_state = 4, .external_lex_state = 6},
  [349] = {.lex_state = 4, .external_lex_state = 2},
  [350] = {.lex_state = 94, .external_lex_state = 6},
  [351] = {.lex_state = 94, .external_lex_state = 6},
  [352] = {.lex_state = 4, .external_lex_state = 2},
  [353] = {.lex_state = 4},
  [354] = {.lex_state = 35, .external_lex_state = 4},
  [355] = {.lex_state = 4, .external_lex_state = 4},
  [356] = {.lex_state = 94, .external_lex_state = 6},
  [357] = {.lex_state = 94, .external_lex_state = 6},
  [358] = {.lex_state = 4, .external_lex_state = 6},
  [359] = {.lex_state = 94, .external_lex_state = 6},
  [360] = {.lex_state = 4, .external_lex_state = 6},
  [361] = {.lex_state = 94, .external_lex_state = 6},
  [362] = {.lex_state = 4, .external_lex_state = 2},
  [363] = {.lex_state = 4},
  [364] = {.lex_state = 4, .external_lex_state = 4},
  [365] = {.lex_state = 4, .external_lex_state = 4},
  [366] = {.lex_state = 4, .external_lex_state = 2},
  [367] = {.lex_state = 4, .external_lex_state = 6},
  [368] = {.lex_state = 4, .external_lex_state = 4},
  [369] = {.lex_state = 4, .external_lex_state = 4},
  [370] = {.lex_state = 4, .external_lex_state = 4},
  [371] = {.lex_state = 4, .external_lex_state = 6},
  [372] = {.lex_state = 4, .external_lex_state = 4},
  [373] = {.lex_state = 94, .external_lex_state = 5},
  [374] = {.lex_state = 4, .external_lex_state = 4},
  [375] = {.lex_state = 4, .external_lex_state = 4},
  [376] = {.lex_state = 4, .external_lex_state = 4},
  [377] = {.lex_state = 4, .external_lex_state = 4},
  [378] = {.lex_state = 4, .external_lex_state = 2},
  [379] = {.lex_state = 4, .external_lex_state = 2},
  [380] = {.lex_state = 4},
  [381] = {.lex_state = 4, .external_lex_state = 4},
  [382] = {.lex_state = 4, .external_lex_state = 4},
  [383] = {.lex_state = 4, .external_lex_state = 4},
  [384] = {.lex_state = 4, .external_lex_state = 4},
  [385] = {.lex_state = 4, .external_lex_state = 4},
  [386] = {.lex_state = 4, .external_lex_state = 4},
  [387] = {.lex_state = 4, .external_lex_state = 4},
  [388] = {.lex_state = 4, .external_lex_state = 4},
  [389] = {.lex_state = 4, .external_lex_state = 4},
  [390] = {.lex_state = 4, .external_lex_state = 4},
  [391] = {.lex_state = 4},
  [392] = {.lex_state = 4, .external_lex_state = 4},
  [393] = {.lex_state = 4, .external_lex_state = 4},
  [394] = {.lex_state = 4, .external_lex_state = 4},
  [395] = {.lex_state = 4, .external_lex_state = 6},
  [396] = {.lex_state = 4, .external_lex_state = 4},
  [397] = {.lex_state = 4, .external_lex_state = 4},
  [398] = {.lex_state = 4, .external_lex_state = 6},
  [399] = {.lex_state = 4, .external_lex_state = 4},
  [400] = {.lex_state = 4, .external_lex_state = 4},
  [401] = {.lex_state = 4, .external_lex_state = 4},
  [402] = {.lex_state = 4, .external_lex_state = 4},
  [403] = {.lex_state = 4, .external_lex_state = 4},
  [404] = {.lex_state = 4, .external_lex_state = 4},
  [405] = {.lex_state = 35, .external_lex_state = 2},
  [406] = {.lex_state = 94, .external_lex_state = 5},
  [407] = {.lex_state = 4, .external_lex_state = 4},
  [408] = {.lex_state = 4},
  [409] = {.lex_state = 4, .external_lex_state = 4},
  [410] = {.lex_state = 35, .external_lex_state = 6},
  [411] = {.lex_state = 35, .external_lex_state = 6},
  [412] = {.lex_state = 35, .external_lex_state = 2},
  [413] = {.lex_state = 94, .external_lex_state = 6},
  [414] = {.lex_state = 4, .external_lex_state = 4},
  [415] = {.lex_state = 4, .external_lex_state = 6},
  [416] = {.lex_state = 94, .external_lex_state = 5},
  [417] = {.lex_state = 4, .external_lex_state = 2},
  [418] = {.lex_state = 4},
  [419] = {.lex_state = 4, .external_lex_state = 6},
  [420] = {.lex_state = 4, .external_lex_state = 2},
  [421] = {.lex_state = 4, .external_lex_state = 2},
  [422] = {.lex_state = 4, .external_lex_state = 6},
  [423] = {.lex_state = 4, .external_lex_state = 2},
  [424] = {.lex_state = 4, .external_lex_state = 2},
  [425] = {.lex_state = 4, .external_lex_state = 2},
  [426] = {.lex_state = 4, .external_lex_state = 6},
  [427] = {.lex_state = 4, .external_lex_state = 2},
  [428] = {.lex_state = 4, .external_lex_state = 2},
  [429] = {.lex_state = 4, .external_lex_state = 6},
  [430] = {.lex_state = 4, .external_lex_state = 6},
  [431] = {.lex_state = 4, .external_lex_state = 6},
  [432] = {.lex_state = 94, .external_lex_state = 6},
  [433] = {.lex_state = 4, .external_lex_state = 6},
  [434] = {.lex_state = 4, .external_lex_state = 2},
  [435] = {.lex_state = 4, .external_lex_state = 2},
  [436] = {.lex_state = 4, .external_lex_state = 2},
  [437] = {.lex_state = 4, .external_lex_state = 6},
  [438] = {.lex_state = 4, .external_lex_state = 2},
  [439] = {.lex_state = 4, .external_lex_state = 6},
  [440] = {.lex_state = 4, .external_lex_state = 6},
  [441] = {.lex_state = 4, .external_lex_state = 6},
  [442] = {.lex_state = 4, .external_lex_state = 6},
  [443] = {.lex_state = 4, .external_lex_state = 6},
  [444] = {.lex_state = 94, .external_lex_state = 5},
  [445] = {.lex_state = 4, .external_lex_state = 6},
  [446] = {.lex_state = 4, .external_lex_state = 6},
  [447] = {.lex_state = 4, .external_lex_state = 6},
  [448] = {.lex_state = 94, .external_lex_state = 5},
  [449] = {.lex_state = 4},
  [450] = {.lex_state = 4, .external_lex_state = 6},
  [451] = {.lex_state = 4, .external_lex_state = 6},
  [452] = {.lex_state = 4, .external_lex_state = 6},
  [453] = {.lex_state = 4, .external_lex_state = 6},
  [454] = {.lex_state = 4, .external_lex_state = 6},
  [455] = {.lex_state = 4, .external_lex_state = 6},
  [456] = {.lex_state = 4, .external_lex_state = 6},
  [457] = {.lex_state = 4, .external_lex_state = 6},
  [458] = {.lex_state = 4, .external_lex_state = 6},
  [459] = {.lex_state = 4, .external_lex_state = 6},
  [460] = {.lex_state = 4, .external_lex_state = 6},
  [461] = {.lex_state = 4, .external_lex_state = 6},
  [462] = {.lex_state = 4, .external_lex_state = 6},
  [463] = {.lex_state = 4, .external_lex_state = 6},
  [464] = {.lex_state = 4, .external_lex_state = 2},
  [465] = {.lex_state = 94, .external_lex_state = 5},
  [466] = {.lex_state = 4, .external_lex_state = 2},
  [467] = {.lex_state = 4, .external_lex_state = 2},
  [468] = {.lex_state = 4, .external_lex_state = 6},
  [469] = {.lex_state = 4, .external_lex_state = 6},
  [470] = {.lex_state = 35},
  [471] = {.lex_state = 35},
  [472] = {.lex_state = 4, .external_lex_state = 6},
  [473] = {.lex_state = 4, .external_lex_state = 6},
  [474] = {.lex_state = 4},
  [475] = {.lex_state = 4},
  [476] = {.lex_state = 4},
  [477] = {.lex_state = 4},
  [478] = {.lex_state = 4},
  [479] = {.lex_state = 4},
  [480] = {.lex_state = 4},
  [481] = {.lex_state = 4},
  [482] = {.lex_state = 94, .external_lex_state = 6},
  [483] = {.lex_state = 94, .external_lex_state = 6},
  [484] = {.lex_state = 92, .external_lex_state = 6},
  [485] = {.lex_state = 4},
  [486] = {.lex_state = 4},
  [487] = {.lex_state = 4},
  [488] = {.lex_state = 94, .external_lex_state = 6},
  [489] = {.lex_state = 4},
  [490] = {.lex_state = 4},
  [491] = {.lex_state = 23, .external_lex_state = 2},
  [492] = {.lex_state = 4},
  [493] = {.lex_state = 92, .external_lex_state = 6},
  [494] = {.lex_state = 94, .external_lex_state = 6},
  [495] = {.lex_state = 4},
  [496] = {.lex_state = 4},
  [497] = {.lex_state = 94, .external_lex_state = 6},
  [498] = {.lex_state = 4, .external_lex_state = 2},
  [499] = {.lex_state = 94, .external_lex_state = 6},
  [500] = {.lex_state = 94, .external_lex_state = 6},
  [501] = {.lex_state = 94, .external_lex_state = 6},
  [502] = {.lex_state = 94, .external_lex_state = 6},
  [503] = {.lex_state = 94, .external_lex_state = 6},
  [504] = {.lex_state = 94, .external_lex_state = 6},
  [505] = {.lex_state = 4, .external_lex_state = 2},
  [506] = {.lex_state = 4, .external_lex_state = 2},
  [507] = {.lex_state = 94, .external_lex_state = 6},
  [508] = {.lex_state = 4, .external_lex_state = 2},
  [509] = {.lex_state = 4, .external_lex_state = 2},
  [510] = {.lex_state = 94, .external_lex_state = 6},
  [511] = {.lex_state = 23},
  [512] = {.lex_state = 94, .external_lex_state = 6},
  [513] = {.lex_state = 94, .external_lex_state = 6},
  [514] = {.lex_state = 94, .external_lex_state = 6},
  [515] = {.lex_state = 94, .external_lex_state = 6},
  [516] = {.lex_state = 94, .external_lex_state = 6},
  [517] = {.lex_state = 94, .external_lex_state = 6},
  [518] = {.lex_state = 94, .external_lex_state = 6},
  [519] = {.lex_state = 94, .external_lex_state = 6},
  [520] = {.lex_state = 4},
  [521] = {.lex_state = 4},
  [522] = {.lex_state = 4},
  [523] = {.lex_state = 4},
  [524] = {.lex_state = 4},
  [525] = {.lex_state = 23, .external_lex_state = 2},
  [526] = {.lex_state = 23},
  [527] = {.lex_state = 96, .external_lex_state = 6},
  [528] = {.lex_state = 96, .external_lex_state = 6},
  [529] = {.lex_state = 96, .external_lex_state = 6},
  [530] = {.lex_state = 96},
  [531] = {.lex_state = 96},
  [532] = {.lex_state = 96, .external_lex_state = 6},
  [533] = {.lex_state = 96, .external_lex_state = 6},
  [534] = {.lex_state = 96, .external_lex_state = 6},
  [535] = {.lex_state = 96},
  [536] = {.lex_state = 96, .external_lex_state = 6},
  [537] = {.lex_state = 97, .external_lex_state = 6},
  [538] = {.lex_state = 96, .external_lex_state = 6},
  [539] = {.lex_state = 96, .external_lex_state = 6},
  [540] = {.lex_state = 97, .external_lex_state = 6},
  [541] = {.lex_state = 96},
  [542] = {.lex_state = 96, .external_lex_state = 6},
  [543] = {.lex_state = 96},
  [544] = {.lex_state = 96},
  [545] = {.lex_state = 96},
  [546] = {.lex_state = 96, .external_lex_state = 6},
  [547] = {.lex_state = 96, .external_lex_state = 6},
  [548] = {.lex_state = 96, .external_lex_state = 6},
  [549] = {.lex_state = 96, .external_lex_state = 6},
  [550] = {.lex_state = 96},
  [551] = {.lex_state = 96},
  [552] = {.lex_state = 97},
  [553] = {.lex_state = 96, .external_lex_state = 6},
  [554] = {.lex_state = 96, .external_lex_state = 6},
  [555] = {.lex_state = 96},
  [556] = {.lex_state = 96, .external_lex_state = 6},
  [557] = {.lex_state = 96, .external_lex_state = 6},
  [558] = {.lex_state = 96, .external_lex_state = 6},
  [559] = {.lex_state = 96, .external_lex_state = 6},
  [560] = {.lex_state = 96, .external_lex_state = 6},
  [561] = {.lex_state = 96},
  [562] = {.lex_state = 96, .external_lex_state = 6},
  [563] = {.lex_state = 96, .external_lex_state = 6},
  [564] = {.lex_state = 96, .external_lex_state = 6},
  [565] = {.lex_state = 96, .external_lex_state = 6},
  [566] = {.lex_state = 96, .external_lex_state = 6},
  [567] = {.lex_state = 96, .external_lex_state = 6},
  [568] = {.lex_state = 96, .external_lex_state = 6},
  [569] = {.lex_state = 96, .external_lex_state = 6},
  [570] = {.lex_state = 96, .external_lex_state = 6},
  [571] = {.lex_state = 96, .external_lex_state = 6},
  [572] = {.lex_state = 96, .external_lex_state = 6},
  [573] = {.lex_state = 96, .external_lex_state = 6},
  [574] = {.lex_state = 96},
  [575] = {.lex_state = 97},
  [576] = {.lex_state = 96, .external_lex_state = 6},
  [577] = {.lex_state = 4, .external_lex_state = 2},
  [578] = {.lex_state = 96, .external_lex_state = 6},
  [579] = {.lex_state = 96, .external_lex_state = 6},
  [580] = {.lex_state = 96, .external_lex_state = 6},
  [581] = {.lex_state = 4, .external_lex_state = 2},
  [582] = {.lex_state = 96, .external_lex_state = 6},
  [583] = {.lex_state = 96, .external_lex_state = 6},
  [584] = {.lex_state = 96, .external_lex_state = 6},
  [585] = {.lex_state = 96, .external_lex_state = 6},
  [586] = {.lex_state = 96, .external_lex_state = 6},
  [587] = {.lex_state = 96, .external_lex_state = 6},
  [588] = {.lex_state = 96, .external_lex_state = 6},
  [589] = {.lex_state = 96},
  [590] = {.lex_state = 4},
  [591] = {.lex_state = 41, .external_lex_state = 3},
  [592] = {.lex_state = 96},
  [593] = {.lex_state = 96},
  [594] = {.lex_state = 96},
  [595] = {.lex_state = 96},
  [596] = {.lex_state = 96},
  [597] = {.lex_state = 96},
  [598] = {.lex_state = 96},
  [599] = {.lex_state = 96},
  [600] = {.lex_state = 41, .external_lex_state = 4},
  [601] = {.lex_state = 96},
  [602] = {.lex_state = 96},
  [603] = {.lex_state = 4},
  [604] = {.lex_state = 96},
  [605] = {.lex_state = 41, .external_lex_state = 3},
  [606] = {.lex_state = 41, .external_lex_state = 3},
  [607] = {.lex_state = 41, .external_lex_state = 6},
  [608] = {.lex_state = 96},
  [609] = {.lex_state = 41, .external_lex_state = 5},
  [610] = {.lex_state = 41, .external_lex_state = 3},
  [611] = {.lex_state = 41, .external_lex_state = 4},
  [612] = {.lex_state = 41, .external_lex_state = 3},
  [613] = {.lex_state = 41, .external_lex_state = 3},
  [614] = {.lex_state = 41, .external_lex_state = 5},
  [615] = {.lex_state = 4, .external_lex_state = 2},
  [616] = {.lex_state = 41, .external_lex_state = 4},
  [617] = {.lex_state = 4, .external_lex_state = 2},
  [618] = {.lex_state = 41, .external_lex_state = 5},
  [619] = {.lex_state = 41, .external_lex_state = 5},
  [620] = {.lex_state = 41, .external_lex_state = 4},
  [621] = {.lex_state = 33, .external_lex_state = 4},
  [622] = {.lex_state = 41, .external_lex_state = 6},
  [623] = {.lex_state = 41, .external_lex_state = 4},
  [624] = {.lex_state = 33, .external_lex_state = 4},
  [625] = {.lex_state = 41, .external_lex_state = 5},
  [626] = {.lex_state = 41, .external_lex_state = 4},
  [627] = {.lex_state = 4},
  [628] = {.lex_state = 4},
  [629] = {.lex_state = 41, .external_lex_state = 5},
  [630] = {.lex_state = 41, .external_lex_state = 4},
  [631] = {.lex_state = 41, .external_lex_state = 4},
  [632] = {.lex_state = 41, .external_lex_state = 6},
  [633] = {.lex_state = 41, .external_lex_state = 4},
  [634] = {.lex_state = 41, .external_lex_state = 3},
  [635] = {.lex_state = 33, .external_lex_state = 6},
  [636] = {.lex_state = 44},
  [637] = {.lex_state = 44},
  [638] = {.lex_state = 44},
  [639] = {.lex_state = 41, .external_lex_state = 6},
  [640] = {.lex_state = 41, .external_lex_state = 4},
  [641] = {.lex_state = 41, .external_lex_state = 4},
  [642] = {.lex_state = 44},
  [643] = {.lex_state = 44},
  [644] = {.lex_state = 41, .external_lex_state = 4},
  [645] = {.lex_state = 41, .external_lex_state = 4},
  [646] = {.lex_state = 41, .external_lex_state = 4},
  [647] = {.lex_state = 44},
  [648] = {.lex_state = 41, .external_lex_state = 4},
  [649] = {.lex_state = 41, .external_lex_state = 3},
  [650] = {.lex_state = 41, .external_lex_state = 4},
  [651] = {.lex_state = 41, .external_lex_state = 6},
  [652] = {.lex_state = 41, .external_lex_state = 4},
  [653] = {.lex_state = 41, .external_lex_state = 4},
  [654] = {.lex_state = 44},
  [655] = {.lex_state = 41, .external_lex_state = 4},
  [656] = {.lex_state = 33, .external_lex_state = 6},
  [657] = {.lex_state = 41, .external_lex_state = 6},
  [658] = {.lex_state = 44},
  [659] = {.lex_state = 44},
  [660] = {.lex_state = 44},
  [661] = {.lex_state = 4, .external_lex_state = 2},
  [662] = {.lex_state = 4, .external_lex_state = 2},
  [663] = {.lex_state = 41, .external_lex_state = 4},
  [664] = {.lex_state = 41, .external_lex_state = 4},
  [665] = {.lex_state = 41, .external_lex_state = 6},
  [666] = {.lex_state = 41, .external_lex_state = 4},
  [667] = {.lex_state = 41, .external_lex_state = 4},
  [668] = {.lex_state = 41, .external_lex_state = 6},
  [669] = {.lex_state = 41, .external_lex_state = 4},
  [670] = {.lex_state = 4, .external_lex_state = 2},
  [671] = {.lex_state = 4, .external_lex_state = 2},
  [672] = {.lex_state = 44},
  [673] = {.lex_state = 44},
  [674] = {.lex_state = 44},
  [675] = {.lex_state = 44},
  [676] = {.lex_state = 44},
  [677] = {.lex_state = 44},
  [678] = {.lex_state = 44},
  [679] = {.lex_state = 44},
  [680] = {.lex_state = 44},
  [681] = {.lex_state = 41, .external_lex_state = 5},
  [682] = {.lex_state = 44},
  [683] = {.lex_state = 44},
  [684] = {.lex_state = 41, .external_lex_state = 5},
  [685] = {.lex_state = 41, .external_lex_state = 3},
  [686] = {.lex_state = 44},
  [687] = {.lex_state = 44},
  [688] = {.lex_state = 44},
  [689] = {.lex_state = 41, .external_lex_state = 3},
  [690] = {.lex_state = 44},
  [691] = {.lex_state = 44},
  [692] = {.lex_state = 44},
  [693] = {.lex_state = 44},
  [694] = {.lex_state = 41, .external_lex_state = 6},
  [695] = {.lex_state = 44},
  [696] = {.lex_state = 44},
  [697] = {.lex_state = 44},
  [698] = {.lex_state = 44},
  [699] = {.lex_state = 41, .external_lex_state = 6},
  [700] = {.lex_state = 44},
  [701] = {.lex_state = 44},
  [702] = {.lex_state = 44},
  [703] = {.lex_state = 41, .external_lex_state = 6},
  [704] = {.lex_state = 44},
  [705] = {.lex_state = 44},
  [706] = {.lex_state = 4},
  [707] = {.lex_state = 4},
  [708] = {.lex_state = 44},
  [709] = {.lex_state = 44},
  [710] = {.lex_state = 44},
  [711] = {.lex_state = 44},
  [712] = {.lex_state = 41, .external_lex_state = 6},
  [713] = {.lex_state = 44},
  [714] = {.lex_state = 44},
  [715] = {.lex_state = 44},
  [716] = {.lex_state = 44},
  [717] = {.lex_state = 44},
  [718] = {.lex_state = 44},
  [719] = {.lex_state = 44},
  [720] = {.lex_state = 44},
  [721] = {.lex_state = 44},
  [722] = {.lex_state = 44},
  [723] = {.lex_state = 44},
  [724] = {.lex_state = 44},
  [725] = {.lex_state = 44},
  [726] = {.lex_state = 44},
  [727] = {.lex_state = 44},
  [728] = {.lex_state = 44},
  [729] = {.lex_state = 44},
  [730] = {.lex_state = 44},
  [731] = {.lex_state = 44},
  [732] = {.lex_state = 44},
  [733] = {.lex_state = 44},
  [734] = {.lex_state = 44},
  [735] = {.lex_state = 44},
  [736] = {.lex_state = 44},
  [737] = {.lex_state = 44},
  [738] = {.lex_state = 44},
  [739] = {.lex_state = 44},
  [740] = {.lex_state = 44},
  [741] = {.lex_state = 44},
  [742] = {.lex_state = 44},
  [743] = {.lex_state = 44},
  [744] = {.lex_state = 44},
  [745] = {.lex_state = 44},
  [746] = {.lex_state = 44},
  [747] = {.lex_state = 44},
  [748] = {.lex_state = 44},
  [749] = {.lex_state = 44},
  [750] = {.lex_state = 44},
  [751] = {.lex_state = 44},
  [752] = {.lex_state = 44},
  [753] = {.lex_state = 44},
  [754] = {.lex_state = 44},
  [755] = {.lex_state = 44},
  [756] = {.lex_state = 41, .external_lex_state = 6},
  [757] = {.lex_state = 44},
  [758] = {.lex_state = 44},
  [759] = {.lex_state = 41, .external_lex_state = 6},
  [760] = {.lex_state = 41, .external_lex_state = 6},
  [761] = {.lex_state = 44},
  [762] = {.lex_state = 41, .external_lex_state = 6},
  [763] = {.lex_state = 44},
  [764] = {.lex_state = 44},
  [765] = {.lex_state = 44},
  [766] = {.lex_state = 41, .external_lex_state = 6},
  [767] = {.lex_state = 44},
  [768] = {.lex_state = 44},
  [769] = {.lex_state = 41, .external_lex_state = 6},
  [770] = {.lex_state = 44},
  [771] = {.lex_state = 44},
  [772] = {.lex_state = 44},
  [773] = {.lex_state = 44},
  [774] = {.lex_state = 44},
  [775] = {.lex_state = 41, .external_lex_state = 6},
  [776] = {.lex_state = 44},
  [777] = {.lex_state = 94, .external_lex_state = 6},
  [778] = {.lex_state = 4},
  [779] = {.lex_state = 41, .external_lex_state = 6},
  [780] = {.lex_state = 44},
  [781] = {.lex_state = 4},
  [782] = {.lex_state = 41, .external_lex_state = 6},
  [783] = {.lex_state = 44},
  [784] = {.lex_state = 41, .external_lex_state = 6},
  [785] = {.lex_state = 41, .external_lex_state = 4},
  [786] = {.lex_state = 44},
  [787] = {.lex_state = 41, .external_lex_state = 6},
  [788] = {.lex_state = 44},
  [789] = {.lex_state = 41, .external_lex_state = 6},
  [790] = {.lex_state = 44},
  [791] = {.lex_state = 44},
  [792] = {.lex_state = 44},
  [793] = {.lex_state = 44},
  [794] = {.lex_state = 44},
  [795] = {.lex_state = 44},
  [796] = {.lex_state = 41, .external_lex_state = 6},
  [797] = {.lex_state = 44},
  [798] = {.lex_state = 33, .external_lex_state = 4},
  [799] = {.lex_state = 44},
  [800] = {.lex_state = 44},
  [801] = {.lex_state = 41, .external_lex_state = 4},
  [802] = {.lex_state = 33, .external_lex_state = 4},
  [803] = {.lex_state = 44},
  [804] = {.lex_state = 44},
  [805] = {.lex_state = 44},
  [806] = {.lex_state = 44},
  [807] = {.lex_state = 44},
  [808] = {.lex_state = 44},
  [809] = {.lex_state = 44},
  [810] = {.lex_state = 44},
  [811] = {.lex_state = 44},
  [812] = {.lex_state = 44},
  [813] = {.lex_state = 44},
  [814] = {.lex_state = 44},
  [815] = {.lex_state = 94, .external_lex_state = 5},
  [816] = {.lex_state = 44},
  [817] = {.lex_state = 44},
  [818] = {.lex_state = 44},
  [819] = {.lex_state = 44},
  [820] = {.lex_state = 44},
  [821] = {.lex_state = 44},
  [822] = {.lex_state = 44},
  [823] = {.lex_state = 44},
  [824] = {.lex_state = 44},
  [825] = {.lex_state = 44},
  [826] = {.lex_state = 44},
  [827] = {.lex_state = 44},
  [828] = {.lex_state = 44},
  [829] = {.lex_state = 44},
  [830] = {.lex_state = 44},
  [831] = {.lex_state = 4, .external_lex_state = 2},
  [832] = {.lex_state = 44},
  [833] = {.lex_state = 44},
  [834] = {.lex_state = 44},
  [835] = {.lex_state = 41, .external_lex_state = 4},
  [836] = {.lex_state = 44},
  [837] = {.lex_state = 4, .external_lex_state = 2},
  [838] = {.lex_state = 94, .external_lex_state = 5},
  [839] = {.lex_state = 44},
  [840] = {.lex_state = 41, .external_lex_state = 4},
  [841] = {.lex_state = 94, .external_lex_state = 5},
  [842] = {.lex_state = 44},
  [843] = {.lex_state = 44},
  [844] = {.lex_state = 44},
  [845] = {.lex_state = 44},
  [846] = {.lex_state = 44},
  [847] = {.lex_state = 44},
  [848] = {.lex_state = 44},
  [849] = {.lex_state = 41, .external_lex_state = 5},
  [850] = {.lex_state = 44},
  [851] = {.lex_state = 41, .external_lex_state = 5},
  [852] = {.lex_state = 44},
  [853] = {.lex_state = 44},
  [854] = {.lex_state = 44},
  [855] = {.lex_state = 44},
  [856] = {.lex_state = 44},
  [857] = {.lex_state = 44},
  [858] = {.lex_state = 44},
  [859] = {.lex_state = 44},
  [860] = {.lex_state = 44},
  [861] = {.lex_state = 44},
  [862] = {.lex_state = 44},
  [863] = {.lex_state = 44},
  [864] = {.lex_state = 44},
  [865] = {.lex_state = 44},
  [866] = {.lex_state = 44},
  [867] = {.lex_state = 44},
  [868] = {.lex_state = 44},
  [869] = {.lex_state = 44},
  [870] = {.lex_state = 44},
  [871] = {.lex_state = 44},
  [872] = {.lex_state = 44},
  [873] = {.lex_state = 44},
  [874] = {.lex_state = 44},
  [875] = {.lex_state = 44},
  [876] = {.lex_state = 44},
  [877] = {.lex_state = 44},
  [878] = {.lex_state = 44},
  [879] = {.lex_state = 44},
  [880] = {.lex_state = 44},
  [881] = {.lex_state = 44},
  [882] = {.lex_state = 44},
  [883] = {.lex_state = 44},
  [884] = {.lex_state = 44},
  [885] = {.lex_state = 44},
  [886] = {.lex_state = 44},
  [887] = {.lex_state = 44},
  [888] = {.lex_state = 44},
  [889] = {.lex_state = 44},
  [890] = {.lex_state = 44},
  [891] = {.lex_state = 44},
  [892] = {.lex_state = 44},
  [893] = {.lex_state = 44},
  [894] = {.lex_state = 44},
  [895] = {.lex_state = 44},
  [896] = {.lex_state = 44},
  [897] = {.lex_state = 44},
  [898] = {.lex_state = 44},
  [899] = {.lex_state = 44},
  [900] = {.lex_state = 44},
  [901] = {.lex_state = 44},
  [902] = {.lex_state = 44},
  [903] = {.lex_state = 44},
  [904] = {.lex_state = 44},
  [905] = {.lex_state = 44},
  [906] = {.lex_state = 44},
  [907] = {.lex_state = 44},
  [908] = {.lex_state = 44},
  [909] = {.lex_state = 44},
  [910] = {.lex_state = 44},
  [911] = {.lex_state = 44},
  [912] = {.lex_state = 44},
  [913] = {.lex_state = 44},
  [914] = {.lex_state = 44},
  [915] = {.lex_state = 44},
  [916] = {.lex_state = 44},
  [917] = {.lex_state = 44},
  [918] = {.lex_state = 44},
  [919] = {.lex_state = 44},
  [920] = {.lex_state = 44},
  [921] = {.lex_state = 44},
  [922] = {.lex_state = 44},
  [923] = {.lex_state = 44},
  [924] = {.lex_state = 44},
  [925] = {.lex_state = 44},
  [926] = {.lex_state = 44},
  [927] = {.lex_state = 44},
  [928] = {.lex_state = 44},
  [929] = {.lex_state = 44},
  [930] = {.lex_state = 44},
  [931] = {.lex_state = 41, .external_lex_state = 6},
  [932] = {.lex_state = 44},
  [933] = {.lex_state = 44},
  [934] = {.lex_state = 44},
  [935] = {.lex_state = 44},
  [936] = {.lex_state = 4},
  [937] = {.lex_state = 44},
  [938] = {.lex_state = 44},
  [939] = {.lex_state = 44},
  [940] = {.lex_state = 44},
  [941] = {.lex_state = 44},
  [942] = {.lex_state = 44},
  [943] = {.lex_state = 44},
  [944] = {.lex_state = 44},
  [945] = {.lex_state = 44},
  [946] = {.lex_state = 44},
  [947] = {.lex_state = 44},
  [948] = {.lex_state = 41, .external_lex_state = 6},
  [949] = {.lex_state = 44},
  [950] = {.lex_state = 44},
  [951] = {.lex_state = 44},
  [952] = {.lex_state = 44},
  [953] = {.lex_state = 44},
  [954] = {.lex_state = 44},
  [955] = {.lex_state = 44},
  [956] = {.lex_state = 44},
  [957] = {.lex_state = 44},
  [958] = {.lex_state = 44},
  [959] = {.lex_state = 44},
  [960] = {.lex_state = 44},
  [961] = {.lex_state = 44},
  [962] = {.lex_state = 44},
  [963] = {.lex_state = 44},
  [964] = {.lex_state = 44},
  [965] = {.lex_state = 41, .external_lex_state = 4},
  [966] = {.lex_state = 44},
  [967] = {.lex_state = 44},
  [968] = {.lex_state = 41, .external_lex_state = 4},
  [969] = {.lex_state = 44},
  [970] = {.lex_state = 44},
  [971] = {.lex_state = 44},
  [972] = {.lex_state = 44},
  [973] = {.lex_state = 44},
  [974] = {.lex_state = 44},
  [975] = {.lex_state = 44},
  [976] = {.lex_state = 44},
  [977] = {.lex_state = 44},
  [978] = {.lex_state = 41, .external_lex_state = 4},
  [979] = {.lex_state = 44},
  [980] = {.lex_state = 41, .external_lex_state = 4},
  [981] = {.lex_state = 44},
  [982] = {.lex_state = 44},
  [983] = {.lex_state = 44},
  [984] = {.lex_state = 44},
  [985] = {.lex_state = 44},
  [986] = {.lex_state = 44},
  [987] = {.lex_state = 44},
  [988] = {.lex_state = 44},
  [989] = {.lex_state = 44},
  [990] = {.lex_state = 44},
  [991] = {.lex_state = 41, .external_lex_state = 4},
  [992] = {.lex_state = 44},
  [993] = {.lex_state = 41, .external_lex_state = 4},
  [994] = {.lex_state = 44},
  [995] = {.lex_state = 41, .external_lex_state = 4},
  [996] = {.lex_state = 44},
  [997] = {.lex_state = 44},
  [998] = {.lex_state = 44},
  [999] = {.lex_state = 44},
  [1000] = {.lex_state = 44},
  [1001] = {.lex_state = 41, .external_lex_state = 4},
  [1002] = {.lex_state = 41, .external_lex_state = 4},
  [1003] = {.lex_state = 44},
  [1004] = {.lex_state = 44},
  [1005] = {.lex_state = 44},
  [1006] = {.lex_state = 41, .external_lex_state = 4},
  [1007] = {.lex_state = 41, .external_lex_state = 4},
  [1008] = {.lex_state = 44},
  [1009] = {.lex_state = 44},
  [1010] = {.lex_state = 44},
  [1011] = {.lex_state = 44},
  [1012] = {.lex_state = 44},
  [1013] = {.lex_state = 44},
  [1014] = {.lex_state = 44},
  [1015] = {.lex_state = 44},
  [1016] = {.lex_state = 44},
  [1017] = {.lex_state = 44},
  [1018] = {.lex_state = 44},
  [1019] = {.lex_state = 44},
  [1020] = {.lex_state = 44},
  [1021] = {.lex_state = 44},
  [1022] = {.lex_state = 44},
  [1023] = {.lex_state = 44},
  [1024] = {.lex_state = 44},
  [1025] = {.lex_state = 44},
  [1026] = {.lex_state = 44},
  [1027] = {.lex_state = 44},
  [1028] = {.lex_state = 44},
  [1029] = {.lex_state = 44},
  [1030] = {.lex_state = 44},
  [1031] = {.lex_state = 44},
  [1032] = {.lex_state = 44},
  [1033] = {.lex_state = 44},
  [1034] = {.lex_state = 44},
  [1035] = {.lex_state = 44},
  [1036] = {.lex_state = 41, .external_lex_state = 4},
  [1037] = {.lex_state = 44},
  [1038] = {.lex_state = 44},
  [1039] = {.lex_state = 44},
  [1040] = {.lex_state = 44},
  [1041] = {.lex_state = 44},
  [1042] = {.lex_state = 44},
  [1043] = {.lex_state = 44},
  [1044] = {.lex_state = 44},
  [1045] = {.lex_state = 44},
  [1046] = {.lex_state = 44},
  [1047] = {.lex_state = 44},
  [1048] = {.lex_state = 44},
  [1049] = {.lex_state = 44},
  [1050] = {.lex_state = 44},
  [1051] = {.lex_state = 44},
  [1052] = {.lex_state = 44},
  [1053] = {.lex_state = 44},
  [1054] = {.lex_state = 44},
  [1055] = {.lex_state = 44},
  [1056] = {.lex_state = 44},
  [1057] = {.lex_state = 44},
  [1058] = {.lex_state = 44},
  [1059] = {.lex_state = 44},
  [1060] = {.lex_state = 44},
  [1061] = {.lex_state = 44},
  [1062] = {.lex_state = 44},
  [1063] = {.lex_state = 94, .external_lex_state = 5},
  [1064] = {.lex_state = 44},
  [1065] = {.lex_state = 44},
  [1066] = {.lex_state = 44},
  [1067] = {.lex_state = 44},
  [1068] = {.lex_state = 44},
  [1069] = {.lex_state = 44},
  [1070] = {.lex_state = 44},
  [1071] = {.lex_state = 44},
  [1072] = {.lex_state = 44},
  [1073] = {.lex_state = 44},
  [1074] = {.lex_state = 41, .external_lex_state = 4},
  [1075] = {.lex_state = 44},
  [1076] = {.lex_state = 44},
  [1077] = {.lex_state = 44},
  [1078] = {.lex_state = 44},
  [1079] = {.lex_state = 94, .external_lex_state = 6},
  [1080] = {.lex_state = 4},
  [1081] = {.lex_state = 44},
  [1082] = {.lex_state = 33, .external_lex_state = 6},
  [1083] = {.lex_state = 44},
  [1084] = {.lex_state = 44},
  [1085] = {.lex_state = 44},
  [1086] = {.lex_state = 44},
  [1087] = {.lex_state = 44},
  [1088] = {.lex_state = 44},
  [1089] = {.lex_state = 44},
  [1090] = {.lex_state = 44},
  [1091] = {.lex_state = 44},
  [1092] = {.lex_state = 44},
  [1093] = {.lex_state = 44},
  [1094] = {.lex_state = 33, .external_lex_state = 6},
  [1095] = {.lex_state = 44},
  [1096] = {.lex_state = 44},
  [1097] = {.lex_state = 44},
  [1098] = {.lex_state = 44},
  [1099] = {.lex_state = 44},
  [1100] = {.lex_state = 44},
  [1101] = {.lex_state = 44},
  [1102] = {.lex_state = 44},
  [1103] = {.lex_state = 44},
  [1104] = {.lex_state = 44},
  [1105] = {.lex_state = 44},
  [1106] = {.lex_state = 44},
  [1107] = {.lex_state = 44},
  [1108] = {.lex_state = 44},
  [1109] = {.lex_state = 44},
  [1110] = {.lex_state = 44},
  [1111] = {.lex_state = 94, .external_lex_state = 5},
  [1112] = {.lex_state = 44},
  [1113] = {.lex_state = 44},
  [1114] = {.lex_state = 44},
  [1115] = {.lex_state = 44},
  [1116] = {.lex_state = 44},
  [1117] = {.lex_state = 44},
  [1118] = {.lex_state = 44},
  [1119] = {.lex_state = 44},
  [1120] = {.lex_state = 44},
  [1121] = {.lex_state = 41, .external_lex_state = 6},
  [1122] = {.lex_state = 44},
  [1123] = {.lex_state = 44},
  [1124] = {.lex_state = 44},
  [1125] = {.lex_state = 44},
  [1126] = {.lex_state = 44},
  [1127] = {.lex_state = 44},
  [1128] = {.lex_state = 44},
  [1129] = {.lex_state = 44},
  [1130] = {.lex_state = 44},
  [1131] = {.lex_state = 41, .external_lex_state = 4},
  [1132] = {.lex_state = 94, .external_lex_state = 5},
  [1133] = {.lex_state = 44},
  [1134] = {.lex_state = 44},
  [1135] = {.lex_state = 44},
  [1136] = {.lex_state = 44},
  [1137] = {.lex_state = 44},
  [1138] = {.lex_state = 44},
  [1139] = {.lex_state = 44},
  [1140] = {.lex_state = 44},
  [1141] = {.lex_state = 44},
  [1142] = {.lex_state = 44},
  [1143] = {.lex_state = 44},
  [1144] = {.lex_state = 44},
  [1145] = {.lex_state = 41, .external_lex_state = 4},
  [1146] = {.lex_state = 44},
  [1147] = {.lex_state = 44},
  [1148] = {.lex_state = 44},
  [1149] = {.lex_state = 44},
  [1150] = {.lex_state = 44},
  [1151] = {.lex_state = 44},
  [1152] = {.lex_state = 44},
  [1153] = {.lex_state = 44},
  [1154] = {.lex_state = 44},
  [1155] = {.lex_state = 44},
  [1156] = {.lex_state = 44},
  [1157] = {.lex_state = 44},
  [1158] = {.lex_state = 44},
  [1159] = {.lex_state = 44},
  [1160] = {.lex_state = 44},
  [1161] = {.lex_state = 44},
  [1162] = {.lex_state = 44},
  [1163] = {.lex_state = 4, .external_lex_state = 2},
  [1164] = {.lex_state = 44},
  [1165] = {.lex_state = 44},
  [1166] = {.lex_state = 44},
  [1167] = {.lex_state = 44},
  [1168] = {.lex_state = 44},
  [1169] = {.lex_state = 44},
  [1170] = {.lex_state = 44},
  [1171] = {.lex_state = 44},
  [1172] = {.lex_state = 44},
  [1173] = {.lex_state = 44},
  [1174] = {.lex_state = 44},
  [1175] = {.lex_state = 44},
  [1176] = {.lex_state = 44},
  [1177] = {.lex_state = 44},
  [1178] = {.lex_state = 44},
  [1179] = {.lex_state = 44},
  [1180] = {.lex_state = 44},
  [1181] = {.lex_state = 44},
  [1182] = {.lex_state = 44},
  [1183] = {.lex_state = 44},
  [1184] = {.lex_state = 44},
  [1185] = {.lex_state = 44},
  [1186] = {.lex_state = 44},
  [1187] = {.lex_state = 44},
  [1188] = {.lex_state = 44},
  [1189] = {.lex_state = 44},
  [1190] = {.lex_state = 44},
  [1191] = {.lex_state = 44},
  [1192] = {.lex_state = 44},
  [1193] = {.lex_state = 44},
  [1194] = {.lex_state = 44},
  [1195] = {.lex_state = 44},
  [1196] = {.lex_state = 44},
  [1197] = {.lex_state = 44},
  [1198] = {.lex_state = 44},
  [1199] = {.lex_state = 44},
  [1200] = {.lex_state = 44},
  [1201] = {.lex_state = 44},
  [1202] = {.lex_state = 44},
  [1203] = {.lex_state = 44},
  [1204] = {.lex_state = 44},
  [1205] = {.lex_state = 44},
  [1206] = {.lex_state = 44},
  [1207] = {.lex_state = 44},
  [1208] = {.lex_state = 44},
  [1209] = {.lex_state = 44},
  [1210] = {.lex_state = 44},
  [1211] = {.lex_state = 44},
  [1212] = {.lex_state = 44},
  [1213] = {.lex_state = 44},
  [1214] = {.lex_state = 44},
  [1215] = {.lex_state = 44},
  [1216] = {.lex_state = 44},
  [1217] = {.lex_state = 44},
  [1218] = {.lex_state = 41, .external_lex_state = 4},
  [1219] = {.lex_state = 37, .external_lex_state = 4},
  [1220] = {.lex_state = 4, .external_lex_state = 2},
  [1221] = {.lex_state = 4, .external_lex_state = 2},
  [1222] = {.lex_state = 94, .external_lex_state = 6},
  [1223] = {.lex_state = 94, .external_lex_state = 6},
  [1224] = {.lex_state = 4, .external_lex_state = 2},
  [1225] = {.lex_state = 4, .external_lex_state = 2},
  [1226] = {.lex_state = 4, .external_lex_state = 2},
  [1227] = {.lex_state = 41, .external_lex_state = 6},
  [1228] = {.lex_state = 4, .external_lex_state = 2},
  [1229] = {.lex_state = 4, .external_lex_state = 2},
  [1230] = {.lex_state = 4, .external_lex_state = 2},
  [1231] = {.lex_state = 4, .external_lex_state = 2},
  [1232] = {.lex_state = 4, .external_lex_state = 2},
  [1233] = {.lex_state = 4, .external_lex_state = 2},
  [1234] = {.lex_state = 41, .external_lex_state = 6},
  [1235] = {.lex_state = 4, .external_lex_state = 2},
  [1236] = {.lex_state = 4, .external_lex_state = 2},
  [1237] = {.lex_state = 4, .external_lex_state = 2},
  [1238] = {.lex_state = 4, .external_lex_state = 2},
  [1239] = {.lex_state = 4, .external_lex_state = 2},
  [1240] = {.lex_state = 4, .external_lex_state = 2},
  [1241] = {.lex_state = 94, .external_lex_state = 6},
  [1242] = {.lex_state = 4, .external_lex_state = 2},
  [1243] = {.lex_state = 4, .external_lex_state = 2},
  [1244] = {.lex_state = 4, .external_lex_state = 2},
  [1245] = {.lex_state = 4, .external_lex_state = 2},
  [1246] = {.lex_state = 4, .external_lex_state = 2},
  [1247] = {.lex_state = 4, .external_lex_state = 2},
  [1248] = {.lex_state = 4, .external_lex_state = 2},
  [1249] = {.lex_state = 4, .external_lex_state = 2},
  [1250] = {.lex_state = 4, .external_lex_state = 2},
  [1251] = {.lex_state = 4, .external_lex_state = 2},
  [1252] = {.lex_state = 4, .external_lex_state = 2},
  [1253] = {.lex_state = 4, .external_lex_state = 2},
  [1254] = {.lex_state = 4, .external_lex_state = 2},
  [1255] = {.lex_state = 4, .external_lex_state = 2},
  [1256] = {.lex_state = 4, .external_lex_state = 2},
  [1257] = {.lex_state = 4, .external_lex_state = 2},
  [1258] = {.lex_state = 4, .external_lex_state = 2},
  [1259] = {.lex_state = 4, .external_lex_state = 2},
  [1260] = {.lex_state = 4, .external_lex_state = 2},
  [1261] = {.lex_state = 4, .external_lex_state = 2},
  [1262] = {.lex_state = 4, .external_lex_state = 2},
  [1263] = {.lex_state = 4, .external_lex_state = 2},
  [1264] = {.lex_state = 4, .external_lex_state = 2},
  [1265] = {.lex_state = 4, .external_lex_state = 2},
  [1266] = {.lex_state = 4},
  [1267] = {.lex_state = 4, .external_lex_state = 2},
  [1268] = {.lex_state = 4, .external_lex_state = 2},
  [1269] = {.lex_state = 94, .external_lex_state = 6},
  [1270] = {.lex_state = 4, .external_lex_state = 2},
  [1271] = {.lex_state = 4, .external_lex_state = 2},
  [1272] = {.lex_state = 4, .external_lex_state = 2},
  [1273] = {.lex_state = 41, .external_lex_state = 6},
  [1274] = {.lex_state = 4, .external_lex_state = 2},
  [1275] = {.lex_state = 4, .external_lex_state = 2},
  [1276] = {.lex_state = 4, .external_lex_state = 2},
  [1277] = {.lex_state = 4, .external_lex_state = 2},
  [1278] = {.lex_state = 4, .external_lex_state = 2},
  [1279] = {.lex_state = 4, .external_lex_state = 2},
  [1280] = {.lex_state = 4, .external_lex_state = 2},
  [1281] = {.lex_state = 4, .external_lex_state = 2},
  [1282] = {.lex_state = 4, .external_lex_state = 2},
  [1283] = {.lex_state = 41, .external_lex_state = 6},
  [1284] = {.lex_state = 41, .external_lex_state = 6},
  [1285] = {.lex_state = 41, .external_lex_state = 6},
  [1286] = {.lex_state = 41, .external_lex_state = 6},
  [1287] = {.lex_state = 41, .external_lex_state = 6},
  [1288] = {.lex_state = 41, .external_lex_state = 6},
  [1289] = {.lex_state = 41, .external_lex_state = 6},
  [1290] = {.lex_state = 41, .external_lex_state = 6},
  [1291] = {.lex_state = 41, .external_lex_state = 6},
  [1292] = {.lex_state = 41, .external_lex_state = 6},
  [1293] = {.lex_state = 41, .external_lex_state = 6},
  [1294] = {.lex_state = 41, .external_lex_state = 6},
  [1295] = {.lex_state = 41, .external_lex_state = 6},
  [1296] = {.lex_state = 92, .external_lex_state = 6},
  [1297] = {.lex_state = 92, .external_lex_state = 6},
  [1298] = {.lex_state = 94, .external_lex_state = 6},
  [1299] = {.lex_state = 4},
  [1300] = {.lex_state = 4},
  [1301] = {.lex_state = 94, .external_lex_state = 6},
  [1302] = {.lex_state = 94, .external_lex_state = 6},
  [1303] = {.lex_state = 94, .external_lex_state = 6},
  [1304] = {.lex_state = 4},
  [1305] = {.lex_state = 4},
  [1306] = {.lex_state = 94, .external_lex_state = 6},
  [1307] = {.lex_state = 94, .external_lex_state = 6},
  [1308] = {.lex_state = 94, .external_lex_state = 6},
  [1309] = {.lex_state = 94, .external_lex_state = 6},
  [1310] = {.lex_state = 94, .external_lex_state = 6},
  [1311] = {.lex_state = 94, .external_lex_state = 6},
  [1312] = {.lex_state = 4},
  [1313] = {.lex_state = 94, .external_lex_state = 6},
  [1314] = {.lex_state = 94, .external_lex_state = 6},
  [1315] = {.lex_state = 94, .external_lex_state = 6},
  [1316] = {.lex_state = 4},
  [1317] = {.lex_state = 4},
  [1318] = {.lex_state = 4},
  [1319] = {.lex_state = 94, .external_lex_state = 6},
  [1320] = {.lex_state = 4},
  [1321] = {.lex_state = 4},
  [1322] = {.lex_state = 4},
  [1323] = {.lex_state = 4},
  [1324] = {.lex_state = 4},
  [1325] = {.lex_state = 4},
  [1326] = {.lex_state = 4},
  [1327] = {.lex_state = 94, .external_lex_state = 6},
  [1328] = {.lex_state = 4},
  [1329] = {.lex_state = 4},
  [1330] = {.lex_state = 4},
  [1331] = {.lex_state = 4},
  [1332] = {.lex_state = 4},
  [1333] = {.lex_state = 4},
  [1334] = {.lex_state = 4},
  [1335] = {.lex_state = 37, .external_lex_state = 2},
  [1336] = {.lex_state = 4},
  [1337] = {.lex_state = 4},
  [1338] = {.lex_state = 94, .external_lex_state = 6},
  [1339] = {.lex_state = 4},
  [1340] = {.lex_state = 4},
  [1341] = {.lex_state = 4},
  [1342] = {.lex_state = 37, .external_lex_state = 6},
  [1343] = {.lex_state = 4},
  [1344] = {.lex_state = 4},
  [1345] = {.lex_state = 4},
  [1346] = {.lex_state = 4},
  [1347] = {.lex_state = 4},
  [1348] = {.lex_state = 37, .external_lex_state = 4},
  [1349] = {.lex_state = 44},
  [1350] = {.lex_state = 4},
  [1351] = {.lex_state = 4},
  [1352] = {.lex_state = 4},
  [1353] = {.lex_state = 4},
  [1354] = {.lex_state = 4},
  [1355] = {.lex_state = 4},
  [1356] = {.lex_state = 4},
  [1357] = {.lex_state = 4},
  [1358] = {.lex_state = 4},
  [1359] = {.lex_state = 4},
  [1360] = {.lex_state = 4},
  [1361] = {.lex_state = 4},
  [1362] = {.lex_state = 4},
  [1363] = {.lex_state = 4},
  [1364] = {.lex_state = 4},
  [1365] = {.lex_state = 4},
  [1366] = {.lex_state = 4},
  [1367] = {.lex_state = 4},
  [1368] = {.lex_state = 4},
  [1369] = {.lex_state = 4},
  [1370] = {.lex_state = 4},
  [1371] = {.lex_state = 4},
  [1372] = {.lex_state = 94, .external_lex_state = 6},
  [1373] = {.lex_state = 4},
  [1374] = {.lex_state = 94, .external_lex_state = 5},
  [1375] = {.lex_state = 94, .external_lex_state = 5},
  [1376] = {.lex_state = 4, .external_lex_state = 2},
  [1377] = {.lex_state = 37, .external_lex_state = 6},
  [1378] = {.lex_state = 37, .external_lex_state = 4},
  [1379] = {.lex_state = 4, .external_lex_state = 2},
  [1380] = {.lex_state = 94, .external_lex_state = 5},
  [1381] = {.lex_state = 4, .external_lex_state = 2},
  [1382] = {.lex_state = 94, .external_lex_state = 5},
  [1383] = {.lex_state = 37, .external_lex_state = 4},
  [1384] = {.lex_state = 37, .external_lex_state = 2},
  [1385] = {.lex_state = 4, .external_lex_state = 2},
  [1386] = {.lex_state = 4, .external_lex_state = 2},
  [1387] = {.lex_state = 94, .external_lex_state = 5},
  [1388] = {.lex_state = 94, .external_lex_state = 5},
  [1389] = {.lex_state = 4, .external_lex_state = 2},
  [1390] = {.lex_state = 37},
  [1391] = {.lex_state = 4, .external_lex_state = 2},
  [1392] = {.lex_state = 4, .external_lex_state = 2},
  [1393] = {.lex_state = 37, .external_lex_state = 4},
  [1394] = {.lex_state = 94, .external_lex_state = 5},
  [1395] = {.lex_state = 94, .external_lex_state = 5},
  [1396] = {.lex_state = 37, .external_lex_state = 6},
  [1397] = {.lex_state = 37, .external_lex_state = 6},
  [1398] = {.lex_state = 37, .external_lex_state = 2},
  [1399] = {.lex_state = 94, .external_lex_state = 5},
  [1400] = {.lex_state = 37, .external_lex_state = 4},
  [1401] = {.lex_state = 94, .external_lex_state = 5},
  [1402] = {.lex_state = 37, .external_lex_state = 4},
  [1403] = {.lex_state = 94, .external_lex_state = 5},
  [1404] = {.lex_state = 37},
  [1405] = {.lex_state = 94, .external_lex_state = 5},
  [1406] = {.lex_state = 37, .external_lex_state = 4},
  [1407] = {.lex_state = 44},
  [1408] = {.lex_state = 37, .external_lex_state = 4},
  [1409] = {.lex_state = 37, .external_lex_state = 2},
  [1410] = {.lex_state = 4},
  [1411] = {.lex_state = 39, .external_lex_state = 4},
  [1412] = {.lex_state = 37, .external_lex_state = 4},
  [1413] = {.lex_state = 37, .external_lex_state = 4},
  [1414] = {.lex_state = 37, .external_lex_state = 4},
  [1415] = {.lex_state = 37, .external_lex_state = 2},
  [1416] = {.lex_state = 37, .external_lex_state = 4},
  [1417] = {.lex_state = 37, .external_lex_state = 4},
  [1418] = {.lex_state = 37, .external_lex_state = 4},
  [1419] = {.lex_state = 37, .external_lex_state = 4},
  [1420] = {.lex_state = 37, .external_lex_state = 4},
  [1421] = {.lex_state = 37, .external_lex_state = 4},
  [1422] = {.lex_state = 37, .external_lex_state = 4},
  [1423] = {.lex_state = 37},
  [1424] = {.lex_state = 37, .external_lex_state = 4},
  [1425] = {.lex_state = 37, .external_lex_state = 6},
  [1426] = {.lex_state = 37, .external_lex_state = 4},
  [1427] = {.lex_state = 37, .external_lex_state = 2},
  [1428] = {.lex_state = 39, .external_lex_state = 4},
  [1429] = {.lex_state = 37, .external_lex_state = 4},
  [1430] = {.lex_state = 37, .external_lex_state = 2},
  [1431] = {.lex_state = 37},
  [1432] = {.lex_state = 37, .external_lex_state = 4},
  [1433] = {.lex_state = 37, .external_lex_state = 4},
  [1434] = {.lex_state = 37, .external_lex_state = 6},
  [1435] = {.lex_state = 37, .external_lex_state = 4},
  [1436] = {.lex_state = 37, .external_lex_state = 4},
  [1437] = {.lex_state = 37, .external_lex_state = 4},
  [1438] = {.lex_state = 37, .external_lex_state = 2},
  [1439] = {.lex_state = 37, .external_lex_state = 6},
  [1440] = {.lex_state = 37, .external_lex_state = 4},
  [1441] = {.lex_state = 37, .external_lex_state = 4},
  [1442] = {.lex_state = 37, .external_lex_state = 2},
  [1443] = {.lex_state = 37, .external_lex_state = 6},
  [1444] = {.lex_state = 37, .external_lex_state = 6},
  [1445] = {.lex_state = 37, .external_lex_state = 4},
  [1446] = {.lex_state = 37, .external_lex_state = 2},
  [1447] = {.lex_state = 37, .external_lex_state = 2},
  [1448] = {.lex_state = 37, .external_lex_state = 4},
  [1449] = {.lex_state = 37, .external_lex_state = 4},
  [1450] = {.lex_state = 37, .external_lex_state = 4},
  [1451] = {.lex_state = 37, .external_lex_state = 4},
  [1452] = {.lex_state = 37, .external_lex_state = 4},
  [1453] = {.lex_state = 37, .external_lex_state = 2},
  [1454] = {.lex_state = 37, .external_lex_state = 4},
  [1455] = {.lex_state = 37},
  [1456] = {.lex_state = 37, .external_lex_state = 6},
  [1457] = {.lex_state = 37, .external_lex_state = 2},
  [1458] = {.lex_state = 37},
  [1459] = {.lex_state = 37, .external_lex_state = 4},
  [1460] = {.lex_state = 37, .external_lex_state = 4},
  [1461] = {.lex_state = 37, .external_lex_state = 4},
  [1462] = {.lex_state = 37, .external_lex_state = 4},
  [1463] = {.lex_state = 37, .external_lex_state = 4},
  [1464] = {.lex_state = 37, .external_lex_state = 4},
  [1465] = {.lex_state = 37, .external_lex_state = 4},
  [1466] = {.lex_state = 37, .external_lex_state = 6},
  [1467] = {.lex_state = 37, .external_lex_state = 6},
  [1468] = {.lex_state = 37, .external_lex_state = 2},
  [1469] = {.lex_state = 37, .external_lex_state = 6},
  [1470] = {.lex_state = 37, .external_lex_state = 6},
  [1471] = {.lex_state = 37, .external_lex_state = 6},
  [1472] = {.lex_state = 37, .external_lex_state = 6},
  [1473] = {.lex_state = 37, .external_lex_state = 6},
  [1474] = {.lex_state = 37},
  [1475] = {.lex_state = 37, .external_lex_state = 6},
  [1476] = {.lex_state = 37, .external_lex_state = 2},
  [1477] = {.lex_state = 37, .external_lex_state = 2},
  [1478] = {.lex_state = 37, .external_lex_state = 2},
  [1479] = {.lex_state = 37, .external_lex_state = 6},
  [1480] = {.lex_state = 37, .external_lex_state = 6},
  [1481] = {.lex_state = 37, .external_lex_state = 2},
  [1482] = {.lex_state = 37, .external_lex_state = 6},
  [1483] = {.lex_state = 37, .external_lex_state = 6},
  [1484] = {.lex_state = 37, .external_lex_state = 2},
  [1485] = {.lex_state = 37, .external_lex_state = 6},
  [1486] = {.lex_state = 37, .external_lex_state = 6},
  [1487] = {.lex_state = 37, .external_lex_state = 6},
  [1488] = {.lex_state = 37, .external_lex_state = 2},
  [1489] = {.lex_state = 37, .external_lex_state = 6},
  [1490] = {.lex_state = 37, .external_lex_state = 2},
  [1491] = {.lex_state = 39, .external_lex_state = 2},
  [1492] = {.lex_state = 39, .external_lex_state = 2},
  [1493] = {.lex_state = 37, .external_lex_state = 4},
  [1494] = {.lex_state = 37, .external_lex_state = 2},
  [1495] = {.lex_state = 39, .external_lex_state = 6},
  [1496] = {.lex_state = 37, .external_lex_state = 2},
  [1497] = {.lex_state = 39, .external_lex_state = 6},
  [1498] = {.lex_state = 37, .external_lex_state = 6},
  [1499] = {.lex_state = 37, .external_lex_state = 6},
  [1500] = {.lex_state = 37},
  [1501] = {.lex_state = 37},
  [1502] = {.lex_state = 37, .external_lex_state = 6},
  [1503] = {.lex_state = 37, .external_lex_state = 4},
  [1504] = {.lex_state = 37, .external_lex_state = 6},
  [1505] = {.lex_state = 37},
  [1506] = {.lex_state = 37, .external_lex_state = 2},
  [1507] = {.lex_state = 44},
  [1508] = {.lex_state = 37, .external_lex_state = 6},
  [1509] = {.lex_state = 37, .external_lex_state = 6},
  [1510] = {.lex_state = 39},
  [1511] = {.lex_state = 37, .external_lex_state = 6},
  [1512] = {.lex_state = 37, .external_lex_state = 6},
  [1513] = {.lex_state = 49, .external_lex_state = 6},
  [1514] = {.lex_state = 37},
  [1515] = {.lex_state = 37, .external_lex_state = 6},
  [1516] = {.lex_state = 37},
  [1517] = {.lex_state = 39},
  [1518] = {.lex_state = 37, .external_lex_state = 6},
  [1519] = {.lex_state = 37, .external_lex_state = 6},
  [1520] = {.lex_state = 37, .external_lex_state = 2},
  [1521] = {.lex_state = 37, .external_lex_state = 6},
  [1522] = {.lex_state = 37, .external_lex_state = 6},
  [1523] = {.lex_state = 37, .external_lex_state = 6},
  [1524] = {.lex_state = 37},
  [1525] = {.lex_state = 37, .external_lex_state = 6},
  [1526] = {.lex_state = 37, .external_lex_state = 6},
  [1527] = {.lex_state = 49, .external_lex_state = 6},
  [1528] = {.lex_state = 37, .external_lex_state = 6},
  [1529] = {.lex_state = 37, .external_lex_state = 2},
  [1530] = {.lex_state = 37},
  [1531] = {.lex_state = 37, .external_lex_state = 4},
  [1532] = {.lex_state = 37, .external_lex_state = 6},
  [1533] = {.lex_state = 37, .external_lex_state = 6},
  [1534] = {.lex_state = 37},
  [1535] = {.lex_state = 37},
  [1536] = {.lex_state = 37},
  [1537] = {.lex_state = 37},
  [1538] = {.lex_state = 44},
  [1539] = {.lex_state = 37},
  [1540] = {.lex_state = 37},
  [1541] = {.lex_state = 37},
  [1542] = {.lex_state = 37},
  [1543] = {.lex_state = 37},
  [1544] = {.lex_state = 37, .external_lex_state = 4},
  [1545] = {.lex_state = 49},
  [1546] = {.lex_state = 37, .external_lex_state = 6},
  [1547] = {.lex_state = 37},
  [1548] = {.lex_state = 37, .external_lex_state = 2},
  [1549] = {.lex_state = 37},
  [1550] = {.lex_state = 39, .external_lex_state = 4},
  [1551] = {.lex_state = 37},
  [1552] = {.lex_state = 96},
  [1553] = {.lex_state = 49},
  [1554] = {.lex_state = 39, .external_lex_state = 4},
  [1555] = {.lex_state = 39, .external_lex_state = 6},
  [1556] = {.lex_state = 37, .external_lex_state = 4},
  [1557] = {.lex_state = 37, .external_lex_state = 2},
  [1558] = {.lex_state = 37, .external_lex_state = 2},
  [1559] = {.lex_state = 37, .external_lex_state = 4},
  [1560] = {.lex_state = 37, .external_lex_state = 2},
  [1561] = {.lex_state = 37, .external_lex_state = 6},
  [1562] = {.lex_state = 37, .external_lex_state = 2},
  [1563] = {.lex_state = 39, .external_lex_state = 6},
  [1564] = {.lex_state = 37, .external_lex_state = 2},
  [1565] = {.lex_state = 37},
  [1566] = {.lex_state = 37, .external_lex_state = 4},
  [1567] = {.lex_state = 37, .external_lex_state = 4},
  [1568] = {.lex_state = 39, .external_lex_state = 2},
  [1569] = {.lex_state = 39, .external_lex_state = 2},
  [1570] = {.lex_state = 49, .external_lex_state = 6},
  [1571] = {.lex_state = 37, .external_lex_state = 4},
  [1572] = {.lex_state = 37, .external_lex_state = 4},
  [1573] = {.lex_state = 37, .external_lex_state = 4},
  [1574] = {.lex_state = 37, .external_lex_state = 4},
  [1575] = {.lex_state = 37, .external_lex_state = 4},
  [1576] = {.lex_state = 37, .external_lex_state = 4},
  [1577] = {.lex_state = 49, .external_lex_state = 6},
  [1578] = {.lex_state = 37, .external_lex_state = 4},
  [1579] = {.lex_state = 49, .external_lex_state = 6},
  [1580] = {.lex_state = 37, .external_lex_state = 2},
  [1581] = {.lex_state = 37, .external_lex_state = 4},
  [1582] = {.lex_state = 37, .external_lex_state = 4},
  [1583] = {.lex_state = 37, .external_lex_state = 4},
  [1584] = {.lex_state = 37, .external_lex_state = 4},
  [1585] = {.lex_state = 37, .external_lex_state = 6},
  [1586] = {.lex_state = 37, .external_lex_state = 6},
  [1587] = {.lex_state = 49},
  [1588] = {.lex_state = 37, .external_lex_state = 6},
  [1589] = {.lex_state = 47, .external_lex_state = 6},
  [1590] = {.lex_state = 39},
  [1591] = {.lex_state = 49, .external_lex_state = 6},
  [1592] = {.lex_state = 37, .external_lex_state = 2},
  [1593] = {.lex_state = 47, .external_lex_state = 6},
  [1594] = {.lex_state = 49, .external_lex_state = 6},
  [1595] = {.lex_state = 49, .external_lex_state = 6},
  [1596] = {.lex_state = 37, .external_lex_state = 6},
  [1597] = {.lex_state = 37, .external_lex_state = 6},
  [1598] = {.lex_state = 37, .external_lex_state = 6},
  [1599] = {.lex_state = 37, .external_lex_state = 6},
  [1600] = {.lex_state = 37, .external_lex_state = 6},
  [1601] = {.lex_state = 49},
  [1602] = {.lex_state = 37, .external_lex_state = 6},
  [1603] = {.lex_state = 37, .external_lex_state = 6},
  [1604] = {.lex_state = 37, .external_lex_state = 6},
  [1605] = {.lex_state = 49},
  [1606] = {.lex_state = 37, .external_lex_state = 6},
  [1607] = {.lex_state = 37, .external_lex_state = 6},
  [1608] = {.lex_state = 37, .external_lex_state = 6},
  [1609] = {.lex_state = 37, .external_lex_state = 6},
  [1610] = {.lex_state = 37},
  [1611] = {.lex_state = 37, .external_lex_state = 2},
  [1612] = {.lex_state = 37, .external_lex_state = 2},
  [1613] = {.lex_state = 37},
  [1614] = {.lex_state = 37},
  [1615] = {.lex_state = 37},
  [1616] = {.lex_state = 39},
  [1617] = {.lex_state = 49, .external_lex_state = 6},
  [1618] = {.lex_state = 49, .external_lex_state = 6},
  [1619] = {.lex_state = 37},
  [1620] = {.lex_state = 37},
  [1621] = {.lex_state = 49, .external_lex_state = 6},
  [1622] = {.lex_state = 49, .external_lex_state = 6},
  [1623] = {.lex_state = 96},
  [1624] = {.lex_state = 49, .external_lex_state = 6},
  [1625] = {.lex_state = 49, .external_lex_state = 6},
  [1626] = {.lex_state = 49},
  [1627] = {.lex_state = 37},
  [1628] = {.lex_state = 49, .external_lex_state = 6},
  [1629] = {.lex_state = 49, .external_lex_state = 6},
  [1630] = {.lex_state = 49, .external_lex_state = 6},
  [1631] = {.lex_state = 96},
  [1632] = {.lex_state = 96},
  [1633] = {.lex_state = 49, .external_lex_state = 6},
  [1634] = {.lex_state = 49, .external_lex_state = 6},
  [1635] = {.lex_state = 49, .external_lex_state = 6},
  [1636] = {.lex_state = 47},
  [1637] = {.lex_state = 49, .external_lex_state = 6},
  [1638] = {.lex_state = 49},
  [1639] = {.lex_state = 49},
  [1640] = {.lex_state = 49},
  [1641] = {.lex_state = 49, .external_lex_state = 6},
  [1642] = {.lex_state = 49, .external_lex_state = 6},
  [1643] = {.lex_state = 49, .external_lex_state = 6},
  [1644] = {.lex_state = 49, .external_lex_state = 6},
  [1645] = {.lex_state = 37},
  [1646] = {.lex_state = 49, .external_lex_state = 6},
  [1647] = {.lex_state = 49, .external_lex_state = 6},
  [1648] = {.lex_state = 49, .external_lex_state = 6},
  [1649] = {.lex_state = 49, .external_lex_state = 6},
  [1650] = {.lex_state = 49, .external_lex_state = 6},
  [1651] = {.lex_state = 49, .external_lex_state = 6},
  [1652] = {.lex_state = 49, .external_lex_state = 6},
  [1653] = {.lex_state = 49, .external_lex_state = 6},
  [1654] = {.lex_state = 49, .external_lex_state = 6},
  [1655] = {.lex_state = 49, .external_lex_state = 6},
  [1656] = {.lex_state = 49, .external_lex_state = 6},
  [1657] = {.lex_state = 96},
  [1658] = {.lex_state = 37},
  [1659] = {.lex_state = 49, .external_lex_state = 6},
  [1660] = {.lex_state = 49, .external_lex_state = 6},
  [1661] = {.lex_state = 49, .external_lex_state = 6},
  [1662] = {.lex_state = 49, .external_lex_state = 6},
  [1663] = {.lex_state = 96},
  [1664] = {.lex_state = 49, .external_lex_state = 6},
  [1665] = {.lex_state = 49, .external_lex_state = 6},
  [1666] = {.lex_state = 49},
  [1667] = {.lex_state = 49, .external_lex_state = 6},
  [1668] = {.lex_state = 47},
  [1669] = {.lex_state = 49, .external_lex_state = 6},
  [1670] = {.lex_state = 96},
  [1671] = {.lex_state = 49},
  [1672] = {.lex_state = 49},
  [1673] = {.lex_state = 96},
  [1674] = {.lex_state = 49},
  [1675] = {.lex_state = 49},
  [1676] = {.lex_state = 49},
  [1677] = {.lex_state = 49},
  [1678] = {.lex_state = 49},
  [1679] = {.lex_state = 49},
  [1680] = {.lex_state = 49},
  [1681] = {.lex_state = 49},
  [1682] = {.lex_state = 49},
  [1683] = {.lex_state = 49},
  [1684] = {.lex_state = 96},
  [1685] = {.lex_state = 96},
  [1686] = {.lex_state = 37, .external_lex_state = 2},
  [1687] = {.lex_state = 37, .external_lex_state = 2},
  [1688] = {.lex_state = 37, .external_lex_state = 2},
  [1689] = {.lex_state = 49},
  [1690] = {.lex_state = 37, .external_lex_state = 2},
  [1691] = {.lex_state = 96},
  [1692] = {.lex_state = 37, .external_lex_state = 2},
  [1693] = {.lex_state = 96},
  [1694] = {.lex_state = 37},
  [1695] = {.lex_state = 37},
  [1696] = {.lex_state = 37},
  [1697] = {.lex_state = 37},
  [1698] = {.lex_state = 37},
  [1699] = {.lex_state = 49},
  [1700] = {.lex_state = 49},
  [1701] = {.lex_state = 49},
  [1702] = {.lex_state = 49},
  [1703] = {.lex_state = 49},
  [1704] = {.lex_state = 49},
  [1705] = {.lex_state = 49},
  [1706] = {.lex_state = 49},
  [1707] = {.lex_state = 49},
  [1708] = {.lex_state = 49},
  [1709] = {.lex_state = 49},
  [1710] = {.lex_state = 49},
  [1711] = {.lex_state = 49},
  [1712] = {.lex_state = 49},
  [1713] = {.lex_state = 49},
  [1714] = {.lex_state = 49},
  [1715] = {.lex_state = 49},
  [1716] = {.lex_state = 49},
  [1717] = {.lex_state = 49},
  [1718] = {.lex_state = 49},
  [1719] = {.lex_state = 49},
  [1720] = {.lex_state = 49},
  [1721] = {.lex_state = 49},
  [1722] = {.lex_state = 49},
  [1723] = {.lex_state = 49},
  [1724] = {.lex_state = 49},
  [1725] = {.lex_state = 49},
  [1726] = {.lex_state = 49},
  [1727] = {.lex_state = 49},
  [1728] = {.lex_state = 49},
  [1729] = {.lex_state = 49},
  [1730] = {.lex_state = 49},
  [1731] = {.lex_state = 49},
  [1732] = {.lex_state = 49},
  [1733] = {.lex_state = 49},
  [1734] = {.lex_state = 49},
  [1735] = {.lex_state = 49},
  [1736] = {.lex_state = 49},
  [1737] = {.lex_state = 49},
  [1738] = {.lex_state = 49},
  [1739] = {.lex_state = 49},
  [1740] = {.lex_state = 49},
  [1741] = {.lex_state = 49},
  [1742] = {.lex_state = 49},
  [1743] = {.lex_state = 49},
  [1744] = {.lex_state = 49},
  [1745] = {.lex_state = 49},
  [1746] = {.lex_state = 49},
  [1747] = {.lex_state = 49},
  [1748] = {.lex_state = 49},
  [1749] = {.lex_state = 49},
  [1750] = {.lex_state = 49},
  [1751] = {.lex_state = 49},
  [1752] = {.lex_state = 49},
  [1753] = {.lex_state = 49},
  [1754] = {.lex_state = 49},
  [1755] = {.lex_state = 49},
  [1756] = {.lex_state = 49},
  [1757] = {.lex_state = 49},
  [1758] = {.lex_state = 49},
  [1759] = {.lex_state = 49},
  [1760] = {.lex_state = 49},
  [1761] = {.lex_state = 49},
  [1762] = {.lex_state = 49},
  [1763] = {.lex_state = 49},
  [1764] = {.lex_state = 49},
  [1765] = {.lex_state = 49},
  [1766] = {.lex_state = 49},
  [1767] = {.lex_state = 49},
  [1768] = {.lex_state = 49},
  [1769] = {.lex_state = 49},
  [1770] = {.lex_state = 49},
  [1771] = {.lex_state = 49},
  [1772] = {.lex_state = 49},
  [1773] = {.lex_state = 49},
  [1774] = {.lex_state = 49},
  [1775] = {.lex_state = 49},
  [1776] = {.lex_state = 49},
  [1777] = {.lex_state = 49},
  [1778] = {.lex_state = 49},
  [1779] = {.lex_state = 49},
  [1780] = {.lex_state = 49},
  [1781] = {.lex_state = 49},
  [1782] = {.lex_state = 49},
  [1783] = {.lex_state = 49},
  [1784] = {.lex_state = 49},
  [1785] = {.lex_state = 49},
  [1786] = {.lex_state = 49},
  [1787] = {.lex_state = 49},
  [1788] = {.lex_state = 49},
  [1789] = {.lex_state = 49},
  [1790] = {.lex_state = 49},
  [1791] = {.lex_state = 49},
  [1792] = {.lex_state = 49},
  [1793] = {.lex_state = 49},
  [1794] = {.lex_state = 49},
  [1795] = {.lex_state = 49},
  [1796] = {.lex_state = 49},
  [1797] = {.lex_state = 49},
  [1798] = {.lex_state = 49},
  [1799] = {.lex_state = 49},
  [1800] = {.lex_state = 49},
  [1801] = {.lex_state = 49},
  [1802] = {.lex_state = 49},
  [1803] = {.lex_state = 49},
  [1804] = {.lex_state = 49},
  [1805] = {.lex_state = 49},
  [1806] = {.lex_state = 49},
  [1807] = {.lex_state = 49},
  [1808] = {.lex_state = 49},
  [1809] = {.lex_state = 49},
  [1810] = {.lex_state = 49},
  [1811] = {.lex_state = 49},
  [1812] = {.lex_state = 49},
  [1813] = {.lex_state = 49},
  [1814] = {.lex_state = 49},
  [1815] = {.lex_state = 49},
  [1816] = {.lex_state = 49},
  [1817] = {.lex_state = 49},
  [1818] = {.lex_state = 49},
  [1819] = {.lex_state = 49},
  [1820] = {.lex_state = 49},
  [1821] = {.lex_state = 49},
  [1822] = {.lex_state = 49},
  [1823] = {.lex_state = 49},
  [1824] = {.lex_state = 49},
  [1825] = {.lex_state = 49},
  [1826] = {.lex_state = 49},
  [1827] = {.lex_state = 49},
  [1828] = {.lex_state = 49},
  [1829] = {.lex_state = 49},
  [1830] = {.lex_state = 49},
  [1831] = {.lex_state = 49},
  [1832] = {.lex_state = 49},
  [1833] = {.lex_state = 49},
  [1834] = {.lex_state = 49},
  [1835] = {.lex_state = 49},
  [1836] = {.lex_state = 49},
  [1837] = {.lex_state = 44},
  [1838] = {.lex_state = 4, .external_lex_state = 2},
  [1839] = {.lex_state = 0},
  [1840] = {.lex_state = 4},
  [1841] = {.lex_state = 4, .external_lex_state = 2},
  [1842] = {.lex_state = 4},
  [1843] = {.lex_state = 0},
  [1844] = {.lex_state = 4, .external_lex_state = 2},
  [1845] = {.lex_state = 4, .external_lex_state = 2},
  [1846] = {.lex_state = 4, .external_lex_state = 2},
  [1847] = {.lex_state = 0},
  [1848] = {.lex_state = 4, .external_lex_state = 2},
  [1849] = {.lex_state = 96},
  [1850] = {.lex_state = 0},
  [1851] = {.lex_state = 4, .external_lex_state = 2},
  [1852] = {.lex_state = 4, .external_lex_state = 2},
  [1853] = {.lex_state = 0},
  [1854] = {.lex_state = 0},
  [1855] = {.lex_state = 4, .external_lex_state = 2},
  [1856] = {.lex_state = 4, .external_lex_state = 2},
  [1857] = {.lex_state = 53},
  [1858] = {.lex_state = 53},
  [1859] = {.lex_state = 53},
  [1860] = {.lex_state = 53},
  [1861] = {.lex_state = 4},
  [1862] = {.lex_state = 53},
  [1863] = {.lex_state = 53},
  [1864] = {.lex_state = 53},
  [1865] = {.lex_state = 4},
  [1866] = {.lex_state = 53},
  [1867] = {.lex_state = 53},
  [1868] = {.lex_state = 53},
  [1869] = {.lex_state = 53},
  [1870] = {.lex_state = 53},
  [1871] = {.lex_state = 53},
  [1872] = {.lex_state = 53},
  [1873] = {.lex_state = 53},
  [1874] = {.lex_state = 53},
  [1875] = {.lex_state = 53},
  [1876] = {.lex_state = 53},
  [1877] = {.lex_state = 53},
  [1878] = {.lex_state = 53},
  [1879] = {.lex_state = 4},
  [1880] = {.lex_state = 53},
  [1881] = {.lex_state = 53},
  [1882] = {.lex_state = 53},
  [1883] = {.lex_state = 4},
  [1884] = {.lex_state = 53},
  [1885] = {.lex_state = 53},
  [1886] = {.lex_state = 96},
  [1887] = {.lex_state = 96},
  [1888] = {.lex_state = 0},
  [1889] = {.lex_state = 96},
  [1890] = {.lex_state = 0},
  [1891] = {.lex_state = 0},
  [1892] = {.lex_state = 96},
  [1893] = {.lex_state = 96},
  [1894] = {.lex_state = 0},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 0},
  [1897] = {.lex_state = 0},
  [1898] = {.lex_state = 0},
  [1899] = {.lex_state = 96},
  [1900] = {.lex_state = 0},
  [1901] = {.lex_state = 96},
  [1902] = {.lex_state = 96},
  [1903] = {.lex_state = 96},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 0},
  [1906] = {.lex_state = 96},
  [1907] = {.lex_state = 0},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 0},
  [1910] = {.lex_state = 0},
  [1911] = {.lex_state = 96},
  [1912] = {.lex_state = 0},
  [1913] = {.lex_state = 0},
  [1914] = {.lex_state = 0},
  [1915] = {.lex_state = 96},
  [1916] = {.lex_state = 0},
  [1917] = {.lex_state = 53},
  [1918] = {.lex_state = 96},
  [1919] = {.lex_state = 96},
  [1920] = {.lex_state = 0},
  [1921] = {.lex_state = 96},
  [1922] = {.lex_state = 96},
  [1923] = {.lex_state = 59},
  [1924] = {.lex_state = 0},
  [1925] = {.lex_state = 96},
  [1926] = {.lex_state = 96},
  [1927] = {.lex_state = 59},
  [1928] = {.lex_state = 96},
  [1929] = {.lex_state = 53},
  [1930] = {.lex_state = 0},
  [1931] = {.lex_state = 96},
  [1932] = {.lex_state = 96},
  [1933] = {.lex_state = 96},
  [1934] = {.lex_state = 96},
  [1935] = {.lex_state = 0},
  [1936] = {.lex_state = 0},
  [1937] = {.lex_state = 96},
  [1938] = {.lex_state = 4, .external_lex_state = 2},
  [1939] = {.lex_state = 0},
  [1940] = {.lex_state = 4, .external_lex_state = 2},
  [1941] = {.lex_state = 0},
  [1942] = {.lex_state = 0},
  [1943] = {.lex_state = 0},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 0},
  [1946] = {.lex_state = 4, .external_lex_state = 2},
  [1947] = {.lex_state = 0},
  [1948] = {.lex_state = 4, .external_lex_state = 2},
  [1949] = {.lex_state = 0},
  [1950] = {.lex_state = 0},
  [1951] = {.lex_state = 0},
  [1952] = {.lex_state = 0},
  [1953] = {.lex_state = 0},
  [1954] = {.lex_state = 0},
  [1955] = {.lex_state = 4, .external_lex_state = 2},
  [1956] = {.lex_state = 0},
  [1957] = {.lex_state = 0},
  [1958] = {.lex_state = 0},
  [1959] = {.lex_state = 0},
  [1960] = {.lex_state = 53},
  [1961] = {.lex_state = 0},
  [1962] = {.lex_state = 4, .external_lex_state = 2},
  [1963] = {.lex_state = 0},
  [1964] = {.lex_state = 0},
  [1965] = {.lex_state = 4, .external_lex_state = 2},
  [1966] = {.lex_state = 0},
  [1967] = {.lex_state = 0},
  [1968] = {.lex_state = 0},
  [1969] = {.lex_state = 0},
  [1970] = {.lex_state = 0},
  [1971] = {.lex_state = 0},
  [1972] = {.lex_state = 4, .external_lex_state = 2},
  [1973] = {.lex_state = 0},
  [1974] = {.lex_state = 0},
  [1975] = {.lex_state = 0},
  [1976] = {.lex_state = 0},
  [1977] = {.lex_state = 50},
  [1978] = {.lex_state = 50},
  [1979] = {.lex_state = 0},
  [1980] = {.lex_state = 50},
  [1981] = {.lex_state = 4},
  [1982] = {.lex_state = 50},
  [1983] = {.lex_state = 50},
  [1984] = {.lex_state = 59},
  [1985] = {.lex_state = 0},
  [1986] = {.lex_state = 50},
  [1987] = {.lex_state = 50},
  [1988] = {.lex_state = 0},
  [1989] = {.lex_state = 4},
  [1990] = {.lex_state = 50},
  [1991] = {.lex_state = 50},
  [1992] = {.lex_state = 50},
  [1993] = {.lex_state = 0},
  [1994] = {.lex_state = 50},
  [1995] = {.lex_state = 50},
  [1996] = {.lex_state = 53},
  [1997] = {.lex_state = 50},
  [1998] = {.lex_state = 50},
  [1999] = {.lex_state = 50},
  [2000] = {.lex_state = 50},
  [2001] = {.lex_state = 50},
  [2002] = {.lex_state = 50},
  [2003] = {.lex_state = 50},
  [2004] = {.lex_state = 0},
  [2005] = {.lex_state = 4},
  [2006] = {.lex_state = 0},
  [2007] = {.lex_state = 50},
  [2008] = {.lex_state = 50},
  [2009] = {.lex_state = 0},
  [2010] = {.lex_state = 4},
  [2011] = {.lex_state = 96},
  [2012] = {.lex_state = 96},
  [2013] = {.lex_state = 96},
  [2014] = {.lex_state = 96},
  [2015] = {.lex_state = 0},
  [2016] = {.lex_state = 0},
  [2017] = {.lex_state = 0},
  [2018] = {.lex_state = 96},
  [2019] = {.lex_state = 0},
  [2020] = {.lex_state = 0},
  [2021] = {.lex_state = 0},
  [2022] = {.lex_state = 0},
  [2023] = {.lex_state = 96},
  [2024] = {.lex_state = 0},
  [2025] = {.lex_state = 0},
  [2026] = {.lex_state = 0},
  [2027] = {.lex_state = 0},
  [2028] = {.lex_state = 56},
  [2029] = {.lex_state = 96},
  [2030] = {.lex_state = 0},
  [2031] = {.lex_state = 56},
  [2032] = {.lex_state = 0},
  [2033] = {.lex_state = 0},
  [2034] = {.lex_state = 0},
  [2035] = {.lex_state = 0},
  [2036] = {.lex_state = 0},
  [2037] = {.lex_state = 96},
  [2038] = {.lex_state = 0},
  [2039] = {.lex_state = 0},
  [2040] = {.lex_state = 96},
  [2041] = {.lex_state = 96},
  [2042] = {.lex_state = 0},
  [2043] = {.lex_state = 0},
  [2044] = {.lex_state = 0},
  [2045] = {.lex_state = 96, .external_lex_state = 7},
  [2046] = {.lex_state = 96, .external_lex_state = 7},
  [2047] = {.lex_state = 0},
  [2048] = {.lex_state = 0},
  [2049] = {.lex_state = 0},
  [2050] = {.lex_state = 0},
  [2051] = {.lex_state = 0},
  [2052] = {.lex_state = 96, .external_lex_state = 7},
  [2053] = {.lex_state = 96},
  [2054] = {.lex_state = 96, .external_lex_state = 7},
  [2055] = {.lex_state = 96, .external_lex_state = 7},
  [2056] = {.lex_state = 96, .external_lex_state = 7},
  [2057] = {.lex_state = 96, .external_lex_state = 7},
  [2058] = {.lex_state = 96, .external_lex_state = 7},
  [2059] = {.lex_state = 0},
  [2060] = {.lex_state = 96, .external_lex_state = 7},
  [2061] = {.lex_state = 96, .external_lex_state = 7},
  [2062] = {.lex_state = 96, .external_lex_state = 7},
  [2063] = {.lex_state = 96, .external_lex_state = 7},
  [2064] = {.lex_state = 96, .external_lex_state = 7},
  [2065] = {.lex_state = 96, .external_lex_state = 7},
  [2066] = {.lex_state = 96, .external_lex_state = 7},
  [2067] = {.lex_state = 96},
  [2068] = {.lex_state = 96},
  [2069] = {.lex_state = 0, .external_lex_state = 8},
  [2070] = {.lex_state = 0},
  [2071] = {.lex_state = 0},
  [2072] = {.lex_state = 0},
  [2073] = {.lex_state = 0},
  [2074] = {.lex_state = 0},
  [2075] = {.lex_state = 0, .external_lex_state = 8},
  [2076] = {.lex_state = 96},
  [2077] = {.lex_state = 0},
  [2078] = {.lex_state = 0},
  [2079] = {.lex_state = 0},
  [2080] = {.lex_state = 0},
  [2081] = {.lex_state = 0, .external_lex_state = 8},
  [2082] = {.lex_state = 0},
  [2083] = {.lex_state = 0},
  [2084] = {.lex_state = 0},
  [2085] = {.lex_state = 0},
  [2086] = {.lex_state = 0, .external_lex_state = 8},
  [2087] = {.lex_state = 0},
  [2088] = {.lex_state = 53},
  [2089] = {.lex_state = 0},
  [2090] = {.lex_state = 0},
  [2091] = {.lex_state = 44},
  [2092] = {.lex_state = 0},
  [2093] = {.lex_state = 0, .external_lex_state = 8},
  [2094] = {.lex_state = 0},
  [2095] = {.lex_state = 0},
  [2096] = {.lex_state = 0},
  [2097] = {.lex_state = 96},
  [2098] = {.lex_state = 0},
  [2099] = {.lex_state = 0, .external_lex_state = 8},
  [2100] = {.lex_state = 0},
  [2101] = {.lex_state = 0},
  [2102] = {.lex_state = 0},
  [2103] = {.lex_state = 0},
  [2104] = {.lex_state = 0},
  [2105] = {.lex_state = 0, .external_lex_state = 8},
  [2106] = {.lex_state = 0},
  [2107] = {.lex_state = 0},
  [2108] = {.lex_state = 0, .external_lex_state = 8},
  [2109] = {.lex_state = 0, .external_lex_state = 8},
  [2110] = {.lex_state = 0, .external_lex_state = 8},
  [2111] = {.lex_state = 0, .external_lex_state = 8},
  [2112] = {.lex_state = 0, .external_lex_state = 8},
  [2113] = {.lex_state = 0, .external_lex_state = 8},
  [2114] = {.lex_state = 96},
  [2115] = {.lex_state = 96},
  [2116] = {.lex_state = 96},
  [2117] = {.lex_state = 0, .external_lex_state = 7},
  [2118] = {.lex_state = 96},
  [2119] = {.lex_state = 0},
  [2120] = {.lex_state = 96},
  [2121] = {.lex_state = 96},
  [2122] = {.lex_state = 96},
  [2123] = {.lex_state = 0},
  [2124] = {.lex_state = 0},
  [2125] = {.lex_state = 0},
  [2126] = {.lex_state = 53},
  [2127] = {.lex_state = 44},
  [2128] = {.lex_state = 96},
  [2129] = {.lex_state = 53},
  [2130] = {.lex_state = 0},
  [2131] = {.lex_state = 0, .external_lex_state = 8},
  [2132] = {.lex_state = 0},
  [2133] = {.lex_state = 0},
  [2134] = {.lex_state = 0},
  [2135] = {.lex_state = 0},
  [2136] = {.lex_state = 0},
  [2137] = {.lex_state = 0},
  [2138] = {.lex_state = 0, .external_lex_state = 8},
  [2139] = {.lex_state = 0},
  [2140] = {.lex_state = 0},
  [2141] = {.lex_state = 96},
  [2142] = {.lex_state = 0},
  [2143] = {.lex_state = 96},
  [2144] = {.lex_state = 53},
  [2145] = {.lex_state = 53},
  [2146] = {.lex_state = 0, .external_lex_state = 8},
  [2147] = {.lex_state = 0},
  [2148] = {.lex_state = 0},
  [2149] = {.lex_state = 0},
  [2150] = {.lex_state = 0},
  [2151] = {.lex_state = 0},
  [2152] = {.lex_state = 0},
  [2153] = {.lex_state = 0},
  [2154] = {.lex_state = 0},
  [2155] = {.lex_state = 0},
  [2156] = {.lex_state = 4},
  [2157] = {.lex_state = 53},
  [2158] = {.lex_state = 0, .external_lex_state = 7},
  [2159] = {.lex_state = 0},
  [2160] = {.lex_state = 96},
  [2161] = {.lex_state = 0},
  [2162] = {.lex_state = 0, .external_lex_state = 8},
  [2163] = {.lex_state = 53},
  [2164] = {.lex_state = 96},
  [2165] = {.lex_state = 96},
  [2166] = {.lex_state = 0},
  [2167] = {.lex_state = 0},
  [2168] = {.lex_state = 0},
  [2169] = {.lex_state = 96},
  [2170] = {.lex_state = 96},
  [2171] = {.lex_state = 0},
  [2172] = {.lex_state = 0},
  [2173] = {.lex_state = 53},
  [2174] = {.lex_state = 96},
  [2175] = {.lex_state = 53},
  [2176] = {.lex_state = 96},
  [2177] = {.lex_state = 0},
  [2178] = {.lex_state = 0},
  [2179] = {.lex_state = 53},
  [2180] = {.lex_state = 96},
  [2181] = {.lex_state = 0},
  [2182] = {.lex_state = 0, .external_lex_state = 7},
  [2183] = {.lex_state = 0},
  [2184] = {.lex_state = 96},
  [2185] = {.lex_state = 96},
  [2186] = {.lex_state = 96},
  [2187] = {.lex_state = 0},
  [2188] = {.lex_state = 0, .external_lex_state = 7},
  [2189] = {.lex_state = 53},
  [2190] = {.lex_state = 53},
  [2191] = {.lex_state = 96},
  [2192] = {.lex_state = 0},
  [2193] = {.lex_state = 0},
  [2194] = {.lex_state = 189},
  [2195] = {.lex_state = 53},
  [2196] = {.lex_state = 53},
  [2197] = {.lex_state = 96},
  [2198] = {.lex_state = 96},
  [2199] = {.lex_state = 0},
  [2200] = {.lex_state = 0},
  [2201] = {.lex_state = 0},
  [2202] = {.lex_state = 53},
  [2203] = {.lex_state = 96},
  [2204] = {.lex_state = 96},
  [2205] = {.lex_state = 96},
  [2206] = {.lex_state = 0},
  [2207] = {.lex_state = 96},
  [2208] = {.lex_state = 0},
  [2209] = {.lex_state = 96},
  [2210] = {.lex_state = 96},
  [2211] = {.lex_state = 0},
  [2212] = {.lex_state = 96},
  [2213] = {.lex_state = 96},
  [2214] = {.lex_state = 0},
  [2215] = {.lex_state = 0, .external_lex_state = 7},
  [2216] = {.lex_state = 0},
  [2217] = {.lex_state = 0},
  [2218] = {.lex_state = 0},
  [2219] = {.lex_state = 0},
  [2220] = {.lex_state = 53},
  [2221] = {.lex_state = 96},
  [2222] = {.lex_state = 0},
  [2223] = {.lex_state = 0, .external_lex_state = 7},
  [2224] = {.lex_state = 189},
  [2225] = {.lex_state = 96},
  [2226] = {.lex_state = 53},
  [2227] = {.lex_state = 0, .external_lex_state = 7},
  [2228] = {.lex_state = 96},
  [2229] = {.lex_state = 0},
  [2230] = {.lex_state = 0, .external_lex_state = 7},
  [2231] = {.lex_state = 96},
  [2232] = {.lex_state = 53},
  [2233] = {.lex_state = 0, .external_lex_state = 7},
  [2234] = {.lex_state = 96},
  [2235] = {.lex_state = 0},
  [2236] = {.lex_state = 0, .external_lex_state = 7},
  [2237] = {.lex_state = 96},
  [2238] = {.lex_state = 53},
  [2239] = {.lex_state = 0, .external_lex_state = 7},
  [2240] = {.lex_state = 96},
  [2241] = {.lex_state = 0},
  [2242] = {.lex_state = 0, .external_lex_state = 7},
  [2243] = {.lex_state = 96},
  [2244] = {.lex_state = 53},
  [2245] = {.lex_state = 0, .external_lex_state = 7},
  [2246] = {.lex_state = 96},
  [2247] = {.lex_state = 0, .external_lex_state = 8},
  [2248] = {.lex_state = 0, .external_lex_state = 7},
  [2249] = {.lex_state = 96},
  [2250] = {.lex_state = 53},
  [2251] = {.lex_state = 0, .external_lex_state = 7},
  [2252] = {.lex_state = 96},
  [2253] = {.lex_state = 0},
  [2254] = {.lex_state = 0, .external_lex_state = 7},
  [2255] = {.lex_state = 96},
  [2256] = {.lex_state = 96},
  [2257] = {.lex_state = 96},
  [2258] = {.lex_state = 96},
  [2259] = {.lex_state = 96},
  [2260] = {.lex_state = 96},
  [2261] = {.lex_state = 96},
  [2262] = {.lex_state = 96},
  [2263] = {.lex_state = 0},
  [2264] = {.lex_state = 0},
  [2265] = {.lex_state = 53},
  [2266] = {.lex_state = 53},
  [2267] = {.lex_state = 53},
  [2268] = {.lex_state = 0},
  [2269] = {.lex_state = 53},
  [2270] = {.lex_state = 0},
  [2271] = {.lex_state = 0},
  [2272] = {.lex_state = 96},
  [2273] = {.lex_state = 96},
  [2274] = {.lex_state = 96},
  [2275] = {.lex_state = 0},
  [2276] = {.lex_state = 0, .external_lex_state = 8},
  [2277] = {.lex_state = 0},
  [2278] = {.lex_state = 0},
  [2279] = {.lex_state = 96},
  [2280] = {.lex_state = 96},
  [2281] = {.lex_state = 96},
  [2282] = {.lex_state = 0},
  [2283] = {.lex_state = 96},
  [2284] = {.lex_state = 0},
  [2285] = {.lex_state = 0},
  [2286] = {.lex_state = 96},
  [2287] = {.lex_state = 96},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_BEGIN] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(1),
    [anon_sym_BEGINFILE] = ACTIONS(1),
    [anon_sym_ENDFILE] = ACTIONS(1),
    [anon_sym_ATinclude] = ACTIONS(1),
    [anon_sym_ATload] = ACTIONS(1),
    [anon_sym_ATnamespace] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [sym_break_statement] = ACTIONS(1),
    [sym_continue_statement] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_exit] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_getline] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym_next_statement] = ACTIONS(1),
    [sym_nextfile_statement] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_printf] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [anon_sym_alnum] = ACTIONS(1),
    [anon_sym_alpha] = ACTIONS(1),
    [anon_sym_blank] = ACTIONS(1),
    [anon_sym_cntrl] = ACTIONS(1),
    [anon_sym_digit] = ACTIONS(1),
    [anon_sym_graph] = ACTIONS(1),
    [anon_sym_lower] = ACTIONS(1),
    [anon_sym_punct] = ACTIONS(1),
    [anon_sym_space] = ACTIONS(1),
    [anon_sym_upper] = ACTIONS(1),
    [anon_sym_xdigit] = ACTIONS(1),
    [anon_sym_RBRACK2] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [aux_sym_number_token1] = ACTIONS(1),
    [aux_sym_number_token2] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_func] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [sym_concatenating_space] = ACTIONS(1),
    [sym__if_else_separator] = ACTIONS(1),
    [sym__no_space] = ACTIONS(1),
    [sym__func_call] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2217),
    [sym_rule] = STATE(301),
    [sym_pattern] = STATE(1632),
    [sym_range_pattern] = STATE(1685),
    [sym__special_pattern] = STATE(1685),
    [sym_directive] = STATE(301),
    [sym__getline_exp] = STATE(596),
    [sym_getline_input] = STATE(596),
    [sym_getline_file] = STATE(596),
    [sym_block] = STATE(1693),
    [sym__exp] = STATE(596),
    [sym_ternary_exp] = STATE(567),
    [sym_binary_exp] = STATE(567),
    [sym__binary_in] = STATE(588),
    [sym_unary_exp] = STATE(567),
    [sym_update_exp] = STATE(596),
    [sym_assignment_exp] = STATE(596),
    [sym_piped_io_exp] = STATE(596),
    [sym_string_concat] = STATE(567),
    [sym_field_ref] = STATE(519),
    [sym_array_ref] = STATE(483),
    [sym_regex] = STATE(596),
    [sym_regex_constant] = STATE(596),
    [sym_grouping] = STATE(567),
    [sym__primitive] = STATE(567),
    [sym_namespace] = STATE(2209),
    [sym_ns_qualified_name] = STATE(448),
    [sym_number] = STATE(567),
    [sym_string] = STATE(567),
    [sym_func_def] = STATE(301),
    [sym_func_call] = STATE(567),
    [sym_indirect_func_call] = STATE(596),
    [sym_comment] = STATE(301),
    [aux_sym_program_repeat1] = STATE(301),
    [ts_builtin_sym_end] = ACTIONS(3),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BEGIN] = ACTIONS(7),
    [anon_sym_END] = ACTIONS(7),
    [anon_sym_BEGINFILE] = ACTIONS(7),
    [anon_sym_ENDFILE] = ACTIONS(7),
    [anon_sym_ATinclude] = ACTIONS(9),
    [anon_sym_ATload] = ACTIONS(9),
    [anon_sym_ATnamespace] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_getline] = ACTIONS(15),
    [anon_sym_SLASH] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(23),
    [anon_sym_DASH_DASH] = ACTIONS(23),
    [anon_sym_DOLLAR] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(27),
    [aux_sym_number_token1] = ACTIONS(29),
    [aux_sym_number_token2] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_function] = ACTIONS(35),
    [anon_sym_func] = ACTIONS(35),
    [anon_sym_POUND] = ACTIONS(37),
  },
  [2] = {
    [sym__statement] = STATE(1221),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1221),
    [sym_if_statement] = STATE(1221),
    [sym_while_statement] = STATE(1221),
    [sym_do_while_statement] = STATE(1221),
    [sym_for_statement] = STATE(1221),
    [sym_for_in_statement] = STATE(1221),
    [sym_delete_statement] = STATE(1221),
    [sym_exit_statement] = STATE(1221),
    [sym_return_statement] = STATE(1221),
    [sym_switch_statement] = STATE(1221),
    [sym__io_statement] = STATE(1221),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1221),
    [sym_piped_io_statement] = STATE(1221),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(41),
    [anon_sym_LF] = ACTIONS(41),
    [anon_sym_CR_LF] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(53),
    [sym_continue_statement] = ACTIONS(53),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_RBRACE] = ACTIONS(41),
    [anon_sym_case] = ACTIONS(41),
    [anon_sym_default] = ACTIONS(41),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(53),
    [sym_nextfile_statement] = ACTIONS(53),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DOLLAR] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_POUND] = ACTIONS(41),
    [sym__if_else_separator] = ACTIONS(83),
  },
  [3] = {
    [sym__statement] = STATE(1410),
    [sym__statement_separated] = STATE(1410),
    [sym__control_statement] = STATE(1410),
    [sym_if_statement] = STATE(1410),
    [sym_while_statement] = STATE(1410),
    [sym_do_while_statement] = STATE(1410),
    [sym_for_statement] = STATE(1410),
    [sym_for_in_statement] = STATE(1410),
    [sym_delete_statement] = STATE(1410),
    [sym_exit_statement] = STATE(1410),
    [sym_return_statement] = STATE(1410),
    [sym_switch_statement] = STATE(1410),
    [sym__io_statement] = STATE(1410),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1410),
    [sym_piped_io_statement] = STATE(1410),
    [sym_block] = STATE(3),
    [sym__block_content] = STATE(3),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(3),
    [aux_sym_block_repeat1] = STATE(3),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(88),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(94),
    [anon_sym_do] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(100),
    [sym_break_statement] = ACTIONS(103),
    [sym_continue_statement] = ACTIONS(103),
    [anon_sym_delete] = ACTIONS(106),
    [anon_sym_exit] = ACTIONS(109),
    [anon_sym_return] = ACTIONS(112),
    [anon_sym_switch] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(121),
    [anon_sym_getline] = ACTIONS(123),
    [sym_next_statement] = ACTIONS(103),
    [sym_nextfile_statement] = ACTIONS(103),
    [anon_sym_print] = ACTIONS(126),
    [anon_sym_printf] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_PLUS_PLUS] = ACTIONS(141),
    [anon_sym_DASH_DASH] = ACTIONS(141),
    [anon_sym_DOLLAR] = ACTIONS(144),
    [anon_sym_AT] = ACTIONS(147),
    [aux_sym_number_token1] = ACTIONS(150),
    [aux_sym_number_token2] = ACTIONS(153),
    [anon_sym_DQUOTE] = ACTIONS(156),
    [anon_sym_POUND] = ACTIONS(159),
  },
  [4] = {
    [sym__statement] = STATE(1410),
    [sym__statement_separated] = STATE(1410),
    [sym__control_statement] = STATE(1410),
    [sym_if_statement] = STATE(1410),
    [sym_while_statement] = STATE(1410),
    [sym_do_while_statement] = STATE(1410),
    [sym_for_statement] = STATE(1410),
    [sym_for_in_statement] = STATE(1410),
    [sym_delete_statement] = STATE(1410),
    [sym_exit_statement] = STATE(1410),
    [sym_return_statement] = STATE(1410),
    [sym_switch_statement] = STATE(1410),
    [sym__io_statement] = STATE(1410),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1410),
    [sym_piped_io_statement] = STATE(1410),
    [sym_block] = STATE(9),
    [sym__block_content] = STATE(9),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(9),
    [aux_sym_block_repeat1] = STATE(9),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(174),
    [sym_continue_statement] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_RBRACE] = ACTIONS(186),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(174),
    [sym_nextfile_statement] = ACTIONS(174),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [5] = {
    [sym__statement] = STATE(1410),
    [sym__statement_separated] = STATE(1410),
    [sym__control_statement] = STATE(1410),
    [sym_if_statement] = STATE(1410),
    [sym_while_statement] = STATE(1410),
    [sym_do_while_statement] = STATE(1410),
    [sym_for_statement] = STATE(1410),
    [sym_for_in_statement] = STATE(1410),
    [sym_delete_statement] = STATE(1410),
    [sym_exit_statement] = STATE(1410),
    [sym_return_statement] = STATE(1410),
    [sym_switch_statement] = STATE(1410),
    [sym__io_statement] = STATE(1410),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1410),
    [sym_piped_io_statement] = STATE(1410),
    [sym_block] = STATE(3),
    [sym__block_content] = STATE(3),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(3),
    [aux_sym_block_repeat1] = STATE(3),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(174),
    [sym_continue_statement] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_RBRACE] = ACTIONS(214),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(174),
    [sym_nextfile_statement] = ACTIONS(174),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [6] = {
    [sym__statement] = STATE(1410),
    [sym__statement_separated] = STATE(1410),
    [sym__control_statement] = STATE(1410),
    [sym_if_statement] = STATE(1410),
    [sym_while_statement] = STATE(1410),
    [sym_do_while_statement] = STATE(1410),
    [sym_for_statement] = STATE(1410),
    [sym_for_in_statement] = STATE(1410),
    [sym_delete_statement] = STATE(1410),
    [sym_exit_statement] = STATE(1410),
    [sym_return_statement] = STATE(1410),
    [sym_switch_statement] = STATE(1410),
    [sym__io_statement] = STATE(1410),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1410),
    [sym_piped_io_statement] = STATE(1410),
    [sym_block] = STATE(12),
    [sym__block_content] = STATE(12),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(12),
    [aux_sym_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(174),
    [sym_continue_statement] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(174),
    [sym_nextfile_statement] = ACTIONS(174),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [7] = {
    [sym__statement] = STATE(1410),
    [sym__statement_separated] = STATE(1410),
    [sym__control_statement] = STATE(1410),
    [sym_if_statement] = STATE(1410),
    [sym_while_statement] = STATE(1410),
    [sym_do_while_statement] = STATE(1410),
    [sym_for_statement] = STATE(1410),
    [sym_for_in_statement] = STATE(1410),
    [sym_delete_statement] = STATE(1410),
    [sym_exit_statement] = STATE(1410),
    [sym_return_statement] = STATE(1410),
    [sym_switch_statement] = STATE(1410),
    [sym__io_statement] = STATE(1410),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1410),
    [sym_piped_io_statement] = STATE(1410),
    [sym_block] = STATE(5),
    [sym__block_content] = STATE(5),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(5),
    [aux_sym_block_repeat1] = STATE(5),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(174),
    [sym_continue_statement] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_RBRACE] = ACTIONS(218),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(174),
    [sym_nextfile_statement] = ACTIONS(174),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [8] = {
    [sym__statement] = STATE(1410),
    [sym__statement_separated] = STATE(1410),
    [sym__control_statement] = STATE(1410),
    [sym_if_statement] = STATE(1410),
    [sym_while_statement] = STATE(1410),
    [sym_do_while_statement] = STATE(1410),
    [sym_for_statement] = STATE(1410),
    [sym_for_in_statement] = STATE(1410),
    [sym_delete_statement] = STATE(1410),
    [sym_exit_statement] = STATE(1410),
    [sym_return_statement] = STATE(1410),
    [sym_switch_statement] = STATE(1410),
    [sym__io_statement] = STATE(1410),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1410),
    [sym_piped_io_statement] = STATE(1410),
    [sym_block] = STATE(11),
    [sym__block_content] = STATE(11),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(11),
    [aux_sym_block_repeat1] = STATE(11),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(174),
    [sym_continue_statement] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_RBRACE] = ACTIONS(220),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(174),
    [sym_nextfile_statement] = ACTIONS(174),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [9] = {
    [sym__statement] = STATE(1410),
    [sym__statement_separated] = STATE(1410),
    [sym__control_statement] = STATE(1410),
    [sym_if_statement] = STATE(1410),
    [sym_while_statement] = STATE(1410),
    [sym_do_while_statement] = STATE(1410),
    [sym_for_statement] = STATE(1410),
    [sym_for_in_statement] = STATE(1410),
    [sym_delete_statement] = STATE(1410),
    [sym_exit_statement] = STATE(1410),
    [sym_return_statement] = STATE(1410),
    [sym_switch_statement] = STATE(1410),
    [sym__io_statement] = STATE(1410),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1410),
    [sym_piped_io_statement] = STATE(1410),
    [sym_block] = STATE(3),
    [sym__block_content] = STATE(3),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(3),
    [aux_sym_block_repeat1] = STATE(3),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(174),
    [sym_continue_statement] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_RBRACE] = ACTIONS(222),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(174),
    [sym_nextfile_statement] = ACTIONS(174),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [10] = {
    [sym__statement] = STATE(1320),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1320),
    [sym_if_statement] = STATE(1320),
    [sym_while_statement] = STATE(1320),
    [sym_do_while_statement] = STATE(1320),
    [sym_for_statement] = STATE(1320),
    [sym_for_in_statement] = STATE(1320),
    [sym_delete_statement] = STATE(1320),
    [sym_exit_statement] = STATE(1320),
    [sym_return_statement] = STATE(1320),
    [sym_switch_statement] = STATE(1320),
    [sym__io_statement] = STATE(1320),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1320),
    [sym_piped_io_statement] = STATE(1320),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(41),
    [anon_sym_LF] = ACTIONS(41),
    [anon_sym_CR_LF] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(234),
    [sym_continue_statement] = ACTIONS(234),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_RBRACE] = ACTIONS(41),
    [anon_sym_case] = ACTIONS(41),
    [anon_sym_default] = ACTIONS(41),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(234),
    [sym_nextfile_statement] = ACTIONS(234),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(246),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(248),
    [anon_sym_PLUS_PLUS] = ACTIONS(250),
    [anon_sym_DASH_DASH] = ACTIONS(250),
    [anon_sym_DOLLAR] = ACTIONS(252),
    [anon_sym_AT] = ACTIONS(254),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(258),
    [anon_sym_POUND] = ACTIONS(41),
  },
  [11] = {
    [sym__statement] = STATE(1410),
    [sym__statement_separated] = STATE(1410),
    [sym__control_statement] = STATE(1410),
    [sym_if_statement] = STATE(1410),
    [sym_while_statement] = STATE(1410),
    [sym_do_while_statement] = STATE(1410),
    [sym_for_statement] = STATE(1410),
    [sym_for_in_statement] = STATE(1410),
    [sym_delete_statement] = STATE(1410),
    [sym_exit_statement] = STATE(1410),
    [sym_return_statement] = STATE(1410),
    [sym_switch_statement] = STATE(1410),
    [sym__io_statement] = STATE(1410),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1410),
    [sym_piped_io_statement] = STATE(1410),
    [sym_block] = STATE(3),
    [sym__block_content] = STATE(3),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(3),
    [aux_sym_block_repeat1] = STATE(3),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(174),
    [sym_continue_statement] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_RBRACE] = ACTIONS(260),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(174),
    [sym_nextfile_statement] = ACTIONS(174),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [12] = {
    [sym__statement] = STATE(1410),
    [sym__statement_separated] = STATE(1410),
    [sym__control_statement] = STATE(1410),
    [sym_if_statement] = STATE(1410),
    [sym_while_statement] = STATE(1410),
    [sym_do_while_statement] = STATE(1410),
    [sym_for_statement] = STATE(1410),
    [sym_for_in_statement] = STATE(1410),
    [sym_delete_statement] = STATE(1410),
    [sym_exit_statement] = STATE(1410),
    [sym_return_statement] = STATE(1410),
    [sym_switch_statement] = STATE(1410),
    [sym__io_statement] = STATE(1410),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1410),
    [sym_piped_io_statement] = STATE(1410),
    [sym_block] = STATE(3),
    [sym__block_content] = STATE(3),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(3),
    [aux_sym_block_repeat1] = STATE(3),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(174),
    [sym_continue_statement] = ACTIONS(174),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_RBRACE] = ACTIONS(262),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(174),
    [sym_nextfile_statement] = ACTIONS(174),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [13] = {
    [sym__statement] = STATE(1359),
    [sym__statement_separated] = STATE(1359),
    [sym__control_statement] = STATE(1359),
    [sym_if_statement] = STATE(1359),
    [sym_while_statement] = STATE(1359),
    [sym_do_while_statement] = STATE(1359),
    [sym_for_statement] = STATE(1359),
    [sym_for_in_statement] = STATE(1359),
    [sym_delete_statement] = STATE(1359),
    [sym_exit_statement] = STATE(1359),
    [sym_return_statement] = STATE(1359),
    [sym_switch_statement] = STATE(1359),
    [sym__io_statement] = STATE(1359),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1359),
    [sym_piped_io_statement] = STATE(1359),
    [sym_block] = STATE(1358),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(71),
    [aux_sym_if_statement_repeat1] = STATE(71),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(264),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(266),
    [sym_continue_statement] = ACTIONS(266),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(266),
    [sym_nextfile_statement] = ACTIONS(266),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [14] = {
    [sym__statement] = STATE(1366),
    [sym__statement_separated] = STATE(1366),
    [sym__control_statement] = STATE(1366),
    [sym_if_statement] = STATE(1366),
    [sym_while_statement] = STATE(1366),
    [sym_do_while_statement] = STATE(1366),
    [sym_for_statement] = STATE(1366),
    [sym_for_in_statement] = STATE(1366),
    [sym_delete_statement] = STATE(1366),
    [sym_exit_statement] = STATE(1366),
    [sym_return_statement] = STATE(1366),
    [sym_switch_statement] = STATE(1366),
    [sym__io_statement] = STATE(1366),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1366),
    [sym_piped_io_statement] = STATE(1366),
    [sym_block] = STATE(1364),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(270),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(272),
    [sym_continue_statement] = ACTIONS(272),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(272),
    [sym_nextfile_statement] = ACTIONS(272),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [15] = {
    [sym__statement] = STATE(1361),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_do_while_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_for_in_statement] = STATE(1361),
    [sym_delete_statement] = STATE(1361),
    [sym_exit_statement] = STATE(1361),
    [sym_return_statement] = STATE(1361),
    [sym_switch_statement] = STATE(1361),
    [sym__io_statement] = STATE(1361),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1361),
    [sym_piped_io_statement] = STATE(1361),
    [sym_block] = STATE(1362),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(274),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(278),
    [sym_continue_statement] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(278),
    [sym_nextfile_statement] = ACTIONS(278),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [16] = {
    [sym__statement] = STATE(1363),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1363),
    [sym_if_statement] = STATE(1363),
    [sym_while_statement] = STATE(1363),
    [sym_do_while_statement] = STATE(1363),
    [sym_for_statement] = STATE(1363),
    [sym_for_in_statement] = STATE(1363),
    [sym_delete_statement] = STATE(1363),
    [sym_exit_statement] = STATE(1363),
    [sym_return_statement] = STATE(1363),
    [sym_switch_statement] = STATE(1363),
    [sym__io_statement] = STATE(1363),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1363),
    [sym_piped_io_statement] = STATE(1363),
    [sym_block] = STATE(1365),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(294),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(296),
    [sym_continue_statement] = ACTIONS(296),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(296),
    [sym_nextfile_statement] = ACTIONS(296),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [17] = {
    [sym__statement] = STATE(1369),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1369),
    [sym_if_statement] = STATE(1369),
    [sym_while_statement] = STATE(1369),
    [sym_do_while_statement] = STATE(1369),
    [sym_for_statement] = STATE(1369),
    [sym_for_in_statement] = STATE(1369),
    [sym_delete_statement] = STATE(1369),
    [sym_exit_statement] = STATE(1369),
    [sym_return_statement] = STATE(1369),
    [sym_switch_statement] = STATE(1369),
    [sym__io_statement] = STATE(1369),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1369),
    [sym_piped_io_statement] = STATE(1369),
    [sym_block] = STATE(1371),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(110),
    [aux_sym_if_statement_repeat1] = STATE(110),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(300),
    [sym_continue_statement] = ACTIONS(300),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(300),
    [sym_nextfile_statement] = ACTIONS(300),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [18] = {
    [sym__statement] = STATE(1276),
    [sym__statement_separated] = STATE(1276),
    [sym__control_statement] = STATE(1276),
    [sym_if_statement] = STATE(1276),
    [sym_while_statement] = STATE(1276),
    [sym_do_while_statement] = STATE(1276),
    [sym_for_statement] = STATE(1276),
    [sym_for_in_statement] = STATE(1276),
    [sym_delete_statement] = STATE(1276),
    [sym_exit_statement] = STATE(1276),
    [sym_return_statement] = STATE(1276),
    [sym_switch_statement] = STATE(1276),
    [sym__io_statement] = STATE(1276),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1276),
    [sym_piped_io_statement] = STATE(1276),
    [sym_block] = STATE(1275),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(314),
    [sym_continue_statement] = ACTIONS(314),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(314),
    [sym_nextfile_statement] = ACTIONS(314),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [19] = {
    [sym__statement] = STATE(1341),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1341),
    [sym_if_statement] = STATE(1341),
    [sym_while_statement] = STATE(1341),
    [sym_do_while_statement] = STATE(1341),
    [sym_for_statement] = STATE(1341),
    [sym_for_in_statement] = STATE(1341),
    [sym_delete_statement] = STATE(1341),
    [sym_exit_statement] = STATE(1341),
    [sym_return_statement] = STATE(1341),
    [sym_switch_statement] = STATE(1341),
    [sym__io_statement] = STATE(1341),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1341),
    [sym_piped_io_statement] = STATE(1341),
    [sym_block] = STATE(1305),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(358),
    [sym_continue_statement] = ACTIONS(358),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(358),
    [sym_nextfile_statement] = ACTIONS(358),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [20] = {
    [sym__statement] = STATE(1225),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1225),
    [sym_if_statement] = STATE(1225),
    [sym_while_statement] = STATE(1225),
    [sym_do_while_statement] = STATE(1225),
    [sym_for_statement] = STATE(1225),
    [sym_for_in_statement] = STATE(1225),
    [sym_delete_statement] = STATE(1225),
    [sym_exit_statement] = STATE(1225),
    [sym_return_statement] = STATE(1225),
    [sym_switch_statement] = STATE(1225),
    [sym__io_statement] = STATE(1225),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1225),
    [sym_piped_io_statement] = STATE(1225),
    [sym_block] = STATE(1224),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(25),
    [aux_sym_if_statement_repeat1] = STATE(25),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(382),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(386),
    [sym_nextfile_statement] = ACTIONS(386),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [21] = {
    [sym__statement] = STATE(1341),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1341),
    [sym_if_statement] = STATE(1341),
    [sym_while_statement] = STATE(1341),
    [sym_do_while_statement] = STATE(1341),
    [sym_for_statement] = STATE(1341),
    [sym_for_in_statement] = STATE(1341),
    [sym_delete_statement] = STATE(1341),
    [sym_exit_statement] = STATE(1341),
    [sym_return_statement] = STATE(1341),
    [sym_switch_statement] = STATE(1341),
    [sym__io_statement] = STATE(1341),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1341),
    [sym_piped_io_statement] = STATE(1341),
    [sym_block] = STATE(1305),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(358),
    [sym_continue_statement] = ACTIONS(358),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(358),
    [sym_nextfile_statement] = ACTIONS(358),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [22] = {
    [sym__statement] = STATE(1373),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1373),
    [sym_if_statement] = STATE(1373),
    [sym_while_statement] = STATE(1373),
    [sym_do_while_statement] = STATE(1373),
    [sym_for_statement] = STATE(1373),
    [sym_for_in_statement] = STATE(1373),
    [sym_delete_statement] = STATE(1373),
    [sym_exit_statement] = STATE(1373),
    [sym_return_statement] = STATE(1373),
    [sym_switch_statement] = STATE(1373),
    [sym__io_statement] = STATE(1373),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1373),
    [sym_piped_io_statement] = STATE(1373),
    [sym_block] = STATE(1299),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(15),
    [aux_sym_if_statement_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(402),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(404),
    [sym_continue_statement] = ACTIONS(404),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(404),
    [sym_nextfile_statement] = ACTIONS(404),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [23] = {
    [sym__statement] = STATE(1370),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1370),
    [sym_if_statement] = STATE(1370),
    [sym_while_statement] = STATE(1370),
    [sym_do_while_statement] = STATE(1370),
    [sym_for_statement] = STATE(1370),
    [sym_for_in_statement] = STATE(1370),
    [sym_delete_statement] = STATE(1370),
    [sym_exit_statement] = STATE(1370),
    [sym_return_statement] = STATE(1370),
    [sym_switch_statement] = STATE(1370),
    [sym__io_statement] = STATE(1370),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1370),
    [sym_piped_io_statement] = STATE(1370),
    [sym_block] = STATE(1367),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(408),
    [sym_continue_statement] = ACTIONS(408),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(408),
    [sym_nextfile_statement] = ACTIONS(408),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [24] = {
    [sym__statement] = STATE(1346),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1346),
    [sym_if_statement] = STATE(1346),
    [sym_while_statement] = STATE(1346),
    [sym_do_while_statement] = STATE(1346),
    [sym_for_statement] = STATE(1346),
    [sym_for_in_statement] = STATE(1346),
    [sym_delete_statement] = STATE(1346),
    [sym_exit_statement] = STATE(1346),
    [sym_return_statement] = STATE(1346),
    [sym_switch_statement] = STATE(1346),
    [sym__io_statement] = STATE(1346),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1346),
    [sym_piped_io_statement] = STATE(1346),
    [sym_block] = STATE(1347),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(21),
    [aux_sym_if_statement_repeat1] = STATE(21),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(412),
    [sym_continue_statement] = ACTIONS(412),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(412),
    [sym_nextfile_statement] = ACTIONS(412),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [25] = {
    [sym__statement] = STATE(1229),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_while_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_delete_statement] = STATE(1229),
    [sym_exit_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym__io_statement] = STATE(1229),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1229),
    [sym_piped_io_statement] = STATE(1229),
    [sym_block] = STATE(1228),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(416),
    [sym_continue_statement] = ACTIONS(416),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(416),
    [sym_nextfile_statement] = ACTIONS(416),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [26] = {
    [sym__statement] = STATE(1274),
    [sym__statement_separated] = STATE(1274),
    [sym__control_statement] = STATE(1274),
    [sym_if_statement] = STATE(1274),
    [sym_while_statement] = STATE(1274),
    [sym_do_while_statement] = STATE(1274),
    [sym_for_statement] = STATE(1274),
    [sym_for_in_statement] = STATE(1274),
    [sym_delete_statement] = STATE(1274),
    [sym_exit_statement] = STATE(1274),
    [sym_return_statement] = STATE(1274),
    [sym_switch_statement] = STATE(1274),
    [sym__io_statement] = STATE(1274),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1274),
    [sym_piped_io_statement] = STATE(1274),
    [sym_block] = STATE(1272),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(420),
    [sym_continue_statement] = ACTIONS(420),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(420),
    [sym_nextfile_statement] = ACTIONS(420),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [27] = {
    [sym__statement] = STATE(1232),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1232),
    [sym_if_statement] = STATE(1232),
    [sym_while_statement] = STATE(1232),
    [sym_do_while_statement] = STATE(1232),
    [sym_for_statement] = STATE(1232),
    [sym_for_in_statement] = STATE(1232),
    [sym_delete_statement] = STATE(1232),
    [sym_exit_statement] = STATE(1232),
    [sym_return_statement] = STATE(1232),
    [sym_switch_statement] = STATE(1232),
    [sym__io_statement] = STATE(1232),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1232),
    [sym_piped_io_statement] = STATE(1232),
    [sym_block] = STATE(1231),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(28),
    [aux_sym_if_statement_repeat1] = STATE(28),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(424),
    [sym_continue_statement] = ACTIONS(424),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(424),
    [sym_nextfile_statement] = ACTIONS(424),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [28] = {
    [sym__statement] = STATE(1239),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1239),
    [sym_if_statement] = STATE(1239),
    [sym_while_statement] = STATE(1239),
    [sym_do_while_statement] = STATE(1239),
    [sym_for_statement] = STATE(1239),
    [sym_for_in_statement] = STATE(1239),
    [sym_delete_statement] = STATE(1239),
    [sym_exit_statement] = STATE(1239),
    [sym_return_statement] = STATE(1239),
    [sym_switch_statement] = STATE(1239),
    [sym__io_statement] = STATE(1239),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1239),
    [sym_piped_io_statement] = STATE(1239),
    [sym_block] = STATE(1238),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(428),
    [sym_continue_statement] = ACTIONS(428),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(428),
    [sym_nextfile_statement] = ACTIONS(428),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [29] = {
    [sym__statement] = STATE(1940),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1940),
    [sym_if_statement] = STATE(1940),
    [sym_while_statement] = STATE(1940),
    [sym_do_while_statement] = STATE(1940),
    [sym_for_statement] = STATE(1940),
    [sym_for_in_statement] = STATE(1940),
    [sym_delete_statement] = STATE(1940),
    [sym_exit_statement] = STATE(1940),
    [sym_return_statement] = STATE(1940),
    [sym_switch_statement] = STATE(1940),
    [sym__io_statement] = STATE(1940),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1940),
    [sym_piped_io_statement] = STATE(1940),
    [sym_block] = STATE(1972),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(79),
    [aux_sym_if_statement_repeat1] = STATE(79),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(442),
    [sym_continue_statement] = ACTIONS(442),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(442),
    [sym_nextfile_statement] = ACTIONS(442),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [30] = {
    [sym__statement] = STATE(1366),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1366),
    [sym_if_statement] = STATE(1366),
    [sym_while_statement] = STATE(1366),
    [sym_do_while_statement] = STATE(1366),
    [sym_for_statement] = STATE(1366),
    [sym_for_in_statement] = STATE(1366),
    [sym_delete_statement] = STATE(1366),
    [sym_exit_statement] = STATE(1366),
    [sym_return_statement] = STATE(1366),
    [sym_switch_statement] = STATE(1366),
    [sym__io_statement] = STATE(1366),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1366),
    [sym_piped_io_statement] = STATE(1366),
    [sym_block] = STATE(1364),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(270),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(272),
    [sym_continue_statement] = ACTIONS(272),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(272),
    [sym_nextfile_statement] = ACTIONS(272),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [31] = {
    [sym__statement] = STATE(1845),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1845),
    [sym_if_statement] = STATE(1845),
    [sym_while_statement] = STATE(1845),
    [sym_do_while_statement] = STATE(1845),
    [sym_for_statement] = STATE(1845),
    [sym_for_in_statement] = STATE(1845),
    [sym_delete_statement] = STATE(1845),
    [sym_exit_statement] = STATE(1845),
    [sym_return_statement] = STATE(1845),
    [sym_switch_statement] = STATE(1845),
    [sym__io_statement] = STATE(1845),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1845),
    [sym_piped_io_statement] = STATE(1845),
    [sym_block] = STATE(1851),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(106),
    [aux_sym_if_statement_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(468),
    [sym_continue_statement] = ACTIONS(468),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(468),
    [sym_nextfile_statement] = ACTIONS(468),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [32] = {
    [sym__statement] = STATE(1848),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1848),
    [sym_if_statement] = STATE(1848),
    [sym_while_statement] = STATE(1848),
    [sym_do_while_statement] = STATE(1848),
    [sym_for_statement] = STATE(1848),
    [sym_for_in_statement] = STATE(1848),
    [sym_delete_statement] = STATE(1848),
    [sym_exit_statement] = STATE(1848),
    [sym_return_statement] = STATE(1848),
    [sym_switch_statement] = STATE(1848),
    [sym__io_statement] = STATE(1848),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1848),
    [sym_piped_io_statement] = STATE(1848),
    [sym_block] = STATE(1852),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(472),
    [sym_continue_statement] = ACTIONS(472),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(472),
    [sym_nextfile_statement] = ACTIONS(472),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [33] = {
    [sym__statement] = STATE(1359),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1359),
    [sym_if_statement] = STATE(1359),
    [sym_while_statement] = STATE(1359),
    [sym_do_while_statement] = STATE(1359),
    [sym_for_statement] = STATE(1359),
    [sym_for_in_statement] = STATE(1359),
    [sym_delete_statement] = STATE(1359),
    [sym_exit_statement] = STATE(1359),
    [sym_return_statement] = STATE(1359),
    [sym_switch_statement] = STATE(1359),
    [sym__io_statement] = STATE(1359),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1359),
    [sym_piped_io_statement] = STATE(1359),
    [sym_block] = STATE(1358),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(16),
    [aux_sym_if_statement_repeat1] = STATE(16),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(264),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(266),
    [sym_continue_statement] = ACTIONS(266),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(266),
    [sym_nextfile_statement] = ACTIONS(266),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [34] = {
    [sym__statement] = STATE(1242),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1242),
    [sym_if_statement] = STATE(1242),
    [sym_while_statement] = STATE(1242),
    [sym_do_while_statement] = STATE(1242),
    [sym_for_statement] = STATE(1242),
    [sym_for_in_statement] = STATE(1242),
    [sym_delete_statement] = STATE(1242),
    [sym_exit_statement] = STATE(1242),
    [sym_return_statement] = STATE(1242),
    [sym_switch_statement] = STATE(1242),
    [sym__io_statement] = STATE(1242),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1242),
    [sym_piped_io_statement] = STATE(1242),
    [sym_block] = STATE(1240),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(56),
    [aux_sym_if_statement_repeat1] = STATE(56),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(476),
    [sym_continue_statement] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(476),
    [sym_nextfile_statement] = ACTIONS(476),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [35] = {
    [sym__statement] = STATE(1271),
    [sym__statement_separated] = STATE(1271),
    [sym__control_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_do_while_statement] = STATE(1271),
    [sym_for_statement] = STATE(1271),
    [sym_for_in_statement] = STATE(1271),
    [sym_delete_statement] = STATE(1271),
    [sym_exit_statement] = STATE(1271),
    [sym_return_statement] = STATE(1271),
    [sym_switch_statement] = STATE(1271),
    [sym__io_statement] = STATE(1271),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1271),
    [sym_piped_io_statement] = STATE(1271),
    [sym_block] = STATE(1270),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(478),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(480),
    [sym_continue_statement] = ACTIONS(480),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(480),
    [sym_nextfile_statement] = ACTIONS(480),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [36] = {
    [sym__statement] = STATE(1244),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1244),
    [sym_if_statement] = STATE(1244),
    [sym_while_statement] = STATE(1244),
    [sym_do_while_statement] = STATE(1244),
    [sym_for_statement] = STATE(1244),
    [sym_for_in_statement] = STATE(1244),
    [sym_delete_statement] = STATE(1244),
    [sym_exit_statement] = STATE(1244),
    [sym_return_statement] = STATE(1244),
    [sym_switch_statement] = STATE(1244),
    [sym__io_statement] = STATE(1244),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1244),
    [sym_piped_io_statement] = STATE(1244),
    [sym_block] = STATE(1243),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(61),
    [aux_sym_if_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(484),
    [sym_continue_statement] = ACTIONS(484),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(484),
    [sym_nextfile_statement] = ACTIONS(484),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [37] = {
    [sym__statement] = STATE(1357),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1357),
    [sym_if_statement] = STATE(1357),
    [sym_while_statement] = STATE(1357),
    [sym_do_while_statement] = STATE(1357),
    [sym_for_statement] = STATE(1357),
    [sym_for_in_statement] = STATE(1357),
    [sym_delete_statement] = STATE(1357),
    [sym_exit_statement] = STATE(1357),
    [sym_return_statement] = STATE(1357),
    [sym_switch_statement] = STATE(1357),
    [sym__io_statement] = STATE(1357),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1357),
    [sym_piped_io_statement] = STATE(1357),
    [sym_block] = STATE(1356),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(488),
    [sym_continue_statement] = ACTIONS(488),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(488),
    [sym_nextfile_statement] = ACTIONS(488),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [38] = {
    [sym__statement] = STATE(1354),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1354),
    [sym_if_statement] = STATE(1354),
    [sym_while_statement] = STATE(1354),
    [sym_do_while_statement] = STATE(1354),
    [sym_for_statement] = STATE(1354),
    [sym_for_in_statement] = STATE(1354),
    [sym_delete_statement] = STATE(1354),
    [sym_exit_statement] = STATE(1354),
    [sym_return_statement] = STATE(1354),
    [sym_switch_statement] = STATE(1354),
    [sym__io_statement] = STATE(1354),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1354),
    [sym_piped_io_statement] = STATE(1354),
    [sym_block] = STATE(1352),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(492),
    [sym_continue_statement] = ACTIONS(492),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(492),
    [sym_nextfile_statement] = ACTIONS(492),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [39] = {
    [sym__statement] = STATE(1340),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1340),
    [sym_if_statement] = STATE(1340),
    [sym_while_statement] = STATE(1340),
    [sym_do_while_statement] = STATE(1340),
    [sym_for_statement] = STATE(1340),
    [sym_for_in_statement] = STATE(1340),
    [sym_delete_statement] = STATE(1340),
    [sym_exit_statement] = STATE(1340),
    [sym_return_statement] = STATE(1340),
    [sym_switch_statement] = STATE(1340),
    [sym__io_statement] = STATE(1340),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1340),
    [sym_piped_io_statement] = STATE(1340),
    [sym_block] = STATE(1337),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(23),
    [aux_sym_if_statement_repeat1] = STATE(23),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(496),
    [sym_continue_statement] = ACTIONS(496),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(496),
    [sym_nextfile_statement] = ACTIONS(496),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [40] = {
    [sym__statement] = STATE(1246),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1246),
    [sym_if_statement] = STATE(1246),
    [sym_while_statement] = STATE(1246),
    [sym_do_while_statement] = STATE(1246),
    [sym_for_statement] = STATE(1246),
    [sym_for_in_statement] = STATE(1246),
    [sym_delete_statement] = STATE(1246),
    [sym_exit_statement] = STATE(1246),
    [sym_return_statement] = STATE(1246),
    [sym_switch_statement] = STATE(1246),
    [sym__io_statement] = STATE(1246),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1246),
    [sym_piped_io_statement] = STATE(1246),
    [sym_block] = STATE(1245),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(67),
    [aux_sym_if_statement_repeat1] = STATE(67),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(500),
    [sym_continue_statement] = ACTIONS(500),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(500),
    [sym_nextfile_statement] = ACTIONS(500),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [41] = {
    [sym__statement] = STATE(1336),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1336),
    [sym_if_statement] = STATE(1336),
    [sym_while_statement] = STATE(1336),
    [sym_do_while_statement] = STATE(1336),
    [sym_for_statement] = STATE(1336),
    [sym_for_in_statement] = STATE(1336),
    [sym_delete_statement] = STATE(1336),
    [sym_exit_statement] = STATE(1336),
    [sym_return_statement] = STATE(1336),
    [sym_switch_statement] = STATE(1336),
    [sym__io_statement] = STATE(1336),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1336),
    [sym_piped_io_statement] = STATE(1336),
    [sym_block] = STATE(1334),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(30),
    [aux_sym_if_statement_repeat1] = STATE(30),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(504),
    [sym_nextfile_statement] = ACTIONS(504),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [42] = {
    [sym__statement] = STATE(1883),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1883),
    [sym_if_statement] = STATE(1883),
    [sym_while_statement] = STATE(1883),
    [sym_do_while_statement] = STATE(1883),
    [sym_for_statement] = STATE(1883),
    [sym_for_in_statement] = STATE(1883),
    [sym_delete_statement] = STATE(1883),
    [sym_exit_statement] = STATE(1883),
    [sym_return_statement] = STATE(1883),
    [sym_switch_statement] = STATE(1883),
    [sym__io_statement] = STATE(1883),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1883),
    [sym_piped_io_statement] = STATE(1883),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(506),
    [sym_continue_statement] = ACTIONS(506),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_case] = ACTIONS(510),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(506),
    [sym_nextfile_statement] = ACTIONS(506),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [43] = {
    [sym__statement] = STATE(1330),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1330),
    [sym_if_statement] = STATE(1330),
    [sym_while_statement] = STATE(1330),
    [sym_do_while_statement] = STATE(1330),
    [sym_for_statement] = STATE(1330),
    [sym_for_in_statement] = STATE(1330),
    [sym_delete_statement] = STATE(1330),
    [sym_exit_statement] = STATE(1330),
    [sym_return_statement] = STATE(1330),
    [sym_switch_statement] = STATE(1330),
    [sym__io_statement] = STATE(1330),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1330),
    [sym_piped_io_statement] = STATE(1330),
    [sym_block] = STATE(1329),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(37),
    [aux_sym_if_statement_repeat1] = STATE(37),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(514),
    [sym_continue_statement] = ACTIONS(514),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(514),
    [sym_nextfile_statement] = ACTIONS(514),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [44] = {
    [sym__statement] = STATE(1267),
    [sym__statement_separated] = STATE(1267),
    [sym__control_statement] = STATE(1267),
    [sym_if_statement] = STATE(1267),
    [sym_while_statement] = STATE(1267),
    [sym_do_while_statement] = STATE(1267),
    [sym_for_statement] = STATE(1267),
    [sym_for_in_statement] = STATE(1267),
    [sym_delete_statement] = STATE(1267),
    [sym_exit_statement] = STATE(1267),
    [sym_return_statement] = STATE(1267),
    [sym_switch_statement] = STATE(1267),
    [sym__io_statement] = STATE(1267),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1267),
    [sym_piped_io_statement] = STATE(1267),
    [sym_block] = STATE(1265),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(18),
    [aux_sym_if_statement_repeat1] = STATE(18),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(516),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(518),
    [sym_continue_statement] = ACTIONS(518),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(518),
    [sym_nextfile_statement] = ACTIONS(518),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [45] = {
    [sym__statement] = STATE(1346),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1346),
    [sym_if_statement] = STATE(1346),
    [sym_while_statement] = STATE(1346),
    [sym_do_while_statement] = STATE(1346),
    [sym_for_statement] = STATE(1346),
    [sym_for_in_statement] = STATE(1346),
    [sym_delete_statement] = STATE(1346),
    [sym_exit_statement] = STATE(1346),
    [sym_return_statement] = STATE(1346),
    [sym_switch_statement] = STATE(1346),
    [sym__io_statement] = STATE(1346),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1346),
    [sym_piped_io_statement] = STATE(1346),
    [sym_block] = STATE(1347),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(19),
    [aux_sym_if_statement_repeat1] = STATE(19),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(412),
    [sym_continue_statement] = ACTIONS(412),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(412),
    [sym_nextfile_statement] = ACTIONS(412),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [46] = {
    [sym__statement] = STATE(1353),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1353),
    [sym_if_statement] = STATE(1353),
    [sym_while_statement] = STATE(1353),
    [sym_do_while_statement] = STATE(1353),
    [sym_for_statement] = STATE(1353),
    [sym_for_in_statement] = STATE(1353),
    [sym_delete_statement] = STATE(1353),
    [sym_exit_statement] = STATE(1353),
    [sym_return_statement] = STATE(1353),
    [sym_switch_statement] = STATE(1353),
    [sym__io_statement] = STATE(1353),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1353),
    [sym_piped_io_statement] = STATE(1353),
    [sym_block] = STATE(1355),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(522),
    [sym_continue_statement] = ACTIONS(522),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(522),
    [sym_nextfile_statement] = ACTIONS(522),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [47] = {
    [sym__statement] = STATE(1264),
    [sym__statement_separated] = STATE(1264),
    [sym__control_statement] = STATE(1264),
    [sym_if_statement] = STATE(1264),
    [sym_while_statement] = STATE(1264),
    [sym_do_while_statement] = STATE(1264),
    [sym_for_statement] = STATE(1264),
    [sym_for_in_statement] = STATE(1264),
    [sym_delete_statement] = STATE(1264),
    [sym_exit_statement] = STATE(1264),
    [sym_return_statement] = STATE(1264),
    [sym_switch_statement] = STATE(1264),
    [sym__io_statement] = STATE(1264),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1264),
    [sym_piped_io_statement] = STATE(1264),
    [sym_block] = STATE(1263),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(26),
    [aux_sym_if_statement_repeat1] = STATE(26),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(524),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(526),
    [sym_continue_statement] = ACTIONS(526),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(526),
    [sym_nextfile_statement] = ACTIONS(526),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [48] = {
    [sym__statement] = STATE(1361),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_do_while_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_for_in_statement] = STATE(1361),
    [sym_delete_statement] = STATE(1361),
    [sym_exit_statement] = STATE(1361),
    [sym_return_statement] = STATE(1361),
    [sym_switch_statement] = STATE(1361),
    [sym__io_statement] = STATE(1361),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1361),
    [sym_piped_io_statement] = STATE(1361),
    [sym_block] = STATE(1362),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(274),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(278),
    [sym_continue_statement] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(278),
    [sym_nextfile_statement] = ACTIONS(278),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [49] = {
    [sym__statement] = STATE(1262),
    [sym__statement_separated] = STATE(1262),
    [sym__control_statement] = STATE(1262),
    [sym_if_statement] = STATE(1262),
    [sym_while_statement] = STATE(1262),
    [sym_do_while_statement] = STATE(1262),
    [sym_for_statement] = STATE(1262),
    [sym_for_in_statement] = STATE(1262),
    [sym_delete_statement] = STATE(1262),
    [sym_exit_statement] = STATE(1262),
    [sym_return_statement] = STATE(1262),
    [sym_switch_statement] = STATE(1262),
    [sym__io_statement] = STATE(1262),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1262),
    [sym_piped_io_statement] = STATE(1262),
    [sym_block] = STATE(1261),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(528),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(530),
    [sym_continue_statement] = ACTIONS(530),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(530),
    [sym_nextfile_statement] = ACTIONS(530),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [50] = {
    [sym__statement] = STATE(1341),
    [sym__statement_separated] = STATE(1341),
    [sym__control_statement] = STATE(1341),
    [sym_if_statement] = STATE(1341),
    [sym_while_statement] = STATE(1341),
    [sym_do_while_statement] = STATE(1341),
    [sym_for_statement] = STATE(1341),
    [sym_for_in_statement] = STATE(1341),
    [sym_delete_statement] = STATE(1341),
    [sym_exit_statement] = STATE(1341),
    [sym_return_statement] = STATE(1341),
    [sym_switch_statement] = STATE(1341),
    [sym__io_statement] = STATE(1341),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1341),
    [sym_piped_io_statement] = STATE(1341),
    [sym_block] = STATE(1305),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(348),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(358),
    [sym_continue_statement] = ACTIONS(358),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(358),
    [sym_nextfile_statement] = ACTIONS(358),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [51] = {
    [sym__statement] = STATE(1328),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1328),
    [sym_if_statement] = STATE(1328),
    [sym_while_statement] = STATE(1328),
    [sym_do_while_statement] = STATE(1328),
    [sym_for_statement] = STATE(1328),
    [sym_for_in_statement] = STATE(1328),
    [sym_delete_statement] = STATE(1328),
    [sym_exit_statement] = STATE(1328),
    [sym_return_statement] = STATE(1328),
    [sym_switch_statement] = STATE(1328),
    [sym__io_statement] = STATE(1328),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1328),
    [sym_piped_io_statement] = STATE(1328),
    [sym_block] = STATE(1326),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(38),
    [aux_sym_if_statement_repeat1] = STATE(38),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(532),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(534),
    [sym_continue_statement] = ACTIONS(534),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(534),
    [sym_nextfile_statement] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [52] = {
    [sym__statement] = STATE(1325),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1325),
    [sym_if_statement] = STATE(1325),
    [sym_while_statement] = STATE(1325),
    [sym_do_while_statement] = STATE(1325),
    [sym_for_statement] = STATE(1325),
    [sym_for_in_statement] = STATE(1325),
    [sym_delete_statement] = STATE(1325),
    [sym_exit_statement] = STATE(1325),
    [sym_return_statement] = STATE(1325),
    [sym_switch_statement] = STATE(1325),
    [sym__io_statement] = STATE(1325),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1325),
    [sym_piped_io_statement] = STATE(1325),
    [sym_block] = STATE(1324),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(538),
    [sym_continue_statement] = ACTIONS(538),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(538),
    [sym_nextfile_statement] = ACTIONS(538),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [53] = {
    [sym__statement] = STATE(1363),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1363),
    [sym_if_statement] = STATE(1363),
    [sym_while_statement] = STATE(1363),
    [sym_do_while_statement] = STATE(1363),
    [sym_for_statement] = STATE(1363),
    [sym_for_in_statement] = STATE(1363),
    [sym_delete_statement] = STATE(1363),
    [sym_exit_statement] = STATE(1363),
    [sym_return_statement] = STATE(1363),
    [sym_switch_statement] = STATE(1363),
    [sym__io_statement] = STATE(1363),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1363),
    [sym_piped_io_statement] = STATE(1363),
    [sym_block] = STATE(1365),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(294),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(296),
    [sym_continue_statement] = ACTIONS(296),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(296),
    [sym_nextfile_statement] = ACTIONS(296),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [54] = {
    [sym__statement] = STATE(1248),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1248),
    [sym_if_statement] = STATE(1248),
    [sym_while_statement] = STATE(1248),
    [sym_do_while_statement] = STATE(1248),
    [sym_for_statement] = STATE(1248),
    [sym_for_in_statement] = STATE(1248),
    [sym_delete_statement] = STATE(1248),
    [sym_exit_statement] = STATE(1248),
    [sym_return_statement] = STATE(1248),
    [sym_switch_statement] = STATE(1248),
    [sym__io_statement] = STATE(1248),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1248),
    [sym_piped_io_statement] = STATE(1248),
    [sym_block] = STATE(1247),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(72),
    [aux_sym_if_statement_repeat1] = STATE(72),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(542),
    [sym_continue_statement] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(542),
    [sym_nextfile_statement] = ACTIONS(542),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [55] = {
    [sym__statement] = STATE(1260),
    [sym__statement_separated] = STATE(1260),
    [sym__control_statement] = STATE(1260),
    [sym_if_statement] = STATE(1260),
    [sym_while_statement] = STATE(1260),
    [sym_do_while_statement] = STATE(1260),
    [sym_for_statement] = STATE(1260),
    [sym_for_in_statement] = STATE(1260),
    [sym_delete_statement] = STATE(1260),
    [sym_exit_statement] = STATE(1260),
    [sym_return_statement] = STATE(1260),
    [sym_switch_statement] = STATE(1260),
    [sym__io_statement] = STATE(1260),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1260),
    [sym_piped_io_statement] = STATE(1260),
    [sym_block] = STATE(1259),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(546),
    [sym_continue_statement] = ACTIONS(546),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(546),
    [sym_nextfile_statement] = ACTIONS(546),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [56] = {
    [sym__statement] = STATE(1254),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1254),
    [sym_if_statement] = STATE(1254),
    [sym_while_statement] = STATE(1254),
    [sym_do_while_statement] = STATE(1254),
    [sym_for_statement] = STATE(1254),
    [sym_for_in_statement] = STATE(1254),
    [sym_delete_statement] = STATE(1254),
    [sym_exit_statement] = STATE(1254),
    [sym_return_statement] = STATE(1254),
    [sym_switch_statement] = STATE(1254),
    [sym__io_statement] = STATE(1254),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1254),
    [sym_piped_io_statement] = STATE(1254),
    [sym_block] = STATE(1253),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(550),
    [sym_continue_statement] = ACTIONS(550),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(550),
    [sym_nextfile_statement] = ACTIONS(550),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [57] = {
    [sym__statement] = STATE(1865),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1865),
    [sym_if_statement] = STATE(1865),
    [sym_while_statement] = STATE(1865),
    [sym_do_while_statement] = STATE(1865),
    [sym_for_statement] = STATE(1865),
    [sym_for_in_statement] = STATE(1865),
    [sym_delete_statement] = STATE(1865),
    [sym_exit_statement] = STATE(1865),
    [sym_return_statement] = STATE(1865),
    [sym_switch_statement] = STATE(1865),
    [sym__io_statement] = STATE(1865),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1865),
    [sym_piped_io_statement] = STATE(1865),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(552),
    [sym_continue_statement] = ACTIONS(552),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_case] = ACTIONS(556),
    [anon_sym_default] = ACTIONS(556),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(552),
    [sym_nextfile_statement] = ACTIONS(552),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [58] = {
    [sym__statement] = STATE(1861),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1861),
    [sym_if_statement] = STATE(1861),
    [sym_while_statement] = STATE(1861),
    [sym_do_while_statement] = STATE(1861),
    [sym_for_statement] = STATE(1861),
    [sym_for_in_statement] = STATE(1861),
    [sym_delete_statement] = STATE(1861),
    [sym_exit_statement] = STATE(1861),
    [sym_return_statement] = STATE(1861),
    [sym_switch_statement] = STATE(1861),
    [sym__io_statement] = STATE(1861),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1861),
    [sym_piped_io_statement] = STATE(1861),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(42),
    [aux_sym_if_statement_repeat1] = STATE(42),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(558),
    [sym_continue_statement] = ACTIONS(558),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_case] = ACTIONS(562),
    [anon_sym_default] = ACTIONS(562),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(558),
    [sym_nextfile_statement] = ACTIONS(558),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [59] = {
    [sym__statement] = STATE(1346),
    [sym__statement_separated] = STATE(1346),
    [sym__control_statement] = STATE(1346),
    [sym_if_statement] = STATE(1346),
    [sym_while_statement] = STATE(1346),
    [sym_do_while_statement] = STATE(1346),
    [sym_for_statement] = STATE(1346),
    [sym_for_in_statement] = STATE(1346),
    [sym_delete_statement] = STATE(1346),
    [sym_exit_statement] = STATE(1346),
    [sym_return_statement] = STATE(1346),
    [sym_switch_statement] = STATE(1346),
    [sym__io_statement] = STATE(1346),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1346),
    [sym_piped_io_statement] = STATE(1346),
    [sym_block] = STATE(1347),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(50),
    [aux_sym_if_statement_repeat1] = STATE(50),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(412),
    [sym_continue_statement] = ACTIONS(412),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(412),
    [sym_nextfile_statement] = ACTIONS(412),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [60] = {
    [sym__statement] = STATE(1353),
    [sym__statement_separated] = STATE(1353),
    [sym__control_statement] = STATE(1353),
    [sym_if_statement] = STATE(1353),
    [sym_while_statement] = STATE(1353),
    [sym_do_while_statement] = STATE(1353),
    [sym_for_statement] = STATE(1353),
    [sym_for_in_statement] = STATE(1353),
    [sym_delete_statement] = STATE(1353),
    [sym_exit_statement] = STATE(1353),
    [sym_return_statement] = STATE(1353),
    [sym_switch_statement] = STATE(1353),
    [sym__io_statement] = STATE(1353),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1353),
    [sym_piped_io_statement] = STATE(1353),
    [sym_block] = STATE(1355),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(522),
    [sym_continue_statement] = ACTIONS(522),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(522),
    [sym_nextfile_statement] = ACTIONS(522),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [61] = {
    [sym__statement] = STATE(1256),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1256),
    [sym_if_statement] = STATE(1256),
    [sym_while_statement] = STATE(1256),
    [sym_do_while_statement] = STATE(1256),
    [sym_for_statement] = STATE(1256),
    [sym_for_in_statement] = STATE(1256),
    [sym_delete_statement] = STATE(1256),
    [sym_exit_statement] = STATE(1256),
    [sym_return_statement] = STATE(1256),
    [sym_switch_statement] = STATE(1256),
    [sym__io_statement] = STATE(1256),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1256),
    [sym_piped_io_statement] = STATE(1256),
    [sym_block] = STATE(1255),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(566),
    [sym_continue_statement] = ACTIONS(566),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(566),
    [sym_nextfile_statement] = ACTIONS(566),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [62] = {
    [sym__statement] = STATE(1258),
    [sym__statement_separated] = STATE(1258),
    [sym__control_statement] = STATE(1258),
    [sym_if_statement] = STATE(1258),
    [sym_while_statement] = STATE(1258),
    [sym_do_while_statement] = STATE(1258),
    [sym_for_statement] = STATE(1258),
    [sym_for_in_statement] = STATE(1258),
    [sym_delete_statement] = STATE(1258),
    [sym_exit_statement] = STATE(1258),
    [sym_return_statement] = STATE(1258),
    [sym_switch_statement] = STATE(1258),
    [sym__io_statement] = STATE(1258),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1258),
    [sym_piped_io_statement] = STATE(1258),
    [sym_block] = STATE(1257),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(35),
    [aux_sym_if_statement_repeat1] = STATE(35),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(570),
    [sym_nextfile_statement] = ACTIONS(570),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [63] = {
    [sym__statement] = STATE(1361),
    [sym__statement_separated] = STATE(1361),
    [sym__control_statement] = STATE(1361),
    [sym_if_statement] = STATE(1361),
    [sym_while_statement] = STATE(1361),
    [sym_do_while_statement] = STATE(1361),
    [sym_for_statement] = STATE(1361),
    [sym_for_in_statement] = STATE(1361),
    [sym_delete_statement] = STATE(1361),
    [sym_exit_statement] = STATE(1361),
    [sym_return_statement] = STATE(1361),
    [sym_switch_statement] = STATE(1361),
    [sym__io_statement] = STATE(1361),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1361),
    [sym_piped_io_statement] = STATE(1361),
    [sym_block] = STATE(1362),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(274),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(278),
    [sym_continue_statement] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(278),
    [sym_nextfile_statement] = ACTIONS(278),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [64] = {
    [sym__statement] = STATE(1256),
    [sym__statement_separated] = STATE(1256),
    [sym__control_statement] = STATE(1256),
    [sym_if_statement] = STATE(1256),
    [sym_while_statement] = STATE(1256),
    [sym_do_while_statement] = STATE(1256),
    [sym_for_statement] = STATE(1256),
    [sym_for_in_statement] = STATE(1256),
    [sym_delete_statement] = STATE(1256),
    [sym_exit_statement] = STATE(1256),
    [sym_return_statement] = STATE(1256),
    [sym_switch_statement] = STATE(1256),
    [sym__io_statement] = STATE(1256),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1256),
    [sym_piped_io_statement] = STATE(1256),
    [sym_block] = STATE(1255),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(566),
    [sym_continue_statement] = ACTIONS(566),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(566),
    [sym_nextfile_statement] = ACTIONS(566),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [65] = {
    [sym__statement] = STATE(1369),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1369),
    [sym_if_statement] = STATE(1369),
    [sym_while_statement] = STATE(1369),
    [sym_do_while_statement] = STATE(1369),
    [sym_for_statement] = STATE(1369),
    [sym_for_in_statement] = STATE(1369),
    [sym_delete_statement] = STATE(1369),
    [sym_exit_statement] = STATE(1369),
    [sym_return_statement] = STATE(1369),
    [sym_switch_statement] = STATE(1369),
    [sym__io_statement] = STATE(1369),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1369),
    [sym_piped_io_statement] = STATE(1369),
    [sym_block] = STATE(1371),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(46),
    [aux_sym_if_statement_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(300),
    [sym_continue_statement] = ACTIONS(300),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(300),
    [sym_nextfile_statement] = ACTIONS(300),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [66] = {
    [sym__statement] = STATE(1258),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1258),
    [sym_if_statement] = STATE(1258),
    [sym_while_statement] = STATE(1258),
    [sym_do_while_statement] = STATE(1258),
    [sym_for_statement] = STATE(1258),
    [sym_for_in_statement] = STATE(1258),
    [sym_delete_statement] = STATE(1258),
    [sym_exit_statement] = STATE(1258),
    [sym_return_statement] = STATE(1258),
    [sym_switch_statement] = STATE(1258),
    [sym__io_statement] = STATE(1258),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1258),
    [sym_piped_io_statement] = STATE(1258),
    [sym_block] = STATE(1257),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(83),
    [aux_sym_if_statement_repeat1] = STATE(83),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(570),
    [sym_nextfile_statement] = ACTIONS(570),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [67] = {
    [sym__statement] = STATE(1260),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1260),
    [sym_if_statement] = STATE(1260),
    [sym_while_statement] = STATE(1260),
    [sym_do_while_statement] = STATE(1260),
    [sym_for_statement] = STATE(1260),
    [sym_for_in_statement] = STATE(1260),
    [sym_delete_statement] = STATE(1260),
    [sym_exit_statement] = STATE(1260),
    [sym_return_statement] = STATE(1260),
    [sym_switch_statement] = STATE(1260),
    [sym__io_statement] = STATE(1260),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1260),
    [sym_piped_io_statement] = STATE(1260),
    [sym_block] = STATE(1259),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(546),
    [sym_continue_statement] = ACTIONS(546),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(546),
    [sym_nextfile_statement] = ACTIONS(546),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [68] = {
    [sym__statement] = STATE(1373),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1373),
    [sym_if_statement] = STATE(1373),
    [sym_while_statement] = STATE(1373),
    [sym_do_while_statement] = STATE(1373),
    [sym_for_statement] = STATE(1373),
    [sym_for_in_statement] = STATE(1373),
    [sym_delete_statement] = STATE(1373),
    [sym_exit_statement] = STATE(1373),
    [sym_return_statement] = STATE(1373),
    [sym_switch_statement] = STATE(1373),
    [sym__io_statement] = STATE(1373),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1373),
    [sym_piped_io_statement] = STATE(1373),
    [sym_block] = STATE(1299),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(48),
    [aux_sym_if_statement_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(402),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(404),
    [sym_continue_statement] = ACTIONS(404),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(404),
    [sym_nextfile_statement] = ACTIONS(404),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [69] = {
    [sym__statement] = STATE(1317),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1317),
    [sym_if_statement] = STATE(1317),
    [sym_while_statement] = STATE(1317),
    [sym_do_while_statement] = STATE(1317),
    [sym_for_statement] = STATE(1317),
    [sym_for_in_statement] = STATE(1317),
    [sym_delete_statement] = STATE(1317),
    [sym_exit_statement] = STATE(1317),
    [sym_return_statement] = STATE(1317),
    [sym_switch_statement] = STATE(1317),
    [sym__io_statement] = STATE(1317),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1317),
    [sym_piped_io_statement] = STATE(1317),
    [sym_block] = STATE(1304),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(52),
    [aux_sym_if_statement_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(574),
    [sym_continue_statement] = ACTIONS(574),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(574),
    [sym_nextfile_statement] = ACTIONS(574),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [70] = {
    [sym__statement] = STATE(1300),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1300),
    [sym_if_statement] = STATE(1300),
    [sym_while_statement] = STATE(1300),
    [sym_do_while_statement] = STATE(1300),
    [sym_for_statement] = STATE(1300),
    [sym_for_in_statement] = STATE(1300),
    [sym_delete_statement] = STATE(1300),
    [sym_exit_statement] = STATE(1300),
    [sym_return_statement] = STATE(1300),
    [sym_switch_statement] = STATE(1300),
    [sym__io_statement] = STATE(1300),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1300),
    [sym_piped_io_statement] = STATE(1300),
    [sym_block] = STATE(1312),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(578),
    [sym_nextfile_statement] = ACTIONS(578),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [71] = {
    [sym__statement] = STATE(1363),
    [sym__statement_separated] = STATE(1363),
    [sym__control_statement] = STATE(1363),
    [sym_if_statement] = STATE(1363),
    [sym_while_statement] = STATE(1363),
    [sym_do_while_statement] = STATE(1363),
    [sym_for_statement] = STATE(1363),
    [sym_for_in_statement] = STATE(1363),
    [sym_delete_statement] = STATE(1363),
    [sym_exit_statement] = STATE(1363),
    [sym_return_statement] = STATE(1363),
    [sym_switch_statement] = STATE(1363),
    [sym__io_statement] = STATE(1363),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1363),
    [sym_piped_io_statement] = STATE(1363),
    [sym_block] = STATE(1365),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(294),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(296),
    [sym_continue_statement] = ACTIONS(296),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(296),
    [sym_nextfile_statement] = ACTIONS(296),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [72] = {
    [sym__statement] = STATE(1262),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1262),
    [sym_if_statement] = STATE(1262),
    [sym_while_statement] = STATE(1262),
    [sym_do_while_statement] = STATE(1262),
    [sym_for_statement] = STATE(1262),
    [sym_for_in_statement] = STATE(1262),
    [sym_delete_statement] = STATE(1262),
    [sym_exit_statement] = STATE(1262),
    [sym_return_statement] = STATE(1262),
    [sym_switch_statement] = STATE(1262),
    [sym__io_statement] = STATE(1262),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1262),
    [sym_piped_io_statement] = STATE(1262),
    [sym_block] = STATE(1261),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(528),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(530),
    [sym_continue_statement] = ACTIONS(530),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(530),
    [sym_nextfile_statement] = ACTIONS(530),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [73] = {
    [sym__statement] = STATE(1264),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1264),
    [sym_if_statement] = STATE(1264),
    [sym_while_statement] = STATE(1264),
    [sym_do_while_statement] = STATE(1264),
    [sym_for_statement] = STATE(1264),
    [sym_for_in_statement] = STATE(1264),
    [sym_delete_statement] = STATE(1264),
    [sym_exit_statement] = STATE(1264),
    [sym_return_statement] = STATE(1264),
    [sym_switch_statement] = STATE(1264),
    [sym__io_statement] = STATE(1264),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1264),
    [sym_piped_io_statement] = STATE(1264),
    [sym_block] = STATE(1263),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(85),
    [aux_sym_if_statement_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(524),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(526),
    [sym_continue_statement] = ACTIONS(526),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(526),
    [sym_nextfile_statement] = ACTIONS(526),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [74] = {
    [sym__statement] = STATE(1370),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1370),
    [sym_if_statement] = STATE(1370),
    [sym_while_statement] = STATE(1370),
    [sym_do_while_statement] = STATE(1370),
    [sym_for_statement] = STATE(1370),
    [sym_for_in_statement] = STATE(1370),
    [sym_delete_statement] = STATE(1370),
    [sym_exit_statement] = STATE(1370),
    [sym_return_statement] = STATE(1370),
    [sym_switch_statement] = STATE(1370),
    [sym__io_statement] = STATE(1370),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1370),
    [sym_piped_io_statement] = STATE(1370),
    [sym_block] = STATE(1367),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(408),
    [sym_continue_statement] = ACTIONS(408),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(408),
    [sym_nextfile_statement] = ACTIONS(408),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [75] = {
    [sym__statement] = STATE(1366),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1366),
    [sym_if_statement] = STATE(1366),
    [sym_while_statement] = STATE(1366),
    [sym_do_while_statement] = STATE(1366),
    [sym_for_statement] = STATE(1366),
    [sym_for_in_statement] = STATE(1366),
    [sym_delete_statement] = STATE(1366),
    [sym_exit_statement] = STATE(1366),
    [sym_return_statement] = STATE(1366),
    [sym_switch_statement] = STATE(1366),
    [sym__io_statement] = STATE(1366),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1366),
    [sym_piped_io_statement] = STATE(1366),
    [sym_block] = STATE(1364),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(270),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(272),
    [sym_continue_statement] = ACTIONS(272),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(272),
    [sym_nextfile_statement] = ACTIONS(272),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [76] = {
    [sym__statement] = STATE(1359),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1359),
    [sym_if_statement] = STATE(1359),
    [sym_while_statement] = STATE(1359),
    [sym_do_while_statement] = STATE(1359),
    [sym_for_statement] = STATE(1359),
    [sym_for_in_statement] = STATE(1359),
    [sym_delete_statement] = STATE(1359),
    [sym_exit_statement] = STATE(1359),
    [sym_return_statement] = STATE(1359),
    [sym_switch_statement] = STATE(1359),
    [sym__io_statement] = STATE(1359),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1359),
    [sym_piped_io_statement] = STATE(1359),
    [sym_block] = STATE(1358),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(53),
    [aux_sym_if_statement_repeat1] = STATE(53),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(264),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(266),
    [sym_continue_statement] = ACTIONS(266),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(266),
    [sym_nextfile_statement] = ACTIONS(266),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [77] = {
    [sym__statement] = STATE(1357),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1357),
    [sym_if_statement] = STATE(1357),
    [sym_while_statement] = STATE(1357),
    [sym_do_while_statement] = STATE(1357),
    [sym_for_statement] = STATE(1357),
    [sym_for_in_statement] = STATE(1357),
    [sym_delete_statement] = STATE(1357),
    [sym_exit_statement] = STATE(1357),
    [sym_return_statement] = STATE(1357),
    [sym_switch_statement] = STATE(1357),
    [sym__io_statement] = STATE(1357),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1357),
    [sym_piped_io_statement] = STATE(1357),
    [sym_block] = STATE(1356),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(488),
    [sym_continue_statement] = ACTIONS(488),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(488),
    [sym_nextfile_statement] = ACTIONS(488),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [78] = {
    [sym__statement] = STATE(1354),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1354),
    [sym_if_statement] = STATE(1354),
    [sym_while_statement] = STATE(1354),
    [sym_do_while_statement] = STATE(1354),
    [sym_for_statement] = STATE(1354),
    [sym_for_in_statement] = STATE(1354),
    [sym_delete_statement] = STATE(1354),
    [sym_exit_statement] = STATE(1354),
    [sym_return_statement] = STATE(1354),
    [sym_switch_statement] = STATE(1354),
    [sym__io_statement] = STATE(1354),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1354),
    [sym_piped_io_statement] = STATE(1354),
    [sym_block] = STATE(1352),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(492),
    [sym_continue_statement] = ACTIONS(492),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(492),
    [sym_nextfile_statement] = ACTIONS(492),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [79] = {
    [sym__statement] = STATE(1962),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1962),
    [sym_if_statement] = STATE(1962),
    [sym_while_statement] = STATE(1962),
    [sym_do_while_statement] = STATE(1962),
    [sym_for_statement] = STATE(1962),
    [sym_for_in_statement] = STATE(1962),
    [sym_delete_statement] = STATE(1962),
    [sym_exit_statement] = STATE(1962),
    [sym_return_statement] = STATE(1962),
    [sym_switch_statement] = STATE(1962),
    [sym__io_statement] = STATE(1962),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1962),
    [sym_piped_io_statement] = STATE(1962),
    [sym_block] = STATE(1946),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(580),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(582),
    [sym_continue_statement] = ACTIONS(582),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(582),
    [sym_nextfile_statement] = ACTIONS(582),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [80] = {
    [sym__statement] = STATE(1267),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1267),
    [sym_if_statement] = STATE(1267),
    [sym_while_statement] = STATE(1267),
    [sym_do_while_statement] = STATE(1267),
    [sym_for_statement] = STATE(1267),
    [sym_for_in_statement] = STATE(1267),
    [sym_delete_statement] = STATE(1267),
    [sym_exit_statement] = STATE(1267),
    [sym_return_statement] = STATE(1267),
    [sym_switch_statement] = STATE(1267),
    [sym__io_statement] = STATE(1267),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1267),
    [sym_piped_io_statement] = STATE(1267),
    [sym_block] = STATE(1265),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(87),
    [aux_sym_if_statement_repeat1] = STATE(87),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(516),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(518),
    [sym_continue_statement] = ACTIONS(518),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(518),
    [sym_nextfile_statement] = ACTIONS(518),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [81] = {
    [sym__statement] = STATE(1254),
    [sym__statement_separated] = STATE(1254),
    [sym__control_statement] = STATE(1254),
    [sym_if_statement] = STATE(1254),
    [sym_while_statement] = STATE(1254),
    [sym_do_while_statement] = STATE(1254),
    [sym_for_statement] = STATE(1254),
    [sym_for_in_statement] = STATE(1254),
    [sym_delete_statement] = STATE(1254),
    [sym_exit_statement] = STATE(1254),
    [sym_return_statement] = STATE(1254),
    [sym_switch_statement] = STATE(1254),
    [sym__io_statement] = STATE(1254),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1254),
    [sym_piped_io_statement] = STATE(1254),
    [sym_block] = STATE(1253),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(550),
    [sym_continue_statement] = ACTIONS(550),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(550),
    [sym_nextfile_statement] = ACTIONS(550),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [82] = {
    [sym__statement] = STATE(1225),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1225),
    [sym_if_statement] = STATE(1225),
    [sym_while_statement] = STATE(1225),
    [sym_do_while_statement] = STATE(1225),
    [sym_for_statement] = STATE(1225),
    [sym_for_in_statement] = STATE(1225),
    [sym_delete_statement] = STATE(1225),
    [sym_exit_statement] = STATE(1225),
    [sym_return_statement] = STATE(1225),
    [sym_switch_statement] = STATE(1225),
    [sym__io_statement] = STATE(1225),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1225),
    [sym_piped_io_statement] = STATE(1225),
    [sym_block] = STATE(1224),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(84),
    [aux_sym_if_statement_repeat1] = STATE(84),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(382),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(386),
    [sym_nextfile_statement] = ACTIONS(386),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [83] = {
    [sym__statement] = STATE(1271),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_do_while_statement] = STATE(1271),
    [sym_for_statement] = STATE(1271),
    [sym_for_in_statement] = STATE(1271),
    [sym_delete_statement] = STATE(1271),
    [sym_exit_statement] = STATE(1271),
    [sym_return_statement] = STATE(1271),
    [sym_switch_statement] = STATE(1271),
    [sym__io_statement] = STATE(1271),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1271),
    [sym_piped_io_statement] = STATE(1271),
    [sym_block] = STATE(1270),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(478),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(480),
    [sym_continue_statement] = ACTIONS(480),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(480),
    [sym_nextfile_statement] = ACTIONS(480),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [84] = {
    [sym__statement] = STATE(1229),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_while_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_delete_statement] = STATE(1229),
    [sym_exit_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym__io_statement] = STATE(1229),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1229),
    [sym_piped_io_statement] = STATE(1229),
    [sym_block] = STATE(1228),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(416),
    [sym_continue_statement] = ACTIONS(416),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(416),
    [sym_nextfile_statement] = ACTIONS(416),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [85] = {
    [sym__statement] = STATE(1274),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1274),
    [sym_if_statement] = STATE(1274),
    [sym_while_statement] = STATE(1274),
    [sym_do_while_statement] = STATE(1274),
    [sym_for_statement] = STATE(1274),
    [sym_for_in_statement] = STATE(1274),
    [sym_delete_statement] = STATE(1274),
    [sym_exit_statement] = STATE(1274),
    [sym_return_statement] = STATE(1274),
    [sym_switch_statement] = STATE(1274),
    [sym__io_statement] = STATE(1274),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1274),
    [sym_piped_io_statement] = STATE(1274),
    [sym_block] = STATE(1272),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(420),
    [sym_continue_statement] = ACTIONS(420),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(420),
    [sym_nextfile_statement] = ACTIONS(420),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [86] = {
    [sym__statement] = STATE(1232),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1232),
    [sym_if_statement] = STATE(1232),
    [sym_while_statement] = STATE(1232),
    [sym_do_while_statement] = STATE(1232),
    [sym_for_statement] = STATE(1232),
    [sym_for_in_statement] = STATE(1232),
    [sym_delete_statement] = STATE(1232),
    [sym_exit_statement] = STATE(1232),
    [sym_return_statement] = STATE(1232),
    [sym_switch_statement] = STATE(1232),
    [sym__io_statement] = STATE(1232),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1232),
    [sym_piped_io_statement] = STATE(1232),
    [sym_block] = STATE(1231),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(92),
    [aux_sym_if_statement_repeat1] = STATE(92),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(424),
    [sym_continue_statement] = ACTIONS(424),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(424),
    [sym_nextfile_statement] = ACTIONS(424),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [87] = {
    [sym__statement] = STATE(1276),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1276),
    [sym_if_statement] = STATE(1276),
    [sym_while_statement] = STATE(1276),
    [sym_do_while_statement] = STATE(1276),
    [sym_for_statement] = STATE(1276),
    [sym_for_in_statement] = STATE(1276),
    [sym_delete_statement] = STATE(1276),
    [sym_exit_statement] = STATE(1276),
    [sym_return_statement] = STATE(1276),
    [sym_switch_statement] = STATE(1276),
    [sym__io_statement] = STATE(1276),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1276),
    [sym_piped_io_statement] = STATE(1276),
    [sym_block] = STATE(1275),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(314),
    [sym_continue_statement] = ACTIONS(314),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(314),
    [sym_nextfile_statement] = ACTIONS(314),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [88] = {
    [sym__statement] = STATE(1278),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1278),
    [sym_if_statement] = STATE(1278),
    [sym_while_statement] = STATE(1278),
    [sym_do_while_statement] = STATE(1278),
    [sym_for_statement] = STATE(1278),
    [sym_for_in_statement] = STATE(1278),
    [sym_delete_statement] = STATE(1278),
    [sym_exit_statement] = STATE(1278),
    [sym_return_statement] = STATE(1278),
    [sym_switch_statement] = STATE(1278),
    [sym__io_statement] = STATE(1278),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1278),
    [sym_piped_io_statement] = STATE(1278),
    [sym_block] = STATE(1277),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(90),
    [aux_sym_if_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(584),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(586),
    [sym_continue_statement] = ACTIONS(586),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(586),
    [sym_nextfile_statement] = ACTIONS(586),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [89] = {
    [sym__statement] = STATE(1340),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1340),
    [sym_if_statement] = STATE(1340),
    [sym_while_statement] = STATE(1340),
    [sym_do_while_statement] = STATE(1340),
    [sym_for_statement] = STATE(1340),
    [sym_for_in_statement] = STATE(1340),
    [sym_delete_statement] = STATE(1340),
    [sym_exit_statement] = STATE(1340),
    [sym_return_statement] = STATE(1340),
    [sym_switch_statement] = STATE(1340),
    [sym__io_statement] = STATE(1340),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1340),
    [sym_piped_io_statement] = STATE(1340),
    [sym_block] = STATE(1337),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(74),
    [aux_sym_if_statement_repeat1] = STATE(74),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(496),
    [sym_continue_statement] = ACTIONS(496),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(496),
    [sym_nextfile_statement] = ACTIONS(496),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [90] = {
    [sym__statement] = STATE(1280),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1280),
    [sym_if_statement] = STATE(1280),
    [sym_while_statement] = STATE(1280),
    [sym_do_while_statement] = STATE(1280),
    [sym_for_statement] = STATE(1280),
    [sym_for_in_statement] = STATE(1280),
    [sym_delete_statement] = STATE(1280),
    [sym_exit_statement] = STATE(1280),
    [sym_return_statement] = STATE(1280),
    [sym_switch_statement] = STATE(1280),
    [sym__io_statement] = STATE(1280),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1280),
    [sym_piped_io_statement] = STATE(1280),
    [sym_block] = STATE(1279),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(590),
    [sym_continue_statement] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(590),
    [sym_nextfile_statement] = ACTIONS(590),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [91] = {
    [sym__statement] = STATE(1336),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1336),
    [sym_if_statement] = STATE(1336),
    [sym_while_statement] = STATE(1336),
    [sym_do_while_statement] = STATE(1336),
    [sym_for_statement] = STATE(1336),
    [sym_for_in_statement] = STATE(1336),
    [sym_delete_statement] = STATE(1336),
    [sym_exit_statement] = STATE(1336),
    [sym_return_statement] = STATE(1336),
    [sym_switch_statement] = STATE(1336),
    [sym__io_statement] = STATE(1336),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1336),
    [sym_piped_io_statement] = STATE(1336),
    [sym_block] = STATE(1334),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(75),
    [aux_sym_if_statement_repeat1] = STATE(75),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(504),
    [sym_nextfile_statement] = ACTIONS(504),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [92] = {
    [sym__statement] = STATE(1239),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1239),
    [sym_if_statement] = STATE(1239),
    [sym_while_statement] = STATE(1239),
    [sym_do_while_statement] = STATE(1239),
    [sym_for_statement] = STATE(1239),
    [sym_for_in_statement] = STATE(1239),
    [sym_delete_statement] = STATE(1239),
    [sym_exit_statement] = STATE(1239),
    [sym_return_statement] = STATE(1239),
    [sym_switch_statement] = STATE(1239),
    [sym__io_statement] = STATE(1239),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1239),
    [sym_piped_io_statement] = STATE(1239),
    [sym_block] = STATE(1238),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(428),
    [sym_continue_statement] = ACTIONS(428),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(428),
    [sym_nextfile_statement] = ACTIONS(428),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [93] = {
    [sym__statement] = STATE(1322),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1322),
    [sym_if_statement] = STATE(1322),
    [sym_while_statement] = STATE(1322),
    [sym_do_while_statement] = STATE(1322),
    [sym_for_statement] = STATE(1322),
    [sym_for_in_statement] = STATE(1322),
    [sym_delete_statement] = STATE(1322),
    [sym_exit_statement] = STATE(1322),
    [sym_return_statement] = STATE(1322),
    [sym_switch_statement] = STATE(1322),
    [sym__io_statement] = STATE(1322),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1322),
    [sym_piped_io_statement] = STATE(1322),
    [sym_block] = STATE(1360),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(70),
    [aux_sym_if_statement_repeat1] = STATE(70),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(594),
    [sym_continue_statement] = ACTIONS(594),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(594),
    [sym_nextfile_statement] = ACTIONS(594),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [94] = {
    [sym__statement] = STATE(1330),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1330),
    [sym_if_statement] = STATE(1330),
    [sym_while_statement] = STATE(1330),
    [sym_do_while_statement] = STATE(1330),
    [sym_for_statement] = STATE(1330),
    [sym_for_in_statement] = STATE(1330),
    [sym_delete_statement] = STATE(1330),
    [sym_exit_statement] = STATE(1330),
    [sym_return_statement] = STATE(1330),
    [sym_switch_statement] = STATE(1330),
    [sym__io_statement] = STATE(1330),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1330),
    [sym_piped_io_statement] = STATE(1330),
    [sym_block] = STATE(1329),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(77),
    [aux_sym_if_statement_repeat1] = STATE(77),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(514),
    [sym_continue_statement] = ACTIONS(514),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(514),
    [sym_nextfile_statement] = ACTIONS(514),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [95] = {
    [sym__statement] = STATE(1328),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1328),
    [sym_if_statement] = STATE(1328),
    [sym_while_statement] = STATE(1328),
    [sym_do_while_statement] = STATE(1328),
    [sym_for_statement] = STATE(1328),
    [sym_for_in_statement] = STATE(1328),
    [sym_delete_statement] = STATE(1328),
    [sym_exit_statement] = STATE(1328),
    [sym_return_statement] = STATE(1328),
    [sym_switch_statement] = STATE(1328),
    [sym__io_statement] = STATE(1328),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1328),
    [sym_piped_io_statement] = STATE(1328),
    [sym_block] = STATE(1326),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(78),
    [aux_sym_if_statement_repeat1] = STATE(78),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(532),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(534),
    [sym_continue_statement] = ACTIONS(534),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(534),
    [sym_nextfile_statement] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [96] = {
    [sym__statement] = STATE(1325),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1325),
    [sym_if_statement] = STATE(1325),
    [sym_while_statement] = STATE(1325),
    [sym_do_while_statement] = STATE(1325),
    [sym_for_statement] = STATE(1325),
    [sym_for_in_statement] = STATE(1325),
    [sym_delete_statement] = STATE(1325),
    [sym_exit_statement] = STATE(1325),
    [sym_return_statement] = STATE(1325),
    [sym_switch_statement] = STATE(1325),
    [sym__io_statement] = STATE(1325),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1325),
    [sym_piped_io_statement] = STATE(1325),
    [sym_block] = STATE(1324),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(538),
    [sym_continue_statement] = ACTIONS(538),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(538),
    [sym_nextfile_statement] = ACTIONS(538),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [97] = {
    [sym__statement] = STATE(1242),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1242),
    [sym_if_statement] = STATE(1242),
    [sym_while_statement] = STATE(1242),
    [sym_do_while_statement] = STATE(1242),
    [sym_for_statement] = STATE(1242),
    [sym_for_in_statement] = STATE(1242),
    [sym_delete_statement] = STATE(1242),
    [sym_exit_statement] = STATE(1242),
    [sym_return_statement] = STATE(1242),
    [sym_switch_statement] = STATE(1242),
    [sym__io_statement] = STATE(1242),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1242),
    [sym_piped_io_statement] = STATE(1242),
    [sym_block] = STATE(1240),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(113),
    [aux_sym_if_statement_repeat1] = STATE(113),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(476),
    [sym_continue_statement] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(476),
    [sym_nextfile_statement] = ACTIONS(476),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [98] = {
    [sym__statement] = STATE(1879),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1879),
    [sym_if_statement] = STATE(1879),
    [sym_while_statement] = STATE(1879),
    [sym_do_while_statement] = STATE(1879),
    [sym_for_statement] = STATE(1879),
    [sym_for_in_statement] = STATE(1879),
    [sym_delete_statement] = STATE(1879),
    [sym_exit_statement] = STATE(1879),
    [sym_return_statement] = STATE(1879),
    [sym_switch_statement] = STATE(1879),
    [sym__io_statement] = STATE(1879),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1879),
    [sym_piped_io_statement] = STATE(1879),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(57),
    [aux_sym_if_statement_repeat1] = STATE(57),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(596),
    [sym_continue_statement] = ACTIONS(596),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_RBRACE] = ACTIONS(598),
    [anon_sym_case] = ACTIONS(600),
    [anon_sym_default] = ACTIONS(600),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(596),
    [sym_nextfile_statement] = ACTIONS(596),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [99] = {
    [sym__statement] = STATE(1225),
    [sym__statement_separated] = STATE(1225),
    [sym__control_statement] = STATE(1225),
    [sym_if_statement] = STATE(1225),
    [sym_while_statement] = STATE(1225),
    [sym_do_while_statement] = STATE(1225),
    [sym_for_statement] = STATE(1225),
    [sym_for_in_statement] = STATE(1225),
    [sym_delete_statement] = STATE(1225),
    [sym_exit_statement] = STATE(1225),
    [sym_return_statement] = STATE(1225),
    [sym_switch_statement] = STATE(1225),
    [sym__io_statement] = STATE(1225),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1225),
    [sym_piped_io_statement] = STATE(1225),
    [sym_block] = STATE(1224),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(115),
    [aux_sym_if_statement_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(382),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(386),
    [sym_nextfile_statement] = ACTIONS(386),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [100] = {
    [sym__statement] = STATE(1244),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1244),
    [sym_if_statement] = STATE(1244),
    [sym_while_statement] = STATE(1244),
    [sym_do_while_statement] = STATE(1244),
    [sym_for_statement] = STATE(1244),
    [sym_for_in_statement] = STATE(1244),
    [sym_delete_statement] = STATE(1244),
    [sym_exit_statement] = STATE(1244),
    [sym_return_statement] = STATE(1244),
    [sym_switch_statement] = STATE(1244),
    [sym__io_statement] = STATE(1244),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1244),
    [sym_piped_io_statement] = STATE(1244),
    [sym_block] = STATE(1243),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(119),
    [aux_sym_if_statement_repeat1] = STATE(119),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(484),
    [sym_continue_statement] = ACTIONS(484),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(484),
    [sym_nextfile_statement] = ACTIONS(484),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [101] = {
    [sym__statement] = STATE(1246),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1246),
    [sym_if_statement] = STATE(1246),
    [sym_while_statement] = STATE(1246),
    [sym_do_while_statement] = STATE(1246),
    [sym_for_statement] = STATE(1246),
    [sym_for_in_statement] = STATE(1246),
    [sym_delete_statement] = STATE(1246),
    [sym_exit_statement] = STATE(1246),
    [sym_return_statement] = STATE(1246),
    [sym_switch_statement] = STATE(1246),
    [sym__io_statement] = STATE(1246),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1246),
    [sym_piped_io_statement] = STATE(1246),
    [sym_block] = STATE(1245),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(131),
    [aux_sym_if_statement_repeat1] = STATE(131),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(500),
    [sym_continue_statement] = ACTIONS(500),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(500),
    [sym_nextfile_statement] = ACTIONS(500),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [102] = {
    [sym__statement] = STATE(1369),
    [sym__statement_separated] = STATE(1369),
    [sym__control_statement] = STATE(1369),
    [sym_if_statement] = STATE(1369),
    [sym_while_statement] = STATE(1369),
    [sym_do_while_statement] = STATE(1369),
    [sym_for_statement] = STATE(1369),
    [sym_for_in_statement] = STATE(1369),
    [sym_delete_statement] = STATE(1369),
    [sym_exit_statement] = STATE(1369),
    [sym_return_statement] = STATE(1369),
    [sym_switch_statement] = STATE(1369),
    [sym__io_statement] = STATE(1369),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1369),
    [sym_piped_io_statement] = STATE(1369),
    [sym_block] = STATE(1371),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(60),
    [aux_sym_if_statement_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(300),
    [sym_continue_statement] = ACTIONS(300),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(300),
    [sym_nextfile_statement] = ACTIONS(300),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [103] = {
    [sym__statement] = STATE(1373),
    [sym__statement_separated] = STATE(1373),
    [sym__control_statement] = STATE(1373),
    [sym_if_statement] = STATE(1373),
    [sym_while_statement] = STATE(1373),
    [sym_do_while_statement] = STATE(1373),
    [sym_for_statement] = STATE(1373),
    [sym_for_in_statement] = STATE(1373),
    [sym_delete_statement] = STATE(1373),
    [sym_exit_statement] = STATE(1373),
    [sym_return_statement] = STATE(1373),
    [sym_switch_statement] = STATE(1373),
    [sym__io_statement] = STATE(1373),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1373),
    [sym_piped_io_statement] = STATE(1373),
    [sym_block] = STATE(1299),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(63),
    [aux_sym_if_statement_repeat1] = STATE(63),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(402),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(404),
    [sym_continue_statement] = ACTIONS(404),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(404),
    [sym_nextfile_statement] = ACTIONS(404),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [104] = {
    [sym__statement] = STATE(1248),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1248),
    [sym_if_statement] = STATE(1248),
    [sym_while_statement] = STATE(1248),
    [sym_do_while_statement] = STATE(1248),
    [sym_for_statement] = STATE(1248),
    [sym_for_in_statement] = STATE(1248),
    [sym_delete_statement] = STATE(1248),
    [sym_exit_statement] = STATE(1248),
    [sym_return_statement] = STATE(1248),
    [sym_switch_statement] = STATE(1248),
    [sym__io_statement] = STATE(1248),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1248),
    [sym_piped_io_statement] = STATE(1248),
    [sym_block] = STATE(1247),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(141),
    [aux_sym_if_statement_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(542),
    [sym_continue_statement] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(542),
    [sym_nextfile_statement] = ACTIONS(542),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [105] = {
    [sym__statement] = STATE(1370),
    [sym__statement_separated] = STATE(1370),
    [sym__control_statement] = STATE(1370),
    [sym_if_statement] = STATE(1370),
    [sym_while_statement] = STATE(1370),
    [sym_do_while_statement] = STATE(1370),
    [sym_for_statement] = STATE(1370),
    [sym_for_in_statement] = STATE(1370),
    [sym_delete_statement] = STATE(1370),
    [sym_exit_statement] = STATE(1370),
    [sym_return_statement] = STATE(1370),
    [sym_switch_statement] = STATE(1370),
    [sym__io_statement] = STATE(1370),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1370),
    [sym_piped_io_statement] = STATE(1370),
    [sym_block] = STATE(1367),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(406),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(408),
    [sym_continue_statement] = ACTIONS(408),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(408),
    [sym_nextfile_statement] = ACTIONS(408),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [106] = {
    [sym__statement] = STATE(1855),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1855),
    [sym_if_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_do_while_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_for_in_statement] = STATE(1855),
    [sym_delete_statement] = STATE(1855),
    [sym_exit_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_switch_statement] = STATE(1855),
    [sym__io_statement] = STATE(1855),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1855),
    [sym_piped_io_statement] = STATE(1855),
    [sym_block] = STATE(1856),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(604),
    [sym_continue_statement] = ACTIONS(604),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(604),
    [sym_nextfile_statement] = ACTIONS(604),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [107] = {
    [sym__statement] = STATE(1844),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1844),
    [sym_if_statement] = STATE(1844),
    [sym_while_statement] = STATE(1844),
    [sym_do_while_statement] = STATE(1844),
    [sym_for_statement] = STATE(1844),
    [sym_for_in_statement] = STATE(1844),
    [sym_delete_statement] = STATE(1844),
    [sym_exit_statement] = STATE(1844),
    [sym_return_statement] = STATE(1844),
    [sym_switch_statement] = STATE(1844),
    [sym__io_statement] = STATE(1844),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1844),
    [sym_piped_io_statement] = STATE(1844),
    [sym_block] = STATE(1846),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_comment] = STATE(32),
    [aux_sym_if_statement_repeat1] = STATE(32),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(606),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(608),
    [sym_continue_statement] = ACTIONS(608),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(608),
    [sym_nextfile_statement] = ACTIONS(608),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [108] = {
    [sym__statement] = STATE(1278),
    [sym__statement_separated] = STATE(1278),
    [sym__control_statement] = STATE(1278),
    [sym_if_statement] = STATE(1278),
    [sym_while_statement] = STATE(1278),
    [sym_do_while_statement] = STATE(1278),
    [sym_for_statement] = STATE(1278),
    [sym_for_in_statement] = STATE(1278),
    [sym_delete_statement] = STATE(1278),
    [sym_exit_statement] = STATE(1278),
    [sym_return_statement] = STATE(1278),
    [sym_switch_statement] = STATE(1278),
    [sym__io_statement] = STATE(1278),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1278),
    [sym_piped_io_statement] = STATE(1278),
    [sym_block] = STATE(1277),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(109),
    [aux_sym_if_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(584),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(586),
    [sym_continue_statement] = ACTIONS(586),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(586),
    [sym_nextfile_statement] = ACTIONS(586),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [109] = {
    [sym__statement] = STATE(1280),
    [sym__statement_separated] = STATE(1280),
    [sym__control_statement] = STATE(1280),
    [sym_if_statement] = STATE(1280),
    [sym_while_statement] = STATE(1280),
    [sym_do_while_statement] = STATE(1280),
    [sym_for_statement] = STATE(1280),
    [sym_for_in_statement] = STATE(1280),
    [sym_delete_statement] = STATE(1280),
    [sym_exit_statement] = STATE(1280),
    [sym_return_statement] = STATE(1280),
    [sym_switch_statement] = STATE(1280),
    [sym__io_statement] = STATE(1280),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1280),
    [sym_piped_io_statement] = STATE(1280),
    [sym_block] = STATE(1279),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(590),
    [sym_continue_statement] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(590),
    [sym_nextfile_statement] = ACTIONS(590),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [110] = {
    [sym__statement] = STATE(1353),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1353),
    [sym_if_statement] = STATE(1353),
    [sym_while_statement] = STATE(1353),
    [sym_do_while_statement] = STATE(1353),
    [sym_for_statement] = STATE(1353),
    [sym_for_in_statement] = STATE(1353),
    [sym_delete_statement] = STATE(1353),
    [sym_exit_statement] = STATE(1353),
    [sym_return_statement] = STATE(1353),
    [sym_switch_statement] = STATE(1353),
    [sym__io_statement] = STATE(1353),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1353),
    [sym_piped_io_statement] = STATE(1353),
    [sym_block] = STATE(1355),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(520),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(522),
    [sym_continue_statement] = ACTIONS(522),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(522),
    [sym_nextfile_statement] = ACTIONS(522),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [111] = {
    [sym__statement] = STATE(1357),
    [sym__statement_separated] = STATE(1357),
    [sym__control_statement] = STATE(1357),
    [sym_if_statement] = STATE(1357),
    [sym_while_statement] = STATE(1357),
    [sym_do_while_statement] = STATE(1357),
    [sym_for_statement] = STATE(1357),
    [sym_for_in_statement] = STATE(1357),
    [sym_delete_statement] = STATE(1357),
    [sym_exit_statement] = STATE(1357),
    [sym_return_statement] = STATE(1357),
    [sym_switch_statement] = STATE(1357),
    [sym__io_statement] = STATE(1357),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1357),
    [sym_piped_io_statement] = STATE(1357),
    [sym_block] = STATE(1356),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(488),
    [sym_continue_statement] = ACTIONS(488),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(488),
    [sym_nextfile_statement] = ACTIONS(488),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [112] = {
    [sym__statement] = STATE(1354),
    [sym__statement_separated] = STATE(1354),
    [sym__control_statement] = STATE(1354),
    [sym_if_statement] = STATE(1354),
    [sym_while_statement] = STATE(1354),
    [sym_do_while_statement] = STATE(1354),
    [sym_for_statement] = STATE(1354),
    [sym_for_in_statement] = STATE(1354),
    [sym_delete_statement] = STATE(1354),
    [sym_exit_statement] = STATE(1354),
    [sym_return_statement] = STATE(1354),
    [sym_switch_statement] = STATE(1354),
    [sym__io_statement] = STATE(1354),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1354),
    [sym_piped_io_statement] = STATE(1354),
    [sym_block] = STATE(1352),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(492),
    [sym_continue_statement] = ACTIONS(492),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(492),
    [sym_nextfile_statement] = ACTIONS(492),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [113] = {
    [sym__statement] = STATE(1254),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1254),
    [sym_if_statement] = STATE(1254),
    [sym_while_statement] = STATE(1254),
    [sym_do_while_statement] = STATE(1254),
    [sym_for_statement] = STATE(1254),
    [sym_for_in_statement] = STATE(1254),
    [sym_delete_statement] = STATE(1254),
    [sym_exit_statement] = STATE(1254),
    [sym_return_statement] = STATE(1254),
    [sym_switch_statement] = STATE(1254),
    [sym__io_statement] = STATE(1254),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1254),
    [sym_piped_io_statement] = STATE(1254),
    [sym_block] = STATE(1253),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(550),
    [sym_continue_statement] = ACTIONS(550),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(550),
    [sym_nextfile_statement] = ACTIONS(550),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [114] = {
    [sym__statement] = STATE(1376),
    [sym__statement_separated] = STATE(1376),
    [sym__control_statement] = STATE(1376),
    [sym_if_statement] = STATE(1376),
    [sym_while_statement] = STATE(1376),
    [sym_do_while_statement] = STATE(1376),
    [sym_for_statement] = STATE(1376),
    [sym_for_in_statement] = STATE(1376),
    [sym_delete_statement] = STATE(1376),
    [sym_exit_statement] = STATE(1376),
    [sym_return_statement] = STATE(1376),
    [sym_switch_statement] = STATE(1376),
    [sym__io_statement] = STATE(1376),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1376),
    [sym_piped_io_statement] = STATE(1376),
    [sym_block] = STATE(1392),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(143),
    [aux_sym_if_statement_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(610),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(612),
    [sym_continue_statement] = ACTIONS(612),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(612),
    [sym_nextfile_statement] = ACTIONS(612),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [115] = {
    [sym__statement] = STATE(1229),
    [sym__statement_separated] = STATE(1229),
    [sym__control_statement] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_while_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_delete_statement] = STATE(1229),
    [sym_exit_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym__io_statement] = STATE(1229),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1229),
    [sym_piped_io_statement] = STATE(1229),
    [sym_block] = STATE(1228),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(416),
    [sym_continue_statement] = ACTIONS(416),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(416),
    [sym_nextfile_statement] = ACTIONS(416),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [116] = {
    [sym__statement] = STATE(1232),
    [sym__statement_separated] = STATE(1232),
    [sym__control_statement] = STATE(1232),
    [sym_if_statement] = STATE(1232),
    [sym_while_statement] = STATE(1232),
    [sym_do_while_statement] = STATE(1232),
    [sym_for_statement] = STATE(1232),
    [sym_for_in_statement] = STATE(1232),
    [sym_delete_statement] = STATE(1232),
    [sym_exit_statement] = STATE(1232),
    [sym_return_statement] = STATE(1232),
    [sym_switch_statement] = STATE(1232),
    [sym__io_statement] = STATE(1232),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1232),
    [sym_piped_io_statement] = STATE(1232),
    [sym_block] = STATE(1231),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(125),
    [aux_sym_if_statement_repeat1] = STATE(125),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(424),
    [sym_continue_statement] = ACTIONS(424),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(424),
    [sym_nextfile_statement] = ACTIONS(424),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [117] = {
    [sym__statement] = STATE(1340),
    [sym__statement_separated] = STATE(1340),
    [sym__control_statement] = STATE(1340),
    [sym_if_statement] = STATE(1340),
    [sym_while_statement] = STATE(1340),
    [sym_do_while_statement] = STATE(1340),
    [sym_for_statement] = STATE(1340),
    [sym_for_in_statement] = STATE(1340),
    [sym_delete_statement] = STATE(1340),
    [sym_exit_statement] = STATE(1340),
    [sym_return_statement] = STATE(1340),
    [sym_switch_statement] = STATE(1340),
    [sym__io_statement] = STATE(1340),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1340),
    [sym_piped_io_statement] = STATE(1340),
    [sym_block] = STATE(1337),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(105),
    [aux_sym_if_statement_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(496),
    [sym_continue_statement] = ACTIONS(496),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(496),
    [sym_nextfile_statement] = ACTIONS(496),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [118] = {
    [sym__statement] = STATE(1336),
    [sym__statement_separated] = STATE(1336),
    [sym__control_statement] = STATE(1336),
    [sym_if_statement] = STATE(1336),
    [sym_while_statement] = STATE(1336),
    [sym_do_while_statement] = STATE(1336),
    [sym_for_statement] = STATE(1336),
    [sym_for_in_statement] = STATE(1336),
    [sym_delete_statement] = STATE(1336),
    [sym_exit_statement] = STATE(1336),
    [sym_return_statement] = STATE(1336),
    [sym_switch_statement] = STATE(1336),
    [sym__io_statement] = STATE(1336),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1336),
    [sym_piped_io_statement] = STATE(1336),
    [sym_block] = STATE(1334),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(14),
    [aux_sym_if_statement_repeat1] = STATE(14),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(504),
    [sym_nextfile_statement] = ACTIONS(504),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [119] = {
    [sym__statement] = STATE(1256),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1256),
    [sym_if_statement] = STATE(1256),
    [sym_while_statement] = STATE(1256),
    [sym_do_while_statement] = STATE(1256),
    [sym_for_statement] = STATE(1256),
    [sym_for_in_statement] = STATE(1256),
    [sym_delete_statement] = STATE(1256),
    [sym_exit_statement] = STATE(1256),
    [sym_return_statement] = STATE(1256),
    [sym_switch_statement] = STATE(1256),
    [sym__io_statement] = STATE(1256),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1256),
    [sym_piped_io_statement] = STATE(1256),
    [sym_block] = STATE(1255),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(566),
    [sym_continue_statement] = ACTIONS(566),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(566),
    [sym_nextfile_statement] = ACTIONS(566),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [120] = {
    [sym__statement] = STATE(1330),
    [sym__statement_separated] = STATE(1330),
    [sym__control_statement] = STATE(1330),
    [sym_if_statement] = STATE(1330),
    [sym_while_statement] = STATE(1330),
    [sym_do_while_statement] = STATE(1330),
    [sym_for_statement] = STATE(1330),
    [sym_for_in_statement] = STATE(1330),
    [sym_delete_statement] = STATE(1330),
    [sym_exit_statement] = STATE(1330),
    [sym_return_statement] = STATE(1330),
    [sym_switch_statement] = STATE(1330),
    [sym__io_statement] = STATE(1330),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1330),
    [sym_piped_io_statement] = STATE(1330),
    [sym_block] = STATE(1329),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(111),
    [aux_sym_if_statement_repeat1] = STATE(111),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(514),
    [sym_continue_statement] = ACTIONS(514),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(514),
    [sym_nextfile_statement] = ACTIONS(514),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [121] = {
    [sym__statement] = STATE(1328),
    [sym__statement_separated] = STATE(1328),
    [sym__control_statement] = STATE(1328),
    [sym_if_statement] = STATE(1328),
    [sym_while_statement] = STATE(1328),
    [sym_do_while_statement] = STATE(1328),
    [sym_for_statement] = STATE(1328),
    [sym_for_in_statement] = STATE(1328),
    [sym_delete_statement] = STATE(1328),
    [sym_exit_statement] = STATE(1328),
    [sym_return_statement] = STATE(1328),
    [sym_switch_statement] = STATE(1328),
    [sym__io_statement] = STATE(1328),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1328),
    [sym_piped_io_statement] = STATE(1328),
    [sym_block] = STATE(1326),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(112),
    [aux_sym_if_statement_repeat1] = STATE(112),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(532),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(534),
    [sym_continue_statement] = ACTIONS(534),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(534),
    [sym_nextfile_statement] = ACTIONS(534),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [122] = {
    [sym__statement] = STATE(1325),
    [sym__statement_separated] = STATE(1325),
    [sym__control_statement] = STATE(1325),
    [sym_if_statement] = STATE(1325),
    [sym_while_statement] = STATE(1325),
    [sym_do_while_statement] = STATE(1325),
    [sym_for_statement] = STATE(1325),
    [sym_for_in_statement] = STATE(1325),
    [sym_delete_statement] = STATE(1325),
    [sym_exit_statement] = STATE(1325),
    [sym_return_statement] = STATE(1325),
    [sym_switch_statement] = STATE(1325),
    [sym__io_statement] = STATE(1325),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1325),
    [sym_piped_io_statement] = STATE(1325),
    [sym_block] = STATE(1324),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(538),
    [sym_continue_statement] = ACTIONS(538),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(538),
    [sym_nextfile_statement] = ACTIONS(538),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [123] = {
    [sym__statement] = STATE(1258),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1258),
    [sym_if_statement] = STATE(1258),
    [sym_while_statement] = STATE(1258),
    [sym_do_while_statement] = STATE(1258),
    [sym_for_statement] = STATE(1258),
    [sym_for_in_statement] = STATE(1258),
    [sym_delete_statement] = STATE(1258),
    [sym_exit_statement] = STATE(1258),
    [sym_return_statement] = STATE(1258),
    [sym_switch_statement] = STATE(1258),
    [sym__io_statement] = STATE(1258),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1258),
    [sym_piped_io_statement] = STATE(1258),
    [sym_block] = STATE(1257),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(140),
    [aux_sym_if_statement_repeat1] = STATE(140),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(570),
    [sym_nextfile_statement] = ACTIONS(570),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [124] = {
    [sym__statement] = STATE(1276),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1276),
    [sym_if_statement] = STATE(1276),
    [sym_while_statement] = STATE(1276),
    [sym_do_while_statement] = STATE(1276),
    [sym_for_statement] = STATE(1276),
    [sym_for_in_statement] = STATE(1276),
    [sym_delete_statement] = STATE(1276),
    [sym_exit_statement] = STATE(1276),
    [sym_return_statement] = STATE(1276),
    [sym_switch_statement] = STATE(1276),
    [sym__io_statement] = STATE(1276),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1276),
    [sym_piped_io_statement] = STATE(1276),
    [sym_block] = STATE(1275),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(314),
    [sym_continue_statement] = ACTIONS(314),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(314),
    [sym_nextfile_statement] = ACTIONS(314),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [125] = {
    [sym__statement] = STATE(1239),
    [sym__statement_separated] = STATE(1239),
    [sym__control_statement] = STATE(1239),
    [sym_if_statement] = STATE(1239),
    [sym_while_statement] = STATE(1239),
    [sym_do_while_statement] = STATE(1239),
    [sym_for_statement] = STATE(1239),
    [sym_for_in_statement] = STATE(1239),
    [sym_delete_statement] = STATE(1239),
    [sym_exit_statement] = STATE(1239),
    [sym_return_statement] = STATE(1239),
    [sym_switch_statement] = STATE(1239),
    [sym__io_statement] = STATE(1239),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1239),
    [sym_piped_io_statement] = STATE(1239),
    [sym_block] = STATE(1238),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(428),
    [sym_continue_statement] = ACTIONS(428),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(428),
    [sym_nextfile_statement] = ACTIONS(428),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [126] = {
    [sym__statement] = STATE(1242),
    [sym__statement_separated] = STATE(1242),
    [sym__control_statement] = STATE(1242),
    [sym_if_statement] = STATE(1242),
    [sym_while_statement] = STATE(1242),
    [sym_do_while_statement] = STATE(1242),
    [sym_for_statement] = STATE(1242),
    [sym_for_in_statement] = STATE(1242),
    [sym_delete_statement] = STATE(1242),
    [sym_exit_statement] = STATE(1242),
    [sym_return_statement] = STATE(1242),
    [sym_switch_statement] = STATE(1242),
    [sym__io_statement] = STATE(1242),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1242),
    [sym_piped_io_statement] = STATE(1242),
    [sym_block] = STATE(1240),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(81),
    [aux_sym_if_statement_repeat1] = STATE(81),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(476),
    [sym_continue_statement] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(476),
    [sym_nextfile_statement] = ACTIONS(476),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [127] = {
    [sym__statement] = STATE(1317),
    [sym__statement_separated] = STATE(1317),
    [sym__control_statement] = STATE(1317),
    [sym_if_statement] = STATE(1317),
    [sym_while_statement] = STATE(1317),
    [sym_do_while_statement] = STATE(1317),
    [sym_for_statement] = STATE(1317),
    [sym_for_in_statement] = STATE(1317),
    [sym_delete_statement] = STATE(1317),
    [sym_exit_statement] = STATE(1317),
    [sym_return_statement] = STATE(1317),
    [sym_switch_statement] = STATE(1317),
    [sym__io_statement] = STATE(1317),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1317),
    [sym_piped_io_statement] = STATE(1317),
    [sym_block] = STATE(1304),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(122),
    [aux_sym_if_statement_repeat1] = STATE(122),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(574),
    [sym_continue_statement] = ACTIONS(574),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(574),
    [sym_nextfile_statement] = ACTIONS(574),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [128] = {
    [sym__statement] = STATE(1300),
    [sym__statement_separated] = STATE(1300),
    [sym__control_statement] = STATE(1300),
    [sym_if_statement] = STATE(1300),
    [sym_while_statement] = STATE(1300),
    [sym_do_while_statement] = STATE(1300),
    [sym_for_statement] = STATE(1300),
    [sym_for_in_statement] = STATE(1300),
    [sym_delete_statement] = STATE(1300),
    [sym_exit_statement] = STATE(1300),
    [sym_return_statement] = STATE(1300),
    [sym_switch_statement] = STATE(1300),
    [sym__io_statement] = STATE(1300),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1300),
    [sym_piped_io_statement] = STATE(1300),
    [sym_block] = STATE(1312),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(578),
    [sym_nextfile_statement] = ACTIONS(578),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [129] = {
    [sym__statement] = STATE(1386),
    [sym__statement_separated] = STATE(1386),
    [sym__control_statement] = STATE(1386),
    [sym_if_statement] = STATE(1386),
    [sym_while_statement] = STATE(1386),
    [sym_do_while_statement] = STATE(1386),
    [sym_for_statement] = STATE(1386),
    [sym_for_in_statement] = STATE(1386),
    [sym_delete_statement] = STATE(1386),
    [sym_exit_statement] = STATE(1386),
    [sym_return_statement] = STATE(1386),
    [sym_switch_statement] = STATE(1386),
    [sym__io_statement] = STATE(1386),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1386),
    [sym_piped_io_statement] = STATE(1386),
    [sym_block] = STATE(1385),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(614),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(616),
    [sym_continue_statement] = ACTIONS(616),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(616),
    [sym_nextfile_statement] = ACTIONS(616),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [130] = {
    [sym__statement] = STATE(1244),
    [sym__statement_separated] = STATE(1244),
    [sym__control_statement] = STATE(1244),
    [sym_if_statement] = STATE(1244),
    [sym_while_statement] = STATE(1244),
    [sym_do_while_statement] = STATE(1244),
    [sym_for_statement] = STATE(1244),
    [sym_for_in_statement] = STATE(1244),
    [sym_delete_statement] = STATE(1244),
    [sym_exit_statement] = STATE(1244),
    [sym_return_statement] = STATE(1244),
    [sym_switch_statement] = STATE(1244),
    [sym__io_statement] = STATE(1244),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1244),
    [sym_piped_io_statement] = STATE(1244),
    [sym_block] = STATE(1243),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(64),
    [aux_sym_if_statement_repeat1] = STATE(64),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(484),
    [sym_continue_statement] = ACTIONS(484),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(484),
    [sym_nextfile_statement] = ACTIONS(484),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [131] = {
    [sym__statement] = STATE(1260),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1260),
    [sym_if_statement] = STATE(1260),
    [sym_while_statement] = STATE(1260),
    [sym_do_while_statement] = STATE(1260),
    [sym_for_statement] = STATE(1260),
    [sym_for_in_statement] = STATE(1260),
    [sym_delete_statement] = STATE(1260),
    [sym_exit_statement] = STATE(1260),
    [sym_return_statement] = STATE(1260),
    [sym_switch_statement] = STATE(1260),
    [sym__io_statement] = STATE(1260),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1260),
    [sym_piped_io_statement] = STATE(1260),
    [sym_block] = STATE(1259),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(546),
    [sym_continue_statement] = ACTIONS(546),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(546),
    [sym_nextfile_statement] = ACTIONS(546),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [132] = {
    [sym__statement] = STATE(1246),
    [sym__statement_separated] = STATE(1246),
    [sym__control_statement] = STATE(1246),
    [sym_if_statement] = STATE(1246),
    [sym_while_statement] = STATE(1246),
    [sym_do_while_statement] = STATE(1246),
    [sym_for_statement] = STATE(1246),
    [sym_for_in_statement] = STATE(1246),
    [sym_delete_statement] = STATE(1246),
    [sym_exit_statement] = STATE(1246),
    [sym_return_statement] = STATE(1246),
    [sym_switch_statement] = STATE(1246),
    [sym__io_statement] = STATE(1246),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1246),
    [sym_piped_io_statement] = STATE(1246),
    [sym_block] = STATE(1245),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(55),
    [aux_sym_if_statement_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(500),
    [sym_continue_statement] = ACTIONS(500),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(500),
    [sym_nextfile_statement] = ACTIONS(500),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [133] = {
    [sym__statement] = STATE(1280),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1280),
    [sym_if_statement] = STATE(1280),
    [sym_while_statement] = STATE(1280),
    [sym_do_while_statement] = STATE(1280),
    [sym_for_statement] = STATE(1280),
    [sym_for_in_statement] = STATE(1280),
    [sym_delete_statement] = STATE(1280),
    [sym_exit_statement] = STATE(1280),
    [sym_return_statement] = STATE(1280),
    [sym_switch_statement] = STATE(1280),
    [sym__io_statement] = STATE(1280),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1280),
    [sym_piped_io_statement] = STATE(1280),
    [sym_block] = STATE(1279),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(590),
    [sym_continue_statement] = ACTIONS(590),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(590),
    [sym_nextfile_statement] = ACTIONS(590),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [134] = {
    [sym__statement] = STATE(1317),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1317),
    [sym_if_statement] = STATE(1317),
    [sym_while_statement] = STATE(1317),
    [sym_do_while_statement] = STATE(1317),
    [sym_for_statement] = STATE(1317),
    [sym_for_in_statement] = STATE(1317),
    [sym_delete_statement] = STATE(1317),
    [sym_exit_statement] = STATE(1317),
    [sym_return_statement] = STATE(1317),
    [sym_switch_statement] = STATE(1317),
    [sym__io_statement] = STATE(1317),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1317),
    [sym_piped_io_statement] = STATE(1317),
    [sym_block] = STATE(1304),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(96),
    [aux_sym_if_statement_repeat1] = STATE(96),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(574),
    [sym_continue_statement] = ACTIONS(574),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(574),
    [sym_nextfile_statement] = ACTIONS(574),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [135] = {
    [sym__statement] = STATE(1278),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1278),
    [sym_if_statement] = STATE(1278),
    [sym_while_statement] = STATE(1278),
    [sym_do_while_statement] = STATE(1278),
    [sym_for_statement] = STATE(1278),
    [sym_for_in_statement] = STATE(1278),
    [sym_delete_statement] = STATE(1278),
    [sym_exit_statement] = STATE(1278),
    [sym_return_statement] = STATE(1278),
    [sym_switch_statement] = STATE(1278),
    [sym__io_statement] = STATE(1278),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1278),
    [sym_piped_io_statement] = STATE(1278),
    [sym_block] = STATE(1277),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(133),
    [aux_sym_if_statement_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(584),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(586),
    [sym_continue_statement] = ACTIONS(586),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(586),
    [sym_nextfile_statement] = ACTIONS(586),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [136] = {
    [sym__statement] = STATE(1248),
    [sym__statement_separated] = STATE(1248),
    [sym__control_statement] = STATE(1248),
    [sym_if_statement] = STATE(1248),
    [sym_while_statement] = STATE(1248),
    [sym_do_while_statement] = STATE(1248),
    [sym_for_statement] = STATE(1248),
    [sym_for_in_statement] = STATE(1248),
    [sym_delete_statement] = STATE(1248),
    [sym_exit_statement] = STATE(1248),
    [sym_return_statement] = STATE(1248),
    [sym_switch_statement] = STATE(1248),
    [sym__io_statement] = STATE(1248),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1248),
    [sym_piped_io_statement] = STATE(1248),
    [sym_block] = STATE(1247),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(49),
    [aux_sym_if_statement_repeat1] = STATE(49),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(542),
    [sym_continue_statement] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(542),
    [sym_nextfile_statement] = ACTIONS(542),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [137] = {
    [sym__statement] = STATE(1274),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1274),
    [sym_if_statement] = STATE(1274),
    [sym_while_statement] = STATE(1274),
    [sym_do_while_statement] = STATE(1274),
    [sym_for_statement] = STATE(1274),
    [sym_for_in_statement] = STATE(1274),
    [sym_delete_statement] = STATE(1274),
    [sym_exit_statement] = STATE(1274),
    [sym_return_statement] = STATE(1274),
    [sym_switch_statement] = STATE(1274),
    [sym__io_statement] = STATE(1274),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1274),
    [sym_piped_io_statement] = STATE(1274),
    [sym_block] = STATE(1272),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(420),
    [sym_continue_statement] = ACTIONS(420),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(420),
    [sym_nextfile_statement] = ACTIONS(420),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [138] = {
    [sym__statement] = STATE(1322),
    [sym__statement_separated] = STATE(1322),
    [sym__control_statement] = STATE(1322),
    [sym_if_statement] = STATE(1322),
    [sym_while_statement] = STATE(1322),
    [sym_do_while_statement] = STATE(1322),
    [sym_for_statement] = STATE(1322),
    [sym_for_in_statement] = STATE(1322),
    [sym_delete_statement] = STATE(1322),
    [sym_exit_statement] = STATE(1322),
    [sym_return_statement] = STATE(1322),
    [sym_switch_statement] = STATE(1322),
    [sym__io_statement] = STATE(1322),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1322),
    [sym_piped_io_statement] = STATE(1322),
    [sym_block] = STATE(1360),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_comment] = STATE(128),
    [aux_sym_if_statement_repeat1] = STATE(128),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(594),
    [sym_continue_statement] = ACTIONS(594),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(594),
    [sym_nextfile_statement] = ACTIONS(594),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [139] = {
    [sym__statement] = STATE(1381),
    [sym__statement_separated] = STATE(1381),
    [sym__control_statement] = STATE(1381),
    [sym_if_statement] = STATE(1381),
    [sym_while_statement] = STATE(1381),
    [sym_do_while_statement] = STATE(1381),
    [sym_for_statement] = STATE(1381),
    [sym_for_in_statement] = STATE(1381),
    [sym_delete_statement] = STATE(1381),
    [sym_exit_statement] = STATE(1381),
    [sym_return_statement] = STATE(1381),
    [sym_switch_statement] = STATE(1381),
    [sym__io_statement] = STATE(1381),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1381),
    [sym_piped_io_statement] = STATE(1381),
    [sym_block] = STATE(1379),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(129),
    [aux_sym_if_statement_repeat1] = STATE(129),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(618),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(620),
    [sym_continue_statement] = ACTIONS(620),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(620),
    [sym_nextfile_statement] = ACTIONS(620),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [140] = {
    [sym__statement] = STATE(1271),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1271),
    [sym_if_statement] = STATE(1271),
    [sym_while_statement] = STATE(1271),
    [sym_do_while_statement] = STATE(1271),
    [sym_for_statement] = STATE(1271),
    [sym_for_in_statement] = STATE(1271),
    [sym_delete_statement] = STATE(1271),
    [sym_exit_statement] = STATE(1271),
    [sym_return_statement] = STATE(1271),
    [sym_switch_statement] = STATE(1271),
    [sym__io_statement] = STATE(1271),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1271),
    [sym_piped_io_statement] = STATE(1271),
    [sym_block] = STATE(1270),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(478),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(480),
    [sym_continue_statement] = ACTIONS(480),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(480),
    [sym_nextfile_statement] = ACTIONS(480),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [141] = {
    [sym__statement] = STATE(1262),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1262),
    [sym_if_statement] = STATE(1262),
    [sym_while_statement] = STATE(1262),
    [sym_do_while_statement] = STATE(1262),
    [sym_for_statement] = STATE(1262),
    [sym_for_in_statement] = STATE(1262),
    [sym_delete_statement] = STATE(1262),
    [sym_exit_statement] = STATE(1262),
    [sym_return_statement] = STATE(1262),
    [sym_switch_statement] = STATE(1262),
    [sym__io_statement] = STATE(1262),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1262),
    [sym_piped_io_statement] = STATE(1262),
    [sym_block] = STATE(1261),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(528),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(530),
    [sym_continue_statement] = ACTIONS(530),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(530),
    [sym_nextfile_statement] = ACTIONS(530),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [142] = {
    [sym__statement] = STATE(1267),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1267),
    [sym_if_statement] = STATE(1267),
    [sym_while_statement] = STATE(1267),
    [sym_do_while_statement] = STATE(1267),
    [sym_for_statement] = STATE(1267),
    [sym_for_in_statement] = STATE(1267),
    [sym_delete_statement] = STATE(1267),
    [sym_exit_statement] = STATE(1267),
    [sym_return_statement] = STATE(1267),
    [sym_switch_statement] = STATE(1267),
    [sym__io_statement] = STATE(1267),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1267),
    [sym_piped_io_statement] = STATE(1267),
    [sym_block] = STATE(1265),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(124),
    [aux_sym_if_statement_repeat1] = STATE(124),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(516),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(518),
    [sym_continue_statement] = ACTIONS(518),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(518),
    [sym_nextfile_statement] = ACTIONS(518),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [143] = {
    [sym__statement] = STATE(1389),
    [sym__statement_separated] = STATE(1389),
    [sym__control_statement] = STATE(1389),
    [sym_if_statement] = STATE(1389),
    [sym_while_statement] = STATE(1389),
    [sym_do_while_statement] = STATE(1389),
    [sym_for_statement] = STATE(1389),
    [sym_for_in_statement] = STATE(1389),
    [sym_delete_statement] = STATE(1389),
    [sym_exit_statement] = STATE(1389),
    [sym_return_statement] = STATE(1389),
    [sym_switch_statement] = STATE(1389),
    [sym__io_statement] = STATE(1389),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1389),
    [sym_piped_io_statement] = STATE(1389),
    [sym_block] = STATE(1391),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(622),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(624),
    [sym_continue_statement] = ACTIONS(624),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(624),
    [sym_nextfile_statement] = ACTIONS(624),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [144] = {
    [sym__statement] = STATE(1938),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1938),
    [sym_if_statement] = STATE(1938),
    [sym_while_statement] = STATE(1938),
    [sym_do_while_statement] = STATE(1938),
    [sym_for_statement] = STATE(1938),
    [sym_for_in_statement] = STATE(1938),
    [sym_delete_statement] = STATE(1938),
    [sym_exit_statement] = STATE(1938),
    [sym_return_statement] = STATE(1938),
    [sym_switch_statement] = STATE(1938),
    [sym__io_statement] = STATE(1938),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1938),
    [sym_piped_io_statement] = STATE(1938),
    [sym_block] = STATE(1965),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(147),
    [aux_sym_if_statement_repeat1] = STATE(147),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(626),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(628),
    [sym_continue_statement] = ACTIONS(628),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(628),
    [sym_nextfile_statement] = ACTIONS(628),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [145] = {
    [sym__statement] = STATE(1322),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1322),
    [sym_if_statement] = STATE(1322),
    [sym_while_statement] = STATE(1322),
    [sym_do_while_statement] = STATE(1322),
    [sym_for_statement] = STATE(1322),
    [sym_for_in_statement] = STATE(1322),
    [sym_delete_statement] = STATE(1322),
    [sym_exit_statement] = STATE(1322),
    [sym_return_statement] = STATE(1322),
    [sym_switch_statement] = STATE(1322),
    [sym__io_statement] = STATE(1322),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1322),
    [sym_piped_io_statement] = STATE(1322),
    [sym_block] = STATE(1360),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(148),
    [aux_sym_if_statement_repeat1] = STATE(148),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(592),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(594),
    [sym_continue_statement] = ACTIONS(594),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(594),
    [sym_nextfile_statement] = ACTIONS(594),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [146] = {
    [sym__statement] = STATE(1264),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1264),
    [sym_if_statement] = STATE(1264),
    [sym_while_statement] = STATE(1264),
    [sym_do_while_statement] = STATE(1264),
    [sym_for_statement] = STATE(1264),
    [sym_for_in_statement] = STATE(1264),
    [sym_delete_statement] = STATE(1264),
    [sym_exit_statement] = STATE(1264),
    [sym_return_statement] = STATE(1264),
    [sym_switch_statement] = STATE(1264),
    [sym__io_statement] = STATE(1264),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1264),
    [sym_piped_io_statement] = STATE(1264),
    [sym_block] = STATE(1263),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(137),
    [aux_sym_if_statement_repeat1] = STATE(137),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(524),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(526),
    [sym_continue_statement] = ACTIONS(526),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(526),
    [sym_nextfile_statement] = ACTIONS(526),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [147] = {
    [sym__statement] = STATE(1948),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1948),
    [sym_if_statement] = STATE(1948),
    [sym_while_statement] = STATE(1948),
    [sym_do_while_statement] = STATE(1948),
    [sym_for_statement] = STATE(1948),
    [sym_for_in_statement] = STATE(1948),
    [sym_delete_statement] = STATE(1948),
    [sym_exit_statement] = STATE(1948),
    [sym_return_statement] = STATE(1948),
    [sym_switch_statement] = STATE(1948),
    [sym__io_statement] = STATE(1948),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1948),
    [sym_piped_io_statement] = STATE(1948),
    [sym_block] = STATE(1955),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(632),
    [sym_continue_statement] = ACTIONS(632),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(632),
    [sym_nextfile_statement] = ACTIONS(632),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [148] = {
    [sym__statement] = STATE(1300),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1300),
    [sym_if_statement] = STATE(1300),
    [sym_while_statement] = STATE(1300),
    [sym_do_while_statement] = STATE(1300),
    [sym_for_statement] = STATE(1300),
    [sym_for_in_statement] = STATE(1300),
    [sym_delete_statement] = STATE(1300),
    [sym_exit_statement] = STATE(1300),
    [sym_return_statement] = STATE(1300),
    [sym_switch_statement] = STATE(1300),
    [sym__io_statement] = STATE(1300),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1300),
    [sym_piped_io_statement] = STATE(1300),
    [sym_block] = STATE(1312),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(578),
    [sym_continue_statement] = ACTIONS(578),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(578),
    [sym_nextfile_statement] = ACTIONS(578),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [149] = {
    [sym__statement] = STATE(1989),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1989),
    [sym_if_statement] = STATE(1989),
    [sym_while_statement] = STATE(1989),
    [sym_do_while_statement] = STATE(1989),
    [sym_for_statement] = STATE(1989),
    [sym_for_in_statement] = STATE(1989),
    [sym_delete_statement] = STATE(1989),
    [sym_exit_statement] = STATE(1989),
    [sym_return_statement] = STATE(1989),
    [sym_switch_statement] = STATE(1989),
    [sym__io_statement] = STATE(1989),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1989),
    [sym_piped_io_statement] = STATE(1989),
    [sym_block] = STATE(2264),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(151),
    [aux_sym_if_statement_repeat1] = STATE(151),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(634),
    [sym_continue_statement] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(634),
    [sym_nextfile_statement] = ACTIONS(634),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [150] = {
    [sym__statement] = STATE(2005),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(2005),
    [sym_if_statement] = STATE(2005),
    [sym_while_statement] = STATE(2005),
    [sym_do_while_statement] = STATE(2005),
    [sym_for_statement] = STATE(2005),
    [sym_for_in_statement] = STATE(2005),
    [sym_delete_statement] = STATE(2005),
    [sym_exit_statement] = STATE(2005),
    [sym_return_statement] = STATE(2005),
    [sym_switch_statement] = STATE(2005),
    [sym__io_statement] = STATE(2005),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(2005),
    [sym_piped_io_statement] = STATE(2005),
    [sym_block] = STATE(2150),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(152),
    [aux_sym_if_statement_repeat1] = STATE(152),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(636),
    [sym_continue_statement] = ACTIONS(636),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(636),
    [sym_nextfile_statement] = ACTIONS(636),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [151] = {
    [sym__statement] = STATE(1981),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1981),
    [sym_if_statement] = STATE(1981),
    [sym_while_statement] = STATE(1981),
    [sym_do_while_statement] = STATE(1981),
    [sym_for_statement] = STATE(1981),
    [sym_for_in_statement] = STATE(1981),
    [sym_delete_statement] = STATE(1981),
    [sym_exit_statement] = STATE(1981),
    [sym_return_statement] = STATE(1981),
    [sym_switch_statement] = STATE(1981),
    [sym__io_statement] = STATE(1981),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1981),
    [sym_piped_io_statement] = STATE(1981),
    [sym_block] = STATE(2268),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(638),
    [sym_nextfile_statement] = ACTIONS(638),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [152] = {
    [sym__statement] = STATE(2010),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(2010),
    [sym_if_statement] = STATE(2010),
    [sym_while_statement] = STATE(2010),
    [sym_do_while_statement] = STATE(2010),
    [sym_for_statement] = STATE(2010),
    [sym_for_in_statement] = STATE(2010),
    [sym_delete_statement] = STATE(2010),
    [sym_exit_statement] = STATE(2010),
    [sym_return_statement] = STATE(2010),
    [sym_switch_statement] = STATE(2010),
    [sym__io_statement] = STATE(2010),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(2010),
    [sym_piped_io_statement] = STATE(2010),
    [sym_block] = STATE(2092),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_comment] = STATE(1349),
    [aux_sym_if_statement_repeat1] = STATE(1349),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(640),
    [sym_continue_statement] = ACTIONS(640),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(640),
    [sym_nextfile_statement] = ACTIONS(640),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_POUND] = ACTIONS(212),
  },
  [153] = {
    [sym__statement] = STATE(1221),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1221),
    [sym_if_statement] = STATE(1221),
    [sym_while_statement] = STATE(1221),
    [sym_do_while_statement] = STATE(1221),
    [sym_for_statement] = STATE(1221),
    [sym_for_in_statement] = STATE(1221),
    [sym_delete_statement] = STATE(1221),
    [sym_exit_statement] = STATE(1221),
    [sym_return_statement] = STATE(1221),
    [sym_switch_statement] = STATE(1221),
    [sym__io_statement] = STATE(1221),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1221),
    [sym_piped_io_statement] = STATE(1221),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(41),
    [anon_sym_LF] = ACTIONS(41),
    [anon_sym_CR_LF] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(53),
    [sym_continue_statement] = ACTIONS(53),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(53),
    [sym_nextfile_statement] = ACTIONS(53),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(456),
    [anon_sym_PLUS_PLUS] = ACTIONS(646),
    [anon_sym_DASH_DASH] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(650),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [sym__if_else_separator] = ACTIONS(83),
  },
  [154] = {
    [sym__statement] = STATE(1320),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1320),
    [sym_if_statement] = STATE(1320),
    [sym_while_statement] = STATE(1320),
    [sym_do_while_statement] = STATE(1320),
    [sym_for_statement] = STATE(1320),
    [sym_for_in_statement] = STATE(1320),
    [sym_delete_statement] = STATE(1320),
    [sym_exit_statement] = STATE(1320),
    [sym_return_statement] = STATE(1320),
    [sym_switch_statement] = STATE(1320),
    [sym__io_statement] = STATE(1320),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1320),
    [sym_piped_io_statement] = STATE(1320),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_SEMI] = ACTIONS(41),
    [anon_sym_LF] = ACTIONS(41),
    [anon_sym_CR_LF] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(234),
    [sym_continue_statement] = ACTIONS(234),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(234),
    [sym_nextfile_statement] = ACTIONS(234),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(372),
    [anon_sym_PLUS_PLUS] = ACTIONS(656),
    [anon_sym_DASH_DASH] = ACTIONS(656),
    [anon_sym_DOLLAR] = ACTIONS(658),
    [anon_sym_AT] = ACTIONS(660),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(258),
  },
  [155] = {
    [sym__statement] = STATE(1344),
    [sym__statement_separated] = STATE(1344),
    [sym__control_statement] = STATE(1344),
    [sym_if_statement] = STATE(1344),
    [sym_while_statement] = STATE(1344),
    [sym_do_while_statement] = STATE(1344),
    [sym_for_statement] = STATE(1344),
    [sym_for_in_statement] = STATE(1344),
    [sym_delete_statement] = STATE(1344),
    [sym_exit_statement] = STATE(1344),
    [sym_return_statement] = STATE(1344),
    [sym_switch_statement] = STATE(1344),
    [sym__io_statement] = STATE(1344),
    [sym__getline_exp] = STATE(521),
    [sym_getline_input] = STATE(521),
    [sym_getline_file] = STATE(521),
    [sym_print_statement] = STATE(936),
    [sym_printf_statement] = STATE(936),
    [sym_redirected_io_statement] = STATE(1344),
    [sym_piped_io_statement] = STATE(1344),
    [sym_block] = STATE(1350),
    [sym__exp] = STATE(521),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(521),
    [sym_assignment_exp] = STATE(521),
    [sym_piped_io_exp] = STATE(521),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_regex] = STATE(521),
    [sym_regex_constant] = STATE(521),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(521),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_if] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(172),
    [sym_break_statement] = ACTIONS(662),
    [sym_continue_statement] = ACTIONS(662),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(178),
    [anon_sym_return] = ACTIONS(180),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(662),
    [sym_nextfile_statement] = ACTIONS(662),
    [anon_sym_print] = ACTIONS(190),
    [anon_sym_printf] = ACTIONS(192),
    [anon_sym_SLASH] = ACTIONS(194),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(198),
    [anon_sym_PLUS_PLUS] = ACTIONS(200),
    [anon_sym_DASH_DASH] = ACTIONS(200),
    [anon_sym_DOLLAR] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(204),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
  },
  [156] = {
    [sym__statement] = STATE(1250),
    [sym__statement_separated] = STATE(1250),
    [sym__control_statement] = STATE(1250),
    [sym_if_statement] = STATE(1250),
    [sym_while_statement] = STATE(1250),
    [sym_do_while_statement] = STATE(1250),
    [sym_for_statement] = STATE(1250),
    [sym_for_in_statement] = STATE(1250),
    [sym_delete_statement] = STATE(1250),
    [sym_exit_statement] = STATE(1250),
    [sym_return_statement] = STATE(1250),
    [sym_switch_statement] = STATE(1250),
    [sym__io_statement] = STATE(1250),
    [sym__getline_exp] = STATE(509),
    [sym_getline_input] = STATE(509),
    [sym_getline_file] = STATE(509),
    [sym_print_statement] = STATE(831),
    [sym_printf_statement] = STATE(831),
    [sym_redirected_io_statement] = STATE(1250),
    [sym_piped_io_statement] = STATE(1250),
    [sym_block] = STATE(1251),
    [sym__exp] = STATE(509),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(509),
    [sym_assignment_exp] = STATE(509),
    [sym_piped_io_exp] = STATE(509),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_regex] = STATE(509),
    [sym_regex_constant] = STATE(509),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(509),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(312),
    [sym_break_statement] = ACTIONS(664),
    [sym_continue_statement] = ACTIONS(664),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(316),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(664),
    [sym_nextfile_statement] = ACTIONS(664),
    [anon_sym_print] = ACTIONS(324),
    [anon_sym_printf] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(332),
    [anon_sym_PLUS_PLUS] = ACTIONS(334),
    [anon_sym_DASH_DASH] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_AT] = ACTIONS(338),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(342),
    [anon_sym_DQUOTE] = ACTIONS(344),
  },
  [157] = {
    [sym__statement] = STATE(1344),
    [sym__statement_separated] = STATE(10),
    [sym__control_statement] = STATE(1344),
    [sym_if_statement] = STATE(1344),
    [sym_while_statement] = STATE(1344),
    [sym_do_while_statement] = STATE(1344),
    [sym_for_statement] = STATE(1344),
    [sym_for_in_statement] = STATE(1344),
    [sym_delete_statement] = STATE(1344),
    [sym_exit_statement] = STATE(1344),
    [sym_return_statement] = STATE(1344),
    [sym_switch_statement] = STATE(1344),
    [sym__io_statement] = STATE(1344),
    [sym__getline_exp] = STATE(1620),
    [sym_getline_input] = STATE(1620),
    [sym_getline_file] = STATE(1620),
    [sym_print_statement] = STATE(1840),
    [sym_printf_statement] = STATE(1840),
    [sym_redirected_io_statement] = STATE(1344),
    [sym_piped_io_statement] = STATE(1344),
    [sym_block] = STATE(1350),
    [sym__exp] = STATE(1620),
    [sym_ternary_exp] = STATE(1518),
    [sym_binary_exp] = STATE(1518),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1518),
    [sym_update_exp] = STATE(1620),
    [sym_assignment_exp] = STATE(1620),
    [sym_piped_io_exp] = STATE(1620),
    [sym_string_concat] = STATE(1518),
    [sym_field_ref] = STATE(694),
    [sym_array_ref] = STATE(665),
    [sym_regex] = STATE(1620),
    [sym_regex_constant] = STATE(1620),
    [sym_grouping] = STATE(1518),
    [sym__primitive] = STATE(1518),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(625),
    [sym_number] = STATE(1518),
    [sym_string] = STATE(1518),
    [sym_func_call] = STATE(1518),
    [sym_indirect_func_call] = STATE(1620),
    [sym_identifier] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_while] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(232),
    [sym_break_statement] = ACTIONS(662),
    [sym_continue_statement] = ACTIONS(662),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(236),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(240),
    [sym_next_statement] = ACTIONS(662),
    [sym_nextfile_statement] = ACTIONS(662),
    [anon_sym_print] = ACTIONS(242),
    [anon_sym_printf] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(282),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
  },
  [158] = {
    [sym__statement] = STATE(1250),
    [sym__statement_separated] = STATE(2),
    [sym__control_statement] = STATE(1250),
    [sym_if_statement] = STATE(1250),
    [sym_while_statement] = STATE(1250),
    [sym_do_while_statement] = STATE(1250),
    [sym_for_statement] = STATE(1250),
    [sym_for_in_statement] = STATE(1250),
    [sym_delete_statement] = STATE(1250),
    [sym_exit_statement] = STATE(1250),
    [sym_return_statement] = STATE(1250),
    [sym_switch_statement] = STATE(1250),
    [sym__io_statement] = STATE(1250),
    [sym__getline_exp] = STATE(1562),
    [sym_getline_input] = STATE(1562),
    [sym_getline_file] = STATE(1562),
    [sym_print_statement] = STATE(1838),
    [sym_printf_statement] = STATE(1838),
    [sym_redirected_io_statement] = STATE(1250),
    [sym_piped_io_statement] = STATE(1250),
    [sym_block] = STATE(1251),
    [sym__exp] = STATE(1562),
    [sym_ternary_exp] = STATE(1493),
    [sym_binary_exp] = STATE(1493),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1493),
    [sym_update_exp] = STATE(1562),
    [sym_assignment_exp] = STATE(1562),
    [sym_piped_io_exp] = STATE(1562),
    [sym_string_concat] = STATE(1493),
    [sym_field_ref] = STATE(648),
    [sym_array_ref] = STATE(630),
    [sym_regex] = STATE(1562),
    [sym_regex_constant] = STATE(1562),
    [sym_grouping] = STATE(1493),
    [sym__primitive] = STATE(1493),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(612),
    [sym_number] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_func_call] = STATE(1493),
    [sym_indirect_func_call] = STATE(1562),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(51),
    [sym_break_statement] = ACTIONS(664),
    [sym_continue_statement] = ACTIONS(664),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(57),
    [anon_sym_return] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(63),
    [sym_next_statement] = ACTIONS(664),
    [sym_nextfile_statement] = ACTIONS(664),
    [anon_sym_print] = ACTIONS(65),
    [anon_sym_printf] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(388),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DOLLAR] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(396),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
  },
  [159] = {
    [sym__statement] = STATE(1344),
    [sym__statement_separated] = STATE(154),
    [sym__control_statement] = STATE(1344),
    [sym_if_statement] = STATE(1344),
    [sym_while_statement] = STATE(1344),
    [sym_do_while_statement] = STATE(1344),
    [sym_for_statement] = STATE(1344),
    [sym_for_in_statement] = STATE(1344),
    [sym_delete_statement] = STATE(1344),
    [sym_exit_statement] = STATE(1344),
    [sym_return_statement] = STATE(1344),
    [sym_switch_statement] = STATE(1344),
    [sym__io_statement] = STATE(1344),
    [sym__getline_exp] = STATE(1695),
    [sym_getline_input] = STATE(1695),
    [sym_getline_file] = STATE(1695),
    [sym_print_statement] = STATE(1842),
    [sym_printf_statement] = STATE(1842),
    [sym_redirected_io_statement] = STATE(1344),
    [sym_piped_io_statement] = STATE(1344),
    [sym_block] = STATE(1350),
    [sym__exp] = STATE(1695),
    [sym_ternary_exp] = STATE(1588),
    [sym_binary_exp] = STATE(1588),
    [sym__binary_in] = STATE(1473),
    [sym_unary_exp] = STATE(1588),
    [sym_update_exp] = STATE(1695),
    [sym_assignment_exp] = STATE(1695),
    [sym_piped_io_exp] = STATE(1695),
    [sym_string_concat] = STATE(1588),
    [sym_field_ref] = STATE(1293),
    [sym_array_ref] = STATE(931),
    [sym_regex] = STATE(1695),
    [sym_regex_constant] = STATE(1695),
    [sym_grouping] = STATE(1588),
    [sym__primitive] = STATE(1588),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(851),
    [sym_number] = STATE(1588),
    [sym_string] = STATE(1588),
    [sym_func_call] = STATE(1588),
    [sym_indirect_func_call] = STATE(1695),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_if] = ACTIONS(350),
    [anon_sym_LPAREN] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(354),
    [anon_sym_do] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(356),
    [sym_break_statement] = ACTIONS(662),
    [sym_continue_statement] = ACTIONS(662),
    [anon_sym_delete] = ACTIONS(176),
    [anon_sym_exit] = ACTIONS(360),
    [anon_sym_return] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(182),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_getline] = ACTIONS(364),
    [sym_next_statement] = ACTIONS(662),
    [sym_nextfile_statement] = ACTIONS(662),
    [anon_sym_print] = ACTIONS(366),
    [anon_sym_printf] = ACTIONS(368),
    [anon_sym_SLASH] = ACTIONS(370),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BANG] = ACTIONS(374),
    [anon_sym_PLUS_PLUS] = ACTIONS(376),
    [anon_sym_DASH_DASH] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(378),
    [anon_sym_AT] = ACTIONS(380),
    [aux_sym_number_token1] = ACTIONS(256),
    [aux_sym_number_token2] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(292),
  },
  [160] = {
    [sym__statement] = STATE(1250),
    [sym__statement_separated] = STATE(153),
    [sym__control_statement] = STATE(1250),
    [sym_if_statement] = STATE(1250),
    [sym_while_statement] = STATE(1250),
    [sym_do_while_statement] = STATE(1250),
    [sym_for_statement] = STATE(1250),
    [sym_for_in_statement] = STATE(1250),
    [sym_delete_statement] = STATE(1250),
    [sym_exit_statement] = STATE(1250),
    [sym_return_statement] = STATE(1250),
    [sym_switch_statement] = STATE(1250),
    [sym__io_statement] = STATE(1250),
    [sym__getline_exp] = STATE(1690),
    [sym_getline_input] = STATE(1690),
    [sym_getline_file] = STATE(1690),
    [sym_print_statement] = STATE(1841),
    [sym_printf_statement] = STATE(1841),
    [sym_redirected_io_statement] = STATE(1250),
    [sym_piped_io_statement] = STATE(1250),
    [sym_block] = STATE(1251),
    [sym__exp] = STATE(1690),
    [sym_ternary_exp] = STATE(1559),
    [sym_binary_exp] = STATE(1559),
    [sym__binary_in] = STATE(1419),
    [sym_unary_exp] = STATE(1559),
    [sym_update_exp] = STATE(1690),
    [sym_assignment_exp] = STATE(1690),
    [sym_piped_io_exp] = STATE(1690),
    [sym_string_concat] = STATE(1559),
    [sym_field_ref] = STATE(1131),
    [sym_array_ref] = STATE(840),
    [sym_regex] = STATE(1690),
    [sym_regex_constant] = STATE(1690),
    [sym_grouping] = STATE(1559),
    [sym__primitive] = STATE(1559),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(689),
    [sym_number] = STATE(1559),
    [sym_string] = STATE(1559),
    [sym_func_call] = STATE(1559),
    [sym_indirect_func_call] = STATE(1690),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(438),
    [anon_sym_do] = ACTIONS(49),
    [anon_sym_for] = ACTIONS(440),
    [sym_break_statement] = ACTIONS(664),
    [sym_continue_statement] = ACTIONS(664),
    [anon_sym_delete] = ACTIONS(55),
    [anon_sym_exit] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_getline] = ACTIONS(448),
    [sym_next_statement] = ACTIONS(664),
    [sym_nextfile_statement] = ACTIONS(664),
    [anon_sym_print] = ACTIONS(450),
    [anon_sym_printf] = ACTIONS(452),
    [anon_sym_SLASH] = ACTIONS(454),
    [anon_sym_PLUS] = ACTIONS(456),
    [anon_sym_DASH] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DOLLAR] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(464),
    [aux_sym_number_token1] = ACTIONS(79),
    [aux_sym_number_token2] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
  },
  [161] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
    [sym__if_else_separator] = ACTIONS(674),
    [sym__func_call] = ACTIONS(676),
  },
  [162] = {
    [sym_array_ref] = STATE(173),
    [sym_namespace] = STATE(2256),
    [sym_ns_qualified_name] = STATE(173),
    [sym_identifier] = ACTIONS(678),
    [anon_sym_COMMA] = ACTIONS(680),
    [anon_sym_SEMI] = ACTIONS(680),
    [anon_sym_LF] = ACTIONS(680),
    [anon_sym_CR_LF] = ACTIONS(680),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_while] = ACTIONS(680),
    [anon_sym_do] = ACTIONS(680),
    [anon_sym_for] = ACTIONS(680),
    [anon_sym_in] = ACTIONS(680),
    [sym_break_statement] = ACTIONS(680),
    [sym_continue_statement] = ACTIONS(680),
    [anon_sym_delete] = ACTIONS(680),
    [anon_sym_exit] = ACTIONS(680),
    [anon_sym_return] = ACTIONS(680),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(680),
    [anon_sym_default] = ACTIONS(680),
    [anon_sym_getline] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [sym_next_statement] = ACTIONS(680),
    [sym_nextfile_statement] = ACTIONS(680),
    [anon_sym_print] = ACTIONS(680),
    [anon_sym_printf] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(680),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(680),
    [anon_sym_STAR_STAR] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_BANG_TILDE] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(680),
    [aux_sym_number_token1] = ACTIONS(680),
    [aux_sym_number_token2] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_POUND] = ACTIONS(680),
    [sym_concatenating_space] = ACTIONS(682),
    [sym__if_else_separator] = ACTIONS(682),
  },
  [163] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(684),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_PLUS_EQ] = ACTIONS(684),
    [anon_sym_DASH_EQ] = ACTIONS(684),
    [anon_sym_STAR_EQ] = ACTIONS(684),
    [anon_sym_SLASH_EQ] = ACTIONS(684),
    [anon_sym_PERCENT_EQ] = ACTIONS(684),
    [anon_sym_CARET_EQ] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(684),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__if_else_separator] = ACTIONS(686),
    [sym__func_call] = ACTIONS(676),
  },
  [164] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(688),
    [anon_sym_DASH_DASH] = ACTIONS(688),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
    [sym__func_call] = ACTIONS(692),
  },
  [165] = {
    [sym__getline_exp] = STATE(425),
    [sym_getline_input] = STATE(425),
    [sym_getline_file] = STATE(425),
    [sym__print_args] = STATE(661),
    [sym__exp] = STATE(425),
    [sym_ternary_exp] = STATE(382),
    [sym_binary_exp] = STATE(382),
    [sym__binary_in] = STATE(399),
    [sym_unary_exp] = STATE(382),
    [sym_update_exp] = STATE(425),
    [sym_assignment_exp] = STATE(425),
    [sym_piped_io_exp] = STATE(425),
    [sym_string_concat] = STATE(382),
    [sym_field_ref] = STATE(255),
    [sym_array_ref] = STATE(233),
    [sym_exp_list] = STATE(661),
    [sym_regex] = STATE(425),
    [sym_regex_constant] = STATE(425),
    [sym_grouping] = STATE(382),
    [sym__primitive] = STATE(382),
    [sym_namespace] = STATE(2249),
    [sym_ns_qualified_name] = STATE(201),
    [sym_number] = STATE(382),
    [sym_string] = STATE(382),
    [sym_func_call] = STATE(382),
    [sym_indirect_func_call] = STATE(425),
    [aux_sym_exp_list_repeat1] = STATE(842),
    [sym_identifier] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(694),
    [anon_sym_CR_LF] = ACTIONS(694),
    [anon_sym_if] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(694),
    [anon_sym_do] = ACTIONS(694),
    [anon_sym_for] = ACTIONS(694),
    [sym_break_statement] = ACTIONS(694),
    [sym_continue_statement] = ACTIONS(694),
    [anon_sym_delete] = ACTIONS(694),
    [anon_sym_exit] = ACTIONS(694),
    [anon_sym_return] = ACTIONS(694),
    [anon_sym_switch] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_getline] = ACTIONS(322),
    [sym_next_statement] = ACTIONS(694),
    [sym_nextfile_statement] = ACTIONS(694),
    [anon_sym_print] = ACTIONS(694),
    [anon_sym_LPAREN2] = ACTIONS(698),
    [anon_sym_printf] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(330),
    [anon_sym_DASH] = ACTIONS(330),
    [anon_sym_BANG] = ACTIONS(330),
    [anon_sym_PLUS_PLUS] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(702),
    [anon_sym_DOLLAR] = ACTIONS(704),
    [anon_sym_AT] = ACTIONS(706),
    [aux_sym_number_token1] = ACTIONS(340),
    [aux_sym_number_token2] = ACTIONS(340),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_POUND] = ACTIONS(694),
    [sym__if_else_separator] = ACTIONS(710),
  },
  [166] = {
    [sym_array_ref] = STATE(202),
    [sym_namespace] = STATE(2243),
    [sym_ns_qualified_name] = STATE(202),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_COMMA] = ACTIONS(680),
    [anon_sym_SEMI] = ACTIONS(680),
    [anon_sym_LF] = ACTIONS(680),
    [anon_sym_CR_LF] = ACTIONS(680),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_while] = ACTIONS(680),
    [anon_sym_do] = ACTIONS(680),
    [anon_sym_for] = ACTIONS(680),
    [anon_sym_in] = ACTIONS(680),
    [sym_break_statement] = ACTIONS(680),
    [sym_continue_statement] = ACTIONS(680),
    [anon_sym_delete] = ACTIONS(680),
    [anon_sym_exit] = ACTIONS(680),
    [anon_sym_return] = ACTIONS(680),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_case] = ACTIONS(680),
    [anon_sym_default] = ACTIONS(680),
    [anon_sym_getline] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(680),
    [sym_next_statement] = ACTIONS(680),
    [sym_nextfile_statement] = ACTIONS(680),
    [anon_sym_print] = ACTIONS(680),
    [anon_sym_printf] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(680),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(680),
    [anon_sym_STAR_STAR] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_BANG_TILDE] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(680),
    [aux_sym_number_token1] = ACTIONS(680),
    [aux_sym_number_token2] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_POUND] = ACTIONS(680),
    [sym_concatenating_space] = ACTIONS(682),
  },
  [167] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(684),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_PLUS_EQ] = ACTIONS(684),
    [anon_sym_DASH_EQ] = ACTIONS(684),
    [anon_sym_STAR_EQ] = ACTIONS(684),
    [anon_sym_SLASH_EQ] = ACTIONS(684),
    [anon_sym_PERCENT_EQ] = ACTIONS(684),
    [anon_sym_CARET_EQ] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(684),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__func_call] = ACTIONS(692),
  },
  [168] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(666),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
    [sym__if_else_separator] = ACTIONS(674),
    [sym__func_call] = ACTIONS(676),
  },
  [169] = {
    [sym_identifier] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(714),
    [anon_sym_SEMI] = ACTIONS(714),
    [anon_sym_LF] = ACTIONS(714),
    [anon_sym_CR_LF] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_while] = ACTIONS(714),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(714),
    [anon_sym_in] = ACTIONS(714),
    [sym_break_statement] = ACTIONS(714),
    [sym_continue_statement] = ACTIONS(714),
    [anon_sym_delete] = ACTIONS(714),
    [anon_sym_exit] = ACTIONS(714),
    [anon_sym_return] = ACTIONS(714),
    [anon_sym_switch] = ACTIONS(714),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_RBRACE] = ACTIONS(714),
    [anon_sym_case] = ACTIONS(714),
    [anon_sym_default] = ACTIONS(714),
    [anon_sym_getline] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(714),
    [sym_next_statement] = ACTIONS(714),
    [sym_nextfile_statement] = ACTIONS(714),
    [anon_sym_print] = ACTIONS(714),
    [anon_sym_printf] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(714),
    [anon_sym_PIPE_AMP] = ACTIONS(714),
    [anon_sym_QMARK] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [anon_sym_STAR_STAR] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_BANG_TILDE] = ACTIONS(714),
    [anon_sym_AMP_AMP] = ACTIONS(714),
    [anon_sym_PIPE_PIPE] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_PLUS_PLUS] = ACTIONS(714),
    [anon_sym_DASH_DASH] = ACTIONS(714),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_PLUS_EQ] = ACTIONS(714),
    [anon_sym_DASH_EQ] = ACTIONS(714),
    [anon_sym_STAR_EQ] = ACTIONS(714),
    [anon_sym_SLASH_EQ] = ACTIONS(714),
    [anon_sym_PERCENT_EQ] = ACTIONS(714),
    [anon_sym_CARET_EQ] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(714),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(714),
    [aux_sym_number_token2] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [anon_sym_POUND] = ACTIONS(714),
    [sym_concatenating_space] = ACTIONS(716),
    [sym__if_else_separator] = ACTIONS(716),
  },
  [170] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(684),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_PLUS_EQ] = ACTIONS(684),
    [anon_sym_DASH_EQ] = ACTIONS(684),
    [anon_sym_STAR_EQ] = ACTIONS(684),
    [anon_sym_SLASH_EQ] = ACTIONS(684),
    [anon_sym_PERCENT_EQ] = ACTIONS(684),
    [anon_sym_CARET_EQ] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(684),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__if_else_separator] = ACTIONS(686),
    [sym__func_call] = ACTIONS(676),
  },
  [171] = {
    [sym_identifier] = ACTIONS(718),
    [anon_sym_COMMA] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(718),
    [anon_sym_LF] = ACTIONS(718),
    [anon_sym_CR_LF] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_do] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(718),
    [sym_break_statement] = ACTIONS(718),
    [sym_continue_statement] = ACTIONS(718),
    [anon_sym_delete] = ACTIONS(718),
    [anon_sym_exit] = ACTIONS(718),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_switch] = ACTIONS(718),
    [anon_sym_LBRACE] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_case] = ACTIONS(718),
    [anon_sym_default] = ACTIONS(718),
    [anon_sym_getline] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(718),
    [sym_next_statement] = ACTIONS(718),
    [sym_nextfile_statement] = ACTIONS(718),
    [anon_sym_print] = ACTIONS(718),
    [anon_sym_printf] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_PIPE_AMP] = ACTIONS(718),
    [anon_sym_QMARK] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(718),
    [anon_sym_STAR_STAR] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(718),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_BANG_TILDE] = ACTIONS(718),
    [anon_sym_AMP_AMP] = ACTIONS(718),
    [anon_sym_PIPE_PIPE] = ACTIONS(718),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_PLUS_PLUS] = ACTIONS(718),
    [anon_sym_DASH_DASH] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_PLUS_EQ] = ACTIONS(718),
    [anon_sym_DASH_EQ] = ACTIONS(718),
    [anon_sym_STAR_EQ] = ACTIONS(718),
    [anon_sym_SLASH_EQ] = ACTIONS(718),
    [anon_sym_PERCENT_EQ] = ACTIONS(718),
    [anon_sym_CARET_EQ] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(718),
    [anon_sym_LBRACK] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(718),
    [aux_sym_number_token1] = ACTIONS(718),
    [aux_sym_number_token2] = ACTIONS(718),
    [anon_sym_DQUOTE] = ACTIONS(718),
    [anon_sym_POUND] = ACTIONS(718),
    [sym_concatenating_space] = ACTIONS(720),
    [sym__if_else_separator] = ACTIONS(720),
    [sym__func_call] = ACTIONS(720),
  },
  [172] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LF] = ACTIONS(722),
    [anon_sym_CR_LF] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_in] = ACTIONS(722),
    [sym_break_statement] = ACTIONS(722),
    [sym_continue_statement] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_exit] = ACTIONS(722),
    [anon_sym_return] = ACTIONS(722),
    [anon_sym_switch] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_case] = ACTIONS(722),
    [anon_sym_default] = ACTIONS(722),
    [anon_sym_getline] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(722),
    [sym_next_statement] = ACTIONS(722),
    [sym_nextfile_statement] = ACTIONS(722),
    [anon_sym_print] = ACTIONS(722),
    [anon_sym_printf] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PIPE_AMP] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(722),
    [anon_sym_STAR_STAR] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(722),
    [anon_sym_EQ_EQ] = ACTIONS(722),
    [anon_sym_BANG_EQ] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_BANG_TILDE] = ACTIONS(722),
    [anon_sym_AMP_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(722),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(722),
    [anon_sym_DASH_DASH] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_PLUS_EQ] = ACTIONS(722),
    [anon_sym_DASH_EQ] = ACTIONS(722),
    [anon_sym_STAR_EQ] = ACTIONS(722),
    [anon_sym_SLASH_EQ] = ACTIONS(722),
    [anon_sym_PERCENT_EQ] = ACTIONS(722),
    [anon_sym_CARET_EQ] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(722),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(722),
    [aux_sym_number_token2] = ACTIONS(722),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [anon_sym_POUND] = ACTIONS(722),
    [sym_concatenating_space] = ACTIONS(724),
    [sym__if_else_separator] = ACTIONS(724),
  },
  [173] = {
    [sym_identifier] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(714),
    [anon_sym_SEMI] = ACTIONS(714),
    [anon_sym_LF] = ACTIONS(714),
    [anon_sym_CR_LF] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_while] = ACTIONS(714),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(714),
    [anon_sym_in] = ACTIONS(714),
    [sym_break_statement] = ACTIONS(714),
    [sym_continue_statement] = ACTIONS(714),
    [anon_sym_delete] = ACTIONS(714),
    [anon_sym_exit] = ACTIONS(714),
    [anon_sym_return] = ACTIONS(714),
    [anon_sym_switch] = ACTIONS(714),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_RBRACE] = ACTIONS(714),
    [anon_sym_case] = ACTIONS(714),
    [anon_sym_default] = ACTIONS(714),
    [anon_sym_getline] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(714),
    [sym_next_statement] = ACTIONS(714),
    [sym_nextfile_statement] = ACTIONS(714),
    [anon_sym_print] = ACTIONS(714),
    [anon_sym_printf] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(714),
    [anon_sym_PIPE_AMP] = ACTIONS(714),
    [anon_sym_QMARK] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [anon_sym_STAR_STAR] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_BANG_TILDE] = ACTIONS(714),
    [anon_sym_AMP_AMP] = ACTIONS(714),
    [anon_sym_PIPE_PIPE] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_PLUS_PLUS] = ACTIONS(714),
    [anon_sym_DASH_DASH] = ACTIONS(714),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_PLUS_EQ] = ACTIONS(714),
    [anon_sym_DASH_EQ] = ACTIONS(714),
    [anon_sym_STAR_EQ] = ACTIONS(714),
    [anon_sym_SLASH_EQ] = ACTIONS(714),
    [anon_sym_PERCENT_EQ] = ACTIONS(714),
    [anon_sym_CARET_EQ] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(714),
    [aux_sym_number_token1] = ACTIONS(714),
    [aux_sym_number_token2] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [anon_sym_POUND] = ACTIONS(714),
    [sym_concatenating_space] = ACTIONS(716),
    [sym__if_else_separator] = ACTIONS(716),
  },
  [174] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(728),
    [anon_sym_PLUS_EQ] = ACTIONS(728),
    [anon_sym_DASH_EQ] = ACTIONS(728),
    [anon_sym_STAR_EQ] = ACTIONS(728),
    [anon_sym_SLASH_EQ] = ACTIONS(728),
    [anon_sym_PERCENT_EQ] = ACTIONS(728),
    [anon_sym_CARET_EQ] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(730),
    [sym__if_else_separator] = ACTIONS(674),
    [sym__func_call] = ACTIONS(732),
  },
  [175] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LF] = ACTIONS(722),
    [anon_sym_CR_LF] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_in] = ACTIONS(722),
    [sym_break_statement] = ACTIONS(722),
    [sym_continue_statement] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_exit] = ACTIONS(722),
    [anon_sym_return] = ACTIONS(722),
    [anon_sym_switch] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_case] = ACTIONS(722),
    [anon_sym_default] = ACTIONS(722),
    [anon_sym_getline] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(722),
    [sym_next_statement] = ACTIONS(722),
    [sym_nextfile_statement] = ACTIONS(722),
    [anon_sym_print] = ACTIONS(722),
    [anon_sym_printf] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PIPE_AMP] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(722),
    [anon_sym_STAR_STAR] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(722),
    [anon_sym_EQ_EQ] = ACTIONS(722),
    [anon_sym_BANG_EQ] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_BANG_TILDE] = ACTIONS(722),
    [anon_sym_AMP_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(722),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(722),
    [anon_sym_DASH_DASH] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_PLUS_EQ] = ACTIONS(722),
    [anon_sym_DASH_EQ] = ACTIONS(722),
    [anon_sym_STAR_EQ] = ACTIONS(722),
    [anon_sym_SLASH_EQ] = ACTIONS(722),
    [anon_sym_PERCENT_EQ] = ACTIONS(722),
    [anon_sym_CARET_EQ] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(722),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(722),
    [aux_sym_number_token2] = ACTIONS(722),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [anon_sym_POUND] = ACTIONS(722),
    [sym_concatenating_space] = ACTIONS(724),
  },
  [176] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(734),
    [anon_sym_DASH_DASH] = ACTIONS(734),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(736),
    [anon_sym_DASH_EQ] = ACTIONS(736),
    [anon_sym_STAR_EQ] = ACTIONS(736),
    [anon_sym_SLASH_EQ] = ACTIONS(736),
    [anon_sym_PERCENT_EQ] = ACTIONS(736),
    [anon_sym_CARET_EQ] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
    [sym__if_else_separator] = ACTIONS(674),
    [sym__func_call] = ACTIONS(732),
  },
  [177] = {
    [sym_identifier] = ACTIONS(718),
    [anon_sym_COMMA] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(718),
    [anon_sym_LF] = ACTIONS(718),
    [anon_sym_CR_LF] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_do] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(718),
    [sym_break_statement] = ACTIONS(718),
    [sym_continue_statement] = ACTIONS(718),
    [anon_sym_delete] = ACTIONS(718),
    [anon_sym_exit] = ACTIONS(718),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_switch] = ACTIONS(718),
    [anon_sym_LBRACE] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_case] = ACTIONS(718),
    [anon_sym_default] = ACTIONS(718),
    [anon_sym_getline] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(718),
    [sym_next_statement] = ACTIONS(718),
    [sym_nextfile_statement] = ACTIONS(718),
    [anon_sym_print] = ACTIONS(718),
    [anon_sym_printf] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_PIPE_AMP] = ACTIONS(718),
    [anon_sym_QMARK] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(718),
    [anon_sym_STAR_STAR] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(718),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_BANG_TILDE] = ACTIONS(718),
    [anon_sym_AMP_AMP] = ACTIONS(718),
    [anon_sym_PIPE_PIPE] = ACTIONS(718),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_PLUS_PLUS] = ACTIONS(718),
    [anon_sym_DASH_DASH] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_PLUS_EQ] = ACTIONS(718),
    [anon_sym_DASH_EQ] = ACTIONS(718),
    [anon_sym_STAR_EQ] = ACTIONS(718),
    [anon_sym_SLASH_EQ] = ACTIONS(718),
    [anon_sym_PERCENT_EQ] = ACTIONS(718),
    [anon_sym_CARET_EQ] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(718),
    [anon_sym_LBRACK] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(718),
    [aux_sym_number_token1] = ACTIONS(718),
    [aux_sym_number_token2] = ACTIONS(718),
    [anon_sym_DQUOTE] = ACTIONS(718),
    [anon_sym_POUND] = ACTIONS(718),
    [sym_concatenating_space] = ACTIONS(720),
    [sym__if_else_separator] = ACTIONS(720),
  },
  [178] = {
    [sym_array_ref] = STATE(173),
    [sym_namespace] = STATE(2256),
    [sym_ns_qualified_name] = STATE(231),
    [sym_identifier] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(680),
    [anon_sym_SEMI] = ACTIONS(680),
    [anon_sym_LF] = ACTIONS(680),
    [anon_sym_CR_LF] = ACTIONS(680),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_while] = ACTIONS(680),
    [anon_sym_do] = ACTIONS(680),
    [anon_sym_for] = ACTIONS(680),
    [anon_sym_in] = ACTIONS(680),
    [sym_break_statement] = ACTIONS(680),
    [sym_continue_statement] = ACTIONS(680),
    [anon_sym_delete] = ACTIONS(680),
    [anon_sym_exit] = ACTIONS(680),
    [anon_sym_return] = ACTIONS(680),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_getline] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(740),
    [sym_next_statement] = ACTIONS(680),
    [sym_nextfile_statement] = ACTIONS(680),
    [anon_sym_print] = ACTIONS(680),
    [anon_sym_printf] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(680),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(680),
    [anon_sym_STAR_STAR] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_BANG_TILDE] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(680),
    [aux_sym_number_token1] = ACTIONS(680),
    [aux_sym_number_token2] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_POUND] = ACTIONS(680),
    [sym_concatenating_space] = ACTIONS(682),
    [sym__if_else_separator] = ACTIONS(682),
  },
  [179] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LF] = ACTIONS(722),
    [anon_sym_CR_LF] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_in] = ACTIONS(722),
    [sym_break_statement] = ACTIONS(722),
    [sym_continue_statement] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_exit] = ACTIONS(722),
    [anon_sym_return] = ACTIONS(722),
    [anon_sym_switch] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_case] = ACTIONS(722),
    [anon_sym_default] = ACTIONS(722),
    [anon_sym_getline] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(722),
    [sym_next_statement] = ACTIONS(722),
    [sym_nextfile_statement] = ACTIONS(722),
    [anon_sym_print] = ACTIONS(722),
    [anon_sym_printf] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PIPE_AMP] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(722),
    [anon_sym_STAR_STAR] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(722),
    [anon_sym_EQ_EQ] = ACTIONS(722),
    [anon_sym_BANG_EQ] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_BANG_TILDE] = ACTIONS(722),
    [anon_sym_AMP_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(722),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(722),
    [anon_sym_DASH_DASH] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_PLUS_EQ] = ACTIONS(722),
    [anon_sym_DASH_EQ] = ACTIONS(722),
    [anon_sym_STAR_EQ] = ACTIONS(722),
    [anon_sym_SLASH_EQ] = ACTIONS(722),
    [anon_sym_PERCENT_EQ] = ACTIONS(722),
    [anon_sym_CARET_EQ] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(722),
    [aux_sym_number_token1] = ACTIONS(722),
    [aux_sym_number_token2] = ACTIONS(722),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [anon_sym_POUND] = ACTIONS(722),
    [sym_concatenating_space] = ACTIONS(724),
    [sym__if_else_separator] = ACTIONS(724),
  },
  [180] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(666),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
    [sym__if_else_separator] = ACTIONS(674),
  },
  [181] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(684),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_PLUS_EQ] = ACTIONS(684),
    [anon_sym_DASH_EQ] = ACTIONS(684),
    [anon_sym_STAR_EQ] = ACTIONS(684),
    [anon_sym_SLASH_EQ] = ACTIONS(684),
    [anon_sym_PERCENT_EQ] = ACTIONS(684),
    [anon_sym_CARET_EQ] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(684),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__if_else_separator] = ACTIONS(686),
  },
  [182] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(684),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_PLUS_EQ] = ACTIONS(684),
    [anon_sym_DASH_EQ] = ACTIONS(684),
    [anon_sym_STAR_EQ] = ACTIONS(684),
    [anon_sym_SLASH_EQ] = ACTIONS(684),
    [anon_sym_PERCENT_EQ] = ACTIONS(684),
    [anon_sym_CARET_EQ] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(684),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__func_call] = ACTIONS(692),
  },
  [183] = {
    [sym_identifier] = ACTIONS(742),
    [anon_sym_COMMA] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(742),
    [anon_sym_LF] = ACTIONS(742),
    [anon_sym_CR_LF] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_do] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_in] = ACTIONS(742),
    [sym_break_statement] = ACTIONS(742),
    [sym_continue_statement] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(742),
    [anon_sym_exit] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_RBRACE] = ACTIONS(742),
    [anon_sym_case] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_getline] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [sym_next_statement] = ACTIONS(742),
    [sym_nextfile_statement] = ACTIONS(742),
    [anon_sym_print] = ACTIONS(742),
    [anon_sym_printf] = ACTIONS(742),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PIPE_AMP] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(742),
    [anon_sym_STAR_STAR] = ACTIONS(742),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(742),
    [anon_sym_EQ_EQ] = ACTIONS(742),
    [anon_sym_BANG_EQ] = ACTIONS(742),
    [anon_sym_TILDE] = ACTIONS(742),
    [anon_sym_BANG_TILDE] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(742),
    [anon_sym_PIPE_PIPE] = ACTIONS(742),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_PLUS_PLUS] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_DOLLAR] = ACTIONS(742),
    [anon_sym_LBRACK] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(742),
    [aux_sym_number_token1] = ACTIONS(742),
    [aux_sym_number_token2] = ACTIONS(742),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_POUND] = ACTIONS(742),
    [sym_concatenating_space] = ACTIONS(744),
    [sym__if_else_separator] = ACTIONS(744),
  },
  [184] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(688),
    [anon_sym_DASH_DASH] = ACTIONS(688),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(666),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
    [sym__func_call] = ACTIONS(692),
  },
  [185] = {
    [sym_identifier] = ACTIONS(718),
    [anon_sym_COMMA] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(718),
    [anon_sym_LF] = ACTIONS(718),
    [anon_sym_CR_LF] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_do] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(718),
    [sym_break_statement] = ACTIONS(718),
    [sym_continue_statement] = ACTIONS(718),
    [anon_sym_delete] = ACTIONS(718),
    [anon_sym_exit] = ACTIONS(718),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_switch] = ACTIONS(718),
    [anon_sym_LBRACE] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_case] = ACTIONS(718),
    [anon_sym_default] = ACTIONS(718),
    [anon_sym_getline] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(718),
    [sym_next_statement] = ACTIONS(718),
    [sym_nextfile_statement] = ACTIONS(718),
    [anon_sym_print] = ACTIONS(718),
    [anon_sym_printf] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_PIPE_AMP] = ACTIONS(718),
    [anon_sym_QMARK] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(718),
    [anon_sym_STAR_STAR] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(718),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_BANG_TILDE] = ACTIONS(718),
    [anon_sym_AMP_AMP] = ACTIONS(718),
    [anon_sym_PIPE_PIPE] = ACTIONS(718),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_PLUS_PLUS] = ACTIONS(718),
    [anon_sym_DASH_DASH] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_PLUS_EQ] = ACTIONS(718),
    [anon_sym_DASH_EQ] = ACTIONS(718),
    [anon_sym_STAR_EQ] = ACTIONS(718),
    [anon_sym_SLASH_EQ] = ACTIONS(718),
    [anon_sym_PERCENT_EQ] = ACTIONS(718),
    [anon_sym_CARET_EQ] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(718),
    [anon_sym_LBRACK] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(718),
    [aux_sym_number_token1] = ACTIONS(718),
    [aux_sym_number_token2] = ACTIONS(718),
    [anon_sym_DQUOTE] = ACTIONS(718),
    [anon_sym_POUND] = ACTIONS(718),
    [sym_concatenating_space] = ACTIONS(720),
    [sym__func_call] = ACTIONS(720),
  },
  [186] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_PLUS_EQ] = ACTIONS(746),
    [anon_sym_DASH_EQ] = ACTIONS(746),
    [anon_sym_STAR_EQ] = ACTIONS(746),
    [anon_sym_SLASH_EQ] = ACTIONS(746),
    [anon_sym_PERCENT_EQ] = ACTIONS(746),
    [anon_sym_CARET_EQ] = ACTIONS(746),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(684),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__if_else_separator] = ACTIONS(686),
    [sym__func_call] = ACTIONS(732),
  },
  [187] = {
    [sym__getline_exp] = STATE(480),
    [sym_getline_input] = STATE(480),
    [sym_getline_file] = STATE(480),
    [sym__print_args] = STATE(781),
    [sym__exp] = STATE(480),
    [sym_ternary_exp] = STATE(426),
    [sym_binary_exp] = STATE(426),
    [sym__binary_in] = STATE(431),
    [sym_unary_exp] = STATE(426),
    [sym_update_exp] = STATE(480),
    [sym_assignment_exp] = STATE(480),
    [sym_piped_io_exp] = STATE(480),
    [sym_string_concat] = STATE(426),
    [sym_field_ref] = STATE(292),
    [sym_array_ref] = STATE(269),
    [sym_exp_list] = STATE(781),
    [sym_regex] = STATE(480),
    [sym_regex_constant] = STATE(480),
    [sym_grouping] = STATE(426),
    [sym__primitive] = STATE(426),
    [sym_namespace] = STATE(2114),
    [sym_ns_qualified_name] = STATE(243),
    [sym_number] = STATE(426),
    [sym_string] = STATE(426),
    [sym_func_call] = STATE(426),
    [sym_indirect_func_call] = STATE(480),
    [aux_sym_exp_list_repeat1] = STATE(830),
    [sym_identifier] = ACTIONS(162),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_LF] = ACTIONS(694),
    [anon_sym_CR_LF] = ACTIONS(694),
    [anon_sym_if] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(694),
    [anon_sym_do] = ACTIONS(694),
    [anon_sym_for] = ACTIONS(694),
    [sym_break_statement] = ACTIONS(694),
    [sym_continue_statement] = ACTIONS(694),
    [anon_sym_delete] = ACTIONS(694),
    [anon_sym_exit] = ACTIONS(694),
    [anon_sym_return] = ACTIONS(694),
    [anon_sym_switch] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_getline] = ACTIONS(188),
    [sym_next_statement] = ACTIONS(694),
    [sym_nextfile_statement] = ACTIONS(694),
    [anon_sym_print] = ACTIONS(694),
    [anon_sym_LPAREN2] = ACTIONS(750),
    [anon_sym_printf] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_PIPE_AMP] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(196),
    [anon_sym_PLUS_PLUS] = ACTIONS(754),
    [anon_sym_DASH_DASH] = ACTIONS(754),
    [anon_sym_DOLLAR] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(758),
    [aux_sym_number_token1] = ACTIONS(206),
    [aux_sym_number_token2] = ACTIONS(206),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [anon_sym_POUND] = ACTIONS(694),
  },
  [188] = {
    [sym_identifier] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(714),
    [anon_sym_SEMI] = ACTIONS(714),
    [anon_sym_LF] = ACTIONS(714),
    [anon_sym_CR_LF] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_while] = ACTIONS(714),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(714),
    [anon_sym_in] = ACTIONS(714),
    [sym_break_statement] = ACTIONS(714),
    [sym_continue_statement] = ACTIONS(714),
    [anon_sym_delete] = ACTIONS(714),
    [anon_sym_exit] = ACTIONS(714),
    [anon_sym_return] = ACTIONS(714),
    [anon_sym_switch] = ACTIONS(714),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_RBRACE] = ACTIONS(714),
    [anon_sym_case] = ACTIONS(714),
    [anon_sym_default] = ACTIONS(714),
    [anon_sym_getline] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(714),
    [sym_next_statement] = ACTIONS(714),
    [sym_nextfile_statement] = ACTIONS(714),
    [anon_sym_print] = ACTIONS(714),
    [anon_sym_printf] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(714),
    [anon_sym_PIPE_AMP] = ACTIONS(714),
    [anon_sym_QMARK] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [anon_sym_STAR_STAR] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_BANG_TILDE] = ACTIONS(714),
    [anon_sym_AMP_AMP] = ACTIONS(714),
    [anon_sym_PIPE_PIPE] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_PLUS_PLUS] = ACTIONS(714),
    [anon_sym_DASH_DASH] = ACTIONS(714),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_PLUS_EQ] = ACTIONS(714),
    [anon_sym_DASH_EQ] = ACTIONS(714),
    [anon_sym_STAR_EQ] = ACTIONS(714),
    [anon_sym_SLASH_EQ] = ACTIONS(714),
    [anon_sym_PERCENT_EQ] = ACTIONS(714),
    [anon_sym_CARET_EQ] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(714),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(714),
    [aux_sym_number_token2] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [anon_sym_POUND] = ACTIONS(714),
    [sym_concatenating_space] = ACTIONS(716),
  },
  [189] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(684),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_PLUS_EQ] = ACTIONS(684),
    [anon_sym_DASH_EQ] = ACTIONS(684),
    [anon_sym_STAR_EQ] = ACTIONS(684),
    [anon_sym_SLASH_EQ] = ACTIONS(684),
    [anon_sym_PERCENT_EQ] = ACTIONS(684),
    [anon_sym_CARET_EQ] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(684),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__if_else_separator] = ACTIONS(686),
  },
  [190] = {
    [sym_identifier] = ACTIONS(762),
    [anon_sym_COMMA] = ACTIONS(762),
    [anon_sym_SEMI] = ACTIONS(762),
    [anon_sym_LF] = ACTIONS(762),
    [anon_sym_CR_LF] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(762),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_while] = ACTIONS(762),
    [anon_sym_do] = ACTIONS(762),
    [anon_sym_for] = ACTIONS(762),
    [anon_sym_in] = ACTIONS(762),
    [sym_break_statement] = ACTIONS(762),
    [sym_continue_statement] = ACTIONS(762),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_exit] = ACTIONS(762),
    [anon_sym_return] = ACTIONS(762),
    [anon_sym_switch] = ACTIONS(762),
    [anon_sym_LBRACE] = ACTIONS(762),
    [anon_sym_RBRACE] = ACTIONS(762),
    [anon_sym_case] = ACTIONS(762),
    [anon_sym_default] = ACTIONS(762),
    [anon_sym_getline] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(762),
    [sym_next_statement] = ACTIONS(762),
    [sym_nextfile_statement] = ACTIONS(762),
    [anon_sym_print] = ACTIONS(762),
    [anon_sym_printf] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(762),
    [anon_sym_PIPE_AMP] = ACTIONS(762),
    [anon_sym_QMARK] = ACTIONS(762),
    [anon_sym_CARET] = ACTIONS(762),
    [anon_sym_STAR_STAR] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(762),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_BANG_TILDE] = ACTIONS(762),
    [anon_sym_AMP_AMP] = ACTIONS(762),
    [anon_sym_PIPE_PIPE] = ACTIONS(762),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(762),
    [anon_sym_DASH_DASH] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(762),
    [anon_sym_PLUS_EQ] = ACTIONS(762),
    [anon_sym_DASH_EQ] = ACTIONS(762),
    [anon_sym_STAR_EQ] = ACTIONS(762),
    [anon_sym_SLASH_EQ] = ACTIONS(762),
    [anon_sym_PERCENT_EQ] = ACTIONS(762),
    [anon_sym_CARET_EQ] = ACTIONS(762),
    [anon_sym_DOLLAR] = ACTIONS(762),
    [anon_sym_AT] = ACTIONS(762),
    [aux_sym_number_token1] = ACTIONS(762),
    [aux_sym_number_token2] = ACTIONS(762),
    [anon_sym_DQUOTE] = ACTIONS(762),
    [anon_sym_POUND] = ACTIONS(762),
    [sym_concatenating_space] = ACTIONS(764),
    [sym__if_else_separator] = ACTIONS(764),
  },
  [191] = {
    [sym_identifier] = ACTIONS(766),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_SEMI] = ACTIONS(766),
    [anon_sym_LF] = ACTIONS(766),
    [anon_sym_CR_LF] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_while] = ACTIONS(766),
    [anon_sym_do] = ACTIONS(766),
    [anon_sym_for] = ACTIONS(766),
    [anon_sym_in] = ACTIONS(766),
    [sym_break_statement] = ACTIONS(766),
    [sym_continue_statement] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_exit] = ACTIONS(766),
    [anon_sym_return] = ACTIONS(766),
    [anon_sym_switch] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_RBRACE] = ACTIONS(766),
    [anon_sym_case] = ACTIONS(766),
    [anon_sym_default] = ACTIONS(766),
    [anon_sym_getline] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(766),
    [sym_next_statement] = ACTIONS(766),
    [sym_nextfile_statement] = ACTIONS(766),
    [anon_sym_print] = ACTIONS(766),
    [anon_sym_printf] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(766),
    [anon_sym_GT_GT] = ACTIONS(766),
    [anon_sym_PIPE] = ACTIONS(766),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_QMARK] = ACTIONS(766),
    [anon_sym_CARET] = ACTIONS(766),
    [anon_sym_STAR_STAR] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(766),
    [anon_sym_SLASH] = ACTIONS(766),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(766),
    [anon_sym_BANG_TILDE] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(766),
    [anon_sym_PIPE_PIPE] = ACTIONS(766),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(766),
    [anon_sym_DASH_DASH] = ACTIONS(766),
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_PLUS_EQ] = ACTIONS(766),
    [anon_sym_DASH_EQ] = ACTIONS(766),
    [anon_sym_STAR_EQ] = ACTIONS(766),
    [anon_sym_SLASH_EQ] = ACTIONS(766),
    [anon_sym_PERCENT_EQ] = ACTIONS(766),
    [anon_sym_CARET_EQ] = ACTIONS(766),
    [anon_sym_DOLLAR] = ACTIONS(766),
    [anon_sym_AT] = ACTIONS(766),
    [aux_sym_number_token1] = ACTIONS(766),
    [aux_sym_number_token2] = ACTIONS(766),
    [anon_sym_DQUOTE] = ACTIONS(766),
    [anon_sym_POUND] = ACTIONS(766),
    [sym_concatenating_space] = ACTIONS(768),
    [sym__if_else_separator] = ACTIONS(768),
  },
  [192] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LF] = ACTIONS(722),
    [anon_sym_CR_LF] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_in] = ACTIONS(722),
    [sym_break_statement] = ACTIONS(722),
    [sym_continue_statement] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_exit] = ACTIONS(722),
    [anon_sym_return] = ACTIONS(722),
    [anon_sym_switch] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_case] = ACTIONS(722),
    [anon_sym_default] = ACTIONS(722),
    [anon_sym_getline] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(722),
    [sym_next_statement] = ACTIONS(722),
    [sym_nextfile_statement] = ACTIONS(722),
    [anon_sym_print] = ACTIONS(722),
    [anon_sym_printf] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PIPE_AMP] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(722),
    [anon_sym_STAR_STAR] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(722),
    [anon_sym_EQ_EQ] = ACTIONS(722),
    [anon_sym_BANG_EQ] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_BANG_TILDE] = ACTIONS(722),
    [anon_sym_AMP_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(722),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(722),
    [anon_sym_DASH_DASH] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_PLUS_EQ] = ACTIONS(722),
    [anon_sym_DASH_EQ] = ACTIONS(722),
    [anon_sym_STAR_EQ] = ACTIONS(722),
    [anon_sym_SLASH_EQ] = ACTIONS(722),
    [anon_sym_PERCENT_EQ] = ACTIONS(722),
    [anon_sym_CARET_EQ] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(722),
    [aux_sym_number_token1] = ACTIONS(722),
    [aux_sym_number_token2] = ACTIONS(722),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [anon_sym_POUND] = ACTIONS(722),
    [sym_concatenating_space] = ACTIONS(724),
  },
  [193] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(770),
    [anon_sym_DASH_DASH] = ACTIONS(770),
    [anon_sym_EQ] = ACTIONS(772),
    [anon_sym_PLUS_EQ] = ACTIONS(772),
    [anon_sym_DASH_EQ] = ACTIONS(772),
    [anon_sym_STAR_EQ] = ACTIONS(772),
    [anon_sym_SLASH_EQ] = ACTIONS(772),
    [anon_sym_PERCENT_EQ] = ACTIONS(772),
    [anon_sym_CARET_EQ] = ACTIONS(772),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(774),
    [sym__func_call] = ACTIONS(776),
  },
  [194] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(684),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_PLUS_EQ] = ACTIONS(684),
    [anon_sym_DASH_EQ] = ACTIONS(684),
    [anon_sym_STAR_EQ] = ACTIONS(684),
    [anon_sym_SLASH_EQ] = ACTIONS(684),
    [anon_sym_PERCENT_EQ] = ACTIONS(684),
    [anon_sym_CARET_EQ] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(684),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__if_else_separator] = ACTIONS(686),
  },
  [195] = {
    [sym_identifier] = ACTIONS(778),
    [anon_sym_COMMA] = ACTIONS(778),
    [anon_sym_SEMI] = ACTIONS(778),
    [anon_sym_LF] = ACTIONS(778),
    [anon_sym_CR_LF] = ACTIONS(778),
    [anon_sym_if] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(778),
    [anon_sym_while] = ACTIONS(778),
    [anon_sym_do] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(778),
    [anon_sym_in] = ACTIONS(778),
    [sym_break_statement] = ACTIONS(778),
    [sym_continue_statement] = ACTIONS(778),
    [anon_sym_delete] = ACTIONS(778),
    [anon_sym_exit] = ACTIONS(778),
    [anon_sym_return] = ACTIONS(778),
    [anon_sym_switch] = ACTIONS(778),
    [anon_sym_LBRACE] = ACTIONS(778),
    [anon_sym_RBRACE] = ACTIONS(778),
    [anon_sym_case] = ACTIONS(778),
    [anon_sym_default] = ACTIONS(778),
    [anon_sym_getline] = ACTIONS(778),
    [anon_sym_LT] = ACTIONS(778),
    [sym_next_statement] = ACTIONS(778),
    [sym_nextfile_statement] = ACTIONS(778),
    [anon_sym_print] = ACTIONS(778),
    [anon_sym_printf] = ACTIONS(778),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(778),
    [anon_sym_PIPE] = ACTIONS(778),
    [anon_sym_PIPE_AMP] = ACTIONS(778),
    [anon_sym_QMARK] = ACTIONS(778),
    [anon_sym_CARET] = ACTIONS(778),
    [anon_sym_STAR_STAR] = ACTIONS(778),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(778),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(778),
    [anon_sym_GT_EQ] = ACTIONS(778),
    [anon_sym_EQ_EQ] = ACTIONS(778),
    [anon_sym_BANG_EQ] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(778),
    [anon_sym_BANG_TILDE] = ACTIONS(778),
    [anon_sym_AMP_AMP] = ACTIONS(778),
    [anon_sym_PIPE_PIPE] = ACTIONS(778),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_PLUS_PLUS] = ACTIONS(778),
    [anon_sym_DASH_DASH] = ACTIONS(778),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_PLUS_EQ] = ACTIONS(778),
    [anon_sym_DASH_EQ] = ACTIONS(778),
    [anon_sym_STAR_EQ] = ACTIONS(778),
    [anon_sym_SLASH_EQ] = ACTIONS(778),
    [anon_sym_PERCENT_EQ] = ACTIONS(778),
    [anon_sym_CARET_EQ] = ACTIONS(778),
    [anon_sym_DOLLAR] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(778),
    [aux_sym_number_token1] = ACTIONS(778),
    [aux_sym_number_token2] = ACTIONS(778),
    [anon_sym_DQUOTE] = ACTIONS(778),
    [anon_sym_POUND] = ACTIONS(778),
    [sym_concatenating_space] = ACTIONS(780),
    [sym__if_else_separator] = ACTIONS(780),
  },
  [196] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_PLUS_EQ] = ACTIONS(746),
    [anon_sym_DASH_EQ] = ACTIONS(746),
    [anon_sym_STAR_EQ] = ACTIONS(746),
    [anon_sym_SLASH_EQ] = ACTIONS(746),
    [anon_sym_PERCENT_EQ] = ACTIONS(746),
    [anon_sym_CARET_EQ] = ACTIONS(746),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(684),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__func_call] = ACTIONS(776),
  },
  [197] = {
    [sym_identifier] = ACTIONS(782),
    [anon_sym_COMMA] = ACTIONS(782),
    [anon_sym_SEMI] = ACTIONS(782),
    [anon_sym_LF] = ACTIONS(782),
    [anon_sym_CR_LF] = ACTIONS(782),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_LPAREN] = ACTIONS(782),
    [anon_sym_while] = ACTIONS(782),
    [anon_sym_do] = ACTIONS(782),
    [anon_sym_for] = ACTIONS(782),
    [anon_sym_in] = ACTIONS(782),
    [sym_break_statement] = ACTIONS(782),
    [sym_continue_statement] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(782),
    [anon_sym_exit] = ACTIONS(782),
    [anon_sym_return] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(782),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_RBRACE] = ACTIONS(782),
    [anon_sym_case] = ACTIONS(782),
    [anon_sym_default] = ACTIONS(782),
    [anon_sym_getline] = ACTIONS(782),
    [anon_sym_LT] = ACTIONS(782),
    [sym_next_statement] = ACTIONS(782),
    [sym_nextfile_statement] = ACTIONS(782),
    [anon_sym_print] = ACTIONS(782),
    [anon_sym_printf] = ACTIONS(782),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_PIPE_AMP] = ACTIONS(782),
    [anon_sym_QMARK] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(782),
    [anon_sym_STAR_STAR] = ACTIONS(782),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(782),
    [anon_sym_GT_EQ] = ACTIONS(782),
    [anon_sym_EQ_EQ] = ACTIONS(782),
    [anon_sym_BANG_EQ] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(782),
    [anon_sym_BANG_TILDE] = ACTIONS(782),
    [anon_sym_AMP_AMP] = ACTIONS(782),
    [anon_sym_PIPE_PIPE] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_PLUS_EQ] = ACTIONS(782),
    [anon_sym_DASH_EQ] = ACTIONS(782),
    [anon_sym_STAR_EQ] = ACTIONS(782),
    [anon_sym_SLASH_EQ] = ACTIONS(782),
    [anon_sym_PERCENT_EQ] = ACTIONS(782),
    [anon_sym_CARET_EQ] = ACTIONS(782),
    [anon_sym_DOLLAR] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(782),
    [aux_sym_number_token1] = ACTIONS(782),
    [aux_sym_number_token2] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(782),
    [anon_sym_POUND] = ACTIONS(782),
    [sym_concatenating_space] = ACTIONS(784),
    [sym__if_else_separator] = ACTIONS(784),
  },
  [198] = {
    [sym_identifier] = ACTIONS(718),
    [anon_sym_COMMA] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(718),
    [anon_sym_LF] = ACTIONS(718),
    [anon_sym_CR_LF] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(718),
    [anon_sym_while] = ACTIONS(718),
    [anon_sym_do] = ACTIONS(718),
    [anon_sym_for] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(718),
    [sym_break_statement] = ACTIONS(718),
    [sym_continue_statement] = ACTIONS(718),
    [anon_sym_delete] = ACTIONS(718),
    [anon_sym_exit] = ACTIONS(718),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_switch] = ACTIONS(718),
    [anon_sym_LBRACE] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_case] = ACTIONS(718),
    [anon_sym_default] = ACTIONS(718),
    [anon_sym_getline] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(718),
    [sym_next_statement] = ACTIONS(718),
    [sym_nextfile_statement] = ACTIONS(718),
    [anon_sym_print] = ACTIONS(718),
    [anon_sym_printf] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_PIPE_AMP] = ACTIONS(718),
    [anon_sym_QMARK] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(718),
    [anon_sym_STAR_STAR] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(718),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(718),
    [anon_sym_GT_EQ] = ACTIONS(718),
    [anon_sym_EQ_EQ] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(718),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_BANG_TILDE] = ACTIONS(718),
    [anon_sym_AMP_AMP] = ACTIONS(718),
    [anon_sym_PIPE_PIPE] = ACTIONS(718),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_PLUS_PLUS] = ACTIONS(718),
    [anon_sym_DASH_DASH] = ACTIONS(718),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_PLUS_EQ] = ACTIONS(718),
    [anon_sym_DASH_EQ] = ACTIONS(718),
    [anon_sym_STAR_EQ] = ACTIONS(718),
    [anon_sym_SLASH_EQ] = ACTIONS(718),
    [anon_sym_PERCENT_EQ] = ACTIONS(718),
    [anon_sym_CARET_EQ] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(718),
    [anon_sym_LBRACK] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(718),
    [aux_sym_number_token1] = ACTIONS(718),
    [aux_sym_number_token2] = ACTIONS(718),
    [anon_sym_DQUOTE] = ACTIONS(718),
    [anon_sym_POUND] = ACTIONS(718),
    [sym_concatenating_space] = ACTIONS(720),
  },
  [199] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(746),
    [anon_sym_PLUS_EQ] = ACTIONS(746),
    [anon_sym_DASH_EQ] = ACTIONS(746),
    [anon_sym_STAR_EQ] = ACTIONS(746),
    [anon_sym_SLASH_EQ] = ACTIONS(746),
    [anon_sym_PERCENT_EQ] = ACTIONS(746),
    [anon_sym_CARET_EQ] = ACTIONS(746),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(684),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
    [sym__if_else_separator] = ACTIONS(686),
    [sym__func_call] = ACTIONS(732),
  },
  [200] = {
    [sym_identifier] = ACTIONS(786),
    [anon_sym_COMMA] = ACTIONS(786),
    [anon_sym_SEMI] = ACTIONS(786),
    [anon_sym_LF] = ACTIONS(786),
    [anon_sym_CR_LF] = ACTIONS(786),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_while] = ACTIONS(786),
    [anon_sym_do] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_in] = ACTIONS(786),
    [sym_break_statement] = ACTIONS(786),
    [sym_continue_statement] = ACTIONS(786),
    [anon_sym_delete] = ACTIONS(786),
    [anon_sym_exit] = ACTIONS(786),
    [anon_sym_return] = ACTIONS(786),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_case] = ACTIONS(786),
    [anon_sym_default] = ACTIONS(786),
    [anon_sym_getline] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(786),
    [sym_next_statement] = ACTIONS(786),
    [sym_nextfile_statement] = ACTIONS(786),
    [anon_sym_print] = ACTIONS(786),
    [anon_sym_printf] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(786),
    [anon_sym_PIPE] = ACTIONS(786),
    [anon_sym_PIPE_AMP] = ACTIONS(786),
    [anon_sym_QMARK] = ACTIONS(786),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_STAR_STAR] = ACTIONS(786),
    [anon_sym_STAR] = ACTIONS(786),
    [anon_sym_SLASH] = ACTIONS(786),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(786),
    [anon_sym_TILDE] = ACTIONS(786),
    [anon_sym_BANG_TILDE] = ACTIONS(786),
    [anon_sym_AMP_AMP] = ACTIONS(786),
    [anon_sym_PIPE_PIPE] = ACTIONS(786),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_PLUS_PLUS] = ACTIONS(786),
    [anon_sym_DASH_DASH] = ACTIONS(786),
    [anon_sym_EQ] = ACTIONS(786),
    [anon_sym_PLUS_EQ] = ACTIONS(786),
    [anon_sym_DASH_EQ] = ACTIONS(786),
    [anon_sym_STAR_EQ] = ACTIONS(786),
    [anon_sym_SLASH_EQ] = ACTIONS(786),
    [anon_sym_PERCENT_EQ] = ACTIONS(786),
    [anon_sym_CARET_EQ] = ACTIONS(786),
    [anon_sym_DOLLAR] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(786),
    [aux_sym_number_token1] = ACTIONS(786),
    [aux_sym_number_token2] = ACTIONS(786),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_POUND] = ACTIONS(786),
    [sym_concatenating_space] = ACTIONS(788),
    [sym__if_else_separator] = ACTIONS(788),
  },
  [201] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(728),
    [anon_sym_PLUS_EQ] = ACTIONS(728),
    [anon_sym_DASH_EQ] = ACTIONS(728),
    [anon_sym_STAR_EQ] = ACTIONS(728),
    [anon_sym_SLASH_EQ] = ACTIONS(728),
    [anon_sym_PERCENT_EQ] = ACTIONS(728),
    [anon_sym_CARET_EQ] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(666),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(730),
    [sym__if_else_separator] = ACTIONS(674),
    [sym__func_call] = ACTIONS(732),
  },
  [202] = {
    [sym_identifier] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(714),
    [anon_sym_SEMI] = ACTIONS(714),
    [anon_sym_LF] = ACTIONS(714),
    [anon_sym_CR_LF] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_while] = ACTIONS(714),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(714),
    [anon_sym_in] = ACTIONS(714),
    [sym_break_statement] = ACTIONS(714),
    [sym_continue_statement] = ACTIONS(714),
    [anon_sym_delete] = ACTIONS(714),
    [anon_sym_exit] = ACTIONS(714),
    [anon_sym_return] = ACTIONS(714),
    [anon_sym_switch] = ACTIONS(714),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_RBRACE] = ACTIONS(714),
    [anon_sym_case] = ACTIONS(714),
    [anon_sym_default] = ACTIONS(714),
    [anon_sym_getline] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(714),
    [sym_next_statement] = ACTIONS(714),
    [sym_nextfile_statement] = ACTIONS(714),
    [anon_sym_print] = ACTIONS(714),
    [anon_sym_printf] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(714),
    [anon_sym_PIPE_AMP] = ACTIONS(714),
    [anon_sym_QMARK] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [anon_sym_STAR_STAR] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_BANG_TILDE] = ACTIONS(714),
    [anon_sym_AMP_AMP] = ACTIONS(714),
    [anon_sym_PIPE_PIPE] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_PLUS_PLUS] = ACTIONS(714),
    [anon_sym_DASH_DASH] = ACTIONS(714),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_PLUS_EQ] = ACTIONS(714),
    [anon_sym_DASH_EQ] = ACTIONS(714),
    [anon_sym_STAR_EQ] = ACTIONS(714),
    [anon_sym_SLASH_EQ] = ACTIONS(714),
    [anon_sym_PERCENT_EQ] = ACTIONS(714),
    [anon_sym_CARET_EQ] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(714),
    [aux_sym_number_token1] = ACTIONS(714),
    [aux_sym_number_token2] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [anon_sym_POUND] = ACTIONS(714),
    [sym_concatenating_space] = ACTIONS(716),
  },
  [203] = {
    [sym_identifier] = ACTIONS(790),
    [anon_sym_COMMA] = ACTIONS(790),
    [anon_sym_SEMI] = ACTIONS(790),
    [anon_sym_LF] = ACTIONS(790),
    [anon_sym_CR_LF] = ACTIONS(790),
    [anon_sym_if] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_while] = ACTIONS(790),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(790),
    [anon_sym_in] = ACTIONS(790),
    [sym_break_statement] = ACTIONS(790),
    [sym_continue_statement] = ACTIONS(790),
    [anon_sym_delete] = ACTIONS(790),
    [anon_sym_exit] = ACTIONS(790),
    [anon_sym_return] = ACTIONS(790),
    [anon_sym_switch] = ACTIONS(790),
    [anon_sym_LBRACE] = ACTIONS(790),
    [anon_sym_RBRACE] = ACTIONS(790),
    [anon_sym_case] = ACTIONS(790),
    [anon_sym_default] = ACTIONS(790),
    [anon_sym_getline] = ACTIONS(790),
    [anon_sym_LT] = ACTIONS(790),
    [sym_next_statement] = ACTIONS(790),
    [sym_nextfile_statement] = ACTIONS(790),
    [anon_sym_print] = ACTIONS(790),
    [anon_sym_printf] = ACTIONS(790),
    [anon_sym_GT] = ACTIONS(790),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_PIPE] = ACTIONS(790),
    [anon_sym_PIPE_AMP] = ACTIONS(790),
    [anon_sym_QMARK] = ACTIONS(790),
    [anon_sym_CARET] = ACTIONS(790),
    [anon_sym_STAR_STAR] = ACTIONS(790),
    [anon_sym_STAR] = ACTIONS(790),
    [anon_sym_SLASH] = ACTIONS(790),
    [anon_sym_PERCENT] = ACTIONS(790),
    [anon_sym_PLUS] = ACTIONS(790),
    [anon_sym_DASH] = ACTIONS(790),
    [anon_sym_LT_EQ] = ACTIONS(790),
    [anon_sym_GT_EQ] = ACTIONS(790),
    [anon_sym_EQ_EQ] = ACTIONS(790),
    [anon_sym_BANG_EQ] = ACTIONS(790),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_BANG_TILDE] = ACTIONS(790),
    [anon_sym_AMP_AMP] = ACTIONS(790),
    [anon_sym_PIPE_PIPE] = ACTIONS(790),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_PLUS_PLUS] = ACTIONS(790),
    [anon_sym_DASH_DASH] = ACTIONS(790),
    [anon_sym_EQ] = ACTIONS(790),
    [anon_sym_PLUS_EQ] = ACTIONS(790),
    [anon_sym_DASH_EQ] = ACTIONS(790),
    [anon_sym_STAR_EQ] = ACTIONS(790),
    [anon_sym_SLASH_EQ] = ACTIONS(790),
    [anon_sym_PERCENT_EQ] = ACTIONS(790),
    [anon_sym_CARET_EQ] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(790),
    [anon_sym_AT] = ACTIONS(790),
    [aux_sym_number_token1] = ACTIONS(790),
    [aux_sym_number_token2] = ACTIONS(790),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [anon_sym_POUND] = ACTIONS(790),
    [sym_concatenating_space] = ACTIONS(792),
    [sym__if_else_separator] = ACTIONS(792),
  },
  [204] = {
    [sym_identifier] = ACTIONS(794),
    [anon_sym_COMMA] = ACTIONS(794),
    [anon_sym_SEMI] = ACTIONS(794),
    [anon_sym_LF] = ACTIONS(794),
    [anon_sym_CR_LF] = ACTIONS(794),
    [anon_sym_if] = ACTIONS(794),
    [anon_sym_LPAREN] = ACTIONS(794),
    [anon_sym_while] = ACTIONS(794),
    [anon_sym_do] = ACTIONS(794),
    [anon_sym_for] = ACTIONS(794),
    [anon_sym_in] = ACTIONS(794),
    [sym_break_statement] = ACTIONS(794),
    [sym_continue_statement] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(794),
    [anon_sym_exit] = ACTIONS(794),
    [anon_sym_return] = ACTIONS(794),
    [anon_sym_switch] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(794),
    [anon_sym_RBRACE] = ACTIONS(794),
    [anon_sym_case] = ACTIONS(794),
    [anon_sym_default] = ACTIONS(794),
    [anon_sym_getline] = ACTIONS(794),
    [anon_sym_LT] = ACTIONS(794),
    [sym_next_statement] = ACTIONS(794),
    [sym_nextfile_statement] = ACTIONS(794),
    [anon_sym_print] = ACTIONS(794),
    [anon_sym_printf] = ACTIONS(794),
    [anon_sym_GT] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(794),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_PIPE_AMP] = ACTIONS(794),
    [anon_sym_QMARK] = ACTIONS(794),
    [anon_sym_CARET] = ACTIONS(794),
    [anon_sym_STAR_STAR] = ACTIONS(794),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(794),
    [anon_sym_DASH] = ACTIONS(794),
    [anon_sym_LT_EQ] = ACTIONS(794),
    [anon_sym_GT_EQ] = ACTIONS(794),
    [anon_sym_EQ_EQ] = ACTIONS(794),
    [anon_sym_BANG_EQ] = ACTIONS(794),
    [anon_sym_TILDE] = ACTIONS(794),
    [anon_sym_BANG_TILDE] = ACTIONS(794),
    [anon_sym_AMP_AMP] = ACTIONS(794),
    [anon_sym_PIPE_PIPE] = ACTIONS(794),
    [anon_sym_BANG] = ACTIONS(794),
    [anon_sym_PLUS_PLUS] = ACTIONS(794),
    [anon_sym_DASH_DASH] = ACTIONS(794),
    [anon_sym_EQ] = ACTIONS(794),
    [anon_sym_PLUS_EQ] = ACTIONS(794),
    [anon_sym_DASH_EQ] = ACTIONS(794),
    [anon_sym_STAR_EQ] = ACTIONS(794),
    [anon_sym_SLASH_EQ] = ACTIONS(794),
    [anon_sym_PERCENT_EQ] = ACTIONS(794),
    [anon_sym_CARET_EQ] = ACTIONS(794),
    [anon_sym_DOLLAR] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(794),
    [aux_sym_number_token1] = ACTIONS(794),
    [aux_sym_number_token2] = ACTIONS(794),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_POUND] = ACTIONS(794),
    [sym_concatenating_space] = ACTIONS(796),
    [sym__if_else_separator] = ACTIONS(796),
  },
  [205] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(722),
    [anon_sym_SEMI] = ACTIONS(722),
    [anon_sym_LF] = ACTIONS(722),
    [anon_sym_CR_LF] = ACTIONS(722),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_in] = ACTIONS(722),
    [sym_break_statement] = ACTIONS(722),
    [sym_continue_statement] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_exit] = ACTIONS(722),
    [anon_sym_return] = ACTIONS(722),
    [anon_sym_switch] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_case] = ACTIONS(722),
    [anon_sym_default] = ACTIONS(722),
    [anon_sym_getline] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(722),
    [sym_next_statement] = ACTIONS(722),
    [sym_nextfile_statement] = ACTIONS(722),
    [anon_sym_print] = ACTIONS(722),
    [anon_sym_printf] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_PIPE_AMP] = ACTIONS(722),
    [anon_sym_QMARK] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(722),
    [anon_sym_STAR_STAR] = ACTIONS(722),
    [anon_sym_STAR] = ACTIONS(722),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(722),
    [anon_sym_EQ_EQ] = ACTIONS(722),
    [anon_sym_BANG_EQ] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_BANG_TILDE] = ACTIONS(722),
    [anon_sym_AMP_AMP] = ACTIONS(722),
    [anon_sym_PIPE_PIPE] = ACTIONS(722),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(722),
    [anon_sym_DASH_DASH] = ACTIONS(722),
    [anon_sym_EQ] = ACTIONS(722),
    [anon_sym_PLUS_EQ] = ACTIONS(722),
    [anon_sym_DASH_EQ] = ACTIONS(722),
    [anon_sym_STAR_EQ] = ACTIONS(722),
    [anon_sym_SLASH_EQ] = ACTIONS(722),
    [anon_sym_PERCENT_EQ] = ACTIONS(722),
    [anon_sym_CARET_EQ] = ACTIONS(722),
    [anon_sym_DOLLAR] = ACTIONS(722),
    [anon_sym_AT] = ACTIONS(722),
    [aux_sym_number_token1] = ACTIONS(722),
    [aux_sym_number_token2] = ACTIONS(722),
    [anon_sym_DQUOTE] = ACTIONS(722),
    [anon_sym_POUND] = ACTIONS(722),
    [sym_concatenating_space] = ACTIONS(724),
    [sym__if_else_separator] = ACTIONS(724),
  },
  [206] = {
    [sym_identifier] = ACTIONS(798),
    [anon_sym_COMMA] = ACTIONS(798),
    [anon_sym_SEMI] = ACTIONS(798),
    [anon_sym_LF] = ACTIONS(798),
    [anon_sym_CR_LF] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(798),
    [anon_sym_LPAREN] = ACTIONS(798),
    [anon_sym_while] = ACTIONS(798),
    [anon_sym_do] = ACTIONS(798),
    [anon_sym_for] = ACTIONS(798),
    [anon_sym_in] = ACTIONS(798),
    [sym_break_statement] = ACTIONS(798),
    [sym_continue_statement] = ACTIONS(798),
    [anon_sym_delete] = ACTIONS(798),
    [anon_sym_exit] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(798),
    [anon_sym_switch] = ACTIONS(798),
    [anon_sym_LBRACE] = ACTIONS(798),
    [anon_sym_RBRACE] = ACTIONS(798),
    [anon_sym_case] = ACTIONS(798),
    [anon_sym_default] = ACTIONS(798),
    [anon_sym_getline] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(798),
    [sym_next_statement] = ACTIONS(798),
    [sym_nextfile_statement] = ACTIONS(798),
    [anon_sym_print] = ACTIONS(798),
    [anon_sym_printf] = ACTIONS(798),
    [anon_sym_GT] = ACTIONS(798),
    [anon_sym_GT_GT] = ACTIONS(798),
    [anon_sym_PIPE] = ACTIONS(798),
    [anon_sym_PIPE_AMP] = ACTIONS(798),
    [anon_sym_QMARK] = ACTIONS(798),
    [anon_sym_CARET] = ACTIONS(798),
    [anon_sym_STAR_STAR] = ACTIONS(798),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_PERCENT] = ACTIONS(798),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_LT_EQ] = ACTIONS(798),
    [anon_sym_GT_EQ] = ACTIONS(798),
    [anon_sym_EQ_EQ] = ACTIONS(798),
    [anon_sym_BANG_EQ] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [anon_sym_BANG_TILDE] = ACTIONS(798),
    [anon_sym_AMP_AMP] = ACTIONS(798),
    [anon_sym_PIPE_PIPE] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_PLUS_PLUS] = ACTIONS(798),
    [anon_sym_DASH_DASH] = ACTIONS(798),
    [anon_sym_EQ] = ACTIONS(798),
    [anon_sym_PLUS_EQ] = ACTIONS(798),
    [anon_sym_DASH_EQ] = ACTIONS(798),
    [anon_sym_STAR_EQ] = ACTIONS(798),
    [anon_sym_SLASH_EQ] = ACTIONS(798),
    [anon_sym_PERCENT_EQ] = ACTIONS(798),
    [anon_sym_CARET_EQ] = ACTIONS(798),
    [anon_sym_DOLLAR] = ACTIONS(798),
    [anon_sym_AT] = ACTIONS(798),
    [aux_sym_number_token1] = ACTIONS(798),
    [aux_sym_number_token2] = ACTIONS(798),
    [anon_sym_DQUOTE] = ACTIONS(798),
    [anon_sym_POUND] = ACTIONS(798),
    [sym_concatenating_space] = ACTIONS(800),
    [sym__if_else_separator] = ACTIONS(800),
  },
  [207] = {
    [sym_identifier] = ACTIONS(802),
    [anon_sym_COMMA] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(802),
    [anon_sym_LF] = ACTIONS(802),
    [anon_sym_CR_LF] = ACTIONS(802),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(802),
    [anon_sym_while] = ACTIONS(802),
    [anon_sym_do] = ACTIONS(802),
    [anon_sym_for] = ACTIONS(802),
    [anon_sym_in] = ACTIONS(802),
    [sym_break_statement] = ACTIONS(802),
    [sym_continue_statement] = ACTIONS(802),
    [anon_sym_delete] = ACTIONS(802),
    [anon_sym_exit] = ACTIONS(802),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_switch] = ACTIONS(802),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_RBRACE] = ACTIONS(802),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_default] = ACTIONS(802),
    [anon_sym_getline] = ACTIONS(802),
    [anon_sym_LT] = ACTIONS(802),
    [sym_next_statement] = ACTIONS(802),
    [sym_nextfile_statement] = ACTIONS(802),
    [anon_sym_print] = ACTIONS(802),
    [anon_sym_printf] = ACTIONS(802),
    [anon_sym_GT] = ACTIONS(802),
    [anon_sym_GT_GT] = ACTIONS(802),
    [anon_sym_PIPE] = ACTIONS(802),
    [anon_sym_PIPE_AMP] = ACTIONS(802),
    [anon_sym_QMARK] = ACTIONS(802),
    [anon_sym_CARET] = ACTIONS(802),
    [anon_sym_STAR_STAR] = ACTIONS(802),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_SLASH] = ACTIONS(802),
    [anon_sym_PERCENT] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(802),
    [anon_sym_DASH] = ACTIONS(802),
    [anon_sym_LT_EQ] = ACTIONS(802),
    [anon_sym_GT_EQ] = ACTIONS(802),
    [anon_sym_EQ_EQ] = ACTIONS(802),
    [anon_sym_BANG_EQ] = ACTIONS(802),
    [anon_sym_TILDE] = ACTIONS(802),
    [anon_sym_BANG_TILDE] = ACTIONS(802),
    [anon_sym_AMP_AMP] = ACTIONS(802),
    [anon_sym_PIPE_PIPE] = ACTIONS(802),
    [anon_sym_BANG] = ACTIONS(802),
    [anon_sym_PLUS_PLUS] = ACTIONS(802),
    [anon_sym_DASH_DASH] = ACTIONS(802),
    [anon_sym_EQ] = ACTIONS(802),
    [anon_sym_PLUS_EQ] = ACTIONS(802),
    [anon_sym_DASH_EQ] = ACTIONS(802),
    [anon_sym_STAR_EQ] = ACTIONS(802),
    [anon_sym_SLASH_EQ] = ACTIONS(802),
    [anon_sym_PERCENT_EQ] = ACTIONS(802),
    [anon_sym_CARET_EQ] = ACTIONS(802),
    [anon_sym_DOLLAR] = ACTIONS(802),
    [anon_sym_AT] = ACTIONS(802),
    [aux_sym_number_token1] = ACTIONS(802),
    [aux_sym_number_token2] = ACTIONS(802),
    [anon_sym_DQUOTE] = ACTIONS(802),
    [anon_sym_POUND] = ACTIONS(802),
    [sym_concatenating_space] = ACTIONS(804),
    [sym__if_else_separator] = ACTIONS(804),
  },
  [208] = {
    [sym_identifier] = ACTIONS(806),
    [anon_sym_COMMA] = ACTIONS(806),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_LF] = ACTIONS(806),
    [anon_sym_CR_LF] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_do] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_in] = ACTIONS(806),
    [sym_break_statement] = ACTIONS(806),
    [sym_continue_statement] = ACTIONS(806),
    [anon_sym_delete] = ACTIONS(806),
    [anon_sym_exit] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_switch] = ACTIONS(806),
    [anon_sym_LBRACE] = ACTIONS(806),
    [anon_sym_RBRACE] = ACTIONS(806),
    [anon_sym_case] = ACTIONS(806),
    [anon_sym_default] = ACTIONS(806),
    [anon_sym_getline] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(806),
    [sym_next_statement] = ACTIONS(806),
    [sym_nextfile_statement] = ACTIONS(806),
    [anon_sym_print] = ACTIONS(806),
    [anon_sym_printf] = ACTIONS(806),
    [anon_sym_GT] = ACTIONS(806),
    [anon_sym_GT_GT] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_PIPE_AMP] = ACTIONS(806),
    [anon_sym_QMARK] = ACTIONS(806),
    [anon_sym_CARET] = ACTIONS(806),
    [anon_sym_STAR_STAR] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(806),
    [anon_sym_SLASH] = ACTIONS(806),
    [anon_sym_PERCENT] = ACTIONS(806),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_LT_EQ] = ACTIONS(806),
    [anon_sym_GT_EQ] = ACTIONS(806),
    [anon_sym_EQ_EQ] = ACTIONS(806),
    [anon_sym_BANG_EQ] = ACTIONS(806),
    [anon_sym_TILDE] = ACTIONS(806),
    [anon_sym_BANG_TILDE] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(806),
    [anon_sym_PIPE_PIPE] = ACTIONS(806),
    [anon_sym_BANG] = ACTIONS(806),
    [anon_sym_PLUS_PLUS] = ACTIONS(806),
    [anon_sym_DASH_DASH] = ACTIONS(806),
    [anon_sym_EQ] = ACTIONS(806),
    [anon_sym_PLUS_EQ] = ACTIONS(806),
    [anon_sym_DASH_EQ] = ACTIONS(806),
    [anon_sym_STAR_EQ] = ACTIONS(806),
    [anon_sym_SLASH_EQ] = ACTIONS(806),
    [anon_sym_PERCENT_EQ] = ACTIONS(806),
    [anon_sym_CARET_EQ] = ACTIONS(806),
    [anon_sym_DOLLAR] = ACTIONS(806),
    [anon_sym_AT] = ACTIONS(806),
    [aux_sym_number_token1] = ACTIONS(806),
    [aux_sym_number_token2] = ACTIONS(806),
    [anon_sym_DQUOTE] = ACTIONS(806),
    [anon_sym_POUND] = ACTIONS(806),
    [sym_concatenating_space] = ACTIONS(808),
    [sym__if_else_separator] = ACTIONS(808),
  },
  [209] = {
    [sym_identifier] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(714),
    [anon_sym_SEMI] = ACTIONS(714),
    [anon_sym_LF] = ACTIONS(714),
    [anon_sym_CR_LF] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_while] = ACTIONS(714),
    [anon_sym_do] = ACTIONS(714),
    [anon_sym_for] = ACTIONS(714),
    [anon_sym_in] = ACTIONS(714),
    [sym_break_statement] = ACTIONS(714),
    [sym_continue_statement] = ACTIONS(714),
    [anon_sym_delete] = ACTIONS(714),
    [anon_sym_exit] = ACTIONS(714),
    [anon_sym_return] = ACTIONS(714),
    [anon_sym_switch] = ACTIONS(714),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_RBRACE] = ACTIONS(714),
    [anon_sym_getline] = ACTIONS(714),
    [anon_sym_LT] = ACTIONS(810),
    [sym_next_statement] = ACTIONS(714),
    [sym_nextfile_statement] = ACTIONS(714),
    [anon_sym_print] = ACTIONS(714),
    [anon_sym_printf] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(714),
    [anon_sym_PIPE_AMP] = ACTIONS(714),
    [anon_sym_QMARK] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [anon_sym_STAR_STAR] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(714),
    [anon_sym_GT_EQ] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(714),
    [anon_sym_BANG_TILDE] = ACTIONS(714),
    [anon_sym_AMP_AMP] = ACTIONS(714),
    [anon_sym_PIPE_PIPE] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_PLUS_PLUS] = ACTIONS(714),
    [anon_sym_DASH_DASH] = ACTIONS(714),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_PLUS_EQ] = ACTIONS(714),
    [anon_sym_DASH_EQ] = ACTIONS(714),
    [anon_sym_STAR_EQ] = ACTIONS(714),
    [anon_sym_SLASH_EQ] = ACTIONS(714),
    [anon_sym_PERCENT_EQ] = ACTIONS(714),
    [anon_sym_CARET_EQ] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(714),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(714),
    [aux_sym_number_token2] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(714),
    [anon_sym_POUND] = ACTIONS(714),
    [sym_concatenating_space] = ACTIONS(716),
    [sym__if_else_separator] = ACTIONS(716),
  },
  [210] = {
    [sym_identifier] = ACTIONS(812),
    [anon_sym_COMMA] = ACTIONS(812),
    [anon_sym_SEMI] = ACTIONS(812),
    [anon_sym_LF] = ACTIONS(812),
    [anon_sym_CR_LF] = ACTIONS(812),
    [anon_sym_if] = ACTIONS(812),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_while] = ACTIONS(812),
    [anon_sym_do] = ACTIONS(812),
    [anon_sym_for] = ACTIONS(812),
    [anon_sym_in] = ACTIONS(812),
    [sym_break_statement] = ACTIONS(812),
    [sym_continue_statement] = ACTIONS(812),
    [anon_sym_delete] = ACTIONS(812),
    [anon_sym_exit] = ACTIONS(812),
    [anon_sym_return] = ACTIONS(812),
    [anon_sym_switch] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_case] = ACTIONS(812),
    [anon_sym_default] = ACTIONS(812),
    [anon_sym_getline] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(812),
    [sym_next_statement] = ACTIONS(812),
    [sym_nextfile_statement] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(812),
    [anon_sym_printf] = ACTIONS(812),
    [anon_sym_GT] = ACTIONS(812),
    [anon_sym_GT_GT] = ACTIONS(812),
    [anon_sym_PIPE] = ACTIONS(812),
    [anon_sym_PIPE_AMP] = ACTIONS(812),
    [anon_sym_QMARK] = ACTIONS(812),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_STAR_STAR] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(812),
    [anon_sym_SLASH] = ACTIONS(812),
    [anon_sym_PERCENT] = ACTIONS(812),
    [anon_sym_PLUS] = ACTIONS(812),
    [anon_sym_DASH] = ACTIONS(812),
    [anon_sym_LT_EQ] = ACTIONS(812),
    [anon_sym_GT_EQ] = ACTIONS(812),
    [anon_sym_EQ_EQ] = ACTIONS(812),
    [anon_sym_BANG_EQ] = ACTIONS(812),
    [anon_sym_TILDE] = ACTIONS(812),
    [anon_sym_BANG_TILDE] = ACTIONS(812),
    [anon_sym_AMP_AMP] = ACTIONS(812),
    [anon_sym_PIPE_PIPE] = ACTIONS(812),
    [anon_sym_BANG] = ACTIONS(812),
    [anon_sym_PLUS_PLUS] = ACTIONS(812),
    [anon_sym_DASH_DASH] = ACTIONS(812),
    [anon_sym_EQ] = ACTIONS(812),
    [anon_sym_PLUS_EQ] = ACTIONS(812),
    [anon_sym_DASH_EQ] = ACTIONS(812),
    [anon_sym_STAR_EQ] = ACTIONS(812),
    [anon_sym_SLASH_EQ] = ACTIONS(812),
    [anon_sym_PERCENT_EQ] = ACTIONS(812),
    [anon_sym_CARET_EQ] = ACTIONS(812),
    [anon_sym_DOLLAR] = ACTIONS(812),
    [anon_sym_AT] = ACTIONS(812),
    [aux_sym_number_token1] = ACTIONS(812),
    [aux_sym_number_token2] = ACTIONS(812),
    [anon_sym_DQUOTE] = ACTIONS(812),
    [anon_sym_POUND] = ACTIONS(812),
    [sym_concatenating_space] = ACTIONS(814),
    [sym__if_else_separator] = ACTIONS(814),
  },
  [211] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(684),
    [anon_sym_SEMI] = ACTIONS(684),
    [anon_sym_LF] = ACTIONS(684),
    [anon_sym_CR_LF] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_while] = ACTIONS(684),
    [anon_sym_do] = ACTIONS(684),
    [anon_sym_for] = ACTIONS(684),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(684),
    [sym_continue_statement] = ACTIONS(684),
    [anon_sym_delete] = ACTIONS(684),
    [anon_sym_exit] = ACTIONS(684),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(684),
    [anon_sym_LBRACE] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_case] = ACTIONS(684),
    [anon_sym_default] = ACTIONS(684),
    [anon_sym_getline] = ACTIONS(684),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(684),
    [sym_nextfile_statement] = ACTIONS(684),
    [anon_sym_print] = ACTIONS(684),
    [anon_sym_printf] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_PLUS_PLUS] = ACTIONS(684),
    [anon_sym_DASH_DASH] = ACTIONS(684),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_PLUS_EQ] = ACTIONS(684),
    [anon_sym_DASH_EQ] = ACTIONS(684),
    [anon_sym_STAR_EQ] = ACTIONS(684),
    [anon_sym_SLASH_EQ] = ACTIONS(684),
    [anon_sym_PERCENT_EQ] = ACTIONS(684),
    [anon_sym_CARET_EQ] = ACTIONS(684),
    [anon_sym_DOLLAR] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(684),
    [aux_sym_number_token1] = ACTIONS(684),
    [aux_sym_number_token2] = ACTIONS(684),
    [anon_sym_DQUOTE] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(684),
    [sym_concatenating_space] = ACTIONS(686),
  },
  [212] = {
    [sym_identifier] = ACTIONS(816),
    [anon_sym_COMMA] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [anon_sym_LF] = ACTIONS(816),
    [anon_sym_CR_LF] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_do] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_in] = ACTIONS(816),
    [sym_break_statement] = ACTIONS(816),
    [sym_continue_statement] = ACTIONS(816),
    [anon_sym_delete] = ACTIONS(816),
    [anon_sym_exit] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_RBRACE] = ACTIONS(816),
    [anon_sym_case] = ACTIONS(816),
    [anon_sym_default] = ACTIONS(816),
    [anon_sym_getline] = ACTIONS(816),
    [anon_sym_LT] = ACTIONS(816),
    [sym_next_statement] = ACTIONS(816),
    [sym_nextfile_statement] = ACTIONS(816),
    [anon_sym_print] = ACTIONS(816),
    [anon_sym_printf] = ACTIONS(816),
    [anon_sym_GT] = ACTIONS(816),
    [anon_sym_GT_GT] = ACTIONS(816),
    [anon_sym_PIPE] = ACTIONS(816),
    [anon_sym_PIPE_AMP] = ACTIONS(816),
    [anon_sym_QMARK] = ACTIONS(816),
    [anon_sym_CARET] = ACTIONS(816),
    [anon_sym_STAR_STAR] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(816),
    [anon_sym_PERCENT] = ACTIONS(816),
    [anon_sym_PLUS] = ACTIONS(816),
    [anon_sym_DASH] = ACTIONS(816),
    [anon_sym_LT_EQ] = ACTIONS(816),
    [anon_sym_GT_EQ] = ACTIONS(816),
    [anon_sym_EQ_EQ] = ACTIONS(816),
    [anon_sym_BANG_EQ] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(816),
    [anon_sym_BANG_TILDE] = ACTIONS(816),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_PIPE_PIPE] = ACTIONS(816),
    [anon_sym_BANG] = ACTIONS(816),
    [anon_sym_PLUS_PLUS] = ACTIONS(816),
    [anon_sym_DASH_DASH] = ACTIONS(816),
    [anon_sym_EQ] = ACTIONS(816),
    [anon_sym_PLUS_EQ] = ACTIONS(816),
    [anon_sym_DASH_EQ] = ACTIONS(816),
    [anon_sym_STAR_EQ] = ACTIONS(816),
    [anon_sym_SLASH_EQ] = ACTIONS(816),
    [anon_sym_PERCENT_EQ] = ACTIONS(816),
    [anon_sym_CARET_EQ] = ACTIONS(816),
    [anon_sym_DOLLAR] = ACTIONS(816),
    [anon_sym_AT] = ACTIONS(816),
    [aux_sym_number_token1] = ACTIONS(816),
    [aux_sym_number_token2] = ACTIONS(816),
    [anon_sym_DQUOTE] = ACTIONS(816),
    [anon_sym_POUND] = ACTIONS(816),
    [sym_concatenating_space] = ACTIONS(818),
    [sym__if_else_separator] = ACTIONS(818),
  },
  [213] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(668),
    [anon_sym_DASH_DASH] = ACTIONS(668),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(666),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
    [sym__if_else_separator] = ACTIONS(674),
  },
  [214] = {
    [sym_identifier] = ACTIONS(820),
    [anon_sym_COMMA] = ACTIONS(820),
    [anon_sym_SEMI] = ACTIONS(820),
    [anon_sym_LF] = ACTIONS(820),
    [anon_sym_CR_LF] = ACTIONS(820),
    [anon_sym_if] = ACTIONS(820),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_while] = ACTIONS(820),
    [anon_sym_do] = ACTIONS(820),
    [anon_sym_for] = ACTIONS(820),
    [anon_sym_in] = ACTIONS(820),
    [sym_break_statement] = ACTIONS(820),
    [sym_continue_statement] = ACTIONS(820),
    [anon_sym_delete] = ACTIONS(820),
    [anon_sym_exit] = ACTIONS(820),
    [anon_sym_return] = ACTIONS(820),
    [anon_sym_switch] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(820),
    [anon_sym_RBRACE] = ACTIONS(820),
    [anon_sym_case] = ACTIONS(820),
    [anon_sym_default] = ACTIONS(820),
    [anon_sym_getline] = ACTIONS(820),
    [anon_sym_LT] = ACTIONS(820),
    [sym_next_statement] = ACTIONS(820),
    [sym_nextfile_statement] = ACTIONS(820),
    [anon_sym_print] = ACTIONS(820),
    [anon_sym_printf] = ACTIONS(820),
    [anon_sym_GT] = ACTIONS(820),
    [anon_sym_GT_GT] = ACTIONS(820),
    [anon_sym_PIPE] = ACTIONS(820),
    [anon_sym_PIPE_AMP] = ACTIONS(820),
    [anon_sym_QMARK] = ACTIONS(820),
    [anon_sym_CARET] = ACTIONS(820),
    [anon_sym_STAR_STAR] = ACTIONS(820),
    [anon_sym_STAR] = ACTIONS(820),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_PERCENT] = ACTIONS(820),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_LT_EQ] = ACTIONS(820),
    [anon_sym_GT_EQ] = ACTIONS(820),
    [anon_sym_EQ_EQ] = ACTIONS(820),
    [anon_sym_BANG_EQ] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_BANG_TILDE] = ACTIONS(820),
    [anon_sym_AMP_AMP] = ACTIONS(820),
    [anon_sym_PIPE_PIPE] = ACTIONS(820),
    [anon_sym_BANG] = ACTIONS(820),
    [anon_sym_PLUS_PLUS] = ACTIONS(820),
    [anon_sym_DASH_DASH] = ACTIONS(820),
    [anon_sym_EQ] = ACTIONS(820),
    [anon_sym_PLUS_EQ] = ACTIONS(820),
    [anon_sym_DASH_EQ] = ACTIONS(820),
    [anon_sym_STAR_EQ] = ACTIONS(820),
    [anon_sym_SLASH_EQ] = ACTIONS(820),
    [anon_sym_PERCENT_EQ] = ACTIONS(820),
    [anon_sym_CARET_EQ] = ACTIONS(820),
    [anon_sym_DOLLAR] = ACTIONS(820),
    [anon_sym_AT] = ACTIONS(820),
    [aux_sym_number_token1] = ACTIONS(820),
    [aux_sym_number_token2] = ACTIONS(820),
    [anon_sym_DQUOTE] = ACTIONS(820),
    [anon_sym_POUND] = ACTIONS(820),
    [sym_concatenating_space] = ACTIONS(822),
    [sym__if_else_separator] = ACTIONS(822),
  },
  [215] = {
    [sym_identifier] = ACTIONS(824),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_SEMI] = ACTIONS(824),
    [anon_sym_LF] = ACTIONS(824),
    [anon_sym_CR_LF] = ACTIONS(824),
    [anon_sym_if] = ACTIONS(824),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_while] = ACTIONS(824),
    [anon_sym_do] = ACTIONS(824),
    [anon_sym_for] = ACTIONS(824),
    [anon_sym_in] = ACTIONS(824),
    [sym_break_statement] = ACTIONS(824),
    [sym_continue_statement] = ACTIONS(824),
    [anon_sym_delete] = ACTIONS(824),
    [anon_sym_exit] = ACTIONS(824),
    [anon_sym_return] = ACTIONS(824),
    [anon_sym_switch] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_RBRACE] = ACTIONS(824),
    [anon_sym_case] = ACTIONS(824),
    [anon_sym_default] = ACTIONS(824),
    [anon_sym_getline] = ACTIONS(824),
    [anon_sym_LT] = ACTIONS(824),
    [sym_next_statement] = ACTIONS(824),
    [sym_nextfile_statement] = ACTIONS(824),
    [anon_sym_print] = ACTIONS(824),
    [anon_sym_printf] = ACTIONS(824),
    [anon_sym_GT] = ACTIONS(824),
    [anon_sym_GT_GT] = ACTIONS(824),
    [anon_sym_PIPE] = ACTIONS(824),
    [anon_sym_PIPE_AMP] = ACTIONS(824),
    [anon_sym_QMARK] = ACTIONS(824),
    [anon_sym_CARET] = ACTIONS(824),
    [anon_sym_STAR_STAR] = ACTIONS(824),
    [anon_sym_STAR] = ACTIONS(824),
    [anon_sym_SLASH] = ACTIONS(824),
    [anon_sym_PERCENT] = ACTIONS(824),
    [anon_sym_PLUS] = ACTIONS(824),
    [anon_sym_DASH] = ACTIONS(824),
    [anon_sym_LT_EQ] = ACTIONS(824),
    [anon_sym_GT_EQ] = ACTIONS(824),
    [anon_sym_EQ_EQ] = ACTIONS(824),
    [anon_sym_BANG_EQ] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_BANG_TILDE] = ACTIONS(824),
    [anon_sym_AMP_AMP] = ACTIONS(824),
    [anon_sym_PIPE_PIPE] = ACTIONS(824),
    [anon_sym_BANG] = ACTIONS(824),
    [anon_sym_PLUS_PLUS] = ACTIONS(824),
    [anon_sym_DASH_DASH] = ACTIONS(824),
    [anon_sym_EQ] = ACTIONS(824),
    [anon_sym_PLUS_EQ] = ACTIONS(824),
    [anon_sym_DASH_EQ] = ACTIONS(824),
    [anon_sym_STAR_EQ] = ACTIONS(824),
    [anon_sym_SLASH_EQ] = ACTIONS(824),
    [anon_sym_PERCENT_EQ] = ACTIONS(824),
    [anon_sym_CARET_EQ] = ACTIONS(824),
    [anon_sym_DOLLAR] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(824),
    [aux_sym_number_token1] = ACTIONS(824),
    [aux_sym_number_token2] = ACTIONS(824),
    [anon_sym_DQUOTE] = ACTIONS(824),
    [anon_sym_POUND] = ACTIONS(824),
    [sym_concatenating_space] = ACTIONS(826),
    [sym__if_else_separator] = ACTIONS(826),
  },
  [216] = {
    [sym_identifier] = ACTIONS(828),
    [anon_sym_COMMA] = ACTIONS(828),
    [anon_sym_SEMI] = ACTIONS(828),
    [anon_sym_LF] = ACTIONS(828),
    [anon_sym_CR_LF] = ACTIONS(828),
    [anon_sym_if] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(828),
    [anon_sym_while] = ACTIONS(828),
    [anon_sym_do] = ACTIONS(828),
    [anon_sym_for] = ACTIONS(828),
    [anon_sym_in] = ACTIONS(828),
    [sym_break_statement] = ACTIONS(828),
    [sym_continue_statement] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(828),
    [anon_sym_exit] = ACTIONS(828),
    [anon_sym_return] = ACTIONS(828),
    [anon_sym_switch] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(828),
    [anon_sym_RBRACE] = ACTIONS(828),
    [anon_sym_case] = ACTIONS(828),
    [anon_sym_default] = ACTIONS(828),
    [anon_sym_getline] = ACTIONS(828),
    [anon_sym_LT] = ACTIONS(828),
    [sym_next_statement] = ACTIONS(828),
    [sym_nextfile_statement] = ACTIONS(828),
    [anon_sym_print] = ACTIONS(828),
    [anon_sym_printf] = ACTIONS(828),
    [anon_sym_GT] = ACTIONS(828),
    [anon_sym_GT_GT] = ACTIONS(828),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_PIPE_AMP] = ACTIONS(828),
    [anon_sym_QMARK] = ACTIONS(828),
    [anon_sym_CARET] = ACTIONS(828),
    [anon_sym_STAR_STAR] = ACTIONS(828),
    [anon_sym_STAR] = ACTIONS(828),
    [anon_sym_SLASH] = ACTIONS(828),
    [anon_sym_PERCENT] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(828),
    [anon_sym_DASH] = ACTIONS(828),
    [anon_sym_LT_EQ] = ACTIONS(828),
    [anon_sym_GT_EQ] = ACTIONS(828),
    [anon_sym_EQ_EQ] = ACTIONS(828),
    [anon_sym_BANG_EQ] = ACTIONS(828),
    [anon_sym_TILDE] = ACTIONS(828),
    [anon_sym_BANG_TILDE] = ACTIONS(828),
    [anon_sym_AMP_AMP] = ACTIONS(828),
    [anon_sym_PIPE_PIPE] = ACTIONS(828),
    [anon_sym_BANG] = ACTIONS(828),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_EQ] = ACTIONS(828),
    [anon_sym_PLUS_EQ] = ACTIONS(828),
    [anon_sym_DASH_EQ] = ACTIONS(828),
    [anon_sym_STAR_EQ] = ACTIONS(828),
    [anon_sym_SLASH_EQ] = ACTIONS(828),
    [anon_sym_PERCENT_EQ] = ACTIONS(828),
    [anon_sym_CARET_EQ] = ACTIONS(828),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [anon_sym_AT] = ACTIONS(828),
    [aux_sym_number_token1] = ACTIONS(828),
    [aux_sym_number_token2] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(828),
    [anon_sym_POUND] = ACTIONS(828),
    [sym_concatenating_space] = ACTIONS(830),
    [sym__if_else_separator] = ACTIONS(830),
  },
  [217] = {
    [sym_identifier] = ACTIONS(742),
    [anon_sym_COMMA] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(742),
    [anon_sym_LF] = ACTIONS(742),
    [anon_sym_CR_LF] = ACTIONS(742),
    [anon_sym_if] = ACTIONS(742),
    [anon_sym_LPAREN] = ACTIONS(742),
    [anon_sym_while] = ACTIONS(742),
    [anon_sym_do] = ACTIONS(742),
    [anon_sym_for] = ACTIONS(742),
    [anon_sym_in] = ACTIONS(742),
    [sym_break_statement] = ACTIONS(742),
    [sym_continue_statement] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(742),
    [anon_sym_exit] = ACTIONS(742),
    [anon_sym_return] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_RBRACE] = ACTIONS(742),
    [anon_sym_case] = ACTIONS(742),
    [anon_sym_default] = ACTIONS(742),
    [anon_sym_getline] = ACTIONS(742),
    [anon_sym_LT] = ACTIONS(742),
    [sym_next_statement] = ACTIONS(742),
    [sym_nextfile_statement] = ACTIONS(742),
    [anon_sym_print] = ACTIONS(742),
    [anon_sym_printf] = ACTIONS(742),
    [anon_sym_GT] = ACTIONS(742),
    [anon_sym_GT_GT] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(742),
    [anon_sym_PIPE_AMP] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(742),
    [anon_sym_CARET] = ACTIONS(742),
    [anon_sym_STAR_STAR] = ACTIONS(742),
    [anon_sym_STAR] = ACTIONS(742),
    [anon_sym_SLASH] = ACTIONS(742),
    [anon_sym_PERCENT] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(742),
    [anon_sym_DASH] = ACTIONS(742),
    [anon_sym_LT_EQ] = ACTIONS(742),
    [anon_sym_GT_EQ] = ACTIONS(742),
    [anon_sym_EQ_EQ] = ACTIONS(742),
    [anon_sym_BANG_EQ] = ACTIONS(742),
    [anon_sym_TILDE] = ACTIONS(742),
    [anon_sym_BANG_TILDE] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(742),
    [anon_sym_PIPE_PIPE] = ACTIONS(742),
    [anon_sym_BANG] = ACTIONS(742),
    [anon_sym_PLUS_PLUS] = ACTIONS(742),
    [anon_sym_DASH_DASH] = ACTIONS(742),
    [anon_sym_EQ] = ACTIONS(742),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_DOLLAR] = ACTIONS(742),
    [anon_sym_LBRACK] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(742),
    [aux_sym_number_token1] = ACTIONS(742),
    [aux_sym_number_token2] = ACTIONS(742),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_POUND] = ACTIONS(742),
    [sym_concatenating_space] = ACTIONS(744),
  },
  [218] = {
    [sym_array_ref] = STATE(202),
    [sym_namespace] = STATE(2243),
    [sym_ns_qualified_name] = STATE(267),
    [sym_identifier] = ACTIONS(832),
    [anon_sym_COMMA] = ACTIONS(680),
    [anon_sym_SEMI] = ACTIONS(680),
    [anon_sym_LF] = ACTIONS(680),
    [anon_sym_CR_LF] = ACTIONS(680),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_while] = ACTIONS(680),
    [anon_sym_do] = ACTIONS(680),
    [anon_sym_for] = ACTIONS(680),
    [anon_sym_in] = ACTIONS(680),
    [sym_break_statement] = ACTIONS(680),
    [sym_continue_statement] = ACTIONS(680),
    [anon_sym_delete] = ACTIONS(680),
    [anon_sym_exit] = ACTIONS(680),
    [anon_sym_return] = ACTIONS(680),
    [anon_sym_switch] = ACTIONS(680),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_getline] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(834),
    [sym_next_statement] = ACTIONS(680),
    [sym_nextfile_statement] = ACTIONS(680),
    [anon_sym_print] = ACTIONS(680),
    [anon_sym_printf] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(680),
    [anon_sym_PIPE_AMP] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(680),
    [anon_sym_STAR_STAR] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_TILDE] = ACTIONS(680),
    [anon_sym_BANG_TILDE] = ACTIONS(680),
    [anon_sym_AMP_AMP] = ACTIONS(680),
    [anon_sym_PIPE_PIPE] = ACTIONS(680),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_DOLLAR] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(680),
    [aux_sym_number_token1] = ACTIONS(680),
    [aux_sym_number_token2] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(680),
    [anon_sym_POUND] = ACTIONS(680),
    [sym_concatenating_space] = ACTIONS(682),
  },
  [219] = {
    [sym_identifier] = ACTIONS(836),
    [anon_sym_COMMA] = ACTIONS(836),
    [anon_sym_SEMI] = ACTIONS(836),
    [anon_sym_LF] = ACTIONS(836),
    [anon_sym_CR_LF] = ACTIONS(836),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_while] = ACTIONS(836),
    [anon_sym_do] = ACTIONS(836),
    [anon_sym_for] = ACTIONS(836),
    [anon_sym_in] = ACTIONS(836),
    [sym_break_statement] = ACTIONS(836),
    [sym_continue_statement] = ACTIONS(836),
    [anon_sym_delete] = ACTIONS(836),
    [anon_sym_exit] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(836),
    [anon_sym_switch] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_RBRACE] = ACTIONS(836),
    [anon_sym_case] = ACTIONS(836),
    [anon_sym_default] = ACTIONS(836),
    [anon_sym_getline] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(836),
    [sym_next_statement] = ACTIONS(836),
    [sym_nextfile_statement] = ACTIONS(836),
    [anon_sym_print] = ACTIONS(836),
    [anon_sym_printf] = ACTIONS(836),
    [anon_sym_GT] = ACTIONS(836),
    [anon_sym_GT_GT] = ACTIONS(836),
    [anon_sym_PIPE] = ACTIONS(836),
    [anon_sym_PIPE_AMP] = ACTIONS(836),
    [anon_sym_QMARK] = ACTIONS(836),
    [anon_sym_CARET] = ACTIONS(836),
    [anon_sym_STAR_STAR] = ACTIONS(836),
    [anon_sym_STAR] = ACTIONS(836),
    [anon_sym_SLASH] = ACTIONS(836),
    [anon_sym_PERCENT] = ACTIONS(836),
    [anon_sym_PLUS] = ACTIONS(836),
    [anon_sym_DASH] = ACTIONS(836),
    [anon_sym_LT_EQ] = ACTIONS(836),
    [anon_sym_GT_EQ] = ACTIONS(836),
    [anon_sym_EQ_EQ] = ACTIONS(836),
    [anon_sym_BANG_EQ] = ACTIONS(836),
    [anon_sym_TILDE] = ACTIONS(836),
    [anon_sym_BANG_TILDE] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(836),
    [anon_sym_PIPE_PIPE] = ACTIONS(836),
    [anon_sym_BANG] = ACTIONS(836),
    [anon_sym_PLUS_PLUS] = ACTIONS(836),
    [anon_sym_DASH_DASH] = ACTIONS(836),
    [anon_sym_EQ] = ACTIONS(836),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_DOLLAR] = ACTIONS(836),
    [anon_sym_AT] = ACTIONS(836),
    [aux_sym_number_token1] = ACTIONS(836),
    [aux_sym_number_token2] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(836),
    [anon_sym_POUND] = ACTIONS(836),
    [sym_concatenating_space] = ACTIONS(838),
    [sym__if_else_separator] = ACTIONS(838),
  },
  [220] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(688),
    [anon_sym_DASH_DASH] = ACTIONS(688),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(666),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
  },
  [221] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(734),
    [anon_sym_DASH_DASH] = ACTIONS(734),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(736),
    [anon_sym_DASH_EQ] = ACTIONS(736),
    [anon_sym_STAR_EQ] = ACTIONS(736),
    [anon_sym_SLASH_EQ] = ACTIONS(736),
    [anon_sym_PERCENT_EQ] = ACTIONS(736),
    [anon_sym_CARET_EQ] = ACTIONS(736),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(666),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
    [sym__if_else_separator] = ACTIONS(674),
    [sym__func_call] = ACTIONS(732),
  },
  [222] = {
    [sym_identifier] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_LF] = ACTIONS(666),
    [anon_sym_CR_LF] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [sym_break_statement] = ACTIONS(666),
    [sym_continue_statement] = ACTIONS(666),
    [anon_sym_delete] = ACTIONS(666),
    [anon_sym_exit] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_getline] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(666),
    [sym_next_statement] = ACTIONS(666),
    [sym_nextfile_statement] = ACTIONS(666),
    [anon_sym_print] = ACTIONS(666),
    [anon_sym_printf] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PIPE_AMP] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(666),
    [anon_sym_BANG_TILDE] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(840),
    [anon_sym_EQ] = ACTIONS(842),
    [anon_sym_PLUS_EQ] = ACTIONS(842),
    [anon_sym_DASH_EQ] = ACTIONS(842),
    [anon_sym_STAR_EQ] = ACTIONS(842),
    [anon_sym_SLASH_EQ] = ACTIONS(842),
    [anon_sym_PERCENT_EQ] = ACTIONS(842),
    [anon_sym_CARET_EQ] = ACTIONS(842),
    [anon_sym_DOLLAR] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [aux_sym_number_token1] = ACTIONS(666),
    [aux_sym_number_token2] = ACTIONS(666),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(666),
    [sym_concatenating_space] = ACTIONS(674),
    [sym__func_call] = ACTIONS(776),
  },
  [223] = {
    [sym_identifier] = ACTIONS(844),
    [anon_sym_COMMA] = ACTIONS(844),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_LF] = ACTIONS(844),
    [anon_sym_CR_LF] = ACTIONS(844),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(844),
    [anon_sym_while] = ACTIONS(844),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_for] = ACTIONS(844),
    [anon_sym_in] = ACTIONS(844),
    [sym_break_statement] = ACTIONS(844),
    [sym_continue_statement] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_exit] = ACTIONS(844),
    [anon_sym_return] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_RBRACE] = ACTIONS(844),
    [anon_sym_case] = ACTIONS(844),
    [anon_sym_default] = ACTIONS(844),
    [anon_sym_getline] = ACTIONS(844),
    [anon_sym_LT] = ACTIONS(844),
    [sym_next_statement] = ACTIONS(844),
    [sym_nextfile_statement] = ACTIONS(844),
    [anon_sym_print] = ACTIONS(844),
    [anon_sym_printf] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_PIPE_AMP] = ACTIONS(844),
    [anon_sym_QMARK] = ACTIONS(844),
    [anon_sym_CARET] = ACTIONS(844),
    [anon_sym_STAR_STAR] = ACTIONS(844),
    [anon_sym_STAR] = ACTIONS(844),
    [anon_sym_SLASH] = ACTIONS(844),
    [anon_sym_PERCENT] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(844),
    [anon_sym_GT_EQ] = ACTIONS(844),
    [anon_sym_EQ_EQ] = ACTIONS(844),
    [anon_sym_BANG_EQ] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(844),
    [anon_sym_BANG_TILDE] = ACTIONS(844),
    [anon_sym_AMP_AMP] = ACTIONS(844),
    [anon_sym_PIPE_PIPE] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(844),
    [anon_sym_DASH_DASH] = ACTIONS(844),
    [anon_sym_EQ] = ACTIONS(844),
    [anon_sym_PLUS_EQ] = ACTIONS(844),
    [anon_sym_DASH_EQ] = ACTIONS(844),
    [anon_sym_STAR_EQ] = ACTIONS(844),
    [anon_sym_SLASH_EQ] = ACTIONS(844),
    [anon_sym_PERCENT_EQ] = ACTIONS(844),
    [anon_sym_CARET_EQ] = ACTIONS(844),
    [anon_sym_DOLLAR] = ACTIONS(844),
    [anon_sym_AT] = ACTIONS(844),
    [aux_sym_number_token1] = ACTIONS(844),
    [aux_sym_number_token2] = ACTIONS(844),
    [anon_sym_DQUOTE] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(844),
    [sym_concatenating_space] = ACTIONS(846),
    [sym__if_else_separator] = ACTIONS(846),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 2,
    ACTIONS(814), 1,
      sym_concatenating_space,
    ACTIONS(812), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [69] = 2,
    ACTIONS(830), 1,
      sym_concatenating_space,
    ACTIONS(828), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [138] = 6,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(776), 1,
      sym__func_call,
    ACTIONS(840), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(842), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [215] = 2,
    ACTIONS(822), 1,
      sym_concatenating_space,
    ACTIONS(820), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [284] = 2,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(778), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [353] = 2,
    ACTIONS(808), 1,
      sym_concatenating_space,
    ACTIONS(806), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [422] = 2,
    ACTIONS(846), 1,
      sym_concatenating_space,
    ACTIONS(844), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [491] = 4,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(810), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 60,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [564] = 2,
    ACTIONS(788), 1,
      sym_concatenating_space,
    ACTIONS(786), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [633] = 6,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(730), 1,
      sym_concatenating_space,
    ACTIONS(726), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(728), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [710] = 2,
    ACTIONS(796), 1,
      sym_concatenating_space,
    ACTIONS(794), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [779] = 2,
    ACTIONS(784), 1,
      sym_concatenating_space,
    ACTIONS(782), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [848] = 2,
    ACTIONS(768), 1,
      sym_concatenating_space,
    ACTIONS(766), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [917] = 2,
    ACTIONS(826), 1,
      sym_concatenating_space,
    ACTIONS(824), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [986] = 2,
    ACTIONS(818), 1,
      sym_concatenating_space,
    ACTIONS(816), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1055] = 6,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(776), 1,
      sym__func_call,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1132] = 2,
    ACTIONS(724), 1,
      sym_concatenating_space,
    ACTIONS(722), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1201] = 3,
    ACTIONS(850), 1,
      sym_regex_flags,
    ACTIONS(852), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(848), 61,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1272] = 2,
    ACTIONS(792), 1,
      sym_concatenating_space,
    ACTIONS(790), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1341] = 6,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(774), 1,
      sym_concatenating_space,
    ACTIONS(776), 1,
      sym__func_call,
    ACTIONS(770), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(772), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1418] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(854), 1,
      anon_sym_LT,
    ACTIONS(714), 60,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1493] = 2,
    ACTIONS(838), 1,
      sym_concatenating_space,
    ACTIONS(836), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1562] = 3,
    ACTIONS(858), 1,
      sym_regex_flags,
    ACTIONS(860), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(856), 61,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1633] = 5,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(734), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(736), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1708] = 3,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1779] = 2,
    ACTIONS(764), 1,
      sym_concatenating_space,
    ACTIONS(762), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1848] = 2,
    ACTIONS(800), 1,
      sym_concatenating_space,
    ACTIONS(798), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1917] = 2,
    ACTIONS(804), 1,
      sym_concatenating_space,
    ACTIONS(802), 63,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [1986] = 3,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2057] = 3,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(688), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(666), 61,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2128] = 5,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(686), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2203] = 5,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(730), 1,
      sym_concatenating_space,
    ACTIONS(726), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(728), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2277] = 7,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(872), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(874), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 46,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2355] = 11,
    ACTIONS(878), 1,
      anon_sym_in,
    ACTIONS(880), 1,
      anon_sym_QMARK,
    ACTIONS(882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(884), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(872), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(886), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2441] = 4,
    ACTIONS(686), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2513] = 7,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(872), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(890), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 46,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2591] = 3,
    ACTIONS(860), 1,
      sym_concatenating_space,
    ACTIONS(892), 1,
      sym_regex_flags,
    ACTIONS(856), 61,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2661] = 11,
    ACTIONS(878), 1,
      anon_sym_in,
    ACTIONS(880), 1,
      anon_sym_QMARK,
    ACTIONS(882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(884), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(872), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(896), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2747] = 11,
    ACTIONS(878), 1,
      anon_sym_in,
    ACTIONS(880), 1,
      anon_sym_QMARK,
    ACTIONS(882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(884), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(872), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(900), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2833] = 3,
    ACTIONS(852), 1,
      sym_concatenating_space,
    ACTIONS(902), 1,
      sym_regex_flags,
    ACTIONS(848), 61,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2903] = 11,
    ACTIONS(878), 1,
      anon_sym_in,
    ACTIONS(880), 1,
      anon_sym_QMARK,
    ACTIONS(882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(884), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(872), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(906), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [2989] = 4,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(734), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(736), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3061] = 9,
    ACTIONS(878), 1,
      anon_sym_in,
    ACTIONS(882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(872), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 44,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3143] = 4,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(854), 1,
      anon_sym_LT,
    ACTIONS(714), 60,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3215] = 8,
    ACTIONS(878), 1,
      anon_sym_in,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(872), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 45,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3295] = 5,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(774), 1,
      sym_concatenating_space,
    ACTIONS(770), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(772), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3369] = 6,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 48,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3445] = 4,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 56,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3517] = 3,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 59,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3587] = 5,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(910), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3661] = 5,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3735] = 5,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3809] = 12,
    ACTIONS(878), 1,
      anon_sym_in,
    ACTIONS(880), 1,
      anon_sym_QMARK,
    ACTIONS(882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(884), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(866), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(870), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(872), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(914), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(916), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(868), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(864), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 40,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3897] = 5,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(840), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(842), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [3971] = 12,
    ACTIONS(916), 1,
      sym_concatenating_space,
    ACTIONS(918), 1,
      anon_sym_in,
    ACTIONS(924), 1,
      anon_sym_QMARK,
    ACTIONS(934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(936), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(922), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(932), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 40,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4058] = 11,
    ACTIONS(900), 1,
      sym_concatenating_space,
    ACTIONS(918), 1,
      anon_sym_in,
    ACTIONS(924), 1,
      anon_sym_QMARK,
    ACTIONS(934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(936), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(932), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4143] = 5,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4216] = 5,
    ACTIONS(910), 1,
      sym_concatenating_space,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4289] = 11,
    ACTIONS(906), 1,
      sym_concatenating_space,
    ACTIONS(918), 1,
      anon_sym_in,
    ACTIONS(924), 1,
      anon_sym_QMARK,
    ACTIONS(934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(936), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(932), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4374] = 3,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 59,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4443] = 4,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 56,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4514] = 4,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(840), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(842), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4585] = 6,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 48,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4660] = 8,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(918), 1,
      anon_sym_in,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(932), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 45,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4739] = 7,
    ACTIONS(874), 1,
      sym_concatenating_space,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(932), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 46,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4816] = 4,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4887] = 11,
    ACTIONS(896), 1,
      sym_concatenating_space,
    ACTIONS(918), 1,
      anon_sym_in,
    ACTIONS(924), 1,
      anon_sym_QMARK,
    ACTIONS(934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(936), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(932), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [4972] = 9,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(918), 1,
      anon_sym_in,
    ACTIONS(934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(932), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 44,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [5053] = 4,
    ACTIONS(774), 1,
      sym_concatenating_space,
    ACTIONS(770), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(772), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [5124] = 11,
    ACTIONS(886), 1,
      sym_concatenating_space,
    ACTIONS(918), 1,
      anon_sym_in,
    ACTIONS(924), 1,
      anon_sym_QMARK,
    ACTIONS(934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(936), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(932), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 42,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [5209] = 7,
    ACTIONS(890), 1,
      sym_concatenating_space,
    ACTIONS(926), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(930), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(932), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(928), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(920), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 46,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [5286] = 7,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(940), 1,
      sym__func_call,
    ACTIONS(666), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 11,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_COLON,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(686), 23,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [5361] = 5,
    ACTIONS(942), 1,
      sym_identifier,
    STATE(2231), 1,
      sym_namespace,
    STATE(314), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(682), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [5432] = 6,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(940), 1,
      sym__func_call,
    ACTIONS(944), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(666), 23,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 32,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [5505] = 19,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(696), 1,
      anon_sym_LPAREN,
    ACTIONS(700), 1,
      anon_sym_SLASH,
    ACTIONS(704), 1,
      anon_sym_DOLLAR,
    ACTIONS(706), 1,
      anon_sym_AT,
    ACTIONS(708), 1,
      anon_sym_DQUOTE,
    ACTIONS(948), 1,
      sym__if_else_separator,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(340), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(702), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(330), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(505), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
    ACTIONS(946), 20,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_POUND,
  [5603] = 2,
    ACTIONS(718), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(720), 37,
      sym_concatenating_space,
      sym__func_call,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [5667] = 19,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(696), 1,
      anon_sym_LPAREN,
    ACTIONS(700), 1,
      anon_sym_SLASH,
    ACTIONS(704), 1,
      anon_sym_DOLLAR,
    ACTIONS(706), 1,
      anon_sym_AT,
    ACTIONS(708), 1,
      anon_sym_DQUOTE,
    ACTIONS(952), 1,
      sym__if_else_separator,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(340), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(702), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(330), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(506), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
    ACTIONS(950), 20,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_POUND,
  [5765] = 29,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(15), 1,
      anon_sym_getline,
    ACTIONS(17), 1,
      anon_sym_SLASH,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(27), 1,
      anon_sym_AT,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      ts_builtin_sym_end,
    STATE(448), 1,
      sym_ns_qualified_name,
    STATE(483), 1,
      sym_array_ref,
    STATE(519), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(1632), 1,
      sym_pattern,
    STATE(1693), 1,
      sym_block,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(23), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(35), 2,
      anon_sym_function,
      anon_sym_func,
    STATE(1685), 2,
      sym_range_pattern,
      sym__special_pattern,
    ACTIONS(9), 3,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
    ACTIONS(7), 4,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
    STATE(302), 5,
      sym_rule,
      sym_directive,
      sym_func_def,
      sym_comment,
      aux_sym_program_repeat1,
    STATE(567), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(596), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [5883] = 29,
    ACTIONS(956), 1,
      ts_builtin_sym_end,
    ACTIONS(958), 1,
      sym_identifier,
    ACTIONS(967), 1,
      anon_sym_LPAREN,
    ACTIONS(970), 1,
      anon_sym_LBRACE,
    ACTIONS(973), 1,
      anon_sym_getline,
    ACTIONS(976), 1,
      anon_sym_SLASH,
    ACTIONS(982), 1,
      anon_sym_BANG,
    ACTIONS(988), 1,
      anon_sym_DOLLAR,
    ACTIONS(991), 1,
      anon_sym_AT,
    ACTIONS(994), 1,
      aux_sym_number_token1,
    ACTIONS(997), 1,
      aux_sym_number_token2,
    ACTIONS(1000), 1,
      anon_sym_DQUOTE,
    ACTIONS(1006), 1,
      anon_sym_POUND,
    STATE(448), 1,
      sym_ns_qualified_name,
    STATE(483), 1,
      sym_array_ref,
    STATE(519), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(1632), 1,
      sym_pattern,
    STATE(1693), 1,
      sym_block,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(979), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(985), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1003), 2,
      anon_sym_function,
      anon_sym_func,
    STATE(1685), 2,
      sym_range_pattern,
      sym__special_pattern,
    ACTIONS(964), 3,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
    ACTIONS(961), 4,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
    STATE(302), 5,
      sym_rule,
      sym_directive,
      sym_func_def,
      sym_comment,
      aux_sym_program_repeat1,
    STATE(567), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(596), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [6001] = 5,
    ACTIONS(1009), 1,
      sym_identifier,
    STATE(2255), 1,
      sym_namespace,
    ACTIONS(682), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    STATE(355), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6071] = 7,
    ACTIONS(1011), 1,
      sym_identifier,
    ACTIONS(1013), 1,
      anon_sym_LT,
    STATE(347), 1,
      sym_ns_qualified_name,
    STATE(355), 1,
      sym_array_ref,
    STATE(2255), 1,
      sym_namespace,
    ACTIONS(682), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(680), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6145] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 23,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 34,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6213] = 6,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(940), 1,
      sym__func_call,
    ACTIONS(666), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 11,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(686), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6285] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 23,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(724), 34,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6353] = 5,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(940), 1,
      sym__func_call,
    ACTIONS(944), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(666), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 33,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6423] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1015), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6490] = 3,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(724), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6555] = 2,
    ACTIONS(718), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(720), 36,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6618] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1015), 1,
      anon_sym_LBRACK,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6687] = 4,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(944), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(666), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 33,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6754] = 3,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6819] = 5,
    ACTIONS(682), 1,
      sym_concatenating_space,
    ACTIONS(1019), 1,
      sym_identifier,
    STATE(2240), 1,
      sym_namespace,
    STATE(367), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6888] = 2,
    ACTIONS(742), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(744), 36,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [6951] = 5,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(666), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 11,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(686), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7020] = 2,
    ACTIONS(720), 1,
      sym__if_else_separator,
    ACTIONS(718), 57,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7083] = 7,
    ACTIONS(682), 1,
      sym__if_else_separator,
    ACTIONS(1021), 1,
      sym_identifier,
    ACTIONS(1023), 1,
      anon_sym_LT,
    STATE(378), 1,
      sym_ns_qualified_name,
    STATE(379), 1,
      sym_array_ref,
    STATE(2252), 1,
      sym_namespace,
    ACTIONS(680), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7156] = 5,
    ACTIONS(682), 1,
      sym__if_else_separator,
    ACTIONS(1025), 1,
      sym_identifier,
    STATE(2252), 1,
      sym_namespace,
    STATE(379), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7225] = 7,
    ACTIONS(682), 1,
      sym_concatenating_space,
    ACTIONS(1027), 1,
      sym_identifier,
    ACTIONS(1029), 1,
      anon_sym_LT,
    STATE(367), 1,
      sym_array_ref,
    STATE(398), 1,
      sym_ns_qualified_name,
    STATE(2240), 1,
      sym_namespace,
    ACTIONS(680), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7298] = 2,
    ACTIONS(744), 1,
      sym__if_else_separator,
    ACTIONS(742), 57,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7361] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1015), 1,
      anon_sym_LBRACK,
    ACTIONS(724), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7428] = 18,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(748), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_SLASH,
    ACTIONS(756), 1,
      anon_sym_DOLLAR,
    ACTIONS(758), 1,
      anon_sym_AT,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(206), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(754), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(196), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(524), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
    ACTIONS(946), 20,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_POUND,
  [7523] = 18,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(748), 1,
      anon_sym_LPAREN,
    ACTIONS(752), 1,
      anon_sym_SLASH,
    ACTIONS(756), 1,
      anon_sym_DOLLAR,
    ACTIONS(758), 1,
      anon_sym_AT,
    ACTIONS(760), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(206), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(754), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(196), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(523), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
    ACTIONS(950), 20,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_POUND,
  [7618] = 2,
    ACTIONS(802), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(804), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7680] = 2,
    ACTIONS(836), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(838), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7742] = 2,
    ACTIONS(816), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(818), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7804] = 2,
    ACTIONS(820), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(822), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7866] = 2,
    ACTIONS(762), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(764), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7928] = 4,
    ACTIONS(666), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 11,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(686), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [7994] = 4,
    ACTIONS(666), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 11,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(686), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8060] = 2,
    ACTIONS(720), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(718), 55,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8122] = 2,
    ACTIONS(798), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(800), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8184] = 2,
    ACTIONS(824), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(826), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8246] = 3,
    ACTIONS(1015), 1,
      anon_sym_LBRACK,
    ACTIONS(724), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8310] = 4,
    ACTIONS(1031), 1,
      sym_identifier,
    STATE(2225), 1,
      sym_namespace,
    STATE(474), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8376] = 2,
    ACTIONS(722), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(724), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8438] = 3,
    ACTIONS(1033), 1,
      sym_regex_flags,
    ACTIONS(852), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(848), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8502] = 1,
    ACTIONS(718), 57,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8562] = 2,
    ACTIONS(744), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(742), 55,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8624] = 2,
    ACTIONS(806), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(808), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8686] = 2,
    ACTIONS(782), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(784), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8748] = 3,
    ACTIONS(944), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(666), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 33,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8812] = 2,
    ACTIONS(812), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(814), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8874] = 2,
    ACTIONS(778), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [8936] = 4,
    ACTIONS(1015), 1,
      anon_sym_LBRACK,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9002] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(724), 1,
      sym_concatenating_space,
    ACTIONS(1035), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9068] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(1037), 1,
      anon_sym_LT,
    ACTIONS(1039), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9136] = 2,
    ACTIONS(766), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(768), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9198] = 2,
    ACTIONS(844), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(846), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9260] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(724), 1,
      sym__if_else_separator,
    ACTIONS(1039), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9326] = 1,
    ACTIONS(742), 57,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9386] = 3,
    ACTIONS(1041), 1,
      sym_regex_flags,
    ACTIONS(860), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(856), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9450] = 3,
    ACTIONS(1015), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9514] = 2,
    ACTIONS(786), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(788), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9576] = 2,
    ACTIONS(794), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(796), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9638] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(1035), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9704] = 2,
    ACTIONS(828), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(830), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9766] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(1035), 1,
      anon_sym_LBRACK,
    ACTIONS(1043), 1,
      anon_sym_LT,
    ACTIONS(714), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9834] = 2,
    ACTIONS(790), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(792), 35,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      anon_sym_RBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9896] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(1039), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [9962] = 6,
    ACTIONS(1045), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      anon_sym_LT,
    STATE(418), 1,
      sym_ns_qualified_name,
    STATE(474), 1,
      sym_array_ref,
    STATE(2225), 1,
      sym_namespace,
    ACTIONS(680), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10032] = 2,
    ACTIONS(808), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(806), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10093] = 7,
    ACTIONS(890), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 39,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10164] = 3,
    ACTIONS(724), 1,
      sym__if_else_separator,
    ACTIONS(1039), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10227] = 3,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(1035), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10290] = 2,
    ACTIONS(764), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(762), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10351] = 5,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 47,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10418] = 7,
    ACTIONS(874), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 39,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10489] = 2,
    ACTIONS(720), 1,
      sym_concatenating_space,
    ACTIONS(718), 55,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10550] = 2,
    ACTIONS(796), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(794), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10611] = 9,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1061), 1,
      anon_sym_EQ,
    ACTIONS(1065), 1,
      sym_concatenating_space,
    ACTIONS(1067), 1,
      sym__func_call,
    ACTIONS(1059), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1063), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 22,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10686] = 3,
    ACTIONS(686), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10749] = 2,
    ACTIONS(822), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(820), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10810] = 11,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(906), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10889] = 2,
    ACTIONS(724), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [10950] = 4,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(1037), 1,
      anon_sym_LT,
    ACTIONS(1039), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11015] = 3,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(1039), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11078] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11141] = 11,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(900), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11220] = 3,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(730), 1,
      sym_concatenating_space,
    ACTIONS(666), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11283] = 2,
    ACTIONS(818), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(816), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11344] = 11,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(896), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11423] = 2,
    ACTIONS(814), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(812), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11484] = 2,
    ACTIONS(826), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(824), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11545] = 2,
    ACTIONS(830), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(828), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11606] = 2,
    ACTIONS(788), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(786), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11667] = 12,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(916), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1079), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11748] = 2,
    ACTIONS(846), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(844), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11809] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_LT,
    ACTIONS(714), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11874] = 2,
    ACTIONS(784), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(782), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11935] = 2,
    ACTIONS(768), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(766), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [11996] = 11,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(886), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12075] = 3,
    ACTIONS(724), 1,
      sym_concatenating_space,
    ACTIONS(1035), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12138] = 5,
    ACTIONS(910), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 47,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12205] = 2,
    ACTIONS(792), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(790), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12266] = 4,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(1035), 1,
      anon_sym_LBRACK,
    ACTIONS(1043), 1,
      anon_sym_LT,
    ACTIONS(714), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12331] = 2,
    ACTIONS(804), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(802), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12392] = 9,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 37,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12467] = 2,
    ACTIONS(800), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(798), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12528] = 8,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 38,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12601] = 6,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 41,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12670] = 4,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 49,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12735] = 3,
    ACTIONS(860), 1,
      sym__if_else_separator,
    ACTIONS(1083), 1,
      sym_regex_flags,
    ACTIONS(856), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12798] = 9,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1067), 1,
      sym__func_call,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 11,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 11,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(686), 14,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12873] = 2,
    ACTIONS(838), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(836), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12934] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [12997] = 2,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(778), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13058] = 3,
    ACTIONS(860), 1,
      sym_concatenating_space,
    ACTIONS(1087), 1,
      sym_regex_flags,
    ACTIONS(856), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13121] = 3,
    ACTIONS(852), 1,
      sym_concatenating_space,
    ACTIONS(1089), 1,
      sym_regex_flags,
    ACTIONS(848), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13184] = 3,
    ACTIONS(852), 1,
      sym__if_else_separator,
    ACTIONS(1091), 1,
      sym_regex_flags,
    ACTIONS(848), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13247] = 7,
    ACTIONS(1093), 1,
      sym_identifier,
    ACTIONS(1095), 1,
      anon_sym_LT,
    STATE(314), 1,
      sym_array_ref,
    STATE(494), 1,
      sym_ns_qualified_name,
    STATE(2231), 1,
      sym_namespace,
    ACTIONS(680), 20,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(682), 31,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13318] = 3,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13381] = 2,
    ACTIONS(744), 1,
      sym_concatenating_space,
    ACTIONS(742), 55,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13442] = 8,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1067), 1,
      sym__func_call,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1101), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 23,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13515] = 2,
    ACTIONS(838), 1,
      sym__if_else_separator,
    ACTIONS(836), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13575] = 3,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_LT,
    ACTIONS(714), 53,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13637] = 2,
    ACTIONS(846), 1,
      sym_concatenating_space,
    ACTIONS(844), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13697] = 12,
    ACTIONS(916), 1,
      sym__if_else_separator,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1103), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13777] = 2,
    ACTIONS(796), 1,
      sym__if_else_separator,
    ACTIONS(794), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13837] = 2,
    ACTIONS(792), 1,
      sym_concatenating_space,
    ACTIONS(790), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13897] = 2,
    ACTIONS(818), 1,
      sym__if_else_separator,
    ACTIONS(816), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [13957] = 12,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(1109), 1,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1105), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14037] = 12,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(1113), 1,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 5,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1111), 35,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14117] = 2,
    ACTIONS(774), 1,
      sym_concatenating_space,
    ACTIONS(666), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14177] = 2,
    ACTIONS(764), 1,
      sym__if_else_separator,
    ACTIONS(762), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14237] = 2,
    ACTIONS(846), 1,
      sym__if_else_separator,
    ACTIONS(844), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14297] = 2,
    ACTIONS(808), 1,
      sym_concatenating_space,
    ACTIONS(806), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14357] = 11,
    ACTIONS(896), 1,
      sym_concatenating_space,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14435] = 2,
    ACTIONS(804), 1,
      sym_concatenating_space,
    ACTIONS(802), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14495] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1133), 1,
      anon_sym_LT,
    ACTIONS(714), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 31,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14561] = 6,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 41,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14629] = 2,
    ACTIONS(784), 1,
      sym__if_else_separator,
    ACTIONS(782), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14689] = 2,
    ACTIONS(768), 1,
      sym__if_else_separator,
    ACTIONS(766), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14749] = 2,
    ACTIONS(814), 1,
      sym__if_else_separator,
    ACTIONS(812), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14809] = 11,
    ACTIONS(906), 1,
      sym_concatenating_space,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14887] = 2,
    ACTIONS(826), 1,
      sym__if_else_separator,
    ACTIONS(824), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [14947] = 2,
    ACTIONS(838), 1,
      sym_concatenating_space,
    ACTIONS(836), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15007] = 2,
    ACTIONS(796), 1,
      sym_concatenating_space,
    ACTIONS(794), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15067] = 3,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 52,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15129] = 2,
    ACTIONS(784), 1,
      sym_concatenating_space,
    ACTIONS(782), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15189] = 7,
    ACTIONS(890), 1,
      sym_concatenating_space,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 39,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15259] = 8,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1067), 1,
      sym__func_call,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 11,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 11,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(686), 14,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15331] = 2,
    ACTIONS(764), 1,
      sym_concatenating_space,
    ACTIONS(762), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15391] = 2,
    ACTIONS(826), 1,
      sym_concatenating_space,
    ACTIONS(824), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15451] = 12,
    ACTIONS(916), 1,
      sym_concatenating_space,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1135), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15531] = 8,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1061), 1,
      anon_sym_EQ,
    ACTIONS(1065), 1,
      sym_concatenating_space,
    ACTIONS(1067), 1,
      sym__func_call,
    ACTIONS(1059), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1063), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 22,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15603] = 2,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15663] = 2,
    ACTIONS(814), 1,
      sym_concatenating_space,
    ACTIONS(812), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15723] = 2,
    ACTIONS(788), 1,
      sym_concatenating_space,
    ACTIONS(786), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15783] = 2,
    ACTIONS(830), 1,
      sym_concatenating_space,
    ACTIONS(828), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15843] = 9,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 37,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15917] = 8,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 38,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [15989] = 11,
    ACTIONS(886), 1,
      sym_concatenating_space,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16067] = 2,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(778), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16127] = 2,
    ACTIONS(768), 1,
      sym_concatenating_space,
    ACTIONS(766), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16187] = 4,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 49,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16251] = 5,
    ACTIONS(910), 1,
      sym_concatenating_space,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 47,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16317] = 5,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 47,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16383] = 2,
    ACTIONS(724), 1,
      sym_concatenating_space,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16443] = 7,
    ACTIONS(874), 1,
      sym_concatenating_space,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 39,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16513] = 11,
    ACTIONS(900), 1,
      sym_concatenating_space,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16591] = 2,
    ACTIONS(724), 1,
      sym__if_else_separator,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16651] = 7,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1067), 1,
      sym__func_call,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1101), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 23,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16721] = 2,
    ACTIONS(788), 1,
      sym__if_else_separator,
    ACTIONS(786), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16781] = 2,
    ACTIONS(830), 1,
      sym__if_else_separator,
    ACTIONS(828), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16841] = 3,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16903] = 2,
    ACTIONS(818), 1,
      sym_concatenating_space,
    ACTIONS(816), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [16963] = 2,
    ACTIONS(1137), 1,
      sym_regex_flags,
    ACTIONS(848), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17023] = 2,
    ACTIONS(1139), 1,
      sym_regex_flags,
    ACTIONS(856), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17083] = 2,
    ACTIONS(800), 1,
      sym_concatenating_space,
    ACTIONS(798), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17143] = 2,
    ACTIONS(822), 1,
      sym_concatenating_space,
    ACTIONS(820), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17203] = 2,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17263] = 1,
    ACTIONS(766), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17320] = 1,
    ACTIONS(782), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17377] = 11,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1141), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17454] = 1,
    ACTIONS(844), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17511] = 1,
    ACTIONS(722), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17568] = 11,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 5,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1111), 35,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17645] = 1,
    ACTIONS(812), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17702] = 7,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 11,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 11,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(686), 14,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17771] = 7,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1061), 1,
      anon_sym_EQ,
    ACTIONS(1065), 1,
      sym_concatenating_space,
    ACTIONS(1059), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1063), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 22,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17840] = 3,
    ACTIONS(1143), 1,
      sym_regex_flags,
    ACTIONS(848), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(852), 31,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17901] = 1,
    ACTIONS(786), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [17958] = 1,
    ACTIONS(816), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18015] = 1,
    ACTIONS(828), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18072] = 6,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1101), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 23,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18139] = 1,
    ACTIONS(824), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18196] = 11,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1105), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18273] = 22,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(45), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(69), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_DOLLAR,
    ACTIONS(77), 1,
      anon_sym_AT,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(698), 1,
      anon_sym_LPAREN2,
    ACTIONS(710), 1,
      sym__if_else_separator,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(836), 1,
      aux_sym_exp_list_repeat1,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(79), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(661), 2,
      sym__print_args,
      sym_exp_list,
    ACTIONS(71), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1506), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
    ACTIONS(694), 11,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [18372] = 1,
    ACTIONS(836), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18429] = 3,
    ACTIONS(1145), 1,
      sym_regex_flags,
    ACTIONS(856), 22,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(860), 31,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18490] = 4,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1133), 1,
      anon_sym_LT,
    ACTIONS(714), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 31,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18553] = 1,
    ACTIONS(762), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18610] = 1,
    ACTIONS(794), 54,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_in,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      anon_sym_LT,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18667] = 8,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 14,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 26,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18737] = 12,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1161), 1,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1103), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1159), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18815] = 11,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1163), 1,
      anon_sym_in,
    ACTIONS(1167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 23,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18891] = 15,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1163), 1,
      anon_sym_in,
    ACTIONS(1167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1171), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(916), 20,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [18975] = 9,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 14,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(890), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19047] = 6,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 16,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 30,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19113] = 9,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 14,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(874), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19185] = 5,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1097), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1101), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 23,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19249] = 12,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1179), 1,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1103), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19327] = 12,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1183), 1,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1103), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1181), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19405] = 13,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1163), 1,
      anon_sym_in,
    ACTIONS(1167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(886), 21,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19485] = 12,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1187), 1,
      sym__if_else_separator,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1103), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1185), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19563] = 12,
    ACTIONS(83), 1,
      sym__if_else_separator,
    ACTIONS(1069), 1,
      anon_sym_in,
    ACTIONS(1071), 1,
      anon_sym_QMARK,
    ACTIONS(1073), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1075), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1051), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1055), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1057), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1103), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1053), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(41), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19641] = 13,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1163), 1,
      anon_sym_in,
    ACTIONS(1167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(896), 21,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19721] = 21,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(228), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(246), 1,
      anon_sym_SLASH,
    ACTIONS(252), 1,
      anon_sym_DOLLAR,
    ACTIONS(254), 1,
      anon_sym_AT,
    ACTIONS(258), 1,
      anon_sym_DQUOTE,
    ACTIONS(750), 1,
      anon_sym_LPAREN2,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(839), 1,
      aux_sym_exp_list_repeat1,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(250), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(256), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    STATE(781), 2,
      sym__print_args,
      sym_exp_list,
    ACTIONS(248), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1547), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
    ACTIONS(694), 11,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [19817] = 13,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1163), 1,
      anon_sym_in,
    ACTIONS(1167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(900), 21,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19897] = 6,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 16,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(910), 30,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [19963] = 10,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1163), 1,
      anon_sym_in,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20037] = 13,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1163), 1,
      anon_sym_in,
    ACTIONS(1167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1155), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(906), 21,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20117] = 5,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1153), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 30,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20181] = 4,
    ACTIONS(1149), 1,
      anon_sym_CARET,
    ACTIONS(1151), 1,
      anon_sym_STAR_STAR,
    ACTIONS(778), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 30,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20243] = 6,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 11,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(684), 11,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(686), 14,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20309] = 6,
    ACTIONS(1061), 1,
      anon_sym_EQ,
    ACTIONS(1065), 1,
      sym_concatenating_space,
    ACTIONS(1059), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1063), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 21,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 22,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20375] = 11,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1141), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1159), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20450] = 11,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1141), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(41), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20525] = 11,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1141), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1185), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20600] = 11,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1141), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1181), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20675] = 11,
    ACTIONS(1115), 1,
      anon_sym_in,
    ACTIONS(1119), 1,
      anon_sym_QMARK,
    ACTIONS(1129), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1131), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1121), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1125), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1127), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1141), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1123), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1117), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 31,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20750] = 22,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(644), 1,
      anon_sym_SLASH,
    ACTIONS(648), 1,
      anon_sym_DOLLAR,
    ACTIONS(650), 1,
      anon_sym_AT,
    ACTIONS(698), 1,
      anon_sym_LPAREN2,
    ACTIONS(710), 1,
      sym__if_else_separator,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(843), 1,
      aux_sym_exp_list_repeat1,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(79), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(646), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(661), 2,
      sym__print_args,
      sym_exp_list,
    ACTIONS(456), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(694), 8,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1611), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [20846] = 21,
    ACTIONS(258), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(654), 1,
      anon_sym_SLASH,
    ACTIONS(658), 1,
      anon_sym_DOLLAR,
    ACTIONS(660), 1,
      anon_sym_AT,
    ACTIONS(750), 1,
      anon_sym_LPAREN2,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(852), 1,
      aux_sym_exp_list_repeat1,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(256), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(656), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(781), 2,
      sym__print_args,
      sym_exp_list,
    ACTIONS(372), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(694), 8,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1658), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [20939] = 5,
    ACTIONS(1189), 1,
      sym_identifier,
    STATE(2228), 1,
      sym_namespace,
    STATE(534), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 17,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(682), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [20999] = 7,
    ACTIONS(1191), 1,
      sym_identifier,
    ACTIONS(1193), 1,
      anon_sym_LT,
    STATE(534), 1,
      sym_array_ref,
    STATE(536), 1,
      sym_ns_qualified_name,
    STATE(2228), 1,
      sym_namespace,
    ACTIONS(680), 16,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(682), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21063] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(724), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21120] = 5,
    ACTIONS(1197), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_namespace,
    STATE(550), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 17,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(682), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21179] = 7,
    ACTIONS(1199), 1,
      sym_identifier,
    ACTIONS(1201), 1,
      anon_sym_LT,
    STATE(550), 1,
      sym_array_ref,
    STATE(551), 1,
      sym_ns_qualified_name,
    STATE(2185), 1,
      sym_namespace,
    ACTIONS(680), 16,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(682), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21242] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21299] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(1203), 1,
      anon_sym_LT,
    ACTIONS(714), 17,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21358] = 3,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21412] = 2,
    ACTIONS(742), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(744), 29,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21464] = 4,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(1203), 1,
      anon_sym_LT,
    ACTIONS(714), 17,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21520] = 3,
    ACTIONS(1205), 1,
      sym_regex_flags,
    ACTIONS(856), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(860), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21574] = 3,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(724), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21628] = 2,
    ACTIONS(718), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(720), 29,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21680] = 3,
    ACTIONS(1207), 1,
      sym_regex_flags,
    ACTIONS(848), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(852), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21734] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21790] = 2,
    ACTIONS(742), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(744), 29,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21842] = 2,
    ACTIONS(718), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(720), 29,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_LBRACK,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21894] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(724), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [21950] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(1211), 1,
      anon_sym_LT,
    ACTIONS(714), 17,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22008] = 5,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 17,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22065] = 2,
    ACTIONS(836), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(838), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22116] = 2,
    ACTIONS(782), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(784), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22167] = 2,
    ACTIONS(794), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(796), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22218] = 3,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22271] = 4,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(1211), 1,
      anon_sym_LT,
    ACTIONS(714), 17,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(716), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22326] = 3,
    ACTIONS(1219), 1,
      sym_regex_flags,
    ACTIONS(856), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(860), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22379] = 6,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(908), 15,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(910), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22438] = 2,
    ACTIONS(798), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(800), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22489] = 3,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(724), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22542] = 15,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1227), 1,
      anon_sym_PIPE,
    ACTIONS(1229), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1239), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 11,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(916), 14,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22619] = 2,
    ACTIONS(786), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(788), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22670] = 2,
    ACTIONS(828), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(830), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22721] = 2,
    ACTIONS(790), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(792), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22772] = 2,
    ACTIONS(762), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(764), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22823] = 2,
    ACTIONS(766), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(768), 28,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22874] = 9,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(890), 18,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [22939] = 13,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1239), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(906), 15,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23012] = 2,
    ACTIONS(806), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(808), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23063] = 11,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 17,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23132] = 2,
    ACTIONS(820), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(822), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23183] = 3,
    ACTIONS(1065), 1,
      sym_concatenating_space,
    ACTIONS(666), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23236] = 13,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1239), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(900), 15,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23309] = 13,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1239), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(896), 15,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23382] = 2,
    ACTIONS(824), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(826), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23433] = 2,
    ACTIONS(812), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(814), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23484] = 2,
    ACTIONS(816), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(818), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23535] = 10,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 18,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23602] = 2,
    ACTIONS(786), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(788), 28,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23653] = 3,
    ACTIONS(1241), 1,
      sym_regex_flags,
    ACTIONS(848), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(852), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23706] = 4,
    ACTIONS(666), 7,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(684), 11,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(674), 14,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(686), 14,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23761] = 19,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(45), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(69), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_DOLLAR,
    ACTIONS(77), 1,
      anon_sym_AT,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(948), 1,
      sym__if_else_separator,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(79), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(71), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(946), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1558), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [23846] = 13,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1239), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(886), 15,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23919] = 2,
    ACTIONS(722), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(724), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [23970] = 9,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(874), 18,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24035] = 19,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(45), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(69), 1,
      anon_sym_SLASH,
    ACTIONS(75), 1,
      anon_sym_DOLLAR,
    ACTIONS(77), 1,
      anon_sym_AT,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(952), 1,
      sym__if_else_separator,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(73), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(79), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(71), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(950), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1560), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [24120] = 6,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(778), 15,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 24,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24179] = 2,
    ACTIONS(766), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(768), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24230] = 2,
    ACTIONS(778), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24281] = 3,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 26,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24334] = 2,
    ACTIONS(844), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(846), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24385] = 8,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_PIPE,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(780), 20,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24448] = 2,
    ACTIONS(802), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(804), 28,
      sym_concatenating_space,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24499] = 2,
    ACTIONS(836), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(838), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24549] = 18,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(228), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(246), 1,
      anon_sym_SLASH,
    ACTIONS(252), 1,
      anon_sym_DOLLAR,
    ACTIONS(254), 1,
      anon_sym_AT,
    ACTIONS(258), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(250), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(256), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(248), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(950), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1619), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [24631] = 8,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(686), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1243), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24693] = 2,
    ACTIONS(844), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(846), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24743] = 2,
    ACTIONS(722), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(724), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24793] = 2,
    ACTIONS(816), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(818), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24843] = 2,
    ACTIONS(812), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(814), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24893] = 16,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1239), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1251), 1,
      anon_sym_COMMA,
    ACTIONS(1253), 1,
      anon_sym_PIPE,
    ACTIONS(1255), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1249), 11,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(1247), 12,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [24971] = 15,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1239), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1253), 1,
      anon_sym_PIPE,
    ACTIONS(1255), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 11,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(916), 13,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [25047] = 2,
    ACTIONS(828), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(830), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [25097] = 2,
    ACTIONS(824), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(826), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [25147] = 7,
    ACTIONS(1257), 1,
      sym_identifier,
    ACTIONS(1259), 1,
      anon_sym_LT,
    STATE(173), 1,
      sym_array_ref,
    STATE(623), 1,
      sym_ns_qualified_name,
    STATE(2256), 1,
      sym_namespace,
    ACTIONS(682), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(680), 38,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [25207] = 2,
    ACTIONS(762), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(764), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [25257] = 2,
    ACTIONS(794), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(796), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [25307] = 18,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(228), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(246), 1,
      anon_sym_SLASH,
    ACTIONS(252), 1,
      anon_sym_DOLLAR,
    ACTIONS(254), 1,
      anon_sym_AT,
    ACTIONS(258), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(250), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(256), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(248), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(946), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1615), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [25389] = 2,
    ACTIONS(782), 18,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_in,
      anon_sym_getline,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(784), 27,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [25439] = 8,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(1265), 1,
      sym_concatenating_space,
    ACTIONS(1261), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1263), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [25500] = 7,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1267), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1269), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [25559] = 7,
    ACTIONS(682), 1,
      sym_concatenating_space,
    ACTIONS(1271), 1,
      sym_identifier,
    ACTIONS(1273), 1,
      anon_sym_LT,
    STATE(202), 1,
      sym_array_ref,
    STATE(657), 1,
      sym_ns_qualified_name,
    STATE(2243), 1,
      sym_namespace,
    ACTIONS(680), 38,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [25618] = 15,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1223), 1,
      anon_sym_in,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1239), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1253), 1,
      anon_sym_PIPE,
    ACTIONS(1255), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1277), 11,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_BANG,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(1275), 12,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [25693] = 8,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1243), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25754] = 7,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(686), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1243), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25813] = 6,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(686), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1243), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25869] = 7,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(1265), 1,
      sym_concatenating_space,
    ACTIONS(1261), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1263), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [25927] = 6,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1267), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1269), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [25983] = 7,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1281), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1283), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [26041] = 19,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(644), 1,
      anon_sym_SLASH,
    ACTIONS(648), 1,
      anon_sym_DOLLAR,
    ACTIONS(650), 1,
      anon_sym_AT,
    ACTIONS(952), 1,
      sym__if_else_separator,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(79), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(646), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(456), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(950), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1688), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [26123] = 5,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1285), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 38,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [26177] = 19,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(644), 1,
      anon_sym_SLASH,
    ACTIONS(648), 1,
      anon_sym_DOLLAR,
    ACTIONS(650), 1,
      anon_sym_AT,
    ACTIONS(948), 1,
      sym__if_else_separator,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(79), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(646), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(456), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(946), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1687), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [26259] = 7,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1291), 1,
      sym_concatenating_space,
    ACTIONS(1287), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1289), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [26317] = 7,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1243), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26375] = 5,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1267), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1269), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [26428] = 3,
    ACTIONS(850), 1,
      sym_regex_flags,
    ACTIONS(852), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(848), 39,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [26477] = 6,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1243), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26532] = 4,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(1285), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 38,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [26583] = 3,
    ACTIONS(858), 1,
      sym_regex_flags,
    ACTIONS(860), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(856), 39,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [26632] = 6,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1291), 1,
      sym_concatenating_space,
    ACTIONS(1287), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1289), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [26687] = 5,
    ACTIONS(686), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1243), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26740] = 18,
    ACTIONS(258), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(654), 1,
      anon_sym_SLASH,
    ACTIONS(658), 1,
      anon_sym_DOLLAR,
    ACTIONS(660), 1,
      anon_sym_AT,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(256), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(656), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(372), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(946), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1698), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [26819] = 18,
    ACTIONS(258), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(654), 1,
      anon_sym_SLASH,
    ACTIONS(658), 1,
      anon_sym_DOLLAR,
    ACTIONS(660), 1,
      anon_sym_AT,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(256), 2,
      aux_sym_number_token1,
      aux_sym_number_token2,
    ACTIONS(656), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(372), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
    ACTIONS(950), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1694), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [26898] = 6,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1281), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1283), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [26953] = 6,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1265), 1,
      sym_concatenating_space,
    ACTIONS(1261), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1263), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [27008] = 7,
    ACTIONS(1293), 1,
      sym_identifier,
    ACTIONS(1295), 1,
      anon_sym_LT,
    STATE(173), 1,
      sym_array_ref,
    STATE(801), 1,
      sym_ns_qualified_name,
    STATE(2256), 1,
      sym_namespace,
    ACTIONS(682), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(680), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [27065] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(1297), 1,
      anon_sym_LT,
    ACTIONS(714), 38,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [27118] = 11,
    ACTIONS(1299), 1,
      anon_sym_in,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(906), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [27182] = 8,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(1319), 1,
      sym_concatenating_space,
    ACTIONS(1261), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1317), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27240] = 3,
    ACTIONS(852), 1,
      sym_concatenating_space,
    ACTIONS(902), 1,
      sym_regex_flags,
    ACTIONS(848), 39,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [27288] = 21,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(454), 1,
      anon_sym_SLASH,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(464), 1,
      anon_sym_AT,
    ACTIONS(1321), 1,
      anon_sym_LPAREN,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(843), 1,
      aux_sym_exp_list_repeat1,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(460), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(662), 2,
      sym__print_args,
      sym_exp_list,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1611), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [27372] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2079), 2,
      sym__print_args,
      sym_exp_list,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1727), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [27456] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2080), 2,
      sym__print_args,
      sym_exp_list,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1719), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [27540] = 7,
    ACTIONS(682), 1,
      sym_concatenating_space,
    ACTIONS(1347), 1,
      sym_identifier,
    ACTIONS(1349), 1,
      anon_sym_LT,
    STATE(202), 1,
      sym_array_ref,
    STATE(948), 1,
      sym_ns_qualified_name,
    STATE(2243), 1,
      sym_namespace,
    ACTIONS(680), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [27596] = 11,
    ACTIONS(1299), 1,
      anon_sym_in,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(896), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [27660] = 11,
    ACTIONS(1299), 1,
      anon_sym_in,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(900), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [27724] = 21,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(388), 1,
      anon_sym_SLASH,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(396), 1,
      anon_sym_AT,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1321), 1,
      anon_sym_LPAREN,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(836), 1,
      aux_sym_exp_list_repeat1,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(392), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(662), 2,
      sym__print_args,
      sym_exp_list,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1506), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [27808] = 21,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(204), 1,
      anon_sym_AT,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1351), 1,
      anon_sym_LPAREN,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(830), 1,
      aux_sym_exp_list_repeat1,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(200), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(778), 2,
      sym__print_args,
      sym_exp_list,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(480), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [27892] = 5,
    ACTIONS(910), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [27944] = 6,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [27998] = 4,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1267), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1269), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [28048] = 21,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 1,
      anon_sym_AT,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1321), 1,
      anon_sym_LPAREN,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(842), 1,
      aux_sym_exp_list_repeat1,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(334), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(662), 2,
      sym__print_args,
      sym_exp_list,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(425), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [28132] = 5,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1265), 1,
      sym_concatenating_space,
    ACTIONS(1261), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1263), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [28184] = 7,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1267), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1353), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28240] = 3,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 37,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [28288] = 5,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1281), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1283), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [28340] = 4,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 34,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [28390] = 11,
    ACTIONS(1299), 1,
      anon_sym_in,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(886), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [28454] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2211), 2,
      sym__print_args,
      sym_exp_list,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1719), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [28538] = 12,
    ACTIONS(1299), 1,
      anon_sym_in,
    ACTIONS(1303), 1,
      anon_sym_QMARK,
    ACTIONS(1313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(914), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(916), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 18,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [28604] = 3,
    ACTIONS(860), 1,
      sym_concatenating_space,
    ACTIONS(892), 1,
      sym_regex_flags,
    ACTIONS(856), 39,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [28652] = 4,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(1297), 1,
      anon_sym_LT,
    ACTIONS(714), 38,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [28702] = 21,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(370), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(380), 1,
      anon_sym_AT,
    ACTIONS(1351), 1,
      anon_sym_LPAREN,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(852), 1,
      aux_sym_exp_list_repeat1,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(376), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(778), 2,
      sym__print_args,
      sym_exp_list,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1658), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [28786] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2216), 2,
      sym__print_args,
      sym_exp_list,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1727), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [28870] = 21,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(280), 1,
      anon_sym_SLASH,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 1,
      anon_sym_AT,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1351), 1,
      anon_sym_LPAREN,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(839), 1,
      aux_sym_exp_list_repeat1,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(284), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(778), 2,
      sym__print_args,
      sym_exp_list,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1547), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [28954] = 2,
    ACTIONS(1357), 1,
      sym__if_else_separator,
    ACTIONS(1355), 40,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [29000] = 2,
    ACTIONS(1361), 1,
      sym__if_else_separator,
    ACTIONS(1359), 40,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [29046] = 7,
    ACTIONS(890), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 24,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [29102] = 9,
    ACTIONS(1299), 1,
      anon_sym_in,
    ACTIONS(1313), 1,
      anon_sym_AMP_AMP,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [29162] = 5,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1291), 1,
      sym_concatenating_space,
    ACTIONS(1287), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1289), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [29214] = 5,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [29266] = 8,
    ACTIONS(1299), 1,
      anon_sym_in,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [29324] = 5,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(1243), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(746), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29376] = 7,
    ACTIONS(874), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1305), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1309), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1307), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1301), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 24,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [29432] = 2,
    ACTIONS(1365), 1,
      sym__if_else_separator,
    ACTIONS(1363), 40,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [29478] = 2,
    ACTIONS(1369), 1,
      sym__if_else_separator,
    ACTIONS(1367), 40,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [29524] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2141), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1701), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [29607] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1089), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1772), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [29690] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(984), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1819), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [29773] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2148), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1702), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [29856] = 20,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1137), 1,
      sym_comment,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1452), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [29937] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(1004), 1,
      sym_comment,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1002), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [30018] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1112), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1817), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [30101] = 20,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1138), 1,
      sym_comment,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1450), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [30182] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1136), 1,
      sym_comment,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1633), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [30263] = 7,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1281), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1413), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30318] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1415), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    STATE(2218), 1,
      sym_args,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [30401] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(883), 1,
      sym_comment,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1309), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [30482] = 7,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1441), 1,
      sym_concatenating_space,
    ACTIONS(1287), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1439), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30537] = 6,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1267), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1353), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30590] = 20,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(998), 1,
      sym_comment,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(507), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [30671] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    STATE(2271), 1,
      sym_exp_list,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1721), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [30754] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2107), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1709), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [30837] = 7,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1245), 1,
      sym__func_call,
    ACTIONS(1319), 1,
      sym_concatenating_space,
    ACTIONS(1261), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1317), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30892] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2133), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1716), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [30975] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2120), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1726), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [31058] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(1160), 1,
      sym_comment,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(568), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [31139] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2095), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1723), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [31222] = 4,
    ACTIONS(1291), 1,
      sym_concatenating_space,
    ACTIONS(1287), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1289), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [31271] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1109), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1736), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [31354] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(872), 1,
      sym_comment,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1311), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [31435] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2094), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1723), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [31518] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2076), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1722), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [31601] = 12,
    ACTIONS(916), 1,
      sym_concatenating_space,
    ACTIONS(1467), 1,
      anon_sym_in,
    ACTIONS(1471), 1,
      anon_sym_QMARK,
    ACTIONS(1481), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(922), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 18,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [31666] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(1161), 1,
      sym_comment,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(641), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [31747] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1107), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1748), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [31830] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1499), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    STATE(2219), 1,
      sym_args,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [31913] = 4,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(1281), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1283), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [31962] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2207), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1718), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [32045] = 20,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(996), 1,
      sym_comment,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(512), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [32126] = 1,
    ACTIONS(1367), 40,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [32169] = 1,
    ACTIONS(1363), 40,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [32212] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2134), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1715), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [32295] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1501), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2139), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [32378] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2116), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1713), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [32461] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1105), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1786), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [32544] = 5,
    ACTIONS(910), 1,
      sym_concatenating_space,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [32595] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(895), 1,
      sym_comment,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(381), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [32676] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(1180), 1,
      sym_comment,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(653), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [32757] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2071), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1709), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [32840] = 20,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(1110), 1,
      sym_comment,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(578), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [32921] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1513), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2193), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [33004] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2143), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1708), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [33087] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1103), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1796), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [33170] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    STATE(2263), 1,
      sym_exp_list,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1724), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [33253] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2077), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1704), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [33336] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2160), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1703), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [33419] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(950), 1,
      sym_comment,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1599), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [33500] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(1029), 1,
      sym_comment,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1007), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [33581] = 20,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1011), 1,
      sym_comment,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1556), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [33662] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1535), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2200), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [33745] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(894), 1,
      sym_comment,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(394), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [33826] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1127), 1,
      sym_comment,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1628), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [33907] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(947), 1,
      sym_comment,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1597), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [33988] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2164), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1705), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34071] = 20,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1015), 1,
      sym_comment,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1582), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [34152] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1537), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2187), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34235] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1539), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2070), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34318] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(949), 1,
      sym_comment,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1284), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [34399] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1101), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1774), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34482] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2176), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1707), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34565] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1100), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1740), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34648] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2180), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1710), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34731] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1099), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1738), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34814] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2169), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1725), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34897] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1191), 1,
      sym_comment,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1762), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [34980] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2191), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1711), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [35063] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(945), 1,
      sym_comment,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(262), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [35144] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1097), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1730), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [35227] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2197), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1714), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [35310] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(943), 1,
      sym_comment,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1286), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [35391] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1096), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1766), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [35474] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    STATE(2210), 1,
      sym_exp_list,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1720), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [35557] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1577), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2171), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [35640] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(941), 1,
      sym_comment,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(257), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [35721] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1579), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2161), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [35804] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1102), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1808), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [35887] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1581), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2153), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [35970] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1583), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2087), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [36053] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1585), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2137), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [36136] = 11,
    ACTIONS(906), 1,
      sym_concatenating_space,
    ACTIONS(1467), 1,
      anon_sym_in,
    ACTIONS(1471), 1,
      anon_sym_QMARK,
    ACTIONS(1481), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [36199] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1211), 1,
      sym_comment,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1770), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [36282] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1587), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2167), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [36365] = 11,
    ACTIONS(900), 1,
      sym_concatenating_space,
    ACTIONS(1467), 1,
      anon_sym_in,
    ACTIONS(1471), 1,
      anon_sym_QMARK,
    ACTIONS(1481), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [36428] = 11,
    ACTIONS(896), 1,
      sym_concatenating_space,
    ACTIONS(1467), 1,
      anon_sym_in,
    ACTIONS(1471), 1,
      anon_sym_QMARK,
    ACTIONS(1481), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [36491] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(1204), 1,
      sym_comment,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(759), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [36572] = 11,
    ACTIONS(886), 1,
      sym_concatenating_space,
    ACTIONS(1467), 1,
      anon_sym_in,
    ACTIONS(1471), 1,
      anon_sym_QMARK,
    ACTIONS(1481), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1483), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [36635] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2101), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1704), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [36718] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2206), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1717), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [36801] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2083), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1709), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [36884] = 7,
    ACTIONS(890), 1,
      sym_concatenating_space,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 24,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [36939] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1603), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2136), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [37022] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(1201), 1,
      sym_comment,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(762), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [37103] = 9,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1467), 1,
      anon_sym_in,
    ACTIONS(1481), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [37162] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2123), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1723), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [37245] = 20,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(1039), 1,
      sym_comment,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(463), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [37326] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2089), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1716), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [37409] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1615), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2103), 1,
      sym_args,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1699), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [37492] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2073), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1702), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [37575] = 8,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1467), 1,
      anon_sym_in,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [37632] = 21,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(832), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2118), 1,
      sym_exp_list,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1712), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [37715] = 7,
    ACTIONS(1617), 1,
      sym_identifier,
    ACTIONS(1619), 1,
      anon_sym_LT,
    STATE(314), 1,
      sym_array_ref,
    STATE(1269), 1,
      sym_ns_qualified_name,
    STATE(2231), 1,
      sym_namespace,
    ACTIONS(680), 10,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(682), 25,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [37770] = 1,
    ACTIONS(1359), 40,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [37813] = 6,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [37866] = 20,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(857), 1,
      sym_comment,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(279), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [37947] = 1,
    ACTIONS(1355), 40,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [37990] = 4,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 34,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [38039] = 20,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(999), 1,
      sym_comment,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(455), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [38120] = 3,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 37,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [38167] = 5,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1635), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [38218] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(908), 1,
      sym_comment,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1515), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [38299] = 5,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [38350] = 21,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1093), 1,
      sym_comment,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1745), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [38433] = 7,
    ACTIONS(874), 1,
      sym_concatenating_space,
    ACTIONS(1473), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1477), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1479), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1475), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1469), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 24,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_POUND,
  [38488] = 20,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(1186), 1,
      sym_comment,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(293), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [38569] = 20,
    ACTIONS(212), 1,
      anon_sym_POUND,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(910), 1,
      sym_comment,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1511), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [38650] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1647), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1744), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [38730] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1649), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1781), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [38810] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1651), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1765), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [38890] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1653), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1788), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [38970] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(1655), 1,
      anon_sym_LT,
    ACTIONS(714), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [39020] = 20,
    ACTIONS(1657), 1,
      sym_identifier,
    ACTIONS(1660), 1,
      anon_sym_LPAREN,
    ACTIONS(1663), 1,
      anon_sym_getline,
    ACTIONS(1666), 1,
      anon_sym_SLASH,
    ACTIONS(1672), 1,
      anon_sym_BANG,
    ACTIONS(1678), 1,
      anon_sym_DOLLAR,
    ACTIONS(1681), 1,
      anon_sym_AT,
    ACTIONS(1684), 1,
      aux_sym_number_token1,
    ACTIONS(1687), 1,
      aux_sym_number_token2,
    ACTIONS(1690), 1,
      anon_sym_DQUOTE,
    STATE(797), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1675), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1749), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39100] = 3,
    ACTIONS(850), 1,
      sym_regex_flags,
    ACTIONS(852), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(848), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [39146] = 20,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1695), 1,
      anon_sym_SEMI,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1403), 1,
      sym_ns_qualified_name,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1775), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39226] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1697), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1812), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39306] = 4,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(1635), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [39354] = 3,
    ACTIONS(858), 1,
      sym_regex_flags,
    ACTIONS(860), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(856), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [39400] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1699), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1737), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39480] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1810), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39560] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1703), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1773), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39640] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1705), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1806), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39720] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1707), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1761), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39800] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1709), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1805), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39880] = 20,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1711), 1,
      sym_identifier,
    ACTIONS(1713), 1,
      anon_sym_SEMI,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1401), 1,
      sym_ns_qualified_name,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1735), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [39960] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1715), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1797), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40040] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1717), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1792), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40120] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1719), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1787), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40200] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1721), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1747), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40280] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1723), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1777), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40360] = 9,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 10,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [40418] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1731), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1746), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40498] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1733), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1760), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40578] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1735), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1800), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40658] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1737), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1816), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40738] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1739), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1785), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40818] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1741), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1729), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40898] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1743), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1743), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [40978] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1745), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1754), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41058] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1747), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1734), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41138] = 20,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_SEMI,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1405), 1,
      sym_ns_qualified_name,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1798), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41218] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1753), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1732), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41298] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1755), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1799), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41378] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1757), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1818), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41458] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1759), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1739), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41538] = 20,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(204), 1,
      anon_sym_AT,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(797), 1,
      aux_sym_exp_list_repeat1,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(200), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(490), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41618] = 4,
    ACTIONS(1767), 1,
      sym__if_else_separator,
    ACTIONS(1763), 2,
      anon_sym_GT,
      anon_sym_GT_GT,
    ACTIONS(1765), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1761), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [41666] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(797), 1,
      aux_sym_exp_list_repeat1,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1700), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41746] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1769), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1801), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41826] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1771), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1780), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [41906] = 5,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1267), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1353), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41956] = 20,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SLASH,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(396), 1,
      anon_sym_AT,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(797), 1,
      aux_sym_exp_list_repeat1,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(392), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1529), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [42036] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1039), 1,
      anon_sym_LBRACK,
    ACTIONS(1775), 1,
      sym__if_else_separator,
    ACTIONS(1773), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [42084] = 8,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(1779), 1,
      anon_sym_EQ,
    ACTIONS(1777), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1781), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 10,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 17,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [42140] = 20,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(280), 1,
      anon_sym_SLASH,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 1,
      anon_sym_AT,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(797), 1,
      aux_sym_exp_list_repeat1,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(284), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1549), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [42220] = 6,
    ACTIONS(670), 1,
      anon_sym_LBRACK,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1319), 1,
      sym_concatenating_space,
    ACTIONS(1261), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1317), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42272] = 10,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(684), 1,
      anon_sym_COLON,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(686), 5,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42332] = 20,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 1,
      anon_sym_AT,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(797), 1,
      aux_sym_exp_list_repeat1,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(334), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(424), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [42412] = 20,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(454), 1,
      anon_sym_SLASH,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(464), 1,
      anon_sym_AT,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(797), 1,
      aux_sym_exp_list_repeat1,
    STATE(840), 1,
      sym_array_ref,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(460), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1612), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [42492] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1783), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1750), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [42572] = 20,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1785), 1,
      sym_identifier,
    ACTIONS(1787), 1,
      anon_sym_SEMI,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1399), 1,
      sym_ns_qualified_name,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1803), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [42652] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1789), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1811), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [42732] = 20,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1791), 1,
      sym_identifier,
    ACTIONS(1793), 1,
      anon_sym_SEMI,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1394), 1,
      sym_ns_qualified_name,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1782), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [42812] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1795), 1,
      anon_sym_SEMI,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1728), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [42892] = 6,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1281), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1413), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42944] = 20,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1797), 1,
      sym_identifier,
    ACTIONS(1799), 1,
      anon_sym_SEMI,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1395), 1,
      sym_ns_qualified_name,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1741), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [43024] = 6,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1279), 1,
      sym__func_call,
    ACTIONS(1441), 1,
      sym_concatenating_space,
    ACTIONS(1287), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1439), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43076] = 20,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(370), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(380), 1,
      anon_sym_AT,
    STATE(797), 1,
      aux_sym_exp_list_repeat1,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(376), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1645), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [43156] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1801), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1751), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [43236] = 20,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1803), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1753), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [43316] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1074), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [43391] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1472), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [43466] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(282), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [43541] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1508), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [43616] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(343), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [43691] = 19,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(370), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(380), 1,
      anon_sym_AT,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(376), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1540), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [43768] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1519), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [43843] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1521), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [43918] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1522), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [43993] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(553), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44068] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1523), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44143] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1525), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44218] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1486), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44293] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1526), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44368] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1533), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44443] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(359), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44518] = 19,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1805), 1,
      sym_identifier,
    STATE(199), 1,
      sym_ns_qualified_name,
    STATE(254), 1,
      sym_array_ref,
    STATE(258), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(374), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1833), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [44595] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1313), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44670] = 19,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(370), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(380), 1,
      anon_sym_AT,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(376), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1627), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [44747] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(370), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44822] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(369), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44897] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(409), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [44972] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(414), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45047] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(404), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45122] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(403), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45197] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(402), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45272] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(400), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45347] = 19,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(370), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(380), 1,
      anon_sym_AT,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(376), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1537), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [45424] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1310), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45499] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(327), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45574] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1298), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45649] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1308), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45724] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(365), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45799] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1307), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45874] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1303), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [45949] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1302), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46024] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1301), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46099] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(346), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46174] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1372), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46249] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(384), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46324] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(376), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46399] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(452), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46474] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1319), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46549] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(447), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46624] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(256), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46699] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(275), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46774] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(195), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46849] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(272), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46924] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(271), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [46999] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(270), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47074] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(268), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47149] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(266), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47224] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(228), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47299] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1509), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47374] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(442), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47449] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1512), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47524] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1295), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47599] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(294), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47674] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1294), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47749] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1291), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47824] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1292), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47899] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1001), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [47974] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1290), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48049] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1289), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48124] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1288), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48199] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1664), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48274] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1815), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [48351] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(291), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48426] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(287), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48501] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(286), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48576] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(284), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48651] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(283), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48726] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(228), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48801] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(280), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48876] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(288), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [48951] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(259), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [49026] = 5,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      sym_concatenating_space,
    ACTIONS(1287), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1439), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49075] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1660), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [49150] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1789), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [49227] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1779), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [49304] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1784), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [49381] = 3,
    ACTIONS(1807), 2,
      anon_sym_GT,
      anon_sym_GT_GT,
    ACTIONS(1809), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1761), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [49426] = 19,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_getline,
    ACTIONS(17), 1,
      anon_sym_SLASH,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1811), 1,
      anon_sym_AT,
    STATE(448), 1,
      sym_ns_qualified_name,
    STATE(483), 1,
      sym_array_ref,
    STATE(519), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(23), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(567), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(598), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [49503] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1783), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [49580] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1287), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [49655] = 19,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1813), 1,
      sym_identifier,
    STATE(444), 1,
      sym_ns_qualified_name,
    STATE(482), 1,
      sym_array_ref,
    STATE(518), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(576), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1827), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [49732] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(261), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [49807] = 19,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_getline,
    ACTIONS(17), 1,
      anon_sym_SLASH,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1811), 1,
      anon_sym_AT,
    STATE(448), 1,
      sym_ns_qualified_name,
    STATE(483), 1,
      sym_array_ref,
    STATE(519), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(23), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(567), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(597), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [49884] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1285), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [49959] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1655), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [50034] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(264), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [50109] = 19,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1815), 1,
      sym_identifier,
    STATE(610), 1,
      sym_ns_qualified_name,
    STATE(611), 1,
      sym_array_ref,
    STATE(626), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1418), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1823), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [50186] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1596), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [50261] = 4,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(1655), 1,
      anon_sym_LT,
    ACTIONS(714), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [50308] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1283), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [50383] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1598), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [50458] = 19,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_getline,
    ACTIONS(17), 1,
      anon_sym_SLASH,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1811), 1,
      anon_sym_AT,
    STATE(448), 1,
      sym_ns_qualified_name,
    STATE(483), 1,
      sym_array_ref,
    STATE(519), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(23), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(567), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(608), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [50535] = 19,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(280), 1,
      anon_sym_SLASH,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 1,
      anon_sym_AT,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(284), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1540), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [50612] = 19,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(280), 1,
      anon_sym_SLASH,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 1,
      anon_sym_AT,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(284), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1551), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [50689] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(225), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [50764] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1600), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [50839] = 19,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(280), 1,
      anon_sym_SLASH,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 1,
      anon_sym_AT,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(284), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1537), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [50916] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(965), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [50991] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(968), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51066] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(195), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51141] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(978), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51216] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(980), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51291] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(991), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51366] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(993), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51441] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(995), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51516] = 7,
    ACTIONS(874), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1825), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [51569] = 19,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1815), 1,
      sym_identifier,
    STATE(610), 1,
      sym_ns_qualified_name,
    STATE(611), 1,
      sym_array_ref,
    STATE(626), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1418), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1829), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [51646] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(343), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51721] = 5,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [51770] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1571), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51845] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1572), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51920] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1420), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [51995] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1573), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52070] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1574), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52145] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1576), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52220] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1578), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52295] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1575), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52370] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1802), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [52447] = 3,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 34,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [52492] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(235), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52567] = 4,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [52614] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1602), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52689] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1603), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52764] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1604), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52839] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1804), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [52916] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1606), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [52991] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1607), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [53066] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1486), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [53141] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1608), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [53216] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1609), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [53291] = 19,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1827), 1,
      sym_identifier,
    STATE(619), 1,
      sym_ns_qualified_name,
    STATE(622), 1,
      sym_array_ref,
    STATE(668), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1485), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1836), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [53368] = 6,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [53419] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(359), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [53494] = 8,
    ACTIONS(1829), 1,
      anon_sym_in,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1825), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [53549] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1820), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [53626] = 9,
    ACTIONS(1829), 1,
      anon_sym_in,
    ACTIONS(1831), 1,
      anon_sym_AMP_AMP,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1825), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 19,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [53683] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(515), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [53758] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(327), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [53833] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(510), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [53908] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(430), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [53983] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1581), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [54058] = 7,
    ACTIONS(890), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1825), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [54111] = 11,
    ACTIONS(1829), 1,
      anon_sym_in,
    ACTIONS(1831), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1835), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(886), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1825), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [54172] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(501), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [54247] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1006), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [54322] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(548), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [54397] = 11,
    ACTIONS(1829), 1,
      anon_sym_in,
    ACTIONS(1831), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1835), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(896), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1825), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [54458] = 11,
    ACTIONS(1829), 1,
      anon_sym_in,
    ACTIONS(1831), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1835), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(900), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1825), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [54519] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1424), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [54594] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(499), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [54669] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(514), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [54744] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1583), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [54819] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(497), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [54894] = 19,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(454), 1,
      anon_sym_SLASH,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(464), 1,
      anon_sym_AT,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(460), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1446), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [54971] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(516), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55046] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1584), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55121] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(407), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55196] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(517), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55271] = 19,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 1,
      anon_sym_AT,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(334), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(417), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [55348] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1502), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55423] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(346), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55498] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(219), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55573] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(502), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55648] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(503), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55723] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1472), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55798] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1567), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55873] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(556), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [55948] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(439), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56023] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(273), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56098] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1036), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56173] = 19,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(370), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(380), 1,
      anon_sym_AT,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(376), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1534), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [56250] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1586), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56325] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(396), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56400] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(558), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56475] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1471), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56550] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1641), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56625] = 11,
    ACTIONS(1829), 1,
      anon_sym_in,
    ACTIONS(1831), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1835), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(906), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1825), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [56686] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(281), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56761] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(225), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56836] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(437), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56911] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(547), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [56986] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1515), 1,
      sym_identifier,
    ACTIONS(1517), 1,
      anon_sym_getline,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(1523), 1,
      anon_sym_AT,
    STATE(849), 1,
      sym_ns_qualified_name,
    STATE(1121), 1,
      sym_array_ref,
    STATE(1234), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1521), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1585), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57061] = 19,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1837), 1,
      sym_identifier,
    STATE(239), 1,
      sym_ns_qualified_name,
    STATE(274), 1,
      sym_array_ref,
    STATE(289), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(468), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1825), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [57138] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(443), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57213] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1465), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57288] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1464), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57363] = 19,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(204), 1,
      anon_sym_AT,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(200), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(476), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [57440] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(580), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57515] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1420), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57590] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1463), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57665] = 19,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 1,
      anon_sym_AT,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(334), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(467), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [57742] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(453), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57817] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(454), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57892] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(433), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [57967] = 19,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(454), 1,
      anon_sym_SLASH,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(464), 1,
      anon_sym_AT,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(460), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1686), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [58044] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(458), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [58119] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(441), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [58194] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(456), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [58269] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(460), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [58344] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(462), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [58419] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1462), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [58494] = 19,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(204), 1,
      anon_sym_AT,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(200), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(477), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [58571] = 19,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 1,
      anon_sym_AT,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(334), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(420), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [58648] = 8,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(686), 6,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58703] = 19,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 1,
      anon_sym_AT,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(334), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(434), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [58780] = 19,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(204), 1,
      anon_sym_AT,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(200), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(487), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [58857] = 19,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(454), 1,
      anon_sym_SLASH,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(464), 1,
      anon_sym_AT,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(460), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1692), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [58934] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(582), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [59009] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(584), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [59084] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(585), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [59159] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(546), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [59234] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(587), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [59309] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(573), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [59384] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(565), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [59459] = 5,
    ACTIONS(910), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [59508] = 19,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1827), 1,
      sym_identifier,
    STATE(619), 1,
      sym_ns_qualified_name,
    STATE(622), 1,
      sym_array_ref,
    STATE(668), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1485), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1826), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [59585] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1752), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [59662] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1767), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [59739] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(387), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [59814] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 1,
      anon_sym_LT,
    ACTIONS(714), 10,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(716), 25,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [59863] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1773), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [59908] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1778), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [59985] = 3,
    ACTIONS(860), 1,
      sym_concatenating_space,
    ACTIONS(892), 1,
      sym_regex_flags,
    ACTIONS(856), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [60030] = 19,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(204), 1,
      anon_sym_AT,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(200), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(520), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [60107] = 19,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(204), 1,
      anon_sym_AT,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(200), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(522), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [60184] = 19,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_getline,
    ACTIONS(17), 1,
      anon_sym_SLASH,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1811), 1,
      anon_sym_AT,
    STATE(448), 1,
      sym_ns_qualified_name,
    STATE(483), 1,
      sym_array_ref,
    STATE(519), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(23), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(567), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(604), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [60261] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1755), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [60338] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1758), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [60415] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1759), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [60492] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1776), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [60569] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(389), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [60644] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1790), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [60721] = 18,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    ACTIONS(1503), 1,
      sym_identifier,
    ACTIONS(1505), 1,
      anon_sym_getline,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(1511), 1,
      anon_sym_AT,
    STATE(221), 1,
      sym_ns_qualified_name,
    STATE(247), 1,
      sym_array_ref,
    STATE(265), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1509), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(392), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [60796] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1794), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [60873] = 3,
    ACTIONS(852), 1,
      sym_concatenating_space,
    ACTIONS(902), 1,
      sym_regex_flags,
    ACTIONS(848), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [60918] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(562), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [60993] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1769), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61070] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1814), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61147] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [61222] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1764), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61299] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1731), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61376] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1768), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61453] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1795), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61530] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1793), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61607] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1791), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61684] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1807), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61761] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(216), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [61836] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1756), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61913] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1706), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [61990] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1733), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [62067] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(569), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [62142] = 7,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(1779), 1,
      anon_sym_EQ,
    ACTIONS(1777), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1781), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 18,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [62195] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1809), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [62272] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1763), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [62349] = 19,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(370), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(380), 1,
      anon_sym_AT,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(376), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1696), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [62426] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1460), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [62501] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1459), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [62576] = 19,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(346), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(364), 1,
      anon_sym_getline,
    ACTIONS(370), 1,
      anon_sym_SLASH,
    ACTIONS(374), 1,
      anon_sym_BANG,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(380), 1,
      anon_sym_AT,
    STATE(851), 1,
      sym_ns_qualified_name,
    STATE(931), 1,
      sym_array_ref,
    STATE(1293), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(372), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(376), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1588), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1697), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [62653] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(235), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [62728] = 18,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 1,
      anon_sym_getline,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(1571), 1,
      anon_sym_BANG,
    ACTIONS(1575), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1569), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1573), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(197), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [62803] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1813), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [62880] = 5,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1281), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1413), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62929] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(219), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63004] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(644), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63079] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(712), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63154] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(245), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63229] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(197), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63304] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1625), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63379] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(216), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63454] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1454), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63529] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(235), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63604] = 5,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1319), 1,
      sym_concatenating_space,
    ACTIONS(1261), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1317), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63653] = 8,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [63708] = 19,
    ACTIONS(162), 1,
      sym_identifier,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(188), 1,
      anon_sym_getline,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(204), 1,
      anon_sym_AT,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    STATE(243), 1,
      sym_ns_qualified_name,
    STATE(269), 1,
      sym_array_ref,
    STATE(292), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(200), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(426), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(492), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [63785] = 19,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(454), 1,
      anon_sym_SLASH,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(464), 1,
      anon_sym_AT,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(460), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1477), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [63862] = 18,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1445), 1,
      anon_sym_getline,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(1451), 1,
      anon_sym_BANG,
    ACTIONS(1455), 1,
      anon_sym_AT,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1449), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1453), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(513), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [63937] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1630), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [64012] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1451), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [64087] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1449), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [64162] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1502), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [64237] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1528), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [64312] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1471), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [64387] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(216), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [64462] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(197), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [64537] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1635), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [64612] = 12,
    ACTIONS(1829), 1,
      anon_sym_in,
    ACTIONS(1831), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1833), 1,
      anon_sym_QMARK,
    ACTIONS(1835), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(914), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(916), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1819), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1823), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1825), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1821), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1817), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 15,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [64675] = 19,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(454), 1,
      anon_sym_SLASH,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(464), 1,
      anon_sym_AT,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(460), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1592), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [64752] = 19,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SLASH,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(396), 1,
      anon_sym_AT,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(392), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1477), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [64829] = 19,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(430), 1,
      sym_identifier,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(448), 1,
      anon_sym_getline,
    ACTIONS(454), 1,
      anon_sym_SLASH,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(464), 1,
      anon_sym_AT,
    STATE(689), 1,
      sym_ns_qualified_name,
    STATE(840), 1,
      sym_array_ref,
    STATE(1131), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(460), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1559), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1490), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [64906] = 19,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SLASH,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(396), 1,
      anon_sym_AT,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(392), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1520), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [64983] = 19,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SLASH,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(396), 1,
      anon_sym_AT,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(392), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1490), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [65060] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1435), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [65135] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1448), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [65210] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1440), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [65285] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(245), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [65360] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1650), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [65435] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(225), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [65510] = 19,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(280), 1,
      anon_sym_SLASH,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 1,
      anon_sym_AT,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(284), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1613), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [65587] = 19,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(280), 1,
      anon_sym_SLASH,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 1,
      anon_sym_AT,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(284), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1610), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [65664] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1679), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [65741] = 18,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1457), 1,
      sym_identifier,
    ACTIONS(1459), 1,
      anon_sym_getline,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(1465), 1,
      anon_sym_AT,
    STATE(465), 1,
      sym_ns_qualified_name,
    STATE(488), 1,
      sym_array_ref,
    STATE(504), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1463), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(563), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [65816] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(633), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [65891] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1435), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [65966] = 3,
    ACTIONS(1039), 1,
      anon_sym_LBRACK,
    ACTIONS(1775), 1,
      sym__if_else_separator,
    ACTIONS(1773), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [66011] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1642), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66086] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1643), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66161] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1644), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66236] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1621), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66311] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1662), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66386] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1646), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66461] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(652), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66536] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1651), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66611] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1683), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [66688] = 19,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1841), 1,
      sym_identifier,
    STATE(1063), 1,
      sym_ns_qualified_name,
    STATE(1222), 1,
      sym_array_ref,
    STATE(1306), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1667), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1824), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [66765] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1566), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66840] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1678), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [66917] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(436), 1,
      anon_sym_LPAREN,
    ACTIONS(458), 1,
      anon_sym_BANG,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1527), 1,
      anon_sym_getline,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(1533), 1,
      anon_sym_AT,
    STATE(685), 1,
      sym_ns_qualified_name,
    STATE(835), 1,
      sym_array_ref,
    STATE(1218), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1531), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1440), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [66992] = 18,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1417), 1,
      sym_identifier,
    ACTIONS(1419), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_getline,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(1427), 1,
      anon_sym_BANG,
    ACTIONS(1431), 1,
      anon_sym_AT,
    ACTIONS(1433), 1,
      aux_sym_number_token1,
    ACTIONS(1435), 1,
      aux_sym_number_token2,
    ACTIONS(1437), 1,
      anon_sym_DQUOTE,
    STATE(308), 1,
      sym_ns_qualified_name,
    STATE(313), 1,
      sym_array_ref,
    STATE(326), 1,
      sym__binary_in,
    STATE(344), 1,
      sym_field_ref,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1425), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1429), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1314), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [67067] = 19,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SLASH,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(396), 1,
      anon_sym_AT,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(392), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1557), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [67144] = 19,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SLASH,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(396), 1,
      anon_sym_AT,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(392), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1564), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [67221] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(640), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [67296] = 19,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_getline,
    ACTIONS(17), 1,
      anon_sym_SLASH,
    ACTIONS(21), 1,
      anon_sym_BANG,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(29), 1,
      aux_sym_number_token1,
    ACTIONS(31), 1,
      aux_sym_number_token2,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(1811), 1,
      anon_sym_AT,
    STATE(448), 1,
      sym_ns_qualified_name,
    STATE(483), 1,
      sym_array_ref,
    STATE(519), 1,
      sym_field_ref,
    STATE(588), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(19), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(23), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(567), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(589), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [67373] = 18,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    ACTIONS(1637), 1,
      sym_identifier,
    ACTIONS(1639), 1,
      anon_sym_getline,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(1645), 1,
      anon_sym_AT,
    STATE(629), 1,
      sym_ns_qualified_name,
    STATE(651), 1,
      sym_array_ref,
    STATE(703), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1643), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1532), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [67448] = 18,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1543), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_getline,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(1551), 1,
      anon_sym_BANG,
    ACTIONS(1555), 1,
      anon_sym_AT,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1549), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1553), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1273), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [67523] = 19,
    ACTIONS(224), 1,
      sym_identifier,
    ACTIONS(240), 1,
      anon_sym_getline,
    ACTIONS(256), 1,
      aux_sym_number_token1,
    ACTIONS(276), 1,
      anon_sym_LPAREN,
    ACTIONS(280), 1,
      anon_sym_SLASH,
    ACTIONS(282), 1,
      anon_sym_BANG,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 1,
      anon_sym_AT,
    ACTIONS(290), 1,
      aux_sym_number_token2,
    ACTIONS(292), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym_ns_qualified_name,
    STATE(665), 1,
      sym_array_ref,
    STATE(694), 1,
      sym_field_ref,
    STATE(1473), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(248), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(284), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1518), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1534), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [67600] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1503), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [67675] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(290), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [67750] = 18,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1383), 1,
      anon_sym_LPAREN,
    ACTIONS(1385), 1,
      anon_sym_getline,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(1391), 1,
      anon_sym_BANG,
    ACTIONS(1395), 1,
      anon_sym_AT,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1389), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1393), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(219), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [67825] = 19,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_getline,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(388), 1,
      anon_sym_SLASH,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(396), 1,
      anon_sym_AT,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    STATE(612), 1,
      sym_ns_qualified_name,
    STATE(630), 1,
      sym_array_ref,
    STATE(648), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(392), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1493), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1446), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [67902] = 18,
    ACTIONS(79), 1,
      aux_sym_number_token1,
    ACTIONS(384), 1,
      anon_sym_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BANG,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(398), 1,
      aux_sym_number_token2,
    ACTIONS(400), 1,
      anon_sym_DQUOTE,
    ACTIONS(1371), 1,
      sym_identifier,
    ACTIONS(1373), 1,
      anon_sym_getline,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(1379), 1,
      anon_sym_AT,
    STATE(613), 1,
      sym_ns_qualified_name,
    STATE(620), 1,
      sym_array_ref,
    STATE(646), 1,
      sym_field_ref,
    STATE(1419), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(71), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1377), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1424), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [67977] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1742), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [68054] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1757), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [68131] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(789), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68206] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(787), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68281] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(228), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68356] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(784), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68431] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(782), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68506] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(779), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68581] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(775), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68656] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(769), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68731] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(766), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68806] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(760), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [68881] = 19,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 1,
      anon_sym_AT,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(334), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(508), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [68958] = 19,
    ACTIONS(302), 1,
      sym_identifier,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    ACTIONS(322), 1,
      anon_sym_getline,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(332), 1,
      anon_sym_BANG,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(338), 1,
      anon_sym_AT,
    ACTIONS(340), 1,
      aux_sym_number_token1,
    ACTIONS(342), 1,
      aux_sym_number_token2,
    ACTIONS(344), 1,
      anon_sym_DQUOTE,
    STATE(201), 1,
      sym_ns_qualified_name,
    STATE(233), 1,
      sym_array_ref,
    STATE(255), 1,
      sym_field_ref,
    STATE(399), 1,
      sym__binary_in,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(330), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(334), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(382), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(498), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [69035] = 18,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1589), 1,
      anon_sym_LPAREN,
    ACTIONS(1591), 1,
      anon_sym_getline,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(1597), 1,
      anon_sym_BANG,
    ACTIONS(1601), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1595), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1599), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(756), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69110] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(669), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69185] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(666), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69260] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(195), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69335] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1689), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [69412] = 18,
    ACTIONS(166), 1,
      anon_sym_LPAREN,
    ACTIONS(198), 1,
      anon_sym_BANG,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(206), 1,
      aux_sym_number_token1,
    ACTIONS(208), 1,
      aux_sym_number_token2,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1605), 1,
      sym_identifier,
    ACTIONS(1607), 1,
      anon_sym_getline,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(1613), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_ns_qualified_name,
    STATE(277), 1,
      sym_array_ref,
    STATE(285), 1,
      sym_field_ref,
    STATE(431), 1,
      sym__binary_in,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(196), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1611), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(459), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69487] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(650), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69562] = 19,
    ACTIONS(1323), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1327), 1,
      anon_sym_getline,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1339), 1,
      anon_sym_AT,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    STATE(1132), 1,
      sym_ns_qualified_name,
    STATE(1223), 1,
      sym_array_ref,
    STATE(1338), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1335), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1659), 9,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_string_concat,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
    STATE(1771), 10,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_regex,
      sym_regex_constant,
      sym_indirect_func_call,
  [69639] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(645), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69714] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(667), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69789] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(664), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69864] = 18,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    ACTIONS(1333), 1,
      anon_sym_BANG,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(1341), 1,
      aux_sym_number_token1,
    ACTIONS(1343), 1,
      aux_sym_number_token2,
    ACTIONS(1345), 1,
      anon_sym_DQUOTE,
    ACTIONS(1403), 1,
      sym_identifier,
    ACTIONS(1405), 1,
      anon_sym_getline,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(1411), 1,
      anon_sym_AT,
    STATE(1111), 1,
      sym_ns_qualified_name,
    STATE(1241), 1,
      sym_array_ref,
    STATE(1327), 1,
      sym_field_ref,
    STATE(1648), 1,
      sym__binary_in,
    STATE(2209), 1,
      sym_namespace,
    ACTIONS(1331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1409), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1669), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [69939] = 18,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(1381), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      aux_sym_number_token1,
    ACTIONS(1399), 1,
      aux_sym_number_token2,
    ACTIONS(1401), 1,
      anon_sym_DQUOTE,
    ACTIONS(1485), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_getline,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(1493), 1,
      anon_sym_BANG,
    ACTIONS(1497), 1,
      anon_sym_AT,
    STATE(168), 1,
      sym_ns_qualified_name,
    STATE(180), 1,
      sym_array_ref,
    STATE(207), 1,
      sym__binary_in,
    STATE(213), 1,
      sym_field_ref,
    STATE(2249), 1,
      sym_namespace,
    ACTIONS(1491), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1495), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(663), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [70014] = 18,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(1541), 1,
      sym_identifier,
    ACTIONS(1557), 1,
      aux_sym_number_token1,
    ACTIONS(1559), 1,
      aux_sym_number_token2,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1621), 1,
      anon_sym_LPAREN,
    ACTIONS(1623), 1,
      anon_sym_getline,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(1629), 1,
      anon_sym_BANG,
    ACTIONS(1633), 1,
      anon_sym_AT,
    STATE(184), 1,
      sym_ns_qualified_name,
    STATE(220), 1,
      sym_array_ref,
    STATE(251), 1,
      sym__binary_in,
    STATE(253), 1,
      sym_field_ref,
    STATE(2114), 1,
      sym_namespace,
    ACTIONS(1627), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1631), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(245), 19,
      sym__getline_exp,
      sym_getline_input,
      sym_getline_file,
      sym__exp,
      sym_ternary_exp,
      sym_binary_exp,
      sym_unary_exp,
      sym_update_exp,
      sym_assignment_exp,
      sym_piped_io_exp,
      sym_string_concat,
      sym_regex,
      sym_regex_constant,
      sym_grouping,
      sym__primitive,
      sym_number,
      sym_string,
      sym_func_call,
      sym_indirect_func_call,
  [70089] = 4,
    ACTIONS(674), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(1267), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1353), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70136] = 5,
    ACTIONS(1843), 1,
      sym_identifier,
    STATE(2258), 1,
      sym_namespace,
    ACTIONS(682), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    STATE(1406), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [70184] = 2,
    ACTIONS(1847), 1,
      sym__if_else_separator,
    ACTIONS(1845), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70226] = 2,
    ACTIONS(1851), 1,
      sym__if_else_separator,
    ACTIONS(1849), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70268] = 7,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(686), 6,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70320] = 7,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [70372] = 2,
    ACTIONS(1855), 1,
      sym__if_else_separator,
    ACTIONS(1853), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70414] = 3,
    ACTIONS(1855), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1853), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70458] = 2,
    ACTIONS(1861), 1,
      sym__if_else_separator,
    ACTIONS(1859), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70500] = 12,
    ACTIONS(916), 1,
      sym_concatenating_space,
    ACTIONS(1863), 1,
      anon_sym_in,
    ACTIONS(1867), 1,
      anon_sym_QMARK,
    ACTIONS(1877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1879), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(922), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1875), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 15,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [70562] = 2,
    ACTIONS(1883), 1,
      sym__if_else_separator,
    ACTIONS(1881), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70604] = 3,
    ACTIONS(1883), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1881), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70648] = 2,
    ACTIONS(1887), 1,
      sym__if_else_separator,
    ACTIONS(1885), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70690] = 2,
    ACTIONS(1891), 1,
      sym__if_else_separator,
    ACTIONS(1889), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70732] = 3,
    ACTIONS(1891), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1889), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70776] = 2,
    ACTIONS(1895), 1,
      sym__if_else_separator,
    ACTIONS(1893), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70818] = 4,
    ACTIONS(674), 1,
      sym_concatenating_space,
    ACTIONS(1281), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1413), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70864] = 2,
    ACTIONS(1899), 1,
      sym__if_else_separator,
    ACTIONS(1897), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70906] = 2,
    ACTIONS(1903), 1,
      sym__if_else_separator,
    ACTIONS(1901), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70948] = 2,
    ACTIONS(1907), 1,
      sym__if_else_separator,
    ACTIONS(1905), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [70990] = 2,
    ACTIONS(1911), 1,
      sym__if_else_separator,
    ACTIONS(1909), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71032] = 3,
    ACTIONS(1911), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1909), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71076] = 2,
    ACTIONS(1915), 1,
      sym__if_else_separator,
    ACTIONS(1913), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71118] = 6,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1779), 1,
      anon_sym_EQ,
    ACTIONS(1777), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1781), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 18,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [71168] = 3,
    ACTIONS(1915), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1913), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71212] = 2,
    ACTIONS(1919), 1,
      sym__if_else_separator,
    ACTIONS(1917), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71254] = 3,
    ACTIONS(1919), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1917), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71298] = 2,
    ACTIONS(1923), 1,
      sym__if_else_separator,
    ACTIONS(1921), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71340] = 3,
    ACTIONS(1923), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1921), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71384] = 2,
    ACTIONS(1927), 1,
      sym__if_else_separator,
    ACTIONS(1925), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71426] = 3,
    ACTIONS(1927), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1925), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71470] = 2,
    ACTIONS(1931), 1,
      sym__if_else_separator,
    ACTIONS(1929), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71512] = 2,
    ACTIONS(1935), 1,
      sym__if_else_separator,
    ACTIONS(1933), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71554] = 2,
    ACTIONS(1935), 1,
      sym__if_else_separator,
    ACTIONS(1933), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71596] = 2,
    ACTIONS(1939), 1,
      sym__if_else_separator,
    ACTIONS(1937), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71638] = 2,
    ACTIONS(1943), 1,
      sym__if_else_separator,
    ACTIONS(1941), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71680] = 3,
    ACTIONS(1943), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1941), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71724] = 2,
    ACTIONS(1947), 1,
      sym__if_else_separator,
    ACTIONS(1945), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71766] = 3,
    ACTIONS(1947), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1945), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71810] = 2,
    ACTIONS(1951), 1,
      sym__if_else_separator,
    ACTIONS(1949), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71852] = 3,
    ACTIONS(1951), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1949), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71896] = 2,
    ACTIONS(1955), 1,
      sym__if_else_separator,
    ACTIONS(1953), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71938] = 3,
    ACTIONS(1955), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1953), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [71982] = 2,
    ACTIONS(1959), 1,
      sym__if_else_separator,
    ACTIONS(1957), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72024] = 3,
    ACTIONS(1959), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1957), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72068] = 2,
    ACTIONS(1963), 1,
      sym__if_else_separator,
    ACTIONS(1961), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72110] = 3,
    ACTIONS(1963), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1961), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72154] = 2,
    ACTIONS(1967), 1,
      sym__if_else_separator,
    ACTIONS(1965), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72196] = 2,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1773), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72238] = 3,
    ACTIONS(1967), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1965), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72282] = 2,
    ACTIONS(1971), 1,
      sym__if_else_separator,
    ACTIONS(1969), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72324] = 4,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 1,
      anon_sym_LT,
    ACTIONS(714), 9,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(716), 26,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [72370] = 2,
    ACTIONS(1975), 1,
      sym__if_else_separator,
    ACTIONS(1973), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72412] = 3,
    ACTIONS(1975), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1973), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72456] = 2,
    ACTIONS(1979), 1,
      sym__if_else_separator,
    ACTIONS(1977), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72498] = 5,
    ACTIONS(910), 1,
      sym_concatenating_space,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [72546] = 3,
    ACTIONS(1979), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1977), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72590] = 2,
    ACTIONS(1983), 1,
      sym__if_else_separator,
    ACTIONS(1981), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72632] = 3,
    ACTIONS(1983), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1981), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72676] = 2,
    ACTIONS(1987), 1,
      sym__if_else_separator,
    ACTIONS(1985), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72718] = 3,
    ACTIONS(1987), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1985), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72762] = 2,
    ACTIONS(1991), 1,
      sym__if_else_separator,
    ACTIONS(1989), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72804] = 3,
    ACTIONS(1991), 1,
      sym__if_else_separator,
    ACTIONS(1857), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1989), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72848] = 2,
    ACTIONS(1995), 1,
      sym__if_else_separator,
    ACTIONS(1993), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72890] = 2,
    ACTIONS(1999), 1,
      sym__if_else_separator,
    ACTIONS(1997), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [72932] = 11,
    ACTIONS(906), 1,
      sym_concatenating_space,
    ACTIONS(1863), 1,
      anon_sym_in,
    ACTIONS(1867), 1,
      anon_sym_QMARK,
    ACTIONS(1877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1879), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1875), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [72992] = 11,
    ACTIONS(900), 1,
      sym_concatenating_space,
    ACTIONS(1863), 1,
      anon_sym_in,
    ACTIONS(1867), 1,
      anon_sym_QMARK,
    ACTIONS(1877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1879), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1875), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73052] = 11,
    ACTIONS(896), 1,
      sym_concatenating_space,
    ACTIONS(1863), 1,
      anon_sym_in,
    ACTIONS(1867), 1,
      anon_sym_QMARK,
    ACTIONS(1877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1879), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1875), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73112] = 11,
    ACTIONS(886), 1,
      sym_concatenating_space,
    ACTIONS(1863), 1,
      anon_sym_in,
    ACTIONS(1867), 1,
      anon_sym_QMARK,
    ACTIONS(1877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1879), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1875), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73172] = 7,
    ACTIONS(890), 1,
      sym_concatenating_space,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1875), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73224] = 9,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1863), 1,
      anon_sym_in,
    ACTIONS(1877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1875), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 19,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73280] = 8,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1863), 1,
      anon_sym_in,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1875), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73334] = 6,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73384] = 4,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73430] = 3,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 34,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73474] = 4,
    ACTIONS(1441), 1,
      sym_concatenating_space,
    ACTIONS(1287), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1439), 7,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73520] = 5,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73568] = 7,
    ACTIONS(874), 1,
      sym_concatenating_space,
    ACTIONS(1869), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1873), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1875), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(1871), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1865), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
  [73620] = 3,
    ACTIONS(1143), 1,
      sym_regex_flags,
    ACTIONS(848), 11,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(852), 25,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [73664] = 3,
    ACTIONS(1145), 1,
      sym_regex_flags,
    ACTIONS(856), 11,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(860), 25,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [73708] = 9,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(888), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(890), 19,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [73763] = 1,
    ACTIONS(1961), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [73802] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1881), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [73843] = 4,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(778), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(780), 25,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [73888] = 5,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(780), 25,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [73935] = 8,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(778), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(780), 21,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [73988] = 1,
    ACTIONS(1889), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74027] = 1,
    ACTIONS(1989), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74066] = 6,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(686), 6,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74115] = 10,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2017), 1,
      anon_sym_in,
    ACTIONS(778), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(780), 18,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [74172] = 11,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2017), 1,
      anon_sym_in,
    ACTIONS(2019), 1,
      anon_sym_AMP_AMP,
    ACTIONS(778), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(780), 17,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [74231] = 13,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2017), 1,
      anon_sym_in,
    ACTIONS(2019), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2021), 1,
      anon_sym_QMARK,
    ACTIONS(2023), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(876), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(886), 15,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [74294] = 13,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2017), 1,
      anon_sym_in,
    ACTIONS(2019), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2021), 1,
      anon_sym_QMARK,
    ACTIONS(2023), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(894), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(896), 15,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [74357] = 13,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2017), 1,
      anon_sym_in,
    ACTIONS(2019), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2021), 1,
      anon_sym_QMARK,
    ACTIONS(2023), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(898), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(900), 15,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [74420] = 1,
    ACTIONS(1881), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74459] = 13,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2017), 1,
      anon_sym_in,
    ACTIONS(2019), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2021), 1,
      anon_sym_QMARK,
    ACTIONS(2023), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(904), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(906), 15,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [74522] = 6,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(910), 25,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [74571] = 15,
    ACTIONS(912), 1,
      anon_sym_EQ,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1171), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2017), 1,
      anon_sym_in,
    ACTIONS(2019), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2021), 1,
      anon_sym_QMARK,
    ACTIONS(2023), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(916), 14,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [74638] = 1,
    ACTIONS(1885), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74677] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1889), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74718] = 1,
    ACTIONS(1893), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74757] = 9,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(862), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(874), 19,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [74812] = 1,
    ACTIONS(1849), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74851] = 1,
    ACTIONS(1897), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74890] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1853), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74931] = 1,
    ACTIONS(1905), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [74970] = 1,
    ACTIONS(1909), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75009] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1909), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75050] = 1,
    ACTIONS(1913), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75089] = 5,
    ACTIONS(1779), 1,
      anon_sym_EQ,
    ACTIONS(1777), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1781), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 18,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [75136] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1913), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75177] = 1,
    ACTIONS(1917), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75216] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1917), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75257] = 1,
    ACTIONS(1993), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75296] = 1,
    ACTIONS(1997), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75335] = 1,
    ACTIONS(1859), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75374] = 1,
    ACTIONS(1921), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75413] = 5,
    ACTIONS(682), 1,
      sym__if_else_separator,
    ACTIONS(2025), 1,
      sym_identifier,
    STATE(2257), 1,
      sym_namespace,
    STATE(1430), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [75460] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1921), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75501] = 1,
    ACTIONS(1925), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75540] = 6,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [75589] = 1,
    ACTIONS(1845), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75628] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1925), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75669] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1989), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75710] = 5,
    ACTIONS(682), 1,
      sym_concatenating_space,
    ACTIONS(2027), 1,
      sym_identifier,
    STATE(2246), 1,
      sym_namespace,
    STATE(1425), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [75757] = 1,
    ACTIONS(1929), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75796] = 1,
    ACTIONS(1933), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75835] = 1,
    ACTIONS(1901), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75874] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1985), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75915] = 1,
    ACTIONS(1985), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [75954] = 7,
    ACTIONS(2029), 1,
      sym_identifier,
    ACTIONS(2031), 1,
      anon_sym_LT,
    STATE(1406), 1,
      sym_array_ref,
    STATE(1426), 1,
      sym_ns_qualified_name,
    STATE(2258), 1,
      sym_namespace,
    ACTIONS(682), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(680), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [76005] = 4,
    ACTIONS(2037), 1,
      anon_sym_POUND,
    STATE(1349), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
    ACTIONS(2035), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
    ACTIONS(2033), 21,
      anon_sym_if,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_identifier,
      aux_sym_number_token1,
  [76050] = 1,
    ACTIONS(1933), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76089] = 1,
    ACTIONS(1937), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76128] = 1,
    ACTIONS(1941), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76167] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1981), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76208] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1941), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76249] = 1,
    ACTIONS(1981), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76288] = 1,
    ACTIONS(1945), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76327] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1945), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76368] = 1,
    ACTIONS(1949), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76407] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1949), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76448] = 1,
    ACTIONS(1853), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76487] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1977), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76528] = 1,
    ACTIONS(1977), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76567] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1973), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76608] = 1,
    ACTIONS(1953), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76647] = 1,
    ACTIONS(1973), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76686] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1953), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76727] = 1,
    ACTIONS(1957), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76766] = 1,
    ACTIONS(1969), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76805] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1965), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76846] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1957), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76887] = 1,
    ACTIONS(1965), 36,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [76926] = 6,
    ACTIONS(2003), 1,
      anon_sym_CARET,
    ACTIONS(2005), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2009), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2007), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(780), 25,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_RBRACK,
  [76975] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(1961), 33,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [77016] = 10,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2040), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77072] = 10,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2042), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77128] = 2,
    ACTIONS(2046), 1,
      sym__if_else_separator,
    ACTIONS(2044), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [77168] = 7,
    ACTIONS(682), 1,
      sym_concatenating_space,
    ACTIONS(2048), 1,
      sym_identifier,
    ACTIONS(2050), 1,
      anon_sym_LT,
    STATE(1425), 1,
      sym_array_ref,
    STATE(1504), 1,
      sym_ns_qualified_name,
    STATE(2246), 1,
      sym_namespace,
    ACTIONS(680), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [77218] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2052), 1,
      anon_sym_LBRACK,
    ACTIONS(724), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [77262] = 2,
    ACTIONS(2054), 1,
      sym__if_else_separator,
    ACTIONS(2044), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [77302] = 10,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2056), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77358] = 2,
    ACTIONS(2054), 1,
      sym__if_else_separator,
    ACTIONS(2044), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [77398] = 10,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2058), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77454] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2052), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [77498] = 7,
    ACTIONS(682), 1,
      sym__if_else_separator,
    ACTIONS(2060), 1,
      sym_identifier,
    ACTIONS(2062), 1,
      anon_sym_LT,
    STATE(1430), 1,
      sym_array_ref,
    STATE(1488), 1,
      sym_ns_qualified_name,
    STATE(2257), 1,
      sym_namespace,
    ACTIONS(680), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [77548] = 2,
    ACTIONS(2066), 1,
      sym__if_else_separator,
    ACTIONS(2064), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [77588] = 2,
    ACTIONS(2066), 1,
      sym__if_else_separator,
    ACTIONS(2064), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [77628] = 10,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2068), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77684] = 10,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2070), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77740] = 2,
    ACTIONS(2072), 1,
      sym__if_else_separator,
    ACTIONS(2064), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [77780] = 4,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(2237), 1,
      sym_namespace,
    STATE(1458), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [77824] = 2,
    ACTIONS(2072), 1,
      sym__if_else_separator,
    ACTIONS(2064), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [77864] = 2,
    ACTIONS(2046), 1,
      sym__if_else_separator,
    ACTIONS(2044), 34,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [77904] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2052), 1,
      anon_sym_LBRACK,
    ACTIONS(2076), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [77949] = 9,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2070), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78002] = 9,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2040), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78055] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(724), 1,
      sym_concatenating_space,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78098] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78141] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(724), 1,
      sym__if_else_separator,
    ACTIONS(2080), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78184] = 9,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2058), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78237] = 2,
    ACTIONS(744), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(742), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_POUND,
  [78276] = 9,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2056), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78329] = 3,
    ACTIONS(2052), 1,
      anon_sym_LBRACK,
    ACTIONS(724), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78370] = 9,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2068), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78423] = 6,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2084), 1,
      anon_sym_LT,
    STATE(1458), 1,
      sym_array_ref,
    STATE(1530), 1,
      sym_ns_qualified_name,
    STATE(2237), 1,
      sym_namespace,
    ACTIONS(680), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78470] = 9,
    ACTIONS(746), 1,
      anon_sym_EQ,
    ACTIONS(938), 1,
      anon_sym_LBRACK,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(1729), 1,
      sym__func_call,
    ACTIONS(2042), 1,
      anon_sym_in,
    ACTIONS(1725), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1085), 6,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(666), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(674), 12,
      anon_sym_SEMI,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78523] = 3,
    ACTIONS(2052), 1,
      anon_sym_LBRACK,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78564] = 2,
    ACTIONS(2088), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
    ACTIONS(2086), 21,
      anon_sym_if,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_identifier,
      aux_sym_number_token1,
  [78603] = 2,
    ACTIONS(720), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(718), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_POUND,
  [78642] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(2080), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78685] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(2090), 31,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [78724] = 3,
    ACTIONS(2092), 1,
      sym_regex_flags,
    ACTIONS(860), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(856), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78764] = 2,
    ACTIONS(764), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(762), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78802] = 2,
    ACTIONS(822), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(820), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78840] = 2,
    ACTIONS(796), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(794), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78878] = 2,
    ACTIONS(744), 1,
      sym__if_else_separator,
    ACTIONS(742), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_POUND,
  [78916] = 2,
    ACTIONS(792), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(790), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [78954] = 7,
    ACTIONS(2094), 1,
      sym_identifier,
    ACTIONS(2096), 1,
      anon_sym_LT,
    STATE(1406), 1,
      sym_array_ref,
    STATE(1544), 1,
      sym_ns_qualified_name,
    STATE(2258), 1,
      sym_namespace,
    ACTIONS(682), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(680), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79002] = 3,
    ACTIONS(686), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79042] = 2,
    ACTIONS(804), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(802), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79080] = 2,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(778), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79118] = 2,
    ACTIONS(800), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(798), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79156] = 2,
    ACTIONS(724), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79194] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2098), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79234] = 2,
    ACTIONS(838), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(836), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79272] = 3,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79312] = 4,
    ACTIONS(2052), 1,
      anon_sym_LBRACK,
    ACTIONS(2076), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79354] = 3,
    ACTIONS(724), 1,
      sym__if_else_separator,
    ACTIONS(2080), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79394] = 3,
    ACTIONS(2100), 1,
      sym_regex_flags,
    ACTIONS(852), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(848), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79434] = 2,
    ACTIONS(818), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(816), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79472] = 3,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(2080), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79512] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2098), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79552] = 2,
    ACTIONS(814), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(812), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79590] = 2,
    ACTIONS(826), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(824), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79628] = 2,
    ACTIONS(720), 1,
      sym_concatenating_space,
    ACTIONS(718), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_POUND,
  [79666] = 2,
    ACTIONS(830), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(828), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79704] = 2,
    ACTIONS(788), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(786), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79742] = 2,
    ACTIONS(808), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(806), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79780] = 2,
    ACTIONS(720), 1,
      sym__if_else_separator,
    ACTIONS(718), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_POUND,
  [79818] = 3,
    ACTIONS(724), 1,
      sym_concatenating_space,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79858] = 2,
    ACTIONS(784), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(782), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79896] = 2,
    ACTIONS(768), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(766), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79934] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(2080), 1,
      anon_sym_LBRACK,
    ACTIONS(2102), 1,
      anon_sym_LT,
    ACTIONS(714), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [79978] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2104), 1,
      anon_sym_LT,
    ACTIONS(714), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80022] = 2,
    ACTIONS(744), 1,
      sym_concatenating_space,
    ACTIONS(742), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_POUND,
  [80060] = 2,
    ACTIONS(846), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(844), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80098] = 2,
    ACTIONS(838), 1,
      sym__if_else_separator,
    ACTIONS(836), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80135] = 2,
    ACTIONS(814), 1,
      sym__if_else_separator,
    ACTIONS(812), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80172] = 12,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(916), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2110), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
  [80229] = 11,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(906), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [80284] = 11,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(900), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [80339] = 11,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(896), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [80394] = 11,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(886), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [80449] = 7,
    ACTIONS(682), 1,
      sym__if_else_separator,
    ACTIONS(2126), 1,
      sym_identifier,
    ACTIONS(2128), 1,
      anon_sym_LT,
    STATE(1430), 1,
      sym_array_ref,
    STATE(1580), 1,
      sym_ns_qualified_name,
    STATE(2257), 1,
      sym_namespace,
    ACTIONS(680), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80496] = 7,
    ACTIONS(890), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 15,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80543] = 1,
    ACTIONS(718), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_POUND,
  [80578] = 2,
    ACTIONS(724), 1,
      sym_concatenating_space,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80615] = 2,
    ACTIONS(724), 1,
      sym__if_else_separator,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80652] = 2,
    ACTIONS(2098), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80689] = 9,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 13,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80740] = 8,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80789] = 6,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80834] = 4,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80875] = 3,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 28,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80914] = 5,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [80957] = 7,
    ACTIONS(874), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 15,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81004] = 2,
    ACTIONS(800), 1,
      sym_concatenating_space,
    ACTIONS(798), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81041] = 2,
    ACTIONS(764), 1,
      sym_concatenating_space,
    ACTIONS(762), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81078] = 2,
    ACTIONS(818), 1,
      sym__if_else_separator,
    ACTIONS(816), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81115] = 2,
    ACTIONS(768), 1,
      sym_concatenating_space,
    ACTIONS(766), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81152] = 2,
    ACTIONS(796), 1,
      sym_concatenating_space,
    ACTIONS(794), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81189] = 2,
    ACTIONS(784), 1,
      sym_concatenating_space,
    ACTIONS(782), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81226] = 2,
    ACTIONS(838), 1,
      sym_concatenating_space,
    ACTIONS(836), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81263] = 2,
    ACTIONS(804), 1,
      sym_concatenating_space,
    ACTIONS(802), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81300] = 1,
    ACTIONS(742), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_POUND,
  [81335] = 2,
    ACTIONS(808), 1,
      sym_concatenating_space,
    ACTIONS(806), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81372] = 2,
    ACTIONS(826), 1,
      sym__if_else_separator,
    ACTIONS(824), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81409] = 2,
    ACTIONS(830), 1,
      sym__if_else_separator,
    ACTIONS(828), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81446] = 2,
    ACTIONS(788), 1,
      sym__if_else_separator,
    ACTIONS(786), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81483] = 2,
    ACTIONS(846), 1,
      sym_concatenating_space,
    ACTIONS(844), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81520] = 2,
    ACTIONS(822), 1,
      sym_concatenating_space,
    ACTIONS(820), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81557] = 2,
    ACTIONS(846), 1,
      sym__if_else_separator,
    ACTIONS(844), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81594] = 7,
    ACTIONS(682), 1,
      sym_concatenating_space,
    ACTIONS(2130), 1,
      sym_identifier,
    ACTIONS(2132), 1,
      anon_sym_LT,
    STATE(1425), 1,
      sym_array_ref,
    STATE(1561), 1,
      sym_ns_qualified_name,
    STATE(2246), 1,
      sym_namespace,
    ACTIONS(680), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81641] = 2,
    ACTIONS(814), 1,
      sym_concatenating_space,
    ACTIONS(812), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81678] = 2,
    ACTIONS(768), 1,
      sym__if_else_separator,
    ACTIONS(766), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81715] = 3,
    ACTIONS(686), 1,
      sym_concatenating_space,
    ACTIONS(684), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
    ACTIONS(666), 21,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81754] = 2,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(778), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81791] = 2,
    ACTIONS(818), 1,
      sym_concatenating_space,
    ACTIONS(816), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81828] = 4,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(2080), 1,
      anon_sym_LBRACK,
    ACTIONS(2102), 1,
      anon_sym_LT,
    ACTIONS(714), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81869] = 2,
    ACTIONS(792), 1,
      sym_concatenating_space,
    ACTIONS(790), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81906] = 2,
    ACTIONS(784), 1,
      sym__if_else_separator,
    ACTIONS(782), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81943] = 3,
    ACTIONS(852), 1,
      sym__if_else_separator,
    ACTIONS(2134), 1,
      sym_regex_flags,
    ACTIONS(848), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [81982] = 3,
    ACTIONS(860), 1,
      sym__if_else_separator,
    ACTIONS(2136), 1,
      sym_regex_flags,
    ACTIONS(856), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82021] = 3,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1265), 1,
      sym_concatenating_space,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82060] = 2,
    ACTIONS(764), 1,
      sym__if_else_separator,
    ACTIONS(762), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82097] = 3,
    ACTIONS(852), 1,
      sym_concatenating_space,
    ACTIONS(2138), 1,
      sym_regex_flags,
    ACTIONS(848), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82136] = 2,
    ACTIONS(796), 1,
      sym__if_else_separator,
    ACTIONS(794), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82173] = 3,
    ACTIONS(860), 1,
      sym_concatenating_space,
    ACTIONS(2140), 1,
      sym_regex_flags,
    ACTIONS(856), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82212] = 2,
    ACTIONS(788), 1,
      sym_concatenating_space,
    ACTIONS(786), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82249] = 2,
    ACTIONS(826), 1,
      sym_concatenating_space,
    ACTIONS(824), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82286] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2098), 1,
      anon_sym_LBRACK,
    ACTIONS(2142), 1,
      anon_sym_LT,
    ACTIONS(714), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82327] = 2,
    ACTIONS(2098), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82364] = 2,
    ACTIONS(830), 1,
      sym_concatenating_space,
    ACTIONS(828), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82401] = 5,
    ACTIONS(910), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82444] = 4,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2104), 1,
      anon_sym_LT,
    ACTIONS(714), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82485] = 6,
    ACTIONS(2144), 1,
      sym_identifier,
    ACTIONS(2146), 1,
      anon_sym_LT,
    STATE(1458), 1,
      sym_array_ref,
    STATE(1614), 1,
      sym_ns_qualified_name,
    STATE(2237), 1,
      sym_namespace,
    ACTIONS(680), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82529] = 12,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(1113), 1,
      sym__if_else_separator,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 5,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1111), 11,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [82585] = 2,
    ACTIONS(1999), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
    ACTIONS(1997), 19,
      anon_sym_if,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_identifier,
      aux_sym_number_token1,
  [82621] = 7,
    ACTIONS(890), 1,
      sym_concatenating_space,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 15,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82667] = 11,
    ACTIONS(896), 1,
      sym_concatenating_space,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [82721] = 2,
    ACTIONS(2166), 1,
      sym_regex_flags,
    ACTIONS(856), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82757] = 11,
    ACTIONS(900), 1,
      sym_concatenating_space,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [82811] = 11,
    ACTIONS(906), 1,
      sym_concatenating_space,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [82865] = 5,
    ACTIONS(2168), 1,
      sym_identifier,
    STATE(2234), 1,
      sym_namespace,
    STATE(1595), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(682), 22,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [82907] = 1,
    ACTIONS(816), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [82941] = 11,
    ACTIONS(886), 1,
      sym_concatenating_space,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [82995] = 1,
    ACTIONS(786), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83029] = 2,
    ACTIONS(2170), 1,
      sym_regex_flags,
    ACTIONS(848), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83065] = 2,
    ACTIONS(1291), 1,
      sym_concatenating_space,
    ACTIONS(666), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83101] = 9,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 13,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83151] = 12,
    ACTIONS(916), 1,
      sym__if_else_separator,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
  [83207] = 8,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83255] = 6,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 17,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83299] = 4,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83339] = 1,
    ACTIONS(812), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83373] = 3,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 28,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83411] = 5,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83453] = 7,
    ACTIONS(2174), 1,
      sym_identifier,
    ACTIONS(2176), 1,
      anon_sym_LT,
    STATE(1594), 1,
      sym_ns_qualified_name,
    STATE(1595), 1,
      sym_array_ref,
    STATE(2234), 1,
      sym_namespace,
    ACTIONS(680), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(682), 22,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [83499] = 12,
    ACTIONS(916), 1,
      sym_concatenating_space,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2178), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
  [83555] = 12,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(1109), 1,
      sym__if_else_separator,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1105), 10,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [83611] = 3,
    ACTIONS(2098), 1,
      anon_sym_LBRACK,
    ACTIONS(2142), 1,
      anon_sym_LT,
    ACTIONS(714), 29,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83649] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2052), 1,
      anon_sym_LBRACK,
    ACTIONS(2180), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83691] = 5,
    ACTIONS(910), 1,
      sym_concatenating_space,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83733] = 7,
    ACTIONS(874), 1,
      sym_concatenating_space,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 15,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83779] = 1,
    ACTIONS(836), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83813] = 1,
    ACTIONS(762), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83847] = 1,
    ACTIONS(766), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83881] = 1,
    ACTIONS(782), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83915] = 2,
    ACTIONS(1995), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
    ACTIONS(1993), 19,
      anon_sym_if,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_delete,
      anon_sym_exit,
      anon_sym_return,
      anon_sym_switch,
      anon_sym_getline,
      sym_next_statement,
      sym_nextfile_statement,
      anon_sym_print,
      anon_sym_printf,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_identifier,
      aux_sym_number_token1,
  [83951] = 1,
    ACTIONS(722), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [83985] = 1,
    ACTIONS(828), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [84019] = 1,
    ACTIONS(824), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [84053] = 1,
    ACTIONS(794), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [84087] = 1,
    ACTIONS(844), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_POUND,
  [84121] = 4,
    ACTIONS(2052), 1,
      anon_sym_LBRACK,
    ACTIONS(2180), 1,
      anon_sym_LT,
    ACTIONS(716), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(714), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84160] = 7,
    ACTIONS(2182), 1,
      sym_identifier,
    ACTIONS(2184), 1,
      anon_sym_LT,
    STATE(1638), 1,
      sym_ns_qualified_name,
    STATE(1639), 1,
      sym_array_ref,
    STATE(2221), 1,
      sym_namespace,
    ACTIONS(680), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(682), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [84205] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2186), 1,
      anon_sym_LT,
    ACTIONS(714), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84246] = 11,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 5,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1111), 11,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [84299] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(2080), 1,
      anon_sym_LBRACK,
    ACTIONS(2188), 1,
      anon_sym_LT,
    ACTIONS(714), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84340] = 11,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1105), 10,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_POUND,
  [84393] = 3,
    ACTIONS(2100), 1,
      sym_regex_flags,
    ACTIONS(852), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(848), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84430] = 11,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(912), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_GT_GT,
      anon_sym_POUND,
  [84483] = 2,
    ACTIONS(2086), 15,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(2088), 15,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [84518] = 5,
    ACTIONS(2192), 1,
      sym_identifier,
    STATE(2221), 1,
      sym_namespace,
    STATE(1639), 2,
      sym_array_ref,
      sym_ns_qualified_name,
    ACTIONS(680), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(682), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [84559] = 3,
    ACTIONS(2092), 1,
      sym_regex_flags,
    ACTIONS(860), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(856), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84596] = 3,
    ACTIONS(852), 1,
      sym_concatenating_space,
    ACTIONS(2138), 1,
      sym_regex_flags,
    ACTIONS(848), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84632] = 11,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(886), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [84684] = 12,
    ACTIONS(1161), 1,
      sym__if_else_separator,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1159), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [84738] = 12,
    ACTIONS(1179), 1,
      sym__if_else_separator,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [84792] = 3,
    ACTIONS(674), 1,
      sym__if_else_separator,
    ACTIONS(1319), 1,
      sym_concatenating_space,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84828] = 12,
    ACTIONS(1183), 1,
      sym__if_else_separator,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1181), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [84882] = 4,
    ACTIONS(716), 1,
      sym_concatenating_space,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2186), 1,
      anon_sym_LT,
    ACTIONS(714), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84920] = 12,
    ACTIONS(83), 1,
      sym__if_else_separator,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(41), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [84974] = 3,
    ACTIONS(860), 1,
      sym_concatenating_space,
    ACTIONS(2140), 1,
      sym_regex_flags,
    ACTIONS(856), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85010] = 12,
    ACTIONS(1187), 1,
      sym__if_else_separator,
    ACTIONS(2106), 1,
      anon_sym_in,
    ACTIONS(2112), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2124), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2114), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2118), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2120), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2116), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2108), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1185), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [85064] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2098), 1,
      anon_sym_LBRACK,
    ACTIONS(2212), 1,
      anon_sym_LT,
    ACTIONS(714), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85102] = 12,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(916), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2110), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(912), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [85156] = 5,
    ACTIONS(910), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85196] = 3,
    ACTIONS(860), 1,
      sym__if_else_separator,
    ACTIONS(2136), 1,
      sym_regex_flags,
    ACTIONS(856), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85232] = 3,
    ACTIONS(852), 1,
      sym__if_else_separator,
    ACTIONS(2134), 1,
      sym_regex_flags,
    ACTIONS(848), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85268] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(716), 22,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [85306] = 7,
    ACTIONS(874), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 12,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85350] = 5,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85390] = 3,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85426] = 4,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85464] = 9,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
  [85512] = 6,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85554] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LT,
    ACTIONS(714), 4,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(716), 22,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [85594] = 8,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(780), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85640] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(724), 22,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [85678] = 4,
    ACTIONS(716), 1,
      sym__if_else_separator,
    ACTIONS(2080), 1,
      anon_sym_LBRACK,
    ACTIONS(2188), 1,
      anon_sym_LT,
    ACTIONS(714), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85716] = 7,
    ACTIONS(890), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 12,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85760] = 11,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(900), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [85812] = 11,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(896), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [85864] = 11,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(906), 2,
      sym_concatenating_space,
      sym__if_else_separator,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [85916] = 5,
    ACTIONS(910), 1,
      sym_concatenating_space,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(908), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85955] = 12,
    ACTIONS(916), 1,
      sym_concatenating_space,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2178), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(912), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [86008] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2236), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(724), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [86045] = 2,
    ACTIONS(1441), 1,
      sym_concatenating_space,
    ACTIONS(666), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86078] = 3,
    ACTIONS(2238), 1,
      sym_regex_flags,
    ACTIONS(848), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(852), 22,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [86113] = 2,
    ACTIONS(2170), 1,
      sym_regex_flags,
    ACTIONS(848), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86146] = 3,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(724), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [86181] = 12,
    ACTIONS(916), 1,
      sym__if_else_separator,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(912), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [86234] = 3,
    ACTIONS(2240), 1,
      sym_regex_flags,
    ACTIONS(856), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(860), 22,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [86269] = 4,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_LT,
    ACTIONS(714), 3,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(716), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [86306] = 3,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(716), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [86341] = 11,
    ACTIONS(906), 1,
      sym_concatenating_space,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(904), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [86392] = 11,
    ACTIONS(900), 1,
      sym_concatenating_space,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(898), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [86443] = 11,
    ACTIONS(896), 1,
      sym_concatenating_space,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(894), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [86494] = 11,
    ACTIONS(886), 1,
      sym_concatenating_space,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(876), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [86545] = 7,
    ACTIONS(890), 1,
      sym_concatenating_space,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(888), 12,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86588] = 5,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2236), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_LT,
    ACTIONS(714), 4,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(716), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [86627] = 9,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
  [86674] = 8,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86719] = 6,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(778), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86760] = 4,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2236), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 5,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(716), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [86797] = 4,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86834] = 3,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86869] = 5,
    ACTIONS(780), 1,
      sym_concatenating_space,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86908] = 7,
    ACTIONS(874), 1,
      sym_concatenating_space,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(862), 12,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86951] = 11,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1185), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [87002] = 12,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(1113), 1,
      sym__if_else_separator,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 5,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1111), 8,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [87055] = 12,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(1109), 1,
      sym__if_else_separator,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1105), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [87108] = 11,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1159), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [87159] = 3,
    ACTIONS(2098), 1,
      anon_sym_LBRACK,
    ACTIONS(2212), 1,
      anon_sym_LT,
    ACTIONS(714), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87194] = 11,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1177), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [87245] = 2,
    ACTIONS(2166), 1,
      sym_regex_flags,
    ACTIONS(856), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87278] = 2,
    ACTIONS(742), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(744), 24,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [87311] = 2,
    ACTIONS(718), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(720), 24,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [87344] = 11,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1181), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [87395] = 11,
    ACTIONS(2158), 1,
      anon_sym_in,
    ACTIONS(2160), 1,
      anon_sym_QMARK,
    ACTIONS(2162), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2164), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2150), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2156), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2152), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2148), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(41), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [87446] = 5,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(778), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
    ACTIONS(780), 19,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [87484] = 2,
    ACTIONS(844), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(846), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [87516] = 2,
    ACTIONS(1997), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_while,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(1999), 14,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [87548] = 2,
    ACTIONS(790), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(792), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [87580] = 13,
    ACTIONS(904), 1,
      anon_sym_PIPE,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(906), 7,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_RBRACK,
  [87634] = 2,
    ACTIONS(742), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(744), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [87666] = 11,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(912), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [87716] = 13,
    ACTIONS(898), 1,
      anon_sym_PIPE,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(900), 7,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_RBRACK,
  [87770] = 2,
    ACTIONS(798), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(800), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [87802] = 13,
    ACTIONS(894), 1,
      anon_sym_PIPE,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(896), 7,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_RBRACK,
  [87856] = 2,
    ACTIONS(1993), 13,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_while,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(1995), 14,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [87888] = 4,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    STATE(1673), 1,
      sym_block,
    ACTIONS(2268), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(2266), 13,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [87924] = 13,
    ACTIONS(876), 1,
      anon_sym_PIPE,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(886), 7,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_RBRACK,
  [87978] = 2,
    ACTIONS(794), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(796), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88010] = 9,
    ACTIONS(888), 1,
      anon_sym_PIPE,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(890), 11,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88056] = 3,
    ACTIONS(2270), 1,
      sym_regex_flags,
    ACTIONS(856), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(860), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88090] = 2,
    ACTIONS(762), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(764), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88122] = 4,
    ACTIONS(2236), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_LT,
    ACTIONS(714), 3,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(716), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88158] = 3,
    ACTIONS(2236), 1,
      anon_sym_LBRACK,
    ACTIONS(714), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(716), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88192] = 2,
    ACTIONS(718), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(720), 23,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [88224] = 2,
    ACTIONS(836), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(838), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88256] = 11,
    ACTIONS(778), 1,
      anon_sym_PIPE,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(780), 9,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88306] = 10,
    ACTIONS(778), 1,
      anon_sym_PIPE,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(780), 10,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88354] = 8,
    ACTIONS(778), 1,
      anon_sym_PIPE,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(780), 13,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88398] = 11,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1105), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [88448] = 2,
    ACTIONS(778), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(780), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88480] = 2,
    ACTIONS(806), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(808), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88512] = 2,
    ACTIONS(802), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(804), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88544] = 2,
    ACTIONS(722), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(724), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88576] = 6,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(778), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
    ACTIONS(780), 17,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88616] = 9,
    ACTIONS(862), 1,
      anon_sym_PIPE,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(874), 11,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88662] = 2,
    ACTIONS(816), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(818), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88694] = 2,
    ACTIONS(812), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(814), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88726] = 2,
    ACTIONS(824), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(826), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88758] = 2,
    ACTIONS(828), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(830), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88790] = 2,
    ACTIONS(786), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(788), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88822] = 2,
    ACTIONS(806), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(808), 15,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [88854] = 11,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2226), 5,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1111), 8,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
  [88904] = 3,
    ACTIONS(1727), 1,
      sym_concatenating_space,
    ACTIONS(666), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(674), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [88938] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2272), 1,
      anon_sym_PIPE,
    ACTIONS(2274), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(916), 6,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [88994] = 2,
    ACTIONS(820), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(822), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89026] = 3,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(778), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(780), 21,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89060] = 2,
    ACTIONS(790), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(792), 15,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [89092] = 2,
    ACTIONS(782), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(784), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89124] = 2,
    ACTIONS(766), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(768), 23,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89156] = 3,
    ACTIONS(2236), 1,
      anon_sym_LBRACK,
    ACTIONS(722), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(724), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89190] = 3,
    ACTIONS(666), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(686), 6,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(674), 17,
      anon_sym_in,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [89224] = 3,
    ACTIONS(2276), 1,
      sym_regex_flags,
    ACTIONS(848), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(852), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89258] = 6,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(908), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
    ACTIONS(910), 17,
      sym_concatenating_space,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89298] = 2,
    ACTIONS(2280), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(2278), 14,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [89329] = 2,
    ACTIONS(786), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(788), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89360] = 2,
    ACTIONS(762), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(764), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89391] = 2,
    ACTIONS(2284), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(2282), 14,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [89422] = 2,
    ACTIONS(816), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(818), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89453] = 2,
    ACTIONS(794), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(796), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89484] = 2,
    ACTIONS(844), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(846), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89515] = 2,
    ACTIONS(722), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(724), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89546] = 2,
    ACTIONS(828), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(830), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89577] = 2,
    ACTIONS(782), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(784), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89608] = 2,
    ACTIONS(766), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(768), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89639] = 2,
    ACTIONS(824), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(826), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89670] = 2,
    ACTIONS(812), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(814), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [89701] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(916), 5,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [89756] = 2,
    ACTIONS(2292), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(2290), 14,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [89787] = 2,
    ACTIONS(1249), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(1247), 14,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [89818] = 12,
    ACTIONS(1187), 1,
      sym__if_else_separator,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1185), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [89869] = 12,
    ACTIONS(1179), 1,
      sym__if_else_separator,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1177), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [89920] = 12,
    ACTIONS(1183), 1,
      sym__if_else_separator,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1181), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [89971] = 2,
    ACTIONS(836), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_STAR,
    ACTIONS(838), 22,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_PIPE_AMP,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
  [90002] = 12,
    ACTIONS(83), 1,
      sym__if_else_separator,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(41), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90053] = 2,
    ACTIONS(2296), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(2294), 14,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [90084] = 12,
    ACTIONS(1161), 1,
      sym__if_else_separator,
    ACTIONS(2194), 1,
      anon_sym_in,
    ACTIONS(2198), 1,
      anon_sym_QMARK,
    ACTIONS(2208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2172), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2200), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2204), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2206), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2202), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1159), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2196), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90135] = 2,
    ACTIONS(2268), 12,
      anon_sym_BEGIN,
      anon_sym_END,
      anon_sym_BEGINFILE,
      anon_sym_ENDFILE,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_AT,
      sym_identifier,
      aux_sym_number_token1,
      anon_sym_function,
      anon_sym_func,
    ACTIONS(2266), 14,
      ts_builtin_sym_end,
      anon_sym_ATinclude,
      anon_sym_ATload,
      anon_sym_ATnamespace,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
      anon_sym_POUND,
  [90166] = 11,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1181), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90214] = 11,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(41), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90262] = 11,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1185), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90310] = 11,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1159), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90358] = 11,
    ACTIONS(2224), 1,
      anon_sym_in,
    ACTIONS(2228), 1,
      anon_sym_QMARK,
    ACTIONS(2232), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2234), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2190), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(2218), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2230), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2220), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1177), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
    ACTIONS(2226), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90406] = 16,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2298), 1,
      anon_sym_COMMA,
    ACTIONS(2300), 1,
      anon_sym_RPAREN,
    STATE(2024), 1,
      aux_sym_args_repeat1,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90463] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(1109), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90518] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2304), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90572] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2306), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90626] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2308), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90680] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2310), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90734] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2312), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90788] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2314), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90840] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2316), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90894] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2318), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [90948] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2320), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91002] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2322), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91056] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2324), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91110] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2326), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91164] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2328), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91218] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2330), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91272] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2332), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91326] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2334), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91380] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2336), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91434] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2338), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91488] = 15,
    ACTIONS(1113), 1,
      anon_sym_RPAREN,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91542] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2340), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91596] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2342), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91650] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2344), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91704] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2346), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91758] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2348), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91812] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2350), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91866] = 15,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2352), 1,
      anon_sym_RBRACK,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91920] = 15,
    ACTIONS(1113), 1,
      anon_sym_RPAREN,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [91974] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2354), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92025] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2356), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92076] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2358), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92127] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2360), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92178] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2362), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92229] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2364), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92280] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2366), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92331] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2368), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92382] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2370), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92433] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2372), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92484] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2374), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92535] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2376), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92586] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2378), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92637] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2380), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92688] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2382), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92739] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2384), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92790] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2386), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92841] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2388), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92892] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2390), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92943] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2392), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [92994] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2394), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93045] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93096] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2396), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93147] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2398), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93198] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2400), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93249] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2402), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93300] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2404), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93351] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2406), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93402] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2408), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93453] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2410), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93504] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2412), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93555] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2414), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93606] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2416), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93657] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2418), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93708] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2420), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93759] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2422), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93810] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2424), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93861] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2426), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93912] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2428), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [93963] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2430), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94014] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2432), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94065] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2434), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94116] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2436), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94167] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2438), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94218] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2440), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94269] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2442), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94320] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2444), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94371] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2446), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94422] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94473] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2450), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94524] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2452), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94575] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2454), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94626] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2456), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94677] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2458), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94728] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2460), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94779] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2462), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94830] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2464), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94881] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2466), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94932] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2468), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [94983] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2470), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95034] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2472), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95085] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2474), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95136] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2476), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95187] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2478), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95238] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2480), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95289] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2482), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95340] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2484), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95391] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2486), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95442] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2488), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95493] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2490), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95544] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2492), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95595] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2494), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95646] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2496), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95697] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2498), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95748] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2500), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95799] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2502), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95850] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2504), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95901] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2506), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [95952] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2508), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96003] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2510), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96054] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2512), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96105] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2514), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96156] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2516), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96207] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2518), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96258] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2520), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96309] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2522), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96360] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2524), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96411] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2526), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96462] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2528), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96513] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2530), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96564] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2532), 1,
      anon_sym_SEMI,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96615] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2534), 1,
      anon_sym_COLON,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96666] = 14,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2536), 1,
      anon_sym_RPAREN,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96717] = 13,
    ACTIONS(1153), 1,
      anon_sym_STAR,
    ACTIONS(1167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1173), 1,
      anon_sym_QMARK,
    ACTIONS(1175), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2538), 1,
      anon_sym_in,
    ACTIONS(1147), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1151), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1165), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2540), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1157), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96765] = 13,
    ACTIONS(928), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2544), 1,
      anon_sym_in,
    ACTIONS(2546), 1,
      anon_sym_QMARK,
    ACTIONS(2558), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2560), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(920), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2552), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2556), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2554), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96813] = 13,
    ACTIONS(2116), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2562), 1,
      anon_sym_in,
    ACTIONS(2564), 1,
      anon_sym_QMARK,
    ACTIONS(2576), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2108), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2566), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2568), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2574), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2572), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96861] = 13,
    ACTIONS(2246), 1,
      anon_sym_STAR,
    ACTIONS(2250), 1,
      anon_sym_in,
    ACTIONS(2254), 1,
      anon_sym_QMARK,
    ACTIONS(2262), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2244), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2248), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2256), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2260), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2258), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96909] = 13,
    ACTIONS(1123), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2580), 1,
      anon_sym_in,
    ACTIONS(2582), 1,
      anon_sym_QMARK,
    ACTIONS(2594), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2596), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1117), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2584), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2586), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2588), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2592), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2590), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [96957] = 13,
    ACTIONS(2152), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2598), 1,
      anon_sym_in,
    ACTIONS(2600), 1,
      anon_sym_QMARK,
    ACTIONS(2612), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2614), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2148), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2602), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2604), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2610), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2608), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97005] = 13,
    ACTIONS(1215), 1,
      anon_sym_STAR,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
    ACTIONS(1237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1239), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2616), 1,
      anon_sym_in,
    ACTIONS(1213), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(1217), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1225), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1235), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2618), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1233), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97053] = 13,
    ACTIONS(1821), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2620), 1,
      anon_sym_in,
    ACTIONS(2622), 1,
      anon_sym_QMARK,
    ACTIONS(2634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1817), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2624), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2626), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2628), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2632), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2630), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97101] = 13,
    ACTIONS(2202), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2638), 1,
      anon_sym_in,
    ACTIONS(2640), 1,
      anon_sym_QMARK,
    ACTIONS(2652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2196), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2642), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2644), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2646), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2650), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2648), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97149] = 13,
    ACTIONS(2007), 1,
      anon_sym_STAR,
    ACTIONS(2017), 1,
      anon_sym_in,
    ACTIONS(2019), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2021), 1,
      anon_sym_QMARK,
    ACTIONS(2023), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2001), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2005), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2013), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2656), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2658), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2011), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97197] = 13,
    ACTIONS(1475), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2660), 1,
      anon_sym_in,
    ACTIONS(2662), 1,
      anon_sym_QMARK,
    ACTIONS(2674), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1469), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2664), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2666), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2668), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2672), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2670), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97245] = 13,
    ACTIONS(1307), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2678), 1,
      anon_sym_in,
    ACTIONS(2680), 1,
      anon_sym_QMARK,
    ACTIONS(2692), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1301), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2682), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2684), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2690), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2688), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97293] = 13,
    ACTIONS(1053), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2696), 1,
      anon_sym_in,
    ACTIONS(2698), 1,
      anon_sym_QMARK,
    ACTIONS(2710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2712), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1049), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2700), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2702), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2704), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2708), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2706), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97341] = 13,
    ACTIONS(1871), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2714), 1,
      anon_sym_in,
    ACTIONS(2716), 1,
      anon_sym_QMARK,
    ACTIONS(2728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1865), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2718), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2720), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2726), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2724), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97389] = 13,
    ACTIONS(868), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2732), 1,
      anon_sym_in,
    ACTIONS(2734), 1,
      anon_sym_QMARK,
    ACTIONS(2746), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2748), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(864), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2736), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2738), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2740), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2744), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2742), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97437] = 13,
    ACTIONS(2220), 1,
      anon_sym_STAR,
    ACTIONS(2286), 1,
      anon_sym_PIPE,
    ACTIONS(2288), 1,
      anon_sym_PIPE_AMP,
    ACTIONS(2750), 1,
      anon_sym_in,
    ACTIONS(2752), 1,
      anon_sym_QMARK,
    ACTIONS(2764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2226), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2754), 2,
      anon_sym_CARET,
      anon_sym_STAR_STAR,
    ACTIONS(2756), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2758), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2762), 2,
      anon_sym_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2760), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [97485] = 2,
    ACTIONS(2768), 5,
      anon_sym_getline,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_identifier,
      aux_sym_number_token1,
    ACTIONS(2770), 9,
      anon_sym_LPAREN,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_number_token2,
      anon_sym_DQUOTE,
  [97504] = 4,
    ACTIONS(1767), 1,
      sym__if_else_separator,
    ACTIONS(2772), 2,
      anon_sym_GT,
      anon_sym_GT_GT,
    ACTIONS(2774), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1761), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97525] = 1,
    ACTIONS(2776), 12,
      anon_sym_print,
      anon_sym_alnum,
      anon_sym_alpha,
      anon_sym_blank,
      anon_sym_cntrl,
      anon_sym_digit,
      anon_sym_graph,
      anon_sym_lower,
      anon_sym_punct,
      anon_sym_space,
      anon_sym_upper,
      anon_sym_xdigit,
  [97540] = 3,
    ACTIONS(2778), 2,
      anon_sym_GT,
      anon_sym_GT_GT,
    ACTIONS(2780), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1761), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97558] = 4,
    ACTIONS(1767), 1,
      sym__if_else_separator,
    ACTIONS(2782), 2,
      anon_sym_GT,
      anon_sym_GT_GT,
    ACTIONS(2784), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1761), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [97576] = 3,
    ACTIONS(2786), 2,
      anon_sym_GT,
      anon_sym_GT_GT,
    ACTIONS(2788), 2,
      anon_sym_PIPE,
      anon_sym_PIPE_AMP,
    ACTIONS(1761), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [97591] = 5,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(2790), 1,
      anon_sym_RBRACE,
    ACTIONS(2792), 1,
      anon_sym_case,
    ACTIONS(2794), 1,
      anon_sym_default,
    STATE(1847), 4,
      sym_switch_case,
      sym_switch_default,
      sym_comment,
      aux_sym_switch_body_repeat1,
  [97610] = 2,
    ACTIONS(2796), 1,
      sym__if_else_separator,
    ACTIONS(2044), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97623] = 2,
    ACTIONS(2798), 1,
      sym__if_else_separator,
    ACTIONS(2044), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97636] = 2,
    ACTIONS(2796), 1,
      sym__if_else_separator,
    ACTIONS(2044), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97649] = 5,
    ACTIONS(2800), 1,
      anon_sym_RBRACE,
    ACTIONS(2802), 1,
      anon_sym_case,
    ACTIONS(2805), 1,
      anon_sym_default,
    ACTIONS(2808), 1,
      anon_sym_POUND,
    STATE(1847), 4,
      sym_switch_case,
      sym_switch_default,
      sym_comment,
      aux_sym_switch_body_repeat1,
  [97668] = 2,
    ACTIONS(2811), 1,
      sym__if_else_separator,
    ACTIONS(2064), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97681] = 5,
    ACTIONS(2813), 1,
      anon_sym_SLASH,
    ACTIONS(2815), 1,
      aux_sym_number_token1,
    ACTIONS(2817), 1,
      aux_sym_number_token2,
    ACTIONS(2819), 1,
      anon_sym_DQUOTE,
    STATE(2184), 4,
      sym_regex,
      sym__primitive,
      sym_number,
      sym_string,
  [97700] = 5,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(2792), 1,
      anon_sym_case,
    ACTIONS(2794), 1,
      anon_sym_default,
    ACTIONS(2821), 1,
      anon_sym_RBRACE,
    STATE(1853), 4,
      sym_switch_case,
      sym_switch_default,
      sym_comment,
      aux_sym_switch_body_repeat1,
  [97719] = 2,
    ACTIONS(2798), 1,
      sym__if_else_separator,
    ACTIONS(2044), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97732] = 2,
    ACTIONS(2811), 1,
      sym__if_else_separator,
    ACTIONS(2064), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97745] = 5,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(2792), 1,
      anon_sym_case,
    ACTIONS(2794), 1,
      anon_sym_default,
    ACTIONS(2823), 1,
      anon_sym_RBRACE,
    STATE(1847), 4,
      sym_switch_case,
      sym_switch_default,
      sym_comment,
      aux_sym_switch_body_repeat1,
  [97764] = 5,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(2792), 1,
      anon_sym_case,
    ACTIONS(2794), 1,
      anon_sym_default,
    ACTIONS(2825), 1,
      anon_sym_RBRACE,
    STATE(1843), 4,
      sym_switch_case,
      sym_switch_default,
      sym_comment,
      aux_sym_switch_body_repeat1,
  [97783] = 2,
    ACTIONS(2827), 1,
      sym__if_else_separator,
    ACTIONS(2064), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97796] = 2,
    ACTIONS(2827), 1,
      sym__if_else_separator,
    ACTIONS(2064), 7,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97809] = 5,
    ACTIONS(2829), 1,
      anon_sym_SLASH2,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    STATE(2220), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [97827] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2835), 1,
      anon_sym_SLASH2,
    STATE(2196), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [97845] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2837), 1,
      anon_sym_SLASH2,
    STATE(2265), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [97863] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2839), 1,
      anon_sym_SLASH2,
    STATE(2266), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [97881] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(510), 4,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97893] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2841), 1,
      anon_sym_SLASH2,
    STATE(2267), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [97911] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2843), 1,
      anon_sym_SLASH2,
    STATE(2250), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [97929] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2845), 1,
      anon_sym_SLASH2,
    STATE(2269), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [97947] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(2847), 4,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [97959] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2849), 1,
      anon_sym_SLASH2,
    STATE(2244), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [97977] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2851), 1,
      anon_sym_SLASH2,
    STATE(2157), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [97995] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2853), 1,
      anon_sym_SLASH2,
    STATE(2129), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98013] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2855), 1,
      anon_sym_SLASH2,
    STATE(2175), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98031] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2857), 1,
      anon_sym_SLASH2,
    STATE(2173), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98049] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2859), 1,
      anon_sym_SLASH2,
    STATE(2179), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98067] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2861), 1,
      anon_sym_SLASH2,
    STATE(2226), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98085] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2863), 1,
      anon_sym_SLASH2,
    STATE(2202), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98103] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2865), 1,
      anon_sym_SLASH2,
    STATE(2238), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98121] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2867), 1,
      anon_sym_SLASH2,
    STATE(2088), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98139] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2869), 1,
      anon_sym_SLASH2,
    STATE(2189), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98157] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2871), 1,
      anon_sym_SLASH2,
    STATE(2232), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98175] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2873), 1,
      anon_sym_SLASH2,
    STATE(2195), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98193] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(556), 4,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [98205] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2875), 1,
      anon_sym_SLASH2,
    STATE(2145), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98223] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2877), 1,
      anon_sym_SLASH2,
    STATE(2126), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98241] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2879), 1,
      anon_sym_SLASH2,
    STATE(2163), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98259] = 2,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
    ACTIONS(2881), 4,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_POUND,
  [98271] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2883), 1,
      anon_sym_SLASH2,
    STATE(2190), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98289] = 5,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2885), 1,
      anon_sym_SLASH2,
    STATE(2144), 1,
      sym_regex_pattern,
    ACTIONS(2831), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1917), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98307] = 6,
    ACTIONS(1609), 1,
      anon_sym_SLASH,
    ACTIONS(2887), 1,
      sym_identifier,
    STATE(450), 1,
      sym_func_call,
    STATE(469), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2233), 1,
      sym_ns_qualified_name,
  [98326] = 6,
    ACTIONS(1407), 1,
      anon_sym_SLASH,
    ACTIONS(2889), 1,
      sym_identifier,
    STATE(1652), 1,
      sym_regex,
    STATE(1653), 1,
      sym_func_call,
    STATE(2212), 1,
      sym_namespace,
    STATE(2227), 1,
      sym_ns_qualified_name,
  [98345] = 5,
    ACTIONS(2891), 1,
      sym_identifier,
    ACTIONS(2893), 1,
      anon_sym_DOLLAR,
    STATE(579), 1,
      sym_field_ref,
    STATE(2228), 1,
      sym_namespace,
    STATE(538), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98362] = 6,
    ACTIONS(370), 1,
      anon_sym_SLASH,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1514), 1,
      sym_regex,
    STATE(1524), 1,
      sym_func_call,
    STATE(2212), 1,
      sym_namespace,
    STATE(2230), 1,
      sym_ns_qualified_name,
  [98381] = 5,
    ACTIONS(2897), 1,
      sym_identifier,
    ACTIONS(2899), 1,
      anon_sym_DOLLAR,
    STATE(593), 1,
      sym_field_ref,
    STATE(2185), 1,
      sym_namespace,
    STATE(555), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98398] = 5,
    ACTIONS(1337), 1,
      anon_sym_DOLLAR,
    ACTIONS(2901), 1,
      sym_identifier,
    STATE(338), 1,
      sym_field_ref,
    STATE(2231), 1,
      sym_namespace,
    STATE(310), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98415] = 6,
    ACTIONS(17), 1,
      anon_sym_SLASH,
    ACTIONS(2903), 1,
      sym_identifier,
    STATE(594), 1,
      sym_regex,
    STATE(595), 1,
      sym_func_call,
    STATE(2182), 1,
      sym_ns_qualified_name,
    STATE(2212), 1,
      sym_namespace,
  [98434] = 6,
    ACTIONS(1461), 1,
      anon_sym_SLASH,
    ACTIONS(2905), 1,
      sym_identifier,
    STATE(571), 1,
      sym_func_call,
    STATE(572), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2215), 1,
      sym_ns_qualified_name,
  [98453] = 5,
    ACTIONS(394), 1,
      anon_sym_DOLLAR,
    ACTIONS(2907), 1,
      sym_identifier,
    STATE(205), 1,
      sym_field_ref,
    STATE(2256), 1,
      sym_namespace,
    STATE(179), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98470] = 5,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(2909), 1,
      sym_identifier,
    STATE(240), 1,
      sym_field_ref,
    STATE(2243), 1,
      sym_namespace,
    STATE(192), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98487] = 5,
    ACTIONS(202), 1,
      anon_sym_DOLLAR,
    ACTIONS(2909), 1,
      sym_identifier,
    STATE(240), 1,
      sym_field_ref,
    STATE(2243), 1,
      sym_namespace,
    STATE(192), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98504] = 5,
    ACTIONS(2911), 1,
      sym_identifier,
    ACTIONS(2913), 1,
      anon_sym_DOLLAR,
    STATE(461), 1,
      sym_field_ref,
    STATE(2240), 1,
      sym_namespace,
    STATE(395), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98521] = 5,
    ACTIONS(2915), 1,
      sym_identifier,
    ACTIONS(2917), 1,
      anon_sym_DOLLAR,
    STATE(1456), 1,
      sym_field_ref,
    STATE(2246), 1,
      sym_namespace,
    STATE(1439), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98538] = 6,
    ACTIONS(1625), 1,
      anon_sym_SLASH,
    ACTIONS(2919), 1,
      sym_identifier,
    STATE(224), 1,
      sym_func_call,
    STATE(238), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2236), 1,
      sym_ns_qualified_name,
  [98557] = 5,
    ACTIONS(2921), 1,
      sym_identifier,
    ACTIONS(2923), 1,
      anon_sym_DOLLAR,
    STATE(464), 1,
      sym_field_ref,
    STATE(2252), 1,
      sym_namespace,
    STATE(366), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98574] = 6,
    ACTIONS(1519), 1,
      anon_sym_SLASH,
    ACTIONS(2925), 1,
      sym_identifier,
    STATE(1483), 1,
      sym_func_call,
    STATE(1487), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2239), 1,
      sym_ns_qualified_name,
  [98593] = 6,
    ACTIONS(1423), 1,
      anon_sym_SLASH,
    ACTIONS(2927), 1,
      sym_identifier,
    STATE(328), 1,
      sym_regex,
    STATE(345), 1,
      sym_func_call,
    STATE(2212), 1,
      sym_namespace,
    STATE(2223), 1,
      sym_ns_qualified_name,
  [98612] = 6,
    ACTIONS(194), 1,
      anon_sym_SLASH,
    ACTIONS(2929), 1,
      sym_identifier,
    STATE(481), 1,
      sym_func_call,
    STATE(486), 1,
      sym_regex,
    STATE(2188), 1,
      sym_ns_qualified_name,
    STATE(2212), 1,
      sym_namespace,
  [98631] = 5,
    ACTIONS(2931), 1,
      sym_identifier,
    ACTIONS(2933), 1,
      anon_sym_DOLLAR,
    STATE(377), 1,
      sym_field_ref,
    STATE(2255), 1,
      sym_namespace,
    STATE(336), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98648] = 5,
    ACTIONS(378), 1,
      anon_sym_DOLLAR,
    ACTIONS(2909), 1,
      sym_identifier,
    STATE(240), 1,
      sym_field_ref,
    STATE(2243), 1,
      sym_namespace,
    STATE(192), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98665] = 6,
    ACTIONS(1547), 1,
      anon_sym_SLASH,
    ACTIONS(2919), 1,
      sym_identifier,
    STATE(224), 1,
      sym_func_call,
    STATE(238), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2236), 1,
      sym_ns_qualified_name,
  [98684] = 5,
    ACTIONS(25), 1,
      anon_sym_DOLLAR,
    ACTIONS(2901), 1,
      sym_identifier,
    STATE(338), 1,
      sym_field_ref,
    STATE(2231), 1,
      sym_namespace,
    STATE(310), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98701] = 5,
    ACTIONS(2935), 1,
      sym_identifier,
    ACTIONS(2937), 1,
      anon_sym_DOLLAR,
    STATE(479), 1,
      sym_field_ref,
    STATE(2225), 1,
      sym_namespace,
    STATE(449), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98718] = 5,
    ACTIONS(2939), 1,
      sym_identifier,
    ACTIONS(2941), 1,
      anon_sym_DOLLAR,
    STATE(1539), 1,
      sym_field_ref,
    STATE(2237), 1,
      sym_namespace,
    STATE(1501), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98735] = 5,
    ACTIONS(2915), 1,
      sym_identifier,
    ACTIONS(2943), 1,
      anon_sym_DOLLAR,
    STATE(1456), 1,
      sym_field_ref,
    STATE(2246), 1,
      sym_namespace,
    STATE(1439), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98752] = 6,
    ACTIONS(1489), 1,
      anon_sym_SLASH,
    ACTIONS(2945), 1,
      sym_identifier,
    STATE(210), 1,
      sym_func_call,
    STATE(212), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2248), 1,
      sym_ns_qualified_name,
  [98771] = 5,
    ACTIONS(462), 1,
      anon_sym_DOLLAR,
    ACTIONS(2907), 1,
      sym_identifier,
    STATE(205), 1,
      sym_field_ref,
    STATE(2256), 1,
      sym_namespace,
    STATE(179), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98788] = 5,
    ACTIONS(2939), 1,
      sym_identifier,
    ACTIONS(2947), 1,
      anon_sym_DOLLAR,
    STATE(1539), 1,
      sym_field_ref,
    STATE(2237), 1,
      sym_namespace,
    STATE(1501), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98805] = 5,
    ACTIONS(2949), 1,
      sym_identifier,
    ACTIONS(2951), 1,
      anon_sym_DOLLAR,
    STATE(1457), 1,
      sym_field_ref,
    STATE(2257), 1,
      sym_namespace,
    STATE(1427), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98822] = 6,
    ACTIONS(1375), 1,
      anon_sym_SLASH,
    ACTIONS(2953), 1,
      sym_identifier,
    STATE(1429), 1,
      sym_regex,
    STATE(1432), 1,
      sym_func_call,
    STATE(2212), 1,
      sym_namespace,
    STATE(2254), 1,
      sym_ns_qualified_name,
  [98841] = 5,
    ACTIONS(2955), 1,
      sym_identifier,
    ACTIONS(2957), 1,
      anon_sym_DOLLAR,
    STATE(1422), 1,
      sym_field_ref,
    STATE(2258), 1,
      sym_namespace,
    STATE(1402), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98858] = 4,
    ACTIONS(2833), 1,
      anon_sym_LBRACK2,
    ACTIONS(2959), 1,
      anon_sym_SLASH2,
    ACTIONS(2961), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1929), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [98873] = 6,
    ACTIONS(1447), 1,
      anon_sym_SLASH,
    ACTIONS(2927), 1,
      sym_identifier,
    STATE(328), 1,
      sym_regex,
    STATE(345), 1,
      sym_func_call,
    STATE(2212), 1,
      sym_namespace,
    STATE(2223), 1,
      sym_ns_qualified_name,
  [98892] = 6,
    ACTIONS(388), 1,
      anon_sym_SLASH,
    ACTIONS(2963), 1,
      sym_identifier,
    STATE(1447), 1,
      sym_func_call,
    STATE(1468), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2251), 1,
      sym_ns_qualified_name,
  [98911] = 5,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(2907), 1,
      sym_identifier,
    STATE(205), 1,
      sym_field_ref,
    STATE(2256), 1,
      sym_namespace,
    STATE(179), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [98928] = 6,
    ACTIONS(328), 1,
      anon_sym_SLASH,
    ACTIONS(2965), 1,
      sym_identifier,
    STATE(423), 1,
      sym_regex,
    STATE(436), 1,
      sym_func_call,
    STATE(2212), 1,
      sym_namespace,
    STATE(2242), 1,
      sym_ns_qualified_name,
  [98947] = 6,
    ACTIONS(1593), 1,
      anon_sym_SLASH,
    ACTIONS(2919), 1,
      sym_identifier,
    STATE(224), 1,
      sym_func_call,
    STATE(238), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2236), 1,
      sym_ns_qualified_name,
  [98966] = 5,
    ACTIONS(2967), 1,
      sym__regex_char,
    ACTIONS(2970), 1,
      sym__regex_char_escaped,
    ACTIONS(2973), 1,
      anon_sym_LBRACK2,
    ACTIONS(2976), 1,
      anon_sym_RBRACK2,
    STATE(1923), 2,
      sym__regex_char_class,
      aux_sym__regex_bracket_exp_repeat1,
  [98983] = 5,
    ACTIONS(2978), 1,
      sym_identifier,
    ACTIONS(2980), 1,
      anon_sym_DOLLAR,
    STATE(1677), 1,
      sym_field_ref,
    STATE(2221), 1,
      sym_namespace,
    STATE(1666), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [99000] = 6,
    ACTIONS(1641), 1,
      anon_sym_SLASH,
    ACTIONS(2925), 1,
      sym_identifier,
    STATE(1483), 1,
      sym_func_call,
    STATE(1487), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2239), 1,
      sym_ns_qualified_name,
  [99019] = 6,
    ACTIONS(1329), 1,
      anon_sym_SLASH,
    ACTIONS(2982), 1,
      sym_identifier,
    STATE(1674), 1,
      sym_regex,
    STATE(1682), 1,
      sym_func_call,
    STATE(2117), 1,
      sym_ns_qualified_name,
    STATE(2212), 1,
      sym_namespace,
  [99038] = 5,
    ACTIONS(2984), 1,
      sym__regex_char,
    ACTIONS(2986), 1,
      sym__regex_char_escaped,
    ACTIONS(2988), 1,
      anon_sym_LBRACK2,
    ACTIONS(2990), 1,
      anon_sym_RBRACK2,
    STATE(1923), 2,
      sym__regex_char_class,
      aux_sym__regex_bracket_exp_repeat1,
  [99055] = 6,
    ACTIONS(280), 1,
      anon_sym_SLASH,
    ACTIONS(2895), 1,
      sym_identifier,
    STATE(1514), 1,
      sym_regex,
    STATE(1524), 1,
      sym_func_call,
    STATE(2212), 1,
      sym_namespace,
    STATE(2230), 1,
      sym_ns_qualified_name,
  [99074] = 4,
    ACTIONS(2992), 1,
      anon_sym_SLASH2,
    ACTIONS(2997), 1,
      anon_sym_LBRACK2,
    ACTIONS(2994), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1929), 2,
      sym__regex_bracket_exp,
      aux_sym_regex_pattern_repeat1,
  [99089] = 5,
    ACTIONS(2949), 1,
      sym_identifier,
    ACTIONS(3000), 1,
      anon_sym_DOLLAR,
    STATE(1457), 1,
      sym_field_ref,
    STATE(2257), 1,
      sym_namespace,
    STATE(1427), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [99106] = 6,
    ACTIONS(1507), 1,
      anon_sym_SLASH,
    ACTIONS(3002), 1,
      sym_identifier,
    STATE(383), 1,
      sym_regex,
    STATE(385), 1,
      sym_func_call,
    STATE(2212), 1,
      sym_namespace,
    STATE(2245), 1,
      sym_ns_qualified_name,
  [99125] = 6,
    ACTIONS(1387), 1,
      anon_sym_SLASH,
    ACTIONS(2945), 1,
      sym_identifier,
    STATE(210), 1,
      sym_func_call,
    STATE(212), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2248), 1,
      sym_ns_qualified_name,
  [99144] = 6,
    ACTIONS(1529), 1,
      anon_sym_SLASH,
    ACTIONS(2953), 1,
      sym_identifier,
    STATE(1429), 1,
      sym_regex,
    STATE(1432), 1,
      sym_func_call,
    STATE(2212), 1,
      sym_namespace,
    STATE(2254), 1,
      sym_ns_qualified_name,
  [99163] = 6,
    ACTIONS(454), 1,
      anon_sym_SLASH,
    ACTIONS(2963), 1,
      sym_identifier,
    STATE(1447), 1,
      sym_func_call,
    STATE(1468), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2251), 1,
      sym_ns_qualified_name,
  [99182] = 5,
    ACTIONS(2955), 1,
      sym_identifier,
    ACTIONS(3004), 1,
      anon_sym_DOLLAR,
    STATE(1422), 1,
      sym_field_ref,
    STATE(2258), 1,
      sym_namespace,
    STATE(1402), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [99199] = 5,
    ACTIONS(3006), 1,
      sym_identifier,
    ACTIONS(3008), 1,
      anon_sym_DOLLAR,
    STATE(1649), 1,
      sym_field_ref,
    STATE(2234), 1,
      sym_namespace,
    STATE(1591), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [99216] = 6,
    ACTIONS(1567), 1,
      anon_sym_SLASH,
    ACTIONS(2945), 1,
      sym_identifier,
    STATE(210), 1,
      sym_func_call,
    STATE(212), 1,
      sym_regex,
    STATE(2212), 1,
      sym_namespace,
    STATE(2248), 1,
      sym_ns_qualified_name,
  [99235] = 2,
    ACTIONS(3010), 1,
      sym__if_else_separator,
    ACTIONS(2044), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [99245] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      anon_sym_else,
    STATE(1351), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99259] = 2,
    ACTIONS(3014), 1,
      sym__if_else_separator,
    ACTIONS(2044), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [99269] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3016), 1,
      anon_sym_else,
    STATE(1268), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99283] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3016), 1,
      anon_sym_else,
    STATE(1252), 1,
      sym_else_clause,
    STATE(1941), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99297] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3018), 1,
      anon_sym_LBRACE,
    STATE(1226), 1,
      sym_switch_body,
    STATE(1973), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99311] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3020), 1,
      anon_sym_else,
    STATE(1345), 1,
      sym_else_clause,
    STATE(1959), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99325] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3022), 1,
      anon_sym_else,
    STATE(1268), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99339] = 2,
    ACTIONS(3024), 1,
      sym__if_else_separator,
    ACTIONS(2064), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [99349] = 3,
    ACTIONS(3026), 1,
      anon_sym_POUND,
    ACTIONS(2035), 2,
      anon_sym_else,
      anon_sym_LBRACE,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99361] = 2,
    ACTIONS(3029), 1,
      sym__if_else_separator,
    ACTIONS(2064), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [99371] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3031), 1,
      anon_sym_else,
    STATE(1268), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99385] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3016), 1,
      anon_sym_else,
    STATE(1252), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99399] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3033), 1,
      anon_sym_else,
    STATE(1351), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99413] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3031), 1,
      anon_sym_else,
    STATE(1252), 1,
      sym_else_clause,
    STATE(1949), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99427] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3031), 1,
      anon_sym_else,
    STATE(1252), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99441] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3035), 1,
      anon_sym_LBRACE,
    STATE(1321), 1,
      sym_switch_body,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99455] = 2,
    ACTIONS(3029), 1,
      sym__if_else_separator,
    ACTIONS(2064), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [99465] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3033), 1,
      anon_sym_else,
    STATE(1351), 1,
      sym_else_clause,
    STATE(1964), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99479] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3020), 1,
      anon_sym_else,
    STATE(1368), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99493] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3020), 1,
      anon_sym_else,
    STATE(1351), 1,
      sym_else_clause,
    STATE(1957), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99507] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3020), 1,
      anon_sym_else,
    STATE(1351), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99521] = 3,
    ACTIONS(2988), 1,
      anon_sym_LBRACK2,
    ACTIONS(3037), 2,
      sym__regex_char,
      sym__regex_char_escaped,
    STATE(1927), 2,
      sym__regex_char_class,
      aux_sym__regex_bracket_exp_repeat1,
  [99533] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      anon_sym_else,
    STATE(1368), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99547] = 2,
    ACTIONS(3024), 1,
      sym__if_else_separator,
    ACTIONS(2064), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [99557] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      anon_sym_else,
    STATE(1345), 1,
      sym_else_clause,
    STATE(1939), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99571] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3033), 1,
      anon_sym_else,
    STATE(1368), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99585] = 2,
    ACTIONS(3010), 1,
      sym__if_else_separator,
    ACTIONS(2044), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [99595] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3035), 1,
      anon_sym_LBRACE,
    STATE(1333), 1,
      sym_switch_body,
    STATE(1954), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99609] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3022), 1,
      anon_sym_else,
    STATE(1236), 1,
      sym_else_clause,
    STATE(1971), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99623] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3033), 1,
      anon_sym_else,
    STATE(1345), 1,
      sym_else_clause,
    STATE(1951), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99637] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3031), 1,
      anon_sym_else,
    STATE(1236), 1,
      sym_else_clause,
    STATE(1953), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99651] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3016), 1,
      anon_sym_else,
    STATE(1236), 1,
      sym_else_clause,
    STATE(1950), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99665] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3022), 1,
      anon_sym_else,
    STATE(1252), 1,
      sym_else_clause,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99679] = 2,
    ACTIONS(3014), 1,
      sym__if_else_separator,
    ACTIONS(2044), 4,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
      anon_sym_while,
  [99689] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3018), 1,
      anon_sym_LBRACE,
    STATE(1235), 1,
      sym_switch_body,
    STATE(1947), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99703] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3022), 1,
      anon_sym_else,
    STATE(1252), 1,
      sym_else_clause,
    STATE(1945), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99717] = 4,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3012), 1,
      anon_sym_else,
    STATE(1351), 1,
      sym_else_clause,
    STATE(1961), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [99731] = 3,
    ACTIONS(3039), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_namespace,
    STATE(2029), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [99742] = 3,
    ACTIONS(3041), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99753] = 3,
    ACTIONS(3045), 1,
      anon_sym_DQUOTE,
    STATE(1990), 1,
      aux_sym_string_repeat1,
    ACTIONS(3047), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99764] = 3,
    ACTIONS(3049), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_namespace,
    STATE(2037), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [99775] = 3,
    ACTIONS(3051), 1,
      anon_sym_DQUOTE,
    STATE(2002), 1,
      aux_sym_string_repeat1,
    ACTIONS(3053), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99786] = 2,
    ACTIONS(3055), 1,
      anon_sym_while,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
  [99795] = 3,
    ACTIONS(3057), 1,
      anon_sym_DQUOTE,
    STATE(1983), 1,
      aux_sym_string_repeat1,
    ACTIONS(3059), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99806] = 3,
    ACTIONS(3061), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99817] = 2,
    ACTIONS(3063), 1,
      sym__regex_char,
    ACTIONS(3065), 3,
      sym__regex_char_escaped,
      anon_sym_LBRACK2,
      anon_sym_RBRACK2,
  [99826] = 3,
    ACTIONS(3067), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_namespace,
    STATE(2068), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [99837] = 3,
    ACTIONS(3069), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99848] = 3,
    ACTIONS(3071), 1,
      anon_sym_DQUOTE,
    STATE(1986), 1,
      aux_sym_string_repeat1,
    ACTIONS(3073), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99859] = 3,
    ACTIONS(3075), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_namespace,
    STATE(2067), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [99870] = 2,
    ACTIONS(3077), 1,
      anon_sym_while,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
  [99879] = 3,
    ACTIONS(3079), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99890] = 3,
    ACTIONS(3081), 1,
      anon_sym_DQUOTE,
    STATE(1994), 1,
      aux_sym_string_repeat1,
    ACTIONS(3083), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99901] = 3,
    ACTIONS(3085), 1,
      anon_sym_DQUOTE,
    STATE(1998), 1,
      aux_sym_string_repeat1,
    ACTIONS(3087), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99912] = 3,
    ACTIONS(3089), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_namespace,
    STATE(2040), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [99923] = 3,
    ACTIONS(3091), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99934] = 3,
    ACTIONS(3093), 1,
      anon_sym_DQUOTE,
    STATE(1997), 1,
      aux_sym_string_repeat1,
    ACTIONS(3095), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99945] = 1,
    ACTIONS(3097), 4,
      anon_sym_SLASH2,
      sym__regex_char,
      sym__regex_char_escaped,
      anon_sym_LBRACK2,
  [99952] = 3,
    ACTIONS(3099), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99963] = 3,
    ACTIONS(3101), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99974] = 3,
    ACTIONS(3103), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3105), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99985] = 3,
    ACTIONS(3108), 1,
      anon_sym_DQUOTE,
    STATE(2007), 1,
      aux_sym_string_repeat1,
    ACTIONS(3110), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [99996] = 3,
    ACTIONS(3112), 1,
      anon_sym_DQUOTE,
    STATE(1977), 1,
      aux_sym_string_repeat1,
    ACTIONS(3114), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [100007] = 3,
    ACTIONS(3116), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [100018] = 3,
    ACTIONS(3118), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [100029] = 3,
    ACTIONS(3120), 1,
      sym_identifier,
    STATE(2252), 1,
      sym_namespace,
    STATE(1163), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [100040] = 2,
    ACTIONS(3122), 1,
      anon_sym_while,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
  [100049] = 3,
    ACTIONS(3124), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_namespace,
    STATE(2053), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [100060] = 3,
    ACTIONS(3126), 1,
      anon_sym_DQUOTE,
    STATE(1999), 1,
      aux_sym_string_repeat1,
    ACTIONS(3043), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [100071] = 3,
    ACTIONS(3128), 1,
      anon_sym_DQUOTE,
    STATE(2003), 1,
      aux_sym_string_repeat1,
    ACTIONS(3130), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [100082] = 3,
    ACTIONS(3132), 1,
      sym_identifier,
    STATE(2225), 1,
      sym_namespace,
    STATE(1266), 2,
      sym_array_ref,
      sym_ns_qualified_name,
  [100093] = 2,
    ACTIONS(3134), 1,
      anon_sym_while,
    ACTIONS(2015), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR_LF,
  [100102] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_RPAREN,
  [100112] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3138), 1,
      anon_sym_RPAREN,
  [100122] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3140), 1,
      anon_sym_RPAREN,
  [100132] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3142), 1,
      anon_sym_RPAREN,
  [100142] = 3,
    ACTIONS(2314), 1,
      anon_sym_RPAREN,
    ACTIONS(3144), 1,
      anon_sym_COMMA,
    STATE(2015), 1,
      aux_sym_args_repeat1,
  [100152] = 3,
    ACTIONS(3147), 1,
      anon_sym_COMMA,
    ACTIONS(3150), 1,
      anon_sym_RPAREN,
    STATE(2016), 1,
      aux_sym_param_list_repeat1,
  [100162] = 3,
    ACTIONS(3152), 1,
      anon_sym_COMMA,
    ACTIONS(3154), 1,
      anon_sym_RPAREN,
    STATE(2021), 1,
      aux_sym_param_list_repeat1,
  [100172] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_RPAREN,
  [100182] = 3,
    ACTIONS(3158), 1,
      sym_identifier,
    ACTIONS(3160), 1,
      anon_sym_RPAREN,
    STATE(2130), 1,
      sym_param_list,
  [100192] = 3,
    ACTIONS(3162), 1,
      sym_identifier,
    STATE(2170), 1,
      sym_ns_qualified_name,
    STATE(2185), 1,
      sym_namespace,
  [100202] = 3,
    ACTIONS(3152), 1,
      anon_sym_COMMA,
    ACTIONS(3164), 1,
      anon_sym_RPAREN,
    STATE(2016), 1,
      aux_sym_param_list_repeat1,
  [100212] = 3,
    ACTIONS(37), 1,
      anon_sym_POUND,
    ACTIONS(3166), 1,
      sym_identifier,
    STATE(2151), 1,
      sym_comment,
  [100222] = 3,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3168), 1,
      anon_sym_RPAREN,
  [100232] = 3,
    ACTIONS(2298), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RPAREN,
    STATE(2015), 1,
      aux_sym_args_repeat1,
  [100242] = 2,
    ACTIONS(3172), 1,
      anon_sym_getline,
    STATE(478), 1,
      sym_getline_input,
  [100249] = 2,
    ACTIONS(3174), 1,
      anon_sym_getline,
    STATE(1479), 1,
      sym_getline_input,
  [100256] = 2,
    ACTIONS(3176), 1,
      anon_sym_getline,
    STATE(586), 1,
      sym_getline_input,
  [100263] = 2,
    ACTIONS(852), 1,
      anon_sym_COLON,
    ACTIONS(3178), 1,
      sym_regex_flags,
  [100270] = 2,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3156), 1,
      anon_sym_RPAREN,
  [100277] = 2,
    ACTIONS(3180), 1,
      anon_sym_getline,
    STATE(230), 1,
      sym_getline_input,
  [100284] = 2,
    ACTIONS(860), 1,
      anon_sym_COLON,
    ACTIONS(3182), 1,
      sym_regex_flags,
  [100291] = 2,
    ACTIONS(3184), 1,
      anon_sym_getline,
    STATE(1543), 1,
      sym_getline_input,
  [100298] = 1,
    ACTIONS(3186), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [100303] = 2,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    STATE(1684), 1,
      sym_block,
  [100310] = 2,
    ACTIONS(3188), 1,
      anon_sym_getline,
    STATE(592), 1,
      sym_getline_input,
  [100317] = 2,
    ACTIONS(3190), 1,
      anon_sym_getline,
    STATE(419), 1,
      sym_getline_input,
  [100324] = 2,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3142), 1,
      anon_sym_RPAREN,
  [100331] = 2,
    ACTIONS(2819), 1,
      anon_sym_DQUOTE,
    STATE(1670), 1,
      sym_string,
  [100338] = 1,
    ACTIONS(3150), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [100343] = 2,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_RPAREN,
  [100350] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3192), 1,
      anon_sym_LPAREN,
  [100357] = 2,
    ACTIONS(3194), 1,
      anon_sym_getline,
    STATE(428), 1,
      sym_getline_input,
  [100364] = 2,
    ACTIONS(3196), 1,
      anon_sym_getline,
    STATE(390), 1,
      sym_getline_input,
  [100371] = 2,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    STATE(1691), 1,
      sym_block,
  [100378] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3198), 1,
      sym__func_call,
  [100385] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3200), 1,
      sym__func_call,
  [100392] = 2,
    ACTIONS(3202), 1,
      anon_sym_getline,
    STATE(1622), 1,
      sym_getline_input,
  [100399] = 2,
    ACTIONS(3204), 1,
      anon_sym_getline,
    STATE(223), 1,
      sym_getline_input,
  [100406] = 2,
    ACTIONS(3206), 1,
      anon_sym_getline,
    STATE(1481), 1,
      sym_getline_input,
  [100413] = 2,
    ACTIONS(3208), 1,
      anon_sym_getline,
    STATE(1676), 1,
      sym_getline_input,
  [100420] = 2,
    ACTIONS(3210), 1,
      anon_sym_getline,
    STATE(1445), 1,
      sym_getline_input,
  [100427] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1067), 1,
      sym__func_call,
  [100434] = 2,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3138), 1,
      anon_sym_RPAREN,
  [100441] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(940), 1,
      sym__func_call,
  [100448] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1729), 1,
      sym__func_call,
  [100455] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3212), 1,
      sym__func_call,
  [100462] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3214), 1,
      sym__func_call,
  [100469] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(776), 1,
      sym__func_call,
  [100476] = 2,
    ACTIONS(3216), 1,
      anon_sym_getline,
    STATE(351), 1,
      sym_getline_input,
  [100483] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(692), 1,
      sym__func_call,
  [100490] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1279), 1,
      sym__func_call,
  [100497] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3218), 1,
      sym__func_call,
  [100504] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(732), 1,
      sym__func_call,
  [100511] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(676), 1,
      sym__func_call,
  [100518] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3220), 1,
      sym__func_call,
  [100525] = 2,
    ACTIONS(672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1245), 1,
      sym__func_call,
  [100532] = 2,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3168), 1,
      anon_sym_RPAREN,
  [100539] = 2,
    ACTIONS(1209), 1,
      anon_sym_LBRACK,
    ACTIONS(3140), 1,
      anon_sym_RPAREN,
  [100546] = 1,
    ACTIONS(3222), 1,
      sym__no_space,
  [100550] = 1,
    ACTIONS(3224), 1,
      anon_sym_RPAREN,
  [100554] = 1,
    ACTIONS(3226), 1,
      anon_sym_RPAREN,
  [100558] = 1,
    ACTIONS(3228), 1,
      anon_sym_LPAREN2,
  [100562] = 1,
    ACTIONS(3230), 1,
      anon_sym_RPAREN,
  [100566] = 1,
    ACTIONS(3232), 1,
      sym_identifier,
  [100570] = 1,
    ACTIONS(3234), 1,
      sym__no_space,
  [100574] = 1,
    ACTIONS(2344), 1,
      anon_sym_RBRACK,
  [100578] = 1,
    ACTIONS(3236), 1,
      anon_sym_RPAREN,
  [100582] = 1,
    ACTIONS(3238), 1,
      anon_sym_LPAREN2,
  [100586] = 1,
    ACTIONS(3240), 1,
      anon_sym_RPAREN,
  [100590] = 1,
    ACTIONS(3242), 1,
      anon_sym_RPAREN,
  [100594] = 1,
    ACTIONS(3244), 1,
      sym__no_space,
  [100598] = 1,
    ACTIONS(3246), 1,
      anon_sym_in,
  [100602] = 1,
    ACTIONS(3248), 1,
      anon_sym_RPAREN,
  [100606] = 1,
    ACTIONS(3250), 1,
      anon_sym_LPAREN2,
  [100610] = 1,
    ACTIONS(3252), 1,
      anon_sym_LPAREN2,
  [100614] = 1,
    ACTIONS(3254), 1,
      sym__no_space,
  [100618] = 1,
    ACTIONS(3256), 1,
      anon_sym_RPAREN,
  [100622] = 1,
    ACTIONS(3258), 1,
      anon_sym_SLASH2,
  [100626] = 1,
    ACTIONS(3260), 1,
      anon_sym_RPAREN,
  [100630] = 1,
    ACTIONS(3262), 1,
      anon_sym_LPAREN2,
  [100634] = 1,
    ACTIONS(3264), 1,
      anon_sym_COLON2,
  [100638] = 1,
    ACTIONS(3266), 1,
      anon_sym_while,
  [100642] = 1,
    ACTIONS(3268), 1,
      sym__no_space,
  [100646] = 1,
    ACTIONS(3270), 1,
      anon_sym_RPAREN,
  [100650] = 1,
    ACTIONS(3272), 1,
      anon_sym_RPAREN,
  [100654] = 1,
    ACTIONS(3274), 1,
      anon_sym_LPAREN2,
  [100658] = 1,
    ACTIONS(3276), 1,
      anon_sym_LPAREN,
  [100662] = 1,
    ACTIONS(3278), 1,
      anon_sym_LPAREN2,
  [100666] = 1,
    ACTIONS(3280), 1,
      sym__no_space,
  [100670] = 1,
    ACTIONS(3282), 1,
      sym_identifier,
  [100674] = 1,
    ACTIONS(3284), 1,
      anon_sym_RPAREN,
  [100678] = 1,
    ACTIONS(3286), 1,
      anon_sym_LPAREN2,
  [100682] = 1,
    ACTIONS(3288), 1,
      anon_sym_RPAREN,
  [100686] = 1,
    ACTIONS(3290), 1,
      sym_identifier,
  [100690] = 1,
    ACTIONS(3292), 1,
      sym__no_space,
  [100694] = 1,
    ACTIONS(3294), 1,
      sym_identifier,
  [100698] = 1,
    ACTIONS(3296), 1,
      anon_sym_RPAREN,
  [100702] = 1,
    ACTIONS(3298), 1,
      sym__no_space,
  [100706] = 1,
    ACTIONS(3300), 1,
      sym__no_space,
  [100710] = 1,
    ACTIONS(3302), 1,
      sym__no_space,
  [100714] = 1,
    ACTIONS(3304), 1,
      sym__no_space,
  [100718] = 1,
    ACTIONS(3306), 1,
      sym__no_space,
  [100722] = 1,
    ACTIONS(3308), 1,
      sym__no_space,
  [100726] = 1,
    ACTIONS(3310), 1,
      anon_sym_COLON_COLON,
  [100730] = 1,
    ACTIONS(3312), 1,
      anon_sym_LPAREN,
  [100734] = 1,
    ACTIONS(2328), 1,
      anon_sym_RBRACK,
  [100738] = 1,
    ACTIONS(3212), 1,
      sym__func_call,
  [100742] = 1,
    ACTIONS(2326), 1,
      anon_sym_RBRACK,
  [100746] = 1,
    ACTIONS(3314), 1,
      anon_sym_in,
  [100750] = 1,
    ACTIONS(2352), 1,
      anon_sym_RBRACK,
  [100754] = 1,
    ACTIONS(3316), 1,
      anon_sym_LPAREN,
  [100758] = 1,
    ACTIONS(3318), 1,
      anon_sym_LPAREN,
  [100762] = 1,
    ACTIONS(3320), 1,
      anon_sym_RPAREN,
  [100766] = 1,
    ACTIONS(3322), 1,
      anon_sym_in,
  [100770] = 1,
    ACTIONS(3324), 1,
      anon_sym_LPAREN2,
  [100774] = 1,
    ACTIONS(3326), 1,
      anon_sym_SLASH2,
  [100778] = 1,
    ACTIONS(3328), 1,
      anon_sym_COLON2,
  [100782] = 1,
    ACTIONS(3330), 1,
      anon_sym_LPAREN,
  [100786] = 1,
    ACTIONS(3332), 1,
      anon_sym_SLASH2,
  [100790] = 1,
    ACTIONS(3334), 1,
      anon_sym_RPAREN,
  [100794] = 1,
    ACTIONS(3336), 1,
      sym__no_space,
  [100798] = 1,
    ACTIONS(3338), 1,
      anon_sym_in,
  [100802] = 1,
    ACTIONS(3340), 1,
      anon_sym_RPAREN,
  [100806] = 1,
    ACTIONS(3342), 1,
      anon_sym_RPAREN,
  [100810] = 1,
    ACTIONS(3344), 1,
      anon_sym_LPAREN2,
  [100814] = 1,
    ACTIONS(3346), 1,
      anon_sym_RPAREN,
  [100818] = 1,
    ACTIONS(3348), 1,
      anon_sym_RPAREN,
  [100822] = 1,
    ACTIONS(3350), 1,
      sym__no_space,
  [100826] = 1,
    ACTIONS(3352), 1,
      anon_sym_RPAREN,
  [100830] = 1,
    ACTIONS(3354), 1,
      sym_identifier,
  [100834] = 1,
    ACTIONS(2304), 1,
      anon_sym_RBRACK,
  [100838] = 1,
    ACTIONS(3356), 1,
      anon_sym_in,
  [100842] = 1,
    ACTIONS(2318), 1,
      anon_sym_RBRACK,
  [100846] = 1,
    ACTIONS(3358), 1,
      anon_sym_SLASH2,
  [100850] = 1,
    ACTIONS(3360), 1,
      anon_sym_SLASH2,
  [100854] = 1,
    ACTIONS(3362), 1,
      sym__no_space,
  [100858] = 1,
    ACTIONS(3364), 1,
      anon_sym_LPAREN2,
  [100862] = 1,
    ACTIONS(3366), 1,
      anon_sym_RPAREN,
  [100866] = 1,
    ACTIONS(3368), 1,
      anon_sym_in,
  [100870] = 1,
    ACTIONS(3370), 1,
      anon_sym_while,
  [100874] = 1,
    ACTIONS(3372), 1,
      sym_identifier,
  [100878] = 1,
    ACTIONS(3374), 1,
      sym_identifier,
  [100882] = 1,
    ACTIONS(3376), 1,
      anon_sym_RPAREN,
  [100886] = 1,
    ACTIONS(3378), 1,
      anon_sym_in,
  [100890] = 1,
    ACTIONS(3380), 1,
      anon_sym_in,
  [100894] = 1,
    ACTIONS(3382), 1,
      anon_sym_RBRACK2,
  [100898] = 1,
    ACTIONS(3384), 1,
      anon_sym_SLASH2,
  [100902] = 1,
    ACTIONS(720), 1,
      sym__func_call,
  [100906] = 1,
    ACTIONS(3386), 1,
      anon_sym_in,
  [100910] = 1,
    ACTIONS(2308), 1,
      anon_sym_RBRACK,
  [100914] = 1,
    ACTIONS(3388), 1,
      anon_sym_RPAREN,
  [100918] = 1,
    ACTIONS(3390), 1,
      sym__no_space,
  [100922] = 1,
    ACTIONS(3392), 1,
      anon_sym_SLASH2,
  [100926] = 1,
    ACTIONS(2312), 1,
      anon_sym_RBRACK,
  [100930] = 1,
    ACTIONS(3394), 1,
      anon_sym_COLON,
  [100934] = 1,
    ACTIONS(3396), 1,
      sym_identifier,
  [100938] = 1,
    ACTIONS(3398), 1,
      anon_sym_RPAREN,
  [100942] = 1,
    ACTIONS(3400), 1,
      sym_identifier,
  [100946] = 1,
    ACTIONS(2350), 1,
      anon_sym_RBRACK,
  [100950] = 1,
    ACTIONS(3192), 1,
      anon_sym_LPAREN,
  [100954] = 1,
    ACTIONS(3402), 1,
      anon_sym_RPAREN,
  [100958] = 1,
    ACTIONS(3404), 1,
      anon_sym_in,
  [100962] = 1,
    ACTIONS(3406), 1,
      anon_sym_SLASH2,
  [100966] = 1,
    ACTIONS(800), 1,
      anon_sym_COLON,
  [100970] = 1,
    ACTIONS(3408), 1,
      anon_sym_SLASH2,
  [100974] = 1,
    ACTIONS(2316), 1,
      anon_sym_RBRACK,
  [100978] = 1,
    ACTIONS(3410), 1,
      sym_identifier,
  [100982] = 1,
    ACTIONS(3412), 1,
      anon_sym_LPAREN2,
  [100986] = 1,
    ACTIONS(3414), 1,
      anon_sym_SLASH2,
  [100990] = 1,
    ACTIONS(2322), 1,
      anon_sym_RBRACK,
  [100994] = 1,
    ACTIONS(3416), 1,
      anon_sym_LPAREN2,
  [100998] = 1,
    ACTIONS(3198), 1,
      sym__func_call,
  [101002] = 1,
    ACTIONS(3418), 1,
      sym_identifier,
  [101006] = 1,
    ACTIONS(3420), 1,
      anon_sym_COLON,
  [101010] = 1,
    ACTIONS(3422), 1,
      anon_sym_COLON_COLON,
  [101014] = 1,
    ACTIONS(3424), 1,
      anon_sym_LPAREN,
  [101018] = 1,
    ACTIONS(3426), 1,
      anon_sym_RPAREN,
  [101022] = 1,
    ACTIONS(3200), 1,
      sym__func_call,
  [101026] = 1,
    ACTIONS(3428), 1,
      anon_sym_SLASH2,
  [101030] = 1,
    ACTIONS(3430), 1,
      anon_sym_SLASH2,
  [101034] = 1,
    ACTIONS(2324), 1,
      anon_sym_RBRACK,
  [101038] = 1,
    ACTIONS(3432), 1,
      sym_identifier,
  [101042] = 1,
    ACTIONS(3434), 1,
      anon_sym_RPAREN,
  [101046] = 1,
    ACTIONS(3436), 1,
      aux_sym_comment_token1,
  [101050] = 1,
    ACTIONS(3438), 1,
      anon_sym_SLASH2,
  [101054] = 1,
    ACTIONS(3440), 1,
      anon_sym_SLASH2,
  [101058] = 1,
    ACTIONS(2330), 1,
      anon_sym_RBRACK,
  [101062] = 1,
    ACTIONS(3442), 1,
      anon_sym_LPAREN,
  [101066] = 1,
    ACTIONS(3444), 1,
      sym_identifier,
  [101070] = 1,
    ACTIONS(3446), 1,
      anon_sym_RPAREN,
  [101074] = 1,
    ACTIONS(3448), 1,
      anon_sym_in,
  [101078] = 1,
    ACTIONS(3450), 1,
      anon_sym_SLASH2,
  [101082] = 1,
    ACTIONS(3452), 1,
      anon_sym_LPAREN,
  [101086] = 1,
    ACTIONS(3454), 1,
      anon_sym_LPAREN,
  [101090] = 1,
    ACTIONS(3456), 1,
      anon_sym_LPAREN,
  [101094] = 1,
    ACTIONS(3458), 1,
      anon_sym_RPAREN,
  [101098] = 1,
    ACTIONS(2338), 1,
      anon_sym_RBRACK,
  [101102] = 1,
    ACTIONS(3460), 1,
      sym_identifier,
  [101106] = 1,
    ACTIONS(3462), 1,
      anon_sym_COLON_COLON,
  [101110] = 1,
    ACTIONS(2340), 1,
      anon_sym_RBRACK,
  [101114] = 1,
    ACTIONS(3464), 1,
      anon_sym_RPAREN,
  [101118] = 1,
    ACTIONS(3466), 1,
      anon_sym_COLON_COLON,
  [101122] = 1,
    ACTIONS(3468), 1,
      anon_sym_LPAREN,
  [101126] = 1,
    ACTIONS(3470), 1,
      sym_identifier,
  [101130] = 1,
    ACTIONS(1067), 1,
      sym__func_call,
  [101134] = 1,
    ACTIONS(3472), 1,
      anon_sym_RPAREN,
  [101138] = 1,
    ACTIONS(3474), 1,
      ts_builtin_sym_end,
  [101142] = 1,
    ACTIONS(3476), 1,
      anon_sym_RPAREN,
  [101146] = 1,
    ACTIONS(3478), 1,
      anon_sym_RPAREN,
  [101150] = 1,
    ACTIONS(3480), 1,
      anon_sym_SLASH2,
  [101154] = 1,
    ACTIONS(3482), 1,
      anon_sym_COLON_COLON,
  [101158] = 1,
    ACTIONS(3484), 1,
      sym_identifier,
  [101162] = 1,
    ACTIONS(940), 1,
      sym__func_call,
  [101166] = 1,
    ACTIONS(3486), 1,
      aux_sym_comment_token1,
  [101170] = 1,
    ACTIONS(3488), 1,
      anon_sym_COLON_COLON,
  [101174] = 1,
    ACTIONS(3490), 1,
      anon_sym_SLASH2,
  [101178] = 1,
    ACTIONS(1729), 1,
      sym__func_call,
  [101182] = 1,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
  [101186] = 1,
    ACTIONS(3494), 1,
      sym_identifier,
  [101190] = 1,
    ACTIONS(3214), 1,
      sym__func_call,
  [101194] = 1,
    ACTIONS(3496), 1,
      anon_sym_COLON_COLON,
  [101198] = 1,
    ACTIONS(3498), 1,
      anon_sym_SLASH2,
  [101202] = 1,
    ACTIONS(776), 1,
      sym__func_call,
  [101206] = 1,
    ACTIONS(3500), 1,
      anon_sym_COLON_COLON,
  [101210] = 1,
    ACTIONS(3502), 1,
      sym_identifier,
  [101214] = 1,
    ACTIONS(692), 1,
      sym__func_call,
  [101218] = 1,
    ACTIONS(3504), 1,
      anon_sym_COLON_COLON,
  [101222] = 1,
    ACTIONS(3506), 1,
      anon_sym_SLASH2,
  [101226] = 1,
    ACTIONS(1279), 1,
      sym__func_call,
  [101230] = 1,
    ACTIONS(3508), 1,
      anon_sym_COLON_COLON,
  [101234] = 1,
    ACTIONS(3510), 1,
      sym_identifier,
  [101238] = 1,
    ACTIONS(3218), 1,
      sym__func_call,
  [101242] = 1,
    ACTIONS(3512), 1,
      anon_sym_COLON_COLON,
  [101246] = 1,
    ACTIONS(3514), 1,
      anon_sym_SLASH2,
  [101250] = 1,
    ACTIONS(732), 1,
      sym__func_call,
  [101254] = 1,
    ACTIONS(3516), 1,
      anon_sym_COLON_COLON,
  [101258] = 1,
    ACTIONS(3518), 1,
      sym__no_space,
  [101262] = 1,
    ACTIONS(676), 1,
      sym__func_call,
  [101266] = 1,
    ACTIONS(3520), 1,
      anon_sym_COLON_COLON,
  [101270] = 1,
    ACTIONS(3522), 1,
      anon_sym_SLASH2,
  [101274] = 1,
    ACTIONS(3220), 1,
      sym__func_call,
  [101278] = 1,
    ACTIONS(3524), 1,
      anon_sym_COLON_COLON,
  [101282] = 1,
    ACTIONS(3526), 1,
      anon_sym_LPAREN2,
  [101286] = 1,
    ACTIONS(1245), 1,
      sym__func_call,
  [101290] = 1,
    ACTIONS(3528), 1,
      anon_sym_COLON_COLON,
  [101294] = 1,
    ACTIONS(3530), 1,
      anon_sym_COLON_COLON,
  [101298] = 1,
    ACTIONS(3532), 1,
      anon_sym_COLON_COLON,
  [101302] = 1,
    ACTIONS(3534), 1,
      anon_sym_COLON_COLON,
  [101306] = 1,
    ACTIONS(3536), 1,
      anon_sym_LPAREN,
  [101310] = 1,
    ACTIONS(3538), 1,
      anon_sym_LPAREN,
  [101314] = 1,
    ACTIONS(3540), 1,
      anon_sym_LPAREN,
  [101318] = 1,
    ACTIONS(3542), 1,
      anon_sym_LPAREN,
  [101322] = 1,
    ACTIONS(3544), 1,
      anon_sym_RPAREN,
  [101326] = 1,
    ACTIONS(3546), 1,
      anon_sym_while,
  [101330] = 1,
    ACTIONS(3548), 1,
      anon_sym_SLASH2,
  [101334] = 1,
    ACTIONS(3550), 1,
      anon_sym_SLASH2,
  [101338] = 1,
    ACTIONS(3552), 1,
      anon_sym_SLASH2,
  [101342] = 1,
    ACTIONS(3554), 1,
      anon_sym_while,
  [101346] = 1,
    ACTIONS(3556), 1,
      anon_sym_SLASH2,
  [101350] = 1,
    ACTIONS(3558), 1,
      anon_sym_in,
  [101354] = 1,
    ACTIONS(3560), 1,
      anon_sym_RPAREN,
  [101358] = 1,
    ACTIONS(3562), 1,
      anon_sym_LPAREN,
  [101362] = 1,
    ACTIONS(3564), 1,
      anon_sym_LPAREN,
  [101366] = 1,
    ACTIONS(3566), 1,
      anon_sym_LPAREN,
  [101370] = 1,
    ACTIONS(3568), 1,
      anon_sym_LPAREN2,
  [101374] = 1,
    ACTIONS(3570), 1,
      sym__no_space,
  [101378] = 1,
    ACTIONS(3572), 1,
      sym_identifier,
  [101382] = 1,
    ACTIONS(3574), 1,
      anon_sym_in,
  [101386] = 1,
    ACTIONS(3576), 1,
      anon_sym_LPAREN,
  [101390] = 1,
    ACTIONS(3578), 1,
      anon_sym_LPAREN,
  [101394] = 1,
    ACTIONS(3580), 1,
      anon_sym_LPAREN,
  [101398] = 1,
    ACTIONS(3582), 1,
      anon_sym_in,
  [101402] = 1,
    ACTIONS(3584), 1,
      anon_sym_LPAREN,
  [101406] = 1,
    ACTIONS(3586), 1,
      anon_sym_in,
  [101410] = 1,
    ACTIONS(3588), 1,
      anon_sym_in,
  [101414] = 1,
    ACTIONS(3590), 1,
      anon_sym_LPAREN,
  [101418] = 1,
    ACTIONS(3592), 1,
      anon_sym_LPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(224)] = 0,
  [SMALL_STATE(225)] = 69,
  [SMALL_STATE(226)] = 138,
  [SMALL_STATE(227)] = 215,
  [SMALL_STATE(228)] = 284,
  [SMALL_STATE(229)] = 353,
  [SMALL_STATE(230)] = 422,
  [SMALL_STATE(231)] = 491,
  [SMALL_STATE(232)] = 564,
  [SMALL_STATE(233)] = 633,
  [SMALL_STATE(234)] = 710,
  [SMALL_STATE(235)] = 779,
  [SMALL_STATE(236)] = 848,
  [SMALL_STATE(237)] = 917,
  [SMALL_STATE(238)] = 986,
  [SMALL_STATE(239)] = 1055,
  [SMALL_STATE(240)] = 1132,
  [SMALL_STATE(241)] = 1201,
  [SMALL_STATE(242)] = 1272,
  [SMALL_STATE(243)] = 1341,
  [SMALL_STATE(244)] = 1418,
  [SMALL_STATE(245)] = 1493,
  [SMALL_STATE(246)] = 1562,
  [SMALL_STATE(247)] = 1633,
  [SMALL_STATE(248)] = 1708,
  [SMALL_STATE(249)] = 1779,
  [SMALL_STATE(250)] = 1848,
  [SMALL_STATE(251)] = 1917,
  [SMALL_STATE(252)] = 1986,
  [SMALL_STATE(253)] = 2057,
  [SMALL_STATE(254)] = 2128,
  [SMALL_STATE(255)] = 2203,
  [SMALL_STATE(256)] = 2277,
  [SMALL_STATE(257)] = 2355,
  [SMALL_STATE(258)] = 2441,
  [SMALL_STATE(259)] = 2513,
  [SMALL_STATE(260)] = 2591,
  [SMALL_STATE(261)] = 2661,
  [SMALL_STATE(262)] = 2747,
  [SMALL_STATE(263)] = 2833,
  [SMALL_STATE(264)] = 2903,
  [SMALL_STATE(265)] = 2989,
  [SMALL_STATE(266)] = 3061,
  [SMALL_STATE(267)] = 3143,
  [SMALL_STATE(268)] = 3215,
  [SMALL_STATE(269)] = 3295,
  [SMALL_STATE(270)] = 3369,
  [SMALL_STATE(271)] = 3445,
  [SMALL_STATE(272)] = 3517,
  [SMALL_STATE(273)] = 3587,
  [SMALL_STATE(274)] = 3661,
  [SMALL_STATE(275)] = 3735,
  [SMALL_STATE(276)] = 3809,
  [SMALL_STATE(277)] = 3897,
  [SMALL_STATE(278)] = 3971,
  [SMALL_STATE(279)] = 4058,
  [SMALL_STATE(280)] = 4143,
  [SMALL_STATE(281)] = 4216,
  [SMALL_STATE(282)] = 4289,
  [SMALL_STATE(283)] = 4374,
  [SMALL_STATE(284)] = 4443,
  [SMALL_STATE(285)] = 4514,
  [SMALL_STATE(286)] = 4585,
  [SMALL_STATE(287)] = 4660,
  [SMALL_STATE(288)] = 4739,
  [SMALL_STATE(289)] = 4816,
  [SMALL_STATE(290)] = 4887,
  [SMALL_STATE(291)] = 4972,
  [SMALL_STATE(292)] = 5053,
  [SMALL_STATE(293)] = 5124,
  [SMALL_STATE(294)] = 5209,
  [SMALL_STATE(295)] = 5286,
  [SMALL_STATE(296)] = 5361,
  [SMALL_STATE(297)] = 5432,
  [SMALL_STATE(298)] = 5505,
  [SMALL_STATE(299)] = 5603,
  [SMALL_STATE(300)] = 5667,
  [SMALL_STATE(301)] = 5765,
  [SMALL_STATE(302)] = 5883,
  [SMALL_STATE(303)] = 6001,
  [SMALL_STATE(304)] = 6071,
  [SMALL_STATE(305)] = 6145,
  [SMALL_STATE(306)] = 6213,
  [SMALL_STATE(307)] = 6285,
  [SMALL_STATE(308)] = 6353,
  [SMALL_STATE(309)] = 6423,
  [SMALL_STATE(310)] = 6490,
  [SMALL_STATE(311)] = 6555,
  [SMALL_STATE(312)] = 6618,
  [SMALL_STATE(313)] = 6687,
  [SMALL_STATE(314)] = 6754,
  [SMALL_STATE(315)] = 6819,
  [SMALL_STATE(316)] = 6888,
  [SMALL_STATE(317)] = 6951,
  [SMALL_STATE(318)] = 7020,
  [SMALL_STATE(319)] = 7083,
  [SMALL_STATE(320)] = 7156,
  [SMALL_STATE(321)] = 7225,
  [SMALL_STATE(322)] = 7298,
  [SMALL_STATE(323)] = 7361,
  [SMALL_STATE(324)] = 7428,
  [SMALL_STATE(325)] = 7523,
  [SMALL_STATE(326)] = 7618,
  [SMALL_STATE(327)] = 7680,
  [SMALL_STATE(328)] = 7742,
  [SMALL_STATE(329)] = 7804,
  [SMALL_STATE(330)] = 7866,
  [SMALL_STATE(331)] = 7928,
  [SMALL_STATE(332)] = 7994,
  [SMALL_STATE(333)] = 8060,
  [SMALL_STATE(334)] = 8122,
  [SMALL_STATE(335)] = 8184,
  [SMALL_STATE(336)] = 8246,
  [SMALL_STATE(337)] = 8310,
  [SMALL_STATE(338)] = 8376,
  [SMALL_STATE(339)] = 8438,
  [SMALL_STATE(340)] = 8502,
  [SMALL_STATE(341)] = 8562,
  [SMALL_STATE(342)] = 8624,
  [SMALL_STATE(343)] = 8686,
  [SMALL_STATE(344)] = 8748,
  [SMALL_STATE(345)] = 8812,
  [SMALL_STATE(346)] = 8874,
  [SMALL_STATE(347)] = 8936,
  [SMALL_STATE(348)] = 9002,
  [SMALL_STATE(349)] = 9068,
  [SMALL_STATE(350)] = 9136,
  [SMALL_STATE(351)] = 9198,
  [SMALL_STATE(352)] = 9260,
  [SMALL_STATE(353)] = 9326,
  [SMALL_STATE(354)] = 9386,
  [SMALL_STATE(355)] = 9450,
  [SMALL_STATE(356)] = 9514,
  [SMALL_STATE(357)] = 9576,
  [SMALL_STATE(358)] = 9638,
  [SMALL_STATE(359)] = 9704,
  [SMALL_STATE(360)] = 9766,
  [SMALL_STATE(361)] = 9834,
  [SMALL_STATE(362)] = 9896,
  [SMALL_STATE(363)] = 9962,
  [SMALL_STATE(364)] = 10032,
  [SMALL_STATE(365)] = 10093,
  [SMALL_STATE(366)] = 10164,
  [SMALL_STATE(367)] = 10227,
  [SMALL_STATE(368)] = 10290,
  [SMALL_STATE(369)] = 10351,
  [SMALL_STATE(370)] = 10418,
  [SMALL_STATE(371)] = 10489,
  [SMALL_STATE(372)] = 10550,
  [SMALL_STATE(373)] = 10611,
  [SMALL_STATE(374)] = 10686,
  [SMALL_STATE(375)] = 10749,
  [SMALL_STATE(376)] = 10810,
  [SMALL_STATE(377)] = 10889,
  [SMALL_STATE(378)] = 10950,
  [SMALL_STATE(379)] = 11015,
  [SMALL_STATE(380)] = 11078,
  [SMALL_STATE(381)] = 11141,
  [SMALL_STATE(382)] = 11220,
  [SMALL_STATE(383)] = 11283,
  [SMALL_STATE(384)] = 11344,
  [SMALL_STATE(385)] = 11423,
  [SMALL_STATE(386)] = 11484,
  [SMALL_STATE(387)] = 11545,
  [SMALL_STATE(388)] = 11606,
  [SMALL_STATE(389)] = 11667,
  [SMALL_STATE(390)] = 11748,
  [SMALL_STATE(391)] = 11809,
  [SMALL_STATE(392)] = 11874,
  [SMALL_STATE(393)] = 11935,
  [SMALL_STATE(394)] = 11996,
  [SMALL_STATE(395)] = 12075,
  [SMALL_STATE(396)] = 12138,
  [SMALL_STATE(397)] = 12205,
  [SMALL_STATE(398)] = 12266,
  [SMALL_STATE(399)] = 12331,
  [SMALL_STATE(400)] = 12392,
  [SMALL_STATE(401)] = 12467,
  [SMALL_STATE(402)] = 12528,
  [SMALL_STATE(403)] = 12601,
  [SMALL_STATE(404)] = 12670,
  [SMALL_STATE(405)] = 12735,
  [SMALL_STATE(406)] = 12798,
  [SMALL_STATE(407)] = 12873,
  [SMALL_STATE(408)] = 12934,
  [SMALL_STATE(409)] = 12997,
  [SMALL_STATE(410)] = 13058,
  [SMALL_STATE(411)] = 13121,
  [SMALL_STATE(412)] = 13184,
  [SMALL_STATE(413)] = 13247,
  [SMALL_STATE(414)] = 13318,
  [SMALL_STATE(415)] = 13381,
  [SMALL_STATE(416)] = 13442,
  [SMALL_STATE(417)] = 13515,
  [SMALL_STATE(418)] = 13575,
  [SMALL_STATE(419)] = 13637,
  [SMALL_STATE(420)] = 13697,
  [SMALL_STATE(421)] = 13777,
  [SMALL_STATE(422)] = 13837,
  [SMALL_STATE(423)] = 13897,
  [SMALL_STATE(424)] = 13957,
  [SMALL_STATE(425)] = 14037,
  [SMALL_STATE(426)] = 14117,
  [SMALL_STATE(427)] = 14177,
  [SMALL_STATE(428)] = 14237,
  [SMALL_STATE(429)] = 14297,
  [SMALL_STATE(430)] = 14357,
  [SMALL_STATE(431)] = 14435,
  [SMALL_STATE(432)] = 14495,
  [SMALL_STATE(433)] = 14561,
  [SMALL_STATE(434)] = 14629,
  [SMALL_STATE(435)] = 14689,
  [SMALL_STATE(436)] = 14749,
  [SMALL_STATE(437)] = 14809,
  [SMALL_STATE(438)] = 14887,
  [SMALL_STATE(439)] = 14947,
  [SMALL_STATE(440)] = 15007,
  [SMALL_STATE(441)] = 15067,
  [SMALL_STATE(442)] = 15129,
  [SMALL_STATE(443)] = 15189,
  [SMALL_STATE(444)] = 15259,
  [SMALL_STATE(445)] = 15331,
  [SMALL_STATE(446)] = 15391,
  [SMALL_STATE(447)] = 15451,
  [SMALL_STATE(448)] = 15531,
  [SMALL_STATE(449)] = 15603,
  [SMALL_STATE(450)] = 15663,
  [SMALL_STATE(451)] = 15723,
  [SMALL_STATE(452)] = 15783,
  [SMALL_STATE(453)] = 15843,
  [SMALL_STATE(454)] = 15917,
  [SMALL_STATE(455)] = 15989,
  [SMALL_STATE(456)] = 16067,
  [SMALL_STATE(457)] = 16127,
  [SMALL_STATE(458)] = 16187,
  [SMALL_STATE(459)] = 16251,
  [SMALL_STATE(460)] = 16317,
  [SMALL_STATE(461)] = 16383,
  [SMALL_STATE(462)] = 16443,
  [SMALL_STATE(463)] = 16513,
  [SMALL_STATE(464)] = 16591,
  [SMALL_STATE(465)] = 16651,
  [SMALL_STATE(466)] = 16721,
  [SMALL_STATE(467)] = 16781,
  [SMALL_STATE(468)] = 16841,
  [SMALL_STATE(469)] = 16903,
  [SMALL_STATE(470)] = 16963,
  [SMALL_STATE(471)] = 17023,
  [SMALL_STATE(472)] = 17083,
  [SMALL_STATE(473)] = 17143,
  [SMALL_STATE(474)] = 17203,
  [SMALL_STATE(475)] = 17263,
  [SMALL_STATE(476)] = 17320,
  [SMALL_STATE(477)] = 17377,
  [SMALL_STATE(478)] = 17454,
  [SMALL_STATE(479)] = 17511,
  [SMALL_STATE(480)] = 17568,
  [SMALL_STATE(481)] = 17645,
  [SMALL_STATE(482)] = 17702,
  [SMALL_STATE(483)] = 17771,
  [SMALL_STATE(484)] = 17840,
  [SMALL_STATE(485)] = 17901,
  [SMALL_STATE(486)] = 17958,
  [SMALL_STATE(487)] = 18015,
  [SMALL_STATE(488)] = 18072,
  [SMALL_STATE(489)] = 18139,
  [SMALL_STATE(490)] = 18196,
  [SMALL_STATE(491)] = 18273,
  [SMALL_STATE(492)] = 18372,
  [SMALL_STATE(493)] = 18429,
  [SMALL_STATE(494)] = 18490,
  [SMALL_STATE(495)] = 18553,
  [SMALL_STATE(496)] = 18610,
  [SMALL_STATE(497)] = 18667,
  [SMALL_STATE(498)] = 18737,
  [SMALL_STATE(499)] = 18815,
  [SMALL_STATE(500)] = 18891,
  [SMALL_STATE(501)] = 18975,
  [SMALL_STATE(502)] = 19047,
  [SMALL_STATE(503)] = 19113,
  [SMALL_STATE(504)] = 19185,
  [SMALL_STATE(505)] = 19249,
  [SMALL_STATE(506)] = 19327,
  [SMALL_STATE(507)] = 19405,
  [SMALL_STATE(508)] = 19485,
  [SMALL_STATE(509)] = 19563,
  [SMALL_STATE(510)] = 19641,
  [SMALL_STATE(511)] = 19721,
  [SMALL_STATE(512)] = 19817,
  [SMALL_STATE(513)] = 19897,
  [SMALL_STATE(514)] = 19963,
  [SMALL_STATE(515)] = 20037,
  [SMALL_STATE(516)] = 20117,
  [SMALL_STATE(517)] = 20181,
  [SMALL_STATE(518)] = 20243,
  [SMALL_STATE(519)] = 20309,
  [SMALL_STATE(520)] = 20375,
  [SMALL_STATE(521)] = 20450,
  [SMALL_STATE(522)] = 20525,
  [SMALL_STATE(523)] = 20600,
  [SMALL_STATE(524)] = 20675,
  [SMALL_STATE(525)] = 20750,
  [SMALL_STATE(526)] = 20846,
  [SMALL_STATE(527)] = 20939,
  [SMALL_STATE(528)] = 20999,
  [SMALL_STATE(529)] = 21063,
  [SMALL_STATE(530)] = 21120,
  [SMALL_STATE(531)] = 21179,
  [SMALL_STATE(532)] = 21242,
  [SMALL_STATE(533)] = 21299,
  [SMALL_STATE(534)] = 21358,
  [SMALL_STATE(535)] = 21412,
  [SMALL_STATE(536)] = 21464,
  [SMALL_STATE(537)] = 21520,
  [SMALL_STATE(538)] = 21574,
  [SMALL_STATE(539)] = 21628,
  [SMALL_STATE(540)] = 21680,
  [SMALL_STATE(541)] = 21734,
  [SMALL_STATE(542)] = 21790,
  [SMALL_STATE(543)] = 21842,
  [SMALL_STATE(544)] = 21894,
  [SMALL_STATE(545)] = 21950,
  [SMALL_STATE(546)] = 22008,
  [SMALL_STATE(547)] = 22065,
  [SMALL_STATE(548)] = 22116,
  [SMALL_STATE(549)] = 22167,
  [SMALL_STATE(550)] = 22218,
  [SMALL_STATE(551)] = 22271,
  [SMALL_STATE(552)] = 22326,
  [SMALL_STATE(553)] = 22379,
  [SMALL_STATE(554)] = 22438,
  [SMALL_STATE(555)] = 22489,
  [SMALL_STATE(556)] = 22542,
  [SMALL_STATE(557)] = 22619,
  [SMALL_STATE(558)] = 22670,
  [SMALL_STATE(559)] = 22721,
  [SMALL_STATE(560)] = 22772,
  [SMALL_STATE(561)] = 22823,
  [SMALL_STATE(562)] = 22874,
  [SMALL_STATE(563)] = 22939,
  [SMALL_STATE(564)] = 23012,
  [SMALL_STATE(565)] = 23063,
  [SMALL_STATE(566)] = 23132,
  [SMALL_STATE(567)] = 23183,
  [SMALL_STATE(568)] = 23236,
  [SMALL_STATE(569)] = 23309,
  [SMALL_STATE(570)] = 23382,
  [SMALL_STATE(571)] = 23433,
  [SMALL_STATE(572)] = 23484,
  [SMALL_STATE(573)] = 23535,
  [SMALL_STATE(574)] = 23602,
  [SMALL_STATE(575)] = 23653,
  [SMALL_STATE(576)] = 23706,
  [SMALL_STATE(577)] = 23761,
  [SMALL_STATE(578)] = 23846,
  [SMALL_STATE(579)] = 23919,
  [SMALL_STATE(580)] = 23970,
  [SMALL_STATE(581)] = 24035,
  [SMALL_STATE(582)] = 24120,
  [SMALL_STATE(583)] = 24179,
  [SMALL_STATE(584)] = 24230,
  [SMALL_STATE(585)] = 24281,
  [SMALL_STATE(586)] = 24334,
  [SMALL_STATE(587)] = 24385,
  [SMALL_STATE(588)] = 24448,
  [SMALL_STATE(589)] = 24499,
  [SMALL_STATE(590)] = 24549,
  [SMALL_STATE(591)] = 24631,
  [SMALL_STATE(592)] = 24693,
  [SMALL_STATE(593)] = 24743,
  [SMALL_STATE(594)] = 24793,
  [SMALL_STATE(595)] = 24843,
  [SMALL_STATE(596)] = 24893,
  [SMALL_STATE(597)] = 24971,
  [SMALL_STATE(598)] = 25047,
  [SMALL_STATE(599)] = 25097,
  [SMALL_STATE(600)] = 25147,
  [SMALL_STATE(601)] = 25207,
  [SMALL_STATE(602)] = 25257,
  [SMALL_STATE(603)] = 25307,
  [SMALL_STATE(604)] = 25389,
  [SMALL_STATE(605)] = 25439,
  [SMALL_STATE(606)] = 25500,
  [SMALL_STATE(607)] = 25559,
  [SMALL_STATE(608)] = 25618,
  [SMALL_STATE(609)] = 25693,
  [SMALL_STATE(610)] = 25754,
  [SMALL_STATE(611)] = 25813,
  [SMALL_STATE(612)] = 25869,
  [SMALL_STATE(613)] = 25927,
  [SMALL_STATE(614)] = 25983,
  [SMALL_STATE(615)] = 26041,
  [SMALL_STATE(616)] = 26123,
  [SMALL_STATE(617)] = 26177,
  [SMALL_STATE(618)] = 26259,
  [SMALL_STATE(619)] = 26317,
  [SMALL_STATE(620)] = 26375,
  [SMALL_STATE(621)] = 26428,
  [SMALL_STATE(622)] = 26477,
  [SMALL_STATE(623)] = 26532,
  [SMALL_STATE(624)] = 26583,
  [SMALL_STATE(625)] = 26632,
  [SMALL_STATE(626)] = 26687,
  [SMALL_STATE(627)] = 26740,
  [SMALL_STATE(628)] = 26819,
  [SMALL_STATE(629)] = 26898,
  [SMALL_STATE(630)] = 26953,
  [SMALL_STATE(631)] = 27008,
  [SMALL_STATE(632)] = 27065,
  [SMALL_STATE(633)] = 27118,
  [SMALL_STATE(634)] = 27182,
  [SMALL_STATE(635)] = 27240,
  [SMALL_STATE(636)] = 27288,
  [SMALL_STATE(637)] = 27372,
  [SMALL_STATE(638)] = 27456,
  [SMALL_STATE(639)] = 27540,
  [SMALL_STATE(640)] = 27596,
  [SMALL_STATE(641)] = 27660,
  [SMALL_STATE(642)] = 27724,
  [SMALL_STATE(643)] = 27808,
  [SMALL_STATE(644)] = 27892,
  [SMALL_STATE(645)] = 27944,
  [SMALL_STATE(646)] = 27998,
  [SMALL_STATE(647)] = 28048,
  [SMALL_STATE(648)] = 28132,
  [SMALL_STATE(649)] = 28184,
  [SMALL_STATE(650)] = 28240,
  [SMALL_STATE(651)] = 28288,
  [SMALL_STATE(652)] = 28340,
  [SMALL_STATE(653)] = 28390,
  [SMALL_STATE(654)] = 28454,
  [SMALL_STATE(655)] = 28538,
  [SMALL_STATE(656)] = 28604,
  [SMALL_STATE(657)] = 28652,
  [SMALL_STATE(658)] = 28702,
  [SMALL_STATE(659)] = 28786,
  [SMALL_STATE(660)] = 28870,
  [SMALL_STATE(661)] = 28954,
  [SMALL_STATE(662)] = 29000,
  [SMALL_STATE(663)] = 29046,
  [SMALL_STATE(664)] = 29102,
  [SMALL_STATE(665)] = 29162,
  [SMALL_STATE(666)] = 29214,
  [SMALL_STATE(667)] = 29266,
  [SMALL_STATE(668)] = 29324,
  [SMALL_STATE(669)] = 29376,
  [SMALL_STATE(670)] = 29432,
  [SMALL_STATE(671)] = 29478,
  [SMALL_STATE(672)] = 29524,
  [SMALL_STATE(673)] = 29607,
  [SMALL_STATE(674)] = 29690,
  [SMALL_STATE(675)] = 29773,
  [SMALL_STATE(676)] = 29856,
  [SMALL_STATE(677)] = 29937,
  [SMALL_STATE(678)] = 30018,
  [SMALL_STATE(679)] = 30101,
  [SMALL_STATE(680)] = 30182,
  [SMALL_STATE(681)] = 30263,
  [SMALL_STATE(682)] = 30318,
  [SMALL_STATE(683)] = 30401,
  [SMALL_STATE(684)] = 30482,
  [SMALL_STATE(685)] = 30537,
  [SMALL_STATE(686)] = 30590,
  [SMALL_STATE(687)] = 30671,
  [SMALL_STATE(688)] = 30754,
  [SMALL_STATE(689)] = 30837,
  [SMALL_STATE(690)] = 30892,
  [SMALL_STATE(691)] = 30975,
  [SMALL_STATE(692)] = 31058,
  [SMALL_STATE(693)] = 31139,
  [SMALL_STATE(694)] = 31222,
  [SMALL_STATE(695)] = 31271,
  [SMALL_STATE(696)] = 31354,
  [SMALL_STATE(697)] = 31435,
  [SMALL_STATE(698)] = 31518,
  [SMALL_STATE(699)] = 31601,
  [SMALL_STATE(700)] = 31666,
  [SMALL_STATE(701)] = 31747,
  [SMALL_STATE(702)] = 31830,
  [SMALL_STATE(703)] = 31913,
  [SMALL_STATE(704)] = 31962,
  [SMALL_STATE(705)] = 32045,
  [SMALL_STATE(706)] = 32126,
  [SMALL_STATE(707)] = 32169,
  [SMALL_STATE(708)] = 32212,
  [SMALL_STATE(709)] = 32295,
  [SMALL_STATE(710)] = 32378,
  [SMALL_STATE(711)] = 32461,
  [SMALL_STATE(712)] = 32544,
  [SMALL_STATE(713)] = 32595,
  [SMALL_STATE(714)] = 32676,
  [SMALL_STATE(715)] = 32757,
  [SMALL_STATE(716)] = 32840,
  [SMALL_STATE(717)] = 32921,
  [SMALL_STATE(718)] = 33004,
  [SMALL_STATE(719)] = 33087,
  [SMALL_STATE(720)] = 33170,
  [SMALL_STATE(721)] = 33253,
  [SMALL_STATE(722)] = 33336,
  [SMALL_STATE(723)] = 33419,
  [SMALL_STATE(724)] = 33500,
  [SMALL_STATE(725)] = 33581,
  [SMALL_STATE(726)] = 33662,
  [SMALL_STATE(727)] = 33745,
  [SMALL_STATE(728)] = 33826,
  [SMALL_STATE(729)] = 33907,
  [SMALL_STATE(730)] = 33988,
  [SMALL_STATE(731)] = 34071,
  [SMALL_STATE(732)] = 34152,
  [SMALL_STATE(733)] = 34235,
  [SMALL_STATE(734)] = 34318,
  [SMALL_STATE(735)] = 34399,
  [SMALL_STATE(736)] = 34482,
  [SMALL_STATE(737)] = 34565,
  [SMALL_STATE(738)] = 34648,
  [SMALL_STATE(739)] = 34731,
  [SMALL_STATE(740)] = 34814,
  [SMALL_STATE(741)] = 34897,
  [SMALL_STATE(742)] = 34980,
  [SMALL_STATE(743)] = 35063,
  [SMALL_STATE(744)] = 35144,
  [SMALL_STATE(745)] = 35227,
  [SMALL_STATE(746)] = 35310,
  [SMALL_STATE(747)] = 35391,
  [SMALL_STATE(748)] = 35474,
  [SMALL_STATE(749)] = 35557,
  [SMALL_STATE(750)] = 35640,
  [SMALL_STATE(751)] = 35721,
  [SMALL_STATE(752)] = 35804,
  [SMALL_STATE(753)] = 35887,
  [SMALL_STATE(754)] = 35970,
  [SMALL_STATE(755)] = 36053,
  [SMALL_STATE(756)] = 36136,
  [SMALL_STATE(757)] = 36199,
  [SMALL_STATE(758)] = 36282,
  [SMALL_STATE(759)] = 36365,
  [SMALL_STATE(760)] = 36428,
  [SMALL_STATE(761)] = 36491,
  [SMALL_STATE(762)] = 36572,
  [SMALL_STATE(763)] = 36635,
  [SMALL_STATE(764)] = 36718,
  [SMALL_STATE(765)] = 36801,
  [SMALL_STATE(766)] = 36884,
  [SMALL_STATE(767)] = 36939,
  [SMALL_STATE(768)] = 37022,
  [SMALL_STATE(769)] = 37103,
  [SMALL_STATE(770)] = 37162,
  [SMALL_STATE(771)] = 37245,
  [SMALL_STATE(772)] = 37326,
  [SMALL_STATE(773)] = 37409,
  [SMALL_STATE(774)] = 37492,
  [SMALL_STATE(775)] = 37575,
  [SMALL_STATE(776)] = 37632,
  [SMALL_STATE(777)] = 37715,
  [SMALL_STATE(778)] = 37770,
  [SMALL_STATE(779)] = 37813,
  [SMALL_STATE(780)] = 37866,
  [SMALL_STATE(781)] = 37947,
  [SMALL_STATE(782)] = 37990,
  [SMALL_STATE(783)] = 38039,
  [SMALL_STATE(784)] = 38120,
  [SMALL_STATE(785)] = 38167,
  [SMALL_STATE(786)] = 38218,
  [SMALL_STATE(787)] = 38299,
  [SMALL_STATE(788)] = 38350,
  [SMALL_STATE(789)] = 38433,
  [SMALL_STATE(790)] = 38488,
  [SMALL_STATE(791)] = 38569,
  [SMALL_STATE(792)] = 38650,
  [SMALL_STATE(793)] = 38730,
  [SMALL_STATE(794)] = 38810,
  [SMALL_STATE(795)] = 38890,
  [SMALL_STATE(796)] = 38970,
  [SMALL_STATE(797)] = 39020,
  [SMALL_STATE(798)] = 39100,
  [SMALL_STATE(799)] = 39146,
  [SMALL_STATE(800)] = 39226,
  [SMALL_STATE(801)] = 39306,
  [SMALL_STATE(802)] = 39354,
  [SMALL_STATE(803)] = 39400,
  [SMALL_STATE(804)] = 39480,
  [SMALL_STATE(805)] = 39560,
  [SMALL_STATE(806)] = 39640,
  [SMALL_STATE(807)] = 39720,
  [SMALL_STATE(808)] = 39800,
  [SMALL_STATE(809)] = 39880,
  [SMALL_STATE(810)] = 39960,
  [SMALL_STATE(811)] = 40040,
  [SMALL_STATE(812)] = 40120,
  [SMALL_STATE(813)] = 40200,
  [SMALL_STATE(814)] = 40280,
  [SMALL_STATE(815)] = 40360,
  [SMALL_STATE(816)] = 40418,
  [SMALL_STATE(817)] = 40498,
  [SMALL_STATE(818)] = 40578,
  [SMALL_STATE(819)] = 40658,
  [SMALL_STATE(820)] = 40738,
  [SMALL_STATE(821)] = 40818,
  [SMALL_STATE(822)] = 40898,
  [SMALL_STATE(823)] = 40978,
  [SMALL_STATE(824)] = 41058,
  [SMALL_STATE(825)] = 41138,
  [SMALL_STATE(826)] = 41218,
  [SMALL_STATE(827)] = 41298,
  [SMALL_STATE(828)] = 41378,
  [SMALL_STATE(829)] = 41458,
  [SMALL_STATE(830)] = 41538,
  [SMALL_STATE(831)] = 41618,
  [SMALL_STATE(832)] = 41666,
  [SMALL_STATE(833)] = 41746,
  [SMALL_STATE(834)] = 41826,
  [SMALL_STATE(835)] = 41906,
  [SMALL_STATE(836)] = 41956,
  [SMALL_STATE(837)] = 42036,
  [SMALL_STATE(838)] = 42084,
  [SMALL_STATE(839)] = 42140,
  [SMALL_STATE(840)] = 42220,
  [SMALL_STATE(841)] = 42272,
  [SMALL_STATE(842)] = 42332,
  [SMALL_STATE(843)] = 42412,
  [SMALL_STATE(844)] = 42492,
  [SMALL_STATE(845)] = 42572,
  [SMALL_STATE(846)] = 42652,
  [SMALL_STATE(847)] = 42732,
  [SMALL_STATE(848)] = 42812,
  [SMALL_STATE(849)] = 42892,
  [SMALL_STATE(850)] = 42944,
  [SMALL_STATE(851)] = 43024,
  [SMALL_STATE(852)] = 43076,
  [SMALL_STATE(853)] = 43156,
  [SMALL_STATE(854)] = 43236,
  [SMALL_STATE(855)] = 43316,
  [SMALL_STATE(856)] = 43391,
  [SMALL_STATE(857)] = 43466,
  [SMALL_STATE(858)] = 43541,
  [SMALL_STATE(859)] = 43616,
  [SMALL_STATE(860)] = 43691,
  [SMALL_STATE(861)] = 43768,
  [SMALL_STATE(862)] = 43843,
  [SMALL_STATE(863)] = 43918,
  [SMALL_STATE(864)] = 43993,
  [SMALL_STATE(865)] = 44068,
  [SMALL_STATE(866)] = 44143,
  [SMALL_STATE(867)] = 44218,
  [SMALL_STATE(868)] = 44293,
  [SMALL_STATE(869)] = 44368,
  [SMALL_STATE(870)] = 44443,
  [SMALL_STATE(871)] = 44518,
  [SMALL_STATE(872)] = 44595,
  [SMALL_STATE(873)] = 44670,
  [SMALL_STATE(874)] = 44747,
  [SMALL_STATE(875)] = 44822,
  [SMALL_STATE(876)] = 44897,
  [SMALL_STATE(877)] = 44972,
  [SMALL_STATE(878)] = 45047,
  [SMALL_STATE(879)] = 45122,
  [SMALL_STATE(880)] = 45197,
  [SMALL_STATE(881)] = 45272,
  [SMALL_STATE(882)] = 45347,
  [SMALL_STATE(883)] = 45424,
  [SMALL_STATE(884)] = 45499,
  [SMALL_STATE(885)] = 45574,
  [SMALL_STATE(886)] = 45649,
  [SMALL_STATE(887)] = 45724,
  [SMALL_STATE(888)] = 45799,
  [SMALL_STATE(889)] = 45874,
  [SMALL_STATE(890)] = 45949,
  [SMALL_STATE(891)] = 46024,
  [SMALL_STATE(892)] = 46099,
  [SMALL_STATE(893)] = 46174,
  [SMALL_STATE(894)] = 46249,
  [SMALL_STATE(895)] = 46324,
  [SMALL_STATE(896)] = 46399,
  [SMALL_STATE(897)] = 46474,
  [SMALL_STATE(898)] = 46549,
  [SMALL_STATE(899)] = 46624,
  [SMALL_STATE(900)] = 46699,
  [SMALL_STATE(901)] = 46774,
  [SMALL_STATE(902)] = 46849,
  [SMALL_STATE(903)] = 46924,
  [SMALL_STATE(904)] = 46999,
  [SMALL_STATE(905)] = 47074,
  [SMALL_STATE(906)] = 47149,
  [SMALL_STATE(907)] = 47224,
  [SMALL_STATE(908)] = 47299,
  [SMALL_STATE(909)] = 47374,
  [SMALL_STATE(910)] = 47449,
  [SMALL_STATE(911)] = 47524,
  [SMALL_STATE(912)] = 47599,
  [SMALL_STATE(913)] = 47674,
  [SMALL_STATE(914)] = 47749,
  [SMALL_STATE(915)] = 47824,
  [SMALL_STATE(916)] = 47899,
  [SMALL_STATE(917)] = 47974,
  [SMALL_STATE(918)] = 48049,
  [SMALL_STATE(919)] = 48124,
  [SMALL_STATE(920)] = 48199,
  [SMALL_STATE(921)] = 48274,
  [SMALL_STATE(922)] = 48351,
  [SMALL_STATE(923)] = 48426,
  [SMALL_STATE(924)] = 48501,
  [SMALL_STATE(925)] = 48576,
  [SMALL_STATE(926)] = 48651,
  [SMALL_STATE(927)] = 48726,
  [SMALL_STATE(928)] = 48801,
  [SMALL_STATE(929)] = 48876,
  [SMALL_STATE(930)] = 48951,
  [SMALL_STATE(931)] = 49026,
  [SMALL_STATE(932)] = 49075,
  [SMALL_STATE(933)] = 49150,
  [SMALL_STATE(934)] = 49227,
  [SMALL_STATE(935)] = 49304,
  [SMALL_STATE(936)] = 49381,
  [SMALL_STATE(937)] = 49426,
  [SMALL_STATE(938)] = 49503,
  [SMALL_STATE(939)] = 49580,
  [SMALL_STATE(940)] = 49655,
  [SMALL_STATE(941)] = 49732,
  [SMALL_STATE(942)] = 49807,
  [SMALL_STATE(943)] = 49884,
  [SMALL_STATE(944)] = 49959,
  [SMALL_STATE(945)] = 50034,
  [SMALL_STATE(946)] = 50109,
  [SMALL_STATE(947)] = 50186,
  [SMALL_STATE(948)] = 50261,
  [SMALL_STATE(949)] = 50308,
  [SMALL_STATE(950)] = 50383,
  [SMALL_STATE(951)] = 50458,
  [SMALL_STATE(952)] = 50535,
  [SMALL_STATE(953)] = 50612,
  [SMALL_STATE(954)] = 50689,
  [SMALL_STATE(955)] = 50764,
  [SMALL_STATE(956)] = 50839,
  [SMALL_STATE(957)] = 50916,
  [SMALL_STATE(958)] = 50991,
  [SMALL_STATE(959)] = 51066,
  [SMALL_STATE(960)] = 51141,
  [SMALL_STATE(961)] = 51216,
  [SMALL_STATE(962)] = 51291,
  [SMALL_STATE(963)] = 51366,
  [SMALL_STATE(964)] = 51441,
  [SMALL_STATE(965)] = 51516,
  [SMALL_STATE(966)] = 51569,
  [SMALL_STATE(967)] = 51646,
  [SMALL_STATE(968)] = 51721,
  [SMALL_STATE(969)] = 51770,
  [SMALL_STATE(970)] = 51845,
  [SMALL_STATE(971)] = 51920,
  [SMALL_STATE(972)] = 51995,
  [SMALL_STATE(973)] = 52070,
  [SMALL_STATE(974)] = 52145,
  [SMALL_STATE(975)] = 52220,
  [SMALL_STATE(976)] = 52295,
  [SMALL_STATE(977)] = 52370,
  [SMALL_STATE(978)] = 52447,
  [SMALL_STATE(979)] = 52492,
  [SMALL_STATE(980)] = 52567,
  [SMALL_STATE(981)] = 52614,
  [SMALL_STATE(982)] = 52689,
  [SMALL_STATE(983)] = 52764,
  [SMALL_STATE(984)] = 52839,
  [SMALL_STATE(985)] = 52916,
  [SMALL_STATE(986)] = 52991,
  [SMALL_STATE(987)] = 53066,
  [SMALL_STATE(988)] = 53141,
  [SMALL_STATE(989)] = 53216,
  [SMALL_STATE(990)] = 53291,
  [SMALL_STATE(991)] = 53368,
  [SMALL_STATE(992)] = 53419,
  [SMALL_STATE(993)] = 53494,
  [SMALL_STATE(994)] = 53549,
  [SMALL_STATE(995)] = 53626,
  [SMALL_STATE(996)] = 53683,
  [SMALL_STATE(997)] = 53758,
  [SMALL_STATE(998)] = 53833,
  [SMALL_STATE(999)] = 53908,
  [SMALL_STATE(1000)] = 53983,
  [SMALL_STATE(1001)] = 54058,
  [SMALL_STATE(1002)] = 54111,
  [SMALL_STATE(1003)] = 54172,
  [SMALL_STATE(1004)] = 54247,
  [SMALL_STATE(1005)] = 54322,
  [SMALL_STATE(1006)] = 54397,
  [SMALL_STATE(1007)] = 54458,
  [SMALL_STATE(1008)] = 54519,
  [SMALL_STATE(1009)] = 54594,
  [SMALL_STATE(1010)] = 54669,
  [SMALL_STATE(1011)] = 54744,
  [SMALL_STATE(1012)] = 54819,
  [SMALL_STATE(1013)] = 54894,
  [SMALL_STATE(1014)] = 54971,
  [SMALL_STATE(1015)] = 55046,
  [SMALL_STATE(1016)] = 55121,
  [SMALL_STATE(1017)] = 55196,
  [SMALL_STATE(1018)] = 55271,
  [SMALL_STATE(1019)] = 55348,
  [SMALL_STATE(1020)] = 55423,
  [SMALL_STATE(1021)] = 55498,
  [SMALL_STATE(1022)] = 55573,
  [SMALL_STATE(1023)] = 55648,
  [SMALL_STATE(1024)] = 55723,
  [SMALL_STATE(1025)] = 55798,
  [SMALL_STATE(1026)] = 55873,
  [SMALL_STATE(1027)] = 55948,
  [SMALL_STATE(1028)] = 56023,
  [SMALL_STATE(1029)] = 56098,
  [SMALL_STATE(1030)] = 56173,
  [SMALL_STATE(1031)] = 56250,
  [SMALL_STATE(1032)] = 56325,
  [SMALL_STATE(1033)] = 56400,
  [SMALL_STATE(1034)] = 56475,
  [SMALL_STATE(1035)] = 56550,
  [SMALL_STATE(1036)] = 56625,
  [SMALL_STATE(1037)] = 56686,
  [SMALL_STATE(1038)] = 56761,
  [SMALL_STATE(1039)] = 56836,
  [SMALL_STATE(1040)] = 56911,
  [SMALL_STATE(1041)] = 56986,
  [SMALL_STATE(1042)] = 57061,
  [SMALL_STATE(1043)] = 57138,
  [SMALL_STATE(1044)] = 57213,
  [SMALL_STATE(1045)] = 57288,
  [SMALL_STATE(1046)] = 57363,
  [SMALL_STATE(1047)] = 57440,
  [SMALL_STATE(1048)] = 57515,
  [SMALL_STATE(1049)] = 57590,
  [SMALL_STATE(1050)] = 57665,
  [SMALL_STATE(1051)] = 57742,
  [SMALL_STATE(1052)] = 57817,
  [SMALL_STATE(1053)] = 57892,
  [SMALL_STATE(1054)] = 57967,
  [SMALL_STATE(1055)] = 58044,
  [SMALL_STATE(1056)] = 58119,
  [SMALL_STATE(1057)] = 58194,
  [SMALL_STATE(1058)] = 58269,
  [SMALL_STATE(1059)] = 58344,
  [SMALL_STATE(1060)] = 58419,
  [SMALL_STATE(1061)] = 58494,
  [SMALL_STATE(1062)] = 58571,
  [SMALL_STATE(1063)] = 58648,
  [SMALL_STATE(1064)] = 58703,
  [SMALL_STATE(1065)] = 58780,
  [SMALL_STATE(1066)] = 58857,
  [SMALL_STATE(1067)] = 58934,
  [SMALL_STATE(1068)] = 59009,
  [SMALL_STATE(1069)] = 59084,
  [SMALL_STATE(1070)] = 59159,
  [SMALL_STATE(1071)] = 59234,
  [SMALL_STATE(1072)] = 59309,
  [SMALL_STATE(1073)] = 59384,
  [SMALL_STATE(1074)] = 59459,
  [SMALL_STATE(1075)] = 59508,
  [SMALL_STATE(1076)] = 59585,
  [SMALL_STATE(1077)] = 59662,
  [SMALL_STATE(1078)] = 59739,
  [SMALL_STATE(1079)] = 59814,
  [SMALL_STATE(1080)] = 59863,
  [SMALL_STATE(1081)] = 59908,
  [SMALL_STATE(1082)] = 59985,
  [SMALL_STATE(1083)] = 60030,
  [SMALL_STATE(1084)] = 60107,
  [SMALL_STATE(1085)] = 60184,
  [SMALL_STATE(1086)] = 60261,
  [SMALL_STATE(1087)] = 60338,
  [SMALL_STATE(1088)] = 60415,
  [SMALL_STATE(1089)] = 60492,
  [SMALL_STATE(1090)] = 60569,
  [SMALL_STATE(1091)] = 60644,
  [SMALL_STATE(1092)] = 60721,
  [SMALL_STATE(1093)] = 60796,
  [SMALL_STATE(1094)] = 60873,
  [SMALL_STATE(1095)] = 60918,
  [SMALL_STATE(1096)] = 60993,
  [SMALL_STATE(1097)] = 61070,
  [SMALL_STATE(1098)] = 61147,
  [SMALL_STATE(1099)] = 61222,
  [SMALL_STATE(1100)] = 61299,
  [SMALL_STATE(1101)] = 61376,
  [SMALL_STATE(1102)] = 61453,
  [SMALL_STATE(1103)] = 61530,
  [SMALL_STATE(1104)] = 61607,
  [SMALL_STATE(1105)] = 61684,
  [SMALL_STATE(1106)] = 61761,
  [SMALL_STATE(1107)] = 61836,
  [SMALL_STATE(1108)] = 61913,
  [SMALL_STATE(1109)] = 61990,
  [SMALL_STATE(1110)] = 62067,
  [SMALL_STATE(1111)] = 62142,
  [SMALL_STATE(1112)] = 62195,
  [SMALL_STATE(1113)] = 62272,
  [SMALL_STATE(1114)] = 62349,
  [SMALL_STATE(1115)] = 62426,
  [SMALL_STATE(1116)] = 62501,
  [SMALL_STATE(1117)] = 62576,
  [SMALL_STATE(1118)] = 62653,
  [SMALL_STATE(1119)] = 62728,
  [SMALL_STATE(1120)] = 62803,
  [SMALL_STATE(1121)] = 62880,
  [SMALL_STATE(1122)] = 62929,
  [SMALL_STATE(1123)] = 63004,
  [SMALL_STATE(1124)] = 63079,
  [SMALL_STATE(1125)] = 63154,
  [SMALL_STATE(1126)] = 63229,
  [SMALL_STATE(1127)] = 63304,
  [SMALL_STATE(1128)] = 63379,
  [SMALL_STATE(1129)] = 63454,
  [SMALL_STATE(1130)] = 63529,
  [SMALL_STATE(1131)] = 63604,
  [SMALL_STATE(1132)] = 63653,
  [SMALL_STATE(1133)] = 63708,
  [SMALL_STATE(1134)] = 63785,
  [SMALL_STATE(1135)] = 63862,
  [SMALL_STATE(1136)] = 63937,
  [SMALL_STATE(1137)] = 64012,
  [SMALL_STATE(1138)] = 64087,
  [SMALL_STATE(1139)] = 64162,
  [SMALL_STATE(1140)] = 64237,
  [SMALL_STATE(1141)] = 64312,
  [SMALL_STATE(1142)] = 64387,
  [SMALL_STATE(1143)] = 64462,
  [SMALL_STATE(1144)] = 64537,
  [SMALL_STATE(1145)] = 64612,
  [SMALL_STATE(1146)] = 64675,
  [SMALL_STATE(1147)] = 64752,
  [SMALL_STATE(1148)] = 64829,
  [SMALL_STATE(1149)] = 64906,
  [SMALL_STATE(1150)] = 64983,
  [SMALL_STATE(1151)] = 65060,
  [SMALL_STATE(1152)] = 65135,
  [SMALL_STATE(1153)] = 65210,
  [SMALL_STATE(1154)] = 65285,
  [SMALL_STATE(1155)] = 65360,
  [SMALL_STATE(1156)] = 65435,
  [SMALL_STATE(1157)] = 65510,
  [SMALL_STATE(1158)] = 65587,
  [SMALL_STATE(1159)] = 65664,
  [SMALL_STATE(1160)] = 65741,
  [SMALL_STATE(1161)] = 65816,
  [SMALL_STATE(1162)] = 65891,
  [SMALL_STATE(1163)] = 65966,
  [SMALL_STATE(1164)] = 66011,
  [SMALL_STATE(1165)] = 66086,
  [SMALL_STATE(1166)] = 66161,
  [SMALL_STATE(1167)] = 66236,
  [SMALL_STATE(1168)] = 66311,
  [SMALL_STATE(1169)] = 66386,
  [SMALL_STATE(1170)] = 66461,
  [SMALL_STATE(1171)] = 66536,
  [SMALL_STATE(1172)] = 66611,
  [SMALL_STATE(1173)] = 66688,
  [SMALL_STATE(1174)] = 66765,
  [SMALL_STATE(1175)] = 66840,
  [SMALL_STATE(1176)] = 66917,
  [SMALL_STATE(1177)] = 66992,
  [SMALL_STATE(1178)] = 67067,
  [SMALL_STATE(1179)] = 67144,
  [SMALL_STATE(1180)] = 67221,
  [SMALL_STATE(1181)] = 67296,
  [SMALL_STATE(1182)] = 67373,
  [SMALL_STATE(1183)] = 67448,
  [SMALL_STATE(1184)] = 67523,
  [SMALL_STATE(1185)] = 67600,
  [SMALL_STATE(1186)] = 67675,
  [SMALL_STATE(1187)] = 67750,
  [SMALL_STATE(1188)] = 67825,
  [SMALL_STATE(1189)] = 67902,
  [SMALL_STATE(1190)] = 67977,
  [SMALL_STATE(1191)] = 68054,
  [SMALL_STATE(1192)] = 68131,
  [SMALL_STATE(1193)] = 68206,
  [SMALL_STATE(1194)] = 68281,
  [SMALL_STATE(1195)] = 68356,
  [SMALL_STATE(1196)] = 68431,
  [SMALL_STATE(1197)] = 68506,
  [SMALL_STATE(1198)] = 68581,
  [SMALL_STATE(1199)] = 68656,
  [SMALL_STATE(1200)] = 68731,
  [SMALL_STATE(1201)] = 68806,
  [SMALL_STATE(1202)] = 68881,
  [SMALL_STATE(1203)] = 68958,
  [SMALL_STATE(1204)] = 69035,
  [SMALL_STATE(1205)] = 69110,
  [SMALL_STATE(1206)] = 69185,
  [SMALL_STATE(1207)] = 69260,
  [SMALL_STATE(1208)] = 69335,
  [SMALL_STATE(1209)] = 69412,
  [SMALL_STATE(1210)] = 69487,
  [SMALL_STATE(1211)] = 69562,
  [SMALL_STATE(1212)] = 69639,
  [SMALL_STATE(1213)] = 69714,
  [SMALL_STATE(1214)] = 69789,
  [SMALL_STATE(1215)] = 69864,
  [SMALL_STATE(1216)] = 69939,
  [SMALL_STATE(1217)] = 70014,
  [SMALL_STATE(1218)] = 70089,
  [SMALL_STATE(1219)] = 70136,
  [SMALL_STATE(1220)] = 70184,
  [SMALL_STATE(1221)] = 70226,
  [SMALL_STATE(1222)] = 70268,
  [SMALL_STATE(1223)] = 70320,
  [SMALL_STATE(1224)] = 70372,
  [SMALL_STATE(1225)] = 70414,
  [SMALL_STATE(1226)] = 70458,
  [SMALL_STATE(1227)] = 70500,
  [SMALL_STATE(1228)] = 70562,
  [SMALL_STATE(1229)] = 70604,
  [SMALL_STATE(1230)] = 70648,
  [SMALL_STATE(1231)] = 70690,
  [SMALL_STATE(1232)] = 70732,
  [SMALL_STATE(1233)] = 70776,
  [SMALL_STATE(1234)] = 70818,
  [SMALL_STATE(1235)] = 70864,
  [SMALL_STATE(1236)] = 70906,
  [SMALL_STATE(1237)] = 70948,
  [SMALL_STATE(1238)] = 70990,
  [SMALL_STATE(1239)] = 71032,
  [SMALL_STATE(1240)] = 71076,
  [SMALL_STATE(1241)] = 71118,
  [SMALL_STATE(1242)] = 71168,
  [SMALL_STATE(1243)] = 71212,
  [SMALL_STATE(1244)] = 71254,
  [SMALL_STATE(1245)] = 71298,
  [SMALL_STATE(1246)] = 71340,
  [SMALL_STATE(1247)] = 71384,
  [SMALL_STATE(1248)] = 71426,
  [SMALL_STATE(1249)] = 71470,
  [SMALL_STATE(1250)] = 71512,
  [SMALL_STATE(1251)] = 71554,
  [SMALL_STATE(1252)] = 71596,
  [SMALL_STATE(1253)] = 71638,
  [SMALL_STATE(1254)] = 71680,
  [SMALL_STATE(1255)] = 71724,
  [SMALL_STATE(1256)] = 71766,
  [SMALL_STATE(1257)] = 71810,
  [SMALL_STATE(1258)] = 71852,
  [SMALL_STATE(1259)] = 71896,
  [SMALL_STATE(1260)] = 71938,
  [SMALL_STATE(1261)] = 71982,
  [SMALL_STATE(1262)] = 72024,
  [SMALL_STATE(1263)] = 72068,
  [SMALL_STATE(1264)] = 72110,
  [SMALL_STATE(1265)] = 72154,
  [SMALL_STATE(1266)] = 72196,
  [SMALL_STATE(1267)] = 72238,
  [SMALL_STATE(1268)] = 72282,
  [SMALL_STATE(1269)] = 72324,
  [SMALL_STATE(1270)] = 72370,
  [SMALL_STATE(1271)] = 72412,
  [SMALL_STATE(1272)] = 72456,
  [SMALL_STATE(1273)] = 72498,
  [SMALL_STATE(1274)] = 72546,
  [SMALL_STATE(1275)] = 72590,
  [SMALL_STATE(1276)] = 72632,
  [SMALL_STATE(1277)] = 72676,
  [SMALL_STATE(1278)] = 72718,
  [SMALL_STATE(1279)] = 72762,
  [SMALL_STATE(1280)] = 72804,
  [SMALL_STATE(1281)] = 72848,
  [SMALL_STATE(1282)] = 72890,
  [SMALL_STATE(1283)] = 72932,
  [SMALL_STATE(1284)] = 72992,
  [SMALL_STATE(1285)] = 73052,
  [SMALL_STATE(1286)] = 73112,
  [SMALL_STATE(1287)] = 73172,
  [SMALL_STATE(1288)] = 73224,
  [SMALL_STATE(1289)] = 73280,
  [SMALL_STATE(1290)] = 73334,
  [SMALL_STATE(1291)] = 73384,
  [SMALL_STATE(1292)] = 73430,
  [SMALL_STATE(1293)] = 73474,
  [SMALL_STATE(1294)] = 73520,
  [SMALL_STATE(1295)] = 73568,
  [SMALL_STATE(1296)] = 73620,
  [SMALL_STATE(1297)] = 73664,
  [SMALL_STATE(1298)] = 73708,
  [SMALL_STATE(1299)] = 73763,
  [SMALL_STATE(1300)] = 73802,
  [SMALL_STATE(1301)] = 73843,
  [SMALL_STATE(1302)] = 73888,
  [SMALL_STATE(1303)] = 73935,
  [SMALL_STATE(1304)] = 73988,
  [SMALL_STATE(1305)] = 74027,
  [SMALL_STATE(1306)] = 74066,
  [SMALL_STATE(1307)] = 74115,
  [SMALL_STATE(1308)] = 74172,
  [SMALL_STATE(1309)] = 74231,
  [SMALL_STATE(1310)] = 74294,
  [SMALL_STATE(1311)] = 74357,
  [SMALL_STATE(1312)] = 74420,
  [SMALL_STATE(1313)] = 74459,
  [SMALL_STATE(1314)] = 74522,
  [SMALL_STATE(1315)] = 74571,
  [SMALL_STATE(1316)] = 74638,
  [SMALL_STATE(1317)] = 74677,
  [SMALL_STATE(1318)] = 74718,
  [SMALL_STATE(1319)] = 74757,
  [SMALL_STATE(1320)] = 74812,
  [SMALL_STATE(1321)] = 74851,
  [SMALL_STATE(1322)] = 74890,
  [SMALL_STATE(1323)] = 74931,
  [SMALL_STATE(1324)] = 74970,
  [SMALL_STATE(1325)] = 75009,
  [SMALL_STATE(1326)] = 75050,
  [SMALL_STATE(1327)] = 75089,
  [SMALL_STATE(1328)] = 75136,
  [SMALL_STATE(1329)] = 75177,
  [SMALL_STATE(1330)] = 75216,
  [SMALL_STATE(1331)] = 75257,
  [SMALL_STATE(1332)] = 75296,
  [SMALL_STATE(1333)] = 75335,
  [SMALL_STATE(1334)] = 75374,
  [SMALL_STATE(1335)] = 75413,
  [SMALL_STATE(1336)] = 75460,
  [SMALL_STATE(1337)] = 75501,
  [SMALL_STATE(1338)] = 75540,
  [SMALL_STATE(1339)] = 75589,
  [SMALL_STATE(1340)] = 75628,
  [SMALL_STATE(1341)] = 75669,
  [SMALL_STATE(1342)] = 75710,
  [SMALL_STATE(1343)] = 75757,
  [SMALL_STATE(1344)] = 75796,
  [SMALL_STATE(1345)] = 75835,
  [SMALL_STATE(1346)] = 75874,
  [SMALL_STATE(1347)] = 75915,
  [SMALL_STATE(1348)] = 75954,
  [SMALL_STATE(1349)] = 76005,
  [SMALL_STATE(1350)] = 76050,
  [SMALL_STATE(1351)] = 76089,
  [SMALL_STATE(1352)] = 76128,
  [SMALL_STATE(1353)] = 76167,
  [SMALL_STATE(1354)] = 76208,
  [SMALL_STATE(1355)] = 76249,
  [SMALL_STATE(1356)] = 76288,
  [SMALL_STATE(1357)] = 76327,
  [SMALL_STATE(1358)] = 76368,
  [SMALL_STATE(1359)] = 76407,
  [SMALL_STATE(1360)] = 76448,
  [SMALL_STATE(1361)] = 76487,
  [SMALL_STATE(1362)] = 76528,
  [SMALL_STATE(1363)] = 76567,
  [SMALL_STATE(1364)] = 76608,
  [SMALL_STATE(1365)] = 76647,
  [SMALL_STATE(1366)] = 76686,
  [SMALL_STATE(1367)] = 76727,
  [SMALL_STATE(1368)] = 76766,
  [SMALL_STATE(1369)] = 76805,
  [SMALL_STATE(1370)] = 76846,
  [SMALL_STATE(1371)] = 76887,
  [SMALL_STATE(1372)] = 76926,
  [SMALL_STATE(1373)] = 76975,
  [SMALL_STATE(1374)] = 77016,
  [SMALL_STATE(1375)] = 77072,
  [SMALL_STATE(1376)] = 77128,
  [SMALL_STATE(1377)] = 77168,
  [SMALL_STATE(1378)] = 77218,
  [SMALL_STATE(1379)] = 77262,
  [SMALL_STATE(1380)] = 77302,
  [SMALL_STATE(1381)] = 77358,
  [SMALL_STATE(1382)] = 77398,
  [SMALL_STATE(1383)] = 77454,
  [SMALL_STATE(1384)] = 77498,
  [SMALL_STATE(1385)] = 77548,
  [SMALL_STATE(1386)] = 77588,
  [SMALL_STATE(1387)] = 77628,
  [SMALL_STATE(1388)] = 77684,
  [SMALL_STATE(1389)] = 77740,
  [SMALL_STATE(1390)] = 77780,
  [SMALL_STATE(1391)] = 77824,
  [SMALL_STATE(1392)] = 77864,
  [SMALL_STATE(1393)] = 77904,
  [SMALL_STATE(1394)] = 77949,
  [SMALL_STATE(1395)] = 78002,
  [SMALL_STATE(1396)] = 78055,
  [SMALL_STATE(1397)] = 78098,
  [SMALL_STATE(1398)] = 78141,
  [SMALL_STATE(1399)] = 78184,
  [SMALL_STATE(1400)] = 78237,
  [SMALL_STATE(1401)] = 78276,
  [SMALL_STATE(1402)] = 78329,
  [SMALL_STATE(1403)] = 78370,
  [SMALL_STATE(1404)] = 78423,
  [SMALL_STATE(1405)] = 78470,
  [SMALL_STATE(1406)] = 78523,
  [SMALL_STATE(1407)] = 78564,
  [SMALL_STATE(1408)] = 78603,
  [SMALL_STATE(1409)] = 78642,
  [SMALL_STATE(1410)] = 78685,
  [SMALL_STATE(1411)] = 78724,
  [SMALL_STATE(1412)] = 78764,
  [SMALL_STATE(1413)] = 78802,
  [SMALL_STATE(1414)] = 78840,
  [SMALL_STATE(1415)] = 78878,
  [SMALL_STATE(1416)] = 78916,
  [SMALL_STATE(1417)] = 78954,
  [SMALL_STATE(1418)] = 79002,
  [SMALL_STATE(1419)] = 79042,
  [SMALL_STATE(1420)] = 79080,
  [SMALL_STATE(1421)] = 79118,
  [SMALL_STATE(1422)] = 79156,
  [SMALL_STATE(1423)] = 79194,
  [SMALL_STATE(1424)] = 79234,
  [SMALL_STATE(1425)] = 79272,
  [SMALL_STATE(1426)] = 79312,
  [SMALL_STATE(1427)] = 79354,
  [SMALL_STATE(1428)] = 79394,
  [SMALL_STATE(1429)] = 79434,
  [SMALL_STATE(1430)] = 79472,
  [SMALL_STATE(1431)] = 79512,
  [SMALL_STATE(1432)] = 79552,
  [SMALL_STATE(1433)] = 79590,
  [SMALL_STATE(1434)] = 79628,
  [SMALL_STATE(1435)] = 79666,
  [SMALL_STATE(1436)] = 79704,
  [SMALL_STATE(1437)] = 79742,
  [SMALL_STATE(1438)] = 79780,
  [SMALL_STATE(1439)] = 79818,
  [SMALL_STATE(1440)] = 79858,
  [SMALL_STATE(1441)] = 79896,
  [SMALL_STATE(1442)] = 79934,
  [SMALL_STATE(1443)] = 79978,
  [SMALL_STATE(1444)] = 80022,
  [SMALL_STATE(1445)] = 80060,
  [SMALL_STATE(1446)] = 80098,
  [SMALL_STATE(1447)] = 80135,
  [SMALL_STATE(1448)] = 80172,
  [SMALL_STATE(1449)] = 80229,
  [SMALL_STATE(1450)] = 80284,
  [SMALL_STATE(1451)] = 80339,
  [SMALL_STATE(1452)] = 80394,
  [SMALL_STATE(1453)] = 80449,
  [SMALL_STATE(1454)] = 80496,
  [SMALL_STATE(1455)] = 80543,
  [SMALL_STATE(1456)] = 80578,
  [SMALL_STATE(1457)] = 80615,
  [SMALL_STATE(1458)] = 80652,
  [SMALL_STATE(1459)] = 80689,
  [SMALL_STATE(1460)] = 80740,
  [SMALL_STATE(1461)] = 80789,
  [SMALL_STATE(1462)] = 80834,
  [SMALL_STATE(1463)] = 80875,
  [SMALL_STATE(1464)] = 80914,
  [SMALL_STATE(1465)] = 80957,
  [SMALL_STATE(1466)] = 81004,
  [SMALL_STATE(1467)] = 81041,
  [SMALL_STATE(1468)] = 81078,
  [SMALL_STATE(1469)] = 81115,
  [SMALL_STATE(1470)] = 81152,
  [SMALL_STATE(1471)] = 81189,
  [SMALL_STATE(1472)] = 81226,
  [SMALL_STATE(1473)] = 81263,
  [SMALL_STATE(1474)] = 81300,
  [SMALL_STATE(1475)] = 81335,
  [SMALL_STATE(1476)] = 81372,
  [SMALL_STATE(1477)] = 81409,
  [SMALL_STATE(1478)] = 81446,
  [SMALL_STATE(1479)] = 81483,
  [SMALL_STATE(1480)] = 81520,
  [SMALL_STATE(1481)] = 81557,
  [SMALL_STATE(1482)] = 81594,
  [SMALL_STATE(1483)] = 81641,
  [SMALL_STATE(1484)] = 81678,
  [SMALL_STATE(1485)] = 81715,
  [SMALL_STATE(1486)] = 81754,
  [SMALL_STATE(1487)] = 81791,
  [SMALL_STATE(1488)] = 81828,
  [SMALL_STATE(1489)] = 81869,
  [SMALL_STATE(1490)] = 81906,
  [SMALL_STATE(1491)] = 81943,
  [SMALL_STATE(1492)] = 81982,
  [SMALL_STATE(1493)] = 82021,
  [SMALL_STATE(1494)] = 82060,
  [SMALL_STATE(1495)] = 82097,
  [SMALL_STATE(1496)] = 82136,
  [SMALL_STATE(1497)] = 82173,
  [SMALL_STATE(1498)] = 82212,
  [SMALL_STATE(1499)] = 82249,
  [SMALL_STATE(1500)] = 82286,
  [SMALL_STATE(1501)] = 82327,
  [SMALL_STATE(1502)] = 82364,
  [SMALL_STATE(1503)] = 82401,
  [SMALL_STATE(1504)] = 82444,
  [SMALL_STATE(1505)] = 82485,
  [SMALL_STATE(1506)] = 82529,
  [SMALL_STATE(1507)] = 82585,
  [SMALL_STATE(1508)] = 82621,
  [SMALL_STATE(1509)] = 82667,
  [SMALL_STATE(1510)] = 82721,
  [SMALL_STATE(1511)] = 82757,
  [SMALL_STATE(1512)] = 82811,
  [SMALL_STATE(1513)] = 82865,
  [SMALL_STATE(1514)] = 82907,
  [SMALL_STATE(1515)] = 82941,
  [SMALL_STATE(1516)] = 82995,
  [SMALL_STATE(1517)] = 83029,
  [SMALL_STATE(1518)] = 83065,
  [SMALL_STATE(1519)] = 83101,
  [SMALL_STATE(1520)] = 83151,
  [SMALL_STATE(1521)] = 83207,
  [SMALL_STATE(1522)] = 83255,
  [SMALL_STATE(1523)] = 83299,
  [SMALL_STATE(1524)] = 83339,
  [SMALL_STATE(1525)] = 83373,
  [SMALL_STATE(1526)] = 83411,
  [SMALL_STATE(1527)] = 83453,
  [SMALL_STATE(1528)] = 83499,
  [SMALL_STATE(1529)] = 83555,
  [SMALL_STATE(1530)] = 83611,
  [SMALL_STATE(1531)] = 83649,
  [SMALL_STATE(1532)] = 83691,
  [SMALL_STATE(1533)] = 83733,
  [SMALL_STATE(1534)] = 83779,
  [SMALL_STATE(1535)] = 83813,
  [SMALL_STATE(1536)] = 83847,
  [SMALL_STATE(1537)] = 83881,
  [SMALL_STATE(1538)] = 83915,
  [SMALL_STATE(1539)] = 83951,
  [SMALL_STATE(1540)] = 83985,
  [SMALL_STATE(1541)] = 84019,
  [SMALL_STATE(1542)] = 84053,
  [SMALL_STATE(1543)] = 84087,
  [SMALL_STATE(1544)] = 84121,
  [SMALL_STATE(1545)] = 84160,
  [SMALL_STATE(1546)] = 84205,
  [SMALL_STATE(1547)] = 84246,
  [SMALL_STATE(1548)] = 84299,
  [SMALL_STATE(1549)] = 84340,
  [SMALL_STATE(1550)] = 84393,
  [SMALL_STATE(1551)] = 84430,
  [SMALL_STATE(1552)] = 84483,
  [SMALL_STATE(1553)] = 84518,
  [SMALL_STATE(1554)] = 84559,
  [SMALL_STATE(1555)] = 84596,
  [SMALL_STATE(1556)] = 84632,
  [SMALL_STATE(1557)] = 84684,
  [SMALL_STATE(1558)] = 84738,
  [SMALL_STATE(1559)] = 84792,
  [SMALL_STATE(1560)] = 84828,
  [SMALL_STATE(1561)] = 84882,
  [SMALL_STATE(1562)] = 84920,
  [SMALL_STATE(1563)] = 84974,
  [SMALL_STATE(1564)] = 85010,
  [SMALL_STATE(1565)] = 85064,
  [SMALL_STATE(1566)] = 85102,
  [SMALL_STATE(1567)] = 85156,
  [SMALL_STATE(1568)] = 85196,
  [SMALL_STATE(1569)] = 85232,
  [SMALL_STATE(1570)] = 85268,
  [SMALL_STATE(1571)] = 85306,
  [SMALL_STATE(1572)] = 85350,
  [SMALL_STATE(1573)] = 85390,
  [SMALL_STATE(1574)] = 85426,
  [SMALL_STATE(1575)] = 85464,
  [SMALL_STATE(1576)] = 85512,
  [SMALL_STATE(1577)] = 85554,
  [SMALL_STATE(1578)] = 85594,
  [SMALL_STATE(1579)] = 85640,
  [SMALL_STATE(1580)] = 85678,
  [SMALL_STATE(1581)] = 85716,
  [SMALL_STATE(1582)] = 85760,
  [SMALL_STATE(1583)] = 85812,
  [SMALL_STATE(1584)] = 85864,
  [SMALL_STATE(1585)] = 85916,
  [SMALL_STATE(1586)] = 85955,
  [SMALL_STATE(1587)] = 86008,
  [SMALL_STATE(1588)] = 86045,
  [SMALL_STATE(1589)] = 86078,
  [SMALL_STATE(1590)] = 86113,
  [SMALL_STATE(1591)] = 86146,
  [SMALL_STATE(1592)] = 86181,
  [SMALL_STATE(1593)] = 86234,
  [SMALL_STATE(1594)] = 86269,
  [SMALL_STATE(1595)] = 86306,
  [SMALL_STATE(1596)] = 86341,
  [SMALL_STATE(1597)] = 86392,
  [SMALL_STATE(1598)] = 86443,
  [SMALL_STATE(1599)] = 86494,
  [SMALL_STATE(1600)] = 86545,
  [SMALL_STATE(1601)] = 86588,
  [SMALL_STATE(1602)] = 86627,
  [SMALL_STATE(1603)] = 86674,
  [SMALL_STATE(1604)] = 86719,
  [SMALL_STATE(1605)] = 86760,
  [SMALL_STATE(1606)] = 86797,
  [SMALL_STATE(1607)] = 86834,
  [SMALL_STATE(1608)] = 86869,
  [SMALL_STATE(1609)] = 86908,
  [SMALL_STATE(1610)] = 86951,
  [SMALL_STATE(1611)] = 87002,
  [SMALL_STATE(1612)] = 87055,
  [SMALL_STATE(1613)] = 87108,
  [SMALL_STATE(1614)] = 87159,
  [SMALL_STATE(1615)] = 87194,
  [SMALL_STATE(1616)] = 87245,
  [SMALL_STATE(1617)] = 87278,
  [SMALL_STATE(1618)] = 87311,
  [SMALL_STATE(1619)] = 87344,
  [SMALL_STATE(1620)] = 87395,
  [SMALL_STATE(1621)] = 87446,
  [SMALL_STATE(1622)] = 87484,
  [SMALL_STATE(1623)] = 87516,
  [SMALL_STATE(1624)] = 87548,
  [SMALL_STATE(1625)] = 87580,
  [SMALL_STATE(1626)] = 87634,
  [SMALL_STATE(1627)] = 87666,
  [SMALL_STATE(1628)] = 87716,
  [SMALL_STATE(1629)] = 87770,
  [SMALL_STATE(1630)] = 87802,
  [SMALL_STATE(1631)] = 87856,
  [SMALL_STATE(1632)] = 87888,
  [SMALL_STATE(1633)] = 87924,
  [SMALL_STATE(1634)] = 87978,
  [SMALL_STATE(1635)] = 88010,
  [SMALL_STATE(1636)] = 88056,
  [SMALL_STATE(1637)] = 88090,
  [SMALL_STATE(1638)] = 88122,
  [SMALL_STATE(1639)] = 88158,
  [SMALL_STATE(1640)] = 88192,
  [SMALL_STATE(1641)] = 88224,
  [SMALL_STATE(1642)] = 88256,
  [SMALL_STATE(1643)] = 88306,
  [SMALL_STATE(1644)] = 88354,
  [SMALL_STATE(1645)] = 88398,
  [SMALL_STATE(1646)] = 88448,
  [SMALL_STATE(1647)] = 88480,
  [SMALL_STATE(1648)] = 88512,
  [SMALL_STATE(1649)] = 88544,
  [SMALL_STATE(1650)] = 88576,
  [SMALL_STATE(1651)] = 88616,
  [SMALL_STATE(1652)] = 88662,
  [SMALL_STATE(1653)] = 88694,
  [SMALL_STATE(1654)] = 88726,
  [SMALL_STATE(1655)] = 88758,
  [SMALL_STATE(1656)] = 88790,
  [SMALL_STATE(1657)] = 88822,
  [SMALL_STATE(1658)] = 88854,
  [SMALL_STATE(1659)] = 88904,
  [SMALL_STATE(1660)] = 88938,
  [SMALL_STATE(1661)] = 88994,
  [SMALL_STATE(1662)] = 89026,
  [SMALL_STATE(1663)] = 89060,
  [SMALL_STATE(1664)] = 89092,
  [SMALL_STATE(1665)] = 89124,
  [SMALL_STATE(1666)] = 89156,
  [SMALL_STATE(1667)] = 89190,
  [SMALL_STATE(1668)] = 89224,
  [SMALL_STATE(1669)] = 89258,
  [SMALL_STATE(1670)] = 89298,
  [SMALL_STATE(1671)] = 89329,
  [SMALL_STATE(1672)] = 89360,
  [SMALL_STATE(1673)] = 89391,
  [SMALL_STATE(1674)] = 89422,
  [SMALL_STATE(1675)] = 89453,
  [SMALL_STATE(1676)] = 89484,
  [SMALL_STATE(1677)] = 89515,
  [SMALL_STATE(1678)] = 89546,
  [SMALL_STATE(1679)] = 89577,
  [SMALL_STATE(1680)] = 89608,
  [SMALL_STATE(1681)] = 89639,
  [SMALL_STATE(1682)] = 89670,
  [SMALL_STATE(1683)] = 89701,
  [SMALL_STATE(1684)] = 89756,
  [SMALL_STATE(1685)] = 89787,
  [SMALL_STATE(1686)] = 89818,
  [SMALL_STATE(1687)] = 89869,
  [SMALL_STATE(1688)] = 89920,
  [SMALL_STATE(1689)] = 89971,
  [SMALL_STATE(1690)] = 90002,
  [SMALL_STATE(1691)] = 90053,
  [SMALL_STATE(1692)] = 90084,
  [SMALL_STATE(1693)] = 90135,
  [SMALL_STATE(1694)] = 90166,
  [SMALL_STATE(1695)] = 90214,
  [SMALL_STATE(1696)] = 90262,
  [SMALL_STATE(1697)] = 90310,
  [SMALL_STATE(1698)] = 90358,
  [SMALL_STATE(1699)] = 90406,
  [SMALL_STATE(1700)] = 90463,
  [SMALL_STATE(1701)] = 90518,
  [SMALL_STATE(1702)] = 90572,
  [SMALL_STATE(1703)] = 90626,
  [SMALL_STATE(1704)] = 90680,
  [SMALL_STATE(1705)] = 90734,
  [SMALL_STATE(1706)] = 90788,
  [SMALL_STATE(1707)] = 90840,
  [SMALL_STATE(1708)] = 90894,
  [SMALL_STATE(1709)] = 90948,
  [SMALL_STATE(1710)] = 91002,
  [SMALL_STATE(1711)] = 91056,
  [SMALL_STATE(1712)] = 91110,
  [SMALL_STATE(1713)] = 91164,
  [SMALL_STATE(1714)] = 91218,
  [SMALL_STATE(1715)] = 91272,
  [SMALL_STATE(1716)] = 91326,
  [SMALL_STATE(1717)] = 91380,
  [SMALL_STATE(1718)] = 91434,
  [SMALL_STATE(1719)] = 91488,
  [SMALL_STATE(1720)] = 91542,
  [SMALL_STATE(1721)] = 91596,
  [SMALL_STATE(1722)] = 91650,
  [SMALL_STATE(1723)] = 91704,
  [SMALL_STATE(1724)] = 91758,
  [SMALL_STATE(1725)] = 91812,
  [SMALL_STATE(1726)] = 91866,
  [SMALL_STATE(1727)] = 91920,
  [SMALL_STATE(1728)] = 91974,
  [SMALL_STATE(1729)] = 92025,
  [SMALL_STATE(1730)] = 92076,
  [SMALL_STATE(1731)] = 92127,
  [SMALL_STATE(1732)] = 92178,
  [SMALL_STATE(1733)] = 92229,
  [SMALL_STATE(1734)] = 92280,
  [SMALL_STATE(1735)] = 92331,
  [SMALL_STATE(1736)] = 92382,
  [SMALL_STATE(1737)] = 92433,
  [SMALL_STATE(1738)] = 92484,
  [SMALL_STATE(1739)] = 92535,
  [SMALL_STATE(1740)] = 92586,
  [SMALL_STATE(1741)] = 92637,
  [SMALL_STATE(1742)] = 92688,
  [SMALL_STATE(1743)] = 92739,
  [SMALL_STATE(1744)] = 92790,
  [SMALL_STATE(1745)] = 92841,
  [SMALL_STATE(1746)] = 92892,
  [SMALL_STATE(1747)] = 92943,
  [SMALL_STATE(1748)] = 92994,
  [SMALL_STATE(1749)] = 93045,
  [SMALL_STATE(1750)] = 93096,
  [SMALL_STATE(1751)] = 93147,
  [SMALL_STATE(1752)] = 93198,
  [SMALL_STATE(1753)] = 93249,
  [SMALL_STATE(1754)] = 93300,
  [SMALL_STATE(1755)] = 93351,
  [SMALL_STATE(1756)] = 93402,
  [SMALL_STATE(1757)] = 93453,
  [SMALL_STATE(1758)] = 93504,
  [SMALL_STATE(1759)] = 93555,
  [SMALL_STATE(1760)] = 93606,
  [SMALL_STATE(1761)] = 93657,
  [SMALL_STATE(1762)] = 93708,
  [SMALL_STATE(1763)] = 93759,
  [SMALL_STATE(1764)] = 93810,
  [SMALL_STATE(1765)] = 93861,
  [SMALL_STATE(1766)] = 93912,
  [SMALL_STATE(1767)] = 93963,
  [SMALL_STATE(1768)] = 94014,
  [SMALL_STATE(1769)] = 94065,
  [SMALL_STATE(1770)] = 94116,
  [SMALL_STATE(1771)] = 94167,
  [SMALL_STATE(1772)] = 94218,
  [SMALL_STATE(1773)] = 94269,
  [SMALL_STATE(1774)] = 94320,
  [SMALL_STATE(1775)] = 94371,
  [SMALL_STATE(1776)] = 94422,
  [SMALL_STATE(1777)] = 94473,
  [SMALL_STATE(1778)] = 94524,
  [SMALL_STATE(1779)] = 94575,
  [SMALL_STATE(1780)] = 94626,
  [SMALL_STATE(1781)] = 94677,
  [SMALL_STATE(1782)] = 94728,
  [SMALL_STATE(1783)] = 94779,
  [SMALL_STATE(1784)] = 94830,
  [SMALL_STATE(1785)] = 94881,
  [SMALL_STATE(1786)] = 94932,
  [SMALL_STATE(1787)] = 94983,
  [SMALL_STATE(1788)] = 95034,
  [SMALL_STATE(1789)] = 95085,
  [SMALL_STATE(1790)] = 95136,
  [SMALL_STATE(1791)] = 95187,
  [SMALL_STATE(1792)] = 95238,
  [SMALL_STATE(1793)] = 95289,
  [SMALL_STATE(1794)] = 95340,
  [SMALL_STATE(1795)] = 95391,
  [SMALL_STATE(1796)] = 95442,
  [SMALL_STATE(1797)] = 95493,
  [SMALL_STATE(1798)] = 95544,
  [SMALL_STATE(1799)] = 95595,
  [SMALL_STATE(1800)] = 95646,
  [SMALL_STATE(1801)] = 95697,
  [SMALL_STATE(1802)] = 95748,
  [SMALL_STATE(1803)] = 95799,
  [SMALL_STATE(1804)] = 95850,
  [SMALL_STATE(1805)] = 95901,
  [SMALL_STATE(1806)] = 95952,
  [SMALL_STATE(1807)] = 96003,
  [SMALL_STATE(1808)] = 96054,
  [SMALL_STATE(1809)] = 96105,
  [SMALL_STATE(1810)] = 96156,
  [SMALL_STATE(1811)] = 96207,
  [SMALL_STATE(1812)] = 96258,
  [SMALL_STATE(1813)] = 96309,
  [SMALL_STATE(1814)] = 96360,
  [SMALL_STATE(1815)] = 96411,
  [SMALL_STATE(1816)] = 96462,
  [SMALL_STATE(1817)] = 96513,
  [SMALL_STATE(1818)] = 96564,
  [SMALL_STATE(1819)] = 96615,
  [SMALL_STATE(1820)] = 96666,
  [SMALL_STATE(1821)] = 96717,
  [SMALL_STATE(1822)] = 96765,
  [SMALL_STATE(1823)] = 96813,
  [SMALL_STATE(1824)] = 96861,
  [SMALL_STATE(1825)] = 96909,
  [SMALL_STATE(1826)] = 96957,
  [SMALL_STATE(1827)] = 97005,
  [SMALL_STATE(1828)] = 97053,
  [SMALL_STATE(1829)] = 97101,
  [SMALL_STATE(1830)] = 97149,
  [SMALL_STATE(1831)] = 97197,
  [SMALL_STATE(1832)] = 97245,
  [SMALL_STATE(1833)] = 97293,
  [SMALL_STATE(1834)] = 97341,
  [SMALL_STATE(1835)] = 97389,
  [SMALL_STATE(1836)] = 97437,
  [SMALL_STATE(1837)] = 97485,
  [SMALL_STATE(1838)] = 97504,
  [SMALL_STATE(1839)] = 97525,
  [SMALL_STATE(1840)] = 97540,
  [SMALL_STATE(1841)] = 97558,
  [SMALL_STATE(1842)] = 97576,
  [SMALL_STATE(1843)] = 97591,
  [SMALL_STATE(1844)] = 97610,
  [SMALL_STATE(1845)] = 97623,
  [SMALL_STATE(1846)] = 97636,
  [SMALL_STATE(1847)] = 97649,
  [SMALL_STATE(1848)] = 97668,
  [SMALL_STATE(1849)] = 97681,
  [SMALL_STATE(1850)] = 97700,
  [SMALL_STATE(1851)] = 97719,
  [SMALL_STATE(1852)] = 97732,
  [SMALL_STATE(1853)] = 97745,
  [SMALL_STATE(1854)] = 97764,
  [SMALL_STATE(1855)] = 97783,
  [SMALL_STATE(1856)] = 97796,
  [SMALL_STATE(1857)] = 97809,
  [SMALL_STATE(1858)] = 97827,
  [SMALL_STATE(1859)] = 97845,
  [SMALL_STATE(1860)] = 97863,
  [SMALL_STATE(1861)] = 97881,
  [SMALL_STATE(1862)] = 97893,
  [SMALL_STATE(1863)] = 97911,
  [SMALL_STATE(1864)] = 97929,
  [SMALL_STATE(1865)] = 97947,
  [SMALL_STATE(1866)] = 97959,
  [SMALL_STATE(1867)] = 97977,
  [SMALL_STATE(1868)] = 97995,
  [SMALL_STATE(1869)] = 98013,
  [SMALL_STATE(1870)] = 98031,
  [SMALL_STATE(1871)] = 98049,
  [SMALL_STATE(1872)] = 98067,
  [SMALL_STATE(1873)] = 98085,
  [SMALL_STATE(1874)] = 98103,
  [SMALL_STATE(1875)] = 98121,
  [SMALL_STATE(1876)] = 98139,
  [SMALL_STATE(1877)] = 98157,
  [SMALL_STATE(1878)] = 98175,
  [SMALL_STATE(1879)] = 98193,
  [SMALL_STATE(1880)] = 98205,
  [SMALL_STATE(1881)] = 98223,
  [SMALL_STATE(1882)] = 98241,
  [SMALL_STATE(1883)] = 98259,
  [SMALL_STATE(1884)] = 98271,
  [SMALL_STATE(1885)] = 98289,
  [SMALL_STATE(1886)] = 98307,
  [SMALL_STATE(1887)] = 98326,
  [SMALL_STATE(1888)] = 98345,
  [SMALL_STATE(1889)] = 98362,
  [SMALL_STATE(1890)] = 98381,
  [SMALL_STATE(1891)] = 98398,
  [SMALL_STATE(1892)] = 98415,
  [SMALL_STATE(1893)] = 98434,
  [SMALL_STATE(1894)] = 98453,
  [SMALL_STATE(1895)] = 98470,
  [SMALL_STATE(1896)] = 98487,
  [SMALL_STATE(1897)] = 98504,
  [SMALL_STATE(1898)] = 98521,
  [SMALL_STATE(1899)] = 98538,
  [SMALL_STATE(1900)] = 98557,
  [SMALL_STATE(1901)] = 98574,
  [SMALL_STATE(1902)] = 98593,
  [SMALL_STATE(1903)] = 98612,
  [SMALL_STATE(1904)] = 98631,
  [SMALL_STATE(1905)] = 98648,
  [SMALL_STATE(1906)] = 98665,
  [SMALL_STATE(1907)] = 98684,
  [SMALL_STATE(1908)] = 98701,
  [SMALL_STATE(1909)] = 98718,
  [SMALL_STATE(1910)] = 98735,
  [SMALL_STATE(1911)] = 98752,
  [SMALL_STATE(1912)] = 98771,
  [SMALL_STATE(1913)] = 98788,
  [SMALL_STATE(1914)] = 98805,
  [SMALL_STATE(1915)] = 98822,
  [SMALL_STATE(1916)] = 98841,
  [SMALL_STATE(1917)] = 98858,
  [SMALL_STATE(1918)] = 98873,
  [SMALL_STATE(1919)] = 98892,
  [SMALL_STATE(1920)] = 98911,
  [SMALL_STATE(1921)] = 98928,
  [SMALL_STATE(1922)] = 98947,
  [SMALL_STATE(1923)] = 98966,
  [SMALL_STATE(1924)] = 98983,
  [SMALL_STATE(1925)] = 99000,
  [SMALL_STATE(1926)] = 99019,
  [SMALL_STATE(1927)] = 99038,
  [SMALL_STATE(1928)] = 99055,
  [SMALL_STATE(1929)] = 99074,
  [SMALL_STATE(1930)] = 99089,
  [SMALL_STATE(1931)] = 99106,
  [SMALL_STATE(1932)] = 99125,
  [SMALL_STATE(1933)] = 99144,
  [SMALL_STATE(1934)] = 99163,
  [SMALL_STATE(1935)] = 99182,
  [SMALL_STATE(1936)] = 99199,
  [SMALL_STATE(1937)] = 99216,
  [SMALL_STATE(1938)] = 99235,
  [SMALL_STATE(1939)] = 99245,
  [SMALL_STATE(1940)] = 99259,
  [SMALL_STATE(1941)] = 99269,
  [SMALL_STATE(1942)] = 99283,
  [SMALL_STATE(1943)] = 99297,
  [SMALL_STATE(1944)] = 99311,
  [SMALL_STATE(1945)] = 99325,
  [SMALL_STATE(1946)] = 99339,
  [SMALL_STATE(1947)] = 99349,
  [SMALL_STATE(1948)] = 99361,
  [SMALL_STATE(1949)] = 99371,
  [SMALL_STATE(1950)] = 99385,
  [SMALL_STATE(1951)] = 99399,
  [SMALL_STATE(1952)] = 99413,
  [SMALL_STATE(1953)] = 99427,
  [SMALL_STATE(1954)] = 99441,
  [SMALL_STATE(1955)] = 99455,
  [SMALL_STATE(1956)] = 99465,
  [SMALL_STATE(1957)] = 99479,
  [SMALL_STATE(1958)] = 99493,
  [SMALL_STATE(1959)] = 99507,
  [SMALL_STATE(1960)] = 99521,
  [SMALL_STATE(1961)] = 99533,
  [SMALL_STATE(1962)] = 99547,
  [SMALL_STATE(1963)] = 99557,
  [SMALL_STATE(1964)] = 99571,
  [SMALL_STATE(1965)] = 99585,
  [SMALL_STATE(1966)] = 99595,
  [SMALL_STATE(1967)] = 99609,
  [SMALL_STATE(1968)] = 99623,
  [SMALL_STATE(1969)] = 99637,
  [SMALL_STATE(1970)] = 99651,
  [SMALL_STATE(1971)] = 99665,
  [SMALL_STATE(1972)] = 99679,
  [SMALL_STATE(1973)] = 99689,
  [SMALL_STATE(1974)] = 99703,
  [SMALL_STATE(1975)] = 99717,
  [SMALL_STATE(1976)] = 99731,
  [SMALL_STATE(1977)] = 99742,
  [SMALL_STATE(1978)] = 99753,
  [SMALL_STATE(1979)] = 99764,
  [SMALL_STATE(1980)] = 99775,
  [SMALL_STATE(1981)] = 99786,
  [SMALL_STATE(1982)] = 99795,
  [SMALL_STATE(1983)] = 99806,
  [SMALL_STATE(1984)] = 99817,
  [SMALL_STATE(1985)] = 99826,
  [SMALL_STATE(1986)] = 99837,
  [SMALL_STATE(1987)] = 99848,
  [SMALL_STATE(1988)] = 99859,
  [SMALL_STATE(1989)] = 99870,
  [SMALL_STATE(1990)] = 99879,
  [SMALL_STATE(1991)] = 99890,
  [SMALL_STATE(1992)] = 99901,
  [SMALL_STATE(1993)] = 99912,
  [SMALL_STATE(1994)] = 99923,
  [SMALL_STATE(1995)] = 99934,
  [SMALL_STATE(1996)] = 99945,
  [SMALL_STATE(1997)] = 99952,
  [SMALL_STATE(1998)] = 99963,
  [SMALL_STATE(1999)] = 99974,
  [SMALL_STATE(2000)] = 99985,
  [SMALL_STATE(2001)] = 99996,
  [SMALL_STATE(2002)] = 100007,
  [SMALL_STATE(2003)] = 100018,
  [SMALL_STATE(2004)] = 100029,
  [SMALL_STATE(2005)] = 100040,
  [SMALL_STATE(2006)] = 100049,
  [SMALL_STATE(2007)] = 100060,
  [SMALL_STATE(2008)] = 100071,
  [SMALL_STATE(2009)] = 100082,
  [SMALL_STATE(2010)] = 100093,
  [SMALL_STATE(2011)] = 100102,
  [SMALL_STATE(2012)] = 100112,
  [SMALL_STATE(2013)] = 100122,
  [SMALL_STATE(2014)] = 100132,
  [SMALL_STATE(2015)] = 100142,
  [SMALL_STATE(2016)] = 100152,
  [SMALL_STATE(2017)] = 100162,
  [SMALL_STATE(2018)] = 100172,
  [SMALL_STATE(2019)] = 100182,
  [SMALL_STATE(2020)] = 100192,
  [SMALL_STATE(2021)] = 100202,
  [SMALL_STATE(2022)] = 100212,
  [SMALL_STATE(2023)] = 100222,
  [SMALL_STATE(2024)] = 100232,
  [SMALL_STATE(2025)] = 100242,
  [SMALL_STATE(2026)] = 100249,
  [SMALL_STATE(2027)] = 100256,
  [SMALL_STATE(2028)] = 100263,
  [SMALL_STATE(2029)] = 100270,
  [SMALL_STATE(2030)] = 100277,
  [SMALL_STATE(2031)] = 100284,
  [SMALL_STATE(2032)] = 100291,
  [SMALL_STATE(2033)] = 100298,
  [SMALL_STATE(2034)] = 100303,
  [SMALL_STATE(2035)] = 100310,
  [SMALL_STATE(2036)] = 100317,
  [SMALL_STATE(2037)] = 100324,
  [SMALL_STATE(2038)] = 100331,
  [SMALL_STATE(2039)] = 100338,
  [SMALL_STATE(2040)] = 100343,
  [SMALL_STATE(2041)] = 100350,
  [SMALL_STATE(2042)] = 100357,
  [SMALL_STATE(2043)] = 100364,
  [SMALL_STATE(2044)] = 100371,
  [SMALL_STATE(2045)] = 100378,
  [SMALL_STATE(2046)] = 100385,
  [SMALL_STATE(2047)] = 100392,
  [SMALL_STATE(2048)] = 100399,
  [SMALL_STATE(2049)] = 100406,
  [SMALL_STATE(2050)] = 100413,
  [SMALL_STATE(2051)] = 100420,
  [SMALL_STATE(2052)] = 100427,
  [SMALL_STATE(2053)] = 100434,
  [SMALL_STATE(2054)] = 100441,
  [SMALL_STATE(2055)] = 100448,
  [SMALL_STATE(2056)] = 100455,
  [SMALL_STATE(2057)] = 100462,
  [SMALL_STATE(2058)] = 100469,
  [SMALL_STATE(2059)] = 100476,
  [SMALL_STATE(2060)] = 100483,
  [SMALL_STATE(2061)] = 100490,
  [SMALL_STATE(2062)] = 100497,
  [SMALL_STATE(2063)] = 100504,
  [SMALL_STATE(2064)] = 100511,
  [SMALL_STATE(2065)] = 100518,
  [SMALL_STATE(2066)] = 100525,
  [SMALL_STATE(2067)] = 100532,
  [SMALL_STATE(2068)] = 100539,
  [SMALL_STATE(2069)] = 100546,
  [SMALL_STATE(2070)] = 100550,
  [SMALL_STATE(2071)] = 100554,
  [SMALL_STATE(2072)] = 100558,
  [SMALL_STATE(2073)] = 100562,
  [SMALL_STATE(2074)] = 100566,
  [SMALL_STATE(2075)] = 100570,
  [SMALL_STATE(2076)] = 100574,
  [SMALL_STATE(2077)] = 100578,
  [SMALL_STATE(2078)] = 100582,
  [SMALL_STATE(2079)] = 100586,
  [SMALL_STATE(2080)] = 100590,
  [SMALL_STATE(2081)] = 100594,
  [SMALL_STATE(2082)] = 100598,
  [SMALL_STATE(2083)] = 100602,
  [SMALL_STATE(2084)] = 100606,
  [SMALL_STATE(2085)] = 100610,
  [SMALL_STATE(2086)] = 100614,
  [SMALL_STATE(2087)] = 100618,
  [SMALL_STATE(2088)] = 100622,
  [SMALL_STATE(2089)] = 100626,
  [SMALL_STATE(2090)] = 100630,
  [SMALL_STATE(2091)] = 100634,
  [SMALL_STATE(2092)] = 100638,
  [SMALL_STATE(2093)] = 100642,
  [SMALL_STATE(2094)] = 100646,
  [SMALL_STATE(2095)] = 100650,
  [SMALL_STATE(2096)] = 100654,
  [SMALL_STATE(2097)] = 100658,
  [SMALL_STATE(2098)] = 100662,
  [SMALL_STATE(2099)] = 100666,
  [SMALL_STATE(2100)] = 100670,
  [SMALL_STATE(2101)] = 100674,
  [SMALL_STATE(2102)] = 100678,
  [SMALL_STATE(2103)] = 100682,
  [SMALL_STATE(2104)] = 100686,
  [SMALL_STATE(2105)] = 100690,
  [SMALL_STATE(2106)] = 100694,
  [SMALL_STATE(2107)] = 100698,
  [SMALL_STATE(2108)] = 100702,
  [SMALL_STATE(2109)] = 100706,
  [SMALL_STATE(2110)] = 100710,
  [SMALL_STATE(2111)] = 100714,
  [SMALL_STATE(2112)] = 100718,
  [SMALL_STATE(2113)] = 100722,
  [SMALL_STATE(2114)] = 100726,
  [SMALL_STATE(2115)] = 100730,
  [SMALL_STATE(2116)] = 100734,
  [SMALL_STATE(2117)] = 100738,
  [SMALL_STATE(2118)] = 100742,
  [SMALL_STATE(2119)] = 100746,
  [SMALL_STATE(2120)] = 100750,
  [SMALL_STATE(2121)] = 100754,
  [SMALL_STATE(2122)] = 100758,
  [SMALL_STATE(2123)] = 100762,
  [SMALL_STATE(2124)] = 100766,
  [SMALL_STATE(2125)] = 100770,
  [SMALL_STATE(2126)] = 100774,
  [SMALL_STATE(2127)] = 100778,
  [SMALL_STATE(2128)] = 100782,
  [SMALL_STATE(2129)] = 100786,
  [SMALL_STATE(2130)] = 100790,
  [SMALL_STATE(2131)] = 100794,
  [SMALL_STATE(2132)] = 100798,
  [SMALL_STATE(2133)] = 100802,
  [SMALL_STATE(2134)] = 100806,
  [SMALL_STATE(2135)] = 100810,
  [SMALL_STATE(2136)] = 100814,
  [SMALL_STATE(2137)] = 100818,
  [SMALL_STATE(2138)] = 100822,
  [SMALL_STATE(2139)] = 100826,
  [SMALL_STATE(2140)] = 100830,
  [SMALL_STATE(2141)] = 100834,
  [SMALL_STATE(2142)] = 100838,
  [SMALL_STATE(2143)] = 100842,
  [SMALL_STATE(2144)] = 100846,
  [SMALL_STATE(2145)] = 100850,
  [SMALL_STATE(2146)] = 100854,
  [SMALL_STATE(2147)] = 100858,
  [SMALL_STATE(2148)] = 100862,
  [SMALL_STATE(2149)] = 100866,
  [SMALL_STATE(2150)] = 100870,
  [SMALL_STATE(2151)] = 100874,
  [SMALL_STATE(2152)] = 100878,
  [SMALL_STATE(2153)] = 100882,
  [SMALL_STATE(2154)] = 100886,
  [SMALL_STATE(2155)] = 100890,
  [SMALL_STATE(2156)] = 100894,
  [SMALL_STATE(2157)] = 100898,
  [SMALL_STATE(2158)] = 100902,
  [SMALL_STATE(2159)] = 100906,
  [SMALL_STATE(2160)] = 100910,
  [SMALL_STATE(2161)] = 100914,
  [SMALL_STATE(2162)] = 100918,
  [SMALL_STATE(2163)] = 100922,
  [SMALL_STATE(2164)] = 100926,
  [SMALL_STATE(2165)] = 100930,
  [SMALL_STATE(2166)] = 100934,
  [SMALL_STATE(2167)] = 100938,
  [SMALL_STATE(2168)] = 100942,
  [SMALL_STATE(2169)] = 100946,
  [SMALL_STATE(2170)] = 100950,
  [SMALL_STATE(2171)] = 100954,
  [SMALL_STATE(2172)] = 100958,
  [SMALL_STATE(2173)] = 100962,
  [SMALL_STATE(2174)] = 100966,
  [SMALL_STATE(2175)] = 100970,
  [SMALL_STATE(2176)] = 100974,
  [SMALL_STATE(2177)] = 100978,
  [SMALL_STATE(2178)] = 100982,
  [SMALL_STATE(2179)] = 100986,
  [SMALL_STATE(2180)] = 100990,
  [SMALL_STATE(2181)] = 100994,
  [SMALL_STATE(2182)] = 100998,
  [SMALL_STATE(2183)] = 101002,
  [SMALL_STATE(2184)] = 101006,
  [SMALL_STATE(2185)] = 101010,
  [SMALL_STATE(2186)] = 101014,
  [SMALL_STATE(2187)] = 101018,
  [SMALL_STATE(2188)] = 101022,
  [SMALL_STATE(2189)] = 101026,
  [SMALL_STATE(2190)] = 101030,
  [SMALL_STATE(2191)] = 101034,
  [SMALL_STATE(2192)] = 101038,
  [SMALL_STATE(2193)] = 101042,
  [SMALL_STATE(2194)] = 101046,
  [SMALL_STATE(2195)] = 101050,
  [SMALL_STATE(2196)] = 101054,
  [SMALL_STATE(2197)] = 101058,
  [SMALL_STATE(2198)] = 101062,
  [SMALL_STATE(2199)] = 101066,
  [SMALL_STATE(2200)] = 101070,
  [SMALL_STATE(2201)] = 101074,
  [SMALL_STATE(2202)] = 101078,
  [SMALL_STATE(2203)] = 101082,
  [SMALL_STATE(2204)] = 101086,
  [SMALL_STATE(2205)] = 101090,
  [SMALL_STATE(2206)] = 101094,
  [SMALL_STATE(2207)] = 101098,
  [SMALL_STATE(2208)] = 101102,
  [SMALL_STATE(2209)] = 101106,
  [SMALL_STATE(2210)] = 101110,
  [SMALL_STATE(2211)] = 101114,
  [SMALL_STATE(2212)] = 101118,
  [SMALL_STATE(2213)] = 101122,
  [SMALL_STATE(2214)] = 101126,
  [SMALL_STATE(2215)] = 101130,
  [SMALL_STATE(2216)] = 101134,
  [SMALL_STATE(2217)] = 101138,
  [SMALL_STATE(2218)] = 101142,
  [SMALL_STATE(2219)] = 101146,
  [SMALL_STATE(2220)] = 101150,
  [SMALL_STATE(2221)] = 101154,
  [SMALL_STATE(2222)] = 101158,
  [SMALL_STATE(2223)] = 101162,
  [SMALL_STATE(2224)] = 101166,
  [SMALL_STATE(2225)] = 101170,
  [SMALL_STATE(2226)] = 101174,
  [SMALL_STATE(2227)] = 101178,
  [SMALL_STATE(2228)] = 101182,
  [SMALL_STATE(2229)] = 101186,
  [SMALL_STATE(2230)] = 101190,
  [SMALL_STATE(2231)] = 101194,
  [SMALL_STATE(2232)] = 101198,
  [SMALL_STATE(2233)] = 101202,
  [SMALL_STATE(2234)] = 101206,
  [SMALL_STATE(2235)] = 101210,
  [SMALL_STATE(2236)] = 101214,
  [SMALL_STATE(2237)] = 101218,
  [SMALL_STATE(2238)] = 101222,
  [SMALL_STATE(2239)] = 101226,
  [SMALL_STATE(2240)] = 101230,
  [SMALL_STATE(2241)] = 101234,
  [SMALL_STATE(2242)] = 101238,
  [SMALL_STATE(2243)] = 101242,
  [SMALL_STATE(2244)] = 101246,
  [SMALL_STATE(2245)] = 101250,
  [SMALL_STATE(2246)] = 101254,
  [SMALL_STATE(2247)] = 101258,
  [SMALL_STATE(2248)] = 101262,
  [SMALL_STATE(2249)] = 101266,
  [SMALL_STATE(2250)] = 101270,
  [SMALL_STATE(2251)] = 101274,
  [SMALL_STATE(2252)] = 101278,
  [SMALL_STATE(2253)] = 101282,
  [SMALL_STATE(2254)] = 101286,
  [SMALL_STATE(2255)] = 101290,
  [SMALL_STATE(2256)] = 101294,
  [SMALL_STATE(2257)] = 101298,
  [SMALL_STATE(2258)] = 101302,
  [SMALL_STATE(2259)] = 101306,
  [SMALL_STATE(2260)] = 101310,
  [SMALL_STATE(2261)] = 101314,
  [SMALL_STATE(2262)] = 101318,
  [SMALL_STATE(2263)] = 101322,
  [SMALL_STATE(2264)] = 101326,
  [SMALL_STATE(2265)] = 101330,
  [SMALL_STATE(2266)] = 101334,
  [SMALL_STATE(2267)] = 101338,
  [SMALL_STATE(2268)] = 101342,
  [SMALL_STATE(2269)] = 101346,
  [SMALL_STATE(2270)] = 101350,
  [SMALL_STATE(2271)] = 101354,
  [SMALL_STATE(2272)] = 101358,
  [SMALL_STATE(2273)] = 101362,
  [SMALL_STATE(2274)] = 101366,
  [SMALL_STATE(2275)] = 101370,
  [SMALL_STATE(2276)] = 101374,
  [SMALL_STATE(2277)] = 101378,
  [SMALL_STATE(2278)] = 101382,
  [SMALL_STATE(2279)] = 101386,
  [SMALL_STATE(2280)] = 101390,
  [SMALL_STATE(2281)] = 101394,
  [SMALL_STATE(2282)] = 101398,
  [SMALL_STATE(2283)] = 101402,
  [SMALL_STATE(2284)] = 101406,
  [SMALL_STATE(2285)] = 101410,
  [SMALL_STATE(2286)] = 101414,
  [SMALL_STATE(2287)] = 101418,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [85] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(193),
  [88] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2205),
  [91] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(720),
  [94] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2204),
  [97] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(150),
  [100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2203),
  [103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1410),
  [106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2009),
  [109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(325),
  [112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(324),
  [115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2198),
  [118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(8),
  [121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(363),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(187),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(643),
  [132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1869),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1209),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1209),
  [141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1908),
  [144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1217),
  [147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1903),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(472),
  [153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(472),
  [156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2001),
  [159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2194),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 33),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 33),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 33),
  [562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 33),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp, 1),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 1, .production_id = 1),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp, 1),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getline_input, 1),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getline_input, 1),
  [684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_concat, 3, .production_id = 8),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_concat, 3, .production_id = 8),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_print_statement, 1),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 1),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getline_input, 2),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getline_input, 2),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ns_qualified_name, 4),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ns_qualified_name, 4),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_exp, 2, .production_id = 3),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_exp, 2, .production_id = 3),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_ref, 4, .production_id = 16),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_ref, 4, .production_id = 16),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_call, 4, .production_id = 15),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_call, 4, .production_id = 15),
  [766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 14),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 14),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_exp, 3, .production_id = 10),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_exp, 3, .production_id = 10),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getline_file, 4, .production_id = 13),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getline_file, 4, .production_id = 13),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 6),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 6),
  [790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_call, 5, .production_id = 15),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_call, 5, .production_id = 15),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number, 1),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number, 1),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_exp, 1, .production_id = 2),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_exp, 1, .production_id = 2),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indirect_func_call, 2),
  [814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indirect_func_call, 2),
  [816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex_constant, 2),
  [818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex_constant, 2),
  [820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 3),
  [822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 3),
  [824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_exp, 2, .production_id = 4),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_exp, 2, .production_id = 4),
  [828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getline_file, 3, .production_id = 5),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getline_file, 3, .production_id = 5),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_ref, 2),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_ref, 2),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_piped_io_exp, 3, .production_id = 11),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_piped_io_exp, 3, .production_id = 11),
  [848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 7),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 7),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 2),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 2),
  [862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_in, 3, .production_id = 10),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_in, 3, .production_id = 10),
  [876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_exp, 5, .production_id = 19),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_exp, 5, .production_id = 19),
  [888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_in, 5, .production_id = 17),
  [890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_in, 5, .production_id = 17),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_exp, 6, .production_id = 21),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_exp, 6, .production_id = 21),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_exp, 6, .production_id = 22),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_exp, 6, .production_id = 22),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_exp, 7, .production_id = 24),
  [906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_exp, 7, .production_id = 24),
  [908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_exp, 2, .production_id = 3),
  [910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_exp, 2, .production_id = 3),
  [912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_exp, 3, .production_id = 8),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_exp, 3, .production_id = 8),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exit_statement, 1),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exit_statement, 1),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(373),
  [961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1685),
  [964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2038),
  [967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(764),
  [970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(531),
  [976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1876),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(864),
  [982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(864),
  [985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1890),
  [988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(884),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1892),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(554),
  [997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(554),
  [1000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1978),
  [1003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2020),
  [1006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2224),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_list, 2),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_list, 2),
  [1111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__print_args, 1),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__print_args, 1),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [1159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redirected_io_statement, 3, .production_id = 5),
  [1161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirected_io_statement, 3, .production_id = 5),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exit_statement, 2),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exit_statement, 2),
  [1185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_piped_io_statement, 3, .production_id = 12),
  [1187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_piped_io_statement, 3, .production_id = 12),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, .production_id = 9),
  [1277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, .production_id = 9),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_print_statement, 2),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_printf_statement, 2),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_printf_statement, 2),
  [1363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_print_statement, 4),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4),
  [1367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_printf_statement, 4),
  [1369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_printf_statement, 4),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [1657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(815),
  [1660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(687),
  [1663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(1545),
  [1666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(1858),
  [1669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(1215),
  [1672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(1215),
  [1675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(1924),
  [1678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(997),
  [1681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(1926),
  [1684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(1629),
  [1687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(1629),
  [1690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2), SHIFT_REPEAT(1980),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__io_statement, 1),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [1767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__io_statement, 1),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [1773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_statement, 2),
  [1775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_statement, 2),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_separated, 2),
  [1847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_separated, 2),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 2),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 2),
  [1853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 20),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 20),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 5),
  [1861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, .production_id = 20),
  [1883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, .production_id = 20),
  [1885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_while_statement, 6, .production_id = 23),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_while_statement, 6, .production_id = 23),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 6),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 6),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 20),
  [1903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 20),
  [1905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_while_statement, 7, .production_id = 25),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_while_statement, 7, .production_id = 25),
  [1909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7),
  [1913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 26),
  [1915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 26),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 27),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 27),
  [1921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 7, .production_id = 28),
  [1923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 7, .production_id = 28),
  [1925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 29),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 29),
  [1929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [1937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 8, .production_id = 20),
  [1939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, .production_id = 20),
  [1941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 26),
  [1943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 26),
  [1945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 27),
  [1947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 27),
  [1949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 30),
  [1951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 30),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 8, .production_id = 28),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 8, .production_id = 28),
  [1957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 29),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 29),
  [1961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 31),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 31),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 32),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 32),
  [1969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 9, .production_id = 20),
  [1971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 9, .production_id = 20),
  [1973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 30),
  [1975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 30),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 31),
  [1979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 31),
  [1981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 32),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 32),
  [1985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 34),
  [1987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 34),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 34),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 34),
  [1993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [2033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [2035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [2037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(2194),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 20),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [2052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 20),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [2076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [2086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comment, 2),
  [2088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2),
  [2090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_content, 1),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [2116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [2120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [2138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [2140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [2144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [2158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [2176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [2178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [2180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [2182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [2196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [2198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule, 1),
  [2268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule, 1),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_directive, 2),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_directive, 2),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule, 2),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule, 2),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_def, 6, .production_id = 18),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_def, 6, .production_id = 18),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_def, 5, .production_id = 18),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_def, 5, .production_id = 18),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_args, 1),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [2768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exp_list_repeat1, 2),
  [2770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [2800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [2802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(1849),
  [2805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(2165),
  [2808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(2224),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 4),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 5, .production_id = 33),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex_pattern, 1),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [2967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__regex_bracket_exp_repeat1, 2), SHIFT_REPEAT(1923),
  [2970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__regex_bracket_exp_repeat1, 2), SHIFT_REPEAT(1923),
  [2973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__regex_bracket_exp_repeat1, 2), SHIFT_REPEAT(2127),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__regex_bracket_exp_repeat1, 2),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [2984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [2992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_regex_pattern_repeat1, 2),
  [2994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_regex_pattern_repeat1, 2), SHIFT_REPEAT(1929),
  [2997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_regex_pattern_repeat1, 2), SHIFT_REPEAT(1960),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [3002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [3026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(2224),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [3041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [3045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [3061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__regex_char_class, 5),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__regex_char_class, 5),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [3069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__regex_bracket_exp, 3),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [3103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [3105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1999),
  [3108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [3116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [3128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [3134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [3144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(1108),
  [3147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_param_list_repeat1, 2), SHIFT_REPEAT(2022),
  [3150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_param_list_repeat1, 2),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_list, 1),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [3164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_list, 2),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [3170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_args, 2),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [3186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_param_list_repeat1, 3),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [3474] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_concatenating_space = 0,
  ts_external_token__if_else_separator = 1,
  ts_external_token__no_space = 2,
  ts_external_token__func_call = 3,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_concatenating_space] = sym_concatenating_space,
  [ts_external_token__if_else_separator] = sym__if_else_separator,
  [ts_external_token__no_space] = sym__no_space,
  [ts_external_token__func_call] = sym__func_call,
};

static const bool ts_external_scanner_states[9][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_concatenating_space] = true,
    [ts_external_token__if_else_separator] = true,
    [ts_external_token__no_space] = true,
    [ts_external_token__func_call] = true,
  },
  [2] = {
    [ts_external_token__if_else_separator] = true,
  },
  [3] = {
    [ts_external_token_concatenating_space] = true,
    [ts_external_token__if_else_separator] = true,
    [ts_external_token__func_call] = true,
  },
  [4] = {
    [ts_external_token_concatenating_space] = true,
    [ts_external_token__if_else_separator] = true,
  },
  [5] = {
    [ts_external_token_concatenating_space] = true,
    [ts_external_token__func_call] = true,
  },
  [6] = {
    [ts_external_token_concatenating_space] = true,
  },
  [7] = {
    [ts_external_token__func_call] = true,
  },
  [8] = {
    [ts_external_token__no_space] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_awk_external_scanner_create(void);
void tree_sitter_awk_external_scanner_destroy(void *);
bool tree_sitter_awk_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_awk_external_scanner_serialize(void *, char *);
void tree_sitter_awk_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_awk() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_awk_external_scanner_create,
      tree_sitter_awk_external_scanner_destroy,
      tree_sitter_awk_external_scanner_scan,
      tree_sitter_awk_external_scanner_serialize,
      tree_sitter_awk_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
