#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2009
#define LARGE_STATE_COUNT 462
#define SYMBOL_COUNT 359
#define ALIAS_COUNT 3
#define TOKEN_COUNT 160
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 39
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 132

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_SEMI = 42,
  anon_sym___extension__ = 43,
  anon_sym_typedef = 44,
  anon_sym_extern = 45,
  anon_sym___attribute__ = 46,
  anon_sym_COLON_COLON = 47,
  anon_sym_LBRACK_LBRACK = 48,
  anon_sym_RBRACK_RBRACK = 49,
  anon_sym___declspec = 50,
  anon_sym___based = 51,
  anon_sym___cdecl = 52,
  anon_sym___clrcall = 53,
  anon_sym___stdcall = 54,
  anon_sym___fastcall = 55,
  anon_sym___thiscall = 56,
  anon_sym___vectorcall = 57,
  sym_ms_restrict_modifier = 58,
  sym_ms_unsigned_ptr_modifier = 59,
  sym_ms_signed_ptr_modifier = 60,
  anon_sym__unaligned = 61,
  anon_sym___unaligned = 62,
  anon_sym_LBRACE = 63,
  anon_sym_RBRACE = 64,
  anon_sym_signed = 65,
  anon_sym_unsigned = 66,
  anon_sym_long = 67,
  anon_sym_short = 68,
  anon_sym_LBRACK = 69,
  anon_sym_static = 70,
  anon_sym_RBRACK = 71,
  anon_sym_EQ = 72,
  anon_sym_auto = 73,
  anon_sym_register = 74,
  anon_sym_inline = 75,
  anon_sym___inline = 76,
  anon_sym___inline__ = 77,
  anon_sym___forceinline = 78,
  anon_sym_thread_local = 79,
  anon_sym___thread = 80,
  anon_sym_const = 81,
  anon_sym_constexpr = 82,
  anon_sym_volatile = 83,
  anon_sym_restrict = 84,
  anon_sym___restrict__ = 85,
  anon_sym__Atomic = 86,
  anon_sym__Noreturn = 87,
  anon_sym_noreturn = 88,
  anon_sym__Nonnull = 89,
  anon_sym_alignas = 90,
  anon_sym__Alignas = 91,
  sym_primitive_type = 92,
  anon_sym_enum = 93,
  anon_sym_COLON = 94,
  anon_sym_struct = 95,
  anon_sym_union = 96,
  anon_sym_if = 97,
  anon_sym_else = 98,
  anon_sym_switch = 99,
  anon_sym_case = 100,
  anon_sym_default = 101,
  anon_sym_while = 102,
  anon_sym_do = 103,
  anon_sym_for = 104,
  anon_sym_return = 105,
  anon_sym_break = 106,
  anon_sym_continue = 107,
  anon_sym_goto = 108,
  anon_sym___try = 109,
  anon_sym___except = 110,
  anon_sym___finally = 111,
  anon_sym___leave = 112,
  anon_sym_QMARK = 113,
  anon_sym_STAR_EQ = 114,
  anon_sym_SLASH_EQ = 115,
  anon_sym_PERCENT_EQ = 116,
  anon_sym_PLUS_EQ = 117,
  anon_sym_DASH_EQ = 118,
  anon_sym_LT_LT_EQ = 119,
  anon_sym_GT_GT_EQ = 120,
  anon_sym_AMP_EQ = 121,
  anon_sym_CARET_EQ = 122,
  anon_sym_PIPE_EQ = 123,
  anon_sym_DASH_DASH = 124,
  anon_sym_PLUS_PLUS = 125,
  anon_sym_sizeof = 126,
  anon_sym___alignof__ = 127,
  anon_sym___alignof = 128,
  anon_sym__alignof = 129,
  anon_sym_alignof = 130,
  anon_sym__Alignof = 131,
  anon_sym_offsetof = 132,
  anon_sym__Generic = 133,
  anon_sym_asm = 134,
  anon_sym___asm__ = 135,
  anon_sym___asm = 136,
  anon_sym___volatile__ = 137,
  anon_sym_DOT = 138,
  anon_sym_DASH_GT = 139,
  sym_number_literal = 140,
  anon_sym_L_SQUOTE = 141,
  anon_sym_u_SQUOTE = 142,
  anon_sym_U_SQUOTE = 143,
  anon_sym_u8_SQUOTE = 144,
  anon_sym_SQUOTE = 145,
  aux_sym_char_literal_token1 = 146,
  anon_sym_L_DQUOTE = 147,
  anon_sym_u_DQUOTE = 148,
  anon_sym_U_DQUOTE = 149,
  anon_sym_u8_DQUOTE = 150,
  anon_sym_DQUOTE = 151,
  aux_sym_string_literal_token1 = 152,
  sym_escape_sequence = 153,
  sym_system_lib_string = 154,
  sym_true = 155,
  sym_false = 156,
  anon_sym_NULL = 157,
  anon_sym_nullptr = 158,
  sym_comment = 159,
  sym_translation_unit = 160,
  sym__top_level_item = 161,
  sym__block_item = 162,
  sym_preproc_include = 163,
  sym_preproc_def = 164,
  sym_preproc_function_def = 165,
  sym_preproc_params = 166,
  sym_preproc_call = 167,
  sym_preproc_if = 168,
  sym_preproc_ifdef = 169,
  sym_preproc_else = 170,
  sym_preproc_elif = 171,
  sym_preproc_elifdef = 172,
  sym_preproc_if_in_field_declaration_list = 173,
  sym_preproc_ifdef_in_field_declaration_list = 174,
  sym_preproc_else_in_field_declaration_list = 175,
  sym_preproc_elif_in_field_declaration_list = 176,
  sym_preproc_elifdef_in_field_declaration_list = 177,
  sym_preproc_if_in_enumerator_list = 178,
  sym_preproc_ifdef_in_enumerator_list = 179,
  sym_preproc_else_in_enumerator_list = 180,
  sym_preproc_elif_in_enumerator_list = 181,
  sym_preproc_elifdef_in_enumerator_list = 182,
  sym_preproc_if_in_enumerator_list_no_comma = 183,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 184,
  sym_preproc_else_in_enumerator_list_no_comma = 185,
  sym_preproc_elif_in_enumerator_list_no_comma = 186,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 187,
  sym__preproc_expression = 188,
  sym_preproc_parenthesized_expression = 189,
  sym_preproc_defined = 190,
  sym_preproc_unary_expression = 191,
  sym_preproc_call_expression = 192,
  sym_preproc_argument_list = 193,
  sym_preproc_binary_expression = 194,
  sym_function_definition = 195,
  sym__old_style_function_definition = 196,
  sym_declaration = 197,
  sym_type_definition = 198,
  sym__type_definition_type = 199,
  sym__type_definition_declarators = 200,
  sym__declaration_modifiers = 201,
  sym__declaration_specifiers = 202,
  sym_linkage_specification = 203,
  sym_attribute_specifier = 204,
  sym_attribute = 205,
  sym_attribute_declaration = 206,
  sym_ms_declspec_modifier = 207,
  sym_ms_based_modifier = 208,
  sym_ms_call_modifier = 209,
  sym_ms_unaligned_ptr_modifier = 210,
  sym_ms_pointer_modifier = 211,
  sym_declaration_list = 212,
  sym__declarator = 213,
  sym__declaration_declarator = 214,
  sym__field_declarator = 215,
  sym__type_declarator = 216,
  sym__abstract_declarator = 217,
  sym_parenthesized_declarator = 218,
  sym_parenthesized_field_declarator = 219,
  sym_parenthesized_type_declarator = 220,
  sym_abstract_parenthesized_declarator = 221,
  sym_attributed_declarator = 222,
  sym_attributed_field_declarator = 223,
  sym_attributed_type_declarator = 224,
  sym_pointer_declarator = 225,
  sym_pointer_field_declarator = 226,
  sym_pointer_type_declarator = 227,
  sym_abstract_pointer_declarator = 228,
  sym_function_declarator = 229,
  sym__function_declaration_declarator = 230,
  sym_function_field_declarator = 231,
  sym_function_type_declarator = 232,
  sym_abstract_function_declarator = 233,
  sym__old_style_function_declarator = 234,
  sym_array_declarator = 235,
  sym_array_field_declarator = 236,
  sym_array_type_declarator = 237,
  sym_abstract_array_declarator = 238,
  sym_init_declarator = 239,
  sym_compound_statement = 240,
  sym_storage_class_specifier = 241,
  sym_type_qualifier = 242,
  sym_alignas_qualifier = 243,
  sym_type_specifier = 244,
  sym_sized_type_specifier = 245,
  sym_enum_specifier = 246,
  sym_enumerator_list = 247,
  sym_struct_specifier = 248,
  sym_union_specifier = 249,
  sym_field_declaration_list = 250,
  sym__field_declaration_list_item = 251,
  sym_field_declaration = 252,
  sym__field_declaration_declarator = 253,
  sym_bitfield_clause = 254,
  sym_enumerator = 255,
  sym_variadic_parameter = 256,
  sym_parameter_list = 257,
  sym__old_style_parameter_list = 258,
  sym_parameter_declaration = 259,
  sym_attributed_statement = 260,
  sym_statement = 261,
  sym__top_level_statement = 262,
  sym_labeled_statement = 263,
  sym__top_level_expression_statement = 264,
  sym_expression_statement = 265,
  sym_if_statement = 266,
  sym_else_clause = 267,
  sym_switch_statement = 268,
  sym_case_statement = 269,
  sym_while_statement = 270,
  sym_do_statement = 271,
  sym_for_statement = 272,
  sym__for_statement_body = 273,
  sym_return_statement = 274,
  sym_break_statement = 275,
  sym_continue_statement = 276,
  sym_goto_statement = 277,
  sym_seh_try_statement = 278,
  sym_seh_except_clause = 279,
  sym_seh_finally_clause = 280,
  sym_seh_leave_statement = 281,
  sym_expression = 282,
  sym__string = 283,
  sym_comma_expression = 284,
  sym_conditional_expression = 285,
  sym_assignment_expression = 286,
  sym_pointer_expression = 287,
  sym_unary_expression = 288,
  sym_binary_expression = 289,
  sym_update_expression = 290,
  sym_cast_expression = 291,
  sym_type_descriptor = 292,
  sym_sizeof_expression = 293,
  sym_alignof_expression = 294,
  sym_offsetof_expression = 295,
  sym_generic_expression = 296,
  sym_subscript_expression = 297,
  sym_call_expression = 298,
  sym_gnu_asm_expression = 299,
  sym_gnu_asm_qualifier = 300,
  sym_gnu_asm_output_operand_list = 301,
  sym_gnu_asm_output_operand = 302,
  sym_gnu_asm_input_operand_list = 303,
  sym_gnu_asm_input_operand = 304,
  sym_gnu_asm_clobber_list = 305,
  sym_gnu_asm_goto_list = 306,
  sym_extension_expression = 307,
  sym_argument_list = 308,
  sym_field_expression = 309,
  sym_compound_literal_expression = 310,
  sym_parenthesized_expression = 311,
  sym_initializer_list = 312,
  sym_initializer_pair = 313,
  sym_subscript_designator = 314,
  sym_subscript_range_designator = 315,
  sym_field_designator = 316,
  sym_char_literal = 317,
  sym_concatenated_string = 318,
  sym_string_literal = 319,
  sym_null = 320,
  sym__empty_declaration = 321,
  sym_macro_type_specifier = 322,
  aux_sym_translation_unit_repeat1 = 323,
  aux_sym_preproc_params_repeat1 = 324,
  aux_sym_preproc_if_repeat1 = 325,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 326,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 327,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 328,
  aux_sym_preproc_argument_list_repeat1 = 329,
  aux_sym__old_style_function_definition_repeat1 = 330,
  aux_sym_declaration_repeat1 = 331,
  aux_sym_type_definition_repeat1 = 332,
  aux_sym__type_definition_type_repeat1 = 333,
  aux_sym__type_definition_declarators_repeat1 = 334,
  aux_sym__declaration_specifiers_repeat1 = 335,
  aux_sym_attribute_declaration_repeat1 = 336,
  aux_sym_attributed_declarator_repeat1 = 337,
  aux_sym_pointer_declarator_repeat1 = 338,
  aux_sym_function_declarator_repeat1 = 339,
  aux_sym_array_declarator_repeat1 = 340,
  aux_sym_sized_type_specifier_repeat1 = 341,
  aux_sym_enumerator_list_repeat1 = 342,
  aux_sym__field_declaration_declarator_repeat1 = 343,
  aux_sym_parameter_list_repeat1 = 344,
  aux_sym__old_style_parameter_list_repeat1 = 345,
  aux_sym_case_statement_repeat1 = 346,
  aux_sym_generic_expression_repeat1 = 347,
  aux_sym_gnu_asm_expression_repeat1 = 348,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 349,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 350,
  aux_sym_gnu_asm_clobber_list_repeat1 = 351,
  aux_sym_gnu_asm_goto_list_repeat1 = 352,
  aux_sym_argument_list_repeat1 = 353,
  aux_sym_initializer_list_repeat1 = 354,
  aux_sym_initializer_pair_repeat1 = 355,
  aux_sym_char_literal_repeat1 = 356,
  aux_sym_concatenated_string_repeat1 = 357,
  aux_sym_string_literal_repeat1 = 358,
  alias_sym_field_identifier = 359,
  alias_sym_statement_identifier = 360,
  alias_sym_type_identifier = 361,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_static] = "static",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_auto] = "auto",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym__Nonnull] = "_Nonnull",
  [anon_sym_alignas] = "alignas",
  [anon_sym__Alignas] = "_Alignas",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_COLON] = ":",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym___asm] = "__asm",
  [anon_sym___volatile__] = "__volatile__",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [sym_translation_unit] = "translation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym__block_item] = "_block_item",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym__old_style_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__declaration_declarator] = "_declaration_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym__function_declaration_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym__old_style_function_declarator] = "function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym_alignas_qualifier] = "alignas_qualifier",
  [sym_type_specifier] = "type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym__field_declaration_declarator] = "_field_declaration_declarator",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter_list] = "parameter_list",
  [sym__old_style_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_statement] = "statement",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym_expression] = "expression",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_extension_expression] = "extension_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym__old_style_function_definition_repeat1] = "_old_style_function_definition_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_function_declarator_repeat1] = "function_declarator_repeat1",
  [aux_sym_array_declarator_repeat1] = "array_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym__field_declaration_declarator_repeat1] = "_field_declaration_declarator_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym__old_style_parameter_list_repeat1] = "_old_style_parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_auto] = anon_sym_auto,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym__Nonnull] = anon_sym__Nonnull,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym__Alignas] = anon_sym__Alignas,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym___asm] = anon_sym___asm,
  [anon_sym___volatile__] = anon_sym___volatile__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [sym_translation_unit] = sym_translation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym__block_item] = sym__block_item,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym__old_style_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__declaration_declarator] = sym__declaration_declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym__function_declaration_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym__old_style_function_declarator] = sym_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_alignas_qualifier] = sym_alignas_qualifier,
  [sym_type_specifier] = sym_type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym__field_declaration_declarator] = sym__field_declaration_declarator,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter_list] = sym_parameter_list,
  [sym__old_style_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_statement] = sym_statement,
  [sym__top_level_statement] = sym__top_level_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym_expression] = sym_expression,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_extension_expression] = sym_extension_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_macro_type_specifier] = sym_macro_type_specifier,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym__old_style_function_definition_repeat1] = aux_sym__old_style_function_definition_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_function_declarator_repeat1] = aux_sym_function_declarator_repeat1,
  [aux_sym_array_declarator_repeat1] = aux_sym_array_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym__field_declaration_declarator_repeat1] = aux_sym__field_declaration_declarator_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym__old_style_parameter_list_repeat1] = aux_sym__old_style_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_auto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Nonnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignas] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___volatile__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym__block_item] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__old_style_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__declaration_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declaration_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__old_style_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym__old_style_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__old_style_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_declaration_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__old_style_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_body = 5,
  field_clobbers = 6,
  field_condition = 7,
  field_consequence = 8,
  field_constraint = 9,
  field_declarator = 10,
  field_designator = 11,
  field_directive = 12,
  field_end = 13,
  field_field = 14,
  field_filter = 15,
  field_function = 16,
  field_goto_labels = 17,
  field_index = 18,
  field_initializer = 19,
  field_input_operands = 20,
  field_label = 21,
  field_left = 22,
  field_member = 23,
  field_name = 24,
  field_operand = 25,
  field_operator = 26,
  field_output_operands = 27,
  field_parameters = 28,
  field_path = 29,
  field_prefix = 30,
  field_register = 31,
  field_right = 32,
  field_size = 33,
  field_start = 34,
  field_symbol = 35,
  field_type = 36,
  field_underlying_type = 37,
  field_update = 38,
  field_value = 39,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_body] = "body",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_member] = "member",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_right] = "right",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_type] = "type",
  [field_underlying_type] = "underlying_type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 3},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 1},
  [7] = {.index = 8, .length = 1},
  [8] = {.index = 9, .length = 1},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 3, .length = 1},
  [11] = {.index = 11, .length = 2},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 17, .length = 1},
  [16] = {.index = 18, .length = 1},
  [17] = {.index = 8, .length = 1},
  [18] = {.index = 19, .length = 2},
  [19] = {.index = 21, .length = 2},
  [20] = {.index = 23, .length = 1},
  [22] = {.index = 24, .length = 1},
  [23] = {.index = 25, .length = 2},
  [24] = {.index = 27, .length = 2},
  [25] = {.index = 29, .length = 1},
  [26] = {.index = 30, .length = 1},
  [27] = {.index = 31, .length = 2},
  [28] = {.index = 33, .length = 2},
  [29] = {.index = 35, .length = 1},
  [30] = {.index = 36, .length = 3},
  [31] = {.index = 39, .length = 1},
  [32] = {.index = 40, .length = 1},
  [33] = {.index = 41, .length = 3},
  [34] = {.index = 44, .length = 2},
  [35] = {.index = 46, .length = 2},
  [36] = {.index = 48, .length = 5},
  [37] = {.index = 53, .length = 3},
  [38] = {.index = 56, .length = 2},
  [39] = {.index = 58, .length = 2},
  [40] = {.index = 60, .length = 1},
  [41] = {.index = 61, .length = 2},
  [42] = {.index = 63, .length = 1},
  [43] = {.index = 64, .length = 2},
  [44] = {.index = 66, .length = 2},
  [45] = {.index = 68, .length = 2},
  [46] = {.index = 70, .length = 2},
  [47] = {.index = 72, .length = 2},
  [48] = {.index = 74, .length = 2},
  [49] = {.index = 76, .length = 2},
  [50] = {.index = 78, .length = 2},
  [52] = {.index = 80, .length = 2},
  [53] = {.index = 82, .length = 1},
  [54] = {.index = 83, .length = 1},
  [55] = {.index = 84, .length = 3},
  [56] = {.index = 87, .length = 1},
  [57] = {.index = 88, .length = 1},
  [58] = {.index = 89, .length = 1},
  [59] = {.index = 90, .length = 2},
  [60] = {.index = 92, .length = 1},
  [61] = {.index = 93, .length = 3},
  [62] = {.index = 96, .length = 3},
  [63] = {.index = 99, .length = 2},
  [64] = {.index = 101, .length = 3},
  [65] = {.index = 104, .length = 2},
  [66] = {.index = 106, .length = 5},
  [67] = {.index = 111, .length = 3},
  [68] = {.index = 114, .length = 5},
  [69] = {.index = 119, .length = 2},
  [70] = {.index = 121, .length = 2},
  [71] = {.index = 123, .length = 3},
  [72] = {.index = 126, .length = 2},
  [73] = {.index = 128, .length = 2},
  [74] = {.index = 130, .length = 1},
  [75] = {.index = 131, .length = 2},
  [76] = {.index = 133, .length = 2},
  [77] = {.index = 135, .length = 2},
  [78] = {.index = 137, .length = 3},
  [79] = {.index = 140, .length = 2},
  [80] = {.index = 142, .length = 2},
  [81] = {.index = 144, .length = 2},
  [82] = {.index = 146, .length = 1},
  [83] = {.index = 147, .length = 2},
  [84] = {.index = 149, .length = 2},
  [85] = {.index = 151, .length = 4},
  [86] = {.index = 155, .length = 1},
  [87] = {.index = 156, .length = 2},
  [88] = {.index = 158, .length = 1},
  [89] = {.index = 159, .length = 1},
  [90] = {.index = 160, .length = 4},
  [91] = {.index = 164, .length = 4},
  [92] = {.index = 168, .length = 2},
  [93] = {.index = 170, .length = 2},
  [94] = {.index = 172, .length = 3},
  [95] = {.index = 175, .length = 5},
  [96] = {.index = 180, .length = 3},
  [97] = {.index = 183, .length = 2},
  [98] = {.index = 185, .length = 1},
  [100] = {.index = 186, .length = 2},
  [101] = {.index = 188, .length = 2},
  [102] = {.index = 190, .length = 2},
  [103] = {.index = 192, .length = 3},
  [104] = {.index = 195, .length = 2},
  [105] = {.index = 197, .length = 2},
  [106] = {.index = 199, .length = 2},
  [107] = {.index = 201, .length = 2},
  [108] = {.index = 203, .length = 3},
  [109] = {.index = 206, .length = 2},
  [110] = {.index = 208, .length = 1},
  [111] = {.index = 209, .length = 5},
  [112] = {.index = 214, .length = 2},
  [113] = {.index = 216, .length = 3},
  [114] = {.index = 219, .length = 2},
  [115] = {.index = 219, .length = 2},
  [116] = {.index = 221, .length = 3},
  [117] = {.index = 224, .length = 2},
  [118] = {.index = 226, .length = 1},
  [119] = {.index = 227, .length = 4},
  [120] = {.index = 231, .length = 3},
  [121] = {.index = 234, .length = 2},
  [122] = {.index = 236, .length = 2},
  [123] = {.index = 35, .length = 1},
  [124] = {.index = 238, .length = 5},
  [125] = {.index = 243, .length = 4},
  [126] = {.index = 247, .length = 2},
  [127] = {.index = 249, .length = 2},
  [128] = {.index = 251, .length = 2},
  [129] = {.index = 253, .length = 5},
  [130] = {.index = 258, .length = 2},
  [131] = {.index = 260, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 0, .inherited = true},
    {field_declarator, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [3] =
    {field_type, 0},
  [4] =
    {field_directive, 0},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_name, 0},
  [8] =
    {field_name, 1},
  [9] =
    {field_body, 1},
  [10] =
    {field_value, 1},
  [11] =
    {field_declarator, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
  [13] =
    {field_argument, 0},
    {field_operator, 1},
  [15] =
    {field_arguments, 1},
    {field_function, 0},
  [17] =
    {field_type, 1},
  [18] =
    {field_path, 1},
  [19] =
    {field_argument, 1},
    {field_directive, 0},
  [21] =
    {field_declarator, 1},
    {field_type, 0},
  [23] =
    {field_parameters, 0},
  [24] =
    {field_declarator, 0},
  [25] =
    {field_body, 2},
    {field_value, 1},
  [27] =
    {field_body, 2},
    {field_name, 1},
  [29] =
    {field_name, 2},
  [30] =
    {field_body, 2},
  [31] =
    {field_condition, 1},
    {field_consequence, 2},
  [33] =
    {field_body, 2},
    {field_condition, 1},
  [35] =
    {field_label, 1},
  [36] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [39] =
    {field_label, 0},
  [40] =
    {field_declarator, 1},
  [41] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [44] =
    {field_declarator, 0},
    {field_parameters, 1},
  [46] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [48] =
    {field_body, 2},
    {field_declarator, 1},
    {field_declarator, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [53] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [56] =
    {field_name, 1},
    {field_value, 2},
  [58] =
    {field_name, 1},
    {field_parameters, 2},
  [60] =
    {field_condition, 1},
  [61] =
    {field_alternative, 2},
    {field_name, 1},
  [63] =
    {field_type, 0, .inherited = true},
  [64] =
    {field_declarator, 2},
    {field_type, 0},
  [66] =
    {field_left, 0},
    {field_right, 2},
  [68] =
    {field_type, 1},
    {field_value, 3},
  [70] =
    {field_declarator, 2},
    {field_type, 1},
  [72] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [74] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [76] =
    {field_name, 2},
    {field_prefix, 0},
  [78] =
    {field_name, 1},
    {field_underlying_type, 3},
  [80] =
    {field_body, 3},
    {field_name, 2},
  [82] =
    {field_name, 3},
  [83] =
    {field_body, 3},
  [84] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [87] =
    {field_initializer, 0},
  [88] =
    {field_type, 2},
  [89] =
    {field_assembly_code, 2},
  [90] =
    {field_name, 0},
    {field_type, 2},
  [92] =
    {field_declarator, 2},
  [93] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [96] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [99] =
    {field_declarator, 0},
    {field_value, 2},
  [101] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [104] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [106] =
    {field_body, 3},
    {field_declarator, 1},
    {field_declarator, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [111] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [114] =
    {field_body, 3},
    {field_declarator, 2},
    {field_declarator, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [119] =
    {field_argument, 0},
    {field_index, 2},
  [121] =
    {field_alternative, 3},
    {field_condition, 0},
  [123] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [126] =
    {field_alternative, 3},
    {field_condition, 1},
  [128] =
    {field_alternative, 3},
    {field_name, 1},
  [130] =
    {field_size, 1},
  [131] =
    {field_declarator, 3},
    {field_type, 1},
  [133] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [135] =
    {field_name, 0},
    {field_value, 2},
  [137] =
    {field_body, 4},
    {field_name, 1},
    {field_underlying_type, 3},
  [140] =
    {field_declarator, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [142] =
    {field_body, 4},
    {field_name, 3},
  [144] =
    {field_body, 1},
    {field_condition, 3},
  [146] =
    {field_update, 2},
  [147] =
    {field_initializer, 0},
    {field_update, 2},
  [149] =
    {field_condition, 1},
    {field_initializer, 0},
  [151] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [155] =
    {field_operand, 1},
  [156] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [158] =
    {field_assembly_code, 3},
  [159] =
    {field_declarator, 3},
  [160] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_type, 0, .inherited = true},
  [164] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [168] =
    {field_declarator, 0},
    {field_size, 2},
  [170] =
    {field_declarator, 1},
    {field_declarator, 2},
  [172] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [175] =
    {field_body, 4},
    {field_declarator, 2},
    {field_declarator, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [180] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [183] =
    {field_alternative, 4},
    {field_condition, 1},
  [185] =
    {field_size, 2},
  [186] =
    {field_body, 2},
    {field_filter, 1},
  [188] =
    {field_declarator, 0},
    {field_declarator, 2, .inherited = true},
  [190] =
    {field_condition, 1},
    {field_update, 3},
  [192] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [195] =
    {field_initializer, 0},
    {field_update, 3},
  [197] =
    {field_condition, 2},
    {field_initializer, 0},
  [199] =
    {field_member, 4},
    {field_type, 2},
  [201] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [203] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [206] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [208] =
    {field_declarator, 4},
  [209] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_declarator, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [214] =
    {field_declarator, 0},
    {field_size, 3},
  [216] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
  [219] =
    {field_designator, 0},
    {field_value, 2},
  [221] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [224] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [226] =
    {field_register, 1},
  [227] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [231] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [234] =
    {field_constraint, 0},
    {field_value, 2},
  [236] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [238] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [243] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [247] =
    {field_end, 3},
    {field_start, 1},
  [249] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [251] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [253] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [258] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [260] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [7] = {
    [1] = alias_sym_type_identifier,
  },
  [10] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = alias_sym_type_identifier,
  },
  [21] = {
    [0] = sym_primitive_type,
  },
  [24] = {
    [1] = alias_sym_type_identifier,
  },
  [25] = {
    [2] = alias_sym_type_identifier,
  },
  [29] = {
    [1] = alias_sym_statement_identifier,
  },
  [31] = {
    [0] = alias_sym_statement_identifier,
  },
  [37] = {
    [2] = alias_sym_field_identifier,
  },
  [50] = {
    [1] = alias_sym_type_identifier,
  },
  [51] = {
    [0] = alias_sym_field_identifier,
  },
  [52] = {
    [2] = alias_sym_type_identifier,
  },
  [53] = {
    [3] = alias_sym_type_identifier,
  },
  [78] = {
    [1] = alias_sym_type_identifier,
  },
  [80] = {
    [3] = alias_sym_type_identifier,
  },
  [99] = {
    [1] = alias_sym_field_identifier,
  },
  [106] = {
    [4] = alias_sym_field_identifier,
  },
  [114] = {
    [0] = alias_sym_field_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 2,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 3,
  [12] = 4,
  [13] = 5,
  [14] = 2,
  [15] = 3,
  [16] = 4,
  [17] = 5,
  [18] = 2,
  [19] = 3,
  [20] = 4,
  [21] = 5,
  [22] = 22,
  [23] = 23,
  [24] = 22,
  [25] = 25,
  [26] = 26,
  [27] = 22,
  [28] = 28,
  [29] = 23,
  [30] = 26,
  [31] = 23,
  [32] = 32,
  [33] = 28,
  [34] = 26,
  [35] = 35,
  [36] = 23,
  [37] = 32,
  [38] = 28,
  [39] = 32,
  [40] = 26,
  [41] = 28,
  [42] = 32,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 48,
  [51] = 47,
  [52] = 45,
  [53] = 48,
  [54] = 49,
  [55] = 46,
  [56] = 45,
  [57] = 46,
  [58] = 49,
  [59] = 47,
  [60] = 49,
  [61] = 48,
  [62] = 47,
  [63] = 46,
  [64] = 45,
  [65] = 49,
  [66] = 66,
  [67] = 46,
  [68] = 47,
  [69] = 48,
  [70] = 45,
  [71] = 66,
  [72] = 66,
  [73] = 66,
  [74] = 66,
  [75] = 75,
  [76] = 75,
  [77] = 75,
  [78] = 75,
  [79] = 75,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 83,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 92,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 80,
  [149] = 80,
  [150] = 80,
  [151] = 112,
  [152] = 110,
  [153] = 111,
  [154] = 112,
  [155] = 113,
  [156] = 114,
  [157] = 115,
  [158] = 116,
  [159] = 117,
  [160] = 110,
  [161] = 111,
  [162] = 112,
  [163] = 113,
  [164] = 114,
  [165] = 115,
  [166] = 116,
  [167] = 117,
  [168] = 82,
  [169] = 83,
  [170] = 107,
  [171] = 84,
  [172] = 108,
  [173] = 86,
  [174] = 87,
  [175] = 88,
  [176] = 89,
  [177] = 84,
  [178] = 89,
  [179] = 90,
  [180] = 91,
  [181] = 92,
  [182] = 109,
  [183] = 93,
  [184] = 94,
  [185] = 95,
  [186] = 96,
  [187] = 118,
  [188] = 90,
  [189] = 91,
  [190] = 98,
  [191] = 99,
  [192] = 100,
  [193] = 101,
  [194] = 81,
  [195] = 82,
  [196] = 102,
  [197] = 103,
  [198] = 104,
  [199] = 105,
  [200] = 106,
  [201] = 106,
  [202] = 82,
  [203] = 83,
  [204] = 84,
  [205] = 86,
  [206] = 87,
  [207] = 88,
  [208] = 89,
  [209] = 90,
  [210] = 91,
  [211] = 92,
  [212] = 108,
  [213] = 93,
  [214] = 109,
  [215] = 94,
  [216] = 95,
  [217] = 96,
  [218] = 118,
  [219] = 100,
  [220] = 101,
  [221] = 81,
  [222] = 93,
  [223] = 106,
  [224] = 107,
  [225] = 108,
  [226] = 109,
  [227] = 110,
  [228] = 111,
  [229] = 115,
  [230] = 116,
  [231] = 98,
  [232] = 99,
  [233] = 102,
  [234] = 103,
  [235] = 104,
  [236] = 105,
  [237] = 105,
  [238] = 113,
  [239] = 114,
  [240] = 117,
  [241] = 94,
  [242] = 95,
  [243] = 96,
  [244] = 118,
  [245] = 98,
  [246] = 99,
  [247] = 100,
  [248] = 86,
  [249] = 101,
  [250] = 81,
  [251] = 87,
  [252] = 88,
  [253] = 102,
  [254] = 103,
  [255] = 104,
  [256] = 107,
  [257] = 136,
  [258] = 140,
  [259] = 144,
  [260] = 120,
  [261] = 146,
  [262] = 147,
  [263] = 120,
  [264] = 125,
  [265] = 119,
  [266] = 125,
  [267] = 127,
  [268] = 128,
  [269] = 121,
  [270] = 130,
  [271] = 129,
  [272] = 141,
  [273] = 127,
  [274] = 133,
  [275] = 128,
  [276] = 122,
  [277] = 121,
  [278] = 130,
  [279] = 141,
  [280] = 142,
  [281] = 143,
  [282] = 129,
  [283] = 123,
  [284] = 135,
  [285] = 139,
  [286] = 131,
  [287] = 137,
  [288] = 138,
  [289] = 122,
  [290] = 132,
  [291] = 124,
  [292] = 126,
  [293] = 131,
  [294] = 133,
  [295] = 135,
  [296] = 134,
  [297] = 137,
  [298] = 147,
  [299] = 138,
  [300] = 123,
  [301] = 126,
  [302] = 134,
  [303] = 139,
  [304] = 140,
  [305] = 144,
  [306] = 306,
  [307] = 136,
  [308] = 146,
  [309] = 145,
  [310] = 145,
  [311] = 142,
  [312] = 143,
  [313] = 306,
  [314] = 119,
  [315] = 132,
  [316] = 124,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 136,
  [322] = 320,
  [323] = 323,
  [324] = 131,
  [325] = 320,
  [326] = 326,
  [327] = 318,
  [328] = 317,
  [329] = 329,
  [330] = 326,
  [331] = 319,
  [332] = 329,
  [333] = 320,
  [334] = 326,
  [335] = 317,
  [336] = 318,
  [337] = 319,
  [338] = 323,
  [339] = 329,
  [340] = 323,
  [341] = 320,
  [342] = 326,
  [343] = 319,
  [344] = 317,
  [345] = 319,
  [346] = 329,
  [347] = 323,
  [348] = 329,
  [349] = 317,
  [350] = 323,
  [351] = 318,
  [352] = 326,
  [353] = 133,
  [354] = 132,
  [355] = 139,
  [356] = 146,
  [357] = 130,
  [358] = 141,
  [359] = 142,
  [360] = 126,
  [361] = 143,
  [362] = 135,
  [363] = 363,
  [364] = 137,
  [365] = 147,
  [366] = 134,
  [367] = 367,
  [368] = 119,
  [369] = 129,
  [370] = 123,
  [371] = 124,
  [372] = 125,
  [373] = 140,
  [374] = 138,
  [375] = 127,
  [376] = 128,
  [377] = 122,
  [378] = 121,
  [379] = 144,
  [380] = 380,
  [381] = 381,
  [382] = 381,
  [383] = 383,
  [384] = 384,
  [385] = 306,
  [386] = 383,
  [387] = 384,
  [388] = 383,
  [389] = 384,
  [390] = 383,
  [391] = 384,
  [392] = 384,
  [393] = 383,
  [394] = 384,
  [395] = 383,
  [396] = 381,
  [397] = 381,
  [398] = 398,
  [399] = 399,
  [400] = 399,
  [401] = 401,
  [402] = 402,
  [403] = 306,
  [404] = 306,
  [405] = 80,
  [406] = 406,
  [407] = 306,
  [408] = 408,
  [409] = 408,
  [410] = 408,
  [411] = 408,
  [412] = 408,
  [413] = 408,
  [414] = 408,
  [415] = 408,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 398,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 433,
  [437] = 437,
  [438] = 433,
  [439] = 432,
  [440] = 434,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 441,
  [445] = 434,
  [446] = 441,
  [447] = 447,
  [448] = 432,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 451,
  [455] = 455,
  [456] = 451,
  [457] = 457,
  [458] = 458,
  [459] = 452,
  [460] = 458,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 462,
  [470] = 470,
  [471] = 467,
  [472] = 467,
  [473] = 468,
  [474] = 474,
  [475] = 468,
  [476] = 462,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 467,
  [481] = 468,
  [482] = 462,
  [483] = 467,
  [484] = 462,
  [485] = 467,
  [486] = 486,
  [487] = 487,
  [488] = 462,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 503,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 502,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 504,
  [524] = 503,
  [525] = 506,
  [526] = 507,
  [527] = 508,
  [528] = 509,
  [529] = 510,
  [530] = 511,
  [531] = 512,
  [532] = 513,
  [533] = 533,
  [534] = 515,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 538,
  [540] = 520,
  [541] = 507,
  [542] = 536,
  [543] = 536,
  [544] = 504,
  [545] = 503,
  [546] = 506,
  [547] = 507,
  [548] = 508,
  [549] = 509,
  [550] = 510,
  [551] = 511,
  [552] = 512,
  [553] = 513,
  [554] = 508,
  [555] = 536,
  [556] = 556,
  [557] = 516,
  [558] = 509,
  [559] = 538,
  [560] = 521,
  [561] = 515,
  [562] = 562,
  [563] = 517,
  [564] = 506,
  [565] = 519,
  [566] = 520,
  [567] = 567,
  [568] = 510,
  [569] = 517,
  [570] = 502,
  [571] = 417,
  [572] = 511,
  [573] = 503,
  [574] = 515,
  [575] = 517,
  [576] = 502,
  [577] = 538,
  [578] = 519,
  [579] = 520,
  [580] = 537,
  [581] = 535,
  [582] = 512,
  [583] = 521,
  [584] = 504,
  [585] = 503,
  [586] = 506,
  [587] = 507,
  [588] = 508,
  [589] = 509,
  [590] = 510,
  [591] = 511,
  [592] = 512,
  [593] = 513,
  [594] = 594,
  [595] = 595,
  [596] = 536,
  [597] = 538,
  [598] = 504,
  [599] = 506,
  [600] = 507,
  [601] = 508,
  [602] = 509,
  [603] = 510,
  [604] = 511,
  [605] = 512,
  [606] = 513,
  [607] = 536,
  [608] = 538,
  [609] = 515,
  [610] = 517,
  [611] = 502,
  [612] = 519,
  [613] = 535,
  [614] = 535,
  [615] = 513,
  [616] = 535,
  [617] = 515,
  [618] = 516,
  [619] = 517,
  [620] = 519,
  [621] = 519,
  [622] = 622,
  [623] = 504,
  [624] = 502,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 646,
  [649] = 646,
  [650] = 644,
  [651] = 644,
  [652] = 645,
  [653] = 646,
  [654] = 647,
  [655] = 645,
  [656] = 647,
  [657] = 645,
  [658] = 644,
  [659] = 647,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 401,
  [664] = 664,
  [665] = 402,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 662,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 670,
  [690] = 670,
  [691] = 688,
  [692] = 670,
  [693] = 688,
  [694] = 694,
  [695] = 695,
  [696] = 688,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 668,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 630,
  [709] = 709,
  [710] = 681,
  [711] = 711,
  [712] = 712,
  [713] = 682,
  [714] = 714,
  [715] = 715,
  [716] = 630,
  [717] = 717,
  [718] = 718,
  [719] = 401,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 402,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 747,
  [768] = 768,
  [769] = 747,
  [770] = 770,
  [771] = 771,
  [772] = 747,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 747,
  [778] = 778,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 136,
  [783] = 124,
  [784] = 131,
  [785] = 137,
  [786] = 138,
  [787] = 122,
  [788] = 788,
  [789] = 630,
  [790] = 788,
  [791] = 791,
  [792] = 792,
  [793] = 788,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 788,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 796,
  [818] = 799,
  [819] = 800,
  [820] = 801,
  [821] = 806,
  [822] = 802,
  [823] = 803,
  [824] = 804,
  [825] = 809,
  [826] = 826,
  [827] = 805,
  [828] = 686,
  [829] = 829,
  [830] = 797,
  [831] = 807,
  [832] = 832,
  [833] = 798,
  [834] = 834,
  [835] = 686,
  [836] = 780,
  [837] = 791,
  [838] = 641,
  [839] = 636,
  [840] = 124,
  [841] = 812,
  [842] = 813,
  [843] = 814,
  [844] = 815,
  [845] = 136,
  [846] = 781,
  [847] = 815,
  [848] = 124,
  [849] = 131,
  [850] = 811,
  [851] = 812,
  [852] = 852,
  [853] = 779,
  [854] = 813,
  [855] = 855,
  [856] = 814,
  [857] = 137,
  [858] = 138,
  [859] = 794,
  [860] = 122,
  [861] = 861,
  [862] = 779,
  [863] = 816,
  [864] = 792,
  [865] = 816,
  [866] = 795,
  [867] = 867,
  [868] = 792,
  [869] = 810,
  [870] = 794,
  [871] = 136,
  [872] = 795,
  [873] = 861,
  [874] = 131,
  [875] = 137,
  [876] = 138,
  [877] = 122,
  [878] = 810,
  [879] = 861,
  [880] = 861,
  [881] = 811,
  [882] = 781,
  [883] = 809,
  [884] = 704,
  [885] = 796,
  [886] = 797,
  [887] = 798,
  [888] = 799,
  [889] = 800,
  [890] = 801,
  [891] = 802,
  [892] = 892,
  [893] = 803,
  [894] = 701,
  [895] = 702,
  [896] = 804,
  [897] = 707,
  [898] = 705,
  [899] = 805,
  [900] = 900,
  [901] = 806,
  [902] = 902,
  [903] = 903,
  [904] = 807,
  [905] = 703,
  [906] = 686,
  [907] = 98,
  [908] = 99,
  [909] = 102,
  [910] = 103,
  [911] = 104,
  [912] = 105,
  [913] = 699,
  [914] = 698,
  [915] = 112,
  [916] = 113,
  [917] = 114,
  [918] = 117,
  [919] = 919,
  [920] = 920,
  [921] = 697,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 102,
  [928] = 103,
  [929] = 104,
  [930] = 105,
  [931] = 931,
  [932] = 112,
  [933] = 113,
  [934] = 114,
  [935] = 117,
  [936] = 99,
  [937] = 98,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 925,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 926,
  [950] = 945,
  [951] = 951,
  [952] = 948,
  [953] = 942,
  [954] = 954,
  [955] = 954,
  [956] = 956,
  [957] = 957,
  [958] = 804,
  [959] = 806,
  [960] = 807,
  [961] = 796,
  [962] = 797,
  [963] = 798,
  [964] = 799,
  [965] = 800,
  [966] = 809,
  [967] = 801,
  [968] = 802,
  [969] = 803,
  [970] = 805,
  [971] = 971,
  [972] = 809,
  [973] = 797,
  [974] = 974,
  [975] = 975,
  [976] = 805,
  [977] = 977,
  [978] = 801,
  [979] = 979,
  [980] = 798,
  [981] = 981,
  [982] = 799,
  [983] = 806,
  [984] = 796,
  [985] = 802,
  [986] = 800,
  [987] = 987,
  [988] = 807,
  [989] = 803,
  [990] = 804,
  [991] = 981,
  [992] = 992,
  [993] = 987,
  [994] = 981,
  [995] = 987,
  [996] = 981,
  [997] = 987,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 998,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 834,
  [1016] = 1013,
  [1017] = 826,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 957,
  [1023] = 1021,
  [1024] = 807,
  [1025] = 1025,
  [1026] = 1019,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1019,
  [1032] = 1032,
  [1033] = 1021,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1025,
  [1039] = 1039,
  [1040] = 809,
  [1041] = 1041,
  [1042] = 1019,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1021,
  [1046] = 1025,
  [1047] = 1047,
  [1048] = 796,
  [1049] = 1025,
  [1050] = 797,
  [1051] = 1051,
  [1052] = 798,
  [1053] = 1053,
  [1054] = 799,
  [1055] = 800,
  [1056] = 801,
  [1057] = 802,
  [1058] = 803,
  [1059] = 804,
  [1060] = 1025,
  [1061] = 805,
  [1062] = 1025,
  [1063] = 806,
  [1064] = 1034,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1067,
  [1070] = 1070,
  [1071] = 1067,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1067,
  [1078] = 1078,
  [1079] = 855,
  [1080] = 1080,
  [1081] = 852,
  [1082] = 1068,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 1067,
  [1093] = 1093,
  [1094] = 867,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1098,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1102,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 1102,
  [1106] = 1097,
  [1107] = 766,
  [1108] = 751,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 751,
  [1116] = 1116,
  [1117] = 765,
  [1118] = 1116,
  [1119] = 1116,
  [1120] = 736,
  [1121] = 1121,
  [1122] = 749,
  [1123] = 766,
  [1124] = 750,
  [1125] = 738,
  [1126] = 764,
  [1127] = 752,
  [1128] = 746,
  [1129] = 1116,
  [1130] = 1130,
  [1131] = 1121,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1132,
  [1135] = 1135,
  [1136] = 1130,
  [1137] = 1135,
  [1138] = 1133,
  [1139] = 1130,
  [1140] = 1135,
  [1141] = 1141,
  [1142] = 1133,
  [1143] = 1130,
  [1144] = 1130,
  [1145] = 1132,
  [1146] = 1135,
  [1147] = 1130,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 826,
  [1155] = 1155,
  [1156] = 1156,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 684,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1149,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1152,
  [1177] = 1165,
  [1178] = 1153,
  [1179] = 1179,
  [1180] = 1163,
  [1181] = 1164,
  [1182] = 1182,
  [1183] = 1169,
  [1184] = 1171,
  [1185] = 1185,
  [1186] = 1172,
  [1187] = 1174,
  [1188] = 1188,
  [1189] = 1148,
  [1190] = 1158,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1158,
  [1197] = 1194,
  [1198] = 1198,
  [1199] = 1194,
  [1200] = 1158,
  [1201] = 1188,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1179,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1195,
  [1209] = 1156,
  [1210] = 1210,
  [1211] = 1198,
  [1212] = 1206,
  [1213] = 1213,
  [1214] = 1168,
  [1215] = 1157,
  [1216] = 1007,
  [1217] = 1210,
  [1218] = 1206,
  [1219] = 1213,
  [1220] = 1203,
  [1221] = 1008,
  [1222] = 1202,
  [1223] = 1175,
  [1224] = 1224,
  [1225] = 1206,
  [1226] = 684,
  [1227] = 1207,
  [1228] = 1170,
  [1229] = 1151,
  [1230] = 1161,
  [1231] = 1213,
  [1232] = 1006,
  [1233] = 1002,
  [1234] = 1155,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1192,
  [1241] = 1210,
  [1242] = 1210,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1243,
  [1248] = 1243,
  [1249] = 1243,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1252,
  [1254] = 1254,
  [1255] = 1254,
  [1256] = 1252,
  [1257] = 1252,
  [1258] = 1254,
  [1259] = 1254,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1268,
  [1273] = 1268,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1250,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1286,
  [1288] = 1286,
  [1289] = 1289,
  [1290] = 1286,
  [1291] = 1291,
  [1292] = 1291,
  [1293] = 1286,
  [1294] = 1294,
  [1295] = 1291,
  [1296] = 1286,
  [1297] = 1291,
  [1298] = 1298,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1320,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1320,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1320,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1260,
  [1339] = 1339,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1336,
  [1343] = 1343,
  [1344] = 1336,
  [1345] = 1336,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1266,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1263,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1282,
  [1355] = 1279,
  [1356] = 1356,
  [1357] = 1356,
  [1358] = 1356,
  [1359] = 1359,
  [1360] = 1353,
  [1361] = 1352,
  [1362] = 1278,
  [1363] = 1352,
  [1364] = 1364,
  [1365] = 1353,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1352,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1353,
  [1373] = 1283,
  [1374] = 1356,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1376,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1379,
  [1382] = 1382,
  [1383] = 1376,
  [1384] = 1384,
  [1385] = 1380,
  [1386] = 1386,
  [1387] = 1387,
  [1388] = 1380,
  [1389] = 1389,
  [1390] = 1380,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1379,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1379,
  [1401] = 1401,
  [1402] = 1376,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1407,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1407,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1418,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1418,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1418,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1407,
  [1435] = 1418,
  [1436] = 1436,
  [1437] = 1407,
  [1438] = 1407,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1418,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1492,
  [1493] = 1491,
  [1494] = 1489,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1490,
  [1499] = 1490,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1489,
  [1503] = 1491,
  [1504] = 1504,
  [1505] = 1500,
  [1506] = 1497,
  [1507] = 1507,
  [1508] = 1497,
  [1509] = 1509,
  [1510] = 1491,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1488,
  [1514] = 1500,
  [1515] = 1515,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1487,
  [1519] = 1497,
  [1520] = 1488,
  [1521] = 1490,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1488,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1522,
  [1528] = 1528,
  [1529] = 1490,
  [1530] = 1490,
  [1531] = 1487,
  [1532] = 1490,
  [1533] = 1522,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 1517,
  [1538] = 1538,
  [1539] = 1489,
  [1540] = 1517,
  [1541] = 1541,
  [1542] = 1491,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1500,
  [1548] = 1548,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1551,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1550,
  [1557] = 1557,
  [1558] = 1558,
  [1559] = 1558,
  [1560] = 1558,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1563,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1549,
  [1577] = 1577,
  [1578] = 1552,
  [1579] = 1575,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1582,
  [1583] = 1583,
  [1584] = 1584,
  [1585] = 1566,
  [1586] = 1550,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1563,
  [1590] = 1568,
  [1591] = 1569,
  [1592] = 1570,
  [1593] = 1568,
  [1594] = 1569,
  [1595] = 1570,
  [1596] = 1577,
  [1597] = 1597,
  [1598] = 1549,
  [1599] = 1577,
  [1600] = 1552,
  [1601] = 1398,
  [1602] = 1568,
  [1603] = 1603,
  [1604] = 1582,
  [1605] = 1569,
  [1606] = 1563,
  [1607] = 1568,
  [1608] = 1569,
  [1609] = 1570,
  [1610] = 1549,
  [1611] = 1577,
  [1612] = 1552,
  [1613] = 1582,
  [1614] = 1614,
  [1615] = 1563,
  [1616] = 1568,
  [1617] = 1569,
  [1618] = 1570,
  [1619] = 1549,
  [1620] = 1577,
  [1621] = 1552,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1550,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1574,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1549,
  [1634] = 1577,
  [1635] = 1552,
  [1636] = 1574,
  [1637] = 1573,
  [1638] = 1638,
  [1639] = 1575,
  [1640] = 1640,
  [1641] = 1641,
  [1642] = 1642,
  [1643] = 1582,
  [1644] = 1644,
  [1645] = 1645,
  [1646] = 1582,
  [1647] = 1647,
  [1648] = 1570,
  [1649] = 1624,
  [1650] = 1650,
  [1651] = 1553,
  [1652] = 1597,
  [1653] = 1624,
  [1654] = 1553,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1563,
  [1658] = 1658,
  [1659] = 1659,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1566,
  [1667] = 1667,
  [1668] = 1582,
  [1669] = 1669,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1672,
  [1675] = 1675,
  [1676] = 1673,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1681,
  [1682] = 1669,
  [1683] = 1677,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1677,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1688,
  [1693] = 1687,
  [1694] = 1694,
  [1695] = 1677,
  [1696] = 1696,
  [1697] = 1687,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1672,
  [1701] = 1688,
  [1702] = 1685,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 1705,
  [1706] = 1703,
  [1707] = 1707,
  [1708] = 1696,
  [1709] = 1677,
  [1710] = 1673,
  [1711] = 1672,
  [1712] = 1688,
  [1713] = 1685,
  [1714] = 1687,
  [1715] = 1687,
  [1716] = 1696,
  [1717] = 1669,
  [1718] = 1718,
  [1719] = 1689,
  [1720] = 1687,
  [1721] = 1703,
  [1722] = 1707,
  [1723] = 1723,
  [1724] = 1696,
  [1725] = 1673,
  [1726] = 1726,
  [1727] = 1696,
  [1728] = 1688,
  [1729] = 1729,
  [1730] = 1669,
  [1731] = 1685,
  [1732] = 1689,
  [1733] = 1733,
  [1734] = 1689,
  [1735] = 1689,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1672,
  [1739] = 1739,
  [1740] = 1703,
  [1741] = 1673,
  [1742] = 1707,
  [1743] = 1699,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1688,
  [1749] = 1749,
  [1750] = 1687,
  [1751] = 1751,
  [1752] = 1705,
  [1753] = 1705,
  [1754] = 1703,
  [1755] = 1707,
  [1756] = 1688,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1764,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1775,
  [1780] = 1774,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 636,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1769,
  [1790] = 1006,
  [1791] = 1761,
  [1792] = 1773,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1007,
  [1797] = 1797,
  [1798] = 1774,
  [1799] = 1771,
  [1800] = 1768,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1768,
  [1805] = 1769,
  [1806] = 1773,
  [1807] = 1760,
  [1808] = 1774,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1774,
  [1814] = 1814,
  [1815] = 641,
  [1816] = 1816,
  [1817] = 1759,
  [1818] = 1818,
  [1819] = 1819,
  [1820] = 1819,
  [1821] = 1764,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 1778,
  [1825] = 1803,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1818,
  [1843] = 1843,
  [1844] = 1763,
  [1845] = 1786,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1773,
  [1853] = 1781,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1793,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1775,
  [1862] = 1862,
  [1863] = 1863,
  [1864] = 1814,
  [1865] = 1793,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1868,
  [1869] = 1768,
  [1870] = 1870,
  [1871] = 1773,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1769,
  [1878] = 1878,
  [1879] = 1760,
  [1880] = 1760,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1766,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1758,
  [1887] = 1784,
  [1888] = 1769,
  [1889] = 1818,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1823,
  [1893] = 1893,
  [1894] = 1002,
  [1895] = 1873,
  [1896] = 1814,
  [1897] = 1768,
  [1898] = 1898,
  [1899] = 1836,
  [1900] = 1810,
  [1901] = 1811,
  [1902] = 1832,
  [1903] = 1903,
  [1904] = 1758,
  [1905] = 1905,
  [1906] = 1769,
  [1907] = 1836,
  [1908] = 1803,
  [1909] = 1819,
  [1910] = 1903,
  [1911] = 1757,
  [1912] = 1912,
  [1913] = 1839,
  [1914] = 1803,
  [1915] = 1814,
  [1916] = 1916,
  [1917] = 1763,
  [1918] = 1778,
  [1919] = 1761,
  [1920] = 1802,
  [1921] = 1858,
  [1922] = 1922,
  [1923] = 1860,
  [1924] = 1797,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1761,
  [1928] = 1928,
  [1929] = 1797,
  [1930] = 1784,
  [1931] = 1810,
  [1932] = 1811,
  [1933] = 1933,
  [1934] = 1771,
  [1935] = 1769,
  [1936] = 1936,
  [1937] = 1819,
  [1938] = 1860,
  [1939] = 1775,
  [1940] = 1766,
  [1941] = 1771,
  [1942] = 1773,
  [1943] = 1943,
  [1944] = 1766,
  [1945] = 1873,
  [1946] = 1803,
  [1947] = 1787,
  [1948] = 1758,
  [1949] = 1860,
  [1950] = 1950,
  [1951] = 1784,
  [1952] = 1810,
  [1953] = 1860,
  [1954] = 1954,
  [1955] = 1775,
  [1956] = 1810,
  [1957] = 1810,
  [1958] = 1775,
  [1959] = 1797,
  [1960] = 1960,
  [1961] = 1811,
  [1962] = 1962,
  [1963] = 1767,
  [1964] = 1765,
  [1965] = 1766,
  [1966] = 1858,
  [1967] = 1967,
  [1968] = 1968,
  [1969] = 1803,
  [1970] = 1970,
  [1971] = 1971,
  [1972] = 1839,
  [1973] = 1973,
  [1974] = 1757,
  [1975] = 1008,
  [1976] = 1976,
  [1977] = 1823,
  [1978] = 1846,
  [1979] = 1774,
  [1980] = 1764,
  [1981] = 1981,
  [1982] = 1832,
  [1983] = 1768,
  [1984] = 1778,
  [1985] = 1985,
  [1986] = 1765,
  [1987] = 1810,
  [1988] = 1873,
  [1989] = 1757,
  [1990] = 1786,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1994,
  [1995] = 1995,
  [1996] = 1793,
  [1997] = 1773,
  [1998] = 1998,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 2001,
  [2002] = 1765,
  [2003] = 1763,
  [2004] = 2004,
  [2005] = 1765,
  [2006] = 2006,
  [2007] = 1774,
  [2008] = 2008,
};

static TSCharacterRange sym_number_literal_character_set_13[] = {
  {'0', '9'}, {'B', 'B'}, {'D', 'D'}, {'F', 'F'}, {'L', 'L'}, {'U', 'U'}, {'W', 'W'}, {'b', 'b'},
  {'d', 'd'}, {'f', 'f'}, {'l', 'l'}, {'u', 'u'}, {'w', 'w'},
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328},
  {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a},
  {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644},
  {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909},
  {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1},
  {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8},
  {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33},
  {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646},
  {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c},
  {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505},
  {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550},
  {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e},
  {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c},
  {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d},
  {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5},
  {0xb7, 0xb7}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1},
  {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd},
  {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669},
  {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5},
  {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1},
  {0x8e3, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1},
  {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33},
  {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3},
  {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff},
  {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44},
  {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a},
  {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf3}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63},
  {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e},
  {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4},
  {0xec6, 0xec6}, {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35},
  {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e},
  {0x1920, 0x192b}, {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b},
  {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c},
  {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba},
  {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040},
  {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe},
  {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d},
  {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827},
  {0xa82c, 0xa82c}, {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953},
  {0xa960, 0xa97c}, {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76},
  {0xaa7a, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a},
  {0xff65, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a},
  {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0},
  {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5},
  {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a},
  {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755},
  {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838},
  {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939},
  {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a},
  {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac},
  {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046},
  {0x11066, 0x11075}, {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147},
  {0x11150, 0x11173}, {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237},
  {0x1123e, 0x11241}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9},
  {0x11300, 0x11303}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344},
  {0x11347, 0x11348}, {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a},
  {0x11450, 0x11459}, {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd},
  {0x11600, 0x11640}, {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739},
  {0x11740, 0x11746}, {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935},
  {0x11937, 0x11938}, {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e},
  {0x11a47, 0x11a47}, {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59},
  {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d},
  {0x11d3f, 0x11d47}, {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9},
  {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e},
  {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69},
  {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77},
  {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1},
  {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132},
  {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99},
  {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad},
  {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9},
  {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e},
  {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714},
  {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff},
  {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a},
  {0x1e000, 0x1e006}, {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c},
  {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb},
  {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f},
  {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42},
  {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59},
  {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77},
  {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9},
  {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
  {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(120);
      ADVANCE_MAP(
        '!', 187,
        '"', 286,
        '#', 75,
        '%', 204,
        '&', 213,
        '\'', 277,
        '(', 124,
        ')', 127,
        '*', 200,
        '+', 195,
        ',', 126,
        '-', 190,
        '.', 253,
        '/', 202,
        '0', 259,
        ':', 237,
        ';', 226,
        '<', 220,
        '=', 236,
        '>', 216,
        '?', 238,
        'L', 298,
        'U', 300,
        '[', 233,
        '\\', 2,
        ']', 234,
        '^', 210,
        'u', 302,
        '{', 230,
        '|', 207,
        '}', 231,
        '~', 188,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(118);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(43);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(43);
      if (lookahead == '\r') SKIP(1);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(46);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(46);
      if (lookahead == '\r') SKIP(3);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(45);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(45);
      if (lookahead == '\r') SKIP(5);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(47);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(47);
      if (lookahead == '\r') SKIP(7);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(49);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(49);
      if (lookahead == '\r') SKIP(9);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(52);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(52);
      if (lookahead == '\r') SKIP(11);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(53);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(53);
      if (lookahead == '\r') SKIP(13);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(57);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(57);
      if (lookahead == '\r') SKIP(15);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(50);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(50);
      if (lookahead == '\r') SKIP(17);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(51);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(51);
      if (lookahead == '\r') SKIP(19);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(23);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(23);
      if (lookahead == '\r') SKIP(21);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '\n', 129,
        '!', 68,
        '%', 203,
        '&', 212,
        '(', 185,
        '*', 199,
        '+', 194,
        '-', 189,
        '/', 201,
        '<', 221,
        '=', 69,
        '>', 217,
      );
      if (lookahead == '\\') SKIP(22);
      if (lookahead == '^') ADVANCE(209);
      if (lookahead == '|') ADVANCE(208);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(48);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(48);
      if (lookahead == '\r') SKIP(24);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(56);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(56);
      if (lookahead == '\r') SKIP(26);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(54);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(54);
      if (lookahead == '\r') SKIP(28);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(58);
      if (lookahead == '\'') ADVANCE(277);
      if (lookahead == '/') ADVANCE(280);
      if (lookahead == '\\') ADVANCE(279);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(281);
      if (lookahead != 0) ADVANCE(278);
      END_STATE();
    case 31:
      if (lookahead == '\n') ADVANCE(293);
      if (lookahead == '\r') ADVANCE(292);
      if (lookahead == 'U') ADVANCE(116);
      if (lookahead == 'u') ADVANCE(108);
      if (lookahead == 'x') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(295);
      if (lookahead != 0) ADVANCE(292);
      END_STATE();
    case 32:
      if (lookahead == '\n') ADVANCE(122);
      if (lookahead == '\r') ADVANCE(36);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == '/') ADVANCE(150);
      if (lookahead == '\\') ADVANCE(145);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(66);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 33:
      if (lookahead == '\n') ADVANCE(122);
      if (lookahead == '\r') ADVANCE(36);
      if (lookahead == '/') ADVANCE(150);
      if (lookahead == '\\') ADVANCE(145);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(66);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 34:
      if (lookahead == '\n') ADVANCE(122);
      if (lookahead == '\r') ADVANCE(35);
      if (lookahead == '(') ADVANCE(185);
      if (lookahead == '/') ADVANCE(60);
      if (lookahead == '\\') SKIP(39);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(59);
      END_STATE();
    case 35:
      if (lookahead == '\n') ADVANCE(122);
      if (lookahead == '(') ADVANCE(185);
      if (lookahead == '/') ADVANCE(60);
      if (lookahead == '\\') SKIP(39);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      END_STATE();
    case 36:
      if (lookahead == '\n') ADVANCE(122);
      if (lookahead == '/') ADVANCE(150);
      if (lookahead == '\\') ADVANCE(145);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(55);
      if (lookahead == '"') ADVANCE(286);
      if (lookahead == '/') ADVANCE(287);
      if (lookahead == '\\') ADVANCE(31);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(290);
      if (lookahead != 0) ADVANCE(291);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(59);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(59);
      if (lookahead == '\r') SKIP(38);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(44);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(44);
      if (lookahead == '\r') SKIP(40);
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 42:
      if (lookahead == '\r') ADVANCE(319);
      if (lookahead == '\\') ADVANCE(313);
      if (lookahead != 0) ADVANCE(318);
      END_STATE();
    case 43:
      ADVANCE_MAP(
        '!', 187,
        '"', 286,
        '#', 75,
        '%', 204,
        '&', 213,
        '\'', 277,
        '(', 185,
        ')', 127,
        '*', 200,
        '+', 195,
        ',', 126,
        '-', 190,
        '.', 253,
        '/', 202,
        '0', 259,
        ':', 237,
        ';', 226,
        '<', 220,
        '=', 236,
        '>', 216,
        '?', 238,
        'L', 298,
        'U', 300,
        '[', 233,
        '\\', 2,
        ']', 234,
        '^', 210,
        'u', 302,
        '{', 230,
        '|', 207,
        '}', 231,
        '~', 188,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 44:
      ADVANCE_MAP(
        '!', 187,
        '"', 286,
        '#', 83,
        '%', 204,
        '&', 213,
        '\'', 277,
        '(', 185,
        ')', 127,
        '*', 200,
        '+', 195,
        ',', 126,
        '-', 190,
        '.', 253,
        '/', 202,
        '0', 259,
        ':', 237,
        ';', 226,
        '<', 220,
        '=', 236,
        '>', 216,
        '?', 238,
        'L', 298,
        'U', 300,
        '[', 232,
        '\\', 41,
        ']', 234,
        '^', 210,
        'u', 302,
        '{', 230,
        '|', 207,
        '}', 231,
        '~', 188,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '!', 186,
        '"', 286,
        '#', 75,
        '&', 211,
        '\'', 277,
        '(', 185,
        '*', 199,
        '+', 196,
        ',', 126,
        '-', 191,
        '.', 96,
        '/', 60,
        '0', 259,
        ':', 67,
        ';', 226,
        'L', 298,
        'U', 300,
        '[', 73,
        '\\', 6,
        ']', 74,
        'u', 302,
        '{', 230,
        '~', 188,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '!', 186,
        '"', 286,
        '#', 79,
        '&', 211,
        '\'', 277,
        '(', 185,
        ')', 127,
        '*', 199,
        '+', 196,
        ',', 126,
        '-', 191,
        '.', 254,
        '/', 60,
        '0', 259,
        ':', 237,
        ';', 226,
        '=', 235,
        'L', 298,
        'U', 300,
        '[', 233,
        '\\', 4,
        ']', 234,
        'u', 302,
        '{', 230,
        '}', 231,
        '~', 188,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '!', 186,
        '"', 286,
        '#', 77,
        '&', 211,
        '\'', 277,
        '(', 185,
        '*', 199,
        '+', 196,
        '-', 191,
        '.', 96,
        '/', 60,
        '0', 259,
        ';', 226,
        'L', 298,
        'U', 300,
        '[', 73,
        '\\', 8,
        'u', 302,
        '{', 230,
        '~', 188,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '!', 186,
        '\'', 277,
        '(', 185,
        ')', 127,
        '+', 198,
        '-', 193,
        '.', 96,
        '/', 60,
        '0', 259,
        'L', 306,
        'U', 307,
        '\\', 25,
        'u', 308,
        '~', 188,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '!', 68,
        '"', 286,
        '#', 83,
        '%', 204,
        '&', 213,
        '(', 185,
        ')', 127,
        '*', 200,
        '+', 197,
        ',', 126,
        '-', 192,
        '.', 252,
        '/', 202,
        ':', 237,
        ';', 226,
        '<', 220,
        '=', 236,
        '>', 216,
        '?', 238,
        'L', 299,
        'U', 301,
        '[', 233,
        '\\', 10,
        ']', 234,
        '^', 210,
        'u', 303,
        '|', 207,
        '}', 231,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '!', 68,
        '#', 83,
        '%', 204,
        '&', 213,
        '(', 185,
        ')', 127,
        '*', 200,
        '+', 197,
        ',', 126,
        '-', 192,
        '.', 252,
        '/', 202,
        ':', 237,
        ';', 226,
        '<', 220,
        '=', 236,
        '>', 216,
        '?', 238,
        '[', 233,
        '\\', 18,
        ']', 234,
        '^', 210,
        '{', 230,
        '|', 207,
        '}', 231,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '!', 68,
        '#', 83,
        '%', 204,
        '&', 213,
        '(', 185,
        ')', 127,
        '*', 200,
        '+', 197,
        ',', 126,
        '-', 192,
        '.', 251,
        '/', 202,
        ':', 237,
        ';', 226,
        '<', 220,
        '=', 236,
        '>', 216,
        '?', 238,
        '[', 232,
        '\\', 20,
        ']', 74,
        '^', 210,
        '|', 207,
        '}', 231,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '!', 68,
        '#', 76,
        '%', 204,
        '&', 213,
        '(', 185,
        ')', 127,
        '*', 200,
        '+', 197,
        ',', 126,
        '-', 192,
        '.', 252,
        '/', 202,
        ':', 237,
        ';', 226,
        '<', 220,
        '=', 236,
        '>', 216,
        '?', 238,
        '[', 233,
        '\\', 12,
        '^', 210,
        '{', 230,
        '|', 207,
        '}', 231,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '!', 68,
        '#', 78,
        '%', 203,
        '&', 212,
        '(', 185,
        ')', 127,
        '*', 199,
        '+', 194,
        ',', 126,
        '-', 189,
        '/', 201,
        ';', 226,
        '<', 221,
        '=', 236,
        '>', 217,
        '[', 233,
        '\\', 14,
        '^', 209,
        '{', 230,
        '|', 208,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 54:
      if (lookahead == '"') ADVANCE(286);
      if (lookahead == '/') ADVANCE(60);
      if (lookahead == '<') ADVANCE(70);
      if (lookahead == 'L') ADVANCE(299);
      if (lookahead == 'U') ADVANCE(301);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == 'u') ADVANCE(303);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 55:
      if (lookahead == '"') ADVANCE(286);
      if (lookahead == '/') ADVANCE(60);
      if (lookahead == '\\') ADVANCE(31);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      END_STATE();
    case 56:
      if (lookahead == '#') ADVANCE(93);
      if (lookahead == '/') ADVANCE(60);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == '}') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 57:
      if (lookahead == '#') ADVANCE(80);
      if (lookahead == '/') ADVANCE(60);
      if (lookahead == '[') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead == '}') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 58:
      if (lookahead == '\'') ADVANCE(277);
      if (lookahead == '/') ADVANCE(60);
      if (lookahead == '\\') ADVANCE(31);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      END_STATE();
    case 59:
      if (lookahead == '(') ADVANCE(185);
      if (lookahead == '/') ADVANCE(60);
      if (lookahead == '\\') SKIP(39);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      END_STATE();
    case 60:
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '/') ADVANCE(318);
      END_STATE();
    case 61:
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '/') ADVANCE(311);
      if (lookahead != 0) ADVANCE(62);
      END_STATE();
    case 62:
      if (lookahead == '*') ADVANCE(61);
      if (lookahead != 0) ADVANCE(62);
      END_STATE();
    case 63:
      if (lookahead == '*') ADVANCE(61);
      if (lookahead != 0) ADVANCE(143);
      END_STATE();
    case 64:
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '0') ADVANCE(257);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(258);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(267);
      END_STATE();
    case 65:
      if (lookahead == '.') ADVANCE(125);
      END_STATE();
    case 66:
      if (lookahead == '/') ADVANCE(150);
      if (lookahead == '\\') ADVANCE(145);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 67:
      if (lookahead == ':') ADVANCE(227);
      END_STATE();
    case 68:
      if (lookahead == '=') ADVANCE(215);
      END_STATE();
    case 69:
      if (lookahead == '=') ADVANCE(214);
      END_STATE();
    case 70:
      if (lookahead == '>') ADVANCE(296);
      if (lookahead == '\\') ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(70);
      END_STATE();
    case 71:
      if (lookahead == '>') ADVANCE(297);
      if (lookahead == '\\') ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(70);
      END_STATE();
    case 72:
      if (lookahead == 'U') ADVANCE(115);
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 73:
      if (lookahead == '[') ADVANCE(228);
      END_STATE();
    case 74:
      if (lookahead == ']') ADVANCE(229);
      END_STATE();
    case 75:
      if (lookahead == 'd') ADVANCE(159);
      if (lookahead == 'e') ADVANCE(179);
      if (lookahead == 'i') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 76:
      if (lookahead == 'd') ADVANCE(159);
      if (lookahead == 'e') ADVANCE(179);
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 77:
      if (lookahead == 'd') ADVANCE(159);
      if (lookahead == 'e') ADVANCE(181);
      if (lookahead == 'i') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 78:
      if (lookahead == 'd') ADVANCE(159);
      if (lookahead == 'e') ADVANCE(181);
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 79:
      if (lookahead == 'd') ADVANCE(159);
      if (lookahead == 'i') ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 80:
      if (lookahead == 'd') ADVANCE(159);
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 81:
      if (lookahead == 'd') ADVANCE(92);
      END_STATE();
    case 82:
      if (lookahead == 'd') ADVANCE(86);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(94);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(83);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 87:
      if (lookahead == 'f') ADVANCE(136);
      END_STATE();
    case 88:
      if (lookahead == 'f') ADVANCE(130);
      END_STATE();
    case 89:
      if (lookahead == 'f') ADVANCE(138);
      END_STATE();
    case 90:
      if (lookahead == 'f') ADVANCE(140);
      END_STATE();
    case 91:
      if (lookahead == 'i') ADVANCE(87);
      if (lookahead == 's') ADVANCE(84);
      END_STATE();
    case 92:
      if (lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 94:
      if (lookahead == 'l') ADVANCE(91);
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 95:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 96:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(256);
      END_STATE();
    case 97:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(258);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(267);
      END_STATE();
    case 98:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(310);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(264);
      END_STATE();
    case 100:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(267);
      END_STATE();
    case 101:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(262);
      END_STATE();
    case 102:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(292);
      END_STATE();
    case 103:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(98);
      END_STATE();
    case 104:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(102);
      END_STATE();
    case 105:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(103);
      END_STATE();
    case 106:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 107:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(105);
      END_STATE();
    case 108:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(106);
      END_STATE();
    case 109:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(107);
      END_STATE();
    case 110:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(108);
      END_STATE();
    case 111:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(109);
      END_STATE();
    case 112:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(110);
      END_STATE();
    case 113:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(111);
      END_STATE();
    case 114:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(112);
      END_STATE();
    case 115:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(113);
      END_STATE();
    case 116:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(114);
      END_STATE();
    case 117:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(152);
      END_STATE();
    case 118:
      if (eof) ADVANCE(120);
      ADVANCE_MAP(
        '!', 187,
        '"', 286,
        '#', 75,
        '%', 204,
        '&', 213,
        '\'', 277,
        '(', 185,
        ')', 127,
        '*', 200,
        '+', 195,
        ',', 126,
        '-', 190,
        '.', 253,
        '/', 202,
        '0', 259,
        ':', 237,
        ';', 226,
        '<', 220,
        '=', 236,
        '>', 216,
        '?', 238,
        'L', 298,
        'U', 300,
        '[', 233,
        '\\', 2,
        ']', 234,
        '^', 210,
        'u', 302,
        '{', 230,
        '|', 207,
        '}', 231,
        '~', 188,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(118);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 119:
      if (eof) ADVANCE(120);
      ADVANCE_MAP(
        '!', 186,
        '"', 286,
        '#', 79,
        '&', 211,
        '\'', 277,
        '(', 185,
        ')', 127,
        '*', 199,
        '+', 196,
        ',', 126,
        '-', 191,
        '.', 254,
        '/', 60,
        '0', 259,
        ':', 237,
        ';', 226,
        '=', 235,
        'L', 298,
        'U', 300,
        '[', 233,
        '\\', 4,
        ']', 234,
        'u', 302,
        '{', 230,
        '}', 231,
        '~', 188,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(119);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(310);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(163);
      if (lookahead == 'n') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(129);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(85);
      if (lookahead == 'n') ADVANCE(82);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(165);
      if (lookahead == 'n') ADVANCE(158);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(62);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '/') ADVANCE(311);
      if (lookahead == '\\') ADVANCE(148);
      if (lookahead != 0) ADVANCE(143);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(62);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(148);
      if (lookahead != 0) ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(318);
      if (lookahead == '\r') ADVANCE(312);
      if (lookahead == '/') ADVANCE(315);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead != 0) ADVANCE(316);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(66);
      if (lookahead == '\r') ADVANCE(146);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(66);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(153);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(151);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(148);
      if (lookahead != 0) ADVANCE(143);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(317);
      if (lookahead == '/') ADVANCE(315);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead != 0) ADVANCE(316);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(143);
      if (lookahead == '/') ADVANCE(315);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(152);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(148);
      if (lookahead != 0) ADVANCE(143);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '\\') ADVANCE(147);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(169);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(128);
      if (lookahead == 'n') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(131);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(182);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(170);
      if (lookahead == 's') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(171);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(177);
      if (lookahead == 'n') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(215);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(249);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '0') ADVANCE(259);
      if (lookahead == '=') ADVANCE(243);
      if (lookahead == '>') ADVANCE(255);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(249);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '0') ADVANCE(259);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(249);
      if (lookahead == '=') ADVANCE(243);
      if (lookahead == '>') ADVANCE(255);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '0') ADVANCE(259);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(250);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '0') ADVANCE(259);
      if (lookahead == '=') ADVANCE(242);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(250);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '0') ADVANCE(259);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(250);
      if (lookahead == '=') ADVANCE(242);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '0') ADVANCE(259);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(239);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '/') ADVANCE(318);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '/') ADVANCE(318);
      if (lookahead == '=') ADVANCE(240);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(241);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(248);
      if (lookahead == '|') ADVANCE(205);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(205);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(247);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(206);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(206);
      if (lookahead == '=') ADVANCE(246);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(218);
      if (lookahead == '>') ADVANCE(225);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(218);
      if (lookahead == '>') ADVANCE(224);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(223);
      if (lookahead == '=') ADVANCE(219);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(222);
      if (lookahead == '=') ADVANCE(219);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(244);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(245);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(228);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(214);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(65);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(256);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(256);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(96);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(269);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(256);
      if (set_contains(sym_number_literal_character_set_13, 13, lookahead)) ADVANCE(272);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 97,
        '.', 270,
        'B', 266,
        'b', 266,
        'E', 265,
        'e', 265,
        'P', 269,
        'p', 269,
        'X', 100,
        'x', 100,
        'A', 267,
        'C', 267,
        'a', 267,
        'c', 267,
        'D', 267,
        'F', 267,
        'd', 267,
        'f', 267,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(258);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 97,
        '.', 270,
        'E', 265,
        'e', 265,
        'P', 269,
        'p', 269,
        'A', 267,
        'C', 267,
        'a', 267,
        'c', 267,
        'B', 267,
        'D', 267,
        'F', 267,
        'b', 267,
        'd', 267,
        'f', 267,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(258);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 95,
        '.', 270,
        'B', 268,
        'b', 268,
        'X', 64,
        'x', 64,
        'E', 269,
        'P', 269,
        'e', 269,
        'p', 269,
        'D', 272,
        'F', 272,
        'L', 272,
        'U', 272,
        'W', 272,
        'd', 272,
        'f', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 95,
        '.', 270,
        'B', 271,
        'b', 271,
        'X', 100,
        'x', 100,
        'E', 269,
        'P', 269,
        'e', 269,
        'p', 269,
        'D', 272,
        'F', 272,
        'L', 272,
        'U', 272,
        'W', 272,
        'd', 272,
        'f', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(261);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(95);
      if (lookahead == '.') ADVANCE(270);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(269);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_number_literal_character_set_13, 13, lookahead)) ADVANCE(272);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 101,
        'B', 262,
        'D', 262,
        'F', 262,
        'b', 262,
        'd', 262,
        'f', 262,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(262);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 99,
        '+', 101,
        '-', 101,
        'E', 263,
        'e', 263,
        'P', 269,
        'p', 269,
        'B', 264,
        'D', 264,
        'F', 264,
        'b', 264,
        'd', 264,
        'f', 264,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(264);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 99,
        'E', 263,
        'e', 263,
        'P', 269,
        'p', 269,
        'B', 264,
        'D', 264,
        'F', 264,
        'b', 264,
        'd', 264,
        'f', 264,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(264);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 100,
        '.', 270,
        '+', 101,
        '-', 101,
        'E', 265,
        'e', 265,
        'P', 269,
        'p', 269,
        'B', 267,
        'D', 267,
        'F', 267,
        'b', 267,
        'd', 267,
        'f', 267,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(267);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 100,
        '.', 270,
        'E', 265,
        'e', 265,
        'P', 269,
        'p', 269,
        'A', 267,
        'C', 267,
        'a', 267,
        'c', 267,
        'B', 267,
        'D', 267,
        'F', 267,
        'b', 267,
        'd', 267,
        'f', 267,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(258);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 100,
        '.', 270,
        'E', 265,
        'e', 265,
        'P', 269,
        'p', 269,
        'B', 267,
        'D', 267,
        'F', 267,
        'b', 267,
        'd', 267,
        'f', 267,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(267);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.') ADVANCE(96);
      if (lookahead == '0') ADVANCE(260);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_number_literal_character_set_13, 13, lookahead)) ADVANCE(272);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '+', 101,
        '-', 101,
        'B', 262,
        'D', 262,
        'F', 262,
        'b', 262,
        'd', 262,
        'f', 262,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(262);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'E', 263,
        'e', 263,
        'P', 269,
        'p', 269,
        'B', 264,
        'D', 264,
        'F', 264,
        'b', 264,
        'd', 264,
        'f', 264,
        'L', 272,
        'U', 272,
        'W', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(264);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(261);
      if (set_contains(sym_number_literal_character_set_13, 13, lookahead)) ADVANCE(272);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'B', 272,
        'D', 272,
        'F', 272,
        'L', 272,
        'U', 272,
        'W', 272,
        'b', 272,
        'd', 272,
        'f', 272,
        'l', 272,
        'u', 272,
        'w', 272,
      );
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(293);
      if (lookahead == '\r') ADVANCE(292);
      if (lookahead == 'U') ADVANCE(116);
      if (lookahead == 'u') ADVANCE(108);
      if (lookahead == 'x') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(295);
      if (lookahead != 0) ADVANCE(292);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '/') ADVANCE(318);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(31);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(289);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(291);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(288);
      if (lookahead == '/') ADVANCE(291);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(288);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(289);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(287);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(290);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(291);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(291);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(31);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(292);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(294);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(296);
      if (lookahead == '\\') ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(70);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(282);
      if (lookahead == '\'') ADVANCE(273);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(282);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(284);
      if (lookahead == '\'') ADVANCE(275);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(284);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(283);
      if (lookahead == '\'') ADVANCE(274);
      if (lookahead == '8') ADVANCE(304);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(283);
      if (lookahead == '8') ADVANCE(305);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(285);
      if (lookahead == '\'') ADVANCE(276);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(285);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(273);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(275);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(274);
      if (lookahead == '8') ADVANCE(309);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(276);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(310);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(318);
      if (lookahead == '/') ADVANCE(315);
      if (lookahead == '\\') ADVANCE(149);
      if (lookahead != 0) ADVANCE(316);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(319);
      if (lookahead == '\\') ADVANCE(313);
      if (lookahead != 0) ADVANCE(318);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(317);
      if (lookahead == '/') ADVANCE(315);
      if (lookahead == '\\') ADVANCE(314);
      if (lookahead != 0) ADVANCE(316);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(318);
      if (lookahead == '\\') ADVANCE(144);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(316);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(315);
      if (lookahead == '\\') ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(316);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(315);
      if (lookahead == '\\') ADVANCE(149);
      if (lookahead != 0) ADVANCE(316);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(42);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(318);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(42);
      if (lookahead != 0) ADVANCE(318);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4);
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'm') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      if (lookahead == 'o') ADVANCE(17);
      if (lookahead == 'p') ADVANCE(18);
      if (lookahead == 'r') ADVANCE(19);
      if (lookahead == 's') ADVANCE(20);
      if (lookahead == 't') ADVANCE(21);
      if (lookahead == 'u') ADVANCE(22);
      if (lookahead == 'v') ADVANCE(23);
      if (lookahead == 'w') ADVANCE(24);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'U') ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == 'R') ADVANCE(27);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(28);
      END_STATE();
    case 5:
      if (lookahead == 'A') ADVANCE(29);
      if (lookahead == 'G') ADVANCE(30);
      if (lookahead == 'N') ADVANCE(31);
      if (lookahead == '_') ADVANCE(32);
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 's') ADVANCE(36);
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == 'h') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'o') ADVANCE(44);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(46);
      if (lookahead == 'x') ADVANCE(47);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(48);
      if (lookahead == 'l') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(51);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(52);
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'o') ADVANCE(54);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(55);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 17:
      if (lookahead == 'f') ADVANCE(58);
      END_STATE();
    case 18:
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(61);
      if (lookahead == 'i') ADVANCE(62);
      if (lookahead == 's') ADVANCE(63);
      if (lookahead == 't') ADVANCE(64);
      if (lookahead == 'w') ADVANCE(65);
      END_STATE();
    case 21:
      if (lookahead == 'h') ADVANCE(66);
      if (lookahead == 'r') ADVANCE(67);
      if (lookahead == 'y') ADVANCE(68);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 24:
      if (lookahead == 'h') ADVANCE(72);
      END_STATE();
    case 25:
      if (lookahead == 'L') ADVANCE(73);
      END_STATE();
    case 26:
      if (lookahead == 'L') ADVANCE(74);
      END_STATE();
    case 27:
      if (lookahead == 'U') ADVANCE(75);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(76);
      if (lookahead == 't') ADVANCE(77);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 31:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        'a', 80,
        'b', 81,
        'c', 82,
        'd', 83,
        'e', 84,
        'f', 85,
        'i', 86,
        'l', 87,
        'r', 88,
        's', 89,
        't', 90,
        'u', 91,
        'v', 92,
      );
      END_STATE();
    case 33:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(95);
      END_STATE();
    case 36:
      if (lookahead == 'm') ADVANCE(96);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(98);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(100);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 42:
      if (lookahead == 'n') ADVANCE(102);
      END_STATE();
    case 43:
      if (lookahead == 'f') ADVANCE(103);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(104);
      END_STATE();
    case 45:
      if (lookahead == 's') ADVANCE(105);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(106);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 48:
      if (lookahead == 'l') ADVANCE(108);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(110);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(112);
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 54:
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 55:
      if (lookahead == 'x') ADVANCE(115);
      END_STATE();
    case 56:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 58:
      if (lookahead == 'f') ADVANCE(118);
      END_STATE();
    case 59:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 60:
      if (lookahead == 'g') ADVANCE(120);
      if (lookahead == 's') ADVANCE(121);
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 61:
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 62:
      if (lookahead == 'g') ADVANCE(124);
      if (lookahead == 'z') ADVANCE(125);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(127);
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(129);
      END_STATE();
    case 66:
      if (lookahead == 'r') ADVANCE(130);
      END_STATE();
    case 67:
      if (lookahead == 'u') ADVANCE(131);
      END_STATE();
    case 68:
      if (lookahead == 'p') ADVANCE(132);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(133);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(134);
      if (lookahead == 's') ADVANCE(135);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(136);
      if (lookahead == 'l') ADVANCE(137);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(138);
      END_STATE();
    case 73:
      if (lookahead == 'S') ADVANCE(139);
      END_STATE();
    case 74:
      if (lookahead == 'L') ADVANCE(140);
      END_STATE();
    case 75:
      if (lookahead == 'E') ADVANCE(141);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(142);
      END_STATE();
    case 77:
      if (lookahead == 'o') ADVANCE(143);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 79:
      if (lookahead == 'n') ADVANCE(145);
      if (lookahead == 'r') ADVANCE(146);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(147);
      if (lookahead == 's') ADVANCE(148);
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 82:
      if (lookahead == 'd') ADVANCE(151);
      if (lookahead == 'l') ADVANCE(152);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 84:
      if (lookahead == 'x') ADVANCE(154);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(155);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == 'o') ADVANCE(157);
      END_STATE();
    case 86:
      if (lookahead == 'n') ADVANCE(158);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 89:
      if (lookahead == 'p') ADVANCE(161);
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 90:
      if (lookahead == 'h') ADVANCE(163);
      if (lookahead == 'r') ADVANCE(164);
      END_STATE();
    case 91:
      if (lookahead == 'n') ADVANCE(165);
      if (lookahead == 'p') ADVANCE(166);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(167);
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(170);
      END_STATE();
    case 95:
      if (lookahead == 'g') ADVANCE(171);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 97:
      if (lookahead == 'o') ADVANCE(172);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(173);
      END_STATE();
    case 99:
      if (lookahead == 'a') ADVANCE(174);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 101:
      if (lookahead == 'r') ADVANCE(176);
      END_STATE();
    case 102:
      if (lookahead == 's') ADVANCE(177);
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(179);
      if (lookahead == 'i') ADVANCE(180);
      END_STATE();
    case 104:
      if (lookahead == 'b') ADVANCE(181);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 106:
      if (lookahead == 'm') ADVANCE(183);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 108:
      if (lookahead == 's') ADVANCE(185);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(186);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 111:
      if (lookahead == 'o') ADVANCE(187);
      END_STATE();
    case 112:
      if (lookahead == 'i') ADVANCE(188);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(189);
      if (lookahead == '3') ADVANCE(190);
      if (lookahead == '6') ADVANCE(191);
      if (lookahead == '8') ADVANCE(192);
      if (lookahead == 'p') ADVANCE(193);
      END_STATE();
    case 114:
      if (lookahead == 'g') ADVANCE(194);
      END_STATE();
    case 115:
      if (lookahead == '_') ADVANCE(195);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(197);
      END_STATE();
    case 118:
      if (lookahead == 's') ADVANCE(198);
      END_STATE();
    case 119:
      if (lookahead == 'd') ADVANCE(199);
      END_STATE();
    case 120:
      if (lookahead == 'i') ADVANCE(200);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 122:
      if (lookahead == 'u') ADVANCE(202);
      END_STATE();
    case 123:
      if (lookahead == 'r') ADVANCE(203);
      END_STATE();
    case 124:
      if (lookahead == 'n') ADVANCE(204);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 126:
      if (lookahead == 'z') ADVANCE(206);
      END_STATE();
    case 127:
      if (lookahead == 't') ADVANCE(207);
      END_STATE();
    case 128:
      if (lookahead == 'u') ADVANCE(208);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(209);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(211);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 134:
      if (lookahead == 'o') ADVANCE(213);
      END_STATE();
    case 135:
      if (lookahead == 'i') ADVANCE(214);
      END_STATE();
    case 136:
      if (lookahead == 'd') ADVANCE(173);
      END_STATE();
    case 137:
      if (lookahead == 'a') ADVANCE(215);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(216);
      END_STATE();
    case 139:
      if (lookahead == 'E') ADVANCE(217);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 142:
      if (lookahead == 'g') ADVANCE(218);
      END_STATE();
    case 143:
      if (lookahead == 'm') ADVANCE(219);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 145:
      if (lookahead == 'n') ADVANCE(221);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 147:
      if (lookahead == 'i') ADVANCE(223);
      END_STATE();
    case 148:
      if (lookahead == 'm') ADVANCE(224);
      END_STATE();
    case 149:
      if (lookahead == 't') ADVANCE(225);
      END_STATE();
    case 150:
      if (lookahead == 's') ADVANCE(226);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 152:
      if (lookahead == 'r') ADVANCE(228);
      END_STATE();
    case 153:
      if (lookahead == 'c') ADVANCE(229);
      END_STATE();
    case 154:
      if (lookahead == 'c') ADVANCE(230);
      if (lookahead == 't') ADVANCE(231);
      END_STATE();
    case 155:
      if (lookahead == 's') ADVANCE(232);
      END_STATE();
    case 156:
      if (lookahead == 'n') ADVANCE(233);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(234);
      END_STATE();
    case 158:
      if (lookahead == 'l') ADVANCE(235);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(237);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(238);
      END_STATE();
    case 162:
      if (lookahead == 'd') ADVANCE(239);
      END_STATE();
    case 163:
      if (lookahead == 'i') ADVANCE(240);
      if (lookahead == 'r') ADVANCE(241);
      END_STATE();
    case 164:
      if (lookahead == 'y') ADVANCE(242);
      END_STATE();
    case 165:
      if (lookahead == 'a') ADVANCE(243);
      END_STATE();
    case 166:
      if (lookahead == 't') ADVANCE(244);
      END_STATE();
    case 167:
      if (lookahead == 'c') ADVANCE(245);
      END_STATE();
    case 168:
      if (lookahead == 'l') ADVANCE(246);
      END_STATE();
    case 169:
      if (lookahead == 'g') ADVANCE(247);
      END_STATE();
    case 170:
      if (lookahead == 'l') ADVANCE(248);
      END_STATE();
    case 171:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_auto);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_primitive_type);
      END_STATE();
    case 174:
      if (lookahead == 'k') ADVANCE(250);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(251);
      if (lookahead == '3') ADVANCE(252);
      if (lookahead == '6') ADVANCE(253);
      if (lookahead == '8') ADVANCE(254);
      if (lookahead == 'p') ADVANCE(255);
      END_STATE();
    case 177:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 178:
      if (lookahead == 'i') ADVANCE(257);
      END_STATE();
    case 179:
      if (lookahead == 'u') ADVANCE(258);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(259);
      END_STATE();
    case 181:
      if (lookahead == 'l') ADVANCE(260);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(261);
      END_STATE();
    case 185:
      if (lookahead == 'e') ADVANCE(217);
      END_STATE();
    case 186:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 188:
      if (lookahead == 'n') ADVANCE(262);
      END_STATE();
    case 189:
      if (lookahead == '6') ADVANCE(263);
      END_STATE();
    case 190:
      if (lookahead == '2') ADVANCE(264);
      END_STATE();
    case 191:
      if (lookahead == '4') ADVANCE(265);
      END_STATE();
    case 192:
      if (lookahead == '_') ADVANCE(266);
      END_STATE();
    case 193:
      if (lookahead == 't') ADVANCE(267);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 195:
      if (lookahead == 'a') ADVANCE(268);
      END_STATE();
    case 196:
      if (lookahead == 't') ADVANCE(269);
      END_STATE();
    case 197:
      if (lookahead == 'p') ADVANCE(270);
      END_STATE();
    case 198:
      if (lookahead == 'e') ADVANCE(271);
      END_STATE();
    case 199:
      if (lookahead == 'i') ADVANCE(272);
      END_STATE();
    case 200:
      if (lookahead == 's') ADVANCE(273);
      END_STATE();
    case 201:
      if (lookahead == 'r') ADVANCE(274);
      END_STATE();
    case 202:
      if (lookahead == 'r') ADVANCE(275);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(276);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(277);
      END_STATE();
    case 205:
      if (lookahead == '_') ADVANCE(278);
      if (lookahead == 'o') ADVANCE(279);
      END_STATE();
    case 206:
      if (lookahead == 'e') ADVANCE(280);
      END_STATE();
    case 207:
      if (lookahead == 'i') ADVANCE(281);
      END_STATE();
    case 208:
      if (lookahead == 'c') ADVANCE(282);
      END_STATE();
    case 209:
      if (lookahead == 'c') ADVANCE(283);
      END_STATE();
    case 210:
      if (lookahead == 'a') ADVANCE(284);
      END_STATE();
    case 211:
      if (lookahead == 'd') ADVANCE(285);
      END_STATE();
    case 212:
      if (lookahead == '1') ADVANCE(286);
      if (lookahead == '3') ADVANCE(287);
      if (lookahead == '6') ADVANCE(288);
      if (lookahead == '8') ADVANCE(289);
      if (lookahead == 'p') ADVANCE(290);
      END_STATE();
    case 213:
      if (lookahead == 'n') ADVANCE(291);
      END_STATE();
    case 214:
      if (lookahead == 'g') ADVANCE(292);
      END_STATE();
    case 215:
      if (lookahead == 't') ADVANCE(293);
      END_STATE();
    case 216:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 218:
      if (lookahead == 'n') ADVANCE(295);
      END_STATE();
    case 219:
      if (lookahead == 'i') ADVANCE(296);
      END_STATE();
    case 220:
      if (lookahead == 'r') ADVANCE(297);
      END_STATE();
    case 221:
      if (lookahead == 'u') ADVANCE(298);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(299);
      END_STATE();
    case 223:
      if (lookahead == 'g') ADVANCE(300);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym___asm);
      if (lookahead == '_') ADVANCE(301);
      END_STATE();
    case 225:
      if (lookahead == 'r') ADVANCE(302);
      END_STATE();
    case 226:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 227:
      if (lookahead == 'c') ADVANCE(304);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(305);
      END_STATE();
    case 229:
      if (lookahead == 'l') ADVANCE(306);
      END_STATE();
    case 230:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 232:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 233:
      if (lookahead == 'a') ADVANCE(310);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(311);
      END_STATE();
    case 235:
      if (lookahead == 'i') ADVANCE(312);
      END_STATE();
    case 236:
      if (lookahead == 'v') ADVANCE(313);
      END_STATE();
    case 237:
      if (lookahead == 't') ADVANCE(314);
      END_STATE();
    case 238:
      if (lookahead == 'r') ADVANCE(315);
      END_STATE();
    case 239:
      if (lookahead == 'c') ADVANCE(316);
      END_STATE();
    case 240:
      if (lookahead == 's') ADVANCE(317);
      END_STATE();
    case 241:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 243:
      if (lookahead == 'l') ADVANCE(319);
      END_STATE();
    case 244:
      if (lookahead == 'r') ADVANCE(320);
      END_STATE();
    case 245:
      if (lookahead == 't') ADVANCE(321);
      END_STATE();
    case 246:
      if (lookahead == 'a') ADVANCE(322);
      END_STATE();
    case 247:
      if (lookahead == 'n') ADVANCE(323);
      END_STATE();
    case 248:
      if (lookahead == 'i') ADVANCE(324);
      END_STATE();
    case 249:
      if (lookahead == 'a') ADVANCE(325);
      if (lookahead == 'o') ADVANCE(326);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 251:
      if (lookahead == '6') ADVANCE(327);
      END_STATE();
    case 252:
      if (lookahead == '2') ADVANCE(328);
      END_STATE();
    case 253:
      if (lookahead == '4') ADVANCE(329);
      END_STATE();
    case 254:
      if (lookahead == '_') ADVANCE(330);
      END_STATE();
    case 255:
      if (lookahead == 't') ADVANCE(331);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(332);
      END_STATE();
    case 257:
      if (lookahead == 'n') ADVANCE(333);
      END_STATE();
    case 258:
      if (lookahead == 'l') ADVANCE(334);
      END_STATE();
    case 259:
      if (lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 260:
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 261:
      if (lookahead == 'n') ADVANCE(336);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(337);
      END_STATE();
    case 263:
      if (lookahead == '_') ADVANCE(338);
      END_STATE();
    case 264:
      if (lookahead == '_') ADVANCE(339);
      END_STATE();
    case 265:
      if (lookahead == '_') ADVANCE(340);
      END_STATE();
    case 266:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 267:
      if (lookahead == 'r') ADVANCE(341);
      END_STATE();
    case 268:
      if (lookahead == 'l') ADVANCE(342);
      END_STATE();
    case 269:
      if (lookahead == 'u') ADVANCE(343);
      END_STATE();
    case 270:
      if (lookahead == 't') ADVANCE(344);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(345);
      END_STATE();
    case 272:
      if (lookahead == 'f') ADVANCE(346);
      END_STATE();
    case 273:
      if (lookahead == 't') ADVANCE(347);
      END_STATE();
    case 274:
      if (lookahead == 'i') ADVANCE(348);
      END_STATE();
    case 275:
      if (lookahead == 'n') ADVANCE(349);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 277:
      if (lookahead == 'd') ADVANCE(350);
      END_STATE();
    case 278:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 279:
      if (lookahead == 'f') ADVANCE(351);
      END_STATE();
    case 280:
      if (lookahead == '_') ADVANCE(352);
      END_STATE();
    case 281:
      if (lookahead == 'c') ADVANCE(353);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(354);
      END_STATE();
    case 283:
      if (lookahead == 'h') ADVANCE(355);
      END_STATE();
    case 284:
      if (lookahead == 'd') ADVANCE(356);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(357);
      END_STATE();
    case 286:
      if (lookahead == '6') ADVANCE(358);
      END_STATE();
    case 287:
      if (lookahead == '2') ADVANCE(359);
      END_STATE();
    case 288:
      if (lookahead == '4') ADVANCE(360);
      END_STATE();
    case 289:
      if (lookahead == '_') ADVANCE(361);
      END_STATE();
    case 290:
      if (lookahead == 't') ADVANCE(362);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 292:
      if (lookahead == 'n') ADVANCE(363);
      END_STATE();
    case 293:
      if (lookahead == 'i') ADVANCE(364);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 295:
      if (lookahead == 'a') ADVANCE(365);
      if (lookahead == 'o') ADVANCE(366);
      END_STATE();
    case 296:
      if (lookahead == 'c') ADVANCE(367);
      END_STATE();
    case 297:
      if (lookahead == 'i') ADVANCE(368);
      END_STATE();
    case 298:
      if (lookahead == 'l') ADVANCE(369);
      END_STATE();
    case 299:
      if (lookahead == 'u') ADVANCE(370);
      END_STATE();
    case 300:
      if (lookahead == 'n') ADVANCE(371);
      END_STATE();
    case 301:
      if (lookahead == '_') ADVANCE(372);
      END_STATE();
    case 302:
      if (lookahead == 'i') ADVANCE(373);
      END_STATE();
    case 303:
      if (lookahead == 'd') ADVANCE(374);
      END_STATE();
    case 304:
      if (lookahead == 'l') ADVANCE(375);
      END_STATE();
    case 305:
      if (lookahead == 'a') ADVANCE(376);
      END_STATE();
    case 306:
      if (lookahead == 's') ADVANCE(377);
      END_STATE();
    case 307:
      if (lookahead == 'p') ADVANCE(378);
      END_STATE();
    case 308:
      if (lookahead == 'n') ADVANCE(379);
      END_STATE();
    case 309:
      if (lookahead == 'c') ADVANCE(380);
      END_STATE();
    case 310:
      if (lookahead == 'l') ADVANCE(381);
      END_STATE();
    case 311:
      if (lookahead == 'e') ADVANCE(382);
      END_STATE();
    case 312:
      if (lookahead == 'n') ADVANCE(383);
      END_STATE();
    case 313:
      if (lookahead == 'e') ADVANCE(384);
      END_STATE();
    case 314:
      if (lookahead == 'r') ADVANCE(385);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 316:
      if (lookahead == 'a') ADVANCE(386);
      END_STATE();
    case 317:
      if (lookahead == 'c') ADVANCE(387);
      END_STATE();
    case 318:
      if (lookahead == 'a') ADVANCE(388);
      END_STATE();
    case 319:
      if (lookahead == 'i') ADVANCE(389);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 321:
      if (lookahead == 'o') ADVANCE(390);
      END_STATE();
    case 322:
      if (lookahead == 't') ADVANCE(391);
      END_STATE();
    case 323:
      if (lookahead == 'o') ADVANCE(392);
      END_STATE();
    case 324:
      if (lookahead == 'g') ADVANCE(393);
      END_STATE();
    case 325:
      if (lookahead == 's') ADVANCE(394);
      END_STATE();
    case 326:
      if (lookahead == 'f') ADVANCE(395);
      END_STATE();
    case 327:
      if (lookahead == '_') ADVANCE(396);
      END_STATE();
    case 328:
      if (lookahead == '_') ADVANCE(397);
      END_STATE();
    case 329:
      if (lookahead == '_') ADVANCE(398);
      END_STATE();
    case 330:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 331:
      if (lookahead == 'r') ADVANCE(399);
      END_STATE();
    case 332:
      if (lookahead == 'x') ADVANCE(400);
      END_STATE();
    case 333:
      if (lookahead == 'u') ADVANCE(401);
      END_STATE();
    case 334:
      if (lookahead == 't') ADVANCE(402);
      END_STATE();
    case 335:
      if (lookahead == 'd') ADVANCE(403);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 338:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 339:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 340:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 341:
      if (lookahead == '_') ADVANCE(404);
      END_STATE();
    case 342:
      if (lookahead == 'i') ADVANCE(405);
      END_STATE();
    case 343:
      if (lookahead == 'r') ADVANCE(406);
      END_STATE();
    case 344:
      if (lookahead == 'r') ADVANCE(407);
      END_STATE();
    case 345:
      if (lookahead == 'o') ADVANCE(408);
      END_STATE();
    case 346:
      if (lookahead == 'f') ADVANCE(409);
      END_STATE();
    case 347:
      if (lookahead == 'e') ADVANCE(410);
      END_STATE();
    case 348:
      if (lookahead == 'c') ADVANCE(411);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 352:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 356:
      if (lookahead == '_') ADVANCE(412);
      END_STATE();
    case 357:
      if (lookahead == 'f') ADVANCE(413);
      END_STATE();
    case 358:
      if (lookahead == '_') ADVANCE(414);
      END_STATE();
    case 359:
      if (lookahead == '_') ADVANCE(415);
      END_STATE();
    case 360:
      if (lookahead == '_') ADVANCE(416);
      END_STATE();
    case 361:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 362:
      if (lookahead == 'r') ADVANCE(417);
      END_STATE();
    case 363:
      if (lookahead == 'e') ADVANCE(418);
      END_STATE();
    case 364:
      if (lookahead == 'l') ADVANCE(419);
      END_STATE();
    case 365:
      if (lookahead == 's') ADVANCE(420);
      END_STATE();
    case 366:
      if (lookahead == 'f') ADVANCE(421);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 368:
      if (lookahead == 'c') ADVANCE(422);
      END_STATE();
    case 369:
      if (lookahead == 'l') ADVANCE(423);
      END_STATE();
    case 370:
      if (lookahead == 'r') ADVANCE(424);
      END_STATE();
    case 371:
      if (lookahead == 'o') ADVANCE(425);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 373:
      if (lookahead == 'b') ADVANCE(426);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 376:
      if (lookahead == 'l') ADVANCE(427);
      END_STATE();
    case 377:
      if (lookahead == 'p') ADVANCE(428);
      END_STATE();
    case 378:
      if (lookahead == 't') ADVANCE(429);
      END_STATE();
    case 379:
      if (lookahead == 's') ADVANCE(430);
      END_STATE();
    case 380:
      if (lookahead == 'a') ADVANCE(431);
      END_STATE();
    case 381:
      if (lookahead == 'l') ADVANCE(432);
      END_STATE();
    case 382:
      if (lookahead == 'i') ADVANCE(433);
      END_STATE();
    case 383:
      if (lookahead == 'e') ADVANCE(434);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 385:
      if (lookahead == 'i') ADVANCE(435);
      END_STATE();
    case 386:
      if (lookahead == 'l') ADVANCE(436);
      END_STATE();
    case 387:
      if (lookahead == 'a') ADVANCE(437);
      END_STATE();
    case 388:
      if (lookahead == 'd') ADVANCE(438);
      END_STATE();
    case 389:
      if (lookahead == 'g') ADVANCE(439);
      END_STATE();
    case 390:
      if (lookahead == 'r') ADVANCE(440);
      END_STATE();
    case 391:
      if (lookahead == 'i') ADVANCE(441);
      END_STATE();
    case 392:
      if (lookahead == 'f') ADVANCE(442);
      END_STATE();
    case 393:
      if (lookahead == 'n') ADVANCE(443);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 396:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 397:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 398:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 399:
      if (lookahead == '_') ADVANCE(444);
      END_STATE();
    case 400:
      if (lookahead == 'p') ADVANCE(445);
      END_STATE();
    case 401:
      if (lookahead == 'e') ADVANCE(446);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 404:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 405:
      if (lookahead == 'g') ADVANCE(447);
      END_STATE();
    case 406:
      if (lookahead == 'n') ADVANCE(448);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_nullptr);
      if (lookahead == '_') ADVANCE(449);
      END_STATE();
    case 408:
      if (lookahead == 'f') ADVANCE(450);
      END_STATE();
    case 409:
      if (lookahead == '_') ADVANCE(451);
      END_STATE();
    case 410:
      if (lookahead == 'r') ADVANCE(452);
      END_STATE();
    case 411:
      if (lookahead == 't') ADVANCE(453);
      END_STATE();
    case 412:
      if (lookahead == 'l') ADVANCE(454);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 414:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 415:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 416:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 417:
      if (lookahead == '_') ADVANCE(455);
      END_STATE();
    case 418:
      if (lookahead == 'd') ADVANCE(456);
      END_STATE();
    case 419:
      if (lookahead == 'e') ADVANCE(457);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym__Alignas);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym__Nonnull);
      END_STATE();
    case 424:
      if (lookahead == 'n') ADVANCE(458);
      END_STATE();
    case 425:
      if (lookahead == 'f') ADVANCE(459);
      END_STATE();
    case 426:
      if (lookahead == 'u') ADVANCE(460);
      END_STATE();
    case 427:
      if (lookahead == 'l') ADVANCE(461);
      END_STATE();
    case 428:
      if (lookahead == 'e') ADVANCE(462);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 430:
      if (lookahead == 'i') ADVANCE(463);
      END_STATE();
    case 431:
      if (lookahead == 'l') ADVANCE(464);
      END_STATE();
    case 432:
      if (lookahead == 'y') ADVANCE(465);
      END_STATE();
    case 433:
      if (lookahead == 'n') ADVANCE(466);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(467);
      END_STATE();
    case 435:
      if (lookahead == 'c') ADVANCE(468);
      END_STATE();
    case 436:
      if (lookahead == 'l') ADVANCE(469);
      END_STATE();
    case 437:
      if (lookahead == 'l') ADVANCE(470);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 439:
      if (lookahead == 'n') ADVANCE(471);
      END_STATE();
    case 440:
      if (lookahead == 'c') ADVANCE(472);
      END_STATE();
    case 441:
      if (lookahead == 'l') ADVANCE(473);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 443:
      if (lookahead == 'e') ADVANCE(474);
      END_STATE();
    case 444:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 445:
      if (lookahead == 'r') ADVANCE(475);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 447:
      if (lookahead == 'n') ADVANCE(476);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 449:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 451:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 454:
      if (lookahead == 'o') ADVANCE(477);
      END_STATE();
    case 455:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(478);
      END_STATE();
    case 460:
      if (lookahead == 't') ADVANCE(479);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 462:
      if (lookahead == 'c') ADVANCE(480);
      END_STATE();
    case 463:
      if (lookahead == 'o') ADVANCE(481);
      END_STATE();
    case 464:
      if (lookahead == 'l') ADVANCE(482);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 466:
      if (lookahead == 'l') ADVANCE(483);
      END_STATE();
    case 467:
      if (lookahead == '_') ADVANCE(484);
      END_STATE();
    case 468:
      if (lookahead == 't') ADVANCE(485);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 470:
      if (lookahead == 'l') ADVANCE(486);
      END_STATE();
    case 471:
      if (lookahead == 'e') ADVANCE(487);
      END_STATE();
    case 472:
      if (lookahead == 'a') ADVANCE(488);
      END_STATE();
    case 473:
      if (lookahead == 'e') ADVANCE(489);
      END_STATE();
    case 474:
      if (lookahead == 'd') ADVANCE(490);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 476:
      if (lookahead == '_') ADVANCE(491);
      END_STATE();
    case 477:
      if (lookahead == 'c') ADVANCE(492);
      END_STATE();
    case 478:
      if (lookahead == '_') ADVANCE(493);
      END_STATE();
    case 479:
      if (lookahead == 'e') ADVANCE(494);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 481:
      if (lookahead == 'n') ADVANCE(495);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 483:
      if (lookahead == 'i') ADVANCE(496);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(497);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 487:
      if (lookahead == 'd') ADVANCE(498);
      END_STATE();
    case 488:
      if (lookahead == 'l') ADVANCE(499);
      END_STATE();
    case 489:
      if (lookahead == '_') ADVANCE(500);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 491:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 492:
      if (lookahead == 'a') ADVANCE(501);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 494:
      if (lookahead == '_') ADVANCE(502);
      END_STATE();
    case 495:
      if (lookahead == '_') ADVANCE(503);
      END_STATE();
    case 496:
      if (lookahead == 'n') ADVANCE(504);
      END_STATE();
    case 497:
      if (lookahead == '_') ADVANCE(505);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 499:
      if (lookahead == 'l') ADVANCE(506);
      END_STATE();
    case 500:
      if (lookahead == '_') ADVANCE(507);
      END_STATE();
    case 501:
      if (lookahead == 'l') ADVANCE(508);
      END_STATE();
    case 502:
      if (lookahead == '_') ADVANCE(509);
      END_STATE();
    case 503:
      if (lookahead == '_') ADVANCE(510);
      END_STATE();
    case 504:
      if (lookahead == 'e') ADVANCE(511);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym___volatile__);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 119},
  [2] = {.lex_state = 45},
  [3] = {.lex_state = 45},
  [4] = {.lex_state = 45},
  [5] = {.lex_state = 45},
  [6] = {.lex_state = 45},
  [7] = {.lex_state = 45},
  [8] = {.lex_state = 45},
  [9] = {.lex_state = 45},
  [10] = {.lex_state = 45},
  [11] = {.lex_state = 45},
  [12] = {.lex_state = 45},
  [13] = {.lex_state = 45},
  [14] = {.lex_state = 45},
  [15] = {.lex_state = 45},
  [16] = {.lex_state = 45},
  [17] = {.lex_state = 45},
  [18] = {.lex_state = 45},
  [19] = {.lex_state = 45},
  [20] = {.lex_state = 45},
  [21] = {.lex_state = 45},
  [22] = {.lex_state = 45},
  [23] = {.lex_state = 119},
  [24] = {.lex_state = 119},
  [25] = {.lex_state = 47},
  [26] = {.lex_state = 119},
  [27] = {.lex_state = 47},
  [28] = {.lex_state = 119},
  [29] = {.lex_state = 119},
  [30] = {.lex_state = 119},
  [31] = {.lex_state = 119},
  [32] = {.lex_state = 119},
  [33] = {.lex_state = 119},
  [34] = {.lex_state = 119},
  [35] = {.lex_state = 47},
  [36] = {.lex_state = 119},
  [37] = {.lex_state = 119},
  [38] = {.lex_state = 119},
  [39] = {.lex_state = 119},
  [40] = {.lex_state = 119},
  [41] = {.lex_state = 119},
  [42] = {.lex_state = 119},
  [43] = {.lex_state = 119},
  [44] = {.lex_state = 119},
  [45] = {.lex_state = 45},
  [46] = {.lex_state = 45},
  [47] = {.lex_state = 45},
  [48] = {.lex_state = 45},
  [49] = {.lex_state = 45},
  [50] = {.lex_state = 119},
  [51] = {.lex_state = 119},
  [52] = {.lex_state = 119},
  [53] = {.lex_state = 119},
  [54] = {.lex_state = 119},
  [55] = {.lex_state = 47},
  [56] = {.lex_state = 47},
  [57] = {.lex_state = 119},
  [58] = {.lex_state = 47},
  [59] = {.lex_state = 47},
  [60] = {.lex_state = 119},
  [61] = {.lex_state = 47},
  [62] = {.lex_state = 119},
  [63] = {.lex_state = 119},
  [64] = {.lex_state = 119},
  [65] = {.lex_state = 119},
  [66] = {.lex_state = 119},
  [67] = {.lex_state = 119},
  [68] = {.lex_state = 119},
  [69] = {.lex_state = 119},
  [70] = {.lex_state = 119},
  [71] = {.lex_state = 119},
  [72] = {.lex_state = 119},
  [73] = {.lex_state = 119},
  [74] = {.lex_state = 119},
  [75] = {.lex_state = 119},
  [76] = {.lex_state = 119},
  [77] = {.lex_state = 119},
  [78] = {.lex_state = 119},
  [79] = {.lex_state = 119},
  [80] = {.lex_state = 45},
  [81] = {.lex_state = 45},
  [82] = {.lex_state = 45},
  [83] = {.lex_state = 45},
  [84] = {.lex_state = 45},
  [85] = {.lex_state = 119},
  [86] = {.lex_state = 45},
  [87] = {.lex_state = 45},
  [88] = {.lex_state = 45},
  [89] = {.lex_state = 45},
  [90] = {.lex_state = 45},
  [91] = {.lex_state = 45},
  [92] = {.lex_state = 45},
  [93] = {.lex_state = 45},
  [94] = {.lex_state = 45},
  [95] = {.lex_state = 45},
  [96] = {.lex_state = 45},
  [97] = {.lex_state = 119},
  [98] = {.lex_state = 45},
  [99] = {.lex_state = 45},
  [100] = {.lex_state = 45},
  [101] = {.lex_state = 45},
  [102] = {.lex_state = 45},
  [103] = {.lex_state = 45},
  [104] = {.lex_state = 45},
  [105] = {.lex_state = 45},
  [106] = {.lex_state = 45},
  [107] = {.lex_state = 45},
  [108] = {.lex_state = 45},
  [109] = {.lex_state = 45},
  [110] = {.lex_state = 45},
  [111] = {.lex_state = 45},
  [112] = {.lex_state = 45},
  [113] = {.lex_state = 45},
  [114] = {.lex_state = 45},
  [115] = {.lex_state = 45},
  [116] = {.lex_state = 45},
  [117] = {.lex_state = 45},
  [118] = {.lex_state = 45},
  [119] = {.lex_state = 45},
  [120] = {.lex_state = 45},
  [121] = {.lex_state = 45},
  [122] = {.lex_state = 45},
  [123] = {.lex_state = 45},
  [124] = {.lex_state = 45},
  [125] = {.lex_state = 45},
  [126] = {.lex_state = 45},
  [127] = {.lex_state = 45},
  [128] = {.lex_state = 45},
  [129] = {.lex_state = 45},
  [130] = {.lex_state = 45},
  [131] = {.lex_state = 45},
  [132] = {.lex_state = 45},
  [133] = {.lex_state = 45},
  [134] = {.lex_state = 45},
  [135] = {.lex_state = 45},
  [136] = {.lex_state = 45},
  [137] = {.lex_state = 45},
  [138] = {.lex_state = 45},
  [139] = {.lex_state = 45},
  [140] = {.lex_state = 45},
  [141] = {.lex_state = 45},
  [142] = {.lex_state = 45},
  [143] = {.lex_state = 45},
  [144] = {.lex_state = 45},
  [145] = {.lex_state = 45},
  [146] = {.lex_state = 45},
  [147] = {.lex_state = 45},
  [148] = {.lex_state = 119},
  [149] = {.lex_state = 119},
  [150] = {.lex_state = 47},
  [151] = {.lex_state = 47},
  [152] = {.lex_state = 119},
  [153] = {.lex_state = 119},
  [154] = {.lex_state = 119},
  [155] = {.lex_state = 119},
  [156] = {.lex_state = 119},
  [157] = {.lex_state = 119},
  [158] = {.lex_state = 119},
  [159] = {.lex_state = 119},
  [160] = {.lex_state = 119},
  [161] = {.lex_state = 119},
  [162] = {.lex_state = 119},
  [163] = {.lex_state = 119},
  [164] = {.lex_state = 119},
  [165] = {.lex_state = 119},
  [166] = {.lex_state = 119},
  [167] = {.lex_state = 119},
  [168] = {.lex_state = 119},
  [169] = {.lex_state = 119},
  [170] = {.lex_state = 119},
  [171] = {.lex_state = 119},
  [172] = {.lex_state = 119},
  [173] = {.lex_state = 119},
  [174] = {.lex_state = 119},
  [175] = {.lex_state = 119},
  [176] = {.lex_state = 119},
  [177] = {.lex_state = 119},
  [178] = {.lex_state = 119},
  [179] = {.lex_state = 119},
  [180] = {.lex_state = 119},
  [181] = {.lex_state = 119},
  [182] = {.lex_state = 119},
  [183] = {.lex_state = 119},
  [184] = {.lex_state = 119},
  [185] = {.lex_state = 119},
  [186] = {.lex_state = 119},
  [187] = {.lex_state = 119},
  [188] = {.lex_state = 119},
  [189] = {.lex_state = 119},
  [190] = {.lex_state = 119},
  [191] = {.lex_state = 119},
  [192] = {.lex_state = 119},
  [193] = {.lex_state = 119},
  [194] = {.lex_state = 119},
  [195] = {.lex_state = 119},
  [196] = {.lex_state = 119},
  [197] = {.lex_state = 119},
  [198] = {.lex_state = 119},
  [199] = {.lex_state = 119},
  [200] = {.lex_state = 119},
  [201] = {.lex_state = 119},
  [202] = {.lex_state = 47},
  [203] = {.lex_state = 47},
  [204] = {.lex_state = 47},
  [205] = {.lex_state = 47},
  [206] = {.lex_state = 47},
  [207] = {.lex_state = 47},
  [208] = {.lex_state = 47},
  [209] = {.lex_state = 47},
  [210] = {.lex_state = 47},
  [211] = {.lex_state = 47},
  [212] = {.lex_state = 119},
  [213] = {.lex_state = 47},
  [214] = {.lex_state = 119},
  [215] = {.lex_state = 47},
  [216] = {.lex_state = 47},
  [217] = {.lex_state = 47},
  [218] = {.lex_state = 47},
  [219] = {.lex_state = 47},
  [220] = {.lex_state = 47},
  [221] = {.lex_state = 47},
  [222] = {.lex_state = 119},
  [223] = {.lex_state = 47},
  [224] = {.lex_state = 47},
  [225] = {.lex_state = 47},
  [226] = {.lex_state = 47},
  [227] = {.lex_state = 47},
  [228] = {.lex_state = 47},
  [229] = {.lex_state = 47},
  [230] = {.lex_state = 47},
  [231] = {.lex_state = 47},
  [232] = {.lex_state = 47},
  [233] = {.lex_state = 47},
  [234] = {.lex_state = 47},
  [235] = {.lex_state = 47},
  [236] = {.lex_state = 47},
  [237] = {.lex_state = 119},
  [238] = {.lex_state = 47},
  [239] = {.lex_state = 47},
  [240] = {.lex_state = 47},
  [241] = {.lex_state = 119},
  [242] = {.lex_state = 119},
  [243] = {.lex_state = 119},
  [244] = {.lex_state = 119},
  [245] = {.lex_state = 119},
  [246] = {.lex_state = 119},
  [247] = {.lex_state = 119},
  [248] = {.lex_state = 119},
  [249] = {.lex_state = 119},
  [250] = {.lex_state = 119},
  [251] = {.lex_state = 119},
  [252] = {.lex_state = 119},
  [253] = {.lex_state = 119},
  [254] = {.lex_state = 119},
  [255] = {.lex_state = 119},
  [256] = {.lex_state = 119},
  [257] = {.lex_state = 47},
  [258] = {.lex_state = 47},
  [259] = {.lex_state = 47},
  [260] = {.lex_state = 119},
  [261] = {.lex_state = 47},
  [262] = {.lex_state = 119},
  [263] = {.lex_state = 47},
  [264] = {.lex_state = 119},
  [265] = {.lex_state = 47},
  [266] = {.lex_state = 47},
  [267] = {.lex_state = 47},
  [268] = {.lex_state = 47},
  [269] = {.lex_state = 47},
  [270] = {.lex_state = 47},
  [271] = {.lex_state = 47},
  [272] = {.lex_state = 119},
  [273] = {.lex_state = 119},
  [274] = {.lex_state = 47},
  [275] = {.lex_state = 119},
  [276] = {.lex_state = 119},
  [277] = {.lex_state = 119},
  [278] = {.lex_state = 119},
  [279] = {.lex_state = 47},
  [280] = {.lex_state = 47},
  [281] = {.lex_state = 47},
  [282] = {.lex_state = 119},
  [283] = {.lex_state = 119},
  [284] = {.lex_state = 47},
  [285] = {.lex_state = 47},
  [286] = {.lex_state = 47},
  [287] = {.lex_state = 47},
  [288] = {.lex_state = 47},
  [289] = {.lex_state = 47},
  [290] = {.lex_state = 119},
  [291] = {.lex_state = 119},
  [292] = {.lex_state = 119},
  [293] = {.lex_state = 119},
  [294] = {.lex_state = 119},
  [295] = {.lex_state = 119},
  [296] = {.lex_state = 119},
  [297] = {.lex_state = 119},
  [298] = {.lex_state = 47},
  [299] = {.lex_state = 119},
  [300] = {.lex_state = 47},
  [301] = {.lex_state = 47},
  [302] = {.lex_state = 47},
  [303] = {.lex_state = 119},
  [304] = {.lex_state = 119},
  [305] = {.lex_state = 119},
  [306] = {.lex_state = 44},
  [307] = {.lex_state = 119},
  [308] = {.lex_state = 119},
  [309] = {.lex_state = 119},
  [310] = {.lex_state = 47},
  [311] = {.lex_state = 119},
  [312] = {.lex_state = 119},
  [313] = {.lex_state = 44},
  [314] = {.lex_state = 119},
  [315] = {.lex_state = 47},
  [316] = {.lex_state = 47},
  [317] = {.lex_state = 119},
  [318] = {.lex_state = 119},
  [319] = {.lex_state = 119},
  [320] = {.lex_state = 119},
  [321] = {.lex_state = 119},
  [322] = {.lex_state = 119},
  [323] = {.lex_state = 119},
  [324] = {.lex_state = 119},
  [325] = {.lex_state = 119},
  [326] = {.lex_state = 119},
  [327] = {.lex_state = 119},
  [328] = {.lex_state = 119},
  [329] = {.lex_state = 119},
  [330] = {.lex_state = 119},
  [331] = {.lex_state = 119},
  [332] = {.lex_state = 119},
  [333] = {.lex_state = 119},
  [334] = {.lex_state = 119},
  [335] = {.lex_state = 119},
  [336] = {.lex_state = 119},
  [337] = {.lex_state = 119},
  [338] = {.lex_state = 119},
  [339] = {.lex_state = 119},
  [340] = {.lex_state = 119},
  [341] = {.lex_state = 119},
  [342] = {.lex_state = 119},
  [343] = {.lex_state = 119},
  [344] = {.lex_state = 119},
  [345] = {.lex_state = 119},
  [346] = {.lex_state = 119},
  [347] = {.lex_state = 119},
  [348] = {.lex_state = 119},
  [349] = {.lex_state = 119},
  [350] = {.lex_state = 119},
  [351] = {.lex_state = 119},
  [352] = {.lex_state = 119},
  [353] = {.lex_state = 119},
  [354] = {.lex_state = 119},
  [355] = {.lex_state = 119},
  [356] = {.lex_state = 119},
  [357] = {.lex_state = 119},
  [358] = {.lex_state = 119},
  [359] = {.lex_state = 119},
  [360] = {.lex_state = 119},
  [361] = {.lex_state = 119},
  [362] = {.lex_state = 119},
  [363] = {.lex_state = 119},
  [364] = {.lex_state = 119},
  [365] = {.lex_state = 119},
  [366] = {.lex_state = 119},
  [367] = {.lex_state = 119},
  [368] = {.lex_state = 119},
  [369] = {.lex_state = 119},
  [370] = {.lex_state = 119},
  [371] = {.lex_state = 119},
  [372] = {.lex_state = 119},
  [373] = {.lex_state = 119},
  [374] = {.lex_state = 119},
  [375] = {.lex_state = 119},
  [376] = {.lex_state = 119},
  [377] = {.lex_state = 119},
  [378] = {.lex_state = 119},
  [379] = {.lex_state = 119},
  [380] = {.lex_state = 119},
  [381] = {.lex_state = 119},
  [382] = {.lex_state = 119},
  [383] = {.lex_state = 119},
  [384] = {.lex_state = 119},
  [385] = {.lex_state = 44},
  [386] = {.lex_state = 119},
  [387] = {.lex_state = 119},
  [388] = {.lex_state = 119},
  [389] = {.lex_state = 119},
  [390] = {.lex_state = 119},
  [391] = {.lex_state = 119},
  [392] = {.lex_state = 119},
  [393] = {.lex_state = 119},
  [394] = {.lex_state = 119},
  [395] = {.lex_state = 119},
  [396] = {.lex_state = 119},
  [397] = {.lex_state = 119},
  [398] = {.lex_state = 119},
  [399] = {.lex_state = 119},
  [400] = {.lex_state = 119},
  [401] = {.lex_state = 119},
  [402] = {.lex_state = 119},
  [403] = {.lex_state = 44},
  [404] = {.lex_state = 44},
  [405] = {.lex_state = 119},
  [406] = {.lex_state = 119},
  [407] = {.lex_state = 44},
  [408] = {.lex_state = 49},
  [409] = {.lex_state = 49},
  [410] = {.lex_state = 49},
  [411] = {.lex_state = 49},
  [412] = {.lex_state = 49},
  [413] = {.lex_state = 49},
  [414] = {.lex_state = 49},
  [415] = {.lex_state = 49},
  [416] = {.lex_state = 49},
  [417] = {.lex_state = 49},
  [418] = {.lex_state = 52},
  [419] = {.lex_state = 119},
  [420] = {.lex_state = 119},
  [421] = {.lex_state = 119},
  [422] = {.lex_state = 119},
  [423] = {.lex_state = 119},
  [424] = {.lex_state = 119},
  [425] = {.lex_state = 119},
  [426] = {.lex_state = 119},
  [427] = {.lex_state = 119},
  [428] = {.lex_state = 119},
  [429] = {.lex_state = 119},
  [430] = {.lex_state = 119},
  [431] = {.lex_state = 52},
  [432] = {.lex_state = 52},
  [433] = {.lex_state = 52},
  [434] = {.lex_state = 52},
  [435] = {.lex_state = 119},
  [436] = {.lex_state = 52},
  [437] = {.lex_state = 52},
  [438] = {.lex_state = 52},
  [439] = {.lex_state = 52},
  [440] = {.lex_state = 52},
  [441] = {.lex_state = 52},
  [442] = {.lex_state = 52},
  [443] = {.lex_state = 119},
  [444] = {.lex_state = 52},
  [445] = {.lex_state = 52},
  [446] = {.lex_state = 52},
  [447] = {.lex_state = 52},
  [448] = {.lex_state = 52},
  [449] = {.lex_state = 52},
  [450] = {.lex_state = 119},
  [451] = {.lex_state = 52},
  [452] = {.lex_state = 119},
  [453] = {.lex_state = 53},
  [454] = {.lex_state = 57},
  [455] = {.lex_state = 57},
  [456] = {.lex_state = 53},
  [457] = {.lex_state = 53},
  [458] = {.lex_state = 119},
  [459] = {.lex_state = 119},
  [460] = {.lex_state = 119},
  [461] = {.lex_state = 57},
  [462] = {.lex_state = 119},
  [463] = {.lex_state = 119},
  [464] = {.lex_state = 119},
  [465] = {.lex_state = 119},
  [466] = {.lex_state = 119},
  [467] = {.lex_state = 119},
  [468] = {.lex_state = 119},
  [469] = {.lex_state = 119},
  [470] = {.lex_state = 119},
  [471] = {.lex_state = 119},
  [472] = {.lex_state = 119},
  [473] = {.lex_state = 119},
  [474] = {.lex_state = 119},
  [475] = {.lex_state = 119},
  [476] = {.lex_state = 119},
  [477] = {.lex_state = 119},
  [478] = {.lex_state = 119},
  [479] = {.lex_state = 119},
  [480] = {.lex_state = 119},
  [481] = {.lex_state = 119},
  [482] = {.lex_state = 119},
  [483] = {.lex_state = 119},
  [484] = {.lex_state = 119},
  [485] = {.lex_state = 119},
  [486] = {.lex_state = 119},
  [487] = {.lex_state = 119},
  [488] = {.lex_state = 119},
  [489] = {.lex_state = 119},
  [490] = {.lex_state = 119},
  [491] = {.lex_state = 119},
  [492] = {.lex_state = 119},
  [493] = {.lex_state = 119},
  [494] = {.lex_state = 119},
  [495] = {.lex_state = 119},
  [496] = {.lex_state = 119},
  [497] = {.lex_state = 119},
  [498] = {.lex_state = 119},
  [499] = {.lex_state = 119},
  [500] = {.lex_state = 119},
  [501] = {.lex_state = 119},
  [502] = {.lex_state = 119},
  [503] = {.lex_state = 119},
  [504] = {.lex_state = 119},
  [505] = {.lex_state = 119},
  [506] = {.lex_state = 119},
  [507] = {.lex_state = 119},
  [508] = {.lex_state = 119},
  [509] = {.lex_state = 119},
  [510] = {.lex_state = 119},
  [511] = {.lex_state = 119},
  [512] = {.lex_state = 119},
  [513] = {.lex_state = 119},
  [514] = {.lex_state = 119},
  [515] = {.lex_state = 119},
  [516] = {.lex_state = 119},
  [517] = {.lex_state = 119},
  [518] = {.lex_state = 119},
  [519] = {.lex_state = 119},
  [520] = {.lex_state = 52},
  [521] = {.lex_state = 119},
  [522] = {.lex_state = 119},
  [523] = {.lex_state = 119},
  [524] = {.lex_state = 119},
  [525] = {.lex_state = 119},
  [526] = {.lex_state = 119},
  [527] = {.lex_state = 119},
  [528] = {.lex_state = 119},
  [529] = {.lex_state = 119},
  [530] = {.lex_state = 119},
  [531] = {.lex_state = 119},
  [532] = {.lex_state = 119},
  [533] = {.lex_state = 119},
  [534] = {.lex_state = 119},
  [535] = {.lex_state = 119},
  [536] = {.lex_state = 119},
  [537] = {.lex_state = 119},
  [538] = {.lex_state = 119},
  [539] = {.lex_state = 119},
  [540] = {.lex_state = 52},
  [541] = {.lex_state = 119},
  [542] = {.lex_state = 119},
  [543] = {.lex_state = 119},
  [544] = {.lex_state = 119},
  [545] = {.lex_state = 119},
  [546] = {.lex_state = 119},
  [547] = {.lex_state = 119},
  [548] = {.lex_state = 119},
  [549] = {.lex_state = 119},
  [550] = {.lex_state = 119},
  [551] = {.lex_state = 119},
  [552] = {.lex_state = 119},
  [553] = {.lex_state = 119},
  [554] = {.lex_state = 119},
  [555] = {.lex_state = 119},
  [556] = {.lex_state = 119},
  [557] = {.lex_state = 119},
  [558] = {.lex_state = 119},
  [559] = {.lex_state = 119},
  [560] = {.lex_state = 119},
  [561] = {.lex_state = 119},
  [562] = {.lex_state = 119},
  [563] = {.lex_state = 119},
  [564] = {.lex_state = 119},
  [565] = {.lex_state = 119},
  [566] = {.lex_state = 52},
  [567] = {.lex_state = 119},
  [568] = {.lex_state = 119},
  [569] = {.lex_state = 119},
  [570] = {.lex_state = 119},
  [571] = {.lex_state = 49},
  [572] = {.lex_state = 119},
  [573] = {.lex_state = 119},
  [574] = {.lex_state = 119},
  [575] = {.lex_state = 119},
  [576] = {.lex_state = 119},
  [577] = {.lex_state = 119},
  [578] = {.lex_state = 119},
  [579] = {.lex_state = 52},
  [580] = {.lex_state = 119},
  [581] = {.lex_state = 119},
  [582] = {.lex_state = 119},
  [583] = {.lex_state = 119},
  [584] = {.lex_state = 119},
  [585] = {.lex_state = 119},
  [586] = {.lex_state = 119},
  [587] = {.lex_state = 119},
  [588] = {.lex_state = 119},
  [589] = {.lex_state = 119},
  [590] = {.lex_state = 119},
  [591] = {.lex_state = 119},
  [592] = {.lex_state = 119},
  [593] = {.lex_state = 119},
  [594] = {.lex_state = 119},
  [595] = {.lex_state = 119},
  [596] = {.lex_state = 119},
  [597] = {.lex_state = 119},
  [598] = {.lex_state = 119},
  [599] = {.lex_state = 119},
  [600] = {.lex_state = 119},
  [601] = {.lex_state = 119},
  [602] = {.lex_state = 119},
  [603] = {.lex_state = 119},
  [604] = {.lex_state = 119},
  [605] = {.lex_state = 119},
  [606] = {.lex_state = 119},
  [607] = {.lex_state = 119},
  [608] = {.lex_state = 119},
  [609] = {.lex_state = 119},
  [610] = {.lex_state = 119},
  [611] = {.lex_state = 119},
  [612] = {.lex_state = 119},
  [613] = {.lex_state = 119},
  [614] = {.lex_state = 119},
  [615] = {.lex_state = 119},
  [616] = {.lex_state = 119},
  [617] = {.lex_state = 119},
  [618] = {.lex_state = 119},
  [619] = {.lex_state = 119},
  [620] = {.lex_state = 119},
  [621] = {.lex_state = 119},
  [622] = {.lex_state = 119},
  [623] = {.lex_state = 119},
  [624] = {.lex_state = 119},
  [625] = {.lex_state = 49},
  [626] = {.lex_state = 49},
  [627] = {.lex_state = 49},
  [628] = {.lex_state = 52},
  [629] = {.lex_state = 52},
  [630] = {.lex_state = 49},
  [631] = {.lex_state = 50},
  [632] = {.lex_state = 50},
  [633] = {.lex_state = 50},
  [634] = {.lex_state = 50},
  [635] = {.lex_state = 50},
  [636] = {.lex_state = 49},
  [637] = {.lex_state = 50},
  [638] = {.lex_state = 52},
  [639] = {.lex_state = 50},
  [640] = {.lex_state = 50},
  [641] = {.lex_state = 49},
  [642] = {.lex_state = 50},
  [643] = {.lex_state = 50},
  [644] = {.lex_state = 52},
  [645] = {.lex_state = 52},
  [646] = {.lex_state = 52},
  [647] = {.lex_state = 52},
  [648] = {.lex_state = 52},
  [649] = {.lex_state = 52},
  [650] = {.lex_state = 52},
  [651] = {.lex_state = 52},
  [652] = {.lex_state = 52},
  [653] = {.lex_state = 52},
  [654] = {.lex_state = 52},
  [655] = {.lex_state = 52},
  [656] = {.lex_state = 52},
  [657] = {.lex_state = 52},
  [658] = {.lex_state = 52},
  [659] = {.lex_state = 52},
  [660] = {.lex_state = 52},
  [661] = {.lex_state = 52},
  [662] = {.lex_state = 119},
  [663] = {.lex_state = 119},
  [664] = {.lex_state = 119},
  [665] = {.lex_state = 119},
  [666] = {.lex_state = 52},
  [667] = {.lex_state = 52},
  [668] = {.lex_state = 49},
  [669] = {.lex_state = 50},
  [670] = {.lex_state = 52},
  [671] = {.lex_state = 50},
  [672] = {.lex_state = 50},
  [673] = {.lex_state = 50},
  [674] = {.lex_state = 50},
  [675] = {.lex_state = 50},
  [676] = {.lex_state = 50},
  [677] = {.lex_state = 50},
  [678] = {.lex_state = 50},
  [679] = {.lex_state = 50},
  [680] = {.lex_state = 50},
  [681] = {.lex_state = 119},
  [682] = {.lex_state = 119},
  [683] = {.lex_state = 50},
  [684] = {.lex_state = 50},
  [685] = {.lex_state = 50},
  [686] = {.lex_state = 50},
  [687] = {.lex_state = 50},
  [688] = {.lex_state = 52},
  [689] = {.lex_state = 52},
  [690] = {.lex_state = 52},
  [691] = {.lex_state = 52},
  [692] = {.lex_state = 52},
  [693] = {.lex_state = 52},
  [694] = {.lex_state = 50},
  [695] = {.lex_state = 50},
  [696] = {.lex_state = 52},
  [697] = {.lex_state = 51},
  [698] = {.lex_state = 51},
  [699] = {.lex_state = 51},
  [700] = {.lex_state = 49},
  [701] = {.lex_state = 50},
  [702] = {.lex_state = 50},
  [703] = {.lex_state = 50},
  [704] = {.lex_state = 50},
  [705] = {.lex_state = 50},
  [706] = {.lex_state = 52},
  [707] = {.lex_state = 50},
  [708] = {.lex_state = 49},
  [709] = {.lex_state = 52},
  [710] = {.lex_state = 52},
  [711] = {.lex_state = 52},
  [712] = {.lex_state = 52},
  [713] = {.lex_state = 52},
  [714] = {.lex_state = 52},
  [715] = {.lex_state = 52},
  [716] = {.lex_state = 49},
  [717] = {.lex_state = 52},
  [718] = {.lex_state = 52},
  [719] = {.lex_state = 52},
  [720] = {.lex_state = 52},
  [721] = {.lex_state = 52},
  [722] = {.lex_state = 52},
  [723] = {.lex_state = 52},
  [724] = {.lex_state = 52},
  [725] = {.lex_state = 52},
  [726] = {.lex_state = 52},
  [727] = {.lex_state = 52},
  [728] = {.lex_state = 52},
  [729] = {.lex_state = 52},
  [730] = {.lex_state = 52},
  [731] = {.lex_state = 52},
  [732] = {.lex_state = 52},
  [733] = {.lex_state = 52},
  [734] = {.lex_state = 52},
  [735] = {.lex_state = 52},
  [736] = {.lex_state = 52},
  [737] = {.lex_state = 52},
  [738] = {.lex_state = 52},
  [739] = {.lex_state = 52},
  [740] = {.lex_state = 52},
  [741] = {.lex_state = 52},
  [742] = {.lex_state = 52},
  [743] = {.lex_state = 52},
  [744] = {.lex_state = 52},
  [745] = {.lex_state = 52},
  [746] = {.lex_state = 52},
  [747] = {.lex_state = 49},
  [748] = {.lex_state = 52},
  [749] = {.lex_state = 52},
  [750] = {.lex_state = 52},
  [751] = {.lex_state = 52},
  [752] = {.lex_state = 52},
  [753] = {.lex_state = 52},
  [754] = {.lex_state = 52},
  [755] = {.lex_state = 52},
  [756] = {.lex_state = 52},
  [757] = {.lex_state = 52},
  [758] = {.lex_state = 52},
  [759] = {.lex_state = 52},
  [760] = {.lex_state = 52},
  [761] = {.lex_state = 52},
  [762] = {.lex_state = 52},
  [763] = {.lex_state = 52},
  [764] = {.lex_state = 52},
  [765] = {.lex_state = 52},
  [766] = {.lex_state = 52},
  [767] = {.lex_state = 49},
  [768] = {.lex_state = 49},
  [769] = {.lex_state = 49},
  [770] = {.lex_state = 52},
  [771] = {.lex_state = 52},
  [772] = {.lex_state = 49},
  [773] = {.lex_state = 52},
  [774] = {.lex_state = 52},
  [775] = {.lex_state = 52},
  [776] = {.lex_state = 52},
  [777] = {.lex_state = 49},
  [778] = {.lex_state = 52},
  [779] = {.lex_state = 52},
  [780] = {.lex_state = 52},
  [781] = {.lex_state = 52},
  [782] = {.lex_state = 52},
  [783] = {.lex_state = 52},
  [784] = {.lex_state = 52},
  [785] = {.lex_state = 52},
  [786] = {.lex_state = 52},
  [787] = {.lex_state = 52},
  [788] = {.lex_state = 52},
  [789] = {.lex_state = 49},
  [790] = {.lex_state = 52},
  [791] = {.lex_state = 52},
  [792] = {.lex_state = 52},
  [793] = {.lex_state = 52},
  [794] = {.lex_state = 52},
  [795] = {.lex_state = 52},
  [796] = {.lex_state = 50},
  [797] = {.lex_state = 50},
  [798] = {.lex_state = 50},
  [799] = {.lex_state = 50},
  [800] = {.lex_state = 50},
  [801] = {.lex_state = 50},
  [802] = {.lex_state = 50},
  [803] = {.lex_state = 50},
  [804] = {.lex_state = 50},
  [805] = {.lex_state = 50},
  [806] = {.lex_state = 50},
  [807] = {.lex_state = 50},
  [808] = {.lex_state = 52},
  [809] = {.lex_state = 50},
  [810] = {.lex_state = 52},
  [811] = {.lex_state = 52},
  [812] = {.lex_state = 52},
  [813] = {.lex_state = 52},
  [814] = {.lex_state = 52},
  [815] = {.lex_state = 52},
  [816] = {.lex_state = 52},
  [817] = {.lex_state = 52},
  [818] = {.lex_state = 52},
  [819] = {.lex_state = 52},
  [820] = {.lex_state = 52},
  [821] = {.lex_state = 52},
  [822] = {.lex_state = 52},
  [823] = {.lex_state = 52},
  [824] = {.lex_state = 52},
  [825] = {.lex_state = 52},
  [826] = {.lex_state = 52},
  [827] = {.lex_state = 52},
  [828] = {.lex_state = 50},
  [829] = {.lex_state = 52},
  [830] = {.lex_state = 52},
  [831] = {.lex_state = 52},
  [832] = {.lex_state = 52},
  [833] = {.lex_state = 52},
  [834] = {.lex_state = 52},
  [835] = {.lex_state = 52},
  [836] = {.lex_state = 52},
  [837] = {.lex_state = 52},
  [838] = {.lex_state = 52},
  [839] = {.lex_state = 52},
  [840] = {.lex_state = 53},
  [841] = {.lex_state = 53},
  [842] = {.lex_state = 53},
  [843] = {.lex_state = 53},
  [844] = {.lex_state = 53},
  [845] = {.lex_state = 57},
  [846] = {.lex_state = 57},
  [847] = {.lex_state = 57},
  [848] = {.lex_state = 57},
  [849] = {.lex_state = 57},
  [850] = {.lex_state = 57},
  [851] = {.lex_state = 57},
  [852] = {.lex_state = 52},
  [853] = {.lex_state = 57},
  [854] = {.lex_state = 57},
  [855] = {.lex_state = 52},
  [856] = {.lex_state = 57},
  [857] = {.lex_state = 57},
  [858] = {.lex_state = 57},
  [859] = {.lex_state = 57},
  [860] = {.lex_state = 57},
  [861] = {.lex_state = 49},
  [862] = {.lex_state = 53},
  [863] = {.lex_state = 53},
  [864] = {.lex_state = 53},
  [865] = {.lex_state = 57},
  [866] = {.lex_state = 57},
  [867] = {.lex_state = 52},
  [868] = {.lex_state = 57},
  [869] = {.lex_state = 57},
  [870] = {.lex_state = 53},
  [871] = {.lex_state = 53},
  [872] = {.lex_state = 53},
  [873] = {.lex_state = 49},
  [874] = {.lex_state = 53},
  [875] = {.lex_state = 53},
  [876] = {.lex_state = 53},
  [877] = {.lex_state = 53},
  [878] = {.lex_state = 53},
  [879] = {.lex_state = 49},
  [880] = {.lex_state = 49},
  [881] = {.lex_state = 53},
  [882] = {.lex_state = 53},
  [883] = {.lex_state = 49},
  [884] = {.lex_state = 49},
  [885] = {.lex_state = 49},
  [886] = {.lex_state = 49},
  [887] = {.lex_state = 49},
  [888] = {.lex_state = 49},
  [889] = {.lex_state = 49},
  [890] = {.lex_state = 49},
  [891] = {.lex_state = 49},
  [892] = {.lex_state = 52},
  [893] = {.lex_state = 49},
  [894] = {.lex_state = 49},
  [895] = {.lex_state = 49},
  [896] = {.lex_state = 49},
  [897] = {.lex_state = 49},
  [898] = {.lex_state = 49},
  [899] = {.lex_state = 49},
  [900] = {.lex_state = 52},
  [901] = {.lex_state = 49},
  [902] = {.lex_state = 52},
  [903] = {.lex_state = 52},
  [904] = {.lex_state = 49},
  [905] = {.lex_state = 49},
  [906] = {.lex_state = 49},
  [907] = {.lex_state = 119},
  [908] = {.lex_state = 119},
  [909] = {.lex_state = 119},
  [910] = {.lex_state = 119},
  [911] = {.lex_state = 119},
  [912] = {.lex_state = 119},
  [913] = {.lex_state = 49},
  [914] = {.lex_state = 49},
  [915] = {.lex_state = 119},
  [916] = {.lex_state = 119},
  [917] = {.lex_state = 119},
  [918] = {.lex_state = 119},
  [919] = {.lex_state = 52},
  [920] = {.lex_state = 52},
  [921] = {.lex_state = 49},
  [922] = {.lex_state = 52},
  [923] = {.lex_state = 52},
  [924] = {.lex_state = 49},
  [925] = {.lex_state = 52},
  [926] = {.lex_state = 52},
  [927] = {.lex_state = 52},
  [928] = {.lex_state = 52},
  [929] = {.lex_state = 52},
  [930] = {.lex_state = 52},
  [931] = {.lex_state = 52},
  [932] = {.lex_state = 52},
  [933] = {.lex_state = 52},
  [934] = {.lex_state = 52},
  [935] = {.lex_state = 52},
  [936] = {.lex_state = 52},
  [937] = {.lex_state = 52},
  [938] = {.lex_state = 52},
  [939] = {.lex_state = 52},
  [940] = {.lex_state = 52},
  [941] = {.lex_state = 52},
  [942] = {.lex_state = 52},
  [943] = {.lex_state = 52},
  [944] = {.lex_state = 52},
  [945] = {.lex_state = 52},
  [946] = {.lex_state = 52},
  [947] = {.lex_state = 52},
  [948] = {.lex_state = 52},
  [949] = {.lex_state = 52},
  [950] = {.lex_state = 52},
  [951] = {.lex_state = 52},
  [952] = {.lex_state = 52},
  [953] = {.lex_state = 52},
  [954] = {.lex_state = 52},
  [955] = {.lex_state = 52},
  [956] = {.lex_state = 52},
  [957] = {.lex_state = 50},
  [958] = {.lex_state = 50},
  [959] = {.lex_state = 50},
  [960] = {.lex_state = 50},
  [961] = {.lex_state = 50},
  [962] = {.lex_state = 50},
  [963] = {.lex_state = 50},
  [964] = {.lex_state = 50},
  [965] = {.lex_state = 50},
  [966] = {.lex_state = 50},
  [967] = {.lex_state = 50},
  [968] = {.lex_state = 50},
  [969] = {.lex_state = 50},
  [970] = {.lex_state = 50},
  [971] = {.lex_state = 52},
  [972] = {.lex_state = 52},
  [973] = {.lex_state = 52},
  [974] = {.lex_state = 52},
  [975] = {.lex_state = 52},
  [976] = {.lex_state = 52},
  [977] = {.lex_state = 52},
  [978] = {.lex_state = 52},
  [979] = {.lex_state = 52},
  [980] = {.lex_state = 52},
  [981] = {.lex_state = 52},
  [982] = {.lex_state = 52},
  [983] = {.lex_state = 52},
  [984] = {.lex_state = 52},
  [985] = {.lex_state = 52},
  [986] = {.lex_state = 52},
  [987] = {.lex_state = 52},
  [988] = {.lex_state = 52},
  [989] = {.lex_state = 52},
  [990] = {.lex_state = 52},
  [991] = {.lex_state = 52},
  [992] = {.lex_state = 52},
  [993] = {.lex_state = 52},
  [994] = {.lex_state = 52},
  [995] = {.lex_state = 52},
  [996] = {.lex_state = 52},
  [997] = {.lex_state = 52},
  [998] = {.lex_state = 52},
  [999] = {.lex_state = 52},
  [1000] = {.lex_state = 52},
  [1001] = {.lex_state = 52},
  [1002] = {.lex_state = 53},
  [1003] = {.lex_state = 52},
  [1004] = {.lex_state = 52},
  [1005] = {.lex_state = 52},
  [1006] = {.lex_state = 53},
  [1007] = {.lex_state = 53},
  [1008] = {.lex_state = 53},
  [1009] = {.lex_state = 52},
  [1010] = {.lex_state = 49},
  [1011] = {.lex_state = 49},
  [1012] = {.lex_state = 49},
  [1013] = {.lex_state = 49},
  [1014] = {.lex_state = 52},
  [1015] = {.lex_state = 52},
  [1016] = {.lex_state = 49},
  [1017] = {.lex_state = 52},
  [1018] = {.lex_state = 49},
  [1019] = {.lex_state = 49},
  [1020] = {.lex_state = 49},
  [1021] = {.lex_state = 49},
  [1022] = {.lex_state = 49},
  [1023] = {.lex_state = 49},
  [1024] = {.lex_state = 49},
  [1025] = {.lex_state = 49},
  [1026] = {.lex_state = 49},
  [1027] = {.lex_state = 49},
  [1028] = {.lex_state = 49},
  [1029] = {.lex_state = 49},
  [1030] = {.lex_state = 49},
  [1031] = {.lex_state = 49},
  [1032] = {.lex_state = 49},
  [1033] = {.lex_state = 49},
  [1034] = {.lex_state = 49},
  [1035] = {.lex_state = 49},
  [1036] = {.lex_state = 49},
  [1037] = {.lex_state = 49},
  [1038] = {.lex_state = 49},
  [1039] = {.lex_state = 49},
  [1040] = {.lex_state = 49},
  [1041] = {.lex_state = 49},
  [1042] = {.lex_state = 49},
  [1043] = {.lex_state = 49},
  [1044] = {.lex_state = 49},
  [1045] = {.lex_state = 49},
  [1046] = {.lex_state = 49},
  [1047] = {.lex_state = 49},
  [1048] = {.lex_state = 49},
  [1049] = {.lex_state = 49},
  [1050] = {.lex_state = 49},
  [1051] = {.lex_state = 49},
  [1052] = {.lex_state = 49},
  [1053] = {.lex_state = 49},
  [1054] = {.lex_state = 49},
  [1055] = {.lex_state = 49},
  [1056] = {.lex_state = 49},
  [1057] = {.lex_state = 49},
  [1058] = {.lex_state = 49},
  [1059] = {.lex_state = 49},
  [1060] = {.lex_state = 49},
  [1061] = {.lex_state = 49},
  [1062] = {.lex_state = 49},
  [1063] = {.lex_state = 49},
  [1064] = {.lex_state = 49},
  [1065] = {.lex_state = 49},
  [1066] = {.lex_state = 49},
  [1067] = {.lex_state = 49},
  [1068] = {.lex_state = 49},
  [1069] = {.lex_state = 49},
  [1070] = {.lex_state = 49},
  [1071] = {.lex_state = 49},
  [1072] = {.lex_state = 52},
  [1073] = {.lex_state = 52},
  [1074] = {.lex_state = 49},
  [1075] = {.lex_state = 49},
  [1076] = {.lex_state = 52},
  [1077] = {.lex_state = 49},
  [1078] = {.lex_state = 49},
  [1079] = {.lex_state = 52},
  [1080] = {.lex_state = 49},
  [1081] = {.lex_state = 52},
  [1082] = {.lex_state = 49},
  [1083] = {.lex_state = 49},
  [1084] = {.lex_state = 52},
  [1085] = {.lex_state = 49},
  [1086] = {.lex_state = 49},
  [1087] = {.lex_state = 52},
  [1088] = {.lex_state = 49},
  [1089] = {.lex_state = 49},
  [1090] = {.lex_state = 49},
  [1091] = {.lex_state = 49},
  [1092] = {.lex_state = 49},
  [1093] = {.lex_state = 49},
  [1094] = {.lex_state = 52},
  [1095] = {.lex_state = 52},
  [1096] = {.lex_state = 52},
  [1097] = {.lex_state = 52},
  [1098] = {.lex_state = 52},
  [1099] = {.lex_state = 52},
  [1100] = {.lex_state = 49},
  [1101] = {.lex_state = 52},
  [1102] = {.lex_state = 52},
  [1103] = {.lex_state = 49},
  [1104] = {.lex_state = 52},
  [1105] = {.lex_state = 52},
  [1106] = {.lex_state = 52},
  [1107] = {.lex_state = 52},
  [1108] = {.lex_state = 52},
  [1109] = {.lex_state = 52},
  [1110] = {.lex_state = 52},
  [1111] = {.lex_state = 52},
  [1112] = {.lex_state = 52},
  [1113] = {.lex_state = 52},
  [1114] = {.lex_state = 52},
  [1115] = {.lex_state = 52},
  [1116] = {.lex_state = 52},
  [1117] = {.lex_state = 52},
  [1118] = {.lex_state = 52},
  [1119] = {.lex_state = 52},
  [1120] = {.lex_state = 52},
  [1121] = {.lex_state = 53},
  [1122] = {.lex_state = 52},
  [1123] = {.lex_state = 52},
  [1124] = {.lex_state = 52},
  [1125] = {.lex_state = 52},
  [1126] = {.lex_state = 52},
  [1127] = {.lex_state = 52},
  [1128] = {.lex_state = 52},
  [1129] = {.lex_state = 52},
  [1130] = {.lex_state = 52},
  [1131] = {.lex_state = 23},
  [1132] = {.lex_state = 48},
  [1133] = {.lex_state = 53},
  [1134] = {.lex_state = 48},
  [1135] = {.lex_state = 52},
  [1136] = {.lex_state = 52},
  [1137] = {.lex_state = 52},
  [1138] = {.lex_state = 53},
  [1139] = {.lex_state = 52},
  [1140] = {.lex_state = 52},
  [1141] = {.lex_state = 52},
  [1142] = {.lex_state = 53},
  [1143] = {.lex_state = 52},
  [1144] = {.lex_state = 52},
  [1145] = {.lex_state = 48},
  [1146] = {.lex_state = 52},
  [1147] = {.lex_state = 52},
  [1148] = {.lex_state = 48},
  [1149] = {.lex_state = 48},
  [1150] = {.lex_state = 48},
  [1151] = {.lex_state = 53},
  [1152] = {.lex_state = 48},
  [1153] = {.lex_state = 48},
  [1154] = {.lex_state = 52},
  [1155] = {.lex_state = 53},
  [1156] = {.lex_state = 53},
  [1157] = {.lex_state = 53},
  [1158] = {.lex_state = 48},
  [1159] = {.lex_state = 48},
  [1160] = {.lex_state = 48},
  [1161] = {.lex_state = 53},
  [1162] = {.lex_state = 48},
  [1163] = {.lex_state = 48},
  [1164] = {.lex_state = 48},
  [1165] = {.lex_state = 48},
  [1166] = {.lex_state = 53},
  [1167] = {.lex_state = 48},
  [1168] = {.lex_state = 53},
  [1169] = {.lex_state = 48},
  [1170] = {.lex_state = 53},
  [1171] = {.lex_state = 48},
  [1172] = {.lex_state = 48},
  [1173] = {.lex_state = 48},
  [1174] = {.lex_state = 48},
  [1175] = {.lex_state = 53},
  [1176] = {.lex_state = 48},
  [1177] = {.lex_state = 48},
  [1178] = {.lex_state = 48},
  [1179] = {.lex_state = 53},
  [1180] = {.lex_state = 48},
  [1181] = {.lex_state = 48},
  [1182] = {.lex_state = 48},
  [1183] = {.lex_state = 48},
  [1184] = {.lex_state = 48},
  [1185] = {.lex_state = 48},
  [1186] = {.lex_state = 48},
  [1187] = {.lex_state = 48},
  [1188] = {.lex_state = 48},
  [1189] = {.lex_state = 48},
  [1190] = {.lex_state = 48},
  [1191] = {.lex_state = 48},
  [1192] = {.lex_state = 53},
  [1193] = {.lex_state = 53},
  [1194] = {.lex_state = 48},
  [1195] = {.lex_state = 53},
  [1196] = {.lex_state = 48},
  [1197] = {.lex_state = 48},
  [1198] = {.lex_state = 53},
  [1199] = {.lex_state = 48},
  [1200] = {.lex_state = 48},
  [1201] = {.lex_state = 48},
  [1202] = {.lex_state = 53},
  [1203] = {.lex_state = 53},
  [1204] = {.lex_state = 23},
  [1205] = {.lex_state = 23},
  [1206] = {.lex_state = 52},
  [1207] = {.lex_state = 53},
  [1208] = {.lex_state = 23},
  [1209] = {.lex_state = 23},
  [1210] = {.lex_state = 23},
  [1211] = {.lex_state = 23},
  [1212] = {.lex_state = 52},
  [1213] = {.lex_state = 23},
  [1214] = {.lex_state = 23},
  [1215] = {.lex_state = 23},
  [1216] = {.lex_state = 23},
  [1217] = {.lex_state = 23},
  [1218] = {.lex_state = 52},
  [1219] = {.lex_state = 23},
  [1220] = {.lex_state = 23},
  [1221] = {.lex_state = 23},
  [1222] = {.lex_state = 23},
  [1223] = {.lex_state = 23},
  [1224] = {.lex_state = 23},
  [1225] = {.lex_state = 52},
  [1226] = {.lex_state = 23},
  [1227] = {.lex_state = 53},
  [1228] = {.lex_state = 23},
  [1229] = {.lex_state = 23},
  [1230] = {.lex_state = 23},
  [1231] = {.lex_state = 23},
  [1232] = {.lex_state = 23},
  [1233] = {.lex_state = 23},
  [1234] = {.lex_state = 23},
  [1235] = {.lex_state = 23},
  [1236] = {.lex_state = 23},
  [1237] = {.lex_state = 23},
  [1238] = {.lex_state = 23},
  [1239] = {.lex_state = 23},
  [1240] = {.lex_state = 23},
  [1241] = {.lex_state = 23},
  [1242] = {.lex_state = 23},
  [1243] = {.lex_state = 52},
  [1244] = {.lex_state = 52},
  [1245] = {.lex_state = 52},
  [1246] = {.lex_state = 52},
  [1247] = {.lex_state = 52},
  [1248] = {.lex_state = 52},
  [1249] = {.lex_state = 52},
  [1250] = {.lex_state = 52},
  [1251] = {.lex_state = 52},
  [1252] = {.lex_state = 52},
  [1253] = {.lex_state = 52},
  [1254] = {.lex_state = 52},
  [1255] = {.lex_state = 52},
  [1256] = {.lex_state = 52},
  [1257] = {.lex_state = 52},
  [1258] = {.lex_state = 52},
  [1259] = {.lex_state = 52},
  [1260] = {.lex_state = 52},
  [1261] = {.lex_state = 52},
  [1262] = {.lex_state = 52},
  [1263] = {.lex_state = 52},
  [1264] = {.lex_state = 52},
  [1265] = {.lex_state = 52},
  [1266] = {.lex_state = 52},
  [1267] = {.lex_state = 52},
  [1268] = {.lex_state = 52},
  [1269] = {.lex_state = 50},
  [1270] = {.lex_state = 50},
  [1271] = {.lex_state = 50},
  [1272] = {.lex_state = 52},
  [1273] = {.lex_state = 52},
  [1274] = {.lex_state = 50},
  [1275] = {.lex_state = 52},
  [1276] = {.lex_state = 52},
  [1277] = {.lex_state = 52},
  [1278] = {.lex_state = 52},
  [1279] = {.lex_state = 52},
  [1280] = {.lex_state = 52},
  [1281] = {.lex_state = 52},
  [1282] = {.lex_state = 52},
  [1283] = {.lex_state = 52},
  [1284] = {.lex_state = 52},
  [1285] = {.lex_state = 52},
  [1286] = {.lex_state = 52},
  [1287] = {.lex_state = 52},
  [1288] = {.lex_state = 52},
  [1289] = {.lex_state = 56},
  [1290] = {.lex_state = 52},
  [1291] = {.lex_state = 52},
  [1292] = {.lex_state = 52},
  [1293] = {.lex_state = 52},
  [1294] = {.lex_state = 56},
  [1295] = {.lex_state = 52},
  [1296] = {.lex_state = 52},
  [1297] = {.lex_state = 52},
  [1298] = {.lex_state = 52},
  [1299] = {.lex_state = 52},
  [1300] = {.lex_state = 52},
  [1301] = {.lex_state = 52},
  [1302] = {.lex_state = 52},
  [1303] = {.lex_state = 52},
  [1304] = {.lex_state = 52},
  [1305] = {.lex_state = 52},
  [1306] = {.lex_state = 52},
  [1307] = {.lex_state = 52},
  [1308] = {.lex_state = 56},
  [1309] = {.lex_state = 50},
  [1310] = {.lex_state = 50},
  [1311] = {.lex_state = 52},
  [1312] = {.lex_state = 52},
  [1313] = {.lex_state = 50},
  [1314] = {.lex_state = 50},
  [1315] = {.lex_state = 52},
  [1316] = {.lex_state = 52},
  [1317] = {.lex_state = 52},
  [1318] = {.lex_state = 50},
  [1319] = {.lex_state = 50},
  [1320] = {.lex_state = 52},
  [1321] = {.lex_state = 50},
  [1322] = {.lex_state = 50},
  [1323] = {.lex_state = 50},
  [1324] = {.lex_state = 52},
  [1325] = {.lex_state = 50},
  [1326] = {.lex_state = 50},
  [1327] = {.lex_state = 50},
  [1328] = {.lex_state = 52},
  [1329] = {.lex_state = 52},
  [1330] = {.lex_state = 52},
  [1331] = {.lex_state = 52},
  [1332] = {.lex_state = 50},
  [1333] = {.lex_state = 50},
  [1334] = {.lex_state = 52},
  [1335] = {.lex_state = 49},
  [1336] = {.lex_state = 119},
  [1337] = {.lex_state = 52},
  [1338] = {.lex_state = 52},
  [1339] = {.lex_state = 52},
  [1340] = {.lex_state = 52},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 119},
  [1343] = {.lex_state = 52},
  [1344] = {.lex_state = 119},
  [1345] = {.lex_state = 119},
  [1346] = {.lex_state = 52},
  [1347] = {.lex_state = 52},
  [1348] = {.lex_state = 52},
  [1349] = {.lex_state = 52},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 52},
  [1352] = {.lex_state = 54},
  [1353] = {.lex_state = 119},
  [1354] = {.lex_state = 52},
  [1355] = {.lex_state = 52},
  [1356] = {.lex_state = 119},
  [1357] = {.lex_state = 119},
  [1358] = {.lex_state = 119},
  [1359] = {.lex_state = 119},
  [1360] = {.lex_state = 119},
  [1361] = {.lex_state = 54},
  [1362] = {.lex_state = 52},
  [1363] = {.lex_state = 54},
  [1364] = {.lex_state = 52},
  [1365] = {.lex_state = 119},
  [1366] = {.lex_state = 49},
  [1367] = {.lex_state = 52},
  [1368] = {.lex_state = 49},
  [1369] = {.lex_state = 54},
  [1370] = {.lex_state = 52},
  [1371] = {.lex_state = 49},
  [1372] = {.lex_state = 119},
  [1373] = {.lex_state = 52},
  [1374] = {.lex_state = 119},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 119},
  [1377] = {.lex_state = 119},
  [1378] = {.lex_state = 52},
  [1379] = {.lex_state = 119},
  [1380] = {.lex_state = 119},
  [1381] = {.lex_state = 119},
  [1382] = {.lex_state = 50},
  [1383] = {.lex_state = 119},
  [1384] = {.lex_state = 52},
  [1385] = {.lex_state = 119},
  [1386] = {.lex_state = 52},
  [1387] = {.lex_state = 52},
  [1388] = {.lex_state = 119},
  [1389] = {.lex_state = 52},
  [1390] = {.lex_state = 119},
  [1391] = {.lex_state = 52},
  [1392] = {.lex_state = 52},
  [1393] = {.lex_state = 52},
  [1394] = {.lex_state = 52},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 52},
  [1397] = {.lex_state = 119},
  [1398] = {.lex_state = 50},
  [1399] = {.lex_state = 50},
  [1400] = {.lex_state = 119},
  [1401] = {.lex_state = 52},
  [1402] = {.lex_state = 119},
  [1403] = {.lex_state = 52},
  [1404] = {.lex_state = 52},
  [1405] = {.lex_state = 52},
  [1406] = {.lex_state = 52},
  [1407] = {.lex_state = 52},
  [1408] = {.lex_state = 52},
  [1409] = {.lex_state = 52},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 52},
  [1412] = {.lex_state = 52},
  [1413] = {.lex_state = 52},
  [1414] = {.lex_state = 119},
  [1415] = {.lex_state = 52},
  [1416] = {.lex_state = 119},
  [1417] = {.lex_state = 52},
  [1418] = {.lex_state = 52},
  [1419] = {.lex_state = 52},
  [1420] = {.lex_state = 52},
  [1421] = {.lex_state = 52},
  [1422] = {.lex_state = 119},
  [1423] = {.lex_state = 52},
  [1424] = {.lex_state = 52},
  [1425] = {.lex_state = 52},
  [1426] = {.lex_state = 52},
  [1427] = {.lex_state = 52},
  [1428] = {.lex_state = 50},
  [1429] = {.lex_state = 52},
  [1430] = {.lex_state = 0},
  [1431] = {.lex_state = 52},
  [1432] = {.lex_state = 119},
  [1433] = {.lex_state = 52},
  [1434] = {.lex_state = 52},
  [1435] = {.lex_state = 52},
  [1436] = {.lex_state = 119},
  [1437] = {.lex_state = 52},
  [1438] = {.lex_state = 52},
  [1439] = {.lex_state = 119},
  [1440] = {.lex_state = 119},
  [1441] = {.lex_state = 52},
  [1442] = {.lex_state = 52},
  [1443] = {.lex_state = 0},
  [1444] = {.lex_state = 52},
  [1445] = {.lex_state = 52},
  [1446] = {.lex_state = 52},
  [1447] = {.lex_state = 52},
  [1448] = {.lex_state = 56},
  [1449] = {.lex_state = 52},
  [1450] = {.lex_state = 119},
  [1451] = {.lex_state = 52},
  [1452] = {.lex_state = 119},
  [1453] = {.lex_state = 0},
  [1454] = {.lex_state = 119},
  [1455] = {.lex_state = 56},
  [1456] = {.lex_state = 52},
  [1457] = {.lex_state = 52},
  [1458] = {.lex_state = 52},
  [1459] = {.lex_state = 52},
  [1460] = {.lex_state = 52},
  [1461] = {.lex_state = 50},
  [1462] = {.lex_state = 52},
  [1463] = {.lex_state = 56},
  [1464] = {.lex_state = 56},
  [1465] = {.lex_state = 56},
  [1466] = {.lex_state = 52},
  [1467] = {.lex_state = 119},
  [1468] = {.lex_state = 56},
  [1469] = {.lex_state = 52},
  [1470] = {.lex_state = 56},
  [1471] = {.lex_state = 119},
  [1472] = {.lex_state = 52},
  [1473] = {.lex_state = 56},
  [1474] = {.lex_state = 56},
  [1475] = {.lex_state = 56},
  [1476] = {.lex_state = 56},
  [1477] = {.lex_state = 0},
  [1478] = {.lex_state = 45},
  [1479] = {.lex_state = 52},
  [1480] = {.lex_state = 52},
  [1481] = {.lex_state = 50},
  [1482] = {.lex_state = 52},
  [1483] = {.lex_state = 52},
  [1484] = {.lex_state = 52},
  [1485] = {.lex_state = 52},
  [1486] = {.lex_state = 52},
  [1487] = {.lex_state = 30},
  [1488] = {.lex_state = 52},
  [1489] = {.lex_state = 52},
  [1490] = {.lex_state = 32},
  [1491] = {.lex_state = 52},
  [1492] = {.lex_state = 0},
  [1493] = {.lex_state = 52},
  [1494] = {.lex_state = 52},
  [1495] = {.lex_state = 50},
  [1496] = {.lex_state = 119},
  [1497] = {.lex_state = 52},
  [1498] = {.lex_state = 32},
  [1499] = {.lex_state = 32},
  [1500] = {.lex_state = 52},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 52},
  [1503] = {.lex_state = 52},
  [1504] = {.lex_state = 0},
  [1505] = {.lex_state = 52},
  [1506] = {.lex_state = 52},
  [1507] = {.lex_state = 37},
  [1508] = {.lex_state = 52},
  [1509] = {.lex_state = 52},
  [1510] = {.lex_state = 52},
  [1511] = {.lex_state = 0},
  [1512] = {.lex_state = 30},
  [1513] = {.lex_state = 52},
  [1514] = {.lex_state = 52},
  [1515] = {.lex_state = 52},
  [1516] = {.lex_state = 50},
  [1517] = {.lex_state = 37},
  [1518] = {.lex_state = 30},
  [1519] = {.lex_state = 52},
  [1520] = {.lex_state = 52},
  [1521] = {.lex_state = 32},
  [1522] = {.lex_state = 37},
  [1523] = {.lex_state = 52},
  [1524] = {.lex_state = 52},
  [1525] = {.lex_state = 119},
  [1526] = {.lex_state = 45},
  [1527] = {.lex_state = 37},
  [1528] = {.lex_state = 0},
  [1529] = {.lex_state = 32},
  [1530] = {.lex_state = 32},
  [1531] = {.lex_state = 30},
  [1532] = {.lex_state = 32},
  [1533] = {.lex_state = 37},
  [1534] = {.lex_state = 50},
  [1535] = {.lex_state = 52},
  [1536] = {.lex_state = 0},
  [1537] = {.lex_state = 37},
  [1538] = {.lex_state = 0},
  [1539] = {.lex_state = 52},
  [1540] = {.lex_state = 37},
  [1541] = {.lex_state = 52},
  [1542] = {.lex_state = 52},
  [1543] = {.lex_state = 52},
  [1544] = {.lex_state = 0},
  [1545] = {.lex_state = 50},
  [1546] = {.lex_state = 0},
  [1547] = {.lex_state = 52},
  [1548] = {.lex_state = 0},
  [1549] = {.lex_state = 0},
  [1550] = {.lex_state = 34},
  [1551] = {.lex_state = 0},
  [1552] = {.lex_state = 0},
  [1553] = {.lex_state = 52},
  [1554] = {.lex_state = 0},
  [1555] = {.lex_state = 52},
  [1556] = {.lex_state = 34},
  [1557] = {.lex_state = 0},
  [1558] = {.lex_state = 45},
  [1559] = {.lex_state = 45},
  [1560] = {.lex_state = 45},
  [1561] = {.lex_state = 0},
  [1562] = {.lex_state = 0},
  [1563] = {.lex_state = 0},
  [1564] = {.lex_state = 0},
  [1565] = {.lex_state = 0},
  [1566] = {.lex_state = 45},
  [1567] = {.lex_state = 52},
  [1568] = {.lex_state = 0},
  [1569] = {.lex_state = 0},
  [1570] = {.lex_state = 0},
  [1571] = {.lex_state = 0},
  [1572] = {.lex_state = 0},
  [1573] = {.lex_state = 0},
  [1574] = {.lex_state = 52},
  [1575] = {.lex_state = 0},
  [1576] = {.lex_state = 0},
  [1577] = {.lex_state = 0},
  [1578] = {.lex_state = 0},
  [1579] = {.lex_state = 0},
  [1580] = {.lex_state = 0},
  [1581] = {.lex_state = 0},
  [1582] = {.lex_state = 0},
  [1583] = {.lex_state = 0},
  [1584] = {.lex_state = 52},
  [1585] = {.lex_state = 45},
  [1586] = {.lex_state = 34},
  [1587] = {.lex_state = 0},
  [1588] = {.lex_state = 0},
  [1589] = {.lex_state = 0},
  [1590] = {.lex_state = 0},
  [1591] = {.lex_state = 0},
  [1592] = {.lex_state = 0},
  [1593] = {.lex_state = 0},
  [1594] = {.lex_state = 0},
  [1595] = {.lex_state = 0},
  [1596] = {.lex_state = 0},
  [1597] = {.lex_state = 0},
  [1598] = {.lex_state = 0},
  [1599] = {.lex_state = 0},
  [1600] = {.lex_state = 0},
  [1601] = {.lex_state = 0},
  [1602] = {.lex_state = 0},
  [1603] = {.lex_state = 0},
  [1604] = {.lex_state = 0},
  [1605] = {.lex_state = 0},
  [1606] = {.lex_state = 0},
  [1607] = {.lex_state = 0},
  [1608] = {.lex_state = 0},
  [1609] = {.lex_state = 0},
  [1610] = {.lex_state = 0},
  [1611] = {.lex_state = 0},
  [1612] = {.lex_state = 0},
  [1613] = {.lex_state = 0},
  [1614] = {.lex_state = 52},
  [1615] = {.lex_state = 0},
  [1616] = {.lex_state = 0},
  [1617] = {.lex_state = 0},
  [1618] = {.lex_state = 0},
  [1619] = {.lex_state = 0},
  [1620] = {.lex_state = 0},
  [1621] = {.lex_state = 0},
  [1622] = {.lex_state = 0},
  [1623] = {.lex_state = 0},
  [1624] = {.lex_state = 30},
  [1625] = {.lex_state = 34},
  [1626] = {.lex_state = 0},
  [1627] = {.lex_state = 0},
  [1628] = {.lex_state = 0},
  [1629] = {.lex_state = 0},
  [1630] = {.lex_state = 52},
  [1631] = {.lex_state = 0},
  [1632] = {.lex_state = 52},
  [1633] = {.lex_state = 0},
  [1634] = {.lex_state = 0},
  [1635] = {.lex_state = 0},
  [1636] = {.lex_state = 52},
  [1637] = {.lex_state = 0},
  [1638] = {.lex_state = 0},
  [1639] = {.lex_state = 0},
  [1640] = {.lex_state = 0},
  [1641] = {.lex_state = 0},
  [1642] = {.lex_state = 0},
  [1643] = {.lex_state = 0},
  [1644] = {.lex_state = 52},
  [1645] = {.lex_state = 0},
  [1646] = {.lex_state = 0},
  [1647] = {.lex_state = 0},
  [1648] = {.lex_state = 0},
  [1649] = {.lex_state = 30},
  [1650] = {.lex_state = 0},
  [1651] = {.lex_state = 52},
  [1652] = {.lex_state = 0},
  [1653] = {.lex_state = 30},
  [1654] = {.lex_state = 52},
  [1655] = {.lex_state = 0},
  [1656] = {.lex_state = 45},
  [1657] = {.lex_state = 0},
  [1658] = {.lex_state = 0},
  [1659] = {.lex_state = 0},
  [1660] = {.lex_state = 0},
  [1661] = {.lex_state = 0},
  [1662] = {.lex_state = 0},
  [1663] = {.lex_state = 0},
  [1664] = {.lex_state = 0},
  [1665] = {.lex_state = 0},
  [1666] = {.lex_state = 45},
  [1667] = {.lex_state = 0},
  [1668] = {.lex_state = 0},
  [1669] = {.lex_state = 119},
  [1670] = {.lex_state = 0},
  [1671] = {.lex_state = 0},
  [1672] = {.lex_state = 0},
  [1673] = {.lex_state = 0},
  [1674] = {.lex_state = 0},
  [1675] = {.lex_state = 0},
  [1676] = {.lex_state = 0},
  [1677] = {.lex_state = 0},
  [1678] = {.lex_state = 119},
  [1679] = {.lex_state = 45},
  [1680] = {.lex_state = 45},
  [1681] = {.lex_state = 0},
  [1682] = {.lex_state = 119},
  [1683] = {.lex_state = 0},
  [1684] = {.lex_state = 52},
  [1685] = {.lex_state = 0},
  [1686] = {.lex_state = 0},
  [1687] = {.lex_state = 33},
  [1688] = {.lex_state = 33},
  [1689] = {.lex_state = 119},
  [1690] = {.lex_state = 0},
  [1691] = {.lex_state = 0},
  [1692] = {.lex_state = 33},
  [1693] = {.lex_state = 33},
  [1694] = {.lex_state = 52},
  [1695] = {.lex_state = 0},
  [1696] = {.lex_state = 119},
  [1697] = {.lex_state = 33},
  [1698] = {.lex_state = 0},
  [1699] = {.lex_state = 52},
  [1700] = {.lex_state = 0},
  [1701] = {.lex_state = 33},
  [1702] = {.lex_state = 0},
  [1703] = {.lex_state = 119},
  [1704] = {.lex_state = 0},
  [1705] = {.lex_state = 52},
  [1706] = {.lex_state = 119},
  [1707] = {.lex_state = 119},
  [1708] = {.lex_state = 119},
  [1709] = {.lex_state = 0},
  [1710] = {.lex_state = 0},
  [1711] = {.lex_state = 0},
  [1712] = {.lex_state = 33},
  [1713] = {.lex_state = 0},
  [1714] = {.lex_state = 33},
  [1715] = {.lex_state = 33},
  [1716] = {.lex_state = 119},
  [1717] = {.lex_state = 119},
  [1718] = {.lex_state = 0},
  [1719] = {.lex_state = 119},
  [1720] = {.lex_state = 33},
  [1721] = {.lex_state = 119},
  [1722] = {.lex_state = 119},
  [1723] = {.lex_state = 45},
  [1724] = {.lex_state = 119},
  [1725] = {.lex_state = 0},
  [1726] = {.lex_state = 0},
  [1727] = {.lex_state = 119},
  [1728] = {.lex_state = 33},
  [1729] = {.lex_state = 119},
  [1730] = {.lex_state = 119},
  [1731] = {.lex_state = 0},
  [1732] = {.lex_state = 119},
  [1733] = {.lex_state = 52},
  [1734] = {.lex_state = 119},
  [1735] = {.lex_state = 119},
  [1736] = {.lex_state = 0},
  [1737] = {.lex_state = 0},
  [1738] = {.lex_state = 0},
  [1739] = {.lex_state = 33},
  [1740] = {.lex_state = 119},
  [1741] = {.lex_state = 0},
  [1742] = {.lex_state = 119},
  [1743] = {.lex_state = 52},
  [1744] = {.lex_state = 0},
  [1745] = {.lex_state = 33},
  [1746] = {.lex_state = 0},
  [1747] = {.lex_state = 0},
  [1748] = {.lex_state = 33},
  [1749] = {.lex_state = 0},
  [1750] = {.lex_state = 33},
  [1751] = {.lex_state = 33},
  [1752] = {.lex_state = 52},
  [1753] = {.lex_state = 52},
  [1754] = {.lex_state = 119},
  [1755] = {.lex_state = 119},
  [1756] = {.lex_state = 33},
  [1757] = {.lex_state = 52},
  [1758] = {.lex_state = 0},
  [1759] = {.lex_state = 0},
  [1760] = {.lex_state = 44},
  [1761] = {.lex_state = 0},
  [1762] = {.lex_state = 0},
  [1763] = {.lex_state = 0},
  [1764] = {.lex_state = 44},
  [1765] = {.lex_state = 119},
  [1766] = {.lex_state = 0},
  [1767] = {.lex_state = 119},
  [1768] = {.lex_state = 0},
  [1769] = {.lex_state = 34},
  [1770] = {.lex_state = 0},
  [1771] = {.lex_state = 0},
  [1772] = {.lex_state = 0},
  [1773] = {.lex_state = 34},
  [1774] = {.lex_state = 34},
  [1775] = {.lex_state = 0},
  [1776] = {.lex_state = 44},
  [1777] = {.lex_state = 0},
  [1778] = {.lex_state = 44},
  [1779] = {.lex_state = 0},
  [1780] = {.lex_state = 34},
  [1781] = {.lex_state = 52},
  [1782] = {.lex_state = 52},
  [1783] = {.lex_state = 34},
  [1784] = {.lex_state = 0},
  [1785] = {.lex_state = 0},
  [1786] = {.lex_state = 0},
  [1787] = {.lex_state = 0},
  [1788] = {.lex_state = 0},
  [1789] = {.lex_state = 34},
  [1790] = {.lex_state = 34},
  [1791] = {.lex_state = 0},
  [1792] = {.lex_state = 34},
  [1793] = {.lex_state = 0},
  [1794] = {.lex_state = 0},
  [1795] = {.lex_state = 52},
  [1796] = {.lex_state = 34},
  [1797] = {.lex_state = 0},
  [1798] = {.lex_state = 34},
  [1799] = {.lex_state = 0},
  [1800] = {.lex_state = 0},
  [1801] = {.lex_state = 52},
  [1802] = {.lex_state = 52},
  [1803] = {.lex_state = 0},
  [1804] = {.lex_state = 0},
  [1805] = {.lex_state = 34},
  [1806] = {.lex_state = 34},
  [1807] = {.lex_state = 44},
  [1808] = {.lex_state = 34},
  [1809] = {.lex_state = 0},
  [1810] = {.lex_state = 52},
  [1811] = {.lex_state = 52},
  [1812] = {.lex_state = 0},
  [1813] = {.lex_state = 34},
  [1814] = {.lex_state = 34},
  [1815] = {.lex_state = 34},
  [1816] = {.lex_state = 52},
  [1817] = {.lex_state = 0},
  [1818] = {.lex_state = 44},
  [1819] = {.lex_state = 52},
  [1820] = {.lex_state = 52},
  [1821] = {.lex_state = 44},
  [1822] = {.lex_state = 44},
  [1823] = {.lex_state = 0},
  [1824] = {.lex_state = 44},
  [1825] = {.lex_state = 0},
  [1826] = {.lex_state = 0},
  [1827] = {.lex_state = 119},
  [1828] = {.lex_state = 0},
  [1829] = {.lex_state = 0},
  [1830] = {.lex_state = 0},
  [1831] = {.lex_state = 0},
  [1832] = {.lex_state = 44},
  [1833] = {.lex_state = 119},
  [1834] = {.lex_state = 44},
  [1835] = {.lex_state = 119},
  [1836] = {.lex_state = 44},
  [1837] = {.lex_state = 0},
  [1838] = {.lex_state = 0},
  [1839] = {.lex_state = 44},
  [1840] = {.lex_state = 119},
  [1841] = {.lex_state = 52},
  [1842] = {.lex_state = 44},
  [1843] = {.lex_state = 0},
  [1844] = {.lex_state = 0},
  [1845] = {.lex_state = 0},
  [1846] = {.lex_state = 0},
  [1847] = {.lex_state = 0},
  [1848] = {.lex_state = 0},
  [1849] = {.lex_state = 0},
  [1850] = {.lex_state = 0},
  [1851] = {.lex_state = 52},
  [1852] = {.lex_state = 34},
  [1853] = {.lex_state = 52},
  [1854] = {.lex_state = 119},
  [1855] = {.lex_state = 44},
  [1856] = {.lex_state = 0},
  [1857] = {.lex_state = 44},
  [1858] = {.lex_state = 52},
  [1859] = {.lex_state = 52},
  [1860] = {.lex_state = 0},
  [1861] = {.lex_state = 0},
  [1862] = {.lex_state = 0},
  [1863] = {.lex_state = 44},
  [1864] = {.lex_state = 34},
  [1865] = {.lex_state = 0},
  [1866] = {.lex_state = 0},
  [1867] = {.lex_state = 0},
  [1868] = {.lex_state = 44},
  [1869] = {.lex_state = 0},
  [1870] = {.lex_state = 44},
  [1871] = {.lex_state = 34},
  [1872] = {.lex_state = 44},
  [1873] = {.lex_state = 44},
  [1874] = {.lex_state = 119},
  [1875] = {.lex_state = 52},
  [1876] = {.lex_state = 44},
  [1877] = {.lex_state = 34},
  [1878] = {.lex_state = 44},
  [1879] = {.lex_state = 44},
  [1880] = {.lex_state = 44},
  [1881] = {.lex_state = 52},
  [1882] = {.lex_state = 0},
  [1883] = {.lex_state = 0},
  [1884] = {.lex_state = 44},
  [1885] = {.lex_state = 0},
  [1886] = {.lex_state = 0},
  [1887] = {.lex_state = 0},
  [1888] = {.lex_state = 34},
  [1889] = {.lex_state = 44},
  [1890] = {.lex_state = 44},
  [1891] = {.lex_state = 44},
  [1892] = {.lex_state = 0},
  [1893] = {.lex_state = 44},
  [1894] = {.lex_state = 34},
  [1895] = {.lex_state = 44},
  [1896] = {.lex_state = 34},
  [1897] = {.lex_state = 0},
  [1898] = {.lex_state = 119},
  [1899] = {.lex_state = 44},
  [1900] = {.lex_state = 52},
  [1901] = {.lex_state = 52},
  [1902] = {.lex_state = 44},
  [1903] = {.lex_state = 0},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 52},
  [1906] = {.lex_state = 34},
  [1907] = {.lex_state = 44},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 52},
  [1910] = {.lex_state = 0},
  [1911] = {.lex_state = 52},
  [1912] = {.lex_state = 0},
  [1913] = {.lex_state = 44},
  [1914] = {.lex_state = 0},
  [1915] = {.lex_state = 34},
  [1916] = {.lex_state = 119},
  [1917] = {.lex_state = 0},
  [1918] = {.lex_state = 44},
  [1919] = {.lex_state = 0},
  [1920] = {.lex_state = 52},
  [1921] = {.lex_state = 52},
  [1922] = {.lex_state = 0},
  [1923] = {.lex_state = 0},
  [1924] = {.lex_state = 0},
  [1925] = {.lex_state = 44},
  [1926] = {.lex_state = 44},
  [1927] = {.lex_state = 0},
  [1928] = {.lex_state = 0},
  [1929] = {.lex_state = 0},
  [1930] = {.lex_state = 0},
  [1931] = {.lex_state = 52},
  [1932] = {.lex_state = 52},
  [1933] = {.lex_state = 52},
  [1934] = {.lex_state = 0},
  [1935] = {.lex_state = 34},
  [1936] = {.lex_state = 0},
  [1937] = {.lex_state = 52},
  [1938] = {.lex_state = 0},
  [1939] = {.lex_state = 0},
  [1940] = {.lex_state = 0},
  [1941] = {.lex_state = 0},
  [1942] = {.lex_state = 34},
  [1943] = {.lex_state = 0},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 44},
  [1946] = {.lex_state = 0},
  [1947] = {.lex_state = 0},
  [1948] = {.lex_state = 0},
  [1949] = {.lex_state = 0},
  [1950] = {.lex_state = 44},
  [1951] = {.lex_state = 0},
  [1952] = {.lex_state = 52},
  [1953] = {.lex_state = 0},
  [1954] = {.lex_state = 0},
  [1955] = {.lex_state = 0},
  [1956] = {.lex_state = 52},
  [1957] = {.lex_state = 52},
  [1958] = {.lex_state = 0},
  [1959] = {.lex_state = 0},
  [1960] = {.lex_state = 52},
  [1961] = {.lex_state = 52},
  [1962] = {.lex_state = 0},
  [1963] = {.lex_state = 119},
  [1964] = {.lex_state = 119},
  [1965] = {.lex_state = 0},
  [1966] = {.lex_state = 52},
  [1967] = {.lex_state = 44},
  [1968] = {.lex_state = 44},
  [1969] = {.lex_state = 0},
  [1970] = {.lex_state = 44},
  [1971] = {.lex_state = 0},
  [1972] = {.lex_state = 44},
  [1973] = {.lex_state = 52},
  [1974] = {.lex_state = 52},
  [1975] = {.lex_state = 34},
  [1976] = {.lex_state = 0},
  [1977] = {.lex_state = 0},
  [1978] = {.lex_state = 0},
  [1979] = {.lex_state = 34},
  [1980] = {.lex_state = 44},
  [1981] = {.lex_state = 44},
  [1982] = {.lex_state = 44},
  [1983] = {.lex_state = 0},
  [1984] = {.lex_state = 44},
  [1985] = {.lex_state = 0},
  [1986] = {.lex_state = 119},
  [1987] = {.lex_state = 52},
  [1988] = {.lex_state = 44},
  [1989] = {.lex_state = 52},
  [1990] = {.lex_state = 0},
  [1991] = {.lex_state = 44},
  [1992] = {.lex_state = 52},
  [1993] = {.lex_state = 119},
  [1994] = {.lex_state = 0},
  [1995] = {.lex_state = 0},
  [1996] = {.lex_state = 0},
  [1997] = {.lex_state = 34},
  [1998] = {.lex_state = 44},
  [1999] = {.lex_state = 44},
  [2000] = {.lex_state = 0},
  [2001] = {.lex_state = 52},
  [2002] = {.lex_state = 119},
  [2003] = {.lex_state = 0},
  [2004] = {.lex_state = 52},
  [2005] = {.lex_state = 119},
  [2006] = {.lex_state = 52},
  [2007] = {.lex_state = 34},
  [2008] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_auto] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym__Nonnull] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym__Alignas] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym___asm] = ACTIONS(1),
    [anon_sym___volatile__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_translation_unit] = STATE(1882),
    [sym__top_level_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym__old_style_function_definition] = STATE(380),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1118),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(690),
    [sym_compound_statement] = STATE(43),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(790),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(367),
    [sym__top_level_statement] = STATE(43),
    [sym_labeled_statement] = STATE(43),
    [sym__top_level_expression_statement] = STATE(43),
    [sym_if_statement] = STATE(43),
    [sym_switch_statement] = STATE(43),
    [sym_case_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_do_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_return_statement] = STATE(43),
    [sym_break_statement] = STATE(43),
    [sym_continue_statement] = STATE(43),
    [sym_goto_statement] = STATE(43),
    [sym_expression] = STATE(1100),
    [sym__string] = STATE(1103),
    [sym_conditional_expression] = STATE(1103),
    [sym_assignment_expression] = STATE(1103),
    [sym_pointer_expression] = STATE(924),
    [sym_unary_expression] = STATE(1103),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(1103),
    [sym_cast_expression] = STATE(1103),
    [sym_sizeof_expression] = STATE(1103),
    [sym_alignof_expression] = STATE(1103),
    [sym_offsetof_expression] = STATE(1103),
    [sym_generic_expression] = STATE(1103),
    [sym_subscript_expression] = STATE(924),
    [sym_call_expression] = STATE(924),
    [sym_gnu_asm_expression] = STATE(1103),
    [sym_extension_expression] = STATE(1103),
    [sym_field_expression] = STATE(924),
    [sym_compound_literal_expression] = STATE(1103),
    [sym_parenthesized_expression] = STATE(924),
    [sym_char_literal] = STATE(1103),
    [sym_concatenated_string] = STATE(1103),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(1103),
    [sym__empty_declaration] = STATE(43),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_translation_unit_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(31),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1760),
    [sym_preproc_elif] = STATE(1760),
    [sym_preproc_elifdef] = STATE(1760),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__block_item] = STATE(5),
    [sym_preproc_include] = STATE(5),
    [sym_preproc_def] = STATE(5),
    [sym_preproc_function_def] = STATE(5),
    [sym_preproc_call] = STATE(5),
    [sym_preproc_if] = STATE(5),
    [sym_preproc_ifdef] = STATE(5),
    [sym_preproc_else] = STATE(1988),
    [sym_preproc_elif] = STATE(1988),
    [sym_preproc_elifdef] = STATE(1988),
    [sym_function_definition] = STATE(5),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(5),
    [sym_type_definition] = STATE(5),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(5),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(5),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(5),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(5),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__block_item] = STATE(6),
    [sym_preproc_include] = STATE(6),
    [sym_preproc_def] = STATE(6),
    [sym_preproc_function_def] = STATE(6),
    [sym_preproc_call] = STATE(6),
    [sym_preproc_if] = STATE(6),
    [sym_preproc_ifdef] = STATE(6),
    [sym_preproc_else] = STATE(1764),
    [sym_preproc_elif] = STATE(1764),
    [sym_preproc_elifdef] = STATE(1764),
    [sym_function_definition] = STATE(6),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(6),
    [sym_type_definition] = STATE(6),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(6),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(6),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(6),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(6),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(165),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1918),
    [sym_preproc_elif] = STATE(1918),
    [sym_preproc_elifdef] = STATE(1918),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1880),
    [sym_preproc_elif] = STATE(1880),
    [sym_preproc_elifdef] = STATE(1880),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__block_item] = STATE(9),
    [sym_preproc_include] = STATE(9),
    [sym_preproc_def] = STATE(9),
    [sym_preproc_function_def] = STATE(9),
    [sym_preproc_call] = STATE(9),
    [sym_preproc_if] = STATE(9),
    [sym_preproc_ifdef] = STATE(9),
    [sym_preproc_else] = STATE(1926),
    [sym_preproc_elif] = STATE(1926),
    [sym_preproc_elifdef] = STATE(1926),
    [sym_function_definition] = STATE(9),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(9),
    [sym_type_definition] = STATE(9),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(9),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(9),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(9),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(9),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__block_item] = STATE(10),
    [sym_preproc_include] = STATE(10),
    [sym_preproc_def] = STATE(10),
    [sym_preproc_function_def] = STATE(10),
    [sym_preproc_call] = STATE(10),
    [sym_preproc_if] = STATE(10),
    [sym_preproc_ifdef] = STATE(10),
    [sym_preproc_else] = STATE(1991),
    [sym_preproc_elif] = STATE(1991),
    [sym_preproc_elifdef] = STATE(1991),
    [sym_function_definition] = STATE(10),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(10),
    [sym_type_definition] = STATE(10),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(10),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(10),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(10),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(10),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1998),
    [sym_preproc_elif] = STATE(1998),
    [sym_preproc_elifdef] = STATE(1998),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1878),
    [sym_preproc_elif] = STATE(1878),
    [sym_preproc_elifdef] = STATE(1878),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__block_item] = STATE(13),
    [sym_preproc_include] = STATE(13),
    [sym_preproc_def] = STATE(13),
    [sym_preproc_function_def] = STATE(13),
    [sym_preproc_call] = STATE(13),
    [sym_preproc_if] = STATE(13),
    [sym_preproc_ifdef] = STATE(13),
    [sym_preproc_else] = STATE(1873),
    [sym_preproc_elif] = STATE(1873),
    [sym_preproc_elifdef] = STATE(1873),
    [sym_function_definition] = STATE(13),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(13),
    [sym_type_definition] = STATE(13),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(13),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(13),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(13),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(13),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__block_item] = STATE(14),
    [sym_preproc_include] = STATE(14),
    [sym_preproc_def] = STATE(14),
    [sym_preproc_function_def] = STATE(14),
    [sym_preproc_call] = STATE(14),
    [sym_preproc_if] = STATE(14),
    [sym_preproc_ifdef] = STATE(14),
    [sym_preproc_else] = STATE(1821),
    [sym_preproc_elif] = STATE(1821),
    [sym_preproc_elifdef] = STATE(1821),
    [sym_function_definition] = STATE(14),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(14),
    [sym_type_definition] = STATE(14),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(14),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(14),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(14),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(14),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(181),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1824),
    [sym_preproc_elif] = STATE(1824),
    [sym_preproc_elifdef] = STATE(1824),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1879),
    [sym_preproc_elif] = STATE(1879),
    [sym_preproc_elifdef] = STATE(1879),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__block_item] = STATE(17),
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(1895),
    [sym_preproc_elif] = STATE(1895),
    [sym_preproc_elifdef] = STATE(1895),
    [sym_function_definition] = STATE(17),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(17),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(17),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(17),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__block_item] = STATE(18),
    [sym_preproc_include] = STATE(18),
    [sym_preproc_def] = STATE(18),
    [sym_preproc_function_def] = STATE(18),
    [sym_preproc_call] = STATE(18),
    [sym_preproc_if] = STATE(18),
    [sym_preproc_ifdef] = STATE(18),
    [sym_preproc_else] = STATE(1776),
    [sym_preproc_elif] = STATE(1776),
    [sym_preproc_elifdef] = STATE(1776),
    [sym_function_definition] = STATE(18),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(18),
    [sym_type_definition] = STATE(18),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(18),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(18),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(18),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(18),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1778),
    [sym_preproc_elif] = STATE(1778),
    [sym_preproc_elifdef] = STATE(1778),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1807),
    [sym_preproc_elif] = STATE(1807),
    [sym_preproc_elifdef] = STATE(1807),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(193),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__block_item] = STATE(21),
    [sym_preproc_include] = STATE(21),
    [sym_preproc_def] = STATE(21),
    [sym_preproc_function_def] = STATE(21),
    [sym_preproc_call] = STATE(21),
    [sym_preproc_if] = STATE(21),
    [sym_preproc_ifdef] = STATE(21),
    [sym_preproc_else] = STATE(1945),
    [sym_preproc_elif] = STATE(1945),
    [sym_preproc_elifdef] = STATE(1945),
    [sym_function_definition] = STATE(21),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(21),
    [sym_type_definition] = STATE(21),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(21),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(21),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(21),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(21),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(195),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__block_item] = STATE(2),
    [sym_preproc_include] = STATE(2),
    [sym_preproc_def] = STATE(2),
    [sym_preproc_function_def] = STATE(2),
    [sym_preproc_call] = STATE(2),
    [sym_preproc_if] = STATE(2),
    [sym_preproc_ifdef] = STATE(2),
    [sym_preproc_else] = STATE(1980),
    [sym_preproc_elif] = STATE(1980),
    [sym_preproc_elifdef] = STATE(1980),
    [sym_function_definition] = STATE(2),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(2),
    [sym_type_definition] = STATE(2),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(2),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(2),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(2),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(2),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(197),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(1984),
    [sym_preproc_elif] = STATE(1984),
    [sym_preproc_elifdef] = STATE(1984),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(103),
    [aux_sym_preproc_include_token1] = ACTIONS(105),
    [aux_sym_preproc_def_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token1] = ACTIONS(109),
    [aux_sym_preproc_if_token2] = ACTIONS(199),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(113),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(113),
    [aux_sym_preproc_else_token1] = ACTIONS(115),
    [aux_sym_preproc_elif_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(119),
    [sym_preproc_directive] = ACTIONS(121),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(129),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym__old_style_function_definition] = STATE(120),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1129),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(689),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(793),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(145),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(201),
    [aux_sym_preproc_include_token1] = ACTIONS(204),
    [aux_sym_preproc_def_token1] = ACTIONS(207),
    [aux_sym_preproc_if_token1] = ACTIONS(210),
    [aux_sym_preproc_if_token2] = ACTIONS(213),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(215),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(215),
    [aux_sym_preproc_else_token1] = ACTIONS(213),
    [aux_sym_preproc_elif_token1] = ACTIONS(213),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(213),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(213),
    [sym_preproc_directive] = ACTIONS(218),
    [anon_sym_LPAREN2] = ACTIONS(221),
    [anon_sym_BANG] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_SEMI] = ACTIONS(233),
    [anon_sym___extension__] = ACTIONS(236),
    [anon_sym_typedef] = ACTIONS(239),
    [anon_sym_extern] = ACTIONS(242),
    [anon_sym___attribute__] = ACTIONS(245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(248),
    [anon_sym___declspec] = ACTIONS(251),
    [anon_sym___cdecl] = ACTIONS(254),
    [anon_sym___clrcall] = ACTIONS(254),
    [anon_sym___stdcall] = ACTIONS(254),
    [anon_sym___fastcall] = ACTIONS(254),
    [anon_sym___thiscall] = ACTIONS(254),
    [anon_sym___vectorcall] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(257),
    [anon_sym_signed] = ACTIONS(260),
    [anon_sym_unsigned] = ACTIONS(260),
    [anon_sym_long] = ACTIONS(260),
    [anon_sym_short] = ACTIONS(260),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_auto] = ACTIONS(263),
    [anon_sym_register] = ACTIONS(263),
    [anon_sym_inline] = ACTIONS(263),
    [anon_sym___inline] = ACTIONS(263),
    [anon_sym___inline__] = ACTIONS(263),
    [anon_sym___forceinline] = ACTIONS(263),
    [anon_sym_thread_local] = ACTIONS(263),
    [anon_sym___thread] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(266),
    [anon_sym_constexpr] = ACTIONS(266),
    [anon_sym_volatile] = ACTIONS(266),
    [anon_sym_restrict] = ACTIONS(266),
    [anon_sym___restrict__] = ACTIONS(266),
    [anon_sym__Atomic] = ACTIONS(266),
    [anon_sym__Noreturn] = ACTIONS(266),
    [anon_sym_noreturn] = ACTIONS(266),
    [anon_sym__Nonnull] = ACTIONS(266),
    [anon_sym_alignas] = ACTIONS(269),
    [anon_sym__Alignas] = ACTIONS(269),
    [sym_primitive_type] = ACTIONS(272),
    [anon_sym_enum] = ACTIONS(275),
    [anon_sym_struct] = ACTIONS(278),
    [anon_sym_union] = ACTIONS(281),
    [anon_sym_if] = ACTIONS(284),
    [anon_sym_switch] = ACTIONS(287),
    [anon_sym_case] = ACTIONS(290),
    [anon_sym_default] = ACTIONS(293),
    [anon_sym_while] = ACTIONS(296),
    [anon_sym_do] = ACTIONS(299),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(308),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(314),
    [anon_sym___try] = ACTIONS(317),
    [anon_sym___leave] = ACTIONS(320),
    [anon_sym_DASH_DASH] = ACTIONS(323),
    [anon_sym_PLUS_PLUS] = ACTIONS(323),
    [anon_sym_sizeof] = ACTIONS(326),
    [anon_sym___alignof__] = ACTIONS(329),
    [anon_sym___alignof] = ACTIONS(329),
    [anon_sym__alignof] = ACTIONS(329),
    [anon_sym_alignof] = ACTIONS(329),
    [anon_sym__Alignof] = ACTIONS(329),
    [anon_sym_offsetof] = ACTIONS(332),
    [anon_sym__Generic] = ACTIONS(335),
    [anon_sym_asm] = ACTIONS(338),
    [anon_sym___asm__] = ACTIONS(338),
    [anon_sym___asm] = ACTIONS(338),
    [sym_number_literal] = ACTIONS(341),
    [anon_sym_L_SQUOTE] = ACTIONS(344),
    [anon_sym_u_SQUOTE] = ACTIONS(344),
    [anon_sym_U_SQUOTE] = ACTIONS(344),
    [anon_sym_u8_SQUOTE] = ACTIONS(344),
    [anon_sym_SQUOTE] = ACTIONS(344),
    [anon_sym_L_DQUOTE] = ACTIONS(347),
    [anon_sym_u_DQUOTE] = ACTIONS(347),
    [anon_sym_U_DQUOTE] = ACTIONS(347),
    [anon_sym_u8_DQUOTE] = ACTIONS(347),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [sym_true] = ACTIONS(350),
    [sym_false] = ACTIONS(350),
    [anon_sym_NULL] = ACTIONS(353),
    [anon_sym_nullptr] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(42),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(378),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(406),
    [aux_sym_preproc_include_token1] = ACTIONS(409),
    [aux_sym_preproc_def_token1] = ACTIONS(412),
    [aux_sym_preproc_if_token1] = ACTIONS(415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(418),
    [sym_preproc_directive] = ACTIONS(421),
    [anon_sym_LPAREN2] = ACTIONS(221),
    [anon_sym_BANG] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_SEMI] = ACTIONS(424),
    [anon_sym___extension__] = ACTIONS(427),
    [anon_sym_typedef] = ACTIONS(430),
    [anon_sym_extern] = ACTIONS(433),
    [anon_sym___attribute__] = ACTIONS(245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(248),
    [anon_sym___declspec] = ACTIONS(251),
    [anon_sym___cdecl] = ACTIONS(254),
    [anon_sym___clrcall] = ACTIONS(254),
    [anon_sym___stdcall] = ACTIONS(254),
    [anon_sym___fastcall] = ACTIONS(254),
    [anon_sym___thiscall] = ACTIONS(254),
    [anon_sym___vectorcall] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(436),
    [anon_sym_RBRACE] = ACTIONS(439),
    [anon_sym_signed] = ACTIONS(260),
    [anon_sym_unsigned] = ACTIONS(260),
    [anon_sym_long] = ACTIONS(260),
    [anon_sym_short] = ACTIONS(260),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_auto] = ACTIONS(263),
    [anon_sym_register] = ACTIONS(263),
    [anon_sym_inline] = ACTIONS(263),
    [anon_sym___inline] = ACTIONS(263),
    [anon_sym___inline__] = ACTIONS(263),
    [anon_sym___forceinline] = ACTIONS(263),
    [anon_sym_thread_local] = ACTIONS(263),
    [anon_sym___thread] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(266),
    [anon_sym_constexpr] = ACTIONS(266),
    [anon_sym_volatile] = ACTIONS(266),
    [anon_sym_restrict] = ACTIONS(266),
    [anon_sym___restrict__] = ACTIONS(266),
    [anon_sym__Atomic] = ACTIONS(266),
    [anon_sym__Noreturn] = ACTIONS(266),
    [anon_sym_noreturn] = ACTIONS(266),
    [anon_sym__Nonnull] = ACTIONS(266),
    [anon_sym_alignas] = ACTIONS(269),
    [anon_sym__Alignas] = ACTIONS(269),
    [sym_primitive_type] = ACTIONS(272),
    [anon_sym_enum] = ACTIONS(275),
    [anon_sym_struct] = ACTIONS(278),
    [anon_sym_union] = ACTIONS(281),
    [anon_sym_if] = ACTIONS(441),
    [anon_sym_switch] = ACTIONS(444),
    [anon_sym_case] = ACTIONS(447),
    [anon_sym_default] = ACTIONS(450),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(456),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(462),
    [anon_sym_break] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(468),
    [anon_sym_goto] = ACTIONS(471),
    [anon_sym___try] = ACTIONS(474),
    [anon_sym___leave] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(323),
    [anon_sym_PLUS_PLUS] = ACTIONS(323),
    [anon_sym_sizeof] = ACTIONS(326),
    [anon_sym___alignof__] = ACTIONS(329),
    [anon_sym___alignof] = ACTIONS(329),
    [anon_sym__alignof] = ACTIONS(329),
    [anon_sym_alignof] = ACTIONS(329),
    [anon_sym__Alignof] = ACTIONS(329),
    [anon_sym_offsetof] = ACTIONS(332),
    [anon_sym__Generic] = ACTIONS(335),
    [anon_sym_asm] = ACTIONS(338),
    [anon_sym___asm__] = ACTIONS(338),
    [anon_sym___asm] = ACTIONS(338),
    [sym_number_literal] = ACTIONS(341),
    [anon_sym_L_SQUOTE] = ACTIONS(344),
    [anon_sym_u_SQUOTE] = ACTIONS(344),
    [anon_sym_U_SQUOTE] = ACTIONS(344),
    [anon_sym_u8_SQUOTE] = ACTIONS(344),
    [anon_sym_SQUOTE] = ACTIONS(344),
    [anon_sym_L_DQUOTE] = ACTIONS(347),
    [anon_sym_u_DQUOTE] = ACTIONS(347),
    [anon_sym_U_DQUOTE] = ACTIONS(347),
    [anon_sym_u8_DQUOTE] = ACTIONS(347),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [sym_true] = ACTIONS(350),
    [sym_false] = ACTIONS(350),
    [anon_sym_NULL] = ACTIONS(353),
    [anon_sym_nullptr] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym__old_style_function_definition] = STATE(263),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1116),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(692),
    [sym_compound_statement] = STATE(204),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(808),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(310),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(35),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(480),
    [aux_sym_preproc_include_token1] = ACTIONS(482),
    [aux_sym_preproc_def_token1] = ACTIONS(484),
    [aux_sym_preproc_if_token1] = ACTIONS(486),
    [aux_sym_preproc_if_token2] = ACTIONS(488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(490),
    [sym_preproc_directive] = ACTIONS(492),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(496),
    [anon_sym_typedef] = ACTIONS(498),
    [anon_sym_extern] = ACTIONS(500),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(263),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1116),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(692),
    [sym_compound_statement] = STATE(204),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(808),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(310),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(532),
    [aux_sym_preproc_include_token1] = ACTIONS(535),
    [aux_sym_preproc_def_token1] = ACTIONS(538),
    [aux_sym_preproc_if_token1] = ACTIONS(541),
    [aux_sym_preproc_if_token2] = ACTIONS(213),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(544),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(544),
    [sym_preproc_directive] = ACTIONS(547),
    [anon_sym_LPAREN2] = ACTIONS(221),
    [anon_sym_BANG] = ACTIONS(224),
    [anon_sym_TILDE] = ACTIONS(224),
    [anon_sym_DASH] = ACTIONS(227),
    [anon_sym_PLUS] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(230),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_SEMI] = ACTIONS(550),
    [anon_sym___extension__] = ACTIONS(553),
    [anon_sym_typedef] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(559),
    [anon_sym___attribute__] = ACTIONS(245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(248),
    [anon_sym___declspec] = ACTIONS(251),
    [anon_sym___cdecl] = ACTIONS(254),
    [anon_sym___clrcall] = ACTIONS(254),
    [anon_sym___stdcall] = ACTIONS(254),
    [anon_sym___fastcall] = ACTIONS(254),
    [anon_sym___thiscall] = ACTIONS(254),
    [anon_sym___vectorcall] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_signed] = ACTIONS(260),
    [anon_sym_unsigned] = ACTIONS(260),
    [anon_sym_long] = ACTIONS(260),
    [anon_sym_short] = ACTIONS(260),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_auto] = ACTIONS(263),
    [anon_sym_register] = ACTIONS(263),
    [anon_sym_inline] = ACTIONS(263),
    [anon_sym___inline] = ACTIONS(263),
    [anon_sym___inline__] = ACTIONS(263),
    [anon_sym___forceinline] = ACTIONS(263),
    [anon_sym_thread_local] = ACTIONS(263),
    [anon_sym___thread] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(266),
    [anon_sym_constexpr] = ACTIONS(266),
    [anon_sym_volatile] = ACTIONS(266),
    [anon_sym_restrict] = ACTIONS(266),
    [anon_sym___restrict__] = ACTIONS(266),
    [anon_sym__Atomic] = ACTIONS(266),
    [anon_sym__Noreturn] = ACTIONS(266),
    [anon_sym_noreturn] = ACTIONS(266),
    [anon_sym__Nonnull] = ACTIONS(266),
    [anon_sym_alignas] = ACTIONS(269),
    [anon_sym__Alignas] = ACTIONS(269),
    [sym_primitive_type] = ACTIONS(272),
    [anon_sym_enum] = ACTIONS(275),
    [anon_sym_struct] = ACTIONS(278),
    [anon_sym_union] = ACTIONS(281),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_switch] = ACTIONS(568),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(574),
    [anon_sym_while] = ACTIONS(577),
    [anon_sym_do] = ACTIONS(580),
    [anon_sym_for] = ACTIONS(583),
    [anon_sym_return] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(589),
    [anon_sym_continue] = ACTIONS(592),
    [anon_sym_goto] = ACTIONS(595),
    [anon_sym___try] = ACTIONS(598),
    [anon_sym___leave] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(323),
    [anon_sym_PLUS_PLUS] = ACTIONS(323),
    [anon_sym_sizeof] = ACTIONS(326),
    [anon_sym___alignof__] = ACTIONS(329),
    [anon_sym___alignof] = ACTIONS(329),
    [anon_sym__alignof] = ACTIONS(329),
    [anon_sym_alignof] = ACTIONS(329),
    [anon_sym__Alignof] = ACTIONS(329),
    [anon_sym_offsetof] = ACTIONS(332),
    [anon_sym__Generic] = ACTIONS(335),
    [anon_sym_asm] = ACTIONS(338),
    [anon_sym___asm__] = ACTIONS(338),
    [anon_sym___asm] = ACTIONS(338),
    [sym_number_literal] = ACTIONS(341),
    [anon_sym_L_SQUOTE] = ACTIONS(344),
    [anon_sym_u_SQUOTE] = ACTIONS(344),
    [anon_sym_U_SQUOTE] = ACTIONS(344),
    [anon_sym_u8_SQUOTE] = ACTIONS(344),
    [anon_sym_SQUOTE] = ACTIONS(344),
    [anon_sym_L_DQUOTE] = ACTIONS(347),
    [anon_sym_u_DQUOTE] = ACTIONS(347),
    [anon_sym_U_DQUOTE] = ACTIONS(347),
    [anon_sym_u8_DQUOTE] = ACTIONS(347),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [sym_true] = ACTIONS(350),
    [sym_false] = ACTIONS(350),
    [anon_sym_NULL] = ACTIONS(353),
    [anon_sym_nullptr] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(30),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(604),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__block_item] = STATE(39),
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(39),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(39),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(606),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__block_item] = STATE(32),
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(32),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(32),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(610),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(612),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym__block_item] = STATE(34),
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(34),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(34),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(614),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(616),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(263),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1116),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(692),
    [sym_compound_statement] = STATE(204),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(808),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(310),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(480),
    [aux_sym_preproc_include_token1] = ACTIONS(482),
    [aux_sym_preproc_def_token1] = ACTIONS(484),
    [aux_sym_preproc_if_token1] = ACTIONS(486),
    [aux_sym_preproc_if_token2] = ACTIONS(618),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(490),
    [sym_preproc_directive] = ACTIONS(492),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(496),
    [anon_sym_typedef] = ACTIONS(498),
    [anon_sym_extern] = ACTIONS(500),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__block_item] = STATE(37),
    [sym_preproc_include] = STATE(37),
    [sym_preproc_def] = STATE(37),
    [sym_preproc_function_def] = STATE(37),
    [sym_preproc_call] = STATE(37),
    [sym_preproc_if] = STATE(37),
    [sym_preproc_ifdef] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(37),
    [sym_type_definition] = STATE(37),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(37),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(37),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(37),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(37),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(620),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(622),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__block_item] = STATE(40),
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(40),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(624),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(626),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(628),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__block_item] = STATE(26),
    [sym_preproc_include] = STATE(26),
    [sym_preproc_def] = STATE(26),
    [sym_preproc_function_def] = STATE(26),
    [sym_preproc_call] = STATE(26),
    [sym_preproc_if] = STATE(26),
    [sym_preproc_ifdef] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(26),
    [sym_type_definition] = STATE(26),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(26),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(26),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(26),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(26),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(630),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(260),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1119),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(670),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(788),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(309),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(356),
    [aux_sym_preproc_include_token1] = ACTIONS(358),
    [aux_sym_preproc_def_token1] = ACTIONS(360),
    [aux_sym_preproc_if_token1] = ACTIONS(362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(364),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(364),
    [sym_preproc_directive] = ACTIONS(366),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(374),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(632),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__top_level_item] = STATE(44),
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym__old_style_function_definition] = STATE(380),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1118),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(690),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(790),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(367),
    [sym__top_level_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym__top_level_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_expression] = STATE(1100),
    [sym__string] = STATE(1103),
    [sym_conditional_expression] = STATE(1103),
    [sym_assignment_expression] = STATE(1103),
    [sym_pointer_expression] = STATE(924),
    [sym_unary_expression] = STATE(1103),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(1103),
    [sym_cast_expression] = STATE(1103),
    [sym_sizeof_expression] = STATE(1103),
    [sym_alignof_expression] = STATE(1103),
    [sym_offsetof_expression] = STATE(1103),
    [sym_generic_expression] = STATE(1103),
    [sym_subscript_expression] = STATE(924),
    [sym_call_expression] = STATE(924),
    [sym_gnu_asm_expression] = STATE(1103),
    [sym_extension_expression] = STATE(1103),
    [sym_field_expression] = STATE(924),
    [sym_compound_literal_expression] = STATE(1103),
    [sym_parenthesized_expression] = STATE(924),
    [sym_char_literal] = STATE(1103),
    [sym_concatenated_string] = STATE(1103),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(1103),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [ts_builtin_sym_end] = ACTIONS(634),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(31),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__top_level_item] = STATE(44),
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym__old_style_function_definition] = STATE(380),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1118),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(690),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(790),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(367),
    [sym__top_level_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym__top_level_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_expression] = STATE(1100),
    [sym__string] = STATE(1103),
    [sym_conditional_expression] = STATE(1103),
    [sym_assignment_expression] = STATE(1103),
    [sym_pointer_expression] = STATE(924),
    [sym_unary_expression] = STATE(1103),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(1103),
    [sym_cast_expression] = STATE(1103),
    [sym_sizeof_expression] = STATE(1103),
    [sym_alignof_expression] = STATE(1103),
    [sym_offsetof_expression] = STATE(1103),
    [sym_generic_expression] = STATE(1103),
    [sym_subscript_expression] = STATE(924),
    [sym_call_expression] = STATE(924),
    [sym_gnu_asm_expression] = STATE(1103),
    [sym_extension_expression] = STATE(1103),
    [sym_field_expression] = STATE(924),
    [sym_compound_literal_expression] = STATE(1103),
    [sym_parenthesized_expression] = STATE(924),
    [sym_char_literal] = STATE(1103),
    [sym_concatenated_string] = STATE(1103),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(1103),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [ts_builtin_sym_end] = ACTIONS(636),
    [sym_identifier] = ACTIONS(638),
    [aux_sym_preproc_include_token1] = ACTIONS(641),
    [aux_sym_preproc_def_token1] = ACTIONS(644),
    [aux_sym_preproc_if_token1] = ACTIONS(647),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(650),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(650),
    [sym_preproc_directive] = ACTIONS(653),
    [anon_sym_LPAREN2] = ACTIONS(656),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(662),
    [anon_sym_STAR] = ACTIONS(665),
    [anon_sym_AMP] = ACTIONS(665),
    [anon_sym___extension__] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(671),
    [anon_sym_extern] = ACTIONS(674),
    [anon_sym___attribute__] = ACTIONS(677),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(680),
    [anon_sym___declspec] = ACTIONS(683),
    [anon_sym___cdecl] = ACTIONS(686),
    [anon_sym___clrcall] = ACTIONS(686),
    [anon_sym___stdcall] = ACTIONS(686),
    [anon_sym___fastcall] = ACTIONS(686),
    [anon_sym___thiscall] = ACTIONS(686),
    [anon_sym___vectorcall] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_signed] = ACTIONS(692),
    [anon_sym_unsigned] = ACTIONS(692),
    [anon_sym_long] = ACTIONS(692),
    [anon_sym_short] = ACTIONS(692),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_auto] = ACTIONS(695),
    [anon_sym_register] = ACTIONS(695),
    [anon_sym_inline] = ACTIONS(695),
    [anon_sym___inline] = ACTIONS(695),
    [anon_sym___inline__] = ACTIONS(695),
    [anon_sym___forceinline] = ACTIONS(695),
    [anon_sym_thread_local] = ACTIONS(695),
    [anon_sym___thread] = ACTIONS(695),
    [anon_sym_const] = ACTIONS(698),
    [anon_sym_constexpr] = ACTIONS(698),
    [anon_sym_volatile] = ACTIONS(698),
    [anon_sym_restrict] = ACTIONS(698),
    [anon_sym___restrict__] = ACTIONS(698),
    [anon_sym__Atomic] = ACTIONS(698),
    [anon_sym__Noreturn] = ACTIONS(698),
    [anon_sym_noreturn] = ACTIONS(698),
    [anon_sym__Nonnull] = ACTIONS(698),
    [anon_sym_alignas] = ACTIONS(701),
    [anon_sym__Alignas] = ACTIONS(701),
    [sym_primitive_type] = ACTIONS(704),
    [anon_sym_enum] = ACTIONS(707),
    [anon_sym_struct] = ACTIONS(710),
    [anon_sym_union] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(716),
    [anon_sym_switch] = ACTIONS(719),
    [anon_sym_case] = ACTIONS(722),
    [anon_sym_default] = ACTIONS(725),
    [anon_sym_while] = ACTIONS(728),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(734),
    [anon_sym_return] = ACTIONS(737),
    [anon_sym_break] = ACTIONS(740),
    [anon_sym_continue] = ACTIONS(743),
    [anon_sym_goto] = ACTIONS(746),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_sizeof] = ACTIONS(752),
    [anon_sym___alignof__] = ACTIONS(755),
    [anon_sym___alignof] = ACTIONS(755),
    [anon_sym__alignof] = ACTIONS(755),
    [anon_sym_alignof] = ACTIONS(755),
    [anon_sym__Alignof] = ACTIONS(755),
    [anon_sym_offsetof] = ACTIONS(758),
    [anon_sym__Generic] = ACTIONS(761),
    [anon_sym_asm] = ACTIONS(764),
    [anon_sym___asm__] = ACTIONS(764),
    [anon_sym___asm] = ACTIONS(764),
    [sym_number_literal] = ACTIONS(767),
    [anon_sym_L_SQUOTE] = ACTIONS(770),
    [anon_sym_u_SQUOTE] = ACTIONS(770),
    [anon_sym_U_SQUOTE] = ACTIONS(770),
    [anon_sym_u8_SQUOTE] = ACTIONS(770),
    [anon_sym_SQUOTE] = ACTIONS(770),
    [anon_sym_L_DQUOTE] = ACTIONS(773),
    [anon_sym_u_DQUOTE] = ACTIONS(773),
    [anon_sym_U_DQUOTE] = ACTIONS(773),
    [anon_sym_u8_DQUOTE] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(773),
    [sym_true] = ACTIONS(776),
    [sym_false] = ACTIONS(776),
    [anon_sym_NULL] = ACTIONS(779),
    [anon_sym_nullptr] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_declaration] = STATE(47),
    [sym_type_definition] = STATE(47),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1143),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(47),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(47),
    [sym_labeled_statement] = STATE(47),
    [sym_expression_statement] = STATE(47),
    [sym_if_statement] = STATE(47),
    [sym_switch_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_do_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_return_statement] = STATE(47),
    [sym_break_statement] = STATE(47),
    [sym_continue_statement] = STATE(47),
    [sym_goto_statement] = STATE(47),
    [sym_seh_try_statement] = STATE(47),
    [sym_seh_leave_statement] = STATE(47),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(47),
    [sym_identifier] = ACTIONS(782),
    [aux_sym_preproc_include_token1] = ACTIONS(784),
    [aux_sym_preproc_def_token1] = ACTIONS(784),
    [aux_sym_preproc_if_token1] = ACTIONS(784),
    [aux_sym_preproc_if_token2] = ACTIONS(784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(784),
    [aux_sym_preproc_else_token1] = ACTIONS(784),
    [aux_sym_preproc_elif_token1] = ACTIONS(784),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(784),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(784),
    [sym_preproc_directive] = ACTIONS(784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(784),
    [anon_sym___clrcall] = ACTIONS(784),
    [anon_sym___stdcall] = ACTIONS(784),
    [anon_sym___fastcall] = ACTIONS(784),
    [anon_sym___thiscall] = ACTIONS(784),
    [anon_sym___vectorcall] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_else] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(784),
    [anon_sym_default] = ACTIONS(784),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1143),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(49),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym_seh_try_statement] = STATE(49),
    [sym_seh_leave_statement] = STATE(49),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(49),
    [sym_identifier] = ACTIONS(782),
    [aux_sym_preproc_include_token1] = ACTIONS(786),
    [aux_sym_preproc_def_token1] = ACTIONS(786),
    [aux_sym_preproc_if_token1] = ACTIONS(786),
    [aux_sym_preproc_if_token2] = ACTIONS(786),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(786),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(786),
    [aux_sym_preproc_else_token1] = ACTIONS(786),
    [aux_sym_preproc_elif_token1] = ACTIONS(786),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(786),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(786),
    [sym_preproc_directive] = ACTIONS(786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(786),
    [anon_sym___clrcall] = ACTIONS(786),
    [anon_sym___stdcall] = ACTIONS(786),
    [anon_sym___fastcall] = ACTIONS(786),
    [anon_sym___thiscall] = ACTIONS(786),
    [anon_sym___vectorcall] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(786),
    [anon_sym_default] = ACTIONS(786),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_declaration] = STATE(48),
    [sym_type_definition] = STATE(48),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1143),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(48),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(48),
    [sym_labeled_statement] = STATE(48),
    [sym_expression_statement] = STATE(48),
    [sym_if_statement] = STATE(48),
    [sym_switch_statement] = STATE(48),
    [sym_while_statement] = STATE(48),
    [sym_do_statement] = STATE(48),
    [sym_for_statement] = STATE(48),
    [sym_return_statement] = STATE(48),
    [sym_break_statement] = STATE(48),
    [sym_continue_statement] = STATE(48),
    [sym_goto_statement] = STATE(48),
    [sym_seh_try_statement] = STATE(48),
    [sym_seh_leave_statement] = STATE(48),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(782),
    [aux_sym_preproc_include_token1] = ACTIONS(788),
    [aux_sym_preproc_def_token1] = ACTIONS(788),
    [aux_sym_preproc_if_token1] = ACTIONS(788),
    [aux_sym_preproc_if_token2] = ACTIONS(788),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(788),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(788),
    [aux_sym_preproc_else_token1] = ACTIONS(788),
    [aux_sym_preproc_elif_token1] = ACTIONS(788),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(788),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(788),
    [sym_preproc_directive] = ACTIONS(788),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(788),
    [anon_sym___clrcall] = ACTIONS(788),
    [anon_sym___stdcall] = ACTIONS(788),
    [anon_sym___fastcall] = ACTIONS(788),
    [anon_sym___thiscall] = ACTIONS(788),
    [anon_sym___vectorcall] = ACTIONS(788),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_else] = ACTIONS(788),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(788),
    [anon_sym_default] = ACTIONS(788),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_declaration] = STATE(48),
    [sym_type_definition] = STATE(48),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1143),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(48),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(48),
    [sym_labeled_statement] = STATE(48),
    [sym_expression_statement] = STATE(48),
    [sym_if_statement] = STATE(48),
    [sym_switch_statement] = STATE(48),
    [sym_while_statement] = STATE(48),
    [sym_do_statement] = STATE(48),
    [sym_for_statement] = STATE(48),
    [sym_return_statement] = STATE(48),
    [sym_break_statement] = STATE(48),
    [sym_continue_statement] = STATE(48),
    [sym_goto_statement] = STATE(48),
    [sym_seh_try_statement] = STATE(48),
    [sym_seh_leave_statement] = STATE(48),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(790),
    [aux_sym_preproc_include_token1] = ACTIONS(793),
    [aux_sym_preproc_def_token1] = ACTIONS(793),
    [aux_sym_preproc_if_token1] = ACTIONS(793),
    [aux_sym_preproc_if_token2] = ACTIONS(793),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(793),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(793),
    [aux_sym_preproc_else_token1] = ACTIONS(793),
    [aux_sym_preproc_elif_token1] = ACTIONS(793),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(793),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(793),
    [sym_preproc_directive] = ACTIONS(793),
    [anon_sym_LPAREN2] = ACTIONS(795),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_AMP] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(807),
    [anon_sym___extension__] = ACTIONS(810),
    [anon_sym_typedef] = ACTIONS(813),
    [anon_sym_extern] = ACTIONS(816),
    [anon_sym___attribute__] = ACTIONS(819),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(822),
    [anon_sym___declspec] = ACTIONS(825),
    [anon_sym___cdecl] = ACTIONS(793),
    [anon_sym___clrcall] = ACTIONS(793),
    [anon_sym___stdcall] = ACTIONS(793),
    [anon_sym___fastcall] = ACTIONS(793),
    [anon_sym___thiscall] = ACTIONS(793),
    [anon_sym___vectorcall] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(828),
    [anon_sym_signed] = ACTIONS(831),
    [anon_sym_unsigned] = ACTIONS(831),
    [anon_sym_long] = ACTIONS(831),
    [anon_sym_short] = ACTIONS(831),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_auto] = ACTIONS(816),
    [anon_sym_register] = ACTIONS(816),
    [anon_sym_inline] = ACTIONS(816),
    [anon_sym___inline] = ACTIONS(816),
    [anon_sym___inline__] = ACTIONS(816),
    [anon_sym___forceinline] = ACTIONS(816),
    [anon_sym_thread_local] = ACTIONS(816),
    [anon_sym___thread] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(834),
    [anon_sym_constexpr] = ACTIONS(834),
    [anon_sym_volatile] = ACTIONS(834),
    [anon_sym_restrict] = ACTIONS(834),
    [anon_sym___restrict__] = ACTIONS(834),
    [anon_sym__Atomic] = ACTIONS(834),
    [anon_sym__Noreturn] = ACTIONS(834),
    [anon_sym_noreturn] = ACTIONS(834),
    [anon_sym__Nonnull] = ACTIONS(834),
    [anon_sym_alignas] = ACTIONS(837),
    [anon_sym__Alignas] = ACTIONS(837),
    [sym_primitive_type] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(843),
    [anon_sym_struct] = ACTIONS(846),
    [anon_sym_union] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(852),
    [anon_sym_else] = ACTIONS(793),
    [anon_sym_switch] = ACTIONS(855),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(858),
    [anon_sym_do] = ACTIONS(861),
    [anon_sym_for] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_break] = ACTIONS(870),
    [anon_sym_continue] = ACTIONS(873),
    [anon_sym_goto] = ACTIONS(876),
    [anon_sym___try] = ACTIONS(879),
    [anon_sym___leave] = ACTIONS(882),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_sizeof] = ACTIONS(888),
    [anon_sym___alignof__] = ACTIONS(891),
    [anon_sym___alignof] = ACTIONS(891),
    [anon_sym__alignof] = ACTIONS(891),
    [anon_sym_alignof] = ACTIONS(891),
    [anon_sym__Alignof] = ACTIONS(891),
    [anon_sym_offsetof] = ACTIONS(894),
    [anon_sym__Generic] = ACTIONS(897),
    [anon_sym_asm] = ACTIONS(900),
    [anon_sym___asm__] = ACTIONS(900),
    [anon_sym___asm] = ACTIONS(900),
    [sym_number_literal] = ACTIONS(903),
    [anon_sym_L_SQUOTE] = ACTIONS(906),
    [anon_sym_u_SQUOTE] = ACTIONS(906),
    [anon_sym_U_SQUOTE] = ACTIONS(906),
    [anon_sym_u8_SQUOTE] = ACTIONS(906),
    [anon_sym_SQUOTE] = ACTIONS(906),
    [anon_sym_L_DQUOTE] = ACTIONS(909),
    [anon_sym_u_DQUOTE] = ACTIONS(909),
    [anon_sym_U_DQUOTE] = ACTIONS(909),
    [anon_sym_u8_DQUOTE] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [anon_sym_NULL] = ACTIONS(915),
    [anon_sym_nullptr] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_declaration] = STATE(48),
    [sym_type_definition] = STATE(48),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1143),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(48),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(48),
    [sym_labeled_statement] = STATE(48),
    [sym_expression_statement] = STATE(48),
    [sym_if_statement] = STATE(48),
    [sym_switch_statement] = STATE(48),
    [sym_while_statement] = STATE(48),
    [sym_do_statement] = STATE(48),
    [sym_for_statement] = STATE(48),
    [sym_return_statement] = STATE(48),
    [sym_break_statement] = STATE(48),
    [sym_continue_statement] = STATE(48),
    [sym_goto_statement] = STATE(48),
    [sym_seh_try_statement] = STATE(48),
    [sym_seh_leave_statement] = STATE(48),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(782),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token2] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [aux_sym_preproc_else_token1] = ACTIONS(918),
    [aux_sym_preproc_elif_token1] = ACTIONS(918),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(125),
    [anon_sym_typedef] = ACTIONS(127),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_declaration] = STATE(50),
    [sym_type_definition] = STATE(50),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(50),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(50),
    [sym_labeled_statement] = STATE(50),
    [sym_expression_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_switch_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_do_statement] = STATE(50),
    [sym_for_statement] = STATE(50),
    [sym_return_statement] = STATE(50),
    [sym_break_statement] = STATE(50),
    [sym_continue_statement] = STATE(50),
    [sym_goto_statement] = STATE(50),
    [sym_seh_try_statement] = STATE(50),
    [sym_seh_leave_statement] = STATE(50),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(50),
    [ts_builtin_sym_end] = ACTIONS(920),
    [sym_identifier] = ACTIONS(922),
    [aux_sym_preproc_include_token1] = ACTIONS(793),
    [aux_sym_preproc_def_token1] = ACTIONS(793),
    [aux_sym_preproc_if_token1] = ACTIONS(793),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(793),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(793),
    [sym_preproc_directive] = ACTIONS(793),
    [anon_sym_LPAREN2] = ACTIONS(795),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_AMP] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym___extension__] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(931),
    [anon_sym_extern] = ACTIONS(816),
    [anon_sym___attribute__] = ACTIONS(819),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(822),
    [anon_sym___declspec] = ACTIONS(825),
    [anon_sym___cdecl] = ACTIONS(793),
    [anon_sym___clrcall] = ACTIONS(793),
    [anon_sym___stdcall] = ACTIONS(793),
    [anon_sym___fastcall] = ACTIONS(793),
    [anon_sym___thiscall] = ACTIONS(793),
    [anon_sym___vectorcall] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(934),
    [anon_sym_signed] = ACTIONS(831),
    [anon_sym_unsigned] = ACTIONS(831),
    [anon_sym_long] = ACTIONS(831),
    [anon_sym_short] = ACTIONS(831),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_auto] = ACTIONS(816),
    [anon_sym_register] = ACTIONS(816),
    [anon_sym_inline] = ACTIONS(816),
    [anon_sym___inline] = ACTIONS(816),
    [anon_sym___inline__] = ACTIONS(816),
    [anon_sym___forceinline] = ACTIONS(816),
    [anon_sym_thread_local] = ACTIONS(816),
    [anon_sym___thread] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(834),
    [anon_sym_constexpr] = ACTIONS(834),
    [anon_sym_volatile] = ACTIONS(834),
    [anon_sym_restrict] = ACTIONS(834),
    [anon_sym___restrict__] = ACTIONS(834),
    [anon_sym__Atomic] = ACTIONS(834),
    [anon_sym__Noreturn] = ACTIONS(834),
    [anon_sym_noreturn] = ACTIONS(834),
    [anon_sym__Nonnull] = ACTIONS(834),
    [anon_sym_alignas] = ACTIONS(837),
    [anon_sym__Alignas] = ACTIONS(837),
    [sym_primitive_type] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(843),
    [anon_sym_struct] = ACTIONS(846),
    [anon_sym_union] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(937),
    [anon_sym_else] = ACTIONS(793),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(949),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(955),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_goto] = ACTIONS(961),
    [anon_sym___try] = ACTIONS(964),
    [anon_sym___leave] = ACTIONS(967),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_sizeof] = ACTIONS(888),
    [anon_sym___alignof__] = ACTIONS(891),
    [anon_sym___alignof] = ACTIONS(891),
    [anon_sym__alignof] = ACTIONS(891),
    [anon_sym_alignof] = ACTIONS(891),
    [anon_sym__Alignof] = ACTIONS(891),
    [anon_sym_offsetof] = ACTIONS(894),
    [anon_sym__Generic] = ACTIONS(897),
    [anon_sym_asm] = ACTIONS(900),
    [anon_sym___asm__] = ACTIONS(900),
    [anon_sym___asm] = ACTIONS(900),
    [sym_number_literal] = ACTIONS(903),
    [anon_sym_L_SQUOTE] = ACTIONS(906),
    [anon_sym_u_SQUOTE] = ACTIONS(906),
    [anon_sym_U_SQUOTE] = ACTIONS(906),
    [anon_sym_u8_SQUOTE] = ACTIONS(906),
    [anon_sym_SQUOTE] = ACTIONS(906),
    [anon_sym_L_DQUOTE] = ACTIONS(909),
    [anon_sym_u_DQUOTE] = ACTIONS(909),
    [anon_sym_U_DQUOTE] = ACTIONS(909),
    [anon_sym_u8_DQUOTE] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [anon_sym_NULL] = ACTIONS(915),
    [anon_sym_nullptr] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1147),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(53),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_goto_statement] = STATE(53),
    [sym_seh_try_statement] = STATE(53),
    [sym_seh_leave_statement] = STATE(53),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(53),
    [sym_identifier] = ACTIONS(970),
    [aux_sym_preproc_include_token1] = ACTIONS(788),
    [aux_sym_preproc_def_token1] = ACTIONS(788),
    [aux_sym_preproc_if_token1] = ACTIONS(788),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(788),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(788),
    [sym_preproc_directive] = ACTIONS(788),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(788),
    [anon_sym___clrcall] = ACTIONS(788),
    [anon_sym___stdcall] = ACTIONS(788),
    [anon_sym___fastcall] = ACTIONS(788),
    [anon_sym___thiscall] = ACTIONS(788),
    [anon_sym___vectorcall] = ACTIONS(788),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_else] = ACTIONS(788),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(788),
    [anon_sym_default] = ACTIONS(788),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(62),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(62),
    [sym_labeled_statement] = STATE(62),
    [sym_expression_statement] = STATE(62),
    [sym_if_statement] = STATE(62),
    [sym_switch_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_do_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_return_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_continue_statement] = STATE(62),
    [sym_goto_statement] = STATE(62),
    [sym_seh_try_statement] = STATE(62),
    [sym_seh_leave_statement] = STATE(62),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(62),
    [ts_builtin_sym_end] = ACTIONS(974),
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(784),
    [aux_sym_preproc_def_token1] = ACTIONS(784),
    [aux_sym_preproc_if_token1] = ACTIONS(784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(784),
    [sym_preproc_directive] = ACTIONS(784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(784),
    [anon_sym___clrcall] = ACTIONS(784),
    [anon_sym___stdcall] = ACTIONS(784),
    [anon_sym___fastcall] = ACTIONS(784),
    [anon_sym___thiscall] = ACTIONS(784),
    [anon_sym___vectorcall] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_else] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(784),
    [anon_sym_default] = ACTIONS(784),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1147),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(53),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_goto_statement] = STATE(53),
    [sym_seh_try_statement] = STATE(53),
    [sym_seh_leave_statement] = STATE(53),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(53),
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(793),
    [aux_sym_preproc_def_token1] = ACTIONS(793),
    [aux_sym_preproc_if_token1] = ACTIONS(793),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(793),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(793),
    [sym_preproc_directive] = ACTIONS(793),
    [anon_sym_LPAREN2] = ACTIONS(795),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_AMP] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym___extension__] = ACTIONS(990),
    [anon_sym_typedef] = ACTIONS(993),
    [anon_sym_extern] = ACTIONS(816),
    [anon_sym___attribute__] = ACTIONS(819),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(822),
    [anon_sym___declspec] = ACTIONS(825),
    [anon_sym___cdecl] = ACTIONS(793),
    [anon_sym___clrcall] = ACTIONS(793),
    [anon_sym___stdcall] = ACTIONS(793),
    [anon_sym___fastcall] = ACTIONS(793),
    [anon_sym___thiscall] = ACTIONS(793),
    [anon_sym___vectorcall] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(996),
    [anon_sym_RBRACE] = ACTIONS(920),
    [anon_sym_signed] = ACTIONS(831),
    [anon_sym_unsigned] = ACTIONS(831),
    [anon_sym_long] = ACTIONS(831),
    [anon_sym_short] = ACTIONS(831),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_auto] = ACTIONS(816),
    [anon_sym_register] = ACTIONS(816),
    [anon_sym_inline] = ACTIONS(816),
    [anon_sym___inline] = ACTIONS(816),
    [anon_sym___inline__] = ACTIONS(816),
    [anon_sym___forceinline] = ACTIONS(816),
    [anon_sym_thread_local] = ACTIONS(816),
    [anon_sym___thread] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(834),
    [anon_sym_constexpr] = ACTIONS(834),
    [anon_sym_volatile] = ACTIONS(834),
    [anon_sym_restrict] = ACTIONS(834),
    [anon_sym___restrict__] = ACTIONS(834),
    [anon_sym__Atomic] = ACTIONS(834),
    [anon_sym__Noreturn] = ACTIONS(834),
    [anon_sym_noreturn] = ACTIONS(834),
    [anon_sym__Nonnull] = ACTIONS(834),
    [anon_sym_alignas] = ACTIONS(837),
    [anon_sym__Alignas] = ACTIONS(837),
    [sym_primitive_type] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(843),
    [anon_sym_struct] = ACTIONS(846),
    [anon_sym_union] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(793),
    [anon_sym_switch] = ACTIONS(1002),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(1005),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1014),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym___try] = ACTIONS(1026),
    [anon_sym___leave] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_sizeof] = ACTIONS(888),
    [anon_sym___alignof__] = ACTIONS(891),
    [anon_sym___alignof] = ACTIONS(891),
    [anon_sym__alignof] = ACTIONS(891),
    [anon_sym_alignof] = ACTIONS(891),
    [anon_sym__Alignof] = ACTIONS(891),
    [anon_sym_offsetof] = ACTIONS(894),
    [anon_sym__Generic] = ACTIONS(897),
    [anon_sym_asm] = ACTIONS(900),
    [anon_sym___asm__] = ACTIONS(900),
    [anon_sym___asm] = ACTIONS(900),
    [sym_number_literal] = ACTIONS(903),
    [anon_sym_L_SQUOTE] = ACTIONS(906),
    [anon_sym_u_SQUOTE] = ACTIONS(906),
    [anon_sym_U_SQUOTE] = ACTIONS(906),
    [anon_sym_u8_SQUOTE] = ACTIONS(906),
    [anon_sym_SQUOTE] = ACTIONS(906),
    [anon_sym_L_DQUOTE] = ACTIONS(909),
    [anon_sym_u_DQUOTE] = ACTIONS(909),
    [anon_sym_U_DQUOTE] = ACTIONS(909),
    [anon_sym_u8_DQUOTE] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [anon_sym_NULL] = ACTIONS(915),
    [anon_sym_nullptr] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_declaration] = STATE(50),
    [sym_type_definition] = STATE(50),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(50),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(50),
    [sym_labeled_statement] = STATE(50),
    [sym_expression_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_switch_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_do_statement] = STATE(50),
    [sym_for_statement] = STATE(50),
    [sym_return_statement] = STATE(50),
    [sym_break_statement] = STATE(50),
    [sym_continue_statement] = STATE(50),
    [sym_goto_statement] = STATE(50),
    [sym_seh_try_statement] = STATE(50),
    [sym_seh_leave_statement] = STATE(50),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(50),
    [ts_builtin_sym_end] = ACTIONS(1032),
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_declaration] = STATE(58),
    [sym_type_definition] = STATE(58),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1144),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(58),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(58),
    [sym_labeled_statement] = STATE(58),
    [sym_expression_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_return_statement] = STATE(58),
    [sym_break_statement] = STATE(58),
    [sym_continue_statement] = STATE(58),
    [sym_goto_statement] = STATE(58),
    [sym_seh_try_statement] = STATE(58),
    [sym_seh_leave_statement] = STATE(58),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(58),
    [sym_identifier] = ACTIONS(1034),
    [aux_sym_preproc_include_token1] = ACTIONS(786),
    [aux_sym_preproc_def_token1] = ACTIONS(786),
    [aux_sym_preproc_if_token1] = ACTIONS(786),
    [aux_sym_preproc_if_token2] = ACTIONS(786),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(786),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(786),
    [sym_preproc_directive] = ACTIONS(786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(496),
    [anon_sym_typedef] = ACTIONS(498),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(786),
    [anon_sym___clrcall] = ACTIONS(786),
    [anon_sym___stdcall] = ACTIONS(786),
    [anon_sym___fastcall] = ACTIONS(786),
    [anon_sym___thiscall] = ACTIONS(786),
    [anon_sym___vectorcall] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(786),
    [anon_sym_default] = ACTIONS(786),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1144),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym_seh_try_statement] = STATE(59),
    [sym_seh_leave_statement] = STATE(59),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(59),
    [sym_identifier] = ACTIONS(1034),
    [aux_sym_preproc_include_token1] = ACTIONS(784),
    [aux_sym_preproc_def_token1] = ACTIONS(784),
    [aux_sym_preproc_if_token1] = ACTIONS(784),
    [aux_sym_preproc_if_token2] = ACTIONS(784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(784),
    [sym_preproc_directive] = ACTIONS(784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(496),
    [anon_sym_typedef] = ACTIONS(498),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(784),
    [anon_sym___clrcall] = ACTIONS(784),
    [anon_sym___stdcall] = ACTIONS(784),
    [anon_sym___fastcall] = ACTIONS(784),
    [anon_sym___thiscall] = ACTIONS(784),
    [anon_sym___vectorcall] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_else] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(784),
    [anon_sym_default] = ACTIONS(784),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(1036),
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(786),
    [aux_sym_preproc_def_token1] = ACTIONS(786),
    [aux_sym_preproc_if_token1] = ACTIONS(786),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(786),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(786),
    [sym_preproc_directive] = ACTIONS(786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(786),
    [anon_sym___clrcall] = ACTIONS(786),
    [anon_sym___stdcall] = ACTIONS(786),
    [anon_sym___fastcall] = ACTIONS(786),
    [anon_sym___thiscall] = ACTIONS(786),
    [anon_sym___vectorcall] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(786),
    [anon_sym_default] = ACTIONS(786),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1144),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(61),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym_seh_try_statement] = STATE(61),
    [sym_seh_leave_statement] = STATE(61),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(1034),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token2] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(496),
    [anon_sym_typedef] = ACTIONS(498),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1144),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(61),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym_seh_try_statement] = STATE(61),
    [sym_seh_leave_statement] = STATE(61),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(1034),
    [aux_sym_preproc_include_token1] = ACTIONS(788),
    [aux_sym_preproc_def_token1] = ACTIONS(788),
    [aux_sym_preproc_if_token1] = ACTIONS(788),
    [aux_sym_preproc_if_token2] = ACTIONS(788),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(788),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(788),
    [sym_preproc_directive] = ACTIONS(788),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(496),
    [anon_sym_typedef] = ACTIONS(498),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(788),
    [anon_sym___clrcall] = ACTIONS(788),
    [anon_sym___stdcall] = ACTIONS(788),
    [anon_sym___fastcall] = ACTIONS(788),
    [anon_sym___thiscall] = ACTIONS(788),
    [anon_sym___vectorcall] = ACTIONS(788),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_else] = ACTIONS(788),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(788),
    [anon_sym_default] = ACTIONS(788),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1147),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(53),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_goto_statement] = STATE(53),
    [sym_seh_try_statement] = STATE(53),
    [sym_seh_leave_statement] = STATE(53),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(53),
    [sym_identifier] = ACTIONS(970),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(1032),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1144),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(61),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym_seh_try_statement] = STATE(61),
    [sym_seh_leave_statement] = STATE(61),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(1038),
    [aux_sym_preproc_include_token1] = ACTIONS(793),
    [aux_sym_preproc_def_token1] = ACTIONS(793),
    [aux_sym_preproc_if_token1] = ACTIONS(793),
    [aux_sym_preproc_if_token2] = ACTIONS(793),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(793),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(793),
    [sym_preproc_directive] = ACTIONS(793),
    [anon_sym_LPAREN2] = ACTIONS(795),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_AMP] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(1041),
    [anon_sym___extension__] = ACTIONS(1044),
    [anon_sym_typedef] = ACTIONS(1047),
    [anon_sym_extern] = ACTIONS(816),
    [anon_sym___attribute__] = ACTIONS(819),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(822),
    [anon_sym___declspec] = ACTIONS(825),
    [anon_sym___cdecl] = ACTIONS(793),
    [anon_sym___clrcall] = ACTIONS(793),
    [anon_sym___stdcall] = ACTIONS(793),
    [anon_sym___fastcall] = ACTIONS(793),
    [anon_sym___thiscall] = ACTIONS(793),
    [anon_sym___vectorcall] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_signed] = ACTIONS(831),
    [anon_sym_unsigned] = ACTIONS(831),
    [anon_sym_long] = ACTIONS(831),
    [anon_sym_short] = ACTIONS(831),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_auto] = ACTIONS(816),
    [anon_sym_register] = ACTIONS(816),
    [anon_sym_inline] = ACTIONS(816),
    [anon_sym___inline] = ACTIONS(816),
    [anon_sym___inline__] = ACTIONS(816),
    [anon_sym___forceinline] = ACTIONS(816),
    [anon_sym_thread_local] = ACTIONS(816),
    [anon_sym___thread] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(834),
    [anon_sym_constexpr] = ACTIONS(834),
    [anon_sym_volatile] = ACTIONS(834),
    [anon_sym_restrict] = ACTIONS(834),
    [anon_sym___restrict__] = ACTIONS(834),
    [anon_sym__Atomic] = ACTIONS(834),
    [anon_sym__Noreturn] = ACTIONS(834),
    [anon_sym_noreturn] = ACTIONS(834),
    [anon_sym__Nonnull] = ACTIONS(834),
    [anon_sym_alignas] = ACTIONS(837),
    [anon_sym__Alignas] = ACTIONS(837),
    [sym_primitive_type] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(843),
    [anon_sym_struct] = ACTIONS(846),
    [anon_sym_union] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(793),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_do] = ACTIONS(1062),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1071),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_goto] = ACTIONS(1077),
    [anon_sym___try] = ACTIONS(1080),
    [anon_sym___leave] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_sizeof] = ACTIONS(888),
    [anon_sym___alignof__] = ACTIONS(891),
    [anon_sym___alignof] = ACTIONS(891),
    [anon_sym__alignof] = ACTIONS(891),
    [anon_sym_alignof] = ACTIONS(891),
    [anon_sym__Alignof] = ACTIONS(891),
    [anon_sym_offsetof] = ACTIONS(894),
    [anon_sym__Generic] = ACTIONS(897),
    [anon_sym_asm] = ACTIONS(900),
    [anon_sym___asm__] = ACTIONS(900),
    [anon_sym___asm] = ACTIONS(900),
    [sym_number_literal] = ACTIONS(903),
    [anon_sym_L_SQUOTE] = ACTIONS(906),
    [anon_sym_u_SQUOTE] = ACTIONS(906),
    [anon_sym_U_SQUOTE] = ACTIONS(906),
    [anon_sym_u8_SQUOTE] = ACTIONS(906),
    [anon_sym_SQUOTE] = ACTIONS(906),
    [anon_sym_L_DQUOTE] = ACTIONS(909),
    [anon_sym_u_DQUOTE] = ACTIONS(909),
    [anon_sym_U_DQUOTE] = ACTIONS(909),
    [anon_sym_u8_DQUOTE] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [anon_sym_NULL] = ACTIONS(915),
    [anon_sym_nullptr] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_declaration] = STATE(50),
    [sym_type_definition] = STATE(50),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(50),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(50),
    [sym_labeled_statement] = STATE(50),
    [sym_expression_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_switch_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_do_statement] = STATE(50),
    [sym_for_statement] = STATE(50),
    [sym_return_statement] = STATE(50),
    [sym_break_statement] = STATE(50),
    [sym_continue_statement] = STATE(50),
    [sym_goto_statement] = STATE(50),
    [sym_seh_try_statement] = STATE(50),
    [sym_seh_leave_statement] = STATE(50),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(50),
    [ts_builtin_sym_end] = ACTIONS(972),
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(788),
    [aux_sym_preproc_def_token1] = ACTIONS(788),
    [aux_sym_preproc_if_token1] = ACTIONS(788),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(788),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(788),
    [sym_preproc_directive] = ACTIONS(788),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(788),
    [anon_sym___clrcall] = ACTIONS(788),
    [anon_sym___stdcall] = ACTIONS(788),
    [anon_sym___fastcall] = ACTIONS(788),
    [anon_sym___thiscall] = ACTIONS(788),
    [anon_sym___vectorcall] = ACTIONS(788),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_else] = ACTIONS(788),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(788),
    [anon_sym_default] = ACTIONS(788),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1147),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(60),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(60),
    [sym_labeled_statement] = STATE(60),
    [sym_expression_statement] = STATE(60),
    [sym_if_statement] = STATE(60),
    [sym_switch_statement] = STATE(60),
    [sym_while_statement] = STATE(60),
    [sym_do_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_return_statement] = STATE(60),
    [sym_break_statement] = STATE(60),
    [sym_continue_statement] = STATE(60),
    [sym_goto_statement] = STATE(60),
    [sym_seh_try_statement] = STATE(60),
    [sym_seh_leave_statement] = STATE(60),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(970),
    [aux_sym_preproc_include_token1] = ACTIONS(786),
    [aux_sym_preproc_def_token1] = ACTIONS(786),
    [aux_sym_preproc_if_token1] = ACTIONS(786),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(786),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(786),
    [sym_preproc_directive] = ACTIONS(786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(786),
    [anon_sym___clrcall] = ACTIONS(786),
    [anon_sym___stdcall] = ACTIONS(786),
    [anon_sym___fastcall] = ACTIONS(786),
    [anon_sym___thiscall] = ACTIONS(786),
    [anon_sym___vectorcall] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(786),
    [anon_sym_default] = ACTIONS(786),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_declaration] = STATE(51),
    [sym_type_definition] = STATE(51),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1147),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(51),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(51),
    [sym_labeled_statement] = STATE(51),
    [sym_expression_statement] = STATE(51),
    [sym_if_statement] = STATE(51),
    [sym_switch_statement] = STATE(51),
    [sym_while_statement] = STATE(51),
    [sym_do_statement] = STATE(51),
    [sym_for_statement] = STATE(51),
    [sym_return_statement] = STATE(51),
    [sym_break_statement] = STATE(51),
    [sym_continue_statement] = STATE(51),
    [sym_goto_statement] = STATE(51),
    [sym_seh_try_statement] = STATE(51),
    [sym_seh_leave_statement] = STATE(51),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(51),
    [sym_identifier] = ACTIONS(970),
    [aux_sym_preproc_include_token1] = ACTIONS(784),
    [aux_sym_preproc_def_token1] = ACTIONS(784),
    [aux_sym_preproc_if_token1] = ACTIONS(784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(784),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(784),
    [sym_preproc_directive] = ACTIONS(784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(370),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(784),
    [anon_sym___clrcall] = ACTIONS(784),
    [anon_sym___stdcall] = ACTIONS(784),
    [anon_sym___fastcall] = ACTIONS(784),
    [anon_sym___thiscall] = ACTIONS(784),
    [anon_sym___vectorcall] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_else] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(784),
    [anon_sym_default] = ACTIONS(784),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_declaration] = STATE(244),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(244),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(65),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(65),
    [sym_labeled_statement] = STATE(65),
    [sym_expression_statement] = STATE(65),
    [sym_if_statement] = STATE(65),
    [sym_switch_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_do_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_return_statement] = STATE(65),
    [sym_break_statement] = STATE(65),
    [sym_continue_statement] = STATE(65),
    [sym_goto_statement] = STATE(65),
    [sym_seh_try_statement] = STATE(65),
    [sym_seh_leave_statement] = STATE(65),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(65),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_else] = ACTIONS(788),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(1102),
    [anon_sym_LPAREN2] = ACTIONS(795),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_AMP] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym___extension__] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(931),
    [anon_sym_extern] = ACTIONS(816),
    [anon_sym___attribute__] = ACTIONS(819),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(822),
    [anon_sym___declspec] = ACTIONS(825),
    [anon_sym_LBRACE] = ACTIONS(934),
    [anon_sym_signed] = ACTIONS(831),
    [anon_sym_unsigned] = ACTIONS(831),
    [anon_sym_long] = ACTIONS(831),
    [anon_sym_short] = ACTIONS(831),
    [anon_sym_static] = ACTIONS(816),
    [anon_sym_auto] = ACTIONS(816),
    [anon_sym_register] = ACTIONS(816),
    [anon_sym_inline] = ACTIONS(816),
    [anon_sym___inline] = ACTIONS(816),
    [anon_sym___inline__] = ACTIONS(816),
    [anon_sym___forceinline] = ACTIONS(816),
    [anon_sym_thread_local] = ACTIONS(816),
    [anon_sym___thread] = ACTIONS(816),
    [anon_sym_const] = ACTIONS(834),
    [anon_sym_constexpr] = ACTIONS(834),
    [anon_sym_volatile] = ACTIONS(834),
    [anon_sym_restrict] = ACTIONS(834),
    [anon_sym___restrict__] = ACTIONS(834),
    [anon_sym__Atomic] = ACTIONS(834),
    [anon_sym__Noreturn] = ACTIONS(834),
    [anon_sym_noreturn] = ACTIONS(834),
    [anon_sym__Nonnull] = ACTIONS(834),
    [anon_sym_alignas] = ACTIONS(837),
    [anon_sym__Alignas] = ACTIONS(837),
    [sym_primitive_type] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(843),
    [anon_sym_struct] = ACTIONS(846),
    [anon_sym_union] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(793),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_while] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(1111),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(955),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_goto] = ACTIONS(961),
    [anon_sym___try] = ACTIONS(1114),
    [anon_sym___leave] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_sizeof] = ACTIONS(888),
    [anon_sym___alignof__] = ACTIONS(891),
    [anon_sym___alignof] = ACTIONS(891),
    [anon_sym__alignof] = ACTIONS(891),
    [anon_sym_alignof] = ACTIONS(891),
    [anon_sym__Alignof] = ACTIONS(891),
    [anon_sym_offsetof] = ACTIONS(894),
    [anon_sym__Generic] = ACTIONS(897),
    [anon_sym_asm] = ACTIONS(900),
    [anon_sym___asm__] = ACTIONS(900),
    [anon_sym___asm] = ACTIONS(900),
    [sym_number_literal] = ACTIONS(903),
    [anon_sym_L_SQUOTE] = ACTIONS(906),
    [anon_sym_u_SQUOTE] = ACTIONS(906),
    [anon_sym_U_SQUOTE] = ACTIONS(906),
    [anon_sym_u8_SQUOTE] = ACTIONS(906),
    [anon_sym_SQUOTE] = ACTIONS(906),
    [anon_sym_L_DQUOTE] = ACTIONS(909),
    [anon_sym_u_DQUOTE] = ACTIONS(909),
    [anon_sym_U_DQUOTE] = ACTIONS(909),
    [anon_sym_u8_DQUOTE] = ACTIONS(909),
    [anon_sym_DQUOTE] = ACTIONS(909),
    [sym_true] = ACTIONS(912),
    [sym_false] = ACTIONS(912),
    [anon_sym_NULL] = ACTIONS(915),
    [anon_sym_nullptr] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(68),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(68),
    [sym_labeled_statement] = STATE(68),
    [sym_expression_statement] = STATE(68),
    [sym_if_statement] = STATE(68),
    [sym_switch_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_do_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_return_statement] = STATE(68),
    [sym_break_statement] = STATE(68),
    [sym_continue_statement] = STATE(68),
    [sym_goto_statement] = STATE(68),
    [sym_seh_try_statement] = STATE(68),
    [sym_seh_leave_statement] = STATE(68),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [aux_sym_case_statement_repeat1] = STATE(68),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_else] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_declaration] = STATE(218),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1144),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(204),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(204),
    [sym_statement] = STATE(218),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1034),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_declaration] = STATE(187),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1147),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(177),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(187),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(970),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_declaration] = STATE(118),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1143),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(84),
    [sym_statement] = STATE(118),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(782),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_declaration] = STATE(244),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1139),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(406),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_compound_statement] = STATE(171),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_attributed_statement] = STATE(171),
    [sym_statement] = STATE(244),
    [sym_labeled_statement] = STATE(171),
    [sym_expression_statement] = STATE(171),
    [sym_if_statement] = STATE(171),
    [sym_switch_statement] = STATE(171),
    [sym_case_statement] = STATE(171),
    [sym_while_statement] = STATE(171),
    [sym_do_statement] = STATE(171),
    [sym_for_statement] = STATE(171),
    [sym_return_statement] = STATE(171),
    [sym_break_statement] = STATE(171),
    [sym_continue_statement] = STATE(171),
    [sym_goto_statement] = STATE(171),
    [sym_seh_try_statement] = STATE(171),
    [sym_seh_leave_statement] = STATE(171),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(976),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_declaration] = STATE(466),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1136),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__for_statement_body] = STATE(1938),
    [sym_expression] = STATE(1051),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1828),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_declaration] = STATE(466),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1136),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__for_statement_body] = STATE(1953),
    [sym_expression] = STATE(1051),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1828),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_declaration] = STATE(466),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1136),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__for_statement_body] = STATE(1949),
    [sym_expression] = STATE(1051),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1828),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_declaration] = STATE(466),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1136),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__for_statement_body] = STATE(1860),
    [sym_expression] = STATE(1051),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1828),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_declaration] = STATE(466),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1136),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__for_statement_body] = STATE(1923),
    [sym_expression] = STATE(1051),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1828),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_else_clause] = STATE(81),
    [sym_identifier] = ACTIONS(1123),
    [aux_sym_preproc_include_token1] = ACTIONS(1123),
    [aux_sym_preproc_def_token1] = ACTIONS(1123),
    [aux_sym_preproc_if_token1] = ACTIONS(1123),
    [aux_sym_preproc_if_token2] = ACTIONS(1123),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1123),
    [aux_sym_preproc_else_token1] = ACTIONS(1123),
    [aux_sym_preproc_elif_token1] = ACTIONS(1123),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1123),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1123),
    [sym_preproc_directive] = ACTIONS(1123),
    [anon_sym_LPAREN2] = ACTIONS(1125),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym___extension__] = ACTIONS(1123),
    [anon_sym_typedef] = ACTIONS(1123),
    [anon_sym_extern] = ACTIONS(1123),
    [anon_sym___attribute__] = ACTIONS(1123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1125),
    [anon_sym___declspec] = ACTIONS(1123),
    [anon_sym___cdecl] = ACTIONS(1123),
    [anon_sym___clrcall] = ACTIONS(1123),
    [anon_sym___stdcall] = ACTIONS(1123),
    [anon_sym___fastcall] = ACTIONS(1123),
    [anon_sym___thiscall] = ACTIONS(1123),
    [anon_sym___vectorcall] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_signed] = ACTIONS(1123),
    [anon_sym_unsigned] = ACTIONS(1123),
    [anon_sym_long] = ACTIONS(1123),
    [anon_sym_short] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_auto] = ACTIONS(1123),
    [anon_sym_register] = ACTIONS(1123),
    [anon_sym_inline] = ACTIONS(1123),
    [anon_sym___inline] = ACTIONS(1123),
    [anon_sym___inline__] = ACTIONS(1123),
    [anon_sym___forceinline] = ACTIONS(1123),
    [anon_sym_thread_local] = ACTIONS(1123),
    [anon_sym___thread] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_constexpr] = ACTIONS(1123),
    [anon_sym_volatile] = ACTIONS(1123),
    [anon_sym_restrict] = ACTIONS(1123),
    [anon_sym___restrict__] = ACTIONS(1123),
    [anon_sym__Atomic] = ACTIONS(1123),
    [anon_sym__Noreturn] = ACTIONS(1123),
    [anon_sym_noreturn] = ACTIONS(1123),
    [anon_sym__Nonnull] = ACTIONS(1123),
    [anon_sym_alignas] = ACTIONS(1123),
    [anon_sym__Alignas] = ACTIONS(1123),
    [sym_primitive_type] = ACTIONS(1123),
    [anon_sym_enum] = ACTIONS(1123),
    [anon_sym_struct] = ACTIONS(1123),
    [anon_sym_union] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_else] = ACTIONS(1127),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1123),
    [anon_sym_default] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_do] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_goto] = ACTIONS(1123),
    [anon_sym___try] = ACTIONS(1123),
    [anon_sym___leave] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_sizeof] = ACTIONS(1123),
    [anon_sym___alignof__] = ACTIONS(1123),
    [anon_sym___alignof] = ACTIONS(1123),
    [anon_sym__alignof] = ACTIONS(1123),
    [anon_sym_alignof] = ACTIONS(1123),
    [anon_sym__Alignof] = ACTIONS(1123),
    [anon_sym_offsetof] = ACTIONS(1123),
    [anon_sym__Generic] = ACTIONS(1123),
    [anon_sym_asm] = ACTIONS(1123),
    [anon_sym___asm__] = ACTIONS(1123),
    [anon_sym___asm] = ACTIONS(1123),
    [sym_number_literal] = ACTIONS(1125),
    [anon_sym_L_SQUOTE] = ACTIONS(1125),
    [anon_sym_u_SQUOTE] = ACTIONS(1125),
    [anon_sym_U_SQUOTE] = ACTIONS(1125),
    [anon_sym_u8_SQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [anon_sym_L_DQUOTE] = ACTIONS(1125),
    [anon_sym_u_DQUOTE] = ACTIONS(1125),
    [anon_sym_U_DQUOTE] = ACTIONS(1125),
    [anon_sym_u8_DQUOTE] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [anon_sym_NULL] = ACTIONS(1123),
    [anon_sym_nullptr] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_identifier] = ACTIONS(1129),
    [aux_sym_preproc_include_token1] = ACTIONS(1129),
    [aux_sym_preproc_def_token1] = ACTIONS(1129),
    [aux_sym_preproc_if_token1] = ACTIONS(1129),
    [aux_sym_preproc_if_token2] = ACTIONS(1129),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1129),
    [aux_sym_preproc_else_token1] = ACTIONS(1129),
    [aux_sym_preproc_elif_token1] = ACTIONS(1129),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1129),
    [sym_preproc_directive] = ACTIONS(1129),
    [anon_sym_LPAREN2] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym___extension__] = ACTIONS(1129),
    [anon_sym_typedef] = ACTIONS(1129),
    [anon_sym_extern] = ACTIONS(1129),
    [anon_sym___attribute__] = ACTIONS(1129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1131),
    [anon_sym___declspec] = ACTIONS(1129),
    [anon_sym___cdecl] = ACTIONS(1129),
    [anon_sym___clrcall] = ACTIONS(1129),
    [anon_sym___stdcall] = ACTIONS(1129),
    [anon_sym___fastcall] = ACTIONS(1129),
    [anon_sym___thiscall] = ACTIONS(1129),
    [anon_sym___vectorcall] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_signed] = ACTIONS(1129),
    [anon_sym_unsigned] = ACTIONS(1129),
    [anon_sym_long] = ACTIONS(1129),
    [anon_sym_short] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(1129),
    [anon_sym_auto] = ACTIONS(1129),
    [anon_sym_register] = ACTIONS(1129),
    [anon_sym_inline] = ACTIONS(1129),
    [anon_sym___inline] = ACTIONS(1129),
    [anon_sym___inline__] = ACTIONS(1129),
    [anon_sym___forceinline] = ACTIONS(1129),
    [anon_sym_thread_local] = ACTIONS(1129),
    [anon_sym___thread] = ACTIONS(1129),
    [anon_sym_const] = ACTIONS(1129),
    [anon_sym_constexpr] = ACTIONS(1129),
    [anon_sym_volatile] = ACTIONS(1129),
    [anon_sym_restrict] = ACTIONS(1129),
    [anon_sym___restrict__] = ACTIONS(1129),
    [anon_sym__Atomic] = ACTIONS(1129),
    [anon_sym__Noreturn] = ACTIONS(1129),
    [anon_sym_noreturn] = ACTIONS(1129),
    [anon_sym__Nonnull] = ACTIONS(1129),
    [anon_sym_alignas] = ACTIONS(1129),
    [anon_sym__Alignas] = ACTIONS(1129),
    [sym_primitive_type] = ACTIONS(1129),
    [anon_sym_enum] = ACTIONS(1129),
    [anon_sym_struct] = ACTIONS(1129),
    [anon_sym_union] = ACTIONS(1129),
    [anon_sym_if] = ACTIONS(1129),
    [anon_sym_else] = ACTIONS(1129),
    [anon_sym_switch] = ACTIONS(1129),
    [anon_sym_case] = ACTIONS(1129),
    [anon_sym_default] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1129),
    [anon_sym_for] = ACTIONS(1129),
    [anon_sym_return] = ACTIONS(1129),
    [anon_sym_break] = ACTIONS(1129),
    [anon_sym_continue] = ACTIONS(1129),
    [anon_sym_goto] = ACTIONS(1129),
    [anon_sym___try] = ACTIONS(1129),
    [anon_sym___leave] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_sizeof] = ACTIONS(1129),
    [anon_sym___alignof__] = ACTIONS(1129),
    [anon_sym___alignof] = ACTIONS(1129),
    [anon_sym__alignof] = ACTIONS(1129),
    [anon_sym_alignof] = ACTIONS(1129),
    [anon_sym__Alignof] = ACTIONS(1129),
    [anon_sym_offsetof] = ACTIONS(1129),
    [anon_sym__Generic] = ACTIONS(1129),
    [anon_sym_asm] = ACTIONS(1129),
    [anon_sym___asm__] = ACTIONS(1129),
    [anon_sym___asm] = ACTIONS(1129),
    [sym_number_literal] = ACTIONS(1131),
    [anon_sym_L_SQUOTE] = ACTIONS(1131),
    [anon_sym_u_SQUOTE] = ACTIONS(1131),
    [anon_sym_U_SQUOTE] = ACTIONS(1131),
    [anon_sym_u8_SQUOTE] = ACTIONS(1131),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [anon_sym_L_DQUOTE] = ACTIONS(1131),
    [anon_sym_u_DQUOTE] = ACTIONS(1131),
    [anon_sym_U_DQUOTE] = ACTIONS(1131),
    [anon_sym_u8_DQUOTE] = ACTIONS(1131),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_true] = ACTIONS(1129),
    [sym_false] = ACTIONS(1129),
    [anon_sym_NULL] = ACTIONS(1129),
    [anon_sym_nullptr] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_identifier] = ACTIONS(1133),
    [aux_sym_preproc_include_token1] = ACTIONS(1133),
    [aux_sym_preproc_def_token1] = ACTIONS(1133),
    [aux_sym_preproc_if_token1] = ACTIONS(1133),
    [aux_sym_preproc_if_token2] = ACTIONS(1133),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1133),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1133),
    [aux_sym_preproc_else_token1] = ACTIONS(1133),
    [aux_sym_preproc_elif_token1] = ACTIONS(1133),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1133),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1133),
    [sym_preproc_directive] = ACTIONS(1133),
    [anon_sym_LPAREN2] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym___extension__] = ACTIONS(1133),
    [anon_sym_typedef] = ACTIONS(1133),
    [anon_sym_extern] = ACTIONS(1133),
    [anon_sym___attribute__] = ACTIONS(1133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1135),
    [anon_sym___declspec] = ACTIONS(1133),
    [anon_sym___cdecl] = ACTIONS(1133),
    [anon_sym___clrcall] = ACTIONS(1133),
    [anon_sym___stdcall] = ACTIONS(1133),
    [anon_sym___fastcall] = ACTIONS(1133),
    [anon_sym___thiscall] = ACTIONS(1133),
    [anon_sym___vectorcall] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_signed] = ACTIONS(1133),
    [anon_sym_unsigned] = ACTIONS(1133),
    [anon_sym_long] = ACTIONS(1133),
    [anon_sym_short] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1133),
    [anon_sym_auto] = ACTIONS(1133),
    [anon_sym_register] = ACTIONS(1133),
    [anon_sym_inline] = ACTIONS(1133),
    [anon_sym___inline] = ACTIONS(1133),
    [anon_sym___inline__] = ACTIONS(1133),
    [anon_sym___forceinline] = ACTIONS(1133),
    [anon_sym_thread_local] = ACTIONS(1133),
    [anon_sym___thread] = ACTIONS(1133),
    [anon_sym_const] = ACTIONS(1133),
    [anon_sym_constexpr] = ACTIONS(1133),
    [anon_sym_volatile] = ACTIONS(1133),
    [anon_sym_restrict] = ACTIONS(1133),
    [anon_sym___restrict__] = ACTIONS(1133),
    [anon_sym__Atomic] = ACTIONS(1133),
    [anon_sym__Noreturn] = ACTIONS(1133),
    [anon_sym_noreturn] = ACTIONS(1133),
    [anon_sym__Nonnull] = ACTIONS(1133),
    [anon_sym_alignas] = ACTIONS(1133),
    [anon_sym__Alignas] = ACTIONS(1133),
    [sym_primitive_type] = ACTIONS(1133),
    [anon_sym_enum] = ACTIONS(1133),
    [anon_sym_struct] = ACTIONS(1133),
    [anon_sym_union] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_else] = ACTIONS(1133),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1133),
    [anon_sym_default] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_do] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1133),
    [anon_sym_break] = ACTIONS(1133),
    [anon_sym_continue] = ACTIONS(1133),
    [anon_sym_goto] = ACTIONS(1133),
    [anon_sym___try] = ACTIONS(1133),
    [anon_sym___leave] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_sizeof] = ACTIONS(1133),
    [anon_sym___alignof__] = ACTIONS(1133),
    [anon_sym___alignof] = ACTIONS(1133),
    [anon_sym__alignof] = ACTIONS(1133),
    [anon_sym_alignof] = ACTIONS(1133),
    [anon_sym__Alignof] = ACTIONS(1133),
    [anon_sym_offsetof] = ACTIONS(1133),
    [anon_sym__Generic] = ACTIONS(1133),
    [anon_sym_asm] = ACTIONS(1133),
    [anon_sym___asm__] = ACTIONS(1133),
    [anon_sym___asm] = ACTIONS(1133),
    [sym_number_literal] = ACTIONS(1135),
    [anon_sym_L_SQUOTE] = ACTIONS(1135),
    [anon_sym_u_SQUOTE] = ACTIONS(1135),
    [anon_sym_U_SQUOTE] = ACTIONS(1135),
    [anon_sym_u8_SQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_L_DQUOTE] = ACTIONS(1135),
    [anon_sym_u_DQUOTE] = ACTIONS(1135),
    [anon_sym_U_DQUOTE] = ACTIONS(1135),
    [anon_sym_u8_DQUOTE] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [sym_true] = ACTIONS(1133),
    [sym_false] = ACTIONS(1133),
    [anon_sym_NULL] = ACTIONS(1133),
    [anon_sym_nullptr] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_identifier] = ACTIONS(1137),
    [aux_sym_preproc_include_token1] = ACTIONS(1137),
    [aux_sym_preproc_def_token1] = ACTIONS(1137),
    [aux_sym_preproc_if_token1] = ACTIONS(1137),
    [aux_sym_preproc_if_token2] = ACTIONS(1137),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1137),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1137),
    [aux_sym_preproc_else_token1] = ACTIONS(1137),
    [aux_sym_preproc_elif_token1] = ACTIONS(1137),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1137),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1137),
    [sym_preproc_directive] = ACTIONS(1137),
    [anon_sym_LPAREN2] = ACTIONS(1139),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym___extension__] = ACTIONS(1137),
    [anon_sym_typedef] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(1137),
    [anon_sym___attribute__] = ACTIONS(1137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1139),
    [anon_sym___declspec] = ACTIONS(1137),
    [anon_sym___cdecl] = ACTIONS(1137),
    [anon_sym___clrcall] = ACTIONS(1137),
    [anon_sym___stdcall] = ACTIONS(1137),
    [anon_sym___fastcall] = ACTIONS(1137),
    [anon_sym___thiscall] = ACTIONS(1137),
    [anon_sym___vectorcall] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_signed] = ACTIONS(1137),
    [anon_sym_unsigned] = ACTIONS(1137),
    [anon_sym_long] = ACTIONS(1137),
    [anon_sym_short] = ACTIONS(1137),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_auto] = ACTIONS(1137),
    [anon_sym_register] = ACTIONS(1137),
    [anon_sym_inline] = ACTIONS(1137),
    [anon_sym___inline] = ACTIONS(1137),
    [anon_sym___inline__] = ACTIONS(1137),
    [anon_sym___forceinline] = ACTIONS(1137),
    [anon_sym_thread_local] = ACTIONS(1137),
    [anon_sym___thread] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_constexpr] = ACTIONS(1137),
    [anon_sym_volatile] = ACTIONS(1137),
    [anon_sym_restrict] = ACTIONS(1137),
    [anon_sym___restrict__] = ACTIONS(1137),
    [anon_sym__Atomic] = ACTIONS(1137),
    [anon_sym__Noreturn] = ACTIONS(1137),
    [anon_sym_noreturn] = ACTIONS(1137),
    [anon_sym__Nonnull] = ACTIONS(1137),
    [anon_sym_alignas] = ACTIONS(1137),
    [anon_sym__Alignas] = ACTIONS(1137),
    [sym_primitive_type] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1137),
    [anon_sym_union] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_goto] = ACTIONS(1137),
    [anon_sym___try] = ACTIONS(1137),
    [anon_sym___leave] = ACTIONS(1137),
    [anon_sym_DASH_DASH] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(1139),
    [anon_sym_sizeof] = ACTIONS(1137),
    [anon_sym___alignof__] = ACTIONS(1137),
    [anon_sym___alignof] = ACTIONS(1137),
    [anon_sym__alignof] = ACTIONS(1137),
    [anon_sym_alignof] = ACTIONS(1137),
    [anon_sym__Alignof] = ACTIONS(1137),
    [anon_sym_offsetof] = ACTIONS(1137),
    [anon_sym__Generic] = ACTIONS(1137),
    [anon_sym_asm] = ACTIONS(1137),
    [anon_sym___asm__] = ACTIONS(1137),
    [anon_sym___asm] = ACTIONS(1137),
    [sym_number_literal] = ACTIONS(1139),
    [anon_sym_L_SQUOTE] = ACTIONS(1139),
    [anon_sym_u_SQUOTE] = ACTIONS(1139),
    [anon_sym_U_SQUOTE] = ACTIONS(1139),
    [anon_sym_u8_SQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [anon_sym_L_DQUOTE] = ACTIONS(1139),
    [anon_sym_u_DQUOTE] = ACTIONS(1139),
    [anon_sym_U_DQUOTE] = ACTIONS(1139),
    [anon_sym_u8_DQUOTE] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [anon_sym_NULL] = ACTIONS(1137),
    [anon_sym_nullptr] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_identifier] = ACTIONS(1141),
    [aux_sym_preproc_include_token1] = ACTIONS(1141),
    [aux_sym_preproc_def_token1] = ACTIONS(1141),
    [aux_sym_preproc_if_token1] = ACTIONS(1141),
    [aux_sym_preproc_if_token2] = ACTIONS(1141),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1141),
    [aux_sym_preproc_else_token1] = ACTIONS(1141),
    [aux_sym_preproc_elif_token1] = ACTIONS(1141),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1141),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1141),
    [sym_preproc_directive] = ACTIONS(1141),
    [anon_sym_LPAREN2] = ACTIONS(1143),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1143),
    [anon_sym___extension__] = ACTIONS(1141),
    [anon_sym_typedef] = ACTIONS(1141),
    [anon_sym_extern] = ACTIONS(1141),
    [anon_sym___attribute__] = ACTIONS(1141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1143),
    [anon_sym___declspec] = ACTIONS(1141),
    [anon_sym___cdecl] = ACTIONS(1141),
    [anon_sym___clrcall] = ACTIONS(1141),
    [anon_sym___stdcall] = ACTIONS(1141),
    [anon_sym___fastcall] = ACTIONS(1141),
    [anon_sym___thiscall] = ACTIONS(1141),
    [anon_sym___vectorcall] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1143),
    [anon_sym_signed] = ACTIONS(1141),
    [anon_sym_unsigned] = ACTIONS(1141),
    [anon_sym_long] = ACTIONS(1141),
    [anon_sym_short] = ACTIONS(1141),
    [anon_sym_static] = ACTIONS(1141),
    [anon_sym_auto] = ACTIONS(1141),
    [anon_sym_register] = ACTIONS(1141),
    [anon_sym_inline] = ACTIONS(1141),
    [anon_sym___inline] = ACTIONS(1141),
    [anon_sym___inline__] = ACTIONS(1141),
    [anon_sym___forceinline] = ACTIONS(1141),
    [anon_sym_thread_local] = ACTIONS(1141),
    [anon_sym___thread] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_constexpr] = ACTIONS(1141),
    [anon_sym_volatile] = ACTIONS(1141),
    [anon_sym_restrict] = ACTIONS(1141),
    [anon_sym___restrict__] = ACTIONS(1141),
    [anon_sym__Atomic] = ACTIONS(1141),
    [anon_sym__Noreturn] = ACTIONS(1141),
    [anon_sym_noreturn] = ACTIONS(1141),
    [anon_sym__Nonnull] = ACTIONS(1141),
    [anon_sym_alignas] = ACTIONS(1141),
    [anon_sym__Alignas] = ACTIONS(1141),
    [sym_primitive_type] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [anon_sym_struct] = ACTIONS(1141),
    [anon_sym_union] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_else] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_case] = ACTIONS(1141),
    [anon_sym_default] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_do] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1141),
    [anon_sym___leave] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1141),
    [anon_sym___alignof__] = ACTIONS(1141),
    [anon_sym___alignof] = ACTIONS(1141),
    [anon_sym__alignof] = ACTIONS(1141),
    [anon_sym_alignof] = ACTIONS(1141),
    [anon_sym__Alignof] = ACTIONS(1141),
    [anon_sym_offsetof] = ACTIONS(1141),
    [anon_sym__Generic] = ACTIONS(1141),
    [anon_sym_asm] = ACTIONS(1141),
    [anon_sym___asm__] = ACTIONS(1141),
    [anon_sym___asm] = ACTIONS(1141),
    [sym_number_literal] = ACTIONS(1143),
    [anon_sym_L_SQUOTE] = ACTIONS(1143),
    [anon_sym_u_SQUOTE] = ACTIONS(1143),
    [anon_sym_U_SQUOTE] = ACTIONS(1143),
    [anon_sym_u8_SQUOTE] = ACTIONS(1143),
    [anon_sym_SQUOTE] = ACTIONS(1143),
    [anon_sym_L_DQUOTE] = ACTIONS(1143),
    [anon_sym_u_DQUOTE] = ACTIONS(1143),
    [anon_sym_U_DQUOTE] = ACTIONS(1143),
    [anon_sym_u8_DQUOTE] = ACTIONS(1143),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [sym_true] = ACTIONS(1141),
    [sym_false] = ACTIONS(1141),
    [anon_sym_NULL] = ACTIONS(1141),
    [anon_sym_nullptr] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(1139),
    [sym_identifier] = ACTIONS(1137),
    [aux_sym_preproc_include_token1] = ACTIONS(1137),
    [aux_sym_preproc_def_token1] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1139),
    [anon_sym_RPAREN] = ACTIONS(1139),
    [aux_sym_preproc_if_token1] = ACTIONS(1137),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1137),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1137),
    [sym_preproc_directive] = ACTIONS(1137),
    [anon_sym_LPAREN2] = ACTIONS(1139),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym___extension__] = ACTIONS(1137),
    [anon_sym_typedef] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(1137),
    [anon_sym___attribute__] = ACTIONS(1137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1139),
    [anon_sym___declspec] = ACTIONS(1137),
    [anon_sym___cdecl] = ACTIONS(1137),
    [anon_sym___clrcall] = ACTIONS(1137),
    [anon_sym___stdcall] = ACTIONS(1137),
    [anon_sym___fastcall] = ACTIONS(1137),
    [anon_sym___thiscall] = ACTIONS(1137),
    [anon_sym___vectorcall] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_signed] = ACTIONS(1137),
    [anon_sym_unsigned] = ACTIONS(1137),
    [anon_sym_long] = ACTIONS(1137),
    [anon_sym_short] = ACTIONS(1137),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_auto] = ACTIONS(1137),
    [anon_sym_register] = ACTIONS(1137),
    [anon_sym_inline] = ACTIONS(1137),
    [anon_sym___inline] = ACTIONS(1137),
    [anon_sym___inline__] = ACTIONS(1137),
    [anon_sym___forceinline] = ACTIONS(1137),
    [anon_sym_thread_local] = ACTIONS(1137),
    [anon_sym___thread] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_constexpr] = ACTIONS(1137),
    [anon_sym_volatile] = ACTIONS(1137),
    [anon_sym_restrict] = ACTIONS(1137),
    [anon_sym___restrict__] = ACTIONS(1137),
    [anon_sym__Atomic] = ACTIONS(1137),
    [anon_sym__Noreturn] = ACTIONS(1137),
    [anon_sym_noreturn] = ACTIONS(1137),
    [anon_sym__Nonnull] = ACTIONS(1137),
    [anon_sym_alignas] = ACTIONS(1137),
    [anon_sym__Alignas] = ACTIONS(1137),
    [sym_primitive_type] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1137),
    [anon_sym_union] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_goto] = ACTIONS(1137),
    [anon_sym___try] = ACTIONS(1137),
    [anon_sym___except] = ACTIONS(1137),
    [anon_sym___finally] = ACTIONS(1137),
    [anon_sym___leave] = ACTIONS(1137),
    [anon_sym_DASH_DASH] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(1139),
    [anon_sym_sizeof] = ACTIONS(1137),
    [anon_sym___alignof__] = ACTIONS(1137),
    [anon_sym___alignof] = ACTIONS(1137),
    [anon_sym__alignof] = ACTIONS(1137),
    [anon_sym_alignof] = ACTIONS(1137),
    [anon_sym__Alignof] = ACTIONS(1137),
    [anon_sym_offsetof] = ACTIONS(1137),
    [anon_sym__Generic] = ACTIONS(1137),
    [anon_sym_asm] = ACTIONS(1137),
    [anon_sym___asm__] = ACTIONS(1137),
    [anon_sym___asm] = ACTIONS(1137),
    [sym_number_literal] = ACTIONS(1139),
    [anon_sym_L_SQUOTE] = ACTIONS(1139),
    [anon_sym_u_SQUOTE] = ACTIONS(1139),
    [anon_sym_U_SQUOTE] = ACTIONS(1139),
    [anon_sym_u8_SQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [anon_sym_L_DQUOTE] = ACTIONS(1139),
    [anon_sym_u_DQUOTE] = ACTIONS(1139),
    [anon_sym_U_DQUOTE] = ACTIONS(1139),
    [anon_sym_u8_DQUOTE] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [anon_sym_NULL] = ACTIONS(1137),
    [anon_sym_nullptr] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_identifier] = ACTIONS(1145),
    [aux_sym_preproc_include_token1] = ACTIONS(1145),
    [aux_sym_preproc_def_token1] = ACTIONS(1145),
    [aux_sym_preproc_if_token1] = ACTIONS(1145),
    [aux_sym_preproc_if_token2] = ACTIONS(1145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1145),
    [aux_sym_preproc_else_token1] = ACTIONS(1145),
    [aux_sym_preproc_elif_token1] = ACTIONS(1145),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1145),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1145),
    [sym_preproc_directive] = ACTIONS(1145),
    [anon_sym_LPAREN2] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym___extension__] = ACTIONS(1145),
    [anon_sym_typedef] = ACTIONS(1145),
    [anon_sym_extern] = ACTIONS(1145),
    [anon_sym___attribute__] = ACTIONS(1145),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1147),
    [anon_sym___declspec] = ACTIONS(1145),
    [anon_sym___cdecl] = ACTIONS(1145),
    [anon_sym___clrcall] = ACTIONS(1145),
    [anon_sym___stdcall] = ACTIONS(1145),
    [anon_sym___fastcall] = ACTIONS(1145),
    [anon_sym___thiscall] = ACTIONS(1145),
    [anon_sym___vectorcall] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [anon_sym_signed] = ACTIONS(1145),
    [anon_sym_unsigned] = ACTIONS(1145),
    [anon_sym_long] = ACTIONS(1145),
    [anon_sym_short] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1145),
    [anon_sym_auto] = ACTIONS(1145),
    [anon_sym_register] = ACTIONS(1145),
    [anon_sym_inline] = ACTIONS(1145),
    [anon_sym___inline] = ACTIONS(1145),
    [anon_sym___inline__] = ACTIONS(1145),
    [anon_sym___forceinline] = ACTIONS(1145),
    [anon_sym_thread_local] = ACTIONS(1145),
    [anon_sym___thread] = ACTIONS(1145),
    [anon_sym_const] = ACTIONS(1145),
    [anon_sym_constexpr] = ACTIONS(1145),
    [anon_sym_volatile] = ACTIONS(1145),
    [anon_sym_restrict] = ACTIONS(1145),
    [anon_sym___restrict__] = ACTIONS(1145),
    [anon_sym__Atomic] = ACTIONS(1145),
    [anon_sym__Noreturn] = ACTIONS(1145),
    [anon_sym_noreturn] = ACTIONS(1145),
    [anon_sym__Nonnull] = ACTIONS(1145),
    [anon_sym_alignas] = ACTIONS(1145),
    [anon_sym__Alignas] = ACTIONS(1145),
    [sym_primitive_type] = ACTIONS(1145),
    [anon_sym_enum] = ACTIONS(1145),
    [anon_sym_struct] = ACTIONS(1145),
    [anon_sym_union] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_else] = ACTIONS(1145),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1145),
    [anon_sym_default] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_do] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1145),
    [anon_sym_break] = ACTIONS(1145),
    [anon_sym_continue] = ACTIONS(1145),
    [anon_sym_goto] = ACTIONS(1145),
    [anon_sym___try] = ACTIONS(1145),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1145),
    [anon_sym___alignof__] = ACTIONS(1145),
    [anon_sym___alignof] = ACTIONS(1145),
    [anon_sym__alignof] = ACTIONS(1145),
    [anon_sym_alignof] = ACTIONS(1145),
    [anon_sym__Alignof] = ACTIONS(1145),
    [anon_sym_offsetof] = ACTIONS(1145),
    [anon_sym__Generic] = ACTIONS(1145),
    [anon_sym_asm] = ACTIONS(1145),
    [anon_sym___asm__] = ACTIONS(1145),
    [anon_sym___asm] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1147),
    [anon_sym_L_SQUOTE] = ACTIONS(1147),
    [anon_sym_u_SQUOTE] = ACTIONS(1147),
    [anon_sym_U_SQUOTE] = ACTIONS(1147),
    [anon_sym_u8_SQUOTE] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_L_DQUOTE] = ACTIONS(1147),
    [anon_sym_u_DQUOTE] = ACTIONS(1147),
    [anon_sym_U_DQUOTE] = ACTIONS(1147),
    [anon_sym_u8_DQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [anon_sym_NULL] = ACTIONS(1145),
    [anon_sym_nullptr] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_identifier] = ACTIONS(1149),
    [aux_sym_preproc_include_token1] = ACTIONS(1149),
    [aux_sym_preproc_def_token1] = ACTIONS(1149),
    [aux_sym_preproc_if_token1] = ACTIONS(1149),
    [aux_sym_preproc_if_token2] = ACTIONS(1149),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1149),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1149),
    [aux_sym_preproc_else_token1] = ACTIONS(1149),
    [aux_sym_preproc_elif_token1] = ACTIONS(1149),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1149),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1149),
    [sym_preproc_directive] = ACTIONS(1149),
    [anon_sym_LPAREN2] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym___extension__] = ACTIONS(1149),
    [anon_sym_typedef] = ACTIONS(1149),
    [anon_sym_extern] = ACTIONS(1149),
    [anon_sym___attribute__] = ACTIONS(1149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1151),
    [anon_sym___declspec] = ACTIONS(1149),
    [anon_sym___cdecl] = ACTIONS(1149),
    [anon_sym___clrcall] = ACTIONS(1149),
    [anon_sym___stdcall] = ACTIONS(1149),
    [anon_sym___fastcall] = ACTIONS(1149),
    [anon_sym___thiscall] = ACTIONS(1149),
    [anon_sym___vectorcall] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_signed] = ACTIONS(1149),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1149),
    [anon_sym_auto] = ACTIONS(1149),
    [anon_sym_register] = ACTIONS(1149),
    [anon_sym_inline] = ACTIONS(1149),
    [anon_sym___inline] = ACTIONS(1149),
    [anon_sym___inline__] = ACTIONS(1149),
    [anon_sym___forceinline] = ACTIONS(1149),
    [anon_sym_thread_local] = ACTIONS(1149),
    [anon_sym___thread] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_constexpr] = ACTIONS(1149),
    [anon_sym_volatile] = ACTIONS(1149),
    [anon_sym_restrict] = ACTIONS(1149),
    [anon_sym___restrict__] = ACTIONS(1149),
    [anon_sym__Atomic] = ACTIONS(1149),
    [anon_sym__Noreturn] = ACTIONS(1149),
    [anon_sym_noreturn] = ACTIONS(1149),
    [anon_sym__Nonnull] = ACTIONS(1149),
    [anon_sym_alignas] = ACTIONS(1149),
    [anon_sym__Alignas] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(1149),
    [anon_sym_enum] = ACTIONS(1149),
    [anon_sym_struct] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_else] = ACTIONS(1149),
    [anon_sym_switch] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1149),
    [anon_sym_default] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_do] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_goto] = ACTIONS(1149),
    [anon_sym___try] = ACTIONS(1149),
    [anon_sym___leave] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_sizeof] = ACTIONS(1149),
    [anon_sym___alignof__] = ACTIONS(1149),
    [anon_sym___alignof] = ACTIONS(1149),
    [anon_sym__alignof] = ACTIONS(1149),
    [anon_sym_alignof] = ACTIONS(1149),
    [anon_sym__Alignof] = ACTIONS(1149),
    [anon_sym_offsetof] = ACTIONS(1149),
    [anon_sym__Generic] = ACTIONS(1149),
    [anon_sym_asm] = ACTIONS(1149),
    [anon_sym___asm__] = ACTIONS(1149),
    [anon_sym___asm] = ACTIONS(1149),
    [sym_number_literal] = ACTIONS(1151),
    [anon_sym_L_SQUOTE] = ACTIONS(1151),
    [anon_sym_u_SQUOTE] = ACTIONS(1151),
    [anon_sym_U_SQUOTE] = ACTIONS(1151),
    [anon_sym_u8_SQUOTE] = ACTIONS(1151),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_L_DQUOTE] = ACTIONS(1151),
    [anon_sym_u_DQUOTE] = ACTIONS(1151),
    [anon_sym_U_DQUOTE] = ACTIONS(1151),
    [anon_sym_u8_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(1151),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [anon_sym_NULL] = ACTIONS(1149),
    [anon_sym_nullptr] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_identifier] = ACTIONS(1153),
    [aux_sym_preproc_include_token1] = ACTIONS(1153),
    [aux_sym_preproc_def_token1] = ACTIONS(1153),
    [aux_sym_preproc_if_token1] = ACTIONS(1153),
    [aux_sym_preproc_if_token2] = ACTIONS(1153),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1153),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1153),
    [aux_sym_preproc_else_token1] = ACTIONS(1153),
    [aux_sym_preproc_elif_token1] = ACTIONS(1153),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1153),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1153),
    [sym_preproc_directive] = ACTIONS(1153),
    [anon_sym_LPAREN2] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_TILDE] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym___extension__] = ACTIONS(1153),
    [anon_sym_typedef] = ACTIONS(1153),
    [anon_sym_extern] = ACTIONS(1153),
    [anon_sym___attribute__] = ACTIONS(1153),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1155),
    [anon_sym___declspec] = ACTIONS(1153),
    [anon_sym___cdecl] = ACTIONS(1153),
    [anon_sym___clrcall] = ACTIONS(1153),
    [anon_sym___stdcall] = ACTIONS(1153),
    [anon_sym___fastcall] = ACTIONS(1153),
    [anon_sym___thiscall] = ACTIONS(1153),
    [anon_sym___vectorcall] = ACTIONS(1153),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_signed] = ACTIONS(1153),
    [anon_sym_unsigned] = ACTIONS(1153),
    [anon_sym_long] = ACTIONS(1153),
    [anon_sym_short] = ACTIONS(1153),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_auto] = ACTIONS(1153),
    [anon_sym_register] = ACTIONS(1153),
    [anon_sym_inline] = ACTIONS(1153),
    [anon_sym___inline] = ACTIONS(1153),
    [anon_sym___inline__] = ACTIONS(1153),
    [anon_sym___forceinline] = ACTIONS(1153),
    [anon_sym_thread_local] = ACTIONS(1153),
    [anon_sym___thread] = ACTIONS(1153),
    [anon_sym_const] = ACTIONS(1153),
    [anon_sym_constexpr] = ACTIONS(1153),
    [anon_sym_volatile] = ACTIONS(1153),
    [anon_sym_restrict] = ACTIONS(1153),
    [anon_sym___restrict__] = ACTIONS(1153),
    [anon_sym__Atomic] = ACTIONS(1153),
    [anon_sym__Noreturn] = ACTIONS(1153),
    [anon_sym_noreturn] = ACTIONS(1153),
    [anon_sym__Nonnull] = ACTIONS(1153),
    [anon_sym_alignas] = ACTIONS(1153),
    [anon_sym__Alignas] = ACTIONS(1153),
    [sym_primitive_type] = ACTIONS(1153),
    [anon_sym_enum] = ACTIONS(1153),
    [anon_sym_struct] = ACTIONS(1153),
    [anon_sym_union] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_else] = ACTIONS(1153),
    [anon_sym_switch] = ACTIONS(1153),
    [anon_sym_case] = ACTIONS(1153),
    [anon_sym_default] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_do] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [anon_sym_goto] = ACTIONS(1153),
    [anon_sym___try] = ACTIONS(1153),
    [anon_sym___leave] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_sizeof] = ACTIONS(1153),
    [anon_sym___alignof__] = ACTIONS(1153),
    [anon_sym___alignof] = ACTIONS(1153),
    [anon_sym__alignof] = ACTIONS(1153),
    [anon_sym_alignof] = ACTIONS(1153),
    [anon_sym__Alignof] = ACTIONS(1153),
    [anon_sym_offsetof] = ACTIONS(1153),
    [anon_sym__Generic] = ACTIONS(1153),
    [anon_sym_asm] = ACTIONS(1153),
    [anon_sym___asm__] = ACTIONS(1153),
    [anon_sym___asm] = ACTIONS(1153),
    [sym_number_literal] = ACTIONS(1155),
    [anon_sym_L_SQUOTE] = ACTIONS(1155),
    [anon_sym_u_SQUOTE] = ACTIONS(1155),
    [anon_sym_U_SQUOTE] = ACTIONS(1155),
    [anon_sym_u8_SQUOTE] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [anon_sym_L_DQUOTE] = ACTIONS(1155),
    [anon_sym_u_DQUOTE] = ACTIONS(1155),
    [anon_sym_U_DQUOTE] = ACTIONS(1155),
    [anon_sym_u8_DQUOTE] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [anon_sym_NULL] = ACTIONS(1153),
    [anon_sym_nullptr] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_identifier] = ACTIONS(1157),
    [aux_sym_preproc_include_token1] = ACTIONS(1157),
    [aux_sym_preproc_def_token1] = ACTIONS(1157),
    [aux_sym_preproc_if_token1] = ACTIONS(1157),
    [aux_sym_preproc_if_token2] = ACTIONS(1157),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1157),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1157),
    [aux_sym_preproc_else_token1] = ACTIONS(1157),
    [aux_sym_preproc_elif_token1] = ACTIONS(1157),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1157),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1157),
    [sym_preproc_directive] = ACTIONS(1157),
    [anon_sym_LPAREN2] = ACTIONS(1159),
    [anon_sym_BANG] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym___extension__] = ACTIONS(1157),
    [anon_sym_typedef] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1157),
    [anon_sym___attribute__] = ACTIONS(1157),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1159),
    [anon_sym___declspec] = ACTIONS(1157),
    [anon_sym___cdecl] = ACTIONS(1157),
    [anon_sym___clrcall] = ACTIONS(1157),
    [anon_sym___stdcall] = ACTIONS(1157),
    [anon_sym___fastcall] = ACTIONS(1157),
    [anon_sym___thiscall] = ACTIONS(1157),
    [anon_sym___vectorcall] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_signed] = ACTIONS(1157),
    [anon_sym_unsigned] = ACTIONS(1157),
    [anon_sym_long] = ACTIONS(1157),
    [anon_sym_short] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1157),
    [anon_sym_auto] = ACTIONS(1157),
    [anon_sym_register] = ACTIONS(1157),
    [anon_sym_inline] = ACTIONS(1157),
    [anon_sym___inline] = ACTIONS(1157),
    [anon_sym___inline__] = ACTIONS(1157),
    [anon_sym___forceinline] = ACTIONS(1157),
    [anon_sym_thread_local] = ACTIONS(1157),
    [anon_sym___thread] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_constexpr] = ACTIONS(1157),
    [anon_sym_volatile] = ACTIONS(1157),
    [anon_sym_restrict] = ACTIONS(1157),
    [anon_sym___restrict__] = ACTIONS(1157),
    [anon_sym__Atomic] = ACTIONS(1157),
    [anon_sym__Noreturn] = ACTIONS(1157),
    [anon_sym_noreturn] = ACTIONS(1157),
    [anon_sym__Nonnull] = ACTIONS(1157),
    [anon_sym_alignas] = ACTIONS(1157),
    [anon_sym__Alignas] = ACTIONS(1157),
    [sym_primitive_type] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [anon_sym_struct] = ACTIONS(1157),
    [anon_sym_union] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_else] = ACTIONS(1157),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_case] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_do] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [anon_sym_goto] = ACTIONS(1157),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_sizeof] = ACTIONS(1157),
    [anon_sym___alignof__] = ACTIONS(1157),
    [anon_sym___alignof] = ACTIONS(1157),
    [anon_sym__alignof] = ACTIONS(1157),
    [anon_sym_alignof] = ACTIONS(1157),
    [anon_sym__Alignof] = ACTIONS(1157),
    [anon_sym_offsetof] = ACTIONS(1157),
    [anon_sym__Generic] = ACTIONS(1157),
    [anon_sym_asm] = ACTIONS(1157),
    [anon_sym___asm__] = ACTIONS(1157),
    [anon_sym___asm] = ACTIONS(1157),
    [sym_number_literal] = ACTIONS(1159),
    [anon_sym_L_SQUOTE] = ACTIONS(1159),
    [anon_sym_u_SQUOTE] = ACTIONS(1159),
    [anon_sym_U_SQUOTE] = ACTIONS(1159),
    [anon_sym_u8_SQUOTE] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [anon_sym_L_DQUOTE] = ACTIONS(1159),
    [anon_sym_u_DQUOTE] = ACTIONS(1159),
    [anon_sym_U_DQUOTE] = ACTIONS(1159),
    [anon_sym_u8_DQUOTE] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [anon_sym_NULL] = ACTIONS(1157),
    [anon_sym_nullptr] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_identifier] = ACTIONS(1161),
    [aux_sym_preproc_include_token1] = ACTIONS(1161),
    [aux_sym_preproc_def_token1] = ACTIONS(1161),
    [aux_sym_preproc_if_token1] = ACTIONS(1161),
    [aux_sym_preproc_if_token2] = ACTIONS(1161),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1161),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1161),
    [aux_sym_preproc_else_token1] = ACTIONS(1161),
    [aux_sym_preproc_elif_token1] = ACTIONS(1161),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1161),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1161),
    [sym_preproc_directive] = ACTIONS(1161),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym___extension__] = ACTIONS(1161),
    [anon_sym_typedef] = ACTIONS(1161),
    [anon_sym_extern] = ACTIONS(1161),
    [anon_sym___attribute__] = ACTIONS(1161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1163),
    [anon_sym___declspec] = ACTIONS(1161),
    [anon_sym___cdecl] = ACTIONS(1161),
    [anon_sym___clrcall] = ACTIONS(1161),
    [anon_sym___stdcall] = ACTIONS(1161),
    [anon_sym___fastcall] = ACTIONS(1161),
    [anon_sym___thiscall] = ACTIONS(1161),
    [anon_sym___vectorcall] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_signed] = ACTIONS(1161),
    [anon_sym_unsigned] = ACTIONS(1161),
    [anon_sym_long] = ACTIONS(1161),
    [anon_sym_short] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1161),
    [anon_sym_auto] = ACTIONS(1161),
    [anon_sym_register] = ACTIONS(1161),
    [anon_sym_inline] = ACTIONS(1161),
    [anon_sym___inline] = ACTIONS(1161),
    [anon_sym___inline__] = ACTIONS(1161),
    [anon_sym___forceinline] = ACTIONS(1161),
    [anon_sym_thread_local] = ACTIONS(1161),
    [anon_sym___thread] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_constexpr] = ACTIONS(1161),
    [anon_sym_volatile] = ACTIONS(1161),
    [anon_sym_restrict] = ACTIONS(1161),
    [anon_sym___restrict__] = ACTIONS(1161),
    [anon_sym__Atomic] = ACTIONS(1161),
    [anon_sym__Noreturn] = ACTIONS(1161),
    [anon_sym_noreturn] = ACTIONS(1161),
    [anon_sym__Nonnull] = ACTIONS(1161),
    [anon_sym_alignas] = ACTIONS(1161),
    [anon_sym__Alignas] = ACTIONS(1161),
    [sym_primitive_type] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [anon_sym_struct] = ACTIONS(1161),
    [anon_sym_union] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_else] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_case] = ACTIONS(1161),
    [anon_sym_default] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_do] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_goto] = ACTIONS(1161),
    [anon_sym___try] = ACTIONS(1161),
    [anon_sym___leave] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_sizeof] = ACTIONS(1161),
    [anon_sym___alignof__] = ACTIONS(1161),
    [anon_sym___alignof] = ACTIONS(1161),
    [anon_sym__alignof] = ACTIONS(1161),
    [anon_sym_alignof] = ACTIONS(1161),
    [anon_sym__Alignof] = ACTIONS(1161),
    [anon_sym_offsetof] = ACTIONS(1161),
    [anon_sym__Generic] = ACTIONS(1161),
    [anon_sym_asm] = ACTIONS(1161),
    [anon_sym___asm__] = ACTIONS(1161),
    [anon_sym___asm] = ACTIONS(1161),
    [sym_number_literal] = ACTIONS(1163),
    [anon_sym_L_SQUOTE] = ACTIONS(1163),
    [anon_sym_u_SQUOTE] = ACTIONS(1163),
    [anon_sym_U_SQUOTE] = ACTIONS(1163),
    [anon_sym_u8_SQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [anon_sym_L_DQUOTE] = ACTIONS(1163),
    [anon_sym_u_DQUOTE] = ACTIONS(1163),
    [anon_sym_U_DQUOTE] = ACTIONS(1163),
    [anon_sym_u8_DQUOTE] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [anon_sym_NULL] = ACTIONS(1161),
    [anon_sym_nullptr] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_identifier] = ACTIONS(1165),
    [aux_sym_preproc_include_token1] = ACTIONS(1165),
    [aux_sym_preproc_def_token1] = ACTIONS(1165),
    [aux_sym_preproc_if_token1] = ACTIONS(1165),
    [aux_sym_preproc_if_token2] = ACTIONS(1165),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1165),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1165),
    [aux_sym_preproc_else_token1] = ACTIONS(1165),
    [aux_sym_preproc_elif_token1] = ACTIONS(1165),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1165),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1165),
    [sym_preproc_directive] = ACTIONS(1165),
    [anon_sym_LPAREN2] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym___extension__] = ACTIONS(1165),
    [anon_sym_typedef] = ACTIONS(1165),
    [anon_sym_extern] = ACTIONS(1165),
    [anon_sym___attribute__] = ACTIONS(1165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1167),
    [anon_sym___declspec] = ACTIONS(1165),
    [anon_sym___cdecl] = ACTIONS(1165),
    [anon_sym___clrcall] = ACTIONS(1165),
    [anon_sym___stdcall] = ACTIONS(1165),
    [anon_sym___fastcall] = ACTIONS(1165),
    [anon_sym___thiscall] = ACTIONS(1165),
    [anon_sym___vectorcall] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_signed] = ACTIONS(1165),
    [anon_sym_unsigned] = ACTIONS(1165),
    [anon_sym_long] = ACTIONS(1165),
    [anon_sym_short] = ACTIONS(1165),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_auto] = ACTIONS(1165),
    [anon_sym_register] = ACTIONS(1165),
    [anon_sym_inline] = ACTIONS(1165),
    [anon_sym___inline] = ACTIONS(1165),
    [anon_sym___inline__] = ACTIONS(1165),
    [anon_sym___forceinline] = ACTIONS(1165),
    [anon_sym_thread_local] = ACTIONS(1165),
    [anon_sym___thread] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_constexpr] = ACTIONS(1165),
    [anon_sym_volatile] = ACTIONS(1165),
    [anon_sym_restrict] = ACTIONS(1165),
    [anon_sym___restrict__] = ACTIONS(1165),
    [anon_sym__Atomic] = ACTIONS(1165),
    [anon_sym__Noreturn] = ACTIONS(1165),
    [anon_sym_noreturn] = ACTIONS(1165),
    [anon_sym__Nonnull] = ACTIONS(1165),
    [anon_sym_alignas] = ACTIONS(1165),
    [anon_sym__Alignas] = ACTIONS(1165),
    [sym_primitive_type] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [anon_sym_struct] = ACTIONS(1165),
    [anon_sym_union] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_goto] = ACTIONS(1165),
    [anon_sym___try] = ACTIONS(1165),
    [anon_sym___leave] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_sizeof] = ACTIONS(1165),
    [anon_sym___alignof__] = ACTIONS(1165),
    [anon_sym___alignof] = ACTIONS(1165),
    [anon_sym__alignof] = ACTIONS(1165),
    [anon_sym_alignof] = ACTIONS(1165),
    [anon_sym__Alignof] = ACTIONS(1165),
    [anon_sym_offsetof] = ACTIONS(1165),
    [anon_sym__Generic] = ACTIONS(1165),
    [anon_sym_asm] = ACTIONS(1165),
    [anon_sym___asm__] = ACTIONS(1165),
    [anon_sym___asm] = ACTIONS(1165),
    [sym_number_literal] = ACTIONS(1167),
    [anon_sym_L_SQUOTE] = ACTIONS(1167),
    [anon_sym_u_SQUOTE] = ACTIONS(1167),
    [anon_sym_U_SQUOTE] = ACTIONS(1167),
    [anon_sym_u8_SQUOTE] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [anon_sym_L_DQUOTE] = ACTIONS(1167),
    [anon_sym_u_DQUOTE] = ACTIONS(1167),
    [anon_sym_U_DQUOTE] = ACTIONS(1167),
    [anon_sym_u8_DQUOTE] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [anon_sym_NULL] = ACTIONS(1165),
    [anon_sym_nullptr] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_identifier] = ACTIONS(1169),
    [aux_sym_preproc_include_token1] = ACTIONS(1169),
    [aux_sym_preproc_def_token1] = ACTIONS(1169),
    [aux_sym_preproc_if_token1] = ACTIONS(1169),
    [aux_sym_preproc_if_token2] = ACTIONS(1169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1169),
    [aux_sym_preproc_else_token1] = ACTIONS(1169),
    [aux_sym_preproc_elif_token1] = ACTIONS(1169),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1169),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1169),
    [sym_preproc_directive] = ACTIONS(1169),
    [anon_sym_LPAREN2] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1171),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym___extension__] = ACTIONS(1169),
    [anon_sym_typedef] = ACTIONS(1169),
    [anon_sym_extern] = ACTIONS(1169),
    [anon_sym___attribute__] = ACTIONS(1169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1171),
    [anon_sym___declspec] = ACTIONS(1169),
    [anon_sym___cdecl] = ACTIONS(1169),
    [anon_sym___clrcall] = ACTIONS(1169),
    [anon_sym___stdcall] = ACTIONS(1169),
    [anon_sym___fastcall] = ACTIONS(1169),
    [anon_sym___thiscall] = ACTIONS(1169),
    [anon_sym___vectorcall] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_signed] = ACTIONS(1169),
    [anon_sym_unsigned] = ACTIONS(1169),
    [anon_sym_long] = ACTIONS(1169),
    [anon_sym_short] = ACTIONS(1169),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_auto] = ACTIONS(1169),
    [anon_sym_register] = ACTIONS(1169),
    [anon_sym_inline] = ACTIONS(1169),
    [anon_sym___inline] = ACTIONS(1169),
    [anon_sym___inline__] = ACTIONS(1169),
    [anon_sym___forceinline] = ACTIONS(1169),
    [anon_sym_thread_local] = ACTIONS(1169),
    [anon_sym___thread] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_constexpr] = ACTIONS(1169),
    [anon_sym_volatile] = ACTIONS(1169),
    [anon_sym_restrict] = ACTIONS(1169),
    [anon_sym___restrict__] = ACTIONS(1169),
    [anon_sym__Atomic] = ACTIONS(1169),
    [anon_sym__Noreturn] = ACTIONS(1169),
    [anon_sym_noreturn] = ACTIONS(1169),
    [anon_sym__Nonnull] = ACTIONS(1169),
    [anon_sym_alignas] = ACTIONS(1169),
    [anon_sym__Alignas] = ACTIONS(1169),
    [sym_primitive_type] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [anon_sym_struct] = ACTIONS(1169),
    [anon_sym_union] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_do] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [anon_sym_goto] = ACTIONS(1169),
    [anon_sym___try] = ACTIONS(1169),
    [anon_sym___leave] = ACTIONS(1169),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_sizeof] = ACTIONS(1169),
    [anon_sym___alignof__] = ACTIONS(1169),
    [anon_sym___alignof] = ACTIONS(1169),
    [anon_sym__alignof] = ACTIONS(1169),
    [anon_sym_alignof] = ACTIONS(1169),
    [anon_sym__Alignof] = ACTIONS(1169),
    [anon_sym_offsetof] = ACTIONS(1169),
    [anon_sym__Generic] = ACTIONS(1169),
    [anon_sym_asm] = ACTIONS(1169),
    [anon_sym___asm__] = ACTIONS(1169),
    [anon_sym___asm] = ACTIONS(1169),
    [sym_number_literal] = ACTIONS(1171),
    [anon_sym_L_SQUOTE] = ACTIONS(1171),
    [anon_sym_u_SQUOTE] = ACTIONS(1171),
    [anon_sym_U_SQUOTE] = ACTIONS(1171),
    [anon_sym_u8_SQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [anon_sym_L_DQUOTE] = ACTIONS(1171),
    [anon_sym_u_DQUOTE] = ACTIONS(1171),
    [anon_sym_U_DQUOTE] = ACTIONS(1171),
    [anon_sym_u8_DQUOTE] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [anon_sym_NULL] = ACTIONS(1169),
    [anon_sym_nullptr] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_identifier] = ACTIONS(1173),
    [aux_sym_preproc_include_token1] = ACTIONS(1173),
    [aux_sym_preproc_def_token1] = ACTIONS(1173),
    [aux_sym_preproc_if_token1] = ACTIONS(1173),
    [aux_sym_preproc_if_token2] = ACTIONS(1173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1173),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1173),
    [aux_sym_preproc_else_token1] = ACTIONS(1173),
    [aux_sym_preproc_elif_token1] = ACTIONS(1173),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1173),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1173),
    [sym_preproc_directive] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym___extension__] = ACTIONS(1173),
    [anon_sym_typedef] = ACTIONS(1173),
    [anon_sym_extern] = ACTIONS(1173),
    [anon_sym___attribute__] = ACTIONS(1173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1175),
    [anon_sym___declspec] = ACTIONS(1173),
    [anon_sym___cdecl] = ACTIONS(1173),
    [anon_sym___clrcall] = ACTIONS(1173),
    [anon_sym___stdcall] = ACTIONS(1173),
    [anon_sym___fastcall] = ACTIONS(1173),
    [anon_sym___thiscall] = ACTIONS(1173),
    [anon_sym___vectorcall] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_signed] = ACTIONS(1173),
    [anon_sym_unsigned] = ACTIONS(1173),
    [anon_sym_long] = ACTIONS(1173),
    [anon_sym_short] = ACTIONS(1173),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_auto] = ACTIONS(1173),
    [anon_sym_register] = ACTIONS(1173),
    [anon_sym_inline] = ACTIONS(1173),
    [anon_sym___inline] = ACTIONS(1173),
    [anon_sym___inline__] = ACTIONS(1173),
    [anon_sym___forceinline] = ACTIONS(1173),
    [anon_sym_thread_local] = ACTIONS(1173),
    [anon_sym___thread] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_constexpr] = ACTIONS(1173),
    [anon_sym_volatile] = ACTIONS(1173),
    [anon_sym_restrict] = ACTIONS(1173),
    [anon_sym___restrict__] = ACTIONS(1173),
    [anon_sym__Atomic] = ACTIONS(1173),
    [anon_sym__Noreturn] = ACTIONS(1173),
    [anon_sym_noreturn] = ACTIONS(1173),
    [anon_sym__Nonnull] = ACTIONS(1173),
    [anon_sym_alignas] = ACTIONS(1173),
    [anon_sym__Alignas] = ACTIONS(1173),
    [sym_primitive_type] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [anon_sym_struct] = ACTIONS(1173),
    [anon_sym_union] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_goto] = ACTIONS(1173),
    [anon_sym___try] = ACTIONS(1173),
    [anon_sym___leave] = ACTIONS(1173),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_sizeof] = ACTIONS(1173),
    [anon_sym___alignof__] = ACTIONS(1173),
    [anon_sym___alignof] = ACTIONS(1173),
    [anon_sym__alignof] = ACTIONS(1173),
    [anon_sym_alignof] = ACTIONS(1173),
    [anon_sym__Alignof] = ACTIONS(1173),
    [anon_sym_offsetof] = ACTIONS(1173),
    [anon_sym__Generic] = ACTIONS(1173),
    [anon_sym_asm] = ACTIONS(1173),
    [anon_sym___asm__] = ACTIONS(1173),
    [anon_sym___asm] = ACTIONS(1173),
    [sym_number_literal] = ACTIONS(1175),
    [anon_sym_L_SQUOTE] = ACTIONS(1175),
    [anon_sym_u_SQUOTE] = ACTIONS(1175),
    [anon_sym_U_SQUOTE] = ACTIONS(1175),
    [anon_sym_u8_SQUOTE] = ACTIONS(1175),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_L_DQUOTE] = ACTIONS(1175),
    [anon_sym_u_DQUOTE] = ACTIONS(1175),
    [anon_sym_U_DQUOTE] = ACTIONS(1175),
    [anon_sym_u8_DQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [anon_sym_NULL] = ACTIONS(1173),
    [anon_sym_nullptr] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_identifier] = ACTIONS(1177),
    [aux_sym_preproc_include_token1] = ACTIONS(1177),
    [aux_sym_preproc_def_token1] = ACTIONS(1177),
    [aux_sym_preproc_if_token1] = ACTIONS(1177),
    [aux_sym_preproc_if_token2] = ACTIONS(1177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1177),
    [aux_sym_preproc_else_token1] = ACTIONS(1177),
    [aux_sym_preproc_elif_token1] = ACTIONS(1177),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1177),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1177),
    [sym_preproc_directive] = ACTIONS(1177),
    [anon_sym_LPAREN2] = ACTIONS(1179),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym___extension__] = ACTIONS(1177),
    [anon_sym_typedef] = ACTIONS(1177),
    [anon_sym_extern] = ACTIONS(1177),
    [anon_sym___attribute__] = ACTIONS(1177),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1179),
    [anon_sym___declspec] = ACTIONS(1177),
    [anon_sym___cdecl] = ACTIONS(1177),
    [anon_sym___clrcall] = ACTIONS(1177),
    [anon_sym___stdcall] = ACTIONS(1177),
    [anon_sym___fastcall] = ACTIONS(1177),
    [anon_sym___thiscall] = ACTIONS(1177),
    [anon_sym___vectorcall] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_signed] = ACTIONS(1177),
    [anon_sym_unsigned] = ACTIONS(1177),
    [anon_sym_long] = ACTIONS(1177),
    [anon_sym_short] = ACTIONS(1177),
    [anon_sym_static] = ACTIONS(1177),
    [anon_sym_auto] = ACTIONS(1177),
    [anon_sym_register] = ACTIONS(1177),
    [anon_sym_inline] = ACTIONS(1177),
    [anon_sym___inline] = ACTIONS(1177),
    [anon_sym___inline__] = ACTIONS(1177),
    [anon_sym___forceinline] = ACTIONS(1177),
    [anon_sym_thread_local] = ACTIONS(1177),
    [anon_sym___thread] = ACTIONS(1177),
    [anon_sym_const] = ACTIONS(1177),
    [anon_sym_constexpr] = ACTIONS(1177),
    [anon_sym_volatile] = ACTIONS(1177),
    [anon_sym_restrict] = ACTIONS(1177),
    [anon_sym___restrict__] = ACTIONS(1177),
    [anon_sym__Atomic] = ACTIONS(1177),
    [anon_sym__Noreturn] = ACTIONS(1177),
    [anon_sym_noreturn] = ACTIONS(1177),
    [anon_sym__Nonnull] = ACTIONS(1177),
    [anon_sym_alignas] = ACTIONS(1177),
    [anon_sym__Alignas] = ACTIONS(1177),
    [sym_primitive_type] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(1177),
    [anon_sym_struct] = ACTIONS(1177),
    [anon_sym_union] = ACTIONS(1177),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_switch] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_default] = ACTIONS(1177),
    [anon_sym_while] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1177),
    [anon_sym_return] = ACTIONS(1177),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1177),
    [anon_sym_goto] = ACTIONS(1177),
    [anon_sym___try] = ACTIONS(1177),
    [anon_sym___leave] = ACTIONS(1177),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_sizeof] = ACTIONS(1177),
    [anon_sym___alignof__] = ACTIONS(1177),
    [anon_sym___alignof] = ACTIONS(1177),
    [anon_sym__alignof] = ACTIONS(1177),
    [anon_sym_alignof] = ACTIONS(1177),
    [anon_sym__Alignof] = ACTIONS(1177),
    [anon_sym_offsetof] = ACTIONS(1177),
    [anon_sym__Generic] = ACTIONS(1177),
    [anon_sym_asm] = ACTIONS(1177),
    [anon_sym___asm__] = ACTIONS(1177),
    [anon_sym___asm] = ACTIONS(1177),
    [sym_number_literal] = ACTIONS(1179),
    [anon_sym_L_SQUOTE] = ACTIONS(1179),
    [anon_sym_u_SQUOTE] = ACTIONS(1179),
    [anon_sym_U_SQUOTE] = ACTIONS(1179),
    [anon_sym_u8_SQUOTE] = ACTIONS(1179),
    [anon_sym_SQUOTE] = ACTIONS(1179),
    [anon_sym_L_DQUOTE] = ACTIONS(1179),
    [anon_sym_u_DQUOTE] = ACTIONS(1179),
    [anon_sym_U_DQUOTE] = ACTIONS(1179),
    [anon_sym_u8_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1179),
    [sym_true] = ACTIONS(1177),
    [sym_false] = ACTIONS(1177),
    [anon_sym_NULL] = ACTIONS(1177),
    [anon_sym_nullptr] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_identifier] = ACTIONS(1181),
    [aux_sym_preproc_include_token1] = ACTIONS(1181),
    [aux_sym_preproc_def_token1] = ACTIONS(1181),
    [aux_sym_preproc_if_token1] = ACTIONS(1181),
    [aux_sym_preproc_if_token2] = ACTIONS(1181),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1181),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1181),
    [aux_sym_preproc_else_token1] = ACTIONS(1181),
    [aux_sym_preproc_elif_token1] = ACTIONS(1181),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1181),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1181),
    [sym_preproc_directive] = ACTIONS(1181),
    [anon_sym_LPAREN2] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym___extension__] = ACTIONS(1181),
    [anon_sym_typedef] = ACTIONS(1181),
    [anon_sym_extern] = ACTIONS(1181),
    [anon_sym___attribute__] = ACTIONS(1181),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1183),
    [anon_sym___declspec] = ACTIONS(1181),
    [anon_sym___cdecl] = ACTIONS(1181),
    [anon_sym___clrcall] = ACTIONS(1181),
    [anon_sym___stdcall] = ACTIONS(1181),
    [anon_sym___fastcall] = ACTIONS(1181),
    [anon_sym___thiscall] = ACTIONS(1181),
    [anon_sym___vectorcall] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1183),
    [anon_sym_signed] = ACTIONS(1181),
    [anon_sym_unsigned] = ACTIONS(1181),
    [anon_sym_long] = ACTIONS(1181),
    [anon_sym_short] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_auto] = ACTIONS(1181),
    [anon_sym_register] = ACTIONS(1181),
    [anon_sym_inline] = ACTIONS(1181),
    [anon_sym___inline] = ACTIONS(1181),
    [anon_sym___inline__] = ACTIONS(1181),
    [anon_sym___forceinline] = ACTIONS(1181),
    [anon_sym_thread_local] = ACTIONS(1181),
    [anon_sym___thread] = ACTIONS(1181),
    [anon_sym_const] = ACTIONS(1181),
    [anon_sym_constexpr] = ACTIONS(1181),
    [anon_sym_volatile] = ACTIONS(1181),
    [anon_sym_restrict] = ACTIONS(1181),
    [anon_sym___restrict__] = ACTIONS(1181),
    [anon_sym__Atomic] = ACTIONS(1181),
    [anon_sym__Noreturn] = ACTIONS(1181),
    [anon_sym_noreturn] = ACTIONS(1181),
    [anon_sym__Nonnull] = ACTIONS(1181),
    [anon_sym_alignas] = ACTIONS(1181),
    [anon_sym__Alignas] = ACTIONS(1181),
    [sym_primitive_type] = ACTIONS(1181),
    [anon_sym_enum] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1181),
    [anon_sym_switch] = ACTIONS(1181),
    [anon_sym_case] = ACTIONS(1181),
    [anon_sym_default] = ACTIONS(1181),
    [anon_sym_while] = ACTIONS(1181),
    [anon_sym_do] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1181),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_continue] = ACTIONS(1181),
    [anon_sym_goto] = ACTIONS(1181),
    [anon_sym___try] = ACTIONS(1181),
    [anon_sym___leave] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1183),
    [anon_sym_sizeof] = ACTIONS(1181),
    [anon_sym___alignof__] = ACTIONS(1181),
    [anon_sym___alignof] = ACTIONS(1181),
    [anon_sym__alignof] = ACTIONS(1181),
    [anon_sym_alignof] = ACTIONS(1181),
    [anon_sym__Alignof] = ACTIONS(1181),
    [anon_sym_offsetof] = ACTIONS(1181),
    [anon_sym__Generic] = ACTIONS(1181),
    [anon_sym_asm] = ACTIONS(1181),
    [anon_sym___asm__] = ACTIONS(1181),
    [anon_sym___asm] = ACTIONS(1181),
    [sym_number_literal] = ACTIONS(1183),
    [anon_sym_L_SQUOTE] = ACTIONS(1183),
    [anon_sym_u_SQUOTE] = ACTIONS(1183),
    [anon_sym_U_SQUOTE] = ACTIONS(1183),
    [anon_sym_u8_SQUOTE] = ACTIONS(1183),
    [anon_sym_SQUOTE] = ACTIONS(1183),
    [anon_sym_L_DQUOTE] = ACTIONS(1183),
    [anon_sym_u_DQUOTE] = ACTIONS(1183),
    [anon_sym_U_DQUOTE] = ACTIONS(1183),
    [anon_sym_u8_DQUOTE] = ACTIONS(1183),
    [anon_sym_DQUOTE] = ACTIONS(1183),
    [sym_true] = ACTIONS(1181),
    [sym_false] = ACTIONS(1181),
    [anon_sym_NULL] = ACTIONS(1181),
    [anon_sym_nullptr] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_identifier] = ACTIONS(1185),
    [aux_sym_preproc_include_token1] = ACTIONS(1185),
    [aux_sym_preproc_def_token1] = ACTIONS(1185),
    [aux_sym_preproc_if_token1] = ACTIONS(1185),
    [aux_sym_preproc_if_token2] = ACTIONS(1185),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1185),
    [aux_sym_preproc_else_token1] = ACTIONS(1185),
    [aux_sym_preproc_elif_token1] = ACTIONS(1185),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1185),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1185),
    [sym_preproc_directive] = ACTIONS(1185),
    [anon_sym_LPAREN2] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_TILDE] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1185),
    [anon_sym_PLUS] = ACTIONS(1185),
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym___extension__] = ACTIONS(1185),
    [anon_sym_typedef] = ACTIONS(1185),
    [anon_sym_extern] = ACTIONS(1185),
    [anon_sym___attribute__] = ACTIONS(1185),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1187),
    [anon_sym___declspec] = ACTIONS(1185),
    [anon_sym___cdecl] = ACTIONS(1185),
    [anon_sym___clrcall] = ACTIONS(1185),
    [anon_sym___stdcall] = ACTIONS(1185),
    [anon_sym___fastcall] = ACTIONS(1185),
    [anon_sym___thiscall] = ACTIONS(1185),
    [anon_sym___vectorcall] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_signed] = ACTIONS(1185),
    [anon_sym_unsigned] = ACTIONS(1185),
    [anon_sym_long] = ACTIONS(1185),
    [anon_sym_short] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1185),
    [anon_sym_auto] = ACTIONS(1185),
    [anon_sym_register] = ACTIONS(1185),
    [anon_sym_inline] = ACTIONS(1185),
    [anon_sym___inline] = ACTIONS(1185),
    [anon_sym___inline__] = ACTIONS(1185),
    [anon_sym___forceinline] = ACTIONS(1185),
    [anon_sym_thread_local] = ACTIONS(1185),
    [anon_sym___thread] = ACTIONS(1185),
    [anon_sym_const] = ACTIONS(1185),
    [anon_sym_constexpr] = ACTIONS(1185),
    [anon_sym_volatile] = ACTIONS(1185),
    [anon_sym_restrict] = ACTIONS(1185),
    [anon_sym___restrict__] = ACTIONS(1185),
    [anon_sym__Atomic] = ACTIONS(1185),
    [anon_sym__Noreturn] = ACTIONS(1185),
    [anon_sym_noreturn] = ACTIONS(1185),
    [anon_sym__Nonnull] = ACTIONS(1185),
    [anon_sym_alignas] = ACTIONS(1185),
    [anon_sym__Alignas] = ACTIONS(1185),
    [sym_primitive_type] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1185),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_union] = ACTIONS(1185),
    [anon_sym_if] = ACTIONS(1185),
    [anon_sym_else] = ACTIONS(1185),
    [anon_sym_switch] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1185),
    [anon_sym_default] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1185),
    [anon_sym_do] = ACTIONS(1185),
    [anon_sym_for] = ACTIONS(1185),
    [anon_sym_return] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1185),
    [anon_sym_continue] = ACTIONS(1185),
    [anon_sym_goto] = ACTIONS(1185),
    [anon_sym___try] = ACTIONS(1185),
    [anon_sym___leave] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1187),
    [anon_sym_sizeof] = ACTIONS(1185),
    [anon_sym___alignof__] = ACTIONS(1185),
    [anon_sym___alignof] = ACTIONS(1185),
    [anon_sym__alignof] = ACTIONS(1185),
    [anon_sym_alignof] = ACTIONS(1185),
    [anon_sym__Alignof] = ACTIONS(1185),
    [anon_sym_offsetof] = ACTIONS(1185),
    [anon_sym__Generic] = ACTIONS(1185),
    [anon_sym_asm] = ACTIONS(1185),
    [anon_sym___asm__] = ACTIONS(1185),
    [anon_sym___asm] = ACTIONS(1185),
    [sym_number_literal] = ACTIONS(1187),
    [anon_sym_L_SQUOTE] = ACTIONS(1187),
    [anon_sym_u_SQUOTE] = ACTIONS(1187),
    [anon_sym_U_SQUOTE] = ACTIONS(1187),
    [anon_sym_u8_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_L_DQUOTE] = ACTIONS(1187),
    [anon_sym_u_DQUOTE] = ACTIONS(1187),
    [anon_sym_U_DQUOTE] = ACTIONS(1187),
    [anon_sym_u8_DQUOTE] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [sym_true] = ACTIONS(1185),
    [sym_false] = ACTIONS(1185),
    [anon_sym_NULL] = ACTIONS(1185),
    [anon_sym_nullptr] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [ts_builtin_sym_end] = ACTIONS(1171),
    [sym_identifier] = ACTIONS(1169),
    [aux_sym_preproc_include_token1] = ACTIONS(1169),
    [aux_sym_preproc_def_token1] = ACTIONS(1169),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_RPAREN] = ACTIONS(1171),
    [aux_sym_preproc_if_token1] = ACTIONS(1169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1169),
    [sym_preproc_directive] = ACTIONS(1169),
    [anon_sym_LPAREN2] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1171),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym___extension__] = ACTIONS(1169),
    [anon_sym_typedef] = ACTIONS(1169),
    [anon_sym_extern] = ACTIONS(1169),
    [anon_sym___attribute__] = ACTIONS(1169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1171),
    [anon_sym___declspec] = ACTIONS(1169),
    [anon_sym___cdecl] = ACTIONS(1169),
    [anon_sym___clrcall] = ACTIONS(1169),
    [anon_sym___stdcall] = ACTIONS(1169),
    [anon_sym___fastcall] = ACTIONS(1169),
    [anon_sym___thiscall] = ACTIONS(1169),
    [anon_sym___vectorcall] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_signed] = ACTIONS(1169),
    [anon_sym_unsigned] = ACTIONS(1169),
    [anon_sym_long] = ACTIONS(1169),
    [anon_sym_short] = ACTIONS(1169),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_auto] = ACTIONS(1169),
    [anon_sym_register] = ACTIONS(1169),
    [anon_sym_inline] = ACTIONS(1169),
    [anon_sym___inline] = ACTIONS(1169),
    [anon_sym___inline__] = ACTIONS(1169),
    [anon_sym___forceinline] = ACTIONS(1169),
    [anon_sym_thread_local] = ACTIONS(1169),
    [anon_sym___thread] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_constexpr] = ACTIONS(1169),
    [anon_sym_volatile] = ACTIONS(1169),
    [anon_sym_restrict] = ACTIONS(1169),
    [anon_sym___restrict__] = ACTIONS(1169),
    [anon_sym__Atomic] = ACTIONS(1169),
    [anon_sym__Noreturn] = ACTIONS(1169),
    [anon_sym_noreturn] = ACTIONS(1169),
    [anon_sym__Nonnull] = ACTIONS(1169),
    [anon_sym_alignas] = ACTIONS(1169),
    [anon_sym__Alignas] = ACTIONS(1169),
    [sym_primitive_type] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [anon_sym_struct] = ACTIONS(1169),
    [anon_sym_union] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_do] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [anon_sym_goto] = ACTIONS(1169),
    [anon_sym___try] = ACTIONS(1169),
    [anon_sym___except] = ACTIONS(1169),
    [anon_sym___finally] = ACTIONS(1169),
    [anon_sym___leave] = ACTIONS(1169),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_sizeof] = ACTIONS(1169),
    [anon_sym___alignof__] = ACTIONS(1169),
    [anon_sym___alignof] = ACTIONS(1169),
    [anon_sym__alignof] = ACTIONS(1169),
    [anon_sym_alignof] = ACTIONS(1169),
    [anon_sym__Alignof] = ACTIONS(1169),
    [anon_sym_offsetof] = ACTIONS(1169),
    [anon_sym__Generic] = ACTIONS(1169),
    [anon_sym_asm] = ACTIONS(1169),
    [anon_sym___asm__] = ACTIONS(1169),
    [anon_sym___asm] = ACTIONS(1169),
    [sym_number_literal] = ACTIONS(1171),
    [anon_sym_L_SQUOTE] = ACTIONS(1171),
    [anon_sym_u_SQUOTE] = ACTIONS(1171),
    [anon_sym_U_SQUOTE] = ACTIONS(1171),
    [anon_sym_u8_SQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [anon_sym_L_DQUOTE] = ACTIONS(1171),
    [anon_sym_u_DQUOTE] = ACTIONS(1171),
    [anon_sym_U_DQUOTE] = ACTIONS(1171),
    [anon_sym_u8_DQUOTE] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [anon_sym_NULL] = ACTIONS(1169),
    [anon_sym_nullptr] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_identifier] = ACTIONS(1189),
    [aux_sym_preproc_include_token1] = ACTIONS(1189),
    [aux_sym_preproc_def_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token2] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1189),
    [aux_sym_preproc_else_token1] = ACTIONS(1189),
    [aux_sym_preproc_elif_token1] = ACTIONS(1189),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1189),
    [sym_preproc_directive] = ACTIONS(1189),
    [anon_sym_LPAREN2] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym___extension__] = ACTIONS(1189),
    [anon_sym_typedef] = ACTIONS(1189),
    [anon_sym_extern] = ACTIONS(1189),
    [anon_sym___attribute__] = ACTIONS(1189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1191),
    [anon_sym___declspec] = ACTIONS(1189),
    [anon_sym___cdecl] = ACTIONS(1189),
    [anon_sym___clrcall] = ACTIONS(1189),
    [anon_sym___stdcall] = ACTIONS(1189),
    [anon_sym___fastcall] = ACTIONS(1189),
    [anon_sym___thiscall] = ACTIONS(1189),
    [anon_sym___vectorcall] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_signed] = ACTIONS(1189),
    [anon_sym_unsigned] = ACTIONS(1189),
    [anon_sym_long] = ACTIONS(1189),
    [anon_sym_short] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_auto] = ACTIONS(1189),
    [anon_sym_register] = ACTIONS(1189),
    [anon_sym_inline] = ACTIONS(1189),
    [anon_sym___inline] = ACTIONS(1189),
    [anon_sym___inline__] = ACTIONS(1189),
    [anon_sym___forceinline] = ACTIONS(1189),
    [anon_sym_thread_local] = ACTIONS(1189),
    [anon_sym___thread] = ACTIONS(1189),
    [anon_sym_const] = ACTIONS(1189),
    [anon_sym_constexpr] = ACTIONS(1189),
    [anon_sym_volatile] = ACTIONS(1189),
    [anon_sym_restrict] = ACTIONS(1189),
    [anon_sym___restrict__] = ACTIONS(1189),
    [anon_sym__Atomic] = ACTIONS(1189),
    [anon_sym__Noreturn] = ACTIONS(1189),
    [anon_sym_noreturn] = ACTIONS(1189),
    [anon_sym__Nonnull] = ACTIONS(1189),
    [anon_sym_alignas] = ACTIONS(1189),
    [anon_sym__Alignas] = ACTIONS(1189),
    [sym_primitive_type] = ACTIONS(1189),
    [anon_sym_enum] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1189),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_do] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [anon_sym_goto] = ACTIONS(1189),
    [anon_sym___try] = ACTIONS(1189),
    [anon_sym___leave] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_sizeof] = ACTIONS(1189),
    [anon_sym___alignof__] = ACTIONS(1189),
    [anon_sym___alignof] = ACTIONS(1189),
    [anon_sym__alignof] = ACTIONS(1189),
    [anon_sym_alignof] = ACTIONS(1189),
    [anon_sym__Alignof] = ACTIONS(1189),
    [anon_sym_offsetof] = ACTIONS(1189),
    [anon_sym__Generic] = ACTIONS(1189),
    [anon_sym_asm] = ACTIONS(1189),
    [anon_sym___asm__] = ACTIONS(1189),
    [anon_sym___asm] = ACTIONS(1189),
    [sym_number_literal] = ACTIONS(1191),
    [anon_sym_L_SQUOTE] = ACTIONS(1191),
    [anon_sym_u_SQUOTE] = ACTIONS(1191),
    [anon_sym_U_SQUOTE] = ACTIONS(1191),
    [anon_sym_u8_SQUOTE] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [anon_sym_L_DQUOTE] = ACTIONS(1191),
    [anon_sym_u_DQUOTE] = ACTIONS(1191),
    [anon_sym_U_DQUOTE] = ACTIONS(1191),
    [anon_sym_u8_DQUOTE] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [sym_true] = ACTIONS(1189),
    [sym_false] = ACTIONS(1189),
    [anon_sym_NULL] = ACTIONS(1189),
    [anon_sym_nullptr] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_identifier] = ACTIONS(1189),
    [aux_sym_preproc_include_token1] = ACTIONS(1189),
    [aux_sym_preproc_def_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token2] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1189),
    [aux_sym_preproc_else_token1] = ACTIONS(1189),
    [aux_sym_preproc_elif_token1] = ACTIONS(1189),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1189),
    [sym_preproc_directive] = ACTIONS(1189),
    [anon_sym_LPAREN2] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym___extension__] = ACTIONS(1189),
    [anon_sym_typedef] = ACTIONS(1189),
    [anon_sym_extern] = ACTIONS(1189),
    [anon_sym___attribute__] = ACTIONS(1189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1191),
    [anon_sym___declspec] = ACTIONS(1189),
    [anon_sym___cdecl] = ACTIONS(1189),
    [anon_sym___clrcall] = ACTIONS(1189),
    [anon_sym___stdcall] = ACTIONS(1189),
    [anon_sym___fastcall] = ACTIONS(1189),
    [anon_sym___thiscall] = ACTIONS(1189),
    [anon_sym___vectorcall] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_signed] = ACTIONS(1189),
    [anon_sym_unsigned] = ACTIONS(1189),
    [anon_sym_long] = ACTIONS(1189),
    [anon_sym_short] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_auto] = ACTIONS(1189),
    [anon_sym_register] = ACTIONS(1189),
    [anon_sym_inline] = ACTIONS(1189),
    [anon_sym___inline] = ACTIONS(1189),
    [anon_sym___inline__] = ACTIONS(1189),
    [anon_sym___forceinline] = ACTIONS(1189),
    [anon_sym_thread_local] = ACTIONS(1189),
    [anon_sym___thread] = ACTIONS(1189),
    [anon_sym_const] = ACTIONS(1189),
    [anon_sym_constexpr] = ACTIONS(1189),
    [anon_sym_volatile] = ACTIONS(1189),
    [anon_sym_restrict] = ACTIONS(1189),
    [anon_sym___restrict__] = ACTIONS(1189),
    [anon_sym__Atomic] = ACTIONS(1189),
    [anon_sym__Noreturn] = ACTIONS(1189),
    [anon_sym_noreturn] = ACTIONS(1189),
    [anon_sym__Nonnull] = ACTIONS(1189),
    [anon_sym_alignas] = ACTIONS(1189),
    [anon_sym__Alignas] = ACTIONS(1189),
    [sym_primitive_type] = ACTIONS(1189),
    [anon_sym_enum] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1189),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_do] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [anon_sym_goto] = ACTIONS(1189),
    [anon_sym___try] = ACTIONS(1189),
    [anon_sym___leave] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_sizeof] = ACTIONS(1189),
    [anon_sym___alignof__] = ACTIONS(1189),
    [anon_sym___alignof] = ACTIONS(1189),
    [anon_sym__alignof] = ACTIONS(1189),
    [anon_sym_alignof] = ACTIONS(1189),
    [anon_sym__Alignof] = ACTIONS(1189),
    [anon_sym_offsetof] = ACTIONS(1189),
    [anon_sym__Generic] = ACTIONS(1189),
    [anon_sym_asm] = ACTIONS(1189),
    [anon_sym___asm__] = ACTIONS(1189),
    [anon_sym___asm] = ACTIONS(1189),
    [sym_number_literal] = ACTIONS(1191),
    [anon_sym_L_SQUOTE] = ACTIONS(1191),
    [anon_sym_u_SQUOTE] = ACTIONS(1191),
    [anon_sym_U_SQUOTE] = ACTIONS(1191),
    [anon_sym_u8_SQUOTE] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [anon_sym_L_DQUOTE] = ACTIONS(1191),
    [anon_sym_u_DQUOTE] = ACTIONS(1191),
    [anon_sym_U_DQUOTE] = ACTIONS(1191),
    [anon_sym_u8_DQUOTE] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [sym_true] = ACTIONS(1189),
    [sym_false] = ACTIONS(1189),
    [anon_sym_NULL] = ACTIONS(1189),
    [anon_sym_nullptr] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_identifier] = ACTIONS(1193),
    [aux_sym_preproc_include_token1] = ACTIONS(1193),
    [aux_sym_preproc_def_token1] = ACTIONS(1193),
    [aux_sym_preproc_if_token1] = ACTIONS(1193),
    [aux_sym_preproc_if_token2] = ACTIONS(1193),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1193),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1193),
    [aux_sym_preproc_else_token1] = ACTIONS(1193),
    [aux_sym_preproc_elif_token1] = ACTIONS(1193),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1193),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1193),
    [sym_preproc_directive] = ACTIONS(1193),
    [anon_sym_LPAREN2] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1195),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym___extension__] = ACTIONS(1193),
    [anon_sym_typedef] = ACTIONS(1193),
    [anon_sym_extern] = ACTIONS(1193),
    [anon_sym___attribute__] = ACTIONS(1193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1195),
    [anon_sym___declspec] = ACTIONS(1193),
    [anon_sym___cdecl] = ACTIONS(1193),
    [anon_sym___clrcall] = ACTIONS(1193),
    [anon_sym___stdcall] = ACTIONS(1193),
    [anon_sym___fastcall] = ACTIONS(1193),
    [anon_sym___thiscall] = ACTIONS(1193),
    [anon_sym___vectorcall] = ACTIONS(1193),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_signed] = ACTIONS(1193),
    [anon_sym_unsigned] = ACTIONS(1193),
    [anon_sym_long] = ACTIONS(1193),
    [anon_sym_short] = ACTIONS(1193),
    [anon_sym_static] = ACTIONS(1193),
    [anon_sym_auto] = ACTIONS(1193),
    [anon_sym_register] = ACTIONS(1193),
    [anon_sym_inline] = ACTIONS(1193),
    [anon_sym___inline] = ACTIONS(1193),
    [anon_sym___inline__] = ACTIONS(1193),
    [anon_sym___forceinline] = ACTIONS(1193),
    [anon_sym_thread_local] = ACTIONS(1193),
    [anon_sym___thread] = ACTIONS(1193),
    [anon_sym_const] = ACTIONS(1193),
    [anon_sym_constexpr] = ACTIONS(1193),
    [anon_sym_volatile] = ACTIONS(1193),
    [anon_sym_restrict] = ACTIONS(1193),
    [anon_sym___restrict__] = ACTIONS(1193),
    [anon_sym__Atomic] = ACTIONS(1193),
    [anon_sym__Noreturn] = ACTIONS(1193),
    [anon_sym_noreturn] = ACTIONS(1193),
    [anon_sym__Nonnull] = ACTIONS(1193),
    [anon_sym_alignas] = ACTIONS(1193),
    [anon_sym__Alignas] = ACTIONS(1193),
    [sym_primitive_type] = ACTIONS(1193),
    [anon_sym_enum] = ACTIONS(1193),
    [anon_sym_struct] = ACTIONS(1193),
    [anon_sym_union] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_switch] = ACTIONS(1193),
    [anon_sym_case] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1193),
    [anon_sym_while] = ACTIONS(1193),
    [anon_sym_do] = ACTIONS(1193),
    [anon_sym_for] = ACTIONS(1193),
    [anon_sym_return] = ACTIONS(1193),
    [anon_sym_break] = ACTIONS(1193),
    [anon_sym_continue] = ACTIONS(1193),
    [anon_sym_goto] = ACTIONS(1193),
    [anon_sym___try] = ACTIONS(1193),
    [anon_sym___leave] = ACTIONS(1193),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_sizeof] = ACTIONS(1193),
    [anon_sym___alignof__] = ACTIONS(1193),
    [anon_sym___alignof] = ACTIONS(1193),
    [anon_sym__alignof] = ACTIONS(1193),
    [anon_sym_alignof] = ACTIONS(1193),
    [anon_sym__Alignof] = ACTIONS(1193),
    [anon_sym_offsetof] = ACTIONS(1193),
    [anon_sym__Generic] = ACTIONS(1193),
    [anon_sym_asm] = ACTIONS(1193),
    [anon_sym___asm__] = ACTIONS(1193),
    [anon_sym___asm] = ACTIONS(1193),
    [sym_number_literal] = ACTIONS(1195),
    [anon_sym_L_SQUOTE] = ACTIONS(1195),
    [anon_sym_u_SQUOTE] = ACTIONS(1195),
    [anon_sym_U_SQUOTE] = ACTIONS(1195),
    [anon_sym_u8_SQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [anon_sym_L_DQUOTE] = ACTIONS(1195),
    [anon_sym_u_DQUOTE] = ACTIONS(1195),
    [anon_sym_U_DQUOTE] = ACTIONS(1195),
    [anon_sym_u8_DQUOTE] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [sym_true] = ACTIONS(1193),
    [sym_false] = ACTIONS(1193),
    [anon_sym_NULL] = ACTIONS(1193),
    [anon_sym_nullptr] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_identifier] = ACTIONS(1197),
    [aux_sym_preproc_include_token1] = ACTIONS(1197),
    [aux_sym_preproc_def_token1] = ACTIONS(1197),
    [aux_sym_preproc_if_token1] = ACTIONS(1197),
    [aux_sym_preproc_if_token2] = ACTIONS(1197),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1197),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1197),
    [aux_sym_preproc_else_token1] = ACTIONS(1197),
    [aux_sym_preproc_elif_token1] = ACTIONS(1197),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1197),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1197),
    [sym_preproc_directive] = ACTIONS(1197),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym___extension__] = ACTIONS(1197),
    [anon_sym_typedef] = ACTIONS(1197),
    [anon_sym_extern] = ACTIONS(1197),
    [anon_sym___attribute__] = ACTIONS(1197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1199),
    [anon_sym___declspec] = ACTIONS(1197),
    [anon_sym___cdecl] = ACTIONS(1197),
    [anon_sym___clrcall] = ACTIONS(1197),
    [anon_sym___stdcall] = ACTIONS(1197),
    [anon_sym___fastcall] = ACTIONS(1197),
    [anon_sym___thiscall] = ACTIONS(1197),
    [anon_sym___vectorcall] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_signed] = ACTIONS(1197),
    [anon_sym_unsigned] = ACTIONS(1197),
    [anon_sym_long] = ACTIONS(1197),
    [anon_sym_short] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_auto] = ACTIONS(1197),
    [anon_sym_register] = ACTIONS(1197),
    [anon_sym_inline] = ACTIONS(1197),
    [anon_sym___inline] = ACTIONS(1197),
    [anon_sym___inline__] = ACTIONS(1197),
    [anon_sym___forceinline] = ACTIONS(1197),
    [anon_sym_thread_local] = ACTIONS(1197),
    [anon_sym___thread] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_constexpr] = ACTIONS(1197),
    [anon_sym_volatile] = ACTIONS(1197),
    [anon_sym_restrict] = ACTIONS(1197),
    [anon_sym___restrict__] = ACTIONS(1197),
    [anon_sym__Atomic] = ACTIONS(1197),
    [anon_sym__Noreturn] = ACTIONS(1197),
    [anon_sym_noreturn] = ACTIONS(1197),
    [anon_sym__Nonnull] = ACTIONS(1197),
    [anon_sym_alignas] = ACTIONS(1197),
    [anon_sym__Alignas] = ACTIONS(1197),
    [sym_primitive_type] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [anon_sym_struct] = ACTIONS(1197),
    [anon_sym_union] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_goto] = ACTIONS(1197),
    [anon_sym___try] = ACTIONS(1197),
    [anon_sym___leave] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1197),
    [anon_sym___alignof__] = ACTIONS(1197),
    [anon_sym___alignof] = ACTIONS(1197),
    [anon_sym__alignof] = ACTIONS(1197),
    [anon_sym_alignof] = ACTIONS(1197),
    [anon_sym__Alignof] = ACTIONS(1197),
    [anon_sym_offsetof] = ACTIONS(1197),
    [anon_sym__Generic] = ACTIONS(1197),
    [anon_sym_asm] = ACTIONS(1197),
    [anon_sym___asm__] = ACTIONS(1197),
    [anon_sym___asm] = ACTIONS(1197),
    [sym_number_literal] = ACTIONS(1199),
    [anon_sym_L_SQUOTE] = ACTIONS(1199),
    [anon_sym_u_SQUOTE] = ACTIONS(1199),
    [anon_sym_U_SQUOTE] = ACTIONS(1199),
    [anon_sym_u8_SQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [anon_sym_L_DQUOTE] = ACTIONS(1199),
    [anon_sym_u_DQUOTE] = ACTIONS(1199),
    [anon_sym_U_DQUOTE] = ACTIONS(1199),
    [anon_sym_u8_DQUOTE] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [anon_sym_NULL] = ACTIONS(1197),
    [anon_sym_nullptr] = ACTIONS(1197),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1201),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token2] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1201),
    [aux_sym_preproc_else_token1] = ACTIONS(1201),
    [aux_sym_preproc_elif_token1] = ACTIONS(1201),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1201),
    [sym_preproc_directive] = ACTIONS(1201),
    [anon_sym_LPAREN2] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym___extension__] = ACTIONS(1201),
    [anon_sym_typedef] = ACTIONS(1201),
    [anon_sym_extern] = ACTIONS(1201),
    [anon_sym___attribute__] = ACTIONS(1201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1203),
    [anon_sym___declspec] = ACTIONS(1201),
    [anon_sym___cdecl] = ACTIONS(1201),
    [anon_sym___clrcall] = ACTIONS(1201),
    [anon_sym___stdcall] = ACTIONS(1201),
    [anon_sym___fastcall] = ACTIONS(1201),
    [anon_sym___thiscall] = ACTIONS(1201),
    [anon_sym___vectorcall] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_signed] = ACTIONS(1201),
    [anon_sym_unsigned] = ACTIONS(1201),
    [anon_sym_long] = ACTIONS(1201),
    [anon_sym_short] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_auto] = ACTIONS(1201),
    [anon_sym_register] = ACTIONS(1201),
    [anon_sym_inline] = ACTIONS(1201),
    [anon_sym___inline] = ACTIONS(1201),
    [anon_sym___inline__] = ACTIONS(1201),
    [anon_sym___forceinline] = ACTIONS(1201),
    [anon_sym_thread_local] = ACTIONS(1201),
    [anon_sym___thread] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_constexpr] = ACTIONS(1201),
    [anon_sym_volatile] = ACTIONS(1201),
    [anon_sym_restrict] = ACTIONS(1201),
    [anon_sym___restrict__] = ACTIONS(1201),
    [anon_sym__Atomic] = ACTIONS(1201),
    [anon_sym__Noreturn] = ACTIONS(1201),
    [anon_sym_noreturn] = ACTIONS(1201),
    [anon_sym__Nonnull] = ACTIONS(1201),
    [anon_sym_alignas] = ACTIONS(1201),
    [anon_sym__Alignas] = ACTIONS(1201),
    [sym_primitive_type] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1201),
    [anon_sym_union] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_goto] = ACTIONS(1201),
    [anon_sym___try] = ACTIONS(1201),
    [anon_sym___leave] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1203),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym___alignof__] = ACTIONS(1201),
    [anon_sym___alignof] = ACTIONS(1201),
    [anon_sym__alignof] = ACTIONS(1201),
    [anon_sym_alignof] = ACTIONS(1201),
    [anon_sym__Alignof] = ACTIONS(1201),
    [anon_sym_offsetof] = ACTIONS(1201),
    [anon_sym__Generic] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1201),
    [anon_sym___asm__] = ACTIONS(1201),
    [anon_sym___asm] = ACTIONS(1201),
    [sym_number_literal] = ACTIONS(1203),
    [anon_sym_L_SQUOTE] = ACTIONS(1203),
    [anon_sym_u_SQUOTE] = ACTIONS(1203),
    [anon_sym_U_SQUOTE] = ACTIONS(1203),
    [anon_sym_u8_SQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [anon_sym_L_DQUOTE] = ACTIONS(1203),
    [anon_sym_u_DQUOTE] = ACTIONS(1203),
    [anon_sym_U_DQUOTE] = ACTIONS(1203),
    [anon_sym_u8_DQUOTE] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [anon_sym_NULL] = ACTIONS(1201),
    [anon_sym_nullptr] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1201),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token2] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1201),
    [aux_sym_preproc_else_token1] = ACTIONS(1201),
    [aux_sym_preproc_elif_token1] = ACTIONS(1201),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1201),
    [sym_preproc_directive] = ACTIONS(1201),
    [anon_sym_LPAREN2] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym___extension__] = ACTIONS(1201),
    [anon_sym_typedef] = ACTIONS(1201),
    [anon_sym_extern] = ACTIONS(1201),
    [anon_sym___attribute__] = ACTIONS(1201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1203),
    [anon_sym___declspec] = ACTIONS(1201),
    [anon_sym___cdecl] = ACTIONS(1201),
    [anon_sym___clrcall] = ACTIONS(1201),
    [anon_sym___stdcall] = ACTIONS(1201),
    [anon_sym___fastcall] = ACTIONS(1201),
    [anon_sym___thiscall] = ACTIONS(1201),
    [anon_sym___vectorcall] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_signed] = ACTIONS(1201),
    [anon_sym_unsigned] = ACTIONS(1201),
    [anon_sym_long] = ACTIONS(1201),
    [anon_sym_short] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_auto] = ACTIONS(1201),
    [anon_sym_register] = ACTIONS(1201),
    [anon_sym_inline] = ACTIONS(1201),
    [anon_sym___inline] = ACTIONS(1201),
    [anon_sym___inline__] = ACTIONS(1201),
    [anon_sym___forceinline] = ACTIONS(1201),
    [anon_sym_thread_local] = ACTIONS(1201),
    [anon_sym___thread] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_constexpr] = ACTIONS(1201),
    [anon_sym_volatile] = ACTIONS(1201),
    [anon_sym_restrict] = ACTIONS(1201),
    [anon_sym___restrict__] = ACTIONS(1201),
    [anon_sym__Atomic] = ACTIONS(1201),
    [anon_sym__Noreturn] = ACTIONS(1201),
    [anon_sym_noreturn] = ACTIONS(1201),
    [anon_sym__Nonnull] = ACTIONS(1201),
    [anon_sym_alignas] = ACTIONS(1201),
    [anon_sym__Alignas] = ACTIONS(1201),
    [sym_primitive_type] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1201),
    [anon_sym_union] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_goto] = ACTIONS(1201),
    [anon_sym___try] = ACTIONS(1201),
    [anon_sym___leave] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1203),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym___alignof__] = ACTIONS(1201),
    [anon_sym___alignof] = ACTIONS(1201),
    [anon_sym__alignof] = ACTIONS(1201),
    [anon_sym_alignof] = ACTIONS(1201),
    [anon_sym__Alignof] = ACTIONS(1201),
    [anon_sym_offsetof] = ACTIONS(1201),
    [anon_sym__Generic] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1201),
    [anon_sym___asm__] = ACTIONS(1201),
    [anon_sym___asm] = ACTIONS(1201),
    [sym_number_literal] = ACTIONS(1203),
    [anon_sym_L_SQUOTE] = ACTIONS(1203),
    [anon_sym_u_SQUOTE] = ACTIONS(1203),
    [anon_sym_U_SQUOTE] = ACTIONS(1203),
    [anon_sym_u8_SQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [anon_sym_L_DQUOTE] = ACTIONS(1203),
    [anon_sym_u_DQUOTE] = ACTIONS(1203),
    [anon_sym_U_DQUOTE] = ACTIONS(1203),
    [anon_sym_u8_DQUOTE] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [anon_sym_NULL] = ACTIONS(1201),
    [anon_sym_nullptr] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1205),
    [aux_sym_preproc_def_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token2] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1205),
    [aux_sym_preproc_else_token1] = ACTIONS(1205),
    [aux_sym_preproc_elif_token1] = ACTIONS(1205),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1205),
    [sym_preproc_directive] = ACTIONS(1205),
    [anon_sym_LPAREN2] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(1205),
    [anon_sym_typedef] = ACTIONS(1205),
    [anon_sym_extern] = ACTIONS(1205),
    [anon_sym___attribute__] = ACTIONS(1205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1207),
    [anon_sym___declspec] = ACTIONS(1205),
    [anon_sym___cdecl] = ACTIONS(1205),
    [anon_sym___clrcall] = ACTIONS(1205),
    [anon_sym___stdcall] = ACTIONS(1205),
    [anon_sym___fastcall] = ACTIONS(1205),
    [anon_sym___thiscall] = ACTIONS(1205),
    [anon_sym___vectorcall] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_signed] = ACTIONS(1205),
    [anon_sym_unsigned] = ACTIONS(1205),
    [anon_sym_long] = ACTIONS(1205),
    [anon_sym_short] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_auto] = ACTIONS(1205),
    [anon_sym_register] = ACTIONS(1205),
    [anon_sym_inline] = ACTIONS(1205),
    [anon_sym___inline] = ACTIONS(1205),
    [anon_sym___inline__] = ACTIONS(1205),
    [anon_sym___forceinline] = ACTIONS(1205),
    [anon_sym_thread_local] = ACTIONS(1205),
    [anon_sym___thread] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_constexpr] = ACTIONS(1205),
    [anon_sym_volatile] = ACTIONS(1205),
    [anon_sym_restrict] = ACTIONS(1205),
    [anon_sym___restrict__] = ACTIONS(1205),
    [anon_sym__Atomic] = ACTIONS(1205),
    [anon_sym__Noreturn] = ACTIONS(1205),
    [anon_sym_noreturn] = ACTIONS(1205),
    [anon_sym__Nonnull] = ACTIONS(1205),
    [anon_sym_alignas] = ACTIONS(1205),
    [anon_sym__Alignas] = ACTIONS(1205),
    [sym_primitive_type] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_do] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_goto] = ACTIONS(1205),
    [anon_sym___try] = ACTIONS(1205),
    [anon_sym___leave] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1207),
    [anon_sym_sizeof] = ACTIONS(1205),
    [anon_sym___alignof__] = ACTIONS(1205),
    [anon_sym___alignof] = ACTIONS(1205),
    [anon_sym__alignof] = ACTIONS(1205),
    [anon_sym_alignof] = ACTIONS(1205),
    [anon_sym__Alignof] = ACTIONS(1205),
    [anon_sym_offsetof] = ACTIONS(1205),
    [anon_sym__Generic] = ACTIONS(1205),
    [anon_sym_asm] = ACTIONS(1205),
    [anon_sym___asm__] = ACTIONS(1205),
    [anon_sym___asm] = ACTIONS(1205),
    [sym_number_literal] = ACTIONS(1207),
    [anon_sym_L_SQUOTE] = ACTIONS(1207),
    [anon_sym_u_SQUOTE] = ACTIONS(1207),
    [anon_sym_U_SQUOTE] = ACTIONS(1207),
    [anon_sym_u8_SQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [anon_sym_L_DQUOTE] = ACTIONS(1207),
    [anon_sym_u_DQUOTE] = ACTIONS(1207),
    [anon_sym_U_DQUOTE] = ACTIONS(1207),
    [anon_sym_u8_DQUOTE] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [anon_sym_NULL] = ACTIONS(1205),
    [anon_sym_nullptr] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1205),
    [aux_sym_preproc_def_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token2] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1205),
    [aux_sym_preproc_else_token1] = ACTIONS(1205),
    [aux_sym_preproc_elif_token1] = ACTIONS(1205),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1205),
    [sym_preproc_directive] = ACTIONS(1205),
    [anon_sym_LPAREN2] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(1205),
    [anon_sym_typedef] = ACTIONS(1205),
    [anon_sym_extern] = ACTIONS(1205),
    [anon_sym___attribute__] = ACTIONS(1205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1207),
    [anon_sym___declspec] = ACTIONS(1205),
    [anon_sym___cdecl] = ACTIONS(1205),
    [anon_sym___clrcall] = ACTIONS(1205),
    [anon_sym___stdcall] = ACTIONS(1205),
    [anon_sym___fastcall] = ACTIONS(1205),
    [anon_sym___thiscall] = ACTIONS(1205),
    [anon_sym___vectorcall] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_signed] = ACTIONS(1205),
    [anon_sym_unsigned] = ACTIONS(1205),
    [anon_sym_long] = ACTIONS(1205),
    [anon_sym_short] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_auto] = ACTIONS(1205),
    [anon_sym_register] = ACTIONS(1205),
    [anon_sym_inline] = ACTIONS(1205),
    [anon_sym___inline] = ACTIONS(1205),
    [anon_sym___inline__] = ACTIONS(1205),
    [anon_sym___forceinline] = ACTIONS(1205),
    [anon_sym_thread_local] = ACTIONS(1205),
    [anon_sym___thread] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_constexpr] = ACTIONS(1205),
    [anon_sym_volatile] = ACTIONS(1205),
    [anon_sym_restrict] = ACTIONS(1205),
    [anon_sym___restrict__] = ACTIONS(1205),
    [anon_sym__Atomic] = ACTIONS(1205),
    [anon_sym__Noreturn] = ACTIONS(1205),
    [anon_sym_noreturn] = ACTIONS(1205),
    [anon_sym__Nonnull] = ACTIONS(1205),
    [anon_sym_alignas] = ACTIONS(1205),
    [anon_sym__Alignas] = ACTIONS(1205),
    [sym_primitive_type] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_do] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_goto] = ACTIONS(1205),
    [anon_sym___try] = ACTIONS(1205),
    [anon_sym___leave] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1207),
    [anon_sym_sizeof] = ACTIONS(1205),
    [anon_sym___alignof__] = ACTIONS(1205),
    [anon_sym___alignof] = ACTIONS(1205),
    [anon_sym__alignof] = ACTIONS(1205),
    [anon_sym_alignof] = ACTIONS(1205),
    [anon_sym__Alignof] = ACTIONS(1205),
    [anon_sym_offsetof] = ACTIONS(1205),
    [anon_sym__Generic] = ACTIONS(1205),
    [anon_sym_asm] = ACTIONS(1205),
    [anon_sym___asm__] = ACTIONS(1205),
    [anon_sym___asm] = ACTIONS(1205),
    [sym_number_literal] = ACTIONS(1207),
    [anon_sym_L_SQUOTE] = ACTIONS(1207),
    [anon_sym_u_SQUOTE] = ACTIONS(1207),
    [anon_sym_U_SQUOTE] = ACTIONS(1207),
    [anon_sym_u8_SQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [anon_sym_L_DQUOTE] = ACTIONS(1207),
    [anon_sym_u_DQUOTE] = ACTIONS(1207),
    [anon_sym_U_DQUOTE] = ACTIONS(1207),
    [anon_sym_u8_DQUOTE] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [anon_sym_NULL] = ACTIONS(1205),
    [anon_sym_nullptr] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_identifier] = ACTIONS(1209),
    [aux_sym_preproc_include_token1] = ACTIONS(1209),
    [aux_sym_preproc_def_token1] = ACTIONS(1209),
    [aux_sym_preproc_if_token1] = ACTIONS(1209),
    [aux_sym_preproc_if_token2] = ACTIONS(1209),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1209),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1209),
    [aux_sym_preproc_else_token1] = ACTIONS(1209),
    [aux_sym_preproc_elif_token1] = ACTIONS(1209),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1209),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1209),
    [sym_preproc_directive] = ACTIONS(1209),
    [anon_sym_LPAREN2] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1209),
    [anon_sym_PLUS] = ACTIONS(1209),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1209),
    [anon_sym_typedef] = ACTIONS(1209),
    [anon_sym_extern] = ACTIONS(1209),
    [anon_sym___attribute__] = ACTIONS(1209),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1211),
    [anon_sym___declspec] = ACTIONS(1209),
    [anon_sym___cdecl] = ACTIONS(1209),
    [anon_sym___clrcall] = ACTIONS(1209),
    [anon_sym___stdcall] = ACTIONS(1209),
    [anon_sym___fastcall] = ACTIONS(1209),
    [anon_sym___thiscall] = ACTIONS(1209),
    [anon_sym___vectorcall] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1211),
    [anon_sym_signed] = ACTIONS(1209),
    [anon_sym_unsigned] = ACTIONS(1209),
    [anon_sym_long] = ACTIONS(1209),
    [anon_sym_short] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1209),
    [anon_sym_auto] = ACTIONS(1209),
    [anon_sym_register] = ACTIONS(1209),
    [anon_sym_inline] = ACTIONS(1209),
    [anon_sym___inline] = ACTIONS(1209),
    [anon_sym___inline__] = ACTIONS(1209),
    [anon_sym___forceinline] = ACTIONS(1209),
    [anon_sym_thread_local] = ACTIONS(1209),
    [anon_sym___thread] = ACTIONS(1209),
    [anon_sym_const] = ACTIONS(1209),
    [anon_sym_constexpr] = ACTIONS(1209),
    [anon_sym_volatile] = ACTIONS(1209),
    [anon_sym_restrict] = ACTIONS(1209),
    [anon_sym___restrict__] = ACTIONS(1209),
    [anon_sym__Atomic] = ACTIONS(1209),
    [anon_sym__Noreturn] = ACTIONS(1209),
    [anon_sym_noreturn] = ACTIONS(1209),
    [anon_sym__Nonnull] = ACTIONS(1209),
    [anon_sym_alignas] = ACTIONS(1209),
    [anon_sym__Alignas] = ACTIONS(1209),
    [sym_primitive_type] = ACTIONS(1209),
    [anon_sym_enum] = ACTIONS(1209),
    [anon_sym_struct] = ACTIONS(1209),
    [anon_sym_union] = ACTIONS(1209),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_else] = ACTIONS(1209),
    [anon_sym_switch] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1209),
    [anon_sym_default] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(1209),
    [anon_sym_do] = ACTIONS(1209),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_return] = ACTIONS(1209),
    [anon_sym_break] = ACTIONS(1209),
    [anon_sym_continue] = ACTIONS(1209),
    [anon_sym_goto] = ACTIONS(1209),
    [anon_sym___try] = ACTIONS(1209),
    [anon_sym___leave] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_sizeof] = ACTIONS(1209),
    [anon_sym___alignof__] = ACTIONS(1209),
    [anon_sym___alignof] = ACTIONS(1209),
    [anon_sym__alignof] = ACTIONS(1209),
    [anon_sym_alignof] = ACTIONS(1209),
    [anon_sym__Alignof] = ACTIONS(1209),
    [anon_sym_offsetof] = ACTIONS(1209),
    [anon_sym__Generic] = ACTIONS(1209),
    [anon_sym_asm] = ACTIONS(1209),
    [anon_sym___asm__] = ACTIONS(1209),
    [anon_sym___asm] = ACTIONS(1209),
    [sym_number_literal] = ACTIONS(1211),
    [anon_sym_L_SQUOTE] = ACTIONS(1211),
    [anon_sym_u_SQUOTE] = ACTIONS(1211),
    [anon_sym_U_SQUOTE] = ACTIONS(1211),
    [anon_sym_u8_SQUOTE] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [anon_sym_L_DQUOTE] = ACTIONS(1211),
    [anon_sym_u_DQUOTE] = ACTIONS(1211),
    [anon_sym_U_DQUOTE] = ACTIONS(1211),
    [anon_sym_u8_DQUOTE] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(1211),
    [sym_true] = ACTIONS(1209),
    [sym_false] = ACTIONS(1209),
    [anon_sym_NULL] = ACTIONS(1209),
    [anon_sym_nullptr] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_identifier] = ACTIONS(1213),
    [aux_sym_preproc_include_token1] = ACTIONS(1213),
    [aux_sym_preproc_def_token1] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1213),
    [aux_sym_preproc_if_token2] = ACTIONS(1213),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1213),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1213),
    [aux_sym_preproc_else_token1] = ACTIONS(1213),
    [aux_sym_preproc_elif_token1] = ACTIONS(1213),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1213),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1213),
    [sym_preproc_directive] = ACTIONS(1213),
    [anon_sym_LPAREN2] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1215),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1213),
    [anon_sym_extern] = ACTIONS(1213),
    [anon_sym___attribute__] = ACTIONS(1213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1215),
    [anon_sym___declspec] = ACTIONS(1213),
    [anon_sym___cdecl] = ACTIONS(1213),
    [anon_sym___clrcall] = ACTIONS(1213),
    [anon_sym___stdcall] = ACTIONS(1213),
    [anon_sym___fastcall] = ACTIONS(1213),
    [anon_sym___thiscall] = ACTIONS(1213),
    [anon_sym___vectorcall] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_signed] = ACTIONS(1213),
    [anon_sym_unsigned] = ACTIONS(1213),
    [anon_sym_long] = ACTIONS(1213),
    [anon_sym_short] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_auto] = ACTIONS(1213),
    [anon_sym_register] = ACTIONS(1213),
    [anon_sym_inline] = ACTIONS(1213),
    [anon_sym___inline] = ACTIONS(1213),
    [anon_sym___inline__] = ACTIONS(1213),
    [anon_sym___forceinline] = ACTIONS(1213),
    [anon_sym_thread_local] = ACTIONS(1213),
    [anon_sym___thread] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1213),
    [anon_sym_constexpr] = ACTIONS(1213),
    [anon_sym_volatile] = ACTIONS(1213),
    [anon_sym_restrict] = ACTIONS(1213),
    [anon_sym___restrict__] = ACTIONS(1213),
    [anon_sym__Atomic] = ACTIONS(1213),
    [anon_sym__Noreturn] = ACTIONS(1213),
    [anon_sym_noreturn] = ACTIONS(1213),
    [anon_sym__Nonnull] = ACTIONS(1213),
    [anon_sym_alignas] = ACTIONS(1213),
    [anon_sym__Alignas] = ACTIONS(1213),
    [sym_primitive_type] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1213),
    [anon_sym_struct] = ACTIONS(1213),
    [anon_sym_union] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1213),
    [anon_sym_else] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1213),
    [anon_sym_default] = ACTIONS(1213),
    [anon_sym_while] = ACTIONS(1213),
    [anon_sym_do] = ACTIONS(1213),
    [anon_sym_for] = ACTIONS(1213),
    [anon_sym_return] = ACTIONS(1213),
    [anon_sym_break] = ACTIONS(1213),
    [anon_sym_continue] = ACTIONS(1213),
    [anon_sym_goto] = ACTIONS(1213),
    [anon_sym___try] = ACTIONS(1213),
    [anon_sym___leave] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_sizeof] = ACTIONS(1213),
    [anon_sym___alignof__] = ACTIONS(1213),
    [anon_sym___alignof] = ACTIONS(1213),
    [anon_sym__alignof] = ACTIONS(1213),
    [anon_sym_alignof] = ACTIONS(1213),
    [anon_sym__Alignof] = ACTIONS(1213),
    [anon_sym_offsetof] = ACTIONS(1213),
    [anon_sym__Generic] = ACTIONS(1213),
    [anon_sym_asm] = ACTIONS(1213),
    [anon_sym___asm__] = ACTIONS(1213),
    [anon_sym___asm] = ACTIONS(1213),
    [sym_number_literal] = ACTIONS(1215),
    [anon_sym_L_SQUOTE] = ACTIONS(1215),
    [anon_sym_u_SQUOTE] = ACTIONS(1215),
    [anon_sym_U_SQUOTE] = ACTIONS(1215),
    [anon_sym_u8_SQUOTE] = ACTIONS(1215),
    [anon_sym_SQUOTE] = ACTIONS(1215),
    [anon_sym_L_DQUOTE] = ACTIONS(1215),
    [anon_sym_u_DQUOTE] = ACTIONS(1215),
    [anon_sym_U_DQUOTE] = ACTIONS(1215),
    [anon_sym_u8_DQUOTE] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1215),
    [sym_true] = ACTIONS(1213),
    [sym_false] = ACTIONS(1213),
    [anon_sym_NULL] = ACTIONS(1213),
    [anon_sym_nullptr] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_identifier] = ACTIONS(1217),
    [aux_sym_preproc_include_token1] = ACTIONS(1217),
    [aux_sym_preproc_def_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token2] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1217),
    [aux_sym_preproc_else_token1] = ACTIONS(1217),
    [aux_sym_preproc_elif_token1] = ACTIONS(1217),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1217),
    [sym_preproc_directive] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1219),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym___extension__] = ACTIONS(1217),
    [anon_sym_typedef] = ACTIONS(1217),
    [anon_sym_extern] = ACTIONS(1217),
    [anon_sym___attribute__] = ACTIONS(1217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1219),
    [anon_sym___declspec] = ACTIONS(1217),
    [anon_sym___cdecl] = ACTIONS(1217),
    [anon_sym___clrcall] = ACTIONS(1217),
    [anon_sym___stdcall] = ACTIONS(1217),
    [anon_sym___fastcall] = ACTIONS(1217),
    [anon_sym___thiscall] = ACTIONS(1217),
    [anon_sym___vectorcall] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(1217),
    [anon_sym_unsigned] = ACTIONS(1217),
    [anon_sym_long] = ACTIONS(1217),
    [anon_sym_short] = ACTIONS(1217),
    [anon_sym_static] = ACTIONS(1217),
    [anon_sym_auto] = ACTIONS(1217),
    [anon_sym_register] = ACTIONS(1217),
    [anon_sym_inline] = ACTIONS(1217),
    [anon_sym___inline] = ACTIONS(1217),
    [anon_sym___inline__] = ACTIONS(1217),
    [anon_sym___forceinline] = ACTIONS(1217),
    [anon_sym_thread_local] = ACTIONS(1217),
    [anon_sym___thread] = ACTIONS(1217),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_constexpr] = ACTIONS(1217),
    [anon_sym_volatile] = ACTIONS(1217),
    [anon_sym_restrict] = ACTIONS(1217),
    [anon_sym___restrict__] = ACTIONS(1217),
    [anon_sym__Atomic] = ACTIONS(1217),
    [anon_sym__Noreturn] = ACTIONS(1217),
    [anon_sym_noreturn] = ACTIONS(1217),
    [anon_sym__Nonnull] = ACTIONS(1217),
    [anon_sym_alignas] = ACTIONS(1217),
    [anon_sym__Alignas] = ACTIONS(1217),
    [sym_primitive_type] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1217),
    [anon_sym_struct] = ACTIONS(1217),
    [anon_sym_union] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1217),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(1217),
    [anon_sym_case] = ACTIONS(1217),
    [anon_sym_default] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(1217),
    [anon_sym_do] = ACTIONS(1217),
    [anon_sym_for] = ACTIONS(1217),
    [anon_sym_return] = ACTIONS(1217),
    [anon_sym_break] = ACTIONS(1217),
    [anon_sym_continue] = ACTIONS(1217),
    [anon_sym_goto] = ACTIONS(1217),
    [anon_sym___try] = ACTIONS(1217),
    [anon_sym___leave] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1219),
    [anon_sym_sizeof] = ACTIONS(1217),
    [anon_sym___alignof__] = ACTIONS(1217),
    [anon_sym___alignof] = ACTIONS(1217),
    [anon_sym__alignof] = ACTIONS(1217),
    [anon_sym_alignof] = ACTIONS(1217),
    [anon_sym__Alignof] = ACTIONS(1217),
    [anon_sym_offsetof] = ACTIONS(1217),
    [anon_sym__Generic] = ACTIONS(1217),
    [anon_sym_asm] = ACTIONS(1217),
    [anon_sym___asm__] = ACTIONS(1217),
    [anon_sym___asm] = ACTIONS(1217),
    [sym_number_literal] = ACTIONS(1219),
    [anon_sym_L_SQUOTE] = ACTIONS(1219),
    [anon_sym_u_SQUOTE] = ACTIONS(1219),
    [anon_sym_U_SQUOTE] = ACTIONS(1219),
    [anon_sym_u8_SQUOTE] = ACTIONS(1219),
    [anon_sym_SQUOTE] = ACTIONS(1219),
    [anon_sym_L_DQUOTE] = ACTIONS(1219),
    [anon_sym_u_DQUOTE] = ACTIONS(1219),
    [anon_sym_U_DQUOTE] = ACTIONS(1219),
    [anon_sym_u8_DQUOTE] = ACTIONS(1219),
    [anon_sym_DQUOTE] = ACTIONS(1219),
    [sym_true] = ACTIONS(1217),
    [sym_false] = ACTIONS(1217),
    [anon_sym_NULL] = ACTIONS(1217),
    [anon_sym_nullptr] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_identifier] = ACTIONS(1221),
    [aux_sym_preproc_include_token1] = ACTIONS(1221),
    [aux_sym_preproc_def_token1] = ACTIONS(1221),
    [aux_sym_preproc_if_token1] = ACTIONS(1221),
    [aux_sym_preproc_if_token2] = ACTIONS(1221),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1221),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1221),
    [aux_sym_preproc_else_token1] = ACTIONS(1221),
    [aux_sym_preproc_elif_token1] = ACTIONS(1221),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1221),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1221),
    [sym_preproc_directive] = ACTIONS(1221),
    [anon_sym_LPAREN2] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym___extension__] = ACTIONS(1221),
    [anon_sym_typedef] = ACTIONS(1221),
    [anon_sym_extern] = ACTIONS(1221),
    [anon_sym___attribute__] = ACTIONS(1221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1223),
    [anon_sym___declspec] = ACTIONS(1221),
    [anon_sym___cdecl] = ACTIONS(1221),
    [anon_sym___clrcall] = ACTIONS(1221),
    [anon_sym___stdcall] = ACTIONS(1221),
    [anon_sym___fastcall] = ACTIONS(1221),
    [anon_sym___thiscall] = ACTIONS(1221),
    [anon_sym___vectorcall] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_signed] = ACTIONS(1221),
    [anon_sym_unsigned] = ACTIONS(1221),
    [anon_sym_long] = ACTIONS(1221),
    [anon_sym_short] = ACTIONS(1221),
    [anon_sym_static] = ACTIONS(1221),
    [anon_sym_auto] = ACTIONS(1221),
    [anon_sym_register] = ACTIONS(1221),
    [anon_sym_inline] = ACTIONS(1221),
    [anon_sym___inline] = ACTIONS(1221),
    [anon_sym___inline__] = ACTIONS(1221),
    [anon_sym___forceinline] = ACTIONS(1221),
    [anon_sym_thread_local] = ACTIONS(1221),
    [anon_sym___thread] = ACTIONS(1221),
    [anon_sym_const] = ACTIONS(1221),
    [anon_sym_constexpr] = ACTIONS(1221),
    [anon_sym_volatile] = ACTIONS(1221),
    [anon_sym_restrict] = ACTIONS(1221),
    [anon_sym___restrict__] = ACTIONS(1221),
    [anon_sym__Atomic] = ACTIONS(1221),
    [anon_sym__Noreturn] = ACTIONS(1221),
    [anon_sym_noreturn] = ACTIONS(1221),
    [anon_sym__Nonnull] = ACTIONS(1221),
    [anon_sym_alignas] = ACTIONS(1221),
    [anon_sym__Alignas] = ACTIONS(1221),
    [sym_primitive_type] = ACTIONS(1221),
    [anon_sym_enum] = ACTIONS(1221),
    [anon_sym_struct] = ACTIONS(1221),
    [anon_sym_union] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1221),
    [anon_sym_else] = ACTIONS(1221),
    [anon_sym_switch] = ACTIONS(1221),
    [anon_sym_case] = ACTIONS(1221),
    [anon_sym_default] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1221),
    [anon_sym_do] = ACTIONS(1221),
    [anon_sym_for] = ACTIONS(1221),
    [anon_sym_return] = ACTIONS(1221),
    [anon_sym_break] = ACTIONS(1221),
    [anon_sym_continue] = ACTIONS(1221),
    [anon_sym_goto] = ACTIONS(1221),
    [anon_sym___try] = ACTIONS(1221),
    [anon_sym___leave] = ACTIONS(1221),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_sizeof] = ACTIONS(1221),
    [anon_sym___alignof__] = ACTIONS(1221),
    [anon_sym___alignof] = ACTIONS(1221),
    [anon_sym__alignof] = ACTIONS(1221),
    [anon_sym_alignof] = ACTIONS(1221),
    [anon_sym__Alignof] = ACTIONS(1221),
    [anon_sym_offsetof] = ACTIONS(1221),
    [anon_sym__Generic] = ACTIONS(1221),
    [anon_sym_asm] = ACTIONS(1221),
    [anon_sym___asm__] = ACTIONS(1221),
    [anon_sym___asm] = ACTIONS(1221),
    [sym_number_literal] = ACTIONS(1223),
    [anon_sym_L_SQUOTE] = ACTIONS(1223),
    [anon_sym_u_SQUOTE] = ACTIONS(1223),
    [anon_sym_U_SQUOTE] = ACTIONS(1223),
    [anon_sym_u8_SQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [anon_sym_L_DQUOTE] = ACTIONS(1223),
    [anon_sym_u_DQUOTE] = ACTIONS(1223),
    [anon_sym_U_DQUOTE] = ACTIONS(1223),
    [anon_sym_u8_DQUOTE] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [anon_sym_NULL] = ACTIONS(1221),
    [anon_sym_nullptr] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_identifier] = ACTIONS(1225),
    [aux_sym_preproc_include_token1] = ACTIONS(1225),
    [aux_sym_preproc_def_token1] = ACTIONS(1225),
    [aux_sym_preproc_if_token1] = ACTIONS(1225),
    [aux_sym_preproc_if_token2] = ACTIONS(1225),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1225),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1225),
    [aux_sym_preproc_else_token1] = ACTIONS(1225),
    [aux_sym_preproc_elif_token1] = ACTIONS(1225),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1225),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1225),
    [sym_preproc_directive] = ACTIONS(1225),
    [anon_sym_LPAREN2] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym___extension__] = ACTIONS(1225),
    [anon_sym_typedef] = ACTIONS(1225),
    [anon_sym_extern] = ACTIONS(1225),
    [anon_sym___attribute__] = ACTIONS(1225),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym___declspec] = ACTIONS(1225),
    [anon_sym___cdecl] = ACTIONS(1225),
    [anon_sym___clrcall] = ACTIONS(1225),
    [anon_sym___stdcall] = ACTIONS(1225),
    [anon_sym___fastcall] = ACTIONS(1225),
    [anon_sym___thiscall] = ACTIONS(1225),
    [anon_sym___vectorcall] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_signed] = ACTIONS(1225),
    [anon_sym_unsigned] = ACTIONS(1225),
    [anon_sym_long] = ACTIONS(1225),
    [anon_sym_short] = ACTIONS(1225),
    [anon_sym_static] = ACTIONS(1225),
    [anon_sym_auto] = ACTIONS(1225),
    [anon_sym_register] = ACTIONS(1225),
    [anon_sym_inline] = ACTIONS(1225),
    [anon_sym___inline] = ACTIONS(1225),
    [anon_sym___inline__] = ACTIONS(1225),
    [anon_sym___forceinline] = ACTIONS(1225),
    [anon_sym_thread_local] = ACTIONS(1225),
    [anon_sym___thread] = ACTIONS(1225),
    [anon_sym_const] = ACTIONS(1225),
    [anon_sym_constexpr] = ACTIONS(1225),
    [anon_sym_volatile] = ACTIONS(1225),
    [anon_sym_restrict] = ACTIONS(1225),
    [anon_sym___restrict__] = ACTIONS(1225),
    [anon_sym__Atomic] = ACTIONS(1225),
    [anon_sym__Noreturn] = ACTIONS(1225),
    [anon_sym_noreturn] = ACTIONS(1225),
    [anon_sym__Nonnull] = ACTIONS(1225),
    [anon_sym_alignas] = ACTIONS(1225),
    [anon_sym__Alignas] = ACTIONS(1225),
    [sym_primitive_type] = ACTIONS(1225),
    [anon_sym_enum] = ACTIONS(1225),
    [anon_sym_struct] = ACTIONS(1225),
    [anon_sym_union] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1225),
    [anon_sym_else] = ACTIONS(1225),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1225),
    [anon_sym_default] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1225),
    [anon_sym_do] = ACTIONS(1225),
    [anon_sym_for] = ACTIONS(1225),
    [anon_sym_return] = ACTIONS(1225),
    [anon_sym_break] = ACTIONS(1225),
    [anon_sym_continue] = ACTIONS(1225),
    [anon_sym_goto] = ACTIONS(1225),
    [anon_sym___try] = ACTIONS(1225),
    [anon_sym___leave] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1225),
    [anon_sym___alignof__] = ACTIONS(1225),
    [anon_sym___alignof] = ACTIONS(1225),
    [anon_sym__alignof] = ACTIONS(1225),
    [anon_sym_alignof] = ACTIONS(1225),
    [anon_sym__Alignof] = ACTIONS(1225),
    [anon_sym_offsetof] = ACTIONS(1225),
    [anon_sym__Generic] = ACTIONS(1225),
    [anon_sym_asm] = ACTIONS(1225),
    [anon_sym___asm__] = ACTIONS(1225),
    [anon_sym___asm] = ACTIONS(1225),
    [sym_number_literal] = ACTIONS(1227),
    [anon_sym_L_SQUOTE] = ACTIONS(1227),
    [anon_sym_u_SQUOTE] = ACTIONS(1227),
    [anon_sym_U_SQUOTE] = ACTIONS(1227),
    [anon_sym_u8_SQUOTE] = ACTIONS(1227),
    [anon_sym_SQUOTE] = ACTIONS(1227),
    [anon_sym_L_DQUOTE] = ACTIONS(1227),
    [anon_sym_u_DQUOTE] = ACTIONS(1227),
    [anon_sym_U_DQUOTE] = ACTIONS(1227),
    [anon_sym_u8_DQUOTE] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [sym_true] = ACTIONS(1225),
    [sym_false] = ACTIONS(1225),
    [anon_sym_NULL] = ACTIONS(1225),
    [anon_sym_nullptr] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_identifier] = ACTIONS(1229),
    [aux_sym_preproc_include_token1] = ACTIONS(1229),
    [aux_sym_preproc_def_token1] = ACTIONS(1229),
    [aux_sym_preproc_if_token1] = ACTIONS(1229),
    [aux_sym_preproc_if_token2] = ACTIONS(1229),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1229),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1229),
    [aux_sym_preproc_else_token1] = ACTIONS(1229),
    [aux_sym_preproc_elif_token1] = ACTIONS(1229),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1229),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1229),
    [sym_preproc_directive] = ACTIONS(1229),
    [anon_sym_LPAREN2] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_TILDE] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym___extension__] = ACTIONS(1229),
    [anon_sym_typedef] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym___attribute__] = ACTIONS(1229),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(1229),
    [anon_sym___cdecl] = ACTIONS(1229),
    [anon_sym___clrcall] = ACTIONS(1229),
    [anon_sym___stdcall] = ACTIONS(1229),
    [anon_sym___fastcall] = ACTIONS(1229),
    [anon_sym___thiscall] = ACTIONS(1229),
    [anon_sym___vectorcall] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1231),
    [anon_sym_signed] = ACTIONS(1229),
    [anon_sym_unsigned] = ACTIONS(1229),
    [anon_sym_long] = ACTIONS(1229),
    [anon_sym_short] = ACTIONS(1229),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_auto] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym___inline] = ACTIONS(1229),
    [anon_sym___inline__] = ACTIONS(1229),
    [anon_sym___forceinline] = ACTIONS(1229),
    [anon_sym_thread_local] = ACTIONS(1229),
    [anon_sym___thread] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1229),
    [anon_sym_constexpr] = ACTIONS(1229),
    [anon_sym_volatile] = ACTIONS(1229),
    [anon_sym_restrict] = ACTIONS(1229),
    [anon_sym___restrict__] = ACTIONS(1229),
    [anon_sym__Atomic] = ACTIONS(1229),
    [anon_sym__Noreturn] = ACTIONS(1229),
    [anon_sym_noreturn] = ACTIONS(1229),
    [anon_sym__Nonnull] = ACTIONS(1229),
    [anon_sym_alignas] = ACTIONS(1229),
    [anon_sym__Alignas] = ACTIONS(1229),
    [sym_primitive_type] = ACTIONS(1229),
    [anon_sym_enum] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1229),
    [anon_sym_union] = ACTIONS(1229),
    [anon_sym_if] = ACTIONS(1229),
    [anon_sym_else] = ACTIONS(1229),
    [anon_sym_switch] = ACTIONS(1229),
    [anon_sym_case] = ACTIONS(1229),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1229),
    [anon_sym_do] = ACTIONS(1229),
    [anon_sym_for] = ACTIONS(1229),
    [anon_sym_return] = ACTIONS(1229),
    [anon_sym_break] = ACTIONS(1229),
    [anon_sym_continue] = ACTIONS(1229),
    [anon_sym_goto] = ACTIONS(1229),
    [anon_sym___try] = ACTIONS(1229),
    [anon_sym___leave] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1229),
    [anon_sym___alignof__] = ACTIONS(1229),
    [anon_sym___alignof] = ACTIONS(1229),
    [anon_sym__alignof] = ACTIONS(1229),
    [anon_sym_alignof] = ACTIONS(1229),
    [anon_sym__Alignof] = ACTIONS(1229),
    [anon_sym_offsetof] = ACTIONS(1229),
    [anon_sym__Generic] = ACTIONS(1229),
    [anon_sym_asm] = ACTIONS(1229),
    [anon_sym___asm__] = ACTIONS(1229),
    [anon_sym___asm] = ACTIONS(1229),
    [sym_number_literal] = ACTIONS(1231),
    [anon_sym_L_SQUOTE] = ACTIONS(1231),
    [anon_sym_u_SQUOTE] = ACTIONS(1231),
    [anon_sym_U_SQUOTE] = ACTIONS(1231),
    [anon_sym_u8_SQUOTE] = ACTIONS(1231),
    [anon_sym_SQUOTE] = ACTIONS(1231),
    [anon_sym_L_DQUOTE] = ACTIONS(1231),
    [anon_sym_u_DQUOTE] = ACTIONS(1231),
    [anon_sym_U_DQUOTE] = ACTIONS(1231),
    [anon_sym_u8_DQUOTE] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1231),
    [sym_true] = ACTIONS(1229),
    [sym_false] = ACTIONS(1229),
    [anon_sym_NULL] = ACTIONS(1229),
    [anon_sym_nullptr] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_identifier] = ACTIONS(1233),
    [aux_sym_preproc_include_token1] = ACTIONS(1233),
    [aux_sym_preproc_def_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token2] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1233),
    [aux_sym_preproc_else_token1] = ACTIONS(1233),
    [aux_sym_preproc_elif_token1] = ACTIONS(1233),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1233),
    [sym_preproc_directive] = ACTIONS(1233),
    [anon_sym_LPAREN2] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym___extension__] = ACTIONS(1233),
    [anon_sym_typedef] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1233),
    [anon_sym___attribute__] = ACTIONS(1233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym___declspec] = ACTIONS(1233),
    [anon_sym___cdecl] = ACTIONS(1233),
    [anon_sym___clrcall] = ACTIONS(1233),
    [anon_sym___stdcall] = ACTIONS(1233),
    [anon_sym___fastcall] = ACTIONS(1233),
    [anon_sym___thiscall] = ACTIONS(1233),
    [anon_sym___vectorcall] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_signed] = ACTIONS(1233),
    [anon_sym_unsigned] = ACTIONS(1233),
    [anon_sym_long] = ACTIONS(1233),
    [anon_sym_short] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_auto] = ACTIONS(1233),
    [anon_sym_register] = ACTIONS(1233),
    [anon_sym_inline] = ACTIONS(1233),
    [anon_sym___inline] = ACTIONS(1233),
    [anon_sym___inline__] = ACTIONS(1233),
    [anon_sym___forceinline] = ACTIONS(1233),
    [anon_sym_thread_local] = ACTIONS(1233),
    [anon_sym___thread] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_constexpr] = ACTIONS(1233),
    [anon_sym_volatile] = ACTIONS(1233),
    [anon_sym_restrict] = ACTIONS(1233),
    [anon_sym___restrict__] = ACTIONS(1233),
    [anon_sym__Atomic] = ACTIONS(1233),
    [anon_sym__Noreturn] = ACTIONS(1233),
    [anon_sym_noreturn] = ACTIONS(1233),
    [anon_sym__Nonnull] = ACTIONS(1233),
    [anon_sym_alignas] = ACTIONS(1233),
    [anon_sym__Alignas] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_goto] = ACTIONS(1233),
    [anon_sym___try] = ACTIONS(1233),
    [anon_sym___leave] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_sizeof] = ACTIONS(1233),
    [anon_sym___alignof__] = ACTIONS(1233),
    [anon_sym___alignof] = ACTIONS(1233),
    [anon_sym__alignof] = ACTIONS(1233),
    [anon_sym_alignof] = ACTIONS(1233),
    [anon_sym__Alignof] = ACTIONS(1233),
    [anon_sym_offsetof] = ACTIONS(1233),
    [anon_sym__Generic] = ACTIONS(1233),
    [anon_sym_asm] = ACTIONS(1233),
    [anon_sym___asm__] = ACTIONS(1233),
    [anon_sym___asm] = ACTIONS(1233),
    [sym_number_literal] = ACTIONS(1235),
    [anon_sym_L_SQUOTE] = ACTIONS(1235),
    [anon_sym_u_SQUOTE] = ACTIONS(1235),
    [anon_sym_U_SQUOTE] = ACTIONS(1235),
    [anon_sym_u8_SQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_L_DQUOTE] = ACTIONS(1235),
    [anon_sym_u_DQUOTE] = ACTIONS(1235),
    [anon_sym_U_DQUOTE] = ACTIONS(1235),
    [anon_sym_u8_DQUOTE] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [anon_sym_NULL] = ACTIONS(1233),
    [anon_sym_nullptr] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token2] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [aux_sym_preproc_else_token1] = ACTIONS(1237),
    [aux_sym_preproc_elif_token1] = ACTIONS(1237),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym__Nonnull] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [anon_sym___asm] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token2] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [aux_sym_preproc_else_token1] = ACTIONS(1237),
    [aux_sym_preproc_elif_token1] = ACTIONS(1237),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym__Nonnull] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [anon_sym___asm] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token2] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [aux_sym_preproc_else_token1] = ACTIONS(1241),
    [aux_sym_preproc_elif_token1] = ACTIONS(1241),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym__Nonnull] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [anon_sym___asm] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token2] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [aux_sym_preproc_else_token1] = ACTIONS(1245),
    [aux_sym_preproc_elif_token1] = ACTIONS(1245),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym__Nonnull] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [anon_sym___asm] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_identifier] = ACTIONS(1249),
    [aux_sym_preproc_include_token1] = ACTIONS(1249),
    [aux_sym_preproc_def_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token2] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1249),
    [aux_sym_preproc_else_token1] = ACTIONS(1249),
    [aux_sym_preproc_elif_token1] = ACTIONS(1249),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1249),
    [sym_preproc_directive] = ACTIONS(1249),
    [anon_sym_LPAREN2] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym___extension__] = ACTIONS(1249),
    [anon_sym_typedef] = ACTIONS(1249),
    [anon_sym_extern] = ACTIONS(1249),
    [anon_sym___attribute__] = ACTIONS(1249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1251),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym___cdecl] = ACTIONS(1249),
    [anon_sym___clrcall] = ACTIONS(1249),
    [anon_sym___stdcall] = ACTIONS(1249),
    [anon_sym___fastcall] = ACTIONS(1249),
    [anon_sym___thiscall] = ACTIONS(1249),
    [anon_sym___vectorcall] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_signed] = ACTIONS(1249),
    [anon_sym_unsigned] = ACTIONS(1249),
    [anon_sym_long] = ACTIONS(1249),
    [anon_sym_short] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_auto] = ACTIONS(1249),
    [anon_sym_register] = ACTIONS(1249),
    [anon_sym_inline] = ACTIONS(1249),
    [anon_sym___inline] = ACTIONS(1249),
    [anon_sym___inline__] = ACTIONS(1249),
    [anon_sym___forceinline] = ACTIONS(1249),
    [anon_sym_thread_local] = ACTIONS(1249),
    [anon_sym___thread] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_constexpr] = ACTIONS(1249),
    [anon_sym_volatile] = ACTIONS(1249),
    [anon_sym_restrict] = ACTIONS(1249),
    [anon_sym___restrict__] = ACTIONS(1249),
    [anon_sym__Atomic] = ACTIONS(1249),
    [anon_sym__Noreturn] = ACTIONS(1249),
    [anon_sym_noreturn] = ACTIONS(1249),
    [anon_sym__Nonnull] = ACTIONS(1249),
    [anon_sym_alignas] = ACTIONS(1249),
    [anon_sym__Alignas] = ACTIONS(1249),
    [sym_primitive_type] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1249),
    [anon_sym_union] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1249),
    [anon_sym___try] = ACTIONS(1249),
    [anon_sym___leave] = ACTIONS(1249),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym___alignof__] = ACTIONS(1249),
    [anon_sym___alignof] = ACTIONS(1249),
    [anon_sym__alignof] = ACTIONS(1249),
    [anon_sym_alignof] = ACTIONS(1249),
    [anon_sym__Alignof] = ACTIONS(1249),
    [anon_sym_offsetof] = ACTIONS(1249),
    [anon_sym__Generic] = ACTIONS(1249),
    [anon_sym_asm] = ACTIONS(1249),
    [anon_sym___asm__] = ACTIONS(1249),
    [anon_sym___asm] = ACTIONS(1249),
    [sym_number_literal] = ACTIONS(1251),
    [anon_sym_L_SQUOTE] = ACTIONS(1251),
    [anon_sym_u_SQUOTE] = ACTIONS(1251),
    [anon_sym_U_SQUOTE] = ACTIONS(1251),
    [anon_sym_u8_SQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [anon_sym_L_DQUOTE] = ACTIONS(1251),
    [anon_sym_u_DQUOTE] = ACTIONS(1251),
    [anon_sym_U_DQUOTE] = ACTIONS(1251),
    [anon_sym_u8_DQUOTE] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [anon_sym_NULL] = ACTIONS(1249),
    [anon_sym_nullptr] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_identifier] = ACTIONS(1253),
    [aux_sym_preproc_include_token1] = ACTIONS(1253),
    [aux_sym_preproc_def_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token2] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1253),
    [aux_sym_preproc_else_token1] = ACTIONS(1253),
    [aux_sym_preproc_elif_token1] = ACTIONS(1253),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1253),
    [sym_preproc_directive] = ACTIONS(1253),
    [anon_sym_LPAREN2] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym___extension__] = ACTIONS(1253),
    [anon_sym_typedef] = ACTIONS(1253),
    [anon_sym_extern] = ACTIONS(1253),
    [anon_sym___attribute__] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1255),
    [anon_sym___declspec] = ACTIONS(1253),
    [anon_sym___cdecl] = ACTIONS(1253),
    [anon_sym___clrcall] = ACTIONS(1253),
    [anon_sym___stdcall] = ACTIONS(1253),
    [anon_sym___fastcall] = ACTIONS(1253),
    [anon_sym___thiscall] = ACTIONS(1253),
    [anon_sym___vectorcall] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_signed] = ACTIONS(1253),
    [anon_sym_unsigned] = ACTIONS(1253),
    [anon_sym_long] = ACTIONS(1253),
    [anon_sym_short] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_auto] = ACTIONS(1253),
    [anon_sym_register] = ACTIONS(1253),
    [anon_sym_inline] = ACTIONS(1253),
    [anon_sym___inline] = ACTIONS(1253),
    [anon_sym___inline__] = ACTIONS(1253),
    [anon_sym___forceinline] = ACTIONS(1253),
    [anon_sym_thread_local] = ACTIONS(1253),
    [anon_sym___thread] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_constexpr] = ACTIONS(1253),
    [anon_sym_volatile] = ACTIONS(1253),
    [anon_sym_restrict] = ACTIONS(1253),
    [anon_sym___restrict__] = ACTIONS(1253),
    [anon_sym__Atomic] = ACTIONS(1253),
    [anon_sym__Noreturn] = ACTIONS(1253),
    [anon_sym_noreturn] = ACTIONS(1253),
    [anon_sym__Nonnull] = ACTIONS(1253),
    [anon_sym_alignas] = ACTIONS(1253),
    [anon_sym__Alignas] = ACTIONS(1253),
    [sym_primitive_type] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_union] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_goto] = ACTIONS(1253),
    [anon_sym___try] = ACTIONS(1253),
    [anon_sym___leave] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_sizeof] = ACTIONS(1253),
    [anon_sym___alignof__] = ACTIONS(1253),
    [anon_sym___alignof] = ACTIONS(1253),
    [anon_sym__alignof] = ACTIONS(1253),
    [anon_sym_alignof] = ACTIONS(1253),
    [anon_sym__Alignof] = ACTIONS(1253),
    [anon_sym_offsetof] = ACTIONS(1253),
    [anon_sym__Generic] = ACTIONS(1253),
    [anon_sym_asm] = ACTIONS(1253),
    [anon_sym___asm__] = ACTIONS(1253),
    [anon_sym___asm] = ACTIONS(1253),
    [sym_number_literal] = ACTIONS(1255),
    [anon_sym_L_SQUOTE] = ACTIONS(1255),
    [anon_sym_u_SQUOTE] = ACTIONS(1255),
    [anon_sym_U_SQUOTE] = ACTIONS(1255),
    [anon_sym_u8_SQUOTE] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_L_DQUOTE] = ACTIONS(1255),
    [anon_sym_u_DQUOTE] = ACTIONS(1255),
    [anon_sym_U_DQUOTE] = ACTIONS(1255),
    [anon_sym_u8_DQUOTE] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [anon_sym_NULL] = ACTIONS(1253),
    [anon_sym_nullptr] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token2] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [aux_sym_preproc_else_token1] = ACTIONS(1257),
    [aux_sym_preproc_elif_token1] = ACTIONS(1257),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym__Nonnull] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [anon_sym___asm] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_identifier] = ACTIONS(1261),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token2] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [aux_sym_preproc_else_token1] = ACTIONS(1261),
    [aux_sym_preproc_elif_token1] = ACTIONS(1261),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym___extension__] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1261),
    [anon_sym_extern] = ACTIONS(1261),
    [anon_sym___attribute__] = ACTIONS(1261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1263),
    [anon_sym___declspec] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_signed] = ACTIONS(1261),
    [anon_sym_unsigned] = ACTIONS(1261),
    [anon_sym_long] = ACTIONS(1261),
    [anon_sym_short] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1261),
    [anon_sym_auto] = ACTIONS(1261),
    [anon_sym_register] = ACTIONS(1261),
    [anon_sym_inline] = ACTIONS(1261),
    [anon_sym___inline] = ACTIONS(1261),
    [anon_sym___inline__] = ACTIONS(1261),
    [anon_sym___forceinline] = ACTIONS(1261),
    [anon_sym_thread_local] = ACTIONS(1261),
    [anon_sym___thread] = ACTIONS(1261),
    [anon_sym_const] = ACTIONS(1261),
    [anon_sym_constexpr] = ACTIONS(1261),
    [anon_sym_volatile] = ACTIONS(1261),
    [anon_sym_restrict] = ACTIONS(1261),
    [anon_sym___restrict__] = ACTIONS(1261),
    [anon_sym__Atomic] = ACTIONS(1261),
    [anon_sym__Noreturn] = ACTIONS(1261),
    [anon_sym_noreturn] = ACTIONS(1261),
    [anon_sym__Nonnull] = ACTIONS(1261),
    [anon_sym_alignas] = ACTIONS(1261),
    [anon_sym__Alignas] = ACTIONS(1261),
    [sym_primitive_type] = ACTIONS(1261),
    [anon_sym_enum] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1261),
    [anon_sym_union] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_do] = ACTIONS(1261),
    [anon_sym_for] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1261),
    [anon_sym_break] = ACTIONS(1261),
    [anon_sym_continue] = ACTIONS(1261),
    [anon_sym_goto] = ACTIONS(1261),
    [anon_sym___try] = ACTIONS(1261),
    [anon_sym___leave] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_sizeof] = ACTIONS(1261),
    [anon_sym___alignof__] = ACTIONS(1261),
    [anon_sym___alignof] = ACTIONS(1261),
    [anon_sym__alignof] = ACTIONS(1261),
    [anon_sym_alignof] = ACTIONS(1261),
    [anon_sym__Alignof] = ACTIONS(1261),
    [anon_sym_offsetof] = ACTIONS(1261),
    [anon_sym__Generic] = ACTIONS(1261),
    [anon_sym_asm] = ACTIONS(1261),
    [anon_sym___asm__] = ACTIONS(1261),
    [anon_sym___asm] = ACTIONS(1261),
    [sym_number_literal] = ACTIONS(1263),
    [anon_sym_L_SQUOTE] = ACTIONS(1263),
    [anon_sym_u_SQUOTE] = ACTIONS(1263),
    [anon_sym_U_SQUOTE] = ACTIONS(1263),
    [anon_sym_u8_SQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [anon_sym_L_DQUOTE] = ACTIONS(1263),
    [anon_sym_u_DQUOTE] = ACTIONS(1263),
    [anon_sym_U_DQUOTE] = ACTIONS(1263),
    [anon_sym_u8_DQUOTE] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_true] = ACTIONS(1261),
    [sym_false] = ACTIONS(1261),
    [anon_sym_NULL] = ACTIONS(1261),
    [anon_sym_nullptr] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_identifier] = ACTIONS(1265),
    [aux_sym_preproc_include_token1] = ACTIONS(1265),
    [aux_sym_preproc_def_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token2] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1265),
    [aux_sym_preproc_else_token1] = ACTIONS(1265),
    [aux_sym_preproc_elif_token1] = ACTIONS(1265),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1265),
    [sym_preproc_directive] = ACTIONS(1265),
    [anon_sym_LPAREN2] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym___extension__] = ACTIONS(1265),
    [anon_sym_typedef] = ACTIONS(1265),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym___attribute__] = ACTIONS(1265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1267),
    [anon_sym___declspec] = ACTIONS(1265),
    [anon_sym___cdecl] = ACTIONS(1265),
    [anon_sym___clrcall] = ACTIONS(1265),
    [anon_sym___stdcall] = ACTIONS(1265),
    [anon_sym___fastcall] = ACTIONS(1265),
    [anon_sym___thiscall] = ACTIONS(1265),
    [anon_sym___vectorcall] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_auto] = ACTIONS(1265),
    [anon_sym_register] = ACTIONS(1265),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym___inline] = ACTIONS(1265),
    [anon_sym___inline__] = ACTIONS(1265),
    [anon_sym___forceinline] = ACTIONS(1265),
    [anon_sym_thread_local] = ACTIONS(1265),
    [anon_sym___thread] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_constexpr] = ACTIONS(1265),
    [anon_sym_volatile] = ACTIONS(1265),
    [anon_sym_restrict] = ACTIONS(1265),
    [anon_sym___restrict__] = ACTIONS(1265),
    [anon_sym__Atomic] = ACTIONS(1265),
    [anon_sym__Noreturn] = ACTIONS(1265),
    [anon_sym_noreturn] = ACTIONS(1265),
    [anon_sym__Nonnull] = ACTIONS(1265),
    [anon_sym_alignas] = ACTIONS(1265),
    [anon_sym__Alignas] = ACTIONS(1265),
    [sym_primitive_type] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1265),
    [anon_sym_union] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_goto] = ACTIONS(1265),
    [anon_sym___try] = ACTIONS(1265),
    [anon_sym___leave] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_sizeof] = ACTIONS(1265),
    [anon_sym___alignof__] = ACTIONS(1265),
    [anon_sym___alignof] = ACTIONS(1265),
    [anon_sym__alignof] = ACTIONS(1265),
    [anon_sym_alignof] = ACTIONS(1265),
    [anon_sym__Alignof] = ACTIONS(1265),
    [anon_sym_offsetof] = ACTIONS(1265),
    [anon_sym__Generic] = ACTIONS(1265),
    [anon_sym_asm] = ACTIONS(1265),
    [anon_sym___asm__] = ACTIONS(1265),
    [anon_sym___asm] = ACTIONS(1265),
    [sym_number_literal] = ACTIONS(1267),
    [anon_sym_L_SQUOTE] = ACTIONS(1267),
    [anon_sym_u_SQUOTE] = ACTIONS(1267),
    [anon_sym_U_SQUOTE] = ACTIONS(1267),
    [anon_sym_u8_SQUOTE] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [anon_sym_L_DQUOTE] = ACTIONS(1267),
    [anon_sym_u_DQUOTE] = ACTIONS(1267),
    [anon_sym_U_DQUOTE] = ACTIONS(1267),
    [anon_sym_u8_DQUOTE] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [anon_sym_NULL] = ACTIONS(1265),
    [anon_sym_nullptr] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_identifier] = ACTIONS(1269),
    [aux_sym_preproc_include_token1] = ACTIONS(1269),
    [aux_sym_preproc_def_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token2] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1269),
    [aux_sym_preproc_else_token1] = ACTIONS(1269),
    [aux_sym_preproc_elif_token1] = ACTIONS(1269),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_LPAREN2] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym___extension__] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym___attribute__] = ACTIONS(1269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1271),
    [anon_sym___declspec] = ACTIONS(1269),
    [anon_sym___cdecl] = ACTIONS(1269),
    [anon_sym___clrcall] = ACTIONS(1269),
    [anon_sym___stdcall] = ACTIONS(1269),
    [anon_sym___fastcall] = ACTIONS(1269),
    [anon_sym___thiscall] = ACTIONS(1269),
    [anon_sym___vectorcall] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_signed] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_auto] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym___inline] = ACTIONS(1269),
    [anon_sym___inline__] = ACTIONS(1269),
    [anon_sym___forceinline] = ACTIONS(1269),
    [anon_sym_thread_local] = ACTIONS(1269),
    [anon_sym___thread] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym___restrict__] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym__Noreturn] = ACTIONS(1269),
    [anon_sym_noreturn] = ACTIONS(1269),
    [anon_sym__Nonnull] = ACTIONS(1269),
    [anon_sym_alignas] = ACTIONS(1269),
    [anon_sym__Alignas] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_goto] = ACTIONS(1269),
    [anon_sym___try] = ACTIONS(1269),
    [anon_sym___leave] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_sizeof] = ACTIONS(1269),
    [anon_sym___alignof__] = ACTIONS(1269),
    [anon_sym___alignof] = ACTIONS(1269),
    [anon_sym__alignof] = ACTIONS(1269),
    [anon_sym_alignof] = ACTIONS(1269),
    [anon_sym__Alignof] = ACTIONS(1269),
    [anon_sym_offsetof] = ACTIONS(1269),
    [anon_sym__Generic] = ACTIONS(1269),
    [anon_sym_asm] = ACTIONS(1269),
    [anon_sym___asm__] = ACTIONS(1269),
    [anon_sym___asm] = ACTIONS(1269),
    [sym_number_literal] = ACTIONS(1271),
    [anon_sym_L_SQUOTE] = ACTIONS(1271),
    [anon_sym_u_SQUOTE] = ACTIONS(1271),
    [anon_sym_U_SQUOTE] = ACTIONS(1271),
    [anon_sym_u8_SQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [anon_sym_L_DQUOTE] = ACTIONS(1271),
    [anon_sym_u_DQUOTE] = ACTIONS(1271),
    [anon_sym_U_DQUOTE] = ACTIONS(1271),
    [anon_sym_u8_DQUOTE] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [anon_sym_NULL] = ACTIONS(1269),
    [anon_sym_nullptr] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token2] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [aux_sym_preproc_else_token1] = ACTIONS(1273),
    [aux_sym_preproc_elif_token1] = ACTIONS(1273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym__Nonnull] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [anon_sym___asm] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token2] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [aux_sym_preproc_else_token1] = ACTIONS(1277),
    [aux_sym_preproc_elif_token1] = ACTIONS(1277),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym__Nonnull] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [anon_sym___asm] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_identifier] = ACTIONS(1281),
    [aux_sym_preproc_include_token1] = ACTIONS(1281),
    [aux_sym_preproc_def_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token2] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1281),
    [aux_sym_preproc_else_token1] = ACTIONS(1281),
    [aux_sym_preproc_elif_token1] = ACTIONS(1281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1281),
    [sym_preproc_directive] = ACTIONS(1281),
    [anon_sym_LPAREN2] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym___extension__] = ACTIONS(1281),
    [anon_sym_typedef] = ACTIONS(1281),
    [anon_sym_extern] = ACTIONS(1281),
    [anon_sym___attribute__] = ACTIONS(1281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1283),
    [anon_sym___declspec] = ACTIONS(1281),
    [anon_sym___cdecl] = ACTIONS(1281),
    [anon_sym___clrcall] = ACTIONS(1281),
    [anon_sym___stdcall] = ACTIONS(1281),
    [anon_sym___fastcall] = ACTIONS(1281),
    [anon_sym___thiscall] = ACTIONS(1281),
    [anon_sym___vectorcall] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_signed] = ACTIONS(1281),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [anon_sym_static] = ACTIONS(1281),
    [anon_sym_auto] = ACTIONS(1281),
    [anon_sym_register] = ACTIONS(1281),
    [anon_sym_inline] = ACTIONS(1281),
    [anon_sym___inline] = ACTIONS(1281),
    [anon_sym___inline__] = ACTIONS(1281),
    [anon_sym___forceinline] = ACTIONS(1281),
    [anon_sym_thread_local] = ACTIONS(1281),
    [anon_sym___thread] = ACTIONS(1281),
    [anon_sym_const] = ACTIONS(1281),
    [anon_sym_constexpr] = ACTIONS(1281),
    [anon_sym_volatile] = ACTIONS(1281),
    [anon_sym_restrict] = ACTIONS(1281),
    [anon_sym___restrict__] = ACTIONS(1281),
    [anon_sym__Atomic] = ACTIONS(1281),
    [anon_sym__Noreturn] = ACTIONS(1281),
    [anon_sym_noreturn] = ACTIONS(1281),
    [anon_sym__Nonnull] = ACTIONS(1281),
    [anon_sym_alignas] = ACTIONS(1281),
    [anon_sym__Alignas] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1281),
    [anon_sym_enum] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1281),
    [anon_sym_union] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(1281),
    [anon_sym_default] = ACTIONS(1281),
    [anon_sym_while] = ACTIONS(1281),
    [anon_sym_do] = ACTIONS(1281),
    [anon_sym_for] = ACTIONS(1281),
    [anon_sym_return] = ACTIONS(1281),
    [anon_sym_break] = ACTIONS(1281),
    [anon_sym_continue] = ACTIONS(1281),
    [anon_sym_goto] = ACTIONS(1281),
    [anon_sym___try] = ACTIONS(1281),
    [anon_sym___leave] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1283),
    [anon_sym_sizeof] = ACTIONS(1281),
    [anon_sym___alignof__] = ACTIONS(1281),
    [anon_sym___alignof] = ACTIONS(1281),
    [anon_sym__alignof] = ACTIONS(1281),
    [anon_sym_alignof] = ACTIONS(1281),
    [anon_sym__Alignof] = ACTIONS(1281),
    [anon_sym_offsetof] = ACTIONS(1281),
    [anon_sym__Generic] = ACTIONS(1281),
    [anon_sym_asm] = ACTIONS(1281),
    [anon_sym___asm__] = ACTIONS(1281),
    [anon_sym___asm] = ACTIONS(1281),
    [sym_number_literal] = ACTIONS(1283),
    [anon_sym_L_SQUOTE] = ACTIONS(1283),
    [anon_sym_u_SQUOTE] = ACTIONS(1283),
    [anon_sym_U_SQUOTE] = ACTIONS(1283),
    [anon_sym_u8_SQUOTE] = ACTIONS(1283),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_L_DQUOTE] = ACTIONS(1283),
    [anon_sym_u_DQUOTE] = ACTIONS(1283),
    [anon_sym_U_DQUOTE] = ACTIONS(1283),
    [anon_sym_u8_DQUOTE] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [anon_sym_NULL] = ACTIONS(1281),
    [anon_sym_nullptr] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_identifier] = ACTIONS(1285),
    [aux_sym_preproc_include_token1] = ACTIONS(1285),
    [aux_sym_preproc_def_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token2] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1285),
    [aux_sym_preproc_else_token1] = ACTIONS(1285),
    [aux_sym_preproc_elif_token1] = ACTIONS(1285),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1285),
    [sym_preproc_directive] = ACTIONS(1285),
    [anon_sym_LPAREN2] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym___extension__] = ACTIONS(1285),
    [anon_sym_typedef] = ACTIONS(1285),
    [anon_sym_extern] = ACTIONS(1285),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1287),
    [anon_sym___declspec] = ACTIONS(1285),
    [anon_sym___cdecl] = ACTIONS(1285),
    [anon_sym___clrcall] = ACTIONS(1285),
    [anon_sym___stdcall] = ACTIONS(1285),
    [anon_sym___fastcall] = ACTIONS(1285),
    [anon_sym___thiscall] = ACTIONS(1285),
    [anon_sym___vectorcall] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_signed] = ACTIONS(1285),
    [anon_sym_unsigned] = ACTIONS(1285),
    [anon_sym_long] = ACTIONS(1285),
    [anon_sym_short] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1285),
    [anon_sym_auto] = ACTIONS(1285),
    [anon_sym_register] = ACTIONS(1285),
    [anon_sym_inline] = ACTIONS(1285),
    [anon_sym___inline] = ACTIONS(1285),
    [anon_sym___inline__] = ACTIONS(1285),
    [anon_sym___forceinline] = ACTIONS(1285),
    [anon_sym_thread_local] = ACTIONS(1285),
    [anon_sym___thread] = ACTIONS(1285),
    [anon_sym_const] = ACTIONS(1285),
    [anon_sym_constexpr] = ACTIONS(1285),
    [anon_sym_volatile] = ACTIONS(1285),
    [anon_sym_restrict] = ACTIONS(1285),
    [anon_sym___restrict__] = ACTIONS(1285),
    [anon_sym__Atomic] = ACTIONS(1285),
    [anon_sym__Noreturn] = ACTIONS(1285),
    [anon_sym_noreturn] = ACTIONS(1285),
    [anon_sym__Nonnull] = ACTIONS(1285),
    [anon_sym_alignas] = ACTIONS(1285),
    [anon_sym__Alignas] = ACTIONS(1285),
    [sym_primitive_type] = ACTIONS(1285),
    [anon_sym_enum] = ACTIONS(1285),
    [anon_sym_struct] = ACTIONS(1285),
    [anon_sym_union] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1285),
    [anon_sym_switch] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1285),
    [anon_sym_default] = ACTIONS(1285),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1285),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_return] = ACTIONS(1285),
    [anon_sym_break] = ACTIONS(1285),
    [anon_sym_continue] = ACTIONS(1285),
    [anon_sym_goto] = ACTIONS(1285),
    [anon_sym___try] = ACTIONS(1285),
    [anon_sym___leave] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1287),
    [anon_sym_sizeof] = ACTIONS(1285),
    [anon_sym___alignof__] = ACTIONS(1285),
    [anon_sym___alignof] = ACTIONS(1285),
    [anon_sym__alignof] = ACTIONS(1285),
    [anon_sym_alignof] = ACTIONS(1285),
    [anon_sym__Alignof] = ACTIONS(1285),
    [anon_sym_offsetof] = ACTIONS(1285),
    [anon_sym__Generic] = ACTIONS(1285),
    [anon_sym_asm] = ACTIONS(1285),
    [anon_sym___asm__] = ACTIONS(1285),
    [anon_sym___asm] = ACTIONS(1285),
    [sym_number_literal] = ACTIONS(1287),
    [anon_sym_L_SQUOTE] = ACTIONS(1287),
    [anon_sym_u_SQUOTE] = ACTIONS(1287),
    [anon_sym_U_SQUOTE] = ACTIONS(1287),
    [anon_sym_u8_SQUOTE] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_L_DQUOTE] = ACTIONS(1287),
    [anon_sym_u_DQUOTE] = ACTIONS(1287),
    [anon_sym_U_DQUOTE] = ACTIONS(1287),
    [anon_sym_u8_DQUOTE] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [anon_sym_NULL] = ACTIONS(1285),
    [anon_sym_nullptr] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_identifier] = ACTIONS(1289),
    [aux_sym_preproc_include_token1] = ACTIONS(1289),
    [aux_sym_preproc_def_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token2] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1289),
    [aux_sym_preproc_else_token1] = ACTIONS(1289),
    [aux_sym_preproc_elif_token1] = ACTIONS(1289),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1289),
    [sym_preproc_directive] = ACTIONS(1289),
    [anon_sym_LPAREN2] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym___extension__] = ACTIONS(1289),
    [anon_sym_typedef] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1289),
    [anon_sym___attribute__] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1289),
    [anon_sym___cdecl] = ACTIONS(1289),
    [anon_sym___clrcall] = ACTIONS(1289),
    [anon_sym___stdcall] = ACTIONS(1289),
    [anon_sym___fastcall] = ACTIONS(1289),
    [anon_sym___thiscall] = ACTIONS(1289),
    [anon_sym___vectorcall] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_signed] = ACTIONS(1289),
    [anon_sym_unsigned] = ACTIONS(1289),
    [anon_sym_long] = ACTIONS(1289),
    [anon_sym_short] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_auto] = ACTIONS(1289),
    [anon_sym_register] = ACTIONS(1289),
    [anon_sym_inline] = ACTIONS(1289),
    [anon_sym___inline] = ACTIONS(1289),
    [anon_sym___inline__] = ACTIONS(1289),
    [anon_sym___forceinline] = ACTIONS(1289),
    [anon_sym_thread_local] = ACTIONS(1289),
    [anon_sym___thread] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_constexpr] = ACTIONS(1289),
    [anon_sym_volatile] = ACTIONS(1289),
    [anon_sym_restrict] = ACTIONS(1289),
    [anon_sym___restrict__] = ACTIONS(1289),
    [anon_sym__Atomic] = ACTIONS(1289),
    [anon_sym__Noreturn] = ACTIONS(1289),
    [anon_sym_noreturn] = ACTIONS(1289),
    [anon_sym__Nonnull] = ACTIONS(1289),
    [anon_sym_alignas] = ACTIONS(1289),
    [anon_sym__Alignas] = ACTIONS(1289),
    [sym_primitive_type] = ACTIONS(1289),
    [anon_sym_enum] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1289),
    [anon_sym_union] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_default] = ACTIONS(1289),
    [anon_sym_while] = ACTIONS(1289),
    [anon_sym_do] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1289),
    [anon_sym_return] = ACTIONS(1289),
    [anon_sym_break] = ACTIONS(1289),
    [anon_sym_continue] = ACTIONS(1289),
    [anon_sym_goto] = ACTIONS(1289),
    [anon_sym___try] = ACTIONS(1289),
    [anon_sym___leave] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1291),
    [anon_sym_sizeof] = ACTIONS(1289),
    [anon_sym___alignof__] = ACTIONS(1289),
    [anon_sym___alignof] = ACTIONS(1289),
    [anon_sym__alignof] = ACTIONS(1289),
    [anon_sym_alignof] = ACTIONS(1289),
    [anon_sym__Alignof] = ACTIONS(1289),
    [anon_sym_offsetof] = ACTIONS(1289),
    [anon_sym__Generic] = ACTIONS(1289),
    [anon_sym_asm] = ACTIONS(1289),
    [anon_sym___asm__] = ACTIONS(1289),
    [anon_sym___asm] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1291),
    [anon_sym_L_SQUOTE] = ACTIONS(1291),
    [anon_sym_u_SQUOTE] = ACTIONS(1291),
    [anon_sym_U_SQUOTE] = ACTIONS(1291),
    [anon_sym_u8_SQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1291),
    [anon_sym_L_DQUOTE] = ACTIONS(1291),
    [anon_sym_u_DQUOTE] = ACTIONS(1291),
    [anon_sym_U_DQUOTE] = ACTIONS(1291),
    [anon_sym_u8_DQUOTE] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [anon_sym_NULL] = ACTIONS(1289),
    [anon_sym_nullptr] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token2] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [aux_sym_preproc_else_token1] = ACTIONS(1293),
    [aux_sym_preproc_elif_token1] = ACTIONS(1293),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym__Nonnull] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [anon_sym___asm] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_identifier] = ACTIONS(1297),
    [aux_sym_preproc_include_token1] = ACTIONS(1297),
    [aux_sym_preproc_def_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token2] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1297),
    [aux_sym_preproc_else_token1] = ACTIONS(1297),
    [aux_sym_preproc_elif_token1] = ACTIONS(1297),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1297),
    [sym_preproc_directive] = ACTIONS(1297),
    [anon_sym_LPAREN2] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym___extension__] = ACTIONS(1297),
    [anon_sym_typedef] = ACTIONS(1297),
    [anon_sym_extern] = ACTIONS(1297),
    [anon_sym___attribute__] = ACTIONS(1297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1299),
    [anon_sym___declspec] = ACTIONS(1297),
    [anon_sym___cdecl] = ACTIONS(1297),
    [anon_sym___clrcall] = ACTIONS(1297),
    [anon_sym___stdcall] = ACTIONS(1297),
    [anon_sym___fastcall] = ACTIONS(1297),
    [anon_sym___thiscall] = ACTIONS(1297),
    [anon_sym___vectorcall] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(1297),
    [anon_sym_unsigned] = ACTIONS(1297),
    [anon_sym_long] = ACTIONS(1297),
    [anon_sym_short] = ACTIONS(1297),
    [anon_sym_static] = ACTIONS(1297),
    [anon_sym_auto] = ACTIONS(1297),
    [anon_sym_register] = ACTIONS(1297),
    [anon_sym_inline] = ACTIONS(1297),
    [anon_sym___inline] = ACTIONS(1297),
    [anon_sym___inline__] = ACTIONS(1297),
    [anon_sym___forceinline] = ACTIONS(1297),
    [anon_sym_thread_local] = ACTIONS(1297),
    [anon_sym___thread] = ACTIONS(1297),
    [anon_sym_const] = ACTIONS(1297),
    [anon_sym_constexpr] = ACTIONS(1297),
    [anon_sym_volatile] = ACTIONS(1297),
    [anon_sym_restrict] = ACTIONS(1297),
    [anon_sym___restrict__] = ACTIONS(1297),
    [anon_sym__Atomic] = ACTIONS(1297),
    [anon_sym__Noreturn] = ACTIONS(1297),
    [anon_sym_noreturn] = ACTIONS(1297),
    [anon_sym__Nonnull] = ACTIONS(1297),
    [anon_sym_alignas] = ACTIONS(1297),
    [anon_sym__Alignas] = ACTIONS(1297),
    [sym_primitive_type] = ACTIONS(1297),
    [anon_sym_enum] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1297),
    [anon_sym_union] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1297),
    [anon_sym_case] = ACTIONS(1297),
    [anon_sym_default] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_do] = ACTIONS(1297),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_return] = ACTIONS(1297),
    [anon_sym_break] = ACTIONS(1297),
    [anon_sym_continue] = ACTIONS(1297),
    [anon_sym_goto] = ACTIONS(1297),
    [anon_sym___try] = ACTIONS(1297),
    [anon_sym___leave] = ACTIONS(1297),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_sizeof] = ACTIONS(1297),
    [anon_sym___alignof__] = ACTIONS(1297),
    [anon_sym___alignof] = ACTIONS(1297),
    [anon_sym__alignof] = ACTIONS(1297),
    [anon_sym_alignof] = ACTIONS(1297),
    [anon_sym__Alignof] = ACTIONS(1297),
    [anon_sym_offsetof] = ACTIONS(1297),
    [anon_sym__Generic] = ACTIONS(1297),
    [anon_sym_asm] = ACTIONS(1297),
    [anon_sym___asm__] = ACTIONS(1297),
    [anon_sym___asm] = ACTIONS(1297),
    [sym_number_literal] = ACTIONS(1299),
    [anon_sym_L_SQUOTE] = ACTIONS(1299),
    [anon_sym_u_SQUOTE] = ACTIONS(1299),
    [anon_sym_U_SQUOTE] = ACTIONS(1299),
    [anon_sym_u8_SQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [anon_sym_L_DQUOTE] = ACTIONS(1299),
    [anon_sym_u_DQUOTE] = ACTIONS(1299),
    [anon_sym_U_DQUOTE] = ACTIONS(1299),
    [anon_sym_u8_DQUOTE] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_true] = ACTIONS(1297),
    [sym_false] = ACTIONS(1297),
    [anon_sym_NULL] = ACTIONS(1297),
    [anon_sym_nullptr] = ACTIONS(1297),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_identifier] = ACTIONS(1301),
    [aux_sym_preproc_include_token1] = ACTIONS(1301),
    [aux_sym_preproc_def_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token2] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1301),
    [aux_sym_preproc_else_token1] = ACTIONS(1301),
    [aux_sym_preproc_elif_token1] = ACTIONS(1301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1301),
    [sym_preproc_directive] = ACTIONS(1301),
    [anon_sym_LPAREN2] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym___extension__] = ACTIONS(1301),
    [anon_sym_typedef] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(1301),
    [anon_sym___attribute__] = ACTIONS(1301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1303),
    [anon_sym___declspec] = ACTIONS(1301),
    [anon_sym___cdecl] = ACTIONS(1301),
    [anon_sym___clrcall] = ACTIONS(1301),
    [anon_sym___stdcall] = ACTIONS(1301),
    [anon_sym___fastcall] = ACTIONS(1301),
    [anon_sym___thiscall] = ACTIONS(1301),
    [anon_sym___vectorcall] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_auto] = ACTIONS(1301),
    [anon_sym_register] = ACTIONS(1301),
    [anon_sym_inline] = ACTIONS(1301),
    [anon_sym___inline] = ACTIONS(1301),
    [anon_sym___inline__] = ACTIONS(1301),
    [anon_sym___forceinline] = ACTIONS(1301),
    [anon_sym_thread_local] = ACTIONS(1301),
    [anon_sym___thread] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_constexpr] = ACTIONS(1301),
    [anon_sym_volatile] = ACTIONS(1301),
    [anon_sym_restrict] = ACTIONS(1301),
    [anon_sym___restrict__] = ACTIONS(1301),
    [anon_sym__Atomic] = ACTIONS(1301),
    [anon_sym__Noreturn] = ACTIONS(1301),
    [anon_sym_noreturn] = ACTIONS(1301),
    [anon_sym__Nonnull] = ACTIONS(1301),
    [anon_sym_alignas] = ACTIONS(1301),
    [anon_sym__Alignas] = ACTIONS(1301),
    [sym_primitive_type] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1301),
    [anon_sym_union] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_goto] = ACTIONS(1301),
    [anon_sym___try] = ACTIONS(1301),
    [anon_sym___leave] = ACTIONS(1301),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1301),
    [anon_sym___alignof__] = ACTIONS(1301),
    [anon_sym___alignof] = ACTIONS(1301),
    [anon_sym__alignof] = ACTIONS(1301),
    [anon_sym_alignof] = ACTIONS(1301),
    [anon_sym__Alignof] = ACTIONS(1301),
    [anon_sym_offsetof] = ACTIONS(1301),
    [anon_sym__Generic] = ACTIONS(1301),
    [anon_sym_asm] = ACTIONS(1301),
    [anon_sym___asm__] = ACTIONS(1301),
    [anon_sym___asm] = ACTIONS(1301),
    [sym_number_literal] = ACTIONS(1303),
    [anon_sym_L_SQUOTE] = ACTIONS(1303),
    [anon_sym_u_SQUOTE] = ACTIONS(1303),
    [anon_sym_U_SQUOTE] = ACTIONS(1303),
    [anon_sym_u8_SQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1303),
    [anon_sym_L_DQUOTE] = ACTIONS(1303),
    [anon_sym_u_DQUOTE] = ACTIONS(1303),
    [anon_sym_U_DQUOTE] = ACTIONS(1303),
    [anon_sym_u8_DQUOTE] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [anon_sym_NULL] = ACTIONS(1301),
    [anon_sym_nullptr] = ACTIONS(1301),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_identifier] = ACTIONS(1305),
    [aux_sym_preproc_include_token1] = ACTIONS(1305),
    [aux_sym_preproc_def_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token2] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1305),
    [aux_sym_preproc_else_token1] = ACTIONS(1305),
    [aux_sym_preproc_elif_token1] = ACTIONS(1305),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_LPAREN2] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_TILDE] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym___extension__] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym___attribute__] = ACTIONS(1305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1307),
    [anon_sym___declspec] = ACTIONS(1305),
    [anon_sym___cdecl] = ACTIONS(1305),
    [anon_sym___clrcall] = ACTIONS(1305),
    [anon_sym___stdcall] = ACTIONS(1305),
    [anon_sym___fastcall] = ACTIONS(1305),
    [anon_sym___thiscall] = ACTIONS(1305),
    [anon_sym___vectorcall] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym___inline] = ACTIONS(1305),
    [anon_sym___inline__] = ACTIONS(1305),
    [anon_sym___forceinline] = ACTIONS(1305),
    [anon_sym_thread_local] = ACTIONS(1305),
    [anon_sym___thread] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_constexpr] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym___restrict__] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym__Noreturn] = ACTIONS(1305),
    [anon_sym_noreturn] = ACTIONS(1305),
    [anon_sym__Nonnull] = ACTIONS(1305),
    [anon_sym_alignas] = ACTIONS(1305),
    [anon_sym__Alignas] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym___try] = ACTIONS(1305),
    [anon_sym___leave] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1307),
    [anon_sym_sizeof] = ACTIONS(1305),
    [anon_sym___alignof__] = ACTIONS(1305),
    [anon_sym___alignof] = ACTIONS(1305),
    [anon_sym__alignof] = ACTIONS(1305),
    [anon_sym_alignof] = ACTIONS(1305),
    [anon_sym__Alignof] = ACTIONS(1305),
    [anon_sym_offsetof] = ACTIONS(1305),
    [anon_sym__Generic] = ACTIONS(1305),
    [anon_sym_asm] = ACTIONS(1305),
    [anon_sym___asm__] = ACTIONS(1305),
    [anon_sym___asm] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1307),
    [anon_sym_L_SQUOTE] = ACTIONS(1307),
    [anon_sym_u_SQUOTE] = ACTIONS(1307),
    [anon_sym_U_SQUOTE] = ACTIONS(1307),
    [anon_sym_u8_SQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1307),
    [anon_sym_L_DQUOTE] = ACTIONS(1307),
    [anon_sym_u_DQUOTE] = ACTIONS(1307),
    [anon_sym_U_DQUOTE] = ACTIONS(1307),
    [anon_sym_u8_DQUOTE] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1307),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [anon_sym_NULL] = ACTIONS(1305),
    [anon_sym_nullptr] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_identifier] = ACTIONS(1309),
    [aux_sym_preproc_include_token1] = ACTIONS(1309),
    [aux_sym_preproc_def_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token2] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1309),
    [aux_sym_preproc_else_token1] = ACTIONS(1309),
    [aux_sym_preproc_elif_token1] = ACTIONS(1309),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1309),
    [sym_preproc_directive] = ACTIONS(1309),
    [anon_sym_LPAREN2] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym___extension__] = ACTIONS(1309),
    [anon_sym_typedef] = ACTIONS(1309),
    [anon_sym_extern] = ACTIONS(1309),
    [anon_sym___attribute__] = ACTIONS(1309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1311),
    [anon_sym___declspec] = ACTIONS(1309),
    [anon_sym___cdecl] = ACTIONS(1309),
    [anon_sym___clrcall] = ACTIONS(1309),
    [anon_sym___stdcall] = ACTIONS(1309),
    [anon_sym___fastcall] = ACTIONS(1309),
    [anon_sym___thiscall] = ACTIONS(1309),
    [anon_sym___vectorcall] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(1309),
    [anon_sym_unsigned] = ACTIONS(1309),
    [anon_sym_long] = ACTIONS(1309),
    [anon_sym_short] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_auto] = ACTIONS(1309),
    [anon_sym_register] = ACTIONS(1309),
    [anon_sym_inline] = ACTIONS(1309),
    [anon_sym___inline] = ACTIONS(1309),
    [anon_sym___inline__] = ACTIONS(1309),
    [anon_sym___forceinline] = ACTIONS(1309),
    [anon_sym_thread_local] = ACTIONS(1309),
    [anon_sym___thread] = ACTIONS(1309),
    [anon_sym_const] = ACTIONS(1309),
    [anon_sym_constexpr] = ACTIONS(1309),
    [anon_sym_volatile] = ACTIONS(1309),
    [anon_sym_restrict] = ACTIONS(1309),
    [anon_sym___restrict__] = ACTIONS(1309),
    [anon_sym__Atomic] = ACTIONS(1309),
    [anon_sym__Noreturn] = ACTIONS(1309),
    [anon_sym_noreturn] = ACTIONS(1309),
    [anon_sym__Nonnull] = ACTIONS(1309),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1309),
    [anon_sym_enum] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1309),
    [anon_sym_union] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1309),
    [anon_sym_default] = ACTIONS(1309),
    [anon_sym_while] = ACTIONS(1309),
    [anon_sym_do] = ACTIONS(1309),
    [anon_sym_for] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1309),
    [anon_sym_goto] = ACTIONS(1309),
    [anon_sym___try] = ACTIONS(1309),
    [anon_sym___leave] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1309),
    [anon_sym___alignof__] = ACTIONS(1309),
    [anon_sym___alignof] = ACTIONS(1309),
    [anon_sym__alignof] = ACTIONS(1309),
    [anon_sym_alignof] = ACTIONS(1309),
    [anon_sym__Alignof] = ACTIONS(1309),
    [anon_sym_offsetof] = ACTIONS(1309),
    [anon_sym__Generic] = ACTIONS(1309),
    [anon_sym_asm] = ACTIONS(1309),
    [anon_sym___asm__] = ACTIONS(1309),
    [anon_sym___asm] = ACTIONS(1309),
    [sym_number_literal] = ACTIONS(1311),
    [anon_sym_L_SQUOTE] = ACTIONS(1311),
    [anon_sym_u_SQUOTE] = ACTIONS(1311),
    [anon_sym_U_SQUOTE] = ACTIONS(1311),
    [anon_sym_u8_SQUOTE] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_L_DQUOTE] = ACTIONS(1311),
    [anon_sym_u_DQUOTE] = ACTIONS(1311),
    [anon_sym_U_DQUOTE] = ACTIONS(1311),
    [anon_sym_u8_DQUOTE] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1311),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [anon_sym_NULL] = ACTIONS(1309),
    [anon_sym_nullptr] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_identifier] = ACTIONS(1313),
    [aux_sym_preproc_include_token1] = ACTIONS(1313),
    [aux_sym_preproc_def_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token2] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1313),
    [aux_sym_preproc_else_token1] = ACTIONS(1313),
    [aux_sym_preproc_elif_token1] = ACTIONS(1313),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_LPAREN2] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym___extension__] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym___attribute__] = ACTIONS(1313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1315),
    [anon_sym___declspec] = ACTIONS(1313),
    [anon_sym___cdecl] = ACTIONS(1313),
    [anon_sym___clrcall] = ACTIONS(1313),
    [anon_sym___stdcall] = ACTIONS(1313),
    [anon_sym___fastcall] = ACTIONS(1313),
    [anon_sym___thiscall] = ACTIONS(1313),
    [anon_sym___vectorcall] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_signed] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_auto] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym___inline] = ACTIONS(1313),
    [anon_sym___inline__] = ACTIONS(1313),
    [anon_sym___forceinline] = ACTIONS(1313),
    [anon_sym_thread_local] = ACTIONS(1313),
    [anon_sym___thread] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym___restrict__] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym__Noreturn] = ACTIONS(1313),
    [anon_sym_noreturn] = ACTIONS(1313),
    [anon_sym__Nonnull] = ACTIONS(1313),
    [anon_sym_alignas] = ACTIONS(1313),
    [anon_sym__Alignas] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym___try] = ACTIONS(1313),
    [anon_sym___leave] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_sizeof] = ACTIONS(1313),
    [anon_sym___alignof__] = ACTIONS(1313),
    [anon_sym___alignof] = ACTIONS(1313),
    [anon_sym__alignof] = ACTIONS(1313),
    [anon_sym_alignof] = ACTIONS(1313),
    [anon_sym__Alignof] = ACTIONS(1313),
    [anon_sym_offsetof] = ACTIONS(1313),
    [anon_sym__Generic] = ACTIONS(1313),
    [anon_sym_asm] = ACTIONS(1313),
    [anon_sym___asm__] = ACTIONS(1313),
    [anon_sym___asm] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1315),
    [anon_sym_L_SQUOTE] = ACTIONS(1315),
    [anon_sym_u_SQUOTE] = ACTIONS(1315),
    [anon_sym_U_SQUOTE] = ACTIONS(1315),
    [anon_sym_u8_SQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [anon_sym_L_DQUOTE] = ACTIONS(1315),
    [anon_sym_u_DQUOTE] = ACTIONS(1315),
    [anon_sym_U_DQUOTE] = ACTIONS(1315),
    [anon_sym_u8_DQUOTE] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [anon_sym_NULL] = ACTIONS(1313),
    [anon_sym_nullptr] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token2] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [aux_sym_preproc_else_token1] = ACTIONS(1317),
    [aux_sym_preproc_elif_token1] = ACTIONS(1317),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym__Nonnull] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [anon_sym___asm] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_identifier] = ACTIONS(1321),
    [aux_sym_preproc_include_token1] = ACTIONS(1321),
    [aux_sym_preproc_def_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token2] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1321),
    [aux_sym_preproc_else_token1] = ACTIONS(1321),
    [aux_sym_preproc_elif_token1] = ACTIONS(1321),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1321),
    [sym_preproc_directive] = ACTIONS(1321),
    [anon_sym_LPAREN2] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym___extension__] = ACTIONS(1321),
    [anon_sym_typedef] = ACTIONS(1321),
    [anon_sym_extern] = ACTIONS(1321),
    [anon_sym___attribute__] = ACTIONS(1321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1323),
    [anon_sym___declspec] = ACTIONS(1321),
    [anon_sym___cdecl] = ACTIONS(1321),
    [anon_sym___clrcall] = ACTIONS(1321),
    [anon_sym___stdcall] = ACTIONS(1321),
    [anon_sym___fastcall] = ACTIONS(1321),
    [anon_sym___thiscall] = ACTIONS(1321),
    [anon_sym___vectorcall] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_signed] = ACTIONS(1321),
    [anon_sym_unsigned] = ACTIONS(1321),
    [anon_sym_long] = ACTIONS(1321),
    [anon_sym_short] = ACTIONS(1321),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_auto] = ACTIONS(1321),
    [anon_sym_register] = ACTIONS(1321),
    [anon_sym_inline] = ACTIONS(1321),
    [anon_sym___inline] = ACTIONS(1321),
    [anon_sym___inline__] = ACTIONS(1321),
    [anon_sym___forceinline] = ACTIONS(1321),
    [anon_sym_thread_local] = ACTIONS(1321),
    [anon_sym___thread] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_constexpr] = ACTIONS(1321),
    [anon_sym_volatile] = ACTIONS(1321),
    [anon_sym_restrict] = ACTIONS(1321),
    [anon_sym___restrict__] = ACTIONS(1321),
    [anon_sym__Atomic] = ACTIONS(1321),
    [anon_sym__Noreturn] = ACTIONS(1321),
    [anon_sym_noreturn] = ACTIONS(1321),
    [anon_sym__Nonnull] = ACTIONS(1321),
    [anon_sym_alignas] = ACTIONS(1321),
    [anon_sym__Alignas] = ACTIONS(1321),
    [sym_primitive_type] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_goto] = ACTIONS(1321),
    [anon_sym___try] = ACTIONS(1321),
    [anon_sym___leave] = ACTIONS(1321),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_sizeof] = ACTIONS(1321),
    [anon_sym___alignof__] = ACTIONS(1321),
    [anon_sym___alignof] = ACTIONS(1321),
    [anon_sym__alignof] = ACTIONS(1321),
    [anon_sym_alignof] = ACTIONS(1321),
    [anon_sym__Alignof] = ACTIONS(1321),
    [anon_sym_offsetof] = ACTIONS(1321),
    [anon_sym__Generic] = ACTIONS(1321),
    [anon_sym_asm] = ACTIONS(1321),
    [anon_sym___asm__] = ACTIONS(1321),
    [anon_sym___asm] = ACTIONS(1321),
    [sym_number_literal] = ACTIONS(1323),
    [anon_sym_L_SQUOTE] = ACTIONS(1323),
    [anon_sym_u_SQUOTE] = ACTIONS(1323),
    [anon_sym_U_SQUOTE] = ACTIONS(1323),
    [anon_sym_u8_SQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [anon_sym_L_DQUOTE] = ACTIONS(1323),
    [anon_sym_u_DQUOTE] = ACTIONS(1323),
    [anon_sym_U_DQUOTE] = ACTIONS(1323),
    [anon_sym_u8_DQUOTE] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [anon_sym_NULL] = ACTIONS(1321),
    [anon_sym_nullptr] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_identifier] = ACTIONS(1325),
    [aux_sym_preproc_include_token1] = ACTIONS(1325),
    [aux_sym_preproc_def_token1] = ACTIONS(1325),
    [aux_sym_preproc_if_token1] = ACTIONS(1325),
    [aux_sym_preproc_if_token2] = ACTIONS(1325),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1325),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1325),
    [aux_sym_preproc_else_token1] = ACTIONS(1325),
    [aux_sym_preproc_elif_token1] = ACTIONS(1325),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1325),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1325),
    [sym_preproc_directive] = ACTIONS(1325),
    [anon_sym_LPAREN2] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym___extension__] = ACTIONS(1325),
    [anon_sym_typedef] = ACTIONS(1325),
    [anon_sym_extern] = ACTIONS(1325),
    [anon_sym___attribute__] = ACTIONS(1325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1327),
    [anon_sym___declspec] = ACTIONS(1325),
    [anon_sym___cdecl] = ACTIONS(1325),
    [anon_sym___clrcall] = ACTIONS(1325),
    [anon_sym___stdcall] = ACTIONS(1325),
    [anon_sym___fastcall] = ACTIONS(1325),
    [anon_sym___thiscall] = ACTIONS(1325),
    [anon_sym___vectorcall] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1327),
    [anon_sym_signed] = ACTIONS(1325),
    [anon_sym_unsigned] = ACTIONS(1325),
    [anon_sym_long] = ACTIONS(1325),
    [anon_sym_short] = ACTIONS(1325),
    [anon_sym_static] = ACTIONS(1325),
    [anon_sym_auto] = ACTIONS(1325),
    [anon_sym_register] = ACTIONS(1325),
    [anon_sym_inline] = ACTIONS(1325),
    [anon_sym___inline] = ACTIONS(1325),
    [anon_sym___inline__] = ACTIONS(1325),
    [anon_sym___forceinline] = ACTIONS(1325),
    [anon_sym_thread_local] = ACTIONS(1325),
    [anon_sym___thread] = ACTIONS(1325),
    [anon_sym_const] = ACTIONS(1325),
    [anon_sym_constexpr] = ACTIONS(1325),
    [anon_sym_volatile] = ACTIONS(1325),
    [anon_sym_restrict] = ACTIONS(1325),
    [anon_sym___restrict__] = ACTIONS(1325),
    [anon_sym__Atomic] = ACTIONS(1325),
    [anon_sym__Noreturn] = ACTIONS(1325),
    [anon_sym_noreturn] = ACTIONS(1325),
    [anon_sym__Nonnull] = ACTIONS(1325),
    [anon_sym_alignas] = ACTIONS(1325),
    [anon_sym__Alignas] = ACTIONS(1325),
    [sym_primitive_type] = ACTIONS(1325),
    [anon_sym_enum] = ACTIONS(1325),
    [anon_sym_struct] = ACTIONS(1325),
    [anon_sym_union] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1325),
    [anon_sym_switch] = ACTIONS(1325),
    [anon_sym_case] = ACTIONS(1325),
    [anon_sym_default] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1325),
    [anon_sym_do] = ACTIONS(1325),
    [anon_sym_for] = ACTIONS(1325),
    [anon_sym_return] = ACTIONS(1325),
    [anon_sym_break] = ACTIONS(1325),
    [anon_sym_continue] = ACTIONS(1325),
    [anon_sym_goto] = ACTIONS(1325),
    [anon_sym___try] = ACTIONS(1325),
    [anon_sym___leave] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1327),
    [anon_sym_sizeof] = ACTIONS(1325),
    [anon_sym___alignof__] = ACTIONS(1325),
    [anon_sym___alignof] = ACTIONS(1325),
    [anon_sym__alignof] = ACTIONS(1325),
    [anon_sym_alignof] = ACTIONS(1325),
    [anon_sym__Alignof] = ACTIONS(1325),
    [anon_sym_offsetof] = ACTIONS(1325),
    [anon_sym__Generic] = ACTIONS(1325),
    [anon_sym_asm] = ACTIONS(1325),
    [anon_sym___asm__] = ACTIONS(1325),
    [anon_sym___asm] = ACTIONS(1325),
    [sym_number_literal] = ACTIONS(1327),
    [anon_sym_L_SQUOTE] = ACTIONS(1327),
    [anon_sym_u_SQUOTE] = ACTIONS(1327),
    [anon_sym_U_SQUOTE] = ACTIONS(1327),
    [anon_sym_u8_SQUOTE] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [anon_sym_L_DQUOTE] = ACTIONS(1327),
    [anon_sym_u_DQUOTE] = ACTIONS(1327),
    [anon_sym_U_DQUOTE] = ACTIONS(1327),
    [anon_sym_u8_DQUOTE] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [sym_true] = ACTIONS(1325),
    [sym_false] = ACTIONS(1325),
    [anon_sym_NULL] = ACTIONS(1325),
    [anon_sym_nullptr] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_identifier] = ACTIONS(1329),
    [aux_sym_preproc_include_token1] = ACTIONS(1329),
    [aux_sym_preproc_def_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token2] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1329),
    [aux_sym_preproc_else_token1] = ACTIONS(1329),
    [aux_sym_preproc_elif_token1] = ACTIONS(1329),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1329),
    [sym_preproc_directive] = ACTIONS(1329),
    [anon_sym_LPAREN2] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_SEMI] = ACTIONS(1331),
    [anon_sym___extension__] = ACTIONS(1329),
    [anon_sym_typedef] = ACTIONS(1329),
    [anon_sym_extern] = ACTIONS(1329),
    [anon_sym___attribute__] = ACTIONS(1329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1331),
    [anon_sym___declspec] = ACTIONS(1329),
    [anon_sym___cdecl] = ACTIONS(1329),
    [anon_sym___clrcall] = ACTIONS(1329),
    [anon_sym___stdcall] = ACTIONS(1329),
    [anon_sym___fastcall] = ACTIONS(1329),
    [anon_sym___thiscall] = ACTIONS(1329),
    [anon_sym___vectorcall] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1331),
    [anon_sym_signed] = ACTIONS(1329),
    [anon_sym_unsigned] = ACTIONS(1329),
    [anon_sym_long] = ACTIONS(1329),
    [anon_sym_short] = ACTIONS(1329),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_auto] = ACTIONS(1329),
    [anon_sym_register] = ACTIONS(1329),
    [anon_sym_inline] = ACTIONS(1329),
    [anon_sym___inline] = ACTIONS(1329),
    [anon_sym___inline__] = ACTIONS(1329),
    [anon_sym___forceinline] = ACTIONS(1329),
    [anon_sym_thread_local] = ACTIONS(1329),
    [anon_sym___thread] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_constexpr] = ACTIONS(1329),
    [anon_sym_volatile] = ACTIONS(1329),
    [anon_sym_restrict] = ACTIONS(1329),
    [anon_sym___restrict__] = ACTIONS(1329),
    [anon_sym__Atomic] = ACTIONS(1329),
    [anon_sym__Noreturn] = ACTIONS(1329),
    [anon_sym_noreturn] = ACTIONS(1329),
    [anon_sym__Nonnull] = ACTIONS(1329),
    [anon_sym_alignas] = ACTIONS(1329),
    [anon_sym__Alignas] = ACTIONS(1329),
    [sym_primitive_type] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1329),
    [anon_sym_union] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_goto] = ACTIONS(1329),
    [anon_sym___try] = ACTIONS(1329),
    [anon_sym___leave] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_sizeof] = ACTIONS(1329),
    [anon_sym___alignof__] = ACTIONS(1329),
    [anon_sym___alignof] = ACTIONS(1329),
    [anon_sym__alignof] = ACTIONS(1329),
    [anon_sym_alignof] = ACTIONS(1329),
    [anon_sym__Alignof] = ACTIONS(1329),
    [anon_sym_offsetof] = ACTIONS(1329),
    [anon_sym__Generic] = ACTIONS(1329),
    [anon_sym_asm] = ACTIONS(1329),
    [anon_sym___asm__] = ACTIONS(1329),
    [anon_sym___asm] = ACTIONS(1329),
    [sym_number_literal] = ACTIONS(1331),
    [anon_sym_L_SQUOTE] = ACTIONS(1331),
    [anon_sym_u_SQUOTE] = ACTIONS(1331),
    [anon_sym_U_SQUOTE] = ACTIONS(1331),
    [anon_sym_u8_SQUOTE] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1331),
    [anon_sym_L_DQUOTE] = ACTIONS(1331),
    [anon_sym_u_DQUOTE] = ACTIONS(1331),
    [anon_sym_U_DQUOTE] = ACTIONS(1331),
    [anon_sym_u8_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [anon_sym_NULL] = ACTIONS(1329),
    [anon_sym_nullptr] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1333),
    [aux_sym_preproc_def_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token2] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1333),
    [aux_sym_preproc_else_token1] = ACTIONS(1333),
    [aux_sym_preproc_elif_token1] = ACTIONS(1333),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1333),
    [sym_preproc_directive] = ACTIONS(1333),
    [anon_sym_LPAREN2] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym___extension__] = ACTIONS(1333),
    [anon_sym_typedef] = ACTIONS(1333),
    [anon_sym_extern] = ACTIONS(1333),
    [anon_sym___attribute__] = ACTIONS(1333),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1335),
    [anon_sym___declspec] = ACTIONS(1333),
    [anon_sym___cdecl] = ACTIONS(1333),
    [anon_sym___clrcall] = ACTIONS(1333),
    [anon_sym___stdcall] = ACTIONS(1333),
    [anon_sym___fastcall] = ACTIONS(1333),
    [anon_sym___thiscall] = ACTIONS(1333),
    [anon_sym___vectorcall] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_signed] = ACTIONS(1333),
    [anon_sym_unsigned] = ACTIONS(1333),
    [anon_sym_long] = ACTIONS(1333),
    [anon_sym_short] = ACTIONS(1333),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_auto] = ACTIONS(1333),
    [anon_sym_register] = ACTIONS(1333),
    [anon_sym_inline] = ACTIONS(1333),
    [anon_sym___inline] = ACTIONS(1333),
    [anon_sym___inline__] = ACTIONS(1333),
    [anon_sym___forceinline] = ACTIONS(1333),
    [anon_sym_thread_local] = ACTIONS(1333),
    [anon_sym___thread] = ACTIONS(1333),
    [anon_sym_const] = ACTIONS(1333),
    [anon_sym_constexpr] = ACTIONS(1333),
    [anon_sym_volatile] = ACTIONS(1333),
    [anon_sym_restrict] = ACTIONS(1333),
    [anon_sym___restrict__] = ACTIONS(1333),
    [anon_sym__Atomic] = ACTIONS(1333),
    [anon_sym__Noreturn] = ACTIONS(1333),
    [anon_sym_noreturn] = ACTIONS(1333),
    [anon_sym__Nonnull] = ACTIONS(1333),
    [anon_sym_alignas] = ACTIONS(1333),
    [anon_sym__Alignas] = ACTIONS(1333),
    [sym_primitive_type] = ACTIONS(1333),
    [anon_sym_enum] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1333),
    [anon_sym_union] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1333),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_while] = ACTIONS(1333),
    [anon_sym_do] = ACTIONS(1333),
    [anon_sym_for] = ACTIONS(1333),
    [anon_sym_return] = ACTIONS(1333),
    [anon_sym_break] = ACTIONS(1333),
    [anon_sym_continue] = ACTIONS(1333),
    [anon_sym_goto] = ACTIONS(1333),
    [anon_sym___try] = ACTIONS(1333),
    [anon_sym___leave] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1333),
    [anon_sym___alignof__] = ACTIONS(1333),
    [anon_sym___alignof] = ACTIONS(1333),
    [anon_sym__alignof] = ACTIONS(1333),
    [anon_sym_alignof] = ACTIONS(1333),
    [anon_sym__Alignof] = ACTIONS(1333),
    [anon_sym_offsetof] = ACTIONS(1333),
    [anon_sym__Generic] = ACTIONS(1333),
    [anon_sym_asm] = ACTIONS(1333),
    [anon_sym___asm__] = ACTIONS(1333),
    [anon_sym___asm] = ACTIONS(1333),
    [sym_number_literal] = ACTIONS(1335),
    [anon_sym_L_SQUOTE] = ACTIONS(1335),
    [anon_sym_u_SQUOTE] = ACTIONS(1335),
    [anon_sym_U_SQUOTE] = ACTIONS(1335),
    [anon_sym_u8_SQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [anon_sym_L_DQUOTE] = ACTIONS(1335),
    [anon_sym_u_DQUOTE] = ACTIONS(1335),
    [anon_sym_U_DQUOTE] = ACTIONS(1335),
    [anon_sym_u8_DQUOTE] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [anon_sym_NULL] = ACTIONS(1333),
    [anon_sym_nullptr] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_identifier] = ACTIONS(1337),
    [aux_sym_preproc_include_token1] = ACTIONS(1337),
    [aux_sym_preproc_def_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token2] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1337),
    [aux_sym_preproc_else_token1] = ACTIONS(1337),
    [aux_sym_preproc_elif_token1] = ACTIONS(1337),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1337),
    [sym_preproc_directive] = ACTIONS(1337),
    [anon_sym_LPAREN2] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym___extension__] = ACTIONS(1337),
    [anon_sym_typedef] = ACTIONS(1337),
    [anon_sym_extern] = ACTIONS(1337),
    [anon_sym___attribute__] = ACTIONS(1337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1339),
    [anon_sym___declspec] = ACTIONS(1337),
    [anon_sym___cdecl] = ACTIONS(1337),
    [anon_sym___clrcall] = ACTIONS(1337),
    [anon_sym___stdcall] = ACTIONS(1337),
    [anon_sym___fastcall] = ACTIONS(1337),
    [anon_sym___thiscall] = ACTIONS(1337),
    [anon_sym___vectorcall] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_signed] = ACTIONS(1337),
    [anon_sym_unsigned] = ACTIONS(1337),
    [anon_sym_long] = ACTIONS(1337),
    [anon_sym_short] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_auto] = ACTIONS(1337),
    [anon_sym_register] = ACTIONS(1337),
    [anon_sym_inline] = ACTIONS(1337),
    [anon_sym___inline] = ACTIONS(1337),
    [anon_sym___inline__] = ACTIONS(1337),
    [anon_sym___forceinline] = ACTIONS(1337),
    [anon_sym_thread_local] = ACTIONS(1337),
    [anon_sym___thread] = ACTIONS(1337),
    [anon_sym_const] = ACTIONS(1337),
    [anon_sym_constexpr] = ACTIONS(1337),
    [anon_sym_volatile] = ACTIONS(1337),
    [anon_sym_restrict] = ACTIONS(1337),
    [anon_sym___restrict__] = ACTIONS(1337),
    [anon_sym__Atomic] = ACTIONS(1337),
    [anon_sym__Noreturn] = ACTIONS(1337),
    [anon_sym_noreturn] = ACTIONS(1337),
    [anon_sym__Nonnull] = ACTIONS(1337),
    [anon_sym_alignas] = ACTIONS(1337),
    [anon_sym__Alignas] = ACTIONS(1337),
    [sym_primitive_type] = ACTIONS(1337),
    [anon_sym_enum] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1337),
    [anon_sym_union] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1337),
    [anon_sym_default] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_do] = ACTIONS(1337),
    [anon_sym_for] = ACTIONS(1337),
    [anon_sym_return] = ACTIONS(1337),
    [anon_sym_break] = ACTIONS(1337),
    [anon_sym_continue] = ACTIONS(1337),
    [anon_sym_goto] = ACTIONS(1337),
    [anon_sym___try] = ACTIONS(1337),
    [anon_sym___leave] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym___alignof__] = ACTIONS(1337),
    [anon_sym___alignof] = ACTIONS(1337),
    [anon_sym__alignof] = ACTIONS(1337),
    [anon_sym_alignof] = ACTIONS(1337),
    [anon_sym__Alignof] = ACTIONS(1337),
    [anon_sym_offsetof] = ACTIONS(1337),
    [anon_sym__Generic] = ACTIONS(1337),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [anon_sym___asm] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1339),
    [anon_sym_L_SQUOTE] = ACTIONS(1339),
    [anon_sym_u_SQUOTE] = ACTIONS(1339),
    [anon_sym_U_SQUOTE] = ACTIONS(1339),
    [anon_sym_u8_SQUOTE] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1339),
    [anon_sym_L_DQUOTE] = ACTIONS(1339),
    [anon_sym_u_DQUOTE] = ACTIONS(1339),
    [anon_sym_U_DQUOTE] = ACTIONS(1339),
    [anon_sym_u8_DQUOTE] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_true] = ACTIONS(1337),
    [sym_false] = ACTIONS(1337),
    [anon_sym_NULL] = ACTIONS(1337),
    [anon_sym_nullptr] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_identifier] = ACTIONS(1341),
    [aux_sym_preproc_include_token1] = ACTIONS(1341),
    [aux_sym_preproc_def_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token2] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1341),
    [aux_sym_preproc_else_token1] = ACTIONS(1341),
    [aux_sym_preproc_elif_token1] = ACTIONS(1341),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1341),
    [sym_preproc_directive] = ACTIONS(1341),
    [anon_sym_LPAREN2] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym___extension__] = ACTIONS(1341),
    [anon_sym_typedef] = ACTIONS(1341),
    [anon_sym_extern] = ACTIONS(1341),
    [anon_sym___attribute__] = ACTIONS(1341),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1343),
    [anon_sym___declspec] = ACTIONS(1341),
    [anon_sym___cdecl] = ACTIONS(1341),
    [anon_sym___clrcall] = ACTIONS(1341),
    [anon_sym___stdcall] = ACTIONS(1341),
    [anon_sym___fastcall] = ACTIONS(1341),
    [anon_sym___thiscall] = ACTIONS(1341),
    [anon_sym___vectorcall] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_signed] = ACTIONS(1341),
    [anon_sym_unsigned] = ACTIONS(1341),
    [anon_sym_long] = ACTIONS(1341),
    [anon_sym_short] = ACTIONS(1341),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_auto] = ACTIONS(1341),
    [anon_sym_register] = ACTIONS(1341),
    [anon_sym_inline] = ACTIONS(1341),
    [anon_sym___inline] = ACTIONS(1341),
    [anon_sym___inline__] = ACTIONS(1341),
    [anon_sym___forceinline] = ACTIONS(1341),
    [anon_sym_thread_local] = ACTIONS(1341),
    [anon_sym___thread] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_constexpr] = ACTIONS(1341),
    [anon_sym_volatile] = ACTIONS(1341),
    [anon_sym_restrict] = ACTIONS(1341),
    [anon_sym___restrict__] = ACTIONS(1341),
    [anon_sym__Atomic] = ACTIONS(1341),
    [anon_sym__Noreturn] = ACTIONS(1341),
    [anon_sym_noreturn] = ACTIONS(1341),
    [anon_sym__Nonnull] = ACTIONS(1341),
    [anon_sym_alignas] = ACTIONS(1341),
    [anon_sym__Alignas] = ACTIONS(1341),
    [sym_primitive_type] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1341),
    [anon_sym_union] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_goto] = ACTIONS(1341),
    [anon_sym___try] = ACTIONS(1341),
    [anon_sym___leave] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_sizeof] = ACTIONS(1341),
    [anon_sym___alignof__] = ACTIONS(1341),
    [anon_sym___alignof] = ACTIONS(1341),
    [anon_sym__alignof] = ACTIONS(1341),
    [anon_sym_alignof] = ACTIONS(1341),
    [anon_sym__Alignof] = ACTIONS(1341),
    [anon_sym_offsetof] = ACTIONS(1341),
    [anon_sym__Generic] = ACTIONS(1341),
    [anon_sym_asm] = ACTIONS(1341),
    [anon_sym___asm__] = ACTIONS(1341),
    [anon_sym___asm] = ACTIONS(1341),
    [sym_number_literal] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1343),
    [anon_sym_u_SQUOTE] = ACTIONS(1343),
    [anon_sym_U_SQUOTE] = ACTIONS(1343),
    [anon_sym_u8_SQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_L_DQUOTE] = ACTIONS(1343),
    [anon_sym_u_DQUOTE] = ACTIONS(1343),
    [anon_sym_U_DQUOTE] = ACTIONS(1343),
    [anon_sym_u8_DQUOTE] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [anon_sym_NULL] = ACTIONS(1341),
    [anon_sym_nullptr] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_identifier] = ACTIONS(1345),
    [aux_sym_preproc_include_token1] = ACTIONS(1345),
    [aux_sym_preproc_def_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token2] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1345),
    [aux_sym_preproc_else_token1] = ACTIONS(1345),
    [aux_sym_preproc_elif_token1] = ACTIONS(1345),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1345),
    [sym_preproc_directive] = ACTIONS(1345),
    [anon_sym_LPAREN2] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym___extension__] = ACTIONS(1345),
    [anon_sym_typedef] = ACTIONS(1345),
    [anon_sym_extern] = ACTIONS(1345),
    [anon_sym___attribute__] = ACTIONS(1345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1347),
    [anon_sym___declspec] = ACTIONS(1345),
    [anon_sym___cdecl] = ACTIONS(1345),
    [anon_sym___clrcall] = ACTIONS(1345),
    [anon_sym___stdcall] = ACTIONS(1345),
    [anon_sym___fastcall] = ACTIONS(1345),
    [anon_sym___thiscall] = ACTIONS(1345),
    [anon_sym___vectorcall] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_signed] = ACTIONS(1345),
    [anon_sym_unsigned] = ACTIONS(1345),
    [anon_sym_long] = ACTIONS(1345),
    [anon_sym_short] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_auto] = ACTIONS(1345),
    [anon_sym_register] = ACTIONS(1345),
    [anon_sym_inline] = ACTIONS(1345),
    [anon_sym___inline] = ACTIONS(1345),
    [anon_sym___inline__] = ACTIONS(1345),
    [anon_sym___forceinline] = ACTIONS(1345),
    [anon_sym_thread_local] = ACTIONS(1345),
    [anon_sym___thread] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_constexpr] = ACTIONS(1345),
    [anon_sym_volatile] = ACTIONS(1345),
    [anon_sym_restrict] = ACTIONS(1345),
    [anon_sym___restrict__] = ACTIONS(1345),
    [anon_sym__Atomic] = ACTIONS(1345),
    [anon_sym__Noreturn] = ACTIONS(1345),
    [anon_sym_noreturn] = ACTIONS(1345),
    [anon_sym__Nonnull] = ACTIONS(1345),
    [anon_sym_alignas] = ACTIONS(1345),
    [anon_sym__Alignas] = ACTIONS(1345),
    [sym_primitive_type] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1345),
    [anon_sym_union] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_goto] = ACTIONS(1345),
    [anon_sym___try] = ACTIONS(1345),
    [anon_sym___leave] = ACTIONS(1345),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_sizeof] = ACTIONS(1345),
    [anon_sym___alignof__] = ACTIONS(1345),
    [anon_sym___alignof] = ACTIONS(1345),
    [anon_sym__alignof] = ACTIONS(1345),
    [anon_sym_alignof] = ACTIONS(1345),
    [anon_sym__Alignof] = ACTIONS(1345),
    [anon_sym_offsetof] = ACTIONS(1345),
    [anon_sym__Generic] = ACTIONS(1345),
    [anon_sym_asm] = ACTIONS(1345),
    [anon_sym___asm__] = ACTIONS(1345),
    [anon_sym___asm] = ACTIONS(1345),
    [sym_number_literal] = ACTIONS(1347),
    [anon_sym_L_SQUOTE] = ACTIONS(1347),
    [anon_sym_u_SQUOTE] = ACTIONS(1347),
    [anon_sym_U_SQUOTE] = ACTIONS(1347),
    [anon_sym_u8_SQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_L_DQUOTE] = ACTIONS(1347),
    [anon_sym_u_DQUOTE] = ACTIONS(1347),
    [anon_sym_U_DQUOTE] = ACTIONS(1347),
    [anon_sym_u8_DQUOTE] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [anon_sym_NULL] = ACTIONS(1345),
    [anon_sym_nullptr] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_identifier] = ACTIONS(1349),
    [aux_sym_preproc_include_token1] = ACTIONS(1349),
    [aux_sym_preproc_def_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token2] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1349),
    [aux_sym_preproc_else_token1] = ACTIONS(1349),
    [aux_sym_preproc_elif_token1] = ACTIONS(1349),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1349),
    [sym_preproc_directive] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym___extension__] = ACTIONS(1349),
    [anon_sym_typedef] = ACTIONS(1349),
    [anon_sym_extern] = ACTIONS(1349),
    [anon_sym___attribute__] = ACTIONS(1349),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1351),
    [anon_sym___declspec] = ACTIONS(1349),
    [anon_sym___cdecl] = ACTIONS(1349),
    [anon_sym___clrcall] = ACTIONS(1349),
    [anon_sym___stdcall] = ACTIONS(1349),
    [anon_sym___fastcall] = ACTIONS(1349),
    [anon_sym___thiscall] = ACTIONS(1349),
    [anon_sym___vectorcall] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_signed] = ACTIONS(1349),
    [anon_sym_unsigned] = ACTIONS(1349),
    [anon_sym_long] = ACTIONS(1349),
    [anon_sym_short] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_auto] = ACTIONS(1349),
    [anon_sym_register] = ACTIONS(1349),
    [anon_sym_inline] = ACTIONS(1349),
    [anon_sym___inline] = ACTIONS(1349),
    [anon_sym___inline__] = ACTIONS(1349),
    [anon_sym___forceinline] = ACTIONS(1349),
    [anon_sym_thread_local] = ACTIONS(1349),
    [anon_sym___thread] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_constexpr] = ACTIONS(1349),
    [anon_sym_volatile] = ACTIONS(1349),
    [anon_sym_restrict] = ACTIONS(1349),
    [anon_sym___restrict__] = ACTIONS(1349),
    [anon_sym__Atomic] = ACTIONS(1349),
    [anon_sym__Noreturn] = ACTIONS(1349),
    [anon_sym_noreturn] = ACTIONS(1349),
    [anon_sym__Nonnull] = ACTIONS(1349),
    [anon_sym_alignas] = ACTIONS(1349),
    [anon_sym__Alignas] = ACTIONS(1349),
    [sym_primitive_type] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1349),
    [anon_sym_union] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_goto] = ACTIONS(1349),
    [anon_sym___try] = ACTIONS(1349),
    [anon_sym___leave] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_sizeof] = ACTIONS(1349),
    [anon_sym___alignof__] = ACTIONS(1349),
    [anon_sym___alignof] = ACTIONS(1349),
    [anon_sym__alignof] = ACTIONS(1349),
    [anon_sym_alignof] = ACTIONS(1349),
    [anon_sym__Alignof] = ACTIONS(1349),
    [anon_sym_offsetof] = ACTIONS(1349),
    [anon_sym__Generic] = ACTIONS(1349),
    [anon_sym_asm] = ACTIONS(1349),
    [anon_sym___asm__] = ACTIONS(1349),
    [anon_sym___asm] = ACTIONS(1349),
    [sym_number_literal] = ACTIONS(1351),
    [anon_sym_L_SQUOTE] = ACTIONS(1351),
    [anon_sym_u_SQUOTE] = ACTIONS(1351),
    [anon_sym_U_SQUOTE] = ACTIONS(1351),
    [anon_sym_u8_SQUOTE] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1351),
    [anon_sym_L_DQUOTE] = ACTIONS(1351),
    [anon_sym_u_DQUOTE] = ACTIONS(1351),
    [anon_sym_U_DQUOTE] = ACTIONS(1351),
    [anon_sym_u8_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [anon_sym_NULL] = ACTIONS(1349),
    [anon_sym_nullptr] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_identifier] = ACTIONS(1353),
    [aux_sym_preproc_include_token1] = ACTIONS(1353),
    [aux_sym_preproc_def_token1] = ACTIONS(1353),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_if_token2] = ACTIONS(1353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1353),
    [aux_sym_preproc_else_token1] = ACTIONS(1353),
    [aux_sym_preproc_elif_token1] = ACTIONS(1353),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1353),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1353),
    [sym_preproc_directive] = ACTIONS(1353),
    [anon_sym_LPAREN2] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_AMP] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1355),
    [anon_sym___extension__] = ACTIONS(1353),
    [anon_sym_typedef] = ACTIONS(1353),
    [anon_sym_extern] = ACTIONS(1353),
    [anon_sym___attribute__] = ACTIONS(1353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1355),
    [anon_sym___declspec] = ACTIONS(1353),
    [anon_sym___cdecl] = ACTIONS(1353),
    [anon_sym___clrcall] = ACTIONS(1353),
    [anon_sym___stdcall] = ACTIONS(1353),
    [anon_sym___fastcall] = ACTIONS(1353),
    [anon_sym___thiscall] = ACTIONS(1353),
    [anon_sym___vectorcall] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1355),
    [anon_sym_signed] = ACTIONS(1353),
    [anon_sym_unsigned] = ACTIONS(1353),
    [anon_sym_long] = ACTIONS(1353),
    [anon_sym_short] = ACTIONS(1353),
    [anon_sym_static] = ACTIONS(1353),
    [anon_sym_auto] = ACTIONS(1353),
    [anon_sym_register] = ACTIONS(1353),
    [anon_sym_inline] = ACTIONS(1353),
    [anon_sym___inline] = ACTIONS(1353),
    [anon_sym___inline__] = ACTIONS(1353),
    [anon_sym___forceinline] = ACTIONS(1353),
    [anon_sym_thread_local] = ACTIONS(1353),
    [anon_sym___thread] = ACTIONS(1353),
    [anon_sym_const] = ACTIONS(1353),
    [anon_sym_constexpr] = ACTIONS(1353),
    [anon_sym_volatile] = ACTIONS(1353),
    [anon_sym_restrict] = ACTIONS(1353),
    [anon_sym___restrict__] = ACTIONS(1353),
    [anon_sym__Atomic] = ACTIONS(1353),
    [anon_sym__Noreturn] = ACTIONS(1353),
    [anon_sym_noreturn] = ACTIONS(1353),
    [anon_sym__Nonnull] = ACTIONS(1353),
    [anon_sym_alignas] = ACTIONS(1353),
    [anon_sym__Alignas] = ACTIONS(1353),
    [sym_primitive_type] = ACTIONS(1353),
    [anon_sym_enum] = ACTIONS(1353),
    [anon_sym_struct] = ACTIONS(1353),
    [anon_sym_union] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(1353),
    [anon_sym_switch] = ACTIONS(1353),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_default] = ACTIONS(1353),
    [anon_sym_while] = ACTIONS(1353),
    [anon_sym_do] = ACTIONS(1353),
    [anon_sym_for] = ACTIONS(1353),
    [anon_sym_return] = ACTIONS(1353),
    [anon_sym_break] = ACTIONS(1353),
    [anon_sym_continue] = ACTIONS(1353),
    [anon_sym_goto] = ACTIONS(1353),
    [anon_sym___try] = ACTIONS(1353),
    [anon_sym___leave] = ACTIONS(1353),
    [anon_sym_DASH_DASH] = ACTIONS(1355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1355),
    [anon_sym_sizeof] = ACTIONS(1353),
    [anon_sym___alignof__] = ACTIONS(1353),
    [anon_sym___alignof] = ACTIONS(1353),
    [anon_sym__alignof] = ACTIONS(1353),
    [anon_sym_alignof] = ACTIONS(1353),
    [anon_sym__Alignof] = ACTIONS(1353),
    [anon_sym_offsetof] = ACTIONS(1353),
    [anon_sym__Generic] = ACTIONS(1353),
    [anon_sym_asm] = ACTIONS(1353),
    [anon_sym___asm__] = ACTIONS(1353),
    [anon_sym___asm] = ACTIONS(1353),
    [sym_number_literal] = ACTIONS(1355),
    [anon_sym_L_SQUOTE] = ACTIONS(1355),
    [anon_sym_u_SQUOTE] = ACTIONS(1355),
    [anon_sym_U_SQUOTE] = ACTIONS(1355),
    [anon_sym_u8_SQUOTE] = ACTIONS(1355),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_L_DQUOTE] = ACTIONS(1355),
    [anon_sym_u_DQUOTE] = ACTIONS(1355),
    [anon_sym_U_DQUOTE] = ACTIONS(1355),
    [anon_sym_u8_DQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_true] = ACTIONS(1353),
    [sym_false] = ACTIONS(1353),
    [anon_sym_NULL] = ACTIONS(1353),
    [anon_sym_nullptr] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_identifier] = ACTIONS(1357),
    [aux_sym_preproc_include_token1] = ACTIONS(1357),
    [aux_sym_preproc_def_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token2] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1357),
    [aux_sym_preproc_else_token1] = ACTIONS(1357),
    [aux_sym_preproc_elif_token1] = ACTIONS(1357),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_LPAREN2] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym___extension__] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym___attribute__] = ACTIONS(1357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1359),
    [anon_sym___declspec] = ACTIONS(1357),
    [anon_sym___cdecl] = ACTIONS(1357),
    [anon_sym___clrcall] = ACTIONS(1357),
    [anon_sym___stdcall] = ACTIONS(1357),
    [anon_sym___fastcall] = ACTIONS(1357),
    [anon_sym___thiscall] = ACTIONS(1357),
    [anon_sym___vectorcall] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_signed] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_auto] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym___inline] = ACTIONS(1357),
    [anon_sym___inline__] = ACTIONS(1357),
    [anon_sym___forceinline] = ACTIONS(1357),
    [anon_sym_thread_local] = ACTIONS(1357),
    [anon_sym___thread] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym___restrict__] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym__Noreturn] = ACTIONS(1357),
    [anon_sym_noreturn] = ACTIONS(1357),
    [anon_sym__Nonnull] = ACTIONS(1357),
    [anon_sym_alignas] = ACTIONS(1357),
    [anon_sym__Alignas] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1357),
    [anon_sym_default] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_return] = ACTIONS(1357),
    [anon_sym_break] = ACTIONS(1357),
    [anon_sym_continue] = ACTIONS(1357),
    [anon_sym_goto] = ACTIONS(1357),
    [anon_sym___try] = ACTIONS(1357),
    [anon_sym___leave] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_sizeof] = ACTIONS(1357),
    [anon_sym___alignof__] = ACTIONS(1357),
    [anon_sym___alignof] = ACTIONS(1357),
    [anon_sym__alignof] = ACTIONS(1357),
    [anon_sym_alignof] = ACTIONS(1357),
    [anon_sym__Alignof] = ACTIONS(1357),
    [anon_sym_offsetof] = ACTIONS(1357),
    [anon_sym__Generic] = ACTIONS(1357),
    [anon_sym_asm] = ACTIONS(1357),
    [anon_sym___asm__] = ACTIONS(1357),
    [anon_sym___asm] = ACTIONS(1357),
    [sym_number_literal] = ACTIONS(1359),
    [anon_sym_L_SQUOTE] = ACTIONS(1359),
    [anon_sym_u_SQUOTE] = ACTIONS(1359),
    [anon_sym_U_SQUOTE] = ACTIONS(1359),
    [anon_sym_u8_SQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_L_DQUOTE] = ACTIONS(1359),
    [anon_sym_u_DQUOTE] = ACTIONS(1359),
    [anon_sym_U_DQUOTE] = ACTIONS(1359),
    [anon_sym_u8_DQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [anon_sym_NULL] = ACTIONS(1357),
    [anon_sym_nullptr] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token2] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [aux_sym_preproc_else_token1] = ACTIONS(1361),
    [aux_sym_preproc_elif_token1] = ACTIONS(1361),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1364),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym__Nonnull] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [anon_sym___asm] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1364),
    [anon_sym_L_SQUOTE] = ACTIONS(1364),
    [anon_sym_u_SQUOTE] = ACTIONS(1364),
    [anon_sym_U_SQUOTE] = ACTIONS(1364),
    [anon_sym_u8_SQUOTE] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_L_DQUOTE] = ACTIONS(1364),
    [anon_sym_u_DQUOTE] = ACTIONS(1364),
    [anon_sym_U_DQUOTE] = ACTIONS(1364),
    [anon_sym_u8_DQUOTE] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_identifier] = ACTIONS(1367),
    [aux_sym_preproc_include_token1] = ACTIONS(1367),
    [aux_sym_preproc_def_token1] = ACTIONS(1367),
    [aux_sym_preproc_if_token1] = ACTIONS(1367),
    [aux_sym_preproc_if_token2] = ACTIONS(1367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1367),
    [aux_sym_preproc_else_token1] = ACTIONS(1367),
    [aux_sym_preproc_elif_token1] = ACTIONS(1367),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1367),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1367),
    [sym_preproc_directive] = ACTIONS(1367),
    [anon_sym_LPAREN2] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1367),
    [anon_sym_STAR] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym___extension__] = ACTIONS(1367),
    [anon_sym_typedef] = ACTIONS(1367),
    [anon_sym_extern] = ACTIONS(1367),
    [anon_sym___attribute__] = ACTIONS(1367),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1369),
    [anon_sym___declspec] = ACTIONS(1367),
    [anon_sym___cdecl] = ACTIONS(1367),
    [anon_sym___clrcall] = ACTIONS(1367),
    [anon_sym___stdcall] = ACTIONS(1367),
    [anon_sym___fastcall] = ACTIONS(1367),
    [anon_sym___thiscall] = ACTIONS(1367),
    [anon_sym___vectorcall] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_signed] = ACTIONS(1367),
    [anon_sym_unsigned] = ACTIONS(1367),
    [anon_sym_long] = ACTIONS(1367),
    [anon_sym_short] = ACTIONS(1367),
    [anon_sym_static] = ACTIONS(1367),
    [anon_sym_auto] = ACTIONS(1367),
    [anon_sym_register] = ACTIONS(1367),
    [anon_sym_inline] = ACTIONS(1367),
    [anon_sym___inline] = ACTIONS(1367),
    [anon_sym___inline__] = ACTIONS(1367),
    [anon_sym___forceinline] = ACTIONS(1367),
    [anon_sym_thread_local] = ACTIONS(1367),
    [anon_sym___thread] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1367),
    [anon_sym_constexpr] = ACTIONS(1367),
    [anon_sym_volatile] = ACTIONS(1367),
    [anon_sym_restrict] = ACTIONS(1367),
    [anon_sym___restrict__] = ACTIONS(1367),
    [anon_sym__Atomic] = ACTIONS(1367),
    [anon_sym__Noreturn] = ACTIONS(1367),
    [anon_sym_noreturn] = ACTIONS(1367),
    [anon_sym__Nonnull] = ACTIONS(1367),
    [anon_sym_alignas] = ACTIONS(1367),
    [anon_sym__Alignas] = ACTIONS(1367),
    [sym_primitive_type] = ACTIONS(1367),
    [anon_sym_enum] = ACTIONS(1367),
    [anon_sym_struct] = ACTIONS(1367),
    [anon_sym_union] = ACTIONS(1367),
    [anon_sym_if] = ACTIONS(1367),
    [anon_sym_switch] = ACTIONS(1367),
    [anon_sym_case] = ACTIONS(1367),
    [anon_sym_default] = ACTIONS(1367),
    [anon_sym_while] = ACTIONS(1367),
    [anon_sym_do] = ACTIONS(1367),
    [anon_sym_for] = ACTIONS(1367),
    [anon_sym_return] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1367),
    [anon_sym_continue] = ACTIONS(1367),
    [anon_sym_goto] = ACTIONS(1367),
    [anon_sym___try] = ACTIONS(1367),
    [anon_sym___leave] = ACTIONS(1367),
    [anon_sym_DASH_DASH] = ACTIONS(1369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_sizeof] = ACTIONS(1367),
    [anon_sym___alignof__] = ACTIONS(1367),
    [anon_sym___alignof] = ACTIONS(1367),
    [anon_sym__alignof] = ACTIONS(1367),
    [anon_sym_alignof] = ACTIONS(1367),
    [anon_sym__Alignof] = ACTIONS(1367),
    [anon_sym_offsetof] = ACTIONS(1367),
    [anon_sym__Generic] = ACTIONS(1367),
    [anon_sym_asm] = ACTIONS(1367),
    [anon_sym___asm__] = ACTIONS(1367),
    [anon_sym___asm] = ACTIONS(1367),
    [sym_number_literal] = ACTIONS(1369),
    [anon_sym_L_SQUOTE] = ACTIONS(1369),
    [anon_sym_u_SQUOTE] = ACTIONS(1369),
    [anon_sym_U_SQUOTE] = ACTIONS(1369),
    [anon_sym_u8_SQUOTE] = ACTIONS(1369),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_L_DQUOTE] = ACTIONS(1369),
    [anon_sym_u_DQUOTE] = ACTIONS(1369),
    [anon_sym_U_DQUOTE] = ACTIONS(1369),
    [anon_sym_u8_DQUOTE] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1369),
    [sym_true] = ACTIONS(1367),
    [sym_false] = ACTIONS(1367),
    [anon_sym_NULL] = ACTIONS(1367),
    [anon_sym_nullptr] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_identifier] = ACTIONS(1371),
    [aux_sym_preproc_include_token1] = ACTIONS(1371),
    [aux_sym_preproc_def_token1] = ACTIONS(1371),
    [aux_sym_preproc_if_token1] = ACTIONS(1371),
    [aux_sym_preproc_if_token2] = ACTIONS(1371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1371),
    [aux_sym_preproc_else_token1] = ACTIONS(1371),
    [aux_sym_preproc_elif_token1] = ACTIONS(1371),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1371),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1371),
    [sym_preproc_directive] = ACTIONS(1371),
    [anon_sym_LPAREN2] = ACTIONS(1373),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym___extension__] = ACTIONS(1371),
    [anon_sym_typedef] = ACTIONS(1371),
    [anon_sym_extern] = ACTIONS(1371),
    [anon_sym___attribute__] = ACTIONS(1371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1373),
    [anon_sym___declspec] = ACTIONS(1371),
    [anon_sym___cdecl] = ACTIONS(1371),
    [anon_sym___clrcall] = ACTIONS(1371),
    [anon_sym___stdcall] = ACTIONS(1371),
    [anon_sym___fastcall] = ACTIONS(1371),
    [anon_sym___thiscall] = ACTIONS(1371),
    [anon_sym___vectorcall] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(1373),
    [anon_sym_signed] = ACTIONS(1371),
    [anon_sym_unsigned] = ACTIONS(1371),
    [anon_sym_long] = ACTIONS(1371),
    [anon_sym_short] = ACTIONS(1371),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_auto] = ACTIONS(1371),
    [anon_sym_register] = ACTIONS(1371),
    [anon_sym_inline] = ACTIONS(1371),
    [anon_sym___inline] = ACTIONS(1371),
    [anon_sym___inline__] = ACTIONS(1371),
    [anon_sym___forceinline] = ACTIONS(1371),
    [anon_sym_thread_local] = ACTIONS(1371),
    [anon_sym___thread] = ACTIONS(1371),
    [anon_sym_const] = ACTIONS(1371),
    [anon_sym_constexpr] = ACTIONS(1371),
    [anon_sym_volatile] = ACTIONS(1371),
    [anon_sym_restrict] = ACTIONS(1371),
    [anon_sym___restrict__] = ACTIONS(1371),
    [anon_sym__Atomic] = ACTIONS(1371),
    [anon_sym__Noreturn] = ACTIONS(1371),
    [anon_sym_noreturn] = ACTIONS(1371),
    [anon_sym__Nonnull] = ACTIONS(1371),
    [anon_sym_alignas] = ACTIONS(1371),
    [anon_sym__Alignas] = ACTIONS(1371),
    [sym_primitive_type] = ACTIONS(1371),
    [anon_sym_enum] = ACTIONS(1371),
    [anon_sym_struct] = ACTIONS(1371),
    [anon_sym_union] = ACTIONS(1371),
    [anon_sym_if] = ACTIONS(1371),
    [anon_sym_switch] = ACTIONS(1371),
    [anon_sym_case] = ACTIONS(1371),
    [anon_sym_default] = ACTIONS(1371),
    [anon_sym_while] = ACTIONS(1371),
    [anon_sym_do] = ACTIONS(1371),
    [anon_sym_for] = ACTIONS(1371),
    [anon_sym_return] = ACTIONS(1371),
    [anon_sym_break] = ACTIONS(1371),
    [anon_sym_continue] = ACTIONS(1371),
    [anon_sym_goto] = ACTIONS(1371),
    [anon_sym___try] = ACTIONS(1371),
    [anon_sym___leave] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_sizeof] = ACTIONS(1371),
    [anon_sym___alignof__] = ACTIONS(1371),
    [anon_sym___alignof] = ACTIONS(1371),
    [anon_sym__alignof] = ACTIONS(1371),
    [anon_sym_alignof] = ACTIONS(1371),
    [anon_sym__Alignof] = ACTIONS(1371),
    [anon_sym_offsetof] = ACTIONS(1371),
    [anon_sym__Generic] = ACTIONS(1371),
    [anon_sym_asm] = ACTIONS(1371),
    [anon_sym___asm__] = ACTIONS(1371),
    [anon_sym___asm] = ACTIONS(1371),
    [sym_number_literal] = ACTIONS(1373),
    [anon_sym_L_SQUOTE] = ACTIONS(1373),
    [anon_sym_u_SQUOTE] = ACTIONS(1373),
    [anon_sym_U_SQUOTE] = ACTIONS(1373),
    [anon_sym_u8_SQUOTE] = ACTIONS(1373),
    [anon_sym_SQUOTE] = ACTIONS(1373),
    [anon_sym_L_DQUOTE] = ACTIONS(1373),
    [anon_sym_u_DQUOTE] = ACTIONS(1373),
    [anon_sym_U_DQUOTE] = ACTIONS(1373),
    [anon_sym_u8_DQUOTE] = ACTIONS(1373),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_true] = ACTIONS(1371),
    [sym_false] = ACTIONS(1371),
    [anon_sym_NULL] = ACTIONS(1371),
    [anon_sym_nullptr] = ACTIONS(1371),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_else_clause] = STATE(194),
    [sym_identifier] = ACTIONS(1123),
    [aux_sym_preproc_include_token1] = ACTIONS(1123),
    [aux_sym_preproc_def_token1] = ACTIONS(1123),
    [aux_sym_preproc_if_token1] = ACTIONS(1123),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1123),
    [sym_preproc_directive] = ACTIONS(1123),
    [anon_sym_LPAREN2] = ACTIONS(1125),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym___extension__] = ACTIONS(1123),
    [anon_sym_typedef] = ACTIONS(1123),
    [anon_sym_extern] = ACTIONS(1123),
    [anon_sym___attribute__] = ACTIONS(1123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1125),
    [anon_sym___declspec] = ACTIONS(1123),
    [anon_sym___cdecl] = ACTIONS(1123),
    [anon_sym___clrcall] = ACTIONS(1123),
    [anon_sym___stdcall] = ACTIONS(1123),
    [anon_sym___fastcall] = ACTIONS(1123),
    [anon_sym___thiscall] = ACTIONS(1123),
    [anon_sym___vectorcall] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym_signed] = ACTIONS(1123),
    [anon_sym_unsigned] = ACTIONS(1123),
    [anon_sym_long] = ACTIONS(1123),
    [anon_sym_short] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_auto] = ACTIONS(1123),
    [anon_sym_register] = ACTIONS(1123),
    [anon_sym_inline] = ACTIONS(1123),
    [anon_sym___inline] = ACTIONS(1123),
    [anon_sym___inline__] = ACTIONS(1123),
    [anon_sym___forceinline] = ACTIONS(1123),
    [anon_sym_thread_local] = ACTIONS(1123),
    [anon_sym___thread] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_constexpr] = ACTIONS(1123),
    [anon_sym_volatile] = ACTIONS(1123),
    [anon_sym_restrict] = ACTIONS(1123),
    [anon_sym___restrict__] = ACTIONS(1123),
    [anon_sym__Atomic] = ACTIONS(1123),
    [anon_sym__Noreturn] = ACTIONS(1123),
    [anon_sym_noreturn] = ACTIONS(1123),
    [anon_sym__Nonnull] = ACTIONS(1123),
    [anon_sym_alignas] = ACTIONS(1123),
    [anon_sym__Alignas] = ACTIONS(1123),
    [sym_primitive_type] = ACTIONS(1123),
    [anon_sym_enum] = ACTIONS(1123),
    [anon_sym_struct] = ACTIONS(1123),
    [anon_sym_union] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_else] = ACTIONS(1375),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1123),
    [anon_sym_default] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_do] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_goto] = ACTIONS(1123),
    [anon_sym___try] = ACTIONS(1123),
    [anon_sym___leave] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_sizeof] = ACTIONS(1123),
    [anon_sym___alignof__] = ACTIONS(1123),
    [anon_sym___alignof] = ACTIONS(1123),
    [anon_sym__alignof] = ACTIONS(1123),
    [anon_sym_alignof] = ACTIONS(1123),
    [anon_sym__Alignof] = ACTIONS(1123),
    [anon_sym_offsetof] = ACTIONS(1123),
    [anon_sym__Generic] = ACTIONS(1123),
    [anon_sym_asm] = ACTIONS(1123),
    [anon_sym___asm__] = ACTIONS(1123),
    [anon_sym___asm] = ACTIONS(1123),
    [sym_number_literal] = ACTIONS(1125),
    [anon_sym_L_SQUOTE] = ACTIONS(1125),
    [anon_sym_u_SQUOTE] = ACTIONS(1125),
    [anon_sym_U_SQUOTE] = ACTIONS(1125),
    [anon_sym_u8_SQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [anon_sym_L_DQUOTE] = ACTIONS(1125),
    [anon_sym_u_DQUOTE] = ACTIONS(1125),
    [anon_sym_U_DQUOTE] = ACTIONS(1125),
    [anon_sym_u8_DQUOTE] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [anon_sym_NULL] = ACTIONS(1123),
    [anon_sym_nullptr] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_else_clause] = STATE(250),
    [ts_builtin_sym_end] = ACTIONS(1125),
    [sym_identifier] = ACTIONS(1123),
    [aux_sym_preproc_include_token1] = ACTIONS(1123),
    [aux_sym_preproc_def_token1] = ACTIONS(1123),
    [aux_sym_preproc_if_token1] = ACTIONS(1123),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1123),
    [sym_preproc_directive] = ACTIONS(1123),
    [anon_sym_LPAREN2] = ACTIONS(1125),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym___extension__] = ACTIONS(1123),
    [anon_sym_typedef] = ACTIONS(1123),
    [anon_sym_extern] = ACTIONS(1123),
    [anon_sym___attribute__] = ACTIONS(1123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1125),
    [anon_sym___declspec] = ACTIONS(1123),
    [anon_sym___cdecl] = ACTIONS(1123),
    [anon_sym___clrcall] = ACTIONS(1123),
    [anon_sym___stdcall] = ACTIONS(1123),
    [anon_sym___fastcall] = ACTIONS(1123),
    [anon_sym___thiscall] = ACTIONS(1123),
    [anon_sym___vectorcall] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_signed] = ACTIONS(1123),
    [anon_sym_unsigned] = ACTIONS(1123),
    [anon_sym_long] = ACTIONS(1123),
    [anon_sym_short] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_auto] = ACTIONS(1123),
    [anon_sym_register] = ACTIONS(1123),
    [anon_sym_inline] = ACTIONS(1123),
    [anon_sym___inline] = ACTIONS(1123),
    [anon_sym___inline__] = ACTIONS(1123),
    [anon_sym___forceinline] = ACTIONS(1123),
    [anon_sym_thread_local] = ACTIONS(1123),
    [anon_sym___thread] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_constexpr] = ACTIONS(1123),
    [anon_sym_volatile] = ACTIONS(1123),
    [anon_sym_restrict] = ACTIONS(1123),
    [anon_sym___restrict__] = ACTIONS(1123),
    [anon_sym__Atomic] = ACTIONS(1123),
    [anon_sym__Noreturn] = ACTIONS(1123),
    [anon_sym_noreturn] = ACTIONS(1123),
    [anon_sym__Nonnull] = ACTIONS(1123),
    [anon_sym_alignas] = ACTIONS(1123),
    [anon_sym__Alignas] = ACTIONS(1123),
    [sym_primitive_type] = ACTIONS(1123),
    [anon_sym_enum] = ACTIONS(1123),
    [anon_sym_struct] = ACTIONS(1123),
    [anon_sym_union] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_else] = ACTIONS(1377),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1123),
    [anon_sym_default] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_do] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_goto] = ACTIONS(1123),
    [anon_sym___try] = ACTIONS(1123),
    [anon_sym___leave] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_sizeof] = ACTIONS(1123),
    [anon_sym___alignof__] = ACTIONS(1123),
    [anon_sym___alignof] = ACTIONS(1123),
    [anon_sym__alignof] = ACTIONS(1123),
    [anon_sym_alignof] = ACTIONS(1123),
    [anon_sym__Alignof] = ACTIONS(1123),
    [anon_sym_offsetof] = ACTIONS(1123),
    [anon_sym__Generic] = ACTIONS(1123),
    [anon_sym_asm] = ACTIONS(1123),
    [anon_sym___asm__] = ACTIONS(1123),
    [anon_sym___asm] = ACTIONS(1123),
    [sym_number_literal] = ACTIONS(1125),
    [anon_sym_L_SQUOTE] = ACTIONS(1125),
    [anon_sym_u_SQUOTE] = ACTIONS(1125),
    [anon_sym_U_SQUOTE] = ACTIONS(1125),
    [anon_sym_u8_SQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [anon_sym_L_DQUOTE] = ACTIONS(1125),
    [anon_sym_u_DQUOTE] = ACTIONS(1125),
    [anon_sym_U_DQUOTE] = ACTIONS(1125),
    [anon_sym_u8_DQUOTE] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [anon_sym_NULL] = ACTIONS(1123),
    [anon_sym_nullptr] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_else_clause] = STATE(221),
    [sym_identifier] = ACTIONS(1123),
    [aux_sym_preproc_include_token1] = ACTIONS(1123),
    [aux_sym_preproc_def_token1] = ACTIONS(1123),
    [aux_sym_preproc_if_token1] = ACTIONS(1123),
    [aux_sym_preproc_if_token2] = ACTIONS(1123),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1123),
    [sym_preproc_directive] = ACTIONS(1123),
    [anon_sym_LPAREN2] = ACTIONS(1125),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym___extension__] = ACTIONS(1123),
    [anon_sym_typedef] = ACTIONS(1123),
    [anon_sym_extern] = ACTIONS(1123),
    [anon_sym___attribute__] = ACTIONS(1123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1125),
    [anon_sym___declspec] = ACTIONS(1123),
    [anon_sym___cdecl] = ACTIONS(1123),
    [anon_sym___clrcall] = ACTIONS(1123),
    [anon_sym___stdcall] = ACTIONS(1123),
    [anon_sym___fastcall] = ACTIONS(1123),
    [anon_sym___thiscall] = ACTIONS(1123),
    [anon_sym___vectorcall] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_signed] = ACTIONS(1123),
    [anon_sym_unsigned] = ACTIONS(1123),
    [anon_sym_long] = ACTIONS(1123),
    [anon_sym_short] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_auto] = ACTIONS(1123),
    [anon_sym_register] = ACTIONS(1123),
    [anon_sym_inline] = ACTIONS(1123),
    [anon_sym___inline] = ACTIONS(1123),
    [anon_sym___inline__] = ACTIONS(1123),
    [anon_sym___forceinline] = ACTIONS(1123),
    [anon_sym_thread_local] = ACTIONS(1123),
    [anon_sym___thread] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_constexpr] = ACTIONS(1123),
    [anon_sym_volatile] = ACTIONS(1123),
    [anon_sym_restrict] = ACTIONS(1123),
    [anon_sym___restrict__] = ACTIONS(1123),
    [anon_sym__Atomic] = ACTIONS(1123),
    [anon_sym__Noreturn] = ACTIONS(1123),
    [anon_sym_noreturn] = ACTIONS(1123),
    [anon_sym__Nonnull] = ACTIONS(1123),
    [anon_sym_alignas] = ACTIONS(1123),
    [anon_sym__Alignas] = ACTIONS(1123),
    [sym_primitive_type] = ACTIONS(1123),
    [anon_sym_enum] = ACTIONS(1123),
    [anon_sym_struct] = ACTIONS(1123),
    [anon_sym_union] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_else] = ACTIONS(1379),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1123),
    [anon_sym_default] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_do] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_goto] = ACTIONS(1123),
    [anon_sym___try] = ACTIONS(1123),
    [anon_sym___leave] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_sizeof] = ACTIONS(1123),
    [anon_sym___alignof__] = ACTIONS(1123),
    [anon_sym___alignof] = ACTIONS(1123),
    [anon_sym__alignof] = ACTIONS(1123),
    [anon_sym_alignof] = ACTIONS(1123),
    [anon_sym__Alignof] = ACTIONS(1123),
    [anon_sym_offsetof] = ACTIONS(1123),
    [anon_sym__Generic] = ACTIONS(1123),
    [anon_sym_asm] = ACTIONS(1123),
    [anon_sym___asm__] = ACTIONS(1123),
    [anon_sym___asm] = ACTIONS(1123),
    [sym_number_literal] = ACTIONS(1125),
    [anon_sym_L_SQUOTE] = ACTIONS(1125),
    [anon_sym_u_SQUOTE] = ACTIONS(1125),
    [anon_sym_U_SQUOTE] = ACTIONS(1125),
    [anon_sym_u8_SQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [anon_sym_L_DQUOTE] = ACTIONS(1125),
    [anon_sym_u_DQUOTE] = ACTIONS(1125),
    [anon_sym_U_DQUOTE] = ACTIONS(1125),
    [anon_sym_u8_DQUOTE] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [anon_sym_NULL] = ACTIONS(1123),
    [anon_sym_nullptr] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_identifier] = ACTIONS(1233),
    [aux_sym_preproc_include_token1] = ACTIONS(1233),
    [aux_sym_preproc_def_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token2] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1233),
    [sym_preproc_directive] = ACTIONS(1233),
    [anon_sym_LPAREN2] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym___extension__] = ACTIONS(1233),
    [anon_sym_typedef] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1233),
    [anon_sym___attribute__] = ACTIONS(1233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym___declspec] = ACTIONS(1233),
    [anon_sym___cdecl] = ACTIONS(1233),
    [anon_sym___clrcall] = ACTIONS(1233),
    [anon_sym___stdcall] = ACTIONS(1233),
    [anon_sym___fastcall] = ACTIONS(1233),
    [anon_sym___thiscall] = ACTIONS(1233),
    [anon_sym___vectorcall] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_signed] = ACTIONS(1233),
    [anon_sym_unsigned] = ACTIONS(1233),
    [anon_sym_long] = ACTIONS(1233),
    [anon_sym_short] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_auto] = ACTIONS(1233),
    [anon_sym_register] = ACTIONS(1233),
    [anon_sym_inline] = ACTIONS(1233),
    [anon_sym___inline] = ACTIONS(1233),
    [anon_sym___inline__] = ACTIONS(1233),
    [anon_sym___forceinline] = ACTIONS(1233),
    [anon_sym_thread_local] = ACTIONS(1233),
    [anon_sym___thread] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_constexpr] = ACTIONS(1233),
    [anon_sym_volatile] = ACTIONS(1233),
    [anon_sym_restrict] = ACTIONS(1233),
    [anon_sym___restrict__] = ACTIONS(1233),
    [anon_sym__Atomic] = ACTIONS(1233),
    [anon_sym__Noreturn] = ACTIONS(1233),
    [anon_sym_noreturn] = ACTIONS(1233),
    [anon_sym__Nonnull] = ACTIONS(1233),
    [anon_sym_alignas] = ACTIONS(1233),
    [anon_sym__Alignas] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_goto] = ACTIONS(1233),
    [anon_sym___try] = ACTIONS(1233),
    [anon_sym___leave] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_sizeof] = ACTIONS(1233),
    [anon_sym___alignof__] = ACTIONS(1233),
    [anon_sym___alignof] = ACTIONS(1233),
    [anon_sym__alignof] = ACTIONS(1233),
    [anon_sym_alignof] = ACTIONS(1233),
    [anon_sym__Alignof] = ACTIONS(1233),
    [anon_sym_offsetof] = ACTIONS(1233),
    [anon_sym__Generic] = ACTIONS(1233),
    [anon_sym_asm] = ACTIONS(1233),
    [anon_sym___asm__] = ACTIONS(1233),
    [anon_sym___asm] = ACTIONS(1233),
    [sym_number_literal] = ACTIONS(1235),
    [anon_sym_L_SQUOTE] = ACTIONS(1235),
    [anon_sym_u_SQUOTE] = ACTIONS(1235),
    [anon_sym_U_SQUOTE] = ACTIONS(1235),
    [anon_sym_u8_SQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_L_DQUOTE] = ACTIONS(1235),
    [anon_sym_u_DQUOTE] = ACTIONS(1235),
    [anon_sym_U_DQUOTE] = ACTIONS(1235),
    [anon_sym_u8_DQUOTE] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [anon_sym_NULL] = ACTIONS(1233),
    [anon_sym_nullptr] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [sym_identifier] = ACTIONS(1225),
    [aux_sym_preproc_include_token1] = ACTIONS(1225),
    [aux_sym_preproc_def_token1] = ACTIONS(1225),
    [aux_sym_preproc_if_token1] = ACTIONS(1225),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1225),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1225),
    [sym_preproc_directive] = ACTIONS(1225),
    [anon_sym_LPAREN2] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym___extension__] = ACTIONS(1225),
    [anon_sym_typedef] = ACTIONS(1225),
    [anon_sym_extern] = ACTIONS(1225),
    [anon_sym___attribute__] = ACTIONS(1225),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym___declspec] = ACTIONS(1225),
    [anon_sym___cdecl] = ACTIONS(1225),
    [anon_sym___clrcall] = ACTIONS(1225),
    [anon_sym___stdcall] = ACTIONS(1225),
    [anon_sym___fastcall] = ACTIONS(1225),
    [anon_sym___thiscall] = ACTIONS(1225),
    [anon_sym___vectorcall] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_signed] = ACTIONS(1225),
    [anon_sym_unsigned] = ACTIONS(1225),
    [anon_sym_long] = ACTIONS(1225),
    [anon_sym_short] = ACTIONS(1225),
    [anon_sym_static] = ACTIONS(1225),
    [anon_sym_auto] = ACTIONS(1225),
    [anon_sym_register] = ACTIONS(1225),
    [anon_sym_inline] = ACTIONS(1225),
    [anon_sym___inline] = ACTIONS(1225),
    [anon_sym___inline__] = ACTIONS(1225),
    [anon_sym___forceinline] = ACTIONS(1225),
    [anon_sym_thread_local] = ACTIONS(1225),
    [anon_sym___thread] = ACTIONS(1225),
    [anon_sym_const] = ACTIONS(1225),
    [anon_sym_constexpr] = ACTIONS(1225),
    [anon_sym_volatile] = ACTIONS(1225),
    [anon_sym_restrict] = ACTIONS(1225),
    [anon_sym___restrict__] = ACTIONS(1225),
    [anon_sym__Atomic] = ACTIONS(1225),
    [anon_sym__Noreturn] = ACTIONS(1225),
    [anon_sym_noreturn] = ACTIONS(1225),
    [anon_sym__Nonnull] = ACTIONS(1225),
    [anon_sym_alignas] = ACTIONS(1225),
    [anon_sym__Alignas] = ACTIONS(1225),
    [sym_primitive_type] = ACTIONS(1225),
    [anon_sym_enum] = ACTIONS(1225),
    [anon_sym_struct] = ACTIONS(1225),
    [anon_sym_union] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1225),
    [anon_sym_else] = ACTIONS(1225),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1225),
    [anon_sym_default] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1225),
    [anon_sym_do] = ACTIONS(1225),
    [anon_sym_for] = ACTIONS(1225),
    [anon_sym_return] = ACTIONS(1225),
    [anon_sym_break] = ACTIONS(1225),
    [anon_sym_continue] = ACTIONS(1225),
    [anon_sym_goto] = ACTIONS(1225),
    [anon_sym___try] = ACTIONS(1225),
    [anon_sym___leave] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1225),
    [anon_sym___alignof__] = ACTIONS(1225),
    [anon_sym___alignof] = ACTIONS(1225),
    [anon_sym__alignof] = ACTIONS(1225),
    [anon_sym_alignof] = ACTIONS(1225),
    [anon_sym__Alignof] = ACTIONS(1225),
    [anon_sym_offsetof] = ACTIONS(1225),
    [anon_sym__Generic] = ACTIONS(1225),
    [anon_sym_asm] = ACTIONS(1225),
    [anon_sym___asm__] = ACTIONS(1225),
    [anon_sym___asm] = ACTIONS(1225),
    [sym_number_literal] = ACTIONS(1227),
    [anon_sym_L_SQUOTE] = ACTIONS(1227),
    [anon_sym_u_SQUOTE] = ACTIONS(1227),
    [anon_sym_U_SQUOTE] = ACTIONS(1227),
    [anon_sym_u8_SQUOTE] = ACTIONS(1227),
    [anon_sym_SQUOTE] = ACTIONS(1227),
    [anon_sym_L_DQUOTE] = ACTIONS(1227),
    [anon_sym_u_DQUOTE] = ACTIONS(1227),
    [anon_sym_U_DQUOTE] = ACTIONS(1227),
    [anon_sym_u8_DQUOTE] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [sym_true] = ACTIONS(1225),
    [sym_false] = ACTIONS(1225),
    [anon_sym_NULL] = ACTIONS(1225),
    [anon_sym_nullptr] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_identifier] = ACTIONS(1229),
    [aux_sym_preproc_include_token1] = ACTIONS(1229),
    [aux_sym_preproc_def_token1] = ACTIONS(1229),
    [aux_sym_preproc_if_token1] = ACTIONS(1229),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1229),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1229),
    [sym_preproc_directive] = ACTIONS(1229),
    [anon_sym_LPAREN2] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_TILDE] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym___extension__] = ACTIONS(1229),
    [anon_sym_typedef] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym___attribute__] = ACTIONS(1229),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(1229),
    [anon_sym___cdecl] = ACTIONS(1229),
    [anon_sym___clrcall] = ACTIONS(1229),
    [anon_sym___stdcall] = ACTIONS(1229),
    [anon_sym___fastcall] = ACTIONS(1229),
    [anon_sym___thiscall] = ACTIONS(1229),
    [anon_sym___vectorcall] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_signed] = ACTIONS(1229),
    [anon_sym_unsigned] = ACTIONS(1229),
    [anon_sym_long] = ACTIONS(1229),
    [anon_sym_short] = ACTIONS(1229),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_auto] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym___inline] = ACTIONS(1229),
    [anon_sym___inline__] = ACTIONS(1229),
    [anon_sym___forceinline] = ACTIONS(1229),
    [anon_sym_thread_local] = ACTIONS(1229),
    [anon_sym___thread] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1229),
    [anon_sym_constexpr] = ACTIONS(1229),
    [anon_sym_volatile] = ACTIONS(1229),
    [anon_sym_restrict] = ACTIONS(1229),
    [anon_sym___restrict__] = ACTIONS(1229),
    [anon_sym__Atomic] = ACTIONS(1229),
    [anon_sym__Noreturn] = ACTIONS(1229),
    [anon_sym_noreturn] = ACTIONS(1229),
    [anon_sym__Nonnull] = ACTIONS(1229),
    [anon_sym_alignas] = ACTIONS(1229),
    [anon_sym__Alignas] = ACTIONS(1229),
    [sym_primitive_type] = ACTIONS(1229),
    [anon_sym_enum] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1229),
    [anon_sym_union] = ACTIONS(1229),
    [anon_sym_if] = ACTIONS(1229),
    [anon_sym_else] = ACTIONS(1229),
    [anon_sym_switch] = ACTIONS(1229),
    [anon_sym_case] = ACTIONS(1229),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1229),
    [anon_sym_do] = ACTIONS(1229),
    [anon_sym_for] = ACTIONS(1229),
    [anon_sym_return] = ACTIONS(1229),
    [anon_sym_break] = ACTIONS(1229),
    [anon_sym_continue] = ACTIONS(1229),
    [anon_sym_goto] = ACTIONS(1229),
    [anon_sym___try] = ACTIONS(1229),
    [anon_sym___leave] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1229),
    [anon_sym___alignof__] = ACTIONS(1229),
    [anon_sym___alignof] = ACTIONS(1229),
    [anon_sym__alignof] = ACTIONS(1229),
    [anon_sym_alignof] = ACTIONS(1229),
    [anon_sym__Alignof] = ACTIONS(1229),
    [anon_sym_offsetof] = ACTIONS(1229),
    [anon_sym__Generic] = ACTIONS(1229),
    [anon_sym_asm] = ACTIONS(1229),
    [anon_sym___asm__] = ACTIONS(1229),
    [anon_sym___asm] = ACTIONS(1229),
    [sym_number_literal] = ACTIONS(1231),
    [anon_sym_L_SQUOTE] = ACTIONS(1231),
    [anon_sym_u_SQUOTE] = ACTIONS(1231),
    [anon_sym_U_SQUOTE] = ACTIONS(1231),
    [anon_sym_u8_SQUOTE] = ACTIONS(1231),
    [anon_sym_SQUOTE] = ACTIONS(1231),
    [anon_sym_L_DQUOTE] = ACTIONS(1231),
    [anon_sym_u_DQUOTE] = ACTIONS(1231),
    [anon_sym_U_DQUOTE] = ACTIONS(1231),
    [anon_sym_u8_DQUOTE] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1231),
    [sym_true] = ACTIONS(1229),
    [sym_false] = ACTIONS(1229),
    [anon_sym_NULL] = ACTIONS(1229),
    [anon_sym_nullptr] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [sym_identifier] = ACTIONS(1233),
    [aux_sym_preproc_include_token1] = ACTIONS(1233),
    [aux_sym_preproc_def_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1233),
    [sym_preproc_directive] = ACTIONS(1233),
    [anon_sym_LPAREN2] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym___extension__] = ACTIONS(1233),
    [anon_sym_typedef] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1233),
    [anon_sym___attribute__] = ACTIONS(1233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym___declspec] = ACTIONS(1233),
    [anon_sym___cdecl] = ACTIONS(1233),
    [anon_sym___clrcall] = ACTIONS(1233),
    [anon_sym___stdcall] = ACTIONS(1233),
    [anon_sym___fastcall] = ACTIONS(1233),
    [anon_sym___thiscall] = ACTIONS(1233),
    [anon_sym___vectorcall] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_signed] = ACTIONS(1233),
    [anon_sym_unsigned] = ACTIONS(1233),
    [anon_sym_long] = ACTIONS(1233),
    [anon_sym_short] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_auto] = ACTIONS(1233),
    [anon_sym_register] = ACTIONS(1233),
    [anon_sym_inline] = ACTIONS(1233),
    [anon_sym___inline] = ACTIONS(1233),
    [anon_sym___inline__] = ACTIONS(1233),
    [anon_sym___forceinline] = ACTIONS(1233),
    [anon_sym_thread_local] = ACTIONS(1233),
    [anon_sym___thread] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_constexpr] = ACTIONS(1233),
    [anon_sym_volatile] = ACTIONS(1233),
    [anon_sym_restrict] = ACTIONS(1233),
    [anon_sym___restrict__] = ACTIONS(1233),
    [anon_sym__Atomic] = ACTIONS(1233),
    [anon_sym__Noreturn] = ACTIONS(1233),
    [anon_sym_noreturn] = ACTIONS(1233),
    [anon_sym__Nonnull] = ACTIONS(1233),
    [anon_sym_alignas] = ACTIONS(1233),
    [anon_sym__Alignas] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_goto] = ACTIONS(1233),
    [anon_sym___try] = ACTIONS(1233),
    [anon_sym___leave] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_sizeof] = ACTIONS(1233),
    [anon_sym___alignof__] = ACTIONS(1233),
    [anon_sym___alignof] = ACTIONS(1233),
    [anon_sym__alignof] = ACTIONS(1233),
    [anon_sym_alignof] = ACTIONS(1233),
    [anon_sym__Alignof] = ACTIONS(1233),
    [anon_sym_offsetof] = ACTIONS(1233),
    [anon_sym__Generic] = ACTIONS(1233),
    [anon_sym_asm] = ACTIONS(1233),
    [anon_sym___asm__] = ACTIONS(1233),
    [anon_sym___asm] = ACTIONS(1233),
    [sym_number_literal] = ACTIONS(1235),
    [anon_sym_L_SQUOTE] = ACTIONS(1235),
    [anon_sym_u_SQUOTE] = ACTIONS(1235),
    [anon_sym_U_SQUOTE] = ACTIONS(1235),
    [anon_sym_u8_SQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_L_DQUOTE] = ACTIONS(1235),
    [anon_sym_u_DQUOTE] = ACTIONS(1235),
    [anon_sym_U_DQUOTE] = ACTIONS(1235),
    [anon_sym_u8_DQUOTE] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [anon_sym_NULL] = ACTIONS(1233),
    [anon_sym_nullptr] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym__Nonnull] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [anon_sym___asm] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym__Nonnull] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [anon_sym___asm] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym__Nonnull] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [anon_sym___asm] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(1247),
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym__Nonnull] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [anon_sym___asm] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_identifier] = ACTIONS(1249),
    [aux_sym_preproc_include_token1] = ACTIONS(1249),
    [aux_sym_preproc_def_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1249),
    [sym_preproc_directive] = ACTIONS(1249),
    [anon_sym_LPAREN2] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym___extension__] = ACTIONS(1249),
    [anon_sym_typedef] = ACTIONS(1249),
    [anon_sym_extern] = ACTIONS(1249),
    [anon_sym___attribute__] = ACTIONS(1249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1251),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym___cdecl] = ACTIONS(1249),
    [anon_sym___clrcall] = ACTIONS(1249),
    [anon_sym___stdcall] = ACTIONS(1249),
    [anon_sym___fastcall] = ACTIONS(1249),
    [anon_sym___thiscall] = ACTIONS(1249),
    [anon_sym___vectorcall] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_signed] = ACTIONS(1249),
    [anon_sym_unsigned] = ACTIONS(1249),
    [anon_sym_long] = ACTIONS(1249),
    [anon_sym_short] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_auto] = ACTIONS(1249),
    [anon_sym_register] = ACTIONS(1249),
    [anon_sym_inline] = ACTIONS(1249),
    [anon_sym___inline] = ACTIONS(1249),
    [anon_sym___inline__] = ACTIONS(1249),
    [anon_sym___forceinline] = ACTIONS(1249),
    [anon_sym_thread_local] = ACTIONS(1249),
    [anon_sym___thread] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_constexpr] = ACTIONS(1249),
    [anon_sym_volatile] = ACTIONS(1249),
    [anon_sym_restrict] = ACTIONS(1249),
    [anon_sym___restrict__] = ACTIONS(1249),
    [anon_sym__Atomic] = ACTIONS(1249),
    [anon_sym__Noreturn] = ACTIONS(1249),
    [anon_sym_noreturn] = ACTIONS(1249),
    [anon_sym__Nonnull] = ACTIONS(1249),
    [anon_sym_alignas] = ACTIONS(1249),
    [anon_sym__Alignas] = ACTIONS(1249),
    [sym_primitive_type] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1249),
    [anon_sym_union] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1249),
    [anon_sym___try] = ACTIONS(1249),
    [anon_sym___leave] = ACTIONS(1249),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym___alignof__] = ACTIONS(1249),
    [anon_sym___alignof] = ACTIONS(1249),
    [anon_sym__alignof] = ACTIONS(1249),
    [anon_sym_alignof] = ACTIONS(1249),
    [anon_sym__Alignof] = ACTIONS(1249),
    [anon_sym_offsetof] = ACTIONS(1249),
    [anon_sym__Generic] = ACTIONS(1249),
    [anon_sym_asm] = ACTIONS(1249),
    [anon_sym___asm__] = ACTIONS(1249),
    [anon_sym___asm] = ACTIONS(1249),
    [sym_number_literal] = ACTIONS(1251),
    [anon_sym_L_SQUOTE] = ACTIONS(1251),
    [anon_sym_u_SQUOTE] = ACTIONS(1251),
    [anon_sym_U_SQUOTE] = ACTIONS(1251),
    [anon_sym_u8_SQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [anon_sym_L_DQUOTE] = ACTIONS(1251),
    [anon_sym_u_DQUOTE] = ACTIONS(1251),
    [anon_sym_U_DQUOTE] = ACTIONS(1251),
    [anon_sym_u8_DQUOTE] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [anon_sym_NULL] = ACTIONS(1249),
    [anon_sym_nullptr] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(1227),
    [sym_identifier] = ACTIONS(1225),
    [aux_sym_preproc_include_token1] = ACTIONS(1225),
    [aux_sym_preproc_def_token1] = ACTIONS(1225),
    [aux_sym_preproc_if_token1] = ACTIONS(1225),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1225),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1225),
    [sym_preproc_directive] = ACTIONS(1225),
    [anon_sym_LPAREN2] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym___extension__] = ACTIONS(1225),
    [anon_sym_typedef] = ACTIONS(1225),
    [anon_sym_extern] = ACTIONS(1225),
    [anon_sym___attribute__] = ACTIONS(1225),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym___declspec] = ACTIONS(1225),
    [anon_sym___cdecl] = ACTIONS(1225),
    [anon_sym___clrcall] = ACTIONS(1225),
    [anon_sym___stdcall] = ACTIONS(1225),
    [anon_sym___fastcall] = ACTIONS(1225),
    [anon_sym___thiscall] = ACTIONS(1225),
    [anon_sym___vectorcall] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_signed] = ACTIONS(1225),
    [anon_sym_unsigned] = ACTIONS(1225),
    [anon_sym_long] = ACTIONS(1225),
    [anon_sym_short] = ACTIONS(1225),
    [anon_sym_static] = ACTIONS(1225),
    [anon_sym_auto] = ACTIONS(1225),
    [anon_sym_register] = ACTIONS(1225),
    [anon_sym_inline] = ACTIONS(1225),
    [anon_sym___inline] = ACTIONS(1225),
    [anon_sym___inline__] = ACTIONS(1225),
    [anon_sym___forceinline] = ACTIONS(1225),
    [anon_sym_thread_local] = ACTIONS(1225),
    [anon_sym___thread] = ACTIONS(1225),
    [anon_sym_const] = ACTIONS(1225),
    [anon_sym_constexpr] = ACTIONS(1225),
    [anon_sym_volatile] = ACTIONS(1225),
    [anon_sym_restrict] = ACTIONS(1225),
    [anon_sym___restrict__] = ACTIONS(1225),
    [anon_sym__Atomic] = ACTIONS(1225),
    [anon_sym__Noreturn] = ACTIONS(1225),
    [anon_sym_noreturn] = ACTIONS(1225),
    [anon_sym__Nonnull] = ACTIONS(1225),
    [anon_sym_alignas] = ACTIONS(1225),
    [anon_sym__Alignas] = ACTIONS(1225),
    [sym_primitive_type] = ACTIONS(1225),
    [anon_sym_enum] = ACTIONS(1225),
    [anon_sym_struct] = ACTIONS(1225),
    [anon_sym_union] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1225),
    [anon_sym_else] = ACTIONS(1225),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1225),
    [anon_sym_default] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1225),
    [anon_sym_do] = ACTIONS(1225),
    [anon_sym_for] = ACTIONS(1225),
    [anon_sym_return] = ACTIONS(1225),
    [anon_sym_break] = ACTIONS(1225),
    [anon_sym_continue] = ACTIONS(1225),
    [anon_sym_goto] = ACTIONS(1225),
    [anon_sym___try] = ACTIONS(1225),
    [anon_sym___leave] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1225),
    [anon_sym___alignof__] = ACTIONS(1225),
    [anon_sym___alignof] = ACTIONS(1225),
    [anon_sym__alignof] = ACTIONS(1225),
    [anon_sym_alignof] = ACTIONS(1225),
    [anon_sym__Alignof] = ACTIONS(1225),
    [anon_sym_offsetof] = ACTIONS(1225),
    [anon_sym__Generic] = ACTIONS(1225),
    [anon_sym_asm] = ACTIONS(1225),
    [anon_sym___asm__] = ACTIONS(1225),
    [anon_sym___asm] = ACTIONS(1225),
    [sym_number_literal] = ACTIONS(1227),
    [anon_sym_L_SQUOTE] = ACTIONS(1227),
    [anon_sym_u_SQUOTE] = ACTIONS(1227),
    [anon_sym_U_SQUOTE] = ACTIONS(1227),
    [anon_sym_u8_SQUOTE] = ACTIONS(1227),
    [anon_sym_SQUOTE] = ACTIONS(1227),
    [anon_sym_L_DQUOTE] = ACTIONS(1227),
    [anon_sym_u_DQUOTE] = ACTIONS(1227),
    [anon_sym_U_DQUOTE] = ACTIONS(1227),
    [anon_sym_u8_DQUOTE] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [sym_true] = ACTIONS(1225),
    [sym_false] = ACTIONS(1225),
    [anon_sym_NULL] = ACTIONS(1225),
    [anon_sym_nullptr] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(1231),
    [sym_identifier] = ACTIONS(1229),
    [aux_sym_preproc_include_token1] = ACTIONS(1229),
    [aux_sym_preproc_def_token1] = ACTIONS(1229),
    [aux_sym_preproc_if_token1] = ACTIONS(1229),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1229),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1229),
    [sym_preproc_directive] = ACTIONS(1229),
    [anon_sym_LPAREN2] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_TILDE] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym___extension__] = ACTIONS(1229),
    [anon_sym_typedef] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym___attribute__] = ACTIONS(1229),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(1229),
    [anon_sym___cdecl] = ACTIONS(1229),
    [anon_sym___clrcall] = ACTIONS(1229),
    [anon_sym___stdcall] = ACTIONS(1229),
    [anon_sym___fastcall] = ACTIONS(1229),
    [anon_sym___thiscall] = ACTIONS(1229),
    [anon_sym___vectorcall] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1231),
    [anon_sym_signed] = ACTIONS(1229),
    [anon_sym_unsigned] = ACTIONS(1229),
    [anon_sym_long] = ACTIONS(1229),
    [anon_sym_short] = ACTIONS(1229),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_auto] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym___inline] = ACTIONS(1229),
    [anon_sym___inline__] = ACTIONS(1229),
    [anon_sym___forceinline] = ACTIONS(1229),
    [anon_sym_thread_local] = ACTIONS(1229),
    [anon_sym___thread] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1229),
    [anon_sym_constexpr] = ACTIONS(1229),
    [anon_sym_volatile] = ACTIONS(1229),
    [anon_sym_restrict] = ACTIONS(1229),
    [anon_sym___restrict__] = ACTIONS(1229),
    [anon_sym__Atomic] = ACTIONS(1229),
    [anon_sym__Noreturn] = ACTIONS(1229),
    [anon_sym_noreturn] = ACTIONS(1229),
    [anon_sym__Nonnull] = ACTIONS(1229),
    [anon_sym_alignas] = ACTIONS(1229),
    [anon_sym__Alignas] = ACTIONS(1229),
    [sym_primitive_type] = ACTIONS(1229),
    [anon_sym_enum] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1229),
    [anon_sym_union] = ACTIONS(1229),
    [anon_sym_if] = ACTIONS(1229),
    [anon_sym_else] = ACTIONS(1229),
    [anon_sym_switch] = ACTIONS(1229),
    [anon_sym_case] = ACTIONS(1229),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1229),
    [anon_sym_do] = ACTIONS(1229),
    [anon_sym_for] = ACTIONS(1229),
    [anon_sym_return] = ACTIONS(1229),
    [anon_sym_break] = ACTIONS(1229),
    [anon_sym_continue] = ACTIONS(1229),
    [anon_sym_goto] = ACTIONS(1229),
    [anon_sym___try] = ACTIONS(1229),
    [anon_sym___leave] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1229),
    [anon_sym___alignof__] = ACTIONS(1229),
    [anon_sym___alignof] = ACTIONS(1229),
    [anon_sym__alignof] = ACTIONS(1229),
    [anon_sym_alignof] = ACTIONS(1229),
    [anon_sym__Alignof] = ACTIONS(1229),
    [anon_sym_offsetof] = ACTIONS(1229),
    [anon_sym__Generic] = ACTIONS(1229),
    [anon_sym_asm] = ACTIONS(1229),
    [anon_sym___asm__] = ACTIONS(1229),
    [anon_sym___asm] = ACTIONS(1229),
    [sym_number_literal] = ACTIONS(1231),
    [anon_sym_L_SQUOTE] = ACTIONS(1231),
    [anon_sym_u_SQUOTE] = ACTIONS(1231),
    [anon_sym_U_SQUOTE] = ACTIONS(1231),
    [anon_sym_u8_SQUOTE] = ACTIONS(1231),
    [anon_sym_SQUOTE] = ACTIONS(1231),
    [anon_sym_L_DQUOTE] = ACTIONS(1231),
    [anon_sym_u_DQUOTE] = ACTIONS(1231),
    [anon_sym_U_DQUOTE] = ACTIONS(1231),
    [anon_sym_u8_DQUOTE] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1231),
    [sym_true] = ACTIONS(1229),
    [sym_false] = ACTIONS(1229),
    [anon_sym_NULL] = ACTIONS(1229),
    [anon_sym_nullptr] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1233),
    [aux_sym_preproc_include_token1] = ACTIONS(1233),
    [aux_sym_preproc_def_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1233),
    [sym_preproc_directive] = ACTIONS(1233),
    [anon_sym_LPAREN2] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym___extension__] = ACTIONS(1233),
    [anon_sym_typedef] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1233),
    [anon_sym___attribute__] = ACTIONS(1233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym___declspec] = ACTIONS(1233),
    [anon_sym___cdecl] = ACTIONS(1233),
    [anon_sym___clrcall] = ACTIONS(1233),
    [anon_sym___stdcall] = ACTIONS(1233),
    [anon_sym___fastcall] = ACTIONS(1233),
    [anon_sym___thiscall] = ACTIONS(1233),
    [anon_sym___vectorcall] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_signed] = ACTIONS(1233),
    [anon_sym_unsigned] = ACTIONS(1233),
    [anon_sym_long] = ACTIONS(1233),
    [anon_sym_short] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_auto] = ACTIONS(1233),
    [anon_sym_register] = ACTIONS(1233),
    [anon_sym_inline] = ACTIONS(1233),
    [anon_sym___inline] = ACTIONS(1233),
    [anon_sym___inline__] = ACTIONS(1233),
    [anon_sym___forceinline] = ACTIONS(1233),
    [anon_sym_thread_local] = ACTIONS(1233),
    [anon_sym___thread] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_constexpr] = ACTIONS(1233),
    [anon_sym_volatile] = ACTIONS(1233),
    [anon_sym_restrict] = ACTIONS(1233),
    [anon_sym___restrict__] = ACTIONS(1233),
    [anon_sym__Atomic] = ACTIONS(1233),
    [anon_sym__Noreturn] = ACTIONS(1233),
    [anon_sym_noreturn] = ACTIONS(1233),
    [anon_sym__Nonnull] = ACTIONS(1233),
    [anon_sym_alignas] = ACTIONS(1233),
    [anon_sym__Alignas] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_goto] = ACTIONS(1233),
    [anon_sym___try] = ACTIONS(1233),
    [anon_sym___leave] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_sizeof] = ACTIONS(1233),
    [anon_sym___alignof__] = ACTIONS(1233),
    [anon_sym___alignof] = ACTIONS(1233),
    [anon_sym__alignof] = ACTIONS(1233),
    [anon_sym_alignof] = ACTIONS(1233),
    [anon_sym__Alignof] = ACTIONS(1233),
    [anon_sym_offsetof] = ACTIONS(1233),
    [anon_sym__Generic] = ACTIONS(1233),
    [anon_sym_asm] = ACTIONS(1233),
    [anon_sym___asm__] = ACTIONS(1233),
    [anon_sym___asm] = ACTIONS(1233),
    [sym_number_literal] = ACTIONS(1235),
    [anon_sym_L_SQUOTE] = ACTIONS(1235),
    [anon_sym_u_SQUOTE] = ACTIONS(1235),
    [anon_sym_U_SQUOTE] = ACTIONS(1235),
    [anon_sym_u8_SQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_L_DQUOTE] = ACTIONS(1235),
    [anon_sym_u_DQUOTE] = ACTIONS(1235),
    [anon_sym_U_DQUOTE] = ACTIONS(1235),
    [anon_sym_u8_DQUOTE] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [anon_sym_NULL] = ACTIONS(1233),
    [anon_sym_nullptr] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(1239),
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym__Nonnull] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [anon_sym___asm] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(1239),
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym__Nonnull] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [anon_sym___asm] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(1243),
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym__Nonnull] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [anon_sym___asm] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym__Nonnull] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [anon_sym___asm] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(1251),
    [sym_identifier] = ACTIONS(1249),
    [aux_sym_preproc_include_token1] = ACTIONS(1249),
    [aux_sym_preproc_def_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1249),
    [sym_preproc_directive] = ACTIONS(1249),
    [anon_sym_LPAREN2] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym___extension__] = ACTIONS(1249),
    [anon_sym_typedef] = ACTIONS(1249),
    [anon_sym_extern] = ACTIONS(1249),
    [anon_sym___attribute__] = ACTIONS(1249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1251),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym___cdecl] = ACTIONS(1249),
    [anon_sym___clrcall] = ACTIONS(1249),
    [anon_sym___stdcall] = ACTIONS(1249),
    [anon_sym___fastcall] = ACTIONS(1249),
    [anon_sym___thiscall] = ACTIONS(1249),
    [anon_sym___vectorcall] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_signed] = ACTIONS(1249),
    [anon_sym_unsigned] = ACTIONS(1249),
    [anon_sym_long] = ACTIONS(1249),
    [anon_sym_short] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_auto] = ACTIONS(1249),
    [anon_sym_register] = ACTIONS(1249),
    [anon_sym_inline] = ACTIONS(1249),
    [anon_sym___inline] = ACTIONS(1249),
    [anon_sym___inline__] = ACTIONS(1249),
    [anon_sym___forceinline] = ACTIONS(1249),
    [anon_sym_thread_local] = ACTIONS(1249),
    [anon_sym___thread] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_constexpr] = ACTIONS(1249),
    [anon_sym_volatile] = ACTIONS(1249),
    [anon_sym_restrict] = ACTIONS(1249),
    [anon_sym___restrict__] = ACTIONS(1249),
    [anon_sym__Atomic] = ACTIONS(1249),
    [anon_sym__Noreturn] = ACTIONS(1249),
    [anon_sym_noreturn] = ACTIONS(1249),
    [anon_sym__Nonnull] = ACTIONS(1249),
    [anon_sym_alignas] = ACTIONS(1249),
    [anon_sym__Alignas] = ACTIONS(1249),
    [sym_primitive_type] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1249),
    [anon_sym_union] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1249),
    [anon_sym___try] = ACTIONS(1249),
    [anon_sym___leave] = ACTIONS(1249),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym___alignof__] = ACTIONS(1249),
    [anon_sym___alignof] = ACTIONS(1249),
    [anon_sym__alignof] = ACTIONS(1249),
    [anon_sym_alignof] = ACTIONS(1249),
    [anon_sym__Alignof] = ACTIONS(1249),
    [anon_sym_offsetof] = ACTIONS(1249),
    [anon_sym__Generic] = ACTIONS(1249),
    [anon_sym_asm] = ACTIONS(1249),
    [anon_sym___asm__] = ACTIONS(1249),
    [anon_sym___asm] = ACTIONS(1249),
    [sym_number_literal] = ACTIONS(1251),
    [anon_sym_L_SQUOTE] = ACTIONS(1251),
    [anon_sym_u_SQUOTE] = ACTIONS(1251),
    [anon_sym_U_SQUOTE] = ACTIONS(1251),
    [anon_sym_u8_SQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [anon_sym_L_DQUOTE] = ACTIONS(1251),
    [anon_sym_u_DQUOTE] = ACTIONS(1251),
    [anon_sym_U_DQUOTE] = ACTIONS(1251),
    [anon_sym_u8_DQUOTE] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [anon_sym_NULL] = ACTIONS(1249),
    [anon_sym_nullptr] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1133),
    [aux_sym_preproc_include_token1] = ACTIONS(1133),
    [aux_sym_preproc_def_token1] = ACTIONS(1133),
    [aux_sym_preproc_if_token1] = ACTIONS(1133),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1133),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1133),
    [sym_preproc_directive] = ACTIONS(1133),
    [anon_sym_LPAREN2] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym___extension__] = ACTIONS(1133),
    [anon_sym_typedef] = ACTIONS(1133),
    [anon_sym_extern] = ACTIONS(1133),
    [anon_sym___attribute__] = ACTIONS(1133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1135),
    [anon_sym___declspec] = ACTIONS(1133),
    [anon_sym___cdecl] = ACTIONS(1133),
    [anon_sym___clrcall] = ACTIONS(1133),
    [anon_sym___stdcall] = ACTIONS(1133),
    [anon_sym___fastcall] = ACTIONS(1133),
    [anon_sym___thiscall] = ACTIONS(1133),
    [anon_sym___vectorcall] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_signed] = ACTIONS(1133),
    [anon_sym_unsigned] = ACTIONS(1133),
    [anon_sym_long] = ACTIONS(1133),
    [anon_sym_short] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1133),
    [anon_sym_auto] = ACTIONS(1133),
    [anon_sym_register] = ACTIONS(1133),
    [anon_sym_inline] = ACTIONS(1133),
    [anon_sym___inline] = ACTIONS(1133),
    [anon_sym___inline__] = ACTIONS(1133),
    [anon_sym___forceinline] = ACTIONS(1133),
    [anon_sym_thread_local] = ACTIONS(1133),
    [anon_sym___thread] = ACTIONS(1133),
    [anon_sym_const] = ACTIONS(1133),
    [anon_sym_constexpr] = ACTIONS(1133),
    [anon_sym_volatile] = ACTIONS(1133),
    [anon_sym_restrict] = ACTIONS(1133),
    [anon_sym___restrict__] = ACTIONS(1133),
    [anon_sym__Atomic] = ACTIONS(1133),
    [anon_sym__Noreturn] = ACTIONS(1133),
    [anon_sym_noreturn] = ACTIONS(1133),
    [anon_sym__Nonnull] = ACTIONS(1133),
    [anon_sym_alignas] = ACTIONS(1133),
    [anon_sym__Alignas] = ACTIONS(1133),
    [sym_primitive_type] = ACTIONS(1133),
    [anon_sym_enum] = ACTIONS(1133),
    [anon_sym_struct] = ACTIONS(1133),
    [anon_sym_union] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_else] = ACTIONS(1133),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1133),
    [anon_sym_default] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_do] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1133),
    [anon_sym_break] = ACTIONS(1133),
    [anon_sym_continue] = ACTIONS(1133),
    [anon_sym_goto] = ACTIONS(1133),
    [anon_sym___try] = ACTIONS(1133),
    [anon_sym___leave] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_sizeof] = ACTIONS(1133),
    [anon_sym___alignof__] = ACTIONS(1133),
    [anon_sym___alignof] = ACTIONS(1133),
    [anon_sym__alignof] = ACTIONS(1133),
    [anon_sym_alignof] = ACTIONS(1133),
    [anon_sym__Alignof] = ACTIONS(1133),
    [anon_sym_offsetof] = ACTIONS(1133),
    [anon_sym__Generic] = ACTIONS(1133),
    [anon_sym_asm] = ACTIONS(1133),
    [anon_sym___asm__] = ACTIONS(1133),
    [anon_sym___asm] = ACTIONS(1133),
    [sym_number_literal] = ACTIONS(1135),
    [anon_sym_L_SQUOTE] = ACTIONS(1135),
    [anon_sym_u_SQUOTE] = ACTIONS(1135),
    [anon_sym_U_SQUOTE] = ACTIONS(1135),
    [anon_sym_u8_SQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_L_DQUOTE] = ACTIONS(1135),
    [anon_sym_u_DQUOTE] = ACTIONS(1135),
    [anon_sym_U_DQUOTE] = ACTIONS(1135),
    [anon_sym_u8_DQUOTE] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [sym_true] = ACTIONS(1133),
    [sym_false] = ACTIONS(1133),
    [anon_sym_NULL] = ACTIONS(1133),
    [anon_sym_nullptr] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_identifier] = ACTIONS(1137),
    [aux_sym_preproc_include_token1] = ACTIONS(1137),
    [aux_sym_preproc_def_token1] = ACTIONS(1137),
    [aux_sym_preproc_if_token1] = ACTIONS(1137),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1137),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1137),
    [sym_preproc_directive] = ACTIONS(1137),
    [anon_sym_LPAREN2] = ACTIONS(1139),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym___extension__] = ACTIONS(1137),
    [anon_sym_typedef] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(1137),
    [anon_sym___attribute__] = ACTIONS(1137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1139),
    [anon_sym___declspec] = ACTIONS(1137),
    [anon_sym___cdecl] = ACTIONS(1137),
    [anon_sym___clrcall] = ACTIONS(1137),
    [anon_sym___stdcall] = ACTIONS(1137),
    [anon_sym___fastcall] = ACTIONS(1137),
    [anon_sym___thiscall] = ACTIONS(1137),
    [anon_sym___vectorcall] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_signed] = ACTIONS(1137),
    [anon_sym_unsigned] = ACTIONS(1137),
    [anon_sym_long] = ACTIONS(1137),
    [anon_sym_short] = ACTIONS(1137),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_auto] = ACTIONS(1137),
    [anon_sym_register] = ACTIONS(1137),
    [anon_sym_inline] = ACTIONS(1137),
    [anon_sym___inline] = ACTIONS(1137),
    [anon_sym___inline__] = ACTIONS(1137),
    [anon_sym___forceinline] = ACTIONS(1137),
    [anon_sym_thread_local] = ACTIONS(1137),
    [anon_sym___thread] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_constexpr] = ACTIONS(1137),
    [anon_sym_volatile] = ACTIONS(1137),
    [anon_sym_restrict] = ACTIONS(1137),
    [anon_sym___restrict__] = ACTIONS(1137),
    [anon_sym__Atomic] = ACTIONS(1137),
    [anon_sym__Noreturn] = ACTIONS(1137),
    [anon_sym_noreturn] = ACTIONS(1137),
    [anon_sym__Nonnull] = ACTIONS(1137),
    [anon_sym_alignas] = ACTIONS(1137),
    [anon_sym__Alignas] = ACTIONS(1137),
    [sym_primitive_type] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1137),
    [anon_sym_union] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_goto] = ACTIONS(1137),
    [anon_sym___try] = ACTIONS(1137),
    [anon_sym___leave] = ACTIONS(1137),
    [anon_sym_DASH_DASH] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(1139),
    [anon_sym_sizeof] = ACTIONS(1137),
    [anon_sym___alignof__] = ACTIONS(1137),
    [anon_sym___alignof] = ACTIONS(1137),
    [anon_sym__alignof] = ACTIONS(1137),
    [anon_sym_alignof] = ACTIONS(1137),
    [anon_sym__Alignof] = ACTIONS(1137),
    [anon_sym_offsetof] = ACTIONS(1137),
    [anon_sym__Generic] = ACTIONS(1137),
    [anon_sym_asm] = ACTIONS(1137),
    [anon_sym___asm__] = ACTIONS(1137),
    [anon_sym___asm] = ACTIONS(1137),
    [sym_number_literal] = ACTIONS(1139),
    [anon_sym_L_SQUOTE] = ACTIONS(1139),
    [anon_sym_u_SQUOTE] = ACTIONS(1139),
    [anon_sym_U_SQUOTE] = ACTIONS(1139),
    [anon_sym_u8_SQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [anon_sym_L_DQUOTE] = ACTIONS(1139),
    [anon_sym_u_DQUOTE] = ACTIONS(1139),
    [anon_sym_U_DQUOTE] = ACTIONS(1139),
    [anon_sym_u8_DQUOTE] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [anon_sym_NULL] = ACTIONS(1137),
    [anon_sym_nullptr] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1213),
    [aux_sym_preproc_include_token1] = ACTIONS(1213),
    [aux_sym_preproc_def_token1] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1213),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1213),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1213),
    [sym_preproc_directive] = ACTIONS(1213),
    [anon_sym_LPAREN2] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1215),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1213),
    [anon_sym_extern] = ACTIONS(1213),
    [anon_sym___attribute__] = ACTIONS(1213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1215),
    [anon_sym___declspec] = ACTIONS(1213),
    [anon_sym___cdecl] = ACTIONS(1213),
    [anon_sym___clrcall] = ACTIONS(1213),
    [anon_sym___stdcall] = ACTIONS(1213),
    [anon_sym___fastcall] = ACTIONS(1213),
    [anon_sym___thiscall] = ACTIONS(1213),
    [anon_sym___vectorcall] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_signed] = ACTIONS(1213),
    [anon_sym_unsigned] = ACTIONS(1213),
    [anon_sym_long] = ACTIONS(1213),
    [anon_sym_short] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_auto] = ACTIONS(1213),
    [anon_sym_register] = ACTIONS(1213),
    [anon_sym_inline] = ACTIONS(1213),
    [anon_sym___inline] = ACTIONS(1213),
    [anon_sym___inline__] = ACTIONS(1213),
    [anon_sym___forceinline] = ACTIONS(1213),
    [anon_sym_thread_local] = ACTIONS(1213),
    [anon_sym___thread] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1213),
    [anon_sym_constexpr] = ACTIONS(1213),
    [anon_sym_volatile] = ACTIONS(1213),
    [anon_sym_restrict] = ACTIONS(1213),
    [anon_sym___restrict__] = ACTIONS(1213),
    [anon_sym__Atomic] = ACTIONS(1213),
    [anon_sym__Noreturn] = ACTIONS(1213),
    [anon_sym_noreturn] = ACTIONS(1213),
    [anon_sym__Nonnull] = ACTIONS(1213),
    [anon_sym_alignas] = ACTIONS(1213),
    [anon_sym__Alignas] = ACTIONS(1213),
    [sym_primitive_type] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1213),
    [anon_sym_struct] = ACTIONS(1213),
    [anon_sym_union] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1213),
    [anon_sym_else] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1213),
    [anon_sym_default] = ACTIONS(1213),
    [anon_sym_while] = ACTIONS(1213),
    [anon_sym_do] = ACTIONS(1213),
    [anon_sym_for] = ACTIONS(1213),
    [anon_sym_return] = ACTIONS(1213),
    [anon_sym_break] = ACTIONS(1213),
    [anon_sym_continue] = ACTIONS(1213),
    [anon_sym_goto] = ACTIONS(1213),
    [anon_sym___try] = ACTIONS(1213),
    [anon_sym___leave] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_sizeof] = ACTIONS(1213),
    [anon_sym___alignof__] = ACTIONS(1213),
    [anon_sym___alignof] = ACTIONS(1213),
    [anon_sym__alignof] = ACTIONS(1213),
    [anon_sym_alignof] = ACTIONS(1213),
    [anon_sym__Alignof] = ACTIONS(1213),
    [anon_sym_offsetof] = ACTIONS(1213),
    [anon_sym__Generic] = ACTIONS(1213),
    [anon_sym_asm] = ACTIONS(1213),
    [anon_sym___asm__] = ACTIONS(1213),
    [anon_sym___asm] = ACTIONS(1213),
    [sym_number_literal] = ACTIONS(1215),
    [anon_sym_L_SQUOTE] = ACTIONS(1215),
    [anon_sym_u_SQUOTE] = ACTIONS(1215),
    [anon_sym_U_SQUOTE] = ACTIONS(1215),
    [anon_sym_u8_SQUOTE] = ACTIONS(1215),
    [anon_sym_SQUOTE] = ACTIONS(1215),
    [anon_sym_L_DQUOTE] = ACTIONS(1215),
    [anon_sym_u_DQUOTE] = ACTIONS(1215),
    [anon_sym_U_DQUOTE] = ACTIONS(1215),
    [anon_sym_u8_DQUOTE] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1215),
    [sym_true] = ACTIONS(1213),
    [sym_false] = ACTIONS(1213),
    [anon_sym_NULL] = ACTIONS(1213),
    [anon_sym_nullptr] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(1143),
    [sym_identifier] = ACTIONS(1141),
    [aux_sym_preproc_include_token1] = ACTIONS(1141),
    [aux_sym_preproc_def_token1] = ACTIONS(1141),
    [aux_sym_preproc_if_token1] = ACTIONS(1141),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1141),
    [sym_preproc_directive] = ACTIONS(1141),
    [anon_sym_LPAREN2] = ACTIONS(1143),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1143),
    [anon_sym___extension__] = ACTIONS(1141),
    [anon_sym_typedef] = ACTIONS(1141),
    [anon_sym_extern] = ACTIONS(1141),
    [anon_sym___attribute__] = ACTIONS(1141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1143),
    [anon_sym___declspec] = ACTIONS(1141),
    [anon_sym___cdecl] = ACTIONS(1141),
    [anon_sym___clrcall] = ACTIONS(1141),
    [anon_sym___stdcall] = ACTIONS(1141),
    [anon_sym___fastcall] = ACTIONS(1141),
    [anon_sym___thiscall] = ACTIONS(1141),
    [anon_sym___vectorcall] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1143),
    [anon_sym_signed] = ACTIONS(1141),
    [anon_sym_unsigned] = ACTIONS(1141),
    [anon_sym_long] = ACTIONS(1141),
    [anon_sym_short] = ACTIONS(1141),
    [anon_sym_static] = ACTIONS(1141),
    [anon_sym_auto] = ACTIONS(1141),
    [anon_sym_register] = ACTIONS(1141),
    [anon_sym_inline] = ACTIONS(1141),
    [anon_sym___inline] = ACTIONS(1141),
    [anon_sym___inline__] = ACTIONS(1141),
    [anon_sym___forceinline] = ACTIONS(1141),
    [anon_sym_thread_local] = ACTIONS(1141),
    [anon_sym___thread] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_constexpr] = ACTIONS(1141),
    [anon_sym_volatile] = ACTIONS(1141),
    [anon_sym_restrict] = ACTIONS(1141),
    [anon_sym___restrict__] = ACTIONS(1141),
    [anon_sym__Atomic] = ACTIONS(1141),
    [anon_sym__Noreturn] = ACTIONS(1141),
    [anon_sym_noreturn] = ACTIONS(1141),
    [anon_sym__Nonnull] = ACTIONS(1141),
    [anon_sym_alignas] = ACTIONS(1141),
    [anon_sym__Alignas] = ACTIONS(1141),
    [sym_primitive_type] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [anon_sym_struct] = ACTIONS(1141),
    [anon_sym_union] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_else] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_case] = ACTIONS(1141),
    [anon_sym_default] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_do] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1141),
    [anon_sym___leave] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1141),
    [anon_sym___alignof__] = ACTIONS(1141),
    [anon_sym___alignof] = ACTIONS(1141),
    [anon_sym__alignof] = ACTIONS(1141),
    [anon_sym_alignof] = ACTIONS(1141),
    [anon_sym__Alignof] = ACTIONS(1141),
    [anon_sym_offsetof] = ACTIONS(1141),
    [anon_sym__Generic] = ACTIONS(1141),
    [anon_sym_asm] = ACTIONS(1141),
    [anon_sym___asm__] = ACTIONS(1141),
    [anon_sym___asm] = ACTIONS(1141),
    [sym_number_literal] = ACTIONS(1143),
    [anon_sym_L_SQUOTE] = ACTIONS(1143),
    [anon_sym_u_SQUOTE] = ACTIONS(1143),
    [anon_sym_U_SQUOTE] = ACTIONS(1143),
    [anon_sym_u8_SQUOTE] = ACTIONS(1143),
    [anon_sym_SQUOTE] = ACTIONS(1143),
    [anon_sym_L_DQUOTE] = ACTIONS(1143),
    [anon_sym_u_DQUOTE] = ACTIONS(1143),
    [anon_sym_U_DQUOTE] = ACTIONS(1143),
    [anon_sym_u8_DQUOTE] = ACTIONS(1143),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [sym_true] = ACTIONS(1141),
    [sym_false] = ACTIONS(1141),
    [anon_sym_NULL] = ACTIONS(1141),
    [anon_sym_nullptr] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1217),
    [aux_sym_preproc_include_token1] = ACTIONS(1217),
    [aux_sym_preproc_def_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1217),
    [sym_preproc_directive] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1219),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym___extension__] = ACTIONS(1217),
    [anon_sym_typedef] = ACTIONS(1217),
    [anon_sym_extern] = ACTIONS(1217),
    [anon_sym___attribute__] = ACTIONS(1217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1219),
    [anon_sym___declspec] = ACTIONS(1217),
    [anon_sym___cdecl] = ACTIONS(1217),
    [anon_sym___clrcall] = ACTIONS(1217),
    [anon_sym___stdcall] = ACTIONS(1217),
    [anon_sym___fastcall] = ACTIONS(1217),
    [anon_sym___thiscall] = ACTIONS(1217),
    [anon_sym___vectorcall] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_RBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(1217),
    [anon_sym_unsigned] = ACTIONS(1217),
    [anon_sym_long] = ACTIONS(1217),
    [anon_sym_short] = ACTIONS(1217),
    [anon_sym_static] = ACTIONS(1217),
    [anon_sym_auto] = ACTIONS(1217),
    [anon_sym_register] = ACTIONS(1217),
    [anon_sym_inline] = ACTIONS(1217),
    [anon_sym___inline] = ACTIONS(1217),
    [anon_sym___inline__] = ACTIONS(1217),
    [anon_sym___forceinline] = ACTIONS(1217),
    [anon_sym_thread_local] = ACTIONS(1217),
    [anon_sym___thread] = ACTIONS(1217),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_constexpr] = ACTIONS(1217),
    [anon_sym_volatile] = ACTIONS(1217),
    [anon_sym_restrict] = ACTIONS(1217),
    [anon_sym___restrict__] = ACTIONS(1217),
    [anon_sym__Atomic] = ACTIONS(1217),
    [anon_sym__Noreturn] = ACTIONS(1217),
    [anon_sym_noreturn] = ACTIONS(1217),
    [anon_sym__Nonnull] = ACTIONS(1217),
    [anon_sym_alignas] = ACTIONS(1217),
    [anon_sym__Alignas] = ACTIONS(1217),
    [sym_primitive_type] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1217),
    [anon_sym_struct] = ACTIONS(1217),
    [anon_sym_union] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1217),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(1217),
    [anon_sym_case] = ACTIONS(1217),
    [anon_sym_default] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(1217),
    [anon_sym_do] = ACTIONS(1217),
    [anon_sym_for] = ACTIONS(1217),
    [anon_sym_return] = ACTIONS(1217),
    [anon_sym_break] = ACTIONS(1217),
    [anon_sym_continue] = ACTIONS(1217),
    [anon_sym_goto] = ACTIONS(1217),
    [anon_sym___try] = ACTIONS(1217),
    [anon_sym___leave] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1219),
    [anon_sym_sizeof] = ACTIONS(1217),
    [anon_sym___alignof__] = ACTIONS(1217),
    [anon_sym___alignof] = ACTIONS(1217),
    [anon_sym__alignof] = ACTIONS(1217),
    [anon_sym_alignof] = ACTIONS(1217),
    [anon_sym__Alignof] = ACTIONS(1217),
    [anon_sym_offsetof] = ACTIONS(1217),
    [anon_sym__Generic] = ACTIONS(1217),
    [anon_sym_asm] = ACTIONS(1217),
    [anon_sym___asm__] = ACTIONS(1217),
    [anon_sym___asm] = ACTIONS(1217),
    [sym_number_literal] = ACTIONS(1219),
    [anon_sym_L_SQUOTE] = ACTIONS(1219),
    [anon_sym_u_SQUOTE] = ACTIONS(1219),
    [anon_sym_U_SQUOTE] = ACTIONS(1219),
    [anon_sym_u8_SQUOTE] = ACTIONS(1219),
    [anon_sym_SQUOTE] = ACTIONS(1219),
    [anon_sym_L_DQUOTE] = ACTIONS(1219),
    [anon_sym_u_DQUOTE] = ACTIONS(1219),
    [anon_sym_U_DQUOTE] = ACTIONS(1219),
    [anon_sym_u8_DQUOTE] = ACTIONS(1219),
    [anon_sym_DQUOTE] = ACTIONS(1219),
    [sym_true] = ACTIONS(1217),
    [sym_false] = ACTIONS(1217),
    [anon_sym_NULL] = ACTIONS(1217),
    [anon_sym_nullptr] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_identifier] = ACTIONS(1145),
    [aux_sym_preproc_include_token1] = ACTIONS(1145),
    [aux_sym_preproc_def_token1] = ACTIONS(1145),
    [aux_sym_preproc_if_token1] = ACTIONS(1145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1145),
    [sym_preproc_directive] = ACTIONS(1145),
    [anon_sym_LPAREN2] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym___extension__] = ACTIONS(1145),
    [anon_sym_typedef] = ACTIONS(1145),
    [anon_sym_extern] = ACTIONS(1145),
    [anon_sym___attribute__] = ACTIONS(1145),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1147),
    [anon_sym___declspec] = ACTIONS(1145),
    [anon_sym___cdecl] = ACTIONS(1145),
    [anon_sym___clrcall] = ACTIONS(1145),
    [anon_sym___stdcall] = ACTIONS(1145),
    [anon_sym___fastcall] = ACTIONS(1145),
    [anon_sym___thiscall] = ACTIONS(1145),
    [anon_sym___vectorcall] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_signed] = ACTIONS(1145),
    [anon_sym_unsigned] = ACTIONS(1145),
    [anon_sym_long] = ACTIONS(1145),
    [anon_sym_short] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1145),
    [anon_sym_auto] = ACTIONS(1145),
    [anon_sym_register] = ACTIONS(1145),
    [anon_sym_inline] = ACTIONS(1145),
    [anon_sym___inline] = ACTIONS(1145),
    [anon_sym___inline__] = ACTIONS(1145),
    [anon_sym___forceinline] = ACTIONS(1145),
    [anon_sym_thread_local] = ACTIONS(1145),
    [anon_sym___thread] = ACTIONS(1145),
    [anon_sym_const] = ACTIONS(1145),
    [anon_sym_constexpr] = ACTIONS(1145),
    [anon_sym_volatile] = ACTIONS(1145),
    [anon_sym_restrict] = ACTIONS(1145),
    [anon_sym___restrict__] = ACTIONS(1145),
    [anon_sym__Atomic] = ACTIONS(1145),
    [anon_sym__Noreturn] = ACTIONS(1145),
    [anon_sym_noreturn] = ACTIONS(1145),
    [anon_sym__Nonnull] = ACTIONS(1145),
    [anon_sym_alignas] = ACTIONS(1145),
    [anon_sym__Alignas] = ACTIONS(1145),
    [sym_primitive_type] = ACTIONS(1145),
    [anon_sym_enum] = ACTIONS(1145),
    [anon_sym_struct] = ACTIONS(1145),
    [anon_sym_union] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_else] = ACTIONS(1145),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1145),
    [anon_sym_default] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_do] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1145),
    [anon_sym_break] = ACTIONS(1145),
    [anon_sym_continue] = ACTIONS(1145),
    [anon_sym_goto] = ACTIONS(1145),
    [anon_sym___try] = ACTIONS(1145),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1145),
    [anon_sym___alignof__] = ACTIONS(1145),
    [anon_sym___alignof] = ACTIONS(1145),
    [anon_sym__alignof] = ACTIONS(1145),
    [anon_sym_alignof] = ACTIONS(1145),
    [anon_sym__Alignof] = ACTIONS(1145),
    [anon_sym_offsetof] = ACTIONS(1145),
    [anon_sym__Generic] = ACTIONS(1145),
    [anon_sym_asm] = ACTIONS(1145),
    [anon_sym___asm__] = ACTIONS(1145),
    [anon_sym___asm] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1147),
    [anon_sym_L_SQUOTE] = ACTIONS(1147),
    [anon_sym_u_SQUOTE] = ACTIONS(1147),
    [anon_sym_U_SQUOTE] = ACTIONS(1147),
    [anon_sym_u8_SQUOTE] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_L_DQUOTE] = ACTIONS(1147),
    [anon_sym_u_DQUOTE] = ACTIONS(1147),
    [anon_sym_U_DQUOTE] = ACTIONS(1147),
    [anon_sym_u8_DQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [anon_sym_NULL] = ACTIONS(1145),
    [anon_sym_nullptr] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_identifier] = ACTIONS(1149),
    [aux_sym_preproc_include_token1] = ACTIONS(1149),
    [aux_sym_preproc_def_token1] = ACTIONS(1149),
    [aux_sym_preproc_if_token1] = ACTIONS(1149),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1149),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1149),
    [sym_preproc_directive] = ACTIONS(1149),
    [anon_sym_LPAREN2] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym___extension__] = ACTIONS(1149),
    [anon_sym_typedef] = ACTIONS(1149),
    [anon_sym_extern] = ACTIONS(1149),
    [anon_sym___attribute__] = ACTIONS(1149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1151),
    [anon_sym___declspec] = ACTIONS(1149),
    [anon_sym___cdecl] = ACTIONS(1149),
    [anon_sym___clrcall] = ACTIONS(1149),
    [anon_sym___stdcall] = ACTIONS(1149),
    [anon_sym___fastcall] = ACTIONS(1149),
    [anon_sym___thiscall] = ACTIONS(1149),
    [anon_sym___vectorcall] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym_signed] = ACTIONS(1149),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1149),
    [anon_sym_auto] = ACTIONS(1149),
    [anon_sym_register] = ACTIONS(1149),
    [anon_sym_inline] = ACTIONS(1149),
    [anon_sym___inline] = ACTIONS(1149),
    [anon_sym___inline__] = ACTIONS(1149),
    [anon_sym___forceinline] = ACTIONS(1149),
    [anon_sym_thread_local] = ACTIONS(1149),
    [anon_sym___thread] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_constexpr] = ACTIONS(1149),
    [anon_sym_volatile] = ACTIONS(1149),
    [anon_sym_restrict] = ACTIONS(1149),
    [anon_sym___restrict__] = ACTIONS(1149),
    [anon_sym__Atomic] = ACTIONS(1149),
    [anon_sym__Noreturn] = ACTIONS(1149),
    [anon_sym_noreturn] = ACTIONS(1149),
    [anon_sym__Nonnull] = ACTIONS(1149),
    [anon_sym_alignas] = ACTIONS(1149),
    [anon_sym__Alignas] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(1149),
    [anon_sym_enum] = ACTIONS(1149),
    [anon_sym_struct] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_else] = ACTIONS(1149),
    [anon_sym_switch] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1149),
    [anon_sym_default] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_do] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_goto] = ACTIONS(1149),
    [anon_sym___try] = ACTIONS(1149),
    [anon_sym___leave] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_sizeof] = ACTIONS(1149),
    [anon_sym___alignof__] = ACTIONS(1149),
    [anon_sym___alignof] = ACTIONS(1149),
    [anon_sym__alignof] = ACTIONS(1149),
    [anon_sym_alignof] = ACTIONS(1149),
    [anon_sym__Alignof] = ACTIONS(1149),
    [anon_sym_offsetof] = ACTIONS(1149),
    [anon_sym__Generic] = ACTIONS(1149),
    [anon_sym_asm] = ACTIONS(1149),
    [anon_sym___asm__] = ACTIONS(1149),
    [anon_sym___asm] = ACTIONS(1149),
    [sym_number_literal] = ACTIONS(1151),
    [anon_sym_L_SQUOTE] = ACTIONS(1151),
    [anon_sym_u_SQUOTE] = ACTIONS(1151),
    [anon_sym_U_SQUOTE] = ACTIONS(1151),
    [anon_sym_u8_SQUOTE] = ACTIONS(1151),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_L_DQUOTE] = ACTIONS(1151),
    [anon_sym_u_DQUOTE] = ACTIONS(1151),
    [anon_sym_U_DQUOTE] = ACTIONS(1151),
    [anon_sym_u8_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(1151),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [anon_sym_NULL] = ACTIONS(1149),
    [anon_sym_nullptr] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [sym_identifier] = ACTIONS(1153),
    [aux_sym_preproc_include_token1] = ACTIONS(1153),
    [aux_sym_preproc_def_token1] = ACTIONS(1153),
    [aux_sym_preproc_if_token1] = ACTIONS(1153),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1153),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1153),
    [sym_preproc_directive] = ACTIONS(1153),
    [anon_sym_LPAREN2] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_TILDE] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym___extension__] = ACTIONS(1153),
    [anon_sym_typedef] = ACTIONS(1153),
    [anon_sym_extern] = ACTIONS(1153),
    [anon_sym___attribute__] = ACTIONS(1153),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1155),
    [anon_sym___declspec] = ACTIONS(1153),
    [anon_sym___cdecl] = ACTIONS(1153),
    [anon_sym___clrcall] = ACTIONS(1153),
    [anon_sym___stdcall] = ACTIONS(1153),
    [anon_sym___fastcall] = ACTIONS(1153),
    [anon_sym___thiscall] = ACTIONS(1153),
    [anon_sym___vectorcall] = ACTIONS(1153),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_signed] = ACTIONS(1153),
    [anon_sym_unsigned] = ACTIONS(1153),
    [anon_sym_long] = ACTIONS(1153),
    [anon_sym_short] = ACTIONS(1153),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_auto] = ACTIONS(1153),
    [anon_sym_register] = ACTIONS(1153),
    [anon_sym_inline] = ACTIONS(1153),
    [anon_sym___inline] = ACTIONS(1153),
    [anon_sym___inline__] = ACTIONS(1153),
    [anon_sym___forceinline] = ACTIONS(1153),
    [anon_sym_thread_local] = ACTIONS(1153),
    [anon_sym___thread] = ACTIONS(1153),
    [anon_sym_const] = ACTIONS(1153),
    [anon_sym_constexpr] = ACTIONS(1153),
    [anon_sym_volatile] = ACTIONS(1153),
    [anon_sym_restrict] = ACTIONS(1153),
    [anon_sym___restrict__] = ACTIONS(1153),
    [anon_sym__Atomic] = ACTIONS(1153),
    [anon_sym__Noreturn] = ACTIONS(1153),
    [anon_sym_noreturn] = ACTIONS(1153),
    [anon_sym__Nonnull] = ACTIONS(1153),
    [anon_sym_alignas] = ACTIONS(1153),
    [anon_sym__Alignas] = ACTIONS(1153),
    [sym_primitive_type] = ACTIONS(1153),
    [anon_sym_enum] = ACTIONS(1153),
    [anon_sym_struct] = ACTIONS(1153),
    [anon_sym_union] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_else] = ACTIONS(1153),
    [anon_sym_switch] = ACTIONS(1153),
    [anon_sym_case] = ACTIONS(1153),
    [anon_sym_default] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_do] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [anon_sym_goto] = ACTIONS(1153),
    [anon_sym___try] = ACTIONS(1153),
    [anon_sym___leave] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_sizeof] = ACTIONS(1153),
    [anon_sym___alignof__] = ACTIONS(1153),
    [anon_sym___alignof] = ACTIONS(1153),
    [anon_sym__alignof] = ACTIONS(1153),
    [anon_sym_alignof] = ACTIONS(1153),
    [anon_sym__Alignof] = ACTIONS(1153),
    [anon_sym_offsetof] = ACTIONS(1153),
    [anon_sym__Generic] = ACTIONS(1153),
    [anon_sym_asm] = ACTIONS(1153),
    [anon_sym___asm__] = ACTIONS(1153),
    [anon_sym___asm] = ACTIONS(1153),
    [sym_number_literal] = ACTIONS(1155),
    [anon_sym_L_SQUOTE] = ACTIONS(1155),
    [anon_sym_u_SQUOTE] = ACTIONS(1155),
    [anon_sym_U_SQUOTE] = ACTIONS(1155),
    [anon_sym_u8_SQUOTE] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [anon_sym_L_DQUOTE] = ACTIONS(1155),
    [anon_sym_u_DQUOTE] = ACTIONS(1155),
    [anon_sym_U_DQUOTE] = ACTIONS(1155),
    [anon_sym_u8_DQUOTE] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [anon_sym_NULL] = ACTIONS(1153),
    [anon_sym_nullptr] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1157),
    [aux_sym_preproc_include_token1] = ACTIONS(1157),
    [aux_sym_preproc_def_token1] = ACTIONS(1157),
    [aux_sym_preproc_if_token1] = ACTIONS(1157),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1157),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1157),
    [sym_preproc_directive] = ACTIONS(1157),
    [anon_sym_LPAREN2] = ACTIONS(1159),
    [anon_sym_BANG] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym___extension__] = ACTIONS(1157),
    [anon_sym_typedef] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1157),
    [anon_sym___attribute__] = ACTIONS(1157),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1159),
    [anon_sym___declspec] = ACTIONS(1157),
    [anon_sym___cdecl] = ACTIONS(1157),
    [anon_sym___clrcall] = ACTIONS(1157),
    [anon_sym___stdcall] = ACTIONS(1157),
    [anon_sym___fastcall] = ACTIONS(1157),
    [anon_sym___thiscall] = ACTIONS(1157),
    [anon_sym___vectorcall] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_signed] = ACTIONS(1157),
    [anon_sym_unsigned] = ACTIONS(1157),
    [anon_sym_long] = ACTIONS(1157),
    [anon_sym_short] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1157),
    [anon_sym_auto] = ACTIONS(1157),
    [anon_sym_register] = ACTIONS(1157),
    [anon_sym_inline] = ACTIONS(1157),
    [anon_sym___inline] = ACTIONS(1157),
    [anon_sym___inline__] = ACTIONS(1157),
    [anon_sym___forceinline] = ACTIONS(1157),
    [anon_sym_thread_local] = ACTIONS(1157),
    [anon_sym___thread] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_constexpr] = ACTIONS(1157),
    [anon_sym_volatile] = ACTIONS(1157),
    [anon_sym_restrict] = ACTIONS(1157),
    [anon_sym___restrict__] = ACTIONS(1157),
    [anon_sym__Atomic] = ACTIONS(1157),
    [anon_sym__Noreturn] = ACTIONS(1157),
    [anon_sym_noreturn] = ACTIONS(1157),
    [anon_sym__Nonnull] = ACTIONS(1157),
    [anon_sym_alignas] = ACTIONS(1157),
    [anon_sym__Alignas] = ACTIONS(1157),
    [sym_primitive_type] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [anon_sym_struct] = ACTIONS(1157),
    [anon_sym_union] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_else] = ACTIONS(1157),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_case] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_do] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [anon_sym_goto] = ACTIONS(1157),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_sizeof] = ACTIONS(1157),
    [anon_sym___alignof__] = ACTIONS(1157),
    [anon_sym___alignof] = ACTIONS(1157),
    [anon_sym__alignof] = ACTIONS(1157),
    [anon_sym_alignof] = ACTIONS(1157),
    [anon_sym__Alignof] = ACTIONS(1157),
    [anon_sym_offsetof] = ACTIONS(1157),
    [anon_sym__Generic] = ACTIONS(1157),
    [anon_sym_asm] = ACTIONS(1157),
    [anon_sym___asm__] = ACTIONS(1157),
    [anon_sym___asm] = ACTIONS(1157),
    [sym_number_literal] = ACTIONS(1159),
    [anon_sym_L_SQUOTE] = ACTIONS(1159),
    [anon_sym_u_SQUOTE] = ACTIONS(1159),
    [anon_sym_U_SQUOTE] = ACTIONS(1159),
    [anon_sym_u8_SQUOTE] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [anon_sym_L_DQUOTE] = ACTIONS(1159),
    [anon_sym_u_DQUOTE] = ACTIONS(1159),
    [anon_sym_U_DQUOTE] = ACTIONS(1159),
    [anon_sym_u8_DQUOTE] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [anon_sym_NULL] = ACTIONS(1157),
    [anon_sym_nullptr] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym_identifier] = ACTIONS(1141),
    [aux_sym_preproc_include_token1] = ACTIONS(1141),
    [aux_sym_preproc_def_token1] = ACTIONS(1141),
    [aux_sym_preproc_if_token1] = ACTIONS(1141),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1141),
    [sym_preproc_directive] = ACTIONS(1141),
    [anon_sym_LPAREN2] = ACTIONS(1143),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1143),
    [anon_sym___extension__] = ACTIONS(1141),
    [anon_sym_typedef] = ACTIONS(1141),
    [anon_sym_extern] = ACTIONS(1141),
    [anon_sym___attribute__] = ACTIONS(1141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1143),
    [anon_sym___declspec] = ACTIONS(1141),
    [anon_sym___cdecl] = ACTIONS(1141),
    [anon_sym___clrcall] = ACTIONS(1141),
    [anon_sym___stdcall] = ACTIONS(1141),
    [anon_sym___fastcall] = ACTIONS(1141),
    [anon_sym___thiscall] = ACTIONS(1141),
    [anon_sym___vectorcall] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1143),
    [anon_sym_RBRACE] = ACTIONS(1143),
    [anon_sym_signed] = ACTIONS(1141),
    [anon_sym_unsigned] = ACTIONS(1141),
    [anon_sym_long] = ACTIONS(1141),
    [anon_sym_short] = ACTIONS(1141),
    [anon_sym_static] = ACTIONS(1141),
    [anon_sym_auto] = ACTIONS(1141),
    [anon_sym_register] = ACTIONS(1141),
    [anon_sym_inline] = ACTIONS(1141),
    [anon_sym___inline] = ACTIONS(1141),
    [anon_sym___inline__] = ACTIONS(1141),
    [anon_sym___forceinline] = ACTIONS(1141),
    [anon_sym_thread_local] = ACTIONS(1141),
    [anon_sym___thread] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_constexpr] = ACTIONS(1141),
    [anon_sym_volatile] = ACTIONS(1141),
    [anon_sym_restrict] = ACTIONS(1141),
    [anon_sym___restrict__] = ACTIONS(1141),
    [anon_sym__Atomic] = ACTIONS(1141),
    [anon_sym__Noreturn] = ACTIONS(1141),
    [anon_sym_noreturn] = ACTIONS(1141),
    [anon_sym__Nonnull] = ACTIONS(1141),
    [anon_sym_alignas] = ACTIONS(1141),
    [anon_sym__Alignas] = ACTIONS(1141),
    [sym_primitive_type] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [anon_sym_struct] = ACTIONS(1141),
    [anon_sym_union] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_else] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_case] = ACTIONS(1141),
    [anon_sym_default] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_do] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1141),
    [anon_sym___leave] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1141),
    [anon_sym___alignof__] = ACTIONS(1141),
    [anon_sym___alignof] = ACTIONS(1141),
    [anon_sym__alignof] = ACTIONS(1141),
    [anon_sym_alignof] = ACTIONS(1141),
    [anon_sym__Alignof] = ACTIONS(1141),
    [anon_sym_offsetof] = ACTIONS(1141),
    [anon_sym__Generic] = ACTIONS(1141),
    [anon_sym_asm] = ACTIONS(1141),
    [anon_sym___asm__] = ACTIONS(1141),
    [anon_sym___asm] = ACTIONS(1141),
    [sym_number_literal] = ACTIONS(1143),
    [anon_sym_L_SQUOTE] = ACTIONS(1143),
    [anon_sym_u_SQUOTE] = ACTIONS(1143),
    [anon_sym_U_SQUOTE] = ACTIONS(1143),
    [anon_sym_u8_SQUOTE] = ACTIONS(1143),
    [anon_sym_SQUOTE] = ACTIONS(1143),
    [anon_sym_L_DQUOTE] = ACTIONS(1143),
    [anon_sym_u_DQUOTE] = ACTIONS(1143),
    [anon_sym_U_DQUOTE] = ACTIONS(1143),
    [anon_sym_u8_DQUOTE] = ACTIONS(1143),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [sym_true] = ACTIONS(1141),
    [sym_false] = ACTIONS(1141),
    [anon_sym_NULL] = ACTIONS(1141),
    [anon_sym_nullptr] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [sym_identifier] = ACTIONS(1157),
    [aux_sym_preproc_include_token1] = ACTIONS(1157),
    [aux_sym_preproc_def_token1] = ACTIONS(1157),
    [aux_sym_preproc_if_token1] = ACTIONS(1157),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1157),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1157),
    [sym_preproc_directive] = ACTIONS(1157),
    [anon_sym_LPAREN2] = ACTIONS(1159),
    [anon_sym_BANG] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym___extension__] = ACTIONS(1157),
    [anon_sym_typedef] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1157),
    [anon_sym___attribute__] = ACTIONS(1157),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1159),
    [anon_sym___declspec] = ACTIONS(1157),
    [anon_sym___cdecl] = ACTIONS(1157),
    [anon_sym___clrcall] = ACTIONS(1157),
    [anon_sym___stdcall] = ACTIONS(1157),
    [anon_sym___fastcall] = ACTIONS(1157),
    [anon_sym___thiscall] = ACTIONS(1157),
    [anon_sym___vectorcall] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_signed] = ACTIONS(1157),
    [anon_sym_unsigned] = ACTIONS(1157),
    [anon_sym_long] = ACTIONS(1157),
    [anon_sym_short] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1157),
    [anon_sym_auto] = ACTIONS(1157),
    [anon_sym_register] = ACTIONS(1157),
    [anon_sym_inline] = ACTIONS(1157),
    [anon_sym___inline] = ACTIONS(1157),
    [anon_sym___inline__] = ACTIONS(1157),
    [anon_sym___forceinline] = ACTIONS(1157),
    [anon_sym_thread_local] = ACTIONS(1157),
    [anon_sym___thread] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_constexpr] = ACTIONS(1157),
    [anon_sym_volatile] = ACTIONS(1157),
    [anon_sym_restrict] = ACTIONS(1157),
    [anon_sym___restrict__] = ACTIONS(1157),
    [anon_sym__Atomic] = ACTIONS(1157),
    [anon_sym__Noreturn] = ACTIONS(1157),
    [anon_sym_noreturn] = ACTIONS(1157),
    [anon_sym__Nonnull] = ACTIONS(1157),
    [anon_sym_alignas] = ACTIONS(1157),
    [anon_sym__Alignas] = ACTIONS(1157),
    [sym_primitive_type] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [anon_sym_struct] = ACTIONS(1157),
    [anon_sym_union] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_else] = ACTIONS(1157),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_case] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_do] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [anon_sym_goto] = ACTIONS(1157),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_sizeof] = ACTIONS(1157),
    [anon_sym___alignof__] = ACTIONS(1157),
    [anon_sym___alignof] = ACTIONS(1157),
    [anon_sym__alignof] = ACTIONS(1157),
    [anon_sym_alignof] = ACTIONS(1157),
    [anon_sym__Alignof] = ACTIONS(1157),
    [anon_sym_offsetof] = ACTIONS(1157),
    [anon_sym__Generic] = ACTIONS(1157),
    [anon_sym_asm] = ACTIONS(1157),
    [anon_sym___asm__] = ACTIONS(1157),
    [anon_sym___asm] = ACTIONS(1157),
    [sym_number_literal] = ACTIONS(1159),
    [anon_sym_L_SQUOTE] = ACTIONS(1159),
    [anon_sym_u_SQUOTE] = ACTIONS(1159),
    [anon_sym_U_SQUOTE] = ACTIONS(1159),
    [anon_sym_u8_SQUOTE] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [anon_sym_L_DQUOTE] = ACTIONS(1159),
    [anon_sym_u_DQUOTE] = ACTIONS(1159),
    [anon_sym_U_DQUOTE] = ACTIONS(1159),
    [anon_sym_u8_DQUOTE] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [anon_sym_NULL] = ACTIONS(1157),
    [anon_sym_nullptr] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(1161),
    [aux_sym_preproc_include_token1] = ACTIONS(1161),
    [aux_sym_preproc_def_token1] = ACTIONS(1161),
    [aux_sym_preproc_if_token1] = ACTIONS(1161),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1161),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1161),
    [sym_preproc_directive] = ACTIONS(1161),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym___extension__] = ACTIONS(1161),
    [anon_sym_typedef] = ACTIONS(1161),
    [anon_sym_extern] = ACTIONS(1161),
    [anon_sym___attribute__] = ACTIONS(1161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1163),
    [anon_sym___declspec] = ACTIONS(1161),
    [anon_sym___cdecl] = ACTIONS(1161),
    [anon_sym___clrcall] = ACTIONS(1161),
    [anon_sym___stdcall] = ACTIONS(1161),
    [anon_sym___fastcall] = ACTIONS(1161),
    [anon_sym___thiscall] = ACTIONS(1161),
    [anon_sym___vectorcall] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_signed] = ACTIONS(1161),
    [anon_sym_unsigned] = ACTIONS(1161),
    [anon_sym_long] = ACTIONS(1161),
    [anon_sym_short] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1161),
    [anon_sym_auto] = ACTIONS(1161),
    [anon_sym_register] = ACTIONS(1161),
    [anon_sym_inline] = ACTIONS(1161),
    [anon_sym___inline] = ACTIONS(1161),
    [anon_sym___inline__] = ACTIONS(1161),
    [anon_sym___forceinline] = ACTIONS(1161),
    [anon_sym_thread_local] = ACTIONS(1161),
    [anon_sym___thread] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_constexpr] = ACTIONS(1161),
    [anon_sym_volatile] = ACTIONS(1161),
    [anon_sym_restrict] = ACTIONS(1161),
    [anon_sym___restrict__] = ACTIONS(1161),
    [anon_sym__Atomic] = ACTIONS(1161),
    [anon_sym__Noreturn] = ACTIONS(1161),
    [anon_sym_noreturn] = ACTIONS(1161),
    [anon_sym__Nonnull] = ACTIONS(1161),
    [anon_sym_alignas] = ACTIONS(1161),
    [anon_sym__Alignas] = ACTIONS(1161),
    [sym_primitive_type] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [anon_sym_struct] = ACTIONS(1161),
    [anon_sym_union] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_else] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_case] = ACTIONS(1161),
    [anon_sym_default] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_do] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_goto] = ACTIONS(1161),
    [anon_sym___try] = ACTIONS(1161),
    [anon_sym___leave] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_sizeof] = ACTIONS(1161),
    [anon_sym___alignof__] = ACTIONS(1161),
    [anon_sym___alignof] = ACTIONS(1161),
    [anon_sym__alignof] = ACTIONS(1161),
    [anon_sym_alignof] = ACTIONS(1161),
    [anon_sym__Alignof] = ACTIONS(1161),
    [anon_sym_offsetof] = ACTIONS(1161),
    [anon_sym__Generic] = ACTIONS(1161),
    [anon_sym_asm] = ACTIONS(1161),
    [anon_sym___asm__] = ACTIONS(1161),
    [anon_sym___asm] = ACTIONS(1161),
    [sym_number_literal] = ACTIONS(1163),
    [anon_sym_L_SQUOTE] = ACTIONS(1163),
    [anon_sym_u_SQUOTE] = ACTIONS(1163),
    [anon_sym_U_SQUOTE] = ACTIONS(1163),
    [anon_sym_u8_SQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [anon_sym_L_DQUOTE] = ACTIONS(1163),
    [anon_sym_u_DQUOTE] = ACTIONS(1163),
    [anon_sym_U_DQUOTE] = ACTIONS(1163),
    [anon_sym_u8_DQUOTE] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [anon_sym_NULL] = ACTIONS(1161),
    [anon_sym_nullptr] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(1167),
    [sym_identifier] = ACTIONS(1165),
    [aux_sym_preproc_include_token1] = ACTIONS(1165),
    [aux_sym_preproc_def_token1] = ACTIONS(1165),
    [aux_sym_preproc_if_token1] = ACTIONS(1165),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1165),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1165),
    [sym_preproc_directive] = ACTIONS(1165),
    [anon_sym_LPAREN2] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym___extension__] = ACTIONS(1165),
    [anon_sym_typedef] = ACTIONS(1165),
    [anon_sym_extern] = ACTIONS(1165),
    [anon_sym___attribute__] = ACTIONS(1165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1167),
    [anon_sym___declspec] = ACTIONS(1165),
    [anon_sym___cdecl] = ACTIONS(1165),
    [anon_sym___clrcall] = ACTIONS(1165),
    [anon_sym___stdcall] = ACTIONS(1165),
    [anon_sym___fastcall] = ACTIONS(1165),
    [anon_sym___thiscall] = ACTIONS(1165),
    [anon_sym___vectorcall] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_signed] = ACTIONS(1165),
    [anon_sym_unsigned] = ACTIONS(1165),
    [anon_sym_long] = ACTIONS(1165),
    [anon_sym_short] = ACTIONS(1165),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_auto] = ACTIONS(1165),
    [anon_sym_register] = ACTIONS(1165),
    [anon_sym_inline] = ACTIONS(1165),
    [anon_sym___inline] = ACTIONS(1165),
    [anon_sym___inline__] = ACTIONS(1165),
    [anon_sym___forceinline] = ACTIONS(1165),
    [anon_sym_thread_local] = ACTIONS(1165),
    [anon_sym___thread] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_constexpr] = ACTIONS(1165),
    [anon_sym_volatile] = ACTIONS(1165),
    [anon_sym_restrict] = ACTIONS(1165),
    [anon_sym___restrict__] = ACTIONS(1165),
    [anon_sym__Atomic] = ACTIONS(1165),
    [anon_sym__Noreturn] = ACTIONS(1165),
    [anon_sym_noreturn] = ACTIONS(1165),
    [anon_sym__Nonnull] = ACTIONS(1165),
    [anon_sym_alignas] = ACTIONS(1165),
    [anon_sym__Alignas] = ACTIONS(1165),
    [sym_primitive_type] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [anon_sym_struct] = ACTIONS(1165),
    [anon_sym_union] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_goto] = ACTIONS(1165),
    [anon_sym___try] = ACTIONS(1165),
    [anon_sym___leave] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_sizeof] = ACTIONS(1165),
    [anon_sym___alignof__] = ACTIONS(1165),
    [anon_sym___alignof] = ACTIONS(1165),
    [anon_sym__alignof] = ACTIONS(1165),
    [anon_sym_alignof] = ACTIONS(1165),
    [anon_sym__Alignof] = ACTIONS(1165),
    [anon_sym_offsetof] = ACTIONS(1165),
    [anon_sym__Generic] = ACTIONS(1165),
    [anon_sym_asm] = ACTIONS(1165),
    [anon_sym___asm__] = ACTIONS(1165),
    [anon_sym___asm] = ACTIONS(1165),
    [sym_number_literal] = ACTIONS(1167),
    [anon_sym_L_SQUOTE] = ACTIONS(1167),
    [anon_sym_u_SQUOTE] = ACTIONS(1167),
    [anon_sym_U_SQUOTE] = ACTIONS(1167),
    [anon_sym_u8_SQUOTE] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [anon_sym_L_DQUOTE] = ACTIONS(1167),
    [anon_sym_u_DQUOTE] = ACTIONS(1167),
    [anon_sym_U_DQUOTE] = ACTIONS(1167),
    [anon_sym_u8_DQUOTE] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [anon_sym_NULL] = ACTIONS(1165),
    [anon_sym_nullptr] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_identifier] = ACTIONS(1169),
    [aux_sym_preproc_include_token1] = ACTIONS(1169),
    [aux_sym_preproc_def_token1] = ACTIONS(1169),
    [aux_sym_preproc_if_token1] = ACTIONS(1169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1169),
    [sym_preproc_directive] = ACTIONS(1169),
    [anon_sym_LPAREN2] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1171),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym___extension__] = ACTIONS(1169),
    [anon_sym_typedef] = ACTIONS(1169),
    [anon_sym_extern] = ACTIONS(1169),
    [anon_sym___attribute__] = ACTIONS(1169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1171),
    [anon_sym___declspec] = ACTIONS(1169),
    [anon_sym___cdecl] = ACTIONS(1169),
    [anon_sym___clrcall] = ACTIONS(1169),
    [anon_sym___stdcall] = ACTIONS(1169),
    [anon_sym___fastcall] = ACTIONS(1169),
    [anon_sym___thiscall] = ACTIONS(1169),
    [anon_sym___vectorcall] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_signed] = ACTIONS(1169),
    [anon_sym_unsigned] = ACTIONS(1169),
    [anon_sym_long] = ACTIONS(1169),
    [anon_sym_short] = ACTIONS(1169),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_auto] = ACTIONS(1169),
    [anon_sym_register] = ACTIONS(1169),
    [anon_sym_inline] = ACTIONS(1169),
    [anon_sym___inline] = ACTIONS(1169),
    [anon_sym___inline__] = ACTIONS(1169),
    [anon_sym___forceinline] = ACTIONS(1169),
    [anon_sym_thread_local] = ACTIONS(1169),
    [anon_sym___thread] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_constexpr] = ACTIONS(1169),
    [anon_sym_volatile] = ACTIONS(1169),
    [anon_sym_restrict] = ACTIONS(1169),
    [anon_sym___restrict__] = ACTIONS(1169),
    [anon_sym__Atomic] = ACTIONS(1169),
    [anon_sym__Noreturn] = ACTIONS(1169),
    [anon_sym_noreturn] = ACTIONS(1169),
    [anon_sym__Nonnull] = ACTIONS(1169),
    [anon_sym_alignas] = ACTIONS(1169),
    [anon_sym__Alignas] = ACTIONS(1169),
    [sym_primitive_type] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [anon_sym_struct] = ACTIONS(1169),
    [anon_sym_union] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_do] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [anon_sym_goto] = ACTIONS(1169),
    [anon_sym___try] = ACTIONS(1169),
    [anon_sym___leave] = ACTIONS(1169),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_sizeof] = ACTIONS(1169),
    [anon_sym___alignof__] = ACTIONS(1169),
    [anon_sym___alignof] = ACTIONS(1169),
    [anon_sym__alignof] = ACTIONS(1169),
    [anon_sym_alignof] = ACTIONS(1169),
    [anon_sym__Alignof] = ACTIONS(1169),
    [anon_sym_offsetof] = ACTIONS(1169),
    [anon_sym__Generic] = ACTIONS(1169),
    [anon_sym_asm] = ACTIONS(1169),
    [anon_sym___asm__] = ACTIONS(1169),
    [anon_sym___asm] = ACTIONS(1169),
    [sym_number_literal] = ACTIONS(1171),
    [anon_sym_L_SQUOTE] = ACTIONS(1171),
    [anon_sym_u_SQUOTE] = ACTIONS(1171),
    [anon_sym_U_SQUOTE] = ACTIONS(1171),
    [anon_sym_u8_SQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [anon_sym_L_DQUOTE] = ACTIONS(1171),
    [anon_sym_u_DQUOTE] = ACTIONS(1171),
    [anon_sym_U_DQUOTE] = ACTIONS(1171),
    [anon_sym_u8_DQUOTE] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [anon_sym_NULL] = ACTIONS(1169),
    [anon_sym_nullptr] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(1223),
    [sym_identifier] = ACTIONS(1221),
    [aux_sym_preproc_include_token1] = ACTIONS(1221),
    [aux_sym_preproc_def_token1] = ACTIONS(1221),
    [aux_sym_preproc_if_token1] = ACTIONS(1221),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1221),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1221),
    [sym_preproc_directive] = ACTIONS(1221),
    [anon_sym_LPAREN2] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym___extension__] = ACTIONS(1221),
    [anon_sym_typedef] = ACTIONS(1221),
    [anon_sym_extern] = ACTIONS(1221),
    [anon_sym___attribute__] = ACTIONS(1221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1223),
    [anon_sym___declspec] = ACTIONS(1221),
    [anon_sym___cdecl] = ACTIONS(1221),
    [anon_sym___clrcall] = ACTIONS(1221),
    [anon_sym___stdcall] = ACTIONS(1221),
    [anon_sym___fastcall] = ACTIONS(1221),
    [anon_sym___thiscall] = ACTIONS(1221),
    [anon_sym___vectorcall] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_signed] = ACTIONS(1221),
    [anon_sym_unsigned] = ACTIONS(1221),
    [anon_sym_long] = ACTIONS(1221),
    [anon_sym_short] = ACTIONS(1221),
    [anon_sym_static] = ACTIONS(1221),
    [anon_sym_auto] = ACTIONS(1221),
    [anon_sym_register] = ACTIONS(1221),
    [anon_sym_inline] = ACTIONS(1221),
    [anon_sym___inline] = ACTIONS(1221),
    [anon_sym___inline__] = ACTIONS(1221),
    [anon_sym___forceinline] = ACTIONS(1221),
    [anon_sym_thread_local] = ACTIONS(1221),
    [anon_sym___thread] = ACTIONS(1221),
    [anon_sym_const] = ACTIONS(1221),
    [anon_sym_constexpr] = ACTIONS(1221),
    [anon_sym_volatile] = ACTIONS(1221),
    [anon_sym_restrict] = ACTIONS(1221),
    [anon_sym___restrict__] = ACTIONS(1221),
    [anon_sym__Atomic] = ACTIONS(1221),
    [anon_sym__Noreturn] = ACTIONS(1221),
    [anon_sym_noreturn] = ACTIONS(1221),
    [anon_sym__Nonnull] = ACTIONS(1221),
    [anon_sym_alignas] = ACTIONS(1221),
    [anon_sym__Alignas] = ACTIONS(1221),
    [sym_primitive_type] = ACTIONS(1221),
    [anon_sym_enum] = ACTIONS(1221),
    [anon_sym_struct] = ACTIONS(1221),
    [anon_sym_union] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1221),
    [anon_sym_else] = ACTIONS(1221),
    [anon_sym_switch] = ACTIONS(1221),
    [anon_sym_case] = ACTIONS(1221),
    [anon_sym_default] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1221),
    [anon_sym_do] = ACTIONS(1221),
    [anon_sym_for] = ACTIONS(1221),
    [anon_sym_return] = ACTIONS(1221),
    [anon_sym_break] = ACTIONS(1221),
    [anon_sym_continue] = ACTIONS(1221),
    [anon_sym_goto] = ACTIONS(1221),
    [anon_sym___try] = ACTIONS(1221),
    [anon_sym___leave] = ACTIONS(1221),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_sizeof] = ACTIONS(1221),
    [anon_sym___alignof__] = ACTIONS(1221),
    [anon_sym___alignof] = ACTIONS(1221),
    [anon_sym__alignof] = ACTIONS(1221),
    [anon_sym_alignof] = ACTIONS(1221),
    [anon_sym__Alignof] = ACTIONS(1221),
    [anon_sym_offsetof] = ACTIONS(1221),
    [anon_sym__Generic] = ACTIONS(1221),
    [anon_sym_asm] = ACTIONS(1221),
    [anon_sym___asm__] = ACTIONS(1221),
    [anon_sym___asm] = ACTIONS(1221),
    [sym_number_literal] = ACTIONS(1223),
    [anon_sym_L_SQUOTE] = ACTIONS(1223),
    [anon_sym_u_SQUOTE] = ACTIONS(1223),
    [anon_sym_U_SQUOTE] = ACTIONS(1223),
    [anon_sym_u8_SQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [anon_sym_L_DQUOTE] = ACTIONS(1223),
    [anon_sym_u_DQUOTE] = ACTIONS(1223),
    [anon_sym_U_DQUOTE] = ACTIONS(1223),
    [anon_sym_u8_DQUOTE] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [anon_sym_NULL] = ACTIONS(1221),
    [anon_sym_nullptr] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_identifier] = ACTIONS(1173),
    [aux_sym_preproc_include_token1] = ACTIONS(1173),
    [aux_sym_preproc_def_token1] = ACTIONS(1173),
    [aux_sym_preproc_if_token1] = ACTIONS(1173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1173),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1173),
    [sym_preproc_directive] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym___extension__] = ACTIONS(1173),
    [anon_sym_typedef] = ACTIONS(1173),
    [anon_sym_extern] = ACTIONS(1173),
    [anon_sym___attribute__] = ACTIONS(1173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1175),
    [anon_sym___declspec] = ACTIONS(1173),
    [anon_sym___cdecl] = ACTIONS(1173),
    [anon_sym___clrcall] = ACTIONS(1173),
    [anon_sym___stdcall] = ACTIONS(1173),
    [anon_sym___fastcall] = ACTIONS(1173),
    [anon_sym___thiscall] = ACTIONS(1173),
    [anon_sym___vectorcall] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_signed] = ACTIONS(1173),
    [anon_sym_unsigned] = ACTIONS(1173),
    [anon_sym_long] = ACTIONS(1173),
    [anon_sym_short] = ACTIONS(1173),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_auto] = ACTIONS(1173),
    [anon_sym_register] = ACTIONS(1173),
    [anon_sym_inline] = ACTIONS(1173),
    [anon_sym___inline] = ACTIONS(1173),
    [anon_sym___inline__] = ACTIONS(1173),
    [anon_sym___forceinline] = ACTIONS(1173),
    [anon_sym_thread_local] = ACTIONS(1173),
    [anon_sym___thread] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_constexpr] = ACTIONS(1173),
    [anon_sym_volatile] = ACTIONS(1173),
    [anon_sym_restrict] = ACTIONS(1173),
    [anon_sym___restrict__] = ACTIONS(1173),
    [anon_sym__Atomic] = ACTIONS(1173),
    [anon_sym__Noreturn] = ACTIONS(1173),
    [anon_sym_noreturn] = ACTIONS(1173),
    [anon_sym__Nonnull] = ACTIONS(1173),
    [anon_sym_alignas] = ACTIONS(1173),
    [anon_sym__Alignas] = ACTIONS(1173),
    [sym_primitive_type] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [anon_sym_struct] = ACTIONS(1173),
    [anon_sym_union] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_goto] = ACTIONS(1173),
    [anon_sym___try] = ACTIONS(1173),
    [anon_sym___leave] = ACTIONS(1173),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_sizeof] = ACTIONS(1173),
    [anon_sym___alignof__] = ACTIONS(1173),
    [anon_sym___alignof] = ACTIONS(1173),
    [anon_sym__alignof] = ACTIONS(1173),
    [anon_sym_alignof] = ACTIONS(1173),
    [anon_sym__Alignof] = ACTIONS(1173),
    [anon_sym_offsetof] = ACTIONS(1173),
    [anon_sym__Generic] = ACTIONS(1173),
    [anon_sym_asm] = ACTIONS(1173),
    [anon_sym___asm__] = ACTIONS(1173),
    [anon_sym___asm] = ACTIONS(1173),
    [sym_number_literal] = ACTIONS(1175),
    [anon_sym_L_SQUOTE] = ACTIONS(1175),
    [anon_sym_u_SQUOTE] = ACTIONS(1175),
    [anon_sym_U_SQUOTE] = ACTIONS(1175),
    [anon_sym_u8_SQUOTE] = ACTIONS(1175),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_L_DQUOTE] = ACTIONS(1175),
    [anon_sym_u_DQUOTE] = ACTIONS(1175),
    [anon_sym_U_DQUOTE] = ACTIONS(1175),
    [anon_sym_u8_DQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [anon_sym_NULL] = ACTIONS(1173),
    [anon_sym_nullptr] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_identifier] = ACTIONS(1177),
    [aux_sym_preproc_include_token1] = ACTIONS(1177),
    [aux_sym_preproc_def_token1] = ACTIONS(1177),
    [aux_sym_preproc_if_token1] = ACTIONS(1177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1177),
    [sym_preproc_directive] = ACTIONS(1177),
    [anon_sym_LPAREN2] = ACTIONS(1179),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym___extension__] = ACTIONS(1177),
    [anon_sym_typedef] = ACTIONS(1177),
    [anon_sym_extern] = ACTIONS(1177),
    [anon_sym___attribute__] = ACTIONS(1177),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1179),
    [anon_sym___declspec] = ACTIONS(1177),
    [anon_sym___cdecl] = ACTIONS(1177),
    [anon_sym___clrcall] = ACTIONS(1177),
    [anon_sym___stdcall] = ACTIONS(1177),
    [anon_sym___fastcall] = ACTIONS(1177),
    [anon_sym___thiscall] = ACTIONS(1177),
    [anon_sym___vectorcall] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym_signed] = ACTIONS(1177),
    [anon_sym_unsigned] = ACTIONS(1177),
    [anon_sym_long] = ACTIONS(1177),
    [anon_sym_short] = ACTIONS(1177),
    [anon_sym_static] = ACTIONS(1177),
    [anon_sym_auto] = ACTIONS(1177),
    [anon_sym_register] = ACTIONS(1177),
    [anon_sym_inline] = ACTIONS(1177),
    [anon_sym___inline] = ACTIONS(1177),
    [anon_sym___inline__] = ACTIONS(1177),
    [anon_sym___forceinline] = ACTIONS(1177),
    [anon_sym_thread_local] = ACTIONS(1177),
    [anon_sym___thread] = ACTIONS(1177),
    [anon_sym_const] = ACTIONS(1177),
    [anon_sym_constexpr] = ACTIONS(1177),
    [anon_sym_volatile] = ACTIONS(1177),
    [anon_sym_restrict] = ACTIONS(1177),
    [anon_sym___restrict__] = ACTIONS(1177),
    [anon_sym__Atomic] = ACTIONS(1177),
    [anon_sym__Noreturn] = ACTIONS(1177),
    [anon_sym_noreturn] = ACTIONS(1177),
    [anon_sym__Nonnull] = ACTIONS(1177),
    [anon_sym_alignas] = ACTIONS(1177),
    [anon_sym__Alignas] = ACTIONS(1177),
    [sym_primitive_type] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(1177),
    [anon_sym_struct] = ACTIONS(1177),
    [anon_sym_union] = ACTIONS(1177),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_switch] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_default] = ACTIONS(1177),
    [anon_sym_while] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1177),
    [anon_sym_return] = ACTIONS(1177),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1177),
    [anon_sym_goto] = ACTIONS(1177),
    [anon_sym___try] = ACTIONS(1177),
    [anon_sym___leave] = ACTIONS(1177),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_sizeof] = ACTIONS(1177),
    [anon_sym___alignof__] = ACTIONS(1177),
    [anon_sym___alignof] = ACTIONS(1177),
    [anon_sym__alignof] = ACTIONS(1177),
    [anon_sym_alignof] = ACTIONS(1177),
    [anon_sym__Alignof] = ACTIONS(1177),
    [anon_sym_offsetof] = ACTIONS(1177),
    [anon_sym__Generic] = ACTIONS(1177),
    [anon_sym_asm] = ACTIONS(1177),
    [anon_sym___asm__] = ACTIONS(1177),
    [anon_sym___asm] = ACTIONS(1177),
    [sym_number_literal] = ACTIONS(1179),
    [anon_sym_L_SQUOTE] = ACTIONS(1179),
    [anon_sym_u_SQUOTE] = ACTIONS(1179),
    [anon_sym_U_SQUOTE] = ACTIONS(1179),
    [anon_sym_u8_SQUOTE] = ACTIONS(1179),
    [anon_sym_SQUOTE] = ACTIONS(1179),
    [anon_sym_L_DQUOTE] = ACTIONS(1179),
    [anon_sym_u_DQUOTE] = ACTIONS(1179),
    [anon_sym_U_DQUOTE] = ACTIONS(1179),
    [anon_sym_u8_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1179),
    [sym_true] = ACTIONS(1177),
    [sym_false] = ACTIONS(1177),
    [anon_sym_NULL] = ACTIONS(1177),
    [anon_sym_nullptr] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_identifier] = ACTIONS(1181),
    [aux_sym_preproc_include_token1] = ACTIONS(1181),
    [aux_sym_preproc_def_token1] = ACTIONS(1181),
    [aux_sym_preproc_if_token1] = ACTIONS(1181),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1181),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1181),
    [sym_preproc_directive] = ACTIONS(1181),
    [anon_sym_LPAREN2] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym___extension__] = ACTIONS(1181),
    [anon_sym_typedef] = ACTIONS(1181),
    [anon_sym_extern] = ACTIONS(1181),
    [anon_sym___attribute__] = ACTIONS(1181),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1183),
    [anon_sym___declspec] = ACTIONS(1181),
    [anon_sym___cdecl] = ACTIONS(1181),
    [anon_sym___clrcall] = ACTIONS(1181),
    [anon_sym___stdcall] = ACTIONS(1181),
    [anon_sym___fastcall] = ACTIONS(1181),
    [anon_sym___thiscall] = ACTIONS(1181),
    [anon_sym___vectorcall] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1183),
    [anon_sym_RBRACE] = ACTIONS(1183),
    [anon_sym_signed] = ACTIONS(1181),
    [anon_sym_unsigned] = ACTIONS(1181),
    [anon_sym_long] = ACTIONS(1181),
    [anon_sym_short] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_auto] = ACTIONS(1181),
    [anon_sym_register] = ACTIONS(1181),
    [anon_sym_inline] = ACTIONS(1181),
    [anon_sym___inline] = ACTIONS(1181),
    [anon_sym___inline__] = ACTIONS(1181),
    [anon_sym___forceinline] = ACTIONS(1181),
    [anon_sym_thread_local] = ACTIONS(1181),
    [anon_sym___thread] = ACTIONS(1181),
    [anon_sym_const] = ACTIONS(1181),
    [anon_sym_constexpr] = ACTIONS(1181),
    [anon_sym_volatile] = ACTIONS(1181),
    [anon_sym_restrict] = ACTIONS(1181),
    [anon_sym___restrict__] = ACTIONS(1181),
    [anon_sym__Atomic] = ACTIONS(1181),
    [anon_sym__Noreturn] = ACTIONS(1181),
    [anon_sym_noreturn] = ACTIONS(1181),
    [anon_sym__Nonnull] = ACTIONS(1181),
    [anon_sym_alignas] = ACTIONS(1181),
    [anon_sym__Alignas] = ACTIONS(1181),
    [sym_primitive_type] = ACTIONS(1181),
    [anon_sym_enum] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1181),
    [anon_sym_switch] = ACTIONS(1181),
    [anon_sym_case] = ACTIONS(1181),
    [anon_sym_default] = ACTIONS(1181),
    [anon_sym_while] = ACTIONS(1181),
    [anon_sym_do] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1181),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_continue] = ACTIONS(1181),
    [anon_sym_goto] = ACTIONS(1181),
    [anon_sym___try] = ACTIONS(1181),
    [anon_sym___leave] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1183),
    [anon_sym_sizeof] = ACTIONS(1181),
    [anon_sym___alignof__] = ACTIONS(1181),
    [anon_sym___alignof] = ACTIONS(1181),
    [anon_sym__alignof] = ACTIONS(1181),
    [anon_sym_alignof] = ACTIONS(1181),
    [anon_sym__Alignof] = ACTIONS(1181),
    [anon_sym_offsetof] = ACTIONS(1181),
    [anon_sym__Generic] = ACTIONS(1181),
    [anon_sym_asm] = ACTIONS(1181),
    [anon_sym___asm__] = ACTIONS(1181),
    [anon_sym___asm] = ACTIONS(1181),
    [sym_number_literal] = ACTIONS(1183),
    [anon_sym_L_SQUOTE] = ACTIONS(1183),
    [anon_sym_u_SQUOTE] = ACTIONS(1183),
    [anon_sym_U_SQUOTE] = ACTIONS(1183),
    [anon_sym_u8_SQUOTE] = ACTIONS(1183),
    [anon_sym_SQUOTE] = ACTIONS(1183),
    [anon_sym_L_DQUOTE] = ACTIONS(1183),
    [anon_sym_u_DQUOTE] = ACTIONS(1183),
    [anon_sym_U_DQUOTE] = ACTIONS(1183),
    [anon_sym_u8_DQUOTE] = ACTIONS(1183),
    [anon_sym_DQUOTE] = ACTIONS(1183),
    [sym_true] = ACTIONS(1181),
    [sym_false] = ACTIONS(1181),
    [anon_sym_NULL] = ACTIONS(1181),
    [anon_sym_nullptr] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_identifier] = ACTIONS(1185),
    [aux_sym_preproc_include_token1] = ACTIONS(1185),
    [aux_sym_preproc_def_token1] = ACTIONS(1185),
    [aux_sym_preproc_if_token1] = ACTIONS(1185),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1185),
    [sym_preproc_directive] = ACTIONS(1185),
    [anon_sym_LPAREN2] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_TILDE] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1185),
    [anon_sym_PLUS] = ACTIONS(1185),
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym___extension__] = ACTIONS(1185),
    [anon_sym_typedef] = ACTIONS(1185),
    [anon_sym_extern] = ACTIONS(1185),
    [anon_sym___attribute__] = ACTIONS(1185),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1187),
    [anon_sym___declspec] = ACTIONS(1185),
    [anon_sym___cdecl] = ACTIONS(1185),
    [anon_sym___clrcall] = ACTIONS(1185),
    [anon_sym___stdcall] = ACTIONS(1185),
    [anon_sym___fastcall] = ACTIONS(1185),
    [anon_sym___thiscall] = ACTIONS(1185),
    [anon_sym___vectorcall] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_signed] = ACTIONS(1185),
    [anon_sym_unsigned] = ACTIONS(1185),
    [anon_sym_long] = ACTIONS(1185),
    [anon_sym_short] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1185),
    [anon_sym_auto] = ACTIONS(1185),
    [anon_sym_register] = ACTIONS(1185),
    [anon_sym_inline] = ACTIONS(1185),
    [anon_sym___inline] = ACTIONS(1185),
    [anon_sym___inline__] = ACTIONS(1185),
    [anon_sym___forceinline] = ACTIONS(1185),
    [anon_sym_thread_local] = ACTIONS(1185),
    [anon_sym___thread] = ACTIONS(1185),
    [anon_sym_const] = ACTIONS(1185),
    [anon_sym_constexpr] = ACTIONS(1185),
    [anon_sym_volatile] = ACTIONS(1185),
    [anon_sym_restrict] = ACTIONS(1185),
    [anon_sym___restrict__] = ACTIONS(1185),
    [anon_sym__Atomic] = ACTIONS(1185),
    [anon_sym__Noreturn] = ACTIONS(1185),
    [anon_sym_noreturn] = ACTIONS(1185),
    [anon_sym__Nonnull] = ACTIONS(1185),
    [anon_sym_alignas] = ACTIONS(1185),
    [anon_sym__Alignas] = ACTIONS(1185),
    [sym_primitive_type] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1185),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_union] = ACTIONS(1185),
    [anon_sym_if] = ACTIONS(1185),
    [anon_sym_else] = ACTIONS(1185),
    [anon_sym_switch] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1185),
    [anon_sym_default] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1185),
    [anon_sym_do] = ACTIONS(1185),
    [anon_sym_for] = ACTIONS(1185),
    [anon_sym_return] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1185),
    [anon_sym_continue] = ACTIONS(1185),
    [anon_sym_goto] = ACTIONS(1185),
    [anon_sym___try] = ACTIONS(1185),
    [anon_sym___leave] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1187),
    [anon_sym_sizeof] = ACTIONS(1185),
    [anon_sym___alignof__] = ACTIONS(1185),
    [anon_sym___alignof] = ACTIONS(1185),
    [anon_sym__alignof] = ACTIONS(1185),
    [anon_sym_alignof] = ACTIONS(1185),
    [anon_sym__Alignof] = ACTIONS(1185),
    [anon_sym_offsetof] = ACTIONS(1185),
    [anon_sym__Generic] = ACTIONS(1185),
    [anon_sym_asm] = ACTIONS(1185),
    [anon_sym___asm__] = ACTIONS(1185),
    [anon_sym___asm] = ACTIONS(1185),
    [sym_number_literal] = ACTIONS(1187),
    [anon_sym_L_SQUOTE] = ACTIONS(1187),
    [anon_sym_u_SQUOTE] = ACTIONS(1187),
    [anon_sym_U_SQUOTE] = ACTIONS(1187),
    [anon_sym_u8_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_L_DQUOTE] = ACTIONS(1187),
    [anon_sym_u_DQUOTE] = ACTIONS(1187),
    [anon_sym_U_DQUOTE] = ACTIONS(1187),
    [anon_sym_u8_DQUOTE] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [sym_true] = ACTIONS(1185),
    [sym_false] = ACTIONS(1185),
    [anon_sym_NULL] = ACTIONS(1185),
    [anon_sym_nullptr] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_identifier] = ACTIONS(1253),
    [aux_sym_preproc_include_token1] = ACTIONS(1253),
    [aux_sym_preproc_def_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1253),
    [sym_preproc_directive] = ACTIONS(1253),
    [anon_sym_LPAREN2] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym___extension__] = ACTIONS(1253),
    [anon_sym_typedef] = ACTIONS(1253),
    [anon_sym_extern] = ACTIONS(1253),
    [anon_sym___attribute__] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1255),
    [anon_sym___declspec] = ACTIONS(1253),
    [anon_sym___cdecl] = ACTIONS(1253),
    [anon_sym___clrcall] = ACTIONS(1253),
    [anon_sym___stdcall] = ACTIONS(1253),
    [anon_sym___fastcall] = ACTIONS(1253),
    [anon_sym___thiscall] = ACTIONS(1253),
    [anon_sym___vectorcall] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_signed] = ACTIONS(1253),
    [anon_sym_unsigned] = ACTIONS(1253),
    [anon_sym_long] = ACTIONS(1253),
    [anon_sym_short] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_auto] = ACTIONS(1253),
    [anon_sym_register] = ACTIONS(1253),
    [anon_sym_inline] = ACTIONS(1253),
    [anon_sym___inline] = ACTIONS(1253),
    [anon_sym___inline__] = ACTIONS(1253),
    [anon_sym___forceinline] = ACTIONS(1253),
    [anon_sym_thread_local] = ACTIONS(1253),
    [anon_sym___thread] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_constexpr] = ACTIONS(1253),
    [anon_sym_volatile] = ACTIONS(1253),
    [anon_sym_restrict] = ACTIONS(1253),
    [anon_sym___restrict__] = ACTIONS(1253),
    [anon_sym__Atomic] = ACTIONS(1253),
    [anon_sym__Noreturn] = ACTIONS(1253),
    [anon_sym_noreturn] = ACTIONS(1253),
    [anon_sym__Nonnull] = ACTIONS(1253),
    [anon_sym_alignas] = ACTIONS(1253),
    [anon_sym__Alignas] = ACTIONS(1253),
    [sym_primitive_type] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_union] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_goto] = ACTIONS(1253),
    [anon_sym___try] = ACTIONS(1253),
    [anon_sym___leave] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_sizeof] = ACTIONS(1253),
    [anon_sym___alignof__] = ACTIONS(1253),
    [anon_sym___alignof] = ACTIONS(1253),
    [anon_sym__alignof] = ACTIONS(1253),
    [anon_sym_alignof] = ACTIONS(1253),
    [anon_sym__Alignof] = ACTIONS(1253),
    [anon_sym_offsetof] = ACTIONS(1253),
    [anon_sym__Generic] = ACTIONS(1253),
    [anon_sym_asm] = ACTIONS(1253),
    [anon_sym___asm__] = ACTIONS(1253),
    [anon_sym___asm] = ACTIONS(1253),
    [sym_number_literal] = ACTIONS(1255),
    [anon_sym_L_SQUOTE] = ACTIONS(1255),
    [anon_sym_u_SQUOTE] = ACTIONS(1255),
    [anon_sym_U_SQUOTE] = ACTIONS(1255),
    [anon_sym_u8_SQUOTE] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_L_DQUOTE] = ACTIONS(1255),
    [anon_sym_u_DQUOTE] = ACTIONS(1255),
    [anon_sym_U_DQUOTE] = ACTIONS(1255),
    [anon_sym_u8_DQUOTE] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [anon_sym_NULL] = ACTIONS(1253),
    [anon_sym_nullptr] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_identifier] = ACTIONS(1161),
    [aux_sym_preproc_include_token1] = ACTIONS(1161),
    [aux_sym_preproc_def_token1] = ACTIONS(1161),
    [aux_sym_preproc_if_token1] = ACTIONS(1161),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1161),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1161),
    [sym_preproc_directive] = ACTIONS(1161),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym___extension__] = ACTIONS(1161),
    [anon_sym_typedef] = ACTIONS(1161),
    [anon_sym_extern] = ACTIONS(1161),
    [anon_sym___attribute__] = ACTIONS(1161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1163),
    [anon_sym___declspec] = ACTIONS(1161),
    [anon_sym___cdecl] = ACTIONS(1161),
    [anon_sym___clrcall] = ACTIONS(1161),
    [anon_sym___stdcall] = ACTIONS(1161),
    [anon_sym___fastcall] = ACTIONS(1161),
    [anon_sym___thiscall] = ACTIONS(1161),
    [anon_sym___vectorcall] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_signed] = ACTIONS(1161),
    [anon_sym_unsigned] = ACTIONS(1161),
    [anon_sym_long] = ACTIONS(1161),
    [anon_sym_short] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1161),
    [anon_sym_auto] = ACTIONS(1161),
    [anon_sym_register] = ACTIONS(1161),
    [anon_sym_inline] = ACTIONS(1161),
    [anon_sym___inline] = ACTIONS(1161),
    [anon_sym___inline__] = ACTIONS(1161),
    [anon_sym___forceinline] = ACTIONS(1161),
    [anon_sym_thread_local] = ACTIONS(1161),
    [anon_sym___thread] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_constexpr] = ACTIONS(1161),
    [anon_sym_volatile] = ACTIONS(1161),
    [anon_sym_restrict] = ACTIONS(1161),
    [anon_sym___restrict__] = ACTIONS(1161),
    [anon_sym__Atomic] = ACTIONS(1161),
    [anon_sym__Noreturn] = ACTIONS(1161),
    [anon_sym_noreturn] = ACTIONS(1161),
    [anon_sym__Nonnull] = ACTIONS(1161),
    [anon_sym_alignas] = ACTIONS(1161),
    [anon_sym__Alignas] = ACTIONS(1161),
    [sym_primitive_type] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [anon_sym_struct] = ACTIONS(1161),
    [anon_sym_union] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_else] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_case] = ACTIONS(1161),
    [anon_sym_default] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_do] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_goto] = ACTIONS(1161),
    [anon_sym___try] = ACTIONS(1161),
    [anon_sym___leave] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_sizeof] = ACTIONS(1161),
    [anon_sym___alignof__] = ACTIONS(1161),
    [anon_sym___alignof] = ACTIONS(1161),
    [anon_sym__alignof] = ACTIONS(1161),
    [anon_sym_alignof] = ACTIONS(1161),
    [anon_sym__Alignof] = ACTIONS(1161),
    [anon_sym_offsetof] = ACTIONS(1161),
    [anon_sym__Generic] = ACTIONS(1161),
    [anon_sym_asm] = ACTIONS(1161),
    [anon_sym___asm__] = ACTIONS(1161),
    [anon_sym___asm] = ACTIONS(1161),
    [sym_number_literal] = ACTIONS(1163),
    [anon_sym_L_SQUOTE] = ACTIONS(1163),
    [anon_sym_u_SQUOTE] = ACTIONS(1163),
    [anon_sym_U_SQUOTE] = ACTIONS(1163),
    [anon_sym_u8_SQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [anon_sym_L_DQUOTE] = ACTIONS(1163),
    [anon_sym_u_DQUOTE] = ACTIONS(1163),
    [anon_sym_U_DQUOTE] = ACTIONS(1163),
    [anon_sym_u8_DQUOTE] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [anon_sym_NULL] = ACTIONS(1161),
    [anon_sym_nullptr] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_identifier] = ACTIONS(1165),
    [aux_sym_preproc_include_token1] = ACTIONS(1165),
    [aux_sym_preproc_def_token1] = ACTIONS(1165),
    [aux_sym_preproc_if_token1] = ACTIONS(1165),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1165),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1165),
    [sym_preproc_directive] = ACTIONS(1165),
    [anon_sym_LPAREN2] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym___extension__] = ACTIONS(1165),
    [anon_sym_typedef] = ACTIONS(1165),
    [anon_sym_extern] = ACTIONS(1165),
    [anon_sym___attribute__] = ACTIONS(1165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1167),
    [anon_sym___declspec] = ACTIONS(1165),
    [anon_sym___cdecl] = ACTIONS(1165),
    [anon_sym___clrcall] = ACTIONS(1165),
    [anon_sym___stdcall] = ACTIONS(1165),
    [anon_sym___fastcall] = ACTIONS(1165),
    [anon_sym___thiscall] = ACTIONS(1165),
    [anon_sym___vectorcall] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_signed] = ACTIONS(1165),
    [anon_sym_unsigned] = ACTIONS(1165),
    [anon_sym_long] = ACTIONS(1165),
    [anon_sym_short] = ACTIONS(1165),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_auto] = ACTIONS(1165),
    [anon_sym_register] = ACTIONS(1165),
    [anon_sym_inline] = ACTIONS(1165),
    [anon_sym___inline] = ACTIONS(1165),
    [anon_sym___inline__] = ACTIONS(1165),
    [anon_sym___forceinline] = ACTIONS(1165),
    [anon_sym_thread_local] = ACTIONS(1165),
    [anon_sym___thread] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_constexpr] = ACTIONS(1165),
    [anon_sym_volatile] = ACTIONS(1165),
    [anon_sym_restrict] = ACTIONS(1165),
    [anon_sym___restrict__] = ACTIONS(1165),
    [anon_sym__Atomic] = ACTIONS(1165),
    [anon_sym__Noreturn] = ACTIONS(1165),
    [anon_sym_noreturn] = ACTIONS(1165),
    [anon_sym__Nonnull] = ACTIONS(1165),
    [anon_sym_alignas] = ACTIONS(1165),
    [anon_sym__Alignas] = ACTIONS(1165),
    [sym_primitive_type] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [anon_sym_struct] = ACTIONS(1165),
    [anon_sym_union] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_goto] = ACTIONS(1165),
    [anon_sym___try] = ACTIONS(1165),
    [anon_sym___leave] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_sizeof] = ACTIONS(1165),
    [anon_sym___alignof__] = ACTIONS(1165),
    [anon_sym___alignof] = ACTIONS(1165),
    [anon_sym__alignof] = ACTIONS(1165),
    [anon_sym_alignof] = ACTIONS(1165),
    [anon_sym__Alignof] = ACTIONS(1165),
    [anon_sym_offsetof] = ACTIONS(1165),
    [anon_sym__Generic] = ACTIONS(1165),
    [anon_sym_asm] = ACTIONS(1165),
    [anon_sym___asm__] = ACTIONS(1165),
    [anon_sym___asm] = ACTIONS(1165),
    [sym_number_literal] = ACTIONS(1167),
    [anon_sym_L_SQUOTE] = ACTIONS(1167),
    [anon_sym_u_SQUOTE] = ACTIONS(1167),
    [anon_sym_U_SQUOTE] = ACTIONS(1167),
    [anon_sym_u8_SQUOTE] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [anon_sym_L_DQUOTE] = ACTIONS(1167),
    [anon_sym_u_DQUOTE] = ACTIONS(1167),
    [anon_sym_U_DQUOTE] = ACTIONS(1167),
    [anon_sym_u8_DQUOTE] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [anon_sym_NULL] = ACTIONS(1165),
    [anon_sym_nullptr] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_identifier] = ACTIONS(1189),
    [aux_sym_preproc_include_token1] = ACTIONS(1189),
    [aux_sym_preproc_def_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1189),
    [sym_preproc_directive] = ACTIONS(1189),
    [anon_sym_LPAREN2] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym___extension__] = ACTIONS(1189),
    [anon_sym_typedef] = ACTIONS(1189),
    [anon_sym_extern] = ACTIONS(1189),
    [anon_sym___attribute__] = ACTIONS(1189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1191),
    [anon_sym___declspec] = ACTIONS(1189),
    [anon_sym___cdecl] = ACTIONS(1189),
    [anon_sym___clrcall] = ACTIONS(1189),
    [anon_sym___stdcall] = ACTIONS(1189),
    [anon_sym___fastcall] = ACTIONS(1189),
    [anon_sym___thiscall] = ACTIONS(1189),
    [anon_sym___vectorcall] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_RBRACE] = ACTIONS(1191),
    [anon_sym_signed] = ACTIONS(1189),
    [anon_sym_unsigned] = ACTIONS(1189),
    [anon_sym_long] = ACTIONS(1189),
    [anon_sym_short] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_auto] = ACTIONS(1189),
    [anon_sym_register] = ACTIONS(1189),
    [anon_sym_inline] = ACTIONS(1189),
    [anon_sym___inline] = ACTIONS(1189),
    [anon_sym___inline__] = ACTIONS(1189),
    [anon_sym___forceinline] = ACTIONS(1189),
    [anon_sym_thread_local] = ACTIONS(1189),
    [anon_sym___thread] = ACTIONS(1189),
    [anon_sym_const] = ACTIONS(1189),
    [anon_sym_constexpr] = ACTIONS(1189),
    [anon_sym_volatile] = ACTIONS(1189),
    [anon_sym_restrict] = ACTIONS(1189),
    [anon_sym___restrict__] = ACTIONS(1189),
    [anon_sym__Atomic] = ACTIONS(1189),
    [anon_sym__Noreturn] = ACTIONS(1189),
    [anon_sym_noreturn] = ACTIONS(1189),
    [anon_sym__Nonnull] = ACTIONS(1189),
    [anon_sym_alignas] = ACTIONS(1189),
    [anon_sym__Alignas] = ACTIONS(1189),
    [sym_primitive_type] = ACTIONS(1189),
    [anon_sym_enum] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1189),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_do] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [anon_sym_goto] = ACTIONS(1189),
    [anon_sym___try] = ACTIONS(1189),
    [anon_sym___leave] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_sizeof] = ACTIONS(1189),
    [anon_sym___alignof__] = ACTIONS(1189),
    [anon_sym___alignof] = ACTIONS(1189),
    [anon_sym__alignof] = ACTIONS(1189),
    [anon_sym_alignof] = ACTIONS(1189),
    [anon_sym__Alignof] = ACTIONS(1189),
    [anon_sym_offsetof] = ACTIONS(1189),
    [anon_sym__Generic] = ACTIONS(1189),
    [anon_sym_asm] = ACTIONS(1189),
    [anon_sym___asm__] = ACTIONS(1189),
    [anon_sym___asm] = ACTIONS(1189),
    [sym_number_literal] = ACTIONS(1191),
    [anon_sym_L_SQUOTE] = ACTIONS(1191),
    [anon_sym_u_SQUOTE] = ACTIONS(1191),
    [anon_sym_U_SQUOTE] = ACTIONS(1191),
    [anon_sym_u8_SQUOTE] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [anon_sym_L_DQUOTE] = ACTIONS(1191),
    [anon_sym_u_DQUOTE] = ACTIONS(1191),
    [anon_sym_U_DQUOTE] = ACTIONS(1191),
    [anon_sym_u8_DQUOTE] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [sym_true] = ACTIONS(1189),
    [sym_false] = ACTIONS(1189),
    [anon_sym_NULL] = ACTIONS(1189),
    [anon_sym_nullptr] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [sym_identifier] = ACTIONS(1189),
    [aux_sym_preproc_include_token1] = ACTIONS(1189),
    [aux_sym_preproc_def_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1189),
    [sym_preproc_directive] = ACTIONS(1189),
    [anon_sym_LPAREN2] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym___extension__] = ACTIONS(1189),
    [anon_sym_typedef] = ACTIONS(1189),
    [anon_sym_extern] = ACTIONS(1189),
    [anon_sym___attribute__] = ACTIONS(1189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1191),
    [anon_sym___declspec] = ACTIONS(1189),
    [anon_sym___cdecl] = ACTIONS(1189),
    [anon_sym___clrcall] = ACTIONS(1189),
    [anon_sym___stdcall] = ACTIONS(1189),
    [anon_sym___fastcall] = ACTIONS(1189),
    [anon_sym___thiscall] = ACTIONS(1189),
    [anon_sym___vectorcall] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_RBRACE] = ACTIONS(1191),
    [anon_sym_signed] = ACTIONS(1189),
    [anon_sym_unsigned] = ACTIONS(1189),
    [anon_sym_long] = ACTIONS(1189),
    [anon_sym_short] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_auto] = ACTIONS(1189),
    [anon_sym_register] = ACTIONS(1189),
    [anon_sym_inline] = ACTIONS(1189),
    [anon_sym___inline] = ACTIONS(1189),
    [anon_sym___inline__] = ACTIONS(1189),
    [anon_sym___forceinline] = ACTIONS(1189),
    [anon_sym_thread_local] = ACTIONS(1189),
    [anon_sym___thread] = ACTIONS(1189),
    [anon_sym_const] = ACTIONS(1189),
    [anon_sym_constexpr] = ACTIONS(1189),
    [anon_sym_volatile] = ACTIONS(1189),
    [anon_sym_restrict] = ACTIONS(1189),
    [anon_sym___restrict__] = ACTIONS(1189),
    [anon_sym__Atomic] = ACTIONS(1189),
    [anon_sym__Noreturn] = ACTIONS(1189),
    [anon_sym_noreturn] = ACTIONS(1189),
    [anon_sym__Nonnull] = ACTIONS(1189),
    [anon_sym_alignas] = ACTIONS(1189),
    [anon_sym__Alignas] = ACTIONS(1189),
    [sym_primitive_type] = ACTIONS(1189),
    [anon_sym_enum] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1189),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_do] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [anon_sym_goto] = ACTIONS(1189),
    [anon_sym___try] = ACTIONS(1189),
    [anon_sym___leave] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_sizeof] = ACTIONS(1189),
    [anon_sym___alignof__] = ACTIONS(1189),
    [anon_sym___alignof] = ACTIONS(1189),
    [anon_sym__alignof] = ACTIONS(1189),
    [anon_sym_alignof] = ACTIONS(1189),
    [anon_sym__Alignof] = ACTIONS(1189),
    [anon_sym_offsetof] = ACTIONS(1189),
    [anon_sym__Generic] = ACTIONS(1189),
    [anon_sym_asm] = ACTIONS(1189),
    [anon_sym___asm__] = ACTIONS(1189),
    [anon_sym___asm] = ACTIONS(1189),
    [sym_number_literal] = ACTIONS(1191),
    [anon_sym_L_SQUOTE] = ACTIONS(1191),
    [anon_sym_u_SQUOTE] = ACTIONS(1191),
    [anon_sym_U_SQUOTE] = ACTIONS(1191),
    [anon_sym_u8_SQUOTE] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [anon_sym_L_DQUOTE] = ACTIONS(1191),
    [anon_sym_u_DQUOTE] = ACTIONS(1191),
    [anon_sym_U_DQUOTE] = ACTIONS(1191),
    [anon_sym_u8_DQUOTE] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [sym_true] = ACTIONS(1189),
    [sym_false] = ACTIONS(1189),
    [anon_sym_NULL] = ACTIONS(1189),
    [anon_sym_nullptr] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_identifier] = ACTIONS(1193),
    [aux_sym_preproc_include_token1] = ACTIONS(1193),
    [aux_sym_preproc_def_token1] = ACTIONS(1193),
    [aux_sym_preproc_if_token1] = ACTIONS(1193),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1193),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1193),
    [sym_preproc_directive] = ACTIONS(1193),
    [anon_sym_LPAREN2] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1195),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym___extension__] = ACTIONS(1193),
    [anon_sym_typedef] = ACTIONS(1193),
    [anon_sym_extern] = ACTIONS(1193),
    [anon_sym___attribute__] = ACTIONS(1193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1195),
    [anon_sym___declspec] = ACTIONS(1193),
    [anon_sym___cdecl] = ACTIONS(1193),
    [anon_sym___clrcall] = ACTIONS(1193),
    [anon_sym___stdcall] = ACTIONS(1193),
    [anon_sym___fastcall] = ACTIONS(1193),
    [anon_sym___thiscall] = ACTIONS(1193),
    [anon_sym___vectorcall] = ACTIONS(1193),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_signed] = ACTIONS(1193),
    [anon_sym_unsigned] = ACTIONS(1193),
    [anon_sym_long] = ACTIONS(1193),
    [anon_sym_short] = ACTIONS(1193),
    [anon_sym_static] = ACTIONS(1193),
    [anon_sym_auto] = ACTIONS(1193),
    [anon_sym_register] = ACTIONS(1193),
    [anon_sym_inline] = ACTIONS(1193),
    [anon_sym___inline] = ACTIONS(1193),
    [anon_sym___inline__] = ACTIONS(1193),
    [anon_sym___forceinline] = ACTIONS(1193),
    [anon_sym_thread_local] = ACTIONS(1193),
    [anon_sym___thread] = ACTIONS(1193),
    [anon_sym_const] = ACTIONS(1193),
    [anon_sym_constexpr] = ACTIONS(1193),
    [anon_sym_volatile] = ACTIONS(1193),
    [anon_sym_restrict] = ACTIONS(1193),
    [anon_sym___restrict__] = ACTIONS(1193),
    [anon_sym__Atomic] = ACTIONS(1193),
    [anon_sym__Noreturn] = ACTIONS(1193),
    [anon_sym_noreturn] = ACTIONS(1193),
    [anon_sym__Nonnull] = ACTIONS(1193),
    [anon_sym_alignas] = ACTIONS(1193),
    [anon_sym__Alignas] = ACTIONS(1193),
    [sym_primitive_type] = ACTIONS(1193),
    [anon_sym_enum] = ACTIONS(1193),
    [anon_sym_struct] = ACTIONS(1193),
    [anon_sym_union] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_switch] = ACTIONS(1193),
    [anon_sym_case] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1193),
    [anon_sym_while] = ACTIONS(1193),
    [anon_sym_do] = ACTIONS(1193),
    [anon_sym_for] = ACTIONS(1193),
    [anon_sym_return] = ACTIONS(1193),
    [anon_sym_break] = ACTIONS(1193),
    [anon_sym_continue] = ACTIONS(1193),
    [anon_sym_goto] = ACTIONS(1193),
    [anon_sym___try] = ACTIONS(1193),
    [anon_sym___leave] = ACTIONS(1193),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_sizeof] = ACTIONS(1193),
    [anon_sym___alignof__] = ACTIONS(1193),
    [anon_sym___alignof] = ACTIONS(1193),
    [anon_sym__alignof] = ACTIONS(1193),
    [anon_sym_alignof] = ACTIONS(1193),
    [anon_sym__Alignof] = ACTIONS(1193),
    [anon_sym_offsetof] = ACTIONS(1193),
    [anon_sym__Generic] = ACTIONS(1193),
    [anon_sym_asm] = ACTIONS(1193),
    [anon_sym___asm__] = ACTIONS(1193),
    [anon_sym___asm] = ACTIONS(1193),
    [sym_number_literal] = ACTIONS(1195),
    [anon_sym_L_SQUOTE] = ACTIONS(1195),
    [anon_sym_u_SQUOTE] = ACTIONS(1195),
    [anon_sym_U_SQUOTE] = ACTIONS(1195),
    [anon_sym_u8_SQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [anon_sym_L_DQUOTE] = ACTIONS(1195),
    [anon_sym_u_DQUOTE] = ACTIONS(1195),
    [anon_sym_U_DQUOTE] = ACTIONS(1195),
    [anon_sym_u8_DQUOTE] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [sym_true] = ACTIONS(1193),
    [sym_false] = ACTIONS(1193),
    [anon_sym_NULL] = ACTIONS(1193),
    [anon_sym_nullptr] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1197),
    [aux_sym_preproc_include_token1] = ACTIONS(1197),
    [aux_sym_preproc_def_token1] = ACTIONS(1197),
    [aux_sym_preproc_if_token1] = ACTIONS(1197),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1197),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1197),
    [sym_preproc_directive] = ACTIONS(1197),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym___extension__] = ACTIONS(1197),
    [anon_sym_typedef] = ACTIONS(1197),
    [anon_sym_extern] = ACTIONS(1197),
    [anon_sym___attribute__] = ACTIONS(1197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1199),
    [anon_sym___declspec] = ACTIONS(1197),
    [anon_sym___cdecl] = ACTIONS(1197),
    [anon_sym___clrcall] = ACTIONS(1197),
    [anon_sym___stdcall] = ACTIONS(1197),
    [anon_sym___fastcall] = ACTIONS(1197),
    [anon_sym___thiscall] = ACTIONS(1197),
    [anon_sym___vectorcall] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_signed] = ACTIONS(1197),
    [anon_sym_unsigned] = ACTIONS(1197),
    [anon_sym_long] = ACTIONS(1197),
    [anon_sym_short] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_auto] = ACTIONS(1197),
    [anon_sym_register] = ACTIONS(1197),
    [anon_sym_inline] = ACTIONS(1197),
    [anon_sym___inline] = ACTIONS(1197),
    [anon_sym___inline__] = ACTIONS(1197),
    [anon_sym___forceinline] = ACTIONS(1197),
    [anon_sym_thread_local] = ACTIONS(1197),
    [anon_sym___thread] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_constexpr] = ACTIONS(1197),
    [anon_sym_volatile] = ACTIONS(1197),
    [anon_sym_restrict] = ACTIONS(1197),
    [anon_sym___restrict__] = ACTIONS(1197),
    [anon_sym__Atomic] = ACTIONS(1197),
    [anon_sym__Noreturn] = ACTIONS(1197),
    [anon_sym_noreturn] = ACTIONS(1197),
    [anon_sym__Nonnull] = ACTIONS(1197),
    [anon_sym_alignas] = ACTIONS(1197),
    [anon_sym__Alignas] = ACTIONS(1197),
    [sym_primitive_type] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [anon_sym_struct] = ACTIONS(1197),
    [anon_sym_union] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_goto] = ACTIONS(1197),
    [anon_sym___try] = ACTIONS(1197),
    [anon_sym___leave] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1197),
    [anon_sym___alignof__] = ACTIONS(1197),
    [anon_sym___alignof] = ACTIONS(1197),
    [anon_sym__alignof] = ACTIONS(1197),
    [anon_sym_alignof] = ACTIONS(1197),
    [anon_sym__Alignof] = ACTIONS(1197),
    [anon_sym_offsetof] = ACTIONS(1197),
    [anon_sym__Generic] = ACTIONS(1197),
    [anon_sym_asm] = ACTIONS(1197),
    [anon_sym___asm__] = ACTIONS(1197),
    [anon_sym___asm] = ACTIONS(1197),
    [sym_number_literal] = ACTIONS(1199),
    [anon_sym_L_SQUOTE] = ACTIONS(1199),
    [anon_sym_u_SQUOTE] = ACTIONS(1199),
    [anon_sym_U_SQUOTE] = ACTIONS(1199),
    [anon_sym_u8_SQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [anon_sym_L_DQUOTE] = ACTIONS(1199),
    [anon_sym_u_DQUOTE] = ACTIONS(1199),
    [anon_sym_U_DQUOTE] = ACTIONS(1199),
    [anon_sym_u8_DQUOTE] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [anon_sym_NULL] = ACTIONS(1197),
    [anon_sym_nullptr] = ACTIONS(1197),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_identifier] = ACTIONS(1129),
    [aux_sym_preproc_include_token1] = ACTIONS(1129),
    [aux_sym_preproc_def_token1] = ACTIONS(1129),
    [aux_sym_preproc_if_token1] = ACTIONS(1129),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1129),
    [sym_preproc_directive] = ACTIONS(1129),
    [anon_sym_LPAREN2] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym___extension__] = ACTIONS(1129),
    [anon_sym_typedef] = ACTIONS(1129),
    [anon_sym_extern] = ACTIONS(1129),
    [anon_sym___attribute__] = ACTIONS(1129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1131),
    [anon_sym___declspec] = ACTIONS(1129),
    [anon_sym___cdecl] = ACTIONS(1129),
    [anon_sym___clrcall] = ACTIONS(1129),
    [anon_sym___stdcall] = ACTIONS(1129),
    [anon_sym___fastcall] = ACTIONS(1129),
    [anon_sym___thiscall] = ACTIONS(1129),
    [anon_sym___vectorcall] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_signed] = ACTIONS(1129),
    [anon_sym_unsigned] = ACTIONS(1129),
    [anon_sym_long] = ACTIONS(1129),
    [anon_sym_short] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(1129),
    [anon_sym_auto] = ACTIONS(1129),
    [anon_sym_register] = ACTIONS(1129),
    [anon_sym_inline] = ACTIONS(1129),
    [anon_sym___inline] = ACTIONS(1129),
    [anon_sym___inline__] = ACTIONS(1129),
    [anon_sym___forceinline] = ACTIONS(1129),
    [anon_sym_thread_local] = ACTIONS(1129),
    [anon_sym___thread] = ACTIONS(1129),
    [anon_sym_const] = ACTIONS(1129),
    [anon_sym_constexpr] = ACTIONS(1129),
    [anon_sym_volatile] = ACTIONS(1129),
    [anon_sym_restrict] = ACTIONS(1129),
    [anon_sym___restrict__] = ACTIONS(1129),
    [anon_sym__Atomic] = ACTIONS(1129),
    [anon_sym__Noreturn] = ACTIONS(1129),
    [anon_sym_noreturn] = ACTIONS(1129),
    [anon_sym__Nonnull] = ACTIONS(1129),
    [anon_sym_alignas] = ACTIONS(1129),
    [anon_sym__Alignas] = ACTIONS(1129),
    [sym_primitive_type] = ACTIONS(1129),
    [anon_sym_enum] = ACTIONS(1129),
    [anon_sym_struct] = ACTIONS(1129),
    [anon_sym_union] = ACTIONS(1129),
    [anon_sym_if] = ACTIONS(1129),
    [anon_sym_else] = ACTIONS(1129),
    [anon_sym_switch] = ACTIONS(1129),
    [anon_sym_case] = ACTIONS(1129),
    [anon_sym_default] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1129),
    [anon_sym_for] = ACTIONS(1129),
    [anon_sym_return] = ACTIONS(1129),
    [anon_sym_break] = ACTIONS(1129),
    [anon_sym_continue] = ACTIONS(1129),
    [anon_sym_goto] = ACTIONS(1129),
    [anon_sym___try] = ACTIONS(1129),
    [anon_sym___leave] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_sizeof] = ACTIONS(1129),
    [anon_sym___alignof__] = ACTIONS(1129),
    [anon_sym___alignof] = ACTIONS(1129),
    [anon_sym__alignof] = ACTIONS(1129),
    [anon_sym_alignof] = ACTIONS(1129),
    [anon_sym__Alignof] = ACTIONS(1129),
    [anon_sym_offsetof] = ACTIONS(1129),
    [anon_sym__Generic] = ACTIONS(1129),
    [anon_sym_asm] = ACTIONS(1129),
    [anon_sym___asm__] = ACTIONS(1129),
    [anon_sym___asm] = ACTIONS(1129),
    [sym_number_literal] = ACTIONS(1131),
    [anon_sym_L_SQUOTE] = ACTIONS(1131),
    [anon_sym_u_SQUOTE] = ACTIONS(1131),
    [anon_sym_U_SQUOTE] = ACTIONS(1131),
    [anon_sym_u8_SQUOTE] = ACTIONS(1131),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [anon_sym_L_DQUOTE] = ACTIONS(1131),
    [anon_sym_u_DQUOTE] = ACTIONS(1131),
    [anon_sym_U_DQUOTE] = ACTIONS(1131),
    [anon_sym_u8_DQUOTE] = ACTIONS(1131),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_true] = ACTIONS(1129),
    [sym_false] = ACTIONS(1129),
    [anon_sym_NULL] = ACTIONS(1129),
    [anon_sym_nullptr] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_identifier] = ACTIONS(1133),
    [aux_sym_preproc_include_token1] = ACTIONS(1133),
    [aux_sym_preproc_def_token1] = ACTIONS(1133),
    [aux_sym_preproc_if_token1] = ACTIONS(1133),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1133),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1133),
    [sym_preproc_directive] = ACTIONS(1133),
    [anon_sym_LPAREN2] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym___extension__] = ACTIONS(1133),
    [anon_sym_typedef] = ACTIONS(1133),
    [anon_sym_extern] = ACTIONS(1133),
    [anon_sym___attribute__] = ACTIONS(1133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1135),
    [anon_sym___declspec] = ACTIONS(1133),
    [anon_sym___cdecl] = ACTIONS(1133),
    [anon_sym___clrcall] = ACTIONS(1133),
    [anon_sym___stdcall] = ACTIONS(1133),
    [anon_sym___fastcall] = ACTIONS(1133),
    [anon_sym___thiscall] = ACTIONS(1133),
    [anon_sym___vectorcall] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_signed] = ACTIONS(1133),
    [anon_sym_unsigned] = ACTIONS(1133),
    [anon_sym_long] = ACTIONS(1133),
    [anon_sym_short] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1133),
    [anon_sym_auto] = ACTIONS(1133),
    [anon_sym_register] = ACTIONS(1133),
    [anon_sym_inline] = ACTIONS(1133),
    [anon_sym___inline] = ACTIONS(1133),
    [anon_sym___inline__] = ACTIONS(1133),
    [anon_sym___forceinline] = ACTIONS(1133),
    [anon_sym_thread_local] = ACTIONS(1133),
    [anon_sym___thread] = ACTIONS(1133),
    [anon_sym_const] = ACTIONS(1133),
    [anon_sym_constexpr] = ACTIONS(1133),
    [anon_sym_volatile] = ACTIONS(1133),
    [anon_sym_restrict] = ACTIONS(1133),
    [anon_sym___restrict__] = ACTIONS(1133),
    [anon_sym__Atomic] = ACTIONS(1133),
    [anon_sym__Noreturn] = ACTIONS(1133),
    [anon_sym_noreturn] = ACTIONS(1133),
    [anon_sym__Nonnull] = ACTIONS(1133),
    [anon_sym_alignas] = ACTIONS(1133),
    [anon_sym__Alignas] = ACTIONS(1133),
    [sym_primitive_type] = ACTIONS(1133),
    [anon_sym_enum] = ACTIONS(1133),
    [anon_sym_struct] = ACTIONS(1133),
    [anon_sym_union] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_else] = ACTIONS(1133),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1133),
    [anon_sym_default] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_do] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1133),
    [anon_sym_break] = ACTIONS(1133),
    [anon_sym_continue] = ACTIONS(1133),
    [anon_sym_goto] = ACTIONS(1133),
    [anon_sym___try] = ACTIONS(1133),
    [anon_sym___leave] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_sizeof] = ACTIONS(1133),
    [anon_sym___alignof__] = ACTIONS(1133),
    [anon_sym___alignof] = ACTIONS(1133),
    [anon_sym__alignof] = ACTIONS(1133),
    [anon_sym_alignof] = ACTIONS(1133),
    [anon_sym__Alignof] = ACTIONS(1133),
    [anon_sym_offsetof] = ACTIONS(1133),
    [anon_sym__Generic] = ACTIONS(1133),
    [anon_sym_asm] = ACTIONS(1133),
    [anon_sym___asm__] = ACTIONS(1133),
    [anon_sym___asm] = ACTIONS(1133),
    [sym_number_literal] = ACTIONS(1135),
    [anon_sym_L_SQUOTE] = ACTIONS(1135),
    [anon_sym_u_SQUOTE] = ACTIONS(1135),
    [anon_sym_U_SQUOTE] = ACTIONS(1135),
    [anon_sym_u8_SQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_L_DQUOTE] = ACTIONS(1135),
    [anon_sym_u_DQUOTE] = ACTIONS(1135),
    [anon_sym_U_DQUOTE] = ACTIONS(1135),
    [anon_sym_u8_DQUOTE] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [sym_true] = ACTIONS(1133),
    [sym_false] = ACTIONS(1133),
    [anon_sym_NULL] = ACTIONS(1133),
    [anon_sym_nullptr] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1201),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1201),
    [sym_preproc_directive] = ACTIONS(1201),
    [anon_sym_LPAREN2] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym___extension__] = ACTIONS(1201),
    [anon_sym_typedef] = ACTIONS(1201),
    [anon_sym_extern] = ACTIONS(1201),
    [anon_sym___attribute__] = ACTIONS(1201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1203),
    [anon_sym___declspec] = ACTIONS(1201),
    [anon_sym___cdecl] = ACTIONS(1201),
    [anon_sym___clrcall] = ACTIONS(1201),
    [anon_sym___stdcall] = ACTIONS(1201),
    [anon_sym___fastcall] = ACTIONS(1201),
    [anon_sym___thiscall] = ACTIONS(1201),
    [anon_sym___vectorcall] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_RBRACE] = ACTIONS(1203),
    [anon_sym_signed] = ACTIONS(1201),
    [anon_sym_unsigned] = ACTIONS(1201),
    [anon_sym_long] = ACTIONS(1201),
    [anon_sym_short] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_auto] = ACTIONS(1201),
    [anon_sym_register] = ACTIONS(1201),
    [anon_sym_inline] = ACTIONS(1201),
    [anon_sym___inline] = ACTIONS(1201),
    [anon_sym___inline__] = ACTIONS(1201),
    [anon_sym___forceinline] = ACTIONS(1201),
    [anon_sym_thread_local] = ACTIONS(1201),
    [anon_sym___thread] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_constexpr] = ACTIONS(1201),
    [anon_sym_volatile] = ACTIONS(1201),
    [anon_sym_restrict] = ACTIONS(1201),
    [anon_sym___restrict__] = ACTIONS(1201),
    [anon_sym__Atomic] = ACTIONS(1201),
    [anon_sym__Noreturn] = ACTIONS(1201),
    [anon_sym_noreturn] = ACTIONS(1201),
    [anon_sym__Nonnull] = ACTIONS(1201),
    [anon_sym_alignas] = ACTIONS(1201),
    [anon_sym__Alignas] = ACTIONS(1201),
    [sym_primitive_type] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1201),
    [anon_sym_union] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_goto] = ACTIONS(1201),
    [anon_sym___try] = ACTIONS(1201),
    [anon_sym___leave] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1203),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym___alignof__] = ACTIONS(1201),
    [anon_sym___alignof] = ACTIONS(1201),
    [anon_sym__alignof] = ACTIONS(1201),
    [anon_sym_alignof] = ACTIONS(1201),
    [anon_sym__Alignof] = ACTIONS(1201),
    [anon_sym_offsetof] = ACTIONS(1201),
    [anon_sym__Generic] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1201),
    [anon_sym___asm__] = ACTIONS(1201),
    [anon_sym___asm] = ACTIONS(1201),
    [sym_number_literal] = ACTIONS(1203),
    [anon_sym_L_SQUOTE] = ACTIONS(1203),
    [anon_sym_u_SQUOTE] = ACTIONS(1203),
    [anon_sym_U_SQUOTE] = ACTIONS(1203),
    [anon_sym_u8_SQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [anon_sym_L_DQUOTE] = ACTIONS(1203),
    [anon_sym_u_DQUOTE] = ACTIONS(1203),
    [anon_sym_U_DQUOTE] = ACTIONS(1203),
    [anon_sym_u8_DQUOTE] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [anon_sym_NULL] = ACTIONS(1201),
    [anon_sym_nullptr] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1201),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1201),
    [sym_preproc_directive] = ACTIONS(1201),
    [anon_sym_LPAREN2] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym___extension__] = ACTIONS(1201),
    [anon_sym_typedef] = ACTIONS(1201),
    [anon_sym_extern] = ACTIONS(1201),
    [anon_sym___attribute__] = ACTIONS(1201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1203),
    [anon_sym___declspec] = ACTIONS(1201),
    [anon_sym___cdecl] = ACTIONS(1201),
    [anon_sym___clrcall] = ACTIONS(1201),
    [anon_sym___stdcall] = ACTIONS(1201),
    [anon_sym___fastcall] = ACTIONS(1201),
    [anon_sym___thiscall] = ACTIONS(1201),
    [anon_sym___vectorcall] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_RBRACE] = ACTIONS(1203),
    [anon_sym_signed] = ACTIONS(1201),
    [anon_sym_unsigned] = ACTIONS(1201),
    [anon_sym_long] = ACTIONS(1201),
    [anon_sym_short] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_auto] = ACTIONS(1201),
    [anon_sym_register] = ACTIONS(1201),
    [anon_sym_inline] = ACTIONS(1201),
    [anon_sym___inline] = ACTIONS(1201),
    [anon_sym___inline__] = ACTIONS(1201),
    [anon_sym___forceinline] = ACTIONS(1201),
    [anon_sym_thread_local] = ACTIONS(1201),
    [anon_sym___thread] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_constexpr] = ACTIONS(1201),
    [anon_sym_volatile] = ACTIONS(1201),
    [anon_sym_restrict] = ACTIONS(1201),
    [anon_sym___restrict__] = ACTIONS(1201),
    [anon_sym__Atomic] = ACTIONS(1201),
    [anon_sym__Noreturn] = ACTIONS(1201),
    [anon_sym_noreturn] = ACTIONS(1201),
    [anon_sym__Nonnull] = ACTIONS(1201),
    [anon_sym_alignas] = ACTIONS(1201),
    [anon_sym__Alignas] = ACTIONS(1201),
    [sym_primitive_type] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1201),
    [anon_sym_union] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_goto] = ACTIONS(1201),
    [anon_sym___try] = ACTIONS(1201),
    [anon_sym___leave] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1203),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym___alignof__] = ACTIONS(1201),
    [anon_sym___alignof] = ACTIONS(1201),
    [anon_sym__alignof] = ACTIONS(1201),
    [anon_sym_alignof] = ACTIONS(1201),
    [anon_sym__Alignof] = ACTIONS(1201),
    [anon_sym_offsetof] = ACTIONS(1201),
    [anon_sym__Generic] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1201),
    [anon_sym___asm__] = ACTIONS(1201),
    [anon_sym___asm] = ACTIONS(1201),
    [sym_number_literal] = ACTIONS(1203),
    [anon_sym_L_SQUOTE] = ACTIONS(1203),
    [anon_sym_u_SQUOTE] = ACTIONS(1203),
    [anon_sym_U_SQUOTE] = ACTIONS(1203),
    [anon_sym_u8_SQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [anon_sym_L_DQUOTE] = ACTIONS(1203),
    [anon_sym_u_DQUOTE] = ACTIONS(1203),
    [anon_sym_U_DQUOTE] = ACTIONS(1203),
    [anon_sym_u8_DQUOTE] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [anon_sym_NULL] = ACTIONS(1201),
    [anon_sym_nullptr] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1205),
    [aux_sym_preproc_def_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1205),
    [sym_preproc_directive] = ACTIONS(1205),
    [anon_sym_LPAREN2] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(1205),
    [anon_sym_typedef] = ACTIONS(1205),
    [anon_sym_extern] = ACTIONS(1205),
    [anon_sym___attribute__] = ACTIONS(1205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1207),
    [anon_sym___declspec] = ACTIONS(1205),
    [anon_sym___cdecl] = ACTIONS(1205),
    [anon_sym___clrcall] = ACTIONS(1205),
    [anon_sym___stdcall] = ACTIONS(1205),
    [anon_sym___fastcall] = ACTIONS(1205),
    [anon_sym___thiscall] = ACTIONS(1205),
    [anon_sym___vectorcall] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_RBRACE] = ACTIONS(1207),
    [anon_sym_signed] = ACTIONS(1205),
    [anon_sym_unsigned] = ACTIONS(1205),
    [anon_sym_long] = ACTIONS(1205),
    [anon_sym_short] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_auto] = ACTIONS(1205),
    [anon_sym_register] = ACTIONS(1205),
    [anon_sym_inline] = ACTIONS(1205),
    [anon_sym___inline] = ACTIONS(1205),
    [anon_sym___inline__] = ACTIONS(1205),
    [anon_sym___forceinline] = ACTIONS(1205),
    [anon_sym_thread_local] = ACTIONS(1205),
    [anon_sym___thread] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_constexpr] = ACTIONS(1205),
    [anon_sym_volatile] = ACTIONS(1205),
    [anon_sym_restrict] = ACTIONS(1205),
    [anon_sym___restrict__] = ACTIONS(1205),
    [anon_sym__Atomic] = ACTIONS(1205),
    [anon_sym__Noreturn] = ACTIONS(1205),
    [anon_sym_noreturn] = ACTIONS(1205),
    [anon_sym__Nonnull] = ACTIONS(1205),
    [anon_sym_alignas] = ACTIONS(1205),
    [anon_sym__Alignas] = ACTIONS(1205),
    [sym_primitive_type] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_do] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_goto] = ACTIONS(1205),
    [anon_sym___try] = ACTIONS(1205),
    [anon_sym___leave] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1207),
    [anon_sym_sizeof] = ACTIONS(1205),
    [anon_sym___alignof__] = ACTIONS(1205),
    [anon_sym___alignof] = ACTIONS(1205),
    [anon_sym__alignof] = ACTIONS(1205),
    [anon_sym_alignof] = ACTIONS(1205),
    [anon_sym__Alignof] = ACTIONS(1205),
    [anon_sym_offsetof] = ACTIONS(1205),
    [anon_sym__Generic] = ACTIONS(1205),
    [anon_sym_asm] = ACTIONS(1205),
    [anon_sym___asm__] = ACTIONS(1205),
    [anon_sym___asm] = ACTIONS(1205),
    [sym_number_literal] = ACTIONS(1207),
    [anon_sym_L_SQUOTE] = ACTIONS(1207),
    [anon_sym_u_SQUOTE] = ACTIONS(1207),
    [anon_sym_U_SQUOTE] = ACTIONS(1207),
    [anon_sym_u8_SQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [anon_sym_L_DQUOTE] = ACTIONS(1207),
    [anon_sym_u_DQUOTE] = ACTIONS(1207),
    [anon_sym_U_DQUOTE] = ACTIONS(1207),
    [anon_sym_u8_DQUOTE] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [anon_sym_NULL] = ACTIONS(1205),
    [anon_sym_nullptr] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1205),
    [aux_sym_preproc_def_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1205),
    [sym_preproc_directive] = ACTIONS(1205),
    [anon_sym_LPAREN2] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(1205),
    [anon_sym_typedef] = ACTIONS(1205),
    [anon_sym_extern] = ACTIONS(1205),
    [anon_sym___attribute__] = ACTIONS(1205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1207),
    [anon_sym___declspec] = ACTIONS(1205),
    [anon_sym___cdecl] = ACTIONS(1205),
    [anon_sym___clrcall] = ACTIONS(1205),
    [anon_sym___stdcall] = ACTIONS(1205),
    [anon_sym___fastcall] = ACTIONS(1205),
    [anon_sym___thiscall] = ACTIONS(1205),
    [anon_sym___vectorcall] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_RBRACE] = ACTIONS(1207),
    [anon_sym_signed] = ACTIONS(1205),
    [anon_sym_unsigned] = ACTIONS(1205),
    [anon_sym_long] = ACTIONS(1205),
    [anon_sym_short] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_auto] = ACTIONS(1205),
    [anon_sym_register] = ACTIONS(1205),
    [anon_sym_inline] = ACTIONS(1205),
    [anon_sym___inline] = ACTIONS(1205),
    [anon_sym___inline__] = ACTIONS(1205),
    [anon_sym___forceinline] = ACTIONS(1205),
    [anon_sym_thread_local] = ACTIONS(1205),
    [anon_sym___thread] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_constexpr] = ACTIONS(1205),
    [anon_sym_volatile] = ACTIONS(1205),
    [anon_sym_restrict] = ACTIONS(1205),
    [anon_sym___restrict__] = ACTIONS(1205),
    [anon_sym__Atomic] = ACTIONS(1205),
    [anon_sym__Noreturn] = ACTIONS(1205),
    [anon_sym_noreturn] = ACTIONS(1205),
    [anon_sym__Nonnull] = ACTIONS(1205),
    [anon_sym_alignas] = ACTIONS(1205),
    [anon_sym__Alignas] = ACTIONS(1205),
    [sym_primitive_type] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_do] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_goto] = ACTIONS(1205),
    [anon_sym___try] = ACTIONS(1205),
    [anon_sym___leave] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1207),
    [anon_sym_sizeof] = ACTIONS(1205),
    [anon_sym___alignof__] = ACTIONS(1205),
    [anon_sym___alignof] = ACTIONS(1205),
    [anon_sym__alignof] = ACTIONS(1205),
    [anon_sym_alignof] = ACTIONS(1205),
    [anon_sym__Alignof] = ACTIONS(1205),
    [anon_sym_offsetof] = ACTIONS(1205),
    [anon_sym__Generic] = ACTIONS(1205),
    [anon_sym_asm] = ACTIONS(1205),
    [anon_sym___asm__] = ACTIONS(1205),
    [anon_sym___asm] = ACTIONS(1205),
    [sym_number_literal] = ACTIONS(1207),
    [anon_sym_L_SQUOTE] = ACTIONS(1207),
    [anon_sym_u_SQUOTE] = ACTIONS(1207),
    [anon_sym_U_SQUOTE] = ACTIONS(1207),
    [anon_sym_u8_SQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [anon_sym_L_DQUOTE] = ACTIONS(1207),
    [anon_sym_u_DQUOTE] = ACTIONS(1207),
    [anon_sym_U_DQUOTE] = ACTIONS(1207),
    [anon_sym_u8_DQUOTE] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [anon_sym_NULL] = ACTIONS(1205),
    [anon_sym_nullptr] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_identifier] = ACTIONS(1209),
    [aux_sym_preproc_include_token1] = ACTIONS(1209),
    [aux_sym_preproc_def_token1] = ACTIONS(1209),
    [aux_sym_preproc_if_token1] = ACTIONS(1209),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1209),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1209),
    [sym_preproc_directive] = ACTIONS(1209),
    [anon_sym_LPAREN2] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1209),
    [anon_sym_PLUS] = ACTIONS(1209),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1209),
    [anon_sym_typedef] = ACTIONS(1209),
    [anon_sym_extern] = ACTIONS(1209),
    [anon_sym___attribute__] = ACTIONS(1209),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1211),
    [anon_sym___declspec] = ACTIONS(1209),
    [anon_sym___cdecl] = ACTIONS(1209),
    [anon_sym___clrcall] = ACTIONS(1209),
    [anon_sym___stdcall] = ACTIONS(1209),
    [anon_sym___fastcall] = ACTIONS(1209),
    [anon_sym___thiscall] = ACTIONS(1209),
    [anon_sym___vectorcall] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1211),
    [anon_sym_RBRACE] = ACTIONS(1211),
    [anon_sym_signed] = ACTIONS(1209),
    [anon_sym_unsigned] = ACTIONS(1209),
    [anon_sym_long] = ACTIONS(1209),
    [anon_sym_short] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1209),
    [anon_sym_auto] = ACTIONS(1209),
    [anon_sym_register] = ACTIONS(1209),
    [anon_sym_inline] = ACTIONS(1209),
    [anon_sym___inline] = ACTIONS(1209),
    [anon_sym___inline__] = ACTIONS(1209),
    [anon_sym___forceinline] = ACTIONS(1209),
    [anon_sym_thread_local] = ACTIONS(1209),
    [anon_sym___thread] = ACTIONS(1209),
    [anon_sym_const] = ACTIONS(1209),
    [anon_sym_constexpr] = ACTIONS(1209),
    [anon_sym_volatile] = ACTIONS(1209),
    [anon_sym_restrict] = ACTIONS(1209),
    [anon_sym___restrict__] = ACTIONS(1209),
    [anon_sym__Atomic] = ACTIONS(1209),
    [anon_sym__Noreturn] = ACTIONS(1209),
    [anon_sym_noreturn] = ACTIONS(1209),
    [anon_sym__Nonnull] = ACTIONS(1209),
    [anon_sym_alignas] = ACTIONS(1209),
    [anon_sym__Alignas] = ACTIONS(1209),
    [sym_primitive_type] = ACTIONS(1209),
    [anon_sym_enum] = ACTIONS(1209),
    [anon_sym_struct] = ACTIONS(1209),
    [anon_sym_union] = ACTIONS(1209),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_else] = ACTIONS(1209),
    [anon_sym_switch] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1209),
    [anon_sym_default] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(1209),
    [anon_sym_do] = ACTIONS(1209),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_return] = ACTIONS(1209),
    [anon_sym_break] = ACTIONS(1209),
    [anon_sym_continue] = ACTIONS(1209),
    [anon_sym_goto] = ACTIONS(1209),
    [anon_sym___try] = ACTIONS(1209),
    [anon_sym___leave] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_sizeof] = ACTIONS(1209),
    [anon_sym___alignof__] = ACTIONS(1209),
    [anon_sym___alignof] = ACTIONS(1209),
    [anon_sym__alignof] = ACTIONS(1209),
    [anon_sym_alignof] = ACTIONS(1209),
    [anon_sym__Alignof] = ACTIONS(1209),
    [anon_sym_offsetof] = ACTIONS(1209),
    [anon_sym__Generic] = ACTIONS(1209),
    [anon_sym_asm] = ACTIONS(1209),
    [anon_sym___asm__] = ACTIONS(1209),
    [anon_sym___asm] = ACTIONS(1209),
    [sym_number_literal] = ACTIONS(1211),
    [anon_sym_L_SQUOTE] = ACTIONS(1211),
    [anon_sym_u_SQUOTE] = ACTIONS(1211),
    [anon_sym_U_SQUOTE] = ACTIONS(1211),
    [anon_sym_u8_SQUOTE] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [anon_sym_L_DQUOTE] = ACTIONS(1211),
    [anon_sym_u_DQUOTE] = ACTIONS(1211),
    [anon_sym_U_DQUOTE] = ACTIONS(1211),
    [anon_sym_u8_DQUOTE] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(1211),
    [sym_true] = ACTIONS(1209),
    [sym_false] = ACTIONS(1209),
    [anon_sym_NULL] = ACTIONS(1209),
    [anon_sym_nullptr] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [ts_builtin_sym_end] = ACTIONS(1211),
    [sym_identifier] = ACTIONS(1209),
    [aux_sym_preproc_include_token1] = ACTIONS(1209),
    [aux_sym_preproc_def_token1] = ACTIONS(1209),
    [aux_sym_preproc_if_token1] = ACTIONS(1209),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1209),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1209),
    [sym_preproc_directive] = ACTIONS(1209),
    [anon_sym_LPAREN2] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1209),
    [anon_sym_PLUS] = ACTIONS(1209),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1209),
    [anon_sym_typedef] = ACTIONS(1209),
    [anon_sym_extern] = ACTIONS(1209),
    [anon_sym___attribute__] = ACTIONS(1209),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1211),
    [anon_sym___declspec] = ACTIONS(1209),
    [anon_sym___cdecl] = ACTIONS(1209),
    [anon_sym___clrcall] = ACTIONS(1209),
    [anon_sym___stdcall] = ACTIONS(1209),
    [anon_sym___fastcall] = ACTIONS(1209),
    [anon_sym___thiscall] = ACTIONS(1209),
    [anon_sym___vectorcall] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1211),
    [anon_sym_signed] = ACTIONS(1209),
    [anon_sym_unsigned] = ACTIONS(1209),
    [anon_sym_long] = ACTIONS(1209),
    [anon_sym_short] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1209),
    [anon_sym_auto] = ACTIONS(1209),
    [anon_sym_register] = ACTIONS(1209),
    [anon_sym_inline] = ACTIONS(1209),
    [anon_sym___inline] = ACTIONS(1209),
    [anon_sym___inline__] = ACTIONS(1209),
    [anon_sym___forceinline] = ACTIONS(1209),
    [anon_sym_thread_local] = ACTIONS(1209),
    [anon_sym___thread] = ACTIONS(1209),
    [anon_sym_const] = ACTIONS(1209),
    [anon_sym_constexpr] = ACTIONS(1209),
    [anon_sym_volatile] = ACTIONS(1209),
    [anon_sym_restrict] = ACTIONS(1209),
    [anon_sym___restrict__] = ACTIONS(1209),
    [anon_sym__Atomic] = ACTIONS(1209),
    [anon_sym__Noreturn] = ACTIONS(1209),
    [anon_sym_noreturn] = ACTIONS(1209),
    [anon_sym__Nonnull] = ACTIONS(1209),
    [anon_sym_alignas] = ACTIONS(1209),
    [anon_sym__Alignas] = ACTIONS(1209),
    [sym_primitive_type] = ACTIONS(1209),
    [anon_sym_enum] = ACTIONS(1209),
    [anon_sym_struct] = ACTIONS(1209),
    [anon_sym_union] = ACTIONS(1209),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_else] = ACTIONS(1209),
    [anon_sym_switch] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1209),
    [anon_sym_default] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(1209),
    [anon_sym_do] = ACTIONS(1209),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_return] = ACTIONS(1209),
    [anon_sym_break] = ACTIONS(1209),
    [anon_sym_continue] = ACTIONS(1209),
    [anon_sym_goto] = ACTIONS(1209),
    [anon_sym___try] = ACTIONS(1209),
    [anon_sym___leave] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_sizeof] = ACTIONS(1209),
    [anon_sym___alignof__] = ACTIONS(1209),
    [anon_sym___alignof] = ACTIONS(1209),
    [anon_sym__alignof] = ACTIONS(1209),
    [anon_sym_alignof] = ACTIONS(1209),
    [anon_sym__Alignof] = ACTIONS(1209),
    [anon_sym_offsetof] = ACTIONS(1209),
    [anon_sym__Generic] = ACTIONS(1209),
    [anon_sym_asm] = ACTIONS(1209),
    [anon_sym___asm__] = ACTIONS(1209),
    [anon_sym___asm] = ACTIONS(1209),
    [sym_number_literal] = ACTIONS(1211),
    [anon_sym_L_SQUOTE] = ACTIONS(1211),
    [anon_sym_u_SQUOTE] = ACTIONS(1211),
    [anon_sym_U_SQUOTE] = ACTIONS(1211),
    [anon_sym_u8_SQUOTE] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [anon_sym_L_DQUOTE] = ACTIONS(1211),
    [anon_sym_u_DQUOTE] = ACTIONS(1211),
    [anon_sym_U_DQUOTE] = ACTIONS(1211),
    [anon_sym_u8_DQUOTE] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(1211),
    [sym_true] = ACTIONS(1209),
    [sym_false] = ACTIONS(1209),
    [anon_sym_NULL] = ACTIONS(1209),
    [anon_sym_nullptr] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [sym_identifier] = ACTIONS(1133),
    [aux_sym_preproc_include_token1] = ACTIONS(1133),
    [aux_sym_preproc_def_token1] = ACTIONS(1133),
    [aux_sym_preproc_if_token1] = ACTIONS(1133),
    [aux_sym_preproc_if_token2] = ACTIONS(1133),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1133),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1133),
    [sym_preproc_directive] = ACTIONS(1133),
    [anon_sym_LPAREN2] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym___extension__] = ACTIONS(1133),
    [anon_sym_typedef] = ACTIONS(1133),
    [anon_sym_extern] = ACTIONS(1133),
    [anon_sym___attribute__] = ACTIONS(1133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1135),
    [anon_sym___declspec] = ACTIONS(1133),
    [anon_sym___cdecl] = ACTIONS(1133),
    [anon_sym___clrcall] = ACTIONS(1133),
    [anon_sym___stdcall] = ACTIONS(1133),
    [anon_sym___fastcall] = ACTIONS(1133),
    [anon_sym___thiscall] = ACTIONS(1133),
    [anon_sym___vectorcall] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_signed] = ACTIONS(1133),
    [anon_sym_unsigned] = ACTIONS(1133),
    [anon_sym_long] = ACTIONS(1133),
    [anon_sym_short] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1133),
    [anon_sym_auto] = ACTIONS(1133),
    [anon_sym_register] = ACTIONS(1133),
    [anon_sym_inline] = ACTIONS(1133),
    [anon_sym___inline] = ACTIONS(1133),
    [anon_sym___inline__] = ACTIONS(1133),
    [anon_sym___forceinline] = ACTIONS(1133),
    [anon_sym_thread_local] = ACTIONS(1133),
    [anon_sym___thread] = ACTIONS(1133),
    [anon_sym_const] = ACTIONS(1133),
    [anon_sym_constexpr] = ACTIONS(1133),
    [anon_sym_volatile] = ACTIONS(1133),
    [anon_sym_restrict] = ACTIONS(1133),
    [anon_sym___restrict__] = ACTIONS(1133),
    [anon_sym__Atomic] = ACTIONS(1133),
    [anon_sym__Noreturn] = ACTIONS(1133),
    [anon_sym_noreturn] = ACTIONS(1133),
    [anon_sym__Nonnull] = ACTIONS(1133),
    [anon_sym_alignas] = ACTIONS(1133),
    [anon_sym__Alignas] = ACTIONS(1133),
    [sym_primitive_type] = ACTIONS(1133),
    [anon_sym_enum] = ACTIONS(1133),
    [anon_sym_struct] = ACTIONS(1133),
    [anon_sym_union] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_else] = ACTIONS(1133),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1133),
    [anon_sym_default] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_do] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1133),
    [anon_sym_break] = ACTIONS(1133),
    [anon_sym_continue] = ACTIONS(1133),
    [anon_sym_goto] = ACTIONS(1133),
    [anon_sym___try] = ACTIONS(1133),
    [anon_sym___leave] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_sizeof] = ACTIONS(1133),
    [anon_sym___alignof__] = ACTIONS(1133),
    [anon_sym___alignof] = ACTIONS(1133),
    [anon_sym__alignof] = ACTIONS(1133),
    [anon_sym_alignof] = ACTIONS(1133),
    [anon_sym__Alignof] = ACTIONS(1133),
    [anon_sym_offsetof] = ACTIONS(1133),
    [anon_sym__Generic] = ACTIONS(1133),
    [anon_sym_asm] = ACTIONS(1133),
    [anon_sym___asm__] = ACTIONS(1133),
    [anon_sym___asm] = ACTIONS(1133),
    [sym_number_literal] = ACTIONS(1135),
    [anon_sym_L_SQUOTE] = ACTIONS(1135),
    [anon_sym_u_SQUOTE] = ACTIONS(1135),
    [anon_sym_U_SQUOTE] = ACTIONS(1135),
    [anon_sym_u8_SQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [anon_sym_L_DQUOTE] = ACTIONS(1135),
    [anon_sym_u_DQUOTE] = ACTIONS(1135),
    [anon_sym_U_DQUOTE] = ACTIONS(1135),
    [anon_sym_u8_DQUOTE] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [sym_true] = ACTIONS(1133),
    [sym_false] = ACTIONS(1133),
    [anon_sym_NULL] = ACTIONS(1133),
    [anon_sym_nullptr] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym_identifier] = ACTIONS(1137),
    [aux_sym_preproc_include_token1] = ACTIONS(1137),
    [aux_sym_preproc_def_token1] = ACTIONS(1137),
    [aux_sym_preproc_if_token1] = ACTIONS(1137),
    [aux_sym_preproc_if_token2] = ACTIONS(1137),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1137),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1137),
    [sym_preproc_directive] = ACTIONS(1137),
    [anon_sym_LPAREN2] = ACTIONS(1139),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym___extension__] = ACTIONS(1137),
    [anon_sym_typedef] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(1137),
    [anon_sym___attribute__] = ACTIONS(1137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1139),
    [anon_sym___declspec] = ACTIONS(1137),
    [anon_sym___cdecl] = ACTIONS(1137),
    [anon_sym___clrcall] = ACTIONS(1137),
    [anon_sym___stdcall] = ACTIONS(1137),
    [anon_sym___fastcall] = ACTIONS(1137),
    [anon_sym___thiscall] = ACTIONS(1137),
    [anon_sym___vectorcall] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_signed] = ACTIONS(1137),
    [anon_sym_unsigned] = ACTIONS(1137),
    [anon_sym_long] = ACTIONS(1137),
    [anon_sym_short] = ACTIONS(1137),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_auto] = ACTIONS(1137),
    [anon_sym_register] = ACTIONS(1137),
    [anon_sym_inline] = ACTIONS(1137),
    [anon_sym___inline] = ACTIONS(1137),
    [anon_sym___inline__] = ACTIONS(1137),
    [anon_sym___forceinline] = ACTIONS(1137),
    [anon_sym_thread_local] = ACTIONS(1137),
    [anon_sym___thread] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_constexpr] = ACTIONS(1137),
    [anon_sym_volatile] = ACTIONS(1137),
    [anon_sym_restrict] = ACTIONS(1137),
    [anon_sym___restrict__] = ACTIONS(1137),
    [anon_sym__Atomic] = ACTIONS(1137),
    [anon_sym__Noreturn] = ACTIONS(1137),
    [anon_sym_noreturn] = ACTIONS(1137),
    [anon_sym__Nonnull] = ACTIONS(1137),
    [anon_sym_alignas] = ACTIONS(1137),
    [anon_sym__Alignas] = ACTIONS(1137),
    [sym_primitive_type] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [anon_sym_struct] = ACTIONS(1137),
    [anon_sym_union] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_goto] = ACTIONS(1137),
    [anon_sym___try] = ACTIONS(1137),
    [anon_sym___leave] = ACTIONS(1137),
    [anon_sym_DASH_DASH] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(1139),
    [anon_sym_sizeof] = ACTIONS(1137),
    [anon_sym___alignof__] = ACTIONS(1137),
    [anon_sym___alignof] = ACTIONS(1137),
    [anon_sym__alignof] = ACTIONS(1137),
    [anon_sym_alignof] = ACTIONS(1137),
    [anon_sym__Alignof] = ACTIONS(1137),
    [anon_sym_offsetof] = ACTIONS(1137),
    [anon_sym__Generic] = ACTIONS(1137),
    [anon_sym_asm] = ACTIONS(1137),
    [anon_sym___asm__] = ACTIONS(1137),
    [anon_sym___asm] = ACTIONS(1137),
    [sym_number_literal] = ACTIONS(1139),
    [anon_sym_L_SQUOTE] = ACTIONS(1139),
    [anon_sym_u_SQUOTE] = ACTIONS(1139),
    [anon_sym_U_SQUOTE] = ACTIONS(1139),
    [anon_sym_u8_SQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [anon_sym_L_DQUOTE] = ACTIONS(1139),
    [anon_sym_u_DQUOTE] = ACTIONS(1139),
    [anon_sym_U_DQUOTE] = ACTIONS(1139),
    [anon_sym_u8_DQUOTE] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [anon_sym_NULL] = ACTIONS(1137),
    [anon_sym_nullptr] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_identifier] = ACTIONS(1141),
    [aux_sym_preproc_include_token1] = ACTIONS(1141),
    [aux_sym_preproc_def_token1] = ACTIONS(1141),
    [aux_sym_preproc_if_token1] = ACTIONS(1141),
    [aux_sym_preproc_if_token2] = ACTIONS(1141),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1141),
    [sym_preproc_directive] = ACTIONS(1141),
    [anon_sym_LPAREN2] = ACTIONS(1143),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1143),
    [anon_sym___extension__] = ACTIONS(1141),
    [anon_sym_typedef] = ACTIONS(1141),
    [anon_sym_extern] = ACTIONS(1141),
    [anon_sym___attribute__] = ACTIONS(1141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1143),
    [anon_sym___declspec] = ACTIONS(1141),
    [anon_sym___cdecl] = ACTIONS(1141),
    [anon_sym___clrcall] = ACTIONS(1141),
    [anon_sym___stdcall] = ACTIONS(1141),
    [anon_sym___fastcall] = ACTIONS(1141),
    [anon_sym___thiscall] = ACTIONS(1141),
    [anon_sym___vectorcall] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1143),
    [anon_sym_signed] = ACTIONS(1141),
    [anon_sym_unsigned] = ACTIONS(1141),
    [anon_sym_long] = ACTIONS(1141),
    [anon_sym_short] = ACTIONS(1141),
    [anon_sym_static] = ACTIONS(1141),
    [anon_sym_auto] = ACTIONS(1141),
    [anon_sym_register] = ACTIONS(1141),
    [anon_sym_inline] = ACTIONS(1141),
    [anon_sym___inline] = ACTIONS(1141),
    [anon_sym___inline__] = ACTIONS(1141),
    [anon_sym___forceinline] = ACTIONS(1141),
    [anon_sym_thread_local] = ACTIONS(1141),
    [anon_sym___thread] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_constexpr] = ACTIONS(1141),
    [anon_sym_volatile] = ACTIONS(1141),
    [anon_sym_restrict] = ACTIONS(1141),
    [anon_sym___restrict__] = ACTIONS(1141),
    [anon_sym__Atomic] = ACTIONS(1141),
    [anon_sym__Noreturn] = ACTIONS(1141),
    [anon_sym_noreturn] = ACTIONS(1141),
    [anon_sym__Nonnull] = ACTIONS(1141),
    [anon_sym_alignas] = ACTIONS(1141),
    [anon_sym__Alignas] = ACTIONS(1141),
    [sym_primitive_type] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [anon_sym_struct] = ACTIONS(1141),
    [anon_sym_union] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_else] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_case] = ACTIONS(1141),
    [anon_sym_default] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_do] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_goto] = ACTIONS(1141),
    [anon_sym___try] = ACTIONS(1141),
    [anon_sym___leave] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_sizeof] = ACTIONS(1141),
    [anon_sym___alignof__] = ACTIONS(1141),
    [anon_sym___alignof] = ACTIONS(1141),
    [anon_sym__alignof] = ACTIONS(1141),
    [anon_sym_alignof] = ACTIONS(1141),
    [anon_sym__Alignof] = ACTIONS(1141),
    [anon_sym_offsetof] = ACTIONS(1141),
    [anon_sym__Generic] = ACTIONS(1141),
    [anon_sym_asm] = ACTIONS(1141),
    [anon_sym___asm__] = ACTIONS(1141),
    [anon_sym___asm] = ACTIONS(1141),
    [sym_number_literal] = ACTIONS(1143),
    [anon_sym_L_SQUOTE] = ACTIONS(1143),
    [anon_sym_u_SQUOTE] = ACTIONS(1143),
    [anon_sym_U_SQUOTE] = ACTIONS(1143),
    [anon_sym_u8_SQUOTE] = ACTIONS(1143),
    [anon_sym_SQUOTE] = ACTIONS(1143),
    [anon_sym_L_DQUOTE] = ACTIONS(1143),
    [anon_sym_u_DQUOTE] = ACTIONS(1143),
    [anon_sym_U_DQUOTE] = ACTIONS(1143),
    [anon_sym_u8_DQUOTE] = ACTIONS(1143),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [sym_true] = ACTIONS(1141),
    [sym_false] = ACTIONS(1141),
    [anon_sym_NULL] = ACTIONS(1141),
    [anon_sym_nullptr] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_identifier] = ACTIONS(1145),
    [aux_sym_preproc_include_token1] = ACTIONS(1145),
    [aux_sym_preproc_def_token1] = ACTIONS(1145),
    [aux_sym_preproc_if_token1] = ACTIONS(1145),
    [aux_sym_preproc_if_token2] = ACTIONS(1145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1145),
    [sym_preproc_directive] = ACTIONS(1145),
    [anon_sym_LPAREN2] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym___extension__] = ACTIONS(1145),
    [anon_sym_typedef] = ACTIONS(1145),
    [anon_sym_extern] = ACTIONS(1145),
    [anon_sym___attribute__] = ACTIONS(1145),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1147),
    [anon_sym___declspec] = ACTIONS(1145),
    [anon_sym___cdecl] = ACTIONS(1145),
    [anon_sym___clrcall] = ACTIONS(1145),
    [anon_sym___stdcall] = ACTIONS(1145),
    [anon_sym___fastcall] = ACTIONS(1145),
    [anon_sym___thiscall] = ACTIONS(1145),
    [anon_sym___vectorcall] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [anon_sym_signed] = ACTIONS(1145),
    [anon_sym_unsigned] = ACTIONS(1145),
    [anon_sym_long] = ACTIONS(1145),
    [anon_sym_short] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1145),
    [anon_sym_auto] = ACTIONS(1145),
    [anon_sym_register] = ACTIONS(1145),
    [anon_sym_inline] = ACTIONS(1145),
    [anon_sym___inline] = ACTIONS(1145),
    [anon_sym___inline__] = ACTIONS(1145),
    [anon_sym___forceinline] = ACTIONS(1145),
    [anon_sym_thread_local] = ACTIONS(1145),
    [anon_sym___thread] = ACTIONS(1145),
    [anon_sym_const] = ACTIONS(1145),
    [anon_sym_constexpr] = ACTIONS(1145),
    [anon_sym_volatile] = ACTIONS(1145),
    [anon_sym_restrict] = ACTIONS(1145),
    [anon_sym___restrict__] = ACTIONS(1145),
    [anon_sym__Atomic] = ACTIONS(1145),
    [anon_sym__Noreturn] = ACTIONS(1145),
    [anon_sym_noreturn] = ACTIONS(1145),
    [anon_sym__Nonnull] = ACTIONS(1145),
    [anon_sym_alignas] = ACTIONS(1145),
    [anon_sym__Alignas] = ACTIONS(1145),
    [sym_primitive_type] = ACTIONS(1145),
    [anon_sym_enum] = ACTIONS(1145),
    [anon_sym_struct] = ACTIONS(1145),
    [anon_sym_union] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_else] = ACTIONS(1145),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1145),
    [anon_sym_default] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_do] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1145),
    [anon_sym_break] = ACTIONS(1145),
    [anon_sym_continue] = ACTIONS(1145),
    [anon_sym_goto] = ACTIONS(1145),
    [anon_sym___try] = ACTIONS(1145),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1145),
    [anon_sym___alignof__] = ACTIONS(1145),
    [anon_sym___alignof] = ACTIONS(1145),
    [anon_sym__alignof] = ACTIONS(1145),
    [anon_sym_alignof] = ACTIONS(1145),
    [anon_sym__Alignof] = ACTIONS(1145),
    [anon_sym_offsetof] = ACTIONS(1145),
    [anon_sym__Generic] = ACTIONS(1145),
    [anon_sym_asm] = ACTIONS(1145),
    [anon_sym___asm__] = ACTIONS(1145),
    [anon_sym___asm] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1147),
    [anon_sym_L_SQUOTE] = ACTIONS(1147),
    [anon_sym_u_SQUOTE] = ACTIONS(1147),
    [anon_sym_U_SQUOTE] = ACTIONS(1147),
    [anon_sym_u8_SQUOTE] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_L_DQUOTE] = ACTIONS(1147),
    [anon_sym_u_DQUOTE] = ACTIONS(1147),
    [anon_sym_U_DQUOTE] = ACTIONS(1147),
    [anon_sym_u8_DQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [anon_sym_NULL] = ACTIONS(1145),
    [anon_sym_nullptr] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_identifier] = ACTIONS(1149),
    [aux_sym_preproc_include_token1] = ACTIONS(1149),
    [aux_sym_preproc_def_token1] = ACTIONS(1149),
    [aux_sym_preproc_if_token1] = ACTIONS(1149),
    [aux_sym_preproc_if_token2] = ACTIONS(1149),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1149),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1149),
    [sym_preproc_directive] = ACTIONS(1149),
    [anon_sym_LPAREN2] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym___extension__] = ACTIONS(1149),
    [anon_sym_typedef] = ACTIONS(1149),
    [anon_sym_extern] = ACTIONS(1149),
    [anon_sym___attribute__] = ACTIONS(1149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1151),
    [anon_sym___declspec] = ACTIONS(1149),
    [anon_sym___cdecl] = ACTIONS(1149),
    [anon_sym___clrcall] = ACTIONS(1149),
    [anon_sym___stdcall] = ACTIONS(1149),
    [anon_sym___fastcall] = ACTIONS(1149),
    [anon_sym___thiscall] = ACTIONS(1149),
    [anon_sym___vectorcall] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_signed] = ACTIONS(1149),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1149),
    [anon_sym_auto] = ACTIONS(1149),
    [anon_sym_register] = ACTIONS(1149),
    [anon_sym_inline] = ACTIONS(1149),
    [anon_sym___inline] = ACTIONS(1149),
    [anon_sym___inline__] = ACTIONS(1149),
    [anon_sym___forceinline] = ACTIONS(1149),
    [anon_sym_thread_local] = ACTIONS(1149),
    [anon_sym___thread] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_constexpr] = ACTIONS(1149),
    [anon_sym_volatile] = ACTIONS(1149),
    [anon_sym_restrict] = ACTIONS(1149),
    [anon_sym___restrict__] = ACTIONS(1149),
    [anon_sym__Atomic] = ACTIONS(1149),
    [anon_sym__Noreturn] = ACTIONS(1149),
    [anon_sym_noreturn] = ACTIONS(1149),
    [anon_sym__Nonnull] = ACTIONS(1149),
    [anon_sym_alignas] = ACTIONS(1149),
    [anon_sym__Alignas] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(1149),
    [anon_sym_enum] = ACTIONS(1149),
    [anon_sym_struct] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_else] = ACTIONS(1149),
    [anon_sym_switch] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1149),
    [anon_sym_default] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_do] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_goto] = ACTIONS(1149),
    [anon_sym___try] = ACTIONS(1149),
    [anon_sym___leave] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_sizeof] = ACTIONS(1149),
    [anon_sym___alignof__] = ACTIONS(1149),
    [anon_sym___alignof] = ACTIONS(1149),
    [anon_sym__alignof] = ACTIONS(1149),
    [anon_sym_alignof] = ACTIONS(1149),
    [anon_sym__Alignof] = ACTIONS(1149),
    [anon_sym_offsetof] = ACTIONS(1149),
    [anon_sym__Generic] = ACTIONS(1149),
    [anon_sym_asm] = ACTIONS(1149),
    [anon_sym___asm__] = ACTIONS(1149),
    [anon_sym___asm] = ACTIONS(1149),
    [sym_number_literal] = ACTIONS(1151),
    [anon_sym_L_SQUOTE] = ACTIONS(1151),
    [anon_sym_u_SQUOTE] = ACTIONS(1151),
    [anon_sym_U_SQUOTE] = ACTIONS(1151),
    [anon_sym_u8_SQUOTE] = ACTIONS(1151),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_L_DQUOTE] = ACTIONS(1151),
    [anon_sym_u_DQUOTE] = ACTIONS(1151),
    [anon_sym_U_DQUOTE] = ACTIONS(1151),
    [anon_sym_u8_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(1151),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [anon_sym_NULL] = ACTIONS(1149),
    [anon_sym_nullptr] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_identifier] = ACTIONS(1153),
    [aux_sym_preproc_include_token1] = ACTIONS(1153),
    [aux_sym_preproc_def_token1] = ACTIONS(1153),
    [aux_sym_preproc_if_token1] = ACTIONS(1153),
    [aux_sym_preproc_if_token2] = ACTIONS(1153),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1153),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1153),
    [sym_preproc_directive] = ACTIONS(1153),
    [anon_sym_LPAREN2] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_TILDE] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym___extension__] = ACTIONS(1153),
    [anon_sym_typedef] = ACTIONS(1153),
    [anon_sym_extern] = ACTIONS(1153),
    [anon_sym___attribute__] = ACTIONS(1153),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1155),
    [anon_sym___declspec] = ACTIONS(1153),
    [anon_sym___cdecl] = ACTIONS(1153),
    [anon_sym___clrcall] = ACTIONS(1153),
    [anon_sym___stdcall] = ACTIONS(1153),
    [anon_sym___fastcall] = ACTIONS(1153),
    [anon_sym___thiscall] = ACTIONS(1153),
    [anon_sym___vectorcall] = ACTIONS(1153),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_signed] = ACTIONS(1153),
    [anon_sym_unsigned] = ACTIONS(1153),
    [anon_sym_long] = ACTIONS(1153),
    [anon_sym_short] = ACTIONS(1153),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_auto] = ACTIONS(1153),
    [anon_sym_register] = ACTIONS(1153),
    [anon_sym_inline] = ACTIONS(1153),
    [anon_sym___inline] = ACTIONS(1153),
    [anon_sym___inline__] = ACTIONS(1153),
    [anon_sym___forceinline] = ACTIONS(1153),
    [anon_sym_thread_local] = ACTIONS(1153),
    [anon_sym___thread] = ACTIONS(1153),
    [anon_sym_const] = ACTIONS(1153),
    [anon_sym_constexpr] = ACTIONS(1153),
    [anon_sym_volatile] = ACTIONS(1153),
    [anon_sym_restrict] = ACTIONS(1153),
    [anon_sym___restrict__] = ACTIONS(1153),
    [anon_sym__Atomic] = ACTIONS(1153),
    [anon_sym__Noreturn] = ACTIONS(1153),
    [anon_sym_noreturn] = ACTIONS(1153),
    [anon_sym__Nonnull] = ACTIONS(1153),
    [anon_sym_alignas] = ACTIONS(1153),
    [anon_sym__Alignas] = ACTIONS(1153),
    [sym_primitive_type] = ACTIONS(1153),
    [anon_sym_enum] = ACTIONS(1153),
    [anon_sym_struct] = ACTIONS(1153),
    [anon_sym_union] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_else] = ACTIONS(1153),
    [anon_sym_switch] = ACTIONS(1153),
    [anon_sym_case] = ACTIONS(1153),
    [anon_sym_default] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_do] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [anon_sym_goto] = ACTIONS(1153),
    [anon_sym___try] = ACTIONS(1153),
    [anon_sym___leave] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_sizeof] = ACTIONS(1153),
    [anon_sym___alignof__] = ACTIONS(1153),
    [anon_sym___alignof] = ACTIONS(1153),
    [anon_sym__alignof] = ACTIONS(1153),
    [anon_sym_alignof] = ACTIONS(1153),
    [anon_sym__Alignof] = ACTIONS(1153),
    [anon_sym_offsetof] = ACTIONS(1153),
    [anon_sym__Generic] = ACTIONS(1153),
    [anon_sym_asm] = ACTIONS(1153),
    [anon_sym___asm__] = ACTIONS(1153),
    [anon_sym___asm] = ACTIONS(1153),
    [sym_number_literal] = ACTIONS(1155),
    [anon_sym_L_SQUOTE] = ACTIONS(1155),
    [anon_sym_u_SQUOTE] = ACTIONS(1155),
    [anon_sym_U_SQUOTE] = ACTIONS(1155),
    [anon_sym_u8_SQUOTE] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [anon_sym_L_DQUOTE] = ACTIONS(1155),
    [anon_sym_u_DQUOTE] = ACTIONS(1155),
    [anon_sym_U_DQUOTE] = ACTIONS(1155),
    [anon_sym_u8_DQUOTE] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [anon_sym_NULL] = ACTIONS(1153),
    [anon_sym_nullptr] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_identifier] = ACTIONS(1157),
    [aux_sym_preproc_include_token1] = ACTIONS(1157),
    [aux_sym_preproc_def_token1] = ACTIONS(1157),
    [aux_sym_preproc_if_token1] = ACTIONS(1157),
    [aux_sym_preproc_if_token2] = ACTIONS(1157),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1157),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1157),
    [sym_preproc_directive] = ACTIONS(1157),
    [anon_sym_LPAREN2] = ACTIONS(1159),
    [anon_sym_BANG] = ACTIONS(1159),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_STAR] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1159),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym___extension__] = ACTIONS(1157),
    [anon_sym_typedef] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1157),
    [anon_sym___attribute__] = ACTIONS(1157),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1159),
    [anon_sym___declspec] = ACTIONS(1157),
    [anon_sym___cdecl] = ACTIONS(1157),
    [anon_sym___clrcall] = ACTIONS(1157),
    [anon_sym___stdcall] = ACTIONS(1157),
    [anon_sym___fastcall] = ACTIONS(1157),
    [anon_sym___thiscall] = ACTIONS(1157),
    [anon_sym___vectorcall] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_signed] = ACTIONS(1157),
    [anon_sym_unsigned] = ACTIONS(1157),
    [anon_sym_long] = ACTIONS(1157),
    [anon_sym_short] = ACTIONS(1157),
    [anon_sym_static] = ACTIONS(1157),
    [anon_sym_auto] = ACTIONS(1157),
    [anon_sym_register] = ACTIONS(1157),
    [anon_sym_inline] = ACTIONS(1157),
    [anon_sym___inline] = ACTIONS(1157),
    [anon_sym___inline__] = ACTIONS(1157),
    [anon_sym___forceinline] = ACTIONS(1157),
    [anon_sym_thread_local] = ACTIONS(1157),
    [anon_sym___thread] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_constexpr] = ACTIONS(1157),
    [anon_sym_volatile] = ACTIONS(1157),
    [anon_sym_restrict] = ACTIONS(1157),
    [anon_sym___restrict__] = ACTIONS(1157),
    [anon_sym__Atomic] = ACTIONS(1157),
    [anon_sym__Noreturn] = ACTIONS(1157),
    [anon_sym_noreturn] = ACTIONS(1157),
    [anon_sym__Nonnull] = ACTIONS(1157),
    [anon_sym_alignas] = ACTIONS(1157),
    [anon_sym__Alignas] = ACTIONS(1157),
    [sym_primitive_type] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [anon_sym_struct] = ACTIONS(1157),
    [anon_sym_union] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_else] = ACTIONS(1157),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_case] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_do] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_return] = ACTIONS(1157),
    [anon_sym_break] = ACTIONS(1157),
    [anon_sym_continue] = ACTIONS(1157),
    [anon_sym_goto] = ACTIONS(1157),
    [anon_sym___try] = ACTIONS(1157),
    [anon_sym___leave] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_sizeof] = ACTIONS(1157),
    [anon_sym___alignof__] = ACTIONS(1157),
    [anon_sym___alignof] = ACTIONS(1157),
    [anon_sym__alignof] = ACTIONS(1157),
    [anon_sym_alignof] = ACTIONS(1157),
    [anon_sym__Alignof] = ACTIONS(1157),
    [anon_sym_offsetof] = ACTIONS(1157),
    [anon_sym__Generic] = ACTIONS(1157),
    [anon_sym_asm] = ACTIONS(1157),
    [anon_sym___asm__] = ACTIONS(1157),
    [anon_sym___asm] = ACTIONS(1157),
    [sym_number_literal] = ACTIONS(1159),
    [anon_sym_L_SQUOTE] = ACTIONS(1159),
    [anon_sym_u_SQUOTE] = ACTIONS(1159),
    [anon_sym_U_SQUOTE] = ACTIONS(1159),
    [anon_sym_u8_SQUOTE] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [anon_sym_L_DQUOTE] = ACTIONS(1159),
    [anon_sym_u_DQUOTE] = ACTIONS(1159),
    [anon_sym_U_DQUOTE] = ACTIONS(1159),
    [anon_sym_u8_DQUOTE] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [sym_true] = ACTIONS(1157),
    [sym_false] = ACTIONS(1157),
    [anon_sym_NULL] = ACTIONS(1157),
    [anon_sym_nullptr] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_identifier] = ACTIONS(1161),
    [aux_sym_preproc_include_token1] = ACTIONS(1161),
    [aux_sym_preproc_def_token1] = ACTIONS(1161),
    [aux_sym_preproc_if_token1] = ACTIONS(1161),
    [aux_sym_preproc_if_token2] = ACTIONS(1161),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1161),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1161),
    [sym_preproc_directive] = ACTIONS(1161),
    [anon_sym_LPAREN2] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym___extension__] = ACTIONS(1161),
    [anon_sym_typedef] = ACTIONS(1161),
    [anon_sym_extern] = ACTIONS(1161),
    [anon_sym___attribute__] = ACTIONS(1161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1163),
    [anon_sym___declspec] = ACTIONS(1161),
    [anon_sym___cdecl] = ACTIONS(1161),
    [anon_sym___clrcall] = ACTIONS(1161),
    [anon_sym___stdcall] = ACTIONS(1161),
    [anon_sym___fastcall] = ACTIONS(1161),
    [anon_sym___thiscall] = ACTIONS(1161),
    [anon_sym___vectorcall] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_signed] = ACTIONS(1161),
    [anon_sym_unsigned] = ACTIONS(1161),
    [anon_sym_long] = ACTIONS(1161),
    [anon_sym_short] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1161),
    [anon_sym_auto] = ACTIONS(1161),
    [anon_sym_register] = ACTIONS(1161),
    [anon_sym_inline] = ACTIONS(1161),
    [anon_sym___inline] = ACTIONS(1161),
    [anon_sym___inline__] = ACTIONS(1161),
    [anon_sym___forceinline] = ACTIONS(1161),
    [anon_sym_thread_local] = ACTIONS(1161),
    [anon_sym___thread] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_constexpr] = ACTIONS(1161),
    [anon_sym_volatile] = ACTIONS(1161),
    [anon_sym_restrict] = ACTIONS(1161),
    [anon_sym___restrict__] = ACTIONS(1161),
    [anon_sym__Atomic] = ACTIONS(1161),
    [anon_sym__Noreturn] = ACTIONS(1161),
    [anon_sym_noreturn] = ACTIONS(1161),
    [anon_sym__Nonnull] = ACTIONS(1161),
    [anon_sym_alignas] = ACTIONS(1161),
    [anon_sym__Alignas] = ACTIONS(1161),
    [sym_primitive_type] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [anon_sym_struct] = ACTIONS(1161),
    [anon_sym_union] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_else] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_case] = ACTIONS(1161),
    [anon_sym_default] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_do] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_goto] = ACTIONS(1161),
    [anon_sym___try] = ACTIONS(1161),
    [anon_sym___leave] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_sizeof] = ACTIONS(1161),
    [anon_sym___alignof__] = ACTIONS(1161),
    [anon_sym___alignof] = ACTIONS(1161),
    [anon_sym__alignof] = ACTIONS(1161),
    [anon_sym_alignof] = ACTIONS(1161),
    [anon_sym__Alignof] = ACTIONS(1161),
    [anon_sym_offsetof] = ACTIONS(1161),
    [anon_sym__Generic] = ACTIONS(1161),
    [anon_sym_asm] = ACTIONS(1161),
    [anon_sym___asm__] = ACTIONS(1161),
    [anon_sym___asm] = ACTIONS(1161),
    [sym_number_literal] = ACTIONS(1163),
    [anon_sym_L_SQUOTE] = ACTIONS(1163),
    [anon_sym_u_SQUOTE] = ACTIONS(1163),
    [anon_sym_U_SQUOTE] = ACTIONS(1163),
    [anon_sym_u8_SQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [anon_sym_L_DQUOTE] = ACTIONS(1163),
    [anon_sym_u_DQUOTE] = ACTIONS(1163),
    [anon_sym_U_DQUOTE] = ACTIONS(1163),
    [anon_sym_u8_DQUOTE] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [anon_sym_NULL] = ACTIONS(1161),
    [anon_sym_nullptr] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_identifier] = ACTIONS(1165),
    [aux_sym_preproc_include_token1] = ACTIONS(1165),
    [aux_sym_preproc_def_token1] = ACTIONS(1165),
    [aux_sym_preproc_if_token1] = ACTIONS(1165),
    [aux_sym_preproc_if_token2] = ACTIONS(1165),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1165),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1165),
    [sym_preproc_directive] = ACTIONS(1165),
    [anon_sym_LPAREN2] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym___extension__] = ACTIONS(1165),
    [anon_sym_typedef] = ACTIONS(1165),
    [anon_sym_extern] = ACTIONS(1165),
    [anon_sym___attribute__] = ACTIONS(1165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1167),
    [anon_sym___declspec] = ACTIONS(1165),
    [anon_sym___cdecl] = ACTIONS(1165),
    [anon_sym___clrcall] = ACTIONS(1165),
    [anon_sym___stdcall] = ACTIONS(1165),
    [anon_sym___fastcall] = ACTIONS(1165),
    [anon_sym___thiscall] = ACTIONS(1165),
    [anon_sym___vectorcall] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_signed] = ACTIONS(1165),
    [anon_sym_unsigned] = ACTIONS(1165),
    [anon_sym_long] = ACTIONS(1165),
    [anon_sym_short] = ACTIONS(1165),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_auto] = ACTIONS(1165),
    [anon_sym_register] = ACTIONS(1165),
    [anon_sym_inline] = ACTIONS(1165),
    [anon_sym___inline] = ACTIONS(1165),
    [anon_sym___inline__] = ACTIONS(1165),
    [anon_sym___forceinline] = ACTIONS(1165),
    [anon_sym_thread_local] = ACTIONS(1165),
    [anon_sym___thread] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_constexpr] = ACTIONS(1165),
    [anon_sym_volatile] = ACTIONS(1165),
    [anon_sym_restrict] = ACTIONS(1165),
    [anon_sym___restrict__] = ACTIONS(1165),
    [anon_sym__Atomic] = ACTIONS(1165),
    [anon_sym__Noreturn] = ACTIONS(1165),
    [anon_sym_noreturn] = ACTIONS(1165),
    [anon_sym__Nonnull] = ACTIONS(1165),
    [anon_sym_alignas] = ACTIONS(1165),
    [anon_sym__Alignas] = ACTIONS(1165),
    [sym_primitive_type] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [anon_sym_struct] = ACTIONS(1165),
    [anon_sym_union] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_goto] = ACTIONS(1165),
    [anon_sym___try] = ACTIONS(1165),
    [anon_sym___leave] = ACTIONS(1165),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_sizeof] = ACTIONS(1165),
    [anon_sym___alignof__] = ACTIONS(1165),
    [anon_sym___alignof] = ACTIONS(1165),
    [anon_sym__alignof] = ACTIONS(1165),
    [anon_sym_alignof] = ACTIONS(1165),
    [anon_sym__Alignof] = ACTIONS(1165),
    [anon_sym_offsetof] = ACTIONS(1165),
    [anon_sym__Generic] = ACTIONS(1165),
    [anon_sym_asm] = ACTIONS(1165),
    [anon_sym___asm__] = ACTIONS(1165),
    [anon_sym___asm] = ACTIONS(1165),
    [sym_number_literal] = ACTIONS(1167),
    [anon_sym_L_SQUOTE] = ACTIONS(1167),
    [anon_sym_u_SQUOTE] = ACTIONS(1167),
    [anon_sym_U_SQUOTE] = ACTIONS(1167),
    [anon_sym_u8_SQUOTE] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [anon_sym_L_DQUOTE] = ACTIONS(1167),
    [anon_sym_u_DQUOTE] = ACTIONS(1167),
    [anon_sym_U_DQUOTE] = ACTIONS(1167),
    [anon_sym_u8_DQUOTE] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [anon_sym_NULL] = ACTIONS(1165),
    [anon_sym_nullptr] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_identifier] = ACTIONS(1169),
    [aux_sym_preproc_include_token1] = ACTIONS(1169),
    [aux_sym_preproc_def_token1] = ACTIONS(1169),
    [aux_sym_preproc_if_token1] = ACTIONS(1169),
    [aux_sym_preproc_if_token2] = ACTIONS(1169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1169),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1169),
    [sym_preproc_directive] = ACTIONS(1169),
    [anon_sym_LPAREN2] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1171),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym___extension__] = ACTIONS(1169),
    [anon_sym_typedef] = ACTIONS(1169),
    [anon_sym_extern] = ACTIONS(1169),
    [anon_sym___attribute__] = ACTIONS(1169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1171),
    [anon_sym___declspec] = ACTIONS(1169),
    [anon_sym___cdecl] = ACTIONS(1169),
    [anon_sym___clrcall] = ACTIONS(1169),
    [anon_sym___stdcall] = ACTIONS(1169),
    [anon_sym___fastcall] = ACTIONS(1169),
    [anon_sym___thiscall] = ACTIONS(1169),
    [anon_sym___vectorcall] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_signed] = ACTIONS(1169),
    [anon_sym_unsigned] = ACTIONS(1169),
    [anon_sym_long] = ACTIONS(1169),
    [anon_sym_short] = ACTIONS(1169),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_auto] = ACTIONS(1169),
    [anon_sym_register] = ACTIONS(1169),
    [anon_sym_inline] = ACTIONS(1169),
    [anon_sym___inline] = ACTIONS(1169),
    [anon_sym___inline__] = ACTIONS(1169),
    [anon_sym___forceinline] = ACTIONS(1169),
    [anon_sym_thread_local] = ACTIONS(1169),
    [anon_sym___thread] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_constexpr] = ACTIONS(1169),
    [anon_sym_volatile] = ACTIONS(1169),
    [anon_sym_restrict] = ACTIONS(1169),
    [anon_sym___restrict__] = ACTIONS(1169),
    [anon_sym__Atomic] = ACTIONS(1169),
    [anon_sym__Noreturn] = ACTIONS(1169),
    [anon_sym_noreturn] = ACTIONS(1169),
    [anon_sym__Nonnull] = ACTIONS(1169),
    [anon_sym_alignas] = ACTIONS(1169),
    [anon_sym__Alignas] = ACTIONS(1169),
    [sym_primitive_type] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [anon_sym_struct] = ACTIONS(1169),
    [anon_sym_union] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_do] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [anon_sym_goto] = ACTIONS(1169),
    [anon_sym___try] = ACTIONS(1169),
    [anon_sym___leave] = ACTIONS(1169),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_sizeof] = ACTIONS(1169),
    [anon_sym___alignof__] = ACTIONS(1169),
    [anon_sym___alignof] = ACTIONS(1169),
    [anon_sym__alignof] = ACTIONS(1169),
    [anon_sym_alignof] = ACTIONS(1169),
    [anon_sym__Alignof] = ACTIONS(1169),
    [anon_sym_offsetof] = ACTIONS(1169),
    [anon_sym__Generic] = ACTIONS(1169),
    [anon_sym_asm] = ACTIONS(1169),
    [anon_sym___asm__] = ACTIONS(1169),
    [anon_sym___asm] = ACTIONS(1169),
    [sym_number_literal] = ACTIONS(1171),
    [anon_sym_L_SQUOTE] = ACTIONS(1171),
    [anon_sym_u_SQUOTE] = ACTIONS(1171),
    [anon_sym_U_SQUOTE] = ACTIONS(1171),
    [anon_sym_u8_SQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [anon_sym_L_DQUOTE] = ACTIONS(1171),
    [anon_sym_u_DQUOTE] = ACTIONS(1171),
    [anon_sym_U_DQUOTE] = ACTIONS(1171),
    [anon_sym_u8_DQUOTE] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [anon_sym_NULL] = ACTIONS(1169),
    [anon_sym_nullptr] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1217),
    [aux_sym_preproc_include_token1] = ACTIONS(1217),
    [aux_sym_preproc_def_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1217),
    [sym_preproc_directive] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1219),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym___extension__] = ACTIONS(1217),
    [anon_sym_typedef] = ACTIONS(1217),
    [anon_sym_extern] = ACTIONS(1217),
    [anon_sym___attribute__] = ACTIONS(1217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1219),
    [anon_sym___declspec] = ACTIONS(1217),
    [anon_sym___cdecl] = ACTIONS(1217),
    [anon_sym___clrcall] = ACTIONS(1217),
    [anon_sym___stdcall] = ACTIONS(1217),
    [anon_sym___fastcall] = ACTIONS(1217),
    [anon_sym___thiscall] = ACTIONS(1217),
    [anon_sym___vectorcall] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(1217),
    [anon_sym_unsigned] = ACTIONS(1217),
    [anon_sym_long] = ACTIONS(1217),
    [anon_sym_short] = ACTIONS(1217),
    [anon_sym_static] = ACTIONS(1217),
    [anon_sym_auto] = ACTIONS(1217),
    [anon_sym_register] = ACTIONS(1217),
    [anon_sym_inline] = ACTIONS(1217),
    [anon_sym___inline] = ACTIONS(1217),
    [anon_sym___inline__] = ACTIONS(1217),
    [anon_sym___forceinline] = ACTIONS(1217),
    [anon_sym_thread_local] = ACTIONS(1217),
    [anon_sym___thread] = ACTIONS(1217),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_constexpr] = ACTIONS(1217),
    [anon_sym_volatile] = ACTIONS(1217),
    [anon_sym_restrict] = ACTIONS(1217),
    [anon_sym___restrict__] = ACTIONS(1217),
    [anon_sym__Atomic] = ACTIONS(1217),
    [anon_sym__Noreturn] = ACTIONS(1217),
    [anon_sym_noreturn] = ACTIONS(1217),
    [anon_sym__Nonnull] = ACTIONS(1217),
    [anon_sym_alignas] = ACTIONS(1217),
    [anon_sym__Alignas] = ACTIONS(1217),
    [sym_primitive_type] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1217),
    [anon_sym_struct] = ACTIONS(1217),
    [anon_sym_union] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1217),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(1217),
    [anon_sym_case] = ACTIONS(1217),
    [anon_sym_default] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(1217),
    [anon_sym_do] = ACTIONS(1217),
    [anon_sym_for] = ACTIONS(1217),
    [anon_sym_return] = ACTIONS(1217),
    [anon_sym_break] = ACTIONS(1217),
    [anon_sym_continue] = ACTIONS(1217),
    [anon_sym_goto] = ACTIONS(1217),
    [anon_sym___try] = ACTIONS(1217),
    [anon_sym___leave] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1219),
    [anon_sym_sizeof] = ACTIONS(1217),
    [anon_sym___alignof__] = ACTIONS(1217),
    [anon_sym___alignof] = ACTIONS(1217),
    [anon_sym__alignof] = ACTIONS(1217),
    [anon_sym_alignof] = ACTIONS(1217),
    [anon_sym__Alignof] = ACTIONS(1217),
    [anon_sym_offsetof] = ACTIONS(1217),
    [anon_sym__Generic] = ACTIONS(1217),
    [anon_sym_asm] = ACTIONS(1217),
    [anon_sym___asm__] = ACTIONS(1217),
    [anon_sym___asm] = ACTIONS(1217),
    [sym_number_literal] = ACTIONS(1219),
    [anon_sym_L_SQUOTE] = ACTIONS(1219),
    [anon_sym_u_SQUOTE] = ACTIONS(1219),
    [anon_sym_U_SQUOTE] = ACTIONS(1219),
    [anon_sym_u8_SQUOTE] = ACTIONS(1219),
    [anon_sym_SQUOTE] = ACTIONS(1219),
    [anon_sym_L_DQUOTE] = ACTIONS(1219),
    [anon_sym_u_DQUOTE] = ACTIONS(1219),
    [anon_sym_U_DQUOTE] = ACTIONS(1219),
    [anon_sym_u8_DQUOTE] = ACTIONS(1219),
    [anon_sym_DQUOTE] = ACTIONS(1219),
    [sym_true] = ACTIONS(1217),
    [sym_false] = ACTIONS(1217),
    [anon_sym_NULL] = ACTIONS(1217),
    [anon_sym_nullptr] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_identifier] = ACTIONS(1173),
    [aux_sym_preproc_include_token1] = ACTIONS(1173),
    [aux_sym_preproc_def_token1] = ACTIONS(1173),
    [aux_sym_preproc_if_token1] = ACTIONS(1173),
    [aux_sym_preproc_if_token2] = ACTIONS(1173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1173),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1173),
    [sym_preproc_directive] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym___extension__] = ACTIONS(1173),
    [anon_sym_typedef] = ACTIONS(1173),
    [anon_sym_extern] = ACTIONS(1173),
    [anon_sym___attribute__] = ACTIONS(1173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1175),
    [anon_sym___declspec] = ACTIONS(1173),
    [anon_sym___cdecl] = ACTIONS(1173),
    [anon_sym___clrcall] = ACTIONS(1173),
    [anon_sym___stdcall] = ACTIONS(1173),
    [anon_sym___fastcall] = ACTIONS(1173),
    [anon_sym___thiscall] = ACTIONS(1173),
    [anon_sym___vectorcall] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_signed] = ACTIONS(1173),
    [anon_sym_unsigned] = ACTIONS(1173),
    [anon_sym_long] = ACTIONS(1173),
    [anon_sym_short] = ACTIONS(1173),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_auto] = ACTIONS(1173),
    [anon_sym_register] = ACTIONS(1173),
    [anon_sym_inline] = ACTIONS(1173),
    [anon_sym___inline] = ACTIONS(1173),
    [anon_sym___inline__] = ACTIONS(1173),
    [anon_sym___forceinline] = ACTIONS(1173),
    [anon_sym_thread_local] = ACTIONS(1173),
    [anon_sym___thread] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_constexpr] = ACTIONS(1173),
    [anon_sym_volatile] = ACTIONS(1173),
    [anon_sym_restrict] = ACTIONS(1173),
    [anon_sym___restrict__] = ACTIONS(1173),
    [anon_sym__Atomic] = ACTIONS(1173),
    [anon_sym__Noreturn] = ACTIONS(1173),
    [anon_sym_noreturn] = ACTIONS(1173),
    [anon_sym__Nonnull] = ACTIONS(1173),
    [anon_sym_alignas] = ACTIONS(1173),
    [anon_sym__Alignas] = ACTIONS(1173),
    [sym_primitive_type] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [anon_sym_struct] = ACTIONS(1173),
    [anon_sym_union] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_goto] = ACTIONS(1173),
    [anon_sym___try] = ACTIONS(1173),
    [anon_sym___leave] = ACTIONS(1173),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_sizeof] = ACTIONS(1173),
    [anon_sym___alignof__] = ACTIONS(1173),
    [anon_sym___alignof] = ACTIONS(1173),
    [anon_sym__alignof] = ACTIONS(1173),
    [anon_sym_alignof] = ACTIONS(1173),
    [anon_sym__Alignof] = ACTIONS(1173),
    [anon_sym_offsetof] = ACTIONS(1173),
    [anon_sym__Generic] = ACTIONS(1173),
    [anon_sym_asm] = ACTIONS(1173),
    [anon_sym___asm__] = ACTIONS(1173),
    [anon_sym___asm] = ACTIONS(1173),
    [sym_number_literal] = ACTIONS(1175),
    [anon_sym_L_SQUOTE] = ACTIONS(1175),
    [anon_sym_u_SQUOTE] = ACTIONS(1175),
    [anon_sym_U_SQUOTE] = ACTIONS(1175),
    [anon_sym_u8_SQUOTE] = ACTIONS(1175),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_L_DQUOTE] = ACTIONS(1175),
    [anon_sym_u_DQUOTE] = ACTIONS(1175),
    [anon_sym_U_DQUOTE] = ACTIONS(1175),
    [anon_sym_u8_DQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [anon_sym_NULL] = ACTIONS(1173),
    [anon_sym_nullptr] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_identifier] = ACTIONS(1221),
    [aux_sym_preproc_include_token1] = ACTIONS(1221),
    [aux_sym_preproc_def_token1] = ACTIONS(1221),
    [aux_sym_preproc_if_token1] = ACTIONS(1221),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1221),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1221),
    [sym_preproc_directive] = ACTIONS(1221),
    [anon_sym_LPAREN2] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym___extension__] = ACTIONS(1221),
    [anon_sym_typedef] = ACTIONS(1221),
    [anon_sym_extern] = ACTIONS(1221),
    [anon_sym___attribute__] = ACTIONS(1221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1223),
    [anon_sym___declspec] = ACTIONS(1221),
    [anon_sym___cdecl] = ACTIONS(1221),
    [anon_sym___clrcall] = ACTIONS(1221),
    [anon_sym___stdcall] = ACTIONS(1221),
    [anon_sym___fastcall] = ACTIONS(1221),
    [anon_sym___thiscall] = ACTIONS(1221),
    [anon_sym___vectorcall] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_signed] = ACTIONS(1221),
    [anon_sym_unsigned] = ACTIONS(1221),
    [anon_sym_long] = ACTIONS(1221),
    [anon_sym_short] = ACTIONS(1221),
    [anon_sym_static] = ACTIONS(1221),
    [anon_sym_auto] = ACTIONS(1221),
    [anon_sym_register] = ACTIONS(1221),
    [anon_sym_inline] = ACTIONS(1221),
    [anon_sym___inline] = ACTIONS(1221),
    [anon_sym___inline__] = ACTIONS(1221),
    [anon_sym___forceinline] = ACTIONS(1221),
    [anon_sym_thread_local] = ACTIONS(1221),
    [anon_sym___thread] = ACTIONS(1221),
    [anon_sym_const] = ACTIONS(1221),
    [anon_sym_constexpr] = ACTIONS(1221),
    [anon_sym_volatile] = ACTIONS(1221),
    [anon_sym_restrict] = ACTIONS(1221),
    [anon_sym___restrict__] = ACTIONS(1221),
    [anon_sym__Atomic] = ACTIONS(1221),
    [anon_sym__Noreturn] = ACTIONS(1221),
    [anon_sym_noreturn] = ACTIONS(1221),
    [anon_sym__Nonnull] = ACTIONS(1221),
    [anon_sym_alignas] = ACTIONS(1221),
    [anon_sym__Alignas] = ACTIONS(1221),
    [sym_primitive_type] = ACTIONS(1221),
    [anon_sym_enum] = ACTIONS(1221),
    [anon_sym_struct] = ACTIONS(1221),
    [anon_sym_union] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1221),
    [anon_sym_else] = ACTIONS(1221),
    [anon_sym_switch] = ACTIONS(1221),
    [anon_sym_case] = ACTIONS(1221),
    [anon_sym_default] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1221),
    [anon_sym_do] = ACTIONS(1221),
    [anon_sym_for] = ACTIONS(1221),
    [anon_sym_return] = ACTIONS(1221),
    [anon_sym_break] = ACTIONS(1221),
    [anon_sym_continue] = ACTIONS(1221),
    [anon_sym_goto] = ACTIONS(1221),
    [anon_sym___try] = ACTIONS(1221),
    [anon_sym___leave] = ACTIONS(1221),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_sizeof] = ACTIONS(1221),
    [anon_sym___alignof__] = ACTIONS(1221),
    [anon_sym___alignof] = ACTIONS(1221),
    [anon_sym__alignof] = ACTIONS(1221),
    [anon_sym_alignof] = ACTIONS(1221),
    [anon_sym__Alignof] = ACTIONS(1221),
    [anon_sym_offsetof] = ACTIONS(1221),
    [anon_sym__Generic] = ACTIONS(1221),
    [anon_sym_asm] = ACTIONS(1221),
    [anon_sym___asm__] = ACTIONS(1221),
    [anon_sym___asm] = ACTIONS(1221),
    [sym_number_literal] = ACTIONS(1223),
    [anon_sym_L_SQUOTE] = ACTIONS(1223),
    [anon_sym_u_SQUOTE] = ACTIONS(1223),
    [anon_sym_U_SQUOTE] = ACTIONS(1223),
    [anon_sym_u8_SQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [anon_sym_L_DQUOTE] = ACTIONS(1223),
    [anon_sym_u_DQUOTE] = ACTIONS(1223),
    [anon_sym_U_DQUOTE] = ACTIONS(1223),
    [anon_sym_u8_DQUOTE] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [anon_sym_NULL] = ACTIONS(1221),
    [anon_sym_nullptr] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_identifier] = ACTIONS(1177),
    [aux_sym_preproc_include_token1] = ACTIONS(1177),
    [aux_sym_preproc_def_token1] = ACTIONS(1177),
    [aux_sym_preproc_if_token1] = ACTIONS(1177),
    [aux_sym_preproc_if_token2] = ACTIONS(1177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1177),
    [sym_preproc_directive] = ACTIONS(1177),
    [anon_sym_LPAREN2] = ACTIONS(1179),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym___extension__] = ACTIONS(1177),
    [anon_sym_typedef] = ACTIONS(1177),
    [anon_sym_extern] = ACTIONS(1177),
    [anon_sym___attribute__] = ACTIONS(1177),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1179),
    [anon_sym___declspec] = ACTIONS(1177),
    [anon_sym___cdecl] = ACTIONS(1177),
    [anon_sym___clrcall] = ACTIONS(1177),
    [anon_sym___stdcall] = ACTIONS(1177),
    [anon_sym___fastcall] = ACTIONS(1177),
    [anon_sym___thiscall] = ACTIONS(1177),
    [anon_sym___vectorcall] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_signed] = ACTIONS(1177),
    [anon_sym_unsigned] = ACTIONS(1177),
    [anon_sym_long] = ACTIONS(1177),
    [anon_sym_short] = ACTIONS(1177),
    [anon_sym_static] = ACTIONS(1177),
    [anon_sym_auto] = ACTIONS(1177),
    [anon_sym_register] = ACTIONS(1177),
    [anon_sym_inline] = ACTIONS(1177),
    [anon_sym___inline] = ACTIONS(1177),
    [anon_sym___inline__] = ACTIONS(1177),
    [anon_sym___forceinline] = ACTIONS(1177),
    [anon_sym_thread_local] = ACTIONS(1177),
    [anon_sym___thread] = ACTIONS(1177),
    [anon_sym_const] = ACTIONS(1177),
    [anon_sym_constexpr] = ACTIONS(1177),
    [anon_sym_volatile] = ACTIONS(1177),
    [anon_sym_restrict] = ACTIONS(1177),
    [anon_sym___restrict__] = ACTIONS(1177),
    [anon_sym__Atomic] = ACTIONS(1177),
    [anon_sym__Noreturn] = ACTIONS(1177),
    [anon_sym_noreturn] = ACTIONS(1177),
    [anon_sym__Nonnull] = ACTIONS(1177),
    [anon_sym_alignas] = ACTIONS(1177),
    [anon_sym__Alignas] = ACTIONS(1177),
    [sym_primitive_type] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(1177),
    [anon_sym_struct] = ACTIONS(1177),
    [anon_sym_union] = ACTIONS(1177),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_switch] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_default] = ACTIONS(1177),
    [anon_sym_while] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1177),
    [anon_sym_return] = ACTIONS(1177),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1177),
    [anon_sym_goto] = ACTIONS(1177),
    [anon_sym___try] = ACTIONS(1177),
    [anon_sym___leave] = ACTIONS(1177),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_sizeof] = ACTIONS(1177),
    [anon_sym___alignof__] = ACTIONS(1177),
    [anon_sym___alignof] = ACTIONS(1177),
    [anon_sym__alignof] = ACTIONS(1177),
    [anon_sym_alignof] = ACTIONS(1177),
    [anon_sym__Alignof] = ACTIONS(1177),
    [anon_sym_offsetof] = ACTIONS(1177),
    [anon_sym__Generic] = ACTIONS(1177),
    [anon_sym_asm] = ACTIONS(1177),
    [anon_sym___asm__] = ACTIONS(1177),
    [anon_sym___asm] = ACTIONS(1177),
    [sym_number_literal] = ACTIONS(1179),
    [anon_sym_L_SQUOTE] = ACTIONS(1179),
    [anon_sym_u_SQUOTE] = ACTIONS(1179),
    [anon_sym_U_SQUOTE] = ACTIONS(1179),
    [anon_sym_u8_SQUOTE] = ACTIONS(1179),
    [anon_sym_SQUOTE] = ACTIONS(1179),
    [anon_sym_L_DQUOTE] = ACTIONS(1179),
    [anon_sym_u_DQUOTE] = ACTIONS(1179),
    [anon_sym_U_DQUOTE] = ACTIONS(1179),
    [anon_sym_u8_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1179),
    [sym_true] = ACTIONS(1177),
    [sym_false] = ACTIONS(1177),
    [anon_sym_NULL] = ACTIONS(1177),
    [anon_sym_nullptr] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_identifier] = ACTIONS(1181),
    [aux_sym_preproc_include_token1] = ACTIONS(1181),
    [aux_sym_preproc_def_token1] = ACTIONS(1181),
    [aux_sym_preproc_if_token1] = ACTIONS(1181),
    [aux_sym_preproc_if_token2] = ACTIONS(1181),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1181),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1181),
    [sym_preproc_directive] = ACTIONS(1181),
    [anon_sym_LPAREN2] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym___extension__] = ACTIONS(1181),
    [anon_sym_typedef] = ACTIONS(1181),
    [anon_sym_extern] = ACTIONS(1181),
    [anon_sym___attribute__] = ACTIONS(1181),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1183),
    [anon_sym___declspec] = ACTIONS(1181),
    [anon_sym___cdecl] = ACTIONS(1181),
    [anon_sym___clrcall] = ACTIONS(1181),
    [anon_sym___stdcall] = ACTIONS(1181),
    [anon_sym___fastcall] = ACTIONS(1181),
    [anon_sym___thiscall] = ACTIONS(1181),
    [anon_sym___vectorcall] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1183),
    [anon_sym_signed] = ACTIONS(1181),
    [anon_sym_unsigned] = ACTIONS(1181),
    [anon_sym_long] = ACTIONS(1181),
    [anon_sym_short] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_auto] = ACTIONS(1181),
    [anon_sym_register] = ACTIONS(1181),
    [anon_sym_inline] = ACTIONS(1181),
    [anon_sym___inline] = ACTIONS(1181),
    [anon_sym___inline__] = ACTIONS(1181),
    [anon_sym___forceinline] = ACTIONS(1181),
    [anon_sym_thread_local] = ACTIONS(1181),
    [anon_sym___thread] = ACTIONS(1181),
    [anon_sym_const] = ACTIONS(1181),
    [anon_sym_constexpr] = ACTIONS(1181),
    [anon_sym_volatile] = ACTIONS(1181),
    [anon_sym_restrict] = ACTIONS(1181),
    [anon_sym___restrict__] = ACTIONS(1181),
    [anon_sym__Atomic] = ACTIONS(1181),
    [anon_sym__Noreturn] = ACTIONS(1181),
    [anon_sym_noreturn] = ACTIONS(1181),
    [anon_sym__Nonnull] = ACTIONS(1181),
    [anon_sym_alignas] = ACTIONS(1181),
    [anon_sym__Alignas] = ACTIONS(1181),
    [sym_primitive_type] = ACTIONS(1181),
    [anon_sym_enum] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1181),
    [anon_sym_switch] = ACTIONS(1181),
    [anon_sym_case] = ACTIONS(1181),
    [anon_sym_default] = ACTIONS(1181),
    [anon_sym_while] = ACTIONS(1181),
    [anon_sym_do] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1181),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_continue] = ACTIONS(1181),
    [anon_sym_goto] = ACTIONS(1181),
    [anon_sym___try] = ACTIONS(1181),
    [anon_sym___leave] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1183),
    [anon_sym_sizeof] = ACTIONS(1181),
    [anon_sym___alignof__] = ACTIONS(1181),
    [anon_sym___alignof] = ACTIONS(1181),
    [anon_sym__alignof] = ACTIONS(1181),
    [anon_sym_alignof] = ACTIONS(1181),
    [anon_sym__Alignof] = ACTIONS(1181),
    [anon_sym_offsetof] = ACTIONS(1181),
    [anon_sym__Generic] = ACTIONS(1181),
    [anon_sym_asm] = ACTIONS(1181),
    [anon_sym___asm__] = ACTIONS(1181),
    [anon_sym___asm] = ACTIONS(1181),
    [sym_number_literal] = ACTIONS(1183),
    [anon_sym_L_SQUOTE] = ACTIONS(1183),
    [anon_sym_u_SQUOTE] = ACTIONS(1183),
    [anon_sym_U_SQUOTE] = ACTIONS(1183),
    [anon_sym_u8_SQUOTE] = ACTIONS(1183),
    [anon_sym_SQUOTE] = ACTIONS(1183),
    [anon_sym_L_DQUOTE] = ACTIONS(1183),
    [anon_sym_u_DQUOTE] = ACTIONS(1183),
    [anon_sym_U_DQUOTE] = ACTIONS(1183),
    [anon_sym_u8_DQUOTE] = ACTIONS(1183),
    [anon_sym_DQUOTE] = ACTIONS(1183),
    [sym_true] = ACTIONS(1181),
    [sym_false] = ACTIONS(1181),
    [anon_sym_NULL] = ACTIONS(1181),
    [anon_sym_nullptr] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym_identifier] = ACTIONS(1185),
    [aux_sym_preproc_include_token1] = ACTIONS(1185),
    [aux_sym_preproc_def_token1] = ACTIONS(1185),
    [aux_sym_preproc_if_token1] = ACTIONS(1185),
    [aux_sym_preproc_if_token2] = ACTIONS(1185),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1185),
    [sym_preproc_directive] = ACTIONS(1185),
    [anon_sym_LPAREN2] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_TILDE] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1185),
    [anon_sym_PLUS] = ACTIONS(1185),
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym___extension__] = ACTIONS(1185),
    [anon_sym_typedef] = ACTIONS(1185),
    [anon_sym_extern] = ACTIONS(1185),
    [anon_sym___attribute__] = ACTIONS(1185),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1187),
    [anon_sym___declspec] = ACTIONS(1185),
    [anon_sym___cdecl] = ACTIONS(1185),
    [anon_sym___clrcall] = ACTIONS(1185),
    [anon_sym___stdcall] = ACTIONS(1185),
    [anon_sym___fastcall] = ACTIONS(1185),
    [anon_sym___thiscall] = ACTIONS(1185),
    [anon_sym___vectorcall] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_signed] = ACTIONS(1185),
    [anon_sym_unsigned] = ACTIONS(1185),
    [anon_sym_long] = ACTIONS(1185),
    [anon_sym_short] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1185),
    [anon_sym_auto] = ACTIONS(1185),
    [anon_sym_register] = ACTIONS(1185),
    [anon_sym_inline] = ACTIONS(1185),
    [anon_sym___inline] = ACTIONS(1185),
    [anon_sym___inline__] = ACTIONS(1185),
    [anon_sym___forceinline] = ACTIONS(1185),
    [anon_sym_thread_local] = ACTIONS(1185),
    [anon_sym___thread] = ACTIONS(1185),
    [anon_sym_const] = ACTIONS(1185),
    [anon_sym_constexpr] = ACTIONS(1185),
    [anon_sym_volatile] = ACTIONS(1185),
    [anon_sym_restrict] = ACTIONS(1185),
    [anon_sym___restrict__] = ACTIONS(1185),
    [anon_sym__Atomic] = ACTIONS(1185),
    [anon_sym__Noreturn] = ACTIONS(1185),
    [anon_sym_noreturn] = ACTIONS(1185),
    [anon_sym__Nonnull] = ACTIONS(1185),
    [anon_sym_alignas] = ACTIONS(1185),
    [anon_sym__Alignas] = ACTIONS(1185),
    [sym_primitive_type] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1185),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_union] = ACTIONS(1185),
    [anon_sym_if] = ACTIONS(1185),
    [anon_sym_else] = ACTIONS(1185),
    [anon_sym_switch] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1185),
    [anon_sym_default] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1185),
    [anon_sym_do] = ACTIONS(1185),
    [anon_sym_for] = ACTIONS(1185),
    [anon_sym_return] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1185),
    [anon_sym_continue] = ACTIONS(1185),
    [anon_sym_goto] = ACTIONS(1185),
    [anon_sym___try] = ACTIONS(1185),
    [anon_sym___leave] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1187),
    [anon_sym_sizeof] = ACTIONS(1185),
    [anon_sym___alignof__] = ACTIONS(1185),
    [anon_sym___alignof] = ACTIONS(1185),
    [anon_sym__alignof] = ACTIONS(1185),
    [anon_sym_alignof] = ACTIONS(1185),
    [anon_sym__Alignof] = ACTIONS(1185),
    [anon_sym_offsetof] = ACTIONS(1185),
    [anon_sym__Generic] = ACTIONS(1185),
    [anon_sym_asm] = ACTIONS(1185),
    [anon_sym___asm__] = ACTIONS(1185),
    [anon_sym___asm] = ACTIONS(1185),
    [sym_number_literal] = ACTIONS(1187),
    [anon_sym_L_SQUOTE] = ACTIONS(1187),
    [anon_sym_u_SQUOTE] = ACTIONS(1187),
    [anon_sym_U_SQUOTE] = ACTIONS(1187),
    [anon_sym_u8_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_L_DQUOTE] = ACTIONS(1187),
    [anon_sym_u_DQUOTE] = ACTIONS(1187),
    [anon_sym_U_DQUOTE] = ACTIONS(1187),
    [anon_sym_u8_DQUOTE] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [sym_true] = ACTIONS(1185),
    [sym_false] = ACTIONS(1185),
    [anon_sym_NULL] = ACTIONS(1185),
    [anon_sym_nullptr] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_identifier] = ACTIONS(1253),
    [aux_sym_preproc_include_token1] = ACTIONS(1253),
    [aux_sym_preproc_def_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token2] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1253),
    [sym_preproc_directive] = ACTIONS(1253),
    [anon_sym_LPAREN2] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym___extension__] = ACTIONS(1253),
    [anon_sym_typedef] = ACTIONS(1253),
    [anon_sym_extern] = ACTIONS(1253),
    [anon_sym___attribute__] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1255),
    [anon_sym___declspec] = ACTIONS(1253),
    [anon_sym___cdecl] = ACTIONS(1253),
    [anon_sym___clrcall] = ACTIONS(1253),
    [anon_sym___stdcall] = ACTIONS(1253),
    [anon_sym___fastcall] = ACTIONS(1253),
    [anon_sym___thiscall] = ACTIONS(1253),
    [anon_sym___vectorcall] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_signed] = ACTIONS(1253),
    [anon_sym_unsigned] = ACTIONS(1253),
    [anon_sym_long] = ACTIONS(1253),
    [anon_sym_short] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_auto] = ACTIONS(1253),
    [anon_sym_register] = ACTIONS(1253),
    [anon_sym_inline] = ACTIONS(1253),
    [anon_sym___inline] = ACTIONS(1253),
    [anon_sym___inline__] = ACTIONS(1253),
    [anon_sym___forceinline] = ACTIONS(1253),
    [anon_sym_thread_local] = ACTIONS(1253),
    [anon_sym___thread] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_constexpr] = ACTIONS(1253),
    [anon_sym_volatile] = ACTIONS(1253),
    [anon_sym_restrict] = ACTIONS(1253),
    [anon_sym___restrict__] = ACTIONS(1253),
    [anon_sym__Atomic] = ACTIONS(1253),
    [anon_sym__Noreturn] = ACTIONS(1253),
    [anon_sym_noreturn] = ACTIONS(1253),
    [anon_sym__Nonnull] = ACTIONS(1253),
    [anon_sym_alignas] = ACTIONS(1253),
    [anon_sym__Alignas] = ACTIONS(1253),
    [sym_primitive_type] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_union] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_goto] = ACTIONS(1253),
    [anon_sym___try] = ACTIONS(1253),
    [anon_sym___leave] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_sizeof] = ACTIONS(1253),
    [anon_sym___alignof__] = ACTIONS(1253),
    [anon_sym___alignof] = ACTIONS(1253),
    [anon_sym__alignof] = ACTIONS(1253),
    [anon_sym_alignof] = ACTIONS(1253),
    [anon_sym__Alignof] = ACTIONS(1253),
    [anon_sym_offsetof] = ACTIONS(1253),
    [anon_sym__Generic] = ACTIONS(1253),
    [anon_sym_asm] = ACTIONS(1253),
    [anon_sym___asm__] = ACTIONS(1253),
    [anon_sym___asm] = ACTIONS(1253),
    [sym_number_literal] = ACTIONS(1255),
    [anon_sym_L_SQUOTE] = ACTIONS(1255),
    [anon_sym_u_SQUOTE] = ACTIONS(1255),
    [anon_sym_U_SQUOTE] = ACTIONS(1255),
    [anon_sym_u8_SQUOTE] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_L_DQUOTE] = ACTIONS(1255),
    [anon_sym_u_DQUOTE] = ACTIONS(1255),
    [anon_sym_U_DQUOTE] = ACTIONS(1255),
    [anon_sym_u8_DQUOTE] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [anon_sym_NULL] = ACTIONS(1253),
    [anon_sym_nullptr] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_identifier] = ACTIONS(1193),
    [aux_sym_preproc_include_token1] = ACTIONS(1193),
    [aux_sym_preproc_def_token1] = ACTIONS(1193),
    [aux_sym_preproc_if_token1] = ACTIONS(1193),
    [aux_sym_preproc_if_token2] = ACTIONS(1193),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1193),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1193),
    [sym_preproc_directive] = ACTIONS(1193),
    [anon_sym_LPAREN2] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1195),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym___extension__] = ACTIONS(1193),
    [anon_sym_typedef] = ACTIONS(1193),
    [anon_sym_extern] = ACTIONS(1193),
    [anon_sym___attribute__] = ACTIONS(1193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1195),
    [anon_sym___declspec] = ACTIONS(1193),
    [anon_sym___cdecl] = ACTIONS(1193),
    [anon_sym___clrcall] = ACTIONS(1193),
    [anon_sym___stdcall] = ACTIONS(1193),
    [anon_sym___fastcall] = ACTIONS(1193),
    [anon_sym___thiscall] = ACTIONS(1193),
    [anon_sym___vectorcall] = ACTIONS(1193),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_signed] = ACTIONS(1193),
    [anon_sym_unsigned] = ACTIONS(1193),
    [anon_sym_long] = ACTIONS(1193),
    [anon_sym_short] = ACTIONS(1193),
    [anon_sym_static] = ACTIONS(1193),
    [anon_sym_auto] = ACTIONS(1193),
    [anon_sym_register] = ACTIONS(1193),
    [anon_sym_inline] = ACTIONS(1193),
    [anon_sym___inline] = ACTIONS(1193),
    [anon_sym___inline__] = ACTIONS(1193),
    [anon_sym___forceinline] = ACTIONS(1193),
    [anon_sym_thread_local] = ACTIONS(1193),
    [anon_sym___thread] = ACTIONS(1193),
    [anon_sym_const] = ACTIONS(1193),
    [anon_sym_constexpr] = ACTIONS(1193),
    [anon_sym_volatile] = ACTIONS(1193),
    [anon_sym_restrict] = ACTIONS(1193),
    [anon_sym___restrict__] = ACTIONS(1193),
    [anon_sym__Atomic] = ACTIONS(1193),
    [anon_sym__Noreturn] = ACTIONS(1193),
    [anon_sym_noreturn] = ACTIONS(1193),
    [anon_sym__Nonnull] = ACTIONS(1193),
    [anon_sym_alignas] = ACTIONS(1193),
    [anon_sym__Alignas] = ACTIONS(1193),
    [sym_primitive_type] = ACTIONS(1193),
    [anon_sym_enum] = ACTIONS(1193),
    [anon_sym_struct] = ACTIONS(1193),
    [anon_sym_union] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_switch] = ACTIONS(1193),
    [anon_sym_case] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1193),
    [anon_sym_while] = ACTIONS(1193),
    [anon_sym_do] = ACTIONS(1193),
    [anon_sym_for] = ACTIONS(1193),
    [anon_sym_return] = ACTIONS(1193),
    [anon_sym_break] = ACTIONS(1193),
    [anon_sym_continue] = ACTIONS(1193),
    [anon_sym_goto] = ACTIONS(1193),
    [anon_sym___try] = ACTIONS(1193),
    [anon_sym___leave] = ACTIONS(1193),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_sizeof] = ACTIONS(1193),
    [anon_sym___alignof__] = ACTIONS(1193),
    [anon_sym___alignof] = ACTIONS(1193),
    [anon_sym__alignof] = ACTIONS(1193),
    [anon_sym_alignof] = ACTIONS(1193),
    [anon_sym__Alignof] = ACTIONS(1193),
    [anon_sym_offsetof] = ACTIONS(1193),
    [anon_sym__Generic] = ACTIONS(1193),
    [anon_sym_asm] = ACTIONS(1193),
    [anon_sym___asm__] = ACTIONS(1193),
    [anon_sym___asm] = ACTIONS(1193),
    [sym_number_literal] = ACTIONS(1195),
    [anon_sym_L_SQUOTE] = ACTIONS(1195),
    [anon_sym_u_SQUOTE] = ACTIONS(1195),
    [anon_sym_U_SQUOTE] = ACTIONS(1195),
    [anon_sym_u8_SQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [anon_sym_L_DQUOTE] = ACTIONS(1195),
    [anon_sym_u_DQUOTE] = ACTIONS(1195),
    [anon_sym_U_DQUOTE] = ACTIONS(1195),
    [anon_sym_u8_DQUOTE] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [sym_true] = ACTIONS(1193),
    [sym_false] = ACTIONS(1193),
    [anon_sym_NULL] = ACTIONS(1193),
    [anon_sym_nullptr] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym_identifier] = ACTIONS(1197),
    [aux_sym_preproc_include_token1] = ACTIONS(1197),
    [aux_sym_preproc_def_token1] = ACTIONS(1197),
    [aux_sym_preproc_if_token1] = ACTIONS(1197),
    [aux_sym_preproc_if_token2] = ACTIONS(1197),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1197),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1197),
    [sym_preproc_directive] = ACTIONS(1197),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym___extension__] = ACTIONS(1197),
    [anon_sym_typedef] = ACTIONS(1197),
    [anon_sym_extern] = ACTIONS(1197),
    [anon_sym___attribute__] = ACTIONS(1197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1199),
    [anon_sym___declspec] = ACTIONS(1197),
    [anon_sym___cdecl] = ACTIONS(1197),
    [anon_sym___clrcall] = ACTIONS(1197),
    [anon_sym___stdcall] = ACTIONS(1197),
    [anon_sym___fastcall] = ACTIONS(1197),
    [anon_sym___thiscall] = ACTIONS(1197),
    [anon_sym___vectorcall] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_signed] = ACTIONS(1197),
    [anon_sym_unsigned] = ACTIONS(1197),
    [anon_sym_long] = ACTIONS(1197),
    [anon_sym_short] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_auto] = ACTIONS(1197),
    [anon_sym_register] = ACTIONS(1197),
    [anon_sym_inline] = ACTIONS(1197),
    [anon_sym___inline] = ACTIONS(1197),
    [anon_sym___inline__] = ACTIONS(1197),
    [anon_sym___forceinline] = ACTIONS(1197),
    [anon_sym_thread_local] = ACTIONS(1197),
    [anon_sym___thread] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_constexpr] = ACTIONS(1197),
    [anon_sym_volatile] = ACTIONS(1197),
    [anon_sym_restrict] = ACTIONS(1197),
    [anon_sym___restrict__] = ACTIONS(1197),
    [anon_sym__Atomic] = ACTIONS(1197),
    [anon_sym__Noreturn] = ACTIONS(1197),
    [anon_sym_noreturn] = ACTIONS(1197),
    [anon_sym__Nonnull] = ACTIONS(1197),
    [anon_sym_alignas] = ACTIONS(1197),
    [anon_sym__Alignas] = ACTIONS(1197),
    [sym_primitive_type] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [anon_sym_struct] = ACTIONS(1197),
    [anon_sym_union] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_goto] = ACTIONS(1197),
    [anon_sym___try] = ACTIONS(1197),
    [anon_sym___leave] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1197),
    [anon_sym___alignof__] = ACTIONS(1197),
    [anon_sym___alignof] = ACTIONS(1197),
    [anon_sym__alignof] = ACTIONS(1197),
    [anon_sym_alignof] = ACTIONS(1197),
    [anon_sym__Alignof] = ACTIONS(1197),
    [anon_sym_offsetof] = ACTIONS(1197),
    [anon_sym__Generic] = ACTIONS(1197),
    [anon_sym_asm] = ACTIONS(1197),
    [anon_sym___asm__] = ACTIONS(1197),
    [anon_sym___asm] = ACTIONS(1197),
    [sym_number_literal] = ACTIONS(1199),
    [anon_sym_L_SQUOTE] = ACTIONS(1199),
    [anon_sym_u_SQUOTE] = ACTIONS(1199),
    [anon_sym_U_SQUOTE] = ACTIONS(1199),
    [anon_sym_u8_SQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [anon_sym_L_DQUOTE] = ACTIONS(1199),
    [anon_sym_u_DQUOTE] = ACTIONS(1199),
    [anon_sym_U_DQUOTE] = ACTIONS(1199),
    [anon_sym_u8_DQUOTE] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [anon_sym_NULL] = ACTIONS(1197),
    [anon_sym_nullptr] = ACTIONS(1197),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym_identifier] = ACTIONS(1129),
    [aux_sym_preproc_include_token1] = ACTIONS(1129),
    [aux_sym_preproc_def_token1] = ACTIONS(1129),
    [aux_sym_preproc_if_token1] = ACTIONS(1129),
    [aux_sym_preproc_if_token2] = ACTIONS(1129),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1129),
    [sym_preproc_directive] = ACTIONS(1129),
    [anon_sym_LPAREN2] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym___extension__] = ACTIONS(1129),
    [anon_sym_typedef] = ACTIONS(1129),
    [anon_sym_extern] = ACTIONS(1129),
    [anon_sym___attribute__] = ACTIONS(1129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1131),
    [anon_sym___declspec] = ACTIONS(1129),
    [anon_sym___cdecl] = ACTIONS(1129),
    [anon_sym___clrcall] = ACTIONS(1129),
    [anon_sym___stdcall] = ACTIONS(1129),
    [anon_sym___fastcall] = ACTIONS(1129),
    [anon_sym___thiscall] = ACTIONS(1129),
    [anon_sym___vectorcall] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_signed] = ACTIONS(1129),
    [anon_sym_unsigned] = ACTIONS(1129),
    [anon_sym_long] = ACTIONS(1129),
    [anon_sym_short] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(1129),
    [anon_sym_auto] = ACTIONS(1129),
    [anon_sym_register] = ACTIONS(1129),
    [anon_sym_inline] = ACTIONS(1129),
    [anon_sym___inline] = ACTIONS(1129),
    [anon_sym___inline__] = ACTIONS(1129),
    [anon_sym___forceinline] = ACTIONS(1129),
    [anon_sym_thread_local] = ACTIONS(1129),
    [anon_sym___thread] = ACTIONS(1129),
    [anon_sym_const] = ACTIONS(1129),
    [anon_sym_constexpr] = ACTIONS(1129),
    [anon_sym_volatile] = ACTIONS(1129),
    [anon_sym_restrict] = ACTIONS(1129),
    [anon_sym___restrict__] = ACTIONS(1129),
    [anon_sym__Atomic] = ACTIONS(1129),
    [anon_sym__Noreturn] = ACTIONS(1129),
    [anon_sym_noreturn] = ACTIONS(1129),
    [anon_sym__Nonnull] = ACTIONS(1129),
    [anon_sym_alignas] = ACTIONS(1129),
    [anon_sym__Alignas] = ACTIONS(1129),
    [sym_primitive_type] = ACTIONS(1129),
    [anon_sym_enum] = ACTIONS(1129),
    [anon_sym_struct] = ACTIONS(1129),
    [anon_sym_union] = ACTIONS(1129),
    [anon_sym_if] = ACTIONS(1129),
    [anon_sym_else] = ACTIONS(1129),
    [anon_sym_switch] = ACTIONS(1129),
    [anon_sym_case] = ACTIONS(1129),
    [anon_sym_default] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1129),
    [anon_sym_for] = ACTIONS(1129),
    [anon_sym_return] = ACTIONS(1129),
    [anon_sym_break] = ACTIONS(1129),
    [anon_sym_continue] = ACTIONS(1129),
    [anon_sym_goto] = ACTIONS(1129),
    [anon_sym___try] = ACTIONS(1129),
    [anon_sym___leave] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_sizeof] = ACTIONS(1129),
    [anon_sym___alignof__] = ACTIONS(1129),
    [anon_sym___alignof] = ACTIONS(1129),
    [anon_sym__alignof] = ACTIONS(1129),
    [anon_sym_alignof] = ACTIONS(1129),
    [anon_sym__Alignof] = ACTIONS(1129),
    [anon_sym_offsetof] = ACTIONS(1129),
    [anon_sym__Generic] = ACTIONS(1129),
    [anon_sym_asm] = ACTIONS(1129),
    [anon_sym___asm__] = ACTIONS(1129),
    [anon_sym___asm] = ACTIONS(1129),
    [sym_number_literal] = ACTIONS(1131),
    [anon_sym_L_SQUOTE] = ACTIONS(1131),
    [anon_sym_u_SQUOTE] = ACTIONS(1131),
    [anon_sym_U_SQUOTE] = ACTIONS(1131),
    [anon_sym_u8_SQUOTE] = ACTIONS(1131),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [anon_sym_L_DQUOTE] = ACTIONS(1131),
    [anon_sym_u_DQUOTE] = ACTIONS(1131),
    [anon_sym_U_DQUOTE] = ACTIONS(1131),
    [anon_sym_u8_DQUOTE] = ACTIONS(1131),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_true] = ACTIONS(1129),
    [sym_false] = ACTIONS(1129),
    [anon_sym_NULL] = ACTIONS(1129),
    [anon_sym_nullptr] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [ts_builtin_sym_end] = ACTIONS(1175),
    [sym_identifier] = ACTIONS(1173),
    [aux_sym_preproc_include_token1] = ACTIONS(1173),
    [aux_sym_preproc_def_token1] = ACTIONS(1173),
    [aux_sym_preproc_if_token1] = ACTIONS(1173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1173),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1173),
    [sym_preproc_directive] = ACTIONS(1173),
    [anon_sym_LPAREN2] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym___extension__] = ACTIONS(1173),
    [anon_sym_typedef] = ACTIONS(1173),
    [anon_sym_extern] = ACTIONS(1173),
    [anon_sym___attribute__] = ACTIONS(1173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1175),
    [anon_sym___declspec] = ACTIONS(1173),
    [anon_sym___cdecl] = ACTIONS(1173),
    [anon_sym___clrcall] = ACTIONS(1173),
    [anon_sym___stdcall] = ACTIONS(1173),
    [anon_sym___fastcall] = ACTIONS(1173),
    [anon_sym___thiscall] = ACTIONS(1173),
    [anon_sym___vectorcall] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_signed] = ACTIONS(1173),
    [anon_sym_unsigned] = ACTIONS(1173),
    [anon_sym_long] = ACTIONS(1173),
    [anon_sym_short] = ACTIONS(1173),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_auto] = ACTIONS(1173),
    [anon_sym_register] = ACTIONS(1173),
    [anon_sym_inline] = ACTIONS(1173),
    [anon_sym___inline] = ACTIONS(1173),
    [anon_sym___inline__] = ACTIONS(1173),
    [anon_sym___forceinline] = ACTIONS(1173),
    [anon_sym_thread_local] = ACTIONS(1173),
    [anon_sym___thread] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_constexpr] = ACTIONS(1173),
    [anon_sym_volatile] = ACTIONS(1173),
    [anon_sym_restrict] = ACTIONS(1173),
    [anon_sym___restrict__] = ACTIONS(1173),
    [anon_sym__Atomic] = ACTIONS(1173),
    [anon_sym__Noreturn] = ACTIONS(1173),
    [anon_sym_noreturn] = ACTIONS(1173),
    [anon_sym__Nonnull] = ACTIONS(1173),
    [anon_sym_alignas] = ACTIONS(1173),
    [anon_sym__Alignas] = ACTIONS(1173),
    [sym_primitive_type] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [anon_sym_struct] = ACTIONS(1173),
    [anon_sym_union] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_goto] = ACTIONS(1173),
    [anon_sym___try] = ACTIONS(1173),
    [anon_sym___leave] = ACTIONS(1173),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_sizeof] = ACTIONS(1173),
    [anon_sym___alignof__] = ACTIONS(1173),
    [anon_sym___alignof] = ACTIONS(1173),
    [anon_sym__alignof] = ACTIONS(1173),
    [anon_sym_alignof] = ACTIONS(1173),
    [anon_sym__Alignof] = ACTIONS(1173),
    [anon_sym_offsetof] = ACTIONS(1173),
    [anon_sym__Generic] = ACTIONS(1173),
    [anon_sym_asm] = ACTIONS(1173),
    [anon_sym___asm__] = ACTIONS(1173),
    [anon_sym___asm] = ACTIONS(1173),
    [sym_number_literal] = ACTIONS(1175),
    [anon_sym_L_SQUOTE] = ACTIONS(1175),
    [anon_sym_u_SQUOTE] = ACTIONS(1175),
    [anon_sym_U_SQUOTE] = ACTIONS(1175),
    [anon_sym_u8_SQUOTE] = ACTIONS(1175),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [anon_sym_L_DQUOTE] = ACTIONS(1175),
    [anon_sym_u_DQUOTE] = ACTIONS(1175),
    [anon_sym_U_DQUOTE] = ACTIONS(1175),
    [anon_sym_u8_DQUOTE] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [anon_sym_NULL] = ACTIONS(1173),
    [anon_sym_nullptr] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym_identifier] = ACTIONS(1209),
    [aux_sym_preproc_include_token1] = ACTIONS(1209),
    [aux_sym_preproc_def_token1] = ACTIONS(1209),
    [aux_sym_preproc_if_token1] = ACTIONS(1209),
    [aux_sym_preproc_if_token2] = ACTIONS(1209),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1209),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1209),
    [sym_preproc_directive] = ACTIONS(1209),
    [anon_sym_LPAREN2] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1209),
    [anon_sym_PLUS] = ACTIONS(1209),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1211),
    [anon_sym___extension__] = ACTIONS(1209),
    [anon_sym_typedef] = ACTIONS(1209),
    [anon_sym_extern] = ACTIONS(1209),
    [anon_sym___attribute__] = ACTIONS(1209),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1211),
    [anon_sym___declspec] = ACTIONS(1209),
    [anon_sym___cdecl] = ACTIONS(1209),
    [anon_sym___clrcall] = ACTIONS(1209),
    [anon_sym___stdcall] = ACTIONS(1209),
    [anon_sym___fastcall] = ACTIONS(1209),
    [anon_sym___thiscall] = ACTIONS(1209),
    [anon_sym___vectorcall] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1211),
    [anon_sym_signed] = ACTIONS(1209),
    [anon_sym_unsigned] = ACTIONS(1209),
    [anon_sym_long] = ACTIONS(1209),
    [anon_sym_short] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1209),
    [anon_sym_auto] = ACTIONS(1209),
    [anon_sym_register] = ACTIONS(1209),
    [anon_sym_inline] = ACTIONS(1209),
    [anon_sym___inline] = ACTIONS(1209),
    [anon_sym___inline__] = ACTIONS(1209),
    [anon_sym___forceinline] = ACTIONS(1209),
    [anon_sym_thread_local] = ACTIONS(1209),
    [anon_sym___thread] = ACTIONS(1209),
    [anon_sym_const] = ACTIONS(1209),
    [anon_sym_constexpr] = ACTIONS(1209),
    [anon_sym_volatile] = ACTIONS(1209),
    [anon_sym_restrict] = ACTIONS(1209),
    [anon_sym___restrict__] = ACTIONS(1209),
    [anon_sym__Atomic] = ACTIONS(1209),
    [anon_sym__Noreturn] = ACTIONS(1209),
    [anon_sym_noreturn] = ACTIONS(1209),
    [anon_sym__Nonnull] = ACTIONS(1209),
    [anon_sym_alignas] = ACTIONS(1209),
    [anon_sym__Alignas] = ACTIONS(1209),
    [sym_primitive_type] = ACTIONS(1209),
    [anon_sym_enum] = ACTIONS(1209),
    [anon_sym_struct] = ACTIONS(1209),
    [anon_sym_union] = ACTIONS(1209),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_else] = ACTIONS(1209),
    [anon_sym_switch] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1209),
    [anon_sym_default] = ACTIONS(1209),
    [anon_sym_while] = ACTIONS(1209),
    [anon_sym_do] = ACTIONS(1209),
    [anon_sym_for] = ACTIONS(1209),
    [anon_sym_return] = ACTIONS(1209),
    [anon_sym_break] = ACTIONS(1209),
    [anon_sym_continue] = ACTIONS(1209),
    [anon_sym_goto] = ACTIONS(1209),
    [anon_sym___try] = ACTIONS(1209),
    [anon_sym___leave] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_sizeof] = ACTIONS(1209),
    [anon_sym___alignof__] = ACTIONS(1209),
    [anon_sym___alignof] = ACTIONS(1209),
    [anon_sym__alignof] = ACTIONS(1209),
    [anon_sym_alignof] = ACTIONS(1209),
    [anon_sym__Alignof] = ACTIONS(1209),
    [anon_sym_offsetof] = ACTIONS(1209),
    [anon_sym__Generic] = ACTIONS(1209),
    [anon_sym_asm] = ACTIONS(1209),
    [anon_sym___asm__] = ACTIONS(1209),
    [anon_sym___asm] = ACTIONS(1209),
    [sym_number_literal] = ACTIONS(1211),
    [anon_sym_L_SQUOTE] = ACTIONS(1211),
    [anon_sym_u_SQUOTE] = ACTIONS(1211),
    [anon_sym_U_SQUOTE] = ACTIONS(1211),
    [anon_sym_u8_SQUOTE] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [anon_sym_L_DQUOTE] = ACTIONS(1211),
    [anon_sym_u_DQUOTE] = ACTIONS(1211),
    [anon_sym_U_DQUOTE] = ACTIONS(1211),
    [anon_sym_u8_DQUOTE] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(1211),
    [sym_true] = ACTIONS(1209),
    [sym_false] = ACTIONS(1209),
    [anon_sym_NULL] = ACTIONS(1209),
    [anon_sym_nullptr] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_identifier] = ACTIONS(1213),
    [aux_sym_preproc_include_token1] = ACTIONS(1213),
    [aux_sym_preproc_def_token1] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1213),
    [aux_sym_preproc_if_token2] = ACTIONS(1213),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1213),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1213),
    [sym_preproc_directive] = ACTIONS(1213),
    [anon_sym_LPAREN2] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1215),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1213),
    [anon_sym_extern] = ACTIONS(1213),
    [anon_sym___attribute__] = ACTIONS(1213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1215),
    [anon_sym___declspec] = ACTIONS(1213),
    [anon_sym___cdecl] = ACTIONS(1213),
    [anon_sym___clrcall] = ACTIONS(1213),
    [anon_sym___stdcall] = ACTIONS(1213),
    [anon_sym___fastcall] = ACTIONS(1213),
    [anon_sym___thiscall] = ACTIONS(1213),
    [anon_sym___vectorcall] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_signed] = ACTIONS(1213),
    [anon_sym_unsigned] = ACTIONS(1213),
    [anon_sym_long] = ACTIONS(1213),
    [anon_sym_short] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_auto] = ACTIONS(1213),
    [anon_sym_register] = ACTIONS(1213),
    [anon_sym_inline] = ACTIONS(1213),
    [anon_sym___inline] = ACTIONS(1213),
    [anon_sym___inline__] = ACTIONS(1213),
    [anon_sym___forceinline] = ACTIONS(1213),
    [anon_sym_thread_local] = ACTIONS(1213),
    [anon_sym___thread] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1213),
    [anon_sym_constexpr] = ACTIONS(1213),
    [anon_sym_volatile] = ACTIONS(1213),
    [anon_sym_restrict] = ACTIONS(1213),
    [anon_sym___restrict__] = ACTIONS(1213),
    [anon_sym__Atomic] = ACTIONS(1213),
    [anon_sym__Noreturn] = ACTIONS(1213),
    [anon_sym_noreturn] = ACTIONS(1213),
    [anon_sym__Nonnull] = ACTIONS(1213),
    [anon_sym_alignas] = ACTIONS(1213),
    [anon_sym__Alignas] = ACTIONS(1213),
    [sym_primitive_type] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1213),
    [anon_sym_struct] = ACTIONS(1213),
    [anon_sym_union] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1213),
    [anon_sym_else] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1213),
    [anon_sym_default] = ACTIONS(1213),
    [anon_sym_while] = ACTIONS(1213),
    [anon_sym_do] = ACTIONS(1213),
    [anon_sym_for] = ACTIONS(1213),
    [anon_sym_return] = ACTIONS(1213),
    [anon_sym_break] = ACTIONS(1213),
    [anon_sym_continue] = ACTIONS(1213),
    [anon_sym_goto] = ACTIONS(1213),
    [anon_sym___try] = ACTIONS(1213),
    [anon_sym___leave] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_sizeof] = ACTIONS(1213),
    [anon_sym___alignof__] = ACTIONS(1213),
    [anon_sym___alignof] = ACTIONS(1213),
    [anon_sym__alignof] = ACTIONS(1213),
    [anon_sym_alignof] = ACTIONS(1213),
    [anon_sym__Alignof] = ACTIONS(1213),
    [anon_sym_offsetof] = ACTIONS(1213),
    [anon_sym__Generic] = ACTIONS(1213),
    [anon_sym_asm] = ACTIONS(1213),
    [anon_sym___asm__] = ACTIONS(1213),
    [anon_sym___asm] = ACTIONS(1213),
    [sym_number_literal] = ACTIONS(1215),
    [anon_sym_L_SQUOTE] = ACTIONS(1215),
    [anon_sym_u_SQUOTE] = ACTIONS(1215),
    [anon_sym_U_SQUOTE] = ACTIONS(1215),
    [anon_sym_u8_SQUOTE] = ACTIONS(1215),
    [anon_sym_SQUOTE] = ACTIONS(1215),
    [anon_sym_L_DQUOTE] = ACTIONS(1215),
    [anon_sym_u_DQUOTE] = ACTIONS(1215),
    [anon_sym_U_DQUOTE] = ACTIONS(1215),
    [anon_sym_u8_DQUOTE] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1215),
    [sym_true] = ACTIONS(1213),
    [sym_false] = ACTIONS(1213),
    [anon_sym_NULL] = ACTIONS(1213),
    [anon_sym_nullptr] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_identifier] = ACTIONS(1217),
    [aux_sym_preproc_include_token1] = ACTIONS(1217),
    [aux_sym_preproc_def_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token2] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1217),
    [sym_preproc_directive] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1219),
    [anon_sym_AMP] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym___extension__] = ACTIONS(1217),
    [anon_sym_typedef] = ACTIONS(1217),
    [anon_sym_extern] = ACTIONS(1217),
    [anon_sym___attribute__] = ACTIONS(1217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1219),
    [anon_sym___declspec] = ACTIONS(1217),
    [anon_sym___cdecl] = ACTIONS(1217),
    [anon_sym___clrcall] = ACTIONS(1217),
    [anon_sym___stdcall] = ACTIONS(1217),
    [anon_sym___fastcall] = ACTIONS(1217),
    [anon_sym___thiscall] = ACTIONS(1217),
    [anon_sym___vectorcall] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_signed] = ACTIONS(1217),
    [anon_sym_unsigned] = ACTIONS(1217),
    [anon_sym_long] = ACTIONS(1217),
    [anon_sym_short] = ACTIONS(1217),
    [anon_sym_static] = ACTIONS(1217),
    [anon_sym_auto] = ACTIONS(1217),
    [anon_sym_register] = ACTIONS(1217),
    [anon_sym_inline] = ACTIONS(1217),
    [anon_sym___inline] = ACTIONS(1217),
    [anon_sym___inline__] = ACTIONS(1217),
    [anon_sym___forceinline] = ACTIONS(1217),
    [anon_sym_thread_local] = ACTIONS(1217),
    [anon_sym___thread] = ACTIONS(1217),
    [anon_sym_const] = ACTIONS(1217),
    [anon_sym_constexpr] = ACTIONS(1217),
    [anon_sym_volatile] = ACTIONS(1217),
    [anon_sym_restrict] = ACTIONS(1217),
    [anon_sym___restrict__] = ACTIONS(1217),
    [anon_sym__Atomic] = ACTIONS(1217),
    [anon_sym__Noreturn] = ACTIONS(1217),
    [anon_sym_noreturn] = ACTIONS(1217),
    [anon_sym__Nonnull] = ACTIONS(1217),
    [anon_sym_alignas] = ACTIONS(1217),
    [anon_sym__Alignas] = ACTIONS(1217),
    [sym_primitive_type] = ACTIONS(1217),
    [anon_sym_enum] = ACTIONS(1217),
    [anon_sym_struct] = ACTIONS(1217),
    [anon_sym_union] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1217),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(1217),
    [anon_sym_case] = ACTIONS(1217),
    [anon_sym_default] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(1217),
    [anon_sym_do] = ACTIONS(1217),
    [anon_sym_for] = ACTIONS(1217),
    [anon_sym_return] = ACTIONS(1217),
    [anon_sym_break] = ACTIONS(1217),
    [anon_sym_continue] = ACTIONS(1217),
    [anon_sym_goto] = ACTIONS(1217),
    [anon_sym___try] = ACTIONS(1217),
    [anon_sym___leave] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1219),
    [anon_sym_sizeof] = ACTIONS(1217),
    [anon_sym___alignof__] = ACTIONS(1217),
    [anon_sym___alignof] = ACTIONS(1217),
    [anon_sym__alignof] = ACTIONS(1217),
    [anon_sym_alignof] = ACTIONS(1217),
    [anon_sym__Alignof] = ACTIONS(1217),
    [anon_sym_offsetof] = ACTIONS(1217),
    [anon_sym__Generic] = ACTIONS(1217),
    [anon_sym_asm] = ACTIONS(1217),
    [anon_sym___asm__] = ACTIONS(1217),
    [anon_sym___asm] = ACTIONS(1217),
    [sym_number_literal] = ACTIONS(1219),
    [anon_sym_L_SQUOTE] = ACTIONS(1219),
    [anon_sym_u_SQUOTE] = ACTIONS(1219),
    [anon_sym_U_SQUOTE] = ACTIONS(1219),
    [anon_sym_u8_SQUOTE] = ACTIONS(1219),
    [anon_sym_SQUOTE] = ACTIONS(1219),
    [anon_sym_L_DQUOTE] = ACTIONS(1219),
    [anon_sym_u_DQUOTE] = ACTIONS(1219),
    [anon_sym_U_DQUOTE] = ACTIONS(1219),
    [anon_sym_u8_DQUOTE] = ACTIONS(1219),
    [anon_sym_DQUOTE] = ACTIONS(1219),
    [sym_true] = ACTIONS(1217),
    [sym_false] = ACTIONS(1217),
    [anon_sym_NULL] = ACTIONS(1217),
    [anon_sym_nullptr] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_identifier] = ACTIONS(1221),
    [aux_sym_preproc_include_token1] = ACTIONS(1221),
    [aux_sym_preproc_def_token1] = ACTIONS(1221),
    [aux_sym_preproc_if_token1] = ACTIONS(1221),
    [aux_sym_preproc_if_token2] = ACTIONS(1221),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1221),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1221),
    [sym_preproc_directive] = ACTIONS(1221),
    [anon_sym_LPAREN2] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym___extension__] = ACTIONS(1221),
    [anon_sym_typedef] = ACTIONS(1221),
    [anon_sym_extern] = ACTIONS(1221),
    [anon_sym___attribute__] = ACTIONS(1221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1223),
    [anon_sym___declspec] = ACTIONS(1221),
    [anon_sym___cdecl] = ACTIONS(1221),
    [anon_sym___clrcall] = ACTIONS(1221),
    [anon_sym___stdcall] = ACTIONS(1221),
    [anon_sym___fastcall] = ACTIONS(1221),
    [anon_sym___thiscall] = ACTIONS(1221),
    [anon_sym___vectorcall] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_signed] = ACTIONS(1221),
    [anon_sym_unsigned] = ACTIONS(1221),
    [anon_sym_long] = ACTIONS(1221),
    [anon_sym_short] = ACTIONS(1221),
    [anon_sym_static] = ACTIONS(1221),
    [anon_sym_auto] = ACTIONS(1221),
    [anon_sym_register] = ACTIONS(1221),
    [anon_sym_inline] = ACTIONS(1221),
    [anon_sym___inline] = ACTIONS(1221),
    [anon_sym___inline__] = ACTIONS(1221),
    [anon_sym___forceinline] = ACTIONS(1221),
    [anon_sym_thread_local] = ACTIONS(1221),
    [anon_sym___thread] = ACTIONS(1221),
    [anon_sym_const] = ACTIONS(1221),
    [anon_sym_constexpr] = ACTIONS(1221),
    [anon_sym_volatile] = ACTIONS(1221),
    [anon_sym_restrict] = ACTIONS(1221),
    [anon_sym___restrict__] = ACTIONS(1221),
    [anon_sym__Atomic] = ACTIONS(1221),
    [anon_sym__Noreturn] = ACTIONS(1221),
    [anon_sym_noreturn] = ACTIONS(1221),
    [anon_sym__Nonnull] = ACTIONS(1221),
    [anon_sym_alignas] = ACTIONS(1221),
    [anon_sym__Alignas] = ACTIONS(1221),
    [sym_primitive_type] = ACTIONS(1221),
    [anon_sym_enum] = ACTIONS(1221),
    [anon_sym_struct] = ACTIONS(1221),
    [anon_sym_union] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1221),
    [anon_sym_else] = ACTIONS(1221),
    [anon_sym_switch] = ACTIONS(1221),
    [anon_sym_case] = ACTIONS(1221),
    [anon_sym_default] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1221),
    [anon_sym_do] = ACTIONS(1221),
    [anon_sym_for] = ACTIONS(1221),
    [anon_sym_return] = ACTIONS(1221),
    [anon_sym_break] = ACTIONS(1221),
    [anon_sym_continue] = ACTIONS(1221),
    [anon_sym_goto] = ACTIONS(1221),
    [anon_sym___try] = ACTIONS(1221),
    [anon_sym___leave] = ACTIONS(1221),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_sizeof] = ACTIONS(1221),
    [anon_sym___alignof__] = ACTIONS(1221),
    [anon_sym___alignof] = ACTIONS(1221),
    [anon_sym__alignof] = ACTIONS(1221),
    [anon_sym_alignof] = ACTIONS(1221),
    [anon_sym__Alignof] = ACTIONS(1221),
    [anon_sym_offsetof] = ACTIONS(1221),
    [anon_sym__Generic] = ACTIONS(1221),
    [anon_sym_asm] = ACTIONS(1221),
    [anon_sym___asm__] = ACTIONS(1221),
    [anon_sym___asm] = ACTIONS(1221),
    [sym_number_literal] = ACTIONS(1223),
    [anon_sym_L_SQUOTE] = ACTIONS(1223),
    [anon_sym_u_SQUOTE] = ACTIONS(1223),
    [anon_sym_U_SQUOTE] = ACTIONS(1223),
    [anon_sym_u8_SQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [anon_sym_L_DQUOTE] = ACTIONS(1223),
    [anon_sym_u_DQUOTE] = ACTIONS(1223),
    [anon_sym_U_DQUOTE] = ACTIONS(1223),
    [anon_sym_u8_DQUOTE] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [anon_sym_NULL] = ACTIONS(1221),
    [anon_sym_nullptr] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_identifier] = ACTIONS(1225),
    [aux_sym_preproc_include_token1] = ACTIONS(1225),
    [aux_sym_preproc_def_token1] = ACTIONS(1225),
    [aux_sym_preproc_if_token1] = ACTIONS(1225),
    [aux_sym_preproc_if_token2] = ACTIONS(1225),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1225),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1225),
    [sym_preproc_directive] = ACTIONS(1225),
    [anon_sym_LPAREN2] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym___extension__] = ACTIONS(1225),
    [anon_sym_typedef] = ACTIONS(1225),
    [anon_sym_extern] = ACTIONS(1225),
    [anon_sym___attribute__] = ACTIONS(1225),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1227),
    [anon_sym___declspec] = ACTIONS(1225),
    [anon_sym___cdecl] = ACTIONS(1225),
    [anon_sym___clrcall] = ACTIONS(1225),
    [anon_sym___stdcall] = ACTIONS(1225),
    [anon_sym___fastcall] = ACTIONS(1225),
    [anon_sym___thiscall] = ACTIONS(1225),
    [anon_sym___vectorcall] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_signed] = ACTIONS(1225),
    [anon_sym_unsigned] = ACTIONS(1225),
    [anon_sym_long] = ACTIONS(1225),
    [anon_sym_short] = ACTIONS(1225),
    [anon_sym_static] = ACTIONS(1225),
    [anon_sym_auto] = ACTIONS(1225),
    [anon_sym_register] = ACTIONS(1225),
    [anon_sym_inline] = ACTIONS(1225),
    [anon_sym___inline] = ACTIONS(1225),
    [anon_sym___inline__] = ACTIONS(1225),
    [anon_sym___forceinline] = ACTIONS(1225),
    [anon_sym_thread_local] = ACTIONS(1225),
    [anon_sym___thread] = ACTIONS(1225),
    [anon_sym_const] = ACTIONS(1225),
    [anon_sym_constexpr] = ACTIONS(1225),
    [anon_sym_volatile] = ACTIONS(1225),
    [anon_sym_restrict] = ACTIONS(1225),
    [anon_sym___restrict__] = ACTIONS(1225),
    [anon_sym__Atomic] = ACTIONS(1225),
    [anon_sym__Noreturn] = ACTIONS(1225),
    [anon_sym_noreturn] = ACTIONS(1225),
    [anon_sym__Nonnull] = ACTIONS(1225),
    [anon_sym_alignas] = ACTIONS(1225),
    [anon_sym__Alignas] = ACTIONS(1225),
    [sym_primitive_type] = ACTIONS(1225),
    [anon_sym_enum] = ACTIONS(1225),
    [anon_sym_struct] = ACTIONS(1225),
    [anon_sym_union] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1225),
    [anon_sym_else] = ACTIONS(1225),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1225),
    [anon_sym_default] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1225),
    [anon_sym_do] = ACTIONS(1225),
    [anon_sym_for] = ACTIONS(1225),
    [anon_sym_return] = ACTIONS(1225),
    [anon_sym_break] = ACTIONS(1225),
    [anon_sym_continue] = ACTIONS(1225),
    [anon_sym_goto] = ACTIONS(1225),
    [anon_sym___try] = ACTIONS(1225),
    [anon_sym___leave] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1225),
    [anon_sym___alignof__] = ACTIONS(1225),
    [anon_sym___alignof] = ACTIONS(1225),
    [anon_sym__alignof] = ACTIONS(1225),
    [anon_sym_alignof] = ACTIONS(1225),
    [anon_sym__Alignof] = ACTIONS(1225),
    [anon_sym_offsetof] = ACTIONS(1225),
    [anon_sym__Generic] = ACTIONS(1225),
    [anon_sym_asm] = ACTIONS(1225),
    [anon_sym___asm__] = ACTIONS(1225),
    [anon_sym___asm] = ACTIONS(1225),
    [sym_number_literal] = ACTIONS(1227),
    [anon_sym_L_SQUOTE] = ACTIONS(1227),
    [anon_sym_u_SQUOTE] = ACTIONS(1227),
    [anon_sym_U_SQUOTE] = ACTIONS(1227),
    [anon_sym_u8_SQUOTE] = ACTIONS(1227),
    [anon_sym_SQUOTE] = ACTIONS(1227),
    [anon_sym_L_DQUOTE] = ACTIONS(1227),
    [anon_sym_u_DQUOTE] = ACTIONS(1227),
    [anon_sym_U_DQUOTE] = ACTIONS(1227),
    [anon_sym_u8_DQUOTE] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1227),
    [sym_true] = ACTIONS(1225),
    [sym_false] = ACTIONS(1225),
    [anon_sym_NULL] = ACTIONS(1225),
    [anon_sym_nullptr] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [sym_identifier] = ACTIONS(1229),
    [aux_sym_preproc_include_token1] = ACTIONS(1229),
    [aux_sym_preproc_def_token1] = ACTIONS(1229),
    [aux_sym_preproc_if_token1] = ACTIONS(1229),
    [aux_sym_preproc_if_token2] = ACTIONS(1229),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1229),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1229),
    [sym_preproc_directive] = ACTIONS(1229),
    [anon_sym_LPAREN2] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_TILDE] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym___extension__] = ACTIONS(1229),
    [anon_sym_typedef] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(1229),
    [anon_sym___attribute__] = ACTIONS(1229),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(1229),
    [anon_sym___cdecl] = ACTIONS(1229),
    [anon_sym___clrcall] = ACTIONS(1229),
    [anon_sym___stdcall] = ACTIONS(1229),
    [anon_sym___fastcall] = ACTIONS(1229),
    [anon_sym___thiscall] = ACTIONS(1229),
    [anon_sym___vectorcall] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1231),
    [anon_sym_signed] = ACTIONS(1229),
    [anon_sym_unsigned] = ACTIONS(1229),
    [anon_sym_long] = ACTIONS(1229),
    [anon_sym_short] = ACTIONS(1229),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_auto] = ACTIONS(1229),
    [anon_sym_register] = ACTIONS(1229),
    [anon_sym_inline] = ACTIONS(1229),
    [anon_sym___inline] = ACTIONS(1229),
    [anon_sym___inline__] = ACTIONS(1229),
    [anon_sym___forceinline] = ACTIONS(1229),
    [anon_sym_thread_local] = ACTIONS(1229),
    [anon_sym___thread] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(1229),
    [anon_sym_constexpr] = ACTIONS(1229),
    [anon_sym_volatile] = ACTIONS(1229),
    [anon_sym_restrict] = ACTIONS(1229),
    [anon_sym___restrict__] = ACTIONS(1229),
    [anon_sym__Atomic] = ACTIONS(1229),
    [anon_sym__Noreturn] = ACTIONS(1229),
    [anon_sym_noreturn] = ACTIONS(1229),
    [anon_sym__Nonnull] = ACTIONS(1229),
    [anon_sym_alignas] = ACTIONS(1229),
    [anon_sym__Alignas] = ACTIONS(1229),
    [sym_primitive_type] = ACTIONS(1229),
    [anon_sym_enum] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1229),
    [anon_sym_union] = ACTIONS(1229),
    [anon_sym_if] = ACTIONS(1229),
    [anon_sym_else] = ACTIONS(1229),
    [anon_sym_switch] = ACTIONS(1229),
    [anon_sym_case] = ACTIONS(1229),
    [anon_sym_default] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1229),
    [anon_sym_do] = ACTIONS(1229),
    [anon_sym_for] = ACTIONS(1229),
    [anon_sym_return] = ACTIONS(1229),
    [anon_sym_break] = ACTIONS(1229),
    [anon_sym_continue] = ACTIONS(1229),
    [anon_sym_goto] = ACTIONS(1229),
    [anon_sym___try] = ACTIONS(1229),
    [anon_sym___leave] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1231),
    [anon_sym_sizeof] = ACTIONS(1229),
    [anon_sym___alignof__] = ACTIONS(1229),
    [anon_sym___alignof] = ACTIONS(1229),
    [anon_sym__alignof] = ACTIONS(1229),
    [anon_sym_alignof] = ACTIONS(1229),
    [anon_sym__Alignof] = ACTIONS(1229),
    [anon_sym_offsetof] = ACTIONS(1229),
    [anon_sym__Generic] = ACTIONS(1229),
    [anon_sym_asm] = ACTIONS(1229),
    [anon_sym___asm__] = ACTIONS(1229),
    [anon_sym___asm] = ACTIONS(1229),
    [sym_number_literal] = ACTIONS(1231),
    [anon_sym_L_SQUOTE] = ACTIONS(1231),
    [anon_sym_u_SQUOTE] = ACTIONS(1231),
    [anon_sym_U_SQUOTE] = ACTIONS(1231),
    [anon_sym_u8_SQUOTE] = ACTIONS(1231),
    [anon_sym_SQUOTE] = ACTIONS(1231),
    [anon_sym_L_DQUOTE] = ACTIONS(1231),
    [anon_sym_u_DQUOTE] = ACTIONS(1231),
    [anon_sym_U_DQUOTE] = ACTIONS(1231),
    [anon_sym_u8_DQUOTE] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1231),
    [sym_true] = ACTIONS(1229),
    [sym_false] = ACTIONS(1229),
    [anon_sym_NULL] = ACTIONS(1229),
    [anon_sym_nullptr] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token2] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym__Nonnull] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [anon_sym___asm] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token2] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym__Nonnull] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [anon_sym___asm] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym_identifier] = ACTIONS(1189),
    [aux_sym_preproc_include_token1] = ACTIONS(1189),
    [aux_sym_preproc_def_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token2] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1189),
    [sym_preproc_directive] = ACTIONS(1189),
    [anon_sym_LPAREN2] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym___extension__] = ACTIONS(1189),
    [anon_sym_typedef] = ACTIONS(1189),
    [anon_sym_extern] = ACTIONS(1189),
    [anon_sym___attribute__] = ACTIONS(1189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1191),
    [anon_sym___declspec] = ACTIONS(1189),
    [anon_sym___cdecl] = ACTIONS(1189),
    [anon_sym___clrcall] = ACTIONS(1189),
    [anon_sym___stdcall] = ACTIONS(1189),
    [anon_sym___fastcall] = ACTIONS(1189),
    [anon_sym___thiscall] = ACTIONS(1189),
    [anon_sym___vectorcall] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_signed] = ACTIONS(1189),
    [anon_sym_unsigned] = ACTIONS(1189),
    [anon_sym_long] = ACTIONS(1189),
    [anon_sym_short] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_auto] = ACTIONS(1189),
    [anon_sym_register] = ACTIONS(1189),
    [anon_sym_inline] = ACTIONS(1189),
    [anon_sym___inline] = ACTIONS(1189),
    [anon_sym___inline__] = ACTIONS(1189),
    [anon_sym___forceinline] = ACTIONS(1189),
    [anon_sym_thread_local] = ACTIONS(1189),
    [anon_sym___thread] = ACTIONS(1189),
    [anon_sym_const] = ACTIONS(1189),
    [anon_sym_constexpr] = ACTIONS(1189),
    [anon_sym_volatile] = ACTIONS(1189),
    [anon_sym_restrict] = ACTIONS(1189),
    [anon_sym___restrict__] = ACTIONS(1189),
    [anon_sym__Atomic] = ACTIONS(1189),
    [anon_sym__Noreturn] = ACTIONS(1189),
    [anon_sym_noreturn] = ACTIONS(1189),
    [anon_sym__Nonnull] = ACTIONS(1189),
    [anon_sym_alignas] = ACTIONS(1189),
    [anon_sym__Alignas] = ACTIONS(1189),
    [sym_primitive_type] = ACTIONS(1189),
    [anon_sym_enum] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1189),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_do] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [anon_sym_goto] = ACTIONS(1189),
    [anon_sym___try] = ACTIONS(1189),
    [anon_sym___leave] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_sizeof] = ACTIONS(1189),
    [anon_sym___alignof__] = ACTIONS(1189),
    [anon_sym___alignof] = ACTIONS(1189),
    [anon_sym__alignof] = ACTIONS(1189),
    [anon_sym_alignof] = ACTIONS(1189),
    [anon_sym__Alignof] = ACTIONS(1189),
    [anon_sym_offsetof] = ACTIONS(1189),
    [anon_sym__Generic] = ACTIONS(1189),
    [anon_sym_asm] = ACTIONS(1189),
    [anon_sym___asm__] = ACTIONS(1189),
    [anon_sym___asm] = ACTIONS(1189),
    [sym_number_literal] = ACTIONS(1191),
    [anon_sym_L_SQUOTE] = ACTIONS(1191),
    [anon_sym_u_SQUOTE] = ACTIONS(1191),
    [anon_sym_U_SQUOTE] = ACTIONS(1191),
    [anon_sym_u8_SQUOTE] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [anon_sym_L_DQUOTE] = ACTIONS(1191),
    [anon_sym_u_DQUOTE] = ACTIONS(1191),
    [anon_sym_U_DQUOTE] = ACTIONS(1191),
    [anon_sym_u8_DQUOTE] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [sym_true] = ACTIONS(1189),
    [sym_false] = ACTIONS(1189),
    [anon_sym_NULL] = ACTIONS(1189),
    [anon_sym_nullptr] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_identifier] = ACTIONS(1189),
    [aux_sym_preproc_include_token1] = ACTIONS(1189),
    [aux_sym_preproc_def_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token2] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1189),
    [sym_preproc_directive] = ACTIONS(1189),
    [anon_sym_LPAREN2] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym___extension__] = ACTIONS(1189),
    [anon_sym_typedef] = ACTIONS(1189),
    [anon_sym_extern] = ACTIONS(1189),
    [anon_sym___attribute__] = ACTIONS(1189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1191),
    [anon_sym___declspec] = ACTIONS(1189),
    [anon_sym___cdecl] = ACTIONS(1189),
    [anon_sym___clrcall] = ACTIONS(1189),
    [anon_sym___stdcall] = ACTIONS(1189),
    [anon_sym___fastcall] = ACTIONS(1189),
    [anon_sym___thiscall] = ACTIONS(1189),
    [anon_sym___vectorcall] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_signed] = ACTIONS(1189),
    [anon_sym_unsigned] = ACTIONS(1189),
    [anon_sym_long] = ACTIONS(1189),
    [anon_sym_short] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_auto] = ACTIONS(1189),
    [anon_sym_register] = ACTIONS(1189),
    [anon_sym_inline] = ACTIONS(1189),
    [anon_sym___inline] = ACTIONS(1189),
    [anon_sym___inline__] = ACTIONS(1189),
    [anon_sym___forceinline] = ACTIONS(1189),
    [anon_sym_thread_local] = ACTIONS(1189),
    [anon_sym___thread] = ACTIONS(1189),
    [anon_sym_const] = ACTIONS(1189),
    [anon_sym_constexpr] = ACTIONS(1189),
    [anon_sym_volatile] = ACTIONS(1189),
    [anon_sym_restrict] = ACTIONS(1189),
    [anon_sym___restrict__] = ACTIONS(1189),
    [anon_sym__Atomic] = ACTIONS(1189),
    [anon_sym__Noreturn] = ACTIONS(1189),
    [anon_sym_noreturn] = ACTIONS(1189),
    [anon_sym__Nonnull] = ACTIONS(1189),
    [anon_sym_alignas] = ACTIONS(1189),
    [anon_sym__Alignas] = ACTIONS(1189),
    [sym_primitive_type] = ACTIONS(1189),
    [anon_sym_enum] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1189),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_do] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [anon_sym_goto] = ACTIONS(1189),
    [anon_sym___try] = ACTIONS(1189),
    [anon_sym___leave] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_sizeof] = ACTIONS(1189),
    [anon_sym___alignof__] = ACTIONS(1189),
    [anon_sym___alignof] = ACTIONS(1189),
    [anon_sym__alignof] = ACTIONS(1189),
    [anon_sym_alignof] = ACTIONS(1189),
    [anon_sym__Alignof] = ACTIONS(1189),
    [anon_sym_offsetof] = ACTIONS(1189),
    [anon_sym__Generic] = ACTIONS(1189),
    [anon_sym_asm] = ACTIONS(1189),
    [anon_sym___asm__] = ACTIONS(1189),
    [anon_sym___asm] = ACTIONS(1189),
    [sym_number_literal] = ACTIONS(1191),
    [anon_sym_L_SQUOTE] = ACTIONS(1191),
    [anon_sym_u_SQUOTE] = ACTIONS(1191),
    [anon_sym_U_SQUOTE] = ACTIONS(1191),
    [anon_sym_u8_SQUOTE] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [anon_sym_L_DQUOTE] = ACTIONS(1191),
    [anon_sym_u_DQUOTE] = ACTIONS(1191),
    [anon_sym_U_DQUOTE] = ACTIONS(1191),
    [anon_sym_u8_DQUOTE] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [sym_true] = ACTIONS(1189),
    [sym_false] = ACTIONS(1189),
    [anon_sym_NULL] = ACTIONS(1189),
    [anon_sym_nullptr] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1201),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token2] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1201),
    [sym_preproc_directive] = ACTIONS(1201),
    [anon_sym_LPAREN2] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym___extension__] = ACTIONS(1201),
    [anon_sym_typedef] = ACTIONS(1201),
    [anon_sym_extern] = ACTIONS(1201),
    [anon_sym___attribute__] = ACTIONS(1201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1203),
    [anon_sym___declspec] = ACTIONS(1201),
    [anon_sym___cdecl] = ACTIONS(1201),
    [anon_sym___clrcall] = ACTIONS(1201),
    [anon_sym___stdcall] = ACTIONS(1201),
    [anon_sym___fastcall] = ACTIONS(1201),
    [anon_sym___thiscall] = ACTIONS(1201),
    [anon_sym___vectorcall] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_signed] = ACTIONS(1201),
    [anon_sym_unsigned] = ACTIONS(1201),
    [anon_sym_long] = ACTIONS(1201),
    [anon_sym_short] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_auto] = ACTIONS(1201),
    [anon_sym_register] = ACTIONS(1201),
    [anon_sym_inline] = ACTIONS(1201),
    [anon_sym___inline] = ACTIONS(1201),
    [anon_sym___inline__] = ACTIONS(1201),
    [anon_sym___forceinline] = ACTIONS(1201),
    [anon_sym_thread_local] = ACTIONS(1201),
    [anon_sym___thread] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_constexpr] = ACTIONS(1201),
    [anon_sym_volatile] = ACTIONS(1201),
    [anon_sym_restrict] = ACTIONS(1201),
    [anon_sym___restrict__] = ACTIONS(1201),
    [anon_sym__Atomic] = ACTIONS(1201),
    [anon_sym__Noreturn] = ACTIONS(1201),
    [anon_sym_noreturn] = ACTIONS(1201),
    [anon_sym__Nonnull] = ACTIONS(1201),
    [anon_sym_alignas] = ACTIONS(1201),
    [anon_sym__Alignas] = ACTIONS(1201),
    [sym_primitive_type] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1201),
    [anon_sym_union] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_goto] = ACTIONS(1201),
    [anon_sym___try] = ACTIONS(1201),
    [anon_sym___leave] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1203),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym___alignof__] = ACTIONS(1201),
    [anon_sym___alignof] = ACTIONS(1201),
    [anon_sym__alignof] = ACTIONS(1201),
    [anon_sym_alignof] = ACTIONS(1201),
    [anon_sym__Alignof] = ACTIONS(1201),
    [anon_sym_offsetof] = ACTIONS(1201),
    [anon_sym__Generic] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1201),
    [anon_sym___asm__] = ACTIONS(1201),
    [anon_sym___asm] = ACTIONS(1201),
    [sym_number_literal] = ACTIONS(1203),
    [anon_sym_L_SQUOTE] = ACTIONS(1203),
    [anon_sym_u_SQUOTE] = ACTIONS(1203),
    [anon_sym_U_SQUOTE] = ACTIONS(1203),
    [anon_sym_u8_SQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [anon_sym_L_DQUOTE] = ACTIONS(1203),
    [anon_sym_u_DQUOTE] = ACTIONS(1203),
    [anon_sym_U_DQUOTE] = ACTIONS(1203),
    [anon_sym_u8_DQUOTE] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [anon_sym_NULL] = ACTIONS(1201),
    [anon_sym_nullptr] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1201),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token2] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1201),
    [sym_preproc_directive] = ACTIONS(1201),
    [anon_sym_LPAREN2] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym___extension__] = ACTIONS(1201),
    [anon_sym_typedef] = ACTIONS(1201),
    [anon_sym_extern] = ACTIONS(1201),
    [anon_sym___attribute__] = ACTIONS(1201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1203),
    [anon_sym___declspec] = ACTIONS(1201),
    [anon_sym___cdecl] = ACTIONS(1201),
    [anon_sym___clrcall] = ACTIONS(1201),
    [anon_sym___stdcall] = ACTIONS(1201),
    [anon_sym___fastcall] = ACTIONS(1201),
    [anon_sym___thiscall] = ACTIONS(1201),
    [anon_sym___vectorcall] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_signed] = ACTIONS(1201),
    [anon_sym_unsigned] = ACTIONS(1201),
    [anon_sym_long] = ACTIONS(1201),
    [anon_sym_short] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_auto] = ACTIONS(1201),
    [anon_sym_register] = ACTIONS(1201),
    [anon_sym_inline] = ACTIONS(1201),
    [anon_sym___inline] = ACTIONS(1201),
    [anon_sym___inline__] = ACTIONS(1201),
    [anon_sym___forceinline] = ACTIONS(1201),
    [anon_sym_thread_local] = ACTIONS(1201),
    [anon_sym___thread] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_constexpr] = ACTIONS(1201),
    [anon_sym_volatile] = ACTIONS(1201),
    [anon_sym_restrict] = ACTIONS(1201),
    [anon_sym___restrict__] = ACTIONS(1201),
    [anon_sym__Atomic] = ACTIONS(1201),
    [anon_sym__Noreturn] = ACTIONS(1201),
    [anon_sym_noreturn] = ACTIONS(1201),
    [anon_sym__Nonnull] = ACTIONS(1201),
    [anon_sym_alignas] = ACTIONS(1201),
    [anon_sym__Alignas] = ACTIONS(1201),
    [sym_primitive_type] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1201),
    [anon_sym_union] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_goto] = ACTIONS(1201),
    [anon_sym___try] = ACTIONS(1201),
    [anon_sym___leave] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1203),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym___alignof__] = ACTIONS(1201),
    [anon_sym___alignof] = ACTIONS(1201),
    [anon_sym__alignof] = ACTIONS(1201),
    [anon_sym_alignof] = ACTIONS(1201),
    [anon_sym__Alignof] = ACTIONS(1201),
    [anon_sym_offsetof] = ACTIONS(1201),
    [anon_sym__Generic] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1201),
    [anon_sym___asm__] = ACTIONS(1201),
    [anon_sym___asm] = ACTIONS(1201),
    [sym_number_literal] = ACTIONS(1203),
    [anon_sym_L_SQUOTE] = ACTIONS(1203),
    [anon_sym_u_SQUOTE] = ACTIONS(1203),
    [anon_sym_U_SQUOTE] = ACTIONS(1203),
    [anon_sym_u8_SQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [anon_sym_L_DQUOTE] = ACTIONS(1203),
    [anon_sym_u_DQUOTE] = ACTIONS(1203),
    [anon_sym_U_DQUOTE] = ACTIONS(1203),
    [anon_sym_u8_DQUOTE] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [anon_sym_NULL] = ACTIONS(1201),
    [anon_sym_nullptr] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1205),
    [aux_sym_preproc_def_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token2] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1205),
    [sym_preproc_directive] = ACTIONS(1205),
    [anon_sym_LPAREN2] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(1205),
    [anon_sym_typedef] = ACTIONS(1205),
    [anon_sym_extern] = ACTIONS(1205),
    [anon_sym___attribute__] = ACTIONS(1205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1207),
    [anon_sym___declspec] = ACTIONS(1205),
    [anon_sym___cdecl] = ACTIONS(1205),
    [anon_sym___clrcall] = ACTIONS(1205),
    [anon_sym___stdcall] = ACTIONS(1205),
    [anon_sym___fastcall] = ACTIONS(1205),
    [anon_sym___thiscall] = ACTIONS(1205),
    [anon_sym___vectorcall] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_signed] = ACTIONS(1205),
    [anon_sym_unsigned] = ACTIONS(1205),
    [anon_sym_long] = ACTIONS(1205),
    [anon_sym_short] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_auto] = ACTIONS(1205),
    [anon_sym_register] = ACTIONS(1205),
    [anon_sym_inline] = ACTIONS(1205),
    [anon_sym___inline] = ACTIONS(1205),
    [anon_sym___inline__] = ACTIONS(1205),
    [anon_sym___forceinline] = ACTIONS(1205),
    [anon_sym_thread_local] = ACTIONS(1205),
    [anon_sym___thread] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_constexpr] = ACTIONS(1205),
    [anon_sym_volatile] = ACTIONS(1205),
    [anon_sym_restrict] = ACTIONS(1205),
    [anon_sym___restrict__] = ACTIONS(1205),
    [anon_sym__Atomic] = ACTIONS(1205),
    [anon_sym__Noreturn] = ACTIONS(1205),
    [anon_sym_noreturn] = ACTIONS(1205),
    [anon_sym__Nonnull] = ACTIONS(1205),
    [anon_sym_alignas] = ACTIONS(1205),
    [anon_sym__Alignas] = ACTIONS(1205),
    [sym_primitive_type] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_do] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_goto] = ACTIONS(1205),
    [anon_sym___try] = ACTIONS(1205),
    [anon_sym___leave] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1207),
    [anon_sym_sizeof] = ACTIONS(1205),
    [anon_sym___alignof__] = ACTIONS(1205),
    [anon_sym___alignof] = ACTIONS(1205),
    [anon_sym__alignof] = ACTIONS(1205),
    [anon_sym_alignof] = ACTIONS(1205),
    [anon_sym__Alignof] = ACTIONS(1205),
    [anon_sym_offsetof] = ACTIONS(1205),
    [anon_sym__Generic] = ACTIONS(1205),
    [anon_sym_asm] = ACTIONS(1205),
    [anon_sym___asm__] = ACTIONS(1205),
    [anon_sym___asm] = ACTIONS(1205),
    [sym_number_literal] = ACTIONS(1207),
    [anon_sym_L_SQUOTE] = ACTIONS(1207),
    [anon_sym_u_SQUOTE] = ACTIONS(1207),
    [anon_sym_U_SQUOTE] = ACTIONS(1207),
    [anon_sym_u8_SQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [anon_sym_L_DQUOTE] = ACTIONS(1207),
    [anon_sym_u_DQUOTE] = ACTIONS(1207),
    [anon_sym_U_DQUOTE] = ACTIONS(1207),
    [anon_sym_u8_DQUOTE] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [anon_sym_NULL] = ACTIONS(1205),
    [anon_sym_nullptr] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1205),
    [aux_sym_preproc_def_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token2] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1205),
    [sym_preproc_directive] = ACTIONS(1205),
    [anon_sym_LPAREN2] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(1205),
    [anon_sym_typedef] = ACTIONS(1205),
    [anon_sym_extern] = ACTIONS(1205),
    [anon_sym___attribute__] = ACTIONS(1205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1207),
    [anon_sym___declspec] = ACTIONS(1205),
    [anon_sym___cdecl] = ACTIONS(1205),
    [anon_sym___clrcall] = ACTIONS(1205),
    [anon_sym___stdcall] = ACTIONS(1205),
    [anon_sym___fastcall] = ACTIONS(1205),
    [anon_sym___thiscall] = ACTIONS(1205),
    [anon_sym___vectorcall] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_signed] = ACTIONS(1205),
    [anon_sym_unsigned] = ACTIONS(1205),
    [anon_sym_long] = ACTIONS(1205),
    [anon_sym_short] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_auto] = ACTIONS(1205),
    [anon_sym_register] = ACTIONS(1205),
    [anon_sym_inline] = ACTIONS(1205),
    [anon_sym___inline] = ACTIONS(1205),
    [anon_sym___inline__] = ACTIONS(1205),
    [anon_sym___forceinline] = ACTIONS(1205),
    [anon_sym_thread_local] = ACTIONS(1205),
    [anon_sym___thread] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_constexpr] = ACTIONS(1205),
    [anon_sym_volatile] = ACTIONS(1205),
    [anon_sym_restrict] = ACTIONS(1205),
    [anon_sym___restrict__] = ACTIONS(1205),
    [anon_sym__Atomic] = ACTIONS(1205),
    [anon_sym__Noreturn] = ACTIONS(1205),
    [anon_sym_noreturn] = ACTIONS(1205),
    [anon_sym__Nonnull] = ACTIONS(1205),
    [anon_sym_alignas] = ACTIONS(1205),
    [anon_sym__Alignas] = ACTIONS(1205),
    [sym_primitive_type] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_do] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_goto] = ACTIONS(1205),
    [anon_sym___try] = ACTIONS(1205),
    [anon_sym___leave] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1207),
    [anon_sym_sizeof] = ACTIONS(1205),
    [anon_sym___alignof__] = ACTIONS(1205),
    [anon_sym___alignof] = ACTIONS(1205),
    [anon_sym__alignof] = ACTIONS(1205),
    [anon_sym_alignof] = ACTIONS(1205),
    [anon_sym__Alignof] = ACTIONS(1205),
    [anon_sym_offsetof] = ACTIONS(1205),
    [anon_sym__Generic] = ACTIONS(1205),
    [anon_sym_asm] = ACTIONS(1205),
    [anon_sym___asm__] = ACTIONS(1205),
    [anon_sym___asm] = ACTIONS(1205),
    [sym_number_literal] = ACTIONS(1207),
    [anon_sym_L_SQUOTE] = ACTIONS(1207),
    [anon_sym_u_SQUOTE] = ACTIONS(1207),
    [anon_sym_U_SQUOTE] = ACTIONS(1207),
    [anon_sym_u8_SQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [anon_sym_L_DQUOTE] = ACTIONS(1207),
    [anon_sym_u_DQUOTE] = ACTIONS(1207),
    [anon_sym_U_DQUOTE] = ACTIONS(1207),
    [anon_sym_u8_DQUOTE] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [anon_sym_NULL] = ACTIONS(1205),
    [anon_sym_nullptr] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [ts_builtin_sym_end] = ACTIONS(1207),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1205),
    [aux_sym_preproc_def_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1205),
    [sym_preproc_directive] = ACTIONS(1205),
    [anon_sym_LPAREN2] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(1205),
    [anon_sym_typedef] = ACTIONS(1205),
    [anon_sym_extern] = ACTIONS(1205),
    [anon_sym___attribute__] = ACTIONS(1205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1207),
    [anon_sym___declspec] = ACTIONS(1205),
    [anon_sym___cdecl] = ACTIONS(1205),
    [anon_sym___clrcall] = ACTIONS(1205),
    [anon_sym___stdcall] = ACTIONS(1205),
    [anon_sym___fastcall] = ACTIONS(1205),
    [anon_sym___thiscall] = ACTIONS(1205),
    [anon_sym___vectorcall] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_signed] = ACTIONS(1205),
    [anon_sym_unsigned] = ACTIONS(1205),
    [anon_sym_long] = ACTIONS(1205),
    [anon_sym_short] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_auto] = ACTIONS(1205),
    [anon_sym_register] = ACTIONS(1205),
    [anon_sym_inline] = ACTIONS(1205),
    [anon_sym___inline] = ACTIONS(1205),
    [anon_sym___inline__] = ACTIONS(1205),
    [anon_sym___forceinline] = ACTIONS(1205),
    [anon_sym_thread_local] = ACTIONS(1205),
    [anon_sym___thread] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_constexpr] = ACTIONS(1205),
    [anon_sym_volatile] = ACTIONS(1205),
    [anon_sym_restrict] = ACTIONS(1205),
    [anon_sym___restrict__] = ACTIONS(1205),
    [anon_sym__Atomic] = ACTIONS(1205),
    [anon_sym__Noreturn] = ACTIONS(1205),
    [anon_sym_noreturn] = ACTIONS(1205),
    [anon_sym__Nonnull] = ACTIONS(1205),
    [anon_sym_alignas] = ACTIONS(1205),
    [anon_sym__Alignas] = ACTIONS(1205),
    [sym_primitive_type] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_do] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_goto] = ACTIONS(1205),
    [anon_sym___try] = ACTIONS(1205),
    [anon_sym___leave] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1207),
    [anon_sym_sizeof] = ACTIONS(1205),
    [anon_sym___alignof__] = ACTIONS(1205),
    [anon_sym___alignof] = ACTIONS(1205),
    [anon_sym__alignof] = ACTIONS(1205),
    [anon_sym_alignof] = ACTIONS(1205),
    [anon_sym__Alignof] = ACTIONS(1205),
    [anon_sym_offsetof] = ACTIONS(1205),
    [anon_sym__Generic] = ACTIONS(1205),
    [anon_sym_asm] = ACTIONS(1205),
    [anon_sym___asm__] = ACTIONS(1205),
    [anon_sym___asm] = ACTIONS(1205),
    [sym_number_literal] = ACTIONS(1207),
    [anon_sym_L_SQUOTE] = ACTIONS(1207),
    [anon_sym_u_SQUOTE] = ACTIONS(1207),
    [anon_sym_U_SQUOTE] = ACTIONS(1207),
    [anon_sym_u8_SQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [anon_sym_L_DQUOTE] = ACTIONS(1207),
    [anon_sym_u_DQUOTE] = ACTIONS(1207),
    [anon_sym_U_DQUOTE] = ACTIONS(1207),
    [anon_sym_u8_DQUOTE] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [anon_sym_NULL] = ACTIONS(1205),
    [anon_sym_nullptr] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token2] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym__Nonnull] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [anon_sym___asm] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token2] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym__Nonnull] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [anon_sym___asm] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym_identifier] = ACTIONS(1249),
    [aux_sym_preproc_include_token1] = ACTIONS(1249),
    [aux_sym_preproc_def_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token2] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1249),
    [sym_preproc_directive] = ACTIONS(1249),
    [anon_sym_LPAREN2] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym___extension__] = ACTIONS(1249),
    [anon_sym_typedef] = ACTIONS(1249),
    [anon_sym_extern] = ACTIONS(1249),
    [anon_sym___attribute__] = ACTIONS(1249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1251),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym___cdecl] = ACTIONS(1249),
    [anon_sym___clrcall] = ACTIONS(1249),
    [anon_sym___stdcall] = ACTIONS(1249),
    [anon_sym___fastcall] = ACTIONS(1249),
    [anon_sym___thiscall] = ACTIONS(1249),
    [anon_sym___vectorcall] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_signed] = ACTIONS(1249),
    [anon_sym_unsigned] = ACTIONS(1249),
    [anon_sym_long] = ACTIONS(1249),
    [anon_sym_short] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_auto] = ACTIONS(1249),
    [anon_sym_register] = ACTIONS(1249),
    [anon_sym_inline] = ACTIONS(1249),
    [anon_sym___inline] = ACTIONS(1249),
    [anon_sym___inline__] = ACTIONS(1249),
    [anon_sym___forceinline] = ACTIONS(1249),
    [anon_sym_thread_local] = ACTIONS(1249),
    [anon_sym___thread] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_constexpr] = ACTIONS(1249),
    [anon_sym_volatile] = ACTIONS(1249),
    [anon_sym_restrict] = ACTIONS(1249),
    [anon_sym___restrict__] = ACTIONS(1249),
    [anon_sym__Atomic] = ACTIONS(1249),
    [anon_sym__Noreturn] = ACTIONS(1249),
    [anon_sym_noreturn] = ACTIONS(1249),
    [anon_sym__Nonnull] = ACTIONS(1249),
    [anon_sym_alignas] = ACTIONS(1249),
    [anon_sym__Alignas] = ACTIONS(1249),
    [sym_primitive_type] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1249),
    [anon_sym_union] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1249),
    [anon_sym___try] = ACTIONS(1249),
    [anon_sym___leave] = ACTIONS(1249),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym___alignof__] = ACTIONS(1249),
    [anon_sym___alignof] = ACTIONS(1249),
    [anon_sym__alignof] = ACTIONS(1249),
    [anon_sym_alignof] = ACTIONS(1249),
    [anon_sym__Alignof] = ACTIONS(1249),
    [anon_sym_offsetof] = ACTIONS(1249),
    [anon_sym__Generic] = ACTIONS(1249),
    [anon_sym_asm] = ACTIONS(1249),
    [anon_sym___asm__] = ACTIONS(1249),
    [anon_sym___asm] = ACTIONS(1249),
    [sym_number_literal] = ACTIONS(1251),
    [anon_sym_L_SQUOTE] = ACTIONS(1251),
    [anon_sym_u_SQUOTE] = ACTIONS(1251),
    [anon_sym_U_SQUOTE] = ACTIONS(1251),
    [anon_sym_u8_SQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [anon_sym_L_DQUOTE] = ACTIONS(1251),
    [anon_sym_u_DQUOTE] = ACTIONS(1251),
    [anon_sym_U_DQUOTE] = ACTIONS(1251),
    [anon_sym_u8_DQUOTE] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [anon_sym_NULL] = ACTIONS(1249),
    [anon_sym_nullptr] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(1179),
    [sym_identifier] = ACTIONS(1177),
    [aux_sym_preproc_include_token1] = ACTIONS(1177),
    [aux_sym_preproc_def_token1] = ACTIONS(1177),
    [aux_sym_preproc_if_token1] = ACTIONS(1177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1177),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1177),
    [sym_preproc_directive] = ACTIONS(1177),
    [anon_sym_LPAREN2] = ACTIONS(1179),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym___extension__] = ACTIONS(1177),
    [anon_sym_typedef] = ACTIONS(1177),
    [anon_sym_extern] = ACTIONS(1177),
    [anon_sym___attribute__] = ACTIONS(1177),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1179),
    [anon_sym___declspec] = ACTIONS(1177),
    [anon_sym___cdecl] = ACTIONS(1177),
    [anon_sym___clrcall] = ACTIONS(1177),
    [anon_sym___stdcall] = ACTIONS(1177),
    [anon_sym___fastcall] = ACTIONS(1177),
    [anon_sym___thiscall] = ACTIONS(1177),
    [anon_sym___vectorcall] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_signed] = ACTIONS(1177),
    [anon_sym_unsigned] = ACTIONS(1177),
    [anon_sym_long] = ACTIONS(1177),
    [anon_sym_short] = ACTIONS(1177),
    [anon_sym_static] = ACTIONS(1177),
    [anon_sym_auto] = ACTIONS(1177),
    [anon_sym_register] = ACTIONS(1177),
    [anon_sym_inline] = ACTIONS(1177),
    [anon_sym___inline] = ACTIONS(1177),
    [anon_sym___inline__] = ACTIONS(1177),
    [anon_sym___forceinline] = ACTIONS(1177),
    [anon_sym_thread_local] = ACTIONS(1177),
    [anon_sym___thread] = ACTIONS(1177),
    [anon_sym_const] = ACTIONS(1177),
    [anon_sym_constexpr] = ACTIONS(1177),
    [anon_sym_volatile] = ACTIONS(1177),
    [anon_sym_restrict] = ACTIONS(1177),
    [anon_sym___restrict__] = ACTIONS(1177),
    [anon_sym__Atomic] = ACTIONS(1177),
    [anon_sym__Noreturn] = ACTIONS(1177),
    [anon_sym_noreturn] = ACTIONS(1177),
    [anon_sym__Nonnull] = ACTIONS(1177),
    [anon_sym_alignas] = ACTIONS(1177),
    [anon_sym__Alignas] = ACTIONS(1177),
    [sym_primitive_type] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(1177),
    [anon_sym_struct] = ACTIONS(1177),
    [anon_sym_union] = ACTIONS(1177),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_switch] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_default] = ACTIONS(1177),
    [anon_sym_while] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1177),
    [anon_sym_return] = ACTIONS(1177),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1177),
    [anon_sym_goto] = ACTIONS(1177),
    [anon_sym___try] = ACTIONS(1177),
    [anon_sym___leave] = ACTIONS(1177),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_sizeof] = ACTIONS(1177),
    [anon_sym___alignof__] = ACTIONS(1177),
    [anon_sym___alignof] = ACTIONS(1177),
    [anon_sym__alignof] = ACTIONS(1177),
    [anon_sym_alignof] = ACTIONS(1177),
    [anon_sym__Alignof] = ACTIONS(1177),
    [anon_sym_offsetof] = ACTIONS(1177),
    [anon_sym__Generic] = ACTIONS(1177),
    [anon_sym_asm] = ACTIONS(1177),
    [anon_sym___asm__] = ACTIONS(1177),
    [anon_sym___asm] = ACTIONS(1177),
    [sym_number_literal] = ACTIONS(1179),
    [anon_sym_L_SQUOTE] = ACTIONS(1179),
    [anon_sym_u_SQUOTE] = ACTIONS(1179),
    [anon_sym_U_SQUOTE] = ACTIONS(1179),
    [anon_sym_u8_SQUOTE] = ACTIONS(1179),
    [anon_sym_SQUOTE] = ACTIONS(1179),
    [anon_sym_L_DQUOTE] = ACTIONS(1179),
    [anon_sym_u_DQUOTE] = ACTIONS(1179),
    [anon_sym_U_DQUOTE] = ACTIONS(1179),
    [anon_sym_u8_DQUOTE] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1179),
    [sym_true] = ACTIONS(1177),
    [sym_false] = ACTIONS(1177),
    [anon_sym_NULL] = ACTIONS(1177),
    [anon_sym_nullptr] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(1183),
    [sym_identifier] = ACTIONS(1181),
    [aux_sym_preproc_include_token1] = ACTIONS(1181),
    [aux_sym_preproc_def_token1] = ACTIONS(1181),
    [aux_sym_preproc_if_token1] = ACTIONS(1181),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1181),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1181),
    [sym_preproc_directive] = ACTIONS(1181),
    [anon_sym_LPAREN2] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym___extension__] = ACTIONS(1181),
    [anon_sym_typedef] = ACTIONS(1181),
    [anon_sym_extern] = ACTIONS(1181),
    [anon_sym___attribute__] = ACTIONS(1181),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1183),
    [anon_sym___declspec] = ACTIONS(1181),
    [anon_sym___cdecl] = ACTIONS(1181),
    [anon_sym___clrcall] = ACTIONS(1181),
    [anon_sym___stdcall] = ACTIONS(1181),
    [anon_sym___fastcall] = ACTIONS(1181),
    [anon_sym___thiscall] = ACTIONS(1181),
    [anon_sym___vectorcall] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1183),
    [anon_sym_signed] = ACTIONS(1181),
    [anon_sym_unsigned] = ACTIONS(1181),
    [anon_sym_long] = ACTIONS(1181),
    [anon_sym_short] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_auto] = ACTIONS(1181),
    [anon_sym_register] = ACTIONS(1181),
    [anon_sym_inline] = ACTIONS(1181),
    [anon_sym___inline] = ACTIONS(1181),
    [anon_sym___inline__] = ACTIONS(1181),
    [anon_sym___forceinline] = ACTIONS(1181),
    [anon_sym_thread_local] = ACTIONS(1181),
    [anon_sym___thread] = ACTIONS(1181),
    [anon_sym_const] = ACTIONS(1181),
    [anon_sym_constexpr] = ACTIONS(1181),
    [anon_sym_volatile] = ACTIONS(1181),
    [anon_sym_restrict] = ACTIONS(1181),
    [anon_sym___restrict__] = ACTIONS(1181),
    [anon_sym__Atomic] = ACTIONS(1181),
    [anon_sym__Noreturn] = ACTIONS(1181),
    [anon_sym_noreturn] = ACTIONS(1181),
    [anon_sym__Nonnull] = ACTIONS(1181),
    [anon_sym_alignas] = ACTIONS(1181),
    [anon_sym__Alignas] = ACTIONS(1181),
    [sym_primitive_type] = ACTIONS(1181),
    [anon_sym_enum] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1181),
    [anon_sym_union] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1181),
    [anon_sym_switch] = ACTIONS(1181),
    [anon_sym_case] = ACTIONS(1181),
    [anon_sym_default] = ACTIONS(1181),
    [anon_sym_while] = ACTIONS(1181),
    [anon_sym_do] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1181),
    [anon_sym_break] = ACTIONS(1181),
    [anon_sym_continue] = ACTIONS(1181),
    [anon_sym_goto] = ACTIONS(1181),
    [anon_sym___try] = ACTIONS(1181),
    [anon_sym___leave] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1183),
    [anon_sym_sizeof] = ACTIONS(1181),
    [anon_sym___alignof__] = ACTIONS(1181),
    [anon_sym___alignof] = ACTIONS(1181),
    [anon_sym__alignof] = ACTIONS(1181),
    [anon_sym_alignof] = ACTIONS(1181),
    [anon_sym__Alignof] = ACTIONS(1181),
    [anon_sym_offsetof] = ACTIONS(1181),
    [anon_sym__Generic] = ACTIONS(1181),
    [anon_sym_asm] = ACTIONS(1181),
    [anon_sym___asm__] = ACTIONS(1181),
    [anon_sym___asm] = ACTIONS(1181),
    [sym_number_literal] = ACTIONS(1183),
    [anon_sym_L_SQUOTE] = ACTIONS(1183),
    [anon_sym_u_SQUOTE] = ACTIONS(1183),
    [anon_sym_U_SQUOTE] = ACTIONS(1183),
    [anon_sym_u8_SQUOTE] = ACTIONS(1183),
    [anon_sym_SQUOTE] = ACTIONS(1183),
    [anon_sym_L_DQUOTE] = ACTIONS(1183),
    [anon_sym_u_DQUOTE] = ACTIONS(1183),
    [anon_sym_U_DQUOTE] = ACTIONS(1183),
    [anon_sym_u8_DQUOTE] = ACTIONS(1183),
    [anon_sym_DQUOTE] = ACTIONS(1183),
    [sym_true] = ACTIONS(1181),
    [sym_false] = ACTIONS(1181),
    [anon_sym_NULL] = ACTIONS(1181),
    [anon_sym_nullptr] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(1187),
    [sym_identifier] = ACTIONS(1185),
    [aux_sym_preproc_include_token1] = ACTIONS(1185),
    [aux_sym_preproc_def_token1] = ACTIONS(1185),
    [aux_sym_preproc_if_token1] = ACTIONS(1185),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1185),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1185),
    [sym_preproc_directive] = ACTIONS(1185),
    [anon_sym_LPAREN2] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_TILDE] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1185),
    [anon_sym_PLUS] = ACTIONS(1185),
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym___extension__] = ACTIONS(1185),
    [anon_sym_typedef] = ACTIONS(1185),
    [anon_sym_extern] = ACTIONS(1185),
    [anon_sym___attribute__] = ACTIONS(1185),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1187),
    [anon_sym___declspec] = ACTIONS(1185),
    [anon_sym___cdecl] = ACTIONS(1185),
    [anon_sym___clrcall] = ACTIONS(1185),
    [anon_sym___stdcall] = ACTIONS(1185),
    [anon_sym___fastcall] = ACTIONS(1185),
    [anon_sym___thiscall] = ACTIONS(1185),
    [anon_sym___vectorcall] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_signed] = ACTIONS(1185),
    [anon_sym_unsigned] = ACTIONS(1185),
    [anon_sym_long] = ACTIONS(1185),
    [anon_sym_short] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1185),
    [anon_sym_auto] = ACTIONS(1185),
    [anon_sym_register] = ACTIONS(1185),
    [anon_sym_inline] = ACTIONS(1185),
    [anon_sym___inline] = ACTIONS(1185),
    [anon_sym___inline__] = ACTIONS(1185),
    [anon_sym___forceinline] = ACTIONS(1185),
    [anon_sym_thread_local] = ACTIONS(1185),
    [anon_sym___thread] = ACTIONS(1185),
    [anon_sym_const] = ACTIONS(1185),
    [anon_sym_constexpr] = ACTIONS(1185),
    [anon_sym_volatile] = ACTIONS(1185),
    [anon_sym_restrict] = ACTIONS(1185),
    [anon_sym___restrict__] = ACTIONS(1185),
    [anon_sym__Atomic] = ACTIONS(1185),
    [anon_sym__Noreturn] = ACTIONS(1185),
    [anon_sym_noreturn] = ACTIONS(1185),
    [anon_sym__Nonnull] = ACTIONS(1185),
    [anon_sym_alignas] = ACTIONS(1185),
    [anon_sym__Alignas] = ACTIONS(1185),
    [sym_primitive_type] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1185),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_union] = ACTIONS(1185),
    [anon_sym_if] = ACTIONS(1185),
    [anon_sym_else] = ACTIONS(1185),
    [anon_sym_switch] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1185),
    [anon_sym_default] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1185),
    [anon_sym_do] = ACTIONS(1185),
    [anon_sym_for] = ACTIONS(1185),
    [anon_sym_return] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1185),
    [anon_sym_continue] = ACTIONS(1185),
    [anon_sym_goto] = ACTIONS(1185),
    [anon_sym___try] = ACTIONS(1185),
    [anon_sym___leave] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1187),
    [anon_sym_sizeof] = ACTIONS(1185),
    [anon_sym___alignof__] = ACTIONS(1185),
    [anon_sym___alignof] = ACTIONS(1185),
    [anon_sym__alignof] = ACTIONS(1185),
    [anon_sym_alignof] = ACTIONS(1185),
    [anon_sym__Alignof] = ACTIONS(1185),
    [anon_sym_offsetof] = ACTIONS(1185),
    [anon_sym__Generic] = ACTIONS(1185),
    [anon_sym_asm] = ACTIONS(1185),
    [anon_sym___asm__] = ACTIONS(1185),
    [anon_sym___asm] = ACTIONS(1185),
    [sym_number_literal] = ACTIONS(1187),
    [anon_sym_L_SQUOTE] = ACTIONS(1187),
    [anon_sym_u_SQUOTE] = ACTIONS(1187),
    [anon_sym_U_SQUOTE] = ACTIONS(1187),
    [anon_sym_u8_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_L_DQUOTE] = ACTIONS(1187),
    [anon_sym_u_DQUOTE] = ACTIONS(1187),
    [anon_sym_U_DQUOTE] = ACTIONS(1187),
    [anon_sym_u8_DQUOTE] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [sym_true] = ACTIONS(1185),
    [sym_false] = ACTIONS(1185),
    [anon_sym_NULL] = ACTIONS(1185),
    [anon_sym_nullptr] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(1255),
    [sym_identifier] = ACTIONS(1253),
    [aux_sym_preproc_include_token1] = ACTIONS(1253),
    [aux_sym_preproc_def_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1253),
    [sym_preproc_directive] = ACTIONS(1253),
    [anon_sym_LPAREN2] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym___extension__] = ACTIONS(1253),
    [anon_sym_typedef] = ACTIONS(1253),
    [anon_sym_extern] = ACTIONS(1253),
    [anon_sym___attribute__] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1255),
    [anon_sym___declspec] = ACTIONS(1253),
    [anon_sym___cdecl] = ACTIONS(1253),
    [anon_sym___clrcall] = ACTIONS(1253),
    [anon_sym___stdcall] = ACTIONS(1253),
    [anon_sym___fastcall] = ACTIONS(1253),
    [anon_sym___thiscall] = ACTIONS(1253),
    [anon_sym___vectorcall] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_signed] = ACTIONS(1253),
    [anon_sym_unsigned] = ACTIONS(1253),
    [anon_sym_long] = ACTIONS(1253),
    [anon_sym_short] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_auto] = ACTIONS(1253),
    [anon_sym_register] = ACTIONS(1253),
    [anon_sym_inline] = ACTIONS(1253),
    [anon_sym___inline] = ACTIONS(1253),
    [anon_sym___inline__] = ACTIONS(1253),
    [anon_sym___forceinline] = ACTIONS(1253),
    [anon_sym_thread_local] = ACTIONS(1253),
    [anon_sym___thread] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_constexpr] = ACTIONS(1253),
    [anon_sym_volatile] = ACTIONS(1253),
    [anon_sym_restrict] = ACTIONS(1253),
    [anon_sym___restrict__] = ACTIONS(1253),
    [anon_sym__Atomic] = ACTIONS(1253),
    [anon_sym__Noreturn] = ACTIONS(1253),
    [anon_sym_noreturn] = ACTIONS(1253),
    [anon_sym__Nonnull] = ACTIONS(1253),
    [anon_sym_alignas] = ACTIONS(1253),
    [anon_sym__Alignas] = ACTIONS(1253),
    [sym_primitive_type] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_union] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_goto] = ACTIONS(1253),
    [anon_sym___try] = ACTIONS(1253),
    [anon_sym___leave] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_sizeof] = ACTIONS(1253),
    [anon_sym___alignof__] = ACTIONS(1253),
    [anon_sym___alignof] = ACTIONS(1253),
    [anon_sym__alignof] = ACTIONS(1253),
    [anon_sym_alignof] = ACTIONS(1253),
    [anon_sym__Alignof] = ACTIONS(1253),
    [anon_sym_offsetof] = ACTIONS(1253),
    [anon_sym__Generic] = ACTIONS(1253),
    [anon_sym_asm] = ACTIONS(1253),
    [anon_sym___asm__] = ACTIONS(1253),
    [anon_sym___asm] = ACTIONS(1253),
    [sym_number_literal] = ACTIONS(1255),
    [anon_sym_L_SQUOTE] = ACTIONS(1255),
    [anon_sym_u_SQUOTE] = ACTIONS(1255),
    [anon_sym_U_SQUOTE] = ACTIONS(1255),
    [anon_sym_u8_SQUOTE] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_L_DQUOTE] = ACTIONS(1255),
    [anon_sym_u_DQUOTE] = ACTIONS(1255),
    [anon_sym_U_DQUOTE] = ACTIONS(1255),
    [anon_sym_u8_DQUOTE] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [anon_sym_NULL] = ACTIONS(1253),
    [anon_sym_nullptr] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [ts_builtin_sym_end] = ACTIONS(1191),
    [sym_identifier] = ACTIONS(1189),
    [aux_sym_preproc_include_token1] = ACTIONS(1189),
    [aux_sym_preproc_def_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1189),
    [sym_preproc_directive] = ACTIONS(1189),
    [anon_sym_LPAREN2] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym___extension__] = ACTIONS(1189),
    [anon_sym_typedef] = ACTIONS(1189),
    [anon_sym_extern] = ACTIONS(1189),
    [anon_sym___attribute__] = ACTIONS(1189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1191),
    [anon_sym___declspec] = ACTIONS(1189),
    [anon_sym___cdecl] = ACTIONS(1189),
    [anon_sym___clrcall] = ACTIONS(1189),
    [anon_sym___stdcall] = ACTIONS(1189),
    [anon_sym___fastcall] = ACTIONS(1189),
    [anon_sym___thiscall] = ACTIONS(1189),
    [anon_sym___vectorcall] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_signed] = ACTIONS(1189),
    [anon_sym_unsigned] = ACTIONS(1189),
    [anon_sym_long] = ACTIONS(1189),
    [anon_sym_short] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_auto] = ACTIONS(1189),
    [anon_sym_register] = ACTIONS(1189),
    [anon_sym_inline] = ACTIONS(1189),
    [anon_sym___inline] = ACTIONS(1189),
    [anon_sym___inline__] = ACTIONS(1189),
    [anon_sym___forceinline] = ACTIONS(1189),
    [anon_sym_thread_local] = ACTIONS(1189),
    [anon_sym___thread] = ACTIONS(1189),
    [anon_sym_const] = ACTIONS(1189),
    [anon_sym_constexpr] = ACTIONS(1189),
    [anon_sym_volatile] = ACTIONS(1189),
    [anon_sym_restrict] = ACTIONS(1189),
    [anon_sym___restrict__] = ACTIONS(1189),
    [anon_sym__Atomic] = ACTIONS(1189),
    [anon_sym__Noreturn] = ACTIONS(1189),
    [anon_sym_noreturn] = ACTIONS(1189),
    [anon_sym__Nonnull] = ACTIONS(1189),
    [anon_sym_alignas] = ACTIONS(1189),
    [anon_sym__Alignas] = ACTIONS(1189),
    [sym_primitive_type] = ACTIONS(1189),
    [anon_sym_enum] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1189),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_do] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [anon_sym_goto] = ACTIONS(1189),
    [anon_sym___try] = ACTIONS(1189),
    [anon_sym___leave] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_sizeof] = ACTIONS(1189),
    [anon_sym___alignof__] = ACTIONS(1189),
    [anon_sym___alignof] = ACTIONS(1189),
    [anon_sym__alignof] = ACTIONS(1189),
    [anon_sym_alignof] = ACTIONS(1189),
    [anon_sym__Alignof] = ACTIONS(1189),
    [anon_sym_offsetof] = ACTIONS(1189),
    [anon_sym__Generic] = ACTIONS(1189),
    [anon_sym_asm] = ACTIONS(1189),
    [anon_sym___asm__] = ACTIONS(1189),
    [anon_sym___asm] = ACTIONS(1189),
    [sym_number_literal] = ACTIONS(1191),
    [anon_sym_L_SQUOTE] = ACTIONS(1191),
    [anon_sym_u_SQUOTE] = ACTIONS(1191),
    [anon_sym_U_SQUOTE] = ACTIONS(1191),
    [anon_sym_u8_SQUOTE] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [anon_sym_L_DQUOTE] = ACTIONS(1191),
    [anon_sym_u_DQUOTE] = ACTIONS(1191),
    [anon_sym_U_DQUOTE] = ACTIONS(1191),
    [anon_sym_u8_DQUOTE] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [sym_true] = ACTIONS(1189),
    [sym_false] = ACTIONS(1189),
    [anon_sym_NULL] = ACTIONS(1189),
    [anon_sym_nullptr] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [ts_builtin_sym_end] = ACTIONS(1191),
    [sym_identifier] = ACTIONS(1189),
    [aux_sym_preproc_include_token1] = ACTIONS(1189),
    [aux_sym_preproc_def_token1] = ACTIONS(1189),
    [aux_sym_preproc_if_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1189),
    [sym_preproc_directive] = ACTIONS(1189),
    [anon_sym_LPAREN2] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym___extension__] = ACTIONS(1189),
    [anon_sym_typedef] = ACTIONS(1189),
    [anon_sym_extern] = ACTIONS(1189),
    [anon_sym___attribute__] = ACTIONS(1189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1191),
    [anon_sym___declspec] = ACTIONS(1189),
    [anon_sym___cdecl] = ACTIONS(1189),
    [anon_sym___clrcall] = ACTIONS(1189),
    [anon_sym___stdcall] = ACTIONS(1189),
    [anon_sym___fastcall] = ACTIONS(1189),
    [anon_sym___thiscall] = ACTIONS(1189),
    [anon_sym___vectorcall] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_signed] = ACTIONS(1189),
    [anon_sym_unsigned] = ACTIONS(1189),
    [anon_sym_long] = ACTIONS(1189),
    [anon_sym_short] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_auto] = ACTIONS(1189),
    [anon_sym_register] = ACTIONS(1189),
    [anon_sym_inline] = ACTIONS(1189),
    [anon_sym___inline] = ACTIONS(1189),
    [anon_sym___inline__] = ACTIONS(1189),
    [anon_sym___forceinline] = ACTIONS(1189),
    [anon_sym_thread_local] = ACTIONS(1189),
    [anon_sym___thread] = ACTIONS(1189),
    [anon_sym_const] = ACTIONS(1189),
    [anon_sym_constexpr] = ACTIONS(1189),
    [anon_sym_volatile] = ACTIONS(1189),
    [anon_sym_restrict] = ACTIONS(1189),
    [anon_sym___restrict__] = ACTIONS(1189),
    [anon_sym__Atomic] = ACTIONS(1189),
    [anon_sym__Noreturn] = ACTIONS(1189),
    [anon_sym_noreturn] = ACTIONS(1189),
    [anon_sym__Nonnull] = ACTIONS(1189),
    [anon_sym_alignas] = ACTIONS(1189),
    [anon_sym__Alignas] = ACTIONS(1189),
    [sym_primitive_type] = ACTIONS(1189),
    [anon_sym_enum] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1189),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_do] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [anon_sym_goto] = ACTIONS(1189),
    [anon_sym___try] = ACTIONS(1189),
    [anon_sym___leave] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_sizeof] = ACTIONS(1189),
    [anon_sym___alignof__] = ACTIONS(1189),
    [anon_sym___alignof] = ACTIONS(1189),
    [anon_sym__alignof] = ACTIONS(1189),
    [anon_sym_alignof] = ACTIONS(1189),
    [anon_sym__Alignof] = ACTIONS(1189),
    [anon_sym_offsetof] = ACTIONS(1189),
    [anon_sym__Generic] = ACTIONS(1189),
    [anon_sym_asm] = ACTIONS(1189),
    [anon_sym___asm__] = ACTIONS(1189),
    [anon_sym___asm] = ACTIONS(1189),
    [sym_number_literal] = ACTIONS(1191),
    [anon_sym_L_SQUOTE] = ACTIONS(1191),
    [anon_sym_u_SQUOTE] = ACTIONS(1191),
    [anon_sym_U_SQUOTE] = ACTIONS(1191),
    [anon_sym_u8_SQUOTE] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [anon_sym_L_DQUOTE] = ACTIONS(1191),
    [anon_sym_u_DQUOTE] = ACTIONS(1191),
    [anon_sym_U_DQUOTE] = ACTIONS(1191),
    [anon_sym_u8_DQUOTE] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [sym_true] = ACTIONS(1189),
    [sym_false] = ACTIONS(1189),
    [anon_sym_NULL] = ACTIONS(1189),
    [anon_sym_nullptr] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1193),
    [aux_sym_preproc_include_token1] = ACTIONS(1193),
    [aux_sym_preproc_def_token1] = ACTIONS(1193),
    [aux_sym_preproc_if_token1] = ACTIONS(1193),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1193),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1193),
    [sym_preproc_directive] = ACTIONS(1193),
    [anon_sym_LPAREN2] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1195),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym___extension__] = ACTIONS(1193),
    [anon_sym_typedef] = ACTIONS(1193),
    [anon_sym_extern] = ACTIONS(1193),
    [anon_sym___attribute__] = ACTIONS(1193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1195),
    [anon_sym___declspec] = ACTIONS(1193),
    [anon_sym___cdecl] = ACTIONS(1193),
    [anon_sym___clrcall] = ACTIONS(1193),
    [anon_sym___stdcall] = ACTIONS(1193),
    [anon_sym___fastcall] = ACTIONS(1193),
    [anon_sym___thiscall] = ACTIONS(1193),
    [anon_sym___vectorcall] = ACTIONS(1193),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_signed] = ACTIONS(1193),
    [anon_sym_unsigned] = ACTIONS(1193),
    [anon_sym_long] = ACTIONS(1193),
    [anon_sym_short] = ACTIONS(1193),
    [anon_sym_static] = ACTIONS(1193),
    [anon_sym_auto] = ACTIONS(1193),
    [anon_sym_register] = ACTIONS(1193),
    [anon_sym_inline] = ACTIONS(1193),
    [anon_sym___inline] = ACTIONS(1193),
    [anon_sym___inline__] = ACTIONS(1193),
    [anon_sym___forceinline] = ACTIONS(1193),
    [anon_sym_thread_local] = ACTIONS(1193),
    [anon_sym___thread] = ACTIONS(1193),
    [anon_sym_const] = ACTIONS(1193),
    [anon_sym_constexpr] = ACTIONS(1193),
    [anon_sym_volatile] = ACTIONS(1193),
    [anon_sym_restrict] = ACTIONS(1193),
    [anon_sym___restrict__] = ACTIONS(1193),
    [anon_sym__Atomic] = ACTIONS(1193),
    [anon_sym__Noreturn] = ACTIONS(1193),
    [anon_sym_noreturn] = ACTIONS(1193),
    [anon_sym__Nonnull] = ACTIONS(1193),
    [anon_sym_alignas] = ACTIONS(1193),
    [anon_sym__Alignas] = ACTIONS(1193),
    [sym_primitive_type] = ACTIONS(1193),
    [anon_sym_enum] = ACTIONS(1193),
    [anon_sym_struct] = ACTIONS(1193),
    [anon_sym_union] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_switch] = ACTIONS(1193),
    [anon_sym_case] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1193),
    [anon_sym_while] = ACTIONS(1193),
    [anon_sym_do] = ACTIONS(1193),
    [anon_sym_for] = ACTIONS(1193),
    [anon_sym_return] = ACTIONS(1193),
    [anon_sym_break] = ACTIONS(1193),
    [anon_sym_continue] = ACTIONS(1193),
    [anon_sym_goto] = ACTIONS(1193),
    [anon_sym___try] = ACTIONS(1193),
    [anon_sym___leave] = ACTIONS(1193),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_sizeof] = ACTIONS(1193),
    [anon_sym___alignof__] = ACTIONS(1193),
    [anon_sym___alignof] = ACTIONS(1193),
    [anon_sym__alignof] = ACTIONS(1193),
    [anon_sym_alignof] = ACTIONS(1193),
    [anon_sym__Alignof] = ACTIONS(1193),
    [anon_sym_offsetof] = ACTIONS(1193),
    [anon_sym__Generic] = ACTIONS(1193),
    [anon_sym_asm] = ACTIONS(1193),
    [anon_sym___asm__] = ACTIONS(1193),
    [anon_sym___asm] = ACTIONS(1193),
    [sym_number_literal] = ACTIONS(1195),
    [anon_sym_L_SQUOTE] = ACTIONS(1195),
    [anon_sym_u_SQUOTE] = ACTIONS(1195),
    [anon_sym_U_SQUOTE] = ACTIONS(1195),
    [anon_sym_u8_SQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [anon_sym_L_DQUOTE] = ACTIONS(1195),
    [anon_sym_u_DQUOTE] = ACTIONS(1195),
    [anon_sym_U_DQUOTE] = ACTIONS(1195),
    [anon_sym_u8_DQUOTE] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [sym_true] = ACTIONS(1193),
    [sym_false] = ACTIONS(1193),
    [anon_sym_NULL] = ACTIONS(1193),
    [anon_sym_nullptr] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [ts_builtin_sym_end] = ACTIONS(1147),
    [sym_identifier] = ACTIONS(1145),
    [aux_sym_preproc_include_token1] = ACTIONS(1145),
    [aux_sym_preproc_def_token1] = ACTIONS(1145),
    [aux_sym_preproc_if_token1] = ACTIONS(1145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1145),
    [sym_preproc_directive] = ACTIONS(1145),
    [anon_sym_LPAREN2] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym___extension__] = ACTIONS(1145),
    [anon_sym_typedef] = ACTIONS(1145),
    [anon_sym_extern] = ACTIONS(1145),
    [anon_sym___attribute__] = ACTIONS(1145),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1147),
    [anon_sym___declspec] = ACTIONS(1145),
    [anon_sym___cdecl] = ACTIONS(1145),
    [anon_sym___clrcall] = ACTIONS(1145),
    [anon_sym___stdcall] = ACTIONS(1145),
    [anon_sym___fastcall] = ACTIONS(1145),
    [anon_sym___thiscall] = ACTIONS(1145),
    [anon_sym___vectorcall] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [anon_sym_signed] = ACTIONS(1145),
    [anon_sym_unsigned] = ACTIONS(1145),
    [anon_sym_long] = ACTIONS(1145),
    [anon_sym_short] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1145),
    [anon_sym_auto] = ACTIONS(1145),
    [anon_sym_register] = ACTIONS(1145),
    [anon_sym_inline] = ACTIONS(1145),
    [anon_sym___inline] = ACTIONS(1145),
    [anon_sym___inline__] = ACTIONS(1145),
    [anon_sym___forceinline] = ACTIONS(1145),
    [anon_sym_thread_local] = ACTIONS(1145),
    [anon_sym___thread] = ACTIONS(1145),
    [anon_sym_const] = ACTIONS(1145),
    [anon_sym_constexpr] = ACTIONS(1145),
    [anon_sym_volatile] = ACTIONS(1145),
    [anon_sym_restrict] = ACTIONS(1145),
    [anon_sym___restrict__] = ACTIONS(1145),
    [anon_sym__Atomic] = ACTIONS(1145),
    [anon_sym__Noreturn] = ACTIONS(1145),
    [anon_sym_noreturn] = ACTIONS(1145),
    [anon_sym__Nonnull] = ACTIONS(1145),
    [anon_sym_alignas] = ACTIONS(1145),
    [anon_sym__Alignas] = ACTIONS(1145),
    [sym_primitive_type] = ACTIONS(1145),
    [anon_sym_enum] = ACTIONS(1145),
    [anon_sym_struct] = ACTIONS(1145),
    [anon_sym_union] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_else] = ACTIONS(1145),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1145),
    [anon_sym_default] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_do] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1145),
    [anon_sym_break] = ACTIONS(1145),
    [anon_sym_continue] = ACTIONS(1145),
    [anon_sym_goto] = ACTIONS(1145),
    [anon_sym___try] = ACTIONS(1145),
    [anon_sym___leave] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_sizeof] = ACTIONS(1145),
    [anon_sym___alignof__] = ACTIONS(1145),
    [anon_sym___alignof] = ACTIONS(1145),
    [anon_sym__alignof] = ACTIONS(1145),
    [anon_sym_alignof] = ACTIONS(1145),
    [anon_sym__Alignof] = ACTIONS(1145),
    [anon_sym_offsetof] = ACTIONS(1145),
    [anon_sym__Generic] = ACTIONS(1145),
    [anon_sym_asm] = ACTIONS(1145),
    [anon_sym___asm__] = ACTIONS(1145),
    [anon_sym___asm] = ACTIONS(1145),
    [sym_number_literal] = ACTIONS(1147),
    [anon_sym_L_SQUOTE] = ACTIONS(1147),
    [anon_sym_u_SQUOTE] = ACTIONS(1147),
    [anon_sym_U_SQUOTE] = ACTIONS(1147),
    [anon_sym_u8_SQUOTE] = ACTIONS(1147),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [anon_sym_L_DQUOTE] = ACTIONS(1147),
    [anon_sym_u_DQUOTE] = ACTIONS(1147),
    [anon_sym_U_DQUOTE] = ACTIONS(1147),
    [anon_sym_u8_DQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [anon_sym_NULL] = ACTIONS(1145),
    [anon_sym_nullptr] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_identifier] = ACTIONS(1197),
    [aux_sym_preproc_include_token1] = ACTIONS(1197),
    [aux_sym_preproc_def_token1] = ACTIONS(1197),
    [aux_sym_preproc_if_token1] = ACTIONS(1197),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1197),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1197),
    [sym_preproc_directive] = ACTIONS(1197),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym___extension__] = ACTIONS(1197),
    [anon_sym_typedef] = ACTIONS(1197),
    [anon_sym_extern] = ACTIONS(1197),
    [anon_sym___attribute__] = ACTIONS(1197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1199),
    [anon_sym___declspec] = ACTIONS(1197),
    [anon_sym___cdecl] = ACTIONS(1197),
    [anon_sym___clrcall] = ACTIONS(1197),
    [anon_sym___stdcall] = ACTIONS(1197),
    [anon_sym___fastcall] = ACTIONS(1197),
    [anon_sym___thiscall] = ACTIONS(1197),
    [anon_sym___vectorcall] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_signed] = ACTIONS(1197),
    [anon_sym_unsigned] = ACTIONS(1197),
    [anon_sym_long] = ACTIONS(1197),
    [anon_sym_short] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_auto] = ACTIONS(1197),
    [anon_sym_register] = ACTIONS(1197),
    [anon_sym_inline] = ACTIONS(1197),
    [anon_sym___inline] = ACTIONS(1197),
    [anon_sym___inline__] = ACTIONS(1197),
    [anon_sym___forceinline] = ACTIONS(1197),
    [anon_sym_thread_local] = ACTIONS(1197),
    [anon_sym___thread] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_constexpr] = ACTIONS(1197),
    [anon_sym_volatile] = ACTIONS(1197),
    [anon_sym_restrict] = ACTIONS(1197),
    [anon_sym___restrict__] = ACTIONS(1197),
    [anon_sym__Atomic] = ACTIONS(1197),
    [anon_sym__Noreturn] = ACTIONS(1197),
    [anon_sym_noreturn] = ACTIONS(1197),
    [anon_sym__Nonnull] = ACTIONS(1197),
    [anon_sym_alignas] = ACTIONS(1197),
    [anon_sym__Alignas] = ACTIONS(1197),
    [sym_primitive_type] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [anon_sym_struct] = ACTIONS(1197),
    [anon_sym_union] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_goto] = ACTIONS(1197),
    [anon_sym___try] = ACTIONS(1197),
    [anon_sym___leave] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_sizeof] = ACTIONS(1197),
    [anon_sym___alignof__] = ACTIONS(1197),
    [anon_sym___alignof] = ACTIONS(1197),
    [anon_sym__alignof] = ACTIONS(1197),
    [anon_sym_alignof] = ACTIONS(1197),
    [anon_sym__Alignof] = ACTIONS(1197),
    [anon_sym_offsetof] = ACTIONS(1197),
    [anon_sym__Generic] = ACTIONS(1197),
    [anon_sym_asm] = ACTIONS(1197),
    [anon_sym___asm__] = ACTIONS(1197),
    [anon_sym___asm] = ACTIONS(1197),
    [sym_number_literal] = ACTIONS(1199),
    [anon_sym_L_SQUOTE] = ACTIONS(1199),
    [anon_sym_u_SQUOTE] = ACTIONS(1199),
    [anon_sym_U_SQUOTE] = ACTIONS(1199),
    [anon_sym_u8_SQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [anon_sym_L_DQUOTE] = ACTIONS(1199),
    [anon_sym_u_DQUOTE] = ACTIONS(1199),
    [anon_sym_U_DQUOTE] = ACTIONS(1199),
    [anon_sym_u8_DQUOTE] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [anon_sym_NULL] = ACTIONS(1197),
    [anon_sym_nullptr] = ACTIONS(1197),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [ts_builtin_sym_end] = ACTIONS(1131),
    [sym_identifier] = ACTIONS(1129),
    [aux_sym_preproc_include_token1] = ACTIONS(1129),
    [aux_sym_preproc_def_token1] = ACTIONS(1129),
    [aux_sym_preproc_if_token1] = ACTIONS(1129),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1129),
    [sym_preproc_directive] = ACTIONS(1129),
    [anon_sym_LPAREN2] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1131),
    [anon_sym_TILDE] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym___extension__] = ACTIONS(1129),
    [anon_sym_typedef] = ACTIONS(1129),
    [anon_sym_extern] = ACTIONS(1129),
    [anon_sym___attribute__] = ACTIONS(1129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1131),
    [anon_sym___declspec] = ACTIONS(1129),
    [anon_sym___cdecl] = ACTIONS(1129),
    [anon_sym___clrcall] = ACTIONS(1129),
    [anon_sym___stdcall] = ACTIONS(1129),
    [anon_sym___fastcall] = ACTIONS(1129),
    [anon_sym___thiscall] = ACTIONS(1129),
    [anon_sym___vectorcall] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_signed] = ACTIONS(1129),
    [anon_sym_unsigned] = ACTIONS(1129),
    [anon_sym_long] = ACTIONS(1129),
    [anon_sym_short] = ACTIONS(1129),
    [anon_sym_static] = ACTIONS(1129),
    [anon_sym_auto] = ACTIONS(1129),
    [anon_sym_register] = ACTIONS(1129),
    [anon_sym_inline] = ACTIONS(1129),
    [anon_sym___inline] = ACTIONS(1129),
    [anon_sym___inline__] = ACTIONS(1129),
    [anon_sym___forceinline] = ACTIONS(1129),
    [anon_sym_thread_local] = ACTIONS(1129),
    [anon_sym___thread] = ACTIONS(1129),
    [anon_sym_const] = ACTIONS(1129),
    [anon_sym_constexpr] = ACTIONS(1129),
    [anon_sym_volatile] = ACTIONS(1129),
    [anon_sym_restrict] = ACTIONS(1129),
    [anon_sym___restrict__] = ACTIONS(1129),
    [anon_sym__Atomic] = ACTIONS(1129),
    [anon_sym__Noreturn] = ACTIONS(1129),
    [anon_sym_noreturn] = ACTIONS(1129),
    [anon_sym__Nonnull] = ACTIONS(1129),
    [anon_sym_alignas] = ACTIONS(1129),
    [anon_sym__Alignas] = ACTIONS(1129),
    [sym_primitive_type] = ACTIONS(1129),
    [anon_sym_enum] = ACTIONS(1129),
    [anon_sym_struct] = ACTIONS(1129),
    [anon_sym_union] = ACTIONS(1129),
    [anon_sym_if] = ACTIONS(1129),
    [anon_sym_else] = ACTIONS(1129),
    [anon_sym_switch] = ACTIONS(1129),
    [anon_sym_case] = ACTIONS(1129),
    [anon_sym_default] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_do] = ACTIONS(1129),
    [anon_sym_for] = ACTIONS(1129),
    [anon_sym_return] = ACTIONS(1129),
    [anon_sym_break] = ACTIONS(1129),
    [anon_sym_continue] = ACTIONS(1129),
    [anon_sym_goto] = ACTIONS(1129),
    [anon_sym___try] = ACTIONS(1129),
    [anon_sym___leave] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_sizeof] = ACTIONS(1129),
    [anon_sym___alignof__] = ACTIONS(1129),
    [anon_sym___alignof] = ACTIONS(1129),
    [anon_sym__alignof] = ACTIONS(1129),
    [anon_sym_alignof] = ACTIONS(1129),
    [anon_sym__Alignof] = ACTIONS(1129),
    [anon_sym_offsetof] = ACTIONS(1129),
    [anon_sym__Generic] = ACTIONS(1129),
    [anon_sym_asm] = ACTIONS(1129),
    [anon_sym___asm__] = ACTIONS(1129),
    [anon_sym___asm] = ACTIONS(1129),
    [sym_number_literal] = ACTIONS(1131),
    [anon_sym_L_SQUOTE] = ACTIONS(1131),
    [anon_sym_u_SQUOTE] = ACTIONS(1131),
    [anon_sym_U_SQUOTE] = ACTIONS(1131),
    [anon_sym_u8_SQUOTE] = ACTIONS(1131),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [anon_sym_L_DQUOTE] = ACTIONS(1131),
    [anon_sym_u_DQUOTE] = ACTIONS(1131),
    [anon_sym_U_DQUOTE] = ACTIONS(1131),
    [anon_sym_u8_DQUOTE] = ACTIONS(1131),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [sym_true] = ACTIONS(1129),
    [sym_false] = ACTIONS(1129),
    [anon_sym_NULL] = ACTIONS(1129),
    [anon_sym_nullptr] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(1151),
    [sym_identifier] = ACTIONS(1149),
    [aux_sym_preproc_include_token1] = ACTIONS(1149),
    [aux_sym_preproc_def_token1] = ACTIONS(1149),
    [aux_sym_preproc_if_token1] = ACTIONS(1149),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1149),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1149),
    [sym_preproc_directive] = ACTIONS(1149),
    [anon_sym_LPAREN2] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym___extension__] = ACTIONS(1149),
    [anon_sym_typedef] = ACTIONS(1149),
    [anon_sym_extern] = ACTIONS(1149),
    [anon_sym___attribute__] = ACTIONS(1149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1151),
    [anon_sym___declspec] = ACTIONS(1149),
    [anon_sym___cdecl] = ACTIONS(1149),
    [anon_sym___clrcall] = ACTIONS(1149),
    [anon_sym___stdcall] = ACTIONS(1149),
    [anon_sym___fastcall] = ACTIONS(1149),
    [anon_sym___thiscall] = ACTIONS(1149),
    [anon_sym___vectorcall] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_signed] = ACTIONS(1149),
    [anon_sym_unsigned] = ACTIONS(1149),
    [anon_sym_long] = ACTIONS(1149),
    [anon_sym_short] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1149),
    [anon_sym_auto] = ACTIONS(1149),
    [anon_sym_register] = ACTIONS(1149),
    [anon_sym_inline] = ACTIONS(1149),
    [anon_sym___inline] = ACTIONS(1149),
    [anon_sym___inline__] = ACTIONS(1149),
    [anon_sym___forceinline] = ACTIONS(1149),
    [anon_sym_thread_local] = ACTIONS(1149),
    [anon_sym___thread] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_constexpr] = ACTIONS(1149),
    [anon_sym_volatile] = ACTIONS(1149),
    [anon_sym_restrict] = ACTIONS(1149),
    [anon_sym___restrict__] = ACTIONS(1149),
    [anon_sym__Atomic] = ACTIONS(1149),
    [anon_sym__Noreturn] = ACTIONS(1149),
    [anon_sym_noreturn] = ACTIONS(1149),
    [anon_sym__Nonnull] = ACTIONS(1149),
    [anon_sym_alignas] = ACTIONS(1149),
    [anon_sym__Alignas] = ACTIONS(1149),
    [sym_primitive_type] = ACTIONS(1149),
    [anon_sym_enum] = ACTIONS(1149),
    [anon_sym_struct] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1149),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_else] = ACTIONS(1149),
    [anon_sym_switch] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1149),
    [anon_sym_default] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_do] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_break] = ACTIONS(1149),
    [anon_sym_continue] = ACTIONS(1149),
    [anon_sym_goto] = ACTIONS(1149),
    [anon_sym___try] = ACTIONS(1149),
    [anon_sym___leave] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_sizeof] = ACTIONS(1149),
    [anon_sym___alignof__] = ACTIONS(1149),
    [anon_sym___alignof] = ACTIONS(1149),
    [anon_sym__alignof] = ACTIONS(1149),
    [anon_sym_alignof] = ACTIONS(1149),
    [anon_sym__Alignof] = ACTIONS(1149),
    [anon_sym_offsetof] = ACTIONS(1149),
    [anon_sym__Generic] = ACTIONS(1149),
    [anon_sym_asm] = ACTIONS(1149),
    [anon_sym___asm__] = ACTIONS(1149),
    [anon_sym___asm] = ACTIONS(1149),
    [sym_number_literal] = ACTIONS(1151),
    [anon_sym_L_SQUOTE] = ACTIONS(1151),
    [anon_sym_u_SQUOTE] = ACTIONS(1151),
    [anon_sym_U_SQUOTE] = ACTIONS(1151),
    [anon_sym_u8_SQUOTE] = ACTIONS(1151),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_L_DQUOTE] = ACTIONS(1151),
    [anon_sym_u_DQUOTE] = ACTIONS(1151),
    [anon_sym_U_DQUOTE] = ACTIONS(1151),
    [anon_sym_u8_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(1151),
    [sym_true] = ACTIONS(1149),
    [sym_false] = ACTIONS(1149),
    [anon_sym_NULL] = ACTIONS(1149),
    [anon_sym_nullptr] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [ts_builtin_sym_end] = ACTIONS(1155),
    [sym_identifier] = ACTIONS(1153),
    [aux_sym_preproc_include_token1] = ACTIONS(1153),
    [aux_sym_preproc_def_token1] = ACTIONS(1153),
    [aux_sym_preproc_if_token1] = ACTIONS(1153),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1153),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1153),
    [sym_preproc_directive] = ACTIONS(1153),
    [anon_sym_LPAREN2] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_TILDE] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym___extension__] = ACTIONS(1153),
    [anon_sym_typedef] = ACTIONS(1153),
    [anon_sym_extern] = ACTIONS(1153),
    [anon_sym___attribute__] = ACTIONS(1153),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1155),
    [anon_sym___declspec] = ACTIONS(1153),
    [anon_sym___cdecl] = ACTIONS(1153),
    [anon_sym___clrcall] = ACTIONS(1153),
    [anon_sym___stdcall] = ACTIONS(1153),
    [anon_sym___fastcall] = ACTIONS(1153),
    [anon_sym___thiscall] = ACTIONS(1153),
    [anon_sym___vectorcall] = ACTIONS(1153),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_signed] = ACTIONS(1153),
    [anon_sym_unsigned] = ACTIONS(1153),
    [anon_sym_long] = ACTIONS(1153),
    [anon_sym_short] = ACTIONS(1153),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_auto] = ACTIONS(1153),
    [anon_sym_register] = ACTIONS(1153),
    [anon_sym_inline] = ACTIONS(1153),
    [anon_sym___inline] = ACTIONS(1153),
    [anon_sym___inline__] = ACTIONS(1153),
    [anon_sym___forceinline] = ACTIONS(1153),
    [anon_sym_thread_local] = ACTIONS(1153),
    [anon_sym___thread] = ACTIONS(1153),
    [anon_sym_const] = ACTIONS(1153),
    [anon_sym_constexpr] = ACTIONS(1153),
    [anon_sym_volatile] = ACTIONS(1153),
    [anon_sym_restrict] = ACTIONS(1153),
    [anon_sym___restrict__] = ACTIONS(1153),
    [anon_sym__Atomic] = ACTIONS(1153),
    [anon_sym__Noreturn] = ACTIONS(1153),
    [anon_sym_noreturn] = ACTIONS(1153),
    [anon_sym__Nonnull] = ACTIONS(1153),
    [anon_sym_alignas] = ACTIONS(1153),
    [anon_sym__Alignas] = ACTIONS(1153),
    [sym_primitive_type] = ACTIONS(1153),
    [anon_sym_enum] = ACTIONS(1153),
    [anon_sym_struct] = ACTIONS(1153),
    [anon_sym_union] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_else] = ACTIONS(1153),
    [anon_sym_switch] = ACTIONS(1153),
    [anon_sym_case] = ACTIONS(1153),
    [anon_sym_default] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_do] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [anon_sym_goto] = ACTIONS(1153),
    [anon_sym___try] = ACTIONS(1153),
    [anon_sym___leave] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1155),
    [anon_sym_sizeof] = ACTIONS(1153),
    [anon_sym___alignof__] = ACTIONS(1153),
    [anon_sym___alignof] = ACTIONS(1153),
    [anon_sym__alignof] = ACTIONS(1153),
    [anon_sym_alignof] = ACTIONS(1153),
    [anon_sym__Alignof] = ACTIONS(1153),
    [anon_sym_offsetof] = ACTIONS(1153),
    [anon_sym__Generic] = ACTIONS(1153),
    [anon_sym_asm] = ACTIONS(1153),
    [anon_sym___asm__] = ACTIONS(1153),
    [anon_sym___asm] = ACTIONS(1153),
    [sym_number_literal] = ACTIONS(1155),
    [anon_sym_L_SQUOTE] = ACTIONS(1155),
    [anon_sym_u_SQUOTE] = ACTIONS(1155),
    [anon_sym_U_SQUOTE] = ACTIONS(1155),
    [anon_sym_u8_SQUOTE] = ACTIONS(1155),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [anon_sym_L_DQUOTE] = ACTIONS(1155),
    [anon_sym_u_DQUOTE] = ACTIONS(1155),
    [anon_sym_U_DQUOTE] = ACTIONS(1155),
    [anon_sym_u8_DQUOTE] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [anon_sym_NULL] = ACTIONS(1153),
    [anon_sym_nullptr] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(1203),
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1201),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1201),
    [sym_preproc_directive] = ACTIONS(1201),
    [anon_sym_LPAREN2] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym___extension__] = ACTIONS(1201),
    [anon_sym_typedef] = ACTIONS(1201),
    [anon_sym_extern] = ACTIONS(1201),
    [anon_sym___attribute__] = ACTIONS(1201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1203),
    [anon_sym___declspec] = ACTIONS(1201),
    [anon_sym___cdecl] = ACTIONS(1201),
    [anon_sym___clrcall] = ACTIONS(1201),
    [anon_sym___stdcall] = ACTIONS(1201),
    [anon_sym___fastcall] = ACTIONS(1201),
    [anon_sym___thiscall] = ACTIONS(1201),
    [anon_sym___vectorcall] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_signed] = ACTIONS(1201),
    [anon_sym_unsigned] = ACTIONS(1201),
    [anon_sym_long] = ACTIONS(1201),
    [anon_sym_short] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_auto] = ACTIONS(1201),
    [anon_sym_register] = ACTIONS(1201),
    [anon_sym_inline] = ACTIONS(1201),
    [anon_sym___inline] = ACTIONS(1201),
    [anon_sym___inline__] = ACTIONS(1201),
    [anon_sym___forceinline] = ACTIONS(1201),
    [anon_sym_thread_local] = ACTIONS(1201),
    [anon_sym___thread] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_constexpr] = ACTIONS(1201),
    [anon_sym_volatile] = ACTIONS(1201),
    [anon_sym_restrict] = ACTIONS(1201),
    [anon_sym___restrict__] = ACTIONS(1201),
    [anon_sym__Atomic] = ACTIONS(1201),
    [anon_sym__Noreturn] = ACTIONS(1201),
    [anon_sym_noreturn] = ACTIONS(1201),
    [anon_sym__Nonnull] = ACTIONS(1201),
    [anon_sym_alignas] = ACTIONS(1201),
    [anon_sym__Alignas] = ACTIONS(1201),
    [sym_primitive_type] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1201),
    [anon_sym_union] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_goto] = ACTIONS(1201),
    [anon_sym___try] = ACTIONS(1201),
    [anon_sym___leave] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1203),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym___alignof__] = ACTIONS(1201),
    [anon_sym___alignof] = ACTIONS(1201),
    [anon_sym__alignof] = ACTIONS(1201),
    [anon_sym_alignof] = ACTIONS(1201),
    [anon_sym__Alignof] = ACTIONS(1201),
    [anon_sym_offsetof] = ACTIONS(1201),
    [anon_sym__Generic] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1201),
    [anon_sym___asm__] = ACTIONS(1201),
    [anon_sym___asm] = ACTIONS(1201),
    [sym_number_literal] = ACTIONS(1203),
    [anon_sym_L_SQUOTE] = ACTIONS(1203),
    [anon_sym_u_SQUOTE] = ACTIONS(1203),
    [anon_sym_U_SQUOTE] = ACTIONS(1203),
    [anon_sym_u8_SQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [anon_sym_L_DQUOTE] = ACTIONS(1203),
    [anon_sym_u_DQUOTE] = ACTIONS(1203),
    [anon_sym_U_DQUOTE] = ACTIONS(1203),
    [anon_sym_u8_DQUOTE] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [anon_sym_NULL] = ACTIONS(1201),
    [anon_sym_nullptr] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(1203),
    [sym_identifier] = ACTIONS(1201),
    [aux_sym_preproc_include_token1] = ACTIONS(1201),
    [aux_sym_preproc_def_token1] = ACTIONS(1201),
    [aux_sym_preproc_if_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1201),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1201),
    [sym_preproc_directive] = ACTIONS(1201),
    [anon_sym_LPAREN2] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_TILDE] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1203),
    [anon_sym___extension__] = ACTIONS(1201),
    [anon_sym_typedef] = ACTIONS(1201),
    [anon_sym_extern] = ACTIONS(1201),
    [anon_sym___attribute__] = ACTIONS(1201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1203),
    [anon_sym___declspec] = ACTIONS(1201),
    [anon_sym___cdecl] = ACTIONS(1201),
    [anon_sym___clrcall] = ACTIONS(1201),
    [anon_sym___stdcall] = ACTIONS(1201),
    [anon_sym___fastcall] = ACTIONS(1201),
    [anon_sym___thiscall] = ACTIONS(1201),
    [anon_sym___vectorcall] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_signed] = ACTIONS(1201),
    [anon_sym_unsigned] = ACTIONS(1201),
    [anon_sym_long] = ACTIONS(1201),
    [anon_sym_short] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_auto] = ACTIONS(1201),
    [anon_sym_register] = ACTIONS(1201),
    [anon_sym_inline] = ACTIONS(1201),
    [anon_sym___inline] = ACTIONS(1201),
    [anon_sym___inline__] = ACTIONS(1201),
    [anon_sym___forceinline] = ACTIONS(1201),
    [anon_sym_thread_local] = ACTIONS(1201),
    [anon_sym___thread] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_constexpr] = ACTIONS(1201),
    [anon_sym_volatile] = ACTIONS(1201),
    [anon_sym_restrict] = ACTIONS(1201),
    [anon_sym___restrict__] = ACTIONS(1201),
    [anon_sym__Atomic] = ACTIONS(1201),
    [anon_sym__Noreturn] = ACTIONS(1201),
    [anon_sym_noreturn] = ACTIONS(1201),
    [anon_sym__Nonnull] = ACTIONS(1201),
    [anon_sym_alignas] = ACTIONS(1201),
    [anon_sym__Alignas] = ACTIONS(1201),
    [sym_primitive_type] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1201),
    [anon_sym_union] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_goto] = ACTIONS(1201),
    [anon_sym___try] = ACTIONS(1201),
    [anon_sym___leave] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1203),
    [anon_sym_sizeof] = ACTIONS(1201),
    [anon_sym___alignof__] = ACTIONS(1201),
    [anon_sym___alignof] = ACTIONS(1201),
    [anon_sym__alignof] = ACTIONS(1201),
    [anon_sym_alignof] = ACTIONS(1201),
    [anon_sym__Alignof] = ACTIONS(1201),
    [anon_sym_offsetof] = ACTIONS(1201),
    [anon_sym__Generic] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1201),
    [anon_sym___asm__] = ACTIONS(1201),
    [anon_sym___asm] = ACTIONS(1201),
    [sym_number_literal] = ACTIONS(1203),
    [anon_sym_L_SQUOTE] = ACTIONS(1203),
    [anon_sym_u_SQUOTE] = ACTIONS(1203),
    [anon_sym_U_SQUOTE] = ACTIONS(1203),
    [anon_sym_u8_SQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [anon_sym_L_DQUOTE] = ACTIONS(1203),
    [anon_sym_u_DQUOTE] = ACTIONS(1203),
    [anon_sym_U_DQUOTE] = ACTIONS(1203),
    [anon_sym_u8_DQUOTE] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [anon_sym_NULL] = ACTIONS(1201),
    [anon_sym_nullptr] = ACTIONS(1201),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(1207),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1205),
    [aux_sym_preproc_def_token1] = ACTIONS(1205),
    [aux_sym_preproc_if_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1205),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1205),
    [sym_preproc_directive] = ACTIONS(1205),
    [anon_sym_LPAREN2] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1207),
    [anon_sym___extension__] = ACTIONS(1205),
    [anon_sym_typedef] = ACTIONS(1205),
    [anon_sym_extern] = ACTIONS(1205),
    [anon_sym___attribute__] = ACTIONS(1205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1207),
    [anon_sym___declspec] = ACTIONS(1205),
    [anon_sym___cdecl] = ACTIONS(1205),
    [anon_sym___clrcall] = ACTIONS(1205),
    [anon_sym___stdcall] = ACTIONS(1205),
    [anon_sym___fastcall] = ACTIONS(1205),
    [anon_sym___thiscall] = ACTIONS(1205),
    [anon_sym___vectorcall] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_signed] = ACTIONS(1205),
    [anon_sym_unsigned] = ACTIONS(1205),
    [anon_sym_long] = ACTIONS(1205),
    [anon_sym_short] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1205),
    [anon_sym_auto] = ACTIONS(1205),
    [anon_sym_register] = ACTIONS(1205),
    [anon_sym_inline] = ACTIONS(1205),
    [anon_sym___inline] = ACTIONS(1205),
    [anon_sym___inline__] = ACTIONS(1205),
    [anon_sym___forceinline] = ACTIONS(1205),
    [anon_sym_thread_local] = ACTIONS(1205),
    [anon_sym___thread] = ACTIONS(1205),
    [anon_sym_const] = ACTIONS(1205),
    [anon_sym_constexpr] = ACTIONS(1205),
    [anon_sym_volatile] = ACTIONS(1205),
    [anon_sym_restrict] = ACTIONS(1205),
    [anon_sym___restrict__] = ACTIONS(1205),
    [anon_sym__Atomic] = ACTIONS(1205),
    [anon_sym__Noreturn] = ACTIONS(1205),
    [anon_sym_noreturn] = ACTIONS(1205),
    [anon_sym__Nonnull] = ACTIONS(1205),
    [anon_sym_alignas] = ACTIONS(1205),
    [anon_sym__Alignas] = ACTIONS(1205),
    [sym_primitive_type] = ACTIONS(1205),
    [anon_sym_enum] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1205),
    [anon_sym_union] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_default] = ACTIONS(1205),
    [anon_sym_while] = ACTIONS(1205),
    [anon_sym_do] = ACTIONS(1205),
    [anon_sym_for] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [anon_sym_goto] = ACTIONS(1205),
    [anon_sym___try] = ACTIONS(1205),
    [anon_sym___leave] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1207),
    [anon_sym_sizeof] = ACTIONS(1205),
    [anon_sym___alignof__] = ACTIONS(1205),
    [anon_sym___alignof] = ACTIONS(1205),
    [anon_sym__alignof] = ACTIONS(1205),
    [anon_sym_alignof] = ACTIONS(1205),
    [anon_sym__Alignof] = ACTIONS(1205),
    [anon_sym_offsetof] = ACTIONS(1205),
    [anon_sym__Generic] = ACTIONS(1205),
    [anon_sym_asm] = ACTIONS(1205),
    [anon_sym___asm__] = ACTIONS(1205),
    [anon_sym___asm] = ACTIONS(1205),
    [sym_number_literal] = ACTIONS(1207),
    [anon_sym_L_SQUOTE] = ACTIONS(1207),
    [anon_sym_u_SQUOTE] = ACTIONS(1207),
    [anon_sym_U_SQUOTE] = ACTIONS(1207),
    [anon_sym_u8_SQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [anon_sym_L_DQUOTE] = ACTIONS(1207),
    [anon_sym_u_DQUOTE] = ACTIONS(1207),
    [anon_sym_U_DQUOTE] = ACTIONS(1207),
    [anon_sym_u8_DQUOTE] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [sym_true] = ACTIONS(1205),
    [sym_false] = ACTIONS(1205),
    [anon_sym_NULL] = ACTIONS(1205),
    [anon_sym_nullptr] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym_identifier] = ACTIONS(1213),
    [aux_sym_preproc_include_token1] = ACTIONS(1213),
    [aux_sym_preproc_def_token1] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1213),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1213),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1213),
    [sym_preproc_directive] = ACTIONS(1213),
    [anon_sym_LPAREN2] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1215),
    [anon_sym___extension__] = ACTIONS(1213),
    [anon_sym_typedef] = ACTIONS(1213),
    [anon_sym_extern] = ACTIONS(1213),
    [anon_sym___attribute__] = ACTIONS(1213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1215),
    [anon_sym___declspec] = ACTIONS(1213),
    [anon_sym___cdecl] = ACTIONS(1213),
    [anon_sym___clrcall] = ACTIONS(1213),
    [anon_sym___stdcall] = ACTIONS(1213),
    [anon_sym___fastcall] = ACTIONS(1213),
    [anon_sym___thiscall] = ACTIONS(1213),
    [anon_sym___vectorcall] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1215),
    [anon_sym_signed] = ACTIONS(1213),
    [anon_sym_unsigned] = ACTIONS(1213),
    [anon_sym_long] = ACTIONS(1213),
    [anon_sym_short] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1213),
    [anon_sym_auto] = ACTIONS(1213),
    [anon_sym_register] = ACTIONS(1213),
    [anon_sym_inline] = ACTIONS(1213),
    [anon_sym___inline] = ACTIONS(1213),
    [anon_sym___inline__] = ACTIONS(1213),
    [anon_sym___forceinline] = ACTIONS(1213),
    [anon_sym_thread_local] = ACTIONS(1213),
    [anon_sym___thread] = ACTIONS(1213),
    [anon_sym_const] = ACTIONS(1213),
    [anon_sym_constexpr] = ACTIONS(1213),
    [anon_sym_volatile] = ACTIONS(1213),
    [anon_sym_restrict] = ACTIONS(1213),
    [anon_sym___restrict__] = ACTIONS(1213),
    [anon_sym__Atomic] = ACTIONS(1213),
    [anon_sym__Noreturn] = ACTIONS(1213),
    [anon_sym_noreturn] = ACTIONS(1213),
    [anon_sym__Nonnull] = ACTIONS(1213),
    [anon_sym_alignas] = ACTIONS(1213),
    [anon_sym__Alignas] = ACTIONS(1213),
    [sym_primitive_type] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1213),
    [anon_sym_struct] = ACTIONS(1213),
    [anon_sym_union] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1213),
    [anon_sym_else] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1213),
    [anon_sym_default] = ACTIONS(1213),
    [anon_sym_while] = ACTIONS(1213),
    [anon_sym_do] = ACTIONS(1213),
    [anon_sym_for] = ACTIONS(1213),
    [anon_sym_return] = ACTIONS(1213),
    [anon_sym_break] = ACTIONS(1213),
    [anon_sym_continue] = ACTIONS(1213),
    [anon_sym_goto] = ACTIONS(1213),
    [anon_sym___try] = ACTIONS(1213),
    [anon_sym___leave] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_sizeof] = ACTIONS(1213),
    [anon_sym___alignof__] = ACTIONS(1213),
    [anon_sym___alignof] = ACTIONS(1213),
    [anon_sym__alignof] = ACTIONS(1213),
    [anon_sym_alignof] = ACTIONS(1213),
    [anon_sym__Alignof] = ACTIONS(1213),
    [anon_sym_offsetof] = ACTIONS(1213),
    [anon_sym__Generic] = ACTIONS(1213),
    [anon_sym_asm] = ACTIONS(1213),
    [anon_sym___asm__] = ACTIONS(1213),
    [anon_sym___asm] = ACTIONS(1213),
    [sym_number_literal] = ACTIONS(1215),
    [anon_sym_L_SQUOTE] = ACTIONS(1215),
    [anon_sym_u_SQUOTE] = ACTIONS(1215),
    [anon_sym_U_SQUOTE] = ACTIONS(1215),
    [anon_sym_u8_SQUOTE] = ACTIONS(1215),
    [anon_sym_SQUOTE] = ACTIONS(1215),
    [anon_sym_L_DQUOTE] = ACTIONS(1215),
    [anon_sym_u_DQUOTE] = ACTIONS(1215),
    [anon_sym_U_DQUOTE] = ACTIONS(1215),
    [anon_sym_u8_DQUOTE] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1215),
    [sym_true] = ACTIONS(1213),
    [sym_false] = ACTIONS(1213),
    [anon_sym_NULL] = ACTIONS(1213),
    [anon_sym_nullptr] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_identifier] = ACTIONS(1325),
    [aux_sym_preproc_include_token1] = ACTIONS(1325),
    [aux_sym_preproc_def_token1] = ACTIONS(1325),
    [aux_sym_preproc_if_token1] = ACTIONS(1325),
    [aux_sym_preproc_if_token2] = ACTIONS(1325),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1325),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1325),
    [sym_preproc_directive] = ACTIONS(1325),
    [anon_sym_LPAREN2] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym___extension__] = ACTIONS(1325),
    [anon_sym_typedef] = ACTIONS(1325),
    [anon_sym_extern] = ACTIONS(1325),
    [anon_sym___attribute__] = ACTIONS(1325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1327),
    [anon_sym___declspec] = ACTIONS(1325),
    [anon_sym___cdecl] = ACTIONS(1325),
    [anon_sym___clrcall] = ACTIONS(1325),
    [anon_sym___stdcall] = ACTIONS(1325),
    [anon_sym___fastcall] = ACTIONS(1325),
    [anon_sym___thiscall] = ACTIONS(1325),
    [anon_sym___vectorcall] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1327),
    [anon_sym_signed] = ACTIONS(1325),
    [anon_sym_unsigned] = ACTIONS(1325),
    [anon_sym_long] = ACTIONS(1325),
    [anon_sym_short] = ACTIONS(1325),
    [anon_sym_static] = ACTIONS(1325),
    [anon_sym_auto] = ACTIONS(1325),
    [anon_sym_register] = ACTIONS(1325),
    [anon_sym_inline] = ACTIONS(1325),
    [anon_sym___inline] = ACTIONS(1325),
    [anon_sym___inline__] = ACTIONS(1325),
    [anon_sym___forceinline] = ACTIONS(1325),
    [anon_sym_thread_local] = ACTIONS(1325),
    [anon_sym___thread] = ACTIONS(1325),
    [anon_sym_const] = ACTIONS(1325),
    [anon_sym_constexpr] = ACTIONS(1325),
    [anon_sym_volatile] = ACTIONS(1325),
    [anon_sym_restrict] = ACTIONS(1325),
    [anon_sym___restrict__] = ACTIONS(1325),
    [anon_sym__Atomic] = ACTIONS(1325),
    [anon_sym__Noreturn] = ACTIONS(1325),
    [anon_sym_noreturn] = ACTIONS(1325),
    [anon_sym__Nonnull] = ACTIONS(1325),
    [anon_sym_alignas] = ACTIONS(1325),
    [anon_sym__Alignas] = ACTIONS(1325),
    [sym_primitive_type] = ACTIONS(1325),
    [anon_sym_enum] = ACTIONS(1325),
    [anon_sym_struct] = ACTIONS(1325),
    [anon_sym_union] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1325),
    [anon_sym_switch] = ACTIONS(1325),
    [anon_sym_case] = ACTIONS(1325),
    [anon_sym_default] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1325),
    [anon_sym_do] = ACTIONS(1325),
    [anon_sym_for] = ACTIONS(1325),
    [anon_sym_return] = ACTIONS(1325),
    [anon_sym_break] = ACTIONS(1325),
    [anon_sym_continue] = ACTIONS(1325),
    [anon_sym_goto] = ACTIONS(1325),
    [anon_sym___try] = ACTIONS(1325),
    [anon_sym___leave] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1327),
    [anon_sym_sizeof] = ACTIONS(1325),
    [anon_sym___alignof__] = ACTIONS(1325),
    [anon_sym___alignof] = ACTIONS(1325),
    [anon_sym__alignof] = ACTIONS(1325),
    [anon_sym_alignof] = ACTIONS(1325),
    [anon_sym__Alignof] = ACTIONS(1325),
    [anon_sym_offsetof] = ACTIONS(1325),
    [anon_sym__Generic] = ACTIONS(1325),
    [anon_sym_asm] = ACTIONS(1325),
    [anon_sym___asm__] = ACTIONS(1325),
    [anon_sym___asm] = ACTIONS(1325),
    [sym_number_literal] = ACTIONS(1327),
    [anon_sym_L_SQUOTE] = ACTIONS(1327),
    [anon_sym_u_SQUOTE] = ACTIONS(1327),
    [anon_sym_U_SQUOTE] = ACTIONS(1327),
    [anon_sym_u8_SQUOTE] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [anon_sym_L_DQUOTE] = ACTIONS(1327),
    [anon_sym_u_DQUOTE] = ACTIONS(1327),
    [anon_sym_U_DQUOTE] = ACTIONS(1327),
    [anon_sym_u8_DQUOTE] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [sym_true] = ACTIONS(1325),
    [sym_false] = ACTIONS(1325),
    [anon_sym_NULL] = ACTIONS(1325),
    [anon_sym_nullptr] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_identifier] = ACTIONS(1341),
    [aux_sym_preproc_include_token1] = ACTIONS(1341),
    [aux_sym_preproc_def_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token2] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1341),
    [sym_preproc_directive] = ACTIONS(1341),
    [anon_sym_LPAREN2] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym___extension__] = ACTIONS(1341),
    [anon_sym_typedef] = ACTIONS(1341),
    [anon_sym_extern] = ACTIONS(1341),
    [anon_sym___attribute__] = ACTIONS(1341),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1343),
    [anon_sym___declspec] = ACTIONS(1341),
    [anon_sym___cdecl] = ACTIONS(1341),
    [anon_sym___clrcall] = ACTIONS(1341),
    [anon_sym___stdcall] = ACTIONS(1341),
    [anon_sym___fastcall] = ACTIONS(1341),
    [anon_sym___thiscall] = ACTIONS(1341),
    [anon_sym___vectorcall] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_signed] = ACTIONS(1341),
    [anon_sym_unsigned] = ACTIONS(1341),
    [anon_sym_long] = ACTIONS(1341),
    [anon_sym_short] = ACTIONS(1341),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_auto] = ACTIONS(1341),
    [anon_sym_register] = ACTIONS(1341),
    [anon_sym_inline] = ACTIONS(1341),
    [anon_sym___inline] = ACTIONS(1341),
    [anon_sym___inline__] = ACTIONS(1341),
    [anon_sym___forceinline] = ACTIONS(1341),
    [anon_sym_thread_local] = ACTIONS(1341),
    [anon_sym___thread] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_constexpr] = ACTIONS(1341),
    [anon_sym_volatile] = ACTIONS(1341),
    [anon_sym_restrict] = ACTIONS(1341),
    [anon_sym___restrict__] = ACTIONS(1341),
    [anon_sym__Atomic] = ACTIONS(1341),
    [anon_sym__Noreturn] = ACTIONS(1341),
    [anon_sym_noreturn] = ACTIONS(1341),
    [anon_sym__Nonnull] = ACTIONS(1341),
    [anon_sym_alignas] = ACTIONS(1341),
    [anon_sym__Alignas] = ACTIONS(1341),
    [sym_primitive_type] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1341),
    [anon_sym_union] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_goto] = ACTIONS(1341),
    [anon_sym___try] = ACTIONS(1341),
    [anon_sym___leave] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_sizeof] = ACTIONS(1341),
    [anon_sym___alignof__] = ACTIONS(1341),
    [anon_sym___alignof] = ACTIONS(1341),
    [anon_sym__alignof] = ACTIONS(1341),
    [anon_sym_alignof] = ACTIONS(1341),
    [anon_sym__Alignof] = ACTIONS(1341),
    [anon_sym_offsetof] = ACTIONS(1341),
    [anon_sym__Generic] = ACTIONS(1341),
    [anon_sym_asm] = ACTIONS(1341),
    [anon_sym___asm__] = ACTIONS(1341),
    [anon_sym___asm] = ACTIONS(1341),
    [sym_number_literal] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1343),
    [anon_sym_u_SQUOTE] = ACTIONS(1343),
    [anon_sym_U_SQUOTE] = ACTIONS(1343),
    [anon_sym_u8_SQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_L_DQUOTE] = ACTIONS(1343),
    [anon_sym_u_DQUOTE] = ACTIONS(1343),
    [anon_sym_U_DQUOTE] = ACTIONS(1343),
    [anon_sym_u8_DQUOTE] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [anon_sym_NULL] = ACTIONS(1341),
    [anon_sym_nullptr] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_identifier] = ACTIONS(1357),
    [aux_sym_preproc_include_token1] = ACTIONS(1357),
    [aux_sym_preproc_def_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token2] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_LPAREN2] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym___extension__] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym___attribute__] = ACTIONS(1357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1359),
    [anon_sym___declspec] = ACTIONS(1357),
    [anon_sym___cdecl] = ACTIONS(1357),
    [anon_sym___clrcall] = ACTIONS(1357),
    [anon_sym___stdcall] = ACTIONS(1357),
    [anon_sym___fastcall] = ACTIONS(1357),
    [anon_sym___thiscall] = ACTIONS(1357),
    [anon_sym___vectorcall] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_signed] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_auto] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym___inline] = ACTIONS(1357),
    [anon_sym___inline__] = ACTIONS(1357),
    [anon_sym___forceinline] = ACTIONS(1357),
    [anon_sym_thread_local] = ACTIONS(1357),
    [anon_sym___thread] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym___restrict__] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym__Noreturn] = ACTIONS(1357),
    [anon_sym_noreturn] = ACTIONS(1357),
    [anon_sym__Nonnull] = ACTIONS(1357),
    [anon_sym_alignas] = ACTIONS(1357),
    [anon_sym__Alignas] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1357),
    [anon_sym_default] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_return] = ACTIONS(1357),
    [anon_sym_break] = ACTIONS(1357),
    [anon_sym_continue] = ACTIONS(1357),
    [anon_sym_goto] = ACTIONS(1357),
    [anon_sym___try] = ACTIONS(1357),
    [anon_sym___leave] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_sizeof] = ACTIONS(1357),
    [anon_sym___alignof__] = ACTIONS(1357),
    [anon_sym___alignof] = ACTIONS(1357),
    [anon_sym__alignof] = ACTIONS(1357),
    [anon_sym_alignof] = ACTIONS(1357),
    [anon_sym__Alignof] = ACTIONS(1357),
    [anon_sym_offsetof] = ACTIONS(1357),
    [anon_sym__Generic] = ACTIONS(1357),
    [anon_sym_asm] = ACTIONS(1357),
    [anon_sym___asm__] = ACTIONS(1357),
    [anon_sym___asm] = ACTIONS(1357),
    [sym_number_literal] = ACTIONS(1359),
    [anon_sym_L_SQUOTE] = ACTIONS(1359),
    [anon_sym_u_SQUOTE] = ACTIONS(1359),
    [anon_sym_U_SQUOTE] = ACTIONS(1359),
    [anon_sym_u8_SQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_L_DQUOTE] = ACTIONS(1359),
    [anon_sym_u_DQUOTE] = ACTIONS(1359),
    [anon_sym_U_DQUOTE] = ACTIONS(1359),
    [anon_sym_u8_DQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [anon_sym_NULL] = ACTIONS(1357),
    [anon_sym_nullptr] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym_identifier] = ACTIONS(1261),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym___extension__] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1261),
    [anon_sym_extern] = ACTIONS(1261),
    [anon_sym___attribute__] = ACTIONS(1261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1263),
    [anon_sym___declspec] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_signed] = ACTIONS(1261),
    [anon_sym_unsigned] = ACTIONS(1261),
    [anon_sym_long] = ACTIONS(1261),
    [anon_sym_short] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1261),
    [anon_sym_auto] = ACTIONS(1261),
    [anon_sym_register] = ACTIONS(1261),
    [anon_sym_inline] = ACTIONS(1261),
    [anon_sym___inline] = ACTIONS(1261),
    [anon_sym___inline__] = ACTIONS(1261),
    [anon_sym___forceinline] = ACTIONS(1261),
    [anon_sym_thread_local] = ACTIONS(1261),
    [anon_sym___thread] = ACTIONS(1261),
    [anon_sym_const] = ACTIONS(1261),
    [anon_sym_constexpr] = ACTIONS(1261),
    [anon_sym_volatile] = ACTIONS(1261),
    [anon_sym_restrict] = ACTIONS(1261),
    [anon_sym___restrict__] = ACTIONS(1261),
    [anon_sym__Atomic] = ACTIONS(1261),
    [anon_sym__Noreturn] = ACTIONS(1261),
    [anon_sym_noreturn] = ACTIONS(1261),
    [anon_sym__Nonnull] = ACTIONS(1261),
    [anon_sym_alignas] = ACTIONS(1261),
    [anon_sym__Alignas] = ACTIONS(1261),
    [sym_primitive_type] = ACTIONS(1261),
    [anon_sym_enum] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1261),
    [anon_sym_union] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_do] = ACTIONS(1261),
    [anon_sym_for] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1261),
    [anon_sym_break] = ACTIONS(1261),
    [anon_sym_continue] = ACTIONS(1261),
    [anon_sym_goto] = ACTIONS(1261),
    [anon_sym___try] = ACTIONS(1261),
    [anon_sym___leave] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_sizeof] = ACTIONS(1261),
    [anon_sym___alignof__] = ACTIONS(1261),
    [anon_sym___alignof] = ACTIONS(1261),
    [anon_sym__alignof] = ACTIONS(1261),
    [anon_sym_alignof] = ACTIONS(1261),
    [anon_sym__Alignof] = ACTIONS(1261),
    [anon_sym_offsetof] = ACTIONS(1261),
    [anon_sym__Generic] = ACTIONS(1261),
    [anon_sym_asm] = ACTIONS(1261),
    [anon_sym___asm__] = ACTIONS(1261),
    [anon_sym___asm] = ACTIONS(1261),
    [sym_number_literal] = ACTIONS(1263),
    [anon_sym_L_SQUOTE] = ACTIONS(1263),
    [anon_sym_u_SQUOTE] = ACTIONS(1263),
    [anon_sym_U_SQUOTE] = ACTIONS(1263),
    [anon_sym_u8_SQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [anon_sym_L_DQUOTE] = ACTIONS(1263),
    [anon_sym_u_DQUOTE] = ACTIONS(1263),
    [anon_sym_U_DQUOTE] = ACTIONS(1263),
    [anon_sym_u8_DQUOTE] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_true] = ACTIONS(1261),
    [sym_false] = ACTIONS(1261),
    [anon_sym_NULL] = ACTIONS(1261),
    [anon_sym_nullptr] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_identifier] = ACTIONS(1367),
    [aux_sym_preproc_include_token1] = ACTIONS(1367),
    [aux_sym_preproc_def_token1] = ACTIONS(1367),
    [aux_sym_preproc_if_token1] = ACTIONS(1367),
    [aux_sym_preproc_if_token2] = ACTIONS(1367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1367),
    [sym_preproc_directive] = ACTIONS(1367),
    [anon_sym_LPAREN2] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1367),
    [anon_sym_STAR] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym___extension__] = ACTIONS(1367),
    [anon_sym_typedef] = ACTIONS(1367),
    [anon_sym_extern] = ACTIONS(1367),
    [anon_sym___attribute__] = ACTIONS(1367),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1369),
    [anon_sym___declspec] = ACTIONS(1367),
    [anon_sym___cdecl] = ACTIONS(1367),
    [anon_sym___clrcall] = ACTIONS(1367),
    [anon_sym___stdcall] = ACTIONS(1367),
    [anon_sym___fastcall] = ACTIONS(1367),
    [anon_sym___thiscall] = ACTIONS(1367),
    [anon_sym___vectorcall] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_signed] = ACTIONS(1367),
    [anon_sym_unsigned] = ACTIONS(1367),
    [anon_sym_long] = ACTIONS(1367),
    [anon_sym_short] = ACTIONS(1367),
    [anon_sym_static] = ACTIONS(1367),
    [anon_sym_auto] = ACTIONS(1367),
    [anon_sym_register] = ACTIONS(1367),
    [anon_sym_inline] = ACTIONS(1367),
    [anon_sym___inline] = ACTIONS(1367),
    [anon_sym___inline__] = ACTIONS(1367),
    [anon_sym___forceinline] = ACTIONS(1367),
    [anon_sym_thread_local] = ACTIONS(1367),
    [anon_sym___thread] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1367),
    [anon_sym_constexpr] = ACTIONS(1367),
    [anon_sym_volatile] = ACTIONS(1367),
    [anon_sym_restrict] = ACTIONS(1367),
    [anon_sym___restrict__] = ACTIONS(1367),
    [anon_sym__Atomic] = ACTIONS(1367),
    [anon_sym__Noreturn] = ACTIONS(1367),
    [anon_sym_noreturn] = ACTIONS(1367),
    [anon_sym__Nonnull] = ACTIONS(1367),
    [anon_sym_alignas] = ACTIONS(1367),
    [anon_sym__Alignas] = ACTIONS(1367),
    [sym_primitive_type] = ACTIONS(1367),
    [anon_sym_enum] = ACTIONS(1367),
    [anon_sym_struct] = ACTIONS(1367),
    [anon_sym_union] = ACTIONS(1367),
    [anon_sym_if] = ACTIONS(1367),
    [anon_sym_switch] = ACTIONS(1367),
    [anon_sym_case] = ACTIONS(1367),
    [anon_sym_default] = ACTIONS(1367),
    [anon_sym_while] = ACTIONS(1367),
    [anon_sym_do] = ACTIONS(1367),
    [anon_sym_for] = ACTIONS(1367),
    [anon_sym_return] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1367),
    [anon_sym_continue] = ACTIONS(1367),
    [anon_sym_goto] = ACTIONS(1367),
    [anon_sym___try] = ACTIONS(1367),
    [anon_sym___leave] = ACTIONS(1367),
    [anon_sym_DASH_DASH] = ACTIONS(1369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_sizeof] = ACTIONS(1367),
    [anon_sym___alignof__] = ACTIONS(1367),
    [anon_sym___alignof] = ACTIONS(1367),
    [anon_sym__alignof] = ACTIONS(1367),
    [anon_sym_alignof] = ACTIONS(1367),
    [anon_sym__Alignof] = ACTIONS(1367),
    [anon_sym_offsetof] = ACTIONS(1367),
    [anon_sym__Generic] = ACTIONS(1367),
    [anon_sym_asm] = ACTIONS(1367),
    [anon_sym___asm__] = ACTIONS(1367),
    [anon_sym___asm] = ACTIONS(1367),
    [sym_number_literal] = ACTIONS(1369),
    [anon_sym_L_SQUOTE] = ACTIONS(1369),
    [anon_sym_u_SQUOTE] = ACTIONS(1369),
    [anon_sym_U_SQUOTE] = ACTIONS(1369),
    [anon_sym_u8_SQUOTE] = ACTIONS(1369),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_L_DQUOTE] = ACTIONS(1369),
    [anon_sym_u_DQUOTE] = ACTIONS(1369),
    [anon_sym_U_DQUOTE] = ACTIONS(1369),
    [anon_sym_u8_DQUOTE] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1369),
    [sym_true] = ACTIONS(1367),
    [sym_false] = ACTIONS(1367),
    [anon_sym_NULL] = ACTIONS(1367),
    [anon_sym_nullptr] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [sym_identifier] = ACTIONS(1371),
    [aux_sym_preproc_include_token1] = ACTIONS(1371),
    [aux_sym_preproc_def_token1] = ACTIONS(1371),
    [aux_sym_preproc_if_token1] = ACTIONS(1371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1371),
    [sym_preproc_directive] = ACTIONS(1371),
    [anon_sym_LPAREN2] = ACTIONS(1373),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym___extension__] = ACTIONS(1371),
    [anon_sym_typedef] = ACTIONS(1371),
    [anon_sym_extern] = ACTIONS(1371),
    [anon_sym___attribute__] = ACTIONS(1371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1373),
    [anon_sym___declspec] = ACTIONS(1371),
    [anon_sym___cdecl] = ACTIONS(1371),
    [anon_sym___clrcall] = ACTIONS(1371),
    [anon_sym___stdcall] = ACTIONS(1371),
    [anon_sym___fastcall] = ACTIONS(1371),
    [anon_sym___thiscall] = ACTIONS(1371),
    [anon_sym___vectorcall] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_signed] = ACTIONS(1371),
    [anon_sym_unsigned] = ACTIONS(1371),
    [anon_sym_long] = ACTIONS(1371),
    [anon_sym_short] = ACTIONS(1371),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_auto] = ACTIONS(1371),
    [anon_sym_register] = ACTIONS(1371),
    [anon_sym_inline] = ACTIONS(1371),
    [anon_sym___inline] = ACTIONS(1371),
    [anon_sym___inline__] = ACTIONS(1371),
    [anon_sym___forceinline] = ACTIONS(1371),
    [anon_sym_thread_local] = ACTIONS(1371),
    [anon_sym___thread] = ACTIONS(1371),
    [anon_sym_const] = ACTIONS(1371),
    [anon_sym_constexpr] = ACTIONS(1371),
    [anon_sym_volatile] = ACTIONS(1371),
    [anon_sym_restrict] = ACTIONS(1371),
    [anon_sym___restrict__] = ACTIONS(1371),
    [anon_sym__Atomic] = ACTIONS(1371),
    [anon_sym__Noreturn] = ACTIONS(1371),
    [anon_sym_noreturn] = ACTIONS(1371),
    [anon_sym__Nonnull] = ACTIONS(1371),
    [anon_sym_alignas] = ACTIONS(1371),
    [anon_sym__Alignas] = ACTIONS(1371),
    [sym_primitive_type] = ACTIONS(1371),
    [anon_sym_enum] = ACTIONS(1371),
    [anon_sym_struct] = ACTIONS(1371),
    [anon_sym_union] = ACTIONS(1371),
    [anon_sym_if] = ACTIONS(1371),
    [anon_sym_switch] = ACTIONS(1371),
    [anon_sym_case] = ACTIONS(1371),
    [anon_sym_default] = ACTIONS(1371),
    [anon_sym_while] = ACTIONS(1371),
    [anon_sym_do] = ACTIONS(1371),
    [anon_sym_for] = ACTIONS(1371),
    [anon_sym_return] = ACTIONS(1371),
    [anon_sym_break] = ACTIONS(1371),
    [anon_sym_continue] = ACTIONS(1371),
    [anon_sym_goto] = ACTIONS(1371),
    [anon_sym___try] = ACTIONS(1371),
    [anon_sym___leave] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_sizeof] = ACTIONS(1371),
    [anon_sym___alignof__] = ACTIONS(1371),
    [anon_sym___alignof] = ACTIONS(1371),
    [anon_sym__alignof] = ACTIONS(1371),
    [anon_sym_alignof] = ACTIONS(1371),
    [anon_sym__Alignof] = ACTIONS(1371),
    [anon_sym_offsetof] = ACTIONS(1371),
    [anon_sym__Generic] = ACTIONS(1371),
    [anon_sym_asm] = ACTIONS(1371),
    [anon_sym___asm__] = ACTIONS(1371),
    [anon_sym___asm] = ACTIONS(1371),
    [sym_number_literal] = ACTIONS(1373),
    [anon_sym_L_SQUOTE] = ACTIONS(1373),
    [anon_sym_u_SQUOTE] = ACTIONS(1373),
    [anon_sym_U_SQUOTE] = ACTIONS(1373),
    [anon_sym_u8_SQUOTE] = ACTIONS(1373),
    [anon_sym_SQUOTE] = ACTIONS(1373),
    [anon_sym_L_DQUOTE] = ACTIONS(1373),
    [anon_sym_u_DQUOTE] = ACTIONS(1373),
    [anon_sym_U_DQUOTE] = ACTIONS(1373),
    [anon_sym_u8_DQUOTE] = ACTIONS(1373),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_true] = ACTIONS(1371),
    [sym_false] = ACTIONS(1371),
    [anon_sym_NULL] = ACTIONS(1371),
    [anon_sym_nullptr] = ACTIONS(1371),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_identifier] = ACTIONS(1261),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token2] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym___extension__] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1261),
    [anon_sym_extern] = ACTIONS(1261),
    [anon_sym___attribute__] = ACTIONS(1261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1263),
    [anon_sym___declspec] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_signed] = ACTIONS(1261),
    [anon_sym_unsigned] = ACTIONS(1261),
    [anon_sym_long] = ACTIONS(1261),
    [anon_sym_short] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1261),
    [anon_sym_auto] = ACTIONS(1261),
    [anon_sym_register] = ACTIONS(1261),
    [anon_sym_inline] = ACTIONS(1261),
    [anon_sym___inline] = ACTIONS(1261),
    [anon_sym___inline__] = ACTIONS(1261),
    [anon_sym___forceinline] = ACTIONS(1261),
    [anon_sym_thread_local] = ACTIONS(1261),
    [anon_sym___thread] = ACTIONS(1261),
    [anon_sym_const] = ACTIONS(1261),
    [anon_sym_constexpr] = ACTIONS(1261),
    [anon_sym_volatile] = ACTIONS(1261),
    [anon_sym_restrict] = ACTIONS(1261),
    [anon_sym___restrict__] = ACTIONS(1261),
    [anon_sym__Atomic] = ACTIONS(1261),
    [anon_sym__Noreturn] = ACTIONS(1261),
    [anon_sym_noreturn] = ACTIONS(1261),
    [anon_sym__Nonnull] = ACTIONS(1261),
    [anon_sym_alignas] = ACTIONS(1261),
    [anon_sym__Alignas] = ACTIONS(1261),
    [sym_primitive_type] = ACTIONS(1261),
    [anon_sym_enum] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1261),
    [anon_sym_union] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_do] = ACTIONS(1261),
    [anon_sym_for] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1261),
    [anon_sym_break] = ACTIONS(1261),
    [anon_sym_continue] = ACTIONS(1261),
    [anon_sym_goto] = ACTIONS(1261),
    [anon_sym___try] = ACTIONS(1261),
    [anon_sym___leave] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_sizeof] = ACTIONS(1261),
    [anon_sym___alignof__] = ACTIONS(1261),
    [anon_sym___alignof] = ACTIONS(1261),
    [anon_sym__alignof] = ACTIONS(1261),
    [anon_sym_alignof] = ACTIONS(1261),
    [anon_sym__Alignof] = ACTIONS(1261),
    [anon_sym_offsetof] = ACTIONS(1261),
    [anon_sym__Generic] = ACTIONS(1261),
    [anon_sym_asm] = ACTIONS(1261),
    [anon_sym___asm__] = ACTIONS(1261),
    [anon_sym___asm] = ACTIONS(1261),
    [sym_number_literal] = ACTIONS(1263),
    [anon_sym_L_SQUOTE] = ACTIONS(1263),
    [anon_sym_u_SQUOTE] = ACTIONS(1263),
    [anon_sym_U_SQUOTE] = ACTIONS(1263),
    [anon_sym_u8_SQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [anon_sym_L_DQUOTE] = ACTIONS(1263),
    [anon_sym_u_DQUOTE] = ACTIONS(1263),
    [anon_sym_U_DQUOTE] = ACTIONS(1263),
    [anon_sym_u8_DQUOTE] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_true] = ACTIONS(1261),
    [sym_false] = ACTIONS(1261),
    [anon_sym_NULL] = ACTIONS(1261),
    [anon_sym_nullptr] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_identifier] = ACTIONS(1281),
    [aux_sym_preproc_include_token1] = ACTIONS(1281),
    [aux_sym_preproc_def_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1281),
    [sym_preproc_directive] = ACTIONS(1281),
    [anon_sym_LPAREN2] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym___extension__] = ACTIONS(1281),
    [anon_sym_typedef] = ACTIONS(1281),
    [anon_sym_extern] = ACTIONS(1281),
    [anon_sym___attribute__] = ACTIONS(1281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1283),
    [anon_sym___declspec] = ACTIONS(1281),
    [anon_sym___cdecl] = ACTIONS(1281),
    [anon_sym___clrcall] = ACTIONS(1281),
    [anon_sym___stdcall] = ACTIONS(1281),
    [anon_sym___fastcall] = ACTIONS(1281),
    [anon_sym___thiscall] = ACTIONS(1281),
    [anon_sym___vectorcall] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_signed] = ACTIONS(1281),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [anon_sym_static] = ACTIONS(1281),
    [anon_sym_auto] = ACTIONS(1281),
    [anon_sym_register] = ACTIONS(1281),
    [anon_sym_inline] = ACTIONS(1281),
    [anon_sym___inline] = ACTIONS(1281),
    [anon_sym___inline__] = ACTIONS(1281),
    [anon_sym___forceinline] = ACTIONS(1281),
    [anon_sym_thread_local] = ACTIONS(1281),
    [anon_sym___thread] = ACTIONS(1281),
    [anon_sym_const] = ACTIONS(1281),
    [anon_sym_constexpr] = ACTIONS(1281),
    [anon_sym_volatile] = ACTIONS(1281),
    [anon_sym_restrict] = ACTIONS(1281),
    [anon_sym___restrict__] = ACTIONS(1281),
    [anon_sym__Atomic] = ACTIONS(1281),
    [anon_sym__Noreturn] = ACTIONS(1281),
    [anon_sym_noreturn] = ACTIONS(1281),
    [anon_sym__Nonnull] = ACTIONS(1281),
    [anon_sym_alignas] = ACTIONS(1281),
    [anon_sym__Alignas] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1281),
    [anon_sym_enum] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1281),
    [anon_sym_union] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(1281),
    [anon_sym_default] = ACTIONS(1281),
    [anon_sym_while] = ACTIONS(1281),
    [anon_sym_do] = ACTIONS(1281),
    [anon_sym_for] = ACTIONS(1281),
    [anon_sym_return] = ACTIONS(1281),
    [anon_sym_break] = ACTIONS(1281),
    [anon_sym_continue] = ACTIONS(1281),
    [anon_sym_goto] = ACTIONS(1281),
    [anon_sym___try] = ACTIONS(1281),
    [anon_sym___leave] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1283),
    [anon_sym_sizeof] = ACTIONS(1281),
    [anon_sym___alignof__] = ACTIONS(1281),
    [anon_sym___alignof] = ACTIONS(1281),
    [anon_sym__alignof] = ACTIONS(1281),
    [anon_sym_alignof] = ACTIONS(1281),
    [anon_sym__Alignof] = ACTIONS(1281),
    [anon_sym_offsetof] = ACTIONS(1281),
    [anon_sym__Generic] = ACTIONS(1281),
    [anon_sym_asm] = ACTIONS(1281),
    [anon_sym___asm__] = ACTIONS(1281),
    [anon_sym___asm] = ACTIONS(1281),
    [sym_number_literal] = ACTIONS(1283),
    [anon_sym_L_SQUOTE] = ACTIONS(1283),
    [anon_sym_u_SQUOTE] = ACTIONS(1283),
    [anon_sym_U_SQUOTE] = ACTIONS(1283),
    [anon_sym_u8_SQUOTE] = ACTIONS(1283),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_L_DQUOTE] = ACTIONS(1283),
    [anon_sym_u_DQUOTE] = ACTIONS(1283),
    [anon_sym_U_DQUOTE] = ACTIONS(1283),
    [anon_sym_u8_DQUOTE] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [anon_sym_NULL] = ACTIONS(1281),
    [anon_sym_nullptr] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token2] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym__Nonnull] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [anon_sym___asm] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [sym_identifier] = ACTIONS(1281),
    [aux_sym_preproc_include_token1] = ACTIONS(1281),
    [aux_sym_preproc_def_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token2] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1281),
    [sym_preproc_directive] = ACTIONS(1281),
    [anon_sym_LPAREN2] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym___extension__] = ACTIONS(1281),
    [anon_sym_typedef] = ACTIONS(1281),
    [anon_sym_extern] = ACTIONS(1281),
    [anon_sym___attribute__] = ACTIONS(1281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1283),
    [anon_sym___declspec] = ACTIONS(1281),
    [anon_sym___cdecl] = ACTIONS(1281),
    [anon_sym___clrcall] = ACTIONS(1281),
    [anon_sym___stdcall] = ACTIONS(1281),
    [anon_sym___fastcall] = ACTIONS(1281),
    [anon_sym___thiscall] = ACTIONS(1281),
    [anon_sym___vectorcall] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_signed] = ACTIONS(1281),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [anon_sym_static] = ACTIONS(1281),
    [anon_sym_auto] = ACTIONS(1281),
    [anon_sym_register] = ACTIONS(1281),
    [anon_sym_inline] = ACTIONS(1281),
    [anon_sym___inline] = ACTIONS(1281),
    [anon_sym___inline__] = ACTIONS(1281),
    [anon_sym___forceinline] = ACTIONS(1281),
    [anon_sym_thread_local] = ACTIONS(1281),
    [anon_sym___thread] = ACTIONS(1281),
    [anon_sym_const] = ACTIONS(1281),
    [anon_sym_constexpr] = ACTIONS(1281),
    [anon_sym_volatile] = ACTIONS(1281),
    [anon_sym_restrict] = ACTIONS(1281),
    [anon_sym___restrict__] = ACTIONS(1281),
    [anon_sym__Atomic] = ACTIONS(1281),
    [anon_sym__Noreturn] = ACTIONS(1281),
    [anon_sym_noreturn] = ACTIONS(1281),
    [anon_sym__Nonnull] = ACTIONS(1281),
    [anon_sym_alignas] = ACTIONS(1281),
    [anon_sym__Alignas] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1281),
    [anon_sym_enum] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1281),
    [anon_sym_union] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(1281),
    [anon_sym_default] = ACTIONS(1281),
    [anon_sym_while] = ACTIONS(1281),
    [anon_sym_do] = ACTIONS(1281),
    [anon_sym_for] = ACTIONS(1281),
    [anon_sym_return] = ACTIONS(1281),
    [anon_sym_break] = ACTIONS(1281),
    [anon_sym_continue] = ACTIONS(1281),
    [anon_sym_goto] = ACTIONS(1281),
    [anon_sym___try] = ACTIONS(1281),
    [anon_sym___leave] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1283),
    [anon_sym_sizeof] = ACTIONS(1281),
    [anon_sym___alignof__] = ACTIONS(1281),
    [anon_sym___alignof] = ACTIONS(1281),
    [anon_sym__alignof] = ACTIONS(1281),
    [anon_sym_alignof] = ACTIONS(1281),
    [anon_sym__Alignof] = ACTIONS(1281),
    [anon_sym_offsetof] = ACTIONS(1281),
    [anon_sym__Generic] = ACTIONS(1281),
    [anon_sym_asm] = ACTIONS(1281),
    [anon_sym___asm__] = ACTIONS(1281),
    [anon_sym___asm] = ACTIONS(1281),
    [sym_number_literal] = ACTIONS(1283),
    [anon_sym_L_SQUOTE] = ACTIONS(1283),
    [anon_sym_u_SQUOTE] = ACTIONS(1283),
    [anon_sym_U_SQUOTE] = ACTIONS(1283),
    [anon_sym_u8_SQUOTE] = ACTIONS(1283),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_L_DQUOTE] = ACTIONS(1283),
    [anon_sym_u_DQUOTE] = ACTIONS(1283),
    [anon_sym_U_DQUOTE] = ACTIONS(1283),
    [anon_sym_u8_DQUOTE] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [anon_sym_NULL] = ACTIONS(1281),
    [anon_sym_nullptr] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_identifier] = ACTIONS(1289),
    [aux_sym_preproc_include_token1] = ACTIONS(1289),
    [aux_sym_preproc_def_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token2] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1289),
    [sym_preproc_directive] = ACTIONS(1289),
    [anon_sym_LPAREN2] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym___extension__] = ACTIONS(1289),
    [anon_sym_typedef] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1289),
    [anon_sym___attribute__] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1289),
    [anon_sym___cdecl] = ACTIONS(1289),
    [anon_sym___clrcall] = ACTIONS(1289),
    [anon_sym___stdcall] = ACTIONS(1289),
    [anon_sym___fastcall] = ACTIONS(1289),
    [anon_sym___thiscall] = ACTIONS(1289),
    [anon_sym___vectorcall] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_signed] = ACTIONS(1289),
    [anon_sym_unsigned] = ACTIONS(1289),
    [anon_sym_long] = ACTIONS(1289),
    [anon_sym_short] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_auto] = ACTIONS(1289),
    [anon_sym_register] = ACTIONS(1289),
    [anon_sym_inline] = ACTIONS(1289),
    [anon_sym___inline] = ACTIONS(1289),
    [anon_sym___inline__] = ACTIONS(1289),
    [anon_sym___forceinline] = ACTIONS(1289),
    [anon_sym_thread_local] = ACTIONS(1289),
    [anon_sym___thread] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_constexpr] = ACTIONS(1289),
    [anon_sym_volatile] = ACTIONS(1289),
    [anon_sym_restrict] = ACTIONS(1289),
    [anon_sym___restrict__] = ACTIONS(1289),
    [anon_sym__Atomic] = ACTIONS(1289),
    [anon_sym__Noreturn] = ACTIONS(1289),
    [anon_sym_noreturn] = ACTIONS(1289),
    [anon_sym__Nonnull] = ACTIONS(1289),
    [anon_sym_alignas] = ACTIONS(1289),
    [anon_sym__Alignas] = ACTIONS(1289),
    [sym_primitive_type] = ACTIONS(1289),
    [anon_sym_enum] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1289),
    [anon_sym_union] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_default] = ACTIONS(1289),
    [anon_sym_while] = ACTIONS(1289),
    [anon_sym_do] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1289),
    [anon_sym_return] = ACTIONS(1289),
    [anon_sym_break] = ACTIONS(1289),
    [anon_sym_continue] = ACTIONS(1289),
    [anon_sym_goto] = ACTIONS(1289),
    [anon_sym___try] = ACTIONS(1289),
    [anon_sym___leave] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1291),
    [anon_sym_sizeof] = ACTIONS(1289),
    [anon_sym___alignof__] = ACTIONS(1289),
    [anon_sym___alignof] = ACTIONS(1289),
    [anon_sym__alignof] = ACTIONS(1289),
    [anon_sym_alignof] = ACTIONS(1289),
    [anon_sym__Alignof] = ACTIONS(1289),
    [anon_sym_offsetof] = ACTIONS(1289),
    [anon_sym__Generic] = ACTIONS(1289),
    [anon_sym_asm] = ACTIONS(1289),
    [anon_sym___asm__] = ACTIONS(1289),
    [anon_sym___asm] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1291),
    [anon_sym_L_SQUOTE] = ACTIONS(1291),
    [anon_sym_u_SQUOTE] = ACTIONS(1291),
    [anon_sym_U_SQUOTE] = ACTIONS(1291),
    [anon_sym_u8_SQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1291),
    [anon_sym_L_DQUOTE] = ACTIONS(1291),
    [anon_sym_u_DQUOTE] = ACTIONS(1291),
    [anon_sym_U_DQUOTE] = ACTIONS(1291),
    [anon_sym_u8_DQUOTE] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [anon_sym_NULL] = ACTIONS(1289),
    [anon_sym_nullptr] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token2] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym__Nonnull] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [anon_sym___asm] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [sym_identifier] = ACTIONS(1265),
    [aux_sym_preproc_include_token1] = ACTIONS(1265),
    [aux_sym_preproc_def_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token2] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1265),
    [sym_preproc_directive] = ACTIONS(1265),
    [anon_sym_LPAREN2] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym___extension__] = ACTIONS(1265),
    [anon_sym_typedef] = ACTIONS(1265),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym___attribute__] = ACTIONS(1265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1267),
    [anon_sym___declspec] = ACTIONS(1265),
    [anon_sym___cdecl] = ACTIONS(1265),
    [anon_sym___clrcall] = ACTIONS(1265),
    [anon_sym___stdcall] = ACTIONS(1265),
    [anon_sym___fastcall] = ACTIONS(1265),
    [anon_sym___thiscall] = ACTIONS(1265),
    [anon_sym___vectorcall] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_auto] = ACTIONS(1265),
    [anon_sym_register] = ACTIONS(1265),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym___inline] = ACTIONS(1265),
    [anon_sym___inline__] = ACTIONS(1265),
    [anon_sym___forceinline] = ACTIONS(1265),
    [anon_sym_thread_local] = ACTIONS(1265),
    [anon_sym___thread] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_constexpr] = ACTIONS(1265),
    [anon_sym_volatile] = ACTIONS(1265),
    [anon_sym_restrict] = ACTIONS(1265),
    [anon_sym___restrict__] = ACTIONS(1265),
    [anon_sym__Atomic] = ACTIONS(1265),
    [anon_sym__Noreturn] = ACTIONS(1265),
    [anon_sym_noreturn] = ACTIONS(1265),
    [anon_sym__Nonnull] = ACTIONS(1265),
    [anon_sym_alignas] = ACTIONS(1265),
    [anon_sym__Alignas] = ACTIONS(1265),
    [sym_primitive_type] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1265),
    [anon_sym_union] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_goto] = ACTIONS(1265),
    [anon_sym___try] = ACTIONS(1265),
    [anon_sym___leave] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_sizeof] = ACTIONS(1265),
    [anon_sym___alignof__] = ACTIONS(1265),
    [anon_sym___alignof] = ACTIONS(1265),
    [anon_sym__alignof] = ACTIONS(1265),
    [anon_sym_alignof] = ACTIONS(1265),
    [anon_sym__Alignof] = ACTIONS(1265),
    [anon_sym_offsetof] = ACTIONS(1265),
    [anon_sym__Generic] = ACTIONS(1265),
    [anon_sym_asm] = ACTIONS(1265),
    [anon_sym___asm__] = ACTIONS(1265),
    [anon_sym___asm] = ACTIONS(1265),
    [sym_number_literal] = ACTIONS(1267),
    [anon_sym_L_SQUOTE] = ACTIONS(1267),
    [anon_sym_u_SQUOTE] = ACTIONS(1267),
    [anon_sym_U_SQUOTE] = ACTIONS(1267),
    [anon_sym_u8_SQUOTE] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [anon_sym_L_DQUOTE] = ACTIONS(1267),
    [anon_sym_u_DQUOTE] = ACTIONS(1267),
    [anon_sym_U_DQUOTE] = ACTIONS(1267),
    [anon_sym_u8_DQUOTE] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [anon_sym_NULL] = ACTIONS(1265),
    [anon_sym_nullptr] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [sym_identifier] = ACTIONS(1301),
    [aux_sym_preproc_include_token1] = ACTIONS(1301),
    [aux_sym_preproc_def_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token2] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1301),
    [sym_preproc_directive] = ACTIONS(1301),
    [anon_sym_LPAREN2] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym___extension__] = ACTIONS(1301),
    [anon_sym_typedef] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(1301),
    [anon_sym___attribute__] = ACTIONS(1301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1303),
    [anon_sym___declspec] = ACTIONS(1301),
    [anon_sym___cdecl] = ACTIONS(1301),
    [anon_sym___clrcall] = ACTIONS(1301),
    [anon_sym___stdcall] = ACTIONS(1301),
    [anon_sym___fastcall] = ACTIONS(1301),
    [anon_sym___thiscall] = ACTIONS(1301),
    [anon_sym___vectorcall] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_auto] = ACTIONS(1301),
    [anon_sym_register] = ACTIONS(1301),
    [anon_sym_inline] = ACTIONS(1301),
    [anon_sym___inline] = ACTIONS(1301),
    [anon_sym___inline__] = ACTIONS(1301),
    [anon_sym___forceinline] = ACTIONS(1301),
    [anon_sym_thread_local] = ACTIONS(1301),
    [anon_sym___thread] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_constexpr] = ACTIONS(1301),
    [anon_sym_volatile] = ACTIONS(1301),
    [anon_sym_restrict] = ACTIONS(1301),
    [anon_sym___restrict__] = ACTIONS(1301),
    [anon_sym__Atomic] = ACTIONS(1301),
    [anon_sym__Noreturn] = ACTIONS(1301),
    [anon_sym_noreturn] = ACTIONS(1301),
    [anon_sym__Nonnull] = ACTIONS(1301),
    [anon_sym_alignas] = ACTIONS(1301),
    [anon_sym__Alignas] = ACTIONS(1301),
    [sym_primitive_type] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1301),
    [anon_sym_union] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_goto] = ACTIONS(1301),
    [anon_sym___try] = ACTIONS(1301),
    [anon_sym___leave] = ACTIONS(1301),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1301),
    [anon_sym___alignof__] = ACTIONS(1301),
    [anon_sym___alignof] = ACTIONS(1301),
    [anon_sym__alignof] = ACTIONS(1301),
    [anon_sym_alignof] = ACTIONS(1301),
    [anon_sym__Alignof] = ACTIONS(1301),
    [anon_sym_offsetof] = ACTIONS(1301),
    [anon_sym__Generic] = ACTIONS(1301),
    [anon_sym_asm] = ACTIONS(1301),
    [anon_sym___asm__] = ACTIONS(1301),
    [anon_sym___asm] = ACTIONS(1301),
    [sym_number_literal] = ACTIONS(1303),
    [anon_sym_L_SQUOTE] = ACTIONS(1303),
    [anon_sym_u_SQUOTE] = ACTIONS(1303),
    [anon_sym_U_SQUOTE] = ACTIONS(1303),
    [anon_sym_u8_SQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1303),
    [anon_sym_L_DQUOTE] = ACTIONS(1303),
    [anon_sym_u_DQUOTE] = ACTIONS(1303),
    [anon_sym_U_DQUOTE] = ACTIONS(1303),
    [anon_sym_u8_DQUOTE] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [anon_sym_NULL] = ACTIONS(1301),
    [anon_sym_nullptr] = ACTIONS(1301),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_identifier] = ACTIONS(1297),
    [aux_sym_preproc_include_token1] = ACTIONS(1297),
    [aux_sym_preproc_def_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token2] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1297),
    [sym_preproc_directive] = ACTIONS(1297),
    [anon_sym_LPAREN2] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym___extension__] = ACTIONS(1297),
    [anon_sym_typedef] = ACTIONS(1297),
    [anon_sym_extern] = ACTIONS(1297),
    [anon_sym___attribute__] = ACTIONS(1297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1299),
    [anon_sym___declspec] = ACTIONS(1297),
    [anon_sym___cdecl] = ACTIONS(1297),
    [anon_sym___clrcall] = ACTIONS(1297),
    [anon_sym___stdcall] = ACTIONS(1297),
    [anon_sym___fastcall] = ACTIONS(1297),
    [anon_sym___thiscall] = ACTIONS(1297),
    [anon_sym___vectorcall] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(1297),
    [anon_sym_unsigned] = ACTIONS(1297),
    [anon_sym_long] = ACTIONS(1297),
    [anon_sym_short] = ACTIONS(1297),
    [anon_sym_static] = ACTIONS(1297),
    [anon_sym_auto] = ACTIONS(1297),
    [anon_sym_register] = ACTIONS(1297),
    [anon_sym_inline] = ACTIONS(1297),
    [anon_sym___inline] = ACTIONS(1297),
    [anon_sym___inline__] = ACTIONS(1297),
    [anon_sym___forceinline] = ACTIONS(1297),
    [anon_sym_thread_local] = ACTIONS(1297),
    [anon_sym___thread] = ACTIONS(1297),
    [anon_sym_const] = ACTIONS(1297),
    [anon_sym_constexpr] = ACTIONS(1297),
    [anon_sym_volatile] = ACTIONS(1297),
    [anon_sym_restrict] = ACTIONS(1297),
    [anon_sym___restrict__] = ACTIONS(1297),
    [anon_sym__Atomic] = ACTIONS(1297),
    [anon_sym__Noreturn] = ACTIONS(1297),
    [anon_sym_noreturn] = ACTIONS(1297),
    [anon_sym__Nonnull] = ACTIONS(1297),
    [anon_sym_alignas] = ACTIONS(1297),
    [anon_sym__Alignas] = ACTIONS(1297),
    [sym_primitive_type] = ACTIONS(1297),
    [anon_sym_enum] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1297),
    [anon_sym_union] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1297),
    [anon_sym_case] = ACTIONS(1297),
    [anon_sym_default] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_do] = ACTIONS(1297),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_return] = ACTIONS(1297),
    [anon_sym_break] = ACTIONS(1297),
    [anon_sym_continue] = ACTIONS(1297),
    [anon_sym_goto] = ACTIONS(1297),
    [anon_sym___try] = ACTIONS(1297),
    [anon_sym___leave] = ACTIONS(1297),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_sizeof] = ACTIONS(1297),
    [anon_sym___alignof__] = ACTIONS(1297),
    [anon_sym___alignof] = ACTIONS(1297),
    [anon_sym__alignof] = ACTIONS(1297),
    [anon_sym_alignof] = ACTIONS(1297),
    [anon_sym__Alignof] = ACTIONS(1297),
    [anon_sym_offsetof] = ACTIONS(1297),
    [anon_sym__Generic] = ACTIONS(1297),
    [anon_sym_asm] = ACTIONS(1297),
    [anon_sym___asm__] = ACTIONS(1297),
    [anon_sym___asm] = ACTIONS(1297),
    [sym_number_literal] = ACTIONS(1299),
    [anon_sym_L_SQUOTE] = ACTIONS(1299),
    [anon_sym_u_SQUOTE] = ACTIONS(1299),
    [anon_sym_U_SQUOTE] = ACTIONS(1299),
    [anon_sym_u8_SQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [anon_sym_L_DQUOTE] = ACTIONS(1299),
    [anon_sym_u_DQUOTE] = ACTIONS(1299),
    [anon_sym_U_DQUOTE] = ACTIONS(1299),
    [anon_sym_u8_DQUOTE] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_true] = ACTIONS(1297),
    [sym_false] = ACTIONS(1297),
    [anon_sym_NULL] = ACTIONS(1297),
    [anon_sym_nullptr] = ACTIONS(1297),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_identifier] = ACTIONS(1345),
    [aux_sym_preproc_include_token1] = ACTIONS(1345),
    [aux_sym_preproc_def_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1345),
    [sym_preproc_directive] = ACTIONS(1345),
    [anon_sym_LPAREN2] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym___extension__] = ACTIONS(1345),
    [anon_sym_typedef] = ACTIONS(1345),
    [anon_sym_extern] = ACTIONS(1345),
    [anon_sym___attribute__] = ACTIONS(1345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1347),
    [anon_sym___declspec] = ACTIONS(1345),
    [anon_sym___cdecl] = ACTIONS(1345),
    [anon_sym___clrcall] = ACTIONS(1345),
    [anon_sym___stdcall] = ACTIONS(1345),
    [anon_sym___fastcall] = ACTIONS(1345),
    [anon_sym___thiscall] = ACTIONS(1345),
    [anon_sym___vectorcall] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_signed] = ACTIONS(1345),
    [anon_sym_unsigned] = ACTIONS(1345),
    [anon_sym_long] = ACTIONS(1345),
    [anon_sym_short] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_auto] = ACTIONS(1345),
    [anon_sym_register] = ACTIONS(1345),
    [anon_sym_inline] = ACTIONS(1345),
    [anon_sym___inline] = ACTIONS(1345),
    [anon_sym___inline__] = ACTIONS(1345),
    [anon_sym___forceinline] = ACTIONS(1345),
    [anon_sym_thread_local] = ACTIONS(1345),
    [anon_sym___thread] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_constexpr] = ACTIONS(1345),
    [anon_sym_volatile] = ACTIONS(1345),
    [anon_sym_restrict] = ACTIONS(1345),
    [anon_sym___restrict__] = ACTIONS(1345),
    [anon_sym__Atomic] = ACTIONS(1345),
    [anon_sym__Noreturn] = ACTIONS(1345),
    [anon_sym_noreturn] = ACTIONS(1345),
    [anon_sym__Nonnull] = ACTIONS(1345),
    [anon_sym_alignas] = ACTIONS(1345),
    [anon_sym__Alignas] = ACTIONS(1345),
    [sym_primitive_type] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1345),
    [anon_sym_union] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_goto] = ACTIONS(1345),
    [anon_sym___try] = ACTIONS(1345),
    [anon_sym___leave] = ACTIONS(1345),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_sizeof] = ACTIONS(1345),
    [anon_sym___alignof__] = ACTIONS(1345),
    [anon_sym___alignof] = ACTIONS(1345),
    [anon_sym__alignof] = ACTIONS(1345),
    [anon_sym_alignof] = ACTIONS(1345),
    [anon_sym__Alignof] = ACTIONS(1345),
    [anon_sym_offsetof] = ACTIONS(1345),
    [anon_sym__Generic] = ACTIONS(1345),
    [anon_sym_asm] = ACTIONS(1345),
    [anon_sym___asm__] = ACTIONS(1345),
    [anon_sym___asm] = ACTIONS(1345),
    [sym_number_literal] = ACTIONS(1347),
    [anon_sym_L_SQUOTE] = ACTIONS(1347),
    [anon_sym_u_SQUOTE] = ACTIONS(1347),
    [anon_sym_U_SQUOTE] = ACTIONS(1347),
    [anon_sym_u8_SQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_L_DQUOTE] = ACTIONS(1347),
    [anon_sym_u_DQUOTE] = ACTIONS(1347),
    [anon_sym_U_DQUOTE] = ACTIONS(1347),
    [anon_sym_u8_DQUOTE] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [anon_sym_NULL] = ACTIONS(1345),
    [anon_sym_nullptr] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_identifier] = ACTIONS(1289),
    [aux_sym_preproc_include_token1] = ACTIONS(1289),
    [aux_sym_preproc_def_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1289),
    [sym_preproc_directive] = ACTIONS(1289),
    [anon_sym_LPAREN2] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym___extension__] = ACTIONS(1289),
    [anon_sym_typedef] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1289),
    [anon_sym___attribute__] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1289),
    [anon_sym___cdecl] = ACTIONS(1289),
    [anon_sym___clrcall] = ACTIONS(1289),
    [anon_sym___stdcall] = ACTIONS(1289),
    [anon_sym___fastcall] = ACTIONS(1289),
    [anon_sym___thiscall] = ACTIONS(1289),
    [anon_sym___vectorcall] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_signed] = ACTIONS(1289),
    [anon_sym_unsigned] = ACTIONS(1289),
    [anon_sym_long] = ACTIONS(1289),
    [anon_sym_short] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_auto] = ACTIONS(1289),
    [anon_sym_register] = ACTIONS(1289),
    [anon_sym_inline] = ACTIONS(1289),
    [anon_sym___inline] = ACTIONS(1289),
    [anon_sym___inline__] = ACTIONS(1289),
    [anon_sym___forceinline] = ACTIONS(1289),
    [anon_sym_thread_local] = ACTIONS(1289),
    [anon_sym___thread] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_constexpr] = ACTIONS(1289),
    [anon_sym_volatile] = ACTIONS(1289),
    [anon_sym_restrict] = ACTIONS(1289),
    [anon_sym___restrict__] = ACTIONS(1289),
    [anon_sym__Atomic] = ACTIONS(1289),
    [anon_sym__Noreturn] = ACTIONS(1289),
    [anon_sym_noreturn] = ACTIONS(1289),
    [anon_sym__Nonnull] = ACTIONS(1289),
    [anon_sym_alignas] = ACTIONS(1289),
    [anon_sym__Alignas] = ACTIONS(1289),
    [sym_primitive_type] = ACTIONS(1289),
    [anon_sym_enum] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1289),
    [anon_sym_union] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_default] = ACTIONS(1289),
    [anon_sym_while] = ACTIONS(1289),
    [anon_sym_do] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1289),
    [anon_sym_return] = ACTIONS(1289),
    [anon_sym_break] = ACTIONS(1289),
    [anon_sym_continue] = ACTIONS(1289),
    [anon_sym_goto] = ACTIONS(1289),
    [anon_sym___try] = ACTIONS(1289),
    [anon_sym___leave] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1291),
    [anon_sym_sizeof] = ACTIONS(1289),
    [anon_sym___alignof__] = ACTIONS(1289),
    [anon_sym___alignof] = ACTIONS(1289),
    [anon_sym__alignof] = ACTIONS(1289),
    [anon_sym_alignof] = ACTIONS(1289),
    [anon_sym__Alignof] = ACTIONS(1289),
    [anon_sym_offsetof] = ACTIONS(1289),
    [anon_sym__Generic] = ACTIONS(1289),
    [anon_sym_asm] = ACTIONS(1289),
    [anon_sym___asm__] = ACTIONS(1289),
    [anon_sym___asm] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1291),
    [anon_sym_L_SQUOTE] = ACTIONS(1291),
    [anon_sym_u_SQUOTE] = ACTIONS(1291),
    [anon_sym_U_SQUOTE] = ACTIONS(1291),
    [anon_sym_u8_SQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1291),
    [anon_sym_L_DQUOTE] = ACTIONS(1291),
    [anon_sym_u_DQUOTE] = ACTIONS(1291),
    [anon_sym_U_DQUOTE] = ACTIONS(1291),
    [anon_sym_u8_DQUOTE] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [anon_sym_NULL] = ACTIONS(1289),
    [anon_sym_nullptr] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_identifier] = ACTIONS(1313),
    [aux_sym_preproc_include_token1] = ACTIONS(1313),
    [aux_sym_preproc_def_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token2] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_LPAREN2] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym___extension__] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym___attribute__] = ACTIONS(1313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1315),
    [anon_sym___declspec] = ACTIONS(1313),
    [anon_sym___cdecl] = ACTIONS(1313),
    [anon_sym___clrcall] = ACTIONS(1313),
    [anon_sym___stdcall] = ACTIONS(1313),
    [anon_sym___fastcall] = ACTIONS(1313),
    [anon_sym___thiscall] = ACTIONS(1313),
    [anon_sym___vectorcall] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_signed] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_auto] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym___inline] = ACTIONS(1313),
    [anon_sym___inline__] = ACTIONS(1313),
    [anon_sym___forceinline] = ACTIONS(1313),
    [anon_sym_thread_local] = ACTIONS(1313),
    [anon_sym___thread] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym___restrict__] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym__Noreturn] = ACTIONS(1313),
    [anon_sym_noreturn] = ACTIONS(1313),
    [anon_sym__Nonnull] = ACTIONS(1313),
    [anon_sym_alignas] = ACTIONS(1313),
    [anon_sym__Alignas] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym___try] = ACTIONS(1313),
    [anon_sym___leave] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_sizeof] = ACTIONS(1313),
    [anon_sym___alignof__] = ACTIONS(1313),
    [anon_sym___alignof] = ACTIONS(1313),
    [anon_sym__alignof] = ACTIONS(1313),
    [anon_sym_alignof] = ACTIONS(1313),
    [anon_sym__Alignof] = ACTIONS(1313),
    [anon_sym_offsetof] = ACTIONS(1313),
    [anon_sym__Generic] = ACTIONS(1313),
    [anon_sym_asm] = ACTIONS(1313),
    [anon_sym___asm__] = ACTIONS(1313),
    [anon_sym___asm] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1315),
    [anon_sym_L_SQUOTE] = ACTIONS(1315),
    [anon_sym_u_SQUOTE] = ACTIONS(1315),
    [anon_sym_U_SQUOTE] = ACTIONS(1315),
    [anon_sym_u8_SQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [anon_sym_L_DQUOTE] = ACTIONS(1315),
    [anon_sym_u_DQUOTE] = ACTIONS(1315),
    [anon_sym_U_DQUOTE] = ACTIONS(1315),
    [anon_sym_u8_DQUOTE] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [anon_sym_NULL] = ACTIONS(1313),
    [anon_sym_nullptr] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym__Nonnull] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [anon_sym___asm] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [sym_identifier] = ACTIONS(1269),
    [aux_sym_preproc_include_token1] = ACTIONS(1269),
    [aux_sym_preproc_def_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_LPAREN2] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym___extension__] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym___attribute__] = ACTIONS(1269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1271),
    [anon_sym___declspec] = ACTIONS(1269),
    [anon_sym___cdecl] = ACTIONS(1269),
    [anon_sym___clrcall] = ACTIONS(1269),
    [anon_sym___stdcall] = ACTIONS(1269),
    [anon_sym___fastcall] = ACTIONS(1269),
    [anon_sym___thiscall] = ACTIONS(1269),
    [anon_sym___vectorcall] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_signed] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_auto] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym___inline] = ACTIONS(1269),
    [anon_sym___inline__] = ACTIONS(1269),
    [anon_sym___forceinline] = ACTIONS(1269),
    [anon_sym_thread_local] = ACTIONS(1269),
    [anon_sym___thread] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym___restrict__] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym__Noreturn] = ACTIONS(1269),
    [anon_sym_noreturn] = ACTIONS(1269),
    [anon_sym__Nonnull] = ACTIONS(1269),
    [anon_sym_alignas] = ACTIONS(1269),
    [anon_sym__Alignas] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_goto] = ACTIONS(1269),
    [anon_sym___try] = ACTIONS(1269),
    [anon_sym___leave] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_sizeof] = ACTIONS(1269),
    [anon_sym___alignof__] = ACTIONS(1269),
    [anon_sym___alignof] = ACTIONS(1269),
    [anon_sym__alignof] = ACTIONS(1269),
    [anon_sym_alignof] = ACTIONS(1269),
    [anon_sym__Alignof] = ACTIONS(1269),
    [anon_sym_offsetof] = ACTIONS(1269),
    [anon_sym__Generic] = ACTIONS(1269),
    [anon_sym_asm] = ACTIONS(1269),
    [anon_sym___asm__] = ACTIONS(1269),
    [anon_sym___asm] = ACTIONS(1269),
    [sym_number_literal] = ACTIONS(1271),
    [anon_sym_L_SQUOTE] = ACTIONS(1271),
    [anon_sym_u_SQUOTE] = ACTIONS(1271),
    [anon_sym_U_SQUOTE] = ACTIONS(1271),
    [anon_sym_u8_SQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [anon_sym_L_DQUOTE] = ACTIONS(1271),
    [anon_sym_u_DQUOTE] = ACTIONS(1271),
    [anon_sym_U_DQUOTE] = ACTIONS(1271),
    [anon_sym_u8_DQUOTE] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [anon_sym_NULL] = ACTIONS(1269),
    [anon_sym_nullptr] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym_identifier] = ACTIONS(1265),
    [aux_sym_preproc_include_token1] = ACTIONS(1265),
    [aux_sym_preproc_def_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1265),
    [sym_preproc_directive] = ACTIONS(1265),
    [anon_sym_LPAREN2] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym___extension__] = ACTIONS(1265),
    [anon_sym_typedef] = ACTIONS(1265),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym___attribute__] = ACTIONS(1265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1267),
    [anon_sym___declspec] = ACTIONS(1265),
    [anon_sym___cdecl] = ACTIONS(1265),
    [anon_sym___clrcall] = ACTIONS(1265),
    [anon_sym___stdcall] = ACTIONS(1265),
    [anon_sym___fastcall] = ACTIONS(1265),
    [anon_sym___thiscall] = ACTIONS(1265),
    [anon_sym___vectorcall] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_auto] = ACTIONS(1265),
    [anon_sym_register] = ACTIONS(1265),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym___inline] = ACTIONS(1265),
    [anon_sym___inline__] = ACTIONS(1265),
    [anon_sym___forceinline] = ACTIONS(1265),
    [anon_sym_thread_local] = ACTIONS(1265),
    [anon_sym___thread] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_constexpr] = ACTIONS(1265),
    [anon_sym_volatile] = ACTIONS(1265),
    [anon_sym_restrict] = ACTIONS(1265),
    [anon_sym___restrict__] = ACTIONS(1265),
    [anon_sym__Atomic] = ACTIONS(1265),
    [anon_sym__Noreturn] = ACTIONS(1265),
    [anon_sym_noreturn] = ACTIONS(1265),
    [anon_sym__Nonnull] = ACTIONS(1265),
    [anon_sym_alignas] = ACTIONS(1265),
    [anon_sym__Alignas] = ACTIONS(1265),
    [sym_primitive_type] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1265),
    [anon_sym_union] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_goto] = ACTIONS(1265),
    [anon_sym___try] = ACTIONS(1265),
    [anon_sym___leave] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_sizeof] = ACTIONS(1265),
    [anon_sym___alignof__] = ACTIONS(1265),
    [anon_sym___alignof] = ACTIONS(1265),
    [anon_sym__alignof] = ACTIONS(1265),
    [anon_sym_alignof] = ACTIONS(1265),
    [anon_sym__Alignof] = ACTIONS(1265),
    [anon_sym_offsetof] = ACTIONS(1265),
    [anon_sym__Generic] = ACTIONS(1265),
    [anon_sym_asm] = ACTIONS(1265),
    [anon_sym___asm__] = ACTIONS(1265),
    [anon_sym___asm] = ACTIONS(1265),
    [sym_number_literal] = ACTIONS(1267),
    [anon_sym_L_SQUOTE] = ACTIONS(1267),
    [anon_sym_u_SQUOTE] = ACTIONS(1267),
    [anon_sym_U_SQUOTE] = ACTIONS(1267),
    [anon_sym_u8_SQUOTE] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [anon_sym_L_DQUOTE] = ACTIONS(1267),
    [anon_sym_u_DQUOTE] = ACTIONS(1267),
    [anon_sym_U_DQUOTE] = ACTIONS(1267),
    [anon_sym_u8_DQUOTE] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [anon_sym_NULL] = ACTIONS(1265),
    [anon_sym_nullptr] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym_identifier] = ACTIONS(1301),
    [aux_sym_preproc_include_token1] = ACTIONS(1301),
    [aux_sym_preproc_def_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1301),
    [sym_preproc_directive] = ACTIONS(1301),
    [anon_sym_LPAREN2] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym___extension__] = ACTIONS(1301),
    [anon_sym_typedef] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(1301),
    [anon_sym___attribute__] = ACTIONS(1301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1303),
    [anon_sym___declspec] = ACTIONS(1301),
    [anon_sym___cdecl] = ACTIONS(1301),
    [anon_sym___clrcall] = ACTIONS(1301),
    [anon_sym___stdcall] = ACTIONS(1301),
    [anon_sym___fastcall] = ACTIONS(1301),
    [anon_sym___thiscall] = ACTIONS(1301),
    [anon_sym___vectorcall] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_RBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_auto] = ACTIONS(1301),
    [anon_sym_register] = ACTIONS(1301),
    [anon_sym_inline] = ACTIONS(1301),
    [anon_sym___inline] = ACTIONS(1301),
    [anon_sym___inline__] = ACTIONS(1301),
    [anon_sym___forceinline] = ACTIONS(1301),
    [anon_sym_thread_local] = ACTIONS(1301),
    [anon_sym___thread] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_constexpr] = ACTIONS(1301),
    [anon_sym_volatile] = ACTIONS(1301),
    [anon_sym_restrict] = ACTIONS(1301),
    [anon_sym___restrict__] = ACTIONS(1301),
    [anon_sym__Atomic] = ACTIONS(1301),
    [anon_sym__Noreturn] = ACTIONS(1301),
    [anon_sym_noreturn] = ACTIONS(1301),
    [anon_sym__Nonnull] = ACTIONS(1301),
    [anon_sym_alignas] = ACTIONS(1301),
    [anon_sym__Alignas] = ACTIONS(1301),
    [sym_primitive_type] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1301),
    [anon_sym_union] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_goto] = ACTIONS(1301),
    [anon_sym___try] = ACTIONS(1301),
    [anon_sym___leave] = ACTIONS(1301),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1301),
    [anon_sym___alignof__] = ACTIONS(1301),
    [anon_sym___alignof] = ACTIONS(1301),
    [anon_sym__alignof] = ACTIONS(1301),
    [anon_sym_alignof] = ACTIONS(1301),
    [anon_sym__Alignof] = ACTIONS(1301),
    [anon_sym_offsetof] = ACTIONS(1301),
    [anon_sym__Generic] = ACTIONS(1301),
    [anon_sym_asm] = ACTIONS(1301),
    [anon_sym___asm__] = ACTIONS(1301),
    [anon_sym___asm] = ACTIONS(1301),
    [sym_number_literal] = ACTIONS(1303),
    [anon_sym_L_SQUOTE] = ACTIONS(1303),
    [anon_sym_u_SQUOTE] = ACTIONS(1303),
    [anon_sym_U_SQUOTE] = ACTIONS(1303),
    [anon_sym_u8_SQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1303),
    [anon_sym_L_DQUOTE] = ACTIONS(1303),
    [anon_sym_u_DQUOTE] = ACTIONS(1303),
    [anon_sym_U_DQUOTE] = ACTIONS(1303),
    [anon_sym_u8_DQUOTE] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [anon_sym_NULL] = ACTIONS(1301),
    [anon_sym_nullptr] = ACTIONS(1301),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym_identifier] = ACTIONS(1345),
    [aux_sym_preproc_include_token1] = ACTIONS(1345),
    [aux_sym_preproc_def_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token2] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1345),
    [sym_preproc_directive] = ACTIONS(1345),
    [anon_sym_LPAREN2] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym___extension__] = ACTIONS(1345),
    [anon_sym_typedef] = ACTIONS(1345),
    [anon_sym_extern] = ACTIONS(1345),
    [anon_sym___attribute__] = ACTIONS(1345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1347),
    [anon_sym___declspec] = ACTIONS(1345),
    [anon_sym___cdecl] = ACTIONS(1345),
    [anon_sym___clrcall] = ACTIONS(1345),
    [anon_sym___stdcall] = ACTIONS(1345),
    [anon_sym___fastcall] = ACTIONS(1345),
    [anon_sym___thiscall] = ACTIONS(1345),
    [anon_sym___vectorcall] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_signed] = ACTIONS(1345),
    [anon_sym_unsigned] = ACTIONS(1345),
    [anon_sym_long] = ACTIONS(1345),
    [anon_sym_short] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_auto] = ACTIONS(1345),
    [anon_sym_register] = ACTIONS(1345),
    [anon_sym_inline] = ACTIONS(1345),
    [anon_sym___inline] = ACTIONS(1345),
    [anon_sym___inline__] = ACTIONS(1345),
    [anon_sym___forceinline] = ACTIONS(1345),
    [anon_sym_thread_local] = ACTIONS(1345),
    [anon_sym___thread] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_constexpr] = ACTIONS(1345),
    [anon_sym_volatile] = ACTIONS(1345),
    [anon_sym_restrict] = ACTIONS(1345),
    [anon_sym___restrict__] = ACTIONS(1345),
    [anon_sym__Atomic] = ACTIONS(1345),
    [anon_sym__Noreturn] = ACTIONS(1345),
    [anon_sym_noreturn] = ACTIONS(1345),
    [anon_sym__Nonnull] = ACTIONS(1345),
    [anon_sym_alignas] = ACTIONS(1345),
    [anon_sym__Alignas] = ACTIONS(1345),
    [sym_primitive_type] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1345),
    [anon_sym_union] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_goto] = ACTIONS(1345),
    [anon_sym___try] = ACTIONS(1345),
    [anon_sym___leave] = ACTIONS(1345),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_sizeof] = ACTIONS(1345),
    [anon_sym___alignof__] = ACTIONS(1345),
    [anon_sym___alignof] = ACTIONS(1345),
    [anon_sym__alignof] = ACTIONS(1345),
    [anon_sym_alignof] = ACTIONS(1345),
    [anon_sym__Alignof] = ACTIONS(1345),
    [anon_sym_offsetof] = ACTIONS(1345),
    [anon_sym__Generic] = ACTIONS(1345),
    [anon_sym_asm] = ACTIONS(1345),
    [anon_sym___asm__] = ACTIONS(1345),
    [anon_sym___asm] = ACTIONS(1345),
    [sym_number_literal] = ACTIONS(1347),
    [anon_sym_L_SQUOTE] = ACTIONS(1347),
    [anon_sym_u_SQUOTE] = ACTIONS(1347),
    [anon_sym_U_SQUOTE] = ACTIONS(1347),
    [anon_sym_u8_SQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_L_DQUOTE] = ACTIONS(1347),
    [anon_sym_u_DQUOTE] = ACTIONS(1347),
    [anon_sym_U_DQUOTE] = ACTIONS(1347),
    [anon_sym_u8_DQUOTE] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [anon_sym_NULL] = ACTIONS(1345),
    [anon_sym_nullptr] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym_identifier] = ACTIONS(1349),
    [aux_sym_preproc_include_token1] = ACTIONS(1349),
    [aux_sym_preproc_def_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token2] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1349),
    [sym_preproc_directive] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym___extension__] = ACTIONS(1349),
    [anon_sym_typedef] = ACTIONS(1349),
    [anon_sym_extern] = ACTIONS(1349),
    [anon_sym___attribute__] = ACTIONS(1349),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1351),
    [anon_sym___declspec] = ACTIONS(1349),
    [anon_sym___cdecl] = ACTIONS(1349),
    [anon_sym___clrcall] = ACTIONS(1349),
    [anon_sym___stdcall] = ACTIONS(1349),
    [anon_sym___fastcall] = ACTIONS(1349),
    [anon_sym___thiscall] = ACTIONS(1349),
    [anon_sym___vectorcall] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_signed] = ACTIONS(1349),
    [anon_sym_unsigned] = ACTIONS(1349),
    [anon_sym_long] = ACTIONS(1349),
    [anon_sym_short] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_auto] = ACTIONS(1349),
    [anon_sym_register] = ACTIONS(1349),
    [anon_sym_inline] = ACTIONS(1349),
    [anon_sym___inline] = ACTIONS(1349),
    [anon_sym___inline__] = ACTIONS(1349),
    [anon_sym___forceinline] = ACTIONS(1349),
    [anon_sym_thread_local] = ACTIONS(1349),
    [anon_sym___thread] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_constexpr] = ACTIONS(1349),
    [anon_sym_volatile] = ACTIONS(1349),
    [anon_sym_restrict] = ACTIONS(1349),
    [anon_sym___restrict__] = ACTIONS(1349),
    [anon_sym__Atomic] = ACTIONS(1349),
    [anon_sym__Noreturn] = ACTIONS(1349),
    [anon_sym_noreturn] = ACTIONS(1349),
    [anon_sym__Nonnull] = ACTIONS(1349),
    [anon_sym_alignas] = ACTIONS(1349),
    [anon_sym__Alignas] = ACTIONS(1349),
    [sym_primitive_type] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1349),
    [anon_sym_union] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_goto] = ACTIONS(1349),
    [anon_sym___try] = ACTIONS(1349),
    [anon_sym___leave] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_sizeof] = ACTIONS(1349),
    [anon_sym___alignof__] = ACTIONS(1349),
    [anon_sym___alignof] = ACTIONS(1349),
    [anon_sym__alignof] = ACTIONS(1349),
    [anon_sym_alignof] = ACTIONS(1349),
    [anon_sym__Alignof] = ACTIONS(1349),
    [anon_sym_offsetof] = ACTIONS(1349),
    [anon_sym__Generic] = ACTIONS(1349),
    [anon_sym_asm] = ACTIONS(1349),
    [anon_sym___asm__] = ACTIONS(1349),
    [anon_sym___asm] = ACTIONS(1349),
    [sym_number_literal] = ACTIONS(1351),
    [anon_sym_L_SQUOTE] = ACTIONS(1351),
    [anon_sym_u_SQUOTE] = ACTIONS(1351),
    [anon_sym_U_SQUOTE] = ACTIONS(1351),
    [anon_sym_u8_SQUOTE] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1351),
    [anon_sym_L_DQUOTE] = ACTIONS(1351),
    [anon_sym_u_DQUOTE] = ACTIONS(1351),
    [anon_sym_U_DQUOTE] = ACTIONS(1351),
    [anon_sym_u8_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [anon_sym_NULL] = ACTIONS(1349),
    [anon_sym_nullptr] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [sym_identifier] = ACTIONS(1353),
    [aux_sym_preproc_include_token1] = ACTIONS(1353),
    [aux_sym_preproc_def_token1] = ACTIONS(1353),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_if_token2] = ACTIONS(1353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1353),
    [sym_preproc_directive] = ACTIONS(1353),
    [anon_sym_LPAREN2] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_AMP] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1355),
    [anon_sym___extension__] = ACTIONS(1353),
    [anon_sym_typedef] = ACTIONS(1353),
    [anon_sym_extern] = ACTIONS(1353),
    [anon_sym___attribute__] = ACTIONS(1353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1355),
    [anon_sym___declspec] = ACTIONS(1353),
    [anon_sym___cdecl] = ACTIONS(1353),
    [anon_sym___clrcall] = ACTIONS(1353),
    [anon_sym___stdcall] = ACTIONS(1353),
    [anon_sym___fastcall] = ACTIONS(1353),
    [anon_sym___thiscall] = ACTIONS(1353),
    [anon_sym___vectorcall] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1355),
    [anon_sym_signed] = ACTIONS(1353),
    [anon_sym_unsigned] = ACTIONS(1353),
    [anon_sym_long] = ACTIONS(1353),
    [anon_sym_short] = ACTIONS(1353),
    [anon_sym_static] = ACTIONS(1353),
    [anon_sym_auto] = ACTIONS(1353),
    [anon_sym_register] = ACTIONS(1353),
    [anon_sym_inline] = ACTIONS(1353),
    [anon_sym___inline] = ACTIONS(1353),
    [anon_sym___inline__] = ACTIONS(1353),
    [anon_sym___forceinline] = ACTIONS(1353),
    [anon_sym_thread_local] = ACTIONS(1353),
    [anon_sym___thread] = ACTIONS(1353),
    [anon_sym_const] = ACTIONS(1353),
    [anon_sym_constexpr] = ACTIONS(1353),
    [anon_sym_volatile] = ACTIONS(1353),
    [anon_sym_restrict] = ACTIONS(1353),
    [anon_sym___restrict__] = ACTIONS(1353),
    [anon_sym__Atomic] = ACTIONS(1353),
    [anon_sym__Noreturn] = ACTIONS(1353),
    [anon_sym_noreturn] = ACTIONS(1353),
    [anon_sym__Nonnull] = ACTIONS(1353),
    [anon_sym_alignas] = ACTIONS(1353),
    [anon_sym__Alignas] = ACTIONS(1353),
    [sym_primitive_type] = ACTIONS(1353),
    [anon_sym_enum] = ACTIONS(1353),
    [anon_sym_struct] = ACTIONS(1353),
    [anon_sym_union] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(1353),
    [anon_sym_switch] = ACTIONS(1353),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_default] = ACTIONS(1353),
    [anon_sym_while] = ACTIONS(1353),
    [anon_sym_do] = ACTIONS(1353),
    [anon_sym_for] = ACTIONS(1353),
    [anon_sym_return] = ACTIONS(1353),
    [anon_sym_break] = ACTIONS(1353),
    [anon_sym_continue] = ACTIONS(1353),
    [anon_sym_goto] = ACTIONS(1353),
    [anon_sym___try] = ACTIONS(1353),
    [anon_sym___leave] = ACTIONS(1353),
    [anon_sym_DASH_DASH] = ACTIONS(1355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1355),
    [anon_sym_sizeof] = ACTIONS(1353),
    [anon_sym___alignof__] = ACTIONS(1353),
    [anon_sym___alignof] = ACTIONS(1353),
    [anon_sym__alignof] = ACTIONS(1353),
    [anon_sym_alignof] = ACTIONS(1353),
    [anon_sym__Alignof] = ACTIONS(1353),
    [anon_sym_offsetof] = ACTIONS(1353),
    [anon_sym__Generic] = ACTIONS(1353),
    [anon_sym_asm] = ACTIONS(1353),
    [anon_sym___asm__] = ACTIONS(1353),
    [anon_sym___asm] = ACTIONS(1353),
    [sym_number_literal] = ACTIONS(1355),
    [anon_sym_L_SQUOTE] = ACTIONS(1355),
    [anon_sym_u_SQUOTE] = ACTIONS(1355),
    [anon_sym_U_SQUOTE] = ACTIONS(1355),
    [anon_sym_u8_SQUOTE] = ACTIONS(1355),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_L_DQUOTE] = ACTIONS(1355),
    [anon_sym_u_DQUOTE] = ACTIONS(1355),
    [anon_sym_U_DQUOTE] = ACTIONS(1355),
    [anon_sym_u8_DQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_true] = ACTIONS(1353),
    [sym_false] = ACTIONS(1353),
    [anon_sym_NULL] = ACTIONS(1353),
    [anon_sym_nullptr] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [sym_identifier] = ACTIONS(1297),
    [aux_sym_preproc_include_token1] = ACTIONS(1297),
    [aux_sym_preproc_def_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1297),
    [sym_preproc_directive] = ACTIONS(1297),
    [anon_sym_LPAREN2] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym___extension__] = ACTIONS(1297),
    [anon_sym_typedef] = ACTIONS(1297),
    [anon_sym_extern] = ACTIONS(1297),
    [anon_sym___attribute__] = ACTIONS(1297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1299),
    [anon_sym___declspec] = ACTIONS(1297),
    [anon_sym___cdecl] = ACTIONS(1297),
    [anon_sym___clrcall] = ACTIONS(1297),
    [anon_sym___stdcall] = ACTIONS(1297),
    [anon_sym___fastcall] = ACTIONS(1297),
    [anon_sym___thiscall] = ACTIONS(1297),
    [anon_sym___vectorcall] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_RBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(1297),
    [anon_sym_unsigned] = ACTIONS(1297),
    [anon_sym_long] = ACTIONS(1297),
    [anon_sym_short] = ACTIONS(1297),
    [anon_sym_static] = ACTIONS(1297),
    [anon_sym_auto] = ACTIONS(1297),
    [anon_sym_register] = ACTIONS(1297),
    [anon_sym_inline] = ACTIONS(1297),
    [anon_sym___inline] = ACTIONS(1297),
    [anon_sym___inline__] = ACTIONS(1297),
    [anon_sym___forceinline] = ACTIONS(1297),
    [anon_sym_thread_local] = ACTIONS(1297),
    [anon_sym___thread] = ACTIONS(1297),
    [anon_sym_const] = ACTIONS(1297),
    [anon_sym_constexpr] = ACTIONS(1297),
    [anon_sym_volatile] = ACTIONS(1297),
    [anon_sym_restrict] = ACTIONS(1297),
    [anon_sym___restrict__] = ACTIONS(1297),
    [anon_sym__Atomic] = ACTIONS(1297),
    [anon_sym__Noreturn] = ACTIONS(1297),
    [anon_sym_noreturn] = ACTIONS(1297),
    [anon_sym__Nonnull] = ACTIONS(1297),
    [anon_sym_alignas] = ACTIONS(1297),
    [anon_sym__Alignas] = ACTIONS(1297),
    [sym_primitive_type] = ACTIONS(1297),
    [anon_sym_enum] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1297),
    [anon_sym_union] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1297),
    [anon_sym_case] = ACTIONS(1297),
    [anon_sym_default] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_do] = ACTIONS(1297),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_return] = ACTIONS(1297),
    [anon_sym_break] = ACTIONS(1297),
    [anon_sym_continue] = ACTIONS(1297),
    [anon_sym_goto] = ACTIONS(1297),
    [anon_sym___try] = ACTIONS(1297),
    [anon_sym___leave] = ACTIONS(1297),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_sizeof] = ACTIONS(1297),
    [anon_sym___alignof__] = ACTIONS(1297),
    [anon_sym___alignof] = ACTIONS(1297),
    [anon_sym__alignof] = ACTIONS(1297),
    [anon_sym_alignof] = ACTIONS(1297),
    [anon_sym__Alignof] = ACTIONS(1297),
    [anon_sym_offsetof] = ACTIONS(1297),
    [anon_sym__Generic] = ACTIONS(1297),
    [anon_sym_asm] = ACTIONS(1297),
    [anon_sym___asm__] = ACTIONS(1297),
    [anon_sym___asm] = ACTIONS(1297),
    [sym_number_literal] = ACTIONS(1299),
    [anon_sym_L_SQUOTE] = ACTIONS(1299),
    [anon_sym_u_SQUOTE] = ACTIONS(1299),
    [anon_sym_U_SQUOTE] = ACTIONS(1299),
    [anon_sym_u8_SQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [anon_sym_L_DQUOTE] = ACTIONS(1299),
    [anon_sym_u_DQUOTE] = ACTIONS(1299),
    [anon_sym_U_DQUOTE] = ACTIONS(1299),
    [anon_sym_u8_DQUOTE] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_true] = ACTIONS(1297),
    [sym_false] = ACTIONS(1297),
    [anon_sym_NULL] = ACTIONS(1297),
    [anon_sym_nullptr] = ACTIONS(1297),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym__Nonnull] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [anon_sym___asm] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_identifier] = ACTIONS(1321),
    [aux_sym_preproc_include_token1] = ACTIONS(1321),
    [aux_sym_preproc_def_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token2] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1321),
    [sym_preproc_directive] = ACTIONS(1321),
    [anon_sym_LPAREN2] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym___extension__] = ACTIONS(1321),
    [anon_sym_typedef] = ACTIONS(1321),
    [anon_sym_extern] = ACTIONS(1321),
    [anon_sym___attribute__] = ACTIONS(1321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1323),
    [anon_sym___declspec] = ACTIONS(1321),
    [anon_sym___cdecl] = ACTIONS(1321),
    [anon_sym___clrcall] = ACTIONS(1321),
    [anon_sym___stdcall] = ACTIONS(1321),
    [anon_sym___fastcall] = ACTIONS(1321),
    [anon_sym___thiscall] = ACTIONS(1321),
    [anon_sym___vectorcall] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_signed] = ACTIONS(1321),
    [anon_sym_unsigned] = ACTIONS(1321),
    [anon_sym_long] = ACTIONS(1321),
    [anon_sym_short] = ACTIONS(1321),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_auto] = ACTIONS(1321),
    [anon_sym_register] = ACTIONS(1321),
    [anon_sym_inline] = ACTIONS(1321),
    [anon_sym___inline] = ACTIONS(1321),
    [anon_sym___inline__] = ACTIONS(1321),
    [anon_sym___forceinline] = ACTIONS(1321),
    [anon_sym_thread_local] = ACTIONS(1321),
    [anon_sym___thread] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_constexpr] = ACTIONS(1321),
    [anon_sym_volatile] = ACTIONS(1321),
    [anon_sym_restrict] = ACTIONS(1321),
    [anon_sym___restrict__] = ACTIONS(1321),
    [anon_sym__Atomic] = ACTIONS(1321),
    [anon_sym__Noreturn] = ACTIONS(1321),
    [anon_sym_noreturn] = ACTIONS(1321),
    [anon_sym__Nonnull] = ACTIONS(1321),
    [anon_sym_alignas] = ACTIONS(1321),
    [anon_sym__Alignas] = ACTIONS(1321),
    [sym_primitive_type] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_goto] = ACTIONS(1321),
    [anon_sym___try] = ACTIONS(1321),
    [anon_sym___leave] = ACTIONS(1321),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_sizeof] = ACTIONS(1321),
    [anon_sym___alignof__] = ACTIONS(1321),
    [anon_sym___alignof] = ACTIONS(1321),
    [anon_sym__alignof] = ACTIONS(1321),
    [anon_sym_alignof] = ACTIONS(1321),
    [anon_sym__Alignof] = ACTIONS(1321),
    [anon_sym_offsetof] = ACTIONS(1321),
    [anon_sym__Generic] = ACTIONS(1321),
    [anon_sym_asm] = ACTIONS(1321),
    [anon_sym___asm__] = ACTIONS(1321),
    [anon_sym___asm] = ACTIONS(1321),
    [sym_number_literal] = ACTIONS(1323),
    [anon_sym_L_SQUOTE] = ACTIONS(1323),
    [anon_sym_u_SQUOTE] = ACTIONS(1323),
    [anon_sym_U_SQUOTE] = ACTIONS(1323),
    [anon_sym_u8_SQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [anon_sym_L_DQUOTE] = ACTIONS(1323),
    [anon_sym_u_DQUOTE] = ACTIONS(1323),
    [anon_sym_U_DQUOTE] = ACTIONS(1323),
    [anon_sym_u8_DQUOTE] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [anon_sym_NULL] = ACTIONS(1321),
    [anon_sym_nullptr] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_identifier] = ACTIONS(1337),
    [aux_sym_preproc_include_token1] = ACTIONS(1337),
    [aux_sym_preproc_def_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token2] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1337),
    [sym_preproc_directive] = ACTIONS(1337),
    [anon_sym_LPAREN2] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym___extension__] = ACTIONS(1337),
    [anon_sym_typedef] = ACTIONS(1337),
    [anon_sym_extern] = ACTIONS(1337),
    [anon_sym___attribute__] = ACTIONS(1337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1339),
    [anon_sym___declspec] = ACTIONS(1337),
    [anon_sym___cdecl] = ACTIONS(1337),
    [anon_sym___clrcall] = ACTIONS(1337),
    [anon_sym___stdcall] = ACTIONS(1337),
    [anon_sym___fastcall] = ACTIONS(1337),
    [anon_sym___thiscall] = ACTIONS(1337),
    [anon_sym___vectorcall] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_signed] = ACTIONS(1337),
    [anon_sym_unsigned] = ACTIONS(1337),
    [anon_sym_long] = ACTIONS(1337),
    [anon_sym_short] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_auto] = ACTIONS(1337),
    [anon_sym_register] = ACTIONS(1337),
    [anon_sym_inline] = ACTIONS(1337),
    [anon_sym___inline] = ACTIONS(1337),
    [anon_sym___inline__] = ACTIONS(1337),
    [anon_sym___forceinline] = ACTIONS(1337),
    [anon_sym_thread_local] = ACTIONS(1337),
    [anon_sym___thread] = ACTIONS(1337),
    [anon_sym_const] = ACTIONS(1337),
    [anon_sym_constexpr] = ACTIONS(1337),
    [anon_sym_volatile] = ACTIONS(1337),
    [anon_sym_restrict] = ACTIONS(1337),
    [anon_sym___restrict__] = ACTIONS(1337),
    [anon_sym__Atomic] = ACTIONS(1337),
    [anon_sym__Noreturn] = ACTIONS(1337),
    [anon_sym_noreturn] = ACTIONS(1337),
    [anon_sym__Nonnull] = ACTIONS(1337),
    [anon_sym_alignas] = ACTIONS(1337),
    [anon_sym__Alignas] = ACTIONS(1337),
    [sym_primitive_type] = ACTIONS(1337),
    [anon_sym_enum] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1337),
    [anon_sym_union] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1337),
    [anon_sym_default] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_do] = ACTIONS(1337),
    [anon_sym_for] = ACTIONS(1337),
    [anon_sym_return] = ACTIONS(1337),
    [anon_sym_break] = ACTIONS(1337),
    [anon_sym_continue] = ACTIONS(1337),
    [anon_sym_goto] = ACTIONS(1337),
    [anon_sym___try] = ACTIONS(1337),
    [anon_sym___leave] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym___alignof__] = ACTIONS(1337),
    [anon_sym___alignof] = ACTIONS(1337),
    [anon_sym__alignof] = ACTIONS(1337),
    [anon_sym_alignof] = ACTIONS(1337),
    [anon_sym__Alignof] = ACTIONS(1337),
    [anon_sym_offsetof] = ACTIONS(1337),
    [anon_sym__Generic] = ACTIONS(1337),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [anon_sym___asm] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1339),
    [anon_sym_L_SQUOTE] = ACTIONS(1339),
    [anon_sym_u_SQUOTE] = ACTIONS(1339),
    [anon_sym_U_SQUOTE] = ACTIONS(1339),
    [anon_sym_u8_SQUOTE] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1339),
    [anon_sym_L_DQUOTE] = ACTIONS(1339),
    [anon_sym_u_DQUOTE] = ACTIONS(1339),
    [anon_sym_U_DQUOTE] = ACTIONS(1339),
    [anon_sym_u8_DQUOTE] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_true] = ACTIONS(1337),
    [sym_false] = ACTIONS(1337),
    [anon_sym_NULL] = ACTIONS(1337),
    [anon_sym_nullptr] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_identifier] = ACTIONS(1305),
    [aux_sym_preproc_include_token1] = ACTIONS(1305),
    [aux_sym_preproc_def_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token2] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_LPAREN2] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_TILDE] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym___extension__] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym___attribute__] = ACTIONS(1305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1307),
    [anon_sym___declspec] = ACTIONS(1305),
    [anon_sym___cdecl] = ACTIONS(1305),
    [anon_sym___clrcall] = ACTIONS(1305),
    [anon_sym___stdcall] = ACTIONS(1305),
    [anon_sym___fastcall] = ACTIONS(1305),
    [anon_sym___thiscall] = ACTIONS(1305),
    [anon_sym___vectorcall] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym___inline] = ACTIONS(1305),
    [anon_sym___inline__] = ACTIONS(1305),
    [anon_sym___forceinline] = ACTIONS(1305),
    [anon_sym_thread_local] = ACTIONS(1305),
    [anon_sym___thread] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_constexpr] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym___restrict__] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym__Noreturn] = ACTIONS(1305),
    [anon_sym_noreturn] = ACTIONS(1305),
    [anon_sym__Nonnull] = ACTIONS(1305),
    [anon_sym_alignas] = ACTIONS(1305),
    [anon_sym__Alignas] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym___try] = ACTIONS(1305),
    [anon_sym___leave] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1307),
    [anon_sym_sizeof] = ACTIONS(1305),
    [anon_sym___alignof__] = ACTIONS(1305),
    [anon_sym___alignof] = ACTIONS(1305),
    [anon_sym__alignof] = ACTIONS(1305),
    [anon_sym_alignof] = ACTIONS(1305),
    [anon_sym__Alignof] = ACTIONS(1305),
    [anon_sym_offsetof] = ACTIONS(1305),
    [anon_sym__Generic] = ACTIONS(1305),
    [anon_sym_asm] = ACTIONS(1305),
    [anon_sym___asm__] = ACTIONS(1305),
    [anon_sym___asm] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1307),
    [anon_sym_L_SQUOTE] = ACTIONS(1307),
    [anon_sym_u_SQUOTE] = ACTIONS(1307),
    [anon_sym_U_SQUOTE] = ACTIONS(1307),
    [anon_sym_u8_SQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1307),
    [anon_sym_L_DQUOTE] = ACTIONS(1307),
    [anon_sym_u_DQUOTE] = ACTIONS(1307),
    [anon_sym_U_DQUOTE] = ACTIONS(1307),
    [anon_sym_u8_DQUOTE] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1307),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [anon_sym_NULL] = ACTIONS(1305),
    [anon_sym_nullptr] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_identifier] = ACTIONS(1329),
    [aux_sym_preproc_include_token1] = ACTIONS(1329),
    [aux_sym_preproc_def_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token2] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1329),
    [sym_preproc_directive] = ACTIONS(1329),
    [anon_sym_LPAREN2] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_SEMI] = ACTIONS(1331),
    [anon_sym___extension__] = ACTIONS(1329),
    [anon_sym_typedef] = ACTIONS(1329),
    [anon_sym_extern] = ACTIONS(1329),
    [anon_sym___attribute__] = ACTIONS(1329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1331),
    [anon_sym___declspec] = ACTIONS(1329),
    [anon_sym___cdecl] = ACTIONS(1329),
    [anon_sym___clrcall] = ACTIONS(1329),
    [anon_sym___stdcall] = ACTIONS(1329),
    [anon_sym___fastcall] = ACTIONS(1329),
    [anon_sym___thiscall] = ACTIONS(1329),
    [anon_sym___vectorcall] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1331),
    [anon_sym_signed] = ACTIONS(1329),
    [anon_sym_unsigned] = ACTIONS(1329),
    [anon_sym_long] = ACTIONS(1329),
    [anon_sym_short] = ACTIONS(1329),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_auto] = ACTIONS(1329),
    [anon_sym_register] = ACTIONS(1329),
    [anon_sym_inline] = ACTIONS(1329),
    [anon_sym___inline] = ACTIONS(1329),
    [anon_sym___inline__] = ACTIONS(1329),
    [anon_sym___forceinline] = ACTIONS(1329),
    [anon_sym_thread_local] = ACTIONS(1329),
    [anon_sym___thread] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_constexpr] = ACTIONS(1329),
    [anon_sym_volatile] = ACTIONS(1329),
    [anon_sym_restrict] = ACTIONS(1329),
    [anon_sym___restrict__] = ACTIONS(1329),
    [anon_sym__Atomic] = ACTIONS(1329),
    [anon_sym__Noreturn] = ACTIONS(1329),
    [anon_sym_noreturn] = ACTIONS(1329),
    [anon_sym__Nonnull] = ACTIONS(1329),
    [anon_sym_alignas] = ACTIONS(1329),
    [anon_sym__Alignas] = ACTIONS(1329),
    [sym_primitive_type] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1329),
    [anon_sym_union] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_goto] = ACTIONS(1329),
    [anon_sym___try] = ACTIONS(1329),
    [anon_sym___leave] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_sizeof] = ACTIONS(1329),
    [anon_sym___alignof__] = ACTIONS(1329),
    [anon_sym___alignof] = ACTIONS(1329),
    [anon_sym__alignof] = ACTIONS(1329),
    [anon_sym_alignof] = ACTIONS(1329),
    [anon_sym__Alignof] = ACTIONS(1329),
    [anon_sym_offsetof] = ACTIONS(1329),
    [anon_sym__Generic] = ACTIONS(1329),
    [anon_sym_asm] = ACTIONS(1329),
    [anon_sym___asm__] = ACTIONS(1329),
    [anon_sym___asm] = ACTIONS(1329),
    [sym_number_literal] = ACTIONS(1331),
    [anon_sym_L_SQUOTE] = ACTIONS(1331),
    [anon_sym_u_SQUOTE] = ACTIONS(1331),
    [anon_sym_U_SQUOTE] = ACTIONS(1331),
    [anon_sym_u8_SQUOTE] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1331),
    [anon_sym_L_DQUOTE] = ACTIONS(1331),
    [anon_sym_u_DQUOTE] = ACTIONS(1331),
    [anon_sym_U_DQUOTE] = ACTIONS(1331),
    [anon_sym_u8_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [anon_sym_NULL] = ACTIONS(1329),
    [anon_sym_nullptr] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1333),
    [aux_sym_preproc_def_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token2] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1333),
    [sym_preproc_directive] = ACTIONS(1333),
    [anon_sym_LPAREN2] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym___extension__] = ACTIONS(1333),
    [anon_sym_typedef] = ACTIONS(1333),
    [anon_sym_extern] = ACTIONS(1333),
    [anon_sym___attribute__] = ACTIONS(1333),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1335),
    [anon_sym___declspec] = ACTIONS(1333),
    [anon_sym___cdecl] = ACTIONS(1333),
    [anon_sym___clrcall] = ACTIONS(1333),
    [anon_sym___stdcall] = ACTIONS(1333),
    [anon_sym___fastcall] = ACTIONS(1333),
    [anon_sym___thiscall] = ACTIONS(1333),
    [anon_sym___vectorcall] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_signed] = ACTIONS(1333),
    [anon_sym_unsigned] = ACTIONS(1333),
    [anon_sym_long] = ACTIONS(1333),
    [anon_sym_short] = ACTIONS(1333),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_auto] = ACTIONS(1333),
    [anon_sym_register] = ACTIONS(1333),
    [anon_sym_inline] = ACTIONS(1333),
    [anon_sym___inline] = ACTIONS(1333),
    [anon_sym___inline__] = ACTIONS(1333),
    [anon_sym___forceinline] = ACTIONS(1333),
    [anon_sym_thread_local] = ACTIONS(1333),
    [anon_sym___thread] = ACTIONS(1333),
    [anon_sym_const] = ACTIONS(1333),
    [anon_sym_constexpr] = ACTIONS(1333),
    [anon_sym_volatile] = ACTIONS(1333),
    [anon_sym_restrict] = ACTIONS(1333),
    [anon_sym___restrict__] = ACTIONS(1333),
    [anon_sym__Atomic] = ACTIONS(1333),
    [anon_sym__Noreturn] = ACTIONS(1333),
    [anon_sym_noreturn] = ACTIONS(1333),
    [anon_sym__Nonnull] = ACTIONS(1333),
    [anon_sym_alignas] = ACTIONS(1333),
    [anon_sym__Alignas] = ACTIONS(1333),
    [sym_primitive_type] = ACTIONS(1333),
    [anon_sym_enum] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1333),
    [anon_sym_union] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1333),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_while] = ACTIONS(1333),
    [anon_sym_do] = ACTIONS(1333),
    [anon_sym_for] = ACTIONS(1333),
    [anon_sym_return] = ACTIONS(1333),
    [anon_sym_break] = ACTIONS(1333),
    [anon_sym_continue] = ACTIONS(1333),
    [anon_sym_goto] = ACTIONS(1333),
    [anon_sym___try] = ACTIONS(1333),
    [anon_sym___leave] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1333),
    [anon_sym___alignof__] = ACTIONS(1333),
    [anon_sym___alignof] = ACTIONS(1333),
    [anon_sym__alignof] = ACTIONS(1333),
    [anon_sym_alignof] = ACTIONS(1333),
    [anon_sym__Alignof] = ACTIONS(1333),
    [anon_sym_offsetof] = ACTIONS(1333),
    [anon_sym__Generic] = ACTIONS(1333),
    [anon_sym_asm] = ACTIONS(1333),
    [anon_sym___asm__] = ACTIONS(1333),
    [anon_sym___asm] = ACTIONS(1333),
    [sym_number_literal] = ACTIONS(1335),
    [anon_sym_L_SQUOTE] = ACTIONS(1335),
    [anon_sym_u_SQUOTE] = ACTIONS(1335),
    [anon_sym_U_SQUOTE] = ACTIONS(1335),
    [anon_sym_u8_SQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [anon_sym_L_DQUOTE] = ACTIONS(1335),
    [anon_sym_u_DQUOTE] = ACTIONS(1335),
    [anon_sym_U_DQUOTE] = ACTIONS(1335),
    [anon_sym_u8_DQUOTE] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [anon_sym_NULL] = ACTIONS(1333),
    [anon_sym_nullptr] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_identifier] = ACTIONS(1269),
    [aux_sym_preproc_include_token1] = ACTIONS(1269),
    [aux_sym_preproc_def_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token2] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_LPAREN2] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym___extension__] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym___attribute__] = ACTIONS(1269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1271),
    [anon_sym___declspec] = ACTIONS(1269),
    [anon_sym___cdecl] = ACTIONS(1269),
    [anon_sym___clrcall] = ACTIONS(1269),
    [anon_sym___stdcall] = ACTIONS(1269),
    [anon_sym___fastcall] = ACTIONS(1269),
    [anon_sym___thiscall] = ACTIONS(1269),
    [anon_sym___vectorcall] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_signed] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_auto] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym___inline] = ACTIONS(1269),
    [anon_sym___inline__] = ACTIONS(1269),
    [anon_sym___forceinline] = ACTIONS(1269),
    [anon_sym_thread_local] = ACTIONS(1269),
    [anon_sym___thread] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym___restrict__] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym__Noreturn] = ACTIONS(1269),
    [anon_sym_noreturn] = ACTIONS(1269),
    [anon_sym__Nonnull] = ACTIONS(1269),
    [anon_sym_alignas] = ACTIONS(1269),
    [anon_sym__Alignas] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_goto] = ACTIONS(1269),
    [anon_sym___try] = ACTIONS(1269),
    [anon_sym___leave] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_sizeof] = ACTIONS(1269),
    [anon_sym___alignof__] = ACTIONS(1269),
    [anon_sym___alignof] = ACTIONS(1269),
    [anon_sym__alignof] = ACTIONS(1269),
    [anon_sym_alignof] = ACTIONS(1269),
    [anon_sym__Alignof] = ACTIONS(1269),
    [anon_sym_offsetof] = ACTIONS(1269),
    [anon_sym__Generic] = ACTIONS(1269),
    [anon_sym_asm] = ACTIONS(1269),
    [anon_sym___asm__] = ACTIONS(1269),
    [anon_sym___asm] = ACTIONS(1269),
    [sym_number_literal] = ACTIONS(1271),
    [anon_sym_L_SQUOTE] = ACTIONS(1271),
    [anon_sym_u_SQUOTE] = ACTIONS(1271),
    [anon_sym_U_SQUOTE] = ACTIONS(1271),
    [anon_sym_u8_SQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [anon_sym_L_DQUOTE] = ACTIONS(1271),
    [anon_sym_u_DQUOTE] = ACTIONS(1271),
    [anon_sym_U_DQUOTE] = ACTIONS(1271),
    [anon_sym_u8_DQUOTE] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [anon_sym_NULL] = ACTIONS(1269),
    [anon_sym_nullptr] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_identifier] = ACTIONS(1309),
    [aux_sym_preproc_include_token1] = ACTIONS(1309),
    [aux_sym_preproc_def_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1309),
    [sym_preproc_directive] = ACTIONS(1309),
    [anon_sym_LPAREN2] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym___extension__] = ACTIONS(1309),
    [anon_sym_typedef] = ACTIONS(1309),
    [anon_sym_extern] = ACTIONS(1309),
    [anon_sym___attribute__] = ACTIONS(1309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1311),
    [anon_sym___declspec] = ACTIONS(1309),
    [anon_sym___cdecl] = ACTIONS(1309),
    [anon_sym___clrcall] = ACTIONS(1309),
    [anon_sym___stdcall] = ACTIONS(1309),
    [anon_sym___fastcall] = ACTIONS(1309),
    [anon_sym___thiscall] = ACTIONS(1309),
    [anon_sym___vectorcall] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(1309),
    [anon_sym_unsigned] = ACTIONS(1309),
    [anon_sym_long] = ACTIONS(1309),
    [anon_sym_short] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_auto] = ACTIONS(1309),
    [anon_sym_register] = ACTIONS(1309),
    [anon_sym_inline] = ACTIONS(1309),
    [anon_sym___inline] = ACTIONS(1309),
    [anon_sym___inline__] = ACTIONS(1309),
    [anon_sym___forceinline] = ACTIONS(1309),
    [anon_sym_thread_local] = ACTIONS(1309),
    [anon_sym___thread] = ACTIONS(1309),
    [anon_sym_const] = ACTIONS(1309),
    [anon_sym_constexpr] = ACTIONS(1309),
    [anon_sym_volatile] = ACTIONS(1309),
    [anon_sym_restrict] = ACTIONS(1309),
    [anon_sym___restrict__] = ACTIONS(1309),
    [anon_sym__Atomic] = ACTIONS(1309),
    [anon_sym__Noreturn] = ACTIONS(1309),
    [anon_sym_noreturn] = ACTIONS(1309),
    [anon_sym__Nonnull] = ACTIONS(1309),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1309),
    [anon_sym_enum] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1309),
    [anon_sym_union] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1309),
    [anon_sym_default] = ACTIONS(1309),
    [anon_sym_while] = ACTIONS(1309),
    [anon_sym_do] = ACTIONS(1309),
    [anon_sym_for] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1309),
    [anon_sym_goto] = ACTIONS(1309),
    [anon_sym___try] = ACTIONS(1309),
    [anon_sym___leave] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1309),
    [anon_sym___alignof__] = ACTIONS(1309),
    [anon_sym___alignof] = ACTIONS(1309),
    [anon_sym__alignof] = ACTIONS(1309),
    [anon_sym_alignof] = ACTIONS(1309),
    [anon_sym__Alignof] = ACTIONS(1309),
    [anon_sym_offsetof] = ACTIONS(1309),
    [anon_sym__Generic] = ACTIONS(1309),
    [anon_sym_asm] = ACTIONS(1309),
    [anon_sym___asm__] = ACTIONS(1309),
    [anon_sym___asm] = ACTIONS(1309),
    [sym_number_literal] = ACTIONS(1311),
    [anon_sym_L_SQUOTE] = ACTIONS(1311),
    [anon_sym_u_SQUOTE] = ACTIONS(1311),
    [anon_sym_U_SQUOTE] = ACTIONS(1311),
    [anon_sym_u8_SQUOTE] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_L_DQUOTE] = ACTIONS(1311),
    [anon_sym_u_DQUOTE] = ACTIONS(1311),
    [anon_sym_U_DQUOTE] = ACTIONS(1311),
    [anon_sym_u8_DQUOTE] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1311),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [anon_sym_NULL] = ACTIONS(1309),
    [anon_sym_nullptr] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_RBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym__Nonnull] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [anon_sym___asm] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_identifier] = ACTIONS(1285),
    [aux_sym_preproc_include_token1] = ACTIONS(1285),
    [aux_sym_preproc_def_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1285),
    [sym_preproc_directive] = ACTIONS(1285),
    [anon_sym_LPAREN2] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym___extension__] = ACTIONS(1285),
    [anon_sym_typedef] = ACTIONS(1285),
    [anon_sym_extern] = ACTIONS(1285),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1287),
    [anon_sym___declspec] = ACTIONS(1285),
    [anon_sym___cdecl] = ACTIONS(1285),
    [anon_sym___clrcall] = ACTIONS(1285),
    [anon_sym___stdcall] = ACTIONS(1285),
    [anon_sym___fastcall] = ACTIONS(1285),
    [anon_sym___thiscall] = ACTIONS(1285),
    [anon_sym___vectorcall] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_RBRACE] = ACTIONS(1287),
    [anon_sym_signed] = ACTIONS(1285),
    [anon_sym_unsigned] = ACTIONS(1285),
    [anon_sym_long] = ACTIONS(1285),
    [anon_sym_short] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1285),
    [anon_sym_auto] = ACTIONS(1285),
    [anon_sym_register] = ACTIONS(1285),
    [anon_sym_inline] = ACTIONS(1285),
    [anon_sym___inline] = ACTIONS(1285),
    [anon_sym___inline__] = ACTIONS(1285),
    [anon_sym___forceinline] = ACTIONS(1285),
    [anon_sym_thread_local] = ACTIONS(1285),
    [anon_sym___thread] = ACTIONS(1285),
    [anon_sym_const] = ACTIONS(1285),
    [anon_sym_constexpr] = ACTIONS(1285),
    [anon_sym_volatile] = ACTIONS(1285),
    [anon_sym_restrict] = ACTIONS(1285),
    [anon_sym___restrict__] = ACTIONS(1285),
    [anon_sym__Atomic] = ACTIONS(1285),
    [anon_sym__Noreturn] = ACTIONS(1285),
    [anon_sym_noreturn] = ACTIONS(1285),
    [anon_sym__Nonnull] = ACTIONS(1285),
    [anon_sym_alignas] = ACTIONS(1285),
    [anon_sym__Alignas] = ACTIONS(1285),
    [sym_primitive_type] = ACTIONS(1285),
    [anon_sym_enum] = ACTIONS(1285),
    [anon_sym_struct] = ACTIONS(1285),
    [anon_sym_union] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1285),
    [anon_sym_switch] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1285),
    [anon_sym_default] = ACTIONS(1285),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1285),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_return] = ACTIONS(1285),
    [anon_sym_break] = ACTIONS(1285),
    [anon_sym_continue] = ACTIONS(1285),
    [anon_sym_goto] = ACTIONS(1285),
    [anon_sym___try] = ACTIONS(1285),
    [anon_sym___leave] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1287),
    [anon_sym_sizeof] = ACTIONS(1285),
    [anon_sym___alignof__] = ACTIONS(1285),
    [anon_sym___alignof] = ACTIONS(1285),
    [anon_sym__alignof] = ACTIONS(1285),
    [anon_sym_alignof] = ACTIONS(1285),
    [anon_sym__Alignof] = ACTIONS(1285),
    [anon_sym_offsetof] = ACTIONS(1285),
    [anon_sym__Generic] = ACTIONS(1285),
    [anon_sym_asm] = ACTIONS(1285),
    [anon_sym___asm__] = ACTIONS(1285),
    [anon_sym___asm] = ACTIONS(1285),
    [sym_number_literal] = ACTIONS(1287),
    [anon_sym_L_SQUOTE] = ACTIONS(1287),
    [anon_sym_u_SQUOTE] = ACTIONS(1287),
    [anon_sym_U_SQUOTE] = ACTIONS(1287),
    [anon_sym_u8_SQUOTE] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_L_DQUOTE] = ACTIONS(1287),
    [anon_sym_u_DQUOTE] = ACTIONS(1287),
    [anon_sym_U_DQUOTE] = ACTIONS(1287),
    [anon_sym_u8_DQUOTE] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [anon_sym_NULL] = ACTIONS(1285),
    [anon_sym_nullptr] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [sym_identifier] = ACTIONS(1305),
    [aux_sym_preproc_include_token1] = ACTIONS(1305),
    [aux_sym_preproc_def_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_LPAREN2] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_TILDE] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym___extension__] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym___attribute__] = ACTIONS(1305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1307),
    [anon_sym___declspec] = ACTIONS(1305),
    [anon_sym___cdecl] = ACTIONS(1305),
    [anon_sym___clrcall] = ACTIONS(1305),
    [anon_sym___stdcall] = ACTIONS(1305),
    [anon_sym___fastcall] = ACTIONS(1305),
    [anon_sym___thiscall] = ACTIONS(1305),
    [anon_sym___vectorcall] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym___inline] = ACTIONS(1305),
    [anon_sym___inline__] = ACTIONS(1305),
    [anon_sym___forceinline] = ACTIONS(1305),
    [anon_sym_thread_local] = ACTIONS(1305),
    [anon_sym___thread] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_constexpr] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym___restrict__] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym__Noreturn] = ACTIONS(1305),
    [anon_sym_noreturn] = ACTIONS(1305),
    [anon_sym__Nonnull] = ACTIONS(1305),
    [anon_sym_alignas] = ACTIONS(1305),
    [anon_sym__Alignas] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym___try] = ACTIONS(1305),
    [anon_sym___leave] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1307),
    [anon_sym_sizeof] = ACTIONS(1305),
    [anon_sym___alignof__] = ACTIONS(1305),
    [anon_sym___alignof] = ACTIONS(1305),
    [anon_sym__alignof] = ACTIONS(1305),
    [anon_sym_alignof] = ACTIONS(1305),
    [anon_sym__Alignof] = ACTIONS(1305),
    [anon_sym_offsetof] = ACTIONS(1305),
    [anon_sym__Generic] = ACTIONS(1305),
    [anon_sym_asm] = ACTIONS(1305),
    [anon_sym___asm__] = ACTIONS(1305),
    [anon_sym___asm] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1307),
    [anon_sym_L_SQUOTE] = ACTIONS(1307),
    [anon_sym_u_SQUOTE] = ACTIONS(1307),
    [anon_sym_U_SQUOTE] = ACTIONS(1307),
    [anon_sym_u8_SQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1307),
    [anon_sym_L_DQUOTE] = ACTIONS(1307),
    [anon_sym_u_DQUOTE] = ACTIONS(1307),
    [anon_sym_U_DQUOTE] = ACTIONS(1307),
    [anon_sym_u8_DQUOTE] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1307),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [anon_sym_NULL] = ACTIONS(1305),
    [anon_sym_nullptr] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [sym_identifier] = ACTIONS(1313),
    [aux_sym_preproc_include_token1] = ACTIONS(1313),
    [aux_sym_preproc_def_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_LPAREN2] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym___extension__] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym___attribute__] = ACTIONS(1313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1315),
    [anon_sym___declspec] = ACTIONS(1313),
    [anon_sym___cdecl] = ACTIONS(1313),
    [anon_sym___clrcall] = ACTIONS(1313),
    [anon_sym___stdcall] = ACTIONS(1313),
    [anon_sym___fastcall] = ACTIONS(1313),
    [anon_sym___thiscall] = ACTIONS(1313),
    [anon_sym___vectorcall] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_signed] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_auto] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym___inline] = ACTIONS(1313),
    [anon_sym___inline__] = ACTIONS(1313),
    [anon_sym___forceinline] = ACTIONS(1313),
    [anon_sym_thread_local] = ACTIONS(1313),
    [anon_sym___thread] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym___restrict__] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym__Noreturn] = ACTIONS(1313),
    [anon_sym_noreturn] = ACTIONS(1313),
    [anon_sym__Nonnull] = ACTIONS(1313),
    [anon_sym_alignas] = ACTIONS(1313),
    [anon_sym__Alignas] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym___try] = ACTIONS(1313),
    [anon_sym___leave] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_sizeof] = ACTIONS(1313),
    [anon_sym___alignof__] = ACTIONS(1313),
    [anon_sym___alignof] = ACTIONS(1313),
    [anon_sym__alignof] = ACTIONS(1313),
    [anon_sym_alignof] = ACTIONS(1313),
    [anon_sym__Alignof] = ACTIONS(1313),
    [anon_sym_offsetof] = ACTIONS(1313),
    [anon_sym__Generic] = ACTIONS(1313),
    [anon_sym_asm] = ACTIONS(1313),
    [anon_sym___asm__] = ACTIONS(1313),
    [anon_sym___asm] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1315),
    [anon_sym_L_SQUOTE] = ACTIONS(1315),
    [anon_sym_u_SQUOTE] = ACTIONS(1315),
    [anon_sym_U_SQUOTE] = ACTIONS(1315),
    [anon_sym_u8_SQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [anon_sym_L_DQUOTE] = ACTIONS(1315),
    [anon_sym_u_DQUOTE] = ACTIONS(1315),
    [anon_sym_U_DQUOTE] = ACTIONS(1315),
    [anon_sym_u8_DQUOTE] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [anon_sym_NULL] = ACTIONS(1313),
    [anon_sym_nullptr] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_identifier] = ACTIONS(1321),
    [aux_sym_preproc_include_token1] = ACTIONS(1321),
    [aux_sym_preproc_def_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1321),
    [sym_preproc_directive] = ACTIONS(1321),
    [anon_sym_LPAREN2] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym___extension__] = ACTIONS(1321),
    [anon_sym_typedef] = ACTIONS(1321),
    [anon_sym_extern] = ACTIONS(1321),
    [anon_sym___attribute__] = ACTIONS(1321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1323),
    [anon_sym___declspec] = ACTIONS(1321),
    [anon_sym___cdecl] = ACTIONS(1321),
    [anon_sym___clrcall] = ACTIONS(1321),
    [anon_sym___stdcall] = ACTIONS(1321),
    [anon_sym___fastcall] = ACTIONS(1321),
    [anon_sym___thiscall] = ACTIONS(1321),
    [anon_sym___vectorcall] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_RBRACE] = ACTIONS(1323),
    [anon_sym_signed] = ACTIONS(1321),
    [anon_sym_unsigned] = ACTIONS(1321),
    [anon_sym_long] = ACTIONS(1321),
    [anon_sym_short] = ACTIONS(1321),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_auto] = ACTIONS(1321),
    [anon_sym_register] = ACTIONS(1321),
    [anon_sym_inline] = ACTIONS(1321),
    [anon_sym___inline] = ACTIONS(1321),
    [anon_sym___inline__] = ACTIONS(1321),
    [anon_sym___forceinline] = ACTIONS(1321),
    [anon_sym_thread_local] = ACTIONS(1321),
    [anon_sym___thread] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_constexpr] = ACTIONS(1321),
    [anon_sym_volatile] = ACTIONS(1321),
    [anon_sym_restrict] = ACTIONS(1321),
    [anon_sym___restrict__] = ACTIONS(1321),
    [anon_sym__Atomic] = ACTIONS(1321),
    [anon_sym__Noreturn] = ACTIONS(1321),
    [anon_sym_noreturn] = ACTIONS(1321),
    [anon_sym__Nonnull] = ACTIONS(1321),
    [anon_sym_alignas] = ACTIONS(1321),
    [anon_sym__Alignas] = ACTIONS(1321),
    [sym_primitive_type] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_goto] = ACTIONS(1321),
    [anon_sym___try] = ACTIONS(1321),
    [anon_sym___leave] = ACTIONS(1321),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_sizeof] = ACTIONS(1321),
    [anon_sym___alignof__] = ACTIONS(1321),
    [anon_sym___alignof] = ACTIONS(1321),
    [anon_sym__alignof] = ACTIONS(1321),
    [anon_sym_alignof] = ACTIONS(1321),
    [anon_sym__Alignof] = ACTIONS(1321),
    [anon_sym_offsetof] = ACTIONS(1321),
    [anon_sym__Generic] = ACTIONS(1321),
    [anon_sym_asm] = ACTIONS(1321),
    [anon_sym___asm__] = ACTIONS(1321),
    [anon_sym___asm] = ACTIONS(1321),
    [sym_number_literal] = ACTIONS(1323),
    [anon_sym_L_SQUOTE] = ACTIONS(1323),
    [anon_sym_u_SQUOTE] = ACTIONS(1323),
    [anon_sym_U_SQUOTE] = ACTIONS(1323),
    [anon_sym_u8_SQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [anon_sym_L_DQUOTE] = ACTIONS(1323),
    [anon_sym_u_DQUOTE] = ACTIONS(1323),
    [anon_sym_U_DQUOTE] = ACTIONS(1323),
    [anon_sym_u8_DQUOTE] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [anon_sym_NULL] = ACTIONS(1321),
    [anon_sym_nullptr] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_RBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym__Nonnull] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [anon_sym___asm] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_identifier] = ACTIONS(1329),
    [aux_sym_preproc_include_token1] = ACTIONS(1329),
    [aux_sym_preproc_def_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1329),
    [sym_preproc_directive] = ACTIONS(1329),
    [anon_sym_LPAREN2] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_SEMI] = ACTIONS(1331),
    [anon_sym___extension__] = ACTIONS(1329),
    [anon_sym_typedef] = ACTIONS(1329),
    [anon_sym_extern] = ACTIONS(1329),
    [anon_sym___attribute__] = ACTIONS(1329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1331),
    [anon_sym___declspec] = ACTIONS(1329),
    [anon_sym___cdecl] = ACTIONS(1329),
    [anon_sym___clrcall] = ACTIONS(1329),
    [anon_sym___stdcall] = ACTIONS(1329),
    [anon_sym___fastcall] = ACTIONS(1329),
    [anon_sym___thiscall] = ACTIONS(1329),
    [anon_sym___vectorcall] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1331),
    [anon_sym_RBRACE] = ACTIONS(1331),
    [anon_sym_signed] = ACTIONS(1329),
    [anon_sym_unsigned] = ACTIONS(1329),
    [anon_sym_long] = ACTIONS(1329),
    [anon_sym_short] = ACTIONS(1329),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_auto] = ACTIONS(1329),
    [anon_sym_register] = ACTIONS(1329),
    [anon_sym_inline] = ACTIONS(1329),
    [anon_sym___inline] = ACTIONS(1329),
    [anon_sym___inline__] = ACTIONS(1329),
    [anon_sym___forceinline] = ACTIONS(1329),
    [anon_sym_thread_local] = ACTIONS(1329),
    [anon_sym___thread] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_constexpr] = ACTIONS(1329),
    [anon_sym_volatile] = ACTIONS(1329),
    [anon_sym_restrict] = ACTIONS(1329),
    [anon_sym___restrict__] = ACTIONS(1329),
    [anon_sym__Atomic] = ACTIONS(1329),
    [anon_sym__Noreturn] = ACTIONS(1329),
    [anon_sym_noreturn] = ACTIONS(1329),
    [anon_sym__Nonnull] = ACTIONS(1329),
    [anon_sym_alignas] = ACTIONS(1329),
    [anon_sym__Alignas] = ACTIONS(1329),
    [sym_primitive_type] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1329),
    [anon_sym_union] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_goto] = ACTIONS(1329),
    [anon_sym___try] = ACTIONS(1329),
    [anon_sym___leave] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_sizeof] = ACTIONS(1329),
    [anon_sym___alignof__] = ACTIONS(1329),
    [anon_sym___alignof] = ACTIONS(1329),
    [anon_sym__alignof] = ACTIONS(1329),
    [anon_sym_alignof] = ACTIONS(1329),
    [anon_sym__Alignof] = ACTIONS(1329),
    [anon_sym_offsetof] = ACTIONS(1329),
    [anon_sym__Generic] = ACTIONS(1329),
    [anon_sym_asm] = ACTIONS(1329),
    [anon_sym___asm__] = ACTIONS(1329),
    [anon_sym___asm] = ACTIONS(1329),
    [sym_number_literal] = ACTIONS(1331),
    [anon_sym_L_SQUOTE] = ACTIONS(1331),
    [anon_sym_u_SQUOTE] = ACTIONS(1331),
    [anon_sym_U_SQUOTE] = ACTIONS(1331),
    [anon_sym_u8_SQUOTE] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1331),
    [anon_sym_L_DQUOTE] = ACTIONS(1331),
    [anon_sym_u_DQUOTE] = ACTIONS(1331),
    [anon_sym_U_DQUOTE] = ACTIONS(1331),
    [anon_sym_u8_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [anon_sym_NULL] = ACTIONS(1329),
    [anon_sym_nullptr] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_identifier] = ACTIONS(1371),
    [aux_sym_preproc_include_token1] = ACTIONS(1371),
    [aux_sym_preproc_def_token1] = ACTIONS(1371),
    [aux_sym_preproc_if_token1] = ACTIONS(1371),
    [aux_sym_preproc_if_token2] = ACTIONS(1371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1371),
    [sym_preproc_directive] = ACTIONS(1371),
    [anon_sym_LPAREN2] = ACTIONS(1373),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym___extension__] = ACTIONS(1371),
    [anon_sym_typedef] = ACTIONS(1371),
    [anon_sym_extern] = ACTIONS(1371),
    [anon_sym___attribute__] = ACTIONS(1371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1373),
    [anon_sym___declspec] = ACTIONS(1371),
    [anon_sym___cdecl] = ACTIONS(1371),
    [anon_sym___clrcall] = ACTIONS(1371),
    [anon_sym___stdcall] = ACTIONS(1371),
    [anon_sym___fastcall] = ACTIONS(1371),
    [anon_sym___thiscall] = ACTIONS(1371),
    [anon_sym___vectorcall] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(1373),
    [anon_sym_signed] = ACTIONS(1371),
    [anon_sym_unsigned] = ACTIONS(1371),
    [anon_sym_long] = ACTIONS(1371),
    [anon_sym_short] = ACTIONS(1371),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_auto] = ACTIONS(1371),
    [anon_sym_register] = ACTIONS(1371),
    [anon_sym_inline] = ACTIONS(1371),
    [anon_sym___inline] = ACTIONS(1371),
    [anon_sym___inline__] = ACTIONS(1371),
    [anon_sym___forceinline] = ACTIONS(1371),
    [anon_sym_thread_local] = ACTIONS(1371),
    [anon_sym___thread] = ACTIONS(1371),
    [anon_sym_const] = ACTIONS(1371),
    [anon_sym_constexpr] = ACTIONS(1371),
    [anon_sym_volatile] = ACTIONS(1371),
    [anon_sym_restrict] = ACTIONS(1371),
    [anon_sym___restrict__] = ACTIONS(1371),
    [anon_sym__Atomic] = ACTIONS(1371),
    [anon_sym__Noreturn] = ACTIONS(1371),
    [anon_sym_noreturn] = ACTIONS(1371),
    [anon_sym__Nonnull] = ACTIONS(1371),
    [anon_sym_alignas] = ACTIONS(1371),
    [anon_sym__Alignas] = ACTIONS(1371),
    [sym_primitive_type] = ACTIONS(1371),
    [anon_sym_enum] = ACTIONS(1371),
    [anon_sym_struct] = ACTIONS(1371),
    [anon_sym_union] = ACTIONS(1371),
    [anon_sym_if] = ACTIONS(1371),
    [anon_sym_switch] = ACTIONS(1371),
    [anon_sym_case] = ACTIONS(1371),
    [anon_sym_default] = ACTIONS(1371),
    [anon_sym_while] = ACTIONS(1371),
    [anon_sym_do] = ACTIONS(1371),
    [anon_sym_for] = ACTIONS(1371),
    [anon_sym_return] = ACTIONS(1371),
    [anon_sym_break] = ACTIONS(1371),
    [anon_sym_continue] = ACTIONS(1371),
    [anon_sym_goto] = ACTIONS(1371),
    [anon_sym___try] = ACTIONS(1371),
    [anon_sym___leave] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_sizeof] = ACTIONS(1371),
    [anon_sym___alignof__] = ACTIONS(1371),
    [anon_sym___alignof] = ACTIONS(1371),
    [anon_sym__alignof] = ACTIONS(1371),
    [anon_sym_alignof] = ACTIONS(1371),
    [anon_sym__Alignof] = ACTIONS(1371),
    [anon_sym_offsetof] = ACTIONS(1371),
    [anon_sym__Generic] = ACTIONS(1371),
    [anon_sym_asm] = ACTIONS(1371),
    [anon_sym___asm__] = ACTIONS(1371),
    [anon_sym___asm] = ACTIONS(1371),
    [sym_number_literal] = ACTIONS(1373),
    [anon_sym_L_SQUOTE] = ACTIONS(1373),
    [anon_sym_u_SQUOTE] = ACTIONS(1373),
    [anon_sym_U_SQUOTE] = ACTIONS(1373),
    [anon_sym_u8_SQUOTE] = ACTIONS(1373),
    [anon_sym_SQUOTE] = ACTIONS(1373),
    [anon_sym_L_DQUOTE] = ACTIONS(1373),
    [anon_sym_u_DQUOTE] = ACTIONS(1373),
    [anon_sym_U_DQUOTE] = ACTIONS(1373),
    [anon_sym_u8_DQUOTE] = ACTIONS(1373),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_true] = ACTIONS(1371),
    [sym_false] = ACTIONS(1371),
    [anon_sym_NULL] = ACTIONS(1371),
    [anon_sym_nullptr] = ACTIONS(1371),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1333),
    [aux_sym_preproc_def_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1333),
    [sym_preproc_directive] = ACTIONS(1333),
    [anon_sym_LPAREN2] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym___extension__] = ACTIONS(1333),
    [anon_sym_typedef] = ACTIONS(1333),
    [anon_sym_extern] = ACTIONS(1333),
    [anon_sym___attribute__] = ACTIONS(1333),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1335),
    [anon_sym___declspec] = ACTIONS(1333),
    [anon_sym___cdecl] = ACTIONS(1333),
    [anon_sym___clrcall] = ACTIONS(1333),
    [anon_sym___stdcall] = ACTIONS(1333),
    [anon_sym___fastcall] = ACTIONS(1333),
    [anon_sym___thiscall] = ACTIONS(1333),
    [anon_sym___vectorcall] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_RBRACE] = ACTIONS(1335),
    [anon_sym_signed] = ACTIONS(1333),
    [anon_sym_unsigned] = ACTIONS(1333),
    [anon_sym_long] = ACTIONS(1333),
    [anon_sym_short] = ACTIONS(1333),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_auto] = ACTIONS(1333),
    [anon_sym_register] = ACTIONS(1333),
    [anon_sym_inline] = ACTIONS(1333),
    [anon_sym___inline] = ACTIONS(1333),
    [anon_sym___inline__] = ACTIONS(1333),
    [anon_sym___forceinline] = ACTIONS(1333),
    [anon_sym_thread_local] = ACTIONS(1333),
    [anon_sym___thread] = ACTIONS(1333),
    [anon_sym_const] = ACTIONS(1333),
    [anon_sym_constexpr] = ACTIONS(1333),
    [anon_sym_volatile] = ACTIONS(1333),
    [anon_sym_restrict] = ACTIONS(1333),
    [anon_sym___restrict__] = ACTIONS(1333),
    [anon_sym__Atomic] = ACTIONS(1333),
    [anon_sym__Noreturn] = ACTIONS(1333),
    [anon_sym_noreturn] = ACTIONS(1333),
    [anon_sym__Nonnull] = ACTIONS(1333),
    [anon_sym_alignas] = ACTIONS(1333),
    [anon_sym__Alignas] = ACTIONS(1333),
    [sym_primitive_type] = ACTIONS(1333),
    [anon_sym_enum] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1333),
    [anon_sym_union] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1333),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_while] = ACTIONS(1333),
    [anon_sym_do] = ACTIONS(1333),
    [anon_sym_for] = ACTIONS(1333),
    [anon_sym_return] = ACTIONS(1333),
    [anon_sym_break] = ACTIONS(1333),
    [anon_sym_continue] = ACTIONS(1333),
    [anon_sym_goto] = ACTIONS(1333),
    [anon_sym___try] = ACTIONS(1333),
    [anon_sym___leave] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1333),
    [anon_sym___alignof__] = ACTIONS(1333),
    [anon_sym___alignof] = ACTIONS(1333),
    [anon_sym__alignof] = ACTIONS(1333),
    [anon_sym_alignof] = ACTIONS(1333),
    [anon_sym__Alignof] = ACTIONS(1333),
    [anon_sym_offsetof] = ACTIONS(1333),
    [anon_sym__Generic] = ACTIONS(1333),
    [anon_sym_asm] = ACTIONS(1333),
    [anon_sym___asm__] = ACTIONS(1333),
    [anon_sym___asm] = ACTIONS(1333),
    [sym_number_literal] = ACTIONS(1335),
    [anon_sym_L_SQUOTE] = ACTIONS(1335),
    [anon_sym_u_SQUOTE] = ACTIONS(1335),
    [anon_sym_U_SQUOTE] = ACTIONS(1335),
    [anon_sym_u8_SQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [anon_sym_L_DQUOTE] = ACTIONS(1335),
    [anon_sym_u_DQUOTE] = ACTIONS(1335),
    [anon_sym_U_DQUOTE] = ACTIONS(1335),
    [anon_sym_u8_DQUOTE] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [anon_sym_NULL] = ACTIONS(1333),
    [anon_sym_nullptr] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token2] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym__Nonnull] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [anon_sym___asm] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_identifier] = ACTIONS(1285),
    [aux_sym_preproc_include_token1] = ACTIONS(1285),
    [aux_sym_preproc_def_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token2] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1285),
    [sym_preproc_directive] = ACTIONS(1285),
    [anon_sym_LPAREN2] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym___extension__] = ACTIONS(1285),
    [anon_sym_typedef] = ACTIONS(1285),
    [anon_sym_extern] = ACTIONS(1285),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1287),
    [anon_sym___declspec] = ACTIONS(1285),
    [anon_sym___cdecl] = ACTIONS(1285),
    [anon_sym___clrcall] = ACTIONS(1285),
    [anon_sym___stdcall] = ACTIONS(1285),
    [anon_sym___fastcall] = ACTIONS(1285),
    [anon_sym___thiscall] = ACTIONS(1285),
    [anon_sym___vectorcall] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_signed] = ACTIONS(1285),
    [anon_sym_unsigned] = ACTIONS(1285),
    [anon_sym_long] = ACTIONS(1285),
    [anon_sym_short] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1285),
    [anon_sym_auto] = ACTIONS(1285),
    [anon_sym_register] = ACTIONS(1285),
    [anon_sym_inline] = ACTIONS(1285),
    [anon_sym___inline] = ACTIONS(1285),
    [anon_sym___inline__] = ACTIONS(1285),
    [anon_sym___forceinline] = ACTIONS(1285),
    [anon_sym_thread_local] = ACTIONS(1285),
    [anon_sym___thread] = ACTIONS(1285),
    [anon_sym_const] = ACTIONS(1285),
    [anon_sym_constexpr] = ACTIONS(1285),
    [anon_sym_volatile] = ACTIONS(1285),
    [anon_sym_restrict] = ACTIONS(1285),
    [anon_sym___restrict__] = ACTIONS(1285),
    [anon_sym__Atomic] = ACTIONS(1285),
    [anon_sym__Noreturn] = ACTIONS(1285),
    [anon_sym_noreturn] = ACTIONS(1285),
    [anon_sym__Nonnull] = ACTIONS(1285),
    [anon_sym_alignas] = ACTIONS(1285),
    [anon_sym__Alignas] = ACTIONS(1285),
    [sym_primitive_type] = ACTIONS(1285),
    [anon_sym_enum] = ACTIONS(1285),
    [anon_sym_struct] = ACTIONS(1285),
    [anon_sym_union] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1285),
    [anon_sym_switch] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1285),
    [anon_sym_default] = ACTIONS(1285),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1285),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_return] = ACTIONS(1285),
    [anon_sym_break] = ACTIONS(1285),
    [anon_sym_continue] = ACTIONS(1285),
    [anon_sym_goto] = ACTIONS(1285),
    [anon_sym___try] = ACTIONS(1285),
    [anon_sym___leave] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1287),
    [anon_sym_sizeof] = ACTIONS(1285),
    [anon_sym___alignof__] = ACTIONS(1285),
    [anon_sym___alignof] = ACTIONS(1285),
    [anon_sym__alignof] = ACTIONS(1285),
    [anon_sym_alignof] = ACTIONS(1285),
    [anon_sym__Alignof] = ACTIONS(1285),
    [anon_sym_offsetof] = ACTIONS(1285),
    [anon_sym__Generic] = ACTIONS(1285),
    [anon_sym_asm] = ACTIONS(1285),
    [anon_sym___asm__] = ACTIONS(1285),
    [anon_sym___asm] = ACTIONS(1285),
    [sym_number_literal] = ACTIONS(1287),
    [anon_sym_L_SQUOTE] = ACTIONS(1287),
    [anon_sym_u_SQUOTE] = ACTIONS(1287),
    [anon_sym_U_SQUOTE] = ACTIONS(1287),
    [anon_sym_u8_SQUOTE] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_L_DQUOTE] = ACTIONS(1287),
    [anon_sym_u_DQUOTE] = ACTIONS(1287),
    [anon_sym_U_DQUOTE] = ACTIONS(1287),
    [anon_sym_u8_DQUOTE] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [anon_sym_NULL] = ACTIONS(1285),
    [anon_sym_nullptr] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token2] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym__Nonnull] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [anon_sym___asm] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_identifier] = ACTIONS(1337),
    [aux_sym_preproc_include_token1] = ACTIONS(1337),
    [aux_sym_preproc_def_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1337),
    [sym_preproc_directive] = ACTIONS(1337),
    [anon_sym_LPAREN2] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym___extension__] = ACTIONS(1337),
    [anon_sym_typedef] = ACTIONS(1337),
    [anon_sym_extern] = ACTIONS(1337),
    [anon_sym___attribute__] = ACTIONS(1337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1339),
    [anon_sym___declspec] = ACTIONS(1337),
    [anon_sym___cdecl] = ACTIONS(1337),
    [anon_sym___clrcall] = ACTIONS(1337),
    [anon_sym___stdcall] = ACTIONS(1337),
    [anon_sym___fastcall] = ACTIONS(1337),
    [anon_sym___thiscall] = ACTIONS(1337),
    [anon_sym___vectorcall] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_signed] = ACTIONS(1337),
    [anon_sym_unsigned] = ACTIONS(1337),
    [anon_sym_long] = ACTIONS(1337),
    [anon_sym_short] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_auto] = ACTIONS(1337),
    [anon_sym_register] = ACTIONS(1337),
    [anon_sym_inline] = ACTIONS(1337),
    [anon_sym___inline] = ACTIONS(1337),
    [anon_sym___inline__] = ACTIONS(1337),
    [anon_sym___forceinline] = ACTIONS(1337),
    [anon_sym_thread_local] = ACTIONS(1337),
    [anon_sym___thread] = ACTIONS(1337),
    [anon_sym_const] = ACTIONS(1337),
    [anon_sym_constexpr] = ACTIONS(1337),
    [anon_sym_volatile] = ACTIONS(1337),
    [anon_sym_restrict] = ACTIONS(1337),
    [anon_sym___restrict__] = ACTIONS(1337),
    [anon_sym__Atomic] = ACTIONS(1337),
    [anon_sym__Noreturn] = ACTIONS(1337),
    [anon_sym_noreturn] = ACTIONS(1337),
    [anon_sym__Nonnull] = ACTIONS(1337),
    [anon_sym_alignas] = ACTIONS(1337),
    [anon_sym__Alignas] = ACTIONS(1337),
    [sym_primitive_type] = ACTIONS(1337),
    [anon_sym_enum] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1337),
    [anon_sym_union] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1337),
    [anon_sym_default] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_do] = ACTIONS(1337),
    [anon_sym_for] = ACTIONS(1337),
    [anon_sym_return] = ACTIONS(1337),
    [anon_sym_break] = ACTIONS(1337),
    [anon_sym_continue] = ACTIONS(1337),
    [anon_sym_goto] = ACTIONS(1337),
    [anon_sym___try] = ACTIONS(1337),
    [anon_sym___leave] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym___alignof__] = ACTIONS(1337),
    [anon_sym___alignof] = ACTIONS(1337),
    [anon_sym__alignof] = ACTIONS(1337),
    [anon_sym_alignof] = ACTIONS(1337),
    [anon_sym__Alignof] = ACTIONS(1337),
    [anon_sym_offsetof] = ACTIONS(1337),
    [anon_sym__Generic] = ACTIONS(1337),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [anon_sym___asm] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1339),
    [anon_sym_L_SQUOTE] = ACTIONS(1339),
    [anon_sym_u_SQUOTE] = ACTIONS(1339),
    [anon_sym_U_SQUOTE] = ACTIONS(1339),
    [anon_sym_u8_SQUOTE] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1339),
    [anon_sym_L_DQUOTE] = ACTIONS(1339),
    [anon_sym_u_DQUOTE] = ACTIONS(1339),
    [anon_sym_U_DQUOTE] = ACTIONS(1339),
    [anon_sym_u8_DQUOTE] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_true] = ACTIONS(1337),
    [sym_false] = ACTIONS(1337),
    [anon_sym_NULL] = ACTIONS(1337),
    [anon_sym_nullptr] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [sym_identifier] = ACTIONS(1341),
    [aux_sym_preproc_include_token1] = ACTIONS(1341),
    [aux_sym_preproc_def_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1341),
    [sym_preproc_directive] = ACTIONS(1341),
    [anon_sym_LPAREN2] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym___extension__] = ACTIONS(1341),
    [anon_sym_typedef] = ACTIONS(1341),
    [anon_sym_extern] = ACTIONS(1341),
    [anon_sym___attribute__] = ACTIONS(1341),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1343),
    [anon_sym___declspec] = ACTIONS(1341),
    [anon_sym___cdecl] = ACTIONS(1341),
    [anon_sym___clrcall] = ACTIONS(1341),
    [anon_sym___stdcall] = ACTIONS(1341),
    [anon_sym___fastcall] = ACTIONS(1341),
    [anon_sym___thiscall] = ACTIONS(1341),
    [anon_sym___vectorcall] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_RBRACE] = ACTIONS(1343),
    [anon_sym_signed] = ACTIONS(1341),
    [anon_sym_unsigned] = ACTIONS(1341),
    [anon_sym_long] = ACTIONS(1341),
    [anon_sym_short] = ACTIONS(1341),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_auto] = ACTIONS(1341),
    [anon_sym_register] = ACTIONS(1341),
    [anon_sym_inline] = ACTIONS(1341),
    [anon_sym___inline] = ACTIONS(1341),
    [anon_sym___inline__] = ACTIONS(1341),
    [anon_sym___forceinline] = ACTIONS(1341),
    [anon_sym_thread_local] = ACTIONS(1341),
    [anon_sym___thread] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_constexpr] = ACTIONS(1341),
    [anon_sym_volatile] = ACTIONS(1341),
    [anon_sym_restrict] = ACTIONS(1341),
    [anon_sym___restrict__] = ACTIONS(1341),
    [anon_sym__Atomic] = ACTIONS(1341),
    [anon_sym__Noreturn] = ACTIONS(1341),
    [anon_sym_noreturn] = ACTIONS(1341),
    [anon_sym__Nonnull] = ACTIONS(1341),
    [anon_sym_alignas] = ACTIONS(1341),
    [anon_sym__Alignas] = ACTIONS(1341),
    [sym_primitive_type] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1341),
    [anon_sym_union] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_goto] = ACTIONS(1341),
    [anon_sym___try] = ACTIONS(1341),
    [anon_sym___leave] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_sizeof] = ACTIONS(1341),
    [anon_sym___alignof__] = ACTIONS(1341),
    [anon_sym___alignof] = ACTIONS(1341),
    [anon_sym__alignof] = ACTIONS(1341),
    [anon_sym_alignof] = ACTIONS(1341),
    [anon_sym__Alignof] = ACTIONS(1341),
    [anon_sym_offsetof] = ACTIONS(1341),
    [anon_sym__Generic] = ACTIONS(1341),
    [anon_sym_asm] = ACTIONS(1341),
    [anon_sym___asm__] = ACTIONS(1341),
    [anon_sym___asm] = ACTIONS(1341),
    [sym_number_literal] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1343),
    [anon_sym_u_SQUOTE] = ACTIONS(1343),
    [anon_sym_U_SQUOTE] = ACTIONS(1343),
    [anon_sym_u8_SQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_L_DQUOTE] = ACTIONS(1343),
    [anon_sym_u_DQUOTE] = ACTIONS(1343),
    [anon_sym_U_DQUOTE] = ACTIONS(1343),
    [anon_sym_u8_DQUOTE] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [anon_sym_NULL] = ACTIONS(1341),
    [anon_sym_nullptr] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_identifier] = ACTIONS(1357),
    [aux_sym_preproc_include_token1] = ACTIONS(1357),
    [aux_sym_preproc_def_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_LPAREN2] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym___extension__] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym___attribute__] = ACTIONS(1357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1359),
    [anon_sym___declspec] = ACTIONS(1357),
    [anon_sym___cdecl] = ACTIONS(1357),
    [anon_sym___clrcall] = ACTIONS(1357),
    [anon_sym___stdcall] = ACTIONS(1357),
    [anon_sym___fastcall] = ACTIONS(1357),
    [anon_sym___thiscall] = ACTIONS(1357),
    [anon_sym___vectorcall] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_RBRACE] = ACTIONS(1359),
    [anon_sym_signed] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_auto] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym___inline] = ACTIONS(1357),
    [anon_sym___inline__] = ACTIONS(1357),
    [anon_sym___forceinline] = ACTIONS(1357),
    [anon_sym_thread_local] = ACTIONS(1357),
    [anon_sym___thread] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym___restrict__] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym__Noreturn] = ACTIONS(1357),
    [anon_sym_noreturn] = ACTIONS(1357),
    [anon_sym__Nonnull] = ACTIONS(1357),
    [anon_sym_alignas] = ACTIONS(1357),
    [anon_sym__Alignas] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1357),
    [anon_sym_default] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_return] = ACTIONS(1357),
    [anon_sym_break] = ACTIONS(1357),
    [anon_sym_continue] = ACTIONS(1357),
    [anon_sym_goto] = ACTIONS(1357),
    [anon_sym___try] = ACTIONS(1357),
    [anon_sym___leave] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_sizeof] = ACTIONS(1357),
    [anon_sym___alignof__] = ACTIONS(1357),
    [anon_sym___alignof] = ACTIONS(1357),
    [anon_sym__alignof] = ACTIONS(1357),
    [anon_sym_alignof] = ACTIONS(1357),
    [anon_sym__Alignof] = ACTIONS(1357),
    [anon_sym_offsetof] = ACTIONS(1357),
    [anon_sym__Generic] = ACTIONS(1357),
    [anon_sym_asm] = ACTIONS(1357),
    [anon_sym___asm__] = ACTIONS(1357),
    [anon_sym___asm] = ACTIONS(1357),
    [sym_number_literal] = ACTIONS(1359),
    [anon_sym_L_SQUOTE] = ACTIONS(1359),
    [anon_sym_u_SQUOTE] = ACTIONS(1359),
    [anon_sym_U_SQUOTE] = ACTIONS(1359),
    [anon_sym_u8_SQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_L_DQUOTE] = ACTIONS(1359),
    [anon_sym_u_DQUOTE] = ACTIONS(1359),
    [anon_sym_U_DQUOTE] = ACTIONS(1359),
    [anon_sym_u8_DQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [anon_sym_NULL] = ACTIONS(1357),
    [anon_sym_nullptr] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_expression] = STATE(704),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(686),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(686),
    [sym_call_expression] = STATE(686),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(686),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(686),
    [sym_initializer_list] = STATE(675),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(700),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1383),
    [aux_sym_preproc_if_token2] = ACTIONS(1383),
    [aux_sym_preproc_else_token1] = ACTIONS(1383),
    [aux_sym_preproc_elif_token1] = ACTIONS(1381),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1383),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1383),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1383),
    [anon_sym_AMP_AMP] = ACTIONS(1383),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_EQ_EQ] = ACTIONS(1383),
    [anon_sym_BANG_EQ] = ACTIONS(1383),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1383),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_LT_LT] = ACTIONS(1381),
    [anon_sym_GT_GT] = ACTIONS(1381),
    [anon_sym___extension__] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1381),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_STAR_EQ] = ACTIONS(1383),
    [anon_sym_SLASH_EQ] = ACTIONS(1383),
    [anon_sym_PERCENT_EQ] = ACTIONS(1383),
    [anon_sym_PLUS_EQ] = ACTIONS(1383),
    [anon_sym_DASH_EQ] = ACTIONS(1383),
    [anon_sym_LT_LT_EQ] = ACTIONS(1383),
    [anon_sym_GT_GT_EQ] = ACTIONS(1383),
    [anon_sym_AMP_EQ] = ACTIONS(1383),
    [anon_sym_CARET_EQ] = ACTIONS(1383),
    [anon_sym_PIPE_EQ] = ACTIONS(1383),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1393),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1381),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym_identifier] = ACTIONS(1325),
    [aux_sym_preproc_include_token1] = ACTIONS(1325),
    [aux_sym_preproc_def_token1] = ACTIONS(1325),
    [aux_sym_preproc_if_token1] = ACTIONS(1325),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1325),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1325),
    [sym_preproc_directive] = ACTIONS(1325),
    [anon_sym_LPAREN2] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym___extension__] = ACTIONS(1325),
    [anon_sym_typedef] = ACTIONS(1325),
    [anon_sym_extern] = ACTIONS(1325),
    [anon_sym___attribute__] = ACTIONS(1325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1327),
    [anon_sym___declspec] = ACTIONS(1325),
    [anon_sym___cdecl] = ACTIONS(1325),
    [anon_sym___clrcall] = ACTIONS(1325),
    [anon_sym___stdcall] = ACTIONS(1325),
    [anon_sym___fastcall] = ACTIONS(1325),
    [anon_sym___thiscall] = ACTIONS(1325),
    [anon_sym___vectorcall] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [anon_sym_signed] = ACTIONS(1325),
    [anon_sym_unsigned] = ACTIONS(1325),
    [anon_sym_long] = ACTIONS(1325),
    [anon_sym_short] = ACTIONS(1325),
    [anon_sym_static] = ACTIONS(1325),
    [anon_sym_auto] = ACTIONS(1325),
    [anon_sym_register] = ACTIONS(1325),
    [anon_sym_inline] = ACTIONS(1325),
    [anon_sym___inline] = ACTIONS(1325),
    [anon_sym___inline__] = ACTIONS(1325),
    [anon_sym___forceinline] = ACTIONS(1325),
    [anon_sym_thread_local] = ACTIONS(1325),
    [anon_sym___thread] = ACTIONS(1325),
    [anon_sym_const] = ACTIONS(1325),
    [anon_sym_constexpr] = ACTIONS(1325),
    [anon_sym_volatile] = ACTIONS(1325),
    [anon_sym_restrict] = ACTIONS(1325),
    [anon_sym___restrict__] = ACTIONS(1325),
    [anon_sym__Atomic] = ACTIONS(1325),
    [anon_sym__Noreturn] = ACTIONS(1325),
    [anon_sym_noreturn] = ACTIONS(1325),
    [anon_sym__Nonnull] = ACTIONS(1325),
    [anon_sym_alignas] = ACTIONS(1325),
    [anon_sym__Alignas] = ACTIONS(1325),
    [sym_primitive_type] = ACTIONS(1325),
    [anon_sym_enum] = ACTIONS(1325),
    [anon_sym_struct] = ACTIONS(1325),
    [anon_sym_union] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1325),
    [anon_sym_switch] = ACTIONS(1325),
    [anon_sym_case] = ACTIONS(1325),
    [anon_sym_default] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1325),
    [anon_sym_do] = ACTIONS(1325),
    [anon_sym_for] = ACTIONS(1325),
    [anon_sym_return] = ACTIONS(1325),
    [anon_sym_break] = ACTIONS(1325),
    [anon_sym_continue] = ACTIONS(1325),
    [anon_sym_goto] = ACTIONS(1325),
    [anon_sym___try] = ACTIONS(1325),
    [anon_sym___leave] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1327),
    [anon_sym_sizeof] = ACTIONS(1325),
    [anon_sym___alignof__] = ACTIONS(1325),
    [anon_sym___alignof] = ACTIONS(1325),
    [anon_sym__alignof] = ACTIONS(1325),
    [anon_sym_alignof] = ACTIONS(1325),
    [anon_sym__Alignof] = ACTIONS(1325),
    [anon_sym_offsetof] = ACTIONS(1325),
    [anon_sym__Generic] = ACTIONS(1325),
    [anon_sym_asm] = ACTIONS(1325),
    [anon_sym___asm__] = ACTIONS(1325),
    [anon_sym___asm] = ACTIONS(1325),
    [sym_number_literal] = ACTIONS(1327),
    [anon_sym_L_SQUOTE] = ACTIONS(1327),
    [anon_sym_u_SQUOTE] = ACTIONS(1327),
    [anon_sym_U_SQUOTE] = ACTIONS(1327),
    [anon_sym_u8_SQUOTE] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [anon_sym_L_DQUOTE] = ACTIONS(1327),
    [anon_sym_u_DQUOTE] = ACTIONS(1327),
    [anon_sym_U_DQUOTE] = ACTIONS(1327),
    [anon_sym_u8_DQUOTE] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [sym_true] = ACTIONS(1325),
    [sym_false] = ACTIONS(1325),
    [anon_sym_NULL] = ACTIONS(1325),
    [anon_sym_nullptr] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym_identifier] = ACTIONS(1367),
    [aux_sym_preproc_include_token1] = ACTIONS(1367),
    [aux_sym_preproc_def_token1] = ACTIONS(1367),
    [aux_sym_preproc_if_token1] = ACTIONS(1367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1367),
    [sym_preproc_directive] = ACTIONS(1367),
    [anon_sym_LPAREN2] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1367),
    [anon_sym_STAR] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym___extension__] = ACTIONS(1367),
    [anon_sym_typedef] = ACTIONS(1367),
    [anon_sym_extern] = ACTIONS(1367),
    [anon_sym___attribute__] = ACTIONS(1367),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1369),
    [anon_sym___declspec] = ACTIONS(1367),
    [anon_sym___cdecl] = ACTIONS(1367),
    [anon_sym___clrcall] = ACTIONS(1367),
    [anon_sym___stdcall] = ACTIONS(1367),
    [anon_sym___fastcall] = ACTIONS(1367),
    [anon_sym___thiscall] = ACTIONS(1367),
    [anon_sym___vectorcall] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_signed] = ACTIONS(1367),
    [anon_sym_unsigned] = ACTIONS(1367),
    [anon_sym_long] = ACTIONS(1367),
    [anon_sym_short] = ACTIONS(1367),
    [anon_sym_static] = ACTIONS(1367),
    [anon_sym_auto] = ACTIONS(1367),
    [anon_sym_register] = ACTIONS(1367),
    [anon_sym_inline] = ACTIONS(1367),
    [anon_sym___inline] = ACTIONS(1367),
    [anon_sym___inline__] = ACTIONS(1367),
    [anon_sym___forceinline] = ACTIONS(1367),
    [anon_sym_thread_local] = ACTIONS(1367),
    [anon_sym___thread] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1367),
    [anon_sym_constexpr] = ACTIONS(1367),
    [anon_sym_volatile] = ACTIONS(1367),
    [anon_sym_restrict] = ACTIONS(1367),
    [anon_sym___restrict__] = ACTIONS(1367),
    [anon_sym__Atomic] = ACTIONS(1367),
    [anon_sym__Noreturn] = ACTIONS(1367),
    [anon_sym_noreturn] = ACTIONS(1367),
    [anon_sym__Nonnull] = ACTIONS(1367),
    [anon_sym_alignas] = ACTIONS(1367),
    [anon_sym__Alignas] = ACTIONS(1367),
    [sym_primitive_type] = ACTIONS(1367),
    [anon_sym_enum] = ACTIONS(1367),
    [anon_sym_struct] = ACTIONS(1367),
    [anon_sym_union] = ACTIONS(1367),
    [anon_sym_if] = ACTIONS(1367),
    [anon_sym_switch] = ACTIONS(1367),
    [anon_sym_case] = ACTIONS(1367),
    [anon_sym_default] = ACTIONS(1367),
    [anon_sym_while] = ACTIONS(1367),
    [anon_sym_do] = ACTIONS(1367),
    [anon_sym_for] = ACTIONS(1367),
    [anon_sym_return] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1367),
    [anon_sym_continue] = ACTIONS(1367),
    [anon_sym_goto] = ACTIONS(1367),
    [anon_sym___try] = ACTIONS(1367),
    [anon_sym___leave] = ACTIONS(1367),
    [anon_sym_DASH_DASH] = ACTIONS(1369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_sizeof] = ACTIONS(1367),
    [anon_sym___alignof__] = ACTIONS(1367),
    [anon_sym___alignof] = ACTIONS(1367),
    [anon_sym__alignof] = ACTIONS(1367),
    [anon_sym_alignof] = ACTIONS(1367),
    [anon_sym__Alignof] = ACTIONS(1367),
    [anon_sym_offsetof] = ACTIONS(1367),
    [anon_sym__Generic] = ACTIONS(1367),
    [anon_sym_asm] = ACTIONS(1367),
    [anon_sym___asm__] = ACTIONS(1367),
    [anon_sym___asm] = ACTIONS(1367),
    [sym_number_literal] = ACTIONS(1369),
    [anon_sym_L_SQUOTE] = ACTIONS(1369),
    [anon_sym_u_SQUOTE] = ACTIONS(1369),
    [anon_sym_U_SQUOTE] = ACTIONS(1369),
    [anon_sym_u8_SQUOTE] = ACTIONS(1369),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_L_DQUOTE] = ACTIONS(1369),
    [anon_sym_u_DQUOTE] = ACTIONS(1369),
    [anon_sym_U_DQUOTE] = ACTIONS(1369),
    [anon_sym_u8_DQUOTE] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1369),
    [sym_true] = ACTIONS(1367),
    [sym_false] = ACTIONS(1367),
    [anon_sym_NULL] = ACTIONS(1367),
    [anon_sym_nullptr] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1364),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym__Nonnull] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [anon_sym___asm] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1364),
    [anon_sym_L_SQUOTE] = ACTIONS(1364),
    [anon_sym_u_SQUOTE] = ACTIONS(1364),
    [anon_sym_U_SQUOTE] = ACTIONS(1364),
    [anon_sym_u8_SQUOTE] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_L_DQUOTE] = ACTIONS(1364),
    [anon_sym_u_DQUOTE] = ACTIONS(1364),
    [anon_sym_U_DQUOTE] = ACTIONS(1364),
    [anon_sym_u8_DQUOTE] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token2] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1364),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym__Nonnull] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [anon_sym___asm] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1364),
    [anon_sym_L_SQUOTE] = ACTIONS(1364),
    [anon_sym_u_SQUOTE] = ACTIONS(1364),
    [anon_sym_U_SQUOTE] = ACTIONS(1364),
    [anon_sym_u8_SQUOTE] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_L_DQUOTE] = ACTIONS(1364),
    [anon_sym_u_DQUOTE] = ACTIONS(1364),
    [anon_sym_U_DQUOTE] = ACTIONS(1364),
    [anon_sym_u8_DQUOTE] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_identifier] = ACTIONS(1349),
    [aux_sym_preproc_include_token1] = ACTIONS(1349),
    [aux_sym_preproc_def_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1349),
    [sym_preproc_directive] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym___extension__] = ACTIONS(1349),
    [anon_sym_typedef] = ACTIONS(1349),
    [anon_sym_extern] = ACTIONS(1349),
    [anon_sym___attribute__] = ACTIONS(1349),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1351),
    [anon_sym___declspec] = ACTIONS(1349),
    [anon_sym___cdecl] = ACTIONS(1349),
    [anon_sym___clrcall] = ACTIONS(1349),
    [anon_sym___stdcall] = ACTIONS(1349),
    [anon_sym___fastcall] = ACTIONS(1349),
    [anon_sym___thiscall] = ACTIONS(1349),
    [anon_sym___vectorcall] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_signed] = ACTIONS(1349),
    [anon_sym_unsigned] = ACTIONS(1349),
    [anon_sym_long] = ACTIONS(1349),
    [anon_sym_short] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_auto] = ACTIONS(1349),
    [anon_sym_register] = ACTIONS(1349),
    [anon_sym_inline] = ACTIONS(1349),
    [anon_sym___inline] = ACTIONS(1349),
    [anon_sym___inline__] = ACTIONS(1349),
    [anon_sym___forceinline] = ACTIONS(1349),
    [anon_sym_thread_local] = ACTIONS(1349),
    [anon_sym___thread] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_constexpr] = ACTIONS(1349),
    [anon_sym_volatile] = ACTIONS(1349),
    [anon_sym_restrict] = ACTIONS(1349),
    [anon_sym___restrict__] = ACTIONS(1349),
    [anon_sym__Atomic] = ACTIONS(1349),
    [anon_sym__Noreturn] = ACTIONS(1349),
    [anon_sym_noreturn] = ACTIONS(1349),
    [anon_sym__Nonnull] = ACTIONS(1349),
    [anon_sym_alignas] = ACTIONS(1349),
    [anon_sym__Alignas] = ACTIONS(1349),
    [sym_primitive_type] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1349),
    [anon_sym_union] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_goto] = ACTIONS(1349),
    [anon_sym___try] = ACTIONS(1349),
    [anon_sym___leave] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_sizeof] = ACTIONS(1349),
    [anon_sym___alignof__] = ACTIONS(1349),
    [anon_sym___alignof] = ACTIONS(1349),
    [anon_sym__alignof] = ACTIONS(1349),
    [anon_sym_alignof] = ACTIONS(1349),
    [anon_sym__Alignof] = ACTIONS(1349),
    [anon_sym_offsetof] = ACTIONS(1349),
    [anon_sym__Generic] = ACTIONS(1349),
    [anon_sym_asm] = ACTIONS(1349),
    [anon_sym___asm__] = ACTIONS(1349),
    [anon_sym___asm] = ACTIONS(1349),
    [sym_number_literal] = ACTIONS(1351),
    [anon_sym_L_SQUOTE] = ACTIONS(1351),
    [anon_sym_u_SQUOTE] = ACTIONS(1351),
    [anon_sym_U_SQUOTE] = ACTIONS(1351),
    [anon_sym_u8_SQUOTE] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1351),
    [anon_sym_L_DQUOTE] = ACTIONS(1351),
    [anon_sym_u_DQUOTE] = ACTIONS(1351),
    [anon_sym_U_DQUOTE] = ACTIONS(1351),
    [anon_sym_u8_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [anon_sym_NULL] = ACTIONS(1349),
    [anon_sym_nullptr] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_identifier] = ACTIONS(1353),
    [aux_sym_preproc_include_token1] = ACTIONS(1353),
    [aux_sym_preproc_def_token1] = ACTIONS(1353),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1353),
    [sym_preproc_directive] = ACTIONS(1353),
    [anon_sym_LPAREN2] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_AMP] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1355),
    [anon_sym___extension__] = ACTIONS(1353),
    [anon_sym_typedef] = ACTIONS(1353),
    [anon_sym_extern] = ACTIONS(1353),
    [anon_sym___attribute__] = ACTIONS(1353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1355),
    [anon_sym___declspec] = ACTIONS(1353),
    [anon_sym___cdecl] = ACTIONS(1353),
    [anon_sym___clrcall] = ACTIONS(1353),
    [anon_sym___stdcall] = ACTIONS(1353),
    [anon_sym___fastcall] = ACTIONS(1353),
    [anon_sym___thiscall] = ACTIONS(1353),
    [anon_sym___vectorcall] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1355),
    [anon_sym_RBRACE] = ACTIONS(1355),
    [anon_sym_signed] = ACTIONS(1353),
    [anon_sym_unsigned] = ACTIONS(1353),
    [anon_sym_long] = ACTIONS(1353),
    [anon_sym_short] = ACTIONS(1353),
    [anon_sym_static] = ACTIONS(1353),
    [anon_sym_auto] = ACTIONS(1353),
    [anon_sym_register] = ACTIONS(1353),
    [anon_sym_inline] = ACTIONS(1353),
    [anon_sym___inline] = ACTIONS(1353),
    [anon_sym___inline__] = ACTIONS(1353),
    [anon_sym___forceinline] = ACTIONS(1353),
    [anon_sym_thread_local] = ACTIONS(1353),
    [anon_sym___thread] = ACTIONS(1353),
    [anon_sym_const] = ACTIONS(1353),
    [anon_sym_constexpr] = ACTIONS(1353),
    [anon_sym_volatile] = ACTIONS(1353),
    [anon_sym_restrict] = ACTIONS(1353),
    [anon_sym___restrict__] = ACTIONS(1353),
    [anon_sym__Atomic] = ACTIONS(1353),
    [anon_sym__Noreturn] = ACTIONS(1353),
    [anon_sym_noreturn] = ACTIONS(1353),
    [anon_sym__Nonnull] = ACTIONS(1353),
    [anon_sym_alignas] = ACTIONS(1353),
    [anon_sym__Alignas] = ACTIONS(1353),
    [sym_primitive_type] = ACTIONS(1353),
    [anon_sym_enum] = ACTIONS(1353),
    [anon_sym_struct] = ACTIONS(1353),
    [anon_sym_union] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(1353),
    [anon_sym_switch] = ACTIONS(1353),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_default] = ACTIONS(1353),
    [anon_sym_while] = ACTIONS(1353),
    [anon_sym_do] = ACTIONS(1353),
    [anon_sym_for] = ACTIONS(1353),
    [anon_sym_return] = ACTIONS(1353),
    [anon_sym_break] = ACTIONS(1353),
    [anon_sym_continue] = ACTIONS(1353),
    [anon_sym_goto] = ACTIONS(1353),
    [anon_sym___try] = ACTIONS(1353),
    [anon_sym___leave] = ACTIONS(1353),
    [anon_sym_DASH_DASH] = ACTIONS(1355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1355),
    [anon_sym_sizeof] = ACTIONS(1353),
    [anon_sym___alignof__] = ACTIONS(1353),
    [anon_sym___alignof] = ACTIONS(1353),
    [anon_sym__alignof] = ACTIONS(1353),
    [anon_sym_alignof] = ACTIONS(1353),
    [anon_sym__Alignof] = ACTIONS(1353),
    [anon_sym_offsetof] = ACTIONS(1353),
    [anon_sym__Generic] = ACTIONS(1353),
    [anon_sym_asm] = ACTIONS(1353),
    [anon_sym___asm__] = ACTIONS(1353),
    [anon_sym___asm] = ACTIONS(1353),
    [sym_number_literal] = ACTIONS(1355),
    [anon_sym_L_SQUOTE] = ACTIONS(1355),
    [anon_sym_u_SQUOTE] = ACTIONS(1355),
    [anon_sym_U_SQUOTE] = ACTIONS(1355),
    [anon_sym_u8_SQUOTE] = ACTIONS(1355),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_L_DQUOTE] = ACTIONS(1355),
    [anon_sym_u_DQUOTE] = ACTIONS(1355),
    [anon_sym_U_DQUOTE] = ACTIONS(1355),
    [anon_sym_u8_DQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_true] = ACTIONS(1353),
    [sym_false] = ACTIONS(1353),
    [anon_sym_NULL] = ACTIONS(1353),
    [anon_sym_nullptr] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_expression] = STATE(704),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(686),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(686),
    [sym_call_expression] = STATE(686),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(686),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(686),
    [sym_initializer_list] = STATE(675),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_COMMA] = ACTIONS(1383),
    [anon_sym_RPAREN] = ACTIONS(1383),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1383),
    [anon_sym_AMP_AMP] = ACTIONS(1383),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_EQ_EQ] = ACTIONS(1383),
    [anon_sym_BANG_EQ] = ACTIONS(1383),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1383),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_LT_LT] = ACTIONS(1381),
    [anon_sym_GT_GT] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym___extension__] = ACTIONS(1401),
    [anon_sym___attribute__] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_RBRACE] = ACTIONS(1383),
    [anon_sym_LBRACK] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1381),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_STAR_EQ] = ACTIONS(1383),
    [anon_sym_SLASH_EQ] = ACTIONS(1383),
    [anon_sym_PERCENT_EQ] = ACTIONS(1383),
    [anon_sym_PLUS_EQ] = ACTIONS(1383),
    [anon_sym_DASH_EQ] = ACTIONS(1383),
    [anon_sym_LT_LT_EQ] = ACTIONS(1383),
    [anon_sym_GT_GT_EQ] = ACTIONS(1383),
    [anon_sym_AMP_EQ] = ACTIONS(1383),
    [anon_sym_CARET_EQ] = ACTIONS(1383),
    [anon_sym_PIPE_EQ] = ACTIONS(1383),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1403),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1381),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_RBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym__Nonnull] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [anon_sym___asm] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym_identifier] = ACTIONS(1309),
    [aux_sym_preproc_include_token1] = ACTIONS(1309),
    [aux_sym_preproc_def_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token2] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1309),
    [sym_preproc_directive] = ACTIONS(1309),
    [anon_sym_LPAREN2] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym___extension__] = ACTIONS(1309),
    [anon_sym_typedef] = ACTIONS(1309),
    [anon_sym_extern] = ACTIONS(1309),
    [anon_sym___attribute__] = ACTIONS(1309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1311),
    [anon_sym___declspec] = ACTIONS(1309),
    [anon_sym___cdecl] = ACTIONS(1309),
    [anon_sym___clrcall] = ACTIONS(1309),
    [anon_sym___stdcall] = ACTIONS(1309),
    [anon_sym___fastcall] = ACTIONS(1309),
    [anon_sym___thiscall] = ACTIONS(1309),
    [anon_sym___vectorcall] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(1309),
    [anon_sym_unsigned] = ACTIONS(1309),
    [anon_sym_long] = ACTIONS(1309),
    [anon_sym_short] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_auto] = ACTIONS(1309),
    [anon_sym_register] = ACTIONS(1309),
    [anon_sym_inline] = ACTIONS(1309),
    [anon_sym___inline] = ACTIONS(1309),
    [anon_sym___inline__] = ACTIONS(1309),
    [anon_sym___forceinline] = ACTIONS(1309),
    [anon_sym_thread_local] = ACTIONS(1309),
    [anon_sym___thread] = ACTIONS(1309),
    [anon_sym_const] = ACTIONS(1309),
    [anon_sym_constexpr] = ACTIONS(1309),
    [anon_sym_volatile] = ACTIONS(1309),
    [anon_sym_restrict] = ACTIONS(1309),
    [anon_sym___restrict__] = ACTIONS(1309),
    [anon_sym__Atomic] = ACTIONS(1309),
    [anon_sym__Noreturn] = ACTIONS(1309),
    [anon_sym_noreturn] = ACTIONS(1309),
    [anon_sym__Nonnull] = ACTIONS(1309),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1309),
    [anon_sym_enum] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1309),
    [anon_sym_union] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1309),
    [anon_sym_default] = ACTIONS(1309),
    [anon_sym_while] = ACTIONS(1309),
    [anon_sym_do] = ACTIONS(1309),
    [anon_sym_for] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1309),
    [anon_sym_goto] = ACTIONS(1309),
    [anon_sym___try] = ACTIONS(1309),
    [anon_sym___leave] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1309),
    [anon_sym___alignof__] = ACTIONS(1309),
    [anon_sym___alignof] = ACTIONS(1309),
    [anon_sym__alignof] = ACTIONS(1309),
    [anon_sym_alignof] = ACTIONS(1309),
    [anon_sym__Alignof] = ACTIONS(1309),
    [anon_sym_offsetof] = ACTIONS(1309),
    [anon_sym__Generic] = ACTIONS(1309),
    [anon_sym_asm] = ACTIONS(1309),
    [anon_sym___asm__] = ACTIONS(1309),
    [anon_sym___asm] = ACTIONS(1309),
    [sym_number_literal] = ACTIONS(1311),
    [anon_sym_L_SQUOTE] = ACTIONS(1311),
    [anon_sym_u_SQUOTE] = ACTIONS(1311),
    [anon_sym_U_SQUOTE] = ACTIONS(1311),
    [anon_sym_u8_SQUOTE] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_L_DQUOTE] = ACTIONS(1311),
    [anon_sym_u_DQUOTE] = ACTIONS(1311),
    [anon_sym_U_DQUOTE] = ACTIONS(1311),
    [anon_sym_u8_DQUOTE] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1311),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [anon_sym_NULL] = ACTIONS(1309),
    [anon_sym_nullptr] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token2] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym__Nonnull] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [anon_sym___asm] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_attribute_declaration] = STATE(317),
    [sym_compound_statement] = STATE(204),
    [sym_attributed_statement] = STATE(204),
    [sym_statement] = STATE(208),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(317),
    [sym_identifier] = ACTIONS(1405),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1423),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_switch] = ACTIONS(1435),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_do] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1453),
    [anon_sym_break] = ACTIONS(1456),
    [anon_sym_continue] = ACTIONS(1459),
    [anon_sym_goto] = ACTIONS(1462),
    [anon_sym___try] = ACTIONS(1465),
    [anon_sym___leave] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1477),
    [anon_sym___alignof] = ACTIONS(1477),
    [anon_sym__alignof] = ACTIONS(1477),
    [anon_sym_alignof] = ACTIONS(1477),
    [anon_sym__Alignof] = ACTIONS(1477),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1483),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [anon_sym___asm] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1489),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1495),
    [anon_sym_u_DQUOTE] = ACTIONS(1495),
    [anon_sym_U_DQUOTE] = ACTIONS(1495),
    [anon_sym_u8_DQUOTE] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1495),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1501),
    [anon_sym_nullptr] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [sym_attribute_declaration] = STATE(340),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(1989),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym_attribute_declaration] = STATE(323),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(214),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_attribute_declaration] = STATE(323),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(148),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1325),
    [aux_sym_preproc_include_token1] = ACTIONS(1325),
    [aux_sym_preproc_def_token1] = ACTIONS(1325),
    [anon_sym_COMMA] = ACTIONS(1327),
    [aux_sym_preproc_if_token1] = ACTIONS(1325),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1325),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1325),
    [sym_preproc_directive] = ACTIONS(1325),
    [anon_sym_LPAREN2] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym___extension__] = ACTIONS(1325),
    [anon_sym_typedef] = ACTIONS(1325),
    [anon_sym_extern] = ACTIONS(1325),
    [anon_sym___attribute__] = ACTIONS(1325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1327),
    [anon_sym___declspec] = ACTIONS(1325),
    [anon_sym___cdecl] = ACTIONS(1325),
    [anon_sym___clrcall] = ACTIONS(1325),
    [anon_sym___stdcall] = ACTIONS(1325),
    [anon_sym___fastcall] = ACTIONS(1325),
    [anon_sym___thiscall] = ACTIONS(1325),
    [anon_sym___vectorcall] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [anon_sym_signed] = ACTIONS(1325),
    [anon_sym_unsigned] = ACTIONS(1325),
    [anon_sym_long] = ACTIONS(1325),
    [anon_sym_short] = ACTIONS(1325),
    [anon_sym_static] = ACTIONS(1325),
    [anon_sym_auto] = ACTIONS(1325),
    [anon_sym_register] = ACTIONS(1325),
    [anon_sym_inline] = ACTIONS(1325),
    [anon_sym___inline] = ACTIONS(1325),
    [anon_sym___inline__] = ACTIONS(1325),
    [anon_sym___forceinline] = ACTIONS(1325),
    [anon_sym_thread_local] = ACTIONS(1325),
    [anon_sym___thread] = ACTIONS(1325),
    [anon_sym_const] = ACTIONS(1325),
    [anon_sym_constexpr] = ACTIONS(1325),
    [anon_sym_volatile] = ACTIONS(1325),
    [anon_sym_restrict] = ACTIONS(1325),
    [anon_sym___restrict__] = ACTIONS(1325),
    [anon_sym__Atomic] = ACTIONS(1325),
    [anon_sym__Noreturn] = ACTIONS(1325),
    [anon_sym_noreturn] = ACTIONS(1325),
    [anon_sym__Nonnull] = ACTIONS(1325),
    [anon_sym_alignas] = ACTIONS(1325),
    [anon_sym__Alignas] = ACTIONS(1325),
    [sym_primitive_type] = ACTIONS(1325),
    [anon_sym_enum] = ACTIONS(1325),
    [anon_sym_struct] = ACTIONS(1325),
    [anon_sym_union] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1325),
    [anon_sym_switch] = ACTIONS(1325),
    [anon_sym_case] = ACTIONS(1325),
    [anon_sym_default] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1325),
    [anon_sym_do] = ACTIONS(1325),
    [anon_sym_for] = ACTIONS(1325),
    [anon_sym_return] = ACTIONS(1325),
    [anon_sym_break] = ACTIONS(1325),
    [anon_sym_continue] = ACTIONS(1325),
    [anon_sym_goto] = ACTIONS(1325),
    [anon_sym_DASH_DASH] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1327),
    [anon_sym_sizeof] = ACTIONS(1325),
    [anon_sym___alignof__] = ACTIONS(1325),
    [anon_sym___alignof] = ACTIONS(1325),
    [anon_sym__alignof] = ACTIONS(1325),
    [anon_sym_alignof] = ACTIONS(1325),
    [anon_sym__Alignof] = ACTIONS(1325),
    [anon_sym_offsetof] = ACTIONS(1325),
    [anon_sym__Generic] = ACTIONS(1325),
    [anon_sym_asm] = ACTIONS(1325),
    [anon_sym___asm__] = ACTIONS(1325),
    [anon_sym___asm] = ACTIONS(1325),
    [sym_number_literal] = ACTIONS(1327),
    [anon_sym_L_SQUOTE] = ACTIONS(1327),
    [anon_sym_u_SQUOTE] = ACTIONS(1327),
    [anon_sym_U_SQUOTE] = ACTIONS(1327),
    [anon_sym_u8_SQUOTE] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [anon_sym_L_DQUOTE] = ACTIONS(1327),
    [anon_sym_u_DQUOTE] = ACTIONS(1327),
    [anon_sym_U_DQUOTE] = ACTIONS(1327),
    [anon_sym_u8_DQUOTE] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [sym_true] = ACTIONS(1325),
    [sym_false] = ACTIONS(1325),
    [anon_sym_NULL] = ACTIONS(1325),
    [anon_sym_nullptr] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_attribute_declaration] = STATE(338),
    [sym_compound_statement] = STATE(171),
    [sym_attributed_statement] = STATE(171),
    [sym_statement] = STATE(149),
    [sym_labeled_statement] = STATE(171),
    [sym_expression_statement] = STATE(171),
    [sym_if_statement] = STATE(171),
    [sym_switch_statement] = STATE(171),
    [sym_case_statement] = STATE(171),
    [sym_while_statement] = STATE(171),
    [sym_do_statement] = STATE(171),
    [sym_for_statement] = STATE(171),
    [sym_return_statement] = STATE(171),
    [sym_break_statement] = STATE(171),
    [sym_continue_statement] = STATE(171),
    [sym_goto_statement] = STATE(171),
    [sym_seh_try_statement] = STATE(171),
    [sym_seh_leave_statement] = STATE(171),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_attribute_declaration] = STATE(349),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(178),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(349),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(1307),
    [sym_identifier] = ACTIONS(1305),
    [aux_sym_preproc_include_token1] = ACTIONS(1305),
    [aux_sym_preproc_def_token1] = ACTIONS(1305),
    [anon_sym_COMMA] = ACTIONS(1307),
    [aux_sym_preproc_if_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_LPAREN2] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_TILDE] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym___extension__] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym___attribute__] = ACTIONS(1305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1307),
    [anon_sym___declspec] = ACTIONS(1305),
    [anon_sym___cdecl] = ACTIONS(1305),
    [anon_sym___clrcall] = ACTIONS(1305),
    [anon_sym___stdcall] = ACTIONS(1305),
    [anon_sym___fastcall] = ACTIONS(1305),
    [anon_sym___thiscall] = ACTIONS(1305),
    [anon_sym___vectorcall] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym___inline] = ACTIONS(1305),
    [anon_sym___inline__] = ACTIONS(1305),
    [anon_sym___forceinline] = ACTIONS(1305),
    [anon_sym_thread_local] = ACTIONS(1305),
    [anon_sym___thread] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_constexpr] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym___restrict__] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym__Noreturn] = ACTIONS(1305),
    [anon_sym_noreturn] = ACTIONS(1305),
    [anon_sym__Nonnull] = ACTIONS(1305),
    [anon_sym_alignas] = ACTIONS(1305),
    [anon_sym__Alignas] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1307),
    [anon_sym_sizeof] = ACTIONS(1305),
    [anon_sym___alignof__] = ACTIONS(1305),
    [anon_sym___alignof] = ACTIONS(1305),
    [anon_sym__alignof] = ACTIONS(1305),
    [anon_sym_alignof] = ACTIONS(1305),
    [anon_sym__Alignof] = ACTIONS(1305),
    [anon_sym_offsetof] = ACTIONS(1305),
    [anon_sym__Generic] = ACTIONS(1305),
    [anon_sym_asm] = ACTIONS(1305),
    [anon_sym___asm__] = ACTIONS(1305),
    [anon_sym___asm] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1307),
    [anon_sym_L_SQUOTE] = ACTIONS(1307),
    [anon_sym_u_SQUOTE] = ACTIONS(1307),
    [anon_sym_U_SQUOTE] = ACTIONS(1307),
    [anon_sym_u8_SQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1307),
    [anon_sym_L_DQUOTE] = ACTIONS(1307),
    [anon_sym_u_DQUOTE] = ACTIONS(1307),
    [anon_sym_U_DQUOTE] = ACTIONS(1307),
    [anon_sym_u8_DQUOTE] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1307),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [anon_sym_NULL] = ACTIONS(1305),
    [anon_sym_nullptr] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [sym_attribute_declaration] = STATE(347),
    [sym_compound_statement] = STATE(84),
    [sym_attributed_statement] = STATE(84),
    [sym_statement] = STATE(80),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_attribute_declaration] = STATE(347),
    [sym_compound_statement] = STATE(84),
    [sym_attributed_statement] = STATE(84),
    [sym_statement] = STATE(94),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [327] = {
    [sym_attribute_declaration] = STATE(340),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(1757),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_attribute_declaration] = STATE(328),
    [sym_compound_statement] = STATE(84),
    [sym_attributed_statement] = STATE(84),
    [sym_statement] = STATE(89),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(328),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1423),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1525),
    [anon_sym_switch] = ACTIONS(1528),
    [anon_sym_case] = ACTIONS(1531),
    [anon_sym_default] = ACTIONS(1534),
    [anon_sym_while] = ACTIONS(1537),
    [anon_sym_do] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_continue] = ACTIONS(1552),
    [anon_sym_goto] = ACTIONS(1555),
    [anon_sym___try] = ACTIONS(1558),
    [anon_sym___leave] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1477),
    [anon_sym___alignof] = ACTIONS(1477),
    [anon_sym__alignof] = ACTIONS(1477),
    [anon_sym_alignof] = ACTIONS(1477),
    [anon_sym__Alignof] = ACTIONS(1477),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1483),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [anon_sym___asm] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1489),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1495),
    [anon_sym_u_DQUOTE] = ACTIONS(1495),
    [anon_sym_U_DQUOTE] = ACTIONS(1495),
    [anon_sym_u8_DQUOTE] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1495),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1501),
    [anon_sym_nullptr] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [sym_attribute_declaration] = STATE(323),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(153),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [330] = {
    [sym_attribute_declaration] = STATE(323),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(184),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(323),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_case] = ACTIONS(384),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(388),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(392),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(396),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_goto] = ACTIONS(400),
    [anon_sym___try] = ACTIONS(402),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [331] = {
    [sym_attribute_declaration] = STATE(347),
    [sym_compound_statement] = STATE(84),
    [sym_attributed_statement] = STATE(84),
    [sym_statement] = STATE(109),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_attribute_declaration] = STATE(347),
    [sym_compound_statement] = STATE(84),
    [sym_attributed_statement] = STATE(84),
    [sym_statement] = STATE(111),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(347),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [333] = {
    [sym_attribute_declaration] = STATE(340),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(405),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [334] = {
    [sym_attribute_declaration] = STATE(340),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(241),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym_attribute_declaration] = STATE(335),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(176),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(335),
    [sym_identifier] = ACTIONS(1564),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym___extension__] = ACTIONS(1423),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1576),
    [anon_sym_case] = ACTIONS(1579),
    [anon_sym_default] = ACTIONS(1582),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1591),
    [anon_sym_return] = ACTIONS(1594),
    [anon_sym_break] = ACTIONS(1597),
    [anon_sym_continue] = ACTIONS(1600),
    [anon_sym_goto] = ACTIONS(1603),
    [anon_sym___try] = ACTIONS(1606),
    [anon_sym___leave] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1477),
    [anon_sym___alignof] = ACTIONS(1477),
    [anon_sym__alignof] = ACTIONS(1477),
    [anon_sym_alignof] = ACTIONS(1477),
    [anon_sym__Alignof] = ACTIONS(1477),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1483),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [anon_sym___asm] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1489),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1495),
    [anon_sym_u_DQUOTE] = ACTIONS(1495),
    [anon_sym_U_DQUOTE] = ACTIONS(1495),
    [anon_sym_u8_DQUOTE] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1495),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1501),
    [anon_sym_nullptr] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [sym_attribute_declaration] = STATE(340),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(1911),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [337] = {
    [sym_attribute_declaration] = STATE(340),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(182),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [sym_attribute_declaration] = STATE(344),
    [sym_compound_statement] = STATE(171),
    [sym_attributed_statement] = STATE(171),
    [sym_statement] = STATE(176),
    [sym_labeled_statement] = STATE(171),
    [sym_expression_statement] = STATE(171),
    [sym_if_statement] = STATE(171),
    [sym_switch_statement] = STATE(171),
    [sym_case_statement] = STATE(171),
    [sym_while_statement] = STATE(171),
    [sym_do_statement] = STATE(171),
    [sym_for_statement] = STATE(171),
    [sym_return_statement] = STATE(171),
    [sym_break_statement] = STATE(171),
    [sym_continue_statement] = STATE(171),
    [sym_goto_statement] = STATE(171),
    [sym_seh_try_statement] = STATE(171),
    [sym_seh_leave_statement] = STATE(171),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [339] = {
    [sym_attribute_declaration] = STATE(340),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(161),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [sym_attribute_declaration] = STATE(335),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(176),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(335),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [sym_attribute_declaration] = STATE(350),
    [sym_compound_statement] = STATE(204),
    [sym_attributed_statement] = STATE(204),
    [sym_statement] = STATE(150),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [sym_identifier] = ACTIONS(1612),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [sym_attribute_declaration] = STATE(350),
    [sym_compound_statement] = STATE(204),
    [sym_attributed_statement] = STATE(204),
    [sym_statement] = STATE(215),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [sym_identifier] = ACTIONS(1612),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [sym_attribute_declaration] = STATE(338),
    [sym_compound_statement] = STATE(171),
    [sym_attributed_statement] = STATE(171),
    [sym_statement] = STATE(182),
    [sym_labeled_statement] = STATE(171),
    [sym_expression_statement] = STATE(171),
    [sym_if_statement] = STATE(171),
    [sym_switch_statement] = STATE(171),
    [sym_case_statement] = STATE(171),
    [sym_while_statement] = STATE(171),
    [sym_do_statement] = STATE(171),
    [sym_for_statement] = STATE(171),
    [sym_return_statement] = STATE(171),
    [sym_break_statement] = STATE(171),
    [sym_continue_statement] = STATE(171),
    [sym_goto_statement] = STATE(171),
    [sym_seh_try_statement] = STATE(171),
    [sym_seh_leave_statement] = STATE(171),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym_attribute_declaration] = STATE(344),
    [sym_compound_statement] = STATE(171),
    [sym_attributed_statement] = STATE(171),
    [sym_statement] = STATE(176),
    [sym_labeled_statement] = STATE(171),
    [sym_expression_statement] = STATE(171),
    [sym_if_statement] = STATE(171),
    [sym_switch_statement] = STATE(171),
    [sym_case_statement] = STATE(171),
    [sym_while_statement] = STATE(171),
    [sym_do_statement] = STATE(171),
    [sym_for_statement] = STATE(171),
    [sym_return_statement] = STATE(171),
    [sym_break_statement] = STATE(171),
    [sym_continue_statement] = STATE(171),
    [sym_goto_statement] = STATE(171),
    [sym_seh_try_statement] = STATE(171),
    [sym_seh_leave_statement] = STATE(171),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(344),
    [sym_identifier] = ACTIONS(1614),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym___extension__] = ACTIONS(1423),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_if] = ACTIONS(1620),
    [anon_sym_switch] = ACTIONS(1576),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1626),
    [anon_sym_while] = ACTIONS(1629),
    [anon_sym_do] = ACTIONS(1588),
    [anon_sym_for] = ACTIONS(1632),
    [anon_sym_return] = ACTIONS(1594),
    [anon_sym_break] = ACTIONS(1597),
    [anon_sym_continue] = ACTIONS(1600),
    [anon_sym_goto] = ACTIONS(1603),
    [anon_sym___try] = ACTIONS(1635),
    [anon_sym___leave] = ACTIONS(1638),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1477),
    [anon_sym___alignof] = ACTIONS(1477),
    [anon_sym__alignof] = ACTIONS(1477),
    [anon_sym_alignof] = ACTIONS(1477),
    [anon_sym__Alignof] = ACTIONS(1477),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1483),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [anon_sym___asm] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1489),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1495),
    [anon_sym_u_DQUOTE] = ACTIONS(1495),
    [anon_sym_U_DQUOTE] = ACTIONS(1495),
    [anon_sym_u8_DQUOTE] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1495),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1501),
    [anon_sym_nullptr] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
  },
  [345] = {
    [sym_attribute_declaration] = STATE(350),
    [sym_compound_statement] = STATE(204),
    [sym_attributed_statement] = STATE(204),
    [sym_statement] = STATE(226),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [sym_identifier] = ACTIONS(1612),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym_attribute_declaration] = STATE(350),
    [sym_compound_statement] = STATE(204),
    [sym_attributed_statement] = STATE(204),
    [sym_statement] = STATE(228),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(350),
    [sym_identifier] = ACTIONS(1612),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [sym_attribute_declaration] = STATE(328),
    [sym_compound_statement] = STATE(84),
    [sym_attributed_statement] = STATE(84),
    [sym_statement] = STATE(89),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1761),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(328),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_case] = ACTIONS(137),
    [anon_sym_default] = ACTIONS(139),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_for] = ACTIONS(145),
    [anon_sym_return] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(151),
    [anon_sym_goto] = ACTIONS(153),
    [anon_sym___try] = ACTIONS(155),
    [anon_sym___leave] = ACTIONS(157),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [sym_attribute_declaration] = STATE(338),
    [sym_compound_statement] = STATE(171),
    [sym_attributed_statement] = STATE(171),
    [sym_statement] = STATE(161),
    [sym_labeled_statement] = STATE(171),
    [sym_expression_statement] = STATE(171),
    [sym_if_statement] = STATE(171),
    [sym_switch_statement] = STATE(171),
    [sym_case_statement] = STATE(171),
    [sym_while_statement] = STATE(171),
    [sym_do_statement] = STATE(171),
    [sym_for_statement] = STATE(171),
    [sym_return_statement] = STATE(171),
    [sym_break_statement] = STATE(171),
    [sym_continue_statement] = STATE(171),
    [sym_goto_statement] = STATE(171),
    [sym_seh_try_statement] = STATE(171),
    [sym_seh_leave_statement] = STATE(171),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym_attribute_declaration] = STATE(349),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(178),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(349),
    [sym_identifier] = ACTIONS(1641),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym___extension__] = ACTIONS(1423),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1650),
    [anon_sym_case] = ACTIONS(1653),
    [anon_sym_default] = ACTIONS(1656),
    [anon_sym_while] = ACTIONS(1659),
    [anon_sym_do] = ACTIONS(1662),
    [anon_sym_for] = ACTIONS(1665),
    [anon_sym_return] = ACTIONS(1668),
    [anon_sym_break] = ACTIONS(1671),
    [anon_sym_continue] = ACTIONS(1674),
    [anon_sym_goto] = ACTIONS(1677),
    [anon_sym___try] = ACTIONS(1680),
    [anon_sym___leave] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1477),
    [anon_sym___alignof] = ACTIONS(1477),
    [anon_sym__alignof] = ACTIONS(1477),
    [anon_sym_alignof] = ACTIONS(1477),
    [anon_sym__Alignof] = ACTIONS(1477),
    [anon_sym_offsetof] = ACTIONS(1480),
    [anon_sym__Generic] = ACTIONS(1483),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [anon_sym___asm] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1489),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1495),
    [anon_sym_u_DQUOTE] = ACTIONS(1495),
    [anon_sym_U_DQUOTE] = ACTIONS(1495),
    [anon_sym_u8_DQUOTE] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1495),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1501),
    [anon_sym_nullptr] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_attribute_declaration] = STATE(317),
    [sym_compound_statement] = STATE(204),
    [sym_attributed_statement] = STATE(204),
    [sym_statement] = STATE(208),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym_seh_try_statement] = STATE(204),
    [sym_seh_leave_statement] = STATE(204),
    [sym_expression] = STATE(1031),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1919),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(317),
    [sym_identifier] = ACTIONS(1612),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(516),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_goto] = ACTIONS(524),
    [anon_sym___try] = ACTIONS(526),
    [anon_sym___leave] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_attribute_declaration] = STATE(340),
    [sym_compound_statement] = STATE(177),
    [sym_attributed_statement] = STATE(177),
    [sym_statement] = STATE(1974),
    [sym_labeled_statement] = STATE(177),
    [sym_expression_statement] = STATE(177),
    [sym_if_statement] = STATE(177),
    [sym_switch_statement] = STATE(177),
    [sym_case_statement] = STATE(177),
    [sym_while_statement] = STATE(177),
    [sym_do_statement] = STATE(177),
    [sym_for_statement] = STATE(177),
    [sym_return_statement] = STATE(177),
    [sym_break_statement] = STATE(177),
    [sym_continue_statement] = STATE(177),
    [sym_goto_statement] = STATE(177),
    [sym_seh_try_statement] = STATE(177),
    [sym_seh_leave_statement] = STATE(177),
    [sym_expression] = STATE(1026),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1927),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(340),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(368),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(1098),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(1094),
    [anon_sym___leave] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [sym_attribute_declaration] = STATE(338),
    [sym_compound_statement] = STATE(171),
    [sym_attributed_statement] = STATE(171),
    [sym_statement] = STATE(241),
    [sym_labeled_statement] = STATE(171),
    [sym_expression_statement] = STATE(171),
    [sym_if_statement] = STATE(171),
    [sym_switch_statement] = STATE(171),
    [sym_case_statement] = STATE(171),
    [sym_while_statement] = STATE(171),
    [sym_do_statement] = STATE(171),
    [sym_for_statement] = STATE(171),
    [sym_return_statement] = STATE(171),
    [sym_break_statement] = STATE(171),
    [sym_continue_statement] = STATE(171),
    [sym_goto_statement] = STATE(171),
    [sym_seh_try_statement] = STATE(171),
    [sym_seh_leave_statement] = STATE(171),
    [sym_expression] = STATE(1042),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1791),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_attributed_declarator_repeat1] = STATE(338),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(65),
    [anon_sym_while] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(69),
    [anon_sym_for] = ACTIONS(71),
    [anon_sym_return] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_continue] = ACTIONS(77),
    [anon_sym_goto] = ACTIONS(79),
    [anon_sym___try] = ACTIONS(980),
    [anon_sym___leave] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [ts_builtin_sym_end] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1313),
    [aux_sym_preproc_include_token1] = ACTIONS(1313),
    [aux_sym_preproc_def_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_LPAREN2] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
    [anon_sym___extension__] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym___attribute__] = ACTIONS(1313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1315),
    [anon_sym___declspec] = ACTIONS(1313),
    [anon_sym___cdecl] = ACTIONS(1313),
    [anon_sym___clrcall] = ACTIONS(1313),
    [anon_sym___stdcall] = ACTIONS(1313),
    [anon_sym___fastcall] = ACTIONS(1313),
    [anon_sym___thiscall] = ACTIONS(1313),
    [anon_sym___vectorcall] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_signed] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_auto] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym___inline] = ACTIONS(1313),
    [anon_sym___inline__] = ACTIONS(1313),
    [anon_sym___forceinline] = ACTIONS(1313),
    [anon_sym_thread_local] = ACTIONS(1313),
    [anon_sym___thread] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym___restrict__] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym__Noreturn] = ACTIONS(1313),
    [anon_sym_noreturn] = ACTIONS(1313),
    [anon_sym__Nonnull] = ACTIONS(1313),
    [anon_sym_alignas] = ACTIONS(1313),
    [anon_sym__Alignas] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_sizeof] = ACTIONS(1313),
    [anon_sym___alignof__] = ACTIONS(1313),
    [anon_sym___alignof] = ACTIONS(1313),
    [anon_sym__alignof] = ACTIONS(1313),
    [anon_sym_alignof] = ACTIONS(1313),
    [anon_sym__Alignof] = ACTIONS(1313),
    [anon_sym_offsetof] = ACTIONS(1313),
    [anon_sym__Generic] = ACTIONS(1313),
    [anon_sym_asm] = ACTIONS(1313),
    [anon_sym___asm__] = ACTIONS(1313),
    [anon_sym___asm] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1315),
    [anon_sym_L_SQUOTE] = ACTIONS(1315),
    [anon_sym_u_SQUOTE] = ACTIONS(1315),
    [anon_sym_U_SQUOTE] = ACTIONS(1315),
    [anon_sym_u8_SQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [anon_sym_L_DQUOTE] = ACTIONS(1315),
    [anon_sym_u_DQUOTE] = ACTIONS(1315),
    [anon_sym_U_DQUOTE] = ACTIONS(1315),
    [anon_sym_u8_DQUOTE] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [anon_sym_NULL] = ACTIONS(1313),
    [anon_sym_nullptr] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [ts_builtin_sym_end] = ACTIONS(1311),
    [sym_identifier] = ACTIONS(1309),
    [aux_sym_preproc_include_token1] = ACTIONS(1309),
    [aux_sym_preproc_def_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1309),
    [sym_preproc_directive] = ACTIONS(1309),
    [anon_sym_LPAREN2] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym___extension__] = ACTIONS(1309),
    [anon_sym_typedef] = ACTIONS(1309),
    [anon_sym_extern] = ACTIONS(1309),
    [anon_sym___attribute__] = ACTIONS(1309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1311),
    [anon_sym___declspec] = ACTIONS(1309),
    [anon_sym___cdecl] = ACTIONS(1309),
    [anon_sym___clrcall] = ACTIONS(1309),
    [anon_sym___stdcall] = ACTIONS(1309),
    [anon_sym___fastcall] = ACTIONS(1309),
    [anon_sym___thiscall] = ACTIONS(1309),
    [anon_sym___vectorcall] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(1309),
    [anon_sym_unsigned] = ACTIONS(1309),
    [anon_sym_long] = ACTIONS(1309),
    [anon_sym_short] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_auto] = ACTIONS(1309),
    [anon_sym_register] = ACTIONS(1309),
    [anon_sym_inline] = ACTIONS(1309),
    [anon_sym___inline] = ACTIONS(1309),
    [anon_sym___inline__] = ACTIONS(1309),
    [anon_sym___forceinline] = ACTIONS(1309),
    [anon_sym_thread_local] = ACTIONS(1309),
    [anon_sym___thread] = ACTIONS(1309),
    [anon_sym_const] = ACTIONS(1309),
    [anon_sym_constexpr] = ACTIONS(1309),
    [anon_sym_volatile] = ACTIONS(1309),
    [anon_sym_restrict] = ACTIONS(1309),
    [anon_sym___restrict__] = ACTIONS(1309),
    [anon_sym__Atomic] = ACTIONS(1309),
    [anon_sym__Noreturn] = ACTIONS(1309),
    [anon_sym_noreturn] = ACTIONS(1309),
    [anon_sym__Nonnull] = ACTIONS(1309),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1309),
    [anon_sym_enum] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1309),
    [anon_sym_union] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1309),
    [anon_sym_default] = ACTIONS(1309),
    [anon_sym_while] = ACTIONS(1309),
    [anon_sym_do] = ACTIONS(1309),
    [anon_sym_for] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1309),
    [anon_sym_goto] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1309),
    [anon_sym___alignof__] = ACTIONS(1309),
    [anon_sym___alignof] = ACTIONS(1309),
    [anon_sym__alignof] = ACTIONS(1309),
    [anon_sym_alignof] = ACTIONS(1309),
    [anon_sym__Alignof] = ACTIONS(1309),
    [anon_sym_offsetof] = ACTIONS(1309),
    [anon_sym__Generic] = ACTIONS(1309),
    [anon_sym_asm] = ACTIONS(1309),
    [anon_sym___asm__] = ACTIONS(1309),
    [anon_sym___asm] = ACTIONS(1309),
    [sym_number_literal] = ACTIONS(1311),
    [anon_sym_L_SQUOTE] = ACTIONS(1311),
    [anon_sym_u_SQUOTE] = ACTIONS(1311),
    [anon_sym_U_SQUOTE] = ACTIONS(1311),
    [anon_sym_u8_SQUOTE] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_L_DQUOTE] = ACTIONS(1311),
    [anon_sym_u_DQUOTE] = ACTIONS(1311),
    [anon_sym_U_DQUOTE] = ACTIONS(1311),
    [anon_sym_u8_DQUOTE] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1311),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [anon_sym_NULL] = ACTIONS(1309),
    [anon_sym_nullptr] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [ts_builtin_sym_end] = ACTIONS(1339),
    [sym_identifier] = ACTIONS(1337),
    [aux_sym_preproc_include_token1] = ACTIONS(1337),
    [aux_sym_preproc_def_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1337),
    [sym_preproc_directive] = ACTIONS(1337),
    [anon_sym_LPAREN2] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym___extension__] = ACTIONS(1337),
    [anon_sym_typedef] = ACTIONS(1337),
    [anon_sym_extern] = ACTIONS(1337),
    [anon_sym___attribute__] = ACTIONS(1337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1339),
    [anon_sym___declspec] = ACTIONS(1337),
    [anon_sym___cdecl] = ACTIONS(1337),
    [anon_sym___clrcall] = ACTIONS(1337),
    [anon_sym___stdcall] = ACTIONS(1337),
    [anon_sym___fastcall] = ACTIONS(1337),
    [anon_sym___thiscall] = ACTIONS(1337),
    [anon_sym___vectorcall] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_signed] = ACTIONS(1337),
    [anon_sym_unsigned] = ACTIONS(1337),
    [anon_sym_long] = ACTIONS(1337),
    [anon_sym_short] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_auto] = ACTIONS(1337),
    [anon_sym_register] = ACTIONS(1337),
    [anon_sym_inline] = ACTIONS(1337),
    [anon_sym___inline] = ACTIONS(1337),
    [anon_sym___inline__] = ACTIONS(1337),
    [anon_sym___forceinline] = ACTIONS(1337),
    [anon_sym_thread_local] = ACTIONS(1337),
    [anon_sym___thread] = ACTIONS(1337),
    [anon_sym_const] = ACTIONS(1337),
    [anon_sym_constexpr] = ACTIONS(1337),
    [anon_sym_volatile] = ACTIONS(1337),
    [anon_sym_restrict] = ACTIONS(1337),
    [anon_sym___restrict__] = ACTIONS(1337),
    [anon_sym__Atomic] = ACTIONS(1337),
    [anon_sym__Noreturn] = ACTIONS(1337),
    [anon_sym_noreturn] = ACTIONS(1337),
    [anon_sym__Nonnull] = ACTIONS(1337),
    [anon_sym_alignas] = ACTIONS(1337),
    [anon_sym__Alignas] = ACTIONS(1337),
    [sym_primitive_type] = ACTIONS(1337),
    [anon_sym_enum] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1337),
    [anon_sym_union] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1337),
    [anon_sym_default] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_do] = ACTIONS(1337),
    [anon_sym_for] = ACTIONS(1337),
    [anon_sym_return] = ACTIONS(1337),
    [anon_sym_break] = ACTIONS(1337),
    [anon_sym_continue] = ACTIONS(1337),
    [anon_sym_goto] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym___alignof__] = ACTIONS(1337),
    [anon_sym___alignof] = ACTIONS(1337),
    [anon_sym__alignof] = ACTIONS(1337),
    [anon_sym_alignof] = ACTIONS(1337),
    [anon_sym__Alignof] = ACTIONS(1337),
    [anon_sym_offsetof] = ACTIONS(1337),
    [anon_sym__Generic] = ACTIONS(1337),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [anon_sym___asm] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1339),
    [anon_sym_L_SQUOTE] = ACTIONS(1339),
    [anon_sym_u_SQUOTE] = ACTIONS(1339),
    [anon_sym_U_SQUOTE] = ACTIONS(1339),
    [anon_sym_u8_SQUOTE] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1339),
    [anon_sym_L_DQUOTE] = ACTIONS(1339),
    [anon_sym_u_DQUOTE] = ACTIONS(1339),
    [anon_sym_U_DQUOTE] = ACTIONS(1339),
    [anon_sym_u8_DQUOTE] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_true] = ACTIONS(1337),
    [sym_false] = ACTIONS(1337),
    [anon_sym_NULL] = ACTIONS(1337),
    [anon_sym_nullptr] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [ts_builtin_sym_end] = ACTIONS(1369),
    [sym_identifier] = ACTIONS(1367),
    [aux_sym_preproc_include_token1] = ACTIONS(1367),
    [aux_sym_preproc_def_token1] = ACTIONS(1367),
    [aux_sym_preproc_if_token1] = ACTIONS(1367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1367),
    [sym_preproc_directive] = ACTIONS(1367),
    [anon_sym_LPAREN2] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1367),
    [anon_sym_STAR] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1369),
    [anon_sym___extension__] = ACTIONS(1367),
    [anon_sym_typedef] = ACTIONS(1367),
    [anon_sym_extern] = ACTIONS(1367),
    [anon_sym___attribute__] = ACTIONS(1367),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1369),
    [anon_sym___declspec] = ACTIONS(1367),
    [anon_sym___cdecl] = ACTIONS(1367),
    [anon_sym___clrcall] = ACTIONS(1367),
    [anon_sym___stdcall] = ACTIONS(1367),
    [anon_sym___fastcall] = ACTIONS(1367),
    [anon_sym___thiscall] = ACTIONS(1367),
    [anon_sym___vectorcall] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_signed] = ACTIONS(1367),
    [anon_sym_unsigned] = ACTIONS(1367),
    [anon_sym_long] = ACTIONS(1367),
    [anon_sym_short] = ACTIONS(1367),
    [anon_sym_static] = ACTIONS(1367),
    [anon_sym_auto] = ACTIONS(1367),
    [anon_sym_register] = ACTIONS(1367),
    [anon_sym_inline] = ACTIONS(1367),
    [anon_sym___inline] = ACTIONS(1367),
    [anon_sym___inline__] = ACTIONS(1367),
    [anon_sym___forceinline] = ACTIONS(1367),
    [anon_sym_thread_local] = ACTIONS(1367),
    [anon_sym___thread] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1367),
    [anon_sym_constexpr] = ACTIONS(1367),
    [anon_sym_volatile] = ACTIONS(1367),
    [anon_sym_restrict] = ACTIONS(1367),
    [anon_sym___restrict__] = ACTIONS(1367),
    [anon_sym__Atomic] = ACTIONS(1367),
    [anon_sym__Noreturn] = ACTIONS(1367),
    [anon_sym_noreturn] = ACTIONS(1367),
    [anon_sym__Nonnull] = ACTIONS(1367),
    [anon_sym_alignas] = ACTIONS(1367),
    [anon_sym__Alignas] = ACTIONS(1367),
    [sym_primitive_type] = ACTIONS(1367),
    [anon_sym_enum] = ACTIONS(1367),
    [anon_sym_struct] = ACTIONS(1367),
    [anon_sym_union] = ACTIONS(1367),
    [anon_sym_if] = ACTIONS(1367),
    [anon_sym_switch] = ACTIONS(1367),
    [anon_sym_case] = ACTIONS(1367),
    [anon_sym_default] = ACTIONS(1367),
    [anon_sym_while] = ACTIONS(1367),
    [anon_sym_do] = ACTIONS(1367),
    [anon_sym_for] = ACTIONS(1367),
    [anon_sym_return] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1367),
    [anon_sym_continue] = ACTIONS(1367),
    [anon_sym_goto] = ACTIONS(1367),
    [anon_sym_DASH_DASH] = ACTIONS(1369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_sizeof] = ACTIONS(1367),
    [anon_sym___alignof__] = ACTIONS(1367),
    [anon_sym___alignof] = ACTIONS(1367),
    [anon_sym__alignof] = ACTIONS(1367),
    [anon_sym_alignof] = ACTIONS(1367),
    [anon_sym__Alignof] = ACTIONS(1367),
    [anon_sym_offsetof] = ACTIONS(1367),
    [anon_sym__Generic] = ACTIONS(1367),
    [anon_sym_asm] = ACTIONS(1367),
    [anon_sym___asm__] = ACTIONS(1367),
    [anon_sym___asm] = ACTIONS(1367),
    [sym_number_literal] = ACTIONS(1369),
    [anon_sym_L_SQUOTE] = ACTIONS(1369),
    [anon_sym_u_SQUOTE] = ACTIONS(1369),
    [anon_sym_U_SQUOTE] = ACTIONS(1369),
    [anon_sym_u8_SQUOTE] = ACTIONS(1369),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_L_DQUOTE] = ACTIONS(1369),
    [anon_sym_u_DQUOTE] = ACTIONS(1369),
    [anon_sym_U_DQUOTE] = ACTIONS(1369),
    [anon_sym_u8_DQUOTE] = ACTIONS(1369),
    [anon_sym_DQUOTE] = ACTIONS(1369),
    [sym_true] = ACTIONS(1367),
    [sym_false] = ACTIONS(1367),
    [anon_sym_NULL] = ACTIONS(1367),
    [anon_sym_nullptr] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [ts_builtin_sym_end] = ACTIONS(1303),
    [sym_identifier] = ACTIONS(1301),
    [aux_sym_preproc_include_token1] = ACTIONS(1301),
    [aux_sym_preproc_def_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1301),
    [sym_preproc_directive] = ACTIONS(1301),
    [anon_sym_LPAREN2] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym___extension__] = ACTIONS(1301),
    [anon_sym_typedef] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(1301),
    [anon_sym___attribute__] = ACTIONS(1301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1303),
    [anon_sym___declspec] = ACTIONS(1301),
    [anon_sym___cdecl] = ACTIONS(1301),
    [anon_sym___clrcall] = ACTIONS(1301),
    [anon_sym___stdcall] = ACTIONS(1301),
    [anon_sym___fastcall] = ACTIONS(1301),
    [anon_sym___thiscall] = ACTIONS(1301),
    [anon_sym___vectorcall] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_auto] = ACTIONS(1301),
    [anon_sym_register] = ACTIONS(1301),
    [anon_sym_inline] = ACTIONS(1301),
    [anon_sym___inline] = ACTIONS(1301),
    [anon_sym___inline__] = ACTIONS(1301),
    [anon_sym___forceinline] = ACTIONS(1301),
    [anon_sym_thread_local] = ACTIONS(1301),
    [anon_sym___thread] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_constexpr] = ACTIONS(1301),
    [anon_sym_volatile] = ACTIONS(1301),
    [anon_sym_restrict] = ACTIONS(1301),
    [anon_sym___restrict__] = ACTIONS(1301),
    [anon_sym__Atomic] = ACTIONS(1301),
    [anon_sym__Noreturn] = ACTIONS(1301),
    [anon_sym_noreturn] = ACTIONS(1301),
    [anon_sym__Nonnull] = ACTIONS(1301),
    [anon_sym_alignas] = ACTIONS(1301),
    [anon_sym__Alignas] = ACTIONS(1301),
    [sym_primitive_type] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1301),
    [anon_sym_union] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_goto] = ACTIONS(1301),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1301),
    [anon_sym___alignof__] = ACTIONS(1301),
    [anon_sym___alignof] = ACTIONS(1301),
    [anon_sym__alignof] = ACTIONS(1301),
    [anon_sym_alignof] = ACTIONS(1301),
    [anon_sym__Alignof] = ACTIONS(1301),
    [anon_sym_offsetof] = ACTIONS(1301),
    [anon_sym__Generic] = ACTIONS(1301),
    [anon_sym_asm] = ACTIONS(1301),
    [anon_sym___asm__] = ACTIONS(1301),
    [anon_sym___asm] = ACTIONS(1301),
    [sym_number_literal] = ACTIONS(1303),
    [anon_sym_L_SQUOTE] = ACTIONS(1303),
    [anon_sym_u_SQUOTE] = ACTIONS(1303),
    [anon_sym_U_SQUOTE] = ACTIONS(1303),
    [anon_sym_u8_SQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1303),
    [anon_sym_L_DQUOTE] = ACTIONS(1303),
    [anon_sym_u_DQUOTE] = ACTIONS(1303),
    [anon_sym_U_DQUOTE] = ACTIONS(1303),
    [anon_sym_u8_DQUOTE] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [anon_sym_NULL] = ACTIONS(1301),
    [anon_sym_nullptr] = ACTIONS(1301),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(1347),
    [sym_identifier] = ACTIONS(1345),
    [aux_sym_preproc_include_token1] = ACTIONS(1345),
    [aux_sym_preproc_def_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1345),
    [sym_preproc_directive] = ACTIONS(1345),
    [anon_sym_LPAREN2] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym___extension__] = ACTIONS(1345),
    [anon_sym_typedef] = ACTIONS(1345),
    [anon_sym_extern] = ACTIONS(1345),
    [anon_sym___attribute__] = ACTIONS(1345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1347),
    [anon_sym___declspec] = ACTIONS(1345),
    [anon_sym___cdecl] = ACTIONS(1345),
    [anon_sym___clrcall] = ACTIONS(1345),
    [anon_sym___stdcall] = ACTIONS(1345),
    [anon_sym___fastcall] = ACTIONS(1345),
    [anon_sym___thiscall] = ACTIONS(1345),
    [anon_sym___vectorcall] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_signed] = ACTIONS(1345),
    [anon_sym_unsigned] = ACTIONS(1345),
    [anon_sym_long] = ACTIONS(1345),
    [anon_sym_short] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_auto] = ACTIONS(1345),
    [anon_sym_register] = ACTIONS(1345),
    [anon_sym_inline] = ACTIONS(1345),
    [anon_sym___inline] = ACTIONS(1345),
    [anon_sym___inline__] = ACTIONS(1345),
    [anon_sym___forceinline] = ACTIONS(1345),
    [anon_sym_thread_local] = ACTIONS(1345),
    [anon_sym___thread] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_constexpr] = ACTIONS(1345),
    [anon_sym_volatile] = ACTIONS(1345),
    [anon_sym_restrict] = ACTIONS(1345),
    [anon_sym___restrict__] = ACTIONS(1345),
    [anon_sym__Atomic] = ACTIONS(1345),
    [anon_sym__Noreturn] = ACTIONS(1345),
    [anon_sym_noreturn] = ACTIONS(1345),
    [anon_sym__Nonnull] = ACTIONS(1345),
    [anon_sym_alignas] = ACTIONS(1345),
    [anon_sym__Alignas] = ACTIONS(1345),
    [sym_primitive_type] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1345),
    [anon_sym_union] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_goto] = ACTIONS(1345),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_sizeof] = ACTIONS(1345),
    [anon_sym___alignof__] = ACTIONS(1345),
    [anon_sym___alignof] = ACTIONS(1345),
    [anon_sym__alignof] = ACTIONS(1345),
    [anon_sym_alignof] = ACTIONS(1345),
    [anon_sym__Alignof] = ACTIONS(1345),
    [anon_sym_offsetof] = ACTIONS(1345),
    [anon_sym__Generic] = ACTIONS(1345),
    [anon_sym_asm] = ACTIONS(1345),
    [anon_sym___asm__] = ACTIONS(1345),
    [anon_sym___asm] = ACTIONS(1345),
    [sym_number_literal] = ACTIONS(1347),
    [anon_sym_L_SQUOTE] = ACTIONS(1347),
    [anon_sym_u_SQUOTE] = ACTIONS(1347),
    [anon_sym_U_SQUOTE] = ACTIONS(1347),
    [anon_sym_u8_SQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_L_DQUOTE] = ACTIONS(1347),
    [anon_sym_u_DQUOTE] = ACTIONS(1347),
    [anon_sym_U_DQUOTE] = ACTIONS(1347),
    [anon_sym_u8_DQUOTE] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [anon_sym_NULL] = ACTIONS(1345),
    [anon_sym_nullptr] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
  },
  [359] = {
    [ts_builtin_sym_end] = ACTIONS(1351),
    [sym_identifier] = ACTIONS(1349),
    [aux_sym_preproc_include_token1] = ACTIONS(1349),
    [aux_sym_preproc_def_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1349),
    [sym_preproc_directive] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym___extension__] = ACTIONS(1349),
    [anon_sym_typedef] = ACTIONS(1349),
    [anon_sym_extern] = ACTIONS(1349),
    [anon_sym___attribute__] = ACTIONS(1349),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1351),
    [anon_sym___declspec] = ACTIONS(1349),
    [anon_sym___cdecl] = ACTIONS(1349),
    [anon_sym___clrcall] = ACTIONS(1349),
    [anon_sym___stdcall] = ACTIONS(1349),
    [anon_sym___fastcall] = ACTIONS(1349),
    [anon_sym___thiscall] = ACTIONS(1349),
    [anon_sym___vectorcall] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_signed] = ACTIONS(1349),
    [anon_sym_unsigned] = ACTIONS(1349),
    [anon_sym_long] = ACTIONS(1349),
    [anon_sym_short] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_auto] = ACTIONS(1349),
    [anon_sym_register] = ACTIONS(1349),
    [anon_sym_inline] = ACTIONS(1349),
    [anon_sym___inline] = ACTIONS(1349),
    [anon_sym___inline__] = ACTIONS(1349),
    [anon_sym___forceinline] = ACTIONS(1349),
    [anon_sym_thread_local] = ACTIONS(1349),
    [anon_sym___thread] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_constexpr] = ACTIONS(1349),
    [anon_sym_volatile] = ACTIONS(1349),
    [anon_sym_restrict] = ACTIONS(1349),
    [anon_sym___restrict__] = ACTIONS(1349),
    [anon_sym__Atomic] = ACTIONS(1349),
    [anon_sym__Noreturn] = ACTIONS(1349),
    [anon_sym_noreturn] = ACTIONS(1349),
    [anon_sym__Nonnull] = ACTIONS(1349),
    [anon_sym_alignas] = ACTIONS(1349),
    [anon_sym__Alignas] = ACTIONS(1349),
    [sym_primitive_type] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1349),
    [anon_sym_union] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_goto] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_sizeof] = ACTIONS(1349),
    [anon_sym___alignof__] = ACTIONS(1349),
    [anon_sym___alignof] = ACTIONS(1349),
    [anon_sym__alignof] = ACTIONS(1349),
    [anon_sym_alignof] = ACTIONS(1349),
    [anon_sym__Alignof] = ACTIONS(1349),
    [anon_sym_offsetof] = ACTIONS(1349),
    [anon_sym__Generic] = ACTIONS(1349),
    [anon_sym_asm] = ACTIONS(1349),
    [anon_sym___asm__] = ACTIONS(1349),
    [anon_sym___asm] = ACTIONS(1349),
    [sym_number_literal] = ACTIONS(1351),
    [anon_sym_L_SQUOTE] = ACTIONS(1351),
    [anon_sym_u_SQUOTE] = ACTIONS(1351),
    [anon_sym_U_SQUOTE] = ACTIONS(1351),
    [anon_sym_u8_SQUOTE] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1351),
    [anon_sym_L_DQUOTE] = ACTIONS(1351),
    [anon_sym_u_DQUOTE] = ACTIONS(1351),
    [anon_sym_U_DQUOTE] = ACTIONS(1351),
    [anon_sym_u8_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [anon_sym_NULL] = ACTIONS(1349),
    [anon_sym_nullptr] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [ts_builtin_sym_end] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1285),
    [aux_sym_preproc_include_token1] = ACTIONS(1285),
    [aux_sym_preproc_def_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1285),
    [sym_preproc_directive] = ACTIONS(1285),
    [anon_sym_LPAREN2] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym___extension__] = ACTIONS(1285),
    [anon_sym_typedef] = ACTIONS(1285),
    [anon_sym_extern] = ACTIONS(1285),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1287),
    [anon_sym___declspec] = ACTIONS(1285),
    [anon_sym___cdecl] = ACTIONS(1285),
    [anon_sym___clrcall] = ACTIONS(1285),
    [anon_sym___stdcall] = ACTIONS(1285),
    [anon_sym___fastcall] = ACTIONS(1285),
    [anon_sym___thiscall] = ACTIONS(1285),
    [anon_sym___vectorcall] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_signed] = ACTIONS(1285),
    [anon_sym_unsigned] = ACTIONS(1285),
    [anon_sym_long] = ACTIONS(1285),
    [anon_sym_short] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1285),
    [anon_sym_auto] = ACTIONS(1285),
    [anon_sym_register] = ACTIONS(1285),
    [anon_sym_inline] = ACTIONS(1285),
    [anon_sym___inline] = ACTIONS(1285),
    [anon_sym___inline__] = ACTIONS(1285),
    [anon_sym___forceinline] = ACTIONS(1285),
    [anon_sym_thread_local] = ACTIONS(1285),
    [anon_sym___thread] = ACTIONS(1285),
    [anon_sym_const] = ACTIONS(1285),
    [anon_sym_constexpr] = ACTIONS(1285),
    [anon_sym_volatile] = ACTIONS(1285),
    [anon_sym_restrict] = ACTIONS(1285),
    [anon_sym___restrict__] = ACTIONS(1285),
    [anon_sym__Atomic] = ACTIONS(1285),
    [anon_sym__Noreturn] = ACTIONS(1285),
    [anon_sym_noreturn] = ACTIONS(1285),
    [anon_sym__Nonnull] = ACTIONS(1285),
    [anon_sym_alignas] = ACTIONS(1285),
    [anon_sym__Alignas] = ACTIONS(1285),
    [sym_primitive_type] = ACTIONS(1285),
    [anon_sym_enum] = ACTIONS(1285),
    [anon_sym_struct] = ACTIONS(1285),
    [anon_sym_union] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1285),
    [anon_sym_switch] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1285),
    [anon_sym_default] = ACTIONS(1285),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1285),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_return] = ACTIONS(1285),
    [anon_sym_break] = ACTIONS(1285),
    [anon_sym_continue] = ACTIONS(1285),
    [anon_sym_goto] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1287),
    [anon_sym_sizeof] = ACTIONS(1285),
    [anon_sym___alignof__] = ACTIONS(1285),
    [anon_sym___alignof] = ACTIONS(1285),
    [anon_sym__alignof] = ACTIONS(1285),
    [anon_sym_alignof] = ACTIONS(1285),
    [anon_sym__Alignof] = ACTIONS(1285),
    [anon_sym_offsetof] = ACTIONS(1285),
    [anon_sym__Generic] = ACTIONS(1285),
    [anon_sym_asm] = ACTIONS(1285),
    [anon_sym___asm__] = ACTIONS(1285),
    [anon_sym___asm] = ACTIONS(1285),
    [sym_number_literal] = ACTIONS(1287),
    [anon_sym_L_SQUOTE] = ACTIONS(1287),
    [anon_sym_u_SQUOTE] = ACTIONS(1287),
    [anon_sym_U_SQUOTE] = ACTIONS(1287),
    [anon_sym_u8_SQUOTE] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_L_DQUOTE] = ACTIONS(1287),
    [anon_sym_u_DQUOTE] = ACTIONS(1287),
    [anon_sym_U_DQUOTE] = ACTIONS(1287),
    [anon_sym_u8_DQUOTE] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [anon_sym_NULL] = ACTIONS(1285),
    [anon_sym_nullptr] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [ts_builtin_sym_end] = ACTIONS(1355),
    [sym_identifier] = ACTIONS(1353),
    [aux_sym_preproc_include_token1] = ACTIONS(1353),
    [aux_sym_preproc_def_token1] = ACTIONS(1353),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1353),
    [sym_preproc_directive] = ACTIONS(1353),
    [anon_sym_LPAREN2] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_AMP] = ACTIONS(1355),
    [anon_sym___extension__] = ACTIONS(1353),
    [anon_sym_typedef] = ACTIONS(1353),
    [anon_sym_extern] = ACTIONS(1353),
    [anon_sym___attribute__] = ACTIONS(1353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1355),
    [anon_sym___declspec] = ACTIONS(1353),
    [anon_sym___cdecl] = ACTIONS(1353),
    [anon_sym___clrcall] = ACTIONS(1353),
    [anon_sym___stdcall] = ACTIONS(1353),
    [anon_sym___fastcall] = ACTIONS(1353),
    [anon_sym___thiscall] = ACTIONS(1353),
    [anon_sym___vectorcall] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1355),
    [anon_sym_signed] = ACTIONS(1353),
    [anon_sym_unsigned] = ACTIONS(1353),
    [anon_sym_long] = ACTIONS(1353),
    [anon_sym_short] = ACTIONS(1353),
    [anon_sym_static] = ACTIONS(1353),
    [anon_sym_auto] = ACTIONS(1353),
    [anon_sym_register] = ACTIONS(1353),
    [anon_sym_inline] = ACTIONS(1353),
    [anon_sym___inline] = ACTIONS(1353),
    [anon_sym___inline__] = ACTIONS(1353),
    [anon_sym___forceinline] = ACTIONS(1353),
    [anon_sym_thread_local] = ACTIONS(1353),
    [anon_sym___thread] = ACTIONS(1353),
    [anon_sym_const] = ACTIONS(1353),
    [anon_sym_constexpr] = ACTIONS(1353),
    [anon_sym_volatile] = ACTIONS(1353),
    [anon_sym_restrict] = ACTIONS(1353),
    [anon_sym___restrict__] = ACTIONS(1353),
    [anon_sym__Atomic] = ACTIONS(1353),
    [anon_sym__Noreturn] = ACTIONS(1353),
    [anon_sym_noreturn] = ACTIONS(1353),
    [anon_sym__Nonnull] = ACTIONS(1353),
    [anon_sym_alignas] = ACTIONS(1353),
    [anon_sym__Alignas] = ACTIONS(1353),
    [sym_primitive_type] = ACTIONS(1353),
    [anon_sym_enum] = ACTIONS(1353),
    [anon_sym_struct] = ACTIONS(1353),
    [anon_sym_union] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(1353),
    [anon_sym_switch] = ACTIONS(1353),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_default] = ACTIONS(1353),
    [anon_sym_while] = ACTIONS(1353),
    [anon_sym_do] = ACTIONS(1353),
    [anon_sym_for] = ACTIONS(1353),
    [anon_sym_return] = ACTIONS(1353),
    [anon_sym_break] = ACTIONS(1353),
    [anon_sym_continue] = ACTIONS(1353),
    [anon_sym_goto] = ACTIONS(1353),
    [anon_sym_DASH_DASH] = ACTIONS(1355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1355),
    [anon_sym_sizeof] = ACTIONS(1353),
    [anon_sym___alignof__] = ACTIONS(1353),
    [anon_sym___alignof] = ACTIONS(1353),
    [anon_sym__alignof] = ACTIONS(1353),
    [anon_sym_alignof] = ACTIONS(1353),
    [anon_sym__Alignof] = ACTIONS(1353),
    [anon_sym_offsetof] = ACTIONS(1353),
    [anon_sym__Generic] = ACTIONS(1353),
    [anon_sym_asm] = ACTIONS(1353),
    [anon_sym___asm__] = ACTIONS(1353),
    [anon_sym___asm] = ACTIONS(1353),
    [sym_number_literal] = ACTIONS(1355),
    [anon_sym_L_SQUOTE] = ACTIONS(1355),
    [anon_sym_u_SQUOTE] = ACTIONS(1355),
    [anon_sym_U_SQUOTE] = ACTIONS(1355),
    [anon_sym_u8_SQUOTE] = ACTIONS(1355),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_L_DQUOTE] = ACTIONS(1355),
    [anon_sym_u_DQUOTE] = ACTIONS(1355),
    [anon_sym_U_DQUOTE] = ACTIONS(1355),
    [anon_sym_u8_DQUOTE] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1355),
    [sym_true] = ACTIONS(1353),
    [sym_false] = ACTIONS(1353),
    [anon_sym_NULL] = ACTIONS(1353),
    [anon_sym_nullptr] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [ts_builtin_sym_end] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1321),
    [aux_sym_preproc_include_token1] = ACTIONS(1321),
    [aux_sym_preproc_def_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1321),
    [sym_preproc_directive] = ACTIONS(1321),
    [anon_sym_LPAREN2] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym___extension__] = ACTIONS(1321),
    [anon_sym_typedef] = ACTIONS(1321),
    [anon_sym_extern] = ACTIONS(1321),
    [anon_sym___attribute__] = ACTIONS(1321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1323),
    [anon_sym___declspec] = ACTIONS(1321),
    [anon_sym___cdecl] = ACTIONS(1321),
    [anon_sym___clrcall] = ACTIONS(1321),
    [anon_sym___stdcall] = ACTIONS(1321),
    [anon_sym___fastcall] = ACTIONS(1321),
    [anon_sym___thiscall] = ACTIONS(1321),
    [anon_sym___vectorcall] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_signed] = ACTIONS(1321),
    [anon_sym_unsigned] = ACTIONS(1321),
    [anon_sym_long] = ACTIONS(1321),
    [anon_sym_short] = ACTIONS(1321),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_auto] = ACTIONS(1321),
    [anon_sym_register] = ACTIONS(1321),
    [anon_sym_inline] = ACTIONS(1321),
    [anon_sym___inline] = ACTIONS(1321),
    [anon_sym___inline__] = ACTIONS(1321),
    [anon_sym___forceinline] = ACTIONS(1321),
    [anon_sym_thread_local] = ACTIONS(1321),
    [anon_sym___thread] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_constexpr] = ACTIONS(1321),
    [anon_sym_volatile] = ACTIONS(1321),
    [anon_sym_restrict] = ACTIONS(1321),
    [anon_sym___restrict__] = ACTIONS(1321),
    [anon_sym__Atomic] = ACTIONS(1321),
    [anon_sym__Noreturn] = ACTIONS(1321),
    [anon_sym_noreturn] = ACTIONS(1321),
    [anon_sym__Nonnull] = ACTIONS(1321),
    [anon_sym_alignas] = ACTIONS(1321),
    [anon_sym__Alignas] = ACTIONS(1321),
    [sym_primitive_type] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_goto] = ACTIONS(1321),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_sizeof] = ACTIONS(1321),
    [anon_sym___alignof__] = ACTIONS(1321),
    [anon_sym___alignof] = ACTIONS(1321),
    [anon_sym__alignof] = ACTIONS(1321),
    [anon_sym_alignof] = ACTIONS(1321),
    [anon_sym__Alignof] = ACTIONS(1321),
    [anon_sym_offsetof] = ACTIONS(1321),
    [anon_sym__Generic] = ACTIONS(1321),
    [anon_sym_asm] = ACTIONS(1321),
    [anon_sym___asm__] = ACTIONS(1321),
    [anon_sym___asm] = ACTIONS(1321),
    [sym_number_literal] = ACTIONS(1323),
    [anon_sym_L_SQUOTE] = ACTIONS(1323),
    [anon_sym_u_SQUOTE] = ACTIONS(1323),
    [anon_sym_U_SQUOTE] = ACTIONS(1323),
    [anon_sym_u8_SQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [anon_sym_L_DQUOTE] = ACTIONS(1323),
    [anon_sym_u_DQUOTE] = ACTIONS(1323),
    [anon_sym_U_DQUOTE] = ACTIONS(1323),
    [anon_sym_u8_DQUOTE] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [anon_sym_NULL] = ACTIONS(1321),
    [anon_sym_nullptr] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [ts_builtin_sym_end] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1685),
    [aux_sym_preproc_include_token1] = ACTIONS(1685),
    [aux_sym_preproc_def_token1] = ACTIONS(1685),
    [aux_sym_preproc_if_token1] = ACTIONS(1685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1685),
    [sym_preproc_directive] = ACTIONS(1685),
    [anon_sym_LPAREN2] = ACTIONS(1683),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym___extension__] = ACTIONS(1685),
    [anon_sym_typedef] = ACTIONS(1685),
    [anon_sym_extern] = ACTIONS(1685),
    [anon_sym___attribute__] = ACTIONS(1685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1683),
    [anon_sym___declspec] = ACTIONS(1685),
    [anon_sym___cdecl] = ACTIONS(1685),
    [anon_sym___clrcall] = ACTIONS(1685),
    [anon_sym___stdcall] = ACTIONS(1685),
    [anon_sym___fastcall] = ACTIONS(1685),
    [anon_sym___thiscall] = ACTIONS(1685),
    [anon_sym___vectorcall] = ACTIONS(1685),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_signed] = ACTIONS(1685),
    [anon_sym_unsigned] = ACTIONS(1685),
    [anon_sym_long] = ACTIONS(1685),
    [anon_sym_short] = ACTIONS(1685),
    [anon_sym_static] = ACTIONS(1685),
    [anon_sym_auto] = ACTIONS(1685),
    [anon_sym_register] = ACTIONS(1685),
    [anon_sym_inline] = ACTIONS(1685),
    [anon_sym___inline] = ACTIONS(1685),
    [anon_sym___inline__] = ACTIONS(1685),
    [anon_sym___forceinline] = ACTIONS(1685),
    [anon_sym_thread_local] = ACTIONS(1685),
    [anon_sym___thread] = ACTIONS(1685),
    [anon_sym_const] = ACTIONS(1685),
    [anon_sym_constexpr] = ACTIONS(1685),
    [anon_sym_volatile] = ACTIONS(1685),
    [anon_sym_restrict] = ACTIONS(1685),
    [anon_sym___restrict__] = ACTIONS(1685),
    [anon_sym__Atomic] = ACTIONS(1685),
    [anon_sym__Noreturn] = ACTIONS(1685),
    [anon_sym_noreturn] = ACTIONS(1685),
    [anon_sym__Nonnull] = ACTIONS(1685),
    [anon_sym_alignas] = ACTIONS(1685),
    [anon_sym__Alignas] = ACTIONS(1685),
    [sym_primitive_type] = ACTIONS(1685),
    [anon_sym_enum] = ACTIONS(1685),
    [anon_sym_struct] = ACTIONS(1685),
    [anon_sym_union] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1685),
    [anon_sym_switch] = ACTIONS(1685),
    [anon_sym_case] = ACTIONS(1685),
    [anon_sym_default] = ACTIONS(1685),
    [anon_sym_while] = ACTIONS(1685),
    [anon_sym_do] = ACTIONS(1685),
    [anon_sym_for] = ACTIONS(1685),
    [anon_sym_return] = ACTIONS(1685),
    [anon_sym_break] = ACTIONS(1685),
    [anon_sym_continue] = ACTIONS(1685),
    [anon_sym_goto] = ACTIONS(1685),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_sizeof] = ACTIONS(1685),
    [anon_sym___alignof__] = ACTIONS(1685),
    [anon_sym___alignof] = ACTIONS(1685),
    [anon_sym__alignof] = ACTIONS(1685),
    [anon_sym_alignof] = ACTIONS(1685),
    [anon_sym__Alignof] = ACTIONS(1685),
    [anon_sym_offsetof] = ACTIONS(1685),
    [anon_sym__Generic] = ACTIONS(1685),
    [anon_sym_asm] = ACTIONS(1685),
    [anon_sym___asm__] = ACTIONS(1685),
    [anon_sym___asm] = ACTIONS(1685),
    [sym_number_literal] = ACTIONS(1683),
    [anon_sym_L_SQUOTE] = ACTIONS(1683),
    [anon_sym_u_SQUOTE] = ACTIONS(1683),
    [anon_sym_U_SQUOTE] = ACTIONS(1683),
    [anon_sym_u8_SQUOTE] = ACTIONS(1683),
    [anon_sym_SQUOTE] = ACTIONS(1683),
    [anon_sym_L_DQUOTE] = ACTIONS(1683),
    [anon_sym_u_DQUOTE] = ACTIONS(1683),
    [anon_sym_U_DQUOTE] = ACTIONS(1683),
    [anon_sym_u8_DQUOTE] = ACTIONS(1683),
    [anon_sym_DQUOTE] = ACTIONS(1683),
    [sym_true] = ACTIONS(1685),
    [sym_false] = ACTIONS(1685),
    [anon_sym_NULL] = ACTIONS(1685),
    [anon_sym_nullptr] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [ts_builtin_sym_end] = ACTIONS(1331),
    [sym_identifier] = ACTIONS(1329),
    [aux_sym_preproc_include_token1] = ACTIONS(1329),
    [aux_sym_preproc_def_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1329),
    [sym_preproc_directive] = ACTIONS(1329),
    [anon_sym_LPAREN2] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym___extension__] = ACTIONS(1329),
    [anon_sym_typedef] = ACTIONS(1329),
    [anon_sym_extern] = ACTIONS(1329),
    [anon_sym___attribute__] = ACTIONS(1329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1331),
    [anon_sym___declspec] = ACTIONS(1329),
    [anon_sym___cdecl] = ACTIONS(1329),
    [anon_sym___clrcall] = ACTIONS(1329),
    [anon_sym___stdcall] = ACTIONS(1329),
    [anon_sym___fastcall] = ACTIONS(1329),
    [anon_sym___thiscall] = ACTIONS(1329),
    [anon_sym___vectorcall] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1331),
    [anon_sym_signed] = ACTIONS(1329),
    [anon_sym_unsigned] = ACTIONS(1329),
    [anon_sym_long] = ACTIONS(1329),
    [anon_sym_short] = ACTIONS(1329),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_auto] = ACTIONS(1329),
    [anon_sym_register] = ACTIONS(1329),
    [anon_sym_inline] = ACTIONS(1329),
    [anon_sym___inline] = ACTIONS(1329),
    [anon_sym___inline__] = ACTIONS(1329),
    [anon_sym___forceinline] = ACTIONS(1329),
    [anon_sym_thread_local] = ACTIONS(1329),
    [anon_sym___thread] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_constexpr] = ACTIONS(1329),
    [anon_sym_volatile] = ACTIONS(1329),
    [anon_sym_restrict] = ACTIONS(1329),
    [anon_sym___restrict__] = ACTIONS(1329),
    [anon_sym__Atomic] = ACTIONS(1329),
    [anon_sym__Noreturn] = ACTIONS(1329),
    [anon_sym_noreturn] = ACTIONS(1329),
    [anon_sym__Nonnull] = ACTIONS(1329),
    [anon_sym_alignas] = ACTIONS(1329),
    [anon_sym__Alignas] = ACTIONS(1329),
    [sym_primitive_type] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1329),
    [anon_sym_union] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_goto] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_sizeof] = ACTIONS(1329),
    [anon_sym___alignof__] = ACTIONS(1329),
    [anon_sym___alignof] = ACTIONS(1329),
    [anon_sym__alignof] = ACTIONS(1329),
    [anon_sym_alignof] = ACTIONS(1329),
    [anon_sym__Alignof] = ACTIONS(1329),
    [anon_sym_offsetof] = ACTIONS(1329),
    [anon_sym__Generic] = ACTIONS(1329),
    [anon_sym_asm] = ACTIONS(1329),
    [anon_sym___asm__] = ACTIONS(1329),
    [anon_sym___asm] = ACTIONS(1329),
    [sym_number_literal] = ACTIONS(1331),
    [anon_sym_L_SQUOTE] = ACTIONS(1331),
    [anon_sym_u_SQUOTE] = ACTIONS(1331),
    [anon_sym_U_SQUOTE] = ACTIONS(1331),
    [anon_sym_u8_SQUOTE] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1331),
    [anon_sym_L_DQUOTE] = ACTIONS(1331),
    [anon_sym_u_DQUOTE] = ACTIONS(1331),
    [anon_sym_U_DQUOTE] = ACTIONS(1331),
    [anon_sym_u8_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [anon_sym_NULL] = ACTIONS(1329),
    [anon_sym_nullptr] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [ts_builtin_sym_end] = ACTIONS(1373),
    [sym_identifier] = ACTIONS(1371),
    [aux_sym_preproc_include_token1] = ACTIONS(1371),
    [aux_sym_preproc_def_token1] = ACTIONS(1371),
    [aux_sym_preproc_if_token1] = ACTIONS(1371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1371),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1371),
    [sym_preproc_directive] = ACTIONS(1371),
    [anon_sym_LPAREN2] = ACTIONS(1373),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym___extension__] = ACTIONS(1371),
    [anon_sym_typedef] = ACTIONS(1371),
    [anon_sym_extern] = ACTIONS(1371),
    [anon_sym___attribute__] = ACTIONS(1371),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1373),
    [anon_sym___declspec] = ACTIONS(1371),
    [anon_sym___cdecl] = ACTIONS(1371),
    [anon_sym___clrcall] = ACTIONS(1371),
    [anon_sym___stdcall] = ACTIONS(1371),
    [anon_sym___fastcall] = ACTIONS(1371),
    [anon_sym___thiscall] = ACTIONS(1371),
    [anon_sym___vectorcall] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(1373),
    [anon_sym_signed] = ACTIONS(1371),
    [anon_sym_unsigned] = ACTIONS(1371),
    [anon_sym_long] = ACTIONS(1371),
    [anon_sym_short] = ACTIONS(1371),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_auto] = ACTIONS(1371),
    [anon_sym_register] = ACTIONS(1371),
    [anon_sym_inline] = ACTIONS(1371),
    [anon_sym___inline] = ACTIONS(1371),
    [anon_sym___inline__] = ACTIONS(1371),
    [anon_sym___forceinline] = ACTIONS(1371),
    [anon_sym_thread_local] = ACTIONS(1371),
    [anon_sym___thread] = ACTIONS(1371),
    [anon_sym_const] = ACTIONS(1371),
    [anon_sym_constexpr] = ACTIONS(1371),
    [anon_sym_volatile] = ACTIONS(1371),
    [anon_sym_restrict] = ACTIONS(1371),
    [anon_sym___restrict__] = ACTIONS(1371),
    [anon_sym__Atomic] = ACTIONS(1371),
    [anon_sym__Noreturn] = ACTIONS(1371),
    [anon_sym_noreturn] = ACTIONS(1371),
    [anon_sym__Nonnull] = ACTIONS(1371),
    [anon_sym_alignas] = ACTIONS(1371),
    [anon_sym__Alignas] = ACTIONS(1371),
    [sym_primitive_type] = ACTIONS(1371),
    [anon_sym_enum] = ACTIONS(1371),
    [anon_sym_struct] = ACTIONS(1371),
    [anon_sym_union] = ACTIONS(1371),
    [anon_sym_if] = ACTIONS(1371),
    [anon_sym_switch] = ACTIONS(1371),
    [anon_sym_case] = ACTIONS(1371),
    [anon_sym_default] = ACTIONS(1371),
    [anon_sym_while] = ACTIONS(1371),
    [anon_sym_do] = ACTIONS(1371),
    [anon_sym_for] = ACTIONS(1371),
    [anon_sym_return] = ACTIONS(1371),
    [anon_sym_break] = ACTIONS(1371),
    [anon_sym_continue] = ACTIONS(1371),
    [anon_sym_goto] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_sizeof] = ACTIONS(1371),
    [anon_sym___alignof__] = ACTIONS(1371),
    [anon_sym___alignof] = ACTIONS(1371),
    [anon_sym__alignof] = ACTIONS(1371),
    [anon_sym_alignof] = ACTIONS(1371),
    [anon_sym__Alignof] = ACTIONS(1371),
    [anon_sym_offsetof] = ACTIONS(1371),
    [anon_sym__Generic] = ACTIONS(1371),
    [anon_sym_asm] = ACTIONS(1371),
    [anon_sym___asm__] = ACTIONS(1371),
    [anon_sym___asm] = ACTIONS(1371),
    [sym_number_literal] = ACTIONS(1373),
    [anon_sym_L_SQUOTE] = ACTIONS(1373),
    [anon_sym_u_SQUOTE] = ACTIONS(1373),
    [anon_sym_U_SQUOTE] = ACTIONS(1373),
    [anon_sym_u8_SQUOTE] = ACTIONS(1373),
    [anon_sym_SQUOTE] = ACTIONS(1373),
    [anon_sym_L_DQUOTE] = ACTIONS(1373),
    [anon_sym_u_DQUOTE] = ACTIONS(1373),
    [anon_sym_U_DQUOTE] = ACTIONS(1373),
    [anon_sym_u8_DQUOTE] = ACTIONS(1373),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [sym_true] = ACTIONS(1371),
    [sym_false] = ACTIONS(1371),
    [anon_sym_NULL] = ACTIONS(1371),
    [anon_sym_nullptr] = ACTIONS(1371),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [ts_builtin_sym_end] = ACTIONS(1319),
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym__Nonnull] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [anon_sym___asm] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [ts_builtin_sym_end] = ACTIONS(1687),
    [sym_identifier] = ACTIONS(1690),
    [aux_sym_preproc_include_token1] = ACTIONS(1690),
    [aux_sym_preproc_def_token1] = ACTIONS(1690),
    [aux_sym_preproc_if_token1] = ACTIONS(1690),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1690),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1690),
    [sym_preproc_directive] = ACTIONS(1690),
    [anon_sym_LPAREN2] = ACTIONS(1687),
    [anon_sym_BANG] = ACTIONS(1687),
    [anon_sym_TILDE] = ACTIONS(1687),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_PLUS] = ACTIONS(1690),
    [anon_sym_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym___extension__] = ACTIONS(1690),
    [anon_sym_typedef] = ACTIONS(1690),
    [anon_sym_extern] = ACTIONS(1690),
    [anon_sym___attribute__] = ACTIONS(1690),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1687),
    [anon_sym___declspec] = ACTIONS(1690),
    [anon_sym___cdecl] = ACTIONS(1690),
    [anon_sym___clrcall] = ACTIONS(1690),
    [anon_sym___stdcall] = ACTIONS(1690),
    [anon_sym___fastcall] = ACTIONS(1690),
    [anon_sym___thiscall] = ACTIONS(1690),
    [anon_sym___vectorcall] = ACTIONS(1690),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_signed] = ACTIONS(1690),
    [anon_sym_unsigned] = ACTIONS(1690),
    [anon_sym_long] = ACTIONS(1690),
    [anon_sym_short] = ACTIONS(1690),
    [anon_sym_static] = ACTIONS(1690),
    [anon_sym_auto] = ACTIONS(1690),
    [anon_sym_register] = ACTIONS(1690),
    [anon_sym_inline] = ACTIONS(1690),
    [anon_sym___inline] = ACTIONS(1690),
    [anon_sym___inline__] = ACTIONS(1690),
    [anon_sym___forceinline] = ACTIONS(1690),
    [anon_sym_thread_local] = ACTIONS(1690),
    [anon_sym___thread] = ACTIONS(1690),
    [anon_sym_const] = ACTIONS(1690),
    [anon_sym_constexpr] = ACTIONS(1690),
    [anon_sym_volatile] = ACTIONS(1690),
    [anon_sym_restrict] = ACTIONS(1690),
    [anon_sym___restrict__] = ACTIONS(1690),
    [anon_sym__Atomic] = ACTIONS(1690),
    [anon_sym__Noreturn] = ACTIONS(1690),
    [anon_sym_noreturn] = ACTIONS(1690),
    [anon_sym__Nonnull] = ACTIONS(1690),
    [anon_sym_alignas] = ACTIONS(1690),
    [anon_sym__Alignas] = ACTIONS(1690),
    [sym_primitive_type] = ACTIONS(1690),
    [anon_sym_enum] = ACTIONS(1690),
    [anon_sym_struct] = ACTIONS(1690),
    [anon_sym_union] = ACTIONS(1690),
    [anon_sym_if] = ACTIONS(1690),
    [anon_sym_switch] = ACTIONS(1690),
    [anon_sym_case] = ACTIONS(1690),
    [anon_sym_default] = ACTIONS(1690),
    [anon_sym_while] = ACTIONS(1690),
    [anon_sym_do] = ACTIONS(1690),
    [anon_sym_for] = ACTIONS(1690),
    [anon_sym_return] = ACTIONS(1690),
    [anon_sym_break] = ACTIONS(1690),
    [anon_sym_continue] = ACTIONS(1690),
    [anon_sym_goto] = ACTIONS(1690),
    [anon_sym_DASH_DASH] = ACTIONS(1687),
    [anon_sym_PLUS_PLUS] = ACTIONS(1687),
    [anon_sym_sizeof] = ACTIONS(1690),
    [anon_sym___alignof__] = ACTIONS(1690),
    [anon_sym___alignof] = ACTIONS(1690),
    [anon_sym__alignof] = ACTIONS(1690),
    [anon_sym_alignof] = ACTIONS(1690),
    [anon_sym__Alignof] = ACTIONS(1690),
    [anon_sym_offsetof] = ACTIONS(1690),
    [anon_sym__Generic] = ACTIONS(1690),
    [anon_sym_asm] = ACTIONS(1690),
    [anon_sym___asm__] = ACTIONS(1690),
    [anon_sym___asm] = ACTIONS(1690),
    [sym_number_literal] = ACTIONS(1687),
    [anon_sym_L_SQUOTE] = ACTIONS(1687),
    [anon_sym_u_SQUOTE] = ACTIONS(1687),
    [anon_sym_U_SQUOTE] = ACTIONS(1687),
    [anon_sym_u8_SQUOTE] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1687),
    [anon_sym_L_DQUOTE] = ACTIONS(1687),
    [anon_sym_u_DQUOTE] = ACTIONS(1687),
    [anon_sym_U_DQUOTE] = ACTIONS(1687),
    [anon_sym_u8_DQUOTE] = ACTIONS(1687),
    [anon_sym_DQUOTE] = ACTIONS(1687),
    [sym_true] = ACTIONS(1690),
    [sym_false] = ACTIONS(1690),
    [anon_sym_NULL] = ACTIONS(1690),
    [anon_sym_nullptr] = ACTIONS(1690),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [ts_builtin_sym_end] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym__Nonnull] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [anon_sym___asm] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(1299),
    [sym_identifier] = ACTIONS(1297),
    [aux_sym_preproc_include_token1] = ACTIONS(1297),
    [aux_sym_preproc_def_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1297),
    [sym_preproc_directive] = ACTIONS(1297),
    [anon_sym_LPAREN2] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym___extension__] = ACTIONS(1297),
    [anon_sym_typedef] = ACTIONS(1297),
    [anon_sym_extern] = ACTIONS(1297),
    [anon_sym___attribute__] = ACTIONS(1297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1299),
    [anon_sym___declspec] = ACTIONS(1297),
    [anon_sym___cdecl] = ACTIONS(1297),
    [anon_sym___clrcall] = ACTIONS(1297),
    [anon_sym___stdcall] = ACTIONS(1297),
    [anon_sym___fastcall] = ACTIONS(1297),
    [anon_sym___thiscall] = ACTIONS(1297),
    [anon_sym___vectorcall] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(1297),
    [anon_sym_unsigned] = ACTIONS(1297),
    [anon_sym_long] = ACTIONS(1297),
    [anon_sym_short] = ACTIONS(1297),
    [anon_sym_static] = ACTIONS(1297),
    [anon_sym_auto] = ACTIONS(1297),
    [anon_sym_register] = ACTIONS(1297),
    [anon_sym_inline] = ACTIONS(1297),
    [anon_sym___inline] = ACTIONS(1297),
    [anon_sym___inline__] = ACTIONS(1297),
    [anon_sym___forceinline] = ACTIONS(1297),
    [anon_sym_thread_local] = ACTIONS(1297),
    [anon_sym___thread] = ACTIONS(1297),
    [anon_sym_const] = ACTIONS(1297),
    [anon_sym_constexpr] = ACTIONS(1297),
    [anon_sym_volatile] = ACTIONS(1297),
    [anon_sym_restrict] = ACTIONS(1297),
    [anon_sym___restrict__] = ACTIONS(1297),
    [anon_sym__Atomic] = ACTIONS(1297),
    [anon_sym__Noreturn] = ACTIONS(1297),
    [anon_sym_noreturn] = ACTIONS(1297),
    [anon_sym__Nonnull] = ACTIONS(1297),
    [anon_sym_alignas] = ACTIONS(1297),
    [anon_sym__Alignas] = ACTIONS(1297),
    [sym_primitive_type] = ACTIONS(1297),
    [anon_sym_enum] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1297),
    [anon_sym_union] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1297),
    [anon_sym_case] = ACTIONS(1297),
    [anon_sym_default] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_do] = ACTIONS(1297),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_return] = ACTIONS(1297),
    [anon_sym_break] = ACTIONS(1297),
    [anon_sym_continue] = ACTIONS(1297),
    [anon_sym_goto] = ACTIONS(1297),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_sizeof] = ACTIONS(1297),
    [anon_sym___alignof__] = ACTIONS(1297),
    [anon_sym___alignof] = ACTIONS(1297),
    [anon_sym__alignof] = ACTIONS(1297),
    [anon_sym_alignof] = ACTIONS(1297),
    [anon_sym__Alignof] = ACTIONS(1297),
    [anon_sym_offsetof] = ACTIONS(1297),
    [anon_sym__Generic] = ACTIONS(1297),
    [anon_sym_asm] = ACTIONS(1297),
    [anon_sym___asm__] = ACTIONS(1297),
    [anon_sym___asm] = ACTIONS(1297),
    [sym_number_literal] = ACTIONS(1299),
    [anon_sym_L_SQUOTE] = ACTIONS(1299),
    [anon_sym_u_SQUOTE] = ACTIONS(1299),
    [anon_sym_U_SQUOTE] = ACTIONS(1299),
    [anon_sym_u8_SQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [anon_sym_L_DQUOTE] = ACTIONS(1299),
    [anon_sym_u_DQUOTE] = ACTIONS(1299),
    [anon_sym_U_DQUOTE] = ACTIONS(1299),
    [anon_sym_u8_DQUOTE] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_true] = ACTIONS(1297),
    [sym_false] = ACTIONS(1297),
    [anon_sym_NULL] = ACTIONS(1297),
    [anon_sym_nullptr] = ACTIONS(1297),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [ts_builtin_sym_end] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym__Nonnull] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [anon_sym___asm] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [ts_builtin_sym_end] = ACTIONS(1279),
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym__Nonnull] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [anon_sym___asm] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [ts_builtin_sym_end] = ACTIONS(1283),
    [sym_identifier] = ACTIONS(1281),
    [aux_sym_preproc_include_token1] = ACTIONS(1281),
    [aux_sym_preproc_def_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1281),
    [sym_preproc_directive] = ACTIONS(1281),
    [anon_sym_LPAREN2] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym___extension__] = ACTIONS(1281),
    [anon_sym_typedef] = ACTIONS(1281),
    [anon_sym_extern] = ACTIONS(1281),
    [anon_sym___attribute__] = ACTIONS(1281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1283),
    [anon_sym___declspec] = ACTIONS(1281),
    [anon_sym___cdecl] = ACTIONS(1281),
    [anon_sym___clrcall] = ACTIONS(1281),
    [anon_sym___stdcall] = ACTIONS(1281),
    [anon_sym___fastcall] = ACTIONS(1281),
    [anon_sym___thiscall] = ACTIONS(1281),
    [anon_sym___vectorcall] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_signed] = ACTIONS(1281),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [anon_sym_static] = ACTIONS(1281),
    [anon_sym_auto] = ACTIONS(1281),
    [anon_sym_register] = ACTIONS(1281),
    [anon_sym_inline] = ACTIONS(1281),
    [anon_sym___inline] = ACTIONS(1281),
    [anon_sym___inline__] = ACTIONS(1281),
    [anon_sym___forceinline] = ACTIONS(1281),
    [anon_sym_thread_local] = ACTIONS(1281),
    [anon_sym___thread] = ACTIONS(1281),
    [anon_sym_const] = ACTIONS(1281),
    [anon_sym_constexpr] = ACTIONS(1281),
    [anon_sym_volatile] = ACTIONS(1281),
    [anon_sym_restrict] = ACTIONS(1281),
    [anon_sym___restrict__] = ACTIONS(1281),
    [anon_sym__Atomic] = ACTIONS(1281),
    [anon_sym__Noreturn] = ACTIONS(1281),
    [anon_sym_noreturn] = ACTIONS(1281),
    [anon_sym__Nonnull] = ACTIONS(1281),
    [anon_sym_alignas] = ACTIONS(1281),
    [anon_sym__Alignas] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1281),
    [anon_sym_enum] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1281),
    [anon_sym_union] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(1281),
    [anon_sym_default] = ACTIONS(1281),
    [anon_sym_while] = ACTIONS(1281),
    [anon_sym_do] = ACTIONS(1281),
    [anon_sym_for] = ACTIONS(1281),
    [anon_sym_return] = ACTIONS(1281),
    [anon_sym_break] = ACTIONS(1281),
    [anon_sym_continue] = ACTIONS(1281),
    [anon_sym_goto] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1283),
    [anon_sym_sizeof] = ACTIONS(1281),
    [anon_sym___alignof__] = ACTIONS(1281),
    [anon_sym___alignof] = ACTIONS(1281),
    [anon_sym__alignof] = ACTIONS(1281),
    [anon_sym_alignof] = ACTIONS(1281),
    [anon_sym__Alignof] = ACTIONS(1281),
    [anon_sym_offsetof] = ACTIONS(1281),
    [anon_sym__Generic] = ACTIONS(1281),
    [anon_sym_asm] = ACTIONS(1281),
    [anon_sym___asm__] = ACTIONS(1281),
    [anon_sym___asm] = ACTIONS(1281),
    [sym_number_literal] = ACTIONS(1283),
    [anon_sym_L_SQUOTE] = ACTIONS(1283),
    [anon_sym_u_SQUOTE] = ACTIONS(1283),
    [anon_sym_U_SQUOTE] = ACTIONS(1283),
    [anon_sym_u8_SQUOTE] = ACTIONS(1283),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_L_DQUOTE] = ACTIONS(1283),
    [anon_sym_u_DQUOTE] = ACTIONS(1283),
    [anon_sym_U_DQUOTE] = ACTIONS(1283),
    [anon_sym_u8_DQUOTE] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [anon_sym_NULL] = ACTIONS(1281),
    [anon_sym_nullptr] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [ts_builtin_sym_end] = ACTIONS(1343),
    [sym_identifier] = ACTIONS(1341),
    [aux_sym_preproc_include_token1] = ACTIONS(1341),
    [aux_sym_preproc_def_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1341),
    [sym_preproc_directive] = ACTIONS(1341),
    [anon_sym_LPAREN2] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym___extension__] = ACTIONS(1341),
    [anon_sym_typedef] = ACTIONS(1341),
    [anon_sym_extern] = ACTIONS(1341),
    [anon_sym___attribute__] = ACTIONS(1341),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1343),
    [anon_sym___declspec] = ACTIONS(1341),
    [anon_sym___cdecl] = ACTIONS(1341),
    [anon_sym___clrcall] = ACTIONS(1341),
    [anon_sym___stdcall] = ACTIONS(1341),
    [anon_sym___fastcall] = ACTIONS(1341),
    [anon_sym___thiscall] = ACTIONS(1341),
    [anon_sym___vectorcall] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_signed] = ACTIONS(1341),
    [anon_sym_unsigned] = ACTIONS(1341),
    [anon_sym_long] = ACTIONS(1341),
    [anon_sym_short] = ACTIONS(1341),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_auto] = ACTIONS(1341),
    [anon_sym_register] = ACTIONS(1341),
    [anon_sym_inline] = ACTIONS(1341),
    [anon_sym___inline] = ACTIONS(1341),
    [anon_sym___inline__] = ACTIONS(1341),
    [anon_sym___forceinline] = ACTIONS(1341),
    [anon_sym_thread_local] = ACTIONS(1341),
    [anon_sym___thread] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_constexpr] = ACTIONS(1341),
    [anon_sym_volatile] = ACTIONS(1341),
    [anon_sym_restrict] = ACTIONS(1341),
    [anon_sym___restrict__] = ACTIONS(1341),
    [anon_sym__Atomic] = ACTIONS(1341),
    [anon_sym__Noreturn] = ACTIONS(1341),
    [anon_sym_noreturn] = ACTIONS(1341),
    [anon_sym__Nonnull] = ACTIONS(1341),
    [anon_sym_alignas] = ACTIONS(1341),
    [anon_sym__Alignas] = ACTIONS(1341),
    [sym_primitive_type] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1341),
    [anon_sym_union] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_goto] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_sizeof] = ACTIONS(1341),
    [anon_sym___alignof__] = ACTIONS(1341),
    [anon_sym___alignof] = ACTIONS(1341),
    [anon_sym__alignof] = ACTIONS(1341),
    [anon_sym_alignof] = ACTIONS(1341),
    [anon_sym__Alignof] = ACTIONS(1341),
    [anon_sym_offsetof] = ACTIONS(1341),
    [anon_sym__Generic] = ACTIONS(1341),
    [anon_sym_asm] = ACTIONS(1341),
    [anon_sym___asm__] = ACTIONS(1341),
    [anon_sym___asm] = ACTIONS(1341),
    [sym_number_literal] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1343),
    [anon_sym_u_SQUOTE] = ACTIONS(1343),
    [anon_sym_U_SQUOTE] = ACTIONS(1343),
    [anon_sym_u8_SQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_L_DQUOTE] = ACTIONS(1343),
    [anon_sym_u_DQUOTE] = ACTIONS(1343),
    [anon_sym_U_DQUOTE] = ACTIONS(1343),
    [anon_sym_u8_DQUOTE] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [anon_sym_NULL] = ACTIONS(1341),
    [anon_sym_nullptr] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [ts_builtin_sym_end] = ACTIONS(1335),
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1333),
    [aux_sym_preproc_def_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1333),
    [sym_preproc_directive] = ACTIONS(1333),
    [anon_sym_LPAREN2] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
    [anon_sym___extension__] = ACTIONS(1333),
    [anon_sym_typedef] = ACTIONS(1333),
    [anon_sym_extern] = ACTIONS(1333),
    [anon_sym___attribute__] = ACTIONS(1333),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1335),
    [anon_sym___declspec] = ACTIONS(1333),
    [anon_sym___cdecl] = ACTIONS(1333),
    [anon_sym___clrcall] = ACTIONS(1333),
    [anon_sym___stdcall] = ACTIONS(1333),
    [anon_sym___fastcall] = ACTIONS(1333),
    [anon_sym___thiscall] = ACTIONS(1333),
    [anon_sym___vectorcall] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_signed] = ACTIONS(1333),
    [anon_sym_unsigned] = ACTIONS(1333),
    [anon_sym_long] = ACTIONS(1333),
    [anon_sym_short] = ACTIONS(1333),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_auto] = ACTIONS(1333),
    [anon_sym_register] = ACTIONS(1333),
    [anon_sym_inline] = ACTIONS(1333),
    [anon_sym___inline] = ACTIONS(1333),
    [anon_sym___inline__] = ACTIONS(1333),
    [anon_sym___forceinline] = ACTIONS(1333),
    [anon_sym_thread_local] = ACTIONS(1333),
    [anon_sym___thread] = ACTIONS(1333),
    [anon_sym_const] = ACTIONS(1333),
    [anon_sym_constexpr] = ACTIONS(1333),
    [anon_sym_volatile] = ACTIONS(1333),
    [anon_sym_restrict] = ACTIONS(1333),
    [anon_sym___restrict__] = ACTIONS(1333),
    [anon_sym__Atomic] = ACTIONS(1333),
    [anon_sym__Noreturn] = ACTIONS(1333),
    [anon_sym_noreturn] = ACTIONS(1333),
    [anon_sym__Nonnull] = ACTIONS(1333),
    [anon_sym_alignas] = ACTIONS(1333),
    [anon_sym__Alignas] = ACTIONS(1333),
    [sym_primitive_type] = ACTIONS(1333),
    [anon_sym_enum] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1333),
    [anon_sym_union] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1333),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_while] = ACTIONS(1333),
    [anon_sym_do] = ACTIONS(1333),
    [anon_sym_for] = ACTIONS(1333),
    [anon_sym_return] = ACTIONS(1333),
    [anon_sym_break] = ACTIONS(1333),
    [anon_sym_continue] = ACTIONS(1333),
    [anon_sym_goto] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1333),
    [anon_sym___alignof__] = ACTIONS(1333),
    [anon_sym___alignof] = ACTIONS(1333),
    [anon_sym__alignof] = ACTIONS(1333),
    [anon_sym_alignof] = ACTIONS(1333),
    [anon_sym__Alignof] = ACTIONS(1333),
    [anon_sym_offsetof] = ACTIONS(1333),
    [anon_sym__Generic] = ACTIONS(1333),
    [anon_sym_asm] = ACTIONS(1333),
    [anon_sym___asm__] = ACTIONS(1333),
    [anon_sym___asm] = ACTIONS(1333),
    [sym_number_literal] = ACTIONS(1335),
    [anon_sym_L_SQUOTE] = ACTIONS(1335),
    [anon_sym_u_SQUOTE] = ACTIONS(1335),
    [anon_sym_U_SQUOTE] = ACTIONS(1335),
    [anon_sym_u8_SQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [anon_sym_L_DQUOTE] = ACTIONS(1335),
    [anon_sym_u_DQUOTE] = ACTIONS(1335),
    [anon_sym_U_DQUOTE] = ACTIONS(1335),
    [anon_sym_u8_DQUOTE] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [anon_sym_NULL] = ACTIONS(1333),
    [anon_sym_nullptr] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [ts_builtin_sym_end] = ACTIONS(1291),
    [sym_identifier] = ACTIONS(1289),
    [aux_sym_preproc_include_token1] = ACTIONS(1289),
    [aux_sym_preproc_def_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1289),
    [sym_preproc_directive] = ACTIONS(1289),
    [anon_sym_LPAREN2] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym___extension__] = ACTIONS(1289),
    [anon_sym_typedef] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1289),
    [anon_sym___attribute__] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1289),
    [anon_sym___cdecl] = ACTIONS(1289),
    [anon_sym___clrcall] = ACTIONS(1289),
    [anon_sym___stdcall] = ACTIONS(1289),
    [anon_sym___fastcall] = ACTIONS(1289),
    [anon_sym___thiscall] = ACTIONS(1289),
    [anon_sym___vectorcall] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_signed] = ACTIONS(1289),
    [anon_sym_unsigned] = ACTIONS(1289),
    [anon_sym_long] = ACTIONS(1289),
    [anon_sym_short] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_auto] = ACTIONS(1289),
    [anon_sym_register] = ACTIONS(1289),
    [anon_sym_inline] = ACTIONS(1289),
    [anon_sym___inline] = ACTIONS(1289),
    [anon_sym___inline__] = ACTIONS(1289),
    [anon_sym___forceinline] = ACTIONS(1289),
    [anon_sym_thread_local] = ACTIONS(1289),
    [anon_sym___thread] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_constexpr] = ACTIONS(1289),
    [anon_sym_volatile] = ACTIONS(1289),
    [anon_sym_restrict] = ACTIONS(1289),
    [anon_sym___restrict__] = ACTIONS(1289),
    [anon_sym__Atomic] = ACTIONS(1289),
    [anon_sym__Noreturn] = ACTIONS(1289),
    [anon_sym_noreturn] = ACTIONS(1289),
    [anon_sym__Nonnull] = ACTIONS(1289),
    [anon_sym_alignas] = ACTIONS(1289),
    [anon_sym__Alignas] = ACTIONS(1289),
    [sym_primitive_type] = ACTIONS(1289),
    [anon_sym_enum] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1289),
    [anon_sym_union] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_default] = ACTIONS(1289),
    [anon_sym_while] = ACTIONS(1289),
    [anon_sym_do] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1289),
    [anon_sym_return] = ACTIONS(1289),
    [anon_sym_break] = ACTIONS(1289),
    [anon_sym_continue] = ACTIONS(1289),
    [anon_sym_goto] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1291),
    [anon_sym_sizeof] = ACTIONS(1289),
    [anon_sym___alignof__] = ACTIONS(1289),
    [anon_sym___alignof] = ACTIONS(1289),
    [anon_sym__alignof] = ACTIONS(1289),
    [anon_sym_alignof] = ACTIONS(1289),
    [anon_sym__Alignof] = ACTIONS(1289),
    [anon_sym_offsetof] = ACTIONS(1289),
    [anon_sym__Generic] = ACTIONS(1289),
    [anon_sym_asm] = ACTIONS(1289),
    [anon_sym___asm__] = ACTIONS(1289),
    [anon_sym___asm] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1291),
    [anon_sym_L_SQUOTE] = ACTIONS(1291),
    [anon_sym_u_SQUOTE] = ACTIONS(1291),
    [anon_sym_U_SQUOTE] = ACTIONS(1291),
    [anon_sym_u8_SQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1291),
    [anon_sym_L_DQUOTE] = ACTIONS(1291),
    [anon_sym_u_DQUOTE] = ACTIONS(1291),
    [anon_sym_U_DQUOTE] = ACTIONS(1291),
    [anon_sym_u8_DQUOTE] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [anon_sym_NULL] = ACTIONS(1289),
    [anon_sym_nullptr] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [ts_builtin_sym_end] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym__Nonnull] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [anon_sym___asm] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [ts_builtin_sym_end] = ACTIONS(1271),
    [sym_identifier] = ACTIONS(1269),
    [aux_sym_preproc_include_token1] = ACTIONS(1269),
    [aux_sym_preproc_def_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_LPAREN2] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym___extension__] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym___attribute__] = ACTIONS(1269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1271),
    [anon_sym___declspec] = ACTIONS(1269),
    [anon_sym___cdecl] = ACTIONS(1269),
    [anon_sym___clrcall] = ACTIONS(1269),
    [anon_sym___stdcall] = ACTIONS(1269),
    [anon_sym___fastcall] = ACTIONS(1269),
    [anon_sym___thiscall] = ACTIONS(1269),
    [anon_sym___vectorcall] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_signed] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_auto] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym___inline] = ACTIONS(1269),
    [anon_sym___inline__] = ACTIONS(1269),
    [anon_sym___forceinline] = ACTIONS(1269),
    [anon_sym_thread_local] = ACTIONS(1269),
    [anon_sym___thread] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym___restrict__] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym__Noreturn] = ACTIONS(1269),
    [anon_sym_noreturn] = ACTIONS(1269),
    [anon_sym__Nonnull] = ACTIONS(1269),
    [anon_sym_alignas] = ACTIONS(1269),
    [anon_sym__Alignas] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_goto] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_sizeof] = ACTIONS(1269),
    [anon_sym___alignof__] = ACTIONS(1269),
    [anon_sym___alignof] = ACTIONS(1269),
    [anon_sym__alignof] = ACTIONS(1269),
    [anon_sym_alignof] = ACTIONS(1269),
    [anon_sym__Alignof] = ACTIONS(1269),
    [anon_sym_offsetof] = ACTIONS(1269),
    [anon_sym__Generic] = ACTIONS(1269),
    [anon_sym_asm] = ACTIONS(1269),
    [anon_sym___asm__] = ACTIONS(1269),
    [anon_sym___asm] = ACTIONS(1269),
    [sym_number_literal] = ACTIONS(1271),
    [anon_sym_L_SQUOTE] = ACTIONS(1271),
    [anon_sym_u_SQUOTE] = ACTIONS(1271),
    [anon_sym_U_SQUOTE] = ACTIONS(1271),
    [anon_sym_u8_SQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [anon_sym_L_DQUOTE] = ACTIONS(1271),
    [anon_sym_u_DQUOTE] = ACTIONS(1271),
    [anon_sym_U_DQUOTE] = ACTIONS(1271),
    [anon_sym_u8_DQUOTE] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [anon_sym_NULL] = ACTIONS(1269),
    [anon_sym_nullptr] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [ts_builtin_sym_end] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1265),
    [aux_sym_preproc_include_token1] = ACTIONS(1265),
    [aux_sym_preproc_def_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1265),
    [sym_preproc_directive] = ACTIONS(1265),
    [anon_sym_LPAREN2] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym___extension__] = ACTIONS(1265),
    [anon_sym_typedef] = ACTIONS(1265),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym___attribute__] = ACTIONS(1265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1267),
    [anon_sym___declspec] = ACTIONS(1265),
    [anon_sym___cdecl] = ACTIONS(1265),
    [anon_sym___clrcall] = ACTIONS(1265),
    [anon_sym___stdcall] = ACTIONS(1265),
    [anon_sym___fastcall] = ACTIONS(1265),
    [anon_sym___thiscall] = ACTIONS(1265),
    [anon_sym___vectorcall] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_auto] = ACTIONS(1265),
    [anon_sym_register] = ACTIONS(1265),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym___inline] = ACTIONS(1265),
    [anon_sym___inline__] = ACTIONS(1265),
    [anon_sym___forceinline] = ACTIONS(1265),
    [anon_sym_thread_local] = ACTIONS(1265),
    [anon_sym___thread] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_constexpr] = ACTIONS(1265),
    [anon_sym_volatile] = ACTIONS(1265),
    [anon_sym_restrict] = ACTIONS(1265),
    [anon_sym___restrict__] = ACTIONS(1265),
    [anon_sym__Atomic] = ACTIONS(1265),
    [anon_sym__Noreturn] = ACTIONS(1265),
    [anon_sym_noreturn] = ACTIONS(1265),
    [anon_sym__Nonnull] = ACTIONS(1265),
    [anon_sym_alignas] = ACTIONS(1265),
    [anon_sym__Alignas] = ACTIONS(1265),
    [sym_primitive_type] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1265),
    [anon_sym_union] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_goto] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_sizeof] = ACTIONS(1265),
    [anon_sym___alignof__] = ACTIONS(1265),
    [anon_sym___alignof] = ACTIONS(1265),
    [anon_sym__alignof] = ACTIONS(1265),
    [anon_sym_alignof] = ACTIONS(1265),
    [anon_sym__Alignof] = ACTIONS(1265),
    [anon_sym_offsetof] = ACTIONS(1265),
    [anon_sym__Generic] = ACTIONS(1265),
    [anon_sym_asm] = ACTIONS(1265),
    [anon_sym___asm__] = ACTIONS(1265),
    [anon_sym___asm] = ACTIONS(1265),
    [sym_number_literal] = ACTIONS(1267),
    [anon_sym_L_SQUOTE] = ACTIONS(1267),
    [anon_sym_u_SQUOTE] = ACTIONS(1267),
    [anon_sym_U_SQUOTE] = ACTIONS(1267),
    [anon_sym_u8_SQUOTE] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [anon_sym_L_DQUOTE] = ACTIONS(1267),
    [anon_sym_u_DQUOTE] = ACTIONS(1267),
    [anon_sym_U_DQUOTE] = ACTIONS(1267),
    [anon_sym_u8_DQUOTE] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [anon_sym_NULL] = ACTIONS(1265),
    [anon_sym_nullptr] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [ts_builtin_sym_end] = ACTIONS(1359),
    [sym_identifier] = ACTIONS(1357),
    [aux_sym_preproc_include_token1] = ACTIONS(1357),
    [aux_sym_preproc_def_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_LPAREN2] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym___extension__] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym___attribute__] = ACTIONS(1357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1359),
    [anon_sym___declspec] = ACTIONS(1357),
    [anon_sym___cdecl] = ACTIONS(1357),
    [anon_sym___clrcall] = ACTIONS(1357),
    [anon_sym___stdcall] = ACTIONS(1357),
    [anon_sym___fastcall] = ACTIONS(1357),
    [anon_sym___thiscall] = ACTIONS(1357),
    [anon_sym___vectorcall] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_signed] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_auto] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym___inline] = ACTIONS(1357),
    [anon_sym___inline__] = ACTIONS(1357),
    [anon_sym___forceinline] = ACTIONS(1357),
    [anon_sym_thread_local] = ACTIONS(1357),
    [anon_sym___thread] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym___restrict__] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym__Noreturn] = ACTIONS(1357),
    [anon_sym_noreturn] = ACTIONS(1357),
    [anon_sym__Nonnull] = ACTIONS(1357),
    [anon_sym_alignas] = ACTIONS(1357),
    [anon_sym__Alignas] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1357),
    [anon_sym_default] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_return] = ACTIONS(1357),
    [anon_sym_break] = ACTIONS(1357),
    [anon_sym_continue] = ACTIONS(1357),
    [anon_sym_goto] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_sizeof] = ACTIONS(1357),
    [anon_sym___alignof__] = ACTIONS(1357),
    [anon_sym___alignof] = ACTIONS(1357),
    [anon_sym__alignof] = ACTIONS(1357),
    [anon_sym_alignof] = ACTIONS(1357),
    [anon_sym__Alignof] = ACTIONS(1357),
    [anon_sym_offsetof] = ACTIONS(1357),
    [anon_sym__Generic] = ACTIONS(1357),
    [anon_sym_asm] = ACTIONS(1357),
    [anon_sym___asm__] = ACTIONS(1357),
    [anon_sym___asm] = ACTIONS(1357),
    [sym_number_literal] = ACTIONS(1359),
    [anon_sym_L_SQUOTE] = ACTIONS(1359),
    [anon_sym_u_SQUOTE] = ACTIONS(1359),
    [anon_sym_U_SQUOTE] = ACTIONS(1359),
    [anon_sym_u8_SQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_L_DQUOTE] = ACTIONS(1359),
    [anon_sym_u_DQUOTE] = ACTIONS(1359),
    [anon_sym_U_DQUOTE] = ACTIONS(1359),
    [anon_sym_u8_DQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [anon_sym_NULL] = ACTIONS(1357),
    [anon_sym_nullptr] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
  },
  [380] = {
    [ts_builtin_sym_end] = ACTIONS(1693),
    [sym_identifier] = ACTIONS(1695),
    [aux_sym_preproc_include_token1] = ACTIONS(1695),
    [aux_sym_preproc_def_token1] = ACTIONS(1695),
    [aux_sym_preproc_if_token1] = ACTIONS(1695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1695),
    [sym_preproc_directive] = ACTIONS(1695),
    [anon_sym_LPAREN2] = ACTIONS(1693),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_TILDE] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1695),
    [anon_sym_PLUS] = ACTIONS(1695),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym___extension__] = ACTIONS(1695),
    [anon_sym_typedef] = ACTIONS(1695),
    [anon_sym_extern] = ACTIONS(1695),
    [anon_sym___attribute__] = ACTIONS(1695),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1693),
    [anon_sym___declspec] = ACTIONS(1695),
    [anon_sym___cdecl] = ACTIONS(1695),
    [anon_sym___clrcall] = ACTIONS(1695),
    [anon_sym___stdcall] = ACTIONS(1695),
    [anon_sym___fastcall] = ACTIONS(1695),
    [anon_sym___thiscall] = ACTIONS(1695),
    [anon_sym___vectorcall] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1693),
    [anon_sym_signed] = ACTIONS(1695),
    [anon_sym_unsigned] = ACTIONS(1695),
    [anon_sym_long] = ACTIONS(1695),
    [anon_sym_short] = ACTIONS(1695),
    [anon_sym_static] = ACTIONS(1695),
    [anon_sym_auto] = ACTIONS(1695),
    [anon_sym_register] = ACTIONS(1695),
    [anon_sym_inline] = ACTIONS(1695),
    [anon_sym___inline] = ACTIONS(1695),
    [anon_sym___inline__] = ACTIONS(1695),
    [anon_sym___forceinline] = ACTIONS(1695),
    [anon_sym_thread_local] = ACTIONS(1695),
    [anon_sym___thread] = ACTIONS(1695),
    [anon_sym_const] = ACTIONS(1695),
    [anon_sym_constexpr] = ACTIONS(1695),
    [anon_sym_volatile] = ACTIONS(1695),
    [anon_sym_restrict] = ACTIONS(1695),
    [anon_sym___restrict__] = ACTIONS(1695),
    [anon_sym__Atomic] = ACTIONS(1695),
    [anon_sym__Noreturn] = ACTIONS(1695),
    [anon_sym_noreturn] = ACTIONS(1695),
    [anon_sym__Nonnull] = ACTIONS(1695),
    [anon_sym_alignas] = ACTIONS(1695),
    [anon_sym__Alignas] = ACTIONS(1695),
    [sym_primitive_type] = ACTIONS(1695),
    [anon_sym_enum] = ACTIONS(1695),
    [anon_sym_struct] = ACTIONS(1695),
    [anon_sym_union] = ACTIONS(1695),
    [anon_sym_if] = ACTIONS(1695),
    [anon_sym_switch] = ACTIONS(1695),
    [anon_sym_case] = ACTIONS(1695),
    [anon_sym_default] = ACTIONS(1695),
    [anon_sym_while] = ACTIONS(1695),
    [anon_sym_do] = ACTIONS(1695),
    [anon_sym_for] = ACTIONS(1695),
    [anon_sym_return] = ACTIONS(1695),
    [anon_sym_break] = ACTIONS(1695),
    [anon_sym_continue] = ACTIONS(1695),
    [anon_sym_goto] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1693),
    [anon_sym_PLUS_PLUS] = ACTIONS(1693),
    [anon_sym_sizeof] = ACTIONS(1695),
    [anon_sym___alignof__] = ACTIONS(1695),
    [anon_sym___alignof] = ACTIONS(1695),
    [anon_sym__alignof] = ACTIONS(1695),
    [anon_sym_alignof] = ACTIONS(1695),
    [anon_sym__Alignof] = ACTIONS(1695),
    [anon_sym_offsetof] = ACTIONS(1695),
    [anon_sym__Generic] = ACTIONS(1695),
    [anon_sym_asm] = ACTIONS(1695),
    [anon_sym___asm__] = ACTIONS(1695),
    [anon_sym___asm] = ACTIONS(1695),
    [sym_number_literal] = ACTIONS(1693),
    [anon_sym_L_SQUOTE] = ACTIONS(1693),
    [anon_sym_u_SQUOTE] = ACTIONS(1693),
    [anon_sym_U_SQUOTE] = ACTIONS(1693),
    [anon_sym_u8_SQUOTE] = ACTIONS(1693),
    [anon_sym_SQUOTE] = ACTIONS(1693),
    [anon_sym_L_DQUOTE] = ACTIONS(1693),
    [anon_sym_u_DQUOTE] = ACTIONS(1693),
    [anon_sym_U_DQUOTE] = ACTIONS(1693),
    [anon_sym_u8_DQUOTE] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [sym_true] = ACTIONS(1695),
    [sym_false] = ACTIONS(1695),
    [anon_sym_NULL] = ACTIONS(1695),
    [anon_sym_nullptr] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
  },
  [381] = {
    [sym_expression] = STATE(972),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1700),
    [anon_sym_typedef] = ACTIONS(1703),
    [anon_sym_extern] = ACTIONS(1705),
    [anon_sym___attribute__] = ACTIONS(1705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1707),
    [anon_sym___declspec] = ACTIONS(1705),
    [anon_sym_signed] = ACTIONS(1705),
    [anon_sym_unsigned] = ACTIONS(1705),
    [anon_sym_long] = ACTIONS(1705),
    [anon_sym_short] = ACTIONS(1705),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_auto] = ACTIONS(1705),
    [anon_sym_register] = ACTIONS(1705),
    [anon_sym_inline] = ACTIONS(1705),
    [anon_sym___inline] = ACTIONS(1705),
    [anon_sym___inline__] = ACTIONS(1705),
    [anon_sym___forceinline] = ACTIONS(1705),
    [anon_sym_thread_local] = ACTIONS(1705),
    [anon_sym___thread] = ACTIONS(1705),
    [anon_sym_const] = ACTIONS(1705),
    [anon_sym_constexpr] = ACTIONS(1705),
    [anon_sym_volatile] = ACTIONS(1705),
    [anon_sym_restrict] = ACTIONS(1705),
    [anon_sym___restrict__] = ACTIONS(1705),
    [anon_sym__Atomic] = ACTIONS(1705),
    [anon_sym__Noreturn] = ACTIONS(1705),
    [anon_sym_noreturn] = ACTIONS(1705),
    [anon_sym__Nonnull] = ACTIONS(1705),
    [anon_sym_alignas] = ACTIONS(1705),
    [anon_sym__Alignas] = ACTIONS(1705),
    [sym_primitive_type] = ACTIONS(1705),
    [anon_sym_enum] = ACTIONS(1705),
    [anon_sym_struct] = ACTIONS(1705),
    [anon_sym_union] = ACTIONS(1705),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [382] = {
    [sym_expression] = STATE(972),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1700),
    [anon_sym_typedef] = ACTIONS(1709),
    [anon_sym_extern] = ACTIONS(1705),
    [anon_sym___attribute__] = ACTIONS(1705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1707),
    [anon_sym___declspec] = ACTIONS(1705),
    [anon_sym_signed] = ACTIONS(1705),
    [anon_sym_unsigned] = ACTIONS(1705),
    [anon_sym_long] = ACTIONS(1705),
    [anon_sym_short] = ACTIONS(1705),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_auto] = ACTIONS(1705),
    [anon_sym_register] = ACTIONS(1705),
    [anon_sym_inline] = ACTIONS(1705),
    [anon_sym___inline] = ACTIONS(1705),
    [anon_sym___inline__] = ACTIONS(1705),
    [anon_sym___forceinline] = ACTIONS(1705),
    [anon_sym_thread_local] = ACTIONS(1705),
    [anon_sym___thread] = ACTIONS(1705),
    [anon_sym_const] = ACTIONS(1705),
    [anon_sym_constexpr] = ACTIONS(1705),
    [anon_sym_volatile] = ACTIONS(1705),
    [anon_sym_restrict] = ACTIONS(1705),
    [anon_sym___restrict__] = ACTIONS(1705),
    [anon_sym__Atomic] = ACTIONS(1705),
    [anon_sym__Noreturn] = ACTIONS(1705),
    [anon_sym_noreturn] = ACTIONS(1705),
    [anon_sym__Nonnull] = ACTIONS(1705),
    [anon_sym_alignas] = ACTIONS(1705),
    [anon_sym__Alignas] = ACTIONS(1705),
    [sym_primitive_type] = ACTIONS(1705),
    [anon_sym_enum] = ACTIONS(1705),
    [anon_sym_struct] = ACTIONS(1705),
    [anon_sym_union] = ACTIONS(1705),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1914),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [384] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1779),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [385] = {
    [sym_expression] = STATE(884),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(686),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(686),
    [sym_call_expression] = STATE(686),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(686),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(686),
    [sym_initializer_list] = STATE(675),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1383),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1719),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1383),
    [anon_sym_AMP_AMP] = ACTIONS(1383),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_EQ_EQ] = ACTIONS(1383),
    [anon_sym_BANG_EQ] = ACTIONS(1383),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1383),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_LT_LT] = ACTIONS(1381),
    [anon_sym_GT_GT] = ACTIONS(1381),
    [anon_sym___extension__] = ACTIONS(1721),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1383),
    [anon_sym_RBRACK] = ACTIONS(1383),
    [anon_sym_EQ] = ACTIONS(1381),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_STAR_EQ] = ACTIONS(1383),
    [anon_sym_SLASH_EQ] = ACTIONS(1383),
    [anon_sym_PERCENT_EQ] = ACTIONS(1383),
    [anon_sym_PLUS_EQ] = ACTIONS(1383),
    [anon_sym_DASH_EQ] = ACTIONS(1383),
    [anon_sym_LT_LT_EQ] = ACTIONS(1383),
    [anon_sym_GT_GT_EQ] = ACTIONS(1383),
    [anon_sym_AMP_EQ] = ACTIONS(1383),
    [anon_sym_CARET_EQ] = ACTIONS(1383),
    [anon_sym_PIPE_EQ] = ACTIONS(1383),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1723),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1381),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [386] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1803),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [387] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1939),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [388] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1946),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [389] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1955),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [390] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1908),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [391] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1958),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1775),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1825),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [394] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1861),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [sym_compound_statement] = STATE(1947),
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1969),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [396] = {
    [sym_expression] = STATE(972),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1700),
    [anon_sym_typedef] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1705),
    [anon_sym___attribute__] = ACTIONS(1705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1707),
    [anon_sym___declspec] = ACTIONS(1705),
    [anon_sym_signed] = ACTIONS(1705),
    [anon_sym_unsigned] = ACTIONS(1705),
    [anon_sym_long] = ACTIONS(1705),
    [anon_sym_short] = ACTIONS(1705),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_auto] = ACTIONS(1705),
    [anon_sym_register] = ACTIONS(1705),
    [anon_sym_inline] = ACTIONS(1705),
    [anon_sym___inline] = ACTIONS(1705),
    [anon_sym___inline__] = ACTIONS(1705),
    [anon_sym___forceinline] = ACTIONS(1705),
    [anon_sym_thread_local] = ACTIONS(1705),
    [anon_sym___thread] = ACTIONS(1705),
    [anon_sym_const] = ACTIONS(1705),
    [anon_sym_constexpr] = ACTIONS(1705),
    [anon_sym_volatile] = ACTIONS(1705),
    [anon_sym_restrict] = ACTIONS(1705),
    [anon_sym___restrict__] = ACTIONS(1705),
    [anon_sym__Atomic] = ACTIONS(1705),
    [anon_sym__Noreturn] = ACTIONS(1705),
    [anon_sym_noreturn] = ACTIONS(1705),
    [anon_sym__Nonnull] = ACTIONS(1705),
    [anon_sym_alignas] = ACTIONS(1705),
    [anon_sym__Alignas] = ACTIONS(1705),
    [sym_primitive_type] = ACTIONS(1705),
    [anon_sym_enum] = ACTIONS(1705),
    [anon_sym_struct] = ACTIONS(1705),
    [anon_sym_union] = ACTIONS(1705),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [397] = {
    [sym_expression] = STATE(972),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1700),
    [anon_sym_typedef] = ACTIONS(1727),
    [anon_sym_extern] = ACTIONS(1705),
    [anon_sym___attribute__] = ACTIONS(1705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1707),
    [anon_sym___declspec] = ACTIONS(1705),
    [anon_sym_signed] = ACTIONS(1705),
    [anon_sym_unsigned] = ACTIONS(1705),
    [anon_sym_long] = ACTIONS(1705),
    [anon_sym_short] = ACTIONS(1705),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_auto] = ACTIONS(1705),
    [anon_sym_register] = ACTIONS(1705),
    [anon_sym_inline] = ACTIONS(1705),
    [anon_sym___inline] = ACTIONS(1705),
    [anon_sym___inline__] = ACTIONS(1705),
    [anon_sym___forceinline] = ACTIONS(1705),
    [anon_sym_thread_local] = ACTIONS(1705),
    [anon_sym___thread] = ACTIONS(1705),
    [anon_sym_const] = ACTIONS(1705),
    [anon_sym_constexpr] = ACTIONS(1705),
    [anon_sym_volatile] = ACTIONS(1705),
    [anon_sym_restrict] = ACTIONS(1705),
    [anon_sym___restrict__] = ACTIONS(1705),
    [anon_sym__Atomic] = ACTIONS(1705),
    [anon_sym__Noreturn] = ACTIONS(1705),
    [anon_sym_noreturn] = ACTIONS(1705),
    [anon_sym__Nonnull] = ACTIONS(1705),
    [anon_sym_alignas] = ACTIONS(1705),
    [anon_sym__Alignas] = ACTIONS(1705),
    [sym_primitive_type] = ACTIONS(1705),
    [anon_sym_enum] = ACTIONS(1705),
    [anon_sym_struct] = ACTIONS(1705),
    [anon_sym_union] = ACTIONS(1705),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [398] = {
    [sym_expression] = STATE(972),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1697),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1700),
    [anon_sym_extern] = ACTIONS(1705),
    [anon_sym___attribute__] = ACTIONS(1705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1707),
    [anon_sym___declspec] = ACTIONS(1705),
    [anon_sym_signed] = ACTIONS(1705),
    [anon_sym_unsigned] = ACTIONS(1705),
    [anon_sym_long] = ACTIONS(1705),
    [anon_sym_short] = ACTIONS(1705),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_auto] = ACTIONS(1705),
    [anon_sym_register] = ACTIONS(1705),
    [anon_sym_inline] = ACTIONS(1705),
    [anon_sym___inline] = ACTIONS(1705),
    [anon_sym___inline__] = ACTIONS(1705),
    [anon_sym___forceinline] = ACTIONS(1705),
    [anon_sym_thread_local] = ACTIONS(1705),
    [anon_sym___thread] = ACTIONS(1705),
    [anon_sym_const] = ACTIONS(1705),
    [anon_sym_constexpr] = ACTIONS(1705),
    [anon_sym_volatile] = ACTIONS(1705),
    [anon_sym_restrict] = ACTIONS(1705),
    [anon_sym___restrict__] = ACTIONS(1705),
    [anon_sym__Atomic] = ACTIONS(1705),
    [anon_sym__Noreturn] = ACTIONS(1705),
    [anon_sym_noreturn] = ACTIONS(1705),
    [anon_sym__Nonnull] = ACTIONS(1705),
    [anon_sym_alignas] = ACTIONS(1705),
    [anon_sym__Alignas] = ACTIONS(1705),
    [sym_primitive_type] = ACTIONS(1705),
    [anon_sym_enum] = ACTIONS(1705),
    [anon_sym_struct] = ACTIONS(1705),
    [anon_sym_union] = ACTIONS(1705),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [399] = {
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1068),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1903),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [400] = {
    [sym_type_qualifier] = STATE(1004),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(1095),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_expression] = STATE(1082),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_type_descriptor] = STATE(1910),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__type_definition_type_repeat1] = STATE(1004),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1108),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1713),
    [anon_sym_unsigned] = ACTIONS(1713),
    [anon_sym_long] = ACTIONS(1713),
    [anon_sym_short] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(1715),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [401] = {
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(1731),
    [anon_sym_RPAREN] = ACTIONS(1731),
    [anon_sym_LPAREN2] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1731),
    [anon_sym___extension__] = ACTIONS(1729),
    [anon_sym_extern] = ACTIONS(1729),
    [anon_sym___attribute__] = ACTIONS(1729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1731),
    [anon_sym___declspec] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_signed] = ACTIONS(1729),
    [anon_sym_unsigned] = ACTIONS(1729),
    [anon_sym_long] = ACTIONS(1729),
    [anon_sym_short] = ACTIONS(1729),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_static] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1731),
    [anon_sym_auto] = ACTIONS(1729),
    [anon_sym_register] = ACTIONS(1729),
    [anon_sym_inline] = ACTIONS(1729),
    [anon_sym___inline] = ACTIONS(1729),
    [anon_sym___inline__] = ACTIONS(1729),
    [anon_sym___forceinline] = ACTIONS(1729),
    [anon_sym_thread_local] = ACTIONS(1729),
    [anon_sym___thread] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(1729),
    [anon_sym_constexpr] = ACTIONS(1729),
    [anon_sym_volatile] = ACTIONS(1729),
    [anon_sym_restrict] = ACTIONS(1729),
    [anon_sym___restrict__] = ACTIONS(1729),
    [anon_sym__Atomic] = ACTIONS(1729),
    [anon_sym__Noreturn] = ACTIONS(1729),
    [anon_sym_noreturn] = ACTIONS(1729),
    [anon_sym__Nonnull] = ACTIONS(1729),
    [anon_sym_alignas] = ACTIONS(1729),
    [anon_sym__Alignas] = ACTIONS(1729),
    [sym_primitive_type] = ACTIONS(1729),
    [anon_sym_enum] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(1731),
    [anon_sym_struct] = ACTIONS(1729),
    [anon_sym_union] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1729),
    [anon_sym_switch] = ACTIONS(1729),
    [anon_sym_case] = ACTIONS(1729),
    [anon_sym_default] = ACTIONS(1729),
    [anon_sym_while] = ACTIONS(1729),
    [anon_sym_do] = ACTIONS(1729),
    [anon_sym_for] = ACTIONS(1729),
    [anon_sym_return] = ACTIONS(1729),
    [anon_sym_break] = ACTIONS(1729),
    [anon_sym_continue] = ACTIONS(1729),
    [anon_sym_goto] = ACTIONS(1729),
    [anon_sym___try] = ACTIONS(1729),
    [anon_sym___leave] = ACTIONS(1729),
    [anon_sym_DASH_DASH] = ACTIONS(1731),
    [anon_sym_PLUS_PLUS] = ACTIONS(1731),
    [anon_sym_sizeof] = ACTIONS(1729),
    [anon_sym___alignof__] = ACTIONS(1729),
    [anon_sym___alignof] = ACTIONS(1729),
    [anon_sym__alignof] = ACTIONS(1729),
    [anon_sym_alignof] = ACTIONS(1729),
    [anon_sym__Alignof] = ACTIONS(1729),
    [anon_sym_offsetof] = ACTIONS(1729),
    [anon_sym__Generic] = ACTIONS(1729),
    [anon_sym_asm] = ACTIONS(1729),
    [anon_sym___asm__] = ACTIONS(1729),
    [anon_sym___asm] = ACTIONS(1729),
    [sym_number_literal] = ACTIONS(1731),
    [anon_sym_L_SQUOTE] = ACTIONS(1731),
    [anon_sym_u_SQUOTE] = ACTIONS(1731),
    [anon_sym_U_SQUOTE] = ACTIONS(1731),
    [anon_sym_u8_SQUOTE] = ACTIONS(1731),
    [anon_sym_SQUOTE] = ACTIONS(1731),
    [anon_sym_L_DQUOTE] = ACTIONS(1731),
    [anon_sym_u_DQUOTE] = ACTIONS(1731),
    [anon_sym_U_DQUOTE] = ACTIONS(1731),
    [anon_sym_u8_DQUOTE] = ACTIONS(1731),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [sym_true] = ACTIONS(1729),
    [sym_false] = ACTIONS(1729),
    [anon_sym_NULL] = ACTIONS(1729),
    [anon_sym_nullptr] = ACTIONS(1729),
    [sym_comment] = ACTIONS(3),
  },
  [402] = {
    [sym_identifier] = ACTIONS(1733),
    [anon_sym_COMMA] = ACTIONS(1735),
    [anon_sym_RPAREN] = ACTIONS(1735),
    [anon_sym_LPAREN2] = ACTIONS(1735),
    [anon_sym_BANG] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_AMP] = ACTIONS(1735),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym___extension__] = ACTIONS(1733),
    [anon_sym_extern] = ACTIONS(1733),
    [anon_sym___attribute__] = ACTIONS(1733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1735),
    [anon_sym___declspec] = ACTIONS(1733),
    [anon_sym_LBRACE] = ACTIONS(1735),
    [anon_sym_signed] = ACTIONS(1733),
    [anon_sym_unsigned] = ACTIONS(1733),
    [anon_sym_long] = ACTIONS(1733),
    [anon_sym_short] = ACTIONS(1733),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_static] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1735),
    [anon_sym_auto] = ACTIONS(1733),
    [anon_sym_register] = ACTIONS(1733),
    [anon_sym_inline] = ACTIONS(1733),
    [anon_sym___inline] = ACTIONS(1733),
    [anon_sym___inline__] = ACTIONS(1733),
    [anon_sym___forceinline] = ACTIONS(1733),
    [anon_sym_thread_local] = ACTIONS(1733),
    [anon_sym___thread] = ACTIONS(1733),
    [anon_sym_const] = ACTIONS(1733),
    [anon_sym_constexpr] = ACTIONS(1733),
    [anon_sym_volatile] = ACTIONS(1733),
    [anon_sym_restrict] = ACTIONS(1733),
    [anon_sym___restrict__] = ACTIONS(1733),
    [anon_sym__Atomic] = ACTIONS(1733),
    [anon_sym__Noreturn] = ACTIONS(1733),
    [anon_sym_noreturn] = ACTIONS(1733),
    [anon_sym__Nonnull] = ACTIONS(1733),
    [anon_sym_alignas] = ACTIONS(1733),
    [anon_sym__Alignas] = ACTIONS(1733),
    [sym_primitive_type] = ACTIONS(1733),
    [anon_sym_enum] = ACTIONS(1733),
    [anon_sym_COLON] = ACTIONS(1735),
    [anon_sym_struct] = ACTIONS(1733),
    [anon_sym_union] = ACTIONS(1733),
    [anon_sym_if] = ACTIONS(1733),
    [anon_sym_switch] = ACTIONS(1733),
    [anon_sym_case] = ACTIONS(1733),
    [anon_sym_default] = ACTIONS(1733),
    [anon_sym_while] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_for] = ACTIONS(1733),
    [anon_sym_return] = ACTIONS(1733),
    [anon_sym_break] = ACTIONS(1733),
    [anon_sym_continue] = ACTIONS(1733),
    [anon_sym_goto] = ACTIONS(1733),
    [anon_sym___try] = ACTIONS(1733),
    [anon_sym___leave] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1735),
    [anon_sym_PLUS_PLUS] = ACTIONS(1735),
    [anon_sym_sizeof] = ACTIONS(1733),
    [anon_sym___alignof__] = ACTIONS(1733),
    [anon_sym___alignof] = ACTIONS(1733),
    [anon_sym__alignof] = ACTIONS(1733),
    [anon_sym_alignof] = ACTIONS(1733),
    [anon_sym__Alignof] = ACTIONS(1733),
    [anon_sym_offsetof] = ACTIONS(1733),
    [anon_sym__Generic] = ACTIONS(1733),
    [anon_sym_asm] = ACTIONS(1733),
    [anon_sym___asm__] = ACTIONS(1733),
    [anon_sym___asm] = ACTIONS(1733),
    [sym_number_literal] = ACTIONS(1735),
    [anon_sym_L_SQUOTE] = ACTIONS(1735),
    [anon_sym_u_SQUOTE] = ACTIONS(1735),
    [anon_sym_U_SQUOTE] = ACTIONS(1735),
    [anon_sym_u8_SQUOTE] = ACTIONS(1735),
    [anon_sym_SQUOTE] = ACTIONS(1735),
    [anon_sym_L_DQUOTE] = ACTIONS(1735),
    [anon_sym_u_DQUOTE] = ACTIONS(1735),
    [anon_sym_U_DQUOTE] = ACTIONS(1735),
    [anon_sym_u8_DQUOTE] = ACTIONS(1735),
    [anon_sym_DQUOTE] = ACTIONS(1735),
    [sym_true] = ACTIONS(1733),
    [sym_false] = ACTIONS(1733),
    [anon_sym_NULL] = ACTIONS(1733),
    [anon_sym_nullptr] = ACTIONS(1733),
    [sym_comment] = ACTIONS(3),
  },
  [403] = {
    [sym_expression] = STATE(704),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_initializer_list] = STATE(675),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1383),
    [anon_sym_RPAREN] = ACTIONS(1383),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1383),
    [anon_sym_AMP_AMP] = ACTIONS(1383),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_EQ_EQ] = ACTIONS(1383),
    [anon_sym_BANG_EQ] = ACTIONS(1383),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1383),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_LT_LT] = ACTIONS(1383),
    [anon_sym_GT_GT] = ACTIONS(1383),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_RBRACE] = ACTIONS(1383),
    [anon_sym_LBRACK] = ACTIONS(1383),
    [anon_sym_COLON] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1381),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [404] = {
    [sym_expression] = STATE(704),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(828),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(828),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(828),
    [sym_initializer_list] = STATE(675),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(700),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1383),
    [aux_sym_preproc_if_token2] = ACTIONS(1383),
    [aux_sym_preproc_else_token1] = ACTIONS(1383),
    [aux_sym_preproc_elif_token1] = ACTIONS(1381),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1383),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1383),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1383),
    [anon_sym_AMP_AMP] = ACTIONS(1383),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_EQ_EQ] = ACTIONS(1383),
    [anon_sym_BANG_EQ] = ACTIONS(1383),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1383),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_LT_LT] = ACTIONS(1383),
    [anon_sym_GT_GT] = ACTIONS(1383),
    [anon_sym___extension__] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1745),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1381),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [405] = {
    [sym_else_clause] = STATE(250),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_LPAREN2] = ACTIONS(1125),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym___extension__] = ACTIONS(1123),
    [anon_sym_typedef] = ACTIONS(1123),
    [anon_sym_extern] = ACTIONS(1123),
    [anon_sym___attribute__] = ACTIONS(1123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1125),
    [anon_sym___declspec] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_signed] = ACTIONS(1123),
    [anon_sym_unsigned] = ACTIONS(1123),
    [anon_sym_long] = ACTIONS(1123),
    [anon_sym_short] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1123),
    [anon_sym_auto] = ACTIONS(1123),
    [anon_sym_register] = ACTIONS(1123),
    [anon_sym_inline] = ACTIONS(1123),
    [anon_sym___inline] = ACTIONS(1123),
    [anon_sym___inline__] = ACTIONS(1123),
    [anon_sym___forceinline] = ACTIONS(1123),
    [anon_sym_thread_local] = ACTIONS(1123),
    [anon_sym___thread] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_constexpr] = ACTIONS(1123),
    [anon_sym_volatile] = ACTIONS(1123),
    [anon_sym_restrict] = ACTIONS(1123),
    [anon_sym___restrict__] = ACTIONS(1123),
    [anon_sym__Atomic] = ACTIONS(1123),
    [anon_sym__Noreturn] = ACTIONS(1123),
    [anon_sym_noreturn] = ACTIONS(1123),
    [anon_sym__Nonnull] = ACTIONS(1123),
    [anon_sym_alignas] = ACTIONS(1123),
    [anon_sym__Alignas] = ACTIONS(1123),
    [sym_primitive_type] = ACTIONS(1123),
    [anon_sym_enum] = ACTIONS(1123),
    [anon_sym_struct] = ACTIONS(1123),
    [anon_sym_union] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_else] = ACTIONS(1747),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_do] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_return] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1123),
    [anon_sym_goto] = ACTIONS(1123),
    [anon_sym___try] = ACTIONS(1123),
    [anon_sym___leave] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_sizeof] = ACTIONS(1123),
    [anon_sym___alignof__] = ACTIONS(1123),
    [anon_sym___alignof] = ACTIONS(1123),
    [anon_sym__alignof] = ACTIONS(1123),
    [anon_sym_alignof] = ACTIONS(1123),
    [anon_sym__Alignof] = ACTIONS(1123),
    [anon_sym_offsetof] = ACTIONS(1123),
    [anon_sym__Generic] = ACTIONS(1123),
    [anon_sym_asm] = ACTIONS(1123),
    [anon_sym___asm__] = ACTIONS(1123),
    [anon_sym___asm] = ACTIONS(1123),
    [sym_number_literal] = ACTIONS(1125),
    [anon_sym_L_SQUOTE] = ACTIONS(1125),
    [anon_sym_u_SQUOTE] = ACTIONS(1125),
    [anon_sym_U_SQUOTE] = ACTIONS(1125),
    [anon_sym_u8_SQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [anon_sym_L_DQUOTE] = ACTIONS(1125),
    [anon_sym_u_DQUOTE] = ACTIONS(1125),
    [anon_sym_U_DQUOTE] = ACTIONS(1125),
    [anon_sym_u8_DQUOTE] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [sym_true] = ACTIONS(1123),
    [sym_false] = ACTIONS(1123),
    [anon_sym_NULL] = ACTIONS(1123),
    [anon_sym_nullptr] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_LPAREN2] = ACTIONS(1752),
    [anon_sym_BANG] = ACTIONS(1752),
    [anon_sym_TILDE] = ACTIONS(1752),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_STAR] = ACTIONS(1752),
    [anon_sym_AMP] = ACTIONS(1752),
    [anon_sym_SEMI] = ACTIONS(1752),
    [anon_sym___extension__] = ACTIONS(1749),
    [anon_sym_extern] = ACTIONS(1756),
    [anon_sym___attribute__] = ACTIONS(1756),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1758),
    [anon_sym___declspec] = ACTIONS(1756),
    [anon_sym_LBRACE] = ACTIONS(1752),
    [anon_sym_signed] = ACTIONS(1756),
    [anon_sym_unsigned] = ACTIONS(1756),
    [anon_sym_long] = ACTIONS(1756),
    [anon_sym_short] = ACTIONS(1756),
    [anon_sym_static] = ACTIONS(1756),
    [anon_sym_auto] = ACTIONS(1756),
    [anon_sym_register] = ACTIONS(1756),
    [anon_sym_inline] = ACTIONS(1756),
    [anon_sym___inline] = ACTIONS(1756),
    [anon_sym___inline__] = ACTIONS(1756),
    [anon_sym___forceinline] = ACTIONS(1756),
    [anon_sym_thread_local] = ACTIONS(1756),
    [anon_sym___thread] = ACTIONS(1756),
    [anon_sym_const] = ACTIONS(1756),
    [anon_sym_constexpr] = ACTIONS(1756),
    [anon_sym_volatile] = ACTIONS(1756),
    [anon_sym_restrict] = ACTIONS(1756),
    [anon_sym___restrict__] = ACTIONS(1756),
    [anon_sym__Atomic] = ACTIONS(1756),
    [anon_sym__Noreturn] = ACTIONS(1756),
    [anon_sym_noreturn] = ACTIONS(1756),
    [anon_sym__Nonnull] = ACTIONS(1756),
    [anon_sym_alignas] = ACTIONS(1756),
    [anon_sym__Alignas] = ACTIONS(1756),
    [sym_primitive_type] = ACTIONS(1756),
    [anon_sym_enum] = ACTIONS(1756),
    [anon_sym_struct] = ACTIONS(1756),
    [anon_sym_union] = ACTIONS(1756),
    [anon_sym_if] = ACTIONS(1754),
    [anon_sym_switch] = ACTIONS(1754),
    [anon_sym_case] = ACTIONS(1754),
    [anon_sym_default] = ACTIONS(1754),
    [anon_sym_while] = ACTIONS(1754),
    [anon_sym_do] = ACTIONS(1754),
    [anon_sym_for] = ACTIONS(1754),
    [anon_sym_return] = ACTIONS(1754),
    [anon_sym_break] = ACTIONS(1754),
    [anon_sym_continue] = ACTIONS(1754),
    [anon_sym_goto] = ACTIONS(1754),
    [anon_sym___try] = ACTIONS(1754),
    [anon_sym___leave] = ACTIONS(1754),
    [anon_sym_DASH_DASH] = ACTIONS(1752),
    [anon_sym_PLUS_PLUS] = ACTIONS(1752),
    [anon_sym_sizeof] = ACTIONS(1754),
    [anon_sym___alignof__] = ACTIONS(1754),
    [anon_sym___alignof] = ACTIONS(1754),
    [anon_sym__alignof] = ACTIONS(1754),
    [anon_sym_alignof] = ACTIONS(1754),
    [anon_sym__Alignof] = ACTIONS(1754),
    [anon_sym_offsetof] = ACTIONS(1754),
    [anon_sym__Generic] = ACTIONS(1754),
    [anon_sym_asm] = ACTIONS(1754),
    [anon_sym___asm__] = ACTIONS(1754),
    [anon_sym___asm] = ACTIONS(1754),
    [sym_number_literal] = ACTIONS(1752),
    [anon_sym_L_SQUOTE] = ACTIONS(1752),
    [anon_sym_u_SQUOTE] = ACTIONS(1752),
    [anon_sym_U_SQUOTE] = ACTIONS(1752),
    [anon_sym_u8_SQUOTE] = ACTIONS(1752),
    [anon_sym_SQUOTE] = ACTIONS(1752),
    [anon_sym_L_DQUOTE] = ACTIONS(1752),
    [anon_sym_u_DQUOTE] = ACTIONS(1752),
    [anon_sym_U_DQUOTE] = ACTIONS(1752),
    [anon_sym_u8_DQUOTE] = ACTIONS(1752),
    [anon_sym_DQUOTE] = ACTIONS(1752),
    [sym_true] = ACTIONS(1754),
    [sym_false] = ACTIONS(1754),
    [anon_sym_NULL] = ACTIONS(1754),
    [anon_sym_nullptr] = ACTIONS(1754),
    [sym_comment] = ACTIONS(3),
  },
  [407] = {
    [sym_expression] = STATE(884),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_initializer_list] = STATE(675),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1383),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1763),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_SLASH] = ACTIONS(1381),
    [anon_sym_PERCENT] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1383),
    [anon_sym_AMP_AMP] = ACTIONS(1383),
    [anon_sym_PIPE] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_EQ_EQ] = ACTIONS(1383),
    [anon_sym_BANG_EQ] = ACTIONS(1383),
    [anon_sym_GT] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1383),
    [anon_sym_LT] = ACTIONS(1381),
    [anon_sym_LT_LT] = ACTIONS(1383),
    [anon_sym_GT_GT] = ACTIONS(1383),
    [anon_sym___extension__] = ACTIONS(1767),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1383),
    [anon_sym_RBRACK] = ACTIONS(1383),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1381),
    [anon_sym_DASH_GT] = ACTIONS(1383),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [408] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1773),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1790),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [409] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1773),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1773),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1773),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1799),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [412] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1773),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1801),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [413] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1773),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1801),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [414] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1773),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1803),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1773),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1794),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1799),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [416] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1805),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_COLON] = ACTIONS(1790),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [417] = {
    [sym_string_literal] = STATE(625),
    [aux_sym_sized_type_specifier_repeat1] = STATE(752),
    [sym_identifier] = ACTIONS(1771),
    [anon_sym_COMMA] = ACTIONS(1773),
    [anon_sym_LPAREN2] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [anon_sym_PERCENT] = ACTIONS(1779),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_CARET] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1773),
    [anon_sym_BANG_EQ] = ACTIONS(1773),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1771),
    [anon_sym___attribute__] = ACTIONS(1771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1784),
    [anon_sym___declspec] = ACTIONS(1771),
    [anon_sym___based] = ACTIONS(1771),
    [anon_sym___cdecl] = ACTIONS(1771),
    [anon_sym___clrcall] = ACTIONS(1771),
    [anon_sym___stdcall] = ACTIONS(1771),
    [anon_sym___fastcall] = ACTIONS(1771),
    [anon_sym___thiscall] = ACTIONS(1771),
    [anon_sym___vectorcall] = ACTIONS(1771),
    [anon_sym_signed] = ACTIONS(1786),
    [anon_sym_unsigned] = ACTIONS(1786),
    [anon_sym_long] = ACTIONS(1786),
    [anon_sym_short] = ACTIONS(1786),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_EQ] = ACTIONS(1788),
    [anon_sym_auto] = ACTIONS(1771),
    [anon_sym_register] = ACTIONS(1771),
    [anon_sym_inline] = ACTIONS(1771),
    [anon_sym___inline] = ACTIONS(1771),
    [anon_sym___inline__] = ACTIONS(1771),
    [anon_sym___forceinline] = ACTIONS(1771),
    [anon_sym_thread_local] = ACTIONS(1771),
    [anon_sym___thread] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1771),
    [anon_sym_constexpr] = ACTIONS(1771),
    [anon_sym_volatile] = ACTIONS(1771),
    [anon_sym_restrict] = ACTIONS(1771),
    [anon_sym___restrict__] = ACTIONS(1771),
    [anon_sym__Atomic] = ACTIONS(1771),
    [anon_sym__Noreturn] = ACTIONS(1771),
    [anon_sym_noreturn] = ACTIONS(1771),
    [anon_sym__Nonnull] = ACTIONS(1771),
    [anon_sym_alignas] = ACTIONS(1771),
    [anon_sym__Alignas] = ACTIONS(1771),
    [anon_sym_QMARK] = ACTIONS(1773),
    [anon_sym_STAR_EQ] = ACTIONS(1792),
    [anon_sym_SLASH_EQ] = ACTIONS(1792),
    [anon_sym_PERCENT_EQ] = ACTIONS(1792),
    [anon_sym_PLUS_EQ] = ACTIONS(1792),
    [anon_sym_DASH_EQ] = ACTIONS(1792),
    [anon_sym_LT_LT_EQ] = ACTIONS(1792),
    [anon_sym_GT_GT_EQ] = ACTIONS(1792),
    [anon_sym_AMP_EQ] = ACTIONS(1792),
    [anon_sym_CARET_EQ] = ACTIONS(1792),
    [anon_sym_PIPE_EQ] = ACTIONS(1792),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1773),
    [anon_sym_DASH_GT] = ACTIONS(1773),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_comment] = ACTIONS(3),
  },
  [418] = {
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1114),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_based_modifier] = STATE(1846),
    [sym_ms_call_modifier] = STATE(1244),
    [sym__declarator] = STATE(1440),
    [sym__abstract_declarator] = STATE(1525),
    [sym_parenthesized_declarator] = STATE(1303),
    [sym_abstract_parenthesized_declarator] = STATE(1445),
    [sym_attributed_declarator] = STATE(1303),
    [sym_pointer_declarator] = STATE(1303),
    [sym_abstract_pointer_declarator] = STATE(1445),
    [sym_function_declarator] = STATE(1303),
    [sym_abstract_function_declarator] = STATE(1445),
    [sym_array_declarator] = STATE(1303),
    [sym_abstract_array_declarator] = STATE(1445),
    [sym_compound_statement] = STATE(1770),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_variadic_parameter] = STATE(1623),
    [sym_parameter_list] = STATE(1446),
    [sym_parameter_declaration] = STATE(1623),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1810),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [anon_sym_LPAREN2] = ACTIONS(1814),
    [anon_sym_STAR] = ACTIONS(1816),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___based] = ACTIONS(1818),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [419] = {
    [sym_type_qualifier] = STATE(664),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1074),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(664),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1824),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1830),
    [anon_sym_RBRACK] = ACTIONS(1832),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [420] = {
    [sym_type_qualifier] = STATE(421),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1091),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1842),
    [anon_sym_RBRACK] = ACTIONS(1844),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [421] = {
    [sym_type_qualifier] = STATE(664),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1086),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(664),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1830),
    [anon_sym_RBRACK] = ACTIONS(1848),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [sym_type_qualifier] = STATE(426),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1089),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1850),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1852),
    [anon_sym_RBRACK] = ACTIONS(1854),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [423] = {
    [sym_type_qualifier] = STATE(664),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1088),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(664),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1856),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1830),
    [anon_sym_RBRACK] = ACTIONS(1858),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym_type_qualifier] = STATE(423),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1065),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1862),
    [anon_sym_RBRACK] = ACTIONS(1864),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [425] = {
    [sym_type_qualifier] = STATE(664),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1085),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(664),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1866),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1830),
    [anon_sym_RBRACK] = ACTIONS(1868),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [426] = {
    [sym_type_qualifier] = STATE(664),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1070),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(664),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1870),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1830),
    [anon_sym_RBRACK] = ACTIONS(1872),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym_type_qualifier] = STATE(425),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1078),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(425),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1876),
    [anon_sym_RBRACK] = ACTIONS(1878),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym_type_qualifier] = STATE(419),
    [sym_alignas_qualifier] = STATE(681),
    [sym_expression] = STATE(1075),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_array_declarator_repeat1] = STATE(419),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1880),
    [anon_sym_AMP] = ACTIONS(1826),
    [anon_sym___extension__] = ACTIONS(1828),
    [anon_sym_static] = ACTIONS(1882),
    [anon_sym_RBRACK] = ACTIONS(1884),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_constexpr] = ACTIONS(1834),
    [anon_sym_volatile] = ACTIONS(1834),
    [anon_sym_restrict] = ACTIONS(1834),
    [anon_sym___restrict__] = ACTIONS(1834),
    [anon_sym__Atomic] = ACTIONS(1834),
    [anon_sym__Noreturn] = ACTIONS(1834),
    [anon_sym_noreturn] = ACTIONS(1834),
    [anon_sym__Nonnull] = ACTIONS(1834),
    [anon_sym_alignas] = ACTIONS(1836),
    [anon_sym__Alignas] = ACTIONS(1836),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_sizeof] = ACTIONS(1769),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [sym_expression] = STATE(1040),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(906),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(906),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(906),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_LPAREN2] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(1892),
    [anon_sym_TILDE] = ACTIONS(1892),
    [anon_sym_DASH] = ACTIONS(1895),
    [anon_sym_PLUS] = ACTIONS(1895),
    [anon_sym_STAR] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1898),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_RBRACK] = ACTIONS(1707),
    [anon_sym_const] = ACTIONS(1705),
    [anon_sym_constexpr] = ACTIONS(1705),
    [anon_sym_volatile] = ACTIONS(1705),
    [anon_sym_restrict] = ACTIONS(1705),
    [anon_sym___restrict__] = ACTIONS(1705),
    [anon_sym__Atomic] = ACTIONS(1705),
    [anon_sym__Noreturn] = ACTIONS(1705),
    [anon_sym_noreturn] = ACTIONS(1705),
    [anon_sym__Nonnull] = ACTIONS(1705),
    [anon_sym_alignas] = ACTIONS(1705),
    [anon_sym__Alignas] = ACTIONS(1705),
    [anon_sym_DASH_DASH] = ACTIONS(1904),
    [anon_sym_PLUS_PLUS] = ACTIONS(1904),
    [anon_sym_sizeof] = ACTIONS(1907),
    [anon_sym___alignof__] = ACTIONS(1910),
    [anon_sym___alignof] = ACTIONS(1910),
    [anon_sym__alignof] = ACTIONS(1910),
    [anon_sym_alignof] = ACTIONS(1910),
    [anon_sym__Alignof] = ACTIONS(1910),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1916),
    [anon_sym_asm] = ACTIONS(1919),
    [anon_sym___asm__] = ACTIONS(1919),
    [anon_sym___asm] = ACTIONS(1919),
    [sym_number_literal] = ACTIONS(1922),
    [anon_sym_L_SQUOTE] = ACTIONS(1925),
    [anon_sym_u_SQUOTE] = ACTIONS(1925),
    [anon_sym_U_SQUOTE] = ACTIONS(1925),
    [anon_sym_u8_SQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1925),
    [anon_sym_L_DQUOTE] = ACTIONS(1928),
    [anon_sym_u_DQUOTE] = ACTIONS(1928),
    [anon_sym_U_DQUOTE] = ACTIONS(1928),
    [anon_sym_u8_DQUOTE] = ACTIONS(1928),
    [anon_sym_DQUOTE] = ACTIONS(1928),
    [sym_true] = ACTIONS(1931),
    [sym_false] = ACTIONS(1931),
    [anon_sym_NULL] = ACTIONS(1934),
    [anon_sym_nullptr] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [sym_expression] = STATE(1012),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_initializer_list] = STATE(1655),
    [sym_initializer_pair] = STATE(1655),
    [sym_subscript_designator] = STATE(1410),
    [sym_subscript_range_designator] = STATE(1410),
    [sym_field_designator] = STATE(1410),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_initializer_pair_repeat1] = STATE(1410),
    [sym_identifier] = ACTIONS(1937),
    [anon_sym_COMMA] = ACTIONS(1939),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_RBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1945),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1114),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_ms_call_modifier] = STATE(1359),
    [sym__abstract_declarator] = STATE(1525),
    [sym_abstract_parenthesized_declarator] = STATE(1445),
    [sym_abstract_pointer_declarator] = STATE(1445),
    [sym_abstract_function_declarator] = STATE(1445),
    [sym_abstract_array_declarator] = STATE(1445),
    [sym_compound_statement] = STATE(1770),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym_variadic_parameter] = STATE(1623),
    [sym_parameter_list] = STATE(1446),
    [sym_parameter_declaration] = STATE(1623),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1810),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1951),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1820),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [432] = {
    [sym_preproc_def] = STATE(440),
    [sym_preproc_function_def] = STATE(440),
    [sym_preproc_call] = STATE(440),
    [sym_preproc_if_in_field_declaration_list] = STATE(440),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(440),
    [sym_preproc_else_in_field_declaration_list] = STATE(1832),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1832),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1832),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(440),
    [sym_field_declaration] = STATE(440),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(440),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [sym_preproc_def] = STATE(446),
    [sym_preproc_function_def] = STATE(446),
    [sym_preproc_call] = STATE(446),
    [sym_preproc_if_in_field_declaration_list] = STATE(446),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(446),
    [sym_preproc_else_in_field_declaration_list] = STATE(1842),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1842),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1842),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(446),
    [sym_field_declaration] = STATE(446),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(446),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1969),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [sym_preproc_def] = STATE(451),
    [sym_preproc_function_def] = STATE(451),
    [sym_preproc_call] = STATE(451),
    [sym_preproc_if_in_field_declaration_list] = STATE(451),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(451),
    [sym_preproc_else_in_field_declaration_list] = STATE(1972),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1972),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1972),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(451),
    [sym_field_declaration] = STATE(451),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [435] = {
    [sym_expression] = STATE(1032),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_initializer_list] = STATE(1671),
    [sym_initializer_pair] = STATE(1671),
    [sym_subscript_designator] = STATE(1410),
    [sym_subscript_range_designator] = STATE(1410),
    [sym_field_designator] = STATE(1410),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_initializer_pair_repeat1] = STATE(1410),
    [sym_identifier] = ACTIONS(1937),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1945),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [436] = {
    [sym_preproc_def] = STATE(444),
    [sym_preproc_function_def] = STATE(444),
    [sym_preproc_call] = STATE(444),
    [sym_preproc_if_in_field_declaration_list] = STATE(444),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(444),
    [sym_preproc_else_in_field_declaration_list] = STATE(1889),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1889),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1889),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(444),
    [sym_field_declaration] = STATE(444),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(444),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1975),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [437] = {
    [sym_preproc_def] = STATE(449),
    [sym_preproc_function_def] = STATE(449),
    [sym_preproc_call] = STATE(449),
    [sym_preproc_if_in_field_declaration_list] = STATE(449),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(449),
    [sym_preproc_else_in_field_declaration_list] = STATE(1950),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1950),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1950),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(449),
    [sym_field_declaration] = STATE(449),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(449),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1977),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [438] = {
    [sym_preproc_def] = STATE(441),
    [sym_preproc_function_def] = STATE(441),
    [sym_preproc_call] = STATE(441),
    [sym_preproc_if_in_field_declaration_list] = STATE(441),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(441),
    [sym_preproc_else_in_field_declaration_list] = STATE(1818),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1818),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1818),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(441),
    [sym_field_declaration] = STATE(441),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(441),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1979),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [439] = {
    [sym_preproc_def] = STATE(445),
    [sym_preproc_function_def] = STATE(445),
    [sym_preproc_call] = STATE(445),
    [sym_preproc_if_in_field_declaration_list] = STATE(445),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(445),
    [sym_preproc_else_in_field_declaration_list] = STATE(1902),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1902),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1902),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(445),
    [sym_field_declaration] = STATE(445),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(445),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1981),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [440] = {
    [sym_preproc_def] = STATE(451),
    [sym_preproc_function_def] = STATE(451),
    [sym_preproc_call] = STATE(451),
    [sym_preproc_if_in_field_declaration_list] = STATE(451),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(451),
    [sym_preproc_else_in_field_declaration_list] = STATE(1839),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1839),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1839),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(451),
    [sym_field_declaration] = STATE(451),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [441] = {
    [sym_preproc_def] = STATE(451),
    [sym_preproc_function_def] = STATE(451),
    [sym_preproc_call] = STATE(451),
    [sym_preproc_if_in_field_declaration_list] = STATE(451),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(451),
    [sym_preproc_else_in_field_declaration_list] = STATE(1836),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1836),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1836),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(451),
    [sym_field_declaration] = STATE(451),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1985),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [442] = {
    [sym_preproc_def] = STATE(447),
    [sym_preproc_function_def] = STATE(447),
    [sym_preproc_call] = STATE(447),
    [sym_preproc_if_in_field_declaration_list] = STATE(447),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(447),
    [sym_preproc_else_in_field_declaration_list] = STATE(1999),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1999),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1999),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(447),
    [sym_field_declaration] = STATE(447),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(447),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1987),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [443] = {
    [sym_expression] = STATE(1032),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_initializer_list] = STATE(1671),
    [sym_initializer_pair] = STATE(1671),
    [sym_subscript_designator] = STATE(1410),
    [sym_subscript_range_designator] = STATE(1410),
    [sym_field_designator] = STATE(1410),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_initializer_pair_repeat1] = STATE(1410),
    [sym_identifier] = ACTIONS(1937),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1945),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [444] = {
    [sym_preproc_def] = STATE(451),
    [sym_preproc_function_def] = STATE(451),
    [sym_preproc_call] = STATE(451),
    [sym_preproc_if_in_field_declaration_list] = STATE(451),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(451),
    [sym_preproc_else_in_field_declaration_list] = STATE(1907),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1907),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1907),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(451),
    [sym_field_declaration] = STATE(451),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1991),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [445] = {
    [sym_preproc_def] = STATE(451),
    [sym_preproc_function_def] = STATE(451),
    [sym_preproc_call] = STATE(451),
    [sym_preproc_if_in_field_declaration_list] = STATE(451),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(451),
    [sym_preproc_else_in_field_declaration_list] = STATE(1913),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1913),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1913),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(451),
    [sym_field_declaration] = STATE(451),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [446] = {
    [sym_preproc_def] = STATE(451),
    [sym_preproc_function_def] = STATE(451),
    [sym_preproc_call] = STATE(451),
    [sym_preproc_if_in_field_declaration_list] = STATE(451),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(451),
    [sym_preproc_else_in_field_declaration_list] = STATE(1899),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1899),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1899),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(451),
    [sym_field_declaration] = STATE(451),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1995),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [447] = {
    [sym_preproc_def] = STATE(451),
    [sym_preproc_function_def] = STATE(451),
    [sym_preproc_call] = STATE(451),
    [sym_preproc_if_in_field_declaration_list] = STATE(451),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(451),
    [sym_preproc_else_in_field_declaration_list] = STATE(1981),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1981),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1981),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(451),
    [sym_field_declaration] = STATE(451),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1997),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [448] = {
    [sym_preproc_def] = STATE(434),
    [sym_preproc_function_def] = STATE(434),
    [sym_preproc_call] = STATE(434),
    [sym_preproc_if_in_field_declaration_list] = STATE(434),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(434),
    [sym_preproc_else_in_field_declaration_list] = STATE(1982),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1982),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1982),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(434),
    [sym_field_declaration] = STATE(434),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(434),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1999),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [449] = {
    [sym_preproc_def] = STATE(451),
    [sym_preproc_function_def] = STATE(451),
    [sym_preproc_call] = STATE(451),
    [sym_preproc_if_in_field_declaration_list] = STATE(451),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(451),
    [sym_preproc_else_in_field_declaration_list] = STATE(1970),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1970),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(1970),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(451),
    [sym_field_declaration] = STATE(451),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(2001),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1959),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1959),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1965),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1965),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [450] = {
    [sym_expression] = STATE(1032),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_initializer_list] = STATE(1671),
    [sym_initializer_pair] = STATE(1671),
    [sym_subscript_designator] = STATE(1410),
    [sym_subscript_range_designator] = STATE(1410),
    [sym_field_designator] = STATE(1410),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [aux_sym_initializer_pair_repeat1] = STATE(1410),
    [sym_identifier] = ACTIONS(1937),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1945),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [451] = {
    [sym_preproc_def] = STATE(451),
    [sym_preproc_function_def] = STATE(451),
    [sym_preproc_call] = STATE(451),
    [sym_preproc_if_in_field_declaration_list] = STATE(451),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(451),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(451),
    [sym_field_declaration] = STATE(451),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(451),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(2003),
    [aux_sym_preproc_def_token1] = ACTIONS(2006),
    [aux_sym_preproc_if_token1] = ACTIONS(2009),
    [aux_sym_preproc_if_token2] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2014),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2014),
    [aux_sym_preproc_else_token1] = ACTIONS(2012),
    [aux_sym_preproc_elif_token1] = ACTIONS(2012),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2012),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2012),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2023),
    [anon_sym___attribute__] = ACTIONS(2026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2032),
    [anon_sym_signed] = ACTIONS(2035),
    [anon_sym_unsigned] = ACTIONS(2035),
    [anon_sym_long] = ACTIONS(2035),
    [anon_sym_short] = ACTIONS(2035),
    [anon_sym_static] = ACTIONS(2023),
    [anon_sym_auto] = ACTIONS(2023),
    [anon_sym_register] = ACTIONS(2023),
    [anon_sym_inline] = ACTIONS(2023),
    [anon_sym___inline] = ACTIONS(2023),
    [anon_sym___inline__] = ACTIONS(2023),
    [anon_sym___forceinline] = ACTIONS(2023),
    [anon_sym_thread_local] = ACTIONS(2023),
    [anon_sym___thread] = ACTIONS(2023),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym___restrict__] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym__Noreturn] = ACTIONS(2020),
    [anon_sym_noreturn] = ACTIONS(2020),
    [anon_sym__Nonnull] = ACTIONS(2020),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2041),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2047),
    [anon_sym_union] = ACTIONS(2050),
    [sym_comment] = ACTIONS(3),
  },
  [452] = {
    [sym_compound_statement] = STATE(1947),
    [sym_expression] = STATE(1034),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1947),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [453] = {
    [sym_preproc_def] = STATE(456),
    [sym_preproc_function_def] = STATE(456),
    [sym_preproc_call] = STATE(456),
    [sym_preproc_if_in_field_declaration_list] = STATE(456),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(456),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1272),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(456),
    [sym_field_declaration] = STATE(456),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(456),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(2053),
    [aux_sym_preproc_if_token1] = ACTIONS(2055),
    [aux_sym_preproc_if_token2] = ACTIONS(2057),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2059),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2059),
    [sym_preproc_directive] = ACTIONS(2061),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [454] = {
    [sym_preproc_def] = STATE(454),
    [sym_preproc_function_def] = STATE(454),
    [sym_preproc_call] = STATE(454),
    [sym_preproc_if_in_field_declaration_list] = STATE(454),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(454),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1273),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(454),
    [sym_field_declaration] = STATE(454),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(454),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(2003),
    [aux_sym_preproc_def_token1] = ACTIONS(2063),
    [aux_sym_preproc_if_token1] = ACTIONS(2066),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2069),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2069),
    [sym_preproc_directive] = ACTIONS(2072),
    [anon_sym___extension__] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2023),
    [anon_sym___attribute__] = ACTIONS(2026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2032),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_signed] = ACTIONS(2035),
    [anon_sym_unsigned] = ACTIONS(2035),
    [anon_sym_long] = ACTIONS(2035),
    [anon_sym_short] = ACTIONS(2035),
    [anon_sym_static] = ACTIONS(2023),
    [anon_sym_auto] = ACTIONS(2023),
    [anon_sym_register] = ACTIONS(2023),
    [anon_sym_inline] = ACTIONS(2023),
    [anon_sym___inline] = ACTIONS(2023),
    [anon_sym___inline__] = ACTIONS(2023),
    [anon_sym___forceinline] = ACTIONS(2023),
    [anon_sym_thread_local] = ACTIONS(2023),
    [anon_sym___thread] = ACTIONS(2023),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym___restrict__] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym__Noreturn] = ACTIONS(2020),
    [anon_sym_noreturn] = ACTIONS(2020),
    [anon_sym__Nonnull] = ACTIONS(2020),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2041),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2047),
    [anon_sym_union] = ACTIONS(2050),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [sym_preproc_def] = STATE(454),
    [sym_preproc_function_def] = STATE(454),
    [sym_preproc_call] = STATE(454),
    [sym_preproc_if_in_field_declaration_list] = STATE(454),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(454),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1273),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(454),
    [sym_field_declaration] = STATE(454),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(454),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(2077),
    [aux_sym_preproc_if_token1] = ACTIONS(2079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2081),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2081),
    [sym_preproc_directive] = ACTIONS(2083),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_RBRACE] = ACTIONS(2085),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [456] = {
    [sym_preproc_def] = STATE(456),
    [sym_preproc_function_def] = STATE(456),
    [sym_preproc_call] = STATE(456),
    [sym_preproc_if_in_field_declaration_list] = STATE(456),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(456),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1272),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(456),
    [sym_field_declaration] = STATE(456),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(456),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(2003),
    [aux_sym_preproc_def_token1] = ACTIONS(2087),
    [aux_sym_preproc_if_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token2] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2093),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2093),
    [sym_preproc_directive] = ACTIONS(2096),
    [anon_sym___extension__] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2023),
    [anon_sym___attribute__] = ACTIONS(2026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2032),
    [anon_sym_signed] = ACTIONS(2035),
    [anon_sym_unsigned] = ACTIONS(2035),
    [anon_sym_long] = ACTIONS(2035),
    [anon_sym_short] = ACTIONS(2035),
    [anon_sym_static] = ACTIONS(2023),
    [anon_sym_auto] = ACTIONS(2023),
    [anon_sym_register] = ACTIONS(2023),
    [anon_sym_inline] = ACTIONS(2023),
    [anon_sym___inline] = ACTIONS(2023),
    [anon_sym___inline__] = ACTIONS(2023),
    [anon_sym___forceinline] = ACTIONS(2023),
    [anon_sym_thread_local] = ACTIONS(2023),
    [anon_sym___thread] = ACTIONS(2023),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym___restrict__] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym__Noreturn] = ACTIONS(2020),
    [anon_sym_noreturn] = ACTIONS(2020),
    [anon_sym__Nonnull] = ACTIONS(2020),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2041),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2047),
    [anon_sym_union] = ACTIONS(2050),
    [sym_comment] = ACTIONS(3),
  },
  [457] = {
    [sym_preproc_def] = STATE(453),
    [sym_preproc_function_def] = STATE(453),
    [sym_preproc_call] = STATE(453),
    [sym_preproc_if_in_field_declaration_list] = STATE(453),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(453),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1272),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(453),
    [sym_field_declaration] = STATE(453),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(453),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(2053),
    [aux_sym_preproc_if_token1] = ACTIONS(2055),
    [aux_sym_preproc_if_token2] = ACTIONS(2099),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2059),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2059),
    [sym_preproc_directive] = ACTIONS(2061),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [sym_compound_statement] = STATE(1597),
    [sym_expression] = STATE(1013),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_RPAREN] = ACTIONS(2101),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [459] = {
    [sym_compound_statement] = STATE(1787),
    [sym_expression] = STATE(1064),
    [sym__string] = STATE(679),
    [sym_comma_expression] = STATE(1787),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [460] = {
    [sym_compound_statement] = STATE(1652),
    [sym_expression] = STATE(1016),
    [sym__string] = STATE(679),
    [sym_conditional_expression] = STATE(679),
    [sym_assignment_expression] = STATE(679),
    [sym_pointer_expression] = STATE(835),
    [sym_unary_expression] = STATE(679),
    [sym_binary_expression] = STATE(679),
    [sym_update_expression] = STATE(679),
    [sym_cast_expression] = STATE(679),
    [sym_sizeof_expression] = STATE(679),
    [sym_alignof_expression] = STATE(679),
    [sym_offsetof_expression] = STATE(679),
    [sym_generic_expression] = STATE(679),
    [sym_subscript_expression] = STATE(835),
    [sym_call_expression] = STATE(835),
    [sym_gnu_asm_expression] = STATE(679),
    [sym_extension_expression] = STATE(679),
    [sym_field_expression] = STATE(835),
    [sym_compound_literal_expression] = STATE(679),
    [sym_parenthesized_expression] = STATE(835),
    [sym_char_literal] = STATE(679),
    [sym_concatenated_string] = STATE(679),
    [sym_string_literal] = STATE(668),
    [sym_null] = STATE(679),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_sizeof] = ACTIONS(83),
    [anon_sym___alignof__] = ACTIONS(85),
    [anon_sym___alignof] = ACTIONS(85),
    [anon_sym__alignof] = ACTIONS(85),
    [anon_sym_alignof] = ACTIONS(85),
    [anon_sym__Alignof] = ACTIONS(85),
    [anon_sym_offsetof] = ACTIONS(87),
    [anon_sym__Generic] = ACTIONS(89),
    [anon_sym_asm] = ACTIONS(91),
    [anon_sym___asm__] = ACTIONS(91),
    [anon_sym___asm] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(159),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [anon_sym_NULL] = ACTIONS(101),
    [anon_sym_nullptr] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [461] = {
    [sym_preproc_def] = STATE(455),
    [sym_preproc_function_def] = STATE(455),
    [sym_preproc_call] = STATE(455),
    [sym_preproc_if_in_field_declaration_list] = STATE(455),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(455),
    [sym__declaration_modifiers] = STATE(706),
    [sym__declaration_specifiers] = STATE(1273),
    [sym_attribute_specifier] = STATE(706),
    [sym_attribute_declaration] = STATE(706),
    [sym_ms_declspec_modifier] = STATE(706),
    [sym_storage_class_specifier] = STATE(706),
    [sym_type_qualifier] = STATE(706),
    [sym_alignas_qualifier] = STATE(710),
    [sym_type_specifier] = STATE(718),
    [sym_sized_type_specifier] = STATE(748),
    [sym_enum_specifier] = STATE(748),
    [sym_struct_specifier] = STATE(748),
    [sym_union_specifier] = STATE(748),
    [sym__field_declaration_list_item] = STATE(455),
    [sym_field_declaration] = STATE(455),
    [sym_macro_type_specifier] = STATE(748),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(455),
    [aux_sym__declaration_specifiers_repeat1] = STATE(706),
    [aux_sym_sized_type_specifier_repeat1] = STATE(751),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(2077),
    [aux_sym_preproc_if_token1] = ACTIONS(2079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2081),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2081),
    [sym_preproc_directive] = ACTIONS(2083),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1121),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [anon_sym__Nonnull] = ACTIONS(47),
    [anon_sym_alignas] = ACTIONS(49),
    [anon_sym__Alignas] = ACTIONS(49),
    [sym_primitive_type] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_struct] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_COLON,
    STATE(668), 1,
      sym_string_literal,
    STATE(1038), 1,
      sym_expression,
    STATE(1800), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [113] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1053), 1,
      sym_expression,
    STATE(1737), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [226] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2109), 1,
      anon_sym_RPAREN,
    STATE(668), 1,
      sym_string_literal,
    STATE(1029), 1,
      sym_expression,
    STATE(1976), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [339] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      anon_sym_SEMI,
    STATE(668), 1,
      sym_string_literal,
    STATE(1035), 1,
      sym_expression,
    STATE(2008), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [452] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2113), 1,
      anon_sym_SEMI,
    STATE(668), 1,
      sym_string_literal,
    STATE(1047), 1,
      sym_expression,
    STATE(1912), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [565] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1391), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(675), 1,
      sym_initializer_list,
    STATE(704), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [678] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2119), 1,
      anon_sym_SEMI,
    STATE(668), 1,
      sym_string_literal,
    STATE(1045), 1,
      sym_expression,
    STATE(1924), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [791] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2121), 1,
      anon_sym_COLON,
    STATE(668), 1,
      sym_string_literal,
    STATE(1062), 1,
      sym_expression,
    STATE(1804), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [904] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1391), 1,
      anon_sym_LBRACE,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1030), 1,
      sym_expression,
    STATE(1698), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1017] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1391), 1,
      anon_sym_LBRACE,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(675), 1,
      sym_initializer_list,
    STATE(700), 1,
      sym_string_literal,
    STATE(704), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1130] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1391), 1,
      anon_sym_LBRACE,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(675), 1,
      sym_initializer_list,
    STATE(884), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1243] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2135), 1,
      anon_sym_SEMI,
    STATE(668), 1,
      sym_string_literal,
    STATE(1021), 1,
      sym_expression,
    STATE(1797), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1356] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2137), 1,
      anon_sym_SEMI,
    STATE(668), 1,
      sym_string_literal,
    STATE(1044), 1,
      sym_expression,
    STATE(1848), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1469] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2139), 1,
      anon_sym_SEMI,
    STATE(668), 1,
      sym_string_literal,
    STATE(1023), 1,
      sym_expression,
    STATE(1959), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1582] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2141), 1,
      anon_sym_COLON,
    STATE(668), 1,
      sym_string_literal,
    STATE(1025), 1,
      sym_expression,
    STATE(1768), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1695] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_RPAREN,
    STATE(668), 1,
      sym_string_literal,
    STATE(1037), 1,
      sym_expression,
    STATE(1809), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1808] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_RPAREN,
    STATE(668), 1,
      sym_string_literal,
    STATE(1039), 1,
      sym_expression,
    STATE(1831), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1921] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2147), 1,
      anon_sym_RPAREN,
    STATE(668), 1,
      sym_string_literal,
    STATE(1020), 1,
      sym_expression,
    STATE(1838), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2034] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1391), 1,
      anon_sym_LBRACE,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(675), 1,
      sym_initializer_list,
    STATE(700), 1,
      sym_string_literal,
    STATE(704), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2147] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2153), 1,
      anon_sym_SEMI,
    STATE(668), 1,
      sym_string_literal,
    STATE(1033), 1,
      sym_expression,
    STATE(1929), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2260] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2155), 1,
      anon_sym_COLON,
    STATE(668), 1,
      sym_string_literal,
    STATE(1046), 1,
      sym_expression,
    STATE(1869), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2373] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1391), 1,
      anon_sym_LBRACE,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(675), 1,
      sym_initializer_list,
    STATE(884), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2486] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2157), 1,
      anon_sym_COLON,
    STATE(668), 1,
      sym_string_literal,
    STATE(1049), 1,
      sym_expression,
    STATE(1897), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2599] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1391), 1,
      anon_sym_LBRACE,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(675), 1,
      sym_initializer_list,
    STATE(704), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2712] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2159), 1,
      anon_sym_RPAREN,
    STATE(668), 1,
      sym_string_literal,
    STATE(1041), 1,
      sym_expression,
    STATE(1837), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2825] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1391), 1,
      anon_sym_LBRACE,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1027), 1,
      sym_expression,
    STATE(1736), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2938] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2161), 1,
      anon_sym_COLON,
    STATE(668), 1,
      sym_string_literal,
    STATE(1060), 1,
      sym_expression,
    STATE(1983), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3051] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1391), 1,
      anon_sym_LBRACE,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1036), 1,
      sym_expression,
    STATE(1690), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3164] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2163), 1,
      anon_sym_RPAREN,
    STATE(668), 1,
      sym_string_literal,
    STATE(1043), 1,
      sym_expression,
    STATE(1843), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3277] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2165), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3387] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2167), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3497] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2169), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3607] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1010), 1,
      sym_expression,
    STATE(1629), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3717] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2171), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3827] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2173), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3937] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2175), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4047] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2177), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4157] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2179), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4267] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2181), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4377] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2183), 1,
      anon_sym_RBRACK,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4487] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(2185), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(898), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4594] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(703), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4701] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(830), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4808] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(703), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4915] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(833), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5022] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(818), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5129] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(819), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5236] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(820), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5343] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(822), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5450] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(823), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5557] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(824), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5664] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(827), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5771] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1011), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5878] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(701), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5985] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(702), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6092] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(707), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6199] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2187), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(705), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6306] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(825), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6413] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      anon_sym_LBRACE,
    STATE(688), 1,
      sym_ms_call_modifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1135), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(296), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [6522] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(961), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6629] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1018), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6736] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(962), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6843] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(703), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6950] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(963), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7057] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(964), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7164] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(965), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7271] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(967), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7378] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(968), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7485] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(969), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7592] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(958), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7699] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(970), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7806] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1066), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7913] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(701), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8020] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1092), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8127] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(959), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8234] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(957), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8341] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(988), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8448] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(960), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8555] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    ACTIONS(2191), 1,
      anon_sym_LBRACE,
    STATE(696), 1,
      sym_ms_call_modifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1140), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(366), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [8664] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(982), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8771] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(983), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8878] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(821), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8985] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(797), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9092] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(905), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9199] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(798), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9306] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(799), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9413] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(800), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9520] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(801), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9627] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(802), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9734] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(803), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9841] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(804), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9948] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(805), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10055] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(986), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10162] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(806), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10269] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1083), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10376] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(702), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10483] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(978), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10590] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(807), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10697] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(984), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10804] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(701), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10911] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1080), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11018] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(707), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11125] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(980), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11232] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(966), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11339] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    ACTIONS(2193), 1,
      anon_sym_LBRACE,
    STATE(691), 1,
      sym_ms_call_modifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1146), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(134), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [11448] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1014), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11555] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(985), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11662] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(707), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11769] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(705), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11876] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1771), 1,
      anon_sym_const,
    ACTIONS(1775), 1,
      anon_sym_LPAREN2,
    ACTIONS(1781), 1,
      anon_sym_STAR,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    STATE(625), 1,
      sym_string_literal,
    STATE(752), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1794), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2197), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1784), 11,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(1773), 12,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [11967] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(989), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12074] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(703), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12181] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(701), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12288] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(707), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12395] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2199), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(705), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12502] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1401), 1,
      anon_sym___extension__,
    ACTIONS(1403), 1,
      anon_sym_sizeof,
    ACTIONS(2115), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(831), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1397), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1399), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2117), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12609] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1389), 1,
      anon_sym___extension__,
    ACTIONS(1393), 1,
      anon_sym_sizeof,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(809), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1385), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1387), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2151), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12716] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    ACTIONS(2201), 1,
      anon_sym_LBRACE,
    STATE(693), 1,
      sym_ms_call_modifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1137), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(302), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [12825] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1022), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12932] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1077), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13039] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(990), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13146] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1048), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13253] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1050), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13360] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(905), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13467] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1052), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13574] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1054), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13681] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1055), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13788] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1056), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13895] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1057), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14002] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1058), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14109] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1059), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14216] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1061), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14323] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1028), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14430] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1090), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14537] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1063), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14644] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1024), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14751] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(886), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14858] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(887), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14965] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(888), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15072] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(889), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15179] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(890), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15286] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(891), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15393] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(893), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15500] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(896), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15607] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(899), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15714] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(901), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15821] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(904), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15928] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(894), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16035] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(897), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16142] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2203), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(898), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16249] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(883), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16356] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1071), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16463] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1067), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16570] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(976), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16677] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1069), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16784] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(894), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16891] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1395), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym___extension__,
    ACTIONS(1723), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(895), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1717), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1719), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2133), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(686), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16998] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(897), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17105] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(972), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17212] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1040), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17319] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym___extension__,
    ACTIONS(1769), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_LPAREN2,
    STATE(668), 1,
      sym_string_literal,
    STATE(1093), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1763), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1765), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1826), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1838), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(906), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17426] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(83), 1,
      anon_sym_sizeof,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1506), 1,
      anon_sym___extension__,
    ACTIONS(1737), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(973), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(81), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(835), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17533] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_offsetof,
    ACTIONS(89), 1,
      anon_sym__Generic,
    ACTIONS(159), 1,
      sym_number_literal,
    ACTIONS(1743), 1,
      anon_sym___extension__,
    ACTIONS(1745), 1,
      anon_sym_sizeof,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2205), 1,
      anon_sym_LPAREN2,
    STATE(700), 1,
      sym_string_literal,
    STATE(705), 1,
      sym_expression,
    ACTIONS(101), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(161), 2,
      sym_true,
      sym_false,
    ACTIONS(1739), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1741), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2127), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2129), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(85), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(828), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(679), 17,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_extension_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17640] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 1,
      sym_identifier,
    STATE(626), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2211), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2209), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [17711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      sym_identifier,
    STATE(627), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2217), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2215), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [17782] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      sym_identifier,
    STATE(627), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2226), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2224), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2222), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [17853] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1812), 1,
      anon_sym_RPAREN,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1114), 1,
      sym__declaration_specifiers,
    STATE(1770), 1,
      sym_compound_statement,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1623), 2,
      sym_variadic_parameter,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [17959] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_RPAREN,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1114), 1,
      sym__declaration_specifiers,
    STATE(1492), 1,
      sym_variadic_parameter,
    STATE(1623), 1,
      sym_parameter_declaration,
    STATE(1770), 1,
      sym_compound_statement,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [18067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1779), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1773), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2233), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2235), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2239), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2243), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2247), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2249), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2251), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2253), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2255), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [18513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2257), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2259), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18576] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 1,
      anon_sym___attribute__,
    ACTIONS(2274), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2277), 1,
      anon_sym___declspec,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(2280), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2263), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(638), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2265), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
    ACTIONS(2268), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(2261), 17,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [18655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2285), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2289), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2291), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2293), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [18844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2295), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2297), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2301), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18970] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(275), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(657), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19070] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(142), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(666), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19170] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(125), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(666), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19270] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(284), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(649), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19370] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(264), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(666), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19470] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(266), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(666), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19570] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(268), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(652), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19670] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(128), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(645), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19770] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(280), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(666), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19870] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(372), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(666), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [19970] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(362), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(653), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [20070] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(359), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(666), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [20170] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(135), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(646), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [20270] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(311), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(666), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [20370] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(376), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(655), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [20470] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(295), 1,
      sym_compound_statement,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(648), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [20570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2303), 44,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
  [20631] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1114), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1718), 2,
      sym_variadic_parameter,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [20728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2309), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2307), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym___try,
      anon_sym___leave,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [20789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1731), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1729), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym___try,
      anon_sym___leave,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [20850] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_static,
    STATE(681), 1,
      sym_alignas_qualifier,
    ACTIONS(2321), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(664), 2,
      sym_type_qualifier,
      aux_sym_array_declarator_repeat1,
    ACTIONS(2315), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
    ACTIONS(2311), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(2313), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [20921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1733), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym___try,
      anon_sym___leave,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [20982] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2324), 1,
      sym_identifier,
    ACTIONS(2333), 1,
      anon_sym___attribute__,
    ACTIONS(2336), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2339), 1,
      anon_sym___declspec,
    ACTIONS(2342), 1,
      anon_sym_LBRACE,
    ACTIONS(2350), 1,
      sym_primitive_type,
    ACTIONS(2353), 1,
      anon_sym_enum,
    ACTIONS(2356), 1,
      anon_sym_struct,
    ACTIONS(2359), 1,
      anon_sym_union,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1130), 1,
      sym__declaration_specifiers,
    ACTIONS(2347), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(666), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(2344), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2327), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
    ACTIONS(2330), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21079] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2362), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1114), 1,
      sym__declaration_specifiers,
    STATE(1675), 1,
      sym_variadic_parameter,
    STATE(1718), 1,
      sym_parameter_declaration,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [21178] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      sym_identifier,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2368), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2366), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2307), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2309), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21302] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1206), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [21392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2370), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2372), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2376), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2378), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2380), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2384), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2388), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2392), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2396), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2400), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1779), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1773), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2402), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2404), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1707), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1705), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_static,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [22030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2408), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2406), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_static,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [22088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2412), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2416), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2420), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1779), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1773), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2424), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22378] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1248), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [22468] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1212), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [22558] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1225), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [22648] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1243), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [22738] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1218), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [22828] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1249), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [22918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2426), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2428), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2432), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [23034] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(718), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1247), 1,
      sym__declaration_specifiers,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(706), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [23124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2436), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [23181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2440), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [23238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2444), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [23295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2368), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2366), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [23356] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2446), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2448), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [23421] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2456), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2458), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23488] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2464), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23555] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2466), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2468), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23622] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2470), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2472), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23689] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_enum,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(721), 1,
      sym_type_specifier,
    STATE(751), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(638), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [23776] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2474), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2476), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23843] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 1,
      anon_sym_EQ,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2480), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      sym_identifier,
    ACTIONS(1773), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [23908] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    STATE(728), 1,
      sym_field_declaration_list,
    STATE(744), 1,
      sym_attribute_specifier,
    ACTIONS(2484), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2482), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [23972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1707), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(1705), 41,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24028] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    STATE(727), 1,
      sym_field_declaration_list,
    STATE(742), 1,
      sym_attribute_specifier,
    ACTIONS(2490), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2488), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2494), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2492), 41,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2408), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2406), 41,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24204] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    STATE(726), 1,
      sym_field_declaration_list,
    STATE(760), 1,
      sym_attribute_specifier,
    ACTIONS(2498), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2496), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24268] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    STATE(735), 1,
      sym_field_declaration_list,
    STATE(757), 1,
      sym_attribute_specifier,
    ACTIONS(2502), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2500), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24332] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [24396] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    STATE(732), 1,
      sym_field_declaration_list,
    STATE(774), 1,
      sym_attribute_specifier,
    ACTIONS(2506), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2504), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24460] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2510), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(722), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2508), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [24531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1731), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1729), 41,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24586] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2514), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(638), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2512), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [24657] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2518), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(720), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2516), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [24728] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2522), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(638), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2520), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [24799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2524), 41,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1733), 41,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(758), 1,
      sym_attribute_specifier,
    ACTIONS(2530), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2528), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(776), 1,
      sym_attribute_specifier,
    ACTIONS(2534), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2532), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25025] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(756), 1,
      sym_attribute_specifier,
    ACTIONS(2538), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2536), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(759), 1,
      sym_attribute_specifier,
    ACTIONS(2542), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2540), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(761), 1,
      sym_attribute_specifier,
    ACTIONS(2546), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2544), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(745), 1,
      sym_attribute_specifier,
    ACTIONS(2550), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2548), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2556), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2554), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2552), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(737), 1,
      sym_attribute_specifier,
    ACTIONS(2561), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2559), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(775), 1,
      sym_attribute_specifier,
    ACTIONS(2565), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2563), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(743), 1,
      sym_attribute_specifier,
    ACTIONS(2569), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2567), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(773), 1,
      sym_attribute_specifier,
    ACTIONS(2573), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2571), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(738), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2579), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2577), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2575), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [25604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2581), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2589), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2587), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2585), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [25714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2591), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2595), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2601), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2599), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2605), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2603), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2607), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2611), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2615), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26085] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 1,
      anon_sym_LPAREN2,
    STATE(752), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1786), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1784), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(1771), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [26144] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    ACTIONS(1803), 1,
      anon_sym_COLON,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [26207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2575), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26260] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2589), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2624), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2622), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [26317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2589), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2628), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2626), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [26374] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      sym_identifier,
    ACTIONS(2639), 1,
      sym_primitive_type,
    STATE(766), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2637), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2633), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2635), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
  [26435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2589), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2643), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2641), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [26492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2645), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2651), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2649), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2655), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2653), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2659), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2657), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2663), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2661), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2667), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2665), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2671), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2669), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2675), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2673), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2677), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2683), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2681), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2687), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2685), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(749), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2693), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2691), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2689), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [27132] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(750), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2699), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2697), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2695), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [27189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 1,
      sym_primitive_type,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2556), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2704), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2701), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [27248] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    ACTIONS(1790), 1,
      anon_sym_COLON,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27311] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    ACTIONS(2707), 1,
      anon_sym_COLON,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27374] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    ACTIONS(1797), 1,
      anon_sym_COLON,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2711), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2709), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2715), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2713), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27543] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    ACTIONS(1801), 1,
      anon_sym_COLON,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2717), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2723), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2721), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2725), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2731), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2729), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27818] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    ACTIONS(1799), 1,
      anon_sym_COLON,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2735), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2733), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2737), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [27986] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2745), 1,
      anon_sym_STAR,
    ACTIONS(2747), 1,
      anon_sym___attribute__,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1373), 1,
      sym__declarator,
    STATE(1419), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2743), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(925), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [28076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2757), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2755), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1327), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1325), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1277), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1305), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1329), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1333), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1269), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28440] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2759), 1,
      anon_sym_SEMI,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2510), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(722), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2508), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [28510] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 1,
      anon_sym_EQ,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2763), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1773), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [28570] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2765), 1,
      anon_sym_SEMI,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2510), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(722), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2508), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [28640] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2745), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    ACTIONS(2769), 1,
      anon_sym___attribute__,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1362), 1,
      sym__declarator,
    STATE(1405), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(2767), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(780), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(926), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [28730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2771), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28782] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2775), 1,
      anon_sym_SEMI,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2510), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(722), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2508), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [28852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2777), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2783), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2781), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [28956] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2797), 1,
      anon_sym_PIPE,
    ACTIONS(2799), 1,
      anon_sym_CARET,
    ACTIONS(2801), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2787), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2785), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29042] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 11,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2464), 23,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29106] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2797), 1,
      anon_sym_PIPE,
    ACTIONS(2799), 1,
      anon_sym_CARET,
    ACTIONS(2801), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29188] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2797), 1,
      anon_sym_PIPE,
    ACTIONS(2799), 1,
      anon_sym_CARET,
    ACTIONS(2801), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29268] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2799), 1,
      anon_sym_CARET,
    ACTIONS(2801), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2462), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29346] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2801), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2464), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29422] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2464), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29496] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2464), 21,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29568] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2464), 23,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29636] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2464), 23,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29702] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2797), 1,
      anon_sym_PIPE,
    ACTIONS(2799), 1,
      anon_sym_CARET,
    ACTIONS(2801), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2815), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2813), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29788] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2797), 1,
      anon_sym_PIPE,
    ACTIONS(2799), 1,
      anon_sym_CARET,
    ACTIONS(2801), 1,
      anon_sym_AMP,
    ACTIONS(2811), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2819), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2817), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [29874] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1121), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2821), 1,
      anon_sym_SEMI,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2510), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(722), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2508), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [29944] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2797), 1,
      anon_sym_PIPE,
    ACTIONS(2799), 1,
      anon_sym_CARET,
    ACTIONS(2801), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2805), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2807), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2809), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2825), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2823), 17,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2829), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2827), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2833), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2831), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2837), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2835), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2839), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2845), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2843), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2849), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2847), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2853), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2851), 43,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30392] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2787), 1,
      anon_sym_EQ,
    ACTIONS(2859), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE,
    ACTIONS(2865), 1,
      anon_sym_CARET,
    ACTIONS(2867), 1,
      anon_sym_AMP,
    ACTIONS(2877), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2869), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2785), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30477] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2462), 1,
      anon_sym_EQ,
    ACTIONS(2863), 1,
      anon_sym_PIPE,
    ACTIONS(2865), 1,
      anon_sym_CARET,
    ACTIONS(2867), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2869), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30556] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2865), 1,
      anon_sym_CARET,
    ACTIONS(2867), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2869), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30633] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2867), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2869), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2462), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30708] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      anon_sym_EQ,
    ACTIONS(2859), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE,
    ACTIONS(2865), 1,
      anon_sym_CARET,
    ACTIONS(2867), 1,
      anon_sym_AMP,
    ACTIONS(2877), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2869), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2813), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30793] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2869), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2464), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30866] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2464), 21,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30937] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2464), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31004] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2825), 1,
      anon_sym_EQ,
    ACTIONS(2859), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE,
    ACTIONS(2865), 1,
      anon_sym_CARET,
    ACTIONS(2867), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2869), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2823), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31087] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 1,
      anon_sym___attribute__,
    ACTIONS(2886), 1,
      anon_sym_LBRACE,
    ACTIONS(2888), 1,
      anon_sym_COLON,
    STATE(778), 1,
      sym_attribute_specifier,
    STATE(867), 1,
      sym_enumerator_list,
    ACTIONS(2881), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2879), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [31148] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2464), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 1,
      anon_sym_EQ,
    ACTIONS(2480), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [31268] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 2,
      anon_sym___attribute__,
      sym_identifier,
    ACTIONS(2897), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2893), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(2900), 4,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(2895), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
  [31325] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2464), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31388] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2819), 1,
      anon_sym_EQ,
    ACTIONS(2859), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE,
    ACTIONS(2865), 1,
      anon_sym_CARET,
    ACTIONS(2867), 1,
      anon_sym_AMP,
    ACTIONS(2877), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2869), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2817), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31473] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 2,
      anon_sym___attribute__,
      sym_identifier,
    ACTIONS(2909), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2905), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(2912), 4,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(2907), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
  [31530] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2462), 1,
      anon_sym_EQ,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE,
    ACTIONS(2865), 1,
      anon_sym_CARET,
    ACTIONS(2867), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2855), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2869), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2871), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2873), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2875), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2857), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2886), 1,
      anon_sym_LBRACE,
    ACTIONS(2918), 1,
      anon_sym___attribute__,
    STATE(771), 1,
      sym_attribute_specifier,
    STATE(852), 1,
      sym_enumerator_list,
    ACTIONS(2916), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2914), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [31669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [31723] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1816), 1,
      anon_sym_STAR,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2743), 1,
      anon_sym_RPAREN,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1283), 1,
      sym__declarator,
    STATE(1419), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(943), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [31809] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1816), 1,
      anon_sym_STAR,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    ACTIONS(2767), 1,
      anon_sym_RPAREN,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1278), 1,
      sym__declarator,
    STATE(1405), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(836), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(949), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [31895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2291), 39,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2253), 39,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1277), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2837), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2835), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2839), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2845), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2843), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2849), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2847), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1327), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1325), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2757), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2755), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2849), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2847), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1277), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1305), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2833), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2831), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2837), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2835), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym___attribute__,
    STATE(763), 1,
      sym_attribute_specifier,
    ACTIONS(2923), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2921), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [32621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2737), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2839), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym___attribute__,
    STATE(740), 1,
      sym_attribute_specifier,
    ACTIONS(2930), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2928), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [32769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2845), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2843), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1329), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1333), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2777), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1269), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(540), 1,
      sym_string_literal,
    ACTIONS(2935), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2524), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2737), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2853), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2851), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2773), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2771), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2853), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2851), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2783), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2781), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 1,
      anon_sym___attribute__,
    STATE(754), 1,
      sym_attribute_specifier,
    ACTIONS(2939), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2937), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [33353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2773), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2771), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2829), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2827), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2777), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1327), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1325), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2783), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2781), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(520), 1,
      sym_string_literal,
    ACTIONS(2935), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2524), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1305), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1329), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1333), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1269), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2829), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2827), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(566), 1,
      sym_string_literal,
    ACTIONS(2935), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2524), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(579), 1,
      sym_string_literal,
    ACTIONS(2935), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2524), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2833), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2831), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [34037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2757), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2755), 39,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [34085] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2825), 1,
      anon_sym_EQ,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2823), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34166] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2466), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2468), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34225] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2787), 1,
      anon_sym_EQ,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(2970), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2785), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34308] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2464), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34369] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2462), 1,
      anon_sym_EQ,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34448] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2462), 1,
      anon_sym_EQ,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34525] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34600] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2462), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2464), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34673] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2464), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34744] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1339), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(999), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [34821] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2464), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34890] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2446), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2448), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [34947] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2456), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2458), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35006] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2464), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35071] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2474), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2476), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35130] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2470), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2472), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35189] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2462), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2464), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35252] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1340), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(892), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1005), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [35329] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2815), 1,
      anon_sym_EQ,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(2970), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2813), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35412] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1339), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(903), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(999), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [35489] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1346), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1000), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [35566] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2819), 1,
      anon_sym_EQ,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2954), 1,
      anon_sym_PIPE,
    ACTIONS(2956), 1,
      anon_sym_CARET,
    ACTIONS(2958), 1,
      anon_sym_AMP,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(2970), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2960), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2962), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2964), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2817), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35649] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2464), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 1,
      anon_sym_EQ,
    ACTIONS(2763), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1773), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [35758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1191), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [35804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1191), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [35850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1203), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [35896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1203), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [35942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1205), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1207), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [35988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1205), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1207), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [36034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2444), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [36080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2440), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [36126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1233), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1235), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [36172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1239), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [36218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1239), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [36264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1251), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [36310] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 1,
      anon_sym_LPAREN2,
    ACTIONS(2982), 1,
      anon_sym_COMMA,
    ACTIONS(2985), 1,
      anon_sym_RPAREN,
    STATE(752), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1645), 1,
      aux_sym__old_style_parameter_list_repeat1,
    ACTIONS(1784), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1786), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1771), 27,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [36368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2988), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2436), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [36460] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 1,
      anon_sym_LPAREN2,
    STATE(752), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1784), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2992), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1786), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1771), 27,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [36513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 1,
      anon_sym_LPAREN2,
    ACTIONS(3002), 1,
      anon_sym_LBRACK,
    STATE(752), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1784), 2,
      anon_sym_COMMA,
      anon_sym_STAR,
    ACTIONS(2995), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1786), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1771), 26,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [36568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ,
    ACTIONS(3005), 1,
      anon_sym_SEMI,
    ACTIONS(1792), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1779), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1773), 13,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [36619] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2745), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    ACTIONS(3009), 1,
      anon_sym___attribute__,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1354), 1,
      sym__declarator,
    STATE(1426), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3007), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [36693] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2745), 1,
      anon_sym_STAR,
    ACTIONS(2747), 1,
      anon_sym___attribute__,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1373), 1,
      sym__declarator,
    STATE(1419), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2743), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [36767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1201), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1201), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1205), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1205), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36939] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(1949), 1,
      anon_sym_LPAREN2,
    ACTIONS(1951), 1,
      anon_sym_STAR,
    ACTIONS(2749), 1,
      sym_ms_restrict_modifier,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1405), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    ACTIONS(3013), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3015), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3017), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(941), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1073), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2767), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3011), 9,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [37012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1233), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1239), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1237), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1239), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1237), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1249), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1189), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1189), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(3019), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3025), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(3023), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3027), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2907), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37399] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(1949), 1,
      anon_sym_LPAREN2,
    ACTIONS(1951), 1,
      anon_sym_STAR,
    ACTIONS(2749), 1,
      sym_ms_restrict_modifier,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1419), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    ACTIONS(3013), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3015), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3017), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1087), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2743), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3011), 9,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [37472] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3031), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1373), 1,
      sym__declarator,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(950), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1105), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [37540] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1816), 1,
      anon_sym_STAR,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    ACTIONS(3007), 1,
      anon_sym_RPAREN,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1282), 1,
      sym__declarator,
    STATE(1426), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [37610] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(3040), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3037), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3035), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3033), 20,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [37660] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1282), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1099), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [37728] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1312), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(951), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1101), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [37796] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1331), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(956), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1104), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [37864] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3031), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1373), 1,
      sym__declarator,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1105), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [37932] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1816), 1,
      anon_sym_STAR,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2743), 1,
      anon_sym_RPAREN,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1283), 1,
      sym__declarator,
    STATE(1419), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [38002] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3031), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1354), 1,
      sym__declarator,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1098), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [38070] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1331), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1104), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [38138] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1283), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1102), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [38206] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1283), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(945), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1102), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [38274] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1278), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(952), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1097), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [38342] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3031), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1362), 1,
      sym__declarator,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(948), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1106), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [38410] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1001), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1329), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2751), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(944), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1096), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2749), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [38478] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3053), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    ACTIONS(3061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3065), 1,
      anon_sym_PIPE,
    ACTIONS(3067), 1,
      anon_sym_CARET,
    ACTIONS(3069), 1,
      anon_sym_AMP,
    ACTIONS(3079), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3051), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [38555] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2462), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2464), 14,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      sym_identifier,
  [38614] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2815), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    ACTIONS(3061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3065), 1,
      anon_sym_PIPE,
    ACTIONS(3067), 1,
      anon_sym_CARET,
    ACTIONS(3069), 1,
      anon_sym_AMP,
    ACTIONS(3079), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2813), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [38691] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2819), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    ACTIONS(3061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3065), 1,
      anon_sym_PIPE,
    ACTIONS(3067), 1,
      anon_sym_CARET,
    ACTIONS(3069), 1,
      anon_sym_AMP,
    ACTIONS(3079), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2817), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [38768] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2787), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    ACTIONS(3061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3065), 1,
      anon_sym_PIPE,
    ACTIONS(3067), 1,
      anon_sym_CARET,
    ACTIONS(3069), 1,
      anon_sym_AMP,
    ACTIONS(3079), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2785), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [38845] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2462), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2464), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      sym_identifier,
  [38900] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2462), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    ACTIONS(3063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3065), 1,
      anon_sym_PIPE,
    ACTIONS(3067), 1,
      anon_sym_CARET,
    ACTIONS(3069), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 8,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      sym_identifier,
  [38973] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2462), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    ACTIONS(3065), 1,
      anon_sym_PIPE,
    ACTIONS(3067), 1,
      anon_sym_CARET,
    ACTIONS(3069), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 9,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      sym_identifier,
  [39044] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    ACTIONS(3067), 1,
      anon_sym_CARET,
    ACTIONS(3069), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 9,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      sym_identifier,
  [39113] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2825), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    ACTIONS(3061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3063), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3065), 1,
      anon_sym_PIPE,
    ACTIONS(3067), 1,
      anon_sym_CARET,
    ACTIONS(3069), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2823), 7,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      sym_identifier,
  [39188] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    ACTIONS(3069), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 10,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_identifier,
  [39255] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3071), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2462), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2464), 10,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_identifier,
  [39320] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3073), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3075), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2462), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2464), 12,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      sym_identifier,
  [39383] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3059), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3057), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2462), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2464), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      sym_identifier,
  [39440] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1947), 1,
      sym_identifier,
    ACTIONS(3081), 1,
      anon_sym_enum,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1095), 1,
      sym_type_specifier,
    STATE(1108), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1850), 1,
      sym_type_descriptor,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(998), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1713), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [39504] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2823), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [39576] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2462), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2464), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [39630] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1095), 1,
      sym_type_specifier,
    STATE(1108), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1885), 1,
      sym_type_descriptor,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1004), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1713), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [39694] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(3114), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3109), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3111), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
    ACTIONS(3107), 11,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39742] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2462), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2464), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [39798] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1947), 1,
      sym_identifier,
    ACTIONS(3081), 1,
      anon_sym_enum,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1095), 1,
      sym_type_specifier,
    STATE(1108), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1971), 1,
      sym_type_descriptor,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(998), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1713), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [39862] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [39928] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1095), 1,
      sym_type_specifier,
    STATE(1108), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1829), 1,
      sym_type_descriptor,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1004), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1713), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [39992] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [40062] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3121), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1110), 1,
      sym_type_specifier,
    STATE(1115), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1254), 1,
      sym__type_definition_type,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1009), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3119), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [40126] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [40194] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2813), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [40268] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2785), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [40342] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [40406] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [40474] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3121), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1110), 1,
      sym_type_specifier,
    STATE(1115), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1253), 1,
      sym__type_definition_type,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1009), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3119), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [40538] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2817), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [40612] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [40674] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2462), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2464), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [40732] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3121), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1110), 1,
      sym_type_specifier,
    STATE(1115), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1255), 1,
      sym__type_definition_type,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1009), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3119), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [40796] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1095), 1,
      sym_type_specifier,
    STATE(1108), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1866), 1,
      sym_type_descriptor,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1004), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1713), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [40860] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3121), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1110), 1,
      sym_type_specifier,
    STATE(1115), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1256), 1,
      sym__type_definition_type,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1009), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3119), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [40924] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3121), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1110), 1,
      sym_type_specifier,
    STATE(1115), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1258), 1,
      sym__type_definition_type,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1009), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3119), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [40988] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3121), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1110), 1,
      sym_type_specifier,
    STATE(1115), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1257), 1,
      sym__type_definition_type,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1009), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3119), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [41052] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3121), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1110), 1,
      sym_type_specifier,
    STATE(1115), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1259), 1,
      sym__type_definition_type,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1009), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3119), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [41116] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3121), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1110), 1,
      sym_type_specifier,
    STATE(1115), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1252), 1,
      sym__type_definition_type,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1009), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3119), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [41180] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1947), 1,
      sym_identifier,
    ACTIONS(3081), 1,
      anon_sym_enum,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1076), 1,
      sym_type_specifier,
    STATE(1108), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1713), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [41241] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1346), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [41302] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1337), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [41363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3125), 25,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [41402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 12,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
    ACTIONS(3131), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [41441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3133), 25,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [41480] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      sym_primitive_type,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(1947), 1,
      sym_identifier,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1076), 1,
      sym_type_specifier,
    STATE(1108), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1713), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [41541] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1339), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [41602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 12,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
    ACTIONS(3139), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [41641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3141), 12,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
    ACTIONS(3143), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [41680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 12,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
    ACTIONS(3147), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [41719] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_struct,
    ACTIONS(57), 1,
      anon_sym_union,
    ACTIONS(1715), 1,
      anon_sym_enum,
    ACTIONS(3117), 1,
      sym_identifier,
    ACTIONS(3121), 1,
      sym_primitive_type,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1109), 1,
      sym_type_specifier,
    STATE(1115), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3119), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(748), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [41780] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3151), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [41854] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3153), 1,
      anon_sym_COMMA,
    ACTIONS(3155), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    STATE(1627), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41929] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3159), 1,
      anon_sym_RBRACE,
    STATE(673), 1,
      sym_argument_list,
    STATE(1551), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42004] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    STATE(1637), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42079] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3165), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [42150] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2886), 1,
      anon_sym_LBRACE,
    STATE(771), 1,
      sym_attribute_specifier,
    STATE(1081), 1,
      sym_enumerator_list,
    ACTIONS(2916), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2914), 19,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [42195] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    STATE(1573), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42270] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2886), 1,
      anon_sym_LBRACE,
    ACTIONS(3169), 1,
      anon_sym_COLON,
    STATE(778), 1,
      sym_attribute_specifier,
    STATE(1094), 1,
      sym_enumerator_list,
    ACTIONS(2881), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(2879), 19,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [42317] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3171), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3197), 1,
      anon_sym_RBRACK,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42391] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3201), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42463] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42535] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3205), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42607] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3051), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42677] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3207), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42749] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2817), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42821] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3209), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42893] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3211), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42965] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3213), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [43035] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3215), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [43105] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3217), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43177] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3219), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [43247] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3221), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43319] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3223), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [43389] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3225), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43461] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3227), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43533] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3229), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43605] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3231), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [43675] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43747] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3235), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43819] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3237), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43891] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2823), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [43961] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3239), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44033] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3241), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44105] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3243), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44177] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3245), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44249] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3247), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44321] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3249), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44393] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3251), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44465] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2785), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44537] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3253), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44609] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2462), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2464), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [44661] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_SEMI,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44733] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [44801] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3257), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [44871] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [44937] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [45003] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [45067] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [45129] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2462), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2464), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [45189] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2462), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2464), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [45245] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3259), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45317] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2462), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2464), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [45371] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3261), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45443] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_DASH_GT,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(2968), 1,
      anon_sym_DOT,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2813), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45515] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3149), 1,
      anon_sym_COMMA,
    ACTIONS(3263), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45587] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2167), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45656] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    ACTIONS(3265), 1,
      anon_sym_RBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45725] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3267), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45794] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3269), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45863] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3271), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45932] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46001] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46070] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(1949), 1,
      anon_sym_LPAREN2,
    ACTIONS(1951), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1452), 1,
      sym__abstract_declarator,
    ACTIONS(3017), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3275), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3011), 9,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [46125] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(1949), 1,
      anon_sym_LPAREN2,
    ACTIONS(1951), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1419), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    ACTIONS(3017), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2743), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3011), 9,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [46180] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2179), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46249] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46318] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(1949), 1,
      anon_sym_LPAREN2,
    ACTIONS(1951), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1454), 1,
      sym__abstract_declarator,
    ACTIONS(3017), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1084), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3277), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3011), 9,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [46373] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3279), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46442] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(740), 1,
      sym_attribute_specifier,
    ACTIONS(2930), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2928), 19,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [46550] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3281), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(763), 1,
      sym_attribute_specifier,
    ACTIONS(2923), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2921), 19,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [46658] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3283), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46727] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3285), 1,
      anon_sym_COMMA,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46796] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(1949), 1,
      anon_sym_LPAREN2,
    ACTIONS(1951), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1467), 1,
      sym__abstract_declarator,
    ACTIONS(3017), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3287), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3011), 9,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [46851] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2177), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46920] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46989] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(1949), 1,
      anon_sym_LPAREN2,
    ACTIONS(1951), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1426), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    ACTIONS(3017), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3007), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3011), 9,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [47044] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47113] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2169), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47182] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3289), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47251] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2171), 1,
      anon_sym_RBRACK,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47320] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    ACTIONS(3291), 1,
      anon_sym_COLON,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47389] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2944), 1,
      anon_sym_LPAREN2,
    ACTIONS(3177), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3181), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3183), 1,
      anon_sym_PIPE,
    ACTIONS(3185), 1,
      anon_sym_CARET,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3199), 1,
      anon_sym_QMARK,
    ACTIONS(3293), 1,
      anon_sym_RBRACK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3173), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3175), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3189), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3193), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3195), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47458] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(754), 1,
      sym_attribute_specifier,
    ACTIONS(2939), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2937), 19,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [47497] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(1949), 1,
      anon_sym_LPAREN2,
    ACTIONS(1951), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1471), 1,
      sym__abstract_declarator,
    ACTIONS(3017), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3295), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3011), 9,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [47552] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1317), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [47604] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1283), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [47656] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3031), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1355), 1,
      sym__declarator,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [47708] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1279), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [47760] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_SLASH,
    ACTIONS(3089), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3091), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3093), 1,
      anon_sym_PIPE,
    ACTIONS(3095), 1,
      anon_sym_CARET,
    ACTIONS(3097), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym_argument_list,
    ACTIONS(2454), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2460), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3083), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3085), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3099), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3101), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3103), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3105), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47826] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1331), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [47878] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1282), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [47930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_SEMI,
    ACTIONS(1779), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1773), 18,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [47966] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1329), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [48018] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3031), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1354), 1,
      sym__declarator,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [48070] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3031), 1,
      anon_sym_STAR,
    STATE(710), 1,
      sym_alignas_qualifier,
    STATE(1373), 1,
      sym__declarator,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [48122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2552), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(2556), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2704), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2701), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
  [48161] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2639), 1,
      sym_primitive_type,
    ACTIONS(3297), 1,
      sym_identifier,
    STATE(1107), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3299), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2633), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2635), 12,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
  [48202] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3303), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1112), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3301), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [48242] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3307), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1111), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3305), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [48282] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3311), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3309), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [48322] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(710), 1,
      sym_alignas_qualifier,
    ACTIONS(49), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3315), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(975), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3313), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 10,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
  [48362] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1264), 1,
      sym_ms_call_modifier,
    STATE(1432), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [48411] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2745), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(1316), 1,
      sym__declarator,
    STATE(1389), 1,
      sym__abstract_declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1978), 1,
      sym_ms_based_modifier,
    ACTIONS(3317), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1485), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [48466] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      sym_identifier,
    ACTIONS(3325), 1,
      sym_primitive_type,
    STATE(1123), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2633), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3322), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2635), 13,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
  [48504] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(647), 1,
      sym__old_style_function_declarator,
    STATE(1297), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1344), 1,
      sym__declarator,
    STATE(1435), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1615), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [48558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1124), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2697), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3330), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2695), 15,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [48592] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(654), 1,
      sym__old_style_function_declarator,
    STATE(1292), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1345), 1,
      sym__declarator,
    STATE(1418), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1657), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [48646] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(659), 1,
      sym__old_style_function_declarator,
    STATE(1291), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1342), 1,
      sym__declarator,
    STATE(1424), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1571), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [48700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1125), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2577), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3333), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2575), 15,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [48734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 1,
      anon_sym_LPAREN2,
    STATE(1002), 1,
      sym_preproc_argument_list,
    ACTIONS(3340), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3336), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2624), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3342), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2622), 15,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [48802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2704), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3345), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2701), 15,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [48836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2628), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3349), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2626), 15,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [48870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2587), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3352), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2585), 15,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [48904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1122), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2691), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3355), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2689), 15,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [48938] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(731), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2643), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3358), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2641), 15,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [48972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(2619), 1,
      anon_sym_LPAREN2,
    STATE(1127), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1771), 15,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [49008] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(656), 1,
      sym__old_style_function_declarator,
    STATE(1295), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1336), 1,
      sym__declarator,
    STATE(1427), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1563), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49062] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1293), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1422), 1,
      sym__declarator,
    STATE(1431), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1606), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49113] = 5,
    ACTIONS(3336), 1,
      anon_sym_LF,
    ACTIONS(3364), 1,
      anon_sym_LPAREN2,
    ACTIONS(3366), 1,
      sym_comment,
    STATE(1233), 1,
      sym_preproc_argument_list,
    ACTIONS(3340), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49146] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3370), 1,
      anon_sym_RPAREN,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3380), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1142), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [49189] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3386), 1,
      anon_sym_RPAREN,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_CARET,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    STATE(1579), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49244] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3412), 1,
      anon_sym_RPAREN,
    ACTIONS(3414), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1138), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [49287] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1291), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1365), 1,
      sym__declarator,
    STATE(1424), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1571), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49338] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1288), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1422), 1,
      sym__declarator,
    STATE(1442), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1589), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49389] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1297), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1360), 1,
      sym__declarator,
    STATE(1435), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1615), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49440] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_CARET,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3416), 1,
      anon_sym_RPAREN,
    STATE(1639), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49495] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1287), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1418), 1,
      sym__declaration_declarator,
    STATE(1422), 1,
      sym__declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1657), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49546] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1292), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1372), 1,
      sym__declarator,
    STATE(1418), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1657), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49597] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1285), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1422), 1,
      sym__declarator,
    STATE(1458), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1749), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49648] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_CARET,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3418), 1,
      anon_sym_RPAREN,
    STATE(1575), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49703] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1296), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1422), 1,
      sym__declarator,
    STATE(1427), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1563), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49754] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1290), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1422), 1,
      sym__declarator,
    STATE(1435), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1615), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49805] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3420), 1,
      anon_sym_RPAREN,
    ACTIONS(3422), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1133), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [49848] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1295), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1353), 1,
      sym__declarator,
    STATE(1427), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1563), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49899] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1286), 1,
      sym_ms_call_modifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1422), 1,
      sym__declarator,
    STATE(1424), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1571), 1,
      sym_init_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49950] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3434), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1215), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [49990] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3438), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1211), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50030] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3440), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1224), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50070] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_CARET,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3442), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [50116] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3444), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1222), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50156] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3446), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1223), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50196] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 1,
      anon_sym_const,
    ACTIONS(2886), 1,
      anon_sym_LBRACE,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(3450), 1,
      anon_sym_COLON,
    STATE(778), 1,
      sym_attribute_specifier,
    STATE(1094), 1,
      sym_enumerator_list,
    ACTIONS(2881), 14,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_alignas,
      anon_sym__Alignas,
  [50234] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3453), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3442), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [50274] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3453), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3442), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [50310] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3453), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3442), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50344] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3455), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1241), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50384] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3457), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1239), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50424] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3459), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1205), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50464] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3453), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3442), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [50506] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3461), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1235), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50546] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3463), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1229), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50586] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3465), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1240), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50626] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3467), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1227), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2416), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50694] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3469), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1236), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3471), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50762] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3475), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1220), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3477), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50830] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3481), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1230), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50870] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3483), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1234), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50910] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3485), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1198), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50950] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3487), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1209), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [50990] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_CARET,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3442), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [51038] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3489), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1202), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51078] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3491), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1207), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51118] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3493), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1175), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3497), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3495), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [51186] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3499), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1151), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51226] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3501), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1192), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51266] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3503), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1193), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3505), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1203), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51346] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3507), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1161), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51386] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3509), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1238), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51426] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3511), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1155), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51466] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3513), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1156), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51506] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3515), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1228), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51546] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3517), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1157), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51586] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3519), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1242), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51626] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3521), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1237), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51666] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3400), 1,
      anon_sym_CARET,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3442), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [51712] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_CARET,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3523), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [51762] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3525), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1231), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3529), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3527), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [51830] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3531), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1210), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51870] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3533), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1219), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51910] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3453), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3442), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [51942] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3535), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1213), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [51982] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN2,
    ACTIONS(3428), 1,
      anon_sym_defined,
    ACTIONS(3537), 1,
      sym_number_literal,
    ACTIONS(3430), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3432), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3436), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1217), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [52022] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_LPAREN2,
    ACTIONS(3374), 1,
      anon_sym_defined,
    ACTIONS(3539), 1,
      sym_number_literal,
    ACTIONS(3376), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3382), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1170), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [52062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3442), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52090] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3453), 1,
      anon_sym_PIPE,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3442), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [52134] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3495), 1,
      anon_sym_LF,
    ACTIONS(3497), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52161] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_LF,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [52206] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(644), 1,
      sym__old_style_function_declarator,
    STATE(1320), 1,
      sym_ms_call_modifier,
    STATE(1357), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [52249] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_CARET,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3563), 1,
      anon_sym_RPAREN,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52298] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_LF,
    ACTIONS(3529), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52325] = 6,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3453), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [52358] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3565), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [52403] = 4,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3453), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52432] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(651), 1,
      sym__old_style_function_declarator,
    STATE(1328), 1,
      sym_ms_call_modifier,
    STATE(1374), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [52475] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3567), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [52520] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3471), 1,
      anon_sym_LF,
    ACTIONS(3473), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52547] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3453), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52578] = 3,
    ACTIONS(3143), 1,
      anon_sym_LF,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3141), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52605] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3569), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [52650] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(650), 1,
      sym__old_style_function_declarator,
    STATE(1334), 1,
      sym_ms_call_modifier,
    STATE(1358), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [52693] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3571), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [52738] = 9,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3453), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [52777] = 3,
    ACTIONS(3147), 1,
      anon_sym_LF,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3145), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52804] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3453), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52831] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3453), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [52876] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3573), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [52921] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(658), 1,
      sym__old_style_function_declarator,
    STATE(1324), 1,
      sym_ms_call_modifier,
    STATE(1356), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [52964] = 3,
    ACTIONS(2416), 1,
      anon_sym_LF,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(2414), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52991] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_SLASH,
    ACTIONS(3394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3398), 1,
      anon_sym_PIPE,
    ACTIONS(3400), 1,
      anon_sym_CARET,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3575), 1,
      anon_sym_RPAREN,
    ACTIONS(3388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3406), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3408), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3410), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53040] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3477), 1,
      anon_sym_LF,
    ACTIONS(3479), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53067] = 11,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3453), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53110] = 8,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3453), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [53147] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3577), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53192] = 3,
    ACTIONS(3139), 1,
      anon_sym_LF,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3137), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53219] = 3,
    ACTIONS(3131), 1,
      anon_sym_LF,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3129), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53246] = 7,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3453), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [53281] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3579), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53326] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3581), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53371] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3583), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53416] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3585), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53461] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3587), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53506] = 10,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_LF,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3453), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53547] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3589), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53592] = 12,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3549), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3551), 1,
      anon_sym_PIPE,
    ACTIONS(3553), 1,
      anon_sym_CARET,
    ACTIONS(3555), 1,
      anon_sym_AMP,
    ACTIONS(3591), 1,
      anon_sym_LF,
    ACTIONS(3543), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3557), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3561), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3545), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3559), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [53637] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1328), 1,
      sym_ms_call_modifier,
    STATE(1380), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [53677] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_LPAREN2,
    ACTIONS(1816), 1,
      anon_sym_STAR,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(1414), 1,
      sym__declarator,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1496), 1,
      sym__abstract_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53721] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(1307), 1,
      sym_ms_call_modifier,
    STATE(1439), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [53761] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1311), 1,
      sym_ms_call_modifier,
    STATE(1440), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [53801] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1324), 1,
      sym_ms_call_modifier,
    STATE(1385), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [53841] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1320), 1,
      sym_ms_call_modifier,
    STATE(1390), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [53881] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1334), 1,
      sym_ms_call_modifier,
    STATE(1388), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [53921] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3593), 1,
      sym_identifier,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    STATE(1263), 1,
      sym_gnu_asm_expression,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(1260), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3595), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [53956] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3593), 1,
      sym_identifier,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    STATE(1261), 1,
      sym_gnu_asm_expression,
    STATE(1306), 1,
      sym_attribute_specifier,
    STATE(1393), 1,
      aux_sym_type_definition_repeat1,
    ACTIONS(3599), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1260), 2,
      sym_preproc_call_expression,
      aux_sym_function_declarator_repeat1,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(3595), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [53997] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1349), 1,
      sym__type_declarator,
    STATE(1539), 1,
      sym__type_definition_declarators,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54038] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1349), 1,
      sym__type_declarator,
    STATE(1494), 1,
      sym__type_definition_declarators,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54079] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1349), 1,
      sym__type_declarator,
    STATE(1547), 1,
      sym__type_definition_declarators,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54120] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1349), 1,
      sym__type_declarator,
    STATE(1514), 1,
      sym__type_definition_declarators,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54161] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1349), 1,
      sym__type_declarator,
    STATE(1489), 1,
      sym__type_definition_declarators,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54202] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1349), 1,
      sym__type_declarator,
    STATE(1502), 1,
      sym__type_definition_declarators,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54243] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1349), 1,
      sym__type_declarator,
    STATE(1505), 1,
      sym__type_definition_declarators,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54284] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1349), 1,
      sym__type_declarator,
    STATE(1500), 1,
      sym__type_definition_declarators,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3593), 1,
      sym_identifier,
    STATE(1265), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3603), 4,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(3601), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [54355] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3593), 1,
      sym_identifier,
    ACTIONS(3603), 1,
      anon_sym_LBRACK,
    STATE(1306), 1,
      sym_attribute_specifier,
    STATE(1394), 1,
      aux_sym_type_definition_repeat1,
    ACTIONS(3605), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1266), 2,
      sym_preproc_call_expression,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3607), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(3601), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [54393] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1367), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54431] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3593), 1,
      sym_identifier,
    STATE(1266), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3603), 4,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(3601), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [54461] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2972), 1,
      sym_identifier,
    ACTIONS(2974), 1,
      anon_sym_LPAREN2,
    ACTIONS(2976), 1,
      anon_sym_STAR,
    ACTIONS(2980), 1,
      sym_primitive_type,
    STATE(1416), 1,
      sym__type_declarator,
    STATE(1954), 1,
      sym_ms_based_modifier,
    ACTIONS(2978), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1408), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [54499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3609), 1,
      sym_identifier,
    ACTIONS(3614), 1,
      anon_sym___attribute__,
    STATE(1265), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3617), 4,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(3612), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [54529] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3593), 1,
      sym_identifier,
    STATE(1265), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3621), 4,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(3619), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [54559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3628), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(1267), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3623), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [54586] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    ACTIONS(3630), 1,
      anon_sym_SEMI,
    STATE(1305), 1,
      sym__field_declarator,
    STATE(1630), 1,
      sym__field_declaration_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    STATE(1845), 1,
      sym_attribute_specifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [54627] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3634), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3636), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3638), 1,
      aux_sym_preproc_elif_token1,
    STATE(1322), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1323), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1428), 1,
      sym_enumerator,
    ACTIONS(3640), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1884), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(1891), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [54666] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3636), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3638), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3642), 1,
      aux_sym_preproc_if_token2,
    STATE(1309), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1310), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1428), 1,
      sym_enumerator,
    ACTIONS(3640), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1868), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(1870), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [54705] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3636), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3638), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3644), 1,
      aux_sym_preproc_if_token2,
    STATE(1319), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1321), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1428), 1,
      sym_enumerator,
    ACTIONS(3640), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1857), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(1893), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [54744] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    ACTIONS(3646), 1,
      anon_sym_SEMI,
    STATE(1305), 1,
      sym__field_declarator,
    STATE(1574), 1,
      sym__field_declaration_declarator,
    STATE(1786), 1,
      sym_attribute_specifier,
    STATE(1788), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [54785] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    ACTIONS(3648), 1,
      anon_sym_SEMI,
    STATE(1305), 1,
      sym__field_declarator,
    STATE(1636), 1,
      sym__field_declaration_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    STATE(1990), 1,
      sym_attribute_specifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [54826] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3636), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3638), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3650), 1,
      aux_sym_preproc_if_token2,
    STATE(1332), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1333), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1428), 1,
      sym_enumerator,
    ACTIONS(3640), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1834), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(1855), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [54865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 6,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
    ACTIONS(3654), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [54887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 6,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
    ACTIONS(2893), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [54909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3658), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(1267), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3656), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [54935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3666), 1,
      anon_sym___asm,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3660), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [54967] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3670), 1,
      anon_sym___asm,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3668), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [54999] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3593), 1,
      sym_identifier,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    STATE(1351), 1,
      sym_gnu_asm_expression,
    ACTIONS(91), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    STATE(1338), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3595), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [55031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2912), 6,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
    ACTIONS(2905), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [55053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3674), 1,
      anon_sym___asm,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3672), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55085] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym___asm,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3676), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3338), 1,
      anon_sym_LPAREN2,
    STATE(1002), 1,
      sym_preproc_argument_list,
    ACTIONS(3680), 6,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
    ACTIONS(3682), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [55143] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1450), 1,
      sym__declarator,
    STATE(1469), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55180] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1413), 1,
      sym__declaration_declarator,
    STATE(1450), 1,
      sym__declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55217] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1407), 1,
      sym__declaration_declarator,
    STATE(1450), 1,
      sym__declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55254] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1409), 1,
      sym__declaration_declarator,
    STATE(1450), 1,
      sym__declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55291] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3686), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(3690), 1,
      anon_sym_RBRACE,
    ACTIONS(3688), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1747), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(1985), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(1308), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [55324] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1438), 1,
      sym__declaration_declarator,
    STATE(1450), 1,
      sym__declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55361] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1381), 1,
      sym__declarator,
    STATE(1413), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55398] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1397), 1,
      sym__declarator,
    STATE(1407), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55435] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1434), 1,
      sym__declaration_declarator,
    STATE(1450), 1,
      sym__declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55472] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3686), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(3692), 1,
      anon_sym_RBRACE,
    ACTIONS(3688), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1746), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(2000), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(1289), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [55505] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1400), 1,
      sym__declarator,
    STATE(1437), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55542] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1437), 1,
      sym__declaration_declarator,
    STATE(1450), 1,
      sym__declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55579] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      sym_identifier,
    STATE(1303), 1,
      sym_function_declarator,
    STATE(1379), 1,
      sym__declarator,
    STATE(1438), 1,
      sym__declaration_declarator,
    STATE(1484), 1,
      sym__function_declaration_declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1343), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [55616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3694), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3698), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3702), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3708), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3706), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3712), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3710), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3714), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3720), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3718), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55756] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3722), 1,
      anon_sym_COMMA,
    ACTIONS(3726), 1,
      anon_sym_LBRACK,
    ACTIONS(3728), 1,
      anon_sym_COLON,
    STATE(1401), 1,
      sym_parameter_list,
    STATE(1515), 1,
      aux_sym__field_declaration_declarator_repeat1,
    STATE(1541), 1,
      sym_bitfield_clause,
    ACTIONS(3724), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(1347), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [55792] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(3680), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(3730), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3735), 3,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
    ACTIONS(3682), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [55818] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(1436), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [55847] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3737), 1,
      sym_identifier,
    ACTIONS(3740), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(3746), 1,
      sym_preproc_directive,
    ACTIONS(3749), 1,
      anon_sym_RBRACE,
    ACTIONS(3743), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(1785), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(1308), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [55876] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3751), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3753), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3755), 1,
      aux_sym_preproc_elif_token1,
    STATE(1399), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
    ACTIONS(3757), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1967), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [55907] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3759), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3761), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3763), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3765), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1382), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1968), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [55936] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1414), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [55965] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3726), 1,
      anon_sym_LBRACK,
    STATE(1401), 1,
      sym_parameter_list,
    STATE(1347), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3767), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [55992] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3753), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3755), 1,
      aux_sym_preproc_elif_token1,
    STATE(1309), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
    ACTIONS(3757), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1868), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [56023] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3761), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3763), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3769), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3765), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1310), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1870), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [56052] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_LPAREN2,
    ACTIONS(3049), 1,
      anon_sym_STAR,
    STATE(1330), 1,
      sym__field_declarator,
    STATE(1788), 1,
      sym_ms_based_modifier,
    STATE(1384), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [56081] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(1280), 1,
      sym_parameter_list,
    ACTIONS(3771), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(1486), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [56112] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3726), 1,
      anon_sym_LBRACK,
    STATE(1401), 1,
      sym_parameter_list,
    STATE(1347), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3773), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [56139] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3753), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3755), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3775), 1,
      aux_sym_preproc_if_token2,
    STATE(1332), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
    ACTIONS(3757), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1834), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [56170] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3753), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3755), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3777), 1,
      aux_sym_preproc_if_token2,
    STATE(1399), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
    ACTIONS(3757), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1822), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [56201] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1402), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [56230] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3761), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3763), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3779), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3765), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1382), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1872), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [56259] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3753), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3755), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3781), 1,
      aux_sym_preproc_if_token2,
    STATE(1399), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
    ACTIONS(3757), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1876), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [56290] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3761), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3763), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3783), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3765), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1382), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1890), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [56319] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1377), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [56348] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3753), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3755), 1,
      aux_sym_preproc_elif_token1,
    STATE(1322), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
    ACTIONS(3757), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1884), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [56379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3761), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3763), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3785), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3765), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1323), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1891), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [56408] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3753), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3755), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3787), 1,
      aux_sym_preproc_if_token2,
    STATE(1319), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
    ACTIONS(3757), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1857), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [56439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1376), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [56468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3726), 1,
      anon_sym_LBRACK,
    STATE(1401), 1,
      sym_parameter_list,
    STATE(1347), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3789), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [56495] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3726), 1,
      anon_sym_LBRACK,
    ACTIONS(3728), 1,
      anon_sym_COLON,
    STATE(1401), 1,
      sym_parameter_list,
    STATE(1555), 1,
      sym_bitfield_clause,
    STATE(1347), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3791), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [56526] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3726), 1,
      anon_sym_LBRACK,
    STATE(1401), 1,
      sym_parameter_list,
    STATE(1347), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3793), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [56553] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(3753), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3755), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3795), 1,
      aux_sym_preproc_if_token2,
    STATE(1399), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
    ACTIONS(3757), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1925), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [56584] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(3761), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3763), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3797), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3765), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1382), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1863), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [56613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym___based,
    ACTIONS(2741), 1,
      sym_identifier,
    ACTIONS(3029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3043), 1,
      anon_sym_STAR,
    STATE(1383), 1,
      sym__declarator,
    STATE(1846), 1,
      sym_ms_based_modifier,
    STATE(1303), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [56642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    ACTIONS(3801), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1548), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [56667] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(132), 1,
      sym_compound_statement,
    STATE(939), 1,
      sym__old_style_parameter_list,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3809), 1,
      anon_sym_LBRACK,
    STATE(1412), 1,
      sym_parameter_list,
    STATE(1370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3807), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [56725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      sym_identifier,
    ACTIONS(3603), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
    STATE(1265), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3601), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [56747] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3809), 1,
      anon_sym_LBRACK,
    STATE(1412), 1,
      sym_parameter_list,
    STATE(1370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3811), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [56773] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3809), 1,
      anon_sym_LBRACK,
    STATE(1412), 1,
      sym_parameter_list,
    STATE(1370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3813), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [56799] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3817), 1,
      anon_sym_LBRACK,
    STATE(1538), 1,
      sym_gnu_asm_input_operand,
    STATE(1898), 1,
      sym_string_literal,
    ACTIONS(3815), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [56823] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(290), 1,
      sym_compound_statement,
    STATE(939), 1,
      sym__old_style_parameter_list,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACK,
    ACTIONS(3821), 1,
      anon_sym___asm,
    ACTIONS(3714), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(3819), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [56877] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(315), 1,
      sym_compound_statement,
    STATE(939), 1,
      sym__old_style_parameter_list,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56909] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(354), 1,
      sym_compound_statement,
    STATE(939), 1,
      sym__old_style_parameter_list,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56941] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3809), 1,
      anon_sym_LBRACK,
    STATE(1412), 1,
      sym_parameter_list,
    STATE(1370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3823), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [56967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3827), 1,
      anon_sym_LBRACK,
    STATE(1267), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3825), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [56989] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      sym_identifier,
    ACTIONS(3621), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
    STATE(1265), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3619), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [57011] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3809), 1,
      anon_sym_LBRACK,
    ACTIONS(3829), 1,
      anon_sym_COMMA,
    STATE(1412), 1,
      sym_parameter_list,
    STATE(1509), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(3831), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(1370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3835), 1,
      anon_sym_LBRACK,
    STATE(1536), 1,
      sym_gnu_asm_output_operand,
    STATE(1854), 1,
      sym_string_literal,
    ACTIONS(3833), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [57065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3593), 1,
      sym_identifier,
    ACTIONS(3603), 1,
      anon_sym_LBRACK,
    STATE(1348), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3601), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [57089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3837), 1,
      sym_identifier,
    ACTIONS(3841), 1,
      sym_system_lib_string,
    STATE(1896), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(3839), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [57110] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(132), 1,
      sym_compound_statement,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(1280), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3672), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [57164] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(1280), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3668), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [57189] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    STATE(375), 1,
      sym_compound_statement,
    STATE(939), 1,
      sym__old_style_parameter_list,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57218] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    STATE(273), 1,
      sym_compound_statement,
    STATE(939), 1,
      sym__old_style_parameter_list,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57247] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    STATE(267), 1,
      sym_compound_statement,
    STATE(939), 1,
      sym__old_style_parameter_list,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57276] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1949), 1,
      anon_sym_LPAREN2,
    ACTIONS(1951), 1,
      anon_sym_STAR,
    ACTIONS(2753), 1,
      anon_sym_LBRACK,
    STATE(1446), 1,
      sym_parameter_list,
    STATE(1496), 1,
      sym__abstract_declarator,
    STATE(1445), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [57301] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(315), 1,
      sym_compound_statement,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57330] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3843), 1,
      sym_identifier,
    ACTIONS(3845), 1,
      sym_system_lib_string,
    STATE(1814), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(3839), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [57351] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(1280), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3660), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [57376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_system_lib_string,
    STATE(1915), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(3839), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [57397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3853), 1,
      anon_sym___attribute__,
    ACTIONS(3856), 1,
      anon_sym___asm,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3851), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [57418] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(290), 1,
      sym_compound_statement,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1665), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [57468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3809), 1,
      anon_sym_LBRACK,
    STATE(1412), 1,
      sym_parameter_list,
    STATE(1370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3858), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [57493] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1587), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [57514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3860), 1,
      sym_identifier,
    ACTIONS(3862), 1,
      sym_system_lib_string,
    STATE(1864), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(3839), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [57535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3866), 1,
      anon_sym_LBRACK,
    STATE(1267), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3864), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [57556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      sym_identifier,
    STATE(668), 1,
      sym_string_literal,
    STATE(1562), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [57577] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(354), 1,
      sym_compound_statement,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57606] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(1280), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3676), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [57631] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    STATE(127), 1,
      sym_compound_statement,
    STATE(939), 1,
      sym__old_style_parameter_list,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3835), 1,
      anon_sym_LBRACK,
    STATE(1572), 1,
      sym_gnu_asm_output_operand,
    STATE(1854), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [57680] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(141), 1,
      sym_compound_statement,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57706] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(358), 1,
      sym_compound_statement,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3870), 1,
      anon_sym_LBRACK,
    ACTIONS(3868), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [57748] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(265), 1,
      sym_compound_statement,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57774] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(127), 1,
      sym_compound_statement,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57800] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(314), 1,
      sym_compound_statement,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3872), 1,
      sym_identifier,
    ACTIONS(3877), 1,
      aux_sym_preproc_elif_token1,
    STATE(1382), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(3875), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [57846] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(279), 1,
      sym_compound_statement,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3881), 1,
      anon_sym_LBRACK,
    ACTIONS(3879), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [57888] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(375), 1,
      sym_compound_statement,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3885), 1,
      anon_sym_LBRACK,
    ACTIONS(3883), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [57930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_LBRACK,
    ACTIONS(3887), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [57946] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(267), 1,
      sym_compound_statement,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57972] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1451), 1,
      sym_parameter_list,
    ACTIONS(3771), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1479), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [57996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(273), 1,
      sym_compound_statement,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 1,
      anon_sym_LBRACK,
    ACTIONS(3893), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [58038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3899), 1,
      anon_sym_LBRACK,
    ACTIONS(3897), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [58054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(3607), 1,
      anon_sym___asm,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3605), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [58074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(3903), 1,
      anon_sym___asm,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3901), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [58094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3817), 1,
      anon_sym_LBRACK,
    STATE(1631), 1,
      sym_gnu_asm_input_operand,
    STATE(1898), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [58114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 1,
      anon_sym_LBRACK,
    ACTIONS(3905), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [58130] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(368), 1,
      sym_compound_statement,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3911), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    ACTIONS(3909), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [58174] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3915), 1,
      sym_identifier,
    ACTIONS(3920), 1,
      aux_sym_preproc_elif_token1,
    STATE(1399), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
    ACTIONS(3918), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [58196] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(119), 1,
      sym_compound_statement,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3924), 1,
      anon_sym_LBRACK,
    ACTIONS(3922), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [58238] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(272), 1,
      sym_compound_statement,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3928), 1,
      anon_sym_LBRACK,
    ACTIONS(3926), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [58280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3932), 1,
      anon_sym_LBRACK,
    ACTIONS(3930), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1451), 1,
      sym_parameter_list,
    ACTIONS(3934), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_COLON,
  [58314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3938), 1,
      anon_sym_LBRACK,
    ACTIONS(3936), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58329] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(3942), 1,
      anon_sym_SEMI,
    STATE(1549), 1,
      sym_gnu_asm_expression,
    STATE(1596), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3948), 1,
      anon_sym_LBRACK,
    ACTIONS(3946), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(3950), 1,
      anon_sym_SEMI,
    STATE(1598), 1,
      sym_gnu_asm_expression,
    STATE(1599), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_LBRACK,
    ACTIONS(3952), 1,
      anon_sym_EQ,
    ACTIONS(3954), 1,
      anon_sym_DOT,
    STATE(1430), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [58409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3958), 1,
      anon_sym_LBRACK,
    ACTIONS(3956), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3962), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58439] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(3964), 1,
      anon_sym_SEMI,
    STATE(1633), 1,
      sym_gnu_asm_expression,
    STATE(1634), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58462] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3966), 1,
      anon_sym_RPAREN,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3970), 1,
      anon_sym_LBRACK,
    ACTIONS(3968), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3809), 1,
      anon_sym_LBRACK,
    ACTIONS(3972), 1,
      anon_sym_RPAREN,
    STATE(1412), 1,
      sym_parameter_list,
    STATE(1370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3976), 1,
      anon_sym_LBRACK,
    ACTIONS(3974), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(3978), 1,
      anon_sym_SEMI,
    STATE(1602), 1,
      sym_gnu_asm_expression,
    STATE(1605), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1451), 1,
      sym_parameter_list,
    ACTIONS(3980), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_COLON,
  [58580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3986), 1,
      anon_sym_LPAREN2,
    STATE(1421), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(3988), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [58612] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3993), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58650] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(3995), 1,
      anon_sym_SEMI,
    STATE(1590), 1,
      sym_gnu_asm_expression,
    STATE(1591), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3997), 1,
      anon_sym_LPAREN2,
    STATE(1433), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(3999), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [58690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1451), 1,
      sym_parameter_list,
    ACTIONS(4001), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_COLON,
  [58709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4003), 1,
      anon_sym_SEMI,
    STATE(1568), 1,
      sym_gnu_asm_expression,
    STATE(1569), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 1,
      anon_sym_COMMA,
    ACTIONS(4009), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4005), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [58749] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    ACTIONS(4011), 1,
      sym_identifier,
    STATE(734), 1,
      sym_field_declaration_list,
    STATE(1482), 1,
      sym_attribute_specifier,
    STATE(1584), 1,
      sym_ms_declspec_modifier,
  [58774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_LBRACK,
    ACTIONS(4016), 1,
      anon_sym_EQ,
    ACTIONS(4018), 1,
      anon_sym_DOT,
    STATE(1430), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [58793] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4021), 1,
      anon_sym_SEMI,
    STATE(1607), 1,
      sym_gnu_asm_expression,
    STATE(1608), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58816] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3809), 1,
      anon_sym_LBRACK,
    ACTIONS(4023), 1,
      anon_sym_RPAREN,
    STATE(1412), 1,
      sym_parameter_list,
    STATE(1370), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4025), 1,
      anon_sym_LPAREN2,
    STATE(1421), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(3999), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [58856] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4027), 1,
      anon_sym_SEMI,
    STATE(1610), 1,
      sym_gnu_asm_expression,
    STATE(1611), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58879] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4029), 1,
      anon_sym_SEMI,
    STATE(1616), 1,
      sym_gnu_asm_expression,
    STATE(1617), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3726), 1,
      anon_sym_LBRACK,
    ACTIONS(4031), 1,
      anon_sym_RPAREN,
    STATE(1401), 1,
      sym_parameter_list,
    STATE(1347), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58925] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4033), 1,
      anon_sym_SEMI,
    STATE(1576), 1,
      sym_gnu_asm_expression,
    STATE(1577), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58948] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4035), 1,
      anon_sym_SEMI,
    STATE(1619), 1,
      sym_gnu_asm_expression,
    STATE(1620), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58971] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3726), 1,
      anon_sym_LBRACK,
    ACTIONS(4037), 1,
      anon_sym_RPAREN,
    STATE(1401), 1,
      sym_parameter_list,
    STATE(1347), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58994] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    ACTIONS(4039), 1,
      anon_sym_RPAREN,
    STATE(1250), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [59017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 1,
      anon_sym_LBRACK,
    ACTIONS(4041), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [59032] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4045), 1,
      anon_sym_SEMI,
    STATE(1593), 1,
      sym_gnu_asm_expression,
    STATE(1594), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(625), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [59069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4047), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4049), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4051), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4055), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4057), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4059), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3664), 1,
      anon_sym_LBRACK,
    STATE(1251), 1,
      sym_parameter_list,
    STATE(1277), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [59163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4061), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1451), 1,
      sym_parameter_list,
    ACTIONS(4063), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1993), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [59207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1451), 1,
      sym_parameter_list,
    ACTIONS(4065), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4069), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4073), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    STATE(1726), 1,
      sym_gnu_asm_expression,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(4075), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [59281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4077), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3920), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3918), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [59319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4081), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4085), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4087), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4089), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4093), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1451), 1,
      sym_parameter_list,
    ACTIONS(4097), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4055), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4057), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym___asm,
    STATE(1691), 1,
      sym_gnu_asm_expression,
    ACTIONS(3944), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(4099), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [59435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4069), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1451), 1,
      sym_parameter_list,
    ACTIONS(4101), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4105), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4107), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3749), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4109), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4111), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4113), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4115), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4117), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1835), 1,
      sym_string_literal,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [59549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    ACTIONS(4121), 1,
      anon_sym_COLON_COLON,
    STATE(1680), 1,
      sym_argument_list,
    ACTIONS(4119), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [59566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4123), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    ACTIONS(4125), 1,
      sym_identifier,
    STATE(730), 1,
      sym_field_declaration_list,
    STATE(1632), 1,
      sym_ms_declspec_modifier,
  [59600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(4127), 1,
      aux_sym_preproc_if_token2,
    STATE(1428), 1,
      sym_enumerator,
    STATE(1495), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1545), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
  [59619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    ACTIONS(4129), 1,
      sym_identifier,
    STATE(725), 1,
      sym_field_declaration_list,
    STATE(1614), 1,
      sym_ms_declspec_modifier,
  [59638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4131), 5,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [59649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 1,
      anon_sym___asm,
    ACTIONS(4133), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [59662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4137), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4123), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59692] = 4,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4139), 1,
      anon_sym_SQUOTE,
    STATE(1512), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4141), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [59706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4143), 1,
      anon_sym_SEMI,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4145), 1,
      anon_sym_SEMI,
    STATE(1506), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59734] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4147), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4149), 1,
      anon_sym_LPAREN,
    ACTIONS(4151), 1,
      sym_preproc_arg,
    STATE(1720), 1,
      sym_preproc_params,
  [59750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4153), 1,
      anon_sym___except,
    ACTIONS(4155), 1,
      anon_sym___finally,
    STATE(101), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [59764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4157), 1,
      anon_sym_COMMA,
    ACTIONS(4159), 1,
      anon_sym_RPAREN,
    STATE(1638), 1,
      aux_sym_parameter_list_repeat1,
    STATE(1645), 1,
      aux_sym__old_style_parameter_list_repeat1,
  [59780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4161), 1,
      anon_sym___except,
    ACTIONS(4163), 1,
      anon_sym___finally,
    STATE(249), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [59794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4165), 1,
      anon_sym_SEMI,
    STATE(1519), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(4167), 1,
      aux_sym_preproc_if_token2,
    STATE(1382), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [59822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    ACTIONS(4169), 1,
      anon_sym_RPAREN,
    STATE(1451), 1,
      sym_parameter_list,
  [59838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4171), 1,
      anon_sym_SEMI,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59852] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_LPAREN,
    ACTIONS(4173), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4175), 1,
      sym_preproc_arg,
    STATE(1714), 1,
      sym_preproc_params,
  [59868] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_LPAREN,
    ACTIONS(4177), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4179), 1,
      sym_preproc_arg,
    STATE(1750), 1,
      sym_preproc_params,
  [59884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4181), 1,
      anon_sym_SEMI,
    STATE(1520), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4183), 1,
      anon_sym_COMMA,
    STATE(1544), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4185), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4187), 1,
      anon_sym_SEMI,
    STATE(1508), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4189), 1,
      anon_sym___except,
    ACTIONS(4191), 1,
      anon_sym___finally,
    STATE(193), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [59940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_COMMA,
    STATE(1504), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4196), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4198), 1,
      anon_sym_SEMI,
    STATE(1513), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4200), 1,
      anon_sym_SEMI,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [59982] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4202), 1,
      anon_sym_DQUOTE,
    ACTIONS(4204), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4207), 1,
      sym_escape_sequence,
    STATE(1507), 1,
      aux_sym_string_literal_repeat1,
  [59998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4210), 1,
      anon_sym_SEMI,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3829), 1,
      anon_sym_COMMA,
    STATE(1523), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4212), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      anon_sym___except,
    ACTIONS(4216), 1,
      anon_sym___finally,
    STATE(220), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [60040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4218), 1,
      anon_sym_COMMA,
    STATE(1546), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4220), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60054] = 4,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4222), 1,
      anon_sym_SQUOTE,
    STATE(1512), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4224), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [60068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4227), 1,
      anon_sym_SEMI,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4229), 1,
      anon_sym_SEMI,
    STATE(1488), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3722), 1,
      anon_sym_COMMA,
    STATE(1535), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4231), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3632), 1,
      sym_identifier,
    ACTIONS(4233), 1,
      aux_sym_preproc_if_token2,
    STATE(1495), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [60124] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_DQUOTE,
    ACTIONS(4237), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4239), 1,
      sym_escape_sequence,
    STATE(1522), 1,
      aux_sym_string_literal_repeat1,
  [60140] = 4,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4241), 1,
      anon_sym_SQUOTE,
    STATE(1512), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4141), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [60154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4243), 1,
      anon_sym_SEMI,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4245), 1,
      anon_sym_SEMI,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60182] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_LPAREN,
    ACTIONS(4247), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4249), 1,
      sym_preproc_arg,
    STATE(1687), 1,
      sym_preproc_params,
  [60198] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4251), 1,
      anon_sym_DQUOTE,
    ACTIONS(4253), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4255), 1,
      sym_escape_sequence,
    STATE(1507), 1,
      aux_sym_string_literal_repeat1,
  [60214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4257), 1,
      anon_sym_COMMA,
    STATE(1523), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4260), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4262), 1,
      anon_sym_SEMI,
    STATE(1364), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_LPAREN2,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    ACTIONS(4264), 1,
      anon_sym_RPAREN,
    STATE(1451), 1,
      sym_parameter_list,
  [60258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    STATE(1679), 1,
      sym_argument_list,
    ACTIONS(4266), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [60272] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4253), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4255), 1,
      sym_escape_sequence,
    ACTIONS(4268), 1,
      anon_sym_DQUOTE,
    STATE(1507), 1,
      aux_sym_string_literal_repeat1,
  [60288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    STATE(1504), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4272), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60302] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_LPAREN,
    ACTIONS(4274), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4276), 1,
      sym_preproc_arg,
    STATE(1693), 1,
      sym_preproc_params,
  [60318] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_LPAREN,
    ACTIONS(4278), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4280), 1,
      sym_preproc_arg,
    STATE(1715), 1,
      sym_preproc_params,
  [60334] = 4,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4282), 1,
      anon_sym_SQUOTE,
    STATE(1512), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4141), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [60348] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4286), 1,
      sym_preproc_arg,
    STATE(1697), 1,
      sym_preproc_params,
  [60364] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4253), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4255), 1,
      sym_escape_sequence,
    ACTIONS(4288), 1,
      anon_sym_DQUOTE,
    STATE(1507), 1,
      aux_sym_string_literal_repeat1,
  [60380] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(4127), 1,
      aux_sym_preproc_if_token2,
    STATE(1545), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
  [60396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 1,
      anon_sym_COMMA,
    STATE(1535), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4293), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    STATE(1528), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4295), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60424] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4297), 1,
      anon_sym_DQUOTE,
    ACTIONS(4299), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4301), 1,
      sym_escape_sequence,
    STATE(1533), 1,
      aux_sym_string_literal_repeat1,
  [60440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4218), 1,
      anon_sym_COMMA,
    STATE(1511), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4303), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4305), 1,
      anon_sym_SEMI,
    STATE(1497), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60468] = 5,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4307), 1,
      anon_sym_DQUOTE,
    ACTIONS(4309), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4311), 1,
      sym_escape_sequence,
    STATE(1527), 1,
      aux_sym_string_literal_repeat1,
  [60484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3722), 1,
      anon_sym_COMMA,
    STATE(1543), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4313), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4315), 1,
      anon_sym___except,
    ACTIONS(4317), 1,
      anon_sym___finally,
    STATE(249), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [60512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3722), 1,
      anon_sym_COMMA,
    STATE(1535), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4319), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4321), 1,
      anon_sym_COMMA,
    STATE(1544), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4324), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 1,
      sym_identifier,
    ACTIONS(4326), 1,
      aux_sym_preproc_if_token2,
    STATE(1399), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1812), 1,
      sym_enumerator,
  [60556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4328), 1,
      anon_sym_COMMA,
    STATE(1546), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4331), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4333), 1,
      anon_sym_SEMI,
    STATE(1524), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4183), 1,
      anon_sym_COMMA,
    STATE(1501), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4335), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4337), 1,
      anon_sym_SEMI,
    STATE(1643), 1,
      aux_sym_declaration_repeat1,
  [60611] = 4,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4339), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4341), 1,
      anon_sym_LPAREN2,
    STATE(1894), 1,
      sym_preproc_argument_list,
  [60624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 1,
      anon_sym_RBRACE,
    ACTIONS(4343), 1,
      anon_sym_COMMA,
    STATE(1603), 1,
      aux_sym_initializer_list_repeat1,
  [60637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4345), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [60650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2886), 1,
      anon_sym_LBRACE,
    ACTIONS(4347), 1,
      sym_identifier,
    STATE(1079), 1,
      sym_enumerator_list,
  [60663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_RPAREN,
    ACTIONS(4351), 1,
      anon_sym_COLON,
    STATE(1583), 1,
      sym_gnu_asm_clobber_list,
  [60676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60685] = 4,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN2,
    ACTIONS(4355), 1,
      aux_sym_preproc_include_token2,
    STATE(1894), 1,
      sym_preproc_argument_list,
  [60698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 1,
      anon_sym_COMMA,
    ACTIONS(4360), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [60711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4362), 1,
      anon_sym_COMMA,
    ACTIONS(4364), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1666), 1,
      aux_sym_attribute_declaration_repeat1,
  [60724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4362), 1,
      anon_sym_COMMA,
    ACTIONS(4366), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1566), 1,
      aux_sym_attribute_declaration_repeat1,
  [60737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4362), 1,
      anon_sym_COMMA,
    ACTIONS(4368), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1585), 1,
      aux_sym_attribute_declaration_repeat1,
  [60750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4370), 1,
      anon_sym_RPAREN,
    ACTIONS(4372), 1,
      anon_sym_COLON,
    STATE(1640), 1,
      sym_gnu_asm_input_operand_list,
  [60763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4374), 1,
      anon_sym_RPAREN,
    ACTIONS(4376), 1,
      anon_sym_COLON,
    STATE(1641), 1,
      sym_gnu_asm_output_operand_list,
  [60776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_SEMI,
    STATE(1570), 1,
      aux_sym_declaration_repeat1,
  [60789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4380), 1,
      anon_sym_COMMA,
    ACTIONS(4382), 1,
      anon_sym_RPAREN,
    STATE(1580), 1,
      aux_sym_preproc_params_repeat1,
  [60802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4384), 1,
      anon_sym_COMMA,
    ACTIONS(4387), 1,
      anon_sym_RPAREN,
    STATE(1565), 1,
      aux_sym__old_style_parameter_list_repeat1,
  [60815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4362), 1,
      anon_sym_COMMA,
    ACTIONS(4389), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1656), 1,
      aux_sym_attribute_declaration_repeat1,
  [60828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
    ACTIONS(4391), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [60839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4395), 1,
      anon_sym_SEMI,
    STATE(1578), 1,
      aux_sym_declaration_repeat1,
  [60852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4397), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [60865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4399), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [60878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4401), 1,
      anon_sym_SEMI,
    STATE(1592), 1,
      aux_sym_declaration_repeat1,
  [60891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4403), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(4405), 1,
      anon_sym_RPAREN,
    STATE(1660), 1,
      aux_sym_argument_list_repeat1,
  [60913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4407), 1,
      anon_sym_SEMI,
    STATE(1823), 1,
      sym_attribute_specifier,
  [60926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(4409), 1,
      anon_sym_RPAREN,
    STATE(1661), 1,
      aux_sym_preproc_argument_list_repeat1,
  [60939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4411), 1,
      anon_sym_SEMI,
    STATE(1582), 1,
      aux_sym_declaration_repeat1,
  [60952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4413), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [60965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4415), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [60978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(4417), 1,
      anon_sym_RPAREN,
    STATE(1661), 1,
      aux_sym_preproc_argument_list_repeat1,
  [60991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4380), 1,
      anon_sym_COMMA,
    ACTIONS(4419), 1,
      anon_sym_RPAREN,
    STATE(1662), 1,
      aux_sym_preproc_params_repeat1,
  [61004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4421), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4423), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4425), 1,
      anon_sym_RPAREN,
    ACTIONS(4427), 1,
      anon_sym_COLON,
    STATE(1962), 1,
      sym_gnu_asm_goto_list,
  [61039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    ACTIONS(4429), 1,
      sym_identifier,
    STATE(725), 1,
      sym_field_declaration_list,
  [61052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4362), 1,
      anon_sym_COMMA,
    ACTIONS(4431), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1656), 1,
      aux_sym_attribute_declaration_repeat1,
  [61065] = 4,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN2,
    ACTIONS(4433), 1,
      aux_sym_preproc_include_token2,
    STATE(1894), 1,
      sym_preproc_argument_list,
  [61078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4376), 1,
      anon_sym_COLON,
    ACTIONS(4435), 1,
      anon_sym_RPAREN,
    STATE(1561), 1,
      sym_gnu_asm_output_operand_list,
  [61091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [61100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4439), 1,
      anon_sym_SEMI,
    STATE(1595), 1,
      aux_sym_declaration_repeat1,
  [61113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4441), 1,
      anon_sym_SEMI,
    STATE(1635), 1,
      aux_sym_declaration_repeat1,
  [61126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4443), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4445), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4447), 1,
      anon_sym_SEMI,
    STATE(1600), 1,
      aux_sym_declaration_repeat1,
  [61165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4451), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4453), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 1,
      anon_sym_RPAREN,
    STATE(1637), 1,
      aux_sym_argument_list_repeat1,
  [61217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4455), 1,
      anon_sym_SEMI,
    STATE(1604), 1,
      aux_sym_declaration_repeat1,
  [61230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4457), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4459), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4461), 1,
      anon_sym_EQ,
    ACTIONS(3909), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [61267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4463), 1,
      anon_sym_SEMI,
    STATE(1552), 1,
      aux_sym_declaration_repeat1,
  [61280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3223), 1,
      anon_sym_RBRACE,
    ACTIONS(4465), 1,
      anon_sym_COMMA,
    STATE(1603), 1,
      aux_sym_initializer_list_repeat1,
  [61293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4468), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4470), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4472), 1,
      anon_sym_SEMI,
    STATE(1609), 1,
      aux_sym_declaration_repeat1,
  [61332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4474), 1,
      anon_sym_SEMI,
    STATE(1612), 1,
      aux_sym_declaration_repeat1,
  [61345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4476), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4478), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4480), 1,
      anon_sym_SEMI,
    STATE(1613), 1,
      aux_sym_declaration_repeat1,
  [61384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4482), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4484), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4486), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    ACTIONS(4488), 1,
      sym_identifier,
    STATE(733), 1,
      sym_field_declaration_list,
  [61436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4490), 1,
      anon_sym_SEMI,
    STATE(1618), 1,
      aux_sym_declaration_repeat1,
  [61449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4492), 1,
      anon_sym_SEMI,
    STATE(1621), 1,
      aux_sym_declaration_repeat1,
  [61462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4494), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4496), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_SEMI,
    STATE(1668), 1,
      aux_sym_declaration_repeat1,
  [61501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4500), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4502), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_COLON,
    ACTIONS(4504), 1,
      anon_sym_RPAREN,
    STATE(1847), 1,
      sym_gnu_asm_goto_list,
  [61540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_COMMA,
    ACTIONS(4508), 1,
      anon_sym_RPAREN,
    STATE(1638), 1,
      aux_sym_parameter_list_repeat1,
  [61553] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    STATE(1518), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4510), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [61564] = 4,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LPAREN2,
    ACTIONS(4512), 1,
      aux_sym_preproc_include_token2,
    STATE(1894), 1,
      sym_preproc_argument_list,
  [61577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4514), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [61586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3153), 1,
      anon_sym_COMMA,
    ACTIONS(4516), 1,
      anon_sym_RPAREN,
    STATE(1663), 1,
      aux_sym_generic_expression_repeat1,
  [61599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3151), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [61617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4520), 1,
      anon_sym_SEMI,
    STATE(1892), 1,
      sym_attribute_specifier,
  [61630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      sym_identifier,
    STATE(729), 1,
      sym_field_declaration_list,
  [61652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4526), 1,
      anon_sym_SEMI,
    STATE(1646), 1,
      aux_sym_declaration_repeat1,
  [61665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4528), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4530), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3448), 1,
      anon_sym___attribute__,
    ACTIONS(4532), 1,
      anon_sym_SEMI,
    STATE(1977), 1,
      sym_attribute_specifier,
  [61704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(4534), 1,
      anon_sym_RPAREN,
    STATE(1660), 1,
      aux_sym_argument_list_repeat1,
  [61717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_COMMA,
    ACTIONS(4536), 1,
      anon_sym_RPAREN,
    STATE(1658), 1,
      aux_sym_parameter_list_repeat1,
  [61730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(4538), 1,
      anon_sym_RPAREN,
    STATE(1661), 1,
      aux_sym_preproc_argument_list_repeat1,
  [61743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4351), 1,
      anon_sym_COLON,
    ACTIONS(4540), 1,
      anon_sym_RPAREN,
    STATE(1622), 1,
      sym_gnu_asm_clobber_list,
  [61756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4372), 1,
      anon_sym_COLON,
    ACTIONS(4542), 1,
      anon_sym_RPAREN,
    STATE(1554), 1,
      sym_gnu_asm_input_operand_list,
  [61769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4544), 1,
      anon_sym_COMMA,
    ACTIONS(4546), 1,
      anon_sym_RPAREN,
    STATE(1667), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [61782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4548), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1810), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4550), 1,
      sym_identifier,
    STATE(1670), 1,
      sym_variadic_parameter,
  [61808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4552), 1,
      anon_sym_COMMA,
    ACTIONS(4554), 1,
      anon_sym_RPAREN,
    STATE(1565), 1,
      aux_sym__old_style_parameter_list_repeat1,
  [61821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4556), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_COMMA,
    ACTIONS(4561), 1,
      anon_sym_RPAREN,
    STATE(1647), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [61847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4563), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [61860] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    STATE(1531), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4565), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [61871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2886), 1,
      anon_sym_LBRACE,
    ACTIONS(4569), 1,
      sym_identifier,
    STATE(855), 1,
      sym_enumerator_list,
  [61893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3167), 1,
      anon_sym_RPAREN,
    STATE(1573), 1,
      aux_sym_argument_list_repeat1,
  [61906] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    STATE(1487), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4571), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [61917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2886), 1,
      anon_sym_LBRACE,
    ACTIONS(4573), 1,
      sym_identifier,
    STATE(1079), 1,
      sym_enumerator_list,
  [61930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3159), 1,
      anon_sym_RBRACE,
    STATE(1551), 1,
      aux_sym_initializer_list_repeat1,
  [61943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 1,
      anon_sym_COMMA,
    ACTIONS(4578), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1656), 1,
      aux_sym_attribute_declaration_repeat1,
  [61956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4580), 1,
      anon_sym_SEMI,
    STATE(1648), 1,
      aux_sym_declaration_repeat1,
  [61969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_COMMA,
    ACTIONS(4585), 1,
      anon_sym_RPAREN,
    STATE(1658), 1,
      aux_sym_parameter_list_repeat1,
  [61982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4587), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [61991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3257), 1,
      anon_sym_RPAREN,
    ACTIONS(4589), 1,
      anon_sym_COMMA,
    STATE(1660), 1,
      aux_sym_argument_list_repeat1,
  [62004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_RPAREN,
    ACTIONS(4592), 1,
      anon_sym_COMMA,
    STATE(1661), 1,
      aux_sym_preproc_argument_list_repeat1,
  [62017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4595), 1,
      anon_sym_COMMA,
    ACTIONS(4598), 1,
      anon_sym_RPAREN,
    STATE(1662), 1,
      aux_sym_preproc_params_repeat1,
  [62030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4600), 1,
      anon_sym_COMMA,
    ACTIONS(4603), 1,
      anon_sym_RPAREN,
    STATE(1663), 1,
      aux_sym_generic_expression_repeat1,
  [62043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4605), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [62052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4607), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [62061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4362), 1,
      anon_sym_COMMA,
    ACTIONS(4609), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1656), 1,
      aux_sym_attribute_declaration_repeat1,
  [62074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4544), 1,
      anon_sym_COMMA,
    ACTIONS(4611), 1,
      anon_sym_RPAREN,
    STATE(1647), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [62087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    ACTIONS(4613), 1,
      anon_sym_SEMI,
    STATE(1557), 1,
      aux_sym_declaration_repeat1,
  [62100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1793), 1,
      sym_parenthesized_expression,
  [62110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3223), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [62126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    STATE(108), 1,
      sym_compound_statement,
  [62136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1503), 1,
      sym_compound_statement,
  [62146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(172), 1,
      sym_compound_statement,
  [62156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4617), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1493), 1,
      sym_compound_statement,
  [62174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(158), 1,
      sym_compound_statement,
  [62184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    STATE(1922), 1,
      sym_argument_list,
  [62194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4620), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [62202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4622), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [62210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4624), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1856), 1,
      sym_parenthesized_expression,
  [62228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    STATE(166), 1,
      sym_compound_statement,
  [62238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4626), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_RPAREN,
  [62248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    STATE(183), 1,
      sym_compound_statement,
  [62258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    STATE(116), 1,
      sym_compound_statement,
  [62268] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4630), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4632), 1,
      sym_preproc_arg,
  [62278] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4634), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4636), 1,
      sym_preproc_arg,
  [62288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1695), 1,
      sym_parenthesized_expression,
  [62298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [62306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4638), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [62314] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4640), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4642), 1,
      sym_preproc_arg,
  [62324] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4644), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4646), 1,
      sym_preproc_arg,
  [62334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4648), 1,
      sym_identifier,
    STATE(1723), 1,
      sym_attribute,
  [62344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(166), 1,
      sym_compound_statement,
  [62354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(334), 1,
      sym_parenthesized_expression,
  [62364] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4652), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4654), 1,
      sym_preproc_arg,
  [62374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [62382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      sym_identifier,
    ACTIONS(4658), 1,
      anon_sym_LPAREN2,
  [62392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    STATE(225), 1,
      sym_compound_statement,
  [62402] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4660), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4662), 1,
      sym_preproc_arg,
  [62412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    STATE(213), 1,
      sym_compound_statement,
  [62422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(322), 1,
      sym_parenthesized_expression,
  [62432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4664), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4648), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_attribute,
  [62450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(341), 1,
      sym_parenthesized_expression,
  [62460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1713), 1,
      sym_parenthesized_expression,
  [62470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(342), 1,
      sym_parenthesized_expression,
  [62480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(502), 1,
      anon_sym_LBRACE,
    STATE(230), 1,
      sym_compound_statement,
  [62490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1491), 1,
      sym_compound_statement,
  [62500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(212), 1,
      sym_compound_statement,
  [62510] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4666), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4668), 1,
      sym_preproc_arg,
  [62520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_LBRACE,
    STATE(93), 1,
      sym_compound_statement,
  [62530] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4670), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4672), 1,
      sym_preproc_arg,
  [62540] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4674), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4676), 1,
      sym_preproc_arg,
  [62550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(326), 1,
      sym_parenthesized_expression,
  [62560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1865), 1,
      sym_parenthesized_expression,
  [62570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1677), 1,
      sym_parenthesized_expression,
  [62588] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4678), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4680), 1,
      sym_preproc_arg,
  [62598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(320), 1,
      sym_parenthesized_expression,
  [62608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1702), 1,
      sym_parenthesized_expression,
  [62618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4578), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [62626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(352), 1,
      sym_parenthesized_expression,
  [62636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1510), 1,
      sym_compound_statement,
  [62646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [62654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(330), 1,
      sym_parenthesized_expression,
  [62664] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4682), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4684), 1,
      sym_preproc_arg,
  [62674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN2,
    STATE(1994), 1,
      sym_argument_list,
  [62684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1996), 1,
      sym_parenthesized_expression,
  [62694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(222), 1,
      sym_compound_statement,
  [62704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1686), 1,
      sym_parenthesized_expression,
  [62714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4686), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [62722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1709), 1,
      sym_parenthesized_expression,
  [62732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1683), 1,
      sym_parenthesized_expression,
  [62742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [62750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3257), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(376), 1,
      anon_sym_LBRACE,
    STATE(172), 1,
      sym_compound_statement,
  [62768] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4688), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4690), 1,
      sym_preproc_arg,
  [62778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(333), 1,
      sym_parenthesized_expression,
  [62788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1542), 1,
      sym_compound_statement,
  [62798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1731), 1,
      sym_parenthesized_expression,
  [62808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4692), 1,
      sym_identifier,
    ACTIONS(4694), 1,
      anon_sym_LPAREN2,
  [62818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4598), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62826] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4696), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4698), 1,
      sym_preproc_arg,
  [62836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3690), 1,
      anon_sym_RBRACE,
    ACTIONS(4700), 1,
      anon_sym_COMMA,
  [62846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_COMMA,
    ACTIONS(4702), 1,
      anon_sym_RBRACE,
  [62856] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4704), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4706), 1,
      sym_preproc_arg,
  [62866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [62874] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4708), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4710), 1,
      sym_preproc_arg,
  [62884] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4712), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4714), 1,
      sym_preproc_arg,
  [62894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4648), 1,
      sym_identifier,
    STATE(1558), 1,
      sym_attribute,
  [62904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4648), 1,
      sym_identifier,
    STATE(1560), 1,
      sym_attribute,
  [62914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN2,
    STATE(325), 1,
      sym_parenthesized_expression,
  [62924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_LPAREN2,
    STATE(1685), 1,
      sym_parenthesized_expression,
  [62934] = 3,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4716), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4718), 1,
      sym_preproc_arg,
  [62944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4720), 1,
      anon_sym_while,
  [62951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4722), 1,
      anon_sym_SEMI,
  [62958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4724), 1,
      anon_sym_RPAREN,
  [62965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4726), 1,
      aux_sym_preproc_if_token2,
  [62972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3201), 1,
      anon_sym_SEMI,
  [62979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4728), 1,
      anon_sym_RBRACE,
  [62986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4730), 1,
      anon_sym_SEMI,
  [62993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4732), 1,
      aux_sym_preproc_if_token2,
  [63000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4734), 1,
      anon_sym_LPAREN2,
  [63007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4736), 1,
      anon_sym_COLON,
  [63014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4738), 1,
      anon_sym_LPAREN2,
  [63021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3209), 1,
      anon_sym_COLON,
  [63028] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4740), 1,
      aux_sym_preproc_include_token2,
  [63035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4508), 1,
      anon_sym_RPAREN,
  [63042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4742), 1,
      anon_sym_SEMI,
  [63049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4744), 1,
      anon_sym_RPAREN,
  [63056] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4746), 1,
      aux_sym_preproc_include_token2,
  [63063] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4748), 1,
      aux_sym_preproc_include_token2,
  [63070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4750), 1,
      anon_sym_RPAREN,
  [63077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      aux_sym_preproc_if_token2,
  [63084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4754), 1,
      anon_sym_RBRACK,
  [63091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4756), 1,
      aux_sym_preproc_if_token2,
  [63098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4758), 1,
      anon_sym_RPAREN,
  [63105] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4760), 1,
      aux_sym_preproc_include_token2,
  [63112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4762), 1,
      sym_identifier,
  [63119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4764), 1,
      sym_identifier,
  [63126] = 2,
    ACTIONS(2255), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3366), 1,
      sym_comment,
  [63133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4766), 1,
      anon_sym_SEMI,
  [63140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_COMMA,
  [63147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4768), 1,
      anon_sym_SEMI,
  [63154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3263), 1,
      anon_sym_RPAREN,
  [63161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4770), 1,
      anon_sym_STAR,
  [63168] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4772), 1,
      aux_sym_preproc_include_token2,
  [63175] = 2,
    ACTIONS(3139), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3366), 1,
      sym_comment,
  [63182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3241), 1,
      anon_sym_SEMI,
  [63189] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4774), 1,
      aux_sym_preproc_include_token2,
  [63196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4776), 1,
      anon_sym_SEMI,
  [63203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4778), 1,
      anon_sym_RBRACE,
  [63210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4780), 1,
      sym_identifier,
  [63217] = 2,
    ACTIONS(3143), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3366), 1,
      sym_comment,
  [63224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3205), 1,
      anon_sym_SEMI,
  [63231] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4782), 1,
      aux_sym_preproc_include_token2,
  [63238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4784), 1,
      anon_sym_SEMI,
  [63245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3235), 1,
      anon_sym_COLON,
  [63252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4786), 1,
      sym_identifier,
  [63259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      sym_primitive_type,
  [63266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4790), 1,
      anon_sym_RPAREN,
  [63273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 1,
      anon_sym_COLON,
  [63280] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4792), 1,
      aux_sym_preproc_include_token2,
  [63287] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4794), 1,
      aux_sym_preproc_include_token2,
  [63294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4796), 1,
      aux_sym_preproc_if_token2,
  [63301] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4798), 1,
      aux_sym_preproc_include_token2,
  [63308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3233), 1,
      anon_sym_RPAREN,
  [63315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4800), 1,
      sym_identifier,
  [63322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4802), 1,
      sym_identifier,
  [63329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 1,
      anon_sym_COMMA,
  [63336] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4804), 1,
      aux_sym_preproc_include_token2,
  [63343] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4339), 1,
      aux_sym_preproc_include_token2,
  [63350] = 2,
    ACTIONS(2293), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3366), 1,
      sym_comment,
  [63357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4806), 1,
      sym_identifier,
  [63364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 1,
      anon_sym_RPAREN,
  [63371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 1,
      aux_sym_preproc_if_token2,
  [63378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4812), 1,
      sym_identifier,
  [63385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 1,
      sym_identifier,
  [63392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 1,
      aux_sym_preproc_if_token2,
  [63399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 1,
      aux_sym_preproc_if_token2,
  [63406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4820), 1,
      anon_sym_SEMI,
  [63413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 1,
      aux_sym_preproc_if_token2,
  [63420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 1,
      anon_sym_RPAREN,
  [63427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_RBRACE,
  [63434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4828), 1,
      anon_sym_LPAREN2,
  [63441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3255), 1,
      anon_sym_SEMI,
  [63448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 1,
      anon_sym_RPAREN,
  [63455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4832), 1,
      anon_sym_RPAREN,
  [63462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3237), 1,
      anon_sym_RPAREN,
  [63469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      aux_sym_preproc_if_token2,
  [63476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_LPAREN2,
  [63483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      aux_sym_preproc_if_token2,
  [63490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4840), 1,
      anon_sym_LPAREN2,
  [63497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4842), 1,
      aux_sym_preproc_if_token2,
  [63504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3239), 1,
      anon_sym_RPAREN,
  [63511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3203), 1,
      anon_sym_RPAREN,
  [63518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4844), 1,
      aux_sym_preproc_if_token2,
  [63525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN2,
  [63532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4848), 1,
      sym_identifier,
  [63539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4850), 1,
      aux_sym_preproc_if_token2,
  [63546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3243), 1,
      anon_sym_RPAREN,
  [63553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4852), 1,
      anon_sym_SEMI,
  [63560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4854), 1,
      anon_sym_SEMI,
  [63567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4856), 1,
      anon_sym_STAR,
  [63574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4858), 1,
      anon_sym_RPAREN,
  [63581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3245), 1,
      anon_sym_SEMI,
  [63588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4860), 1,
      anon_sym_RPAREN,
  [63595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 1,
      anon_sym_COLON,
  [63602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4864), 1,
      sym_identifier,
  [63609] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4866), 1,
      aux_sym_preproc_include_token2,
  [63616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4868), 1,
      sym_identifier,
  [63623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4870), 1,
      anon_sym_LPAREN2,
  [63630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4872), 1,
      aux_sym_preproc_if_token2,
  [63637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4874), 1,
      anon_sym_SEMI,
  [63644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4876), 1,
      aux_sym_preproc_if_token2,
  [63651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4878), 1,
      sym_identifier,
  [63658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4880), 1,
      sym_identifier,
  [63665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4882), 1,
      anon_sym_RPAREN,
  [63672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4884), 1,
      anon_sym_RPAREN,
  [63679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 1,
      anon_sym_RBRACK,
  [63686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 1,
      aux_sym_preproc_if_token2,
  [63693] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4355), 1,
      aux_sym_preproc_include_token2,
  [63700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4890), 1,
      anon_sym_SEMI,
  [63707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4892), 1,
      anon_sym_RPAREN,
  [63714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 1,
      anon_sym_RBRACE,
  [63721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4896), 1,
      aux_sym_preproc_if_token2,
  [63728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_COLON,
  [63735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4898), 1,
      aux_sym_preproc_if_token2,
  [63742] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4900), 1,
      aux_sym_preproc_include_token2,
  [63749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4902), 1,
      aux_sym_preproc_if_token2,
  [63756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4904), 1,
      aux_sym_preproc_if_token2,
  [63763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LPAREN2,
  [63770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 1,
      sym_identifier,
  [63777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      aux_sym_preproc_if_token2,
  [63784] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4912), 1,
      aux_sym_preproc_include_token2,
  [63791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      aux_sym_preproc_if_token2,
  [63798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4916), 1,
      aux_sym_preproc_if_token2,
  [63805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 1,
      aux_sym_preproc_if_token2,
  [63812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4920), 1,
      sym_identifier,
  [63819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      ts_builtin_sym_end,
  [63826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 1,
      anon_sym_COLON,
  [63833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4926), 1,
      aux_sym_preproc_if_token2,
  [63840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 1,
      anon_sym_COMMA,
  [63847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_SEMI,
  [63854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4932), 1,
      anon_sym_SEMI,
  [63861] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4934), 1,
      aux_sym_preproc_include_token2,
  [63868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4936), 1,
      aux_sym_preproc_if_token2,
  [63875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4938), 1,
      aux_sym_preproc_if_token2,
  [63882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4940), 1,
      aux_sym_preproc_if_token2,
  [63889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4942), 1,
      anon_sym_SEMI,
  [63896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4944), 1,
      aux_sym_preproc_if_token2,
  [63903] = 2,
    ACTIONS(3131), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3366), 1,
      sym_comment,
  [63910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4946), 1,
      aux_sym_preproc_if_token2,
  [63917] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4433), 1,
      aux_sym_preproc_include_token2,
  [63924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3253), 1,
      anon_sym_COLON,
  [63931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4948), 1,
      anon_sym_LPAREN2,
  [63938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4950), 1,
      aux_sym_preproc_if_token2,
  [63945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4952), 1,
      sym_identifier,
  [63952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4954), 1,
      sym_identifier,
  [63959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4956), 1,
      aux_sym_preproc_if_token2,
  [63966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3269), 1,
      anon_sym_RPAREN,
  [63973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_SEMI,
  [63980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4960), 1,
      sym_identifier,
  [63987] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4962), 1,
      aux_sym_preproc_include_token2,
  [63994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      aux_sym_preproc_if_token2,
  [64001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4966), 1,
      anon_sym_RPAREN,
  [64008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4968), 1,
      sym_identifier,
  [64015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3283), 1,
      anon_sym_RPAREN,
  [64022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4970), 1,
      anon_sym_while,
  [64029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_SEMI,
  [64036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      aux_sym_preproc_if_token2,
  [64043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4974), 1,
      anon_sym_RPAREN,
  [64050] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(4512), 1,
      aux_sym_preproc_include_token2,
  [64057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4976), 1,
      anon_sym_LPAREN2,
  [64064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4978), 1,
      anon_sym_SEMI,
  [64071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4980), 1,
      aux_sym_preproc_if_token2,
  [64078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3221), 1,
      anon_sym_SEMI,
  [64085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4982), 1,
      sym_primitive_type,
  [64092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4984), 1,
      sym_identifier,
  [64099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4986), 1,
      anon_sym_STAR,
  [64106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4988), 1,
      anon_sym_RPAREN,
  [64113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3247), 1,
      anon_sym_SEMI,
  [64120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4990), 1,
      aux_sym_preproc_if_token2,
  [64127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4992), 1,
      aux_sym_preproc_if_token2,
  [64134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3211), 1,
      anon_sym_SEMI,
  [64141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3159), 1,
      anon_sym_RBRACE,
  [64148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3225), 1,
      anon_sym_SEMI,
  [64155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_SEMI,
  [64162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 1,
      sym_identifier,
  [64169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      sym_identifier,
  [64176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5000), 1,
      sym_identifier,
  [64183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_SEMI,
  [64190] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(5004), 1,
      aux_sym_preproc_include_token2,
  [64197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_RBRACE,
  [64204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5008), 1,
      sym_identifier,
  [64211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5010), 1,
      anon_sym_RPAREN,
  [64218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_RPAREN,
  [64225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5014), 1,
      anon_sym_COLON,
  [64232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_SEMI,
  [64239] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(5018), 1,
      aux_sym_preproc_include_token2,
  [64246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_RPAREN,
  [64253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5022), 1,
      anon_sym_COLON,
  [64260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5024), 1,
      aux_sym_preproc_if_token2,
  [64267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5026), 1,
      anon_sym_RPAREN,
  [64274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3227), 1,
      anon_sym_RPAREN,
  [64281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
  [64288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5030), 1,
      anon_sym_RPAREN,
  [64295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5032), 1,
      aux_sym_preproc_if_token2,
  [64302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5034), 1,
      anon_sym_SEMI,
  [64309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 1,
      sym_identifier,
  [64316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 1,
      anon_sym_RPAREN,
  [64323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5040), 1,
      anon_sym_STAR,
  [64330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 1,
      anon_sym_RPAREN,
  [64337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5044), 1,
      sym_identifier,
  [64344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
  [64351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5048), 1,
      anon_sym_RPAREN,
  [64358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 1,
      anon_sym_SEMI,
  [64365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 1,
      sym_identifier,
  [64372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5052), 1,
      sym_identifier,
  [64379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5054), 1,
      anon_sym_RPAREN,
  [64386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LPAREN2,
  [64393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5058), 1,
      anon_sym_LPAREN2,
  [64400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5060), 1,
      anon_sym_COLON,
  [64407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 1,
      sym_identifier,
  [64414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5064), 1,
      aux_sym_preproc_if_token2,
  [64421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 1,
      aux_sym_preproc_if_token2,
  [64428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5068), 1,
      anon_sym_RPAREN,
  [64435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 1,
      aux_sym_preproc_if_token2,
  [64442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5072), 1,
      anon_sym_COLON,
  [64449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5074), 1,
      aux_sym_preproc_if_token2,
  [64456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5076), 1,
      sym_identifier,
  [64463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 1,
      anon_sym_while,
  [64470] = 2,
    ACTIONS(3147), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3366), 1,
      sym_comment,
  [64477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3217), 1,
      anon_sym_RPAREN,
  [64484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5080), 1,
      anon_sym_SEMI,
  [64491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5082), 1,
      anon_sym_STAR,
  [64498] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(5084), 1,
      aux_sym_preproc_include_token2,
  [64505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5086), 1,
      aux_sym_preproc_if_token2,
  [64512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5088), 1,
      aux_sym_preproc_if_token2,
  [64519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5090), 1,
      aux_sym_preproc_if_token2,
  [64526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 1,
      anon_sym_COLON,
  [64533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5092), 1,
      aux_sym_preproc_if_token2,
  [64540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4702), 1,
      anon_sym_RBRACE,
  [64547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      anon_sym_LPAREN2,
  [64554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5096), 1,
      sym_identifier,
  [64561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5098), 1,
      aux_sym_preproc_if_token2,
  [64568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5100), 1,
      anon_sym_while,
  [64575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5102), 1,
      anon_sym_SEMI,
  [64582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5104), 1,
      aux_sym_preproc_if_token2,
  [64589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5106), 1,
      sym_identifier,
  [64596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5108), 1,
      anon_sym_LPAREN2,
  [64603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5110), 1,
      anon_sym_RPAREN,
  [64610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5112), 1,
      anon_sym_RBRACE,
  [64617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 1,
      anon_sym_SEMI,
  [64624] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(5116), 1,
      aux_sym_preproc_include_token2,
  [64631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 1,
      aux_sym_preproc_if_token2,
  [64638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      aux_sym_preproc_if_token2,
  [64645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3690), 1,
      anon_sym_RBRACE,
  [64652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 1,
      sym_identifier,
  [64659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5124), 1,
      anon_sym_LPAREN2,
  [64666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 1,
      anon_sym_SEMI,
  [64673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 1,
      sym_identifier,
  [64680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 1,
      anon_sym_LPAREN2,
  [64687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 1,
      sym_identifier,
  [64694] = 2,
    ACTIONS(3366), 1,
      sym_comment,
    ACTIONS(5134), 1,
      aux_sym_preproc_include_token2,
  [64701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3229), 1,
      anon_sym_SEMI,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(462)] = 0,
  [SMALL_STATE(463)] = 113,
  [SMALL_STATE(464)] = 226,
  [SMALL_STATE(465)] = 339,
  [SMALL_STATE(466)] = 452,
  [SMALL_STATE(467)] = 565,
  [SMALL_STATE(468)] = 678,
  [SMALL_STATE(469)] = 791,
  [SMALL_STATE(470)] = 904,
  [SMALL_STATE(471)] = 1017,
  [SMALL_STATE(472)] = 1130,
  [SMALL_STATE(473)] = 1243,
  [SMALL_STATE(474)] = 1356,
  [SMALL_STATE(475)] = 1469,
  [SMALL_STATE(476)] = 1582,
  [SMALL_STATE(477)] = 1695,
  [SMALL_STATE(478)] = 1808,
  [SMALL_STATE(479)] = 1921,
  [SMALL_STATE(480)] = 2034,
  [SMALL_STATE(481)] = 2147,
  [SMALL_STATE(482)] = 2260,
  [SMALL_STATE(483)] = 2373,
  [SMALL_STATE(484)] = 2486,
  [SMALL_STATE(485)] = 2599,
  [SMALL_STATE(486)] = 2712,
  [SMALL_STATE(487)] = 2825,
  [SMALL_STATE(488)] = 2938,
  [SMALL_STATE(489)] = 3051,
  [SMALL_STATE(490)] = 3164,
  [SMALL_STATE(491)] = 3277,
  [SMALL_STATE(492)] = 3387,
  [SMALL_STATE(493)] = 3497,
  [SMALL_STATE(494)] = 3607,
  [SMALL_STATE(495)] = 3717,
  [SMALL_STATE(496)] = 3827,
  [SMALL_STATE(497)] = 3937,
  [SMALL_STATE(498)] = 4047,
  [SMALL_STATE(499)] = 4157,
  [SMALL_STATE(500)] = 4267,
  [SMALL_STATE(501)] = 4377,
  [SMALL_STATE(502)] = 4487,
  [SMALL_STATE(503)] = 4594,
  [SMALL_STATE(504)] = 4701,
  [SMALL_STATE(505)] = 4808,
  [SMALL_STATE(506)] = 4915,
  [SMALL_STATE(507)] = 5022,
  [SMALL_STATE(508)] = 5129,
  [SMALL_STATE(509)] = 5236,
  [SMALL_STATE(510)] = 5343,
  [SMALL_STATE(511)] = 5450,
  [SMALL_STATE(512)] = 5557,
  [SMALL_STATE(513)] = 5664,
  [SMALL_STATE(514)] = 5771,
  [SMALL_STATE(515)] = 5878,
  [SMALL_STATE(516)] = 5985,
  [SMALL_STATE(517)] = 6092,
  [SMALL_STATE(518)] = 6199,
  [SMALL_STATE(519)] = 6306,
  [SMALL_STATE(520)] = 6413,
  [SMALL_STATE(521)] = 6522,
  [SMALL_STATE(522)] = 6629,
  [SMALL_STATE(523)] = 6736,
  [SMALL_STATE(524)] = 6843,
  [SMALL_STATE(525)] = 6950,
  [SMALL_STATE(526)] = 7057,
  [SMALL_STATE(527)] = 7164,
  [SMALL_STATE(528)] = 7271,
  [SMALL_STATE(529)] = 7378,
  [SMALL_STATE(530)] = 7485,
  [SMALL_STATE(531)] = 7592,
  [SMALL_STATE(532)] = 7699,
  [SMALL_STATE(533)] = 7806,
  [SMALL_STATE(534)] = 7913,
  [SMALL_STATE(535)] = 8020,
  [SMALL_STATE(536)] = 8127,
  [SMALL_STATE(537)] = 8234,
  [SMALL_STATE(538)] = 8341,
  [SMALL_STATE(539)] = 8448,
  [SMALL_STATE(540)] = 8555,
  [SMALL_STATE(541)] = 8664,
  [SMALL_STATE(542)] = 8771,
  [SMALL_STATE(543)] = 8878,
  [SMALL_STATE(544)] = 8985,
  [SMALL_STATE(545)] = 9092,
  [SMALL_STATE(546)] = 9199,
  [SMALL_STATE(547)] = 9306,
  [SMALL_STATE(548)] = 9413,
  [SMALL_STATE(549)] = 9520,
  [SMALL_STATE(550)] = 9627,
  [SMALL_STATE(551)] = 9734,
  [SMALL_STATE(552)] = 9841,
  [SMALL_STATE(553)] = 9948,
  [SMALL_STATE(554)] = 10055,
  [SMALL_STATE(555)] = 10162,
  [SMALL_STATE(556)] = 10269,
  [SMALL_STATE(557)] = 10376,
  [SMALL_STATE(558)] = 10483,
  [SMALL_STATE(559)] = 10590,
  [SMALL_STATE(560)] = 10697,
  [SMALL_STATE(561)] = 10804,
  [SMALL_STATE(562)] = 10911,
  [SMALL_STATE(563)] = 11018,
  [SMALL_STATE(564)] = 11125,
  [SMALL_STATE(565)] = 11232,
  [SMALL_STATE(566)] = 11339,
  [SMALL_STATE(567)] = 11448,
  [SMALL_STATE(568)] = 11555,
  [SMALL_STATE(569)] = 11662,
  [SMALL_STATE(570)] = 11769,
  [SMALL_STATE(571)] = 11876,
  [SMALL_STATE(572)] = 11967,
  [SMALL_STATE(573)] = 12074,
  [SMALL_STATE(574)] = 12181,
  [SMALL_STATE(575)] = 12288,
  [SMALL_STATE(576)] = 12395,
  [SMALL_STATE(577)] = 12502,
  [SMALL_STATE(578)] = 12609,
  [SMALL_STATE(579)] = 12716,
  [SMALL_STATE(580)] = 12825,
  [SMALL_STATE(581)] = 12932,
  [SMALL_STATE(582)] = 13039,
  [SMALL_STATE(583)] = 13146,
  [SMALL_STATE(584)] = 13253,
  [SMALL_STATE(585)] = 13360,
  [SMALL_STATE(586)] = 13467,
  [SMALL_STATE(587)] = 13574,
  [SMALL_STATE(588)] = 13681,
  [SMALL_STATE(589)] = 13788,
  [SMALL_STATE(590)] = 13895,
  [SMALL_STATE(591)] = 14002,
  [SMALL_STATE(592)] = 14109,
  [SMALL_STATE(593)] = 14216,
  [SMALL_STATE(594)] = 14323,
  [SMALL_STATE(595)] = 14430,
  [SMALL_STATE(596)] = 14537,
  [SMALL_STATE(597)] = 14644,
  [SMALL_STATE(598)] = 14751,
  [SMALL_STATE(599)] = 14858,
  [SMALL_STATE(600)] = 14965,
  [SMALL_STATE(601)] = 15072,
  [SMALL_STATE(602)] = 15179,
  [SMALL_STATE(603)] = 15286,
  [SMALL_STATE(604)] = 15393,
  [SMALL_STATE(605)] = 15500,
  [SMALL_STATE(606)] = 15607,
  [SMALL_STATE(607)] = 15714,
  [SMALL_STATE(608)] = 15821,
  [SMALL_STATE(609)] = 15928,
  [SMALL_STATE(610)] = 16035,
  [SMALL_STATE(611)] = 16142,
  [SMALL_STATE(612)] = 16249,
  [SMALL_STATE(613)] = 16356,
  [SMALL_STATE(614)] = 16463,
  [SMALL_STATE(615)] = 16570,
  [SMALL_STATE(616)] = 16677,
  [SMALL_STATE(617)] = 16784,
  [SMALL_STATE(618)] = 16891,
  [SMALL_STATE(619)] = 16998,
  [SMALL_STATE(620)] = 17105,
  [SMALL_STATE(621)] = 17212,
  [SMALL_STATE(622)] = 17319,
  [SMALL_STATE(623)] = 17426,
  [SMALL_STATE(624)] = 17533,
  [SMALL_STATE(625)] = 17640,
  [SMALL_STATE(626)] = 17711,
  [SMALL_STATE(627)] = 17782,
  [SMALL_STATE(628)] = 17853,
  [SMALL_STATE(629)] = 17959,
  [SMALL_STATE(630)] = 18067,
  [SMALL_STATE(631)] = 18135,
  [SMALL_STATE(632)] = 18198,
  [SMALL_STATE(633)] = 18261,
  [SMALL_STATE(634)] = 18324,
  [SMALL_STATE(635)] = 18387,
  [SMALL_STATE(636)] = 18450,
  [SMALL_STATE(637)] = 18513,
  [SMALL_STATE(638)] = 18576,
  [SMALL_STATE(639)] = 18655,
  [SMALL_STATE(640)] = 18718,
  [SMALL_STATE(641)] = 18781,
  [SMALL_STATE(642)] = 18844,
  [SMALL_STATE(643)] = 18907,
  [SMALL_STATE(644)] = 18970,
  [SMALL_STATE(645)] = 19070,
  [SMALL_STATE(646)] = 19170,
  [SMALL_STATE(647)] = 19270,
  [SMALL_STATE(648)] = 19370,
  [SMALL_STATE(649)] = 19470,
  [SMALL_STATE(650)] = 19570,
  [SMALL_STATE(651)] = 19670,
  [SMALL_STATE(652)] = 19770,
  [SMALL_STATE(653)] = 19870,
  [SMALL_STATE(654)] = 19970,
  [SMALL_STATE(655)] = 20070,
  [SMALL_STATE(656)] = 20170,
  [SMALL_STATE(657)] = 20270,
  [SMALL_STATE(658)] = 20370,
  [SMALL_STATE(659)] = 20470,
  [SMALL_STATE(660)] = 20570,
  [SMALL_STATE(661)] = 20631,
  [SMALL_STATE(662)] = 20728,
  [SMALL_STATE(663)] = 20789,
  [SMALL_STATE(664)] = 20850,
  [SMALL_STATE(665)] = 20921,
  [SMALL_STATE(666)] = 20982,
  [SMALL_STATE(667)] = 21079,
  [SMALL_STATE(668)] = 21178,
  [SMALL_STATE(669)] = 21243,
  [SMALL_STATE(670)] = 21302,
  [SMALL_STATE(671)] = 21392,
  [SMALL_STATE(672)] = 21450,
  [SMALL_STATE(673)] = 21508,
  [SMALL_STATE(674)] = 21566,
  [SMALL_STATE(675)] = 21624,
  [SMALL_STATE(676)] = 21682,
  [SMALL_STATE(677)] = 21740,
  [SMALL_STATE(678)] = 21798,
  [SMALL_STATE(679)] = 21856,
  [SMALL_STATE(680)] = 21914,
  [SMALL_STATE(681)] = 21972,
  [SMALL_STATE(682)] = 22030,
  [SMALL_STATE(683)] = 22088,
  [SMALL_STATE(684)] = 22146,
  [SMALL_STATE(685)] = 22204,
  [SMALL_STATE(686)] = 22262,
  [SMALL_STATE(687)] = 22320,
  [SMALL_STATE(688)] = 22378,
  [SMALL_STATE(689)] = 22468,
  [SMALL_STATE(690)] = 22558,
  [SMALL_STATE(691)] = 22648,
  [SMALL_STATE(692)] = 22738,
  [SMALL_STATE(693)] = 22828,
  [SMALL_STATE(694)] = 22918,
  [SMALL_STATE(695)] = 22976,
  [SMALL_STATE(696)] = 23034,
  [SMALL_STATE(697)] = 23124,
  [SMALL_STATE(698)] = 23181,
  [SMALL_STATE(699)] = 23238,
  [SMALL_STATE(700)] = 23295,
  [SMALL_STATE(701)] = 23356,
  [SMALL_STATE(702)] = 23421,
  [SMALL_STATE(703)] = 23488,
  [SMALL_STATE(704)] = 23555,
  [SMALL_STATE(705)] = 23622,
  [SMALL_STATE(706)] = 23689,
  [SMALL_STATE(707)] = 23776,
  [SMALL_STATE(708)] = 23843,
  [SMALL_STATE(709)] = 23908,
  [SMALL_STATE(710)] = 23972,
  [SMALL_STATE(711)] = 24028,
  [SMALL_STATE(712)] = 24092,
  [SMALL_STATE(713)] = 24148,
  [SMALL_STATE(714)] = 24204,
  [SMALL_STATE(715)] = 24268,
  [SMALL_STATE(716)] = 24332,
  [SMALL_STATE(717)] = 24396,
  [SMALL_STATE(718)] = 24460,
  [SMALL_STATE(719)] = 24531,
  [SMALL_STATE(720)] = 24586,
  [SMALL_STATE(721)] = 24657,
  [SMALL_STATE(722)] = 24728,
  [SMALL_STATE(723)] = 24799,
  [SMALL_STATE(724)] = 24854,
  [SMALL_STATE(725)] = 24909,
  [SMALL_STATE(726)] = 24967,
  [SMALL_STATE(727)] = 25025,
  [SMALL_STATE(728)] = 25083,
  [SMALL_STATE(729)] = 25141,
  [SMALL_STATE(730)] = 25199,
  [SMALL_STATE(731)] = 25257,
  [SMALL_STATE(732)] = 25315,
  [SMALL_STATE(733)] = 25373,
  [SMALL_STATE(734)] = 25431,
  [SMALL_STATE(735)] = 25489,
  [SMALL_STATE(736)] = 25547,
  [SMALL_STATE(737)] = 25604,
  [SMALL_STATE(738)] = 25657,
  [SMALL_STATE(739)] = 25714,
  [SMALL_STATE(740)] = 25767,
  [SMALL_STATE(741)] = 25820,
  [SMALL_STATE(742)] = 25873,
  [SMALL_STATE(743)] = 25926,
  [SMALL_STATE(744)] = 25979,
  [SMALL_STATE(745)] = 26032,
  [SMALL_STATE(746)] = 26085,
  [SMALL_STATE(747)] = 26144,
  [SMALL_STATE(748)] = 26207,
  [SMALL_STATE(749)] = 26260,
  [SMALL_STATE(750)] = 26317,
  [SMALL_STATE(751)] = 26374,
  [SMALL_STATE(752)] = 26435,
  [SMALL_STATE(753)] = 26492,
  [SMALL_STATE(754)] = 26545,
  [SMALL_STATE(755)] = 26598,
  [SMALL_STATE(756)] = 26651,
  [SMALL_STATE(757)] = 26704,
  [SMALL_STATE(758)] = 26757,
  [SMALL_STATE(759)] = 26810,
  [SMALL_STATE(760)] = 26863,
  [SMALL_STATE(761)] = 26916,
  [SMALL_STATE(762)] = 26969,
  [SMALL_STATE(763)] = 27022,
  [SMALL_STATE(764)] = 27075,
  [SMALL_STATE(765)] = 27132,
  [SMALL_STATE(766)] = 27189,
  [SMALL_STATE(767)] = 27248,
  [SMALL_STATE(768)] = 27311,
  [SMALL_STATE(769)] = 27374,
  [SMALL_STATE(770)] = 27437,
  [SMALL_STATE(771)] = 27490,
  [SMALL_STATE(772)] = 27543,
  [SMALL_STATE(773)] = 27606,
  [SMALL_STATE(774)] = 27659,
  [SMALL_STATE(775)] = 27712,
  [SMALL_STATE(776)] = 27765,
  [SMALL_STATE(777)] = 27818,
  [SMALL_STATE(778)] = 27881,
  [SMALL_STATE(779)] = 27934,
  [SMALL_STATE(780)] = 27986,
  [SMALL_STATE(781)] = 28076,
  [SMALL_STATE(782)] = 28128,
  [SMALL_STATE(783)] = 28180,
  [SMALL_STATE(784)] = 28232,
  [SMALL_STATE(785)] = 28284,
  [SMALL_STATE(786)] = 28336,
  [SMALL_STATE(787)] = 28388,
  [SMALL_STATE(788)] = 28440,
  [SMALL_STATE(789)] = 28510,
  [SMALL_STATE(790)] = 28570,
  [SMALL_STATE(791)] = 28640,
  [SMALL_STATE(792)] = 28730,
  [SMALL_STATE(793)] = 28782,
  [SMALL_STATE(794)] = 28852,
  [SMALL_STATE(795)] = 28904,
  [SMALL_STATE(796)] = 28956,
  [SMALL_STATE(797)] = 29042,
  [SMALL_STATE(798)] = 29106,
  [SMALL_STATE(799)] = 29188,
  [SMALL_STATE(800)] = 29268,
  [SMALL_STATE(801)] = 29346,
  [SMALL_STATE(802)] = 29422,
  [SMALL_STATE(803)] = 29496,
  [SMALL_STATE(804)] = 29568,
  [SMALL_STATE(805)] = 29636,
  [SMALL_STATE(806)] = 29702,
  [SMALL_STATE(807)] = 29788,
  [SMALL_STATE(808)] = 29874,
  [SMALL_STATE(809)] = 29944,
  [SMALL_STATE(810)] = 30028,
  [SMALL_STATE(811)] = 30080,
  [SMALL_STATE(812)] = 30132,
  [SMALL_STATE(813)] = 30184,
  [SMALL_STATE(814)] = 30236,
  [SMALL_STATE(815)] = 30288,
  [SMALL_STATE(816)] = 30340,
  [SMALL_STATE(817)] = 30392,
  [SMALL_STATE(818)] = 30477,
  [SMALL_STATE(819)] = 30556,
  [SMALL_STATE(820)] = 30633,
  [SMALL_STATE(821)] = 30708,
  [SMALL_STATE(822)] = 30793,
  [SMALL_STATE(823)] = 30866,
  [SMALL_STATE(824)] = 30937,
  [SMALL_STATE(825)] = 31004,
  [SMALL_STATE(826)] = 31087,
  [SMALL_STATE(827)] = 31148,
  [SMALL_STATE(828)] = 31213,
  [SMALL_STATE(829)] = 31268,
  [SMALL_STATE(830)] = 31325,
  [SMALL_STATE(831)] = 31388,
  [SMALL_STATE(832)] = 31473,
  [SMALL_STATE(833)] = 31530,
  [SMALL_STATE(834)] = 31611,
  [SMALL_STATE(835)] = 31669,
  [SMALL_STATE(836)] = 31723,
  [SMALL_STATE(837)] = 31809,
  [SMALL_STATE(838)] = 31895,
  [SMALL_STATE(839)] = 31944,
  [SMALL_STATE(840)] = 31993,
  [SMALL_STATE(841)] = 32041,
  [SMALL_STATE(842)] = 32089,
  [SMALL_STATE(843)] = 32137,
  [SMALL_STATE(844)] = 32185,
  [SMALL_STATE(845)] = 32233,
  [SMALL_STATE(846)] = 32281,
  [SMALL_STATE(847)] = 32329,
  [SMALL_STATE(848)] = 32377,
  [SMALL_STATE(849)] = 32425,
  [SMALL_STATE(850)] = 32473,
  [SMALL_STATE(851)] = 32521,
  [SMALL_STATE(852)] = 32569,
  [SMALL_STATE(853)] = 32621,
  [SMALL_STATE(854)] = 32669,
  [SMALL_STATE(855)] = 32717,
  [SMALL_STATE(856)] = 32769,
  [SMALL_STATE(857)] = 32817,
  [SMALL_STATE(858)] = 32865,
  [SMALL_STATE(859)] = 32913,
  [SMALL_STATE(860)] = 32961,
  [SMALL_STATE(861)] = 33009,
  [SMALL_STATE(862)] = 33061,
  [SMALL_STATE(863)] = 33109,
  [SMALL_STATE(864)] = 33157,
  [SMALL_STATE(865)] = 33205,
  [SMALL_STATE(866)] = 33253,
  [SMALL_STATE(867)] = 33301,
  [SMALL_STATE(868)] = 33353,
  [SMALL_STATE(869)] = 33401,
  [SMALL_STATE(870)] = 33449,
  [SMALL_STATE(871)] = 33497,
  [SMALL_STATE(872)] = 33545,
  [SMALL_STATE(873)] = 33593,
  [SMALL_STATE(874)] = 33645,
  [SMALL_STATE(875)] = 33693,
  [SMALL_STATE(876)] = 33741,
  [SMALL_STATE(877)] = 33789,
  [SMALL_STATE(878)] = 33837,
  [SMALL_STATE(879)] = 33885,
  [SMALL_STATE(880)] = 33937,
  [SMALL_STATE(881)] = 33989,
  [SMALL_STATE(882)] = 34037,
  [SMALL_STATE(883)] = 34085,
  [SMALL_STATE(884)] = 34166,
  [SMALL_STATE(885)] = 34225,
  [SMALL_STATE(886)] = 34308,
  [SMALL_STATE(887)] = 34369,
  [SMALL_STATE(888)] = 34448,
  [SMALL_STATE(889)] = 34525,
  [SMALL_STATE(890)] = 34600,
  [SMALL_STATE(891)] = 34673,
  [SMALL_STATE(892)] = 34744,
  [SMALL_STATE(893)] = 34821,
  [SMALL_STATE(894)] = 34890,
  [SMALL_STATE(895)] = 34947,
  [SMALL_STATE(896)] = 35006,
  [SMALL_STATE(897)] = 35071,
  [SMALL_STATE(898)] = 35130,
  [SMALL_STATE(899)] = 35189,
  [SMALL_STATE(900)] = 35252,
  [SMALL_STATE(901)] = 35329,
  [SMALL_STATE(902)] = 35412,
  [SMALL_STATE(903)] = 35489,
  [SMALL_STATE(904)] = 35566,
  [SMALL_STATE(905)] = 35649,
  [SMALL_STATE(906)] = 35708,
  [SMALL_STATE(907)] = 35758,
  [SMALL_STATE(908)] = 35804,
  [SMALL_STATE(909)] = 35850,
  [SMALL_STATE(910)] = 35896,
  [SMALL_STATE(911)] = 35942,
  [SMALL_STATE(912)] = 35988,
  [SMALL_STATE(913)] = 36034,
  [SMALL_STATE(914)] = 36080,
  [SMALL_STATE(915)] = 36126,
  [SMALL_STATE(916)] = 36172,
  [SMALL_STATE(917)] = 36218,
  [SMALL_STATE(918)] = 36264,
  [SMALL_STATE(919)] = 36310,
  [SMALL_STATE(920)] = 36368,
  [SMALL_STATE(921)] = 36414,
  [SMALL_STATE(922)] = 36460,
  [SMALL_STATE(923)] = 36513,
  [SMALL_STATE(924)] = 36568,
  [SMALL_STATE(925)] = 36619,
  [SMALL_STATE(926)] = 36693,
  [SMALL_STATE(927)] = 36767,
  [SMALL_STATE(928)] = 36810,
  [SMALL_STATE(929)] = 36853,
  [SMALL_STATE(930)] = 36896,
  [SMALL_STATE(931)] = 36939,
  [SMALL_STATE(932)] = 37012,
  [SMALL_STATE(933)] = 37055,
  [SMALL_STATE(934)] = 37098,
  [SMALL_STATE(935)] = 37141,
  [SMALL_STATE(936)] = 37184,
  [SMALL_STATE(937)] = 37227,
  [SMALL_STATE(938)] = 37270,
  [SMALL_STATE(939)] = 37313,
  [SMALL_STATE(940)] = 37356,
  [SMALL_STATE(941)] = 37399,
  [SMALL_STATE(942)] = 37472,
  [SMALL_STATE(943)] = 37540,
  [SMALL_STATE(944)] = 37610,
  [SMALL_STATE(945)] = 37660,
  [SMALL_STATE(946)] = 37728,
  [SMALL_STATE(947)] = 37796,
  [SMALL_STATE(948)] = 37864,
  [SMALL_STATE(949)] = 37932,
  [SMALL_STATE(950)] = 38002,
  [SMALL_STATE(951)] = 38070,
  [SMALL_STATE(952)] = 38138,
  [SMALL_STATE(953)] = 38206,
  [SMALL_STATE(954)] = 38274,
  [SMALL_STATE(955)] = 38342,
  [SMALL_STATE(956)] = 38410,
  [SMALL_STATE(957)] = 38478,
  [SMALL_STATE(958)] = 38555,
  [SMALL_STATE(959)] = 38614,
  [SMALL_STATE(960)] = 38691,
  [SMALL_STATE(961)] = 38768,
  [SMALL_STATE(962)] = 38845,
  [SMALL_STATE(963)] = 38900,
  [SMALL_STATE(964)] = 38973,
  [SMALL_STATE(965)] = 39044,
  [SMALL_STATE(966)] = 39113,
  [SMALL_STATE(967)] = 39188,
  [SMALL_STATE(968)] = 39255,
  [SMALL_STATE(969)] = 39320,
  [SMALL_STATE(970)] = 39383,
  [SMALL_STATE(971)] = 39440,
  [SMALL_STATE(972)] = 39504,
  [SMALL_STATE(973)] = 39576,
  [SMALL_STATE(974)] = 39630,
  [SMALL_STATE(975)] = 39694,
  [SMALL_STATE(976)] = 39742,
  [SMALL_STATE(977)] = 39798,
  [SMALL_STATE(978)] = 39862,
  [SMALL_STATE(979)] = 39928,
  [SMALL_STATE(980)] = 39992,
  [SMALL_STATE(981)] = 40062,
  [SMALL_STATE(982)] = 40126,
  [SMALL_STATE(983)] = 40194,
  [SMALL_STATE(984)] = 40268,
  [SMALL_STATE(985)] = 40342,
  [SMALL_STATE(986)] = 40406,
  [SMALL_STATE(987)] = 40474,
  [SMALL_STATE(988)] = 40538,
  [SMALL_STATE(989)] = 40612,
  [SMALL_STATE(990)] = 40674,
  [SMALL_STATE(991)] = 40732,
  [SMALL_STATE(992)] = 40796,
  [SMALL_STATE(993)] = 40860,
  [SMALL_STATE(994)] = 40924,
  [SMALL_STATE(995)] = 40988,
  [SMALL_STATE(996)] = 41052,
  [SMALL_STATE(997)] = 41116,
  [SMALL_STATE(998)] = 41180,
  [SMALL_STATE(999)] = 41241,
  [SMALL_STATE(1000)] = 41302,
  [SMALL_STATE(1001)] = 41363,
  [SMALL_STATE(1002)] = 41402,
  [SMALL_STATE(1003)] = 41441,
  [SMALL_STATE(1004)] = 41480,
  [SMALL_STATE(1005)] = 41541,
  [SMALL_STATE(1006)] = 41602,
  [SMALL_STATE(1007)] = 41641,
  [SMALL_STATE(1008)] = 41680,
  [SMALL_STATE(1009)] = 41719,
  [SMALL_STATE(1010)] = 41780,
  [SMALL_STATE(1011)] = 41854,
  [SMALL_STATE(1012)] = 41929,
  [SMALL_STATE(1013)] = 42004,
  [SMALL_STATE(1014)] = 42079,
  [SMALL_STATE(1015)] = 42150,
  [SMALL_STATE(1016)] = 42195,
  [SMALL_STATE(1017)] = 42270,
  [SMALL_STATE(1018)] = 42317,
  [SMALL_STATE(1019)] = 42391,
  [SMALL_STATE(1020)] = 42463,
  [SMALL_STATE(1021)] = 42535,
  [SMALL_STATE(1022)] = 42607,
  [SMALL_STATE(1023)] = 42677,
  [SMALL_STATE(1024)] = 42749,
  [SMALL_STATE(1025)] = 42821,
  [SMALL_STATE(1026)] = 42893,
  [SMALL_STATE(1027)] = 42965,
  [SMALL_STATE(1028)] = 43035,
  [SMALL_STATE(1029)] = 43105,
  [SMALL_STATE(1030)] = 43177,
  [SMALL_STATE(1031)] = 43247,
  [SMALL_STATE(1032)] = 43319,
  [SMALL_STATE(1033)] = 43389,
  [SMALL_STATE(1034)] = 43461,
  [SMALL_STATE(1035)] = 43533,
  [SMALL_STATE(1036)] = 43605,
  [SMALL_STATE(1037)] = 43675,
  [SMALL_STATE(1038)] = 43747,
  [SMALL_STATE(1039)] = 43819,
  [SMALL_STATE(1040)] = 43891,
  [SMALL_STATE(1041)] = 43961,
  [SMALL_STATE(1042)] = 44033,
  [SMALL_STATE(1043)] = 44105,
  [SMALL_STATE(1044)] = 44177,
  [SMALL_STATE(1045)] = 44249,
  [SMALL_STATE(1046)] = 44321,
  [SMALL_STATE(1047)] = 44393,
  [SMALL_STATE(1048)] = 44465,
  [SMALL_STATE(1049)] = 44537,
  [SMALL_STATE(1050)] = 44609,
  [SMALL_STATE(1051)] = 44661,
  [SMALL_STATE(1052)] = 44733,
  [SMALL_STATE(1053)] = 44801,
  [SMALL_STATE(1054)] = 44871,
  [SMALL_STATE(1055)] = 44937,
  [SMALL_STATE(1056)] = 45003,
  [SMALL_STATE(1057)] = 45067,
  [SMALL_STATE(1058)] = 45129,
  [SMALL_STATE(1059)] = 45189,
  [SMALL_STATE(1060)] = 45245,
  [SMALL_STATE(1061)] = 45317,
  [SMALL_STATE(1062)] = 45371,
  [SMALL_STATE(1063)] = 45443,
  [SMALL_STATE(1064)] = 45515,
  [SMALL_STATE(1065)] = 45587,
  [SMALL_STATE(1066)] = 45656,
  [SMALL_STATE(1067)] = 45725,
  [SMALL_STATE(1068)] = 45794,
  [SMALL_STATE(1069)] = 45863,
  [SMALL_STATE(1070)] = 45932,
  [SMALL_STATE(1071)] = 46001,
  [SMALL_STATE(1072)] = 46070,
  [SMALL_STATE(1073)] = 46125,
  [SMALL_STATE(1074)] = 46180,
  [SMALL_STATE(1075)] = 46249,
  [SMALL_STATE(1076)] = 46318,
  [SMALL_STATE(1077)] = 46373,
  [SMALL_STATE(1078)] = 46442,
  [SMALL_STATE(1079)] = 46511,
  [SMALL_STATE(1080)] = 46550,
  [SMALL_STATE(1081)] = 46619,
  [SMALL_STATE(1082)] = 46658,
  [SMALL_STATE(1083)] = 46727,
  [SMALL_STATE(1084)] = 46796,
  [SMALL_STATE(1085)] = 46851,
  [SMALL_STATE(1086)] = 46920,
  [SMALL_STATE(1087)] = 46989,
  [SMALL_STATE(1088)] = 47044,
  [SMALL_STATE(1089)] = 47113,
  [SMALL_STATE(1090)] = 47182,
  [SMALL_STATE(1091)] = 47251,
  [SMALL_STATE(1092)] = 47320,
  [SMALL_STATE(1093)] = 47389,
  [SMALL_STATE(1094)] = 47458,
  [SMALL_STATE(1095)] = 47497,
  [SMALL_STATE(1096)] = 47552,
  [SMALL_STATE(1097)] = 47604,
  [SMALL_STATE(1098)] = 47656,
  [SMALL_STATE(1099)] = 47708,
  [SMALL_STATE(1100)] = 47760,
  [SMALL_STATE(1101)] = 47826,
  [SMALL_STATE(1102)] = 47878,
  [SMALL_STATE(1103)] = 47930,
  [SMALL_STATE(1104)] = 47966,
  [SMALL_STATE(1105)] = 48018,
  [SMALL_STATE(1106)] = 48070,
  [SMALL_STATE(1107)] = 48122,
  [SMALL_STATE(1108)] = 48161,
  [SMALL_STATE(1109)] = 48202,
  [SMALL_STATE(1110)] = 48242,
  [SMALL_STATE(1111)] = 48282,
  [SMALL_STATE(1112)] = 48322,
  [SMALL_STATE(1113)] = 48362,
  [SMALL_STATE(1114)] = 48411,
  [SMALL_STATE(1115)] = 48466,
  [SMALL_STATE(1116)] = 48504,
  [SMALL_STATE(1117)] = 48558,
  [SMALL_STATE(1118)] = 48592,
  [SMALL_STATE(1119)] = 48646,
  [SMALL_STATE(1120)] = 48700,
  [SMALL_STATE(1121)] = 48734,
  [SMALL_STATE(1122)] = 48768,
  [SMALL_STATE(1123)] = 48802,
  [SMALL_STATE(1124)] = 48836,
  [SMALL_STATE(1125)] = 48870,
  [SMALL_STATE(1126)] = 48904,
  [SMALL_STATE(1127)] = 48938,
  [SMALL_STATE(1128)] = 48972,
  [SMALL_STATE(1129)] = 49008,
  [SMALL_STATE(1130)] = 49062,
  [SMALL_STATE(1131)] = 49113,
  [SMALL_STATE(1132)] = 49146,
  [SMALL_STATE(1133)] = 49189,
  [SMALL_STATE(1134)] = 49244,
  [SMALL_STATE(1135)] = 49287,
  [SMALL_STATE(1136)] = 49338,
  [SMALL_STATE(1137)] = 49389,
  [SMALL_STATE(1138)] = 49440,
  [SMALL_STATE(1139)] = 49495,
  [SMALL_STATE(1140)] = 49546,
  [SMALL_STATE(1141)] = 49597,
  [SMALL_STATE(1142)] = 49648,
  [SMALL_STATE(1143)] = 49703,
  [SMALL_STATE(1144)] = 49754,
  [SMALL_STATE(1145)] = 49805,
  [SMALL_STATE(1146)] = 49848,
  [SMALL_STATE(1147)] = 49899,
  [SMALL_STATE(1148)] = 49950,
  [SMALL_STATE(1149)] = 49990,
  [SMALL_STATE(1150)] = 50030,
  [SMALL_STATE(1151)] = 50070,
  [SMALL_STATE(1152)] = 50116,
  [SMALL_STATE(1153)] = 50156,
  [SMALL_STATE(1154)] = 50196,
  [SMALL_STATE(1155)] = 50234,
  [SMALL_STATE(1156)] = 50274,
  [SMALL_STATE(1157)] = 50310,
  [SMALL_STATE(1158)] = 50344,
  [SMALL_STATE(1159)] = 50384,
  [SMALL_STATE(1160)] = 50424,
  [SMALL_STATE(1161)] = 50464,
  [SMALL_STATE(1162)] = 50506,
  [SMALL_STATE(1163)] = 50546,
  [SMALL_STATE(1164)] = 50586,
  [SMALL_STATE(1165)] = 50626,
  [SMALL_STATE(1166)] = 50666,
  [SMALL_STATE(1167)] = 50694,
  [SMALL_STATE(1168)] = 50734,
  [SMALL_STATE(1169)] = 50762,
  [SMALL_STATE(1170)] = 50802,
  [SMALL_STATE(1171)] = 50830,
  [SMALL_STATE(1172)] = 50870,
  [SMALL_STATE(1173)] = 50910,
  [SMALL_STATE(1174)] = 50950,
  [SMALL_STATE(1175)] = 50990,
  [SMALL_STATE(1176)] = 51038,
  [SMALL_STATE(1177)] = 51078,
  [SMALL_STATE(1178)] = 51118,
  [SMALL_STATE(1179)] = 51158,
  [SMALL_STATE(1180)] = 51186,
  [SMALL_STATE(1181)] = 51226,
  [SMALL_STATE(1182)] = 51266,
  [SMALL_STATE(1183)] = 51306,
  [SMALL_STATE(1184)] = 51346,
  [SMALL_STATE(1185)] = 51386,
  [SMALL_STATE(1186)] = 51426,
  [SMALL_STATE(1187)] = 51466,
  [SMALL_STATE(1188)] = 51506,
  [SMALL_STATE(1189)] = 51546,
  [SMALL_STATE(1190)] = 51586,
  [SMALL_STATE(1191)] = 51626,
  [SMALL_STATE(1192)] = 51666,
  [SMALL_STATE(1193)] = 51712,
  [SMALL_STATE(1194)] = 51762,
  [SMALL_STATE(1195)] = 51802,
  [SMALL_STATE(1196)] = 51830,
  [SMALL_STATE(1197)] = 51870,
  [SMALL_STATE(1198)] = 51910,
  [SMALL_STATE(1199)] = 51942,
  [SMALL_STATE(1200)] = 51982,
  [SMALL_STATE(1201)] = 52022,
  [SMALL_STATE(1202)] = 52062,
  [SMALL_STATE(1203)] = 52090,
  [SMALL_STATE(1204)] = 52134,
  [SMALL_STATE(1205)] = 52161,
  [SMALL_STATE(1206)] = 52206,
  [SMALL_STATE(1207)] = 52249,
  [SMALL_STATE(1208)] = 52298,
  [SMALL_STATE(1209)] = 52325,
  [SMALL_STATE(1210)] = 52358,
  [SMALL_STATE(1211)] = 52403,
  [SMALL_STATE(1212)] = 52432,
  [SMALL_STATE(1213)] = 52475,
  [SMALL_STATE(1214)] = 52520,
  [SMALL_STATE(1215)] = 52547,
  [SMALL_STATE(1216)] = 52578,
  [SMALL_STATE(1217)] = 52605,
  [SMALL_STATE(1218)] = 52650,
  [SMALL_STATE(1219)] = 52693,
  [SMALL_STATE(1220)] = 52738,
  [SMALL_STATE(1221)] = 52777,
  [SMALL_STATE(1222)] = 52804,
  [SMALL_STATE(1223)] = 52831,
  [SMALL_STATE(1224)] = 52876,
  [SMALL_STATE(1225)] = 52921,
  [SMALL_STATE(1226)] = 52964,
  [SMALL_STATE(1227)] = 52991,
  [SMALL_STATE(1228)] = 53040,
  [SMALL_STATE(1229)] = 53067,
  [SMALL_STATE(1230)] = 53110,
  [SMALL_STATE(1231)] = 53147,
  [SMALL_STATE(1232)] = 53192,
  [SMALL_STATE(1233)] = 53219,
  [SMALL_STATE(1234)] = 53246,
  [SMALL_STATE(1235)] = 53281,
  [SMALL_STATE(1236)] = 53326,
  [SMALL_STATE(1237)] = 53371,
  [SMALL_STATE(1238)] = 53416,
  [SMALL_STATE(1239)] = 53461,
  [SMALL_STATE(1240)] = 53506,
  [SMALL_STATE(1241)] = 53547,
  [SMALL_STATE(1242)] = 53592,
  [SMALL_STATE(1243)] = 53637,
  [SMALL_STATE(1244)] = 53677,
  [SMALL_STATE(1245)] = 53721,
  [SMALL_STATE(1246)] = 53761,
  [SMALL_STATE(1247)] = 53801,
  [SMALL_STATE(1248)] = 53841,
  [SMALL_STATE(1249)] = 53881,
  [SMALL_STATE(1250)] = 53921,
  [SMALL_STATE(1251)] = 53956,
  [SMALL_STATE(1252)] = 53997,
  [SMALL_STATE(1253)] = 54038,
  [SMALL_STATE(1254)] = 54079,
  [SMALL_STATE(1255)] = 54120,
  [SMALL_STATE(1256)] = 54161,
  [SMALL_STATE(1257)] = 54202,
  [SMALL_STATE(1258)] = 54243,
  [SMALL_STATE(1259)] = 54284,
  [SMALL_STATE(1260)] = 54325,
  [SMALL_STATE(1261)] = 54355,
  [SMALL_STATE(1262)] = 54393,
  [SMALL_STATE(1263)] = 54431,
  [SMALL_STATE(1264)] = 54461,
  [SMALL_STATE(1265)] = 54499,
  [SMALL_STATE(1266)] = 54529,
  [SMALL_STATE(1267)] = 54559,
  [SMALL_STATE(1268)] = 54586,
  [SMALL_STATE(1269)] = 54627,
  [SMALL_STATE(1270)] = 54666,
  [SMALL_STATE(1271)] = 54705,
  [SMALL_STATE(1272)] = 54744,
  [SMALL_STATE(1273)] = 54785,
  [SMALL_STATE(1274)] = 54826,
  [SMALL_STATE(1275)] = 54865,
  [SMALL_STATE(1276)] = 54887,
  [SMALL_STATE(1277)] = 54909,
  [SMALL_STATE(1278)] = 54935,
  [SMALL_STATE(1279)] = 54967,
  [SMALL_STATE(1280)] = 54999,
  [SMALL_STATE(1281)] = 55031,
  [SMALL_STATE(1282)] = 55053,
  [SMALL_STATE(1283)] = 55085,
  [SMALL_STATE(1284)] = 55117,
  [SMALL_STATE(1285)] = 55143,
  [SMALL_STATE(1286)] = 55180,
  [SMALL_STATE(1287)] = 55217,
  [SMALL_STATE(1288)] = 55254,
  [SMALL_STATE(1289)] = 55291,
  [SMALL_STATE(1290)] = 55324,
  [SMALL_STATE(1291)] = 55361,
  [SMALL_STATE(1292)] = 55398,
  [SMALL_STATE(1293)] = 55435,
  [SMALL_STATE(1294)] = 55472,
  [SMALL_STATE(1295)] = 55505,
  [SMALL_STATE(1296)] = 55542,
  [SMALL_STATE(1297)] = 55579,
  [SMALL_STATE(1298)] = 55616,
  [SMALL_STATE(1299)] = 55636,
  [SMALL_STATE(1300)] = 55656,
  [SMALL_STATE(1301)] = 55676,
  [SMALL_STATE(1302)] = 55696,
  [SMALL_STATE(1303)] = 55716,
  [SMALL_STATE(1304)] = 55736,
  [SMALL_STATE(1305)] = 55756,
  [SMALL_STATE(1306)] = 55792,
  [SMALL_STATE(1307)] = 55818,
  [SMALL_STATE(1308)] = 55847,
  [SMALL_STATE(1309)] = 55876,
  [SMALL_STATE(1310)] = 55907,
  [SMALL_STATE(1311)] = 55936,
  [SMALL_STATE(1312)] = 55965,
  [SMALL_STATE(1313)] = 55992,
  [SMALL_STATE(1314)] = 56023,
  [SMALL_STATE(1315)] = 56052,
  [SMALL_STATE(1316)] = 56081,
  [SMALL_STATE(1317)] = 56112,
  [SMALL_STATE(1318)] = 56139,
  [SMALL_STATE(1319)] = 56170,
  [SMALL_STATE(1320)] = 56201,
  [SMALL_STATE(1321)] = 56230,
  [SMALL_STATE(1322)] = 56259,
  [SMALL_STATE(1323)] = 56290,
  [SMALL_STATE(1324)] = 56319,
  [SMALL_STATE(1325)] = 56348,
  [SMALL_STATE(1326)] = 56379,
  [SMALL_STATE(1327)] = 56408,
  [SMALL_STATE(1328)] = 56439,
  [SMALL_STATE(1329)] = 56468,
  [SMALL_STATE(1330)] = 56495,
  [SMALL_STATE(1331)] = 56526,
  [SMALL_STATE(1332)] = 56553,
  [SMALL_STATE(1333)] = 56584,
  [SMALL_STATE(1334)] = 56613,
  [SMALL_STATE(1335)] = 56642,
  [SMALL_STATE(1336)] = 56667,
  [SMALL_STATE(1337)] = 56699,
  [SMALL_STATE(1338)] = 56725,
  [SMALL_STATE(1339)] = 56747,
  [SMALL_STATE(1340)] = 56773,
  [SMALL_STATE(1341)] = 56799,
  [SMALL_STATE(1342)] = 56823,
  [SMALL_STATE(1343)] = 56855,
  [SMALL_STATE(1344)] = 56877,
  [SMALL_STATE(1345)] = 56909,
  [SMALL_STATE(1346)] = 56941,
  [SMALL_STATE(1347)] = 56967,
  [SMALL_STATE(1348)] = 56989,
  [SMALL_STATE(1349)] = 57011,
  [SMALL_STATE(1350)] = 57041,
  [SMALL_STATE(1351)] = 57065,
  [SMALL_STATE(1352)] = 57089,
  [SMALL_STATE(1353)] = 57110,
  [SMALL_STATE(1354)] = 57139,
  [SMALL_STATE(1355)] = 57164,
  [SMALL_STATE(1356)] = 57189,
  [SMALL_STATE(1357)] = 57218,
  [SMALL_STATE(1358)] = 57247,
  [SMALL_STATE(1359)] = 57276,
  [SMALL_STATE(1360)] = 57301,
  [SMALL_STATE(1361)] = 57330,
  [SMALL_STATE(1362)] = 57351,
  [SMALL_STATE(1363)] = 57376,
  [SMALL_STATE(1364)] = 57397,
  [SMALL_STATE(1365)] = 57418,
  [SMALL_STATE(1366)] = 57447,
  [SMALL_STATE(1367)] = 57468,
  [SMALL_STATE(1368)] = 57493,
  [SMALL_STATE(1369)] = 57514,
  [SMALL_STATE(1370)] = 57535,
  [SMALL_STATE(1371)] = 57556,
  [SMALL_STATE(1372)] = 57577,
  [SMALL_STATE(1373)] = 57606,
  [SMALL_STATE(1374)] = 57631,
  [SMALL_STATE(1375)] = 57660,
  [SMALL_STATE(1376)] = 57680,
  [SMALL_STATE(1377)] = 57706,
  [SMALL_STATE(1378)] = 57732,
  [SMALL_STATE(1379)] = 57748,
  [SMALL_STATE(1380)] = 57774,
  [SMALL_STATE(1381)] = 57800,
  [SMALL_STATE(1382)] = 57826,
  [SMALL_STATE(1383)] = 57846,
  [SMALL_STATE(1384)] = 57872,
  [SMALL_STATE(1385)] = 57888,
  [SMALL_STATE(1386)] = 57914,
  [SMALL_STATE(1387)] = 57930,
  [SMALL_STATE(1388)] = 57946,
  [SMALL_STATE(1389)] = 57972,
  [SMALL_STATE(1390)] = 57996,
  [SMALL_STATE(1391)] = 58022,
  [SMALL_STATE(1392)] = 58038,
  [SMALL_STATE(1393)] = 58054,
  [SMALL_STATE(1394)] = 58074,
  [SMALL_STATE(1395)] = 58094,
  [SMALL_STATE(1396)] = 58114,
  [SMALL_STATE(1397)] = 58130,
  [SMALL_STATE(1398)] = 58156,
  [SMALL_STATE(1399)] = 58174,
  [SMALL_STATE(1400)] = 58196,
  [SMALL_STATE(1401)] = 58222,
  [SMALL_STATE(1402)] = 58238,
  [SMALL_STATE(1403)] = 58264,
  [SMALL_STATE(1404)] = 58280,
  [SMALL_STATE(1405)] = 58295,
  [SMALL_STATE(1406)] = 58314,
  [SMALL_STATE(1407)] = 58329,
  [SMALL_STATE(1408)] = 58352,
  [SMALL_STATE(1409)] = 58367,
  [SMALL_STATE(1410)] = 58390,
  [SMALL_STATE(1411)] = 58409,
  [SMALL_STATE(1412)] = 58424,
  [SMALL_STATE(1413)] = 58439,
  [SMALL_STATE(1414)] = 58462,
  [SMALL_STATE(1415)] = 58485,
  [SMALL_STATE(1416)] = 58500,
  [SMALL_STATE(1417)] = 58523,
  [SMALL_STATE(1418)] = 58538,
  [SMALL_STATE(1419)] = 58561,
  [SMALL_STATE(1420)] = 58580,
  [SMALL_STATE(1421)] = 58595,
  [SMALL_STATE(1422)] = 58612,
  [SMALL_STATE(1423)] = 58635,
  [SMALL_STATE(1424)] = 58650,
  [SMALL_STATE(1425)] = 58673,
  [SMALL_STATE(1426)] = 58690,
  [SMALL_STATE(1427)] = 58709,
  [SMALL_STATE(1428)] = 58732,
  [SMALL_STATE(1429)] = 58749,
  [SMALL_STATE(1430)] = 58774,
  [SMALL_STATE(1431)] = 58793,
  [SMALL_STATE(1432)] = 58816,
  [SMALL_STATE(1433)] = 58839,
  [SMALL_STATE(1434)] = 58856,
  [SMALL_STATE(1435)] = 58879,
  [SMALL_STATE(1436)] = 58902,
  [SMALL_STATE(1437)] = 58925,
  [SMALL_STATE(1438)] = 58948,
  [SMALL_STATE(1439)] = 58971,
  [SMALL_STATE(1440)] = 58994,
  [SMALL_STATE(1441)] = 59017,
  [SMALL_STATE(1442)] = 59032,
  [SMALL_STATE(1443)] = 59055,
  [SMALL_STATE(1444)] = 59069,
  [SMALL_STATE(1445)] = 59081,
  [SMALL_STATE(1446)] = 59093,
  [SMALL_STATE(1447)] = 59105,
  [SMALL_STATE(1448)] = 59117,
  [SMALL_STATE(1449)] = 59131,
  [SMALL_STATE(1450)] = 59143,
  [SMALL_STATE(1451)] = 59163,
  [SMALL_STATE(1452)] = 59175,
  [SMALL_STATE(1453)] = 59193,
  [SMALL_STATE(1454)] = 59207,
  [SMALL_STATE(1455)] = 59225,
  [SMALL_STATE(1456)] = 59239,
  [SMALL_STATE(1457)] = 59251,
  [SMALL_STATE(1458)] = 59263,
  [SMALL_STATE(1459)] = 59281,
  [SMALL_STATE(1460)] = 59293,
  [SMALL_STATE(1461)] = 59305,
  [SMALL_STATE(1462)] = 59319,
  [SMALL_STATE(1463)] = 59331,
  [SMALL_STATE(1464)] = 59345,
  [SMALL_STATE(1465)] = 59359,
  [SMALL_STATE(1466)] = 59373,
  [SMALL_STATE(1467)] = 59385,
  [SMALL_STATE(1468)] = 59403,
  [SMALL_STATE(1469)] = 59417,
  [SMALL_STATE(1470)] = 59435,
  [SMALL_STATE(1471)] = 59449,
  [SMALL_STATE(1472)] = 59467,
  [SMALL_STATE(1473)] = 59479,
  [SMALL_STATE(1474)] = 59493,
  [SMALL_STATE(1475)] = 59507,
  [SMALL_STATE(1476)] = 59521,
  [SMALL_STATE(1477)] = 59535,
  [SMALL_STATE(1478)] = 59549,
  [SMALL_STATE(1479)] = 59566,
  [SMALL_STATE(1480)] = 59581,
  [SMALL_STATE(1481)] = 59600,
  [SMALL_STATE(1482)] = 59619,
  [SMALL_STATE(1483)] = 59638,
  [SMALL_STATE(1484)] = 59649,
  [SMALL_STATE(1485)] = 59662,
  [SMALL_STATE(1486)] = 59677,
  [SMALL_STATE(1487)] = 59692,
  [SMALL_STATE(1488)] = 59706,
  [SMALL_STATE(1489)] = 59720,
  [SMALL_STATE(1490)] = 59734,
  [SMALL_STATE(1491)] = 59750,
  [SMALL_STATE(1492)] = 59764,
  [SMALL_STATE(1493)] = 59780,
  [SMALL_STATE(1494)] = 59794,
  [SMALL_STATE(1495)] = 59808,
  [SMALL_STATE(1496)] = 59822,
  [SMALL_STATE(1497)] = 59838,
  [SMALL_STATE(1498)] = 59852,
  [SMALL_STATE(1499)] = 59868,
  [SMALL_STATE(1500)] = 59884,
  [SMALL_STATE(1501)] = 59898,
  [SMALL_STATE(1502)] = 59912,
  [SMALL_STATE(1503)] = 59926,
  [SMALL_STATE(1504)] = 59940,
  [SMALL_STATE(1505)] = 59954,
  [SMALL_STATE(1506)] = 59968,
  [SMALL_STATE(1507)] = 59982,
  [SMALL_STATE(1508)] = 59998,
  [SMALL_STATE(1509)] = 60012,
  [SMALL_STATE(1510)] = 60026,
  [SMALL_STATE(1511)] = 60040,
  [SMALL_STATE(1512)] = 60054,
  [SMALL_STATE(1513)] = 60068,
  [SMALL_STATE(1514)] = 60082,
  [SMALL_STATE(1515)] = 60096,
  [SMALL_STATE(1516)] = 60110,
  [SMALL_STATE(1517)] = 60124,
  [SMALL_STATE(1518)] = 60140,
  [SMALL_STATE(1519)] = 60154,
  [SMALL_STATE(1520)] = 60168,
  [SMALL_STATE(1521)] = 60182,
  [SMALL_STATE(1522)] = 60198,
  [SMALL_STATE(1523)] = 60214,
  [SMALL_STATE(1524)] = 60228,
  [SMALL_STATE(1525)] = 60242,
  [SMALL_STATE(1526)] = 60258,
  [SMALL_STATE(1527)] = 60272,
  [SMALL_STATE(1528)] = 60288,
  [SMALL_STATE(1529)] = 60302,
  [SMALL_STATE(1530)] = 60318,
  [SMALL_STATE(1531)] = 60334,
  [SMALL_STATE(1532)] = 60348,
  [SMALL_STATE(1533)] = 60364,
  [SMALL_STATE(1534)] = 60380,
  [SMALL_STATE(1535)] = 60396,
  [SMALL_STATE(1536)] = 60410,
  [SMALL_STATE(1537)] = 60424,
  [SMALL_STATE(1538)] = 60440,
  [SMALL_STATE(1539)] = 60454,
  [SMALL_STATE(1540)] = 60468,
  [SMALL_STATE(1541)] = 60484,
  [SMALL_STATE(1542)] = 60498,
  [SMALL_STATE(1543)] = 60512,
  [SMALL_STATE(1544)] = 60526,
  [SMALL_STATE(1545)] = 60540,
  [SMALL_STATE(1546)] = 60556,
  [SMALL_STATE(1547)] = 60570,
  [SMALL_STATE(1548)] = 60584,
  [SMALL_STATE(1549)] = 60598,
  [SMALL_STATE(1550)] = 60611,
  [SMALL_STATE(1551)] = 60624,
  [SMALL_STATE(1552)] = 60637,
  [SMALL_STATE(1553)] = 60650,
  [SMALL_STATE(1554)] = 60663,
  [SMALL_STATE(1555)] = 60676,
  [SMALL_STATE(1556)] = 60685,
  [SMALL_STATE(1557)] = 60698,
  [SMALL_STATE(1558)] = 60711,
  [SMALL_STATE(1559)] = 60724,
  [SMALL_STATE(1560)] = 60737,
  [SMALL_STATE(1561)] = 60750,
  [SMALL_STATE(1562)] = 60763,
  [SMALL_STATE(1563)] = 60776,
  [SMALL_STATE(1564)] = 60789,
  [SMALL_STATE(1565)] = 60802,
  [SMALL_STATE(1566)] = 60815,
  [SMALL_STATE(1567)] = 60828,
  [SMALL_STATE(1568)] = 60839,
  [SMALL_STATE(1569)] = 60852,
  [SMALL_STATE(1570)] = 60865,
  [SMALL_STATE(1571)] = 60878,
  [SMALL_STATE(1572)] = 60891,
  [SMALL_STATE(1573)] = 60900,
  [SMALL_STATE(1574)] = 60913,
  [SMALL_STATE(1575)] = 60926,
  [SMALL_STATE(1576)] = 60939,
  [SMALL_STATE(1577)] = 60952,
  [SMALL_STATE(1578)] = 60965,
  [SMALL_STATE(1579)] = 60978,
  [SMALL_STATE(1580)] = 60991,
  [SMALL_STATE(1581)] = 61004,
  [SMALL_STATE(1582)] = 61013,
  [SMALL_STATE(1583)] = 61026,
  [SMALL_STATE(1584)] = 61039,
  [SMALL_STATE(1585)] = 61052,
  [SMALL_STATE(1586)] = 61065,
  [SMALL_STATE(1587)] = 61078,
  [SMALL_STATE(1588)] = 61091,
  [SMALL_STATE(1589)] = 61100,
  [SMALL_STATE(1590)] = 61113,
  [SMALL_STATE(1591)] = 61126,
  [SMALL_STATE(1592)] = 61139,
  [SMALL_STATE(1593)] = 61152,
  [SMALL_STATE(1594)] = 61165,
  [SMALL_STATE(1595)] = 61178,
  [SMALL_STATE(1596)] = 61191,
  [SMALL_STATE(1597)] = 61204,
  [SMALL_STATE(1598)] = 61217,
  [SMALL_STATE(1599)] = 61230,
  [SMALL_STATE(1600)] = 61243,
  [SMALL_STATE(1601)] = 61256,
  [SMALL_STATE(1602)] = 61267,
  [SMALL_STATE(1603)] = 61280,
  [SMALL_STATE(1604)] = 61293,
  [SMALL_STATE(1605)] = 61306,
  [SMALL_STATE(1606)] = 61319,
  [SMALL_STATE(1607)] = 61332,
  [SMALL_STATE(1608)] = 61345,
  [SMALL_STATE(1609)] = 61358,
  [SMALL_STATE(1610)] = 61371,
  [SMALL_STATE(1611)] = 61384,
  [SMALL_STATE(1612)] = 61397,
  [SMALL_STATE(1613)] = 61410,
  [SMALL_STATE(1614)] = 61423,
  [SMALL_STATE(1615)] = 61436,
  [SMALL_STATE(1616)] = 61449,
  [SMALL_STATE(1617)] = 61462,
  [SMALL_STATE(1618)] = 61475,
  [SMALL_STATE(1619)] = 61488,
  [SMALL_STATE(1620)] = 61501,
  [SMALL_STATE(1621)] = 61514,
  [SMALL_STATE(1622)] = 61527,
  [SMALL_STATE(1623)] = 61540,
  [SMALL_STATE(1624)] = 61553,
  [SMALL_STATE(1625)] = 61564,
  [SMALL_STATE(1626)] = 61577,
  [SMALL_STATE(1627)] = 61586,
  [SMALL_STATE(1628)] = 61599,
  [SMALL_STATE(1629)] = 61608,
  [SMALL_STATE(1630)] = 61617,
  [SMALL_STATE(1631)] = 61630,
  [SMALL_STATE(1632)] = 61639,
  [SMALL_STATE(1633)] = 61652,
  [SMALL_STATE(1634)] = 61665,
  [SMALL_STATE(1635)] = 61678,
  [SMALL_STATE(1636)] = 61691,
  [SMALL_STATE(1637)] = 61704,
  [SMALL_STATE(1638)] = 61717,
  [SMALL_STATE(1639)] = 61730,
  [SMALL_STATE(1640)] = 61743,
  [SMALL_STATE(1641)] = 61756,
  [SMALL_STATE(1642)] = 61769,
  [SMALL_STATE(1643)] = 61782,
  [SMALL_STATE(1644)] = 61795,
  [SMALL_STATE(1645)] = 61808,
  [SMALL_STATE(1646)] = 61821,
  [SMALL_STATE(1647)] = 61834,
  [SMALL_STATE(1648)] = 61847,
  [SMALL_STATE(1649)] = 61860,
  [SMALL_STATE(1650)] = 61871,
  [SMALL_STATE(1651)] = 61880,
  [SMALL_STATE(1652)] = 61893,
  [SMALL_STATE(1653)] = 61906,
  [SMALL_STATE(1654)] = 61917,
  [SMALL_STATE(1655)] = 61930,
  [SMALL_STATE(1656)] = 61943,
  [SMALL_STATE(1657)] = 61956,
  [SMALL_STATE(1658)] = 61969,
  [SMALL_STATE(1659)] = 61982,
  [SMALL_STATE(1660)] = 61991,
  [SMALL_STATE(1661)] = 62004,
  [SMALL_STATE(1662)] = 62017,
  [SMALL_STATE(1663)] = 62030,
  [SMALL_STATE(1664)] = 62043,
  [SMALL_STATE(1665)] = 62052,
  [SMALL_STATE(1666)] = 62061,
  [SMALL_STATE(1667)] = 62074,
  [SMALL_STATE(1668)] = 62087,
  [SMALL_STATE(1669)] = 62100,
  [SMALL_STATE(1670)] = 62110,
  [SMALL_STATE(1671)] = 62118,
  [SMALL_STATE(1672)] = 62126,
  [SMALL_STATE(1673)] = 62136,
  [SMALL_STATE(1674)] = 62146,
  [SMALL_STATE(1675)] = 62156,
  [SMALL_STATE(1676)] = 62164,
  [SMALL_STATE(1677)] = 62174,
  [SMALL_STATE(1678)] = 62184,
  [SMALL_STATE(1679)] = 62194,
  [SMALL_STATE(1680)] = 62202,
  [SMALL_STATE(1681)] = 62210,
  [SMALL_STATE(1682)] = 62218,
  [SMALL_STATE(1683)] = 62228,
  [SMALL_STATE(1684)] = 62238,
  [SMALL_STATE(1685)] = 62248,
  [SMALL_STATE(1686)] = 62258,
  [SMALL_STATE(1687)] = 62268,
  [SMALL_STATE(1688)] = 62278,
  [SMALL_STATE(1689)] = 62288,
  [SMALL_STATE(1690)] = 62298,
  [SMALL_STATE(1691)] = 62306,
  [SMALL_STATE(1692)] = 62314,
  [SMALL_STATE(1693)] = 62324,
  [SMALL_STATE(1694)] = 62334,
  [SMALL_STATE(1695)] = 62344,
  [SMALL_STATE(1696)] = 62354,
  [SMALL_STATE(1697)] = 62364,
  [SMALL_STATE(1698)] = 62374,
  [SMALL_STATE(1699)] = 62382,
  [SMALL_STATE(1700)] = 62392,
  [SMALL_STATE(1701)] = 62402,
  [SMALL_STATE(1702)] = 62412,
  [SMALL_STATE(1703)] = 62422,
  [SMALL_STATE(1704)] = 62432,
  [SMALL_STATE(1705)] = 62440,
  [SMALL_STATE(1706)] = 62450,
  [SMALL_STATE(1707)] = 62460,
  [SMALL_STATE(1708)] = 62470,
  [SMALL_STATE(1709)] = 62480,
  [SMALL_STATE(1710)] = 62490,
  [SMALL_STATE(1711)] = 62500,
  [SMALL_STATE(1712)] = 62510,
  [SMALL_STATE(1713)] = 62520,
  [SMALL_STATE(1714)] = 62530,
  [SMALL_STATE(1715)] = 62540,
  [SMALL_STATE(1716)] = 62550,
  [SMALL_STATE(1717)] = 62560,
  [SMALL_STATE(1718)] = 62570,
  [SMALL_STATE(1719)] = 62578,
  [SMALL_STATE(1720)] = 62588,
  [SMALL_STATE(1721)] = 62598,
  [SMALL_STATE(1722)] = 62608,
  [SMALL_STATE(1723)] = 62618,
  [SMALL_STATE(1724)] = 62626,
  [SMALL_STATE(1725)] = 62636,
  [SMALL_STATE(1726)] = 62646,
  [SMALL_STATE(1727)] = 62654,
  [SMALL_STATE(1728)] = 62664,
  [SMALL_STATE(1729)] = 62674,
  [SMALL_STATE(1730)] = 62684,
  [SMALL_STATE(1731)] = 62694,
  [SMALL_STATE(1732)] = 62704,
  [SMALL_STATE(1733)] = 62714,
  [SMALL_STATE(1734)] = 62722,
  [SMALL_STATE(1735)] = 62732,
  [SMALL_STATE(1736)] = 62742,
  [SMALL_STATE(1737)] = 62750,
  [SMALL_STATE(1738)] = 62758,
  [SMALL_STATE(1739)] = 62768,
  [SMALL_STATE(1740)] = 62778,
  [SMALL_STATE(1741)] = 62788,
  [SMALL_STATE(1742)] = 62798,
  [SMALL_STATE(1743)] = 62808,
  [SMALL_STATE(1744)] = 62818,
  [SMALL_STATE(1745)] = 62826,
  [SMALL_STATE(1746)] = 62836,
  [SMALL_STATE(1747)] = 62846,
  [SMALL_STATE(1748)] = 62856,
  [SMALL_STATE(1749)] = 62866,
  [SMALL_STATE(1750)] = 62874,
  [SMALL_STATE(1751)] = 62884,
  [SMALL_STATE(1752)] = 62894,
  [SMALL_STATE(1753)] = 62904,
  [SMALL_STATE(1754)] = 62914,
  [SMALL_STATE(1755)] = 62924,
  [SMALL_STATE(1756)] = 62934,
  [SMALL_STATE(1757)] = 62944,
  [SMALL_STATE(1758)] = 62951,
  [SMALL_STATE(1759)] = 62958,
  [SMALL_STATE(1760)] = 62965,
  [SMALL_STATE(1761)] = 62972,
  [SMALL_STATE(1762)] = 62979,
  [SMALL_STATE(1763)] = 62986,
  [SMALL_STATE(1764)] = 62993,
  [SMALL_STATE(1765)] = 63000,
  [SMALL_STATE(1766)] = 63007,
  [SMALL_STATE(1767)] = 63014,
  [SMALL_STATE(1768)] = 63021,
  [SMALL_STATE(1769)] = 63028,
  [SMALL_STATE(1770)] = 63035,
  [SMALL_STATE(1771)] = 63042,
  [SMALL_STATE(1772)] = 63049,
  [SMALL_STATE(1773)] = 63056,
  [SMALL_STATE(1774)] = 63063,
  [SMALL_STATE(1775)] = 63070,
  [SMALL_STATE(1776)] = 63077,
  [SMALL_STATE(1777)] = 63084,
  [SMALL_STATE(1778)] = 63091,
  [SMALL_STATE(1779)] = 63098,
  [SMALL_STATE(1780)] = 63105,
  [SMALL_STATE(1781)] = 63112,
  [SMALL_STATE(1782)] = 63119,
  [SMALL_STATE(1783)] = 63126,
  [SMALL_STATE(1784)] = 63133,
  [SMALL_STATE(1785)] = 63140,
  [SMALL_STATE(1786)] = 63147,
  [SMALL_STATE(1787)] = 63154,
  [SMALL_STATE(1788)] = 63161,
  [SMALL_STATE(1789)] = 63168,
  [SMALL_STATE(1790)] = 63175,
  [SMALL_STATE(1791)] = 63182,
  [SMALL_STATE(1792)] = 63189,
  [SMALL_STATE(1793)] = 63196,
  [SMALL_STATE(1794)] = 63203,
  [SMALL_STATE(1795)] = 63210,
  [SMALL_STATE(1796)] = 63217,
  [SMALL_STATE(1797)] = 63224,
  [SMALL_STATE(1798)] = 63231,
  [SMALL_STATE(1799)] = 63238,
  [SMALL_STATE(1800)] = 63245,
  [SMALL_STATE(1801)] = 63252,
  [SMALL_STATE(1802)] = 63259,
  [SMALL_STATE(1803)] = 63266,
  [SMALL_STATE(1804)] = 63273,
  [SMALL_STATE(1805)] = 63280,
  [SMALL_STATE(1806)] = 63287,
  [SMALL_STATE(1807)] = 63294,
  [SMALL_STATE(1808)] = 63301,
  [SMALL_STATE(1809)] = 63308,
  [SMALL_STATE(1810)] = 63315,
  [SMALL_STATE(1811)] = 63322,
  [SMALL_STATE(1812)] = 63329,
  [SMALL_STATE(1813)] = 63336,
  [SMALL_STATE(1814)] = 63343,
  [SMALL_STATE(1815)] = 63350,
  [SMALL_STATE(1816)] = 63357,
  [SMALL_STATE(1817)] = 63364,
  [SMALL_STATE(1818)] = 63371,
  [SMALL_STATE(1819)] = 63378,
  [SMALL_STATE(1820)] = 63385,
  [SMALL_STATE(1821)] = 63392,
  [SMALL_STATE(1822)] = 63399,
  [SMALL_STATE(1823)] = 63406,
  [SMALL_STATE(1824)] = 63413,
  [SMALL_STATE(1825)] = 63420,
  [SMALL_STATE(1826)] = 63427,
  [SMALL_STATE(1827)] = 63434,
  [SMALL_STATE(1828)] = 63441,
  [SMALL_STATE(1829)] = 63448,
  [SMALL_STATE(1830)] = 63455,
  [SMALL_STATE(1831)] = 63462,
  [SMALL_STATE(1832)] = 63469,
  [SMALL_STATE(1833)] = 63476,
  [SMALL_STATE(1834)] = 63483,
  [SMALL_STATE(1835)] = 63490,
  [SMALL_STATE(1836)] = 63497,
  [SMALL_STATE(1837)] = 63504,
  [SMALL_STATE(1838)] = 63511,
  [SMALL_STATE(1839)] = 63518,
  [SMALL_STATE(1840)] = 63525,
  [SMALL_STATE(1841)] = 63532,
  [SMALL_STATE(1842)] = 63539,
  [SMALL_STATE(1843)] = 63546,
  [SMALL_STATE(1844)] = 63553,
  [SMALL_STATE(1845)] = 63560,
  [SMALL_STATE(1846)] = 63567,
  [SMALL_STATE(1847)] = 63574,
  [SMALL_STATE(1848)] = 63581,
  [SMALL_STATE(1849)] = 63588,
  [SMALL_STATE(1850)] = 63595,
  [SMALL_STATE(1851)] = 63602,
  [SMALL_STATE(1852)] = 63609,
  [SMALL_STATE(1853)] = 63616,
  [SMALL_STATE(1854)] = 63623,
  [SMALL_STATE(1855)] = 63630,
  [SMALL_STATE(1856)] = 63637,
  [SMALL_STATE(1857)] = 63644,
  [SMALL_STATE(1858)] = 63651,
  [SMALL_STATE(1859)] = 63658,
  [SMALL_STATE(1860)] = 63665,
  [SMALL_STATE(1861)] = 63672,
  [SMALL_STATE(1862)] = 63679,
  [SMALL_STATE(1863)] = 63686,
  [SMALL_STATE(1864)] = 63693,
  [SMALL_STATE(1865)] = 63700,
  [SMALL_STATE(1866)] = 63707,
  [SMALL_STATE(1867)] = 63714,
  [SMALL_STATE(1868)] = 63721,
  [SMALL_STATE(1869)] = 63728,
  [SMALL_STATE(1870)] = 63735,
  [SMALL_STATE(1871)] = 63742,
  [SMALL_STATE(1872)] = 63749,
  [SMALL_STATE(1873)] = 63756,
  [SMALL_STATE(1874)] = 63763,
  [SMALL_STATE(1875)] = 63770,
  [SMALL_STATE(1876)] = 63777,
  [SMALL_STATE(1877)] = 63784,
  [SMALL_STATE(1878)] = 63791,
  [SMALL_STATE(1879)] = 63798,
  [SMALL_STATE(1880)] = 63805,
  [SMALL_STATE(1881)] = 63812,
  [SMALL_STATE(1882)] = 63819,
  [SMALL_STATE(1883)] = 63826,
  [SMALL_STATE(1884)] = 63833,
  [SMALL_STATE(1885)] = 63840,
  [SMALL_STATE(1886)] = 63847,
  [SMALL_STATE(1887)] = 63854,
  [SMALL_STATE(1888)] = 63861,
  [SMALL_STATE(1889)] = 63868,
  [SMALL_STATE(1890)] = 63875,
  [SMALL_STATE(1891)] = 63882,
  [SMALL_STATE(1892)] = 63889,
  [SMALL_STATE(1893)] = 63896,
  [SMALL_STATE(1894)] = 63903,
  [SMALL_STATE(1895)] = 63910,
  [SMALL_STATE(1896)] = 63917,
  [SMALL_STATE(1897)] = 63924,
  [SMALL_STATE(1898)] = 63931,
  [SMALL_STATE(1899)] = 63938,
  [SMALL_STATE(1900)] = 63945,
  [SMALL_STATE(1901)] = 63952,
  [SMALL_STATE(1902)] = 63959,
  [SMALL_STATE(1903)] = 63966,
  [SMALL_STATE(1904)] = 63973,
  [SMALL_STATE(1905)] = 63980,
  [SMALL_STATE(1906)] = 63987,
  [SMALL_STATE(1907)] = 63994,
  [SMALL_STATE(1908)] = 64001,
  [SMALL_STATE(1909)] = 64008,
  [SMALL_STATE(1910)] = 64015,
  [SMALL_STATE(1911)] = 64022,
  [SMALL_STATE(1912)] = 64029,
  [SMALL_STATE(1913)] = 64036,
  [SMALL_STATE(1914)] = 64043,
  [SMALL_STATE(1915)] = 64050,
  [SMALL_STATE(1916)] = 64057,
  [SMALL_STATE(1917)] = 64064,
  [SMALL_STATE(1918)] = 64071,
  [SMALL_STATE(1919)] = 64078,
  [SMALL_STATE(1920)] = 64085,
  [SMALL_STATE(1921)] = 64092,
  [SMALL_STATE(1922)] = 64099,
  [SMALL_STATE(1923)] = 64106,
  [SMALL_STATE(1924)] = 64113,
  [SMALL_STATE(1925)] = 64120,
  [SMALL_STATE(1926)] = 64127,
  [SMALL_STATE(1927)] = 64134,
  [SMALL_STATE(1928)] = 64141,
  [SMALL_STATE(1929)] = 64148,
  [SMALL_STATE(1930)] = 64155,
  [SMALL_STATE(1931)] = 64162,
  [SMALL_STATE(1932)] = 64169,
  [SMALL_STATE(1933)] = 64176,
  [SMALL_STATE(1934)] = 64183,
  [SMALL_STATE(1935)] = 64190,
  [SMALL_STATE(1936)] = 64197,
  [SMALL_STATE(1937)] = 64204,
  [SMALL_STATE(1938)] = 64211,
  [SMALL_STATE(1939)] = 64218,
  [SMALL_STATE(1940)] = 64225,
  [SMALL_STATE(1941)] = 64232,
  [SMALL_STATE(1942)] = 64239,
  [SMALL_STATE(1943)] = 64246,
  [SMALL_STATE(1944)] = 64253,
  [SMALL_STATE(1945)] = 64260,
  [SMALL_STATE(1946)] = 64267,
  [SMALL_STATE(1947)] = 64274,
  [SMALL_STATE(1948)] = 64281,
  [SMALL_STATE(1949)] = 64288,
  [SMALL_STATE(1950)] = 64295,
  [SMALL_STATE(1951)] = 64302,
  [SMALL_STATE(1952)] = 64309,
  [SMALL_STATE(1953)] = 64316,
  [SMALL_STATE(1954)] = 64323,
  [SMALL_STATE(1955)] = 64330,
  [SMALL_STATE(1956)] = 64337,
  [SMALL_STATE(1957)] = 64344,
  [SMALL_STATE(1958)] = 64351,
  [SMALL_STATE(1959)] = 64358,
  [SMALL_STATE(1960)] = 64365,
  [SMALL_STATE(1961)] = 64372,
  [SMALL_STATE(1962)] = 64379,
  [SMALL_STATE(1963)] = 64386,
  [SMALL_STATE(1964)] = 64393,
  [SMALL_STATE(1965)] = 64400,
  [SMALL_STATE(1966)] = 64407,
  [SMALL_STATE(1967)] = 64414,
  [SMALL_STATE(1968)] = 64421,
  [SMALL_STATE(1969)] = 64428,
  [SMALL_STATE(1970)] = 64435,
  [SMALL_STATE(1971)] = 64442,
  [SMALL_STATE(1972)] = 64449,
  [SMALL_STATE(1973)] = 64456,
  [SMALL_STATE(1974)] = 64463,
  [SMALL_STATE(1975)] = 64470,
  [SMALL_STATE(1976)] = 64477,
  [SMALL_STATE(1977)] = 64484,
  [SMALL_STATE(1978)] = 64491,
  [SMALL_STATE(1979)] = 64498,
  [SMALL_STATE(1980)] = 64505,
  [SMALL_STATE(1981)] = 64512,
  [SMALL_STATE(1982)] = 64519,
  [SMALL_STATE(1983)] = 64526,
  [SMALL_STATE(1984)] = 64533,
  [SMALL_STATE(1985)] = 64540,
  [SMALL_STATE(1986)] = 64547,
  [SMALL_STATE(1987)] = 64554,
  [SMALL_STATE(1988)] = 64561,
  [SMALL_STATE(1989)] = 64568,
  [SMALL_STATE(1990)] = 64575,
  [SMALL_STATE(1991)] = 64582,
  [SMALL_STATE(1992)] = 64589,
  [SMALL_STATE(1993)] = 64596,
  [SMALL_STATE(1994)] = 64603,
  [SMALL_STATE(1995)] = 64610,
  [SMALL_STATE(1996)] = 64617,
  [SMALL_STATE(1997)] = 64624,
  [SMALL_STATE(1998)] = 64631,
  [SMALL_STATE(1999)] = 64638,
  [SMALL_STATE(2000)] = 64645,
  [SMALL_STATE(2001)] = 64652,
  [SMALL_STATE(2002)] = 64659,
  [SMALL_STATE(2003)] = 64666,
  [SMALL_STATE(2004)] = 64673,
  [SMALL_STATE(2005)] = 64680,
  [SMALL_STATE(2006)] = 64687,
  [SMALL_STATE(2007)] = 64694,
  [SMALL_STATE(2008)] = 64701,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, 0, 17),
  [173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, 0, 40),
  [175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, 0, 17),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, 0, 40),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(409),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1369),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1900),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1196),
  [213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1901),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1728),
  [221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(383),
  [224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(557),
  [233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(82),
  [236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(382),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(993),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(879),
  [245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1752),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1840),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(920),
  [257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(33),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(751),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1767),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(736),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1651),
  [278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1429),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1480),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1754),
  [287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1707),
  [290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(614),
  [293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1883),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1716),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(318),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2002),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1758),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1784),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1909),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1710),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2003),
  [323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(569),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(570),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1827),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1874),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1833),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1425),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(679),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1653),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1540),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(679),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(685),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(415),
  [409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1361),
  [412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1810),
  [415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1190),
  [418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1811),
  [421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(195),
  [427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(396),
  [430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(987),
  [433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(873),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1721),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1755),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(581),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1940),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1727),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1964),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(468),
  [465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1948),
  [468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1951),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1819),
  [474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1676),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1844),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(413),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1352),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1952),
  [541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1200),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1932),
  [547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1688),
  [550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(202),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(397),
  [556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(995),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(880),
  [562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(38),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1706),
  [568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1722),
  [571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(616),
  [574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1766),
  [577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1708),
  [580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(327),
  [583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2005),
  [586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(481),
  [589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1886),
  [592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1887),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1937),
  [598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1725),
  [601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1917),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(416),
  [641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1363),
  [644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1987),
  [647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1158),
  [650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1961),
  [653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1701),
  [656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(383),
  [659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(557),
  [668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(381),
  [671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(997),
  [674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(861),
  [677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1752),
  [683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1840),
  [686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(920),
  [689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(41),
  [692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(751),
  [695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1767),
  [704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(736),
  [707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1651),
  [710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1429),
  [713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1480),
  [716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1703),
  [719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1742),
  [722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(535),
  [725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1944),
  [728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1724),
  [731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(336),
  [734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1765),
  [737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(475),
  [740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1904),
  [743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1930),
  [746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1820),
  [749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(569),
  [752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(570),
  [755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1827),
  [758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1874),
  [761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1833),
  [764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1425),
  [767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1103),
  [770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1653),
  [773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1540),
  [776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1103),
  [779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(685),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 9),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2, 0, 0),
  [788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 9),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(410),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(383),
  [798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(557),
  [807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(82),
  [810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(382),
  [813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(993),
  [816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1752),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1840),
  [828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(33),
  [831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(751),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1767),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(736),
  [843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1651),
  [846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1429),
  [849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1480),
  [852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1754),
  [855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1707),
  [858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1716),
  [861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(318),
  [864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2002),
  [867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1758),
  [873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1784),
  [876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1909),
  [879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1710),
  [882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2003),
  [885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(569),
  [888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(570),
  [891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1827),
  [894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1874),
  [897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1833),
  [900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1425),
  [903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(679),
  [906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1653),
  [909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1540),
  [912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(679),
  [915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(685),
  [918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 0),
  [920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(408),
  [925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(168),
  [928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(381),
  [931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(997),
  [934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(41),
  [937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1703),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1742),
  [943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1724),
  [946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(336),
  [949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1765),
  [952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(475),
  [955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1904),
  [958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1930),
  [961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1820),
  [964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1673),
  [967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1763),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 9),
  [974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 9),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(411),
  [987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(195),
  [990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(396),
  [993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(987),
  [996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1721),
  [1002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1755),
  [1005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1727),
  [1008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(351),
  [1011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1964),
  [1014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(468),
  [1017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1948),
  [1020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1951),
  [1023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1819),
  [1026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1676),
  [1029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1844),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(412),
  [1041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(202),
  [1044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(397),
  [1047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(995),
  [1050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(38),
  [1053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1706),
  [1056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1722),
  [1059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1708),
  [1062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(327),
  [1065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2005),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(481),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1886),
  [1074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1887),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1937),
  [1080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1725),
  [1083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1917),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [1102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(414),
  [1105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1740),
  [1108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1696),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1986),
  [1114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1741),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [1123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 27),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 27),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 55),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 55),
  [1133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [1143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [1145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [1151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [1153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [1157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [1165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 28),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 28),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 28),
  [1179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 28),
  [1181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 29),
  [1187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 29),
  [1189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 35),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 35),
  [1193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 47),
  [1195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 47),
  [1197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, 0, 8),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, 0, 8),
  [1201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 62),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 62),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 64),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 64),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 76),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 76),
  [1213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 47),
  [1215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 47),
  [1217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, 0, 8),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, 0, 8),
  [1221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 81),
  [1227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 81),
  [1229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 85),
  [1231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 85),
  [1233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 90),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 90),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 91),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 91),
  [1241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, 0, 76),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, 0, 76),
  [1245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, 0, 100),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, 0, 100),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 6, 0, 111),
  [1251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 6, 0, 111),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 31),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 31),
  [1257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 61),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 61),
  [1261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_item, 1, 0, 2),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_item, 1, 0, 2),
  [1265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 72),
  [1267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 72),
  [1269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, 0, 71),
  [1271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, 0, 71),
  [1273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, 0, 16),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, 0, 16),
  [1277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, 0, 17),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, 0, 17),
  [1281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 4, 0, 66),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 4, 0, 66),
  [1285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, 0, 17),
  [1287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 17),
  [1289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 67),
  [1291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 67),
  [1293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 4, 0, 68),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 4, 0, 68),
  [1297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, 0, 73),
  [1299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 73),
  [1301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 40),
  [1303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 40),
  [1305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, 0, 18),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, 0, 18),
  [1309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 33),
  [1311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 33),
  [1313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [1315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [1317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, 0, 23),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, 0, 23),
  [1321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 3, 0, 36),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 3, 0, 36),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, 0, 4),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, 0, 4),
  [1329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, 0, 38),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, 0, 38),
  [1333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, 0, 39),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, 0, 39),
  [1337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 40),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 40),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 41),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 41),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 94),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 94),
  [1349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 5, 0, 95),
  [1351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 5, 0, 95),
  [1353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 97),
  [1355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 97),
  [1357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 17),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 17),
  [1361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [1364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [1367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 57),
  [1383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 57),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [1405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(772),
  [1408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(383),
  [1411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(534),
  [1414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(534),
  [1417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(557),
  [1420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(202),
  [1423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(620),
  [1426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1753),
  [1429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(38),
  [1432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1706),
  [1435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1722),
  [1438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(616),
  [1441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1766),
  [1444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1708),
  [1447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(327),
  [1450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2005),
  [1453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(481),
  [1456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1886),
  [1459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1887),
  [1462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1937),
  [1465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1725),
  [1468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1917),
  [1471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(569),
  [1474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(570),
  [1477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1827),
  [1480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1874),
  [1483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1833),
  [1486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1425),
  [1489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(679),
  [1492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1653),
  [1495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1540),
  [1498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(679),
  [1501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(685),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [1506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(769),
  [1519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(82),
  [1522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(33),
  [1525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1754),
  [1528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1707),
  [1531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(614),
  [1534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1883),
  [1537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1716),
  [1540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(318),
  [1543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2002),
  [1546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(473),
  [1549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1758),
  [1552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1784),
  [1555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1909),
  [1558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1710),
  [1561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2003),
  [1564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(747),
  [1567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(195),
  [1570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(41),
  [1573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1740),
  [1576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1742),
  [1579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(613),
  [1582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1965),
  [1585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1696),
  [1588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(336),
  [1591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1986),
  [1594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(475),
  [1597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1904),
  [1600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1930),
  [1603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1820),
  [1606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1741),
  [1609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1844),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [1614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(767),
  [1617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(168),
  [1620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1703),
  [1623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(535),
  [1626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1944),
  [1629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1724),
  [1632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1765),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1673),
  [1638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1763),
  [1641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(777),
  [1644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(28),
  [1647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1721),
  [1650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1755),
  [1653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(581),
  [1656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1940),
  [1659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1727),
  [1662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(351),
  [1665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1964),
  [1668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(468),
  [1671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1948),
  [1674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1951),
  [1677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1819),
  [1680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1676),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [1685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [1687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [1690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [1693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 2),
  [1695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 2),
  [1697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(716),
  [1700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(620),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [1705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [1707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [1735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [1749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [1754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [1756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [1758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [1775] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0), SHIFT(979),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [1781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [1784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(363),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [1886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(789),
  [1889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(395),
  [1892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(617),
  [1895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(617),
  [1898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(618),
  [1901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(621),
  [1904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(619),
  [1907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(502),
  [1910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1827),
  [1913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1874),
  [1916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1833),
  [1919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1425),
  [1922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(679),
  [1925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1653),
  [1928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1540),
  [1931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(679),
  [1934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(685),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, 0, 40),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, 0, 17),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 17),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 40),
  [2003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(746),
  [2006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1956),
  [2009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1194),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [2014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1858),
  [2017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1712),
  [2020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [2023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [2026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [2029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1705),
  [2032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1840),
  [2035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(751),
  [2038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1767),
  [2041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(736),
  [2044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1651),
  [2047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1429),
  [2050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1480),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [2057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, 0, 0),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [2063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1931),
  [2066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1197),
  [2069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1966),
  [2072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1692),
  [2075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1957),
  [2090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1199),
  [2093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1921),
  [2096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1748),
  [2099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, 0, 0),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 0, 105),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 40),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 84),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 56),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 0, 0),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 0, 56),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [2209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [2211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [2217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [2219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(627),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [2226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1540),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 109),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 109),
  [2237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 124),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 124),
  [2241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 87),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 87),
  [2245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 108),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 108),
  [2249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 125),
  [2251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 125),
  [2253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [2257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 88),
  [2259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 88),
  [2261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [2265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [2268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [2271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [2274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1705),
  [2277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1840),
  [2280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1767),
  [2283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, 0, 129),
  [2285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, 0, 129),
  [2287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, 0, 58),
  [2289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, 0, 58),
  [2291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [2293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [2295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 119),
  [2297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 119),
  [2299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 120),
  [2301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 120),
  [2303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [2305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [2307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [2313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [2315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(681),
  [2318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(664),
  [2321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1963),
  [2324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(746),
  [2327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [2330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [2333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [2336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1705),
  [2339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1840),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0),
  [2344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(751),
  [2347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1767),
  [2350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(736),
  [2353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1651),
  [2356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1429),
  [2359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1480),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [2364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [2370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [2374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [2378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 13),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 13),
  [2382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [2386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, 0, 45),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, 0, 45),
  [2390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, 0, 69),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, 0, 69),
  [2394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [2398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 12),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 12),
  [2402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [2406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [2410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3, 0, 0),
  [2416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3, 0, 0),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [2422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, 0, 106),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, 0, 106),
  [2426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, 0, 57),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, 0, 57),
  [2430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 37),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 37),
  [2434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [2438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 5),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 5),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [2456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, 0, 5),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, 0, 5),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 30),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 30),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 45),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 45),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, 0, 9),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, 0, 9),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 5),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 5),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 7),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 7),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [2488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 7),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 7),
  [2492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [2496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 25),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 25),
  [2500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 25),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 25),
  [2504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 53),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 53),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 3),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 3),
  [2512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, 0, 14),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, 0, 14),
  [2516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 14),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 14),
  [2520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 3),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 3),
  [2524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [2528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 26),
  [2530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 26),
  [2532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, 0, 52),
  [2534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, 0, 52),
  [2536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 24),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 24),
  [2540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 24),
  [2542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 24),
  [2544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 26),
  [2546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 26),
  [2548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 8),
  [2550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 8),
  [2552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(731),
  [2559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, 0, 80),
  [2561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, 0, 80),
  [2563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 54),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 54),
  [2567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 8),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 8),
  [2571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 52),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 52),
  [2575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [2581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 6, 0, 80),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 6, 0, 80),
  [2585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 3),
  [2587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 3),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [2591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [2595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 8),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 8),
  [2599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 7),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 7),
  [2607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 8),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 8),
  [2611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 7),
  [2613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 7),
  [2615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 8),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 8),
  [2619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(979),
  [2622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 14),
  [2624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 14),
  [2626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 15),
  [2628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 15),
  [2630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(765),
  [2633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [2635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [2641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 10),
  [2643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 10),
  [2645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [2647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 24),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 24),
  [2653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 24),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 24),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 25),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 25),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 26),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 26),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, 0, 24),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, 0, 24),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, 0, 25),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, 0, 25),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, 0, 26),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, 0, 26),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_type_specifier, 4, -1, 59),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_type_specifier, 4, -1, 59),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, 0, 78),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, 0, 78),
  [2689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 14),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 14),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [2695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 15),
  [2697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 15),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [2701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 50),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 50),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, 0, 52),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, 0, 52),
  [2721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, 0, 53),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, 0, 53),
  [2725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, 0, 54),
  [2727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, 0, 54),
  [2729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 5, 0, 52),
  [2731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 5, 0, 52),
  [2733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 7),
  [2735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 7),
  [2737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 17),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 17),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [2743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [2749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [2751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [2755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 42),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 42),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [2767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [2771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 79),
  [2773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 79),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 40),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 40),
  [2781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 41),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 41),
  [2785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 30),
  [2787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 30),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, 0, 70),
  [2815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, 0, 70),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 96),
  [2819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 96),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [2825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [2827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 17),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 17),
  [2831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 79),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 79),
  [2835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 72),
  [2837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 72),
  [2839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 40),
  [2841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 40),
  [2843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 73),
  [2845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 73),
  [2847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 97),
  [2849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 97),
  [2851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 42),
  [2853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 42),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 7),
  [2881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 7),
  [2883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 7), SHIFT(1916),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [2890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0), REDUCE(sym__old_style_parameter_list, 2, 0, 0),
  [2893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [2895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_parameter_list, 2, 0, 0),
  [2897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0), REDUCE(sym__old_style_parameter_list, 2, 0, 0),
  [2900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [2902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0), REDUCE(sym__old_style_parameter_list, 3, 0, 0),
  [2905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [2907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_parameter_list, 3, 0, 0),
  [2909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0), REDUCE(sym__old_style_parameter_list, 3, 0, 0),
  [2912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [2914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 50),
  [2916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 50),
  [2918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 50), SHIFT(1916),
  [2921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 78),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 78),
  [2925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 78), SHIFT(1916),
  [2928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 8),
  [2930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 8),
  [2932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 8), SHIFT(1916),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [2937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 24),
  [2939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 24),
  [2941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 24), SHIFT(1916),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [2948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [2962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [2966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [2968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [2980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [2982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(1644),
  [2985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(940),
  [2988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [2990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [2992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(aux_sym__old_style_parameter_list_repeat1, 2, 0, 0),
  [2995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [2998] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(979),
  [3002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [3009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_parameter_list, 4, 0, 0),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_parameter_list, 4, 0, 0),
  [3023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_declarator, 2, 0, 34),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_declarator, 2, 0, 34),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_parameter_list, 3, 0, 0),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [3035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [3037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1001),
  [3040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1003),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [3045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [3051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, 0, 77),
  [3053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, 0, 77),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [3065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [3109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [3111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [3114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1767),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [3127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [3129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, 0, 13),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, 0, 13),
  [3133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [3135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [3137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [3139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [3141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [3143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [3145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [3147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, 0, 44),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [3165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 0, 104),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 114),
  [3215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4, 0, 0),
  [3217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, 0, 116),
  [3219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, 0, 63),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [3223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 115),
  [3233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 0, 102),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [3237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 0, 103),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 82),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 83),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [3257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 3),
  [3277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 14),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 14),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, 0, 3),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 14),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 14),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, 0, 3),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, 0, 3),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 3),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 3),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, 0, 14),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, 0, 14),
  [3317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 42),
  [3319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1117),
  [3322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1123),
  [3325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1126),
  [3328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [3330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 15), SHIFT(1124),
  [3333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1125),
  [3336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [3342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 14), SHIFT(731),
  [3345] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(731),
  [3349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 15), SHIFT(731),
  [3352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 3), SHIFT(731),
  [3355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 14), SHIFT(1122),
  [3358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 10), SHIFT(731),
  [3361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(1127),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [3366] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [3368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [3378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [3392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [3424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [3428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [3432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [3442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 30),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [3450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 7), SHIFT(1920),
  [3453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 30),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [3471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [3473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 5),
  [3479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 5),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [3497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [3509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [3527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [3529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [3543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [3545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [3549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [3551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [3553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [3555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [3557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [3559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [3561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [3593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, 0, 34),
  [3597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, 0, 34),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declaration_declarator, 2, 0, 34),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 3, 0, 34),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 3, 0, 34),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declaration_declarator, 3, 0, 34),
  [3607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declaration_declarator, 3, 0, 34),
  [3609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1284),
  [3612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 2, 0, 0),
  [3614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2, 0, 0),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 4, 0, 34),
  [3621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 4, 0, 34),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [3625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1752),
  [3628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [3634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, 0, 17),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [3642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, 0, 40),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [3652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [3654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [3656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [3658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [3660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, 1, 32),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [3666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 2, 1, 32),
  [3668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, 1, 110),
  [3670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 5, 1, 110),
  [3672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, 1, 89),
  [3674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 4, 1, 89),
  [3676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, 1, 60),
  [3678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 3, 1, 60),
  [3680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 1, 0, 0),
  [3682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 1, 0, 0),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [3686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [3694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, 0, 112),
  [3696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, 0, 112),
  [3698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [3700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [3702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 92),
  [3704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 92),
  [3706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [3708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [3710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 22),
  [3712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 22),
  [3714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0),
  [3716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0),
  [3718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, 0, 22),
  [3720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, 0, 22),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [3724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 1, 0, 22),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [3730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 1, 0, 0),
  [3732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 1, 0, 0), REDUCE(aux_sym_function_declarator_repeat1, 1, 0, 0),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 1, 0, 0),
  [3737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1601),
  [3740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1150),
  [3743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1782),
  [3746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1701),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [3751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 40),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [3755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [3759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 40),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [3763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [3767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, 1, 32),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, 0, 40),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 35),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, 1, 110),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 17),
  [3783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 17),
  [3785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, 0, 17),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, 1, 89),
  [3791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, 0, 32),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, 1, 60),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [3801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1, 0, 0),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [3807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, 1, 110),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [3811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, 1, 60),
  [3813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, 1, 32),
  [3815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1, 0, 0),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [3819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 1, 0, 0),
  [3821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_declarator, 1, 0, 0),
  [3823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, 1, 89),
  [3825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [3827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [3831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, 0, 22),
  [3833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1, 0, 0),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [3837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [3847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [3851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [3853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [3856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [3858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 32),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [3864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [3866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [3868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [3870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [3872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0), SHIFT_REPEAT(1398),
  [3875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [3877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [3879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [3881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [3883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 92),
  [3885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 92),
  [3887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, 0, 22),
  [3889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, 0, 22),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [3893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, 0, 112),
  [3895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, 0, 112),
  [3897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 22),
  [3899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 22),
  [3901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declaration_declarator, 4, 0, 34),
  [3903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declaration_declarator, 4, 0, 34),
  [3905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 51),
  [3907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 51),
  [3909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, 0, 6),
  [3911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, 0, 6),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1601),
  [3918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [3920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [3922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, 0, 34),
  [3924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, 0, 34),
  [3926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [3928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [3930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, 0, 22),
  [3932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, 0, 22),
  [3934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 32),
  [3936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 21),
  [3938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 21),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [3946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [3948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [3956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [3958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [3960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, 0, 34),
  [3962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, 0, 34),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [3968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, 0, 112),
  [3970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, 0, 112),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [3974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [3976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [3980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 60),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [3984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [3986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0),
  [3988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1483),
  [3991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 22),
  [3993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 22),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [4001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 89),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [4005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [4009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [4013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(522),
  [4016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0),
  [4018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(1933),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [4041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 92),
  [4043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 92),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [4047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 92),
  [4049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [4051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, 0, 20),
  [4053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [4055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 17),
  [4057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 17),
  [4059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [4061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, 0, 34),
  [4063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 43),
  [4065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 46),
  [4067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 40),
  [4069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 40),
  [4071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, 0, 112),
  [4073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 74),
  [4075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 32),
  [4077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 22),
  [4079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [4081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 22),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 73),
  [4085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 73),
  [4087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 97),
  [4089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 97),
  [4091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 17),
  [4093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 17),
  [4095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [4097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, 0, 75),
  [4099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 3, 0, 93),
  [4101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 19),
  [4103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 98),
  [4105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 41),
  [4107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 41),
  [4109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [4111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 72),
  [4113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 72),
  [4115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 40),
  [4117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 40),
  [4119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 6),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [4123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 35),
  [4125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [4127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1, 0, 0),
  [4129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [4131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1, 0, 0),
  [4133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 1, 0, 11),
  [4135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_declarator, 1, 0, 11),
  [4137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 42),
  [4139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [4167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2, 0, 0),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [4179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [4185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, 0, 122),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [4193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 117), SHIFT_REPEAT(1375),
  [4196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 117),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [4202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [4204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1507),
  [4207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1507),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [4212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, 0, 48),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [4220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, 0, 107),
  [4222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0),
  [4224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1512),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [4231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 2, 0, 48),
  [4233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1, 0, 0),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [4241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [4251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [4257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 65), SHIFT_REPEAT(1262),
  [4260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 65),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [4266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 49),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [4272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, 0, 107),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [4276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [4282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [4288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [4290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, 0, 65), SHIFT_REPEAT(1315),
  [4293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, 0, 65),
  [4295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, 0, 86),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [4303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, 0, 86),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [4311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [4313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 2, 0, 22),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [4319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 3, 0, 101),
  [4321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 127), SHIFT_REPEAT(1366),
  [4324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 127),
  [4326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2, 0, 0),
  [4328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 117), SHIFT_REPEAT(1395),
  [4331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 117),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [4335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, 0, 118),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [4341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [4353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 3, 0, 32),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [4357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 65), SHIFT_REPEAT(1141),
  [4360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 65),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [4384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__old_style_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1644),
  [4387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__old_style_parameter_list_repeat1, 2, 0, 0),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [4403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 86),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [4421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, 0, 131),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [4437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [4465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(450),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [4514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, 0, 99),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [4518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, 0, 121),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 86),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [4546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, 0, 123),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [4558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 130), SHIFT_REPEAT(2001),
  [4561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 130),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [4567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, 0, 131),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [4571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [4575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(1694),
  [4578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [4582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(661),
  [4585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [4587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, 0, 126),
  [4589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(463),
  [4592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1182),
  [4595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0), SHIFT_REPEAT(1733),
  [4598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0),
  [4600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(977),
  [4603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0),
  [4605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, 0, 121),
  [4607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 118),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [4611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, 0, 128),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), REDUCE(aux_sym__old_style_parameter_list_repeat1, 2, 0, 0),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 49),
  [4622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 6),
  [4624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 123),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [4628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1, 0, 0),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [4638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 4, 0, 113),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [4664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 1, 0, 0),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [4688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [4690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [4696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [4698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [4712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [4714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [4718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 41),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [4778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 72),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 40),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [4894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, 0, 97),
  [4896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 72),
  [4898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 72),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [4910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, 0, 73),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [4914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 97),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4922] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [4926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 41),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, 0, 73),
  [4940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 41),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2, 0, 0),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [4992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, 0, 41),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [5006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, 0, 73),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [5032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 72),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [5064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, 0, 97),
  [5066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, 0, 97),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [5070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, 0, 97),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [5088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, 0, 73),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [5104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 72),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [5112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 17),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [5118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, 0, 73),
  [5120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 41),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_c(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
